/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/path","vs/base/common/types","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/arrays","vs/base/common/buffer","vs/base/common/network","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/telemetry/common/telemetry","vs/base/node/pfs","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/product/common/productService","vs/base/common/objects","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/process","os","vs/base/common/json","vs/base/parts/ipc/common/ipc","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/base/common/map","vs/base/common/stream","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataSync/common/abstractSynchronizer","child_process","vs/platform/externalServices/common/serviceMachineId","vs/base/common/codicons","vs/base/common/jsonFormatter","fs","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/userDataSync/common/content","vs/base/common/decorators","vs/base/common/iterator","net","vs/base/common/date","vs/base/parts/ipc/node/ipc.cp","vs/platform/localizations/common/localizations","vs/platform/native/electron-sandbox/native","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/extensionManagement/common/extensionStorage","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/hash","vs/base/common/normalization","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.net","electron","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/environment/common/environmentService","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/ignoredExtensions","vs/base/common/assert","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/mime","vs/base/common/processes","vs/base/common/skipList","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/node/decoder","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ports","vs/base/node/ps","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/request/common/request","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/node/shellEnv","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/assignment/common/assignment","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/sign/node/signService","vs/platform/extensionManagement/common/extensionEnablementService","vs/code/electron-browser/sharedProcess/contrib/extensionsCleaner","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/assignment/common/assignmentService","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/shellEnv","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","string_decoder","util","minimist","assert","path","graceful-fs","yauzl","yazl","zlib","vs/code/electron-browser/sharedProcess/sharedProcessMain"],ne=function(K){for(var e=[],k=0,t=K.length;k<t;k++)e[k]=te[K[k]];return e};define(te[99],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function k(t,L){if(!t)throw new Error(L?`Assertion failed (${L})`:"Assertion Failed")}e.ok=k}),define(te[48],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function k(A){return A?A.replace(/\$\((.*?)\)/g,(R,b)=>` ${b} `).trim():""}e.getCodiconAriaLabel=k;class t{constructor(R,b,C){this.id=R,this.definition=b,this.description=C,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function L(A,R){const b=["codicon","codicon-"+A];return R&&b.push("codicon-modifier-"+R),b}e.getClassNamesArray=L;var T;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function b(E){if(E instanceof t)return["codicon","codicon-"+E.id];const f=R.exec(E.id);if(!f)return b(t.error);let[,p,h]=f;const u=["codicon","codicon-"+p];return h&&u.push("codicon-modifier-"+h.substr(1)),u}A.asClassNameArray=b;function C(E){return b(E).join(" ")}A.asClassName=C;function P(E){return"."+b(E).join(".")}A.asCSSSelector=P})(T=e.CSSIcon||(e.CSSIcon={}))}),define(te[68],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const k=Object.prototype.hasOwnProperty;function t(P){const E=[];for(let f in P)k.call(P,f)&&E.push(P[f]);return E}e.values=t;function L(P,E){for(let f in P)if(k.call(P,f)&&E({key:f,value:P[f]},function(){delete P[f]})===!1)return}e.forEach=L;function T(P,E){const f=Object.create(null);for(const p of P){const h=E(p);let u=f[h];u||(u=f[h]=[]),u.push(p)}return f}e.groupBy=T;function A(P){const E=Object.create(null);return P&&P.forEach((f,p)=>{E[p]=f}),E}e.fromMap=A;function R(P,E){const f=[],p=[];for(let h of P)E.has(h)||f.push(h);for(let h of E)P.has(h)||p.push(h);return{removed:f,added:p}}e.diffSets=R;function b(P,E){const f=[],p=[];for(let[h,u]of P)E.has(h)||f.push(u);for(let[h,u]of E)P.has(h)||p.push(u);return{removed:f,added:p}}e.diffMaps=b;class C{constructor(){this.map=new Map}add(E,f){let p=this.map.get(E);p||(p=new Set,this.map.set(E,p)),p.add(f)}delete(E,f){const p=this.map.get(E);!p||(p.delete(f),p.size===0&&this.map.delete(E))}forEach(E,f){const p=this.map.get(E);!p||p.forEach(f)}}e.SetMap=C}),define(te[54],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function k(A){return(R,b,C)=>{let P=null,E=null;if(typeof C.value=="function"?(P="value",E=C.value):typeof C.get=="function"&&(P="get",E=C.get),!E)throw new Error("not supported");C[P]=A(E,b)}}e.createDecorator=k;function t(A,R,b){let C=null,P=null;if(typeof b.value=="function"?(C="value",P=b.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(C="get",P=b.get),!P)throw new Error("not supported");const E=`$memoize$${R}`;b[C]=function(...f){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,f)}),this[E]}}e.memoize=t;function L(A,R,b){return k((C,P)=>{const E=`$debounce$${P}`,f=`$debounce$result$${P}`;return function(...p){this[f]||(this[f]=b?b():void 0),clearTimeout(this[E]),R&&(this[f]=R(this[f],...p),p=[this[f]]),this[E]=setTimeout(()=>{C.apply(this,p),this[f]=b?b():void 0},A)}})}e.debounce=L;function T(A,R,b){return k((C,P)=>{const E=`$throttle$timer$${P}`,f=`$throttle$result$${P}`,p=`$throttle$lastRun$${P}`,h=`$throttle$pending$${P}`;return function(...u){if(this[f]||(this[f]=b?b():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),R&&(this[f]=R(this[f],...u)),this[h])return;const v=this[p]+A;v<=Date.now()?(this[p]=Date.now(),C.apply(this,[this[f]]),this[f]=b?b():void 0):(this[h]=!0,this[E]=setTimeout(()=>{this[h]=!1,this[p]=Date.now(),C.apply(this,[this[f]]),this[f]=b?b():void 0},v-Date.now()))}})}e.throttle=T}),define(te[9],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class k{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(d){setTimeout(()=>{throw d.stack?new Error(d.message+`

`+d.stack):d},0)}}addListener(d){return this.listeners.push(d),()=>{this._removeListener(d)}}emit(d){this.listeners.forEach(i=>{i(d)})}_removeListener(d){this.listeners.splice(this.listeners.indexOf(d),1)}setUnexpectedErrorHandler(d){this.unexpectedErrorHandler=d}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(d){this.unexpectedErrorHandler(d),this.emit(d)}onUnexpectedExternalError(d){this.unexpectedErrorHandler(d)}}e.ErrorHandler=k,e.errorHandler=new k;function t(S){e.errorHandler.setUnexpectedErrorHandler(S)}e.setUnexpectedErrorHandler=t;function L(S){b(S)||e.errorHandler.onUnexpectedError(S)}e.onUnexpectedError=L;function T(S){b(S)||e.errorHandler.onUnexpectedExternalError(S)}e.onUnexpectedExternalError=T;function A(S){if(S instanceof Error){let{name:d,message:i}=S;const c=S.stacktrace||S.stack;return{$isError:!0,name:d,message:i,stack:c}}return S}e.transformErrorForSerialization=A;const R="Canceled";function b(S){return S instanceof C?!0:S instanceof Error&&S.name===R&&S.message===R}e.isCancellationError=b;class C extends Error{constructor(){super(R);this.name=this.message}}e.CancellationError=C;function P(){const S=new Error(R);return S.name=S.message,S}e.canceled=P;function E(S){return S?new Error(`Illegal argument: ${S}`):new Error("Illegal argument")}e.illegalArgument=E;function f(S){return S?new Error(`Illegal state: ${S}`):new Error("Illegal state")}e.illegalState=f;function p(S){return S?new Error(`readonly property '${S} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function h(S){const d=new Error(`${S} has been disposed`);return d.name="DISPOSED",d}e.disposed=h;function u(S){return S?S.message?S.message:S.stack?S.stack.split(`
`)[0]:String(S):"Error"}e.getErrorMessage=u;class v extends Error{constructor(d){super("NotImplemented");d&&(this.message=d)}}e.NotImplementedError=v;class m extends Error{constructor(d){super("NotSupported");d&&(this.message=d)}}e.NotSupportedError=m;class w extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=w;class y extends Error{constructor(){super(...arguments);this.logTelemetry=!1}}e.ErrorNoTelemetry=y}),define(te[16],ne([0,1,9]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function t(q,F=0){return q[q.length-(1+F)]}e.tail=t;function L(q){if(q.length===0)throw new Error("Invalid tail call");return[q.slice(0,q.length-1),q[q.length-1]]}e.tail2=L;function T(q,F,$=(z,H)=>z===H){if(q===F)return!0;if(!q||!F||q.length!==F.length)return!1;for(let z=0,H=q.length;z<H;z++)if(!$(q[z],F[z]))return!1;return!0}e.equals=T;function A(q,F,$){let z=0,H=q.length-1;for(;z<=H;){const ee=(z+H)/2|0,se=$(q[ee],F);if(se<0)z=ee+1;else if(se>0)H=ee-1;else return ee}return-(z+1)}e.binarySearch=A;function R(q,F){let $=0,z=q.length;if(z===0)return 0;for(;$<z;){const H=Math.floor(($+z)/2);F(q[H])?z=H:$=H+1}return $}e.findFirstInSorted=R;function b(q,F,$){if(q=q|0,q>=F.length)throw new TypeError("invalid index");let z=F[Math.floor(F.length*Math.random())],H=[],ee=[],se=[];for(let ae of F){const de=$(ae,z);de<0?H.push(ae):de>0?ee.push(ae):se.push(ae)}return q<H.length?b(q,H,$):q<H.length+se.length?se[0]:b(q-(H.length+se.length),ee,$)}e.quickSelect=b;function C(q,F){const $=[];let z;for(const H of q.slice(0).sort(F))!z||F(z[0],H)!==0?(z=[H],$.push(z)):z.push(H);return $}e.groupBy=C;function P(q,F,$){const z=[];function H(ae,de,ge){if(de===0&&ge.length===0)return;const Ee=z[z.length-1];Ee&&Ee.start+Ee.deleteCount===ae?(Ee.deleteCount+=de,Ee.toInsert.push(...ge)):z.push({start:ae,deleteCount:de,toInsert:ge})}let ee=0,se=0;for(;;){if(ee===q.length){H(ee,0,F.slice(se));break}if(se===F.length){H(ee,q.length-ee,[]);break}const ae=q[ee],de=F[se],ge=$(ae,de);ge===0?(ee+=1,se+=1):ge<0?(H(ee,1,[]),ee+=1):ge>0&&(H(ee,0,[de]),se+=1)}return z}e.sortedDiff=P;function E(q,F,$){const z=P(q,F,$),H=[],ee=[];for(const se of z)H.push(...q.slice(se.start,se.start+se.deleteCount)),ee.push(...se.toInsert);return{removed:H,added:ee}}e.delta=E;function f(q,F,$){if($===0)return[];const z=q.slice(0,$).sort(F);return h(q,F,z,$,q.length),z}e.top=f;function p(q,F,$,z,H){return $===0?Promise.resolve([]):new Promise((ee,se)=>{(async()=>{const ae=q.length,de=q.slice(0,$).sort(F);for(let ge=$,Ee=Math.min($+z,ae);ge<ae;ge=Ee,Ee=Math.min(Ee+z,ae)){if(ge>$&&await new Promise(Se=>setTimeout(Se)),H&&H.isCancellationRequested)throw(0,k.canceled)();h(q,F,de,ge,Ee)}return de})().then(ee,se)})}e.topAsync=p;function h(q,F,$,z,H){for(const ee=$.length;z<H;z++){const se=q[z];if(F(se,$[ee-1])<0){$.pop();const ae=R($,de=>F(se,de)<0);$.splice(ae,0,se)}}}function u(q){return q.filter(F=>!!F)}e.coalesce=u;function v(q){let F=0;for(let $=0;$<q.length;$++)q[$]&&(q[F]=q[$],F+=1);q.length=F}e.coalesceInPlace=v;function m(q,F,$){q.splice($,0,q.splice(F,1)[0])}e.move=m;function w(q){return!Array.isArray(q)||q.length===0}e.isFalsyOrEmpty=w;function y(q){return Array.isArray(q)&&q.length>0}e.isNonEmptyArray=y;function S(q,F=$=>$){const $=new Set;return q.filter(z=>{const H=F(z);return $.has(H)?!1:($.add(H),!0)})}e.distinct=S;function d(q){const F=new Set;return $=>{const z=q($);return F.has(z)?!1:(F.add(z),!0)}}e.uniqueFilter=d;function i(q,F){const $=c(q,F);if($!==-1)return q[$]}e.findLast=i;function c(q,F){for(let $=q.length-1;$>=0;$--){const z=q[$];if(F(z))return $}return-1}e.lastIndex=c;function r(q,F){return q.length>0?q[0]:F}e.firstOrDefault=r;function n(q,F,$=(z,H)=>z===H){let z=0;for(let H=0,ee=Math.min(q.length,F.length);H<ee&&$(q[H],F[H]);H++)z++;return z}e.commonPrefixLength=n;function o(q){return[].concat(...q)}e.flatten=o;function s(q,F){let $=typeof F=="number"?q:0;typeof F=="number"?$=q:($=0,F=q);const z=[];if($<=F)for(let H=$;H<F;H++)z.push(H);else for(let H=$;H>F;H--)z.push(H);return z}e.range=s;function a(q,F,$){return q.reduce((z,H)=>(z[F(H)]=$?$(H):H,z),Object.create(null))}e.index=a;function l(q,F){return q.push(F),()=>g(q,F)}e.insert=l;function g(q,F){const $=q.indexOf(F);if($>-1)return q.splice($,1),F}e.remove=g;function I(q,F,$){const z=q.slice(0,F),H=q.slice(F);return z.concat($,H)}e.arrayInsert=I;function _(q,F){let $;if(typeof F=="number"){let z=F;$=()=>{const H=Math.sin(z++)*179426549;return H-Math.floor(H)}}else $=Math.random;for(let z=q.length-1;z>0;z-=1){const H=Math.floor($()*(z+1)),ee=q[z];q[z]=q[H],q[H]=ee}}e.shuffle=_;function O(q,F){const $=q.indexOf(F);$>-1&&(q.splice($,1),q.unshift(F))}e.pushToStart=O;function U(q,F){const $=q.indexOf(F);$>-1&&(q.splice($,1),q.push(F))}e.pushToEnd=U;function D(q,F){return Array.isArray(q)?q.map(F):F(q)}e.mapArrayOrNot=D;function M(q){return Array.isArray(q)?q:[q]}e.asArray=M;function N(q){return q[Math.floor(Math.random()*q.length)]}e.getRandomElement=N;function x(q,F){for(const $ of q){const z=F($);if(z!==void 0)return z}}e.mapFind=x;function Q(q,F,$){const z=ie(q,F),H=q.length,ee=$.length;q.length=H+ee;for(let se=H-1;se>=z;se--)q[se+ee]=q[se];for(let se=0;se<ee;se++)q[se+z]=$[se]}e.insertInto=Q;function W(q,F,$,z){const H=ie(q,F),ee=q.splice(H,$);return Q(q,H,z),ee}e.splice=W;function ie(q,F){return F<0?Math.max(F+q.length,0):Math.min(F,q.length)}function B(q,F){return($,z)=>F(q($),q(z))}e.compareBy=B;const j=(q,F)=>q-F;e.numberComparator=j;function Y(q,F){if(q.length===0)return;let $=q[0];for(let z=1;z<q.length;z++){const H=q[z];F(H,$)>0&&($=H)}return $}e.findMaxBy=Y;function V(q,F){if(q.length===0)return;let $=q[0];for(let z=1;z<q.length;z++){const H=q[z];F(H,$)>=0&&($=H)}return $}e.findLastMaxBy=V;function J(q,F){return Y(q,($,z)=>-F($,z))}e.findMinBy=J;class Z{constructor(F){this.items=F,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(F){let $=this.firstIdx;for(;$<this.items.length&&F(this.items[$]);)$++;const z=$===this.firstIdx?null:this.items.slice(this.firstIdx,$);return this.firstIdx=$,z}takeFromEndWhile(F){let $=this.lastIdx;for(;$>=0&&F(this.items[$]);)$--;const z=$===this.lastIdx?null:this.items.slice($+1,this.lastIdx+1);return this.lastIdx=$,z}peek(){return this.items[this.firstIdx]}dequeue(){const F=this.items[this.firstIdx];return this.firstIdx++,F}takeCount(F){const $=this.items.slice(this.firstIdx,this.firstIdx+F);return this.firstIdx+=F,$}}e.ArrayQueue=Z}),define(te[69],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function k(t){const L=this;let T=!1,A;return function(){return T||(T=!0,A=t.apply(L,arguments)),A}}e.once=k}),define(te[55],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var k;(function(t){function L(d){return d&&typeof d=="object"&&typeof d[Symbol.iterator]=="function"}t.is=L;const T=Object.freeze([]);function A(){return T}t.empty=A;function*R(d){yield d}t.single=R;function b(d){return d||T}t.from=b;function C(d){return!d||d[Symbol.iterator]().next().done===!0}t.isEmpty=C;function P(d){return d[Symbol.iterator]().next().value}t.first=P;function E(d,i){for(const c of d)if(i(c))return!0;return!1}t.some=E;function f(d,i){for(const c of d)if(i(c))return c}t.find=f;function*p(d,i){for(const c of d)i(c)&&(yield c)}t.filter=p;function*h(d,i){let c=0;for(const r of d)yield i(r,c++)}t.map=h;function*u(...d){for(const i of d)for(const c of i)yield c}t.concat=u;function*v(d){for(const i of d)for(const c of i)yield c}t.concatNested=v;function m(d,i,c){let r=c;for(const n of d)r=i(r,n);return r}t.reduce=m;function*w(d,i,c=d.length){for(i<0&&(i+=d.length),c<0?c+=d.length:c>d.length&&(c=d.length);i<c;i++)yield d[i]}t.slice=w;function y(d,i=Number.POSITIVE_INFINITY){const c=[];if(i===0)return[c,d];const r=d[Symbol.iterator]();for(let n=0;n<i;n++){const o=r.next();if(o.done)return[c,t.empty()];c.push(o.value)}return[c,{[Symbol.iterator](){return r}}]}t.consume=y;function S(d,i,c=(r,n)=>r===n){const r=d[Symbol.iterator](),n=i[Symbol.iterator]();for(;;){const o=r.next(),s=n.next();if(o.done!==s.done)return!1;if(o.done)return!0;if(!c(o.value,s.value))return!1}}t.equals=S})(k=e.Iterable||(e.Iterable={}))}),define(te[35],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var k;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(k=e.ScanError||(e.ScanError={}));var t;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var L;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(L=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(i){i.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function A(i,c=!1){let r=0,n=i.length,o="",s=0,a=16,l=0;function g(N){let x=0,Q=0;for(;x<N;){const W=i.charCodeAt(r);if(W>=48&&W<=57)Q=Q*16+W-48;else if(W>=65&&W<=70)Q=Q*16+W-65+10;else if(W>=97&&W<=102)Q=Q*16+W-97+10;else break;r++,x++}return x<N&&(Q=-1),Q}function I(N){r=N,o="",s=0,a=16,l=0}function _(){const N=r;if(i.charCodeAt(r)===48)r++;else for(r++;r<i.length&&C(i.charCodeAt(r));)r++;if(r<i.length&&i.charCodeAt(r)===46)if(r++,r<i.length&&C(i.charCodeAt(r)))for(r++;r<i.length&&C(i.charCodeAt(r));)r++;else return l=3,i.substring(N,r);let x=r;if(r<i.length&&(i.charCodeAt(r)===69||i.charCodeAt(r)===101))if(r++,(r<i.length&&i.charCodeAt(r)===43||i.charCodeAt(r)===45)&&r++,r<i.length&&C(i.charCodeAt(r))){for(r++;r<i.length&&C(i.charCodeAt(r));)r++;x=r}else l=3;return i.substring(N,x)}function O(){let N="",x=r;for(;;){if(r>=n){N+=i.substring(x,r),l=2;break}const Q=i.charCodeAt(r);if(Q===34){N+=i.substring(x,r),r++;break}if(Q===92){if(N+=i.substring(x,r),r++,r>=n){l=2;break}switch(i.charCodeAt(r++)){case 34:N+='"';break;case 92:N+="\\";break;case 47:N+="/";break;case 98:N+="\b";break;case 102:N+="\f";break;case 110:N+=`
`;break;case 114:N+="\r";break;case 116:N+="	";break;case 117:{const ie=g(4);ie>=0?N+=String.fromCharCode(ie):l=4;break}default:l=5}x=r;continue}if(Q>=0&&Q<=31)if(b(Q)){N+=i.substring(x,r),l=2;break}else l=6;r++}return N}function U(){if(o="",l=0,s=r,r>=n)return s=n,a=17;let N=i.charCodeAt(r);if(R(N)){do r++,o+=String.fromCharCode(N),N=i.charCodeAt(r);while(R(N));return a=15}if(b(N))return r++,o+=String.fromCharCode(N),N===13&&i.charCodeAt(r)===10&&(r++,o+=`
`),a=14;switch(N){case 123:return r++,a=1;case 125:return r++,a=2;case 91:return r++,a=3;case 93:return r++,a=4;case 58:return r++,a=6;case 44:return r++,a=5;case 34:return r++,o=O(),a=10;case 47:{const x=r-1;if(i.charCodeAt(r+1)===47){for(r+=2;r<n&&!b(i.charCodeAt(r));)r++;return o=i.substring(x,r),a=12}if(i.charCodeAt(r+1)===42){r+=2;const Q=n-1;let W=!1;for(;r<Q;){if(i.charCodeAt(r)===42&&i.charCodeAt(r+1)===47){r+=2,W=!0;break}r++}return W||(r++,l=1),o=i.substring(x,r),a=13}return o+=String.fromCharCode(N),r++,a=16}case 45:if(o+=String.fromCharCode(N),r++,r===n||!C(i.charCodeAt(r)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=_(),a=11;default:for(;r<n&&D(N);)r++,N=i.charCodeAt(r);if(s!==r){switch(o=i.substring(s,r),o){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return o+=String.fromCharCode(N),r++,a=16}}function D(N){if(R(N)||b(N))return!1;switch(N){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let N;do N=U();while(N>=12&&N<=15);return N}return{setPosition:I,getPosition:()=>r,scan:c?M:U,getToken:()=>a,getTokenValue:()=>o,getTokenOffset:()=>s,getTokenLength:()=>r-s,getTokenError:()=>l}}e.createScanner=A;function R(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function b(i){return i===10||i===13||i===8232||i===8233}function C(i){return i>=48&&i<=57}var P;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(P||(P={}));function E(i,c){const r=[],n=new Object;let o;const s={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function l(g,I,_,O){s.value=g,s.offset=I,s.length=_,s.type=O,s.colonOffset=void 0,o=s}try{y(i,{onObjectBegin:(g,I)=>{if(c<=g)throw n;o=void 0,a=c>g,r.push("")},onObjectProperty:(g,I,_)=>{if(c<I||(l(g,I,_,"property"),r[r.length-1]=g,c<=I+_))throw n},onObjectEnd:(g,I)=>{if(c<=g)throw n;o=void 0,r.pop()},onArrayBegin:(g,I)=>{if(c<=g)throw n;o=void 0,r.push(0)},onArrayEnd:(g,I)=>{if(c<=g)throw n;o=void 0,r.pop()},onLiteralValue:(g,I,_)=>{if(c<I||(l(g,I,_,d(g)),c<=I+_))throw n},onSeparator:(g,I,_)=>{if(c<=I)throw n;if(g===":"&&o&&o.type==="property")o.colonOffset=I,a=!1,o=void 0;else if(g===","){const O=r[r.length-1];typeof O=="number"?r[r.length-1]=O+1:(a=!0,r[r.length-1]=""),o=void 0}}})}catch(g){if(g!==n)throw g}return{path:r,previousNode:o,isAtPropertyKey:a,matches:g=>{let I=0;for(let _=0;I<g.length&&_<r.length;_++)if(g[I]===r[_]||g[I]==="*")I++;else if(g[I]!=="**")return!1;return I===g.length}}}e.getLocation=E;function f(i,c=[],r=T.DEFAULT){let n=null,o=[];const s=[];function a(g){Array.isArray(o)?o.push(g):n!==null&&(o[n]=g)}return y(i,{onObjectBegin:()=>{const g={};a(g),s.push(o),o=g,n=null},onObjectProperty:g=>{n=g},onObjectEnd:()=>{o=s.pop()},onArrayBegin:()=>{const g=[];a(g),s.push(o),o=g,n=null},onArrayEnd:()=>{o=s.pop()},onLiteralValue:a,onError:(g,I,_)=>{c.push({error:g,offset:I,length:_})}},r),o[0]}e.parse=f;function p(i,c=[],r=T.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(g){n.type==="property"&&(n.length=g-n.offset,n=n.parent)}function s(g){return n.children.push(g),g}y(i,{onObjectBegin:g=>{n=s({type:"object",offset:g,length:-1,parent:n,children:[]})},onObjectProperty:(g,I,_)=>{n=s({type:"property",offset:I,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:g,offset:I,length:_,parent:n})},onObjectEnd:(g,I)=>{n.length=g+I-n.offset,n=n.parent,o(g+I)},onArrayBegin:(g,I)=>{n=s({type:"array",offset:g,length:-1,parent:n,children:[]})},onArrayEnd:(g,I)=>{n.length=g+I-n.offset,n=n.parent,o(g+I)},onLiteralValue:(g,I,_)=>{s({type:d(g),offset:I,length:_,parent:n,value:g}),o(I+_)},onSeparator:(g,I,_)=>{n.type==="property"&&(g===":"?n.colonOffset=I:g===","&&o(I))},onError:(g,I,_)=>{c.push({error:g,offset:I,length:_})}},r);const l=n.children[0];return l&&delete l.parent,l}e.parseTree=p;function h(i,c){if(!i)return;let r=i;for(let n of c)if(typeof n=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let o=!1;for(const s of r.children)if(Array.isArray(s.children)&&s.children[0].value===n){r=s.children[1],o=!0;break}if(!o)return}else{const o=n;if(r.type!=="array"||o<0||!Array.isArray(r.children)||o>=r.children.length)return;r=r.children[o]}return r}e.findNodeAtLocation=h;function u(i){if(!i.parent||!i.parent.children)return[];const c=u(i.parent);if(i.parent.type==="property"){const r=i.parent.children[0].value;c.push(r)}else if(i.parent.type==="array"){const r=i.parent.children.indexOf(i);r!==-1&&c.push(r)}return c}e.getNodePath=u;function v(i){switch(i.type){case"array":return i.children.map(v);case"object":{const c=Object.create(null);for(let r of i.children){const n=r.children[1];n&&(c[r.children[0].value]=v(n))}return c}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=v;function m(i,c,r=!1){return c>=i.offset&&c<i.offset+i.length||r&&c===i.offset+i.length}e.contains=m;function w(i,c,r=!1){if(m(i,c,r)){const n=i.children;if(Array.isArray(n))for(let o=0;o<n.length&&n[o].offset<=c;o++){const s=w(n[o],c,r);if(s)return s}return i}}e.findNodeAtOffset=w;function y(i,c,r=T.DEFAULT){const n=A(i,!1);function o(Z){return Z?()=>Z(n.getTokenOffset(),n.getTokenLength()):()=>!0}function s(Z){return Z?q=>Z(q,n.getTokenOffset(),n.getTokenLength()):()=>!0}const a=o(c.onObjectBegin),l=s(c.onObjectProperty),g=o(c.onObjectEnd),I=o(c.onArrayBegin),_=o(c.onArrayEnd),O=s(c.onLiteralValue),U=s(c.onSeparator),D=o(c.onComment),M=s(c.onError),N=r&&r.disallowComments,x=r&&r.allowTrailingComma;function Q(){for(;;){const Z=n.scan();switch(n.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:N||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(Z){case 12:case 13:N?W(10):D();break;case 16:W(1);break;case 15:case 14:break;default:return Z}}}function W(Z,q=[],F=[]){if(M(Z),q.length+F.length>0){let $=n.getToken();for(;$!==17;){if(q.indexOf($)!==-1){Q();break}else if(F.indexOf($)!==-1)break;$=Q()}}}function ie(Z){const q=n.getTokenValue();return Z?O(q):l(q),Q(),!0}function B(){switch(n.getToken()){case 11:{let Z=0;try{Z=JSON.parse(n.getTokenValue()),typeof Z!="number"&&(W(2),Z=0)}catch{W(2)}O(Z);break}case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return Q(),!0}function j(){return n.getToken()!==10?(W(3,[],[2,5]),!1):(ie(!1),n.getToken()===6?(U(":"),Q(),J()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function Y(){a(),Q();let Z=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(Z||W(4,[],[]),U(","),Q(),n.getToken()===2&&x)break}else Z&&W(6,[],[]);j()||W(4,[],[2,5]),Z=!0}return g(),n.getToken()!==2?W(7,[2],[]):Q(),!0}function V(){I(),Q();let Z=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(Z||W(4,[],[]),U(","),Q(),n.getToken()===4&&x)break}else Z&&W(6,[],[]);J()||W(4,[],[4,5]),Z=!0}return _(),n.getToken()!==4?W(8,[4],[]):Q(),!0}function J(){switch(n.getToken()){case 3:return V();case 1:return Y();case 10:return ie(!0);default:return B()}}return Q(),n.getToken()===17?r.allowEmptyContent?!0:(W(4,[],[]),!1):J()?(n.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.visit=y;function S(i,c){let r=A(i),n=[],o,s=0,a;do switch(a=r.getPosition(),o=r.scan(),o){case 12:case 13:case 17:s!==a&&n.push(i.substring(s,a)),c!==void 0&&n.push(r.getTokenValue().replace(/[^\r\n]/g,c)),s=r.getPosition();break}while(o!==17);return n.join("")}e.stripComments=S;function d(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=d}),define(te[49],ne([0,1,35]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(C,P,E){let f,p,h,u,v;if(P){for(u=P.offset,v=u+P.length,h=u;h>0&&!b(C,h-1);)h--;let a=v;for(;a<C.length&&!b(C,a);)a++;p=C.substring(h,a),f=A(p,E)}else p=C,f=0,h=0,u=0,v=C.length;const m=R(E,C);let w=!1,y=0,S;E.insertSpaces?S=T(" ",E.tabSize||4):S="	";const d=(0,k.createScanner)(p,!1);let i=!1;function c(){return m+T(S,f+y)}function r(){let a=d.scan();for(w=!1;a===15||a===14;)w=w||a===14,a=d.scan();return i=a===16||d.getTokenError()!==0,a}const n=[];function o(a,l,g){!i&&l<v&&g>u&&C.substring(l,g)!==a&&n.push({offset:l,length:g-l,content:a})}let s=r();if(s!==17){const a=d.getTokenOffset()+h,l=T(S,f);o(l,h,a)}for(;s!==17;){let a=d.getTokenOffset()+d.getTokenLength()+h,l=r(),g="";for(;!w&&(l===12||l===13);){const _=d.getTokenOffset()+h;o(" ",a,_),a=d.getTokenOffset()+d.getTokenLength()+h,g=l===12?c():"",l=r()}if(l===2)s!==1&&(y--,g=c());else if(l===4)s!==3&&(y--,g=c());else{switch(s){case 3:case 1:y++,g=c();break;case 5:case 12:g=c();break;case 13:w?g=c():g=" ";break;case 6:g=" ";break;case 10:if(l===6){g="";break}case 7:case 8:case 9:case 11:case 2:case 4:l===12||l===13?g=" ":l!==5&&l!==17&&(i=!0);break;case 16:i=!0;break}w&&(l===12||l===13)&&(g=c())}const I=d.getTokenOffset()+h;o(g,a,I),s=l}return n}e.format=t;function L(C,P){const E=JSON.stringify(C,void 0,P.insertSpaces?P.tabSize||4:"	");return P.eol!==void 0?E.replace(/\r\n|\r|\n/g,P.eol):E}e.toFormattedString=L;function T(C,P){let E="";for(let f=0;f<P;f++)E+=C;return E}function A(C,P){let E=0,f=0;const p=P.tabSize||4;for(;E<C.length;){const h=C.charAt(E);if(h===" ")f++;else if(h==="	")f+=p;else break;E++}return Math.floor(f/p)}function R(C,P){for(let E=0;E<P.length;E++){const f=P.charAt(E);if(f==="\r")return E+1<P.length&&P.charAt(E+1)===`
`?`\r
`:"\r";if(f===`
`)return`
`}return C&&C.eol||`
`}e.getEOL=R;function b(C,P){return`\r
`.indexOf(C.charAt(P))!==-1}e.isEOL=b}),define(te[70],ne([0,1,35,49]),function(K,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function L(C,P,E){return T(C,P,void 0,E)}e.removeProperty=L;function T(C,P,E,f,p){const h=P.slice(),u=[],v=(0,k.parseTree)(C,u);let m,w;for(;h.length>0&&(w=h.pop(),m=(0,k.findNodeAtLocation)(v,h),m===void 0&&E!==void 0);)typeof w=="string"?E={[w]:E}:E=[E];if(m)if(m.type==="object"&&typeof w=="string"&&Array.isArray(m.children)){const y=(0,k.findNodeAtLocation)(m,[w]);if(y!==void 0)if(E===void 0){if(!y.parent)throw new Error("Malformed AST");const S=m.children.indexOf(y.parent);let d,i=y.parent.offset+y.parent.length;if(S>0){const c=m.children[S-1];d=c.offset+c.length}else d=m.offset+1,m.children.length>1&&(i=m.children[1].offset);return A(C,{offset:d,length:i-d,content:""},f)}else return A(C,{offset:y.offset,length:y.length,content:JSON.stringify(E)},f);else{if(E===void 0)return[];const S=`${JSON.stringify(w)}: ${JSON.stringify(E)}`,d=p?p(m.children.map(c=>c.children[0].value)):m.children.length;let i;if(d>0){const c=m.children[d-1];i={offset:c.offset+c.length,length:0,content:","+S}}else m.children.length===0?i={offset:m.offset+1,length:0,content:S}:i={offset:m.offset+1,length:0,content:S+","};return A(C,i,f)}}else if(m.type==="array"&&typeof w=="number"&&Array.isArray(m.children))if(E!==void 0){const y=`${JSON.stringify(E)}`;let S;if(m.children.length===0||w===0)S={offset:m.offset+1,length:0,content:m.children.length===0?y:y+","};else{const d=w===-1||w>m.children.length?m.children.length:w,i=m.children[d-1];S={offset:i.offset+i.length,length:0,content:","+y}}return A(C,S,f)}else{const y=w,S=m.children[y];let d;if(m.children.length===1)d={offset:m.offset+1,length:m.length-2,content:""};else if(m.children.length-1===y){const i=m.children[y-1],c=i.offset+i.length,r=m.offset+m.length;d={offset:c,length:r-2-c,content:""}}else d={offset:S.offset,length:m.children[y+1].offset-S.offset,content:""};return A(C,d,f)}else throw new Error(`Can not add ${typeof w!="number"?"index":"property"} to parent of type ${m.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return A(C,{offset:v?v.offset:0,length:v?v.length:0,content:JSON.stringify(E)},f)}}e.setProperty=T;function A(C,P,E){let f=R(C,P),p=P.offset,h=P.offset+P.content.length;if(P.length===0||P.content.length===0){for(;p>0&&!(0,t.isEOL)(f,p-1);)p--;for(;h<f.length&&!(0,t.isEOL)(f,h);)h++}const u=(0,t.format)(f,{offset:p,length:h-p},E);for(let m=u.length-1;m>=0;m--){const w=u[m];f=R(f,w),p=Math.min(p,w.offset),h=Math.max(h,w.offset+w.length),h+=w.content.length-w.length}const v=C.length-(f.length-h)-p;return[{offset:p,length:v,content:f.substring(p,h)}]}e.withFormatting=A;function R(C,P){return C.substring(0,P.offset)+P.content+C.substring(P.offset+P.length)}e.applyEdit=R;function b(C,P){let E=P.slice(0).sort((p,h)=>{const u=p.offset-h.offset;return u===0?p.length-h.length:u}),f=C.length;for(let p=E.length-1;p>=0;p--){let h=E[p];if(h.offset+h.length<=f)C=R(C,h);else throw new Error("Overlapping edit");f=h.offset}return C}e.applyEdits=b}),define(te[100],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class k{constructor(L){this.executor=L,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(L){this._error=L}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(L){return new k(()=>L(this.getValue()))}}e.Lazy=k}),define(te[2],ne([0,1,69,55]),function(K,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const L=!1;let T=null;function A(o){T=o}if(e.setDisposableTracker=A,L){const o="__is_disposable_tracked__";A(new class{trackDisposable(s){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[o]||console.log(a)},3e3)}setParent(s,a){if(s&&s!==w.None)try{s[o]=!0}catch{}}markAsDisposed(s){if(s&&s!==w.None)try{s[o]=!0}catch{}}markAsSingleton(s){}})}function R(o){return T?.trackDisposable(o),o}function b(o){T?.markAsDisposed(o)}function C(o,s){T?.setParent(o,s)}function P(o,s){if(!!T)for(const a of o)T.setParent(a,s)}function E(o){return T?.markAsSingleton(o),o}e.markAsSingleton=E;class f extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=f;function p(o){return typeof o.dispose=="function"&&o.dispose.length===0}e.isDisposable=p;function h(o){if(t.Iterable.is(o)){let s=[];for(const a of o)if(a)try{a.dispose()}catch(l){s.push(l)}if(s.length===1)throw s[0];if(s.length>1)throw new f(s);return Array.isArray(o)?[]:o}else if(o)return o.dispose(),o}e.dispose=h;function u(...o){const s=v(()=>h(o));return P(o,s),s}e.combinedDisposable=u;function v(o){const s=R({dispose:(0,k.once)(()=>{b(s),o()})});return s}e.toDisposable=v;class m{constructor(){this._toDispose=new Set,this._isDisposed=!1,R(this)}dispose(){this._isDisposed||(b(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return C(s,this),this._isDisposed?m.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=m,m.DISABLE_DISPOSED_WARNING=!1;class w{constructor(){this._store=new m,R(this),C(this._store,this)}dispose(){b(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=w,w.None=Object.freeze({dispose(){}});class y{constructor(){this._isDisposed=!1,R(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&C(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,b(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&C(s,null),s}}e.MutableDisposable=y;class S{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=S;class d{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,R(this)}set(s){let a=s;return this.unset=()=>a=void 0,this.isset=()=>a!==void 0,this.dispose=()=>{a&&(a(),a=void 0,b(this))},this}}e.SafeDisposable=d;class i{constructor(){this.references=new Map}acquire(s,...a){let l=this.references.get(s);l||(l={counter:0,object:this.createReferencedObject(s,...a)},this.references.set(s,l));const{object:g}=l,I=(0,k.once)(()=>{--l.counter==0&&(this.destroyReferencedObject(s,l.object),this.references.delete(s))});return l.counter++,{object:g,dispose:I}}}e.ReferenceCollection=i;class c{constructor(s){this.referenceCollection=s}async acquire(s,...a){const l=this.referenceCollection.acquire(s,...a);try{return{object:await l.object,dispose:()=>l.dispose()}}catch(g){throw l.dispose(),g}}}e.AsyncReferenceCollection=c;class r{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=r;function n(o){const s=new m;try{o(s)}finally{s.dispose()}}e.disposeOnReturn=n}),define(te[101],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class k{constructor(T){this.element=T,this.next=k.Undefined,this.prev=k.Undefined}}k.Undefined=new k(void 0);class t{constructor(){this._first=k.Undefined,this._last=k.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===k.Undefined}clear(){let T=this._first;for(;T!==k.Undefined;){const A=T.next;T.prev=k.Undefined,T.next=k.Undefined,T=A}this._first=k.Undefined,this._last=k.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,A){const R=new k(T);if(this._first===k.Undefined)this._first=R,this._last=R;else if(A){const C=this._last;this._last=R,R.prev=C,C.next=R}else{const C=this._first;this._first=R,R.next=C,C.prev=R}this._size+=1;let b=!1;return()=>{b||(b=!0,this._remove(R))}}shift(){if(this._first!==k.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==k.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==k.Undefined&&T.next!==k.Undefined){const A=T.prev;A.next=T.next,T.next.prev=A}else T.prev===k.Undefined&&T.next===k.Undefined?(this._first=k.Undefined,this._last=k.Undefined):T.next===k.Undefined?(this._last=this._last.prev,this._last.next=k.Undefined):T.prev===k.Undefined&&(this._first=this._first.next,this._first.prev=k.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==k.Undefined;)yield T.element,T=T.next}}e.LinkedList=t}),function(){function K(L){const T=[];typeof L=="number"&&T.push("code/timeOrigin",L);function A(b){T.push(b,Date.now())}function R(){const b=[];for(let C=0;C<T.length;C+=2)b.push({name:T[C],startTime:T[C+1]});return b}return{mark:A,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const A of performance.getEntriesByType("mark"))T.push({name:A.name,startTime:Math.round(L+A.startTime)});return T}};if(typeof process=="object"){const L=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function k(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return k(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=k(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=k(t))}(),define(te[4],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const k="en";let t=!1,L=!1,T=!1,A=!1,R=!1,b=!1,C=!1,P=!1,E=!1,f,p=k,h,u;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let v;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?v=e.globals.vscode.process:typeof process!="undefined"&&(v=process);const m=typeof v?.versions?.electron=="string",w=m&&v?.type==="renderer";if(e.isElectronSandboxed=w&&v?.sandboxed,typeof navigator=="object"&&!w)u=navigator.userAgent,t=u.indexOf("Windows")>=0,L=u.indexOf("Macintosh")>=0,P=(u.indexOf("Macintosh")>=0||u.indexOf("iPad")>=0||u.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,T=u.indexOf("Linux")>=0,b=!0,f=navigator.language,p=f;else if(typeof v=="object"){t=v.platform==="win32",L=v.platform==="darwin",T=v.platform==="linux",A=T&&!!v.env.SNAP&&!!v.env.SNAP_REVISION,C=m,E=!!v.env.CI||!!v.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=k,p=k;const s=v.env.VSCODE_NLS_CONFIG;if(s)try{const a=JSON.parse(s),l=a.availableLanguages["*"];f=a.locale,p=l||k,h=a._translationsConfigFile}catch{}R=!0}else console.error("Unable to resolve platform.");var y;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(y=e.Platform||(e.Platform={}));function S(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=S;let d=0;L?d=1:t?d=3:T&&(d=2),e.isWindows=t,e.isMacintosh=L,e.isLinux=T,e.isLinuxSnap=A,e.isNative=R,e.isElectron=C,e.isWeb=b,e.isWebWorker=b&&typeof e.globals.importScripts=="function",e.isIOS=P,e.isCI=E,e.platform=d,e.userAgent=u,e.language=p;var i;(function(s){function a(){return e.language}s.value=a;function l(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=l;function g(){return e.language==="en"}s.isDefault=g})(i=e.Language||(e.Language={})),e.locale=f,e.translationsConfigFile=h,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let s=[];e.globals.addEventListener("message",l=>{if(l.data&&l.data.vscodeScheduleAsyncWork)for(let g=0,I=s.length;g<I;g++){const _=s[g];if(_.id===l.data.vscodeScheduleAsyncWork){s.splice(g,1),_.callback();return}}});let a=0;return l=>{const g=++a;s.push({id:g,callback:l}),e.globals.postMessage({vscodeScheduleAsyncWork:g},"*")}}return s=>setTimeout(s)})();var c;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(c=e.OperatingSystem||(e.OperatingSystem={})),e.OS=L||P?2:t?1:3;let r=!0,n=!1;function o(){if(!n){n=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,r=new Uint16Array(s.buffer)[0]===(2<<8)+1}return r}e.isLittleEndian=o,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(te[33],ne([0,1,4]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof k.globals.vscode!="undefined"&&typeof k.globals.vscode.process!="undefined"){const L=k.globals.vscode.process;t={get platform(){return L.platform},get arch(){return L.arch},get env(){return L.env},cwd(){return L.cwd()}}}else typeof process!="undefined"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return k.isWindows?"win32":k.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(te[10],ne([0,1,33]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,L=97,T=90,A=122,R=46,b=47,C=92,P=58,E=63;class f extends Error{constructor(S,d,i){let c;typeof d=="string"&&d.indexOf("not ")===0?(c="must not be",d=d.replace(/^not /,"")):c="must be";const r=S.indexOf(".")!==-1?"property":"argument";let n=`The "${S}" ${r} ${c} of type ${d}`;n+=`. Received type ${typeof i}`;super(n);this.code="ERR_INVALID_ARG_TYPE"}}function p(y,S){if(typeof y!="string")throw new f(S,"string",y)}function h(y){return y===b||y===C}function u(y){return y===b}function v(y){return y>=t&&y<=T||y>=L&&y<=A}function m(y,S,d,i){let c="",r=0,n=-1,o=0,s=0;for(let a=0;a<=y.length;++a){if(a<y.length)s=y.charCodeAt(a);else{if(i(s))break;s=b}if(i(s)){if(!(n===a-1||o===1))if(o===2){if(c.length<2||r!==2||c.charCodeAt(c.length-1)!==R||c.charCodeAt(c.length-2)!==R){if(c.length>2){const l=c.lastIndexOf(d);l===-1?(c="",r=0):(c=c.slice(0,l),r=c.length-1-c.lastIndexOf(d)),n=a,o=0;continue}else if(c.length!==0){c="",r=0,n=a,o=0;continue}}S&&(c+=c.length>0?`${d}..`:"..",r=2)}else c.length>0?c+=`${d}${y.slice(n+1,a)}`:c=y.slice(n+1,a),r=a-n-1;n=a,o=0}else s===R&&o!==-1?++o:o=-1}return c}function w(y,S){if(S===null||typeof S!="object")throw new f("pathObject","Object",S);const d=S.dir||S.root,i=S.base||`${S.name||""}${S.ext||""}`;return d?d===S.root?`${d}${i}`:`${d}${y}${i}`:i}e.win32={resolve(...y){let S="",d="",i=!1;for(let c=y.length-1;c>=-1;c--){let r;if(c>=0){if(r=y[c],p(r,"path"),r.length===0)continue}else S.length===0?r=k.cwd():(r=k.env[`=${S}`]||k.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==S.toLowerCase()&&r.charCodeAt(2)===C)&&(r=`${S}\\`));const n=r.length;let o=0,s="",a=!1;const l=r.charCodeAt(0);if(n===1)h(l)&&(o=1,a=!0);else if(h(l))if(a=!0,h(r.charCodeAt(1))){let g=2,I=g;for(;g<n&&!h(r.charCodeAt(g));)g++;if(g<n&&g!==I){const _=r.slice(I,g);for(I=g;g<n&&h(r.charCodeAt(g));)g++;if(g<n&&g!==I){for(I=g;g<n&&!h(r.charCodeAt(g));)g++;(g===n||g!==I)&&(s=`\\\\${_}\\${r.slice(I,g)}`,o=g)}}}else o=1;else v(l)&&r.charCodeAt(1)===P&&(s=r.slice(0,2),o=2,n>2&&h(r.charCodeAt(2))&&(a=!0,o=3));if(s.length>0)if(S.length>0){if(s.toLowerCase()!==S.toLowerCase())continue}else S=s;if(i){if(S.length>0)break}else if(d=`${r.slice(o)}\\${d}`,i=a,a&&S.length>0)break}return d=m(d,!i,"\\",h),i?`${S}\\${d}`:`${S}${d}`||"."},normalize(y){p(y,"path");const S=y.length;if(S===0)return".";let d=0,i,c=!1;const r=y.charCodeAt(0);if(S===1)return u(r)?"\\":y;if(h(r))if(c=!0,h(y.charCodeAt(1))){let o=2,s=o;for(;o<S&&!h(y.charCodeAt(o));)o++;if(o<S&&o!==s){const a=y.slice(s,o);for(s=o;o<S&&h(y.charCodeAt(o));)o++;if(o<S&&o!==s){for(s=o;o<S&&!h(y.charCodeAt(o));)o++;if(o===S)return`\\\\${a}\\${y.slice(s)}\\`;o!==s&&(i=`\\\\${a}\\${y.slice(s,o)}`,d=o)}}}else d=1;else v(r)&&y.charCodeAt(1)===P&&(i=y.slice(0,2),d=2,S>2&&h(y.charCodeAt(2))&&(c=!0,d=3));let n=d<S?m(y.slice(d),!c,"\\",h):"";return n.length===0&&!c&&(n="."),n.length>0&&h(y.charCodeAt(S-1))&&(n+="\\"),i===void 0?c?`\\${n}`:n:c?`${i}\\${n}`:`${i}${n}`},isAbsolute(y){p(y,"path");const S=y.length;if(S===0)return!1;const d=y.charCodeAt(0);return h(d)||S>2&&v(d)&&y.charCodeAt(1)===P&&h(y.charCodeAt(2))},join(...y){if(y.length===0)return".";let S,d;for(let r=0;r<y.length;++r){const n=y[r];p(n,"path"),n.length>0&&(S===void 0?S=d=n:S+=`\\${n}`)}if(S===void 0)return".";let i=!0,c=0;if(typeof d=="string"&&h(d.charCodeAt(0))){++c;const r=d.length;r>1&&h(d.charCodeAt(1))&&(++c,r>2&&(h(d.charCodeAt(2))?++c:i=!1))}if(i){for(;c<S.length&&h(S.charCodeAt(c));)c++;c>=2&&(S=`\\${S.slice(c)}`)}return e.win32.normalize(S)},relative(y,S){if(p(y,"from"),p(S,"to"),y===S)return"";const d=e.win32.resolve(y),i=e.win32.resolve(S);if(d===i||(y=d.toLowerCase(),S=i.toLowerCase(),y===S))return"";let c=0;for(;c<y.length&&y.charCodeAt(c)===C;)c++;let r=y.length;for(;r-1>c&&y.charCodeAt(r-1)===C;)r--;const n=r-c;let o=0;for(;o<S.length&&S.charCodeAt(o)===C;)o++;let s=S.length;for(;s-1>o&&S.charCodeAt(s-1)===C;)s--;const a=s-o,l=n<a?n:a;let g=-1,I=0;for(;I<l;I++){const O=y.charCodeAt(c+I);if(O!==S.charCodeAt(o+I))break;O===C&&(g=I)}if(I!==l){if(g===-1)return i}else{if(a>l){if(S.charCodeAt(o+I)===C)return i.slice(o+I+1);if(I===2)return i.slice(o+I)}n>l&&(y.charCodeAt(c+I)===C?g=I:I===2&&(g=3)),g===-1&&(g=0)}let _="";for(I=c+g+1;I<=r;++I)(I===r||y.charCodeAt(I)===C)&&(_+=_.length===0?"..":"\\..");return o+=g,_.length>0?`${_}${i.slice(o,s)}`:(i.charCodeAt(o)===C&&++o,i.slice(o,s))},toNamespacedPath(y){if(typeof y!="string")return y;if(y.length===0)return"";const S=e.win32.resolve(y);if(S.length<=2)return y;if(S.charCodeAt(0)===C){if(S.charCodeAt(1)===C){const d=S.charCodeAt(2);if(d!==E&&d!==R)return`\\\\?\\UNC\\${S.slice(2)}`}}else if(v(S.charCodeAt(0))&&S.charCodeAt(1)===P&&S.charCodeAt(2)===C)return`\\\\?\\${S}`;return y},dirname(y){p(y,"path");const S=y.length;if(S===0)return".";let d=-1,i=0;const c=y.charCodeAt(0);if(S===1)return h(c)?y:".";if(h(c)){if(d=i=1,h(y.charCodeAt(1))){let o=2,s=o;for(;o<S&&!h(y.charCodeAt(o));)o++;if(o<S&&o!==s){for(s=o;o<S&&h(y.charCodeAt(o));)o++;if(o<S&&o!==s){for(s=o;o<S&&!h(y.charCodeAt(o));)o++;if(o===S)return y;o!==s&&(d=i=o+1)}}}}else v(c)&&y.charCodeAt(1)===P&&(d=S>2&&h(y.charCodeAt(2))?3:2,i=d);let r=-1,n=!0;for(let o=S-1;o>=i;--o)if(h(y.charCodeAt(o))){if(!n){r=o;break}}else n=!1;if(r===-1){if(d===-1)return".";r=d}return y.slice(0,r)},basename(y,S){S!==void 0&&p(S,"ext"),p(y,"path");let d=0,i=-1,c=!0,r;if(y.length>=2&&v(y.charCodeAt(0))&&y.charCodeAt(1)===P&&(d=2),S!==void 0&&S.length>0&&S.length<=y.length){if(S===y)return"";let n=S.length-1,o=-1;for(r=y.length-1;r>=d;--r){const s=y.charCodeAt(r);if(h(s)){if(!c){d=r+1;break}}else o===-1&&(c=!1,o=r+1),n>=0&&(s===S.charCodeAt(n)?--n==-1&&(i=r):(n=-1,i=o))}return d===i?i=o:i===-1&&(i=y.length),y.slice(d,i)}for(r=y.length-1;r>=d;--r)if(h(y.charCodeAt(r))){if(!c){d=r+1;break}}else i===-1&&(c=!1,i=r+1);return i===-1?"":y.slice(d,i)},extname(y){p(y,"path");let S=0,d=-1,i=0,c=-1,r=!0,n=0;y.length>=2&&y.charCodeAt(1)===P&&v(y.charCodeAt(0))&&(S=i=2);for(let o=y.length-1;o>=S;--o){const s=y.charCodeAt(o);if(h(s)){if(!r){i=o+1;break}continue}c===-1&&(r=!1,c=o+1),s===R?d===-1?d=o:n!==1&&(n=1):d!==-1&&(n=-1)}return d===-1||c===-1||n===0||n===1&&d===c-1&&d===i+1?"":y.slice(d,c)},format:w.bind(null,"\\"),parse(y){p(y,"path");const S={root:"",dir:"",base:"",ext:"",name:""};if(y.length===0)return S;const d=y.length;let i=0,c=y.charCodeAt(0);if(d===1)return h(c)?(S.root=S.dir=y,S):(S.base=S.name=y,S);if(h(c)){if(i=1,h(y.charCodeAt(1))){let g=2,I=g;for(;g<d&&!h(y.charCodeAt(g));)g++;if(g<d&&g!==I){for(I=g;g<d&&h(y.charCodeAt(g));)g++;if(g<d&&g!==I){for(I=g;g<d&&!h(y.charCodeAt(g));)g++;g===d?i=g:g!==I&&(i=g+1)}}}}else if(v(c)&&y.charCodeAt(1)===P){if(d<=2)return S.root=S.dir=y,S;if(i=2,h(y.charCodeAt(2))){if(d===3)return S.root=S.dir=y,S;i=3}}i>0&&(S.root=y.slice(0,i));let r=-1,n=i,o=-1,s=!0,a=y.length-1,l=0;for(;a>=i;--a){if(c=y.charCodeAt(a),h(c)){if(!s){n=a+1;break}continue}o===-1&&(s=!1,o=a+1),c===R?r===-1?r=a:l!==1&&(l=1):r!==-1&&(l=-1)}return o!==-1&&(r===-1||l===0||l===1&&r===o-1&&r===n+1?S.base=S.name=y.slice(n,o):(S.name=y.slice(n,r),S.base=y.slice(n,o),S.ext=y.slice(r,o))),n>0&&n!==i?S.dir=y.slice(0,n-1):S.dir=S.root,S},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...y){let S="",d=!1;for(let i=y.length-1;i>=-1&&!d;i--){const c=i>=0?y[i]:k.cwd();p(c,"path"),c.length!==0&&(S=`${c}/${S}`,d=c.charCodeAt(0)===b)}return S=m(S,!d,"/",u),d?`/${S}`:S.length>0?S:"."},normalize(y){if(p(y,"path"),y.length===0)return".";const S=y.charCodeAt(0)===b,d=y.charCodeAt(y.length-1)===b;return y=m(y,!S,"/",u),y.length===0?S?"/":d?"./":".":(d&&(y+="/"),S?`/${y}`:y)},isAbsolute(y){return p(y,"path"),y.length>0&&y.charCodeAt(0)===b},join(...y){if(y.length===0)return".";let S;for(let d=0;d<y.length;++d){const i=y[d];p(i,"path"),i.length>0&&(S===void 0?S=i:S+=`/${i}`)}return S===void 0?".":e.posix.normalize(S)},relative(y,S){if(p(y,"from"),p(S,"to"),y===S||(y=e.posix.resolve(y),S=e.posix.resolve(S),y===S))return"";const d=1,i=y.length,c=i-d,r=1,n=S.length-r,o=c<n?c:n;let s=-1,a=0;for(;a<o;a++){const g=y.charCodeAt(d+a);if(g!==S.charCodeAt(r+a))break;g===b&&(s=a)}if(a===o)if(n>o){if(S.charCodeAt(r+a)===b)return S.slice(r+a+1);if(a===0)return S.slice(r+a)}else c>o&&(y.charCodeAt(d+a)===b?s=a:a===0&&(s=0));let l="";for(a=d+s+1;a<=i;++a)(a===i||y.charCodeAt(a)===b)&&(l+=l.length===0?"..":"/..");return`${l}${S.slice(r+s)}`},toNamespacedPath(y){return y},dirname(y){if(p(y,"path"),y.length===0)return".";const S=y.charCodeAt(0)===b;let d=-1,i=!0;for(let c=y.length-1;c>=1;--c)if(y.charCodeAt(c)===b){if(!i){d=c;break}}else i=!1;return d===-1?S?"/":".":S&&d===1?"//":y.slice(0,d)},basename(y,S){S!==void 0&&p(S,"ext"),p(y,"path");let d=0,i=-1,c=!0,r;if(S!==void 0&&S.length>0&&S.length<=y.length){if(S===y)return"";let n=S.length-1,o=-1;for(r=y.length-1;r>=0;--r){const s=y.charCodeAt(r);if(s===b){if(!c){d=r+1;break}}else o===-1&&(c=!1,o=r+1),n>=0&&(s===S.charCodeAt(n)?--n==-1&&(i=r):(n=-1,i=o))}return d===i?i=o:i===-1&&(i=y.length),y.slice(d,i)}for(r=y.length-1;r>=0;--r)if(y.charCodeAt(r)===b){if(!c){d=r+1;break}}else i===-1&&(c=!1,i=r+1);return i===-1?"":y.slice(d,i)},extname(y){p(y,"path");let S=-1,d=0,i=-1,c=!0,r=0;for(let n=y.length-1;n>=0;--n){const o=y.charCodeAt(n);if(o===b){if(!c){d=n+1;break}continue}i===-1&&(c=!1,i=n+1),o===R?S===-1?S=n:r!==1&&(r=1):S!==-1&&(r=-1)}return S===-1||i===-1||r===0||r===1&&S===i-1&&S===d+1?"":y.slice(S,i)},format:w.bind(null,"/"),parse(y){p(y,"path");const S={root:"",dir:"",base:"",ext:"",name:""};if(y.length===0)return S;const d=y.charCodeAt(0)===b;let i;d?(S.root="/",i=1):i=0;let c=-1,r=0,n=-1,o=!0,s=y.length-1,a=0;for(;s>=i;--s){const l=y.charCodeAt(s);if(l===b){if(!o){r=s+1;break}continue}n===-1&&(o=!1,n=s+1),l===R?c===-1?c=s:a!==1&&(a=1):c!==-1&&(a=-1)}if(n!==-1){const l=r===0&&d?1:r;c===-1||a===0||a===1&&c===n-1&&c===r+1?S.base=S.name=y.slice(l,n):(S.name=y.slice(l,c),S.base=y.slice(l,n),S.ext=y.slice(c,n))}return r>0?S.dir=y.slice(0,r-1):d&&(S.dir="/"),S},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=k.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=k.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=k.platform==="win32"?e.win32.join:e.posix.join,e.resolve=k.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=k.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=k.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=k.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=k.platform==="win32"?e.win32.extname:e.posix.extname,e.format=k.platform==="win32"?e.win32.format:e.posix.format,e.parse=k.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=k.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=k.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=k.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(te[102],ne([0,1,10]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var t;(function(E){E.text="text/plain",E.binary="application/octet-stream",E.unknown="application/unknown",E.markdown="text/markdown",E.latex="text/latex",E.uriList="text/uri-list"})(t=e.Mimes||(e.Mimes={}));const L={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},T={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(E){const f=(0,k.extname)(E),p=L[f.toLowerCase()];return p!==void 0?p:R(E)}e.getMediaOrTextMime=A;function R(E){const f=(0,k.extname)(E);return T[f.toLowerCase()]}e.getMediaMime=R;function b(E){for(const f in T)if(T[f]===E)return f}e.getExtensionForMimeType=b;const C=/^(.+)\/(.+?)(;.+)?$/;function P(E,f){const p=C.exec(E);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:f?void 0:E}e.normalizeMimeType=P}),define(te[103],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var k;(function(T){T[T.stdout=0]="stdout",T[T.stderr=1]="stderr"})(k=e.Source||(e.Source={}));var t;(function(T){T[T.Success=0]="Success",T[T.Unknown=1]="Unknown",T[T.AccessDenied=2]="AccessDenied",T[T.ProcessNotFound=3]="ProcessNotFound"})(t=e.TerminateResponseCode||(e.TerminateResponseCode={}));function L(T,...A){const R=A.reduce((P,E)=>(P[E]=!0,P),{}),b=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(T).filter(P=>!R[P]).forEach(P=>{for(let E=0;E<b.length;E++)if(P.search(b[E])!==-1){delete T[P];break}})}e.sanitizeProcessEnvironment=L}),function(K,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var k=e();for(var t in k)(typeof exports=="object"?exports:K)[t]=k[t]}}(typeof self!="undefined"?self:this,function(){return function(K){var e={};function k(t){if(e[t])return e[t].exports;var L=e[t]={i:t,l:!1,exports:{}};return K[t].call(L.exports,L,L.exports,k),L.l=!0,L.exports}return k.m=K,k.c=e,k.d=function(t,L,T){k.o(t,L)||Object.defineProperty(t,L,{enumerable:!0,get:T})},k.r=function(t){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},k.t=function(t,L){if(1&L&&(t=k(t)),8&L||4&L&&typeof t=="object"&&t&&t.__esModule)return t;var T=Object.create(null);if(k.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:t}),2&L&&typeof t!="string")for(var A in t)k.d(T,A,function(R){return t[R]}.bind(null,A));return T},k.n=function(t){var L=t&&t.__esModule?function(){return t.default}:function(){return t};return k.d(L,"a",L),L},k.o=function(t,L){return Object.prototype.hasOwnProperty.call(t,L)},k.p="",k(k.s=0)}([function(K,e,k){(function(t){var L;e=K.exports=F,L=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var re=Array.prototype.slice.call(arguments,0);re.unshift("SEMVER"),console.log.apply(console,re)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],b=e.src=[],C=0,P=C++;b[P]="0|[1-9]\\d*";var E=C++;b[E]="[0-9]+";var f=C++;b[f]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=C++;b[p]="("+b[P]+")\\.("+b[P]+")\\.("+b[P]+")";var h=C++;b[h]="("+b[E]+")\\.("+b[E]+")\\.("+b[E]+")";var u=C++;b[u]="(?:"+b[P]+"|"+b[f]+")";var v=C++;b[v]="(?:"+b[E]+"|"+b[f]+")";var m=C++;b[m]="(?:-("+b[u]+"(?:\\."+b[u]+")*))";var w=C++;b[w]="(?:-?("+b[v]+"(?:\\."+b[v]+")*))";var y=C++;b[y]="[0-9A-Za-z-]+";var S=C++;b[S]="(?:\\+("+b[y]+"(?:\\."+b[y]+")*))";var d=C++,i="v?"+b[p]+b[m]+"?"+b[S]+"?";b[d]="^"+i+"$";var c="[v=\\s]*"+b[h]+b[w]+"?"+b[S]+"?",r=C++;b[r]="^"+c+"$";var n=C++;b[n]="((?:<|>)?=?)";var o=C++;b[o]=b[E]+"|x|X|\\*";var s=C++;b[s]=b[P]+"|x|X|\\*";var a=C++;b[a]="[v=\\s]*("+b[s]+")(?:\\.("+b[s]+")(?:\\.("+b[s]+")(?:"+b[m]+")?"+b[S]+"?)?)?";var l=C++;b[l]="[v=\\s]*("+b[o]+")(?:\\.("+b[o]+")(?:\\.("+b[o]+")(?:"+b[w]+")?"+b[S]+"?)?)?";var g=C++;b[g]="^"+b[n]+"\\s*"+b[a]+"$";var I=C++;b[I]="^"+b[n]+"\\s*"+b[l]+"$";var _=C++;b[_]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=C++;b[O]="(?:~>?)";var U=C++;b[U]="(\\s*)"+b[O]+"\\s+",R[U]=new RegExp(b[U],"g");var D=C++;b[D]="^"+b[O]+b[a]+"$";var M=C++;b[M]="^"+b[O]+b[l]+"$";var N=C++;b[N]="(?:\\^)";var x=C++;b[x]="(\\s*)"+b[N]+"\\s+",R[x]=new RegExp(b[x],"g");var Q=C++;b[Q]="^"+b[N]+b[a]+"$";var W=C++;b[W]="^"+b[N]+b[l]+"$";var ie=C++;b[ie]="^"+b[n]+"\\s*("+c+")$|^$";var B=C++;b[B]="^"+b[n]+"\\s*("+i+")$|^$";var j=C++;b[j]="(\\s*)"+b[n]+"\\s*("+c+"|"+b[a]+")",R[j]=new RegExp(b[j],"g");var Y=C++;b[Y]="^\\s*("+b[a]+")\\s+-\\s+("+b[a]+")\\s*$";var V=C++;b[V]="^\\s*("+b[l]+")\\s+-\\s+("+b[l]+")\\s*$";var J=C++;b[J]="(<|>)?=?\\s*\\*";for(var Z=0;Z<35;Z++)L(Z,b[Z]),R[Z]||(R[Z]=new RegExp(b[Z]));function q(re,ce){if(re instanceof F)return re;if(typeof re!="string"||re.length>T||!(ce?R[r]:R[d]).test(re))return null;try{return new F(re,ce)}catch{return null}}function F(re,ce){if(re instanceof F){if(re.loose===ce)return re;re=re.version}else if(typeof re!="string")throw new TypeError("Invalid Version: "+re);if(re.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof F))return new F(re,ce);L("SemVer",re,ce),this.loose=ce;var ue=re.trim().match(ce?R[r]:R[d]);if(!ue)throw new TypeError("Invalid Version: "+re);if(this.raw=re,this.major=+ue[1],this.minor=+ue[2],this.patch=+ue[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ue[4]?this.prerelease=ue[4].split(".").map(function(we){if(/^[0-9]+$/.test(we)){var be=+we;if(be>=0&&be<A)return be}return we}):this.prerelease=[],this.build=ue[5]?ue[5].split("."):[],this.format()}e.parse=q,e.valid=function(re,ce){var ue=q(re,ce);return ue?ue.version:null},e.clean=function(re,ce){var ue=q(re.trim().replace(/^[=v]+/,""),ce);return ue?ue.version:null},e.SemVer=F,F.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},F.prototype.toString=function(){return this.version},F.prototype.compare=function(re){return L("SemVer.compare",this.version,this.loose,re),re instanceof F||(re=new F(re,this.loose)),this.compareMain(re)||this.comparePre(re)},F.prototype.compareMain=function(re){return re instanceof F||(re=new F(re,this.loose)),z(this.major,re.major)||z(this.minor,re.minor)||z(this.patch,re.patch)},F.prototype.comparePre=function(re){if(re instanceof F||(re=new F(re,this.loose)),this.prerelease.length&&!re.prerelease.length)return-1;if(!this.prerelease.length&&re.prerelease.length)return 1;if(!this.prerelease.length&&!re.prerelease.length)return 0;var ce=0;do{var ue=this.prerelease[ce],we=re.prerelease[ce];if(L("prerelease compare",ce,ue,we),ue===void 0&&we===void 0)return 0;if(we===void 0)return 1;if(ue===void 0)return-1;if(ue!==we)return z(ue,we)}while(++ce)},F.prototype.inc=function(re,ce){switch(re){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ce);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ce);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ce),this.inc("pre",ce);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ce),this.inc("pre",ce);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ue=this.prerelease.length;--ue>=0;)typeof this.prerelease[ue]=="number"&&(this.prerelease[ue]++,ue=-2);ue===-1&&this.prerelease.push(0)}ce&&(this.prerelease[0]===ce?isNaN(this.prerelease[1])&&(this.prerelease=[ce,0]):this.prerelease=[ce,0]);break;default:throw new Error("invalid increment argument: "+re)}return this.format(),this.raw=this.version,this},e.inc=function(re,ce,ue,we){typeof ue=="string"&&(we=ue,ue=void 0);try{return new F(re,ue).inc(ce,we).version}catch{return null}},e.diff=function(re,ce){if(ae(re,ce))return null;var ue=q(re),we=q(ce);if(ue.prerelease.length||we.prerelease.length){for(var be in ue)if((be==="major"||be==="minor"||be==="patch")&&ue[be]!==we[be])return"pre"+be;return"prerelease"}for(var be in ue)if((be==="major"||be==="minor"||be==="patch")&&ue[be]!==we[be])return be},e.compareIdentifiers=z;var $=/^[0-9]+$/;function z(re,ce){var ue=$.test(re),we=$.test(ce);return ue&&we&&(re=+re,ce=+ce),ue&&!we?-1:we&&!ue?1:re<ce?-1:re>ce?1:0}function H(re,ce,ue){return new F(re,ue).compare(new F(ce,ue))}function ee(re,ce,ue){return H(re,ce,ue)>0}function se(re,ce,ue){return H(re,ce,ue)<0}function ae(re,ce,ue){return H(re,ce,ue)===0}function de(re,ce,ue){return H(re,ce,ue)!==0}function ge(re,ce,ue){return H(re,ce,ue)>=0}function Ee(re,ce,ue){return H(re,ce,ue)<=0}function Se(re,ce,ue,we){var be;switch(ce){case"===":typeof re=="object"&&(re=re.version),typeof ue=="object"&&(ue=ue.version),be=re===ue;break;case"!==":typeof re=="object"&&(re=re.version),typeof ue=="object"&&(ue=ue.version),be=re!==ue;break;case"":case"=":case"==":be=ae(re,ue,we);break;case"!=":be=de(re,ue,we);break;case">":be=ee(re,ue,we);break;case">=":be=ge(re,ue,we);break;case"<":be=se(re,ue,we);break;case"<=":be=Ee(re,ue,we);break;default:throw new TypeError("Invalid operator: "+ce)}return be}function pe(re,ce){if(re instanceof pe){if(re.loose===ce)return re;re=re.value}if(!(this instanceof pe))return new pe(re,ce);L("comparator",re,ce),this.loose=ce,this.parse(re),this.semver===Ce?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(re,ce){return z(ce,re)},e.major=function(re,ce){return new F(re,ce).major},e.minor=function(re,ce){return new F(re,ce).minor},e.patch=function(re,ce){return new F(re,ce).patch},e.compare=H,e.compareLoose=function(re,ce){return H(re,ce,!0)},e.rcompare=function(re,ce,ue){return H(ce,re,ue)},e.sort=function(re,ce){return re.sort(function(ue,we){return e.compare(ue,we,ce)})},e.rsort=function(re,ce){return re.sort(function(ue,we){return e.rcompare(ue,we,ce)})},e.gt=ee,e.lt=se,e.eq=ae,e.neq=de,e.gte=ge,e.lte=Ee,e.cmp=Se,e.Comparator=pe;var Ce={};function Ie(re,ce){if(re instanceof Ie)return re.loose===ce?re:new Ie(re.raw,ce);if(re instanceof pe)return new Ie(re.value,ce);if(!(this instanceof Ie))return new Ie(re,ce);if(this.loose=ce,this.raw=re,this.set=re.split(/\s*\|\|\s*/).map(function(ue){return this.parseRange(ue.trim())},this).filter(function(ue){return ue.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+re);this.format()}function De(re){return!re||re.toLowerCase()==="x"||re==="*"}function Me(re,ce,ue,we,be,Fe,Te,Oe,_e,X,oe,le,fe){return((ce=De(ue)?"":De(we)?">="+ue+".0.0":De(be)?">="+ue+"."+we+".0":">="+ce)+" "+(Oe=De(_e)?"":De(X)?"<"+(+_e+1)+".0.0":De(oe)?"<"+_e+"."+(+X+1)+".0":le?"<="+_e+"."+X+"."+oe+"-"+le:"<="+Oe)).trim()}function je(re,ce){for(var ue=0;ue<re.length;ue++)if(!re[ue].test(ce))return!1;if(ce.prerelease.length){for(ue=0;ue<re.length;ue++)if(L(re[ue].semver),re[ue].semver!==Ce&&re[ue].semver.prerelease.length>0){var we=re[ue].semver;if(we.major===ce.major&&we.minor===ce.minor&&we.patch===ce.patch)return!0}return!1}return!0}function Ge(re,ce,ue){try{ce=new Ie(ce,ue)}catch{return!1}return ce.test(re)}function Be(re,ce,ue,we){var be,Fe,Te,Oe,_e;switch(re=new F(re,we),ce=new Ie(ce,we),ue){case">":be=ee,Fe=Ee,Te=se,Oe=">",_e=">=";break;case"<":be=se,Fe=ge,Te=ee,Oe="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ge(re,ce,we))return!1;for(var X=0;X<ce.set.length;++X){var oe=ce.set[X],le=null,fe=null;if(oe.forEach(function(me){me.semver===Ce&&(me=new pe(">=0.0.0")),le=le||me,fe=fe||me,be(me.semver,le.semver,we)?le=me:Te(me.semver,fe.semver,we)&&(fe=me)}),le.operator===Oe||le.operator===_e||(!fe.operator||fe.operator===Oe)&&Fe(re,fe.semver)||fe.operator===_e&&Te(re,fe.semver))return!1}return!0}pe.prototype.parse=function(re){var ce=this.loose?R[ie]:R[B],ue=re.match(ce);if(!ue)throw new TypeError("Invalid comparator: "+re);this.operator=ue[1],this.operator==="="&&(this.operator=""),ue[2]?this.semver=new F(ue[2],this.loose):this.semver=Ce},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(re){return L("Comparator.test",re,this.loose),this.semver===Ce||(typeof re=="string"&&(re=new F(re,this.loose)),Se(re,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(re,ce){if(!(re instanceof pe))throw new TypeError("a Comparator is required");var ue;if(this.operator==="")return ue=new Ie(re.value,ce),Ge(this.value,ue,ce);if(re.operator==="")return ue=new Ie(this.value,ce),Ge(re.semver,ue,ce);var we=!(this.operator!==">="&&this.operator!==">"||re.operator!==">="&&re.operator!==">"),be=!(this.operator!=="<="&&this.operator!=="<"||re.operator!=="<="&&re.operator!=="<"),Fe=this.semver.version===re.semver.version,Te=!(this.operator!==">="&&this.operator!=="<="||re.operator!==">="&&re.operator!=="<="),Oe=Se(this.semver,"<",re.semver,ce)&&(this.operator===">="||this.operator===">")&&(re.operator==="<="||re.operator==="<"),_e=Se(this.semver,">",re.semver,ce)&&(this.operator==="<="||this.operator==="<")&&(re.operator===">="||re.operator===">");return we||be||Fe&&Te||Oe||_e},e.Range=Ie,Ie.prototype.format=function(){return this.range=this.set.map(function(re){return re.join(" ").trim()}).join("||").trim(),this.range},Ie.prototype.toString=function(){return this.range},Ie.prototype.parseRange=function(re){var ce=this.loose;re=re.trim(),L("range",re,ce);var ue=ce?R[V]:R[Y];re=re.replace(ue,Me),L("hyphen replace",re),re=re.replace(R[j],"$1$2$3"),L("comparator trim",re,R[j]),re=(re=(re=re.replace(R[U],"$1~")).replace(R[x],"$1^")).split(/\s+/).join(" ");var we=ce?R[ie]:R[B],be=re.split(" ").map(function(Fe){return function(Te,Oe){return L("comp",Te),Te=function(_e,X){return _e.trim().split(/\s+/).map(function(oe){return function(le,fe){L("caret",le,fe);var me=fe?R[W]:R[Q];return le.replace(me,function(Le,ye,Re,ke,Pe){var Ae;return L("caret",le,Le,ye,Re,ke,Pe),De(ye)?Ae="":De(Re)?Ae=">="+ye+".0.0 <"+(+ye+1)+".0.0":De(ke)?Ae=ye==="0"?">="+ye+"."+Re+".0 <"+ye+"."+(+Re+1)+".0":">="+ye+"."+Re+".0 <"+(+ye+1)+".0.0":Pe?(L("replaceCaret pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Ae=ye==="0"?Re==="0"?">="+ye+"."+Re+"."+ke+Pe+" <"+ye+"."+Re+"."+(+ke+1):">="+ye+"."+Re+"."+ke+Pe+" <"+ye+"."+(+Re+1)+".0":">="+ye+"."+Re+"."+ke+Pe+" <"+(+ye+1)+".0.0"):(L("no pr"),Ae=ye==="0"?Re==="0"?">="+ye+"."+Re+"."+ke+" <"+ye+"."+Re+"."+(+ke+1):">="+ye+"."+Re+"."+ke+" <"+ye+"."+(+Re+1)+".0":">="+ye+"."+Re+"."+ke+" <"+(+ye+1)+".0.0"),L("caret return",Ae),Ae})}(oe,X)}).join(" ")}(Te,Oe),L("caret",Te),Te=function(_e,X){return _e.trim().split(/\s+/).map(function(oe){return function(le,fe){var me=fe?R[M]:R[D];return le.replace(me,function(Le,ye,Re,ke,Pe){var Ae;return L("tilde",le,Le,ye,Re,ke,Pe),De(ye)?Ae="":De(Re)?Ae=">="+ye+".0.0 <"+(+ye+1)+".0.0":De(ke)?Ae=">="+ye+"."+Re+".0 <"+ye+"."+(+Re+1)+".0":Pe?(L("replaceTilde pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Ae=">="+ye+"."+Re+"."+ke+Pe+" <"+ye+"."+(+Re+1)+".0"):Ae=">="+ye+"."+Re+"."+ke+" <"+ye+"."+(+Re+1)+".0",L("tilde return",Ae),Ae})}(oe,X)}).join(" ")}(Te,Oe),L("tildes",Te),Te=function(_e,X){return L("replaceXRanges",_e,X),_e.split(/\s+/).map(function(oe){return function(le,fe){le=le.trim();var me=fe?R[I]:R[g];return le.replace(me,function(Le,ye,Re,ke,Pe,Ae){L("xRange",le,Le,ye,Re,ke,Pe,Ae);var Ne=De(Re),We=Ne||De(ke),qe=We||De(Pe);return ye==="="&&qe&&(ye=""),Ne?Le=ye===">"||ye==="<"?"<0.0.0":"*":ye&&qe?(We&&(ke=0),qe&&(Pe=0),ye===">"?(ye=">=",We?(Re=+Re+1,ke=0,Pe=0):qe&&(ke=+ke+1,Pe=0)):ye==="<="&&(ye="<",We?Re=+Re+1:ke=+ke+1),Le=ye+Re+"."+ke+"."+Pe):We?Le=">="+Re+".0.0 <"+(+Re+1)+".0.0":qe&&(Le=">="+Re+"."+ke+".0 <"+Re+"."+(+ke+1)+".0"),L("xRange return",Le),Le})}(oe,X)}).join(" ")}(Te,Oe),L("xrange",Te),Te=function(_e,X){return L("replaceStars",_e,X),_e.trim().replace(R[J],"")}(Te,Oe),L("stars",Te),Te}(Fe,ce)}).join(" ").split(/\s+/);return this.loose&&(be=be.filter(function(Fe){return!!Fe.match(we)})),be=be.map(function(Fe){return new pe(Fe,ce)})},Ie.prototype.intersects=function(re,ce){if(!(re instanceof Ie))throw new TypeError("a Range is required");return this.set.some(function(ue){return ue.every(function(we){return re.set.some(function(be){return be.every(function(Fe){return we.intersects(Fe,ce)})})})})},e.toComparators=function(re,ce){return new Ie(re,ce).set.map(function(ue){return ue.map(function(we){return we.value}).join(" ").trim().split(" ")})},Ie.prototype.test=function(re){if(!re)return!1;typeof re=="string"&&(re=new F(re,this.loose));for(var ce=0;ce<this.set.length;ce++)if(je(this.set[ce],re))return!0;return!1},e.satisfies=Ge,e.maxSatisfying=function(re,ce,ue){var we=null,be=null;try{var Fe=new Ie(ce,ue)}catch{return null}return re.forEach(function(Te){Fe.test(Te)&&(we&&be.compare(Te)!==-1||(be=new F(we=Te,ue)))}),we},e.minSatisfying=function(re,ce,ue){var we=null,be=null;try{var Fe=new Ie(ce,ue)}catch{return null}return re.forEach(function(Te){Fe.test(Te)&&(we&&be.compare(Te)!==1||(be=new F(we=Te,ue)))}),we},e.validRange=function(re,ce){try{return new Ie(re,ce).range||"*"}catch{return null}},e.ltr=function(re,ce,ue){return Be(re,ce,"<",ue)},e.gtr=function(re,ce,ue){return Be(re,ce,">",ue)},e.outside=Be,e.prerelease=function(re,ce){var ue=q(re,ce);return ue&&ue.prerelease.length?ue.prerelease:null},e.intersects=function(re,ce,ue){return re=new Ie(re,ue),ce=new Ie(ce,ue),re.intersects(ce)},e.coerce=function(re){if(re instanceof F)return re;if(typeof re!="string")return null;var ce=re.match(R[_]);return ce==null?null:q((ce[1]||"0")+"."+(ce[2]||"0")+"."+(ce[3]||"0"))}}).call(this,k(1))},function(K,e){var k,t,L=K.exports={};function T(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function R(v){if(k===setTimeout)return setTimeout(v,0);if((k===T||!k)&&setTimeout)return k=setTimeout,setTimeout(v,0);try{return k(v,0)}catch{try{return k.call(null,v,0)}catch{return k.call(this,v,0)}}}(function(){try{k=typeof setTimeout=="function"?setTimeout:T}catch{k=T}try{t=typeof clearTimeout=="function"?clearTimeout:A}catch{t=A}})();var b,C=[],P=!1,E=-1;function f(){P&&b&&(P=!1,b.length?C=b.concat(C):E=-1,C.length&&p())}function p(){if(!P){var v=R(f);P=!0;for(var m=C.length;m;){for(b=C,C=[];++E<m;)b&&b[E].run();E=-1,m=C.length}b=null,P=!1,function(w){if(t===clearTimeout)return clearTimeout(w);if((t===A||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(w);try{t(w)}catch{try{return t.call(null,w)}catch{return t.call(this,w)}}}(v)}}function h(v,m){this.fun=v,this.array=m}function u(){}L.nextTick=function(v){var m=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)m[w-1]=arguments[w];C.push(new h(v,m)),C.length!==1||P||R(p)},h.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=u,L.addListener=u,L.once=u,L.off=u,L.removeListener=u,L.removeAllListeners=u,L.emit=u,L.prependListener=u,L.prependOnceListener=u,L.listeners=function(v){return[]},L.binding=function(v){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(v){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(te[104],ne([0,1]),function(K,e){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(R,b,C){this.level=R,this.key=b,this.value=C,this.forward=[]}}const L=void 0;class T{constructor(R,b=2**16){this.comparator=R,this[k]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(b)|0),this._header=new t(this._maxLevel,L,L)}get size(){return this._size}clear(){this._header=new t(this._maxLevel,L,L)}has(R){return Boolean(T._search(this,R,this.comparator))}get(R){return T._search(this,R,this.comparator)?.value}set(R,b){return T._insert(this,R,b,this.comparator)&&(this._size+=1),this}delete(R){const b=T._delete(this,R,this.comparator);return b&&(this._size-=1),b}forEach(R,b){let C=this._header.forward[0];for(;C;)R.call(b,C.value,C.key,this),C=C.forward[0]}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this._header.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this._header.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this._header.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",b=this._header.forward[0];for(;b;)R+=`node(${b.key}, ${b.value}, lvl:${b.level})`,b=b.forward[0];return R}static _search(R,b,C){let P=R._header;for(let E=R._level-1;E>=0;E--)for(;P.forward[E]&&C(P.forward[E].key,b)<0;)P=P.forward[E];if(P=P.forward[0],P&&C(P.key,b)===0)return P}static _insert(R,b,C,P){let E=[],f=R._header;for(let p=R._level-1;p>=0;p--){for(;f.forward[p]&&P(f.forward[p].key,b)<0;)f=f.forward[p];E[p]=f}if(f=f.forward[0],f&&P(f.key,b)===0)return f.value=C,!1;{let p=T._randomLevel(R);if(p>R._level){for(let h=R._level;h<p;h++)E[h]=R._header;R._level=p}f=new t(p,b,C);for(let h=0;h<p;h++)f.forward[h]=E[h].forward[h],E[h].forward[h]=f;return!0}}static _randomLevel(R,b=.5){let C=1;for(;Math.random()<b&&C<R._maxLevel;)C+=1;return C}static _delete(R,b,C){let P=[],E=R._header;for(let f=R._level-1;f>=0;f--){for(;E.forward[f]&&C(E.forward[f].key,b)<0;)E=E.forward[f];P[f]=E}if(E=E.forward[0],!E||C(E.key,b)!==0)return!1;for(let f=0;f<R._level&&P[f].forward[f]===E;f++)P[f].forward[f]=E.forward[f];for(;R._level>0&&R._header.forward[R._level-1]===L;)R._level-=1;return!0}}e.SkipList=T}),define(te[105],ne([0,1,4]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=k.globals.performance&&typeof k.globals.performance.now=="function";class L{constructor(A){this._highResolution=t&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new L(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?k.globals.performance.now():Date.now()}}e.StopWatch=L}),define(te[3],ne([0,1,9,69,2,101,105]),function(K,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;let R=!1,b=!1;var C;(function(r){r.None=()=>L.Disposable.None;function n(V){if(b){const{onListenerDidAdd:J}=V,Z=h.create();let q=0;V.onListenerDidAdd=()=>{++q==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Z.print()),J?.()}}}function o(V){return(J,Z=null,q)=>{let F=!1,$;return $=V(z=>{if(!F)return $?$.dispose():F=!0,J.call(Z,z)},null,q),F&&$.dispose(),$}}r.once=o;function s(V,J,Z){return O((q,F=null,$)=>V(z=>q.call(F,J(z)),null,$),Z)}r.map=s;function a(V,J,Z){return O((q,F=null,$)=>V(z=>{J(z),q.call(F,z)},null,$),Z)}r.forEach=a;function l(V,J,Z){return O((q,F=null,$)=>V(z=>J(z)&&q.call(F,z),null,$),Z)}r.filter=l;function g(V){return V}r.signal=g;function I(...V){return(J,Z=null,q)=>(0,L.combinedDisposable)(...V.map(F=>F($=>J.call(Z,$),null,q)))}r.any=I;function _(V,J,Z,q){let F=Z;return s(V,$=>(F=J(F,$),F),q)}r.reduce=_;function O(V,J){let Z;const q={onFirstListenerAdd(){Z=V(F.fire,F)},onLastListenerRemove(){Z.dispose()}};J||n(q);const F=new v(q);return J&&J.add(F),F.event}function U(V,J,Z=100,q=!1,F,$){let z,H,ee,se=0;const ae={leakWarningThreshold:F,onFirstListenerAdd(){z=V(ge=>{se++,H=J(H,ge),q&&!ee&&(de.fire(H),H=void 0),clearTimeout(ee),ee=setTimeout(()=>{const Ee=H;H=void 0,ee=void 0,(!q||se>1)&&de.fire(Ee),se=0},Z)})},onLastListenerRemove(){z.dispose()}};$||n(ae);const de=new v(ae);return $&&$.add(de),de.event}r.debounce=U;function D(V,J=(q,F)=>q===F,Z){let q=!0,F;return l(V,$=>{const z=q||!J($,F);return q=!1,F=$,z},Z)}r.latch=D;function M(V,J,Z){return[r.filter(V,J,Z),r.filter(V,q=>!J(q),Z)]}r.split=M;function N(V,J=!1,Z=[]){let q=Z.slice(),F=V(H=>{q?q.push(H):z.fire(H)});const $=()=>{q&&q.forEach(H=>z.fire(H)),q=null},z=new v({onFirstListenerAdd(){F||(F=V(H=>z.fire(H)))},onFirstListenerDidAdd(){q&&(J?setTimeout($):$())},onLastListenerRemove(){F&&F.dispose(),F=null}});return z.event}r.buffer=N;class x{constructor(J){this.event=J}map(J){return new x(s(this.event,J))}forEach(J){return new x(a(this.event,J))}filter(J){return new x(l(this.event,J))}reduce(J,Z){return new x(_(this.event,J,Z))}latch(){return new x(D(this.event))}debounce(J,Z=100,q=!1,F){return new x(U(this.event,J,Z,q,F))}on(J,Z,q){return this.event(J,Z,q)}once(J,Z,q){return o(this.event)(J,Z,q)}}function Q(V){return new x(V)}r.chain=Q;function W(V,J,Z=q=>q){const q=(...H)=>z.fire(Z(...H)),F=()=>V.on(J,q),$=()=>V.removeListener(J,q),z=new v({onFirstListenerAdd:F,onLastListenerRemove:$});return z.event}r.fromNodeEventEmitter=W;function ie(V,J,Z=q=>q){const q=(...H)=>z.fire(Z(...H)),F=()=>V.addEventListener(J,q),$=()=>V.removeEventListener(J,q),z=new v({onFirstListenerAdd:F,onLastListenerRemove:$});return z.event}r.fromDOMEventEmitter=ie;function B(V){return new Promise(J=>o(V)(J))}r.toPromise=B;function j(V,J){return J(void 0),V(Z=>J(Z))}r.runAndSubscribe=j;function Y(V,J){let Z=null;function q($){Z?.dispose(),Z=new L.DisposableStore,J($,Z)}q(void 0);const F=V($=>q($));return(0,L.toDisposable)(()=>{F.dispose(),Z?.dispose()})}r.runAndSubscribeWithStore=Y})(C=e.Event||(e.Event={}));class P{constructor(n){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${n}_${P._idPool++}`}start(n){this._stopWatch=new A.StopWatch(!0),this._listenerCount=n}stop(){if(this._stopWatch){const n=this._stopWatch.elapsed();this._elapsedOverall+=n,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${n.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}P._idPool=0;let E=-1;function f(r){const n=E;return E=r,{dispose(){E=n}}}e.setGlobalLeakWarningThreshold=f;class p{constructor(n,o=Math.random().toString(18).slice(2,5)){this.customThreshold=n,this.name=o,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(n,o){let s=E;if(typeof this.customThreshold=="number"&&(s=this.customThreshold),s<=0||o<s)return;this._stacks||(this._stacks=new Map);const a=this._stacks.get(n.value)||0;if(this._stacks.set(n.value,a+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=s*.5;let l,g=0;for(const[I,_]of this._stacks)(!l||g<_)&&(l=I,g=_);console.warn(`[${this.name}] potential listener LEAK detected, having ${o} listeners already. MOST frequent listener (${g}):`),console.warn(l)}return()=>{const l=this._stacks.get(n.value)||0;this._stacks.set(n.value,l-1)}}}class h{constructor(n){this.value=n}static create(){return new h(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class u{constructor(n,o,s){this.callback=n,this.callbackThis=o,this.stack=s,this.subscription=new L.SafeDisposable}invoke(n){this.callback.call(this.callbackThis,n)}}class v{constructor(n){this._disposed=!1,this._options=n,this._leakageMon=E>0?new p(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new P(this._options._profName):void 0}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(R){const n=Array.from(this._listeners);queueMicrotask(()=>{for(const o of n)o.subscription.isset()&&(o.subscription.unset(),o.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(n,o,s)=>{this._listeners||(this._listeners=new T.LinkedList);const a=this._listeners.isEmpty();a&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let l,g;this._leakageMon&&this._listeners.size>=30&&(g=h.create(),l=this._leakageMon.check(g,this._listeners.size+1)),R&&(g=g??h.create());const I=new u(n,o,g),_=this._listeners.push(I);a&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,n,o);const O=I.subscription.set(()=>{l&&l(),this._disposed||(_(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return s instanceof L.DisposableStore?s.add(O):Array.isArray(s)&&s.push(O),O}),this._event}fire(n){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new T.LinkedList);for(let o of this._listeners)this._deliveryQueue.push([o,n]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[o,s]=this._deliveryQueue.shift();try{o.invoke(s)}catch(a){(0,k.onUnexpectedError)(a)}}this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=v;class m extends v{async fireAsync(n,o,s){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new T.LinkedList);for(const a of this._listeners)this._asyncDeliveryQueue.push([a,n]);for(;this._asyncDeliveryQueue.size>0&&!o.isCancellationRequested;){const[a,l]=this._asyncDeliveryQueue.shift(),g=[],I={...l,token:o,waitUntil:_=>{if(Object.isFrozen(g))throw new Error("waitUntil can NOT be called asynchronous");s&&(_=s(_,a.callback)),g.push(_)}};try{a.invoke(I)}catch(_){(0,k.onUnexpectedError)(_);continue}Object.freeze(g),await Promise.allSettled(g).then(_=>{for(const O of _)O.status==="rejected"&&(0,k.onUnexpectedError)(O.reason)})}}}}e.AsyncEmitter=m;class w extends v{constructor(n){super(n);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=n?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const n=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(n))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(n){this._listeners&&(this._isPaused!==0?this._eventQueue.push(n):super.fire(n))}}e.PauseableEmitter=w;class y extends w{constructor(n){super(n);this._delay=n.delay??100}fire(n){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(n)}}e.DebounceEmitter=y;class S extends v{constructor(n){super(n);this._queuedEvents=[],this._mergeFn=n?.merge}fire(n){this._queuedEvents.push(n),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(o=>super.fire(o)),this._queuedEvents=[]})}}e.MicrotaskEmitter=S;class d{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new v({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(n){const o={event:n,listener:null};this.events.push(o),this.hasListeners&&this.hook(o);const s=()=>{this.hasListeners&&this.unhook(o);const a=this.events.indexOf(o);this.events.splice(a,1)};return(0,L.toDisposable)((0,t.once)(s))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(n=>this.hook(n))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(n=>this.unhook(n))}hook(n){n.listener=n.event(o=>this.emitter.fire(o))}unhook(n){n.listener&&n.listener.dispose(),n.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=d;class i{constructor(){this.buffers=[]}wrapEvent(n){return(o,s,a)=>n(l=>{const g=this.buffers[this.buffers.length-1];g?g.push(()=>o.call(s,l)):o.call(s,l)},void 0,a)}bufferEvents(n){const o=[];this.buffers.push(o);const s=n();return this.buffers.pop(),o.forEach(a=>a()),s}}e.EventBufferer=i;class c{constructor(){this.listening=!1,this.inputEvent=C.None,this.inputEventListener=L.Disposable.None,this.emitter=new v({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(n){this.inputEvent=n,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=n(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=c}),define(te[25],ne([0,1,3]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(R,b){const C=setTimeout(R.bind(b),0);return{dispose(){clearTimeout(C)}}});var L;(function(R){function b(C){return C===R.None||C===R.Cancelled||C instanceof T?!0:!C||typeof C!="object"?!1:typeof C.isCancellationRequested=="boolean"&&typeof C.onCancellationRequested=="function"}R.isCancellationToken=b,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:k.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(L=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new k.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(b){this._token=void 0,this._parentListener=void 0,this._parentListener=b&&b.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=L.Cancelled}dispose(b=!1){b&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=L.None}}e.CancellationTokenSource=A}),define(te[106],ne([0,1,25]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class t{constructor(A){this.task=A,this.result=null}get(){if(this.result)return this.result;const A=new k.CancellationTokenSource,R=this.task(A.token);return this.result={promise:R,dispose:()=>{this.result=null,A.cancel(),A.dispose()}},this.result}}e.Cache=t;class L{constructor(A){this.computeFn=A,this.lastCache=void 0,this.lastArgKey=void 0}get(A){const R=JSON.stringify(A);return this.lastArgKey!==R&&(this.lastArgKey=R,this.lastCache=this.computeFn(A)),this.lastCache}}e.LRUCachedComputed=L}),define(te[40],ne([0,1,9,2]),function(K,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function L(y){const S=y;return S?[S.on,S.pause,S.resume,S.destroy].every(d=>typeof d=="function"):!1}e.isReadableStream=L;function T(y){const S=y;return S?L(S.stream)&&Array.isArray(S.buffer)&&typeof S.ended=="boolean":!1}e.isReadableBufferedStream=T;function A(y,S){return new R(y,S)}e.newWriteableStream=A;class R{constructor(S,d){this.reducer=S,this.options=d,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(S){if(!this.state.destroyed){if(this.state.flowing)this.emitData(S);else if(this.buffer.data.push(S),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(d=>this.pendingWritePromises.push(d))}}error(S){this.state.destroyed||(this.state.flowing?this.emitError(S):this.buffer.error.push(S))}end(S){this.state.destroyed||(typeof S!="undefined"&&this.write(S),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(S){this.listeners.data.slice(0).forEach(d=>d(S))}emitError(S){this.listeners.error.length===0?(0,k.onUnexpectedError)(S):this.listeners.error.slice(0).forEach(d=>d(S))}emitEnd(){this.listeners.end.slice(0).forEach(S=>S())}on(S,d){if(!this.state.destroyed)switch(S){case"data":this.listeners.data.push(d),this.resume();break;case"end":this.listeners.end.push(d),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(d),this.state.flowing&&this.flowErrors();break}}removeListener(S,d){if(this.state.destroyed)return;let i;switch(S){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error;break}if(i){const c=i.indexOf(d);c>=0&&i.splice(c,1)}}flowData(){if(this.buffer.data.length>0){const S=this.reducer(this.buffer.data);this.emitData(S),this.buffer.data.length=0;const d=[...this.pendingWritePromises];this.pendingWritePromises.length=0,d.forEach(i=>i())}}flowErrors(){if(this.listeners.error.length>0){for(const S of this.buffer.error)this.emitError(S);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function b(y,S){const d=[];let i;for(;(i=y.read())!==null;)d.push(i);return S(d)}e.consumeReadable=b;function C(y,S,d){const i=[];let c;for(;(c=y.read())!==null&&i.length<d;)i.push(c);return c===null&&i.length>0?S(i):{read:()=>{if(i.length>0)return i.shift();if(typeof c!="undefined"){const r=c;return c=void 0,r}return y.read()}}}e.peekReadable=C;function P(y,S){return new Promise((d,i)=>{const c=[];E(y,{onData:r=>{S&&c.push(r)},onError:r=>{S?i(r):d(void 0)},onEnd:()=>{d(S?S(c):void 0)}})})}e.consumeStream=P;function E(y,S){let d=!1;return y.on("error",i=>{d||S.onError(i)}),y.on("end",()=>{d||S.onEnd()}),y.on("data",i=>{d||S.onData(i)}),(0,t.toDisposable)(()=>d=!0)}e.listenStream=E;function f(y,S){return new Promise((d,i)=>{const c=new t.DisposableStore,r=[],n=a=>{if(r.push(a),r.length>S)return c.dispose(),y.pause(),d({stream:y,buffer:r,ended:!1})},o=a=>i(a),s=()=>d({stream:y,buffer:r,ended:!0});c.add((0,t.toDisposable)(()=>y.removeListener("error",o))),y.on("error",o),c.add((0,t.toDisposable)(()=>y.removeListener("end",s))),y.on("end",s),c.add((0,t.toDisposable)(()=>y.removeListener("data",n))),y.on("data",n)})}e.peekStream=f;function p(y,S){const d=A(S);return d.end(y),d}e.toStream=p;function h(){const y=A(()=>{throw new Error("not supported")});return y.end(),y}e.emptyStream=h;function u(y){let S=!1;return{read:()=>S?null:(S=!0,y)}}e.toReadable=u;function v(y,S,d){const i=A(d);return E(y,{onData:c=>i.write(S.data(c)),onError:c=>i.error(S.error?S.error(c):c),onEnd:()=>i.end()}),i}e.transform=v;function m(y,S,d){let i=!1;return{read:()=>{const c=S.read();return i?c:(i=!0,c!==null?d([y,c]):y)}}}e.prefixedReadable=m;function w(y,S,d){let i=!1;const c=A(d);return E(S,{onData:r=>i?c.write(r):(i=!0,c.write(d([y,r]))),onError:r=>c.error(r),onEnd:()=>{i||(i=!0,c.write(y)),c.end()}}),c}e.prefixedStream=w}),define(te[17],ne([0,1,40]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let L,T;class A{constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}static alloc(l){return t?new A(Buffer.allocUnsafe(l)):new A(new Uint8Array(l))}static wrap(l){return t&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new A(l)}static fromString(l,g){return!(g?.dontUseNodeBuffer||!1)&&t?new A(Buffer.from(l)):(L||(L=new TextEncoder),new A(L.encode(l)))}static fromByteArray(l){const g=A.alloc(l.length);for(let I=0,_=l.length;I<_;I++)g.buffer[I]=l[I];return g}static concat(l,g){if(typeof g=="undefined"){g=0;for(let O=0,U=l.length;O<U;O++)g+=l[O].byteLength}const I=A.alloc(g);let _=0;for(let O=0,U=l.length;O<U;O++){const D=l[O];I.set(D,_),_+=D.byteLength}return I}clone(){const l=A.alloc(this.byteLength);return l.set(this),l}toString(){return t?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(l,g){return new A(this.buffer.subarray(l,g))}set(l,g){if(l instanceof A)this.buffer.set(l.buffer,g);else if(l instanceof Uint8Array)this.buffer.set(l,g);else if(l instanceof ArrayBuffer)this.buffer.set(new Uint8Array(l),g);else if(ArrayBuffer.isView(l))this.buffer.set(new Uint8Array(l.buffer,l.byteOffset,l.byteLength),g);else throw new Error("Unknown argument 'array'")}readUInt32BE(l){return C(this.buffer,l)}writeUInt32BE(l,g){P(this.buffer,l,g)}readUInt32LE(l){return E(this.buffer,l)}writeUInt32LE(l,g){f(this.buffer,l,g)}readUInt8(l){return p(this.buffer,l)}writeUInt8(l,g){h(this.buffer,l,g)}}e.VSBuffer=A;function R(a,l){return a[l+0]<<0>>>0|a[l+1]<<8>>>0}e.readUInt16LE=R;function b(a,l,g){a[g+0]=l&255,l=l>>>8,a[g+1]=l&255}e.writeUInt16LE=b;function C(a,l){return a[l]*2**24+a[l+1]*2**16+a[l+2]*2**8+a[l+3]}e.readUInt32BE=C;function P(a,l,g){a[g+3]=l,l=l>>>8,a[g+2]=l,l=l>>>8,a[g+1]=l,l=l>>>8,a[g]=l}e.writeUInt32BE=P;function E(a,l){return a[l+0]<<0>>>0|a[l+1]<<8>>>0|a[l+2]<<16>>>0|a[l+3]<<24>>>0}e.readUInt32LE=E;function f(a,l,g){a[g+0]=l&255,l=l>>>8,a[g+1]=l&255,l=l>>>8,a[g+2]=l&255,l=l>>>8,a[g+3]=l&255}e.writeUInt32LE=f;function p(a,l){return a[l]}e.readUInt8=p;function h(a,l,g){a[g]=l}e.writeUInt8=h;function u(a){return k.consumeReadable(a,l=>A.concat(l))}e.readableToBuffer=u;function v(a){return k.toReadable(a)}e.bufferToReadable=v;function m(a){return k.consumeStream(a,l=>A.concat(l))}e.streamToBuffer=m;async function w(a){return a.ended?A.concat(a.buffer):A.concat([...a.buffer,await m(a.stream)])}e.bufferedStreamToBuffer=w;function y(a){return k.toStream(a,l=>A.concat(l))}e.bufferToStream=y;function S(a){return k.transform(a,{data:l=>typeof l=="string"?A.fromString(l):A.wrap(l)},l=>A.concat(l))}e.streamToBufferReadableStream=S;function d(a){return k.newWriteableStream(l=>A.concat(l),a)}e.newWriteableBufferStream=d;function i(a,l){return k.prefixedReadable(a,l,g=>A.concat(g))}e.prefixedBufferReadable=i;function c(a,l){return k.prefixedStream(a,l,g=>A.concat(g))}e.prefixedBufferStream=c;function r(a){let l=0,g=0,I=0;const _=new Uint8Array(Math.floor(a.length/4*3)),O=D=>{switch(g){case 3:_[I++]=l|D,g=0;break;case 2:_[I++]=l|D>>>2,l=D<<6,g=3;break;case 1:_[I++]=l|D>>>4,l=D<<4,g=2;break;default:l=D<<2,g=1}};for(let D=0;D<a.length;D++){const M=a.charCodeAt(D);if(M>=65&&M<=90)O(M-65);else if(M>=97&&M<=122)O(M-97+26);else if(M>=48&&M<=57)O(M-48+52);else if(M===43||M===45)O(62);else if(M===47||M===95)O(63);else{if(M===61)break;throw new SyntaxError(`Unexpected base64 character ${a[D]}`)}}const U=I;for(;g>0;)O(0);return A.wrap(_).slice(0,U)}e.decodeBase64=r;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function s({buffer:a},l=!0,g=!1){const I=g?o:n;let _="";const O=a.byteLength%3;let U=0;for(;U<a.byteLength-O;U+=3){const D=a[U+0],M=a[U+1],N=a[U+2];_+=I[D>>>2],_+=I[(D<<4|M>>>4)&63],_+=I[(M<<2|N>>>6)&63],_+=I[N&63]}if(O===1){const D=a[U+0];_+=I[D>>>2],_+=I[D<<4&63],l&&(_+="==")}else if(O===2){const D=a[U+0],M=a[U+1];_+=I[D>>>2],_+=I[(D<<4|M>>>4)&63],_+=I[M<<2&63],l&&(_+="=")}return _}e.encodeBase64=s}),define(te[26],ne([0,1,106,100]),function(K,e,k,t){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function T(X){return!X||typeof X!="string"?!0:X.trim().length===0}e.isFalsyOrWhitespace=T;const A=/{(\d+)}/g;function R(X,...oe){return oe.length===0?X:X.replace(A,function(le,fe){const me=parseInt(fe,10);return isNaN(me)||me<0||me>=oe.length?le:oe[me]})}e.format=R;const b=/{([^}]+)}/g;function C(X,oe){return X.replace(b,(le,fe)=>oe[fe]??le)}e.format2=C;function P(X){return X.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}e.escape=P;function E(X){return X.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=E;function f(X,oe){let le=0;const fe=oe.charCodeAt(0);for(let me=X.length-1;me>=0;me--)X.charCodeAt(me)===fe&&le++;return le}e.count=f;function p(X,oe,le="\u2026"){return X.length<=oe?X:`${X.substr(0,oe)}${le}`}e.truncate=p;function h(X,oe=" "){const le=u(X,oe);return v(le,oe)}e.trim=h;function u(X,oe){if(!X||!oe)return X;const le=oe.length;if(le===0||X.length===0)return X;let fe=0;for(;X.indexOf(oe,fe)===fe;)fe=fe+le;return X.substring(fe)}e.ltrim=u;function v(X,oe){if(!X||!oe)return X;const le=oe.length,fe=X.length;if(le===0||fe===0)return X;let me=fe,Le=-1;for(;Le=X.lastIndexOf(oe,me-1),!(Le===-1||Le+le!==me);){if(Le===0)return"";me=Le}return X.substring(0,me)}e.rtrim=v;function m(X){return X.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=m;function w(X){return X.replace(/\*/g,"")}e.stripWildcards=w;function y(X,oe,le={}){if(!X)throw new Error("Cannot create regex from empty string");oe||(X=E(X)),le.wholeWord&&(/\B/.test(X.charAt(0))||(X="\\b"+X),/\B/.test(X.charAt(X.length-1))||(X=X+"\\b"));let fe="";return le.global&&(fe+="g"),le.matchCase||(fe+="i"),le.multiline&&(fe+="m"),le.unicode&&(fe+="u"),new RegExp(X,fe)}e.createRegExp=y;function S(X){return X.source==="^"||X.source==="^$"||X.source==="$"||X.source==="^\\s*$"?!1:!!(X.exec("")&&X.lastIndex===0)}e.regExpLeadsToEndlessLoop=S;function d(X){return!!X.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=d;function i(X){return(X.global?"g":"")+(X.ignoreCase?"i":"")+(X.multiline?"m":"")+(X.unicode?"u":"")}e.regExpFlags=i;function c(X){return X.split(/\r\n|\r|\n/)}e.splitLines=c;function r(X){for(let oe=0,le=X.length;oe<le;oe++){const fe=X.charCodeAt(oe);if(fe!==32&&fe!==9)return oe}return-1}e.firstNonWhitespaceIndex=r;function n(X,oe=0,le=X.length){for(let fe=oe;fe<le;fe++){const me=X.charCodeAt(fe);if(me!==32&&me!==9)return X.substring(oe,fe)}return X.substring(oe,le)}e.getLeadingWhitespace=n;function o(X,oe=X.length-1){for(let le=oe;le>=0;le--){const fe=X.charCodeAt(le);if(fe!==32&&fe!==9)return le}return-1}e.lastNonWhitespaceIndex=o;function s(X,oe){return X<oe?-1:X>oe?1:0}e.compare=s;function a(X,oe,le=0,fe=X.length,me=0,Le=oe.length){for(;le<fe&&me<Le;le++,me++){let ke=X.charCodeAt(le),Pe=oe.charCodeAt(me);if(ke<Pe)return-1;if(ke>Pe)return 1}const ye=fe-le,Re=Le-me;return ye<Re?-1:ye>Re?1:0}e.compareSubstring=a;function l(X,oe){return g(X,oe,0,X.length,0,oe.length)}e.compareIgnoreCase=l;function g(X,oe,le=0,fe=X.length,me=0,Le=oe.length){for(;le<fe&&me<Le;le++,me++){let ke=X.charCodeAt(le),Pe=oe.charCodeAt(me);if(ke===Pe)continue;if(ke>=128||Pe>=128)return a(X.toLowerCase(),oe.toLowerCase(),le,fe,me,Le);I(ke)&&(ke-=32),I(Pe)&&(Pe-=32);const Ae=ke-Pe;if(Ae!==0)return Ae}const ye=fe-le,Re=Le-me;return ye<Re?-1:ye>Re?1:0}e.compareSubstringIgnoreCase=g;function I(X){return X>=97&&X<=122}e.isLowerAsciiLetter=I;function _(X){return X>=65&&X<=90}e.isUpperAsciiLetter=_;function O(X,oe){return X.length===oe.length&&g(X,oe)===0}e.equalsIgnoreCase=O;function U(X,oe){const le=oe.length;return oe.length>X.length?!1:g(X,oe,0,le)===0}e.startsWithIgnoreCase=U;function D(X,oe){let le,fe=Math.min(X.length,oe.length);for(le=0;le<fe;le++)if(X.charCodeAt(le)!==oe.charCodeAt(le))return le;return fe}e.commonPrefixLength=D;function M(X,oe){let le,fe=Math.min(X.length,oe.length);const me=X.length-1,Le=oe.length-1;for(le=0;le<fe;le++)if(X.charCodeAt(me-le)!==oe.charCodeAt(Le-le))return le;return fe}e.commonSuffixLength=M;function N(X){return 55296<=X&&X<=56319}e.isHighSurrogate=N;function x(X){return 56320<=X&&X<=57343}e.isLowSurrogate=x;function Q(X,oe){return(X-55296<<10)+(oe-56320)+65536}e.computeCodePoint=Q;function W(X,oe,le){const fe=X.charCodeAt(le);if(N(fe)&&le+1<oe){const me=X.charCodeAt(le+1);if(x(me))return Q(fe,me)}return fe}e.getNextCodePoint=W;function ie(X,oe){const le=X.charCodeAt(oe-1);if(x(le)&&oe>1){const fe=X.charCodeAt(oe-2);if(N(fe))return Q(fe,le)}return le}class B{constructor(oe,le=0){this._str=oe,this._len=oe.length,this._offset=le}get offset(){return this._offset}setOffset(oe){this._offset=oe}prevCodePoint(){const oe=ie(this._str,this._offset);return this._offset-=oe>=65536?2:1,oe}nextCodePoint(){const oe=W(this._str,this._len,this._offset);return this._offset+=oe>=65536?2:1,oe}eol(){return this._offset>=this._len}}e.CodePointIterator=B;class j{constructor(oe,le=0){this._iterator=new B(oe,le)}get offset(){return this._iterator.offset}nextGraphemeLength(){const oe=ce.getInstance(),le=this._iterator,fe=le.offset;let me=oe.getGraphemeBreakType(le.nextCodePoint());for(;!le.eol();){const Le=le.offset,ye=oe.getGraphemeBreakType(le.nextCodePoint());if(Be(me,ye)){le.setOffset(Le);break}me=ye}return le.offset-fe}prevGraphemeLength(){const oe=ce.getInstance(),le=this._iterator,fe=le.offset;let me=oe.getGraphemeBreakType(le.prevCodePoint());for(;le.offset>0;){const Le=le.offset,ye=oe.getGraphemeBreakType(le.prevCodePoint());if(Be(ye,me)){le.setOffset(Le);break}me=ye}return fe-le.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=j;function Y(X,oe){return new j(X,oe).nextGraphemeLength()}e.nextCharLength=Y;function V(X,oe){return new j(X,oe).prevGraphemeLength()}e.prevCharLength=V;function J(X,oe){oe>0&&x(X.charCodeAt(oe))&&oe--;const le=oe+Y(X,oe);return[le-V(X,le),le]}e.getCharContainingOffset=J;const Z=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function q(X){return Z.test(X)}e.containsRTL=q;const F=/^[\t\n\r\x20-\x7E]*$/;function $(X){return F.test(X)}e.isBasicASCII=$,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function z(X){return e.UNUSUAL_LINE_TERMINATORS.test(X)}e.containsUnusualLineTerminators=z;function H(X){return X>=11904&&X<=55215||X>=63744&&X<=64255||X>=65281&&X<=65374}e.isFullWidthCharacter=H;function ee(X){return X>=127462&&X<=127487||X===8986||X===8987||X===9200||X===9203||X>=9728&&X<=10175||X===11088||X===11093||X>=127744&&X<=128591||X>=128640&&X<=128764||X>=128992&&X<=129008||X>=129280&&X<=129535||X>=129648&&X<=129782}e.isEmojiImprecise=ee;function se(X,oe){if(X.length<oe)return X;const le=/\b/g;let fe=0;for(;le.test(X)&&!(X.length-le.lastIndex<oe);)fe=le.lastIndex,le.lastIndex+=1;return X.substring(fe).replace(/^\s/,"")}e.lcut=se;const ae=/\x1B\x5B[12]?K/g,de=/\x1b\[\d+m/g,ge=/\x1b\[0?m/g;function Ee(X){return X&&(X=X.replace(ae,""),X=X.replace(de,""),X=X.replace(ge,"")),X}e.removeAnsiEscapeCodes=Ee,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Se(X){return!!(X&&X.length>0&&X.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Se;function pe(X){return Se(X)?X.substr(1):X}e.stripUTF8BOM=pe;function Ce(X,oe){if(!X||!oe||X.length<oe.length)return!1;const le=oe.length,fe=X.toLowerCase();let me=0,Le=-1;for(;me<le;){const ye=fe.indexOf(oe[me],Le+1);if(ye<0)return!1;Le=ye,me++}return!0}e.fuzzyContains=Ce;function Ie(X,oe=!1){return X?(oe&&(X=X.replace(/\\./g,"")),X.toLowerCase()!==X):!1}e.containsUppercaseCharacter=Ie;function De(X){return X.charAt(0).toUpperCase()+X.slice(1)}e.uppercaseFirstLetter=De;function Me(X,oe=1){if(oe===0)return"";let le=-1;do le=X.indexOf(`
`,le+1),oe--;while(oe>0&&le>=0);return le===-1?X:(X[le-1]==="\r"&&le--,X.substr(0,le))}e.getNLines=Me;function je(X){const oe=90-65+1;return X=X%(2*oe),X<oe?String.fromCharCode(97+X):String.fromCharCode(65+X-oe)}e.singleLetterHash=je;function Ge(X){return ce.getInstance().getGraphemeBreakType(X)}e.getGraphemeBreakType=Ge;function Be(X,oe){return X===0?oe!==5&&oe!==7:X===2&&oe===3?!1:X===4||X===2||X===3||oe===4||oe===2||oe===3?!0:!(X===8&&(oe===8||oe===9||oe===11||oe===12)||(X===11||X===9)&&(oe===9||oe===10)||(X===12||X===10)&&oe===10||oe===5||oe===13||oe===7||X===1||X===13&&oe===14||X===6&&oe===6)}var re;(function(X){X[X.Other=0]="Other",X[X.Prepend=1]="Prepend",X[X.CR=2]="CR",X[X.LF=3]="LF",X[X.Control=4]="Control",X[X.Extend=5]="Extend",X[X.Regional_Indicator=6]="Regional_Indicator",X[X.SpacingMark=7]="SpacingMark",X[X.L=8]="L",X[X.V=9]="V",X[X.T=10]="T",X[X.LV=11]="LV",X[X.LVT=12]="LVT",X[X.ZWJ=13]="ZWJ",X[X.Extended_Pictographic=14]="Extended_Pictographic"})(re=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ce{constructor(){this._data=ue()}static getInstance(){return ce._INSTANCE||(ce._INSTANCE=new ce),ce._INSTANCE}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const le=this._data,fe=le.length/3;let me=1;for(;me<=fe;)if(oe<le[3*me])me=2*me;else if(oe>le[3*me+1])me=2*me+1;else return le[3*me+2];return 0}}ce._INSTANCE=null;function ue(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function we(X,oe){if(X===0)return 0;const le=be(X,oe);if(le!==void 0)return le;const fe=new B(oe,X);return fe.prevCodePoint(),fe.offset}e.getLeftDeleteOffset=we;function be(X,oe){const le=new B(oe,X);let fe=le.prevCodePoint();for(;Fe(fe)||fe===65039||fe===8419;){if(le.offset===0)return;fe=le.prevCodePoint()}if(!ee(fe))return;let me=le.offset;return me>0&&le.prevCodePoint()===8205&&(me=le.offset),me}function Fe(X){return 127995<=X&&X<=127999}var Te;(function(X){X[X.zwj=8205]="zwj",X[X.emojiVariantSelector=65039]="emojiVariantSelector",X[X.enclosingKeyCap=8419]="enclosingKeyCap"})(Te||(Te={})),e.noBreakWhitespace="\xA0";class Oe{constructor(oe){this.confusableDictionary=oe}static getInstance(oe){return Oe.cache.get(Array.from(oe))}static getLocales(){return Oe._locales.getValue()}isAmbiguous(oe){return this.confusableDictionary.has(oe)}getPrimaryConfusable(oe){return this.confusableDictionary.get(oe)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Oe,L=Oe,Oe.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Oe.cache=new k.LRUCachedComputed(X=>{function oe(Pe){const Ae=new Map;for(let Ne=0;Ne<Pe.length;Ne+=2)Ae.set(Pe[Ne],Pe[Ne+1]);return Ae}function le(Pe,Ae){const Ne=new Map(Pe);for(const[We,qe]of Ae)Ne.set(We,qe);return Ne}function fe(Pe,Ae){if(!Pe)return Ae;const Ne=new Map;for(const[We,qe]of Pe)Ae.has(We)&&Ne.set(We,qe);return Ne}const me=L.ambiguousCharacterData.getValue();let Le=X.filter(Pe=>!Pe.startsWith("_")&&Pe in me);Le.length===0&&(Le=["_default"]);let ye;for(const Pe of Le){const Ae=oe(me[Pe]);ye=fe(ye,Ae)}const Re=oe(me._common),ke=le(Re,ye);return new Oe(ke)}),Oe._locales=new t.Lazy(()=>Object.keys(Oe.ambiguousCharacterData.getValue()).filter(X=>!X.startsWith("_")));class _e{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(_e.getRawData())),this._data}static isInvisibleCharacter(oe){return _e.getData().has(oe)}static get codePoints(){return _e.getData()}}e.InvisibleCharacters=_e,_e._data=void 0}),define(te[71],ne([0,1,26]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(m){return L(m,0)}e.hash=t;function L(m,w){switch(typeof m){case"object":return m===null?T(349,w):Array.isArray(m)?b(m,w):C(m,w);case"string":return R(m,w);case"boolean":return A(m,w);case"number":return T(m,w);case"undefined":return T(937,w);default:return T(617,w)}}e.doHash=L;function T(m,w){return(w<<5)-w+m|0}e.numberHash=T;function A(m,w){return T(m?433:863,w)}function R(m,w){w=T(149417,w);for(let y=0,S=m.length;y<S;y++)w=T(m.charCodeAt(y),w);return w}e.stringHash=R;function b(m,w){return w=T(104579,w),m.reduce((y,S)=>L(S,y),w)}function C(m,w){return w=T(181387,w),Object.keys(m).sort().reduce((y,S)=>(y=R(S,y),L(m[S],y)),w)}class P{constructor(){this._value=0}get value(){return this._value}hash(w){return this._value=L(w,this._value),this._value}}e.Hasher=P;var E;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function f(m,w,y=32){const S=y-w,d=~((1<<S)-1);return(m<<w|(d&m)>>>S)>>>0}function p(m,w=0,y=m.byteLength,S=0){for(let d=0;d<y;d++)m[w+d]=S}function h(m,w,y="0"){for(;m.length<w;)m=y+m;return m}function u(m,w=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(y=>y.toString(16).padStart(2,"0")).join(""):h((m>>>0).toString(16),w/4)}e.toHexString=u;class v{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(w){const y=w.length;if(y===0)return;const S=this._buff;let d=this._buffLen,i=this._leftoverHighSurrogate,c,r;for(i!==0?(c=i,r=-1,i=0):(c=w.charCodeAt(0),r=0);;){let n=c;if(k.isHighSurrogate(c))if(r+1<y){const o=w.charCodeAt(r+1);k.isLowSurrogate(o)?(r++,n=k.computeCodePoint(c,o)):n=65533}else{i=c;break}else k.isLowSurrogate(c)&&(n=65533);if(d=this._push(S,d,n),r++,r<y)c=w.charCodeAt(r);else break}this._buffLen=d,this._leftoverHighSurrogate=i}_push(w,y,S){return S<128?w[y++]=S:S<2048?(w[y++]=192|(S&1984)>>>6,w[y++]=128|(S&63)>>>0):S<65536?(w[y++]=224|(S&61440)>>>12,w[y++]=128|(S&4032)>>>6,w[y++]=128|(S&63)>>>0):(w[y++]=240|(S&1835008)>>>18,w[y++]=128|(S&258048)>>>12,w[y++]=128|(S&4032)>>>6,w[y++]=128|(S&63)>>>0),y>=64&&(this._step(),y-=64,this._totalLen+=64,w[0]=w[64+0],w[1]=w[64+1],w[2]=w[64+2]),y}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),u(this._h0)+u(this._h1)+u(this._h2)+u(this._h3)+u(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const w=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(w/4294967296),!1),this._buffDV.setUint32(60,w%4294967296,!1),this._step()}_step(){const w=v._bigBlock32,y=this._buffDV;for(let a=0;a<64;a+=4)w.setUint32(a,y.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)w.setUint32(a,f(w.getUint32(a-12,!1)^w.getUint32(a-32,!1)^w.getUint32(a-56,!1)^w.getUint32(a-64,!1),1),!1);let S=this._h0,d=this._h1,i=this._h2,c=this._h3,r=this._h4,n,o,s;for(let a=0;a<80;a++)a<20?(n=d&i|~d&c,o=1518500249):a<40?(n=d^i^c,o=1859775393):a<60?(n=d&i|d&c|i&c,o=2400959708):(n=d^i^c,o=3395469782),s=f(S,5)+n+r+o+w.getUint32(a*4,!1)&4294967295,r=c,c=i,i=f(d,30),d=S,S=s;this._h0=this._h0+S&4294967295,this._h1=this._h1+d&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+c&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=v,v._bigBlock32=new DataView(new ArrayBuffer(320))});var It=this&&this.__classPrivateFieldSet||function(K,e,k,t,L){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!L)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!L:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?L.call(K,k):L?L.value=k:e.set(K,k),k},He=this&&this.__classPrivateFieldGet||function(K,e,k,t){if(k==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!t:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return k==="m"?t:k==="a"?t.call(K):t?t.value:e.get(K)};define(te[39],ne([0,1,16,26]),function(K,e,k,t){"use strict";var L,T,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function R(r,n,o){let s=r.get(n);return s===void 0&&(s=o,r.set(n,s)),s}e.getOrSet=R;function b(r){const n=[];return r.forEach((o,s)=>{n.push(`${s} => ${o}`)}),`Map(${r.size}) {${n.join(", ")}}`}e.mapToString=b;function C(r){const n=[];return r.forEach(o=>{n.push(o)}),`Set(${r.size}) {${n.join(", ")}}`}e.setToString=C;class P{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const o=n.charCodeAt(0),s=this._value.charCodeAt(this._pos);return o-s}value(){return this._value[this._pos]}}e.StringIterator=P;class E{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=E;class f{constructor(n=!0,o=!0){this._splitOnBackslash=n,this._caseSensitive=o}reset(n){this._from=0,this._to=0,this._value=n,this._valueLen=n.length;for(let o=n.length-1;o>=0;o--,this._valueLen--){const s=this._value.charCodeAt(o);if(!(s===47||this._splitOnBackslash&&s===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let n=!0;for(;this._to<this._valueLen;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=f;var p;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(p||(p={}));class h{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new f(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,t.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class u{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var v;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(v||(v={}));class m{constructor(n){this._iter=n}static forUris(n=()=>!1){return new m(new h(n))}static forPaths(n=!1){return new m(new f(void 0,!n))}static forStrings(){return new m(new P)}static forConfigKeys(){return new m(new E)}clear(){this._root=void 0}fill(n,o){if(o){const s=o.slice(0);(0,k.shuffle)(s);for(let a of s)this.set(a,n)}else{const s=n.slice(0);(0,k.shuffle)(s);for(let a of s)this.set(a[0],a[1])}}set(n,o){const s=this._iter.reset(n);let a;this._root||(this._root=new u,this._root.segment=s.value());const l=[];for(a=this._root;;){const I=s.cmp(a.segment);if(I>0)a.left||(a.left=new u,a.left.segment=s.value()),l.push([-1,a]),a=a.left;else if(I<0)a.right||(a.right=new u,a.right.segment=s.value()),l.push([1,a]),a=a.right;else if(s.hasNext())s.next(),a.mid||(a.mid=new u,a.mid.segment=s.value()),l.push([0,a]),a=a.mid;else break}const g=a.value;a.value=o,a.key=n;for(let I=l.length-1;I>=0;I--){const _=l[I][1];_.updateHeight();const O=_.balanceFactor();if(O<-1||O>1){const U=l[I][0],D=l[I+1][0];if(U===1&&D===1)l[I][1]=_.rotateLeft();else if(U===-1&&D===-1)l[I][1]=_.rotateRight();else if(U===1&&D===-1)_.right=l[I+1][1]=l[I+1][1].rotateRight(),l[I][1]=_.rotateLeft();else if(U===-1&&D===1)_.left=l[I+1][1]=l[I+1][1].rotateLeft(),l[I][1]=_.rotateRight();else throw new Error;if(I>0)switch(l[I-1][0]){case-1:l[I-1][1].left=l[I][1];break;case 1:l[I-1][1].right=l[I][1];break;case 0:l[I-1][1].mid=l[I][1];break}else this._root=l[0][1]}}return g}get(n){return this._getNode(n)?.value}_getNode(n){const o=this._iter.reset(n);let s=this._root;for(;s;){const a=o.cmp(s.segment);if(a>0)s=s.left;else if(a<0)s=s.right;else if(o.hasNext())o.next(),s=s.mid;else break}return s}has(n){const o=this._getNode(n);return!(o?.value===void 0&&o?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,o){const s=this._iter.reset(n),a=[];let l=this._root;for(;l;){const g=s.cmp(l.segment);if(g>0)a.push([-1,l]),l=l.left;else if(g<0)a.push([1,l]),l=l.right;else if(s.hasNext())s.next(),a.push([0,l]),l=l.mid;else break}if(!!l){if(o?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const g=this._min(l.right),{key:I,value:_,segment:O}=g;this._delete(g.key,!1),l.key=I,l.value=_,l.segment=O}else{const g=l.left??l.right;if(a.length>0){const[I,_]=a[a.length-1];switch(I){case-1:_.left=g;break;case 0:_.mid=g;break;case 1:_.right=g;break}}else this._root=g}for(let g=a.length-1;g>=0;g--){const I=a[g][1];I.updateHeight();const _=I.balanceFactor();if(_>1?(I.right.balanceFactor()>=0||(I.right=I.right.rotateRight()),a[g][1]=I.rotateLeft()):_<-1&&(I.left.balanceFactor()<=0||(I.left=I.left.rotateLeft()),a[g][1]=I.rotateRight()),g>0)switch(a[g-1][0]){case-1:a[g-1][1].left=a[g][1];break;case 1:a[g-1][1].right=a[g][1];break;case 0:a[g-1][1].mid=a[g][1];break}else this._root=a[0][1]}}}_min(n){for(;n.left;)n=n.left;return n}findSubstr(n){const o=this._iter.reset(n);let s=this._root,a;for(;s;){const l=o.cmp(s.segment);if(l>0)s=s.left;else if(l<0)s=s.right;else if(o.hasNext())o.next(),a=s.value||a,s=s.mid;else break}return s&&s.value||a}findSuperstr(n){const o=this._iter.reset(n);let s=this._root;for(;s;){const a=o.cmp(s.segment);if(a>0)s=s.left;else if(a<0)s=s.right;else if(o.hasNext())o.next(),s=s.mid;else return s.mid?this._entries(s.mid):void 0}}forEach(n){for(const[o,s]of this)n(s,o)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){!n||(n.left&&(yield*this._entries(n.left)),n.value&&(yield[n.key,n.value]),n.mid&&(yield*this._entries(n.mid)),n.right&&(yield*this._entries(n.right)))}_isBalanced(){const n=o=>{if(!o)return!0;const s=o.balanceFactor();return s<-1||s>1?!1:n(o.left)&&n(o.right)};return n(this._root)}}e.TernarySearchTree=m;class w{constructor(n,o){this.uri=n,this.value=o}}class y{constructor(n,o){this[L]="ResourceMap",n instanceof y?(this.map=new Map(n.map),this.toKey=o??y.defaultToKey):(this.map=new Map,this.toKey=n??y.defaultToKey)}set(n,o){return this.map.set(this.toKey(n),new w(n,o)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,o){typeof o!="undefined"&&(n=n.bind(o));for(let[s,a]of this.map)n(a.value,a.uri,this)}*values(){for(let n of this.map.values())yield n.value}*keys(){for(let n of this.map.values())yield n.uri}*entries(){for(let n of this.map.values())yield[n.uri,n.value]}*[(L=Symbol.toStringTag,Symbol.iterator)](){for(let[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=y,y.defaultToKey=r=>r.toString();var S;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(S=e.Touch||(e.Touch={}));class d{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,o=0){const s=this._map.get(n);if(!!s)return o!==0&&this.touch(s,o),s.value}set(n,o,s=0){let a=this._map.get(n);if(a)a.value=o,s!==0&&this.touch(a,s);else{switch(a={key:n,value:o,next:void 0,previous:void 0},s){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(n,a),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const o=this._map.get(n);if(!!o)return this._map.delete(n),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,o){const s=this._state;let a=this._head;for(;a;){if(o?n.bind(o)(a.value,a.key,this):n(a.value,a.key,this),this._state!==s)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const n=this,o=this._state;let s=this._head;const a={[Symbol.iterator](){return a},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(s){const l={value:s.key,done:!1};return s=s.next,l}else return{value:void 0,done:!0}}};return a}values(){const n=this,o=this._state;let s=this._head;const a={[Symbol.iterator](){return a},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(s){const l={value:s.value,done:!1};return s=s.next,l}else return{value:void 0,done:!0}}};return a}entries(){const n=this,o=this._state;let s=this._head;const a={[Symbol.iterator](){return a},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(s){const l={value:[s.key,s.value],done:!1};return s=s.next,l}else return{value:void 0,done:!0}}};return a}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let o=this._head,s=this.size;for(;o&&s>n;)this._map.delete(o.key),o=o.next,s--;this._head=o,this._size=s,o&&(o.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const o=n.next,s=n.previous;if(!o||!s)throw new Error("Invalid list");o.previous=s,s.next=o}n.next=void 0,n.previous=void 0,this._state++}touch(n,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(n===this._head)return;const s=n.next,a=n.previous;n===this._tail?(a.next=void 0,this._tail=a):(s.previous=a,a.next=s),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(o===2){if(n===this._tail)return;const s=n.next,a=n.previous;n===this._head?(s.previous=void 0,this._head=s):(s.previous=a,a.next=s),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((o,s)=>{n.push([s,o])}),n}fromJSON(n){this.clear();for(const[o,s]of n)this.set(o,s)}}e.LinkedMap=d;class i extends d{constructor(n,o=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,o=2){return super.get(n,o)}peek(n){return super.get(n,0)}set(n,o){return super.set(n,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=i;class c{constructor(n){A.set(this,void 0),It(this,A,n,"f")}get size(){return He(this,A,"f").size}forEach(n,o){He(this,A,"f").forEach(n,o)}get(n){return He(this,A,"f").get(n)}has(n){return He(this,A,"f").has(n)}entries(){return He(this,A,"f").entries()}keys(){return He(this,A,"f").keys()}values(){return He(this,A,"f").values()}[(A=new WeakMap,Symbol.iterator)](){return He(this,A,"f").entries()}}e.ReadonlyMapView=c}),define(te[72],ne([0,1,39]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new k.LRUCache(1e4);function L(C){return b(C,"NFC",t)}e.normalizeNFC=L;const T=new k.LRUCache(1e4);function A(C){return b(C,"NFD",T)}e.normalizeNFD=A;const R=/[^\u0000-\u0080]/;function b(C,P,E){if(!C)return C;const f=E.get(C);if(f)return f;let p;return R.test(C)?p=C.normalize(P):p=C,E.set(C,p),p}e.removeAccents=function(){const C=/[\u0300-\u036f]/g;return function(P){return A(P).replace(C,"")}}()}),define(te[11],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function k(s){return Array.isArray(s)}e.isArray=k;function t(s){return typeof s=="string"}e.isString=t;function L(s){return Array.isArray(s)&&s.every(a=>t(a))}e.isStringArray=L;function T(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}e.isObject=T;function A(s){return typeof s=="number"&&!isNaN(s)}e.isNumber=A;function R(s){return!!s&&typeof s[Symbol.iterator]=="function"}e.isIterable=R;function b(s){return s===!0||s===!1}e.isBoolean=b;function C(s){return typeof s=="undefined"}e.isUndefined=C;function P(s){return!E(s)}e.isDefined=P;function E(s){return C(s)||s===null}e.isUndefinedOrNull=E;function f(s,a){if(!s)throw new Error(a?`Unexpected type, expected '${a}'`:"Unexpected type")}e.assertType=f;function p(s){if(E(s))throw new Error("Assertion Failed: argument is undefined or null");return s}e.assertIsDefined=p;function h(...s){const a=[];for(let l=0;l<s.length;l++){const g=s[l];if(E(g))throw new Error(`Assertion Failed: argument at index ${l} is undefined or null`);a.push(g)}return a}e.assertAllDefined=h;const u=Object.prototype.hasOwnProperty;function v(s){if(!T(s))return!1;for(let a in s)if(u.call(s,a))return!1;return!0}e.isEmptyObject=v;function m(s){return typeof s=="function"}e.isFunction=m;function w(...s){return s.length>0&&s.every(m)}e.areFunctions=w;function y(s,a){const l=Math.min(s.length,a.length);for(let g=0;g<l;g++)S(s[g],a[g])}e.validateConstraints=y;function S(s,a){if(t(a)){if(typeof s!==a)throw new Error(`argument does not match constraint: typeof ${a}`)}else if(m(a)){try{if(s instanceof a)return}catch{}if(!E(s)&&s.constructor===a||a.length===1&&a.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=S;function d(s){let a=[],l=Object.getPrototypeOf(s);for(;Object.prototype!==l;)a=a.concat(Object.getOwnPropertyNames(l)),l=Object.getPrototypeOf(l);return a}e.getAllPropertyNames=d;function i(s){const a=[];for(const l of d(s))typeof s[l]=="function"&&a.push(l);return a}e.getAllMethodNames=i;function c(s,a){const l=I=>function(){const _=Array.prototype.slice.call(arguments,0);return a(I,_)};let g={};for(const I of s)g[I]=l(I);return g}e.createProxyObject=c;function r(s){return s===null?void 0:s}e.withNullAsUndefined=r;function n(s){return typeof s=="undefined"?null:s}e.withUndefinedAsNull=n;function o(s,a="Unreachable"){throw new Error(a)}e.assertNever=o}),define(te[41],ne([0,1,10,4,26,11]),function(K,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(o){return o===47||o===92}e.isPathSeparator=A;function R(o){return o.replace(/[\\/]/g,k.posix.sep)}e.toSlashes=R;function b(o){return o.indexOf("/")===-1&&(o=R(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=b;function C(o,s=k.posix.sep){if(!o)return"";const a=o.length,l=o.charCodeAt(0);if(A(l)){if(A(o.charCodeAt(1))&&!A(o.charCodeAt(2))){let I=3;const _=I;for(;I<a&&!A(o.charCodeAt(I));I++);if(_!==I&&!A(o.charCodeAt(I+1))){for(I+=1;I<a;I++)if(A(o.charCodeAt(I)))return o.slice(0,I+1).replace(/[\\/]/g,s)}}return s}else if(m(l)&&o.charCodeAt(1)===58)return A(o.charCodeAt(2))?o.slice(0,2)+s:o.slice(0,2);let g=o.indexOf("://");if(g!==-1){for(g+=3;g<a;g++)if(A(o.charCodeAt(g)))return o.slice(0,g+1)}return""}e.getRoot=C;function P(o){if(!t.isWindows||!o||o.length<5)return!1;let s=o.charCodeAt(0);if(s!==92||(s=o.charCodeAt(1),s!==92))return!1;let a=2;const l=a;for(;a<o.length&&(s=o.charCodeAt(a),s!==92);a++);return!(l===a||(s=o.charCodeAt(a+1),isNaN(s)||s===92))}e.isUNC=P;const E=/[\\/:\*\?"<>\|]/g,f=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(o,s=t.isWindows){const a=s?E:f;return!(!o||o.length===0||/^\s+$/.test(o)||(a.lastIndex=0,a.test(o))||s&&p.test(o)||o==="."||o===".."||s&&o[o.length-1]==="."||s&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=h;function u(o,s,a){const l=o===s;return!a||l?l:!o||!s?!1:(0,L.equalsIgnoreCase)(o,s)}e.isEqual=u;function v(o,s,a,l=k.sep){if(o===s)return!0;if(!o||!s||s.length>o.length)return!1;if(a){if(!(0,L.startsWithIgnoreCase)(o,s))return!1;if(s.length===o.length)return!0;let I=s.length;return s.charAt(s.length-1)===l&&I--,o.charAt(I)===l}return s.charAt(s.length-1)!==l&&(s+=l),o.indexOf(s)===0}e.isEqualOrParent=v;function m(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=m;function w(o,s){return t.isWindows&&o.endsWith(":")&&(o+=k.sep),(0,k.isAbsolute)(o)||(o=(0,k.join)(s,o)),o=(0,k.normalize)(o),t.isWindows?(o=(0,L.rtrim)(o,k.sep),o.endsWith(":")&&(o+=k.sep)):(o=(0,L.rtrim)(o,k.sep),o||(o=k.sep)),o}e.sanitizeFilePath=w;function y(o){const s=(0,k.normalize)(o);return t.isWindows?o.length>3?!1:S(s)&&(o.length===2||s.charCodeAt(2)===92):s===k.posix.sep}e.isRootOrDriveLetter=y;function S(o,s){return(s!==void 0?s:t.isWindows)?m(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=S;function d(o){return S(o)?o[0]:void 0}e.getDriveLetter=d;function i(o,s,a){return s.length>o.length?-1:o===s?0:(a&&(o=o.toLowerCase(),s=s.toLowerCase()),o.indexOf(s))}e.indexOfPath=i;function c(o){const s=o.split(":");let a,l,g;for(const I of s){const _=Number(I);(0,T.isNumber)(_)?l===void 0?l=_:g===void 0&&(g=_):a=a?[a,I].join(":"):I}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:l!==void 0?l:void 0,column:g!==void 0?g:l!==void 0?1:void 0}}e.parseLineAndColumnAware=c;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(o,s,a=8){let l="";for(let I=0;I<a;I++)l+=r.charAt(Math.floor(Math.random()*r.length));let g;return s?g=`${s}-${l}`:g=l,o?(0,k.join)(o,g):g}e.randomPath=n}),define(te[28],ne([0,1,11]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const v=Array.isArray(u)?[]:{};return Object.keys(u).forEach(m=>{u[m]&&typeof u[m]=="object"?v[m]=t(u[m]):v[m]=u[m]}),v}e.deepClone=t;function L(u){if(!u||typeof u!="object")return u;const v=[u];for(;v.length>0;){const m=v.shift();Object.freeze(m);for(const w in m)if(T.call(m,w)){const y=m[w];typeof y=="object"&&!Object.isFrozen(y)&&v.push(y)}}return u}e.deepFreeze=L;const T=Object.prototype.hasOwnProperty;function A(u,v){return R(u,v,new Set)}e.cloneAndChange=A;function R(u,v,m){if((0,k.isUndefinedOrNull)(u))return u;const w=v(u);if(typeof w!="undefined")return w;if((0,k.isArray)(u)){const y=[];for(const S of u)y.push(R(S,v,m));return y}if((0,k.isObject)(u)){if(m.has(u))throw new Error("Cannot clone recursive data-structure");m.add(u);const y={};for(let S in u)T.call(u,S)&&(y[S]=R(u[S],v,m));return m.delete(u),y}return u}function b(u,v,m=!0){return(0,k.isObject)(u)?((0,k.isObject)(v)&&Object.keys(v).forEach(w=>{w in u?m&&((0,k.isObject)(u[w])&&(0,k.isObject)(v[w])?b(u[w],v[w],m):u[w]=v[w]):u[w]=v[w]}),u):v}e.mixin=b;function C(u,v){if(u===v)return!0;if(u==null||v===null||v===void 0||typeof u!=typeof v||typeof u!="object"||Array.isArray(u)!==Array.isArray(v))return!1;let m,w;if(Array.isArray(u)){if(u.length!==v.length)return!1;for(m=0;m<u.length;m++)if(!C(u[m],v[m]))return!1}else{const y=[];for(w in u)y.push(w);y.sort();const S=[];for(w in v)S.push(w);if(S.sort(),!C(y,S))return!1;for(m=0;m<y.length;m++)if(!C(u[y[m]],v[y[m]]))return!1}return!0}e.equals=C;function P(u){const v=new Set;return JSON.stringify(u,(m,w)=>{if((0,k.isObject)(w)||Array.isArray(w)){if(v.has(w))return"[Circular]";v.add(w)}return w})}e.safeStringify=P;function E(u,v,m){const w=v(u);return typeof w=="undefined"?m:w}e.getOrDefault=E;function f(u,v){const m=Object.create(null);return!u||!v||Object.keys(v).forEach(y=>{const S=u[y],d=v[y];C(S,d)||(m[y]=d)}),m}e.distinct=f;function p(u,v){const m=v.toLowerCase(),w=Object.keys(u).find(y=>y.toLowerCase()===m);return w?u[w]:u[v]}e.getCaseInsensitive=p;function h(u,v){const m=Object.create(null);for(const[w,y]of Object.entries(u))v(w,y)&&(m[w]=y);return m}e.filter=h}),define(te[7],ne([0,1,10,4]),function(K,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const L=/^\w[\w\d+.-]*$/,T=/^\//,A=/^\/\//;function R(r,n){if(!r.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!L.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!T.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function b(r,n){return!r&&!n?"file":r}function C(r,n){switch(r){case"https":case"http":case"file":n?n[0]!==E&&(n=E+n):n=E;break}return n}const P="",E="/",f=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{constructor(n,o,s,a,l,g=!1){typeof n=="object"?(this.scheme=n.scheme||P,this.authority=n.authority||P,this.path=n.path||P,this.query=n.query||P,this.fragment=n.fragment||P):(this.scheme=b(n,g),this.authority=o||P,this.path=C(this.scheme,s||P),this.query=a||P,this.fragment=l||P,R(this,g))}static isUri(n){return n instanceof p?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}get fsPath(){return y(this,!1)}with(n){if(!n)return this;let{scheme:o,authority:s,path:a,query:l,fragment:g}=n;return o===void 0?o=this.scheme:o===null&&(o=P),s===void 0?s=this.authority:s===null&&(s=P),a===void 0?a=this.path:a===null&&(a=P),l===void 0?l=this.query:l===null&&(l=P),g===void 0?g=this.fragment:g===null&&(g=P),o===this.scheme&&s===this.authority&&a===this.path&&l===this.query&&g===this.fragment?this:new u(o,s,a,l,g)}static parse(n,o=!1){const s=f.exec(n);return s?new u(s[2]||P,c(s[4]||P),c(s[5]||P),c(s[7]||P),c(s[9]||P),o):new u(P,P,P,P,P)}static file(n){let o=P;if(t.isWindows&&(n=n.replace(/\\/g,E)),n[0]===E&&n[1]===E){const s=n.indexOf(E,2);s===-1?(o=n.substring(2),n=E):(o=n.substring(2,s),n=n.substring(s)||E)}return new u("file",o,n,P,P)}static from(n){const o=new u(n.scheme,n.authority,n.path,n.query,n.fragment);return R(o,!0),o}static joinPath(n,...o){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let s;return t.isWindows&&n.scheme==="file"?s=p.file(k.win32.join(y(n,!0),...o)).path:s=k.posix.join(n.path,...o),n.with({path:s})}toString(n=!1){return S(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof p)return n;{const o=new u(n);return o._formatted=n.external,o._fsPath=n._sep===h?n.fsPath:null,o}}else return n}}e.URI=p;const h=t.isWindows?1:void 0;class u extends p{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=y(this,!1)),this._fsPath}toString(n=!1){return n?S(this,!0):(this._formatted||(this._formatted=S(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=h),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const v={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(r,n){let o,s=-1;for(let a=0;a<r.length;a++){const l=r.charCodeAt(a);if(l>=97&&l<=122||l>=65&&l<=90||l>=48&&l<=57||l===45||l===46||l===95||l===126||n&&l===47)s!==-1&&(o+=encodeURIComponent(r.substring(s,a)),s=-1),o!==void 0&&(o+=r.charAt(a));else{o===void 0&&(o=r.substr(0,a));const g=v[l];g!==void 0?(s!==-1&&(o+=encodeURIComponent(r.substring(s,a)),s=-1),o+=g):s===-1&&(s=a)}}return s!==-1&&(o+=encodeURIComponent(r.substring(s))),o!==void 0?o:r}function w(r){let n;for(let o=0;o<r.length;o++){const s=r.charCodeAt(o);s===35||s===63?(n===void 0&&(n=r.substr(0,o)),n+=v[s]):n!==void 0&&(n+=r[o])}return n!==void 0?n:r}function y(r,n){let o;return r.authority&&r.path.length>1&&r.scheme==="file"?o=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?n?o=r.path.substr(1):o=r.path[1].toLowerCase()+r.path.substr(2):o=r.path,t.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=y;function S(r,n){const o=n?w:m;let s="",{scheme:a,authority:l,path:g,query:I,fragment:_}=r;if(a&&(s+=a,s+=":"),(l||a==="file")&&(s+=E,s+=E),l){let O=l.indexOf("@");if(O!==-1){const U=l.substr(0,O);l=l.substr(O+1),O=U.indexOf(":"),O===-1?s+=o(U,!1):(s+=o(U.substr(0,O),!1),s+=":",s+=o(U.substr(O+1),!1)),s+="@"}l=l.toLowerCase(),O=l.indexOf(":"),O===-1?s+=o(l,!1):(s+=o(l.substr(0,O),!1),s+=l.substr(O))}if(g){if(g.length>=3&&g.charCodeAt(0)===47&&g.charCodeAt(2)===58){const O=g.charCodeAt(1);O>=65&&O<=90&&(g=`/${String.fromCharCode(O+32)}:${g.substr(3)}`)}else if(g.length>=2&&g.charCodeAt(1)===58){const O=g.charCodeAt(0);O>=65&&O<=90&&(g=`${String.fromCharCode(O+32)}:${g.substr(2)}`)}s+=o(g,!0)}return I&&(s+="?",s+=o(I,!1)),_&&(s+="#",s+=n?_:m(_,!1)),s}function d(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+d(r.substr(3)):r}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function c(r){return r.match(i)?r.replace(i,n=>d(n)):r}}),define(te[107],ne([0,1,7]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(C){const P=C;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.isRemoteConsoleLog=t;function L(C){const P=[];let E;try{const f=JSON.parse(C.arguments),p=f[f.length-1];p&&p.__$stack&&(f.pop(),E=p.__$stack),P.push(...f)}catch{P.push("Unable to log remote console arguments",C.arguments)}return{args:P,stack:E}}e.parse=L;function T(C){if(typeof C!="string")return T(L(C).stack);const P=C;if(P){const E=A(P),f=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(f&&f.length===4)return{uri:k.URI.file(f[1]),line:Number(f[2]),column:Number(f[3])}}}e.getFirstFrame=T;function A(C){if(!C)return C;const P=C.indexOf(`
`);return P===-1?C:C.substring(0,P)}function R(C,P){const{args:E,stack:f}=L(C),p=typeof E[0]=="string"&&E.length===1;let h=A(f);h&&(h=`(${h.trim()})`);let u=[];if(typeof E[0]=="string"?h&&p?u=[`%c[${P}] %c${E[0]} %c${h}`,b("blue"),b(""),b("grey")]:u=[`%c[${P}] %c${E[0]}`,b("blue"),b(""),...E.slice(1)]:u=[`%c[${P}]%`,b("blue"),...E],h&&!p&&u.push(h),typeof console[C.severity]!="function")throw new Error("Unknown console method");console[C.severity].apply(console,u)}e.log=R;function b(C){return`color: ${C}`}}),define(te[108],ne([0,1,17,26,7]),function(K,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function T(C){return JSON.stringify(C,R)}e.stringify=T;function A(C){let P=JSON.parse(C);return P=b(P),P}e.parse=A;function R(C,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:(0,t.regExpFlags)(P)}:P}function b(C,P=0){if(!C||P>200)return C;if(typeof C=="object"){switch(C.$mid){case 1:return L.URI.revive(C);case 2:return new RegExp(C.source,C.flags);case 14:return new Date(C.source)}if(C instanceof k.VSBuffer||C instanceof Uint8Array)return C;if(Array.isArray(C))for(let E=0;E<C.length;++E)C[E]=b(C[E],P+1);else for(const E in C)Object.hasOwnProperty.call(C,E)&&(C[E]=b(C[E],P+1))}return C}e.revive=b}),define(te[18],ne([0,1,4,7]),function(K,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var L;(function(R){R.inMemory="inmemory",R.vscode="vscode",R.internal="private",R.walkThrough="walkThrough",R.walkThroughSnippet="walkThroughSnippet",R.http="http",R.https="https",R.file="file",R.mailto="mailto",R.untitled="untitled",R.data="data",R.command="command",R.vscodeRemote="vscode-remote",R.vscodeRemoteResource="vscode-remote-resource",R.userData="vscode-userdata",R.vscodeCustomEditor="vscode-custom-editor",R.vscodeNotebook="vscode-notebook",R.vscodeNotebookCell="vscode-notebook-cell",R.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",R.vscodeNotebookCellOutput="vscode-notebook-cell-output",R.vscodeInteractive="vscode-interactive",R.vscodeInteractiveInput="vscode-interactive-input",R.vscodeSettings="vscode-settings",R.vscodeWorkspaceTrust="vscode-workspace-trust",R.vscodeTerminal="vscode-terminal",R.webviewPanel="webview-panel",R.vscodeWebview="vscode-webview",R.extension="extension",R.vscodeFileResource="vscode-file",R.tmp="tmp",R.vsls="vsls"})(L=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(b){this._preferredWebSchema=b}setDelegate(b){this._delegate=b}set(b,C,P){this._hosts[b]=C,this._ports[b]=P}setConnectionToken(b,C){this._connectionTokens[b]=C}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(b){if(this._delegate)return this._delegate(b);const C=b.authority;let P=this._hosts[C];P&&P.indexOf(":")!==-1&&(P=`[${P}]`);const E=this._ports[C],f=this._connectionTokens[C];let p=`path=${encodeURIComponent(b.path)}`;return typeof f=="string"&&(p+=`&${e.connectionTokenQueryName}=${encodeURIComponent(f)}`),t.URI.from({scheme:k.isWeb?this._preferredWebSchema:L.vscodeRemoteResource,authority:`${P}:${E}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new T;class A{asBrowserUri(b,C){const P=this.toUri(b,C);return P.scheme===L.vscodeRemote?e.RemoteAuthorities.rewrite(P):P.scheme===L.file&&(k.isNative||k.isWebWorker&&k.globals.origin===`${L.vscodeFileResource}://${A.FALLBACK_AUTHORITY}`)?P.with({scheme:L.vscodeFileResource,authority:P.authority||A.FALLBACK_AUTHORITY,query:null,fragment:null}):P}asFileUri(b,C){const P=this.toUri(b,C);return P.scheme===L.vscodeFileResource?P.with({scheme:L.file,authority:P.authority!==A.FALLBACK_AUTHORITY?P.authority:null,query:null,fragment:null}):P}toUri(b,C){return t.URI.isUri(b)?b:t.URI.parse(C.toUrl(b))}}A.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new A}),define(te[20],ne([0,1,41,18,10,4,26,7]),function(K,e,k,t,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function b(p){return(0,R.uriToFsPath)(p,!0)}e.originalFSPath=b;class C{constructor(h){this._ignorePathCasing=h}compare(h,u,v=!1){return h===u?0:(0,A.compare)(this.getComparisonKey(h,v),this.getComparisonKey(u,v))}isEqual(h,u,v=!1){return h===u?!0:!h||!u?!1:this.getComparisonKey(h,v)===this.getComparisonKey(u,v)}getComparisonKey(h,u=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:u?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,u,v=!1){if(h.scheme===u.scheme){if(h.scheme===t.Schemas.file)return k.isEqualOrParent(b(h),b(u),this._ignorePathCasing(h))&&h.query===u.query&&(v||h.fragment===u.fragment);if((0,e.isEqualAuthority)(h.authority,u.authority))return k.isEqualOrParent(h.path,u.path,this._ignorePathCasing(h),"/")&&h.query===u.query&&(v||h.fragment===u.fragment)}return!1}joinPath(h,...u){return R.URI.joinPath(h,...u)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return L.posix.basename(h.path)}extname(h){return L.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let u;return h.scheme===t.Schemas.file?u=R.URI.file(L.dirname(b(h))).path:(u=L.posix.dirname(h.path),h.authority&&u.length&&u.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),u="/")),h.with({path:u})}normalizePath(h){if(!h.path.length)return h;let u;return h.scheme===t.Schemas.file?u=R.URI.file(L.normalize(b(h))).path:u=L.posix.normalize(h.path),h.with({path:u})}relativePath(h,u){if(h.scheme!==u.scheme||!(0,e.isEqualAuthority)(h.authority,u.authority))return;if(h.scheme===t.Schemas.file){const w=L.relative(b(h),b(u));return T.isWindows?k.toSlashes(w):w}let v=h.path||"/",m=u.path||"/";if(this._ignorePathCasing(h)){let w=0;for(const y=Math.min(v.length,m.length);w<y&&!(v.charCodeAt(w)!==m.charCodeAt(w)&&v.charAt(w).toLowerCase()!==m.charAt(w).toLowerCase());w++);v=m.substr(0,w)+v.substr(w)}return L.posix.relative(v,m)}resolvePath(h,u){if(h.scheme===t.Schemas.file){const v=R.URI.file(L.resolve(b(h),u));return h.with({authority:v.authority,path:v.path})}return u=k.toPosixPath(u),h.with({path:L.posix.resolve(h.path,u)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,u){return h===u||h!==void 0&&u!==void 0&&(0,A.equalsIgnoreCase)(h,u)}hasTrailingPathSeparator(h,u=L.sep){if(h.scheme===t.Schemas.file){const v=b(h);return v.length>k.getRoot(v).length&&v[v.length-1]===u}else{const v=h.path;return v.length>1&&v.charCodeAt(v.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,u=L.sep){return(0,e.hasTrailingPathSeparator)(h,u)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,u=L.sep){let v=!1;if(h.scheme===t.Schemas.file){const m=b(h);v=m!==void 0&&m.length===k.getRoot(m).length&&m[m.length-1]===u}else{u="/";const m=h.path;v=m.length===1&&m.charCodeAt(m.length-1)===47}return!v&&!(0,e.hasTrailingPathSeparator)(h,u)?h.with({path:h.path+"/"}):h}}e.ExtUri=C,e.extUri=new C(()=>!1),e.extUriBiasedIgnorePathCase=new C(p=>p.scheme===t.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new C(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function P(p,h){const u=[];for(let v=0;v<p.length;v++){const m=h(p[v]);p.some((w,y)=>y===v?!1:(0,e.isEqualOrParent)(m,h(w)))||u.push(p[v])}return u}e.distinctParents=P;var E;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function h(u){const v=new Map;u.path.substring(u.path.indexOf(";")+1,u.path.lastIndexOf(";")).split(";").forEach(y=>{const[S,d]=y.split(":");S&&d&&v.set(S,d)});const w=u.path.substring(0,u.path.indexOf(";"));return w&&v.set(p.META_DATA_MIME,w),v}p.parseMetaData=h})(E=e.DataUri||(e.DataUri={}));function f(p,h,u){if(h){let v=p.path;return v&&v[0]!==L.posix.sep&&(v=L.posix.sep+v),p.with({scheme:u,authority:h,path:v})}return p.with({scheme:u})}e.toLocalResource=f}),define(te[5],ne([0,1,25,9,3,2,20,4]),function(K,e,k,t,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function b(q){return!!q&&typeof q.then=="function"}e.isThenable=b;function C(q){const F=new k.CancellationTokenSource,$=q(F.token),z=new Promise((H,ee)=>{const se=F.token.onCancellationRequested(()=>{se.dispose(),F.dispose(),ee(new t.CancellationError)});Promise.resolve($).then(ae=>{se.dispose(),F.dispose(),H(ae)},ae=>{se.dispose(),F.dispose(),ee(ae)})});return new class{cancel(){F.cancel()}then(H,ee){return z.then(H,ee)}catch(H){return this.then(void 0,H)}finally(H){return z.finally(H)}}}e.createCancelablePromise=C;function P(q,F,$){return new Promise((z,H)=>{const ee=F.onCancellationRequested(()=>{ee.dispose(),z($)});q.then(z,H).finally(()=>ee.dispose())})}e.raceCancellation=P;function E(q,F){return new Promise(($,z)=>{const H=F.onCancellationRequested(()=>{H.dispose(),z(new t.CancellationError)});q.then($,z).finally(()=>H.dispose())})}e.raceCancellationError=E;async function f(q){let F=-1;const $=q.map((H,ee)=>H.then(se=>(F=ee,se))),z=await Promise.race($);return q.forEach((H,ee)=>{ee!==F&&H.cancel()}),z}e.raceCancellablePromises=f;function p(q,F,$){let z;const H=setTimeout(()=>{z?.(void 0),$?.()},F);return Promise.race([q.finally(()=>clearTimeout(H)),new Promise(ee=>z=ee)])}e.raceTimeout=p;function h(q){return new Promise((F,$)=>{const z=q();b(z)?z.then(F,$):F(z)})}e.asPromise=h;class u{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(F){if(this.activePromise){if(this.queuedPromiseFactory=F,!this.queuedPromise){const $=()=>{this.queuedPromise=null;const z=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,z};this.queuedPromise=new Promise(z=>{this.activePromise.then($,$).then(z)})}return new Promise(($,z)=>{this.queuedPromise.then($,z)})}return this.activePromise=F(),new Promise(($,z)=>{this.activePromise.then(H=>{this.activePromise=null,$(H)},H=>{this.activePromise=null,z(H)})})}}e.Throttler=u;class v{constructor(){this.current=Promise.resolve(null)}queue(F){return this.current=this.current.then(()=>F(),()=>F())}}e.Sequencer=v;class m{constructor(){this.promiseMap=new Map}queue(F,$){const H=(this.promiseMap.get(F)??Promise.resolve()).catch(()=>{}).then($).finally(()=>{this.promiseMap.get(F)===H&&this.promiseMap.delete(F)});return this.promiseMap.set(F,H),H}}e.SequencerByKey=m;const w=(q,F)=>{let $=!0;const z=setTimeout(()=>{$=!1,F()},q);return{isTriggered:()=>$,dispose:()=>{clearTimeout(z),$=!1}}},y=q=>{let F=!0;return queueMicrotask(()=>{F&&(F=!1,q())}),{isTriggered:()=>F,dispose:()=>{F=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class S{constructor(F){this.defaultDelay=F,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(F,$=this.defaultDelay){this.task=F,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((H,ee)=>{this.doResolve=H,this.doReject=ee}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const H=this.task;return this.task=null,H()}}));const z=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=$===e.MicrotaskDelay?y(z):w($,z),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=S;class d{constructor(F){this.delayer=new S(F),this.throttler=new u}trigger(F,$){return this.delayer.trigger(()=>this.throttler.queue(F),$)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=d;class i{constructor(){this._isOpen=!1,this._promise=new Promise((F,$)=>{this._completePromise=F})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=i;class c extends i{constructor(F){super();this._timeout=setTimeout(()=>this.open(),F)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function r(q,F){return F?new Promise(($,z)=>{const H=setTimeout(()=>{ee.dispose(),$()},q),ee=F.onCancellationRequested(()=>{clearTimeout(H),ee.dispose(),z(new t.CancellationError)})}):C($=>r(q,$))}e.timeout=r;function n(q,F=0){const $=setTimeout(q,F);return(0,T.toDisposable)(()=>clearTimeout($))}e.disposableTimeout=n;function o(q){const F=[];let $=0;const z=q.length;function H(){return $<z?q[$++]():null}function ee(se){se!=null&&F.push(se);const ae=H();return ae?ae.then(ee):Promise.resolve(F)}return Promise.resolve(null).then(ee)}e.sequence=o;function s(q,F=z=>!!z,$=null){let z=0;const H=q.length,ee=()=>{if(z>=H)return Promise.resolve($);const se=q[z++];return Promise.resolve(se()).then(de=>F(de)?Promise.resolve(de):ee())};return ee()}e.first=s;function a(q,F=z=>!!z,$=null){if(q.length===0)return Promise.resolve($);let z=q.length;const H=()=>{z=-1;for(const ee of q)ee.cancel?.()};return new Promise((ee,se)=>{for(const ae of q)ae.then(de=>{--z>=0&&F(de)?(H(),ee(de)):z===0&&ee($)}).catch(de=>{--z>=0&&(H(),se(de))})})}e.firstParallel=a;class l{constructor(F){this._size=0,this.maxDegreeOfParalellism=F,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new L.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(F){return this._size++,new Promise(($,z)=>{this.outstandingPromises.push({factory:F,c:$,e:z}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const F=this.outstandingPromises.shift();this.runningPromises++;const $=F.factory();$.then(F.c,F.e),$.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=l;class g extends l{constructor(){super(1)}}e.Queue=g;class I{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const F=new B;return this.drainers.add(F),F.p}isDrained(){for(const[,F]of this.queues)if(F.size>0)return!1;return!0}queueFor(F,$=A.extUri){const z=$.getComparisonKey(F);let H=this.queues.get(z);return H||(H=new g,L.Event.once(H.onFinished)(()=>{H?.dispose(),this.queues.delete(z),this.onDidQueueFinish()}),this.queues.set(z,H)),H}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const F of this.drainers)F.complete();this.drainers.clear()}dispose(){for(const[,F]of this.queues)F.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=I;class _{constructor(F,$){this._token=-1,typeof F=="function"&&typeof $=="number"&&this.setIfNotSet(F,$)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(F,$){this.cancel(),this._token=setTimeout(()=>{this._token=-1,F()},$)}setIfNotSet(F,$){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,F()},$))}}e.TimeoutTimer=_;class O{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(F,$){this.cancel(),this._token=setInterval(()=>{F()},$)}}e.IntervalTimer=O;class U{constructor(F,$){this.timeoutToken=-1,this.runner=F,this.timeout=$,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(F=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,F)}get delay(){return this.timeout}set delay(F){this.timeout=F}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=U;class D{constructor(F,$){$%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${$}ms is not a multiple of 1000ms.`),this.runner=F,this.timeout=$,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(F=this.timeout){F%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(F/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=D;class M extends U{constructor(F,$){super(F,$);this.units=[]}work(F){this.units.push(F),this.isScheduled()||this.schedule()}doRun(){const F=this.units;this.units=[],this.runner&&this.runner(F)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=M;class N extends T.Disposable{constructor(F,$){super();this.options=F,this.handler=$,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(F){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+F.length>this.options.maxBufferedWork)return!1}else if(this.pending+F.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...F),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new U(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=N,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=q=>{(0,R.setTimeout0)(()=>{if(F)return;const $=Date.now()+15;q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,$-Date.now())}}))});let F=!1;return{dispose(){F||(F=!0)}}}:e.runWhenIdle=(q,F)=>{const $=requestIdleCallback(q,typeof F=="number"?{timeout:F}:void 0);let z=!1;return{dispose(){z||(z=!0,cancelIdleCallback($))}}}}();class x{constructor(F){this._didRun=!1,this._executor=()=>{try{this._value=F()}catch($){this._error=$}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=x;async function Q(q,F,$){let z;for(let H=0;H<$;H++)try{return await q()}catch(ee){z=ee,await r(F)}throw z}e.retry=Q;class W{hasPending(F){return this._pending?typeof F=="number"?this._pending.taskId===F:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(F,$,z){return this._pending={taskId:F,cancel:()=>z?.(),promise:$},$.then(()=>this.donePending(F),()=>this.donePending(F)),$}donePending(F){this._pending&&F===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const F=this._next;this._next=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this._next)this._next.run=F;else{let $,z;const H=new Promise((ee,se)=>{$=ee,z=se});this._next={run:F,promise:H,promiseResolve:$,promiseReject:z}}return this._next.promise}}e.TaskSequentializer=W;class ie{constructor(F,$=()=>Date.now()){this.interval=F,this.nowFn=$,this.lastIncrementTime=0,this.value=0}increment(){const F=this.nowFn();return F-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=F,this.value=0),this.value++,this.value}}e.IntervalCounter=ie;class B{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((F,$)=>{this.completeCallback=F,this.errorCallback=$})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(F){return new Promise($=>{this.completeCallback(F),this.resolved=!0,$()})}error(F){return new Promise($=>{this.errorCallback(F),this.rejected=!0,$()})}cancel(){new Promise(F=>{this.errorCallback(new t.CancellationError),this.rejected=!0,F()})}}e.DeferredPromise=B;var j;(function(q){async function F(z){let H;const ee=await Promise.all(z.map(se=>se.then(ae=>ae,ae=>{H||(H=ae)})));if(typeof H!="undefined")throw H;return ee}q.settled=F;function $(z){return new Promise(async(H,ee)=>{try{await z(H,ee)}catch(se){ee(se)}})}q.withAsyncBody=$})(j=e.Promises||(e.Promises={}));var Y;(function(q){q[q.Initial=0]="Initial",q[q.DoneOK=1]="DoneOK",q[q.DoneError=2]="DoneError"})(Y||(Y={}));class V{constructor(F){this._state=0,this._results=[],this._error=null,this._onStateChanged=new L.Emitter,queueMicrotask(async()=>{const $={emitOne:z=>this.emitOne(z),emitMany:z=>this.emitMany(z),reject:z=>this.reject(z)};try{await Promise.resolve(F($)),this.resolve()}catch(z){this.reject(z)}finally{$.emitOne=void 0,$.emitMany=void 0,$.reject=void 0}})}static fromArray(F){return new V($=>{$.emitMany(F)})}static fromPromise(F){return new V(async $=>{$.emitMany(await F)})}static fromPromises(F){return new V(async $=>{await Promise.all(F.map(async z=>$.emitOne(await z)))})}static merge(F){return new V(async $=>{await Promise.all(F.map(async z=>{for await(const H of z)$.emitOne(H)}))})}[Symbol.asyncIterator](){let F=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(F<this._results.length)return{done:!1,value:this._results[F++]};if(this._state===1)return{done:!0,value:void 0};await L.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(F,$){return new V(async z=>{for await(const H of F)z.emitOne($(H))})}map(F){return V.map(this,F)}static filter(F,$){return new V(async z=>{for await(const H of F)$(H)&&z.emitOne(H)})}filter(F){return V.filter(this,F)}static coalesce(F){return V.filter(F,$=>!!$)}coalesce(){return V.coalesce(this)}static async toPromise(F){const $=[];for await(const z of F)$.push(z);return $}toPromise(){return V.toPromise(this)}emitOne(F){this._state===0&&(this._results.push(F),this._onStateChanged.fire())}emitMany(F){this._state===0&&(this._results=this._results.concat(F),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(F){this._state===0&&(this._state=2,this._error=F,this._onStateChanged.fire())}}e.AsyncIterableObject=V,V.EMPTY=V.fromArray([]);class J extends V{constructor(F,$){super($);this._source=F}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=J;function Z(q){const F=new k.CancellationTokenSource,$=q(F.token);return new J(F,async z=>{const H=F.token.onCancellationRequested(()=>{H.dispose(),F.dispose(),z.reject(new t.CancellationError)});try{for await(const ee of $){if(F.token.isCancellationRequested)return;z.emitOne(ee)}H.dispose(),F.dispose()}catch(ee){H.dispose(),F.dispose(),z.reject(ee)}})}e.createCancelableAsyncIterable=Z}),define(te[109],ne([0,1,5,41,39,10,4,26]),function(K,e,k,t,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function b(){return Object.create(null)}e.getEmptyExpression=b,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const C="[/\\\\]",P="[^/\\\\]",E=/\//g;function f(B){switch(B){case 0:return"";case 1:return`${P}*?`;default:return`(?:${C}|${P}+${C}|${C}${P}+)*?`}}function p(B,j){if(!B)return[];const Y=[];let V=!1,J=!1,Z="";for(const q of B){switch(q){case j:if(!V&&!J){Y.push(Z),Z="";continue}break;case"{":V=!0;break;case"}":V=!1;break;case"[":J=!0;break;case"]":J=!1;break}Z+=q}return Z&&Y.push(Z),Y}e.splitGlobAware=p;function h(B){if(!B)return"";let j="";const Y=p(B,e.GLOB_SPLIT);if(Y.every(V=>V===e.GLOBSTAR))j=".*";else{let V=!1;Y.forEach((J,Z)=>{if(J===e.GLOBSTAR){V||(j+=f(2),V=!0);return}let q=!1,F="",$=!1,z="";for(const H of J){if(H!=="}"&&q){F+=H;continue}if($&&(H!=="]"||!z)){let ee;H==="-"?ee=H:(H==="^"||H==="!")&&!z?ee="^":H===e.GLOB_SPLIT?ee="":ee=(0,R.escapeRegExpCharacters)(H),z+=ee;continue}switch(H){case"{":q=!0;continue;case"[":$=!0;continue;case"}":{j+=`(?:${p(F,",").map(ae=>h(ae)).join("|")})`,q=!1,F="";break}case"]":j+="["+z+"]",$=!1,z="";break;case"?":j+=P;continue;case"*":j+=f(1);continue;default:j+=(0,R.escapeRegExpCharacters)(H)}}Z<Y.length-1&&(Y[Z+1]!==e.GLOBSTAR||Z+2<Y.length)&&(j+=C),V=!1})}return j}const u=/^\*\*\/\*\.[\w\.-]+$/,v=/^\*\*\/([\w\.-]+)\/?$/,m=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,w=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,y=/^\*\*((\/[\w\.-]+)+)\/?$/,S=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,d=new L.LRUCache(1e4),i=function(){return!1},c=function(){return null};function r(B,j){if(!B)return c;let Y;typeof B!="string"?Y=B.pattern:Y=B,Y=Y.trim();const V=`${Y}_${!!j.trimForExclusions}`;let J=d.get(V);if(J)return n(J,B);let Z;if(u.test(Y)){const q=Y.substr(4);J=function(F,$){return typeof F=="string"&&F.endsWith(q)?Y:null}}else(Z=v.exec(o(Y,j)))?J=s(Z[1],Y):(j.trimForExclusions?w:m).test(Y)?J=a(Y,j):(Z=y.exec(o(Y,j)))?J=l(Z[1].substr(1),Y,!0):(Z=S.exec(o(Y,j)))?J=l(Z[1],Y,!1):J=g(Y);return d.set(V,J),n(J,B)}function n(B,j){return typeof j=="string"?B:function(Y,V){return(0,t.isEqualOrParent)(Y,j.base,!A.isLinux)?B(Y.substr(j.base.length+1),V):null}}function o(B,j){return j.trimForExclusions&&B.endsWith("/**")?B.substr(0,B.length-2):B}function s(B,j){const Y=`/${B}`,V=`\\${B}`,J=function(q,F){return typeof q!="string"?null:F?F===B?j:null:q===B||q.endsWith(Y)||q.endsWith(V)?j:null},Z=[B];return J.basenames=Z,J.patterns=[j],J.allBasenames=Z,J}function a(B,j){const Y=ie(B.slice(1,-1).split(",").map(F=>r(F,j)).filter(F=>F!==c),B),V=Y.length;if(!V)return c;if(V===1)return Y[0];const J=function(F,$){for(let z=0,H=Y.length;z<H;z++)if(Y[z](F,$))return B;return null},Z=Y.find(F=>!!F.allBasenames);Z&&(J.allBasenames=Z.allBasenames);const q=Y.reduce((F,$)=>$.allPaths?F.concat($.allPaths):F,[]);return q.length&&(J.allPaths=q),J}function l(B,j,Y){const V=T.sep===T.posix.sep,J=V?B:B.replace(E,T.sep),Z=T.sep+J,q=T.posix.sep+B,F=Y?function($,z){return typeof $=="string"&&($===J||$.endsWith(Z)||!V&&($===B||$.endsWith(q)))?j:null}:function($,z){return typeof $=="string"&&($===J||!V&&$===B)?j:null};return F.allPaths=[(Y?"*/":"./")+B],F}function g(B){try{const j=new RegExp(`^${h(B)}$`);return function(Y){return j.lastIndex=0,typeof Y=="string"&&j.test(Y)?B:null}}catch{return c}}function I(B,j,Y){return!B||typeof j!="string"?!1:_(B)(j,void 0,Y)}e.match=I;function _(B,j={}){if(!B)return i;if(typeof B=="string"||M(B)){const Y=r(B,j);if(Y===c)return i;const V=function(J,Z){return!!Y(J,Z)};return Y.allBasenames&&(V.allBasenames=Y.allBasenames),Y.allPaths&&(V.allPaths=Y.allPaths),V}return Q(B,j)}e.parse=_;function O(B){if(!B)return;let j;return Y=>(j||(j=(B()||Promise.resolve([])).then(V=>V?D(V):{})),j.then(V=>!!V[Y]))}e.hasSiblingPromiseFn=O;function U(B){if(!B)return;let j;return Y=>{if(!j){const V=B();j=V?D(V):{}}return!!j[Y]}}e.hasSiblingFn=U;function D(B){const j={};for(const Y of B)j[Y]=!0;return j}function M(B){const j=B;return j?typeof j.base=="string"&&typeof j.pattern=="string":!1}e.isRelativePattern=M;function N(B){return B.allBasenames||[]}e.getBasenameTerms=N;function x(B){return B.allPaths||[]}e.getPathTerms=x;function Q(B,j){const Y=ie(Object.getOwnPropertyNames(B).map(F=>W(F,B[F],j)).filter(F=>F!==c)),V=Y.length;if(!V)return c;if(!Y.some(F=>!!F.requiresSiblings)){if(V===1)return Y[0];const F=function(H,ee){for(let se=0,ae=Y.length;se<ae;se++){const de=Y[se](H,ee);if(de)return de}return null},$=Y.find(H=>!!H.allBasenames);$&&(F.allBasenames=$.allBasenames);const z=Y.reduce((H,ee)=>ee.allPaths?H.concat(ee.allPaths):H,[]);return z.length&&(F.allPaths=z),F}const J=function(F,$,z){let H;for(let ee=0,se=Y.length;ee<se;ee++){const ae=Y[ee];ae.requiresSiblings&&z&&($||($=(0,T.basename)(F)),H||(H=$.substr(0,$.length-(0,T.extname)(F).length)));const de=ae(F,$,H,z);if(de)return de}return null},Z=Y.find(F=>!!F.allBasenames);Z&&(J.allBasenames=Z.allBasenames);const q=Y.reduce((F,$)=>$.allPaths?F.concat($.allPaths):F,[]);return q.length&&(J.allPaths=q),J}function W(B,j,Y){if(j===!1)return c;const V=r(B,Y);if(V===c)return c;if(typeof j=="boolean")return V;if(j){const J=j.when;if(typeof J=="string"){const Z=(q,F,$,z)=>{if(!z||!V(q,F))return null;const H=J.replace("$(basename)",$),ee=z(H);return(0,k.isThenable)(ee)?ee.then(se=>se?B:null):ee?B:null};return Z.requiresSiblings=!0,Z}}return V}function ie(B,j){const Y=B.filter(F=>!!F.basenames);if(Y.length<2)return B;const V=Y.reduce((F,$)=>{const z=$.basenames;return z?F.concat(z):F},[]);let J;if(j){J=[];for(let F=0,$=V.length;F<$;F++)J.push(j)}else J=Y.reduce((F,$)=>{const z=$.patterns;return z?F.concat(z):F},[]);const Z=function(F,$){if(typeof F!="string")return null;if(!$){let H;for(H=F.length;H>0;H--){const ee=F.charCodeAt(H-1);if(ee===47||ee===92)break}$=F.substr(H)}const z=V.indexOf($);return z!==-1?J[z]:null};Z.basenames=V,Z.patterns=J,Z.allBasenames=V;const q=B.filter(F=>!F.basenames);return q.push(Z),q}}),define(te[110],ne([0,1,7]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(P){return P.toJSON()}class L{constructor(E){this._uriTransformer=E}transformIncoming(E){const f=this._uriTransformer.transformIncoming(E);return f===E?E:t(k.URI.from(f))}transformOutgoing(E){const f=this._uriTransformer.transformOutgoing(E);return f===E?E:t(k.URI.from(f))}transformOutgoingURI(E){const f=this._uriTransformer.transformOutgoing(E);return f===E?E:k.URI.from(f)}transformOutgoingScheme(E){return this._uriTransformer.transformOutgoingScheme(E)}}e.URITransformer=L,e.DefaultURITransformer=new class{transformIncoming(P){return P}transformOutgoing(P){return P}transformOutgoingURI(P){return P}transformOutgoingScheme(P){return P}};function T(P,E,f){if(!P||f>200)return null;if(typeof P=="object"){if(P instanceof k.URI)return E.transformOutgoing(P);for(let p in P)if(Object.hasOwnProperty.call(P,p)){const h=T(P[p],E,f+1);h!==null&&(P[p]=h)}}return null}function A(P,E){const f=T(P,E,0);return f===null?P:f}e.transformOutgoingURIs=A;function R(P,E,f,p){if(!P||p>200)return null;if(typeof P=="object"){if(P.$mid===1)return f?k.URI.revive(E.transformIncoming(P)):E.transformIncoming(P);for(let h in P)if(Object.hasOwnProperty.call(P,h)){const u=R(P[h],E,f,p+1);u!==null&&(P[h]=u)}}return null}function b(P,E){const f=R(P,E,!1,0);return f===null?P:f}e.transformIncomingURIs=b;function C(P,E){const f=R(P,E,!0,0);return f===null?P:f}e.transformAndReviveIncomingURIs=C}),define(te[29],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const k=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(b){return k.test(b)}e.isUUID=t;const L=new Uint8Array(16),T=[];for(let b=0;b<256;b++)T.push(b.toString(16).padStart(2,"0"));let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(b){for(let C=0;C<b.length;C++)b[C]=Math.floor(Math.random()*256);return b};function R(){A(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let b=0,C="";return C+=T[L[b++]],C+=T[L[b++]],C+=T[L[b++]],C+=T[L[b++]],C+="-",C+=T[L[b++]],C+=T[L[b++]],C+="-",C+=T[L[b++]],C+=T[L[b++]],C+="-",C+=T[L[b++]],C+=T[L[b++]],C+="-",C+=T[L[b++]],C+=T[L[b++]],C+=T[L[b++]],C+=T[L[b++]],C+=T[L[b++]],C+=T[L[b++]],C}e.generateUuid=R}),define(te[111],ne([0,1,252]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class t{constructor(T="utf8"){this.stringDecoder=new k.StringDecoder(T),this.remaining=null}write(T){const A=[],R=this.remaining?this.remaining+this.stringDecoder.write(T):this.stringDecoder.write(T);if(R.length<1)return A;let b=0,C,P=b;for(;P<R.length;)if(C=R.charCodeAt(P),C===13||C===10){if(A.push(R.substring(b,P)),P++,P<R.length){const E=C;C=R.charCodeAt(P),(E===13&&C===10||E===10&&C===13)&&P++}b=P}else P++;return this.remaining=b<R.length?R.substr(b):null,A}end(){return this.remaining}}e.LineDecoder=t}),define(te[112],ne([0,1,34]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function L(A){const R=A.replace(/\-/g,":").toLowerCase();return!t.has(R)}function T(){const A=(0,k.networkInterfaces)();for(let R in A){const b=A[R];if(b){for(const{mac:C}of b)if(L(C))return C}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=T}),define(te[113],ne([0,1,34,9,39,29,112]),function(K,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(P){return this._virtualMachineOUIs||(this._virtualMachineOUIs=L.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(P)}value(){if(this._value===void 0){let P=0,E=0;const f=(0,k.networkInterfaces)();for(let p in f){const h=f[p];if(h)for(const{mac:u,internal:v}of h)v||(E+=1,this._isVirtualMachineMacAddress(u.toUpperCase())&&(P+=1))}this._value=E>0?P/E:0}return this._value}};let R;async function b(){return R||(R=(async()=>await C()||T.generateUuid())()),R}e.getMachineId=b;async function C(){try{const P=await new Promise((f,p)=>{K(["crypto"],f,p)}),E=(0,A.getMac)();return P.createHash("sha256").update(E,"utf8").digest("hex")}catch(P){t.onUnexpectedError(P);return}}}),define(te[22],ne([0,1,50,34,253,5,41,72,10,4,20,7]),function(K,e,k,t,L,T,A,R,b,C,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var f;(function(N){N[N.UNLINK=0]="UNLINK",N[N.MOVE=1]="MOVE"})(f=e.RimRafMode||(e.RimRafMode={}));async function p(N,x=f.UNLINK){if((0,A.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");return x===f.UNLINK?u(N):h(N)}async function h(N){try{const x=(0,A.randomPath)((0,t.tmpdir)());try{await k.promises.rename(N,x)}catch{return u(N)}u(x).catch(Q=>{})}catch(x){if(x.code!=="ENOENT")throw x}}async function u(N){return e.Promises.rmdir(N,{recursive:!0,maxRetries:3})}function v(N){if((0,A.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");k.rmdirSync(N,{recursive:!0})}e.rimrafSync=v;async function m(N,x){return S(await(x?w(N):(0,L.promisify)(k.readdir)(N)))}async function w(N){try{return await(0,L.promisify)(k.readdir)(N,{withFileTypes:!0})}catch(W){console.warn("[node.js fs] readdir with filetypes failed with error: ",W)}const x=[],Q=await m(N);for(const W of Q){let ie=!1,B=!1,j=!1;try{const Y=await e.Promises.lstat((0,b.join)(N,W));ie=Y.isFile(),B=Y.isDirectory(),j=Y.isSymbolicLink()}catch(Y){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Y)}x.push({name:W,isFile:()=>ie,isDirectory:()=>B,isSymbolicLink:()=>j})}return x}function y(N){return S(k.readdirSync(N))}e.readdirSync=y;function S(N){return N.map(x=>typeof x=="string"?C.isMacintosh?(0,R.normalizeNFC)(x):x:(x.name=C.isMacintosh?(0,R.normalizeNFC)(x.name):x.name,x))}async function d(N){const x=await m(N),Q=[];for(const W of x)await c.existsDirectory((0,b.join)(N,W))&&Q.push(W);return Q}function i(N,x=1e3){return new Promise(Q=>{let W=!1;const ie=setInterval(()=>{W||(W=!0,k.access(N,B=>{W=!1,B&&(clearInterval(ie),Q(void 0))}))},x)})}e.whenDeleted=i;var c;(function(N){async function x(ie){let B;try{if(B=await e.Promises.lstat(ie),!B.isSymbolicLink())return{stat:B}}catch{}try{return{stat:await e.Promises.stat(ie),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch(j){if(j.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(C.isWindows&&j.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(ie)),symbolicLink:{dangling:!1}}}catch(Y){if(Y.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw Y}throw j}}N.stat=x;async function Q(ie){try{const{stat:B,symbolicLink:j}=await N.stat(ie);return B.isFile()&&j?.dangling!==!0}catch{}return!1}N.existsFile=Q;async function W(ie){try{const{stat:B,symbolicLink:j}=await N.stat(ie);return B.isDirectory()&&j?.dangling!==!0}catch{}return!1}N.existsDirectory=W})(c=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new T.ResourceQueue;function n(N,x,Q){return r.queueFor(E.URI.file(N),P.extUriBiasedIgnorePathCase).queue(()=>{const W=l(Q);return new Promise((ie,B)=>s(N,x,W,j=>j?B(j):ie()))})}let o=!0;function s(N,x,Q,W){if(!o)return k.writeFile(N,x,{mode:Q.mode,flag:Q.flag},W);k.open(N,Q.flag,Q.mode,(ie,B)=>{if(ie)return W(ie);k.writeFile(B,x,j=>{if(j)return k.close(B,()=>W(j));k.fdatasync(B,Y=>(Y&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Y),o=!1),k.close(B,V=>W(V))))})})}function a(N,x,Q){const W=l(Q);if(!o)return k.writeFileSync(N,x,{mode:W.mode,flag:W.flag});const ie=k.openSync(N,W.flag,W.mode);try{k.writeFileSync(ie,x);try{k.fdatasyncSync(ie)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),o=!1}}finally{k.closeSync(ie)}}e.writeFileSync=a;function l(N){return N?{mode:typeof N.mode=="number"?N.mode:438,flag:typeof N.flag=="string"?N.flag:"w"}:{mode:438,flag:"w"}}async function g(N,x){if(N!==x)try{await e.Promises.rename(N,x)}catch(Q){if(N.toLowerCase()!==x.toLowerCase()&&Q.code==="EXDEV"||N.endsWith("."))await I(N,x,{preserveSymlinks:!1}),await p(N,f.MOVE);else throw Q}}async function I(N,x,Q){return O(N,x,{root:{source:N,target:x},options:Q,handledSourcePaths:new Set})}const _=511;async function O(N,x,Q){if(Q.handledSourcePaths.has(N))return;Q.handledSourcePaths.add(N);const{stat:W,symbolicLink:ie}=await c.stat(N);if(ie){if(Q.options.preserveSymlinks)try{return await M(N,x,Q)}catch(B){console.warn("[node.js fs] copy of symlink failed: ",B)}if(ie.dangling)return}return W.isDirectory()?U(N,x,W.mode&_,Q):D(N,x,W.mode&_)}async function U(N,x,Q,W){await e.Promises.mkdir(x,{recursive:!0,mode:Q});const ie=await m(N);for(const B of ie)await O((0,b.join)(N,B),(0,b.join)(x,B),W)}async function D(N,x,Q){await e.Promises.copyFile(N,x),await e.Promises.chmod(x,Q)}async function M(N,x,Q){let W=await e.Promises.readlink(N);(0,A.isEqualOrParent)(W,Q.root.source,!C.isLinux)&&(W=(0,b.join)(Q.root.target,W.substr(Q.root.source.length+1))),await e.Promises.symlink(W,x)}e.Promises=new class{get access(){return(0,L.promisify)(k.access)}get stat(){return(0,L.promisify)(k.stat)}get lstat(){return(0,L.promisify)(k.lstat)}get utimes(){return(0,L.promisify)(k.utimes)}get read(){return(N,x,Q,W,ie)=>new Promise((B,j)=>{k.read(N,x,Q,W,ie,(Y,V,J)=>Y?j(Y):B({bytesRead:V,buffer:J}))})}get readFile(){return(0,L.promisify)(k.readFile)}get write(){return(N,x,Q,W,ie)=>new Promise((B,j)=>{k.write(N,x,Q,W,ie,(Y,V,J)=>Y?j(Y):B({bytesWritten:V,buffer:J}))})}get appendFile(){return(0,L.promisify)(k.appendFile)}get fdatasync(){return(0,L.promisify)(k.fdatasync)}get truncate(){return(0,L.promisify)(k.truncate)}get rename(){return(0,L.promisify)(k.rename)}get copyFile(){return(0,L.promisify)(k.copyFile)}get open(){return(0,L.promisify)(k.open)}get close(){return(0,L.promisify)(k.close)}get symlink(){return(0,L.promisify)(k.symlink)}get readlink(){return(0,L.promisify)(k.readlink)}get chmod(){return(0,L.promisify)(k.chmod)}get mkdir(){return(0,L.promisify)(k.mkdir)}get unlink(){return(0,L.promisify)(k.unlink)}get rmdir(){return(0,L.promisify)(k.rmdir)}get realpath(){return(0,L.promisify)(k.realpath)}async exists(N){try{return await e.Promises.access(N),!0}catch{return!1}}get readdir(){return m}get readDirsInDir(){return d}get writeFile(){return n}get rm(){return p}get move(){return g}get copy(){return I}}}),define(te[114],ne([0,1,50,10,4,26,22]),function(K,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function R(f){if(L.isLinux)return f;const p=(0,t.dirname)(f);if(f===p)return f;const h=((0,t.basename)(f)||f).toLowerCase();try{const v=(0,A.readdirSync)(p).filter(m=>m.toLowerCase()===h);if(v.length===1){const m=R(p);if(m)return(0,t.join)(m,v[0])}else if(v.length>1){const m=v.indexOf(h);if(m>=0){const w=R(p);if(w)return(0,t.join)(w,v[m])}}}catch{}return null}e.realcaseSync=R;async function b(f){if(L.isLinux)return f;const p=(0,t.dirname)(f);if(f===p)return f;const h=((0,t.basename)(f)||f).toLowerCase();try{const v=(await A.Promises.readdir(p)).filter(m=>m.toLowerCase()===h);if(v.length===1){const m=await b(p);if(m)return(0,t.join)(m,v[0])}else if(v.length>1){const m=v.indexOf(h);if(m>=0){const w=await b(p);if(w)return(0,t.join)(w,v[m])}}}catch{}return null}e.realcase=b;async function C(f){try{return await A.Promises.realpath(f)}catch{const h=E(f);return await A.Promises.access(h,k.constants.R_OK),h}}e.realpath=C;function P(f){try{return k.realpathSync(f)}catch{const h=E(f);return k.accessSync(h,k.constants.R_OK),h}}e.realpathSync=P;function E(f){return(0,T.rtrim)((0,t.normalize)(f),t.sep)}}),define(te[115],ne([0,1,56]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(R,b,C,P=1){let E=!1;return new Promise(f=>{const p=setTimeout(()=>{if(!E)return E=!0,f(0)},C);L(R,b,P,h=>{if(!E)return E=!0,clearTimeout(p),f(h)})})}e.findFreePort=t;function L(R,b,C,P){if(b===0)return P(0);const E=new k.Socket;E.once("connect",()=>(A(E),L(R+C,b-1,C,P))),E.once("data",()=>{}),E.once("error",f=>(A(E),f.code!=="ECONNREFUSED"?L(R+C,b-1,C,P):P(R))),E.connect(R,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function T(R,b,C){let P=!1,E,f=1;const p=k.createServer({pauseOnConnect:!0});function h(u,v){P||(P=!0,p.removeAllListeners(),p.close(),E&&clearTimeout(E),v(u))}return new Promise(u=>{E=setTimeout(()=>{h(0,u)},C),p.on("listening",()=>{h(R,u)}),p.on("error",v=>{v&&(v.code==="EADDRINUSE"||v.code==="EACCES")&&f<b?(R++,f++,p.listen(R,"127.0.0.1")):h(0,u)}),p.on("close",()=>{h(0,u)}),p.listen(R,"127.0.0.1")})}e.findFreePortFaster=T;function A(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(b){console.error(b)}}}),define(te[73],ne([0,1,34,10,22]),function(K,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const T=/^\d+$/,A=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var b;(function(S){S[S.x64=0]="x64",S[S.x86=1]="x86",S[S.ARM=2]="ARM"})(b||(b={}));let C;switch(process.arch){case"ia32":case"x32":C=1;break;case"arm":case"arm64":C=2;break;default:C=0;break}let P;process.env.PROCESSOR_ARCHITEW6432?P=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?P=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?P=1:P=0;class E{constructor(d,i,c){this.exePath=d,this.displayName=i,this.knownToExist=c}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await L.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function f({useAlternateBitness:S=!1}={}){return S?C===0?process.env["ProgramFiles(x86)"]||null:P===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:S=!1,findPreview:d=!1}={}){const i=f({useAlternateBitness:S});if(!i)return null;const c=t.join(i,"PowerShell");if(!await L.SymlinkSupport.existsDirectory(c))return null;let r=-1,n=null;for(const a of await L.Promises.readdir(c)){let l=-1;if(d){const I=a.indexOf("-");if(I<0)continue;const _=a.substring(0,I);if(!T.test(_)||a.substring(I+1)!=="preview")continue;l=parseInt(_,10)}else{if(!T.test(a))continue;l=parseInt(a,10)}if(l<=r)continue;const g=t.join(c,a,"pwsh.exe");!await L.SymlinkSupport.existsFile(g)||(n=g,r=l)}if(!n)return null;const o=i.includes("x86")?" (x86)":"",s=d?" Preview":"";return new E(n,`PowerShell${s}${o}`,!0)}async function h({findPreview:S}={}){if(!process.env.LOCALAPPDATA)return null;const d=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await L.SymlinkSupport.existsDirectory(d))return null;const{pwshMsixDirRegex:i,pwshMsixName:c}=S?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const r of await L.Promises.readdir(d))if(i.test(r)){const n=t.join(d,r,"pwsh.exe");return new E(n,c)}return null}function u(){const S=t.join(k.homedir(),".dotnet","tools","pwsh.exe");return new E(S,".NET Core PowerShell Global Tool")}function v(){const S=t.join(process.env.windir,C===1&&P!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(S,"Windows PowerShell",!0)}async function*m(){let S=await p();S&&(yield S),S=await p({useAlternateBitness:!0}),S&&(yield S),S=await h(),S&&(yield S),S=u(),S&&(yield S),S=await p({findPreview:!0}),S&&(yield S),S=await h({findPreview:!0}),S&&(yield S),S=await p({useAlternateBitness:!0,findPreview:!0}),S&&(yield S),S=v(),S&&(yield S)}async function*w(){for await(const S of m())await S.exists()&&(yield S)}e.enumeratePowerShellInstallations=w;async function y(){for await(const S of w())return S;return null}e.getFirstAvailablePowerShellInstallation=y}),define(te[116],ne([0,1,46,18]),function(K,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function L(A){return new Promise((R,b)=>{let C;const P=new Map;function E(p,h,u,v,m){const w=P.get(h);if(p===A||w){const y={name:f(u),cmd:u,pid:p,ppid:h,load:v,mem:m};P.set(p,y),p===A&&(C=y),w&&(w.children||(w.children=[]),w.children.push(y),w.children.length>1&&(w.children=w.children.sort((S,d)=>S.pid-d.pid)))}}function f(p){const h=/--vscode-window-kind=shared-process/,u=/--vscode-window-kind=issue-reporter/,v=/--vscode-window-kind=process-explorer/,m=/--utility-sub-type=network/,w=/--crashes-directory/,y=/\\pipe\\winpty-control/,S=/conhost\.exe/,d=/--type=([a-zA-Z-]+)/;if(w.exec(p))return"electron-crash-reporter";if(y.exec(p))return"winpty-process";if(S.exec(p))return"console-window-host (Windows internal process)";let i=d.exec(p);if(i&&i.length===2)return i[1]==="renderer"?h.exec(p)?"shared-process":u.exec(p)?"issue-reporter":v.exec(p)?"process-explorer":"window":i[1]==="utility"&&m.exec(p)?"utility-network-service":i[1];const c=/[a-zA-Z-]+\.js/g;let r="";do i=c.exec(p),i&&(r+=i+" ");while(i);return r&&p.indexOf("node ")<0&&p.indexOf("node.exe")<0?`electron_node ${r}`:p}if(process.platform==="win32"){const p=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,u)=>{K(["windows-process-tree"],h,u)}).then(h=>{h.getProcessList(A,u=>{h.getProcessCpuUsage(u,v=>{const m=new Map;v.forEach(w=>{const y=p(w.commandLine||"");m.set(w.pid,{name:f(y),cmd:y,pid:w.pid,ppid:w.ppid,load:w.cpu||0,mem:w.memory||0})}),C=m.get(A),C?(m.forEach(w=>{const y=m.get(w.ppid);y&&(y.children||(y.children=[]),y.children.push(w))}),m.forEach(w=>{w.children&&(w.children=w.children.sort((y,S)=>y.pid-S.pid))}),R(C)):b(new Error(`Root process ${A} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let p=function(){let h=[C];const u=[];for(;h.length;){const m=h.shift();m&&(u.push(m.pid),m.children&&(h=h.concat(m.children)))}let v=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",K).fsPath);v+=" "+u.join(" "),(0,k.exec)(v,{},(m,w,y)=>{if(m||y)b(m||new Error(y.toString()));else{const S=w.toString().split(`
`);for(let d=0;d<u.length;d++){const i=P.get(u[d]);i.load=parseFloat(S[d])}if(!C){b(new Error(`Root process ${A} not found`));return}R(C)}})};(0,k.exec)("which ps",{},(h,u,v)=>{if(h||v)if(process.platform!=="linux")b(h||new Error(v.toString()));else{const m=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh",K).fsPath);(0,k.exec)(m,{},(w,y,S)=>{w||S?b(w||new Error(S.toString())):(T(y,E),p())})}else{const m=u.toString().trim(),w="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,k.exec)(`${m} ${w}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(y,S,d)=>{y||d&&!d.includes("screen size is bogus")?b(y||new Error(d.toString())):(T(S,E),process.platform==="linux"?p():C?R(C):b(new Error(`Root process ${A} not found`)))})}})}})}e.listProcesses=L;function T(A,R){const b=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,C=A.toString().split(`
`);for(const P of C){const E=b.exec(P.trim());E&&E.length===6&&R(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}});var he=this&&this.__decorate||function(K,e,k,t){var L=arguments.length,T=L<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,k):t,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(K,e,k,t);else for(var R=K.length-1;R>=0;R--)(A=K[R])&&(T=(L<3?A(T):L>3?A(e,k,T):A(e,k))||T);return L>3&&T&&Object.defineProperty(e,k,T),T};define(te[36],ne([0,1,16,5,17,25,54,9,3,2,108,26,11]),function(K,e,k,t,L,T,A,R,b,C,P,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var p;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(p=e.RequestType||(e.RequestType={}));function h(B){switch(B){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var u;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(u=e.ResponseType||(e.ResponseType={}));function v(B){switch(B){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(m||(m={}));class w{constructor(j){this.buffer=j,this.pos=0}read(j){const Y=this.buffer.slice(this.pos,this.pos+j);return this.pos+=Y.byteLength,Y}}class y{constructor(){this.buffers=[]}get buffer(){return L.VSBuffer.concat(this.buffers)}write(j){this.buffers.push(j)}}var S;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object"})(S||(S={}));function d(B){const j=L.VSBuffer.alloc(4);return j.writeUInt32BE(B,0),j}function i(B){return B.read(4).readUInt32BE(0)}function c(B){const j=L.VSBuffer.alloc(1);return j.writeUInt8(B,0),j}const r={Undefined:c(S.Undefined),String:c(S.String),Buffer:c(S.Buffer),VSBuffer:c(S.VSBuffer),Array:c(S.Array),Object:c(S.Object)},n=typeof Buffer!="undefined";function o(B,j){if(typeof j=="undefined")B.write(r.Undefined);else if(typeof j=="string"){const Y=L.VSBuffer.fromString(j);B.write(r.String),B.write(d(Y.byteLength)),B.write(Y)}else if(n&&Buffer.isBuffer(j)){const Y=L.VSBuffer.wrap(j);B.write(r.Buffer),B.write(d(Y.byteLength)),B.write(Y)}else if(j instanceof L.VSBuffer)B.write(r.VSBuffer),B.write(d(j.byteLength)),B.write(j);else if(Array.isArray(j)){B.write(r.Array),B.write(d(j.length));for(const Y of j)o(B,Y)}else{const Y=L.VSBuffer.fromString(JSON.stringify(j));B.write(r.Object),B.write(d(Y.byteLength)),B.write(Y)}}function s(B){switch(B.read(1).readUInt8(0)){case S.Undefined:return;case S.String:return B.read(i(B)).toString();case S.Buffer:return B.read(i(B)).buffer;case S.VSBuffer:return B.read(i(B));case S.Array:{const Y=i(B),V=[];for(let J=0;J<Y;J++)V.push(s(B));return V}case S.Object:return JSON.parse(B.read(i(B)).toString())}}class a{constructor(j,Y,V=null,J=1e3){this.protocol=j,this.ctx=Y,this.logger=V,this.timeoutDelay=J,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(Z=>this.onRawMessage(Z)),this.sendResponse({type:200})}registerChannel(j,Y){this.channels.set(j,Y),setTimeout(()=>this.flushPendingRequests(j),0)}sendResponse(j){switch(j.type){case 200:{const Y=this.send([j.type]);this.logger?.logOutgoing(Y,0,1,v(j.type));return}case 201:case 202:case 204:case 203:{const Y=this.send([j.type,j.id],j.data);this.logger?.logOutgoing(Y,j.id,1,v(j.type),j.data);return}}}send(j,Y=void 0){const V=new y;return o(V,j),o(V,Y),this.sendBuffer(V.buffer)}sendBuffer(j){try{return this.protocol.send(j),j.byteLength}catch{return 0}}onRawMessage(j){const Y=new w(j),V=s(Y),J=s(Y),Z=V[0];switch(Z){case 100:return this.logger?.logIncoming(j.byteLength,V[1],1,`${h(Z)}: ${V[2]}.${V[3]}`,J),this.onPromise({type:Z,id:V[1],channelName:V[2],name:V[3],arg:J});case 102:return this.logger?.logIncoming(j.byteLength,V[1],1,`${h(Z)}: ${V[2]}.${V[3]}`,J),this.onEventListen({type:Z,id:V[1],channelName:V[2],name:V[3],arg:J});case 101:return this.logger?.logIncoming(j.byteLength,V[1],1,`${h(Z)}`),this.disposeActiveRequest({type:Z,id:V[1]});case 103:return this.logger?.logIncoming(j.byteLength,V[1],1,`${h(Z)}`),this.disposeActiveRequest({type:Z,id:V[1]})}}onPromise(j){const Y=this.channels.get(j.channelName);if(!Y){this.collectPendingRequest(j);return}const V=new T.CancellationTokenSource;let J;try{J=Y.call(this.ctx,j.name,j.arg,V.token)}catch(F){J=Promise.reject(F)}const Z=j.id;J.then(F=>{this.sendResponse({id:Z,data:F,type:201}),this.activeRequests.delete(j.id)},F=>{F instanceof Error?this.sendResponse({id:Z,data:{message:F.message,name:F.name,stack:F.stack?F.stack.split?F.stack.split(`
`):F.stack:void 0},type:202}):this.sendResponse({id:Z,data:F,type:203}),this.activeRequests.delete(j.id)});const q=(0,C.toDisposable)(()=>V.cancel());this.activeRequests.set(j.id,q)}onEventListen(j){const Y=this.channels.get(j.channelName);if(!Y){this.collectPendingRequest(j);return}const V=j.id,Z=Y.listen(this.ctx,j.name,j.arg)(q=>this.sendResponse({id:V,data:q,type:204}));this.activeRequests.set(j.id,Z)}disposeActiveRequest(j){const Y=this.activeRequests.get(j.id);Y&&(Y.dispose(),this.activeRequests.delete(j.id))}collectPendingRequest(j){let Y=this.pendingRequests.get(j.channelName);Y||(Y=[],this.pendingRequests.set(j.channelName,Y));const V=setTimeout(()=>{console.error(`Unknown channel: ${j.channelName}`),j.type===100&&this.sendResponse({id:j.id,data:{name:"Unknown channel",message:`Channel name '${j.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Y.push({request:j,timeoutTimer:V})}flushPendingRequests(j){const Y=this.pendingRequests.get(j);if(Y){for(const V of Y)switch(clearTimeout(V.timeoutTimer),V.request.type){case 100:this.onPromise(V.request);break;case 102:this.onEventListen(V.request);break}this.pendingRequests.delete(j)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,C.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=a;var l;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(l=e.RequestInitiator||(e.RequestInitiator={}));class g{constructor(j,Y=null){this.protocol=j,this.isDisposed=!1,this.state=m.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new b.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(V=>this.onBuffer(V)),this.logger=Y}getChannel(j){const Y=this;return{call(V,J,Z){return Y.isDisposed?Promise.reject(R.canceled()):Y.requestPromise(j,V,J,Z)},listen(V,J){return Y.isDisposed?b.Event.None:Y.requestEvent(j,V,J)}}}requestPromise(j,Y,V,J=T.CancellationToken.None){const Z=this.lastRequestId++,F={id:Z,type:100,channelName:j,name:Y,arg:V};if(J.isCancellationRequested)return Promise.reject(R.canceled());let $;return new Promise((H,ee)=>{if(J.isCancellationRequested)return ee(R.canceled());const se=()=>{const Ee=Se=>{switch(Se.type){case 201:this.handlers.delete(Z),H(Se.data);break;case 202:{this.handlers.delete(Z);const pe=new Error(Se.data.message);pe.stack=Se.data.stack,pe.name=Se.data.name,ee(pe);break}case 203:this.handlers.delete(Z),ee(Se.data);break}};this.handlers.set(Z,Ee),this.sendRequest(F)};let ae=null;this.state===m.Idle?se():(ae=(0,t.createCancelablePromise)(Ee=>this.whenInitialized()),ae.then(()=>{ae=null,se()}));const de=()=>{ae?(ae.cancel(),ae=null):this.sendRequest({id:Z,type:101}),ee(R.canceled())},ge=J.onCancellationRequested(de);$=(0,C.combinedDisposable)((0,C.toDisposable)(de),ge),this.activeRequests.add($)}).finally(()=>{this.activeRequests.delete($)})}requestEvent(j,Y,V){const J=this.lastRequestId++,q={id:J,type:102,channelName:j,name:Y,arg:V};let F=null;const $=new b.Emitter({onFirstListenerAdd:()=>{F=(0,t.createCancelablePromise)(H=>this.whenInitialized()),F.then(()=>{F=null,this.activeRequests.add($),this.sendRequest(q)})},onLastListenerRemove:()=>{F?(F.cancel(),F=null):(this.activeRequests.delete($),this.sendRequest({id:J,type:103}))}}),z=H=>$.fire(H.data);return this.handlers.set(J,z),$.event}sendRequest(j){switch(j.type){case 100:case 102:{const Y=this.send([j.type,j.id,j.channelName,j.name],j.arg);this.logger&&this.logger.logOutgoing(Y,j.id,0,`${h(j.type)}: ${j.channelName}.${j.name}`,j.arg);return}case 101:case 103:{const Y=this.send([j.type,j.id]);this.logger&&this.logger.logOutgoing(Y,j.id,0,h(j.type));return}}}send(j,Y=void 0){const V=new y;return o(V,j),o(V,Y),this.sendBuffer(V.buffer)}sendBuffer(j){try{return this.protocol.send(j),j.byteLength}catch{return 0}}onBuffer(j){const Y=new w(j),V=s(Y),J=s(Y),Z=V[0];switch(Z){case 200:return this.logger&&this.logger.logIncoming(j.byteLength,0,0,v(Z)),this.onResponse({type:V[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(j.byteLength,V[1],0,v(Z),J),this.onResponse({type:V[0],id:V[1],data:J})}}onResponse(j){if(j.type===200){this.state=m.Idle,this._onDidInitialize.fire();return}const Y=this.handlers.get(j.id);Y&&Y(j)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,C.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}he([A.memoize],g.prototype,"onDidInitializePromise",null),e.ChannelClient=g;class I{constructor(j){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new b.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new b.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,j(({protocol:Y,onDidClientDisconnect:V})=>{b.Event.once(Y.onMessage)(Z=>{const q=new w(Z),F=s(q),$=new a(Y,F),z=new g(Y);this.channels.forEach((ee,se)=>$.registerChannel(se,ee));const H={channelServer:$,channelClient:z,ctx:F};this._connections.add(H),this._onDidAddConnection.fire(H),V(()=>{$.dispose(),z.dispose(),this._connections.delete(H),this._onDidRemoveConnection.fire(H)})})})}get connections(){const j=[];return this._connections.forEach(Y=>j.push(Y)),j}getChannel(j,Y){const V=this;return{call(J,Z,q){let F;if((0,f.isFunction)(Y)){let z=(0,k.getRandomElement)(V.connections.filter(Y));F=z?Promise.resolve(z):b.Event.toPromise(b.Event.filter(V.onDidAddConnection,Y))}else F=Y.routeCall(V,J,Z);const $=F.then(z=>z.channelClient.getChannel(j));return O($).call(J,Z,q)},listen(J,Z){if((0,f.isFunction)(Y))return V.getMulticastEvent(j,Y,J,Z);const q=Y.routeEvent(V,J,Z).then(F=>F.channelClient.getChannel(j));return O(q).listen(J,Z)}}}getMulticastEvent(j,Y,V,J){const Z=this;let q=new C.DisposableStore;const F=new b.Emitter({onFirstListenerAdd:()=>{q=new C.DisposableStore;const $=new b.EventMultiplexer,z=new Map,H=se=>{const de=se.channelClient.getChannel(j).listen(V,J),ge=$.add(de);z.set(se,ge)},ee=se=>{const ae=z.get(se);!ae||(ae.dispose(),z.delete(se))};Z.connections.filter(Y).forEach(H),b.Event.filter(Z.onDidAddConnection,Y)(H,void 0,q),Z.onDidRemoveConnection(ee,void 0,q),$.event(F.fire,F,q),q.add($)},onLastListenerRemove:()=>{q.dispose()}});return F.event}registerChannel(j,Y){this.channels.set(j,Y),this._connections.forEach(V=>{V.channelServer.registerChannel(j,Y)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=I;class _{constructor(j,Y,V=null){const J=new y;o(J,Y),j.send(J.buffer),this.channelClient=new g(j,V),this.channelServer=new a(j,Y,V)}getChannel(j){return this.channelClient.getChannel(j)}registerChannel(j,Y){this.channelServer.registerChannel(j,Y)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=_;function O(B){return{call(j,Y,V){return B.then(J=>J.call(j,Y,V))},listen(j,Y){const V=new b.Relay;return B.then(J=>V.input=J.listen(j,Y)),V.event}}}e.getDelayedChannel=O;function U(B){let j=!1;return{call(Y,V,J){return j?B.call(Y,V,J):(0,t.timeout)(0).then(()=>j=!0).then(()=>B.call(Y,V,J))},listen(Y,V){if(j)return B.listen(Y,V);const J=new b.Relay;return(0,t.timeout)(0).then(()=>j=!0).then(()=>J.input=B.listen(Y,V)),J.event}}}e.getNextTickChannel=U;class D{constructor(j){this.fn=j}routeCall(j){return this.route(j)}routeEvent(j){return this.route(j)}async route(j){for(const Y of j.connections)if(await Promise.resolve(this.fn(Y.ctx)))return Promise.resolve(Y);return await b.Event.toPromise(j.onDidAddConnection),await this.route(j)}}e.StaticRouter=D;var M;(function(B){function j(Z,q){const F=Z,$=q&&q.disableMarshalling,z=new Map;for(const H in F)V(H)&&z.set(H,b.Event.buffer(F[H],!0));return new class{listen(H,ee,se){const ae=z.get(ee);if(ae)return ae;if(J(ee)){const de=F[ee];if(typeof de=="function")return de.call(F,se)}throw new Error(`Event not found: ${ee}`)}call(H,ee,se){const ae=F[ee];if(typeof ae=="function"){if(!$&&Array.isArray(se))for(let de=0;de<se.length;de++)se[de]=(0,P.revive)(se[de]);return ae.apply(F,se)}throw new Error(`Method not found: ${ee}`)}}}B.fromService=j;function Y(Z,q){const F=q&&q.disableMarshalling;return new Proxy({},{get($,z){if(typeof z=="string")return q?.properties?.has(z)?q.properties.get(z):J(z)?function(H){return Z.listen(z,H)}:V(z)?Z.listen(z):async function(...H){let ee;q&&!(0,f.isUndefinedOrNull)(q.context)?ee=[q.context,...H]:ee=H;const se=await Z.call(z,ee);return F?se:(0,P.revive)(se)};throw new Error(`Property not found: ${String(z)}`)}})}B.toService=Y;function V(Z){return Z[0]==="o"&&Z[1]==="n"&&E.isUpperAsciiLetter(Z.charCodeAt(2))}function J(Z){return/^onDynamic/.test(Z)&&E.isUpperAsciiLetter(Z.charCodeAt(9))}})(M=e.ProxyChannel||(e.ProxyChannel={}));const N=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function x(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){let j=B.toString();if(j!=="[object Object]")return j}return B}function Q(B){return Array.isArray(B)?B.map(x):x(B)}function W(B,j,Y,V,J,Z,q){q=Q(q);const F=N[J],$=F[V%F.length];let z=[`%c[${B}]%c[${String(j).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(V).padStart(5," ")} - ${Z}`,"color: darkgreen","color: grey","color: grey",`color: ${$}`];/\($/.test(Z)?(z=z.concat(q),z.push(")")):z.push(q),console.log.apply(console,z)}e.logWithColors=W;class ie{constructor(j,Y){this._outgoingPrefix=j,this._incomingPrefix=Y,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(j,Y,V,J,Z){this._totalOutgoing+=j,W(this._outgoingPrefix,this._totalOutgoing,j,Y,V,J,Z)}logIncoming(j,Y,V,J,Z){this._totalIncoming+=j,W(this._incomingPrefix,this._totalIncoming,j,Y,V,J,Z)}}e.IPCLogger=ie}),define(te[117],ne([0,1,17,3,36]),function(K,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class T{constructor(b){this.port=b,this.onMessage=t.Event.fromDOMEventEmitter(this.port,"message",C=>k.VSBuffer.wrap(C.data)),b.start()}send(b){this.port.postMessage(b.buffer)}disconnect(){this.port.close()}}e.Protocol=T;class A extends L.IPCClient{constructor(b,C){const P=new T(b);super(P,C);this.protocol=P}dispose(){this.protocol.disconnect()}}e.Client=A}),define(te[74],ne([0,1,17,3,2,36]),function(K,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(A=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var R;(function(n){n.enableDiagnostics=!1,n.records=[];const o=new WeakMap;let s=0;function a(g,I){if(!o.has(g)){const _=String(++s);o.set(g,_)}return o.get(g)}function l(g,I,_,O){if(!n.enableDiagnostics)return;const U=a(g,I);if(O instanceof k.VSBuffer||O instanceof Uint8Array||O instanceof ArrayBuffer||ArrayBuffer.isView(O)){const D=k.VSBuffer.alloc(O.byteLength);D.set(O),n.records.push({timestamp:Date.now(),id:U,label:I,type:_,buff:D})}else n.records.push({timestamp:Date.now(),id:U,label:I,type:_,data:O})}n.traceSocketEvent=l})(R=e.SocketDiagnostics||(e.SocketDiagnostics={}));var b;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(b=e.SocketCloseEventType||(e.SocketCloseEventType={}));let C=null;function P(){return C||(C=k.VSBuffer.alloc(0)),C}class E{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,s){if(o===0)return P();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const I=this._chunks[0];return s&&(this._chunks.shift(),this._totalLength-=o),I}if(this._chunks[0].byteLength>o){const I=this._chunks[0].slice(0,o);return s&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),I}let a=k.VSBuffer.alloc(o),l=0,g=0;for(;o>0;){const I=this._chunks[g];if(I.byteLength>o){const _=I.slice(0,o);a.set(_,l),l+=o,s&&(this._chunks[g]=I.slice(o),this._totalLength-=o),o-=o}else a.set(I,l),l+=I.byteLength,s?(this._chunks.shift(),this._totalLength-=I.byteLength):g++,o-=I.byteLength}return a}}e.ChunkStream=E;var f;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume"})(f||(f={}));function p(n){switch(n){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var h;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(h=e.ProtocolConstants||(e.ProtocolConstants={}));class u{constructor(o,s,a,l){this.type=o,this.id=s,this.ack=a,this.data=l,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends L.Disposable{constructor(o){super();this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new E,this._register(this._socket.onData(s=>this.acceptChunk(s))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const s=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=s.readUInt32BE(9),this._state.messageType=s.readUInt8(0),this._state.id=s.readUInt32BE(1),this._state.ack=s.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:p(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const a=this._state.messageType,l=this._state.id,g=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",s),this._onMessage.fire(new u(a,l,g,s)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class m{constructor(o){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(o){if(this._isDisposed)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const s=k.VSBuffer.alloc(13);s.writeUInt8(o.type,0),s.writeUInt32BE(o.id,1),s.writeUInt32BE(o.ack,5),s.writeUInt32BE(o.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:p(o.type),id:o.id,ack:o.ack,messageSize:o.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",o.data),this._writeSoon(s,o.data)}_bufferAdd(o,s){const a=this._totalLength===0;return this._data.push(o,s),this._totalLength+=o.byteLength+s.byteLength,a}_bufferTake(){const o=k.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,s){this._bufferAdd(o,s)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const o=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:o.byteLength}),this._socket.write(o)}}class w extends L.Disposable{constructor(o){super();this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new m(this._socket)),this._socketReader=this._register(new v(this._socket)),this._register(this._socketReader.onMessage(s=>{s.type===1&&this._onMessage.fire(s.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new u(1,0,0,o))}}e.Protocol=w;class y extends T.IPCClient{constructor(o,s,a=null){super(o,s,a);this.protocol=o}static fromSocket(o,s){return new y(new w(o),s)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=y;class S{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=S;class d{constructor(o){this.data=o,this.next=null}}class i{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let o=[],s=0,a=this._first;for(;a;)o[s++]=a.data,a=a.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const s=new d(o);if(!this._first){this._first=s,this._last=s;return}this._last.next=s,this._last=s}}class c{constructor(){this.lastRuns=[];const o=Date.now();for(let s=0;s<c._HISTORY_LENGTH;s++)this.lastRuns[s]=o-1e3*s;setInterval(()=>{for(let s=c._HISTORY_LENGTH;s>=1;s--)this.lastRuns[s]=this.lastRuns[s-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return c._INSTANCE||(c._INSTANCE=new c),c._INSTANCE}load(){const o=Date.now(),s=(1+c._HISTORY_LENGTH)*1e3;let a=0;for(let l=0;l<c._HISTORY_LENGTH;l++)o-this.lastRuns[l]<=s&&a++;return 1-a/c._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}c._HISTORY_LENGTH=10,c._INSTANCE=null;class r{constructor(o,s=null,a=c.getInstance()){this._onControlMessage=new S,this.onControlMessage=this._onControlMessage.event,this._onMessage=new S,this.onMessage=this._onMessage.event,this._onDidDispose=new S,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new S,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new S,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=a,this._isReconnecting=!1,this._outgoingUnackMsg=new i,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=o,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(l=>this._onSocketClose.fire(l))),s&&this._socketReader.acceptChunk(s)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,L.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new u(5,0,0,P());this._socketWriter.write(o),this._socketWriter.flush()}sendPause(){const o=new u(7,0,0,P());this._socketWriter.write(o)}sendResume(){const o=new u(8,0,0,P());this._socketWriter.write(o)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,s){this._isReconnecting=!0,this._socketDisposables=(0,L.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=o,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(s)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const o=new u(3,0,this._incomingAckId,P());this._socketWriter.write(o);const s=this._outgoingUnackMsg.toArray();for(let a=0,l=s.length;a<l;a++)this._socketWriter.write(s[a]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const s=this._outgoingUnackMsg.peek();if(s&&s.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(o.type){case 0:break;case 1:{if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const s=Date.now();s-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=s,this._socketWriter.write(new u(6,0,0,P())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data);break}case 2:{this._onControlMessage.fire(o.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const s=this._outgoingUnackMsg.toArray();for(let a=0,l=s.length;a<l;a++)this._socketWriter.write(s[a]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const s=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new u(1,s,this._incomingAckId,o);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(o){const s=new u(2,0,0,o);this._socketWriter.write(s)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const o=this._outgoingUnackMsg.peek(),s=Date.now()-o.writtenTime,a=Date.now()-this._socketReader.lastReadTime,l=Date.now()-this._lastSocketTimeoutTime;if(s>=2e4&&a>=2e4&&l>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const g=Math.max(2e4-s,2e4-a,2e4-l,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},g)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const o=new u(3,0,this._incomingAckId,P());this._socketWriter.write(o)}}e.PersistentProtocol=r}),define(te[118],ne([0,1,75,3,36,117]),function(K,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class A extends L.IPCServer{static getOnDidClientConnect(){const b=t.Event.fromNodeEventEmitter(k.ipcRenderer,"vscode:createMessageChannel",(C,P)=>P);return t.Event.map(b,C=>{const{port1:P,port2:E}=new MessageChannel,p={protocol:new T.Protocol(P),onDidClientDisconnect:t.Event.fromDOMEventEmitter(P,"close")};return k.ipcRenderer.postMessage("vscode:createMessageChannelResult",C,[E]),p})}constructor(){super(A.getOnDidClientConnect())}}e.Server=A}),define(te[119],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OfflineError=e.isOfflineError=void 0;const k="Offline";function t(T){return T instanceof L?!0:T instanceof Error&&T.name===k&&T.message===k}e.isOfflineError=t;class L extends Error{constructor(){super(k);this.name=this.message}}e.OfflineError=L}),define(te[120],ne([0,1,17,9,119]),function(K,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function T(b,C){if(!navigator.onLine)throw new L.OfflineError;b.proxyAuthorization&&(b.headers={...b.headers||{},"Proxy-Authorization":b.proxyAuthorization});const P=new XMLHttpRequest;return new Promise((E,f)=>{P.open(b.type||"GET",b.url||"",!0,b.user,b.password),A(P,b),P.responseType="arraybuffer",P.onerror=p=>f(new Error(P.statusText&&"XHR failed: "+P.statusText||"XHR failed")),P.onload=p=>{E({res:{statusCode:P.status,headers:R(P)},stream:(0,k.bufferToStream)(k.VSBuffer.wrap(new Uint8Array(P.response)))})},P.ontimeout=p=>f(new Error(`XHR timeout: ${b.timeout}ms`)),b.timeout&&(P.timeout=b.timeout),P.send(b.data),C.onCancellationRequested(()=>{P.abort(),f((0,t.canceled)())})})}e.request=T;function A(b,C){if(C.headers){e:for(let P in C.headers){switch(P){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}b.setRequestHeader(P,C.headers[P])}}}function R(b){const C=Object.create(null);for(const P of b.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(P){const E=P.indexOf(":");C[P.substr(0,E).trim().toLowerCase()]=P.substr(E+1).trim()}return C}}),define(te[76],ne([0,1,5,3,2,11]),function(K,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var A;(function(E){E[E.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(A=e.StorageHint||(e.StorageHint={}));function R(E){const f=E;return f?.changed instanceof Map||f?.deleted instanceof Set}e.isStorageItemsChangeEvent=R;var b;(function(E){E[E.None=0]="None",E[E.Initialized=1]="Initialized",E[E.Closed=2]="Closed"})(b||(b={}));class C extends L.Disposable{constructor(f,p=Object.create(null)){super();this.database=f,this.options=p,this._onDidChangeStorage=this._register(new t.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=b.None,this.cache=new Map,this.flushDelayer=new k.ThrottledDelayer(C.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(f=>this.onDidChangeItemsExternal(f)))}onDidChangeItemsExternal(f){f.changed?.forEach((p,h)=>this.accept(h,p)),f.deleted?.forEach(p=>this.accept(p,void 0))}accept(f,p){if(this.state===b.Closed)return;let h=!1;(0,T.isUndefinedOrNull)(p)?h=this.cache.delete(f):this.cache.get(f)!==p&&(this.cache.set(f,p),h=!0),h&&this._onDidChangeStorage.fire(f)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===b.None&&(this.state=b.Initialized,this.options.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(f,p){const h=this.cache.get(f);return(0,T.isUndefinedOrNull)(h)?p:h}getBoolean(f,p){const h=this.get(f);return(0,T.isUndefinedOrNull)(h)?p:h==="true"}getNumber(f,p){const h=this.get(f);return(0,T.isUndefinedOrNull)(h)?p:parseInt(h,10)}async set(f,p){if(this.state===b.Closed)return;if((0,T.isUndefinedOrNull)(p))return this.delete(f);const h=String(p);if(this.cache.get(f)!==h)return this.cache.set(f,h),this.pendingInserts.set(f,h),this.pendingDeletes.delete(f),this._onDidChangeStorage.fire(f),this.doFlush()}async delete(f){if(!(this.state===b.Closed||!this.cache.delete(f)))return this.pendingDeletes.has(f)||this.pendingDeletes.add(f),this.pendingInserts.delete(f),this._onDidChangeStorage.fire(f),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=b.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const f={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(f).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(f){if(!!this.hasPending)return this.doFlush(f)}async doFlush(f){return this.flushDelayer.trigger(()=>this.flushPending(),f)}async whenFlushed(){if(!!this.hasPending)return new Promise(f=>this.whenFlushedCallbacks.push(f))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=C,C.DEFAULT_FLUSH_DELAY=100;class P{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(f){f.insert&&f.insert.forEach((p,h)=>this.items.set(h,p)),f.delete&&f.delete.forEach(p=>this.items.delete(p))}async close(){}}e.InMemoryStorageDatabase=P}),define(te[121],ne([12,13]),function(K,e){return K.create("vs/base/common/date",e)}),define(te[57],ne([0,1,121]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,L=t*60,T=L*24,A=T*7,R=T*30,b=T*365;function C(E,f,p){typeof E!="number"&&(E=E.getTime());const h=Math.round((new Date().getTime()-E)/1e3);if(h<-30)return(0,k.localize)(0,null,C(new Date().getTime()+h*1e3,!1));if(h<30)return(0,k.localize)(1,null);let u;return h<t?(u=h,f?u===1?p?(0,k.localize)(2,null,u):(0,k.localize)(3,null,u):p?(0,k.localize)(4,null,u):(0,k.localize)(5,null,u):u===1?p?(0,k.localize)(6,null,u):(0,k.localize)(7,null,u):p?(0,k.localize)(8,null,u):(0,k.localize)(9,null,u)):h<L?(u=Math.floor(h/t),f?u===1?p?(0,k.localize)(10,null,u):(0,k.localize)(11,null,u):p?(0,k.localize)(12,null,u):(0,k.localize)(13,null,u):u===1?p?(0,k.localize)(14,null,u):(0,k.localize)(15,null,u):p?(0,k.localize)(16,null,u):(0,k.localize)(17,null,u)):h<T?(u=Math.floor(h/L),f?u===1?p?(0,k.localize)(18,null,u):(0,k.localize)(19,null,u):p?(0,k.localize)(20,null,u):(0,k.localize)(21,null,u):u===1?p?(0,k.localize)(22,null,u):(0,k.localize)(23,null,u):p?(0,k.localize)(24,null,u):(0,k.localize)(25,null,u)):h<A?(u=Math.floor(h/T),f?u===1?(0,k.localize)(26,null,u):(0,k.localize)(27,null,u):u===1?(0,k.localize)(28,null,u):(0,k.localize)(29,null,u)):h<R?(u=Math.floor(h/A),f?u===1?p?(0,k.localize)(30,null,u):(0,k.localize)(31,null,u):p?(0,k.localize)(32,null,u):(0,k.localize)(33,null,u):u===1?p?(0,k.localize)(34,null,u):(0,k.localize)(35,null,u):p?(0,k.localize)(36,null,u):(0,k.localize)(37,null,u)):h<b?(u=Math.floor(h/R),f?u===1?p?(0,k.localize)(38,null,u):(0,k.localize)(39,null,u):p?(0,k.localize)(40,null,u):(0,k.localize)(41,null,u):u===1?p?(0,k.localize)(42,null,u):(0,k.localize)(43,null,u):p?(0,k.localize)(44,null,u):(0,k.localize)(45,null,u)):(u=Math.floor(h/b),f?u===1?p?(0,k.localize)(46,null,u):(0,k.localize)(47,null,u):p?(0,k.localize)(48,null,u):(0,k.localize)(49,null,u):u===1?p?(0,k.localize)(50,null,u):(0,k.localize)(51,null,u):p?(0,k.localize)(52,null,u):(0,k.localize)(53,null,u))}e.fromNow=C;function P(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=P}),define(te[122],ne([12,13]),function(K,e){return K.create("vs/base/common/errorMessage",e)}),define(te[37],ne([0,1,16,11,122]),function(K,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function T(E,f){return f&&(E.stack||E.stacktrace)?L.localize(0,null,R(E),A(E.stack)||A(E.stacktrace)):R(E)}function A(E){return Array.isArray(E)?E.join(`
`):E}function R(E){return typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?L.localize(1,null,E.message):E.message||L.localize(2,null)}function b(E=null,f=!1){if(!E)return L.localize(3,null);if(Array.isArray(E)){const p=k.coalesce(E),h=b(p[0],f);return p.length>1?L.localize(4,null,h,p.length):h}if(t.isString(E))return E;if(E.detail){const p=E.detail;if(p.error)return T(p.error,f);if(p.exception)return T(p.exception,f)}return E.stack?T(E,f):E.message?E.message:L.localize(5,null)}e.toErrorMessage=b;function C(E){const f=E;return f instanceof Error&&Array.isArray(f.actions)}e.isErrorWithActions=C;function P(E,f=Object.create(null)){const p=new Error(E);return f.actions&&(p.actions=f.actions),p}e.createErrorWithActions=P}),define(te[123],ne([12,13]),function(K,e){return K.create("vs/base/node/processes",e)}),define(te[77],ne([0,1,46,41,18,28,10,4,33,103,11,111,22,123]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return C.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return C.TerminateResponseCode}});function h(i){switch(i){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function u(i,c){if(R.isWindows)try{const r={stdio:["pipe","pipe","ignore"]};c&&(r.cwd=c);const n=k.execFile("taskkill",["/T","/F","/PID",i.pid.toString()],r);return new Promise(o=>{n.once("error",s=>{o({success:!1,error:s})}),n.once("exit",(s,a)=>{o(s===0?{success:!0}:{success:!1,code:s!==null?s:1})})})}catch(r){return Promise.resolve({success:!1,error:r,code:r.status?h(r.status):1})}else if(R.isLinux||R.isMacintosh)try{const r=L.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",K).fsPath;return new Promise(n=>{k.execFile(r,[i.pid.toString()],{encoding:"utf8",shell:!0},(o,s,a)=>{n(o?{success:!1,error:o}:{success:!0})})})}catch(r){return Promise.resolve({success:!1,error:r})}else i.kill("SIGKILL");return Promise.resolve({success:!0})}function v(i){!i||(delete i.DEBUG,R.isMacintosh&&delete i.DYLD_LIBRARY_PATH,R.isLinux&&delete i.LD_PRELOAD)}e.removeDangerousEnvVariables=v;function m(i=b.env){return i.comspec||"cmd.exe"}e.getWindowsShell=m;class w{constructor(c,r,n,o){if(r!==void 0&&n!==void 0&&o!==void 0)this.cmd=c,this.args=r,this.shell=n,this.options=o;else{const s=c;this.cmd=s.command,this.shell=s.isShellCommand,this.args=s.args.slice(0),this.options=s.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const s=Object.create(null);Object.keys(b.env).forEach(a=>{s[a]=b.env[a]}),Object.keys(this.options.env).forEach(a=>{s[a]=this.options.env[a]}),this.options.env=s}}getSanitizedCommand(){let c=this.cmd.toLowerCase();const r=c.lastIndexOf(A.sep);return r!==-1&&(c=c.substring(r+1)),w.WellKnowCommands[c]?c:"other"}start(c){return R.isWindows&&(this.options&&this.options.cwd&&t.isUNC(this.options.cwd)||!this.options&&t.isUNC(b.cwd()))?Promise.reject(new Error(p.localize(0,null))):this.useExec().then(r=>{let n,o;const s=new Promise((a,l)=>{n=a,o=l});if(r){let a=this.cmd;this.args&&(a=a+" "+this.args.join(" ")),this.childProcess=k.exec(a,this.options,(l,g,I)=>{this.childProcess=null;const _=l;_&&_.killed?o({killed:this.terminateRequested,stdout:g.toString(),stderr:I.toString()}):this.handleExec(n,c,l,g,I)})}else{let a=null;const l=g=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(g,n,c,o);const I={terminated:this.terminateRequested};P.isNumber(g)&&(I.cmdCode=g),n(I)};if(this.shell&&R.isWindows){const g=T.deepClone(this.options);g.windowsVerbatimArguments=!0,g.detached=!1;let I=!1,_=!1;const O=[];let U=this.ensureQuotes(this.cmd);O.push(U.value),I=U.quoted,this.args&&this.args.forEach(M=>{U=this.ensureQuotes(M),O.push(U.value),_=_&&U.quoted});const D=["/s","/c"];I?_?D.push('"'+O.join(" ")+'"'):O.length>1?D.push('"'+O[0]+'" '+O.slice(1).join(" ")):D.push('"'+O[0]+'"'):D.push(O.join(" ")),a=k.spawn(m(),D,g)}else this.cmd&&(a=k.spawn(this.cmd,this.args,this.options));a&&(this.childProcess=a,this.childProcessPromise=Promise.resolve(a),this.pidResolve&&(this.pidResolve(P.isNumber(a.pid)?a.pid:-1),this.pidResolve=void 0),a.on("error",g=>{this.childProcess=null,o({terminated:this.terminateRequested,error:g})}),a.pid&&(this.childProcess.on("close",l),this.handleSpawn(a,n,c,o,!0)))}return s})}handleClose(c,r,n,o){}ensureQuotes(c){return w.regexp.test(c)?{value:'"'+c+'"',quoted:!0}:{value:c,quoted:c.length>0&&c[0]==='"'&&c[c.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(c=>c.pid,c=>-1):new Promise(c=>{this.pidResolve=c})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(c=>(this.terminateRequested=!0,u(c,this.options.cwd).then(r=>(r.success&&(this.childProcess=null),r))),c=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(c=>{if(!this.shell||!R.isWindows)return c(!1);const r=k.spawn(m(),["/s","/c"]);r.on("error",n=>c(!0)),r.on("exit",n=>c(!1))})}}e.AbstractProcess=w,w.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},w.regexp=/^[^"].* .*[^"]/;class y extends w{constructor(c,r,n,o){super(c,r,n,o);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(c,r,n,o,s){[o,s].forEach((a,l)=>{const g=new E.LineDecoder;g.write(a).forEach(O=>{r({line:O,source:l===0?0:1})});const _=g.end();_&&r({line:_,source:l===0?0:1})}),c({terminated:this.terminateRequested,error:n})}handleSpawn(c,r,n,o,s){const a=new E.LineDecoder,l=new E.LineDecoder;c.stdout.on("data",g=>{a.write(g).forEach(_=>n({line:_,source:0}))}),c.stderr.on("data",g=>{l.write(g).forEach(_=>n({line:_,source:1}))}),this.stdoutLineDecoder=a,this.stderrLineDecoder=l}handleClose(c,r,n,o){const s=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;s&&n({line:s,source:0});const a=this.stderrLineDecoder?this.stderrLineDecoder.end():null;a&&n({line:a,source:1})}}e.LineProcess=y;function S(i){let c=[],r=!1;const n=function(o){if(r){c.push(o);return}(!i.send(o,a=>{if(a&&console.error(a),r=!1,c.length>0){const l=c.slice(0);c=[],l.forEach(g=>n(g))}})||R.isWindows)&&(r=!0)};return{send:n}}e.createQueuedSender=S;var d;(function(i){async function c(r,n,o){if(A.isAbsolute(r))return r;if(n===void 0&&(n=b.cwd()),A.dirname(r)!=="."||(o===void 0&&P.isString(b.env.PATH)&&(o=b.env.PATH.split(A.delimiter)),o===void 0||o.length===0))return A.join(n,r);async function a(l){if(await f.Promises.exists(l)){let g;try{g=await f.Promises.stat(l)}catch(I){I.message.startsWith("EACCES")&&(g=await f.Promises.lstat(l))}return g?!g.isDirectory():!1}return!1}for(let l of o){let g;if(A.isAbsolute(l)?g=A.join(l,r):g=A.join(n,l,r),await a(g))return g;let I=g+".com";if(await a(I)||(I=g+".exe",await a(I)))return I}return A.join(n,r)}i.findExecutable=c})(d=e.win32||(e.win32={}))}),define(te[124],ne([0,1,34,4,73,77]),function(K,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function A(p,h){return p===1?t.isWindows?E():T.getWindowsShell(h):C(p,h)}e.getSystemShell=A;function R(p,h){return p===1?t.isWindows?f(h):T.getWindowsShell(h):C(p,h)}e.getSystemShellSync=R;let b=null;function C(p,h){if(t.isLinux&&p===2||t.isMacintosh&&p===3)return"/bin/bash";if(!b){let u;if(t.isWindows)u="/bin/bash";else{if(u=h.SHELL,!u)try{u=(0,k.userInfo)().shell}catch{}u||(u="sh"),u==="/bin/false"&&(u="/bin/bash")}b=u}return b}let P=null;async function E(){return P||(P=(await(0,L.getFirstAvailablePowerShellInstallation)()).exePath),P}function f(p){if(P)return P;const h=t.isWindows&&parseFloat((0,k.release)())>=10,u=p.hasOwnProperty("PROCESSOR_ARCHITEW6432"),v=`${p.windir}\\${u?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return h?v:T.getWindowsShell(p)}}),define(te[58],ne([0,1,46,5,17,25,107,9,3,2,28,77,36]),function(K,e,k,t,L,T,A,R,b,C,P,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class p extends f.ChannelServer{constructor(v){super({send:m=>{try{process.send&&process.send(m.buffer.toString("base64"))}catch{}},onMessage:b.Event.fromNodeEventEmitter(process,"message",m=>L.VSBuffer.wrap(Buffer.from(m,"base64")))},v);process.once("disconnect",()=>this.dispose())}}e.Server=p;class h{constructor(v,m){this.modulePath=v,this.options=m,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new b.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const w=m&&m.timeout?m.timeout:6e4;this.disposeDelayer=new t.Delayer(w),this.child=null,this._client=null}getChannel(v){const m=this;return{call(w,y,S){return m.requestPromise(v,w,y,S)},listen(w,y){return m.requestEvent(v,w,y)}}}requestPromise(v,m,w,y=T.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(y.isCancellationRequested)return Promise.reject(R.canceled());this.disposeDelayer.cancel();const S=this.getCachedChannel(v),d=(0,t.createCancelablePromise)(r=>S.call(m,w,r)),i=y.onCancellationRequested(()=>d.cancel()),c=(0,C.toDisposable)(()=>d.cancel());return this.activeRequests.add(c),d.finally(()=>{i.dispose(),this.activeRequests.delete(c),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),d}requestEvent(v,m,w){if(!this.disposeDelayer)return b.Event.None;this.disposeDelayer.cancel();let y;const S=new b.Emitter({onFirstListenerAdd:()=>{y=this.getCachedChannel(v).listen(m,w)(S.fire,S),this.activeRequests.add(y)},onLastListenerRemove:()=>{this.activeRequests.delete(y),y.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return S.event}get client(){if(!this._client){const v=this.options&&this.options.args?this.options.args:[],m=Object.create(null);m.env={...(0,P.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(m.env={...m.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(m.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n))),(0,E.removeDangerousEnvVariables)(m.env),this.child=(0,k.fork)(this.modulePath,v,m);const w=new b.Emitter;b.Event.fromNodeEventEmitter(this.child,"message",n=>n)(n=>{if((0,A.isRemoteConsoleLog)(n)){(0,A.log)(n,`IPC Library: ${this.options.serverName}`);return}w.fire(L.VSBuffer.wrap(Buffer.from(n,"base64")))});const S=this.options.useQueue?(0,E.createQueuedSender)(this.child):this.child,d=n=>this.child&&this.child.connected&&S.send(n.buffer.toString("base64")),i=w.event,c={send:d,onMessage:i};this._client=new f.ChannelClient(c);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",n=>console.warn('IPC "'+this.options.serverName+'" errored with '+n)),this.child.on("exit",(n,o)=>{process.removeListener("exit",r),this.activeRequests.forEach(s=>(0,C.dispose)(s)),this.activeRequests.clear(),n!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+n+" and signal "+o),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:n,signal:o})})}return this._client}getCachedChannel(v){let m=this.channels.get(v);return m||(m=this.client.getChannel(v),this.channels.set(v,m)),m}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=h}),define(te[125],ne([12,13]),function(K,e){return K.create("vs/base/node/zip",e)}),define(te[126],ne([12,13]),function(K,e){return K.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[127],ne([12,13]),function(K,e){return K.create("vs/platform/environment/node/argv",e)}),define(te[128],ne([12,13]),function(K,e){return K.create("vs/platform/environment/node/argvHelper",e)}),define(te[129],ne([12,13]),function(K,e){return K.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(te[130],ne([12,13]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[131],ne([12,13]),function(K,e){return K.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(te[132],ne([12,13]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(te[133],ne([12,13]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(te[134],ne([12,13]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(te[135],ne([12,13]),function(K,e){return K.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[136],ne([12,13]),function(K,e){return K.create("vs/platform/files/common/fileService",e)}),define(te[137],ne([12,13]),function(K,e){return K.create("vs/platform/files/common/files",e)}),define(te[138],ne([12,13]),function(K,e){return K.create("vs/platform/files/common/io",e)}),define(te[139],ne([12,13]),function(K,e){return K.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[140],ne([12,13]),function(K,e){return K.create("vs/platform/request/common/request",e)}),define(te[141],ne([12,13]),function(K,e){return K.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[142],ne([12,13]),function(K,e){return K.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(te[143],ne([12,13]),function(K,e){return K.create("vs/platform/terminal/node/shellEnv",e)}),define(te[144],ne([12,13]),function(K,e){return K.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(te[145],ne([12,13]),function(K,e){return K.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(te[146],ne([12,13]),function(K,e){return K.create("vs/platform/userDataSync/common/settingsSync",e)}),define(te[147],ne([12,13]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(te[148],ne([12,13]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataSync",e)}),define(te[149],ne([12,13]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(te[150],ne([0,1,4]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentFilterProvider=e.Filters=e.TargetPopulation=e.ASSIGNMENT_REFETCH_INTERVAL=e.ASSIGNMENT_STORAGE_KEY=void 0,e.ASSIGNMENT_STORAGE_KEY="VSCode.ABExp.FeatureData",e.ASSIGNMENT_REFETCH_INTERVAL=0;var t;(function(A){A.Team="team",A.Internal="internal",A.Insiders="insider",A.Public="public"})(t=e.TargetPopulation||(e.TargetPopulation={}));var L;(function(A){A.Market="X-MSEdge-Market",A.CorpNet="X-FD-Corpnet",A.ApplicationVersion="X-VSCode-AppVersion",A.Build="X-VSCode-Build",A.ClientId="X-MSEdge-ClientId",A.ExtensionName="X-VSCode-ExtensionName",A.Language="X-VSCode-Language",A.TargetPopulation="X-VSCode-TargetPopulation"})(L=e.Filters||(e.Filters={}));class T{constructor(R,b,C,P){this.version=R,this.appName=b,this.machineId=C,this.targetPopulation=P}getFilterValue(R){switch(R){case L.ApplicationVersion:return this.version;case L.Build:return this.appName;case L.ClientId:return this.machineId;case L.Language:return k.language;case L.ExtensionName:return"vscode-core";case L.TargetPopulation:return this.targetPopulation;default:return""}}getFilters(){let R=new Map,b=Object.values(L);for(let C of b)R.set(C,this.getFilterValue(C));return R}}e.AssignmentFilterProvider=T}),define(te[78],ne([0,1,57,54,18,10,33,20,7]),function(K,e,k,t,L,T,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class C{constructor(u,v,m){this._args=u,this.paths=v,this.productService=m}get appRoot(){return(0,T.dirname)(L.FileAccess.asFileUri("",K).fsPath)}get userHome(){return b.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return b.URI.file((0,T.join)(this.userDataPath,"User"))}get tmpDir(){return b.URI.file(this.paths.tmpDir)}get cacheHome(){return b.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,R.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const u=(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,T.join)(this.userDataPath,"logs",u)}return this.args.logsPath}get userDataSyncLogResource(){return b.URI.file((0,T.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(b.URI.file((0,T.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return b.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return b.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const u=A.env.VSCODE_PORTABLE;return u?b.URI.file((0,T.join)(u,"argv.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,R.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return b.URI.file((0,T.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,T.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const u=this.args["builtin-extensions-dir"];return u?(0,T.resolve)(u):(0,T.normalize)((0,T.join)(L.FileAccess.asFileUri("",K).fsPath,"..","extensions"))}get extensionsDownloadPath(){const u=this.args["extensions-download-dir"];return u?(0,T.resolve)(u):(0,T.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const u=this.args["extensions-dir"];if(u)return(0,T.resolve)(u);const v=A.env.VSCODE_EXTENSIONS;if(v)return v;const m=A.env.VSCODE_PORTABLE;return m?(0,T.join)(m,"extensions"):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const u=this.args.extensionDevelopmentPath;if(Array.isArray(u))return u.map(v=>/^[^:/?#]+?:\/\//.test(v)?b.URI.parse(v):b.URI.file((0,T.normalize)(v)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(u=>u==="ui"||u==="workspace"||u==="web"?u:"workspace")}get extensionTestsLocationURI(){const u=this.args.extensionTestsPath;if(u)return/^[^:/?#]+?:\/\//.test(u)?b.URI.parse(u):b.URI.file((0,T.normalize)(u))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const u=this.args["disable-extension"];if(u){if(typeof u=="string")return[u];if(Array.isArray(u)&&u.length>0)return u}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,R.joinPath)(b.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return b.URI.file((0,T.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([t.memoize],C.prototype,"appRoot",null),he([t.memoize],C.prototype,"userHome",null),he([t.memoize],C.prototype,"userDataPath",null),he([t.memoize],C.prototype,"appSettingsHome",null),he([t.memoize],C.prototype,"tmpDir",null),he([t.memoize],C.prototype,"cacheHome",null),he([t.memoize],C.prototype,"userRoamingDataHome",null),he([t.memoize],C.prototype,"settingsResource",null),he([t.memoize],C.prototype,"userDataSyncHome",null),he([t.memoize],C.prototype,"userDataSyncLogResource",null),he([t.memoize],C.prototype,"sync",null),he([t.memoize],C.prototype,"machineSettingsResource",null),he([t.memoize],C.prototype,"globalStorageHome",null),he([t.memoize],C.prototype,"workspaceStorageHome",null),he([t.memoize],C.prototype,"keybindingsResource",null),he([t.memoize],C.prototype,"keyboardLayoutResource",null),he([t.memoize],C.prototype,"argvResource",null),he([t.memoize],C.prototype,"snippetsHome",null),he([t.memoize],C.prototype,"isExtensionDevelopment",null),he([t.memoize],C.prototype,"untitledWorkspacesHome",null),he([t.memoize],C.prototype,"installSourcePath",null),he([t.memoize],C.prototype,"builtinExtensionsPath",null),he([t.memoize],C.prototype,"extensionsPath",null),he([t.memoize],C.prototype,"extensionDevelopmentLocationURI",null),he([t.memoize],C.prototype,"extensionDevelopmentKind",null),he([t.memoize],C.prototype,"extensionTestsLocationURI",null),he([t.memoize],C.prototype,"debugExtensionHost",null),he([t.memoize],C.prototype,"serviceMachineIdResource",null),he([t.memoize],C.prototype,"telemetryLogResource",null),he([t.memoize],C.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=C;function P(h,u){return p(h["inspect-extensions"],h["inspect-brk-extensions"],5870,u,h.debugId,h.extensionEnvironment)}e.parseExtensionHostPort=P;function E(h,u){return p(h["inspect-search"],h["inspect-brk-search"],5876,u,h.extensionEnvironment)}e.parseSearchPort=E;function f(h,u){return p(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,u,h.extensionEnvironment)}e.parsePtyHostPort=f;function p(h,u,v,m,w,y){const d=Number(u||h)||(m?null:v),i=d?Boolean(!!u):!1;let c;if(y)try{c=JSON.parse(y)}catch{}return{port:d,break:i,debugId:w,env:c}}}),define(te[151],ne([0,1,254,4,127]),function(K,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const T={o:(0,L.localize)(0,null),e:(0,L.localize)(1,null),t:(0,L.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,L.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,L.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,L.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,L.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,L.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,L.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,L.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,L.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,L.localize)(11,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,L.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,L.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,L.localize)(14,null)},category:{type:"string",cat:"e",description:(0,L.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,L.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,L.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,L.localize)(18,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"ext-id",description:(0,L.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,L.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,L.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,L.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,L.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,L.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,L.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,L.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,L.localize)(27,null),args:["on | off"]},"inspect-extensions":{type:"string",deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,L.localize)(28,null)},"inspect-brk-extensions":{type:"string",deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,L.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,L.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,L.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,L.localize)(32,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:["debugSearch"]},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"]},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{},onDeprecatedOption:()=>{}};function R(h,u,v=A){const m={},w=[],y=[];for(let c in u){const r=u[c];r.alias&&(m[c]=r.alias),r.type==="string"||r.type==="string[]"?(w.push(c),r.deprecates&&w.push(...r.deprecates)):r.type==="boolean"&&(y.push(c),r.deprecates&&y.push(...r.deprecates))}const S=k(h,{string:w,boolean:y,alias:m}),d={},i=S;d._=S._.map(c=>String(c)).filter(c=>c.length>0),delete i._;for(let c in u){const r=u[c];r.alias&&delete i[r.alias];let n=i[c];if(r.deprecates)for(const o of r.deprecates)i.hasOwnProperty(o)&&(n||(n=i[o],n&&v.onDeprecatedOption(o,r.deprecationMessage||(0,L.localize)(33,null))),delete i[o]);typeof n!="undefined"&&(r.type==="string[]"?n&&!Array.isArray(n)&&(n=[n]):r.type==="string"&&Array.isArray(n)&&(n=n.pop(),v.onMultipleValues(c,n)),d[c]=n,r.deprecationMessage&&v.onDeprecatedOption(c,r.deprecationMessage)),delete i[c]}for(let c in i)v.onUnknownOption(c);return d}e.parseArgs=R;function b(h,u){let v="";return u.args&&(Array.isArray(u.args)?v=` <${u.args.join("> <")}>`:v=` <${u.args}>`),u.alias?`-${u.alias} --${h}${v}`:`--${h}${v}`}function C(h,u){let v=0,m=[];for(const d in h){const i=h[d],c=b(d,i);v=Math.max(v,c.length),m.push([c,i.description])}let w=v+2+1;if(u-w<25)return m.reduce((d,i)=>d.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);let y=u-w-1,S=[];for(const d of m){let i=d[0],c=E(d[1],y),r=P(w-i.length-2);S.push("  "+i+r+c[0]);for(let n=1;n<c.length;n++)S.push(P(w)+c[n])}return S}e.formatOptions=C;function P(h){return" ".repeat(h)}function E(h,u){let v=[];for(;h.length;){let m=h.length<u?h.length:h.lastIndexOf(" ",u),w=h.slice(0,m).trim();h=h.slice(m),v.push(w)}return v}function f(h,u,v,m,w){const y=process.stdout.isTTY&&process.stdout.columns||80,S=w?.noInputFiles!==!0?`[${(0,L.localize)(34,null)}...]`:"",d=[`${h} ${v}`];d.push(""),d.push(`${(0,L.localize)(35,null)}: ${u} [${(0,L.localize)(36,null)}]${S}`),d.push(""),w?.noPipe!==!0&&(t.isWindows?d.push((0,L.localize)(37,null,u)):d.push((0,L.localize)(38,null,u)),d.push(""));const i={};for(const c in m){const r=m[c];if(r.description&&r.cat){let n=i[r.cat];n||(i[r.cat]=n={}),n[c]=r}}for(let c in i){const r=c;let n=i[r];n&&(d.push(T[r]),d.push(...C(n,y)),d.push(""))}return d.join(`
`)}e.buildHelpMessage=f;function p(h,u){return`${h||(0,L.localize)(39,null)}
${u||(0,L.localize)(40,null)}
${process.arch}`}e.buildVersionMessage=p}),define(te[152],ne([0,1,255,128,151]),function(K,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const T=2048;function A(f,p){const h={onUnknownOption:v=>{console.warn((0,t.localize)(0,null,v))},onMultipleValues:(v,m)=>{console.warn((0,t.localize)(1,null,v,m))},onDeprecatedOption:(v,m)=>{console.warn((0,t.localize)(2,null,v,m))}},u=(0,L.parseArgs)(f,L.OPTIONS,p?h:void 0);return u.goto&&u._.forEach(v=>k(/^(\w:)?[^:]+(:\d*){0,2}$/.test(v),(0,t.localize)(3,null))),u["max-memory"]&&k(parseInt(u["max-memory"])>=T,`The max-memory argument cannot be specified lower than ${T} MB.`),u}function R(f){const p=f.findIndex(h=>!/^-/.test(h));if(p>-1)return[...f.slice(0,p),...f.slice(p+1)]}function b(f){let[,...p]=f;process.env.VSCODE_DEV&&(p=R(p)||[]);const h=!E(process.env);return A(p,h)}e.parseMainProcessArgv=b;function C(f){const[,,...p]=f;return A(p,!0)}e.parseCLIProcessArgv=C;function P(f,...p){const h=f.indexOf("--");return h===-1?f.push(...p):f.splice(h,0,...p),f}e.addArg=P;function E(f){return f.VSCODE_CLI==="1"}e.isLaunchedFromCli=E}),function(){"use strict";function K(e,k,t,L){function T(R){const b=A(R),C=[b];return e.isAbsolute(b)||C.unshift(L),e.resolve(...C)}function A(R){const b=process.env.VSCODE_PORTABLE;if(b)return e.join(b,"user-data");let C=process.env.VSCODE_APPDATA;if(C)return e.join(C,t);const P=R["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(C=process.env.APPDATA,!C){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");C=e.join(E,"AppData","Roaming")}break;case"darwin":C=e.join(k.homedir(),"Library","Application Support");break;case"linux":C=process.env.XDG_CONFIG_HOME||e.join(k.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(C,t)}return{getUserDataPath:T}}if(typeof define=="function")define(te[153],ne([0,256,34,18,20,33]),function(e,k,t,L,T,A){const R=T.dirname(L.FileAccess.asFileUri("",e)),b=e.__$__nodeRequire(T.joinPath(R,"package.json").fsPath);return K(k,t,b.name,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),k=require("path"),t=require("os");module.exports=K(k,t,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[154],ne([0,1,34,78,153]),function(K,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class T extends t.AbstractNativeEnvironmentService{constructor(R,b){super(R,{homeDir:(0,k.homedir)(),tmpDir:(0,k.tmpdir)(),userDataDir:(0,L.getUserDataPath)(R)},b)}}e.NativeEnvironmentService=T}),define(te[155],ne([0,1,7]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const t=/^([^@:]+@)?([^:]+):/,L=/^([^@:]+@)?([^:]+):(.+)$/,T=/^([^@]+@)?([^:]+)(:\d+)?$/,A=/([^@:.]+\.[^@:.]+)(:\d+)?$/,R=/^\s*url\s*=\s*(.+\S)\s*$/mg,b=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function C(v){const m=v.match(A);return m?m[1]:null}function P(v){if(v.indexOf("://")===-1){const m=v.match(t);return m?C(m[2]):null}try{const m=k.URI.parse(v);if(m.authority)return C(m.authority)}catch{}return null}function E(v,m){const w=new Set;let y;for(;y=R.exec(v);){const d=P(y[1]);d&&w.add(d)}const S=new Set(m);return Array.from(w).map(d=>S.has(d)?d:d.replace(b,"a"))}e.getDomainsOfRemotes=E;function f(v){const m=v.match(T);return m?m[2]:null}function p(v,m,w){return v&&m?(w&&m.endsWith(".git")&&(m=m.substr(0,m.length-4)),m.indexOf("/")===0?`${v}${m}`:`${v}/${m}`):null}function h(v,m){if(v.indexOf("://")===-1){const w=v.match(L);if(w)return p(w[2],w[3],m)}try{const w=k.URI.parse(v);if(w.authority)return p(f(w.authority),w.path,m)}catch{}return null}function u(v,m=!1){const w=[];let y;for(;y=R.exec(v);){const S=h(y[1],m);S&&w.push(S)}return w}e.getRemotes=u}),define(te[156],ne([0,1,28]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const t=/^%([\w\d.-]+)%$/i;function L(T,A){const R=b=>{if(typeof b!="string")return;const C=t.exec(b);if(!C)return;const P=A[C[1]]??b;return typeof P=="string"?P:typeof P.message=="string"?P.message:b};return(0,k.cloneAndChange)(T,R)}e.localizeManifest=L}),define(te[157],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class k{constructor(T){this.channel=T}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(T,A,R,b){return this.channel.call("promptImportantExtensionsInstallNotification",[T,A,R,b])}promptWorkspaceRecommendations(T){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=k;class t{constructor(T){this.service=T}listen(T,A){throw new Error(`Event not found: ${A}`)}call(T,A,R){switch(A){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(R[0],R[1],R[2],R[3])}throw new Error(`Call not found: ${A}`)}}e.ExtensionRecommendationNotificationServiceChannel=t}),define(te[79],ne([0,1,135]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const t=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,L=/^-(\d{4})(\d{2})(\d{2})$/;function T(f){return f=f.trim(),f==="*"||t.test(f)}e.isValidVersionStr=T;function A(f){if(!T(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let p=f.match(t);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=A;function R(f){if(!f)return null;let p=f.majorBase,h=f.majorMustEqual,u=f.minorBase,v=f.minorMustEqual,m=f.patchBase,w=f.patchMustEqual;f.hasCaret&&(p===0||(v=!1),w=!1);let y=0;if(f.preRelease){const S=L.exec(f.preRelease);if(S){const[,d,i,c]=S;y=Date.UTC(Number(d),Number(i)-1,Number(c))}}return{majorBase:p,majorMustEqual:h,minorBase:u,minorMustEqual:v,patchBase:m,patchMustEqual:w,isMinimum:f.hasGreaterEquals,notBefore:y}}e.normalizeVersion=R;function b(f,p,h){let u;typeof f=="string"?u=R(A(f)):u=f;let v;p instanceof Date?v=p.getTime():typeof p=="string"&&(v=new Date(p).getTime());let m;if(typeof h=="string"?m=R(A(h)):m=h,!u||!m)return!1;let w=u.majorBase,y=u.minorBase,S=u.patchBase,d=m.majorBase,i=m.minorBase,c=m.patchBase,r=m.notBefore,n=m.majorMustEqual,o=m.minorMustEqual,s=m.patchMustEqual;return m.isMinimum?w>d?!0:w<d?!1:y>i?!0:y<i||v&&v<r?!1:S>=c:(w===1&&d===0&&(!n||!o||!s)&&(d=1,i=0,c=0,n=!0,o=!1,s=!1),w<d?!1:w>d?!n:y<i?!1:y>i?!o:S<c?!1:S>c?!s:!(v&&v<r))}e.isValidVersion=b;function C(f,p,h,u){return h.isBuiltin||typeof h.main=="undefined"?!0:E(f,p,h.engines.vscode,u)}e.isValidExtensionVersion=C;function P(f,p,h){return f==="*"||E(p,h,f)}e.isEngineValid=P;function E(f,p,h,u=[]){let v=R(A(h));if(!v)return u.push(k.localize(0,null,h)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return u.push(k.localize(1,null,h)),!1}else if(!v.majorMustEqual)return u.push(k.localize(2,null,h)),!1;return b(f,p,v)?!0:(u.push(k.localize(3,null,f,h)),!1)}}),define(te[47],ne([0,1,17,29]),function(K,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function L(T,A,R){let b=R&&R.get("storage.serviceMachineId",0)||null;if(b)return b;try{const P=(await A.readFile(T.serviceMachineIdResource)).value.toString();b=(0,t.isUUID)(P)?P:null}catch{b=null}if(!b){b=(0,t.generateUuid)();try{await A.writeFile(T.serviceMachineIdResource,k.VSBuffer.fromString(b))}catch{}}return R&&R.store("storage.serviceMachineId",b,0,1),b}e.getServiceMachineId=L}),define(te[51],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class k{constructor(L,T=[],A=!1){this.ctor=L,this.staticArguments=T,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=k}),define(te[80],ne([0,1,51]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function L(A,R,b){R instanceof k.SyncDescriptor||(R=new k.SyncDescriptor(R,[],b)),t.push([A,R])}e.registerSingleton=L;function T(){return t}e.getSingletonServiceDescriptors=T}),define(te[158],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class k{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=k;class t{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let A of this._nodes.values())A.outgoing.size===0&&T.push(A);return T}insertEdge(T,A){const R=this.lookupOrInsertNode(T),b=this.lookupOrInsertNode(A);R.outgoing.set(this._hashFn(A),b),b.incoming.set(this._hashFn(T),R)}removeNode(T){const A=this._hashFn(T);this._nodes.delete(A);for(let R of this._nodes.values())R.outgoing.delete(A),R.incoming.delete(A)}lookupOrInsertNode(T){const A=this._hashFn(T);let R=this._nodes.get(A);return R||(R=new k(T),this._nodes.set(A,R)),R}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[A,R]of this._nodes)T.push(`${A}, (incoming)[${[...R.incoming.keys()].join(", ")}], (outgoing)[${[...R.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,A]of this._nodes){const R=new Set([T]),b=this._findCycle(A,R);if(b)return b}}_findCycle(T,A){for(let[R,b]of T.outgoing){if(A.has(R))return[...A,R].join(" -> ");A.add(R);const C=this._findCycle(b,A);if(C)return C;A.delete(R)}}}e.Graph=t}),define(te[6],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var k;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function R(b){return b[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=R})(k=e._util||(e._util={})),e.IInstantiationService=L("instantiationService");function t(A,R,b){R[k.DI_TARGET]===R?R[k.DI_DEPENDENCIES].push({id:A,index:b}):(R[k.DI_DEPENDENCIES]=[{id:A,index:b}],R[k.DI_TARGET]=R)}function L(A){if(k.serviceIds.has(A))return k.serviceIds.get(A);const R=function(b,C,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(R,b,P)};return R.toString=()=>A,k.serviceIds.set(A,R),R}e.createDecorator=L;function T(A){return A}e.refineServiceDecorator=T}),define(te[159],ne([0,1,6]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,k.createDecorator)("checksumService")}),define(te[19],ne([0,1,11,7,6]),function(K,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,L.createDecorator)("configurationService");function T(v){return v&&typeof v=="object"&&(!v.overrideIdentifier||typeof v.overrideIdentifier=="string")&&(!v.resource||v.resource instanceof t.URI)}e.isConfigurationOverrides=T;function A(v){return v&&typeof v=="object"&&(!v.overrideIdentifiers||k.isArray(v.overrideIdentifiers))&&!v.overrideIdentifier&&(!v.resource||v.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=A;var R;(function(v){v[v.USER=1]="USER",v[v.USER_LOCAL=2]="USER_LOCAL",v[v.USER_REMOTE=3]="USER_REMOTE",v[v.WORKSPACE=4]="WORKSPACE",v[v.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",v[v.DEFAULT=6]="DEFAULT",v[v.MEMORY=7]="MEMORY"})(R=e.ConfigurationTarget||(e.ConfigurationTarget={}));function b(v){switch(v){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=b;function C(v,m){const w=Object.create(null);for(let y in v)P(w,y,v[y],m);return w}e.toValuesTree=C;function P(v,m,w,y){const S=m.split("."),d=S.pop();let i=v;for(let c=0;c<S.length;c++){let r=S[c],n=i[r];switch(typeof n){case"undefined":n=i[r]=Object.create(null);break;case"object":break;default:y(`Ignoring ${m} as ${S.slice(0,c+1).join(".")} is ${JSON.stringify(n)}`);return}i=n}if(typeof i=="object"&&i!==null)try{i[d]=w}catch{y(`Ignoring ${m} as ${S.join(".")} is ${JSON.stringify(i)}`)}else y(`Ignoring ${m} as ${S.join(".")} is ${JSON.stringify(i)}`)}e.addToValueTree=P;function E(v,m){const w=m.split(".");f(v,w)}e.removeFromValueTree=E;function f(v,m){const w=m.shift();if(m.length===0){delete v[w];return}if(Object.keys(v).indexOf(w)!==-1){const y=v[w];typeof y=="object"&&!Array.isArray(y)&&(f(y,m),Object.keys(y).length===0&&delete v[w])}}function p(v,m,w){function y(i,c){let r=i;for(const n of c){if(typeof r!="object"||r===null)return;r=r[n]}return r}const S=m.split("."),d=y(v,S);return typeof d=="undefined"?w:d}e.getConfigurationValue=p;function h(v,m,w){Object.keys(m).forEach(y=>{y!=="__proto__"&&(y in v?k.isObject(v[y])&&k.isObject(m[y])?h(v[y],m[y],w):w&&(v[y]=m[y]):v[y]=m[y])})}e.merge=h;function u(v,m,w){const y=v.inspect(m),S=v.inspect(w);return typeof y.userValue!="undefined"||typeof y.workspaceValue!="undefined"||typeof y.workspaceFolderValue!="undefined"?y.value:typeof S.userValue!="undefined"||typeof S.workspaceValue!="undefined"||typeof S.workspaceFolderValue!="undefined"?S.value:y.defaultValue}e.getMigratedSettingValue=u}),define(te[160],ne([0,1,4,26,6]),function(K,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",k.isMacintosh),T.set("isLinux",k.isLinux),T.set("isWindows",k.isWindows),T.set("isWeb",k.isWeb),T.set("isMacNative",k.isMacintosh&&!k.isWeb),T.set("isEdge",k.isEdge),T.set("isFirefox",k.isFirefox),T.set("isChrome",k.isChrome),T.set("isSafari",k.isSafari);const A=Object.prototype.hasOwnProperty;var R;(function(U){U[U.False=0]="False",U[U.True=1]="True",U[U.Defined=2]="Defined",U[U.Not=3]="Not",U[U.Equals=4]="Equals",U[U.NotEquals=5]="NotEquals",U[U.And=6]="And",U[U.Regex=7]="Regex",U[U.NotRegex=8]="NotRegex",U[U.Or=9]="Or",U[U.In=10]="In",U[U.NotIn=11]="NotIn",U[U.Greater=12]="Greater",U[U.GreaterEquals=13]="GreaterEquals",U[U.Smaller=14]="Smaller",U[U.SmallerEquals=15]="SmallerEquals"})(R=e.ContextKeyExprType||(e.ContextKeyExprType={}));class b{static false(){return E.INSTANCE}static true(){return f.INSTANCE}static has(D){return p.create(D)}static equals(D,M){return h.create(D,M)}static notEquals(D,M){return m.create(D,M)}static regex(D,M){return r.create(D,M)}static in(D,M){return u.create(D,M)}static not(D){return w.create(D)}static and(...D){return s.create(D,null)}static or(...D){return a.create(D,null,!0)}static greater(D,M){return S.create(D,M)}static greaterEquals(D,M){return d.create(D,M)}static smaller(D,M){return i.create(D,M)}static smallerEquals(D,M){return c.create(D,M)}static deserialize(D,M=!1){if(!!D)return this._deserializeOrExpression(D,M)}static _deserializeOrExpression(D,M){let N=D.split("||");return a.create(N.map(x=>this._deserializeAndExpression(x,M)),null,!0)}static _deserializeAndExpression(D,M){let N=D.split("&&");return s.create(N.map(x=>this._deserializeOne(x,M)),null)}static _deserializeOne(D,M){if(D=D.trim(),D.indexOf("!=")>=0){let N=D.split("!=");return m.create(N[0].trim(),this._deserializeValue(N[1],M))}if(D.indexOf("==")>=0){let N=D.split("==");return h.create(N[0].trim(),this._deserializeValue(N[1],M))}if(D.indexOf("=~")>=0){let N=D.split("=~");return r.create(N[0].trim(),this._deserializeRegexValue(N[1],M))}if(D.indexOf(" in ")>=0){let N=D.split(" in ");return u.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(D)){const N=D.split(">=");return d.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(D)){const N=D.split(">");return S.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(D)){const N=D.split("<=");return c.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(D)){const N=D.split("<");return i.create(N[0].trim(),N[1].trim())}return/^\!\s*/.test(D)?w.create(D.substr(1).trim()):p.create(D)}static _deserializeValue(D,M){if(D=D.trim(),D==="true")return!0;if(D==="false")return!1;let N=/^'([^']*)'$/.exec(D);return N?N[1].trim():D}static _deserializeRegexValue(D,M){if((0,t.isFalsyOrWhitespace)(D)){if(M)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let N=D.indexOf("/"),x=D.lastIndexOf("/");if(N===x||N<0){if(M)throw new Error(`bad regexp-value '${D}', missing /-enclosure`);return console.warn(`bad regexp-value '${D}', missing /-enclosure`),null}let Q=D.slice(N+1,x),W=D[x+1]==="i"?"i":"";try{return new RegExp(Q,W)}catch(ie){if(M)throw new Error(`bad regexp-value '${D}', parse error: ${ie}`);return console.warn(`bad regexp-value '${D}', parse error: ${ie}`),null}}}e.ContextKeyExpr=b;function C(U,D){const M=U?U.substituteConstants():void 0,N=D?D.substituteConstants():void 0;return!M&&!N?!0:!M||!N?!1:M.equals(N)}e.expressionsAreEqualWithConstantSubstitution=C;function P(U,D){return U.cmp(D)}class E{constructor(){this.type=0}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!1}serialize(){return"false"}keys(){return[]}map(D){return this}negate(){return f.INSTANCE}}e.ContextKeyFalseExpr=E,E.INSTANCE=new E;class f{constructor(){this.type=1}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!0}serialize(){return"true"}keys(){return[]}map(D){return this}negate(){return E.INSTANCE}}e.ContextKeyTrueExpr=f,f.INSTANCE=new f;class p{constructor(D,M){this.key=D,this.negated=M,this.type=2}static create(D,M=null){const N=T.get(D);return typeof N=="boolean"?N?f.INSTANCE:E.INSTANCE:new p(D,M)}cmp(D){return D.type!==this.type?this.type-D.type:g(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=T.get(this.key);return typeof D=="boolean"?D?f.INSTANCE:E.INSTANCE:this}evaluate(D){return!!D.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(D){return D.mapDefined(this.key)}negate(){return this.negated||(this.negated=w.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=p;class h{constructor(D,M,N){this.key=D,this.value=M,this.negated=N,this.type=4}static create(D,M,N=null){if(typeof M=="boolean")return M?p.create(D,N):w.create(D,N);const x=T.get(D);return typeof x=="boolean"?M===(x?"true":"false")?f.INSTANCE:E.INSTANCE:new h(D,M,N)}cmp(D){return D.type!==this.type?this.type-D.type:I(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){const D=T.get(this.key);if(typeof D=="boolean"){const M=D?"true":"false";return this.value===M?f.INSTANCE:E.INSTANCE}return this}evaluate(D){return D.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(D){return D.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=m.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=h;class u{constructor(D,M){this.key=D,this.valueKey=M,this.type=10,this.negated=null}static create(D,M){return new u(D,M)}cmp(D){return D.type!==this.type?this.type-D.type:I(this.key,this.valueKey,D.key,D.valueKey)}equals(D){return D.type===this.type?this.key===D.key&&this.valueKey===D.valueKey:!1}substituteConstants(){return this}evaluate(D){const M=D.getValue(this.valueKey),N=D.getValue(this.key);return Array.isArray(M)?M.indexOf(N)>=0:typeof N=="string"&&typeof M=="object"&&M!==null?A.call(M,N):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(D){return D.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=v.create(this)),this.negated}}e.ContextKeyInExpr=u;class v{constructor(D){this._actual=D,this.type=11}static create(D){return new v(D)}cmp(D){return D.type!==this.type?this.type-D.type:this._actual.cmp(D._actual)}equals(D){return D.type===this.type?this._actual.equals(D._actual):!1}substituteConstants(){return this}evaluate(D){return!this._actual.evaluate(D)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(D){return new v(this._actual.map(D))}negate(){return this._actual}}e.ContextKeyNotInExpr=v;class m{constructor(D,M,N){this.key=D,this.value=M,this.negated=N,this.type=5}static create(D,M,N=null){if(typeof M=="boolean")return M?w.create(D,N):p.create(D,N);const x=T.get(D);return typeof x=="boolean"?M===(x?"true":"false")?E.INSTANCE:f.INSTANCE:new m(D,M,N)}cmp(D){return D.type!==this.type?this.type-D.type:I(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){const D=T.get(this.key);if(typeof D=="boolean"){const M=D?"true":"false";return this.value===M?E.INSTANCE:f.INSTANCE}return this}evaluate(D){return D.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(D){return D.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=m;class w{constructor(D,M){this.key=D,this.negated=M,this.type=3}static create(D,M=null){const N=T.get(D);return typeof N=="boolean"?N?E.INSTANCE:f.INSTANCE:new w(D,M)}cmp(D){return D.type!==this.type?this.type-D.type:g(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=T.get(this.key);return typeof D=="boolean"?D?E.INSTANCE:f.INSTANCE:this}evaluate(D){return!D.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(D){return D.mapNot(this.key)}negate(){return this.negated||(this.negated=p.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=w;function y(U,D){if(typeof U=="string"){const M=parseFloat(U);isNaN(M)||(U=M)}return typeof U=="string"||typeof U=="number"?D(U):E.INSTANCE}class S{constructor(D,M,N){this.key=D,this.value=M,this.negated=N,this.type=12}static create(D,M,N=null){return y(M,x=>new S(D,x,N))}cmp(D){return D.type!==this.type?this.type-D.type:I(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(D){return D.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=S;class d{constructor(D,M,N){this.key=D,this.value=M,this.negated=N,this.type=13}static create(D,M,N=null){return y(M,x=>new d(D,x,N))}cmp(D){return D.type!==this.type?this.type-D.type:I(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(D){return D.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=d;class i{constructor(D,M,N){this.key=D,this.value=M,this.negated=N,this.type=14}static create(D,M,N=null){return y(M,x=>new i(D,x,N))}cmp(D){return D.type!==this.type?this.type-D.type:I(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(D){return D.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=i;class c{constructor(D,M,N){this.key=D,this.value=M,this.negated=N,this.type=15}static create(D,M,N=null){return y(M,x=>new c(D,x,N))}cmp(D){return D.type!==this.type?this.type-D.type:I(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(D){return D.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=c;class r{constructor(D,M){this.key=D,this.regexp=M,this.type=7,this.negated=null}static create(D,M){return new r(D,M)}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.key<D.key)return-1;if(this.key>D.key)return 1;const M=this.regexp?this.regexp.source:"",N=D.regexp?D.regexp.source:"";return M<N?-1:M>N?1:0}equals(D){if(D.type===this.type){const M=this.regexp?this.regexp.source:"",N=D.regexp?D.regexp.source:"";return this.key===D.key&&M===N}return!1}substituteConstants(){return this}evaluate(D){let M=D.getValue(this.key);return this.regexp?this.regexp.test(M):!1}serialize(){const D=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${D}`}keys(){return[this.key]}map(D){return D.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=n.create(this)),this.negated}}e.ContextKeyRegexExpr=r;class n{constructor(D){this._actual=D,this.type=8}static create(D){return new n(D)}cmp(D){return D.type!==this.type?this.type-D.type:this._actual.cmp(D._actual)}equals(D){return D.type===this.type?this._actual.equals(D._actual):!1}substituteConstants(){return this}evaluate(D){return!this._actual.evaluate(D)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(D){return new n(this._actual.map(D))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;function o(U){let D=null;for(let M=0,N=U.length;M<N;M++){const x=U[M].substituteConstants();if(U[M]!==x&&D===null){D=[];for(let Q=0;Q<M;Q++)D[Q]=U[Q]}D!==null&&(D[M]=x)}return D===null?U:D}class s{constructor(D,M){this.expr=D,this.negated=M,this.type=6}static create(D,M){return s._normalizeArr(D,M)}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let M=0,N=this.expr.length;M<N;M++){const x=P(this.expr[M],D.expr[M]);if(x!==0)return x}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let M=0,N=this.expr.length;M<N;M++)if(!this.expr[M].equals(D.expr[M]))return!1;return!0}return!1}substituteConstants(){const D=o(this.expr);return D===this.expr?this:s.create(D,this.negated)}evaluate(D){for(let M=0,N=this.expr.length;M<N;M++)if(!this.expr[M].evaluate(D))return!1;return!0}static _normalizeArr(D,M){const N=[];let x=!1;for(const Q of D)if(!!Q){if(Q.type===1){x=!0;continue}if(Q.type===0)return E.INSTANCE;if(Q.type===6){N.push(...Q.expr);continue}N.push(Q)}if(N.length===0&&x)return f.INSTANCE;if(N.length!==0){if(N.length===1)return N[0];N.sort(P);for(let Q=1;Q<N.length;Q++)N[Q-1].equals(N[Q])&&(N.splice(Q,1),Q--);if(N.length===1)return N[0];for(;N.length>1;){const Q=N[N.length-1];if(Q.type!==9)break;N.pop();const W=N.pop(),ie=N.length===0,B=a.create(Q.expr.map(j=>s.create([j,W],null)),null,ie);B&&(N.push(B),N.sort(P))}return N.length===1?N[0]:new s(N,M)}}serialize(){return this.expr.map(D=>D.serialize()).join(" && ")}keys(){const D=[];for(let M of this.expr)D.push(...M.keys());return D}map(D){return new s(this.expr.map(M=>M.map(D)),null)}negate(){if(!this.negated){const D=[];for(let M of this.expr)D.push(M.negate());this.negated=a.create(D,this,!0)}return this.negated}}class a{constructor(D,M){this.expr=D,this.negated=M,this.type=9}static create(D,M,N){return a._normalizeArr(D,M,N)}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let M=0,N=this.expr.length;M<N;M++){const x=P(this.expr[M],D.expr[M]);if(x!==0)return x}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let M=0,N=this.expr.length;M<N;M++)if(!this.expr[M].equals(D.expr[M]))return!1;return!0}return!1}substituteConstants(){const D=o(this.expr);return D===this.expr?this:a.create(D,this.negated,!1)}evaluate(D){for(let M=0,N=this.expr.length;M<N;M++)if(this.expr[M].evaluate(D))return!0;return!1}static _normalizeArr(D,M,N){let x=[],Q=!1;if(D){for(let W=0,ie=D.length;W<ie;W++){const B=D[W];if(!!B){if(B.type===0){Q=!0;continue}if(B.type===1)return f.INSTANCE;if(B.type===9){x=x.concat(B.expr);continue}x.push(B)}}if(x.length===0&&Q)return E.INSTANCE;x.sort(P)}if(x.length!==0){if(x.length===1)return x[0];for(let W=1;W<x.length;W++)x[W-1].equals(x[W])&&(x.splice(W,1),W--);if(x.length===1)return x[0];if(N){for(let W=0;W<x.length;W++)for(let ie=W+1;ie<x.length;ie++)_(x[W],x[ie])&&(x.splice(ie,1),ie--);if(x.length===1)return x[0]}return new a(x,M)}}serialize(){return this.expr.map(D=>D.serialize()).join(" || ")}keys(){const D=[];for(let M of this.expr)D.push(...M.keys());return D}map(D){return new a(this.expr.map(M=>M.map(D)),null)}negate(){if(!this.negated){let D=[];for(let M of this.expr)D.push(M.negate());for(;D.length>1;){const M=D.shift(),N=D.shift(),x=[];for(const W of O(M))for(const ie of O(N))x.push(s.create([W,ie],null));const Q=D.length===0;D.unshift(a.create(x,null,Q))}this.negated=D[0]}return this.negated}}class l extends p{constructor(D,M,N){super(D,null);this._defaultValue=M,typeof N=="object"?l._info.push({...N,key:D}):N!==!0&&l._info.push({key:D,description:N,type:M!=null?typeof M:void 0})}static all(){return l._info.values()}bindTo(D){return D.createKey(this.key,this._defaultValue)}getValue(D){return D.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(D){return h.create(this.key,D)}notEqualsTo(D){return m.create(this.key,D)}}e.RawContextKey=l,l._info=[],e.IContextKeyService=(0,L.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function g(U,D){return U<D?-1:U>D?1:0}function I(U,D,M,N){return U<M?-1:U>M?1:D<N?-1:D>N?1:0}function _(U,D){if(D.type===6&&U.type!==9&&U.type!==6){for(const x of D.expr)if(U.equals(x))return!0}const M=U.negate(),N=O(M).concat(O(D));N.sort(P);for(let x=0;x<N.length;x++){const W=N[x].negate();for(let ie=x+1;ie<N.length;ie++){const B=N[ie];if(W.equals(B))return!0}}return!1}e.implies=_;function O(U){return U.type===9?U.expr:[U]}}),define(te[81],ne([0,1,6]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,k.createDecorator)(e.ID);function t(T){return!!T.hostName&&!!T.errorMessage}e.isRemoteDiagnosticError=t;class L{async getPerformanceInfo(A,R){return{}}async getSystemInfo(A,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(A,R){return""}async getWorkspaceFileExtensions(A){return{extensions:[]}}async reportWorkspaceStats(A){}}e.NullDiagnosticsService=L}),define(te[82],ne([0,1,6]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,k.createDecorator)("downloadService")}),define(te[14],ne([0,1,6]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,k.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,k.refineServiceDecorator)(e.IEnvironmentService)}),define(te[83],ne([0,1,6]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var t;(function(A){A[A.FILE=1]="FILE",A[A.WORKSPACE=2]="WORKSPACE",A[A.EXE=3]="EXE"})(t=e.RecommendationSource||(e.RecommendationSource={}));function L(A){switch(A){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=L;var T;(function(A){A.Ignored="ignored",A.Cancelled="cancelled",A.TooMany="toomany",A.IncompatibleWindow="incompatibleWindow",A.Accepted="reacted"})(T=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,k.createDecorator)("IExtensionRecommendationNotificationService")}),define(te[15],ne([0,1,9,39,10,26,11,7,137,6]),function(K,e,k,t,L,T,A,R,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,C.createDecorator)("fileService");function P(W){return W.create===!0}e.isFileOpenForWriteOptions=P;var E;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(E=e.FileType||(e.FileType={}));var f;(function(W){W[W.Readonly=1]="Readonly"})(f=e.FilePermission||(e.FilePermission={}));var p;(function(W){W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock",W[W.FileAtomicRead=16384]="FileAtomicRead"})(p=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function h(W){return!!(W.capabilities&2)}e.hasReadWriteCapability=h;function u(W){return!!(W.capabilities&8)}e.hasFileFolderCopyCapability=u;function v(W){return!!(W.capabilities&4)}e.hasOpenReadWriteCloseCapability=v;function m(W){return!!(W.capabilities&16)}e.hasFileReadStreamCapability=m;function w(W){return h(W)?!!(W.capabilities&16384):!1}e.hasFileAtomicReadCapability=w;var y;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(y=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class S extends Error{constructor(ie,B){super(ie);this.code=B}}e.FileSystemProviderError=S;function d(W,ie){const B=new S(W.toString(),ie);return c(B,ie),B}e.createFileSystemProviderError=d;function i(W){return W||d((0,b.localize)(0,null),y.Unknown)}e.ensureFileSystemProviderError=i;function c(W,ie){return W.name=ie?`${ie} (FileSystemError)`:"FileSystemError",W}e.markAsFileSystemProviderError=c;function r(W){if(!W)return y.Unknown;if(W instanceof S)return W.code;const ie=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!ie)return y.Unknown;switch(ie[1]){case y.FileExists:return y.FileExists;case y.FileIsADirectory:return y.FileIsADirectory;case y.FileNotADirectory:return y.FileNotADirectory;case y.FileNotFound:return y.FileNotFound;case y.FileExceedsMemoryLimit:return y.FileExceedsMemoryLimit;case y.FileTooLarge:return y.FileTooLarge;case y.FileWriteLocked:return y.FileWriteLocked;case y.NoPermissions:return y.NoPermissions;case y.Unavailable:return y.Unavailable}return y.Unknown}e.toFileSystemProviderErrorCode=r;function n(W){if(W instanceof I)return W.fileOperationResult;switch(r(W)){case y.FileNotFound:return 1;case y.FileIsADirectory:return 0;case y.FileNotADirectory:return 10;case y.FileWriteLocked:return 5;case y.NoPermissions:return 6;case y.FileExists:return 4;case y.FileExceedsMemoryLimit:return 9;case y.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=n;var o;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY",W[W.WRITE=4]="WRITE"})(o=e.FileOperation||(e.FileOperation={}));class s{constructor(ie,B,j){this.resource=ie,this.operation=B,this.target=j}isOperation(ie){return this.operation===ie}}e.FileOperationEvent=s;var a;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class l{constructor(ie,B){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=ie;const j=new Map;for(const Y of ie){const V=j.get(Y.type);switch(V?V.push([Y.resource,Y]):j.set(Y.type,[[Y.resource,Y]]),Y.type){case 1:this.rawAdded.push(Y.resource);break;case 0:this.rawUpdated.push(Y.resource);break;case 2:this.rawDeleted.push(Y.resource);break}}for(const[Y,V]of j)switch(Y){case 1:this.added=t.TernarySearchTree.forUris(()=>B),this.added.fill(V);break;case 0:this.updated=t.TernarySearchTree.forUris(()=>B),this.updated.fill(V);break;case 2:this.deleted=t.TernarySearchTree.forUris(()=>B),this.deleted.fill(V);break}}contains(ie,...B){return this.doContains(ie,{includeChildren:!1},...B)}affects(ie,...B){return this.doContains(ie,{includeChildren:!0},...B)}doContains(ie,B,...j){if(!ie)return!1;const Y=j.length>0;return!!((!Y||j.includes(1))&&(this.added?.get(ie)||B.includeChildren&&this.added?.findSuperstr(ie))||(!Y||j.includes(0))&&(this.updated?.get(ie)||B.includeChildren&&this.updated?.findSuperstr(ie))||(!Y||j.includes(2))&&(this.deleted?.findSubstr(ie)||B.includeChildren&&this.deleted?.findSuperstr(ie)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=l;function g(W,ie,B){return!W||!ie||W===ie||ie.length>W.length?!1:(ie.charAt(ie.length-1)!==L.sep&&(ie+=L.sep),B?(0,T.startsWithIgnoreCase)(W,ie):W.indexOf(ie)===0)}e.isParent=g;class I extends k.ErrorNoTelemetry{constructor(ie,B,j){super(ie);this.fileOperationResult=B,this.options=j}}e.FileOperationError=I;class _ extends I{constructor(ie,B,j){super(ie,2,j);this.stat=B}}e.NotModifiedSinceFileOperationError=_;var O;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",W[W.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(O=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var U;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(U=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function D(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}e.etag=D;async function M(W,ie){if(!ie.hasProvider(R.URI.from({scheme:W.scheme})))return new Promise(B=>{const j=ie.onDidChangeFileSystemProviderRegistrations(Y=>{Y.scheme===W.scheme&&Y.added&&(j.dispose(),B())})})}e.whenProviderRegistered=M,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class N{static formatSize(ie){return(0,A.isNumber)(ie)||(ie=0),ie<N.KB?(0,b.localize)(1,null,ie.toFixed(0)):ie<N.MB?(0,b.localize)(2,null,(ie/N.KB).toFixed(2)):ie<N.GB?(0,b.localize)(3,null,(ie/N.MB).toFixed(2)):ie<N.TB?(0,b.localize)(4,null,(ie/N.GB).toFixed(2)):(0,b.localize)(5,null,(ie/N.TB).toFixed(2))}}e.ByteSize=N,N.KB=1024,N.MB=N.KB*N.KB,N.GB=N.MB*N.KB,N.TB=N.GB*N.KB;var x;(function(W){W[W.IA32=0]="IA32",W[W.OTHER=1]="OTHER"})(x=e.Arch||(e.Arch={}));function Q(W){return{maxFileSize:W===0?300*N.MB:16*N.GB,maxHeapSize:W===0?700*N.MB:2*700*N.MB}}e.getPlatformLimits=Q});var G=this&&this.__param||function(K,e){return function(k,t){e(k,t,K)}};define(te[161],ne([0,1,84,40,15]),function(K,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let T=class{constructor(R){this.fileService=R}async checksum(R){const b=(await this.fileService.readFileStream(R)).value;return new Promise((C,P)=>{const E=(0,k.createHash)("md5");(0,t.listenStream)(b,{onData:f=>E.update(f.buffer),onError:f=>P(f),onEnd:()=>C(E.digest("base64").replace(/=+$/,""))})})}};T=he([G(0,L.IFileService)],T),e.ChecksumService=T}),define(te[162],ne([0,1,17,37,9,3,2,40,7,29,15]),function(K,e,k,t,L,T,A,R,b,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class E extends A.Disposable{constructor(p,h){super();this.channel=p,this.extraCapabilities=h,this.onDidChangeCapabilities=T.Event.None,this._onDidChange=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,C.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(p){return this.channel.call("stat",[p])}readdir(p){return this.channel.call("readdir",[p])}async readFile(p,h){const{buffer:u}=await this.channel.call("readFile",[p,h]);return u}readFileStream(p,h,u){const v=(0,R.newWriteableStream)(w=>k.VSBuffer.concat(w.map(y=>k.VSBuffer.wrap(y))).buffer),m=this.channel.listen("readFileStream",[p,h])(w=>{if(w instanceof k.VSBuffer)v.write(w.buffer);else{if(w==="end")v.end();else{let y=w;y instanceof Error||(y=(0,P.createFileSystemProviderError)((0,t.toErrorMessage)(y),P.FileSystemProviderErrorCode.Unknown)),v.error(y),v.end()}m.dispose()}});return u.onCancellationRequested(()=>{v.error((0,L.canceled)()),v.end(),m.dispose()}),v}writeFile(p,h,u){return this.channel.call("writeFile",[p,k.VSBuffer.wrap(h),u])}open(p,h){return this.channel.call("open",[p,h])}close(p){return this.channel.call("close",[p])}async read(p,h,u,v,m){const[w,y]=await this.channel.call("read",[p,h,m]);return u.set(w.buffer.slice(0,y),v),y}write(p,h,u,v,m){return this.channel.call("write",[p,h,k.VSBuffer.wrap(u),v,m])}mkdir(p){return this.channel.call("mkdir",[p])}delete(p,h){return this.channel.call("delete",[p,h])}rename(p,h,u){return this.channel.call("rename",[p,h,u])}copy(p,h,u){return this.channel.call("copy",[p,h,u])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(p=>{if(Array.isArray(p)){const h=p;this._onDidChange.fire(h.map(u=>({resource:b.URI.revive(u.resource),type:u.type})))}else{const h=p;this._onDidWatchError.fire(h)}}))}watch(p,h){const u=(0,C.generateUuid)();return this.channel.call("watch",[this.sessionId,u,p,h]),(0,A.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,u]))}}e.DiskFileSystemProviderClient=E}),define(te[85],ne([0,1,17,9,138,15]),function(K,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function A(P,E,f,p,h,u){let v;try{await R(P,E,f,p,h,u)}catch(m){v=m}finally{v&&h.errorTransformer&&(v=h.errorTransformer(v)),typeof v!="undefined"&&f.error(v),f.end()}}e.readFileIntoStream=A;async function R(P,E,f,p,h,u){b(u);const v=await P.open(E,{create:!1});try{b(u);let m=0,w=0,y=h&&typeof h.length=="number"?h.length:void 0,S=k.VSBuffer.alloc(Math.min(h.bufferSize,typeof y=="number"?y:h.bufferSize)),d=h&&typeof h.position=="number"?h.position:0,i=0;do w=await P.read(v,d,S.buffer,i,S.byteLength-i),d+=w,i+=w,m+=w,typeof y=="number"&&(y-=w),i===S.byteLength&&(await f.write(p(S)),S=k.VSBuffer.alloc(Math.min(h.bufferSize,typeof y=="number"?y:h.bufferSize)),i=0);while(w>0&&(typeof y!="number"||y>0)&&b(u)&&C(m,h));if(i>0){let c=i;typeof y=="number"&&(c=Math.min(i,y)),f.write(p(S.slice(0,c)))}}catch(m){throw(0,T.ensureFileSystemProviderError)(m)}finally{await P.close(v)}}function b(P){if(P.isCancellationRequested)throw(0,t.canceled)();return!0}function C(P,E){if(E?.limits){if(typeof E.limits.memory=="number"&&P>E.limits.memory)throw(0,T.createFileSystemProviderError)((0,L.localize)(0,null),T.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof E.limits.size=="number"&&P>E.limits.size)throw(0,T.createFileSystemProviderError)((0,L.localize)(1,null),T.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(te[52],ne([0,1,2,4,7,15]),function(K,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function A(p){return p.recursive===!0}e.isRecursiveWatchRequest=A;class R extends k.Disposable{constructor(h,u,v,m){super();this.onFileChanges=h,this.onLogMessage=u,this.verboseLogging=v,this.options=m,this.watcherDisposables=this._register(new k.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const h=new k.DisposableStore;this.watcherDisposables.value=h,this.watcher=this.createWatcher(h),this.watcher.setVerboseLogging(this.verboseLogging),h.add(this.watcher.onDidChangeFile(u=>this.onFileChanges(u))),h.add(this.watcher.onDidLogMessage(u=>this.onLogMessage(u))),h.add(this.watcher.onDidError(u=>this.onError(u)))}onError(h){this.options.restartOnError?this.restartCounter<R.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${h}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${h}`):this.error(h)}restart(h){this.restartCounter++,this.init(),this.watch(h)}async watch(h){this.requests=h,await this.watcher?.watch(h)}async setVerboseLogging(h){this.verboseLogging=h,await this.watcher?.setVerboseLogging(h)}error(h){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${h}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=R,R.MAX_RESTARTS=5;class b extends R{constructor(h,u,v){super(h,u,v,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=b;class C extends R{constructor(h,u,v){super(h,u,v,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=C;function P(p){return p.map(h=>({type:h.type,resource:L.URI.file(h.path)}))}e.toFileChanges=P;function E(p){const h=new f;for(const u of p)h.processEvent(u);return h.coalesce()}e.coalesceEvents=E;class f{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(h){return t.isLinux?h.path:h.path.toLowerCase()}processEvent(h){const u=this.mapPathToChange.get(this.toKey(h));let v=!1;if(u){const m=u.type,w=h.type;u.path!==h.path&&(h.type===2||h.type===1)?v=!0:m===1&&w===2?(this.mapPathToChange.delete(this.toKey(h)),this.coalesced.delete(u)):m===2&&w===1?u.type=0:m===1&&w===0||(u.type=w)}else v=!0;v&&(this.coalesced.add(h),this.mapPathToChange.set(this.toKey(h),h))}coalesce(){const h=[],u=[];return Array.from(this.coalesced).filter(v=>v.type!==2?(h.push(v),!1):!0).sort((v,m)=>v.path.length-m.path.length).filter(v=>u.some(m=>(0,T.isParent)(v.path,m,!t.isLinux))?!1:(u.push(v.path),!0)).concat(h)}}}),define(te[163],ne([0,1,50,5,25,41,109,2,72,10,4,114,22,52]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class h extends R.Disposable{constructor(m,w,y,S){super();this.request=m,this.onDidFilesChange=w,this.onLogMessage=y,this.verboseLogging=S,this.throttledFileChangesWorker=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},d=>this.onDidFilesChange(d)),this.fileChangesDelayer=this._register(new t.ThrottledDelayer(h.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=this.request.excludes.map(d=>(0,A.parse)(d)),this.cts=new L.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const m=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const w=await f.Promises.stat(m);this._register(await this.doWatch(m,w.isDirectory()))}catch(m){m.code!=="ENOENT"?this.error(m):this.trace(m)}}async normalizePath(m){let w=m.path;try{w=await f.Promises.realpath(m.path),m.path===w&&(w=await(0,E.realcase)(m.path)??m.path),m.path!==w&&this.warn(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${m.path}, real: ${w})`)}catch{}return w}async doWatch(m,w){if(P.isMacintosh&&(0,T.isEqualOrParent)(m,"/Volumes/",!0))return this.error(`Refusing to watch ${m} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.Disposable.None;const y=new L.CancellationTokenSource(this.cts.token);let S=new R.DisposableStore;try{const d=(0,C.basename)(m),i=(0,k.watch)(m);S.add((0,R.toDisposable)(()=>{i.removeAllListeners(),i.close()})),this.trace(`Started watching: '${m}'`);const c=new Set;if(w)try{for(const n of await f.Promises.readdir(m))c.add(n)}catch(n){this.error(n)}const r=new Map;S.add((0,R.toDisposable)(()=>{for(const[,n]of r)n.dispose();r.clear()})),i.on("error",(n,o)=>{this.error(`Failed to watch ${m} for changes using fs.watch() (${n}, ${o})`),this.dispose()}),i.on("change",(n,o)=>{if(y.token.isCancellationRequested)return;this.trace(`[raw] ["${n}"] ${o}`);let s="";if(o&&(s=o.toString(),P.isMacintosh&&(s=(0,b.normalizeNFC)(s))),!(!s||n!=="change"&&n!=="rename"))if(w)if(n==="rename"){r.get(s)?.dispose();const a=setTimeout(async()=>{if(r.delete(s),s===d&&!await f.Promises.exists(m)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const l=await this.existsChildStrictCase((0,C.join)(m,s));if(y.token.isCancellationRequested)return;let g;l?c.has(s)?g=0:(g=1,c.add(s)):(c.delete(s),g=2),this.onFileChange({path:(0,C.join)(this.request.path,s),type:g})},h.FILE_DELETE_HANDLER_DELAY);r.set(s,(0,R.toDisposable)(()=>clearTimeout(a)))}else{let a;c.has(s)?a=0:(a=1,c.add(s)),this.onFileChange({path:(0,C.join)(this.request.path,s),type:a})}else if(n==="rename"||s!==d){const a=setTimeout(async()=>{const l=await f.Promises.exists(m);y.token.isCancellationRequested||(l?(this.onFileChange({path:this.request.path,type:0},!0),S.add(await this.doWatch(m,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},h.FILE_DELETE_HANDLER_DELAY);S.clear(),S.add((0,R.toDisposable)(()=>clearTimeout(a)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(d){await f.Promises.exists(m)&&!y.token.isCancellationRequested&&this.error(`Failed to watch ${m} for changes using fs.watch() (${d.toString()})`)}return(0,R.toDisposable)(()=>{y.dispose(!0),S.dispose()})}async onFileChange(m,w=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${m.type===1?"[ADDED]":m.type===2?"[DELETED]":"[CHANGED]"} ${m.path}`),!w&&this.excludes.some(y=>y(m.path))?this.verboseLogging&&this.trace(` >> ignored ${m.path}`):this.fileChangesBuffer.push(m);try{await this.fileChangesDelayer.trigger(async()=>{const y=this.fileChangesBuffer;this.fileChangesBuffer=[];const S=(0,p.coalesceEvents)(y);if(S.length>0){if(this.verboseLogging)for(const i of S)this.trace(`>> normalized ${i.type===1?"[ADDED]":i.type===2?"[DELETED]":"[CHANGED]"} ${i.path}`);this.throttledFileChangesWorker.work(S)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${S[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${S.length}, most recent change: ${S[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(m){if(P.isLinux)return f.Promises.exists(m);try{const w=(0,C.basename)(m);return(await f.Promises.readdir((0,C.dirname)(m))).some(S=>S===w)}catch(w){return this.trace(w),!1}}setVerboseLogging(m){this.verboseLogging=m}error(m){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${m}`})}warn(m){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${m}`})}trace(m){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${m}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=h,h.FILE_DELETE_HANDLER_DELAY=100,h.FILE_CHANGES_HANDLER_DELAY=50;async function u(v,m,w,y,S=512){const d=await f.Promises.open(v,"r"),i=Buffer.allocUnsafe(S),c=new L.CancellationTokenSource(y);let r,n=!1;const o={path:v,excludes:[],recursive:!1},s=new h(o,a=>{(async()=>{for(const{type:l}of a)if(l===0){if(n)return;n=!0;try{for(;!c.token.isCancellationRequested;){const{bytesRead:g}=await f.Promises.read(d,i,0,S,null);if(!g||c.token.isCancellationRequested)break;m(i.slice(0,g))}}catch(g){r=new Error(g),c.dispose(!0)}finally{n=!1}}})()});return await s.ready,w(),new Promise((a,l)=>{c.token.onCancellationRequested(async()=>{s.dispose();try{await f.Promises.close(d)}catch(g){r=new Error(g)}r?l(r):a()})})}e.watchFileContents=u}),define(te[164],ne([0,1,16,3,2,4,163]),function(K,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class R extends L.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new t.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new t.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=t.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(C){const P=this.normalizeRequests(C),E=P.filter(p=>{const h=this.watchers.get(p.path);return h?!(0,k.equals)(h.request.excludes,p.excludes):!0}),f=Array.from(this.watchers.values()).filter(({request:p})=>!P.find(h=>h.path===p.path&&(0,k.equals)(h.excludes,p.excludes))).map(({request:p})=>p.path);E.length&&this.trace(`Request to start watching: ${E.map(p=>`${p.path} (excludes: ${p.excludes.length>0?p.excludes:"<none>"})`).join(",")}`),f.length&&this.trace(`Request to stop watching: ${f.join(",")}`);for(const p of f)this.stopWatching(p);for(const p of E)this.startWatching(p)}startWatching(C){const P=new A.NodeJSFileWatcherLibrary(C,f=>this._onDidChangeFile.fire(f),f=>this._onDidLogMessage.fire(f),this.verboseLogging),E={request:C,instance:P};this.watchers.set(C.path,E)}async stop(){for(const[C]of this.watchers)this.stopWatching(C);this.watchers.clear()}stopWatching(C){const P=this.watchers.get(C);P&&(this.watchers.delete(C),P.instance.dispose())}normalizeRequests(C){const P=new Map;for(const E of C){const f=T.isLinux?E.path:E.path.toLowerCase();P.set(f,E)}return Array.from(P.values())}async setVerboseLogging(C){this.verboseLogging=C;for(const[,P]of this.watchers)P.instance.setVerboseLogging(C)}trace(C){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(C)})}toMessage(C,P){return P?`[File Watcher (node.js)] ${C} (path: ${P.request.path})`:`[File Watcher (node.js)] ${C}`}}e.NodeJSWatcher=R}),define(te[165],ne([0,1,52,164]),function(K,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class L extends k.AbstractNonRecursiveWatcherClient{constructor(A,R,b){super(A,R,b);this.init()}createWatcher(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=L}),define(te[166],ne([0,1,18,36,58,52]),function(K,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class A extends T.AbstractUniversalWatcherClient{constructor(b,C,P){super(b,C,P);this.init()}createWatcher(b){const C=b.add(new L.Client(k.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return b.add(C.onDidProcessExit(({code:P,signal:E})=>this.onError(`terminated by itself with code ${P}, signal: ${E}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(C.getChannel("watcher")))}}e.UniversalWatcherClient=A}),define(te[86],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class k{constructor(...L){this._entries=new Map;for(let[T,A]of L)this.set(T,A)}set(L,T){const A=this._entries.get(L);return this._entries.set(L,T),A}has(L){return this._entries.has(L)}get(L){return this._entries.get(L)}}e.ServiceCollection=k}),define(te[167],ne([0,1,5,9,51,158,6,86]),function(K,e,k,t,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const b=!1;class C extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class P{constructor(h=new R.ServiceCollection,u=!1,v){this._activeInstantiations=new Set,this._services=h,this._strict=u,this._parent=v,this._services.set(A.IInstantiationService,this)}createChild(h){return new P(h,this._strict,this)}invokeFunction(h,...u){let v=f.traceInvocation(h),m=!1;try{return h({get:y=>{if(m)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const S=this._getOrCreateServiceInstance(y,v);if(!S)throw new Error(`[invokeFunction] unknown service '${y}'`);return S}},...u)}finally{m=!0,v.stop()}}createInstance(h,...u){let v,m;return h instanceof L.SyncDescriptor?(v=f.traceCreation(h.ctor),m=this._createInstance(h.ctor,h.staticArguments.concat(u),v)):(v=f.traceCreation(h),m=this._createInstance(h,u,v)),v.stop(),m}_createInstance(h,u=[],v){let m=A._util.getServiceDependencies(h).sort((S,d)=>S.index-d.index),w=[];for(const S of m){let d=this._getOrCreateServiceInstance(S.id,v);d||this._throwIfStrict(`[createInstance] ${h.name} depends on UNKNOWN service ${S.id}.`,!1),w.push(d)}let y=m.length>0?m[0].index:u.length;if(u.length!==y){console.warn(`[createInstance] First service dependency of ${h.name} at position ${y+1} conflicts with ${u.length} static arguments`);let S=y-u.length;S>0?u=u.concat(new Array(S)):u=u.slice(0,y)}return new h(...[...u,...w])}_setServiceInstance(h,u){if(this._services.get(h)instanceof L.SyncDescriptor)this._services.set(h,u);else if(this._parent)this._parent._setServiceInstance(h,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let u=this._services.get(h);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):u}_getOrCreateServiceInstance(h,u){let v=this._getServiceInstanceOrDescriptor(h);return v instanceof L.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,v,u.branch(h,!0)):(u.branch(h,!1),v)}_safeCreateAndCacheServiceInstance(h,u,v){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,u,v)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,u,v){const m=new T.Graph(S=>S.id.toString());let w=0;const y=[{id:h,desc:u,_trace:v}];for(;y.length;){const S=y.pop();if(m.lookupOrInsertNode(S),w++>1e3)throw new C(m);for(let d of A._util.getServiceDependencies(S.desc.ctor)){let i=this._getServiceInstanceOrDescriptor(d.id);if(i||this._throwIfStrict(`[createInstance] ${h} depends on ${d.id} which is NOT registered.`,!0),i instanceof L.SyncDescriptor){const c={id:d.id,desc:i,_trace:S._trace.branch(d.id,!0)};m.insertEdge(S,c),y.push(c)}}}for(;;){const S=m.roots();if(S.length===0){if(!m.isEmpty())throw new C(m);break}for(const{data:d}of S){if(this._getServiceInstanceOrDescriptor(d.id)instanceof L.SyncDescriptor){const c=this._createServiceInstanceWithOwner(d.id,d.desc.ctor,d.desc.staticArguments,d.desc.supportsDelayedInstantiation,d._trace);this._setServiceInstance(d.id,c)}m.removeNode(d)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,u,v=[],m,w){if(this._services.get(h)instanceof L.SyncDescriptor)return this._createServiceInstance(u,v,m,w);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,u,v,m,w);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(h,u=[],v,m){if(v){const w=new k.IdleValue(()=>this._createInstance(h,u,m));return new Proxy(Object.create(null),{get(y,S){if(S in y)return y[S];let d=w.value,i=d[S];return typeof i!="function"||(i=i.bind(d),y[S]=i),i},set(y,S,d){return w.value[S]=d,!0}})}else return this._createInstance(h,u,m)}_throwIfStrict(h,u){if(u&&console.warn(u),this._strict)throw new Error(h)}}e.InstantiationService=P;var E;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(E||(E={}));class f{constructor(h,u){this.type=h,this.name=u,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return b?new f(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):f._None}static traceCreation(h){return b?new f(0,h.name):f._None}branch(h,u){let v=new f(2,h.toString());return this._dep.push([h,u,v]),v}stop(){let h=Date.now()-this._start;f._totals+=h;let u=!1;function v(w,y){let S=[],d=new Array(w+1).join("	");for(const[i,c,r]of y._dep)if(c&&r){u=!0,S.push(`${d}CREATES -> ${i}`);let n=v(w+1,r);n&&S.push(n)}else S.push(`${d}uses -> ${i}`);return S.join(`
`)}let m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${f._totals.toFixed(2)}ms)`];(h>2||u)&&console.log(m.join(`
`))}}e.Trace=f,f._None=new class extends f{constructor(){super(-1,null)}stop(){}branch(){return this}},f._totals=0}),define(te[168],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class k{constructor(L,T){this.server=L,this.router=T}getChannel(L){return this.server.getChannel(L,this.router)}registerChannel(L,T){this.server.registerChannel(L,T)}}e.MessagePortMainProcessService=k}),define(te[169],ne([0,1,36,51,80,6]),function(K,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class A{constructor(p,h,u){const v=u.getChannel(p);return R(h)?new h.channelClientCtor(v):k.ProxyChannel.toService(v,h?.proxyOptions)}}function R(f){return!!f?.channelClientCtor}e.IMainProcessService=(0,T.createDecorator)("mainProcessService");let b=class extends A{constructor(p,h,u){super(p,h,u)}};b=he([G(2,e.IMainProcessService)],b);function C(f,p,h){(0,L.registerSingleton)(f,new t.SyncDescriptor(b,[p,h],h?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=C,e.ISharedProcessService=(0,T.createDecorator)("sharedProcessService");let P=class extends A{constructor(p,h,u){super(p,h,u)}};P=he([G(2,e.ISharedProcessService)],P);function E(f,p,h){(0,L.registerSingleton)(f,new t.SyncDescriptor(P,[p,h],h?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=E}),define(te[59],ne([0,1,6]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,k.createDecorator)("localizationsService");function t(L){if(typeof L.languageId!="string"||!Array.isArray(L.translations)||L.translations.length===0)return!1;for(const T of L.translations)if(typeof T.id!="string"||typeof T.path!="string")return!1;return!(L.languageName&&typeof L.languageName!="string"||L.localizedLanguageName&&typeof L.localizedLanguageName!="string")}e.isValidLocalization=t}),define(te[170],ne([0,1,2,59]),function(K,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let L=class extends k.Disposable{constructor(A){super();this.localizationsService=A,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};L=he([G(0,t.ILocalizationsService)],L),e.LocalizationsUpdater=L}),define(te[8],ne([0,1,37,3,2,4,6]),function(K,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,A.createDecorator)("logService"),e.ILoggerService=(0,A.createDecorator)("loggerService");function R(){return new Date().toISOString()}var b;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(b=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=b.Info;function C(c,r,n){switch(r){case b.Trace:c.trace(n);break;case b.Debug:c.debug(n);break;case b.Info:c.info(n);break;case b.Warning:c.warn(n);break;case b.Error:c.error(n);break;case b.Critical:c.critical(n);break;default:throw new Error("Invalid log level")}}e.log=C;function P(c){let r="";for(let n=0;n<c.length;n++){let o=c[n];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}r+=(n>0?" ":"")+o}return r}e.format=P;class E extends L.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(r){this.level!==r&&(this.level=r,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=E;class f extends E{constructor(r){super();this.logAlways=r}checkLogLevel(r){return this.logAlways||this.getLevel()<=r}trace(r,...n){this.checkLogLevel(b.Trace)&&this.log(b.Trace,P([r,...n]))}debug(r,...n){this.checkLogLevel(b.Debug)&&this.log(b.Debug,P([r,...n]))}info(r,...n){this.checkLogLevel(b.Info)&&this.log(b.Info,P([r,...n]))}warn(r,...n){this.checkLogLevel(b.Warning)&&this.log(b.Warning,P([r,...n]))}error(r,...n){if(this.checkLogLevel(b.Error))if(r instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=r.stack,this.log(b.Error,P(o))}else this.log(b.Error,P([r,...n]))}critical(r,...n){this.checkLogLevel(b.Critical)&&this.log(b.Critical,P([r,...n]))}flush(){}}e.AbstractMessageLogger=f;class p extends E{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r),this.useColors=!T.isWindows}trace(r,...n){this.getLevel()<=b.Trace&&(this.useColors?console.log(`[90m[main ${R()}][0m`,r,...n):console.log(`[main ${R()}]`,r,...n))}debug(r,...n){this.getLevel()<=b.Debug&&(this.useColors?console.log(`[90m[main ${R()}][0m`,r,...n):console.log(`[main ${R()}]`,r,...n))}info(r,...n){this.getLevel()<=b.Info&&(this.useColors?console.log(`[90m[main ${R()}][0m`,r,...n):console.log(`[main ${R()}]`,r,...n))}warn(r,...n){this.getLevel()<=b.Warning&&(this.useColors?console.warn(`[93m[main ${R()}][0m`,r,...n):console.warn(`[main ${R()}]`,r,...n))}error(r,...n){this.getLevel()<=b.Error&&(this.useColors?console.error(`[91m[main ${R()}][0m`,r,...n):console.error(`[main ${R()}]`,r,...n))}critical(r,...n){this.getLevel()<=b.Critical&&(this.useColors?console.error(`[90m[main ${R()}][0m`,r,...n):console.error(`[main ${R()}]`,r,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=p;class h extends E{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r)}trace(r,...n){this.getLevel()<=b.Trace&&console.log("%cTRACE","color: #888",r,...n)}debug(r,...n){this.getLevel()<=b.Debug&&console.log("%cDEBUG","background: #eee; color: #888",r,...n)}info(r,...n){this.getLevel()<=b.Info&&console.log("%c INFO","color: #33f",r,...n)}warn(r,...n){this.getLevel()<=b.Warning&&console.log("%c WARN","color: #993",r,...n)}error(r,...n){this.getLevel()<=b.Error&&console.log("%c  ERR","color: #f33",r,...n)}critical(r,...n){this.getLevel()<=b.Critical&&console.log("%cCRITI","background: #f33; color: white",r,...n)}dispose(){}flush(){}}e.ConsoleLogger=h;class u extends E{constructor(r,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=r,this.setLevel(n)}trace(r,...n){this.getLevel()<=b.Trace&&this.adapter.log(b.Trace,[this.extractMessage(r),...n])}debug(r,...n){this.getLevel()<=b.Debug&&this.adapter.log(b.Debug,[this.extractMessage(r),...n])}info(r,...n){this.getLevel()<=b.Info&&this.adapter.log(b.Info,[this.extractMessage(r),...n])}warn(r,...n){this.getLevel()<=b.Warning&&this.adapter.log(b.Warning,[this.extractMessage(r),...n])}error(r,...n){this.getLevel()<=b.Error&&this.adapter.log(b.Error,[this.extractMessage(r),...n])}critical(r,...n){this.getLevel()<=b.Critical&&this.adapter.log(b.Critical,[this.extractMessage(r),...n])}extractMessage(r){return typeof r=="string"?r:(0,k.toErrorMessage)(r,this.getLevel()<=b.Trace)}dispose(){}flush(){}}e.AdapterLogger=u;class v extends E{constructor(r){super();this.logServices=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const n of this.logServices)n.setLevel(r);super.setLevel(r)}trace(r,...n){for(const o of this.logServices)o.trace(r,...n)}debug(r,...n){for(const o of this.logServices)o.debug(r,...n)}info(r,...n){for(const o of this.logServices)o.info(r,...n)}warn(r,...n){for(const o of this.logServices)o.warn(r,...n)}error(r,...n){for(const o of this.logServices)o.error(r,...n)}critical(r,...n){for(const o of this.logServices)o.critical(r,...n)}flush(){for(const r of this.logServices)r.flush()}dispose(){for(const r of this.logServices)r.dispose()}}e.MultiplexLogService=v;class m extends L.Disposable{constructor(r){super();this.logger=r,this._register(r)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(r){this.logger.setLevel(r)}getLevel(){return this.logger.getLevel()}trace(r,...n){this.logger.trace(r,...n)}debug(r,...n){this.logger.debug(r,...n)}info(r,...n){this.logger.info(r,...n)}warn(r,...n){this.logger.warn(r,...n)}error(r,...n){this.logger.error(r,...n)}critical(r,...n){this.logger.critical(r,...n)}flush(){this.logger.flush()}}e.LogService=m;class w extends L.Disposable{constructor(r,n){super();this.logLevel=r,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(o))}))}getLogger(r){return this.loggers.get(r.toString())}createLogger(r,n){let o=this.loggers.get(r.toString());return o||(o=this.doCreateLogger(r,n?.always?b.Trace:this.logLevel,n),this.loggers.set(r.toString(),o),n?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(r=>r.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=w;class y{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(r){}getLevel(){return b.Info}trace(r,...n){}debug(r,...n){}info(r,...n){}warn(r,...n){}error(r,...n){}critical(r,...n){}dispose(){}flush(){}}e.NullLogService=y;function S(c){if(c.verbose)return b.Trace;if(typeof c.logLevel=="string"){const r=d(c.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=S;function d(c){switch(c){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Critical;case"off":return b.Off}}e.parseLogLevel=d;function i(c){switch(c){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Critical:return"critical";case b.Off:return"off"}}e.LogLevelToString=i}),define(te[171],ne([0,1,5,9,2,10,22,14,8]),function(K,e,k,t,L,T,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let C=class extends L.Disposable{constructor(E,f){super();this.environmentService=E,this.logService=f,this._register(new k.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const E=(0,T.basename)(this.environmentService.logsPath),f=(0,T.dirname)(this.environmentService.logsPath),u=(await A.Promises.readdir(f)).filter(m=>/^\d{8}T\d{6}$/.test(m)).sort().filter(m=>m!==E),v=u.slice(0,Math.max(0,u.length-9));v.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${v.join(", ")}'`),await Promise.all(v.map(m=>A.Promises.rm((0,T.join)(f,m)))))}catch(E){(0,t.onUnexpectedError)(E)}}};C=he([G(0,R.IEnvironmentService),G(1,b.ILogService)],C),e.LogsDataCleaner=C}),define(te[172],ne([0,1,5,9,2,10,22,14,8]),function(K,e,k,t,L,T,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let C=class gt extends L.Disposable{constructor(E,f,p){super();this.backupWorkspacesPath=E,this.environmentService=f,this.logService=p,this._register(new k.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up storage folders.");try{const E=await A.Promises.readFile(this.backupWorkspacesPath,"utf8"),p=JSON.parse(E).emptyWorkspaceInfos.map(u=>u.backupFolder),h=await A.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(h.map(async u=>{u.length===gt.NON_EMPTY_WORKSPACE_ID_LENGTH||u===gt.EXTENSION_DEV_EMPTY_WINDOW_ID||p.indexOf(u)>=0||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${u}.`),await A.Promises.rm((0,T.join)(this.environmentService.workspaceStorageHome.fsPath,u)))}))}catch(E){(0,t.onUnexpectedError)(E)}}};C.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,C.EXTENSION_DEV_EMPTY_WINDOW_ID="ext-dev",C=he([G(1,R.INativeEnvironmentService),G(2,b.ILogService)],C),e.StorageDataCleaner=C}),define(te[173],ne([0,1,46,5,37,3,2,18,10,22,14,8]),function(K,e,k,t,L,T,A,R,b,C,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let f=class extends A.Disposable{constructor(h,u){super();this.environmentService=h,this.logService=u,this.processesLimiter=new t.Limiter(5)}async postUninstall(h){const u=this.parseScript(h,"uninstall");return u&&(this.logService.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(u.script,"uninstall",u.args,!0,h).then(()=>this.logService.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),v=>this.logService.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${v}`)))),C.Promises.rm(this.getExtensionStoragePath(h)).then(void 0,v=>this.logService.error("Error while removing extension storage path",v))}parseScript(h,u){const v=`vscode:${u}`;if(h.location.scheme===R.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[v]=="string"){const m=h.manifest.scripts[v].split(" ");return m.length<2||m[0]!=="node"||!m[1]?(this.logService.warn(h.identifier.id,h.manifest.version,`${v} should be a node script`),null):{script:(0,b.join)(h.location.fsPath,m[1]),args:m.slice(2)||[]}}return null}runLifecycleHook(h,u,v,m,w){return new Promise((y,S)=>{const d=this.start(h,u,v,w);let i;const c=r=>{i&&(clearTimeout(i),i=null),r?S(r):y(void 0)};d.on("error",r=>{c((0,L.toErrorMessage)(r)||"Unknown")}),d.on("exit",(r,n)=>{c(r?`post-${u} process exited with code ${r}`:void 0)}),m&&(i=setTimeout(()=>{i=null,d.kill(),S("timed out")},5e3))})}start(h,u,v,m){const w={silent:!0,execArgv:void 0},y=(0,k.fork)(h,[`--type=extension-post-${u}`,...v],w);y.stdout.setEncoding("utf8"),y.stderr.setEncoding("utf8");const S=T.Event.fromNodeEventEmitter(y.stdout,"data"),d=T.Event.fromNodeEventEmitter(y.stderr,"data");S(r=>this.logService.info(m.identifier.id,m.manifest.version,`post-${u}`,r)),d(r=>this.logService.error(m.identifier.id,m.manifest.version,`post-${u}`,r));const i=T.Event.any(T.Event.map(S,r=>({data:`%c${r}`,format:[""]})),T.Event.map(d,r=>({data:`%c${r}`,format:["color: red"]})));return T.Event.debounce(i,(r,n)=>r?{data:r.data+n.data,format:[...r.format,...n.format]}:{data:n.data,format:n.format},100)(r=>{console.group(m.identifier.id),console.log(r.data,...r.format),console.groupEnd()}),y}getExtensionStoragePath(h){return(0,b.join)(this.environmentService.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};f=he([G(0,P.IEnvironmentService),G(1,E.ILogService)],f),e.ExtensionsLifecycle=f}),define(te[174],ne([0,1,16,5,9,3,2,10,52,8]),function(K,e,k,t,L,T,A,R,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class P extends A.Disposable{constructor(f,p){super();this.logService=f,this.options=p,this._onDidChangeFile=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new t.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new t.ThrottledDelayer(0))}watch(f,p){return p.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(f,p):this.watchNonRecursive(f,p)}watchUniversal(f,p){const h={path:this.toFilePath(f),excludes:p.excludes,recursive:p.recursive},u=(0,k.insert)(this.universalPathsToWatch,h);return this.refreshUniversalWatchers(),(0,A.toDisposable)(()=>{u(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(f=>(0,L.onUnexpectedError)(f))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(p=>this._onDidChangeFile.fire((0,b.toFileChanges)(p)),p=>this.onWatcherLogMessage(p),this.logService.getLevel()===C.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===C.LogLevel.Trace)})));const f=this.options?.watcher?.recursive?.usePolling;if(f===!0)for(const p of this.universalPathsToWatch)(0,b.isRecursiveWatchRequest)(p)&&(p.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(f))for(const p of this.universalPathsToWatch)(0,b.isRecursiveWatchRequest)(p)&&f.includes(p.path)&&(p.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(f,p){const h={path:this.toFilePath(f),excludes:p.excludes,recursive:!1},u=(0,k.insert)(this.nonRecursivePathsToWatch,h);return this.refreshNonRecursiveWatchers(),(0,A.toDisposable)(()=>{u(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(f=>(0,L.onUnexpectedError)(f))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(f=>this._onDidChangeFile.fire((0,b.toFileChanges)(f)),f=>this.onWatcherLogMessage(f),this.logService.getLevel()===C.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===C.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(f){f.type==="error"&&this._onDidWatchError.fire(f.message),this.logService[f.type](f.message)}toFilePath(f){return(0,R.normalize)(f.fsPath)}}e.AbstractDiskFileSystemProvider=P}),define(te[175],ne([0,1,16,5,17,25,3,71,55,2,39,18,176,20,40,136,15,85,8]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p,h,u,v,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let y=class extends C.Disposable{constructor(d){super();this.logService=d,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new A.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new A.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new A.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new t.ResourceQueue)}registerProvider(d,i){if(this.provider.has(d))throw new Error(`A filesystem provider for the scheme '${d}' is already registered.`);(0,f.mark)(`code/registerFilesystem/${d}`);const c=new C.DisposableStore;return this.provider.set(d,i),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:d,provider:i}),c.add(i.onDidChangeFile(r=>this._onDidFilesChange.fire(new v.FileChangesEvent(r,!this.isPathCaseSensitive(i))))),typeof i.onDidWatchError=="function"&&c.add(i.onDidWatchError(r=>this._onDidWatchError.fire(new Error(r)))),c.add(i.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:i,scheme:d}))),(0,C.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:d,provider:i}),this.provider.delete(d),(0,C.dispose)(c)})}getProvider(d){return this.provider.get(d)}async activateProvider(d){const i=[];this._onWillActivateFileSystemProvider.fire({scheme:d,join(c){i.push(c)}}),!this.provider.has(d)&&await t.Promises.settled(i)}async canHandleResource(d){return await this.activateProvider(d.scheme),this.hasProvider(d)}hasProvider(d){return this.provider.has(d.scheme)}hasCapability(d,i){const c=this.provider.get(d.scheme);return!!(c&&c.capabilities&i)}listCapabilities(){return b.Iterable.map(this.provider,([d,i])=>({scheme:d,capabilities:i.capabilities}))}async withProvider(d){if(!(0,p.isAbsolutePath)(d))throw new v.FileOperationError((0,u.localize)(0,null,this.resourceForError(d)),8);await this.activateProvider(d.scheme);const i=this.provider.get(d.scheme);if(!i){const c=new Error;throw c.name="ENOPRO",c.message=(0,u.localize)(1,null,d.toString()),c}return i}async withReadProvider(d){const i=await this.withProvider(d);if((0,v.hasOpenReadWriteCloseCapability)(i)||(0,v.hasReadWriteCapability)(i)||(0,v.hasFileReadStreamCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${d.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(d){const i=await this.withProvider(d);if((0,v.hasOpenReadWriteCloseCapability)(i)||(0,v.hasReadWriteCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${d.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(d,i){try{return await this.doResolveFile(d,i)}catch(c){throw(0,v.toFileSystemProviderErrorCode)(c)===v.FileSystemProviderErrorCode.FileNotFound?new v.FileOperationError((0,u.localize)(2,null,this.resourceForError(d)),1):(0,v.ensureFileSystemProviderError)(c)}}async doResolveFile(d,i){const c=await this.withProvider(d),r=this.isPathCaseSensitive(c),n=i?.resolveTo,o=i?.resolveSingleChildDescendants,s=i?.resolveMetadata,a=await c.stat(d);let l;return this.toFileStat(c,d,a,void 0,!!s,(g,I)=>(l||(l=P.TernarySearchTree.forUris(()=>!r),l.set(d,!0),n&&l.fill(!0,n)),l.get(g.resource)||l.findSuperstr(g.resource.with({query:null,fragment:null}))?!0:g.isDirectory&&o?I===1:!1))}async toFileStat(d,i,c,r,n,o){const{providerExtUri:s}=this.getExtUri(d),a={resource:i,name:s.basename(i),isFile:(c.type&v.FileType.File)!=0,isDirectory:(c.type&v.FileType.Directory)!=0,isSymbolicLink:(c.type&v.FileType.SymbolicLink)!=0,mtime:c.mtime,ctime:c.ctime,size:c.size,readonly:Boolean((c.permissions??0)&v.FilePermission.Readonly)||Boolean(d.capabilities&2048),etag:(0,v.etag)({mtime:c.mtime,size:c.size}),children:void 0};if(a.isDirectory&&o(a,r)){try{const l=await d.readdir(i),g=await t.Promises.settled(l.map(async([I,_])=>{try{const O=s.joinPath(i,I),U=n?await d.stat(O):{type:_};return await this.toFileStat(d,O,U,l.length,n,o)}catch(O){return this.logService.trace(O),null}}));a.children=(0,k.coalesce)(g)}catch(l){this.logService.trace(l),a.children=[]}return a}return a}async resolveAll(d){return t.Promises.settled(d.map(async i=>{try{return{stat:await this.doResolveFile(i.resource,i.options),success:!0}}catch(c){return this.logService.trace(c),{stat:void 0,success:!1}}}))}async stat(d){const i=await this.withProvider(d),c=await i.stat(d);return this.toFileStat(i,d,c,void 0,!0,()=>!1)}async exists(d){const i=await this.withProvider(d);try{return!!await i.stat(d)}catch{return!1}}async canCreateFile(d,i){try{await this.doValidateCreateFile(d,i)}catch(c){return c}return!0}async doValidateCreateFile(d,i){if(!i?.overwrite&&await this.exists(d))throw new v.FileOperationError((0,u.localize)(3,null,this.resourceForError(d)),3,i)}async createFile(d,i=L.VSBuffer.fromString(""),c){await this.doValidateCreateFile(d,c);const r=await this.writeFile(d,i);return this._onDidRunOperation.fire(new v.FileOperationEvent(d,0,r)),r}async writeFile(d,i,c){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(d),d),{providerExtUri:n}=this.getExtUri(r);try{await this.validateWriteFile(r,d,c)||await this.mkdirp(r,n.dirname(d));let s;if((0,v.hasReadWriteCapability)(r)&&!(i instanceof L.VSBuffer))if((0,h.isReadableStream)(i)){const a=await(0,h.peekStream)(i,3);a.ended?s=L.VSBuffer.concat(a.buffer):s=a}else s=(0,h.peekReadable)(i,a=>L.VSBuffer.concat(a),3);else s=i;!(0,v.hasOpenReadWriteCloseCapability)(r)||(0,v.hasReadWriteCapability)(r)&&s instanceof L.VSBuffer?await this.doWriteUnbuffered(r,d,c,s):await this.doWriteBuffered(r,d,c,s instanceof L.VSBuffer?(0,L.bufferToReadable)(s):s),this._onDidRunOperation.fire(new v.FileOperationEvent(d,4))}catch(o){throw new v.FileOperationError((0,u.localize)(4,null,this.resourceForError(d),(0,v.ensureFileSystemProviderError)(o).toString()),(0,v.toFileOperationResult)(o),c)}return this.resolve(d,{resolveMetadata:!0})}async validateWriteFile(d,i,c){if(!!c?.unlock&&!(d.capabilities&8192))throw new Error((0,u.localize)(5,null,this.resourceForError(i)));let n;try{n=await d.stat(i)}catch{return}if((n.type&v.FileType.Directory)!=0)throw new v.FileOperationError((0,u.localize)(6,null,this.resourceForError(i)),0,c);if(this.throwIfFileIsReadonly(i,n),typeof c?.mtime=="number"&&typeof c.etag=="string"&&c.etag!==v.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&c.mtime<n.mtime&&c.etag!==(0,v.etag)({mtime:c.mtime,size:n.size}))throw new v.FileOperationError((0,u.localize)(7,null),3,c);return n}async readFile(d,i,c){const r=await this.withReadProvider(d);return i?.atomic?this.doReadFileAtomic(r,d,i,c):this.doReadFile(r,d,i,c)}async doReadFileAtomic(d,i,c,r){return new Promise((n,o)=>{this.writeQueue.queueFor(i,this.getExtUri(d).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(d,i,c,r);n(s)}catch(s){o(s)}})})}async doReadFile(d,i,c,r){const n=await this.doReadFileStream(d,i,{...c,preferUnbuffered:!0},r);return{...n,value:await(0,L.streamToBuffer)(n.value)}}async readFileStream(d,i,c){const r=await this.withReadProvider(d);return this.doReadFileStream(r,d,i,c)}async doReadFileStream(d,i,c,r){const n=new T.CancellationTokenSource(r),o=this.validateReadFile(i,c).then(a=>a,a=>{throw n.cancel(),a});let s;try{return typeof c?.etag=="string"&&c.etag!==v.ETAG_DISABLED&&await o,c?.atomic&&(0,v.hasFileAtomicReadCapability)(d)||!((0,v.hasOpenReadWriteCloseCapability)(d)||(0,v.hasFileReadStreamCapability)(d))||(0,v.hasReadWriteCapability)(d)&&c?.preferUnbuffered?s=this.readFileUnbuffered(d,i,c):(0,v.hasFileReadStreamCapability)(d)?s=this.readFileStreamed(d,i,n.token,c):s=this.readFileBuffered(d,i,n.token,c),{...await o,value:s}}catch(a){s&&await(0,h.consumeStream)(s);const l=(0,u.localize)(8,null,this.resourceForError(i),(0,v.ensureFileSystemProviderError)(a).toString());throw a instanceof v.NotModifiedSinceFileOperationError?new v.NotModifiedSinceFileOperationError(l,a.stat,c):new v.FileOperationError(l,(0,v.toFileOperationResult)(a),c)}}readFileStreamed(d,i,c,r=Object.create(null)){const n=d.readFileStream(i,r,c);return(0,h.transform)(n,{data:o=>o instanceof L.VSBuffer?o:L.VSBuffer.wrap(o),error:o=>new v.FileOperationError((0,u.localize)(9,null,this.resourceForError(i),(0,v.ensureFileSystemProviderError)(o).toString()),(0,v.toFileOperationResult)(o),r)},o=>L.VSBuffer.concat(o))}readFileBuffered(d,i,c,r=Object.create(null)){const n=(0,L.newWriteableBufferStream)();return(0,m.readFileIntoStream)(d,i,n,o=>o,{...r,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new v.FileOperationError((0,u.localize)(10,null,this.resourceForError(i),(0,v.ensureFileSystemProviderError)(o).toString()),(0,v.toFileOperationResult)(o),r)},c),n}readFileUnbuffered(d,i,c){const r=(0,h.newWriteableStream)(n=>L.VSBuffer.concat(n));return(async()=>{try{let n;c?.atomic&&(0,v.hasFileAtomicReadCapability)(d)?n=await d.readFile(i,{atomic:!0}):n=await d.readFile(i),typeof c?.position=="number"&&(n=n.slice(c.position)),typeof c?.length=="number"&&(n=n.slice(0,c.length)),this.validateReadFileLimits(i,n.byteLength,c),r.end(L.VSBuffer.wrap(n))}catch(n){r.error(n),r.end()}})(),r}async validateReadFile(d,i){const c=await this.resolve(d,{resolveMetadata:!0});if(c.isDirectory)throw new v.FileOperationError((0,u.localize)(11,null,this.resourceForError(d)),0,i);if(typeof i?.etag=="string"&&i.etag!==v.ETAG_DISABLED&&i.etag===c.etag)throw new v.NotModifiedSinceFileOperationError((0,u.localize)(12,null),c,i);return this.validateReadFileLimits(d,c.size,i),c}validateReadFileLimits(d,i,c){if(c?.limits){let r;if(typeof c.limits.memory=="number"&&i>c.limits.memory&&(r=9),typeof c.limits.size=="number"&&i>c.limits.size&&(r=7),typeof r=="number")throw new v.FileOperationError((0,u.localize)(13,null,this.resourceForError(d)),r)}}async canMove(d,i,c){return this.doCanMoveCopy(d,i,"move",c)}async canCopy(d,i,c){return this.doCanMoveCopy(d,i,"copy",c)}async doCanMoveCopy(d,i,c,r){if(d.toString()!==i.toString())try{const n=c==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(d),d):await this.withReadProvider(d),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);await this.doValidateMoveCopy(n,d,o,i,c,r)}catch(n){return n}return!0}async move(d,i,c){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(d),d),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),o=await this.doMoveCopy(r,d,n,i,"move",!!c),s=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new v.FileOperationEvent(d,o==="move"?2:3,s)),s}async copy(d,i,c){const r=await this.withReadProvider(d),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),o=await this.doMoveCopy(r,d,n,i,"copy",!!c),s=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new v.FileOperationEvent(d,o==="copy"?3:2,s)),s}async doMoveCopy(d,i,c,r,n,o){if(i.toString()===r.toString())return n;const{exists:s,isSameResourceWithDifferentPathCase:a}=await this.doValidateMoveCopy(d,i,c,r,n,o);if(s&&!a&&o&&await this.del(r,{recursive:!0}),await this.mkdirp(c,this.getExtUri(c).providerExtUri.dirname(r)),n==="copy"){if(d===c&&(0,v.hasFileFolderCopyCapability)(d))await d.copy(i,r,{overwrite:o});else{const l=await this.resolve(i);l.isDirectory?await this.doCopyFolder(d,l,c,r):await this.doCopyFile(d,i,c,r)}return n}else return d===c?(await d.rename(i,r,{overwrite:o}),n):(await this.doMoveCopy(d,i,c,r,"copy",o),await this.del(i,{recursive:!0}),"copy")}async doCopyFile(d,i,c,r){if((0,v.hasOpenReadWriteCloseCapability)(d)&&(0,v.hasOpenReadWriteCloseCapability)(c))return this.doPipeBuffered(d,i,c,r);if((0,v.hasOpenReadWriteCloseCapability)(d)&&(0,v.hasReadWriteCapability)(c))return this.doPipeBufferedToUnbuffered(d,i,c,r);if((0,v.hasReadWriteCapability)(d)&&(0,v.hasOpenReadWriteCloseCapability)(c))return this.doPipeUnbufferedToBuffered(d,i,c,r);if((0,v.hasReadWriteCapability)(d)&&(0,v.hasReadWriteCapability)(c))return this.doPipeUnbuffered(d,i,c,r)}async doCopyFolder(d,i,c,r){await c.mkdir(r),Array.isArray(i.children)&&await t.Promises.settled(i.children.map(async n=>{const o=this.getExtUri(c).providerExtUri.joinPath(r,n.name);return n.isDirectory?this.doCopyFolder(d,await this.resolve(n.resource),c,o):this.doCopyFile(d,n.resource,c,o)}))}async doValidateMoveCopy(d,i,c,r,n,o){let s=!1;if(d===c){const{providerExtUri:l,isPathCaseSensitive:g}=this.getExtUri(d);if(g||(s=l.isEqual(i,r)),s&&n==="copy")throw new Error((0,u.localize)(14,null,this.resourceForError(i),this.resourceForError(r)));if(!s&&l.isEqualOrParent(r,i))throw new Error((0,u.localize)(15,null,this.resourceForError(i),this.resourceForError(r)))}const a=await this.exists(r);if(a&&!s){if(!o)throw new v.FileOperationError((0,u.localize)(16,null,this.resourceForError(i),this.resourceForError(r)),4);if(d===c){const{providerExtUri:l}=this.getExtUri(d);if(l.isEqualOrParent(i,r))throw new Error((0,u.localize)(17,null,this.resourceForError(i),this.resourceForError(r)))}}return{exists:a,isSameResourceWithDifferentPathCase:s}}getExtUri(d){const i=this.isPathCaseSensitive(d);return{providerExtUri:i?p.extUri:p.extUriIgnorePathCase,isPathCaseSensitive:i}}isPathCaseSensitive(d){return!!(d.capabilities&1024)}async createFolder(d){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(d),d);await this.mkdirp(i,d);const c=await this.resolve(d,{resolveMetadata:!0});return this._onDidRunOperation.fire(new v.FileOperationEvent(d,0,c)),c}async mkdirp(d,i){const c=[],{providerExtUri:r}=this.getExtUri(d);for(;!r.isEqual(i,r.dirname(i));)try{if(((await d.stat(i)).type&v.FileType.Directory)==0)throw new Error((0,u.localize)(18,null,this.resourceForError(i)));break}catch(n){if((0,v.toFileSystemProviderErrorCode)(n)!==v.FileSystemProviderErrorCode.FileNotFound)throw n;c.push(r.basename(i)),i=r.dirname(i)}for(let n=c.length-1;n>=0;n--){i=r.joinPath(i,c[n]);try{await d.mkdir(i)}catch(o){if((0,v.toFileSystemProviderErrorCode)(o)!==v.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(d,i){try{await this.doValidateDelete(d,i)}catch(c){return c}return!0}async doValidateDelete(d,i){const c=this.throwIfFileSystemIsReadonly(await this.withProvider(d),d);if(!!i?.useTrash&&!(c.capabilities&4096))throw new Error((0,u.localize)(19,null,this.resourceForError(d)));let n;try{n=await c.stat(d)}catch{}if(n)this.throwIfFileIsReadonly(d,n);else throw new v.FileOperationError((0,u.localize)(20,null,this.resourceForError(d)),1);if(!!!i?.recursive){const s=await this.resolve(d);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,u.localize)(21,null,this.resourceForError(d)))}return c}async del(d,i){const c=await this.doValidateDelete(d,i),r=!!i?.useTrash,n=!!i?.recursive;await c.delete(d,{recursive:n,useTrash:r}),this._onDidRunOperation.fire(new v.FileOperationEvent(d,1))}watch(d,i={recursive:!1,excludes:[]}){const c=new C.DisposableStore;let r=!1,n=()=>{r=!0};return c.add((0,C.toDisposable)(()=>n())),(async()=>{try{const o=await this.doWatch(d,i);r?(0,C.dispose)(o):n=()=>(0,C.dispose)(o)}catch(o){this.logService.error(o)}})(),c}async doWatch(d,i){const c=await this.withProvider(d),r=(0,R.hash)([this.getExtUri(c).providerExtUri.getComparisonKey(d),i]);let n=this.activeWatchers.get(r);return n||(n={count:0,disposable:c.watch(d,i)},this.activeWatchers.set(r,n)),n.count+=1,(0,C.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,C.dispose)(n.disposable),this.activeWatchers.delete(r)))})}dispose(){super.dispose();for(const[,d]of this.activeWatchers)(0,C.dispose)(d.disposable);this.activeWatchers.clear()}async doWriteBuffered(d,i,c,r){return this.writeQueue.queueFor(i,this.getExtUri(d).providerExtUri).queue(async()=>{const n=await d.open(i,{create:!0,unlock:c?.unlock??!1});try{(0,h.isReadableStream)(r)||(0,h.isReadableBufferedStream)(r)?await this.doWriteStreamBufferedQueued(d,n,r):await this.doWriteReadableBufferedQueued(d,n,r)}catch(o){throw(0,v.ensureFileSystemProviderError)(o)}finally{await d.close(n)}})}async doWriteStreamBufferedQueued(d,i,c){let r=0,n;if((0,h.isReadableBufferedStream)(c)){if(c.buffer.length>0){const o=L.VSBuffer.concat(c.buffer);await this.doWriteBuffer(d,i,o,o.byteLength,r,0),r+=o.byteLength}if(c.ended)return;n=c.stream}else n=c;return new Promise((o,s)=>{(0,h.listenStream)(n,{onData:async a=>{n.pause();try{await this.doWriteBuffer(d,i,a,a.byteLength,r,0)}catch(l){return s(l)}r+=a.byteLength,setTimeout(()=>n.resume())},onError:a=>s(a),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(d,i,c){let r=0,n;for(;(n=c.read())!==null;)await this.doWriteBuffer(d,i,n,n.byteLength,r,0),r+=n.byteLength}async doWriteBuffer(d,i,c,r,n,o){let s=0;for(;s<r;)s+=await d.write(i,n+s,c.buffer,o+s,r-s)}async doWriteUnbuffered(d,i,c,r){return this.writeQueue.queueFor(i,this.getExtUri(d).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(d,i,c,r))}async doWriteUnbufferedQueued(d,i,c,r){let n;r instanceof L.VSBuffer?n=r:(0,h.isReadableStream)(r)?n=await(0,L.streamToBuffer)(r):(0,h.isReadableBufferedStream)(r)?n=await(0,L.bufferedStreamToBuffer)(r):n=(0,L.readableToBuffer)(r),await d.writeFile(i,n.buffer,{create:!0,overwrite:!0,unlock:c?.unlock??!1})}async doPipeBuffered(d,i,c,r){return this.writeQueue.queueFor(r,this.getExtUri(c).providerExtUri).queue(()=>this.doPipeBufferedQueued(d,i,c,r))}async doPipeBufferedQueued(d,i,c,r){let n,o;try{n=await d.open(i,{create:!1}),o=await c.open(r,{create:!0,unlock:!1});const s=L.VSBuffer.alloc(this.BUFFER_SIZE);let a=0,l=0,g=0;do g=await d.read(n,a,s.buffer,l,s.byteLength-l),await this.doWriteBuffer(c,o,s,g,a,l),a+=g,l+=g,l===s.byteLength&&(l=0);while(g>0)}catch(s){throw(0,v.ensureFileSystemProviderError)(s)}finally{await t.Promises.settled([typeof n=="number"?d.close(n):Promise.resolve(),typeof o=="number"?c.close(o):Promise.resolve()])}}async doPipeUnbuffered(d,i,c,r){return this.writeQueue.queueFor(r,this.getExtUri(c).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(d,i,c,r))}async doPipeUnbufferedQueued(d,i,c,r){return c.writeFile(r,await d.readFile(i),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(d,i,c,r){return this.writeQueue.queueFor(r,this.getExtUri(c).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(d,i,c,r))}async doPipeUnbufferedToBufferedQueued(d,i,c,r){const n=await c.open(r,{create:!0,unlock:!1});try{const o=await d.readFile(i);await this.doWriteBuffer(c,n,L.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,v.ensureFileSystemProviderError)(o)}finally{await c.close(n)}}async doPipeBufferedToUnbuffered(d,i,c,r){const n=await(0,L.streamToBuffer)(this.readFileBuffered(d,i,T.CancellationToken.None));await this.doWriteUnbuffered(c,r,void 0,n)}throwIfFileSystemIsReadonly(d,i){if(d.capabilities&2048)throw new v.FileOperationError((0,u.localize)(22,null,this.resourceForError(i)),6);return d}throwIfFileIsReadonly(d,i){if((i.permissions??0)&v.FilePermission.Readonly)throw new v.FileOperationError((0,u.localize)(23,null,this.resourceForError(d)),6)}resourceForError(d){return d.scheme===E.Schemas.file?d.fsPath:d.toString(!0)}};y=he([G(0,w.ILogService)],y),e.FileService=y}),define(te[177],ne([0,1,50,257,5,39,17,3,41,2,10,4,20,40,22,139,15,85,174,37,166,165]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p,h,u,v,m,w,y,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(k)}catch(c){console.error(`Error enabling graceful-fs: ${(0,y.toErrorMessage)(c)}`)}})();class i extends w.AbstractDiskFileSystemProvider{constructor(r,n){super(r,n);this.onDidChangeCapabilities=R.Event.None,this.resourceLocks=new T.ResourceMap(o=>f.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,E.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:n,symbolicLink:o}=await h.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(n,o),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.toFileSystemProviderError(n)}}async readdir(r){try{const n=await h.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),o=[];return await Promise.all(n.map(async s=>{try{let a;s.isSymbolicLink()?a=(await this.stat((0,f.joinPath)(r,s.name))).type:a=this.toType(s),o.push([s.name,a])}catch(a){this.logService.trace(a)}})),o}catch(n){throw this.toFileSystemProviderError(n)}}toType(r,n){let o;return n?.dangling?o=v.FileType.Unknown:r.isFile()?o=v.FileType.File:r.isDirectory()?o=v.FileType.Directory:o=v.FileType.Unknown,n&&(o|=v.FileType.SymbolicLink),o}async createResourceLock(r){const n=this.toFilePath(r);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let o;for(;o=this.resourceLocks.get(r);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await o.wait();const s=new L.Barrier;return this.resourceLocks.set(r,s),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,C.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.resourceLocks.get(r)===s&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.resourceLocks.delete(r)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),s.open()})}async readFile(r,n){let o;try{n?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(r)})`),o=await this.createResourceLock(r));const s=this.toFilePath(r);return await h.Promises.readFile(s)}catch(s){throw this.toFileSystemProviderError(s)}finally{o?.dispose()}}readFileStream(r,n,o){const s=(0,p.newWriteableStream)(a=>A.VSBuffer.concat(a.map(l=>A.VSBuffer.wrap(l))).buffer);return(0,m.readFileIntoStream)(this,r,s,a=>a.buffer,{...n,bufferSize:256*1024},o),s}async writeFile(r,n,o){let s;try{const a=this.toFilePath(r);if(!o.create||!o.overwrite){if(await h.Promises.exists(a)){if(!o.overwrite)throw(0,v.createFileSystemProviderError)((0,u.localize)(0,null),v.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,v.createFileSystemProviderError)((0,u.localize)(1,null),v.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(r,{create:!0,unlock:o.unlock}),await this.write(s,0,n,0,n.byteLength)}catch(a){throw await this.toFileSystemProviderWriteError(r,a)}finally{typeof s=="number"&&await this.close(s)}}async open(r,n){const o=this.toFilePath(r);let s;(0,v.isFileOpenForWriteOptions)(n)&&(s=await this.createResourceLock(r));let a;try{if((0,v.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:g}=await h.SymlinkSupport.stat(o);g.mode&128||await h.Promises.chmod(o,g.mode|128)}catch(g){this.logService.trace(g)}let l;if((0,v.isFileOpenForWriteOptions)(n)){if(E.isWindows)try{await h.Promises.truncate(o,0),l="r+"}catch(g){g.code!=="ENOENT"&&this.logService.trace(g)}l||(l="w")}else l="r";a=await h.Promises.open(o,l)}catch(l){throw s?.dispose(),(0,v.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(r,l):this.toFileSystemProviderError(l)}if(this.mapHandleToPos.set(a,0),(0,v.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(a,r),s){const l=this.mapHandleToLock.get(a);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${o})`),this.mapHandleToLock.set(a,s),l&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${o})`),l.dispose())}return a}async close(r){const n=this.mapHandleToLock.get(r);try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&this.canFlush)try{await h.Promises.fdatasync(r)}catch(o){this.canFlush=!1,this.logService.error(o)}return await h.Promises.close(r)}catch(o){throw this.toFileSystemProviderError(o)}finally{n&&(this.mapHandleToLock.get(r)===n&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.mapHandleToLock.delete(r)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),n.dispose())}}async read(r,n,o,s,a){const l=this.normalizePos(r,n);let g=null;try{g=(await h.Promises.read(r,o,s,a,l)).bytesRead}catch(I){throw this.toFileSystemProviderError(I)}finally{this.updatePos(r,l,g)}return g}normalizePos(r,n){return n===this.mapHandleToPos.get(r)?null:n}updatePos(r,n,o){const s=this.mapHandleToPos.get(r);typeof s=="number"&&(typeof n=="number"||(typeof o=="number"?this.mapHandleToPos.set(r,s+o):this.mapHandleToPos.delete(r)))}async write(r,n,o,s,a){return(0,L.retry)(()=>this.doWrite(r,n,o,s,a),100,3)}async doWrite(r,n,o,s,a){const l=this.normalizePos(r,n);let g=null;try{g=(await h.Promises.write(r,o,s,a,l)).bytesWritten}catch(I){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),I)}finally{this.updatePos(r,l,g)}return g}async mkdir(r){try{await h.Promises.mkdir(this.toFilePath(r))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(r,n){try{const o=this.toFilePath(r);n.recursive?await h.Promises.rm(o,h.RimRafMode.MOVE):await h.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(r,n,o){const s=this.toFilePath(r),a=this.toFilePath(n);if(s!==a)try{await this.validateTargetDeleted(r,n,"move",o.overwrite),await h.Promises.move(s,a)}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,u.localize)(2,null,(0,P.basename)(s),(0,P.basename)((0,P.dirname)(a)),l.toString()))),this.toFileSystemProviderError(l)}}async copy(r,n,o){const s=this.toFilePath(r),a=this.toFilePath(n);if(s!==a)try{await this.validateTargetDeleted(r,n,"copy",o.overwrite),await h.Promises.copy(s,a,{preserveSymlinks:!0})}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,u.localize)(3,null,(0,P.basename)(s),(0,P.basename)((0,P.dirname)(a)),l.toString()))),this.toFileSystemProviderError(l)}}async validateTargetDeleted(r,n,o,s){const a=this.toFilePath(r),l=this.toFilePath(n);let g=!1;if(!!(this.capabilities&1024)||(g=(0,b.isEqual)(a,l,!0)),g&&o==="copy")throw(0,v.createFileSystemProviderError)((0,u.localize)(4,null),v.FileSystemProviderErrorCode.FileExists);if(!g&&await h.Promises.exists(l)){if(!s)throw(0,v.createFileSystemProviderError)((0,u.localize)(5,null),v.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}createUniversalWatcher(r,n,o){return new S.UniversalWatcherClient(s=>r(s),s=>n(s),o)}createNonRecursiveWatcher(r,n,o){return new d.NodeJSWatcherClient(s=>r(s),s=>n(s),o)}toFileSystemProviderError(r){if(r instanceof v.FileSystemProviderError)return r;let n;switch(r.code){case"ENOENT":n=v.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=v.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=v.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=v.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=v.FileSystemProviderErrorCode.NoPermissions;break;default:n=v.FileSystemProviderErrorCode.Unknown}return(0,v.createFileSystemProviderError)(r,n)}async toFileSystemProviderWriteError(r,n){let o=this.toFileSystemProviderError(n);if(r&&o.code===v.FileSystemProviderErrorCode.NoPermissions)try{const{stat:s}=await h.SymlinkSupport.stat(this.toFilePath(r));s.mode&128||(o=(0,v.createFileSystemProviderError)(n,v.FileSystemProviderErrorCode.FileWriteLocked))}catch(s){this.logService.trace(s)}return o}}e.DiskFileSystemProvider=i}),define(te[87],ne([0,1,3,7,8]),function(K,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class T{constructor(f){this.service=f,this.onDidChangeLogLevel=k.Event.buffer(f.onDidChangeLogLevel,!0)}listen(f,p){switch(p){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${p}`)}async call(f,p,h){switch(p){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${p}`)}}e.LogLevelChannel=T;class A{constructor(f){this.channel=f}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(f){A.setLevel(this.channel,f)}static setLevel(f,p){return f.call("setLevel",p)}}e.LogLevelChannelClient=A;class R{constructor(f){this.loggerService=f,this.loggers=new Map}listen(f,p){throw new Error(`Event not found: ${p}`)}async call(f,p,h){switch(p){case"createLogger":this.createLogger(t.URI.revive(h[0]),h[1]);return;case"log":return this.log(t.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${p}`)}createLogger(f,p){this.loggers.set(f.toString(),this.loggerService.createLogger(f,p))}consoleLog(f,p){let h=console.log;switch(f){case L.LogLevel.Error:h=console.error;break;case L.LogLevel.Warning:h=console.warn;break;case L.LogLevel.Info:h=console.info;break}h.call(console,...p)}log(f,p){const h=this.loggers.get(f.toString());if(!h)throw new Error("Create the logger before logging");for(const[u,v]of p)(0,L.log)(h,u,v)}}e.LoggerChannel=R;class b extends L.AbstractLoggerService{constructor(f,p,h){super(f,p);this.channel=h}createConsoleMainLogger(){return new L.AdapterLogger({log:(f,p)=>{this.channel.call("consoleLog",[f,p])}})}doCreateLogger(f,p,h){return new C(this.channel,f,p,h)}}e.LoggerChannelClient=b;class C extends L.AbstractMessageLogger{constructor(f,p,h,u){super(u?.always);this.channel=f,this.file=p,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[p,u]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(f,p){const h=[[f,p]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(f){this.channel.call("log",[this.file,f])}}class P extends L.LogService{constructor(f,p){super(p);this.parent=f,this._register(f.onDidChangeLogLevel(h=>p.setLevel(h)))}setLevel(f){super.setLevel(f),this.parent.setLevel(f)}}e.FollowerLogService=P}),define(te[60],ne([0,1,6]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,k.createDecorator)("nativeHostService")}),define(te[88],ne([0,1,18,4,33,20]),function(K,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.context!="undefined"){const R=t.globals.vscode.context.configuration();if(R)A=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof K?.__$__nodeRequire=="function"){const R=(0,T.dirname)(k.FileAccess.asFileUri("",K));A=K.__$__nodeRequire((0,T.joinPath)(R,"product.json").fsPath);const b=K.__$__nodeRequire((0,T.joinPath)(R,"package.json").fsPath);L.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`,serverDataFolderName:A.serverDataFolderName?`${A.serverDataFolderName}-dev`:void 0}),Object.assign(A,{version:b.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.65.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=A}),define(te[27],ne([0,1,6]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,k.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(te[178],ne([0,1,5,9,2,10,22,8,27]),function(K,e,k,t,L,T,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let C=class extends L.Disposable{constructor(E,f,p){super();this.productService=f,this.logService=p,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,E&&this._register(new k.RunOnceScheduler(()=>{this.cleanUpCodeCaches(E)},30*1e3)).schedule()}async cleanUpCodeCaches(E){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const f=Date.now(),p=(0,T.dirname)(E),h=(0,T.basename)(E),u=await A.Promises.readdir(p);await Promise.all(u.map(async v=>{if(v===h)return;const m=(0,T.join)(p,v),w=await A.Promises.stat(m);if(w.isDirectory()&&f-w.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${v}.`),A.Promises.rm(m)}))}catch(f){(0,t.onUnexpectedError)(f)}}};C=he([G(1,b.IProductService),G(2,R.ILogService)],C),e.CodeCacheCleaner=C}),define(te[179],ne([0,1,5,9,2,10,22,14,8,27]),function(K,e,k,t,L,T,A,R,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let P=class extends L.Disposable{constructor(f,p,h){super();this.environmentService=f,this.logService=p,this.productService=h,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new k.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const f=Object.create(null),p=JSON.parse(await A.Promises.readFile((0,T.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let w of Object.keys(p)){const y=p[w];f[`${y.hash}.${w}`]=!0}const h=(0,T.join)(this.environmentService.userDataPath,"clp");if(!await A.Promises.exists(h))return;const v=await A.Promises.readdir(h);for(const w of v){if(f[w]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${w}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${w}`),await A.Promises.rm((0,T.join)(h,w))}const m=Date.now();for(const w of Object.keys(f)){const y=(0,T.join)(h,w),S=await A.Promises.readdir(y);for(const d of S){if(d==="tcf.json")continue;const i=(0,T.join)(y,d),c=await A.Promises.stat(i);c.isDirectory()&&m-c.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,T.join)(w,d)}`),await A.Promises.rm(i))}}}catch(f){(0,t.onUnexpectedError)(f)}}};P=he([G(0,R.INativeEnvironmentService),G(1,b.ILogService),G(2,C.IProductService)],P),e.LanguagePackCachedDataCleaner=P}),define(te[180],ne([0,1,10,6]),function(K,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,t.createDecorator)("IV8InspectProfilingService");var L;(function(T){function A(R,b="noAbsolutePaths"){for(const C of R.nodes)C.callFrame&&C.callFrame.url&&((0,k.isAbsolute)(C.callFrame.url)||/^\w[\w\d+.-]*:\/\/\//.test(C.callFrame.url))&&(C.callFrame.url=(0,k.join)(b,(0,k.basename)(C.callFrame.url)));return R}T.rewriteAbsolutePaths=A})(L=e.Utils||(e.Utils={}))}),define(te[181],ne([0,1,29]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class t{constructor(){this._sessions=new Map}async startProfiling(T){const R=await(await new Promise((C,P)=>{K(["v8-inspect-profiler"],C,P)})).startProfiling({port:T.port,checkForPaused:!0}),b=(0,k.generateUuid)();return this._sessions.set(b,R),b}async stopProfiling(T){const A=this._sessions.get(T);if(!A)throw new Error(`UNKNOWN session '${T}'`);const R=await A.stop();return this._sessions.delete(T),R.profile}}e.InspectProfilingService=t}),define(te[38],ne([0,1,99,11]),function(K,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class L{constructor(){this.data=new Map}add(A,R){k.ok(t.isString(A)),k.ok(t.isObject(R)),k.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,R)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new L}),define(te[89],ne([0,1,3,38]),function(K,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function L(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class T{constructor(){this._onDidChangeSchema=new k.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(b,C){this.schemasById[L(b)]=C,this._onDidChangeSchema.fire(b)}notifySchemaChanged(b){this._onDidChangeSchema.fire(b)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new T;t.Registry.add(e.Extensions.JSONContribution,A)}),define(te[42],ne([0,1,16,3,11,126,89,38]),function(K,e,k,t,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var b;(function(S){S.Multiline="multilineText",S.Singleline="singlelineText"})(b=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var C;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const P=R.Registry.as(A.Extensions.JSONContribution);class E{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(d,i=!0){this.registerConfigurations([d],i)}registerConfigurations(d,i=!0){const c=this.doRegisterConfigurations(d,i);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c})}deregisterConfigurations(d){const i=this.doDeregisterConfigurations(d);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}updateConfigurations({add:d,remove:i}){const c=[];c.push(...this.doDeregisterConfigurations(i)),c.push(...this.doRegisterConfigurations(d,!1)),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,k.distinct)(c)})}registerDefaultConfigurations(d){const i=[],c=[];for(const{overrides:r,source:n}of d)for(const o in r)if(i.push(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){const s={...this.configurationDefaultsOverrides.get(o)?.value||{},...r[o]};this.configurationDefaultsOverrides.set(o,{source:n,value:s});const a={type:"object",default:s,description:T.localize(1,null,o),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:s,source:L.isString(n)?void 0:n};c.push(...h(o)),this.configurationProperties[o]=a,this.defaultLanguageConfigurationOverridesNode.properties[o]=a}else{this.configurationDefaultsOverrides.set(o,{value:r[o],source:n});const s=this.configurationProperties[o];s&&(this.updatePropertyDefaultValue(o,s),this.updateSchema(o,s))}this.registerOverrideIdentifiers(c),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i,defaultsOverrides:!0})}deregisterDefaultConfigurations(d){const i=[];for(const{overrides:c,source:r}of d)for(const n in c){const o=this.configurationDefaultsOverrides.get(n),s=L.isString(r)?r:r?.id,a=L.isString(o?.source)?o?.source:o?.source?.id;if(s===a)if(i.push(n),this.configurationDefaultsOverrides.delete(n),e.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const l=this.configurationProperties[n];l&&(this.updatePropertyDefaultValue(n,l),this.updateSchema(n,l))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...d){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(d){for(const i of d)this.overrideIdentifiers.add(i);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(d,i){const c=[];return d.forEach(r=>{c.push(...this.validateAndRegisterProperties(r,i,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),c}doDeregisterConfigurations(d){const i=[],c=r=>{if(r.properties)for(const n in r.properties)i.push(n),delete this.configurationProperties[n],this.removeFromSchema(n,r.properties[n]);r.allOf&&r.allOf.forEach(n=>c(n))};for(const r of d){c(r);const n=this.configurationContributors.indexOf(r);n!==-1&&this.configurationContributors.splice(n,1)}return i}validateAndRegisterProperties(d,i=!0,c,r,n=3){n=L.isUndefinedOrNull(d.scope)?n:d.scope;let o=[],s=d.properties;if(s)for(let l in s){if(i&&w(l)){delete s[l];continue}const g=s[l];if(g.source=c,g.defaultDefaultValue=s[l].default,this.updatePropertyDefaultValue(l,g),e.OVERRIDE_PROPERTY_REGEX.test(l)?g.scope=void 0:(g.scope=L.isUndefinedOrNull(g.scope)?n:g.scope,g.restricted=L.isUndefinedOrNull(g.restricted)?!!r?.includes(l):g.restricted),s[l].hasOwnProperty("included")&&!s[l].included){this.excludedConfigurationProperties[l]=s[l],delete s[l];continue}else this.configurationProperties[l]=s[l];!s[l].deprecationMessage&&s[l].markdownDeprecationMessage&&(s[l].deprecationMessage=s[l].markdownDeprecationMessage),o.push(l)}let a=d.allOf;if(a)for(let l of a)o.push(...this.validateAndRegisterProperties(l,i,c,r,n));return o}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(d){const i=c=>{let r=c.properties;if(r)for(const o in r)this.updateSchema(o,r[o]);let n=c.allOf;n&&n.forEach(i)};i(d)}updateSchema(d,i){switch(e.allSettings.properties[d]=i,i.scope){case 1:e.applicationSettings.properties[d]=i;break;case 2:e.machineSettings.properties[d]=i;break;case 6:e.machineOverridableSettings.properties[d]=i;break;case 3:e.windowSettings.properties[d]=i;break;case 4:e.resourceSettings.properties[d]=i;break;case 5:e.resourceSettings.properties[d]=i,this.resourceLanguageSettingsSchema.properties[d]=i;break}}removeFromSchema(d,i){switch(delete e.allSettings.properties[d],i.scope){case 1:delete e.applicationSettings.properties[d];break;case 2:delete e.machineSettings.properties[d];break;case 6:delete e.machineOverridableSettings.properties[d];break;case 3:delete e.windowSettings.properties[d];break;case 4:case 5:delete e.resourceSettings.properties[d],delete this.resourceLanguageSettingsSchema.properties[d];break}}updateOverridePropertyPatternKey(){for(const d of this.overrideIdentifiers.values()){const i=`[${d}]`,c={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(i,c),e.allSettings.properties[i]=c,e.applicationSettings.properties[i]=c,e.machineSettings.properties[i]=c,e.machineOverridableSettings.properties[i]=c,e.windowSettings.properties[i]=c,e.resourceSettings.properties[i]=c}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const d={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=d,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=d,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=d,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=d,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=d,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=d,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(d,i){const c=this.configurationDefaultsOverrides.get(d);let r=c?.value,n=c?.source;L.isUndefined(r)&&(r=i.defaultDefaultValue,n=void 0),L.isUndefined(r)&&(r=v(i.type)),i.default=r,i.defaultValueSource=n}}const f="\\[([^\\]]+)\\]",p=new RegExp(f,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${f})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function h(S){const d=[];if(e.OVERRIDE_PROPERTY_REGEX.test(S)){let i=p.exec(S);for(;i?.length;){const c=i[1].trim();c&&d.push(c),i=p.exec(S)}}return(0,k.distinct)(d)}e.overrideIdentifiersFromKey=h;function u(S){return S.reduce((d,i)=>`${d}[${i}]`,"")}e.keyFromOverrideIdentifiers=u;function v(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=v;const m=new E;R.Registry.add(e.Extensions.Configuration,m);function w(S){return S.trim()?e.OVERRIDE_PROPERTY_REGEX.test(S)?T.localize(7,null,S):m.getConfigurationProperties()[S]!==void 0?T.localize(8,null,S):null:T.localize(6,null)}e.validateProperty=w;function y(){const S=[],d=m.getConfigurationProperties();for(const i of Object.keys(d))S.push([i,d[i].scope]);return S.push(["launch",4]),S.push(["task",4]),S}e.getScopes=y}),define(te[90],ne([0,1,16,3,35,2,39,28,11,7,19,42,38]),function(K,e,k,t,L,T,A,R,b,C,P,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(r={},n=[],o=[]){this._contents=r,this._keys=n,this._overrides=o,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,P.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,n){const o=this.getContentsForOverrideIdentifer(n);return o?r?(0,P.getConfigurationValue)(o,r):o:void 0}getKeysForOverrideIdentifier(r){const n=[];for(const o of this.overrides)o.identifiers.includes(r)&&n.push(...o.keys);return k.distinct(n)}getAllOverrideIdentifiers(){const r=[];for(const n of this.overrides)r.push(...n.identifiers);return k.distinct(r)}override(r){let n=this.overrideConfigurations.get(r);return n||(n=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,n)),n}merge(...r){const n=R.deepClone(this.contents),o=R.deepClone(this.overrides),s=[...this.keys];for(const a of r){this.mergeContents(n,a.contents);for(const l of a.overrides){const[g]=o.filter(I=>k.equals(I.identifiers,l.identifiers));g?(this.mergeContents(g.contents,l.contents),g.keys.push(...l.keys),g.keys=k.distinct(g.keys)):o.push(R.deepClone(l))}for(const l of a.keys)s.indexOf(l)===-1&&s.push(l)}return new p(n,s,o)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(r){const n=this.getContentsForOverrideIdentifer(r);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let o={};for(const s of k.distinct([...Object.keys(this.contents),...Object.keys(n)])){let a=this.contents[s],l=n[s];l&&(typeof a=="object"&&typeof l=="object"?(a=R.deepClone(a),this.mergeContents(a,l)):a=l),o[s]=a}return new p(o,this.keys,this.overrides)}mergeContents(r,n){for(const o of Object.keys(n)){if(o in r&&b.isObject(r[o])&&b.isObject(n[o])){this.mergeContents(r[o],n[o]);continue}r[o]=R.deepClone(n[o])}}checkAndFreeze(r){return this.isFrozen&&!Object.isFrozen(r)?R.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let n=null,o=null;const s=a=>{a&&(o?this.mergeContents(o,a):o=R.deepClone(a))};for(const a of this.overrides)k.equals(a.identifiers,[r])?n=a.contents:a.identifiers.includes(r)&&s(a.contents);return s(n),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,n){this.addKey(r),(0,P.addToValueTree)(this.contents,r,n,o=>{throw new Error(o)})}removeValue(r){this.removeKey(r)&&(0,P.removeFromValueTree)(this.contents,r)}addKey(r){let n=this.keys.length;for(let o=0;o<n;o++)r.indexOf(this.keys[o])===0&&(n=o);this.keys.splice(n,1,r)}removeKey(r){let n=this.keys.indexOf(r);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=p;class h extends p{constructor(r={}){const n=f.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),o=Object.keys(n),s=Object.create(null),a=[];for(const l in n){const g=r[l],I=g!==void 0?g:n[l].default;(0,P.addToValueTree)(s,l,I,_=>console.error(`Conflict in default settings: ${_}`))}for(const l of Object.keys(s))E.OVERRIDE_PROPERTY_REGEX.test(l)&&a.push({identifiers:(0,E.overrideIdentifiersFromKey)(l),keys:Object.keys(s[l]),contents:(0,P.toValuesTree)(s[l],g=>console.error(`Conflict in default settings file: ${g}`))});super(s,o,a)}}e.DefaultConfigurationModel=h;class u{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,n){if(!b.isUndefinedOrNull(r)){const o=this.doParseContent(r);this.parseRaw(o,n)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,n){this._raw=r;const{contents:o,keys:s,overrides:a,restricted:l}=this.doParseRaw(r,n);this._configurationModel=new p(o,s,a),this._restrictedConfigurations=l||[]}doParseContent(r){let n={},o=null,s=[],a=[],l=[];function g(_){Array.isArray(s)?s.push(_):o!==null&&(s[o]=_)}let I={onObjectBegin:()=>{let _={};g(_),a.push(s),s=_,o=null},onObjectProperty:_=>{o=_},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{let _=[];g(_),a.push(s),s=_,o=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:g,onError:(_,O,U)=>{l.push({error:_,offset:O,length:U})}};if(r)try{L.visit(r,I),n=s[0]||{}}catch(_){console.error(`Error while parsing settings file ${this._name}: ${_}`),this._parseErrors=[_]}return n}doParseRaw(r,n){const o=f.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),s=this.filter(r,o,!0,n);r=s.raw;const a=(0,P.toValuesTree)(r,I=>console.error(`Conflict in settings file ${this._name}: ${I}`)),l=Object.keys(r),g=this.toOverrides(r,I=>console.error(`Conflict in settings file ${this._name}: ${I}`));return{contents:a,keys:l,overrides:g,restricted:s.restricted}}filter(r,n,o,s){if(!s?.scopes&&!s?.skipRestricted)return{raw:r,restricted:[]};const a={},l=[];for(let g in r)if(E.OVERRIDE_PROPERTY_REGEX.test(g)&&o){const I=this.filter(r[g],n,!1,s);a[g]=I.raw,l.push(...I.restricted)}else{const I=n[g],_=I?typeof I.scope!="undefined"?I.scope:3:void 0;I?.restricted&&l.push(g),(_===void 0||s.scopes===void 0||s.scopes.includes(_))&&(s.skipRestricted&&I?.restricted||(a[g]=r[g]))}return{raw:a,restricted:l}}toOverrides(r,n){const o=[];for(const s of Object.keys(r))if(E.OVERRIDE_PROPERTY_REGEX.test(s)){const a={};for(const l in r[s])a[l]=r[s][l];o.push({identifiers:(0,E.overrideIdentifiersFromKey)(s),keys:Object.keys(a),contents:(0,P.toValuesTree)(a,n)})}return o}}e.ConfigurationModelParser=u;class v extends T.Disposable{constructor(r,n,o,s){super();this.userSettingsResource=r,this.scopes=n,this.fileService=s,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new u(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(1)||a.isOperation(4))&&o.isEqual(a.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=v;class m{constructor(r,n,o=new p,s=new p,a=new A.ResourceMap,l=new p,g=new A.ResourceMap,I=!0){this._defaultConfiguration=r,this._localUserConfiguration=n,this._remoteUserConfiguration=o,this._workspaceConfiguration=s,this._folderConfigurations=a,this._memoryConfiguration=l,this._memoryConfigurationByResource=g,this._freeze=I,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(r,n,o){return this.getConsolidateConfigurationModel(n,o).getValue(r)}updateValue(r,n,o={}){let s;o.resource?(s=this._memoryConfigurationByResource.get(o.resource),s||(s=new p,this._memoryConfigurationByResource.set(o.resource,s))):s=this._memoryConfiguration,n===void 0?s.removeValue(r):s.setValue(r,n),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,n,o){const s=this.getConsolidateConfigurationModel(n,o),a=this.getFolderConfigurationModelForResource(n.resource,o),l=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,g=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),I=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),_=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),O=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),U=o?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,D=a?n.overrideIdentifier?a.freeze().override(n.overrideIdentifier).getValue(r):a.freeze().getValue(r):void 0,M=n.overrideIdentifier?l.override(n.overrideIdentifier).getValue(r):l.getValue(r),N=s.getValue(r),x=k.distinct(k.flatten(s.overrides.map(Q=>Q.identifiers))).filter(Q=>s.getOverrideValue(r,Q)!==void 0);return{defaultValue:g,userValue:I,userLocalValue:_,userRemoteValue:O,workspaceValue:U,workspaceFolderValue:D,memoryValue:M,value:N,default:g!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,user:I!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,userLocal:_!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,userRemote:O!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,workspace:U!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,workspaceFolder:D!==void 0?{value:a?.freeze().getValue(r),override:n.overrideIdentifier?a?.freeze().getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,memory:M!==void 0?{value:l.getValue(r),override:n.overrideIdentifier?l.getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:x.length?x:void 0}}keys(r){const n=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,n){this._folderConfigurations.set(r,n),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,n){const o=[];if(!n){const{added:s,updated:a,removed:l}=d(this._defaultConfiguration,r);n=[...s,...a,...l]}for(const s of n)for(const a of(0,E.overrideIdentifiersFromKey)(s)){const l=this._defaultConfiguration.getKeysForOverrideIdentifier(a),g=r.getKeysForOverrideIdentifier(a),I=[...g.filter(_=>l.indexOf(_)===-1),...l.filter(_=>g.indexOf(_)===-1),...l.filter(_=>!R.equals(this._defaultConfiguration.override(a).getValue(_),r.override(a).getValue(_)))];o.push([a,I])}return this.updateDefaultConfiguration(r),{keys:n,overrides:o}}compareAndUpdateLocalUserConfiguration(r){const{added:n,updated:o,removed:s,overrides:a}=d(this.localUserConfiguration,r),l=[...n,...o,...s];return l.length&&this.updateLocalUserConfiguration(r),{keys:l,overrides:a}}compareAndUpdateRemoteUserConfiguration(r){const{added:n,updated:o,removed:s,overrides:a}=d(this.remoteUserConfiguration,r);let l=[...n,...o,...s];return l.length&&this.updateRemoteUserConfiguration(r),{keys:l,overrides:a}}compareAndUpdateWorkspaceConfiguration(r){const{added:n,updated:o,removed:s,overrides:a}=d(this.workspaceConfiguration,r);let l=[...n,...o,...s];return l.length&&this.updateWorkspaceConfiguration(r),{keys:l,overrides:a}}compareAndUpdateFolderConfiguration(r,n){const o=this.folderConfigurations.get(r),{added:s,updated:a,removed:l,overrides:g}=d(o,n);let I=[...s,...a,...l];return(I.length||!o)&&this.updateFolderConfiguration(r,n),{keys:I,overrides:g}}compareAndDeleteFolderConfiguration(r){const n=this.folderConfigurations.get(r);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:o,updated:s,removed:a,overrides:l}=d(n,void 0);return{keys:[...o,...s,...a],overrides:l}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(r,n){let o=this.getConsolidatedConfigurationModelForResource(r,n);return r.overrideIdentifier?o.override(r.overrideIdentifier):o}getConsolidatedConfigurationModelForResource({resource:r},n){let o=this.getWorkspaceConsolidatedConfiguration();if(n&&r){const s=n.getFolder(r);s&&(o=this.getFolderConsolidatedConfiguration(s.uri)||o);const a=this._memoryConfigurationByResource.get(r);a&&(o=o.merge(a))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let n=this._foldersConsolidatedConfigurations.get(r);if(!n){const o=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(r);s?(n=o.merge(s),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(r,n)):n=o}return n}getFolderConfigurationModelForResource(r,n){if(n&&r){const o=n.getFolder(r);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,n)=>{const{contents:o,overrides:s,keys:a}=this._folderConfigurations.get(n);return r.push([n,{contents:o,overrides:s,keys:a}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>r.add(n)),this.userConfiguration.freeze().keys.forEach(n=>r.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>r.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(o=>r.add(o))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(o=>r.add(o))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(o=>n.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(o=>n.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(o=>n.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(r).forEach(s=>n.add(s))),[...n.values()]}static parse(r){const n=this.parseConfigurationModel(r.defaults),o=this.parseConfigurationModel(r.user),s=this.parseConfigurationModel(r.workspace),a=r.folders.reduce((l,g)=>(l.set(C.URI.revive(g[0]),this.parseConfigurationModel(g[1])),l),new A.ResourceMap);return new m(n,o,new p,s,a,new p,new A.ResourceMap,!1)}static parseConfigurationModel(r){return new p(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=m;function w(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const r=new Set,n=new Map;for(const s of c)s.keys.forEach(a=>r.add(a)),s.overrides.forEach(([a,l])=>{const g=(0,A.getOrSet)(n,a,new Set);l.forEach(I=>g.add(I))});const o=[];return n.forEach((s,a)=>o.push([a,[...s.values()]])),{keys:[...r.values()],overrides:o}}e.mergeChanges=w;class y{constructor(r,n,o,s){this.change=r,this.previous=n,this.currentConfiguraiton=o,this.currentWorkspace=s,this._previousConfiguration=void 0;const a=new Set;r.keys.forEach(g=>a.add(g)),r.overrides.forEach(([,g])=>g.forEach(I=>a.add(I))),this.affectedKeys=[...a.values()];const l=new p;this.affectedKeys.forEach(g=>l.setValue(g,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=m.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(n){const o=this.previousConfiguration?this.previousConfiguration.getValue(r,n,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(r,n,this.currentWorkspace);return!R.equals(o,s)}return!0}return!1}doesAffectedKeysTreeContains(r,n){let o=(0,P.toValuesTree)({[n]:!0},()=>{}),s;for(;typeof o=="object"&&(s=Object.keys(o)[0]);){if(r=r[s],!r)return!1;o=o[s]}return!0}}e.ConfigurationChangeEvent=y;class S extends y{constructor(r,n,o,s){super({keys:r.allKeys(),overrides:[]},void 0,r,n);this.source=o,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=S;function d(c,r){const{added:n,removed:o,updated:s}=i(r,c),a=[],l=c?.getAllOverrideIdentifiers()||[],g=r?.getAllOverrideIdentifiers()||[];if(r){const I=g.filter(_=>!l.includes(_));for(const _ of I)a.push([_,r.getKeysForOverrideIdentifier(_)])}if(c){const I=l.filter(_=>!g.includes(_));for(const _ of I)a.push([_,c.getKeysForOverrideIdentifier(_)])}if(r&&c){for(const I of l)if(g.includes(I)){const _=i({contents:c.getOverrideValue(void 0,I)||{},keys:c.getKeysForOverrideIdentifier(I)},{contents:r.getOverrideValue(void 0,I)||{},keys:r.getKeysForOverrideIdentifier(I)});a.push([I,[..._.added,..._.removed,..._.updated]])}}return{added:n,removed:o,updated:s,overrides:a}}function i(c,r){const n=c?r?c.keys.filter(a=>r.keys.indexOf(a)===-1):[...c.keys]:[],o=r?c?r.keys.filter(a=>c.keys.indexOf(a)===-1):[...r.keys]:[],s=[];if(c&&r){for(const a of r.keys)if(c.keys.indexOf(a)!==-1){const l=(0,P.getConfigurationValue)(r.contents,a),g=(0,P.getConfigurationValue)(c.contents,a);R.equals(l,g)||s.push(a)}}return{added:n,removed:o,updated:s}}}),define(te[182],ne([0,1,5,3,2,20,19,90,42,38]),function(K,e,k,t,L,T,A,R,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class P extends L.Disposable{constructor(f,p){super();this.settingsResource=f,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new R.UserSettings(this.settingsResource,void 0,T.extUriBiasedIgnorePathCase,p)),this.configuration=new R.Configuration(new R.DefaultConfigurationModel,new R.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new k.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(C.Registry.as(b.Extensions.Configuration).onDidUpdateConfiguration(({properties:h})=>this.onDidDefaultConfigurationChange(h))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const f=await this.userConfiguration.loadConfiguration();this.configuration=new R.Configuration(new R.DefaultConfigurationModel,f)}getConfigurationData(){return this.configuration.toData()}getValue(f,p){const h=typeof f=="string"?f:void 0,u=(0,A.isConfigurationOverrides)(f)?f:(0,A.isConfigurationOverrides)(p)?p:{};return this.configuration.getValue(h,u,void 0)}updateValue(f,p,h,u){return Promise.reject(new Error("not supported"))}inspect(f){return this.configuration.inspect(f,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const f=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(f)}onDidChangeUserConfiguration(f){const p=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(f);this.trigger(h,p,1)}onDidDefaultConfigurationChange(f){const p=this.configuration.toData(),h=this.configuration.compareAndUpdateDefaultConfiguration(new R.DefaultConfigurationModel,f);this.trigger(h,p,6)}trigger(f,p,h){const u=new R.ConfigurationChangeEvent(f,{data:p},this.configuration);u.source=h,u.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(u)}getTargetConfiguration(f){switch(f){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=P}),define(te[183],ne([0,1,6]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,k.createDecorator)("remoteAuthorityResolverService");var t;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(t=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class L extends Error{constructor(A,R=t.Unknown,b){super(A);this._message=A,this._code=R,this._detail=b,this.isHandled=R===t.NotAvailable&&b===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,L.prototype)}static isTemporarilyNotAvailable(A){return A instanceof L&&A._code===t.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof L&&A._code===t.NoResolverFound}static isHandled(A){return A instanceof L&&A.isHandled}}e.RemoteAuthorityResolverError=L}),define(te[184],ne([0,1,5,17,25,9,3,2,29,74,183]),function(K,e,k,t,L,T,A,R,b,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const E=30*1e3;var f;(function(V){V[V.Management=1]="Management",V[V.ExtensionHost=2]="ExtensionHost",V[V.Tunnel=3]="Tunnel"})(f=e.ConnectionType||(e.ConnectionType={}));function p(V){switch(V){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(V){const J=new L.CancellationTokenSource;return setTimeout(()=>J.cancel(),V),J.token}function u(V,J){if(V.isCancellationRequested||J.isCancellationRequested)return L.CancellationToken.Cancelled;const Z=new L.CancellationTokenSource;return V.onCancellationRequested(()=>Z.cancel()),J.onCancellationRequested(()=>Z.cancel()),Z.token}class v{constructor(J){this._state="pending",this._disposables=new R.DisposableStore,this.promise=new Promise((Z,q)=>{this._resolvePromise=Z,this._rejectPromise=q}),J.isCancellationRequested?this._timeout():this._disposables.add(J.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(J){this._state==="pending"?this._disposables.add(J):J.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const J=new Error("Time limit reached");return J.code="ETIMEDOUT",J.syscall="connect",J}resolve(J){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(J))}reject(J){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(J))}}function m(V,J){const Z=new v(J);return Z.registerDisposable(V.onControlMessage(q=>{const F=JSON.parse(q.toString()),$=W(F);$?Z.reject($):Z.resolve(F)})),Z.promise}function w(V,J,Z,q,F,$,z){const H=new v(z);return J.connect(Z,q,F,$,(ee,se)=>{H.didTimeout?(ee&&V.error(ee),se?.dispose()):ee||!se?H.reject(ee):H.resolve(se)}),H.promise}function y(V,J){const Z=new v(J);return V.then(q=>{Z.didTimeout||Z.resolve(q)},q=>{Z.didTimeout||Z.reject(q)}),Z.promise}async function S(V,J,Z,q){const F=j(V,J);V.logService.trace(`${F} 1/6. invoking socketFactory.connect().`);let $;try{$=await w(V.logService,V.socketFactory,V.host,V.port,`reconnectionToken=${V.reconnectionToken}&reconnection=${V.reconnectionProtocol?"true":"false"}`,`renderer-${p(J)}-${V.reconnectionToken}`,q)}catch(ae){throw V.logService.error(`${F} socketFactory.connect() failed or timed out. Error:`),V.logService.error(ae),ae}V.logService.trace(`${F} 2/6. socketFactory.connect() was successful.`);let z,H;V.reconnectionProtocol?(V.reconnectionProtocol.beginAcceptReconnection($,null),z=V.reconnectionProtocol,H=!1):(z=new C.PersistentProtocol($,null),H=!0),V.logService.trace(`${F} 3/6. sending AuthRequest control message.`);const ee=await y(V.signService.createNewMessage((0,b.generateUuid)()),q),se={type:"auth",auth:V.connectionToken||"00000000000000000000",data:ee.data};z.sendControl(t.VSBuffer.fromString(JSON.stringify(se)));try{const ae=await m(z,u(q,h(1e4)));if(ae.type!=="sign"||typeof ae.data!="string"){const Se=new Error("Unexpected handshake message");throw Se.code="VSCODE_CONNECTION_ERROR",Se}if(V.logService.trace(`${F} 4/6. received SignRequest control message.`),!await y(V.signService.validate(ee,ae.signedData),q)){const Se=new Error("Refused to connect to unsupported server");throw Se.code="VSCODE_CONNECTION_ERROR",Se}const ge=await y(V.signService.sign(ae.data),q),Ee={type:"connectionType",commit:V.commit,signedData:ge,desiredConnectionType:J};return Z&&(Ee.args=Z),V.logService.trace(`${F} 5/6. sending ConnectionTypeRequest control message.`),z.sendControl(t.VSBuffer.fromString(JSON.stringify(Ee))),{protocol:z,ownsProtocol:H}}catch(ae){throw ae&&ae.code==="ETIMEDOUT"&&(V.logService.error(`${F} the handshake timed out. Error:`),V.logService.error(ae)),ae&&ae.code==="VSCODE_CONNECTION_ERROR"&&(V.logService.error(`${F} received error control message when negotiating connection. Error:`),V.logService.error(ae)),H&&Q(z),ae}}async function d(V,J,Z,q){const F=Date.now(),$=j(V,J),{protocol:z,ownsProtocol:H}=await S(V,J,Z,q),ee=new v(q);return ee.registerDisposable(z.onControlMessage(se=>{const ae=JSON.parse(se.toString()),de=W(ae);de?(V.logService.error(`${$} received error control message when negotiating connection. Error:`),V.logService.error(de),H&&Q(z),ee.reject(de)):(V.reconnectionProtocol&&V.reconnectionProtocol.endAcceptReconnection(),V.logService.trace(`${$} 6/6. handshake finished, connection is up and running after ${Y(F)}!`),ee.resolve({protocol:z,firstMessage:ae}))})),ee.promise}async function i(V,J){const{protocol:Z}=await d(V,1,void 0,J);return{protocol:Z}}async function c(V,J,Z){const{protocol:q,firstMessage:F}=await d(V,2,J,Z),$=F&&F.debugPort;return{protocol:q,debugPort:$}}async function r(V,J,Z){const q=Date.now(),F=j(V,3),{protocol:$}=await S(V,3,J,Z);return V.logService.trace(`${F} 6/6. handshake finished, connection is up and running after ${Y(q)}!`),$}async function n(V,J,Z){const{host:q,port:F,connectionToken:$}=await V.addressProvider.getAddress();return{commit:V.commit,host:q,port:F,connectionToken:$,reconnectionToken:J,reconnectionProtocol:Z,socketFactory:V.socketFactory,signService:V.signService,logService:V.logService}}async function o(V,J,Z){try{const q=(0,b.generateUuid)(),F=await n(V,q,null),{protocol:$}=await i(F,L.CancellationToken.None);return new N(V,J,Z,q,$)}catch(q){throw V.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),V.logService.error(q),M.triggerPermanentFailure(0,0,P.RemoteAuthorityResolverError.isHandled(q)),q}}e.connectRemoteAgentManagement=o;async function s(V,J){try{const Z=(0,b.generateUuid)(),q=await n(V,Z,null),{protocol:F,debugPort:$}=await c(q,J,L.CancellationToken.None);return new x(V,J,Z,F,$)}catch(Z){throw V.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),V.logService.error(Z),M.triggerPermanentFailure(0,0,P.RemoteAuthorityResolverError.isHandled(Z)),Z}}e.connectRemoteAgentExtensionHost=s;async function a(V,J,Z){const q=await n(V,(0,b.generateUuid)(),null);return await r(q,{host:J,port:Z},L.CancellationToken.None)}e.connectRemoteAgentTunnel=a;function l(V){return(0,k.createCancelablePromise)(J=>new Promise((Z,q)=>{const F=setTimeout(Z,V*1e3);J.onCancellationRequested(()=>{clearTimeout(F),Z()})}))}var g;(function(V){V[V.ConnectionLost=0]="ConnectionLost",V[V.ReconnectionWait=1]="ReconnectionWait",V[V.ReconnectionRunning=2]="ReconnectionRunning",V[V.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",V[V.ConnectionGain=4]="ConnectionGain"})(g=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class I{constructor(J,Z){this.reconnectionToken=J,this.millisSinceLastIncomingData=Z,this.type=0}}e.ConnectionLostEvent=I;class _{constructor(J,Z,q,F){this.reconnectionToken=J,this.millisSinceLastIncomingData=Z,this.durationSeconds=q,this.cancellableTimer=F,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=_;class O{constructor(J,Z,q){this.reconnectionToken=J,this.millisSinceLastIncomingData=Z,this.attempt=q,this.type=2}}e.ReconnectionRunningEvent=O;class U{constructor(J,Z,q){this.reconnectionToken=J,this.millisSinceLastIncomingData=Z,this.attempt=q,this.type=4}}e.ConnectionGainEvent=U;class D{constructor(J,Z,q,F){this.reconnectionToken=J,this.millisSinceLastIncomingData=Z,this.attempt=q,this.handled=F,this.type=3}}e.ReconnectionPermanentFailureEvent=D;class M extends R.Disposable{constructor(J,Z,q,F){super();this._connectionType=J,this._onDidStateChange=this._register(new A.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=Z,this.reconnectionToken=q,this.protocol=F,this._isReconnecting=!1,this._onDidStateChange.fire(new U(this.reconnectionToken,0,0)),this._register(F.onSocketClose($=>{const z=B(this._connectionType,this.reconnectionToken,!0);$?$.type===0?(this._options.logService.info(`${z} received socket close event (hadError: ${$.hadError}).`),$.error&&this._options.logService.error($.error)):(this._options.logService.info(`${z} received socket close event (wasClean: ${$.wasClean}, code: ${$.code}, reason: ${$.reason}).`),$.event&&this._options.logService.error($.event)):this._options.logService.info(`${z} received socket close event.`),this._beginReconnecting()})),this._register(F.onSocketTimeout(()=>{const $=B(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${$} received socket timeout event.`),this._beginReconnecting()})),M._instances.push(this),M._permanentFailure&&this._gotoPermanentFailure(M._permanentFailureMillisSinceLastIncomingData,M._permanentFailureAttempt,M._permanentFailureHandled)}static triggerPermanentFailure(J,Z,q){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=J,this._permanentFailureAttempt=Z,this._permanentFailureHandled=q,this._instances.forEach(F=>F._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(J=>J._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(J=>J._pauseSocketWriting())}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(M._permanentFailure)return;const J=B(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${J} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new I(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const Z=[0,5,5,10,10,10,10,10,30];let q=-1;do{q++;const F=q<Z.length?Z[q]:Z[Z.length-1];try{if(F>0){const z=l(F);this._onDidStateChange.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F,z)),this._options.logService.info(`${J} waiting for ${F} seconds before reconnecting...`);try{await z}catch{}}if(M._permanentFailure){this._options.logService.error(`${J} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q+1)),this._options.logService.info(`${J} resolving connection...`);const $=await n(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${J} connecting to ${$.host}:${$.port}...`),await this._reconnect($,h(E)),this._options.logService.info(`${J} reconnected!`),this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q+1));break}catch($){if($.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${J} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error($),M.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}if(q>360){this._options.logService.error(`${J} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error($),M.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}if(P.RemoteAuthorityResolverError.isTemporarilyNotAvailable($)){this._options.logService.info(`${J} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace($);continue}if(($.code==="ETIMEDOUT"||$.code==="ENETUNREACH"||$.code==="ECONNREFUSED"||$.code==="ECONNRESET")&&$.syscall==="connect"){this._options.logService.info(`${J} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace($);continue}if((0,T.isCancellationError)($)){this._options.logService.info(`${J} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace($);continue}if($ instanceof P.RemoteAuthorityResolverError){this._options.logService.error(`${J} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error($),M.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,P.RemoteAuthorityResolverError.isHandled($));break}this._options.logService.error(`${J} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error($),M.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}}while(!M._permanentFailure)}_gotoPermanentFailure(J,Z,q){this._onDidStateChange.fire(new D(this.reconnectionToken,J,Z,q)),Q(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=M,M._permanentFailure=!1,M._permanentFailureMillisSinceLastIncomingData=0,M._permanentFailureAttempt=0,M._permanentFailureHandled=!1,M._instances=[];class N extends M{constructor(J,Z,q,F,$){super(1,J,F,$);this.client=this._register(new C.Client($,{remoteAuthority:Z,clientId:q},J.ipcLogger))}async _reconnect(J,Z){await i(J,Z)}}e.ManagementPersistentConnection=N;class x extends M{constructor(J,Z,q,F,$){super(2,J,q,F);this._startArguments=Z,this.debugPort=$}async _reconnect(J,Z){await c(J,this._startArguments,Z)}}e.ExtensionHostPersistentConnection=x;function Q(V){try{V.acceptDisconnect();const J=V.getSocket();V.dispose(),J.dispose()}catch(J){(0,T.onUnexpectedError)(J)}}function W(V){if(V&&V.type==="error"){const J=new Error(`Connection error: ${V.reason}`);return J.code="VSCODE_CONNECTION_ERROR",J}return null}function ie(V,J){for(;V.length<J;)V+=" ";return V}function B(V,J,Z){return`[remote-connection][${ie(p(V),13)}][${J.substr(0,5)}\u2026][${Z?"reconnect":"initial"}]`}function j(V,J){return`${B(J,V.reconnectionToken,!!V.reconnectionProtocol)}[${V.host}:${V.port}]`}function Y(V){return`${Date.now()-V} ms`}}),define(te[185],ne([0,1,18]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function t(T){return T.scheme===k.Schemas.vscodeRemote?T.authority:void 0}e.getRemoteAuthority=t;function L(T){if(!T)return;const A=T.indexOf("+");return A<0?T:T.substr(0,A)}e.getRemoteName=L}),define(te[61],ne([0,1,26,6,185]),function(K,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function T(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=T;function A(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));class b{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,h){if(typeof p=="undefined"||p===null)return typeof h=="undefined"||h===null;if(typeof h=="undefined"||h===null)return!1;if(typeof p=="string"||typeof h=="string"){let u=typeof p=="string"?p:p.value,v=typeof h=="string"?h:h.value;return k.equalsIgnoreCase(u,v)}return p._lower===h._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.ExtensionIdentifier=b;function C(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=C;function P(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=P;function E(f,p){if(p){const h=`onResolveRemoteAuthority:${(0,L.getRemoteName)(p)}`;return f.activationEvents?.indexOf(h)!==-1}return!1}e.isResolverExtension=E,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(te[31],ne([0,1,26,61]),function(K,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function L(h,u){return h.uuid&&u.uuid?h.uuid===u.uuid:h.id===u.id?!0:(0,k.compareIgnoreCase)(h.id,u.id)===0}e.areSameExtensions=L;class T{constructor(u,v){this.version=v,this.id=u.id,this.uuid=u.uuid}key(){return`${this.id}-${this.version}`}equals(u){return u instanceof T?L(this,u)&&this.version===u.version:!1}}e.ExtensionIdentifierWithVersion=T;function A(h,u){return`${h}.${u}`}e.getExtensionId=A;function R(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=R;function b(h,u){return R(A(h,u))}e.getGalleryExtensionId=b;function C(h,u){const v=[],m=w=>{for(const y of v)if(y.some(S=>L(u(S),u(w))))return y;return null};for(const w of h){const y=m(w);y?y.push(w):v.push([w])}return v}e.groupByExtension=C;function P(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=P;function E(h){return{id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,isPreReleaseVersion:h.properties.isPreReleaseVersion,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),...h.telemetryData}}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new t.ExtensionIdentifier("pprice.better-merge");function f(h){const u=new Set;if(h.malicious)for(const v of h.malicious)u.add(v.id);return u}e.getMaliciousExtensionsSet=f;function p(h,u){const v=[],m=u.manifest.extensionDependencies?.slice(0)??[];for(;m.length;){const w=m.shift();if(w&&v.every(y=>!L(y.identifier,{id:w}))){const y=h.filter(S=>L(S.identifier,{id:w}));y.length===1&&(v.push(y[0]),m.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}e.getExtensionDependencies=p}),define(te[30],ne([0,1,18,130,31,6]),function(K,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.getIdAndVersion=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";const A=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function R(i){const c=A.exec(i);return c&&c[1]?[(0,L.adoptToGalleryExtensionId)(c[1]),c[2]]:[(0,L.adoptToGalleryExtensionId)(i),void 0]}e.getIdAndVersion=R;var b;(function(i){i.WIN32_X64="win32-x64",i.WIN32_IA32="win32-ia32",i.WIN32_ARM64="win32-arm64",i.LINUX_X64="linux-x64",i.LINUX_ARM64="linux-arm64",i.LINUX_ARMHF="linux-armhf",i.ALPINE_X64="alpine-x64",i.ALPINE_ARM64="alpine-arm64",i.DARWIN_X64="darwin-x64",i.DARWIN_ARM64="darwin-arm64",i.WEB="web",i.UNIVERSAL="universal",i.UNKNOWN="unknown",i.UNDEFINED="undefined"})(b=e.TargetPlatform||(e.TargetPlatform={}));function C(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=C;function P(i){switch(i){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=P;function E(i,c){switch(i){case 3:return c==="x64"?"win32-x64":c==="ia32"?"win32-ia32":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=E;function f(i,c){return c==="web"&&!i.includes("web")}e.isNotWebExtensionInWebTargetPlatform=f;function p(i,c,r){return f(c,r)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===r?!0:h(r).includes(i)}e.isTargetPlatformCompatible=p;function h(i){switch(i){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=h;function u(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=u;var v;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(v=e.SortBy||(e.SortBy={}));var m;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(m=e.SortOrder||(e.SortOrder={}));var w;(function(i){i.Install="install",i.Uninstall="uninstall"})(w=e.StatisticType||(e.StatisticType={}));var y;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(y=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,T.createDecorator)("extensionGalleryService");var S;(function(i){i.Unsupported="Unsupported",i.UnsupportedPreRelease="UnsupportedPreRelease",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatiblePreRelease="IncompatiblePreRelease",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.Extract="Extract",i.Delete="Delete",i.Rename="Rename",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Internal="Internal"})(S=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class d extends Error{constructor(c,r){super(c);this.code=r,this.name=r}}e.ExtensionManagementError=d,e.IExtensionManagementService=(0,T.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,T.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,T.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=k.FileAccess.asBrowserUri("./media/defaultIcon.png",K).toString(!0),e.ExtensionsLabel=(0,t.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,t.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,T.createDecorator)("IExtensionManagementCLIService")}),define(te[186],ne([0,1,3,2,28,7,110,30]),function(K,e,k,t,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function b(u,v){return T.URI.revive(v?v.transformIncoming(u):u)}function C(u,v){return v?v.transformOutgoingURI(u):u}function P(u,v){v=v||A.DefaultURITransformer;const m=u.manifest;return{...(0,A.transformAndReviveIncomingURIs)({...u,manifest:void 0},v),manifest:m}}function E(u,v){return v?(0,L.cloneAndChange)(u,m=>m instanceof T.URI?v.transformOutgoingURI(m):void 0):u}class f{constructor(v,m){this.service=v,this.getUriTransformer=m,this.onInstallExtension=k.Event.buffer(v.onInstallExtension,!0),this.onDidInstallExtensions=k.Event.buffer(v.onDidInstallExtensions,!0),this.onUninstallExtension=k.Event.buffer(v.onUninstallExtension,!0),this.onDidUninstallExtension=k.Event.buffer(v.onDidUninstallExtension,!0)}listen(v,m){const w=this.getUriTransformer(v);switch(m){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return k.Event.map(this.onDidInstallExtensions,y=>y.map(S=>({...S,local:S.local?E(S.local,w):S.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(v,m,w){const y=this.getUriTransformer(v);switch(m){case"zip":return this.service.zip(P(w[0],y)).then(S=>C(S,y));case"unzip":return this.service.unzip(b(w[0],y));case"install":return this.service.install(b(w[0],y),w[1]);case"getManifest":return this.service.getManifest(b(w[0],y));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(w[0]);case"installFromGallery":return this.service.installFromGallery(w[0],w[1]);case"uninstall":return this.service.uninstall(P(w[0],y),w[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(P(w[0],y));case"getInstalled":return this.service.getInstalled(w[0]).then(S=>S.map(d=>E(d,y)));case"updateMetadata":return this.service.updateMetadata(P(w[0],y),w[1]).then(S=>E(S,y));case"updateExtensionScope":return this.service.updateExtensionScope(P(w[0],y),w[1]).then(S=>E(S,y));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=f;class p extends t.Disposable{constructor(v){super();this.channel=v,this._onInstallExtension=this._register(new k.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new k.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new k.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new k.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(m=>this._onInstallExtension.fire({identifier:m.identifier,source:this.isUriComponents(m.source)?T.URI.revive(m.source):m.source}))),this._register(this.channel.listen("onDidInstallExtensions")(m=>this._onDidInstallExtensions.fire(m.map(w=>({...w,local:w.local?P(w.local,null):w.local,source:this.isUriComponents(w.source)?T.URI.revive(w.source):w.source}))))),this._register(this.channel.listen("onUninstallExtension")(m=>this._onUninstallExtension.fire(m))),this._register(this.channel.listen("onDidUninstallExtension")(m=>this._onDidUninstallExtension.fire(m)))}isUriComponents(v){return v?typeof v.path=="string"&&typeof v.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(v){const m=await this.getTargetPlatform();return v.allTargetPlatforms.some(w=>(0,R.isTargetPlatformCompatible)(w,v.allTargetPlatforms,m))}zip(v){return Promise.resolve(this.channel.call("zip",[v]).then(m=>T.URI.revive(m)))}unzip(v){return Promise.resolve(this.channel.call("unzip",[v]))}install(v,m){return Promise.resolve(this.channel.call("install",[v,m])).then(w=>P(w,null))}getManifest(v){return Promise.resolve(this.channel.call("getManifest",[v]))}installFromGallery(v,m){return Promise.resolve(this.channel.call("installFromGallery",[v,m])).then(w=>P(w,null))}uninstall(v,m){return Promise.resolve(this.channel.call("uninstall",[v,m]))}reinstallFromGallery(v){return Promise.resolve(this.channel.call("reinstallFromGallery",[v]))}getInstalled(v=null){return Promise.resolve(this.channel.call("getInstalled",[v])).then(m=>m.map(w=>P(w,null)))}updateMetadata(v,m){return Promise.resolve(this.channel.call("updateMetadata",[v,m])).then(w=>P(w,null))}updateExtensionScope(v,m){return Promise.resolve(this.channel.call("updateExtensionScope",[v,m])).then(w=>P(w,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=p;class h{constructor(v){this.service=v}listen(v,m){throw new Error("Invalid listen")}call(v,m,w){switch(m){case"getConfigBasedTips":return this.service.getConfigBasedTips(T.URI.revive(w[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=h}),define(te[187],ne([0,1,25,31]),function(K,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function L(T,A,R,b,C){try{const P=await T.getExtensionsControlManifest();if(!P.unsupportedPreReleaseExtensions)return;const E=await T.getInstalled(1);for(const[f,{id:p,migrateStorage:h}]of Object.entries(P.unsupportedPreReleaseExtensions)){const u=E.find(m=>(0,t.areSameExtensions)(m.identifier,{id:f}));if(!u)continue;const v=(await A.getExtensions([{id:p,preRelease:!0}],{targetPlatform:await T.getTargetPlatform(),compatible:!0},k.CancellationToken.None))[0];if(!v){C.info(`Skipping migrating '${u.identifier.id}' extension because, the comaptible target '${p}' extension is not found`);continue}try{C.info(`Migrating '${u.identifier.id}' extension to '${p}' extension...`);const m=!b.getDisabledExtensions().some(y=>(0,t.areSameExtensions)(y,u.identifier));await T.uninstall(u),C.info(`Uninstalled the unsupported extension '${u.identifier.id}'`);let w=E.find(y=>(0,t.areSameExtensions)(y.identifier,{id:p}));(!w||!w.isPreReleaseVersion&&m)&&(w=await T.installFromGallery(v,{installPreReleaseVersion:!0,isMachineScoped:u.isMachineScoped,operation:4}),C.info(`Installed the pre-release extension '${w.identifier.id}'`),m||(await b.disableExtension(w.identifier),C.info(`Disabled the pre-release extension '${w.identifier.id}' because the unsupported extension '${u.identifier.id}' is disabled`)),h&&(R.addToMigrationList((0,t.getExtensionId)(u.manifest.publisher,u.manifest.name),(0,t.getExtensionId)(w.manifest.publisher,w.manifest.name)),C.info("Added pre-release extension to the storage migration list"))),C.info(`Migrated '${u.identifier.id}' extension to '${p}' extension.`)}catch(m){C.error(m)}}}catch(P){C.error(P)}}e.migrateUnsupportedExtensions=L}),define(te[188],ne([0,1,5,9,2,4,20,62,7,29,22,14,30,31,15,8]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let m=class extends L.Disposable{constructor(y,S,d,i){super();this.fileService=S,this.extensionGalleryService=d,this.logService=i,this.extensionsDownloadDir=b.URI.file(y.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(y,S){await this.cleanUpPromise;const d=this.getName(y),i=(0,A.joinPath)(this.extensionsDownloadDir,d);if(!await this.fileService.exists(i)){const c=(0,A.joinPath)(this.extensionsDownloadDir,`.${(0,C.generateUuid)()}`);await this.fileService.exists(c)||await this.extensionGalleryService.download(y,c,S);try{await this.rename(c,i,Date.now()+2*60*1e3)}catch(r){try{await this.fileService.del(c)}catch{}if(r.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",y.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,t.getErrorMessage)(r)}. Deleted the vsix from downloaded location`,c.path),r}}return i}async delete(y){await this.cleanUpPromise,await this.fileService.del(y)}async rename(y,S,d){try{await P.Promises.rename(y.fsPath,S.fsPath)}catch(i){if(T.isWindows&&i&&i.code==="EPERM"&&Date.now()<d)return this.logService.info(`Failed renaming ${y} to ${S} with 'EPERM' error. Trying again...`),this.rename(y,S,d);throw i}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const y=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(y.children){const S=[],d=[];for(const r of y.children){const n=this.parse(r.name);n&&d.push([n,r])}const i=(0,p.groupByExtension)(d,([r])=>r),c=[];for(const r of i)r.sort((n,o)=>R.rcompare(n[0].version,o[0].version)),S.push(...r.slice(1).map(n=>n[1].resource)),c.push(r[0][1]);c.sort((r,n)=>r.mtime-n.mtime),S.push(...c.slice(0,Math.max(0,c.length-this.cache)).map(r=>r.resource)),await k.Promises.settled(S.map(r=>(this.logService.trace("Deleting vsix from cache",r.path),this.fileService.del(r))))}}catch(y){this.logService.error(y)}}getName(y){return this.cache?`${new p.ExtensionIdentifierWithVersion(y.identifier,y.version).key().toLowerCase()}${y.properties.targetPlatform!=="undefined"?`-${y.properties.targetPlatform}`:""}`:(0,C.generateUuid)()}parse(y){const S=v.exec(y);return S&&S[1]&&S[2]?new p.ExtensionIdentifierWithVersion({id:S[1]},S[2]):null}};m=he([G(0,E.INativeEnvironmentService),G(1,h.IFileService),G(2,f.IExtensionGalleryService),G(3,u.ILogService)],m),e.ExtensionsDownloader=m}),define(te[189],ne([0,1,2,10,22,61]),function(K,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends k.Disposable{constructor(b,C){super();this.environmentService=b,this.extensionsManifestCache=(0,t.join)(this.environmentService.userDataPath,T.MANIFEST_CACHE_FOLDER,T.USER_MANIFEST_CACHE_FILE),this._register(C.onDidInstallExtensions(P=>this.onDidInstallExtensions(P))),this._register(C.onDidUninstallExtension(P=>this.onDidUnInstallExtension(P)))}onDidInstallExtensions(b){b.some(C=>!!C.local)&&this.invalidate()}onDidUnInstallExtension(b){b.error||this.invalidate()}invalidate(){L.Promises.rm(this.extensionsManifestCache,L.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=A}),define(te[190],ne([0,1,84,16,5,2,18,10,22,14,30,31,59,8]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let h=class extends T.Disposable{constructor(m,w,y){super();this.extensionManagementService=m,this.logService=y,this.cache=this._register(new u(w,y)),this.extensionManagementService.registerParticipant({postInstall:async S=>this.postInstallExtension(S),postUninstall:async S=>this.postUninstallExtension(S)})}async getLanguageIds(){const m=await this.cache.getLanguagePacks(),w=["en",...Object.keys(m)];return(0,t.distinct)(w)}async postInstallExtension(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",m.identifier.id),await this.update())}async postUninstallExtension(m){const w=await this.cache.getLanguagePacks();Object.keys(w).some(y=>w[y]&&w[y].extensions.some(S=>(0,E.areSameExtensions)(S.extensionIdentifier,m.identifier)))&&(this.logService.info("Removing language packs from the extension",m.identifier.id),await this.update())}async update(){const[m,w]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),y=await this.cache.update(w);return!(0,t.equals)(Object.keys(m),Object.keys(y))}};h=he([G(0,P.IExtensionManagementService),G(1,C.INativeEnvironmentService),G(2,p.ILogService)],h),e.LocalizationsService=h;let u=class extends T.Disposable{constructor(m,w){super();this.logService=w,this.languagePacks={},this.languagePacksFilePath=(0,R.join)(m.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new L.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(m){return this.withLanguagePacks(w=>{Object.keys(w).forEach(y=>delete w[y]),this.createLanguagePacksFromExtensions(w,...m)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(m,...w){for(const y of w)y&&y.manifest&&y.manifest.contributes&&y.manifest.contributes.localizations&&y.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(m,y);Object.keys(m).forEach(y=>this.updateHash(m[y]))}createLanguagePacksFromExtension(m,w){const y=w.identifier,S=w.manifest.contributes&&w.manifest.contributes.localizations?w.manifest.contributes.localizations:[];for(const d of S)if(w.location.scheme===A.Schemas.file&&(0,f.isValidLocalization)(d)){let i=m[d.languageId];i||(i={hash:"",extensions:[],translations:{}},m[d.languageId]=i);let c=i.extensions.filter(r=>(0,E.areSameExtensions)(r.extensionIdentifier,y))[0];c?c.version=w.manifest.version:i.extensions.push({extensionIdentifier:y,version:w.manifest.version});for(const r of d.translations)i.translations[r.id]=(0,R.join)(w.location.fsPath,r.path)}}updateHash(m){if(m){const w=(0,k.createHash)("md5");for(const y of m.extensions)w.update(y.extensionIdentifier.uuid||y.extensionIdentifier.id).update(y.version);m.hash=w.digest("hex")}}withLanguagePacks(m=()=>null){return this.languagePacksFileLimiter.queue(()=>{let w=null;return b.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,y=>y.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(y)).then(y=>{try{return JSON.parse(y)}catch{return{}}}).then(y=>(w=m(y),y)).then(y=>{for(const d of Object.keys(y))y[d]||delete y[d];this.languagePacks=y,this.initializedCache=!0;const S=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",S),b.Promises.writeFile(this.languagePacksFilePath,S)}).then(()=>w,y=>this.logService.error(y))})}};u=he([G(0,C.INativeEnvironmentService),G(1,p.ILogService)],u)}),define(te[191],ne([0,1,6]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,k.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(te[192],ne([0,1,120,19,8]),function(K,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let T=class{constructor(R,b){this.configurationService=R,this.logService=b}request(R,b){return this.logService.trace("RequestService#request",R.url),R.proxyAuthorization||(R.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,k.request)(R,b)}async resolveProxy(R){}};T=he([G(0,t.IConfigurationService),G(1,L.ILogService)],T),e.RequestService=T}),define(te[43],ne([0,1,17,140,42,6,38]),function(K,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,T.createDecorator)("requestService");function R(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}e.isSuccess=R;function b(h){return h.res.statusCode===204}async function C(h){if(!R(h))throw new Error("Server returned "+h.res.statusCode);return b(h)?null:(await(0,k.streamToBuffer)(h.stream)).toString()}e.asText=C;async function P(h){if(!R(h))throw new Error("Server returned "+h.res.statusCode);if(b(h))return null;const v=(await(0,k.streamToBuffer)(h.stream)).toString();try{return JSON.parse(v)}catch(m){throw m.message+=`:
`+v,m}}e.asJson=P;function E(h){p(h)}e.updateProxyConfigurationsScope=E;let f;function p(h){const u=A.Registry.as(L.Extensions.Configuration),v=f;f={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},u.updateConfigurations({add:[f],remove:v?[v]:[]})}p(2)}),define(te[193],ne([0,1,25,18,15,43]),function(K,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let A=class{constructor(b,C){this.requestService=b,this.fileService=C}async download(b,C,P=k.CancellationToken.None){if(b.scheme===t.Schemas.file||b.scheme===t.Schemas.vscodeRemote){await this.fileService.copy(b,C);return}const E={type:"GET",url:b.toString()},f=await this.requestService.request(E,P);if(f.res.statusCode===200)await this.fileService.writeFile(C,f.stream);else{const p=await(0,T.asText)(f);throw new Error(`Expected 200, got back ${f.res.statusCode} instead.

${p}`)}}};A=he([G(0,T.IRequestService),G(1,L.IFileService)],A),e.DownloadService=A}),define(te[194],ne([0,1,16,25,68,2,20,155,15,8,27,43]),function(K,e,k,t,L,T,A,R,b,C,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let f=class extends T.Disposable{constructor(h,u,v,m){super();this.fileService=h,this.productService=u,this.requestService=v,this.logService=m,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,L.forEach)(this.productService.configBasedExtensionTips,({value:w})=>this.allConfigBasedTips.set(w.configPath,w))}getConfigBasedTips(h){return this.getValidConfigBasedTips(h)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(h){const u=[];for(const[v,m]of this.allConfigBasedTips)if(!(m.configScheme&&m.configScheme!==h.scheme))try{const w=await this.fileService.readFile((0,A.joinPath)(h,v)),y=new Map;(0,L.forEach)(m.recommendations,({key:d,value:i})=>{if((0,k.isNonEmptyArray)(i.remotes))for(const c of i.remotes)y.set(c,{extensionId:d,extensionName:i.name,configName:m.configName,important:!!i.important,isExtensionPack:!!i.isExtensionPack,whenNotInstalled:i.whenNotInstalled});else u.push({extensionId:d,extensionName:i.name,configName:m.configName,important:!!i.important,isExtensionPack:!!i.isExtensionPack,whenNotInstalled:i.whenNotInstalled})});const S=(0,R.getDomainsOfRemotes)(w.value.toString(),[...y.keys()]);for(const d of S){const i=y.get(d);i&&u.push(i)}}catch{}return u}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const h=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},t.CancellationToken.None);if(h.res.statusCode!==200)return[];const u=await(0,E.asJson)(h);return u?u.workspaceRecommendations||[]:[]}catch(h){return this.logService.error(h),[]}}};f=he([G(0,b.IFileService),G(1,P.IProductService),G(2,E.IRequestService),G(3,C.ILogService)],f),e.ExtensionTipsService=f}),define(te[91],ne([0,1,71,6]),function(K,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function L(T){return(0,k.hash)({moduleId:T.process.moduleId,windowId:T.reply.windowId})}e.hash=L,e.ISharedProcessWorkerService=(0,t.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(te[195],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var k;(function(t){t.Spawn="vscode:shared-process->shared-process-worker=spawn",t.Terminate="vscode:shared-process->shared-process-worker=terminate",t.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",t.Ready="vscode:shared-process-worker->shared-process=ready",t.Ack="vscode:shared-process-worker->shared-process=ack",t.Trace="vscode:shared-process-worker->shared-process=trace",t.Info="vscode:shared-process-worker->shared-process=info",t.Warn="vscode:shared-process-worker->shared-process=warn",t.Error="vscode:shared-process-worker->shared-process=error"})(k=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(te[196],ne([0,1,75,5,25,3,2,18,29,8,91,195]),function(K,e,k,t,L,T,A,R,b,C,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let f=class{constructor(u){this.logService=u,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(u){const v=`window: ${u.reply.windowId}, moduleId: ${u.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${v})`);const m=(0,P.hash)(u);this.processeDisposables.has(m)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${v})`),this.doDisposeWorker(u));const w=new L.CancellationTokenSource;let y,S,d;this.processeDisposables.set(m,n=>{w.dispose(!0),y?.terminate(u,L.CancellationToken.None),S?.close(),d?.close(),this.processeDisposables.delete(m);const o=this.processResolvers.get(m);o&&(this.processResolvers.delete(m),o({reason:n}))}),y=await this.getOrCreateWebWorker(u);const i=new Promise(n=>{this.processResolvers.set(m,n)});if(w.token.isCancellationRequested)return i;const{port1:c,port2:r}=new MessageChannel;return S=c,d=r,await y.spawn(u,d,w.token),w.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${v})`),k.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",u,[S])),i}getOrCreateWebWorker(u){let v=this.workers.get(u.process.moduleId);if(!v){this.logService.trace(`SharedProcess: creating new web worker (${u.process.moduleId})`);const m=new p(u.process.type,this.logService);v=m.init(),m.onDidProcessSelfTerminate(({configuration:w,reason:y})=>{this.doDisposeWorker(w,y)}),this.workers.set(u.process.moduleId,v)}return v}async disposeWorker(u){return this.doDisposeWorker(u)}doDisposeWorker(u,v){const m=this.processeDisposables.get((0,P.hash)(u));m&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${u.reply.windowId}, moduleId: ${u.process.moduleId})`),m(v))}};f=he([G(0,C.ILogService)],f),e.SharedProcessWorkerService=f;class p extends A.Disposable{constructor(u,v){super();this.type=u,this.logService=v,this._onDidProcessSelfTerminate=this._register(new T.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const u=new t.DeferredPromise,v=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return v.onerror=m=>{this.logService.error(`SharedProcess: worker error (${this.type})`,m.message)},v.onmessageerror=m=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,m)},v.onmessage=m=>{const{id:w,message:y,configuration:S,nonce:d}=m.data;switch(w){case E.SharedProcessWorkerMessages.Ready:u.complete(v);break;case E.SharedProcessWorkerMessages.Ack:if(d){const i=this.mapMessageNonceToPendingMessageResolve.get(d);i&&(this.mapMessageNonceToPendingMessageResolve.delete(d),i())}break;case E.SharedProcessWorkerMessages.SelfTerminated:S&&y&&this._onDidProcessSelfTerminate.fire({configuration:S,reason:JSON.parse(y)});break;case E.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,y);break;case E.SharedProcessWorkerMessages.Info:y&&this.logService.info(y);break;case E.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,y);break;case E.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,y);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,m)}},v.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),u.p}async send(u,v,m){const w=await this.workerReady;if(!v.isCancellationRequested)return new Promise(y=>{const S=(0,b.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(S,y);const d={...u,nonce:S};m?w.postMessage(d,[m]):w.postMessage(d),v.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(S)&&y()})})}spawn(u,v,m){const w={id:E.SharedProcessWorkerMessages.Spawn,configuration:u,environment:{bootstrapPath:R.FileAccess.asFileUri("bootstrap-fork",K).fsPath}};return this.send(w,m,v)}terminate(u,v){const m={id:E.SharedProcessWorkerMessages.Terminate,configuration:u};return this.send(m,v)}}}),define(te[197],ne([0,1,54,18,154]),function(K,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class T extends L.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:t.Schemas.userData})}}he([k.memoize],T.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=T}),define(te[92],ne([0,1,6]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,k.createDecorator)(e.SIGN_SERVICE_ID)}),define(te[198],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class k{constructor(){this.validators=new Map}vsda(){return new Promise((L,T)=>K(["vsda"],L,T))}async createNewMessage(L){try{const T=await this.vsda(),A=new T.validator;if(A){const R=String(k._nextId++);return this.validators.set(R,A),{id:R,data:A.createNewMessage(L)}}}catch{}return{id:"",data:L}}async validate(L,T){if(!L.id)return!0;const A=this.validators.get(L.id);if(!A)return!1;this.validators.delete(L.id);try{return A.validate(T)==="ok"}catch{return!1}}async sign(L){try{const T=await this.vsda(),A=new T.signer;if(A)return A.sign(L)}catch{}return L}}e.SignService=k,k._nextId=1}),define(te[23],ne([0,1,5,3,2,176,11,76,6]),function(K,e,k,t,L,T,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const C="__$__targetStorageMarker";e.IStorageService=(0,b.createDecorator)("storageService");var P;(function(v){v[v.NONE=0]="NONE",v[v.SHUTDOWN=1]="SHUTDOWN"})(P=e.WillSaveStateReason||(e.WillSaveStateReason={}));var E;(function(v){v[v.GLOBAL=0]="GLOBAL",v[v.WORKSPACE=1]="WORKSPACE"})(E=e.StorageScope||(e.StorageScope={}));var f;(function(v){v[v.USER=0]="USER",v[v.MACHINE=1]="MACHINE"})(f=e.StorageTarget||(e.StorageTarget={}));class p extends L.Disposable{constructor(m={flushInterval:p.DEFAULT_FLUSH_INTERVAL}){super();this.options=m,this._onDidChangeValue=this._register(new t.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new t.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new t.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new k.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new L.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,k.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,L.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,T.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,T.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(m,w){w===C?(m===0?this._globalKeyTargets=void 0:m===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:m})):this._onDidChangeValue.fire({scope:m,key:w,target:this.getKeyTargets(m)[w]})}emitWillSaveState(m){this._onWillSaveState.fire({reason:m})}get(m,w,y){return this.getStorage(w)?.get(m,y)}getBoolean(m,w,y){return this.getStorage(w)?.getBoolean(m,y)}getNumber(m,w,y){return this.getStorage(w)?.getNumber(m,y)}store(m,w,y,S){if((0,A.isUndefinedOrNull)(w)){this.remove(m,y);return}this.withPausedEmitters(()=>{this.updateKeyTarget(m,y,S),this.getStorage(y)?.set(m,w)})}remove(m,w){this.withPausedEmitters(()=>{this.updateKeyTarget(m,w,void 0),this.getStorage(w)?.delete(m)})}withPausedEmitters(m){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{m()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(m,w){const y=[],S=this.getKeyTargets(m);for(const d of Object.keys(S))S[d]===w&&y.push(d);return y}updateKeyTarget(m,w,y){const S=this.getKeyTargets(w);typeof y=="number"?S[m]!==y&&(S[m]=y,this.getStorage(w)?.set(C,JSON.stringify(S))):typeof S[m]=="number"&&(delete S[m],this.getStorage(w)?.set(C,JSON.stringify(S)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(m){return m===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(m){const w=this.get(C,m);if(w)try{return JSON.parse(w)}catch{}return Object.create(null)}isNew(m){return this.getBoolean(e.IS_NEW_KEY,m)===!0}async flush(m=P.NONE){this._onWillSaveState.fire({reason:m});const w=this.getStorage(0),y=this.getStorage(1);switch(m){case P.NONE:await k.Promises.settled([w?.whenFlushed()??Promise.resolve(),y?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await k.Promises.settled([w?.flush(0)??Promise.resolve(),y?.flush(0)??Promise.resolve()]);break}}async logStorage(){const m=this.getStorage(0)?.items??new Map,w=this.getStorage(1)?.items??new Map;return u(m,w,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=p,p.DEFAULT_FLUSH_INTERVAL=60*1e3;class h extends p{constructor(){super();this.globalStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(m=>this.emitDidChangeValue(1,m))),this._register(this.globalStorage.onDidChangeStorage(m=>this.emitDidChangeValue(0,m)))}getStorage(m){return m===0?this.globalStorage:this.workspaceStorage}getLogDetails(m){return m===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(m){}}e.InMemoryStorageService=h;async function u(v,m,w,y){const S=s=>{try{return JSON.parse(s)}catch{return s}},d=new Map,i=new Map;v.forEach((s,a)=>{d.set(a,s),i.set(a,S(s))});const c=new Map,r=new Map;m.forEach((s,a)=>{c.set(a,s),r.set(a,S(s))}),console.group(`Storage: Global (path: ${w})`);let n=[];d.forEach((s,a)=>{n.push({key:a,value:s})}),console.table(n),console.groupEnd(),console.log(i),console.group(`Storage: Workspace (path: ${y})`);let o=[];c.forEach((s,a)=>{o.push({key:a,value:s})}),console.table(o),console.groupEnd(),console.log(r)}e.logStorage=u}),define(te[199],ne([0,1,3,2,11,30,31,23]),function(K,e,k,t,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let b=class extends t.Disposable{constructor(E,f){super();this._onDidChangeEnablement=new k.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new C(E)),this._register(this.storageManger.onDidChange(p=>this._onDidChangeEnablement.fire({extensions:p,source:"storage"}))),this._register(f.onDidInstallExtensions(p=>p.forEach(({local:h,operation:u})=>{h&&u===4&&this._removeFromDisabledExtensions(h.identifier)})))}async enableExtension(E,f){return this._removeFromDisabledExtensions(E)?(this._onDidChangeEnablement.fire({extensions:[E],source:f}),!0):!1}async disableExtension(E,f){return this._addToDisabledExtensions(E)?(this._onDidChangeEnablement.fire({extensions:[E],source:f}),!0):!1}getDisabledExtensions(){return this._getExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(E){let f=this.getDisabledExtensions();return f.every(p=>!(0,A.areSameExtensions)(p,E))?(f.push(E),this._setDisabledExtensions(f),!0):!1}_removeFromDisabledExtensions(E){let f=this.getDisabledExtensions();for(let p=0;p<f.length;p++){const h=f[p];if((0,A.areSameExtensions)(h,E))return f.splice(p,1),this._setDisabledExtensions(f),!0}return!1}_setDisabledExtensions(E){this._setExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH,E)}_getExtensions(E){return this.storageManger.get(E,0)}_setExtensions(E,f){this.storageManger.set(E,f,0)}};b=he([G(0,R.IStorageService),G(1,T.IExtensionManagementService)],b),e.GlobalExtensionEnablementService=b;class C extends t.Disposable{constructor(E){super();this.storageService=E,this.storage=Object.create(null),this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event,this._register(E.onDidChangeValue(f=>this.onDidStorageChange(f)))}get(E,f){let p;return f===0?((0,L.isUndefinedOrNull)(this.storage[E])&&(this.storage[E]=this._get(E,f)),p=this.storage[E]):p=this._get(E,f),JSON.parse(p)}set(E,f,p){let h=JSON.stringify(f.map(({id:v,uuid:m})=>({id:v,uuid:m})));this._get(E,p)!==h&&(p===0&&(f.length?this.storage[E]=h:delete this.storage[E]),this._set(E,f.length?h:void 0,p))}onDidStorageChange(E){if(E.scope===0&&!(0,L.isUndefinedOrNull)(this.storage[E.key])&&this._get(E.key,E.scope)!==this.storage[E.key]){const p=this.get(E.key,E.scope);delete this.storage[E.key];const h=this.get(E.key,E.scope),u=p.filter(m=>!h.some(w=>(0,A.areSameExtensions)(m,w))),v=h.filter(m=>!p.some(w=>(0,A.areSameExtensions)(w,m)));(u.length||v.length)&&this._onDidChange.fire([...u,...v])}}_get(E,f){return this.storageService.get(E,f,"[]")}_set(E,f,p){f?this.storageService.store(E,f,p,1):this.storageService.remove(E,p)}}e.StorageManager=C}),define(te[63],ne([0,1,6,3,2,23,31,27,16,8,11]),function(K,e,k,t,L,T,A,R,b,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,k.createDecorator)("IExtensionStorageService");const E=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let f=class tt extends L.Disposable{constructor(h,u,v){super();this.storageService=h,this.productService=u,this.logService=v,this._onDidChangeExtensionStorageToSync=this._register(new t.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(m=>this.onDidChangeStorageValue(m)))}static toKey(h){return`extensionKeys/${(0,A.adoptToGalleryExtensionId)(h.id)}@${h.version}`}static fromKey(h){const u=E.exec(h);if(u&&u[1])return{id:u[1],version:u[2]}}initialize(){const h=this.storageService.keys(0,1);for(const u of h){const v=tt.fromKey(u);v&&this.extensionsWithKeysForSync.add(v.id.toLowerCase())}}onDidChangeStorageValue(h){if(h.scope!==0)return;if(this.extensionsWithKeysForSync.has(h.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const u=tt.fromKey(h.key);if(u){this.extensionsWithKeysForSync.add(u.id.toLowerCase()),this._onDidChangeExtensionStorageToSync.fire();return}}getExtensionId(h){if((0,P.isString)(h))return h;const u=h.manifest?h.manifest.publisher:h.publisher,v=h.manifest?h.manifest.name:h.name;return(0,A.getExtensionId)(u,v)}getExtensionState(h,u){const v=this.getExtensionId(h),m=this.storageService.get(v,u?0:1);if(m)try{return JSON.parse(m)}catch(w){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${v}, global: ${u}): ${w}`)}}setExtensionState(h,u,v){const m=this.getExtensionId(h);u===void 0?this.storageService.remove(m,v?0:1):this.storageService.store(m,JSON.stringify(u),v?0:1,1)}setKeysForSync(h,u){this.storageService.store(tt.toKey(h),JSON.stringify(u),0,1)}getKeysForSync(h){const u=this.productService.extensionSyncedKeys?.[h.id.toLowerCase()],v=this.storageService.get(tt.toKey(h),0),m=v?JSON.parse(v):void 0;return m&&u?(0,b.distinct)([...m,...u]):m||u}addToMigrationList(h,u){if(h!==u){const v=this.migrationList.filter(m=>!m.includes(h)&&!m.includes(u));v.push([h,u]),this.migrationList=v}}getSourceExtensionToMigrate(h){const u=this.migrationList.find(([,v])=>h===v);return u?u[0]:void 0}get migrationList(){const h=this.storageService.get("extensionStorage.migrationList",0,"[]");try{const u=JSON.parse(h);if((0,P.isArray)(u))return u}catch{}return[]}set migrationList(h){h.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(h),0,1):this.storageService.remove("extensionStorage.migrationList",0)}};f=he([G(0,T.IStorageService),G(1,R.IProductService),G(2,C.ILogService)],f),e.ExtensionStorageService=f}),define(te[200],ne([0,1,2,30,63,187,8]),function(K,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsCleaner=void 0;let R=class extends k.Disposable{constructor(C,P,E,f,p){super();C.removeDeprecatedExtensions(),(0,T.migrateUnsupportedExtensions)(C,P,E,f,p)}};R=he([G(0,t.IExtensionManagementService),G(1,t.IExtensionGalleryService),G(2,L.IExtensionStorageService),G(3,t.IGlobalExtensionEnablementService),G(4,A.ILogService)],R),e.ExtensionsCleaner=R}),define(te[201],ne([0,1,3,2]),function(K,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class L extends t.Disposable{constructor(C,P){super();this.channel=C,this.workspace=P}async getItems(){const C={workspace:this.workspace},P=await this.channel.call("getItems",C);return new Map(P)}updateItems(C){const P={workspace:this.workspace};return C.insert&&(P.insert=Array.from(C.insert.entries())),C.delete&&(P.delete=Array.from(C.delete.values())),this.channel.call("updateItems",P)}}class T extends L{constructor(C){super(C,void 0);this._onDidChangeItemsExternal=this._register(new k.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(C=>this.onDidChangeGlobalStorage(C)))}onDidChangeGlobalStorage(C){(Array.isArray(C.changed)||Array.isArray(C.deleted))&&this._onDidChangeItemsExternal.fire({changed:C.changed?new Map(C.changed):void 0,deleted:C.deleted?new Set(C.deleted):void 0})}async close(){this.dispose()}}class A extends L{constructor(C,P){super(C,P);this.onDidChangeItemsExternal=k.Event.None}async close(){const C={workspace:this.workspace};return this.channel.call("close",C)}}class R extends t.Disposable{constructor(C,P){super();this.channel=C,this.workspace=P,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new T(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new A(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=R}),define(te[202],ne([0,1,5,2,20,76,23,201]),function(K,e,k,t,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class b extends A.AbstractStorageService{constructor(P,E,f){super();this.mainProcessService=E,this.environmentService=f,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new t.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(P)}createGlobalStorage(){const P=new R.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),E=new T.Storage(P.globalStorage);return this._register(E.onDidChangeStorage(f=>this.emitDidChangeValue(0,f))),E}createWorkspaceStorage(P){const E=new R.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),P);if(E.workspaceStorage){const f=new T.Storage(E.workspaceStorage);return this.workspaceStorageDisposable.value=f.onDidChangeStorage(p=>this.emitDidChangeValue(1,p)),this.workspaceStorageId=P?.id,f}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){await k.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(P){return P===0?this.globalStorage:this.workspaceStorage}getLogDetails(P){return P===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,L.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(A.WillSaveStateReason.SHUTDOWN),await k.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(P){const E=this.workspaceStorage,f=E?.items??new Map;E&&(await E.close(),E.dispose()),this.workspaceStorage=this.createWorkspaceStorage(P),await this.workspaceStorage.init();for(const[p,h]of f)this.workspaceStorage.set(p,h)}}e.NativeStorageService=b}),define(te[203],ne([0,1,4,33,7,29]),function(K,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(C){if(k.platform===2&&/^penguin(\.|$)/i.test(C))return"chromebook"}async function R(C,P,E,f,p,h,u,v,m,w){const y=Object.create(null);y["common.machineId"]=u,y.sessionID=(0,T.generateUuid)()+Date.now(),y.commitHash=p,y.version=h,y["common.platformVersion"]=(P||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),y["common.platform"]=(0,k.PlatformToString)(k.platform),y["common.nodePlatform"]=t.platform,y["common.nodeArch"]=f,y["common.product"]=w||"desktop";const S=b(v||[]);S&&(y["common.msftInternal"]=S);let d=0;const i=Date.now();Object.defineProperties(y,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),k.isLinuxSnap&&(y["common.snap"]="true");const c=A(E);c&&(y["common.platformDetail"]=c);try{const r=await C.readFile(L.URI.file(m));y["common.source"]=r.value.toString().slice(0,30)}catch{}return y}e.resolveCommonProperties=R;function b(C){const P=t.env.USERDNSDOMAIN;if(!P)return!1;const E=P.toLowerCase();return C.some(f=>E===f)}e.verifyMicrosoftInternalDomain=b}),define(te[21],ne([0,1,6]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,k.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,k.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(T){T[T.NONE=0]="NONE",T[T.CRASH=1]="CRASH",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var L;(function(T){T.OFF="off",T.CRASH="crash",T.ERROR="error",T.ON="all"})(L=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(te[204],ne([0,1,34,55,5,35,18,10,4,7,113,22,116,81,15,27,21]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p,h,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const m=new Map;async function w(c,r){const n=`${c}::${r.join(":")}`,o=m.get(n);if(o)return o;const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],a=new Map,l=new Map,g=2e4;function I(O,U,D,M){const N=U.substring(O.length+1);return L.Promises.withAsyncBody(async x=>{let Q;try{Q=await E.Promises.readdir(U,{withFileTypes:!0})}catch{x();return}if(M.count>=g){M.count+=Q.length,M.maxReached=!0,x();return}let W=Q.length;if(W===0){x();return}let ie=Q;M.count+Q.length>g&&(M.maxReached=!0,W=g-M.count,ie=Q.slice(0,W)),M.count+=Q.length;for(const B of ie)if(B.isDirectory()){if(D.includes(B.name)||await I(O,(0,R.join)(U,B.name),D,M),--W==0){x();return}}else{const j=B.name.lastIndexOf(".");if(j>=0){const Y=B.name.substring(j+1);Y&&a.set(Y,(a.get(Y)??0)+1)}for(const Y of s)Y.relativePathPattern?.test(N)!==!1&&Y.filePattern.test(B.name)&&l.set(Y.tag,(l.get(Y.tag)??0)+1);if(--W==0){x();return}}})}const _=L.Promises.withAsyncBody(async O=>{const U={count:0,maxReached:!1};await I(c,c,r,U);const D=await d(c);O({configFiles:y(l),fileTypes:y(a),fileCount:U.count,maxFilesReached:U.maxReached,launchConfigFiles:D})});return m.set(n,_),_}e.collectWorkspaceStats=w;function y(c){return[...t.Iterable.map(c.entries(),([r,n])=>({name:r,count:n}))].sort((r,n)=>n.count-r.count)}function S(){const c={os:`${k.type()} ${k.arch()} ${k.release()}`,memory:`${(k.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(P.virtualMachineHint.value()*100)}%`},r=k.cpus();return r&&r.length>0&&(c.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),c}e.getMachineInfo=S;async function d(c){try{const r=new Map,n=(0,R.join)(c,".vscode","launch.json"),o=await E.Promises.readFile(n),s=[],a=(0,T.parse)(o.toString(),s);if(s.length)return console.log(`Unable to parse ${n}`),[];if((0,T.getNodeType)(a)==="object"&&a.configurations)for(const l of a.configurations){const g=l.type;g&&(r.has(g)?r.set(g,r.get(g)+1):r.set(g,1))}return y(r)}catch{return[]}}e.collectLaunchConfigs=d;let i=class{constructor(r,n){this.telemetryService=r,this.productService=n}formatMachineInfo(r){const n=[];return n.push(`OS Version:       ${r.os}`),n.push(`CPUs:             ${r.cpus}`),n.push(`Memory (System):  ${r.memory}`),n.push(`VM:               ${r.vmHint}`),n.join(`
`)}formatEnvironment(r){const n=[];n.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),n.push(`OS Version:       ${k.type()} ${k.arch()} ${k.release()}`);const o=k.cpus();return o&&o.length>0&&n.push(`CPUs:             ${o[0].model} (${o.length} x ${o[0].speed})`),n.push(`Memory (System):  ${(k.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),b.isWindows||n.push(`Load (avg):       ${k.loadavg().map(s=>Math.round(s)).join(", ")}`),n.push(`VM:               ${Math.round(P.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${r.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.expandGPUFeatures(r.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(r,n){return Promise.all([(0,f.listProcesses)(r.mainPID),this.formatWorkspaceMetadata(r)]).then(async o=>{let[s,a]=o,l=this.formatProcessList(r,s);return n.forEach(g=>{if((0,p.isRemoteDiagnosticError)(g))l+=`
${g.errorMessage}`,a+=`
${g.errorMessage}`;else if(l+=`

Remote: ${g.hostName}`,g.processes&&(l+=`
${this.formatProcessList(r,g.processes)}`),g.workspaceMetadata){a+=`
|  Remote: ${g.hostName}`;for(const I of Object.keys(g.workspaceMetadata)){const _=g.workspaceMetadata[I];let O=`${_.fileCount} files`;_.maxFilesReached&&(O=`more than ${O}`),a+=`|    Folder (${I}): ${O}`,a+=this.formatWorkspaceStats(_)}}}),{processInfo:l,workspaceInfo:a}})}async getSystemInfo(r,n){const{memory:o,vmHint:s,os:a,cpus:l}=S(),g={os:a,memory:o,cpus:l,vmHint:s,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:n};return b.isWindows||(g.load=`${k.loadavg().map(I=>Math.round(I)).join(", ")}`),b.isLinux&&(g.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(g)}async getDiagnostics(r,n){const o=[];return(0,f.listProcesses)(r.mainPID).then(async s=>(o.push(""),o.push(this.formatEnvironment(r)),o.push(""),o.push(this.formatProcessList(r,s)),r.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(o.push(""),o.push("Workspace Stats: "),o.push(await this.formatWorkspaceMetadata(r))),n.forEach(a=>{if((0,p.isRemoteDiagnosticError)(a))o.push(`
${a.errorMessage}`);else if(o.push(`

`),o.push(`Remote:           ${a.hostName}`),o.push(this.formatMachineInfo(a.machineInfo)),a.processes&&o.push(this.formatProcessList(r,a.processes)),a.workspaceMetadata)for(const l of Object.keys(a.workspaceMetadata)){const g=a.workspaceMetadata[l];let I=`${g.fileCount} files`;g.maxFilesReached&&(I=`more than ${I}`),o.push(`Folder (${l}): ${I}`),o.push(this.formatWorkspaceStats(g))}}),o.push(""),o.push(""),o.join(`
`)))}formatWorkspaceStats(r){const n=[],o=60;let s=0;const a=(_,O)=>{const U=` ${_}(${O})`;s+U.length>o?(n.push(l),l="|                 ",s=l.length):s+=U.length,l+=U};let l="|      File types:";const g=10;let I=r.fileTypes.length>g?g:r.fileTypes.length;for(let _=0;_<I;_++){const O=r.fileTypes[_];a(O.name,O.count)}if(n.push(l),r.configFiles.length>=0&&(l="|      Conf files:",s=0,r.configFiles.forEach(_=>{a(_.name,_.count)}),n.push(l)),r.launchConfigFiles.length>0){let _="|      Launch Configs:";r.launchConfigFiles.forEach(O=>{_+=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`}),n.push(_)}return n.join(`
`)}expandGPUFeatures(r){const n=Math.max(...Object.keys(r).map(o=>o.length));return Object.keys(r).map(o=>`${o}:  ${" ".repeat(n-o.length)}  ${r[o]}`).join(`
                  `)}formatWorkspaceMetadata(r){const n=[],o=[];return r.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(n.push(`|  Window (${s.title})`),s.folderURIs.forEach(a=>{const l=C.URI.revive(a);if(l.scheme===A.Schemas.file){const g=l.fsPath;o.push(w(g,["node_modules",".git"]).then(I=>{let _=`${I.fileCount} files`;I.maxFilesReached&&(_=`more than ${_}`),n.push(`|    Folder (${(0,R.basename)(g)}): ${_}`),n.push(this.formatWorkspaceStats(I))}).catch(I=>{n.push(`|      Error: Unable to collect workspace stats for folder ${g} (${I.toString()})`)}))}else n.push(`|    Folder (${l.toString()}): Workspace stats not available.`)}))}),Promise.all(o).then(s=>n.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(r,n){const o=new Map;r.windows.forEach(a=>o.set(a.pid,a.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),n&&this.formatProcessItem(r.mainPID,o,s,n,0),s.join(`
`)}formatProcessItem(r,n,o,s,a){const l=a===0;let g;l?g=s.pid===r?`${this.productService.applicationName} main`:"remote agent":(g=`${"  ".repeat(a)} ${s.name}`,s.name==="window"&&(g=`${g} (${n.get(s.pid)})`));const I=process.platform==="win32"?s.mem:k.totalmem()*(s.mem/100);o.push(`${s.load.toFixed(0).padStart(5," ")}	${(I/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${g}`),Array.isArray(s.children)&&s.children.forEach(_=>this.formatProcessItem(r,n,o,_,a+1))}async getWorkspaceFileExtensions(r){const n=new Set;for(const{uri:o}of r.folders){const s=C.URI.revive(o);if(s.scheme!==A.Schemas.file)continue;const a=s.fsPath;try{(await w(a,["node_modules",".git"])).fileTypes.forEach(g=>n.add(g.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(r){for(const{uri:n}of r.folders){const o=C.URI.revive(n);if(o.scheme!==A.Schemas.file)continue;const s=o.fsPath;try{const a=await w(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),a.fileTypes.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:l.name,count:l.count})}),a.launchConfigFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:l.name,count:l.count})}),a.configFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:l.name,count:l.count})})}catch{}}}};i=he([G(0,v.ITelemetryService),G(1,u.IProductService)],i),e.DiagnosticsService=i}),define(te[205],ne([0,1,16,5,25,9,3,2,4,11,7,129,30,31,8,27,21]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p,h,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let m=class extends R.Disposable{constructor(c,r,n,o){super();this.galleryService=c,this.telemetryService=r,this.logService=n,this.productService=o,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new A.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new A.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new A.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new A.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,R.toDisposable)(()=>{this.installingExtensions.forEach(s=>s.cancel()),this.uninstallingExtensions.forEach(s=>s.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(c){const r=await this.getTargetPlatform();return c.allTargetPlatforms.some(n=>(0,f.isTargetPlatformCompatible)(n,c.allTargetPlatforms,r))}async installFromGallery(c,r={}){try{if(!this.galleryService.isEnabled())throw new f.ExtensionManagementError(E.localize(0,null),f.ExtensionManagementErrorCode.Internal);const n=await this.checkAndGetCompatibleVersion(c,!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.installExtension(n.manifest,n.extension,r)}catch(n){throw S(this.telemetryService,"extensionGallery:install",(0,p.getGalleryExtensionTelemetryData)(c),void 0,n),this.logService.error("Failed to install extension.",c.identifier.id),this.logService.error(n),y(n)}}async uninstall(c,r={}){return this.logService.trace("ExtensionManagementService#uninstall",c.identifier.id),this.unininstallExtension(c,r)}async reinstallFromGallery(c){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",c.identifier.id),!this.galleryService.isEnabled())throw new Error(E.localize(1,null));const r=await this.getTargetPlatform(),[n]=await this.galleryService.getExtensions([{...c.identifier,preRelease:c.preRelease}],{targetPlatform:r,compatible:!0},L.CancellationToken.None);if(!n)throw new Error(E.localize(2,null));await this.createUninstallExtensionTask(c,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(n)}getExtensionsControlManifest(){const c=new Date().getTime();return(!this.extensionsControlManifest||c-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=c),this.extensionsControlManifest}registerParticipant(c){this.participants.push(c)}async installExtension(c,r,n){if(!P.URI.isUri(r)){let g=this.installingExtensions.get(new p.ExtensionIdentifierWithVersion(r.identifier,r.version).key());if(g)return this.logService.info("Extensions is already requested to install",r.identifier.id),g.waitUntilTaskIsFinished();n={...n,installOnlyNewlyAddedFromExtensionPack:!0}}const o=[],s=[],a=this.createInstallExtensionTask(c,r,n);P.URI.isUri(r)||this.installingExtensions.set(new p.ExtensionIdentifierWithVersion(a.identifier,c.version).key(),a),this._onInstallExtension.fire({identifier:a.identifier,source:r}),this.logService.info("Installing extension:",a.identifier.id),o.push({task:a,manifest:c});let l=!1;try{if(n.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",a.identifier.id);else try{const I=await this.getAllDepsAndPackExtensionsToInstall(a.identifier,c,!!n.installOnlyNewlyAddedFromExtensionPack,!!n.installPreReleaseVersion);for(const{gallery:_,manifest:O}of I)if(l=l||!!O.extensionDependencies?.some(U=>(0,p.areSameExtensions)({id:U},a.identifier)),this.installingExtensions.has(new p.ExtensionIdentifierWithVersion(_.identifier,_.version).key()))this.logService.info("Extension is already requested to install",_.identifier.id);else{const U=this.createInstallExtensionTask(O,_,{...n,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new p.ExtensionIdentifierWithVersion(U.identifier,O.version).key(),U),this._onInstallExtension.fire({identifier:U.identifier,source:_}),this.logService.info("Installing extension:",U.identifier.id),o.push({task:U,manifest:O})}}catch(I){if(P.URI.isUri(a.source))(0,k.isNonEmptyArray)(c.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",a.identifier.id,I.message),(0,k.isNonEmptyArray)(c.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",a.identifier.id,I.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",a.identifier.id),I}const g=o.reduce((I,{task:_,manifest:O})=>(I.set(_.identifier.id.toLowerCase(),{task:_,manifest:O}),I),new Map);for(;g.size;){let I;const _=[...g.values()].filter(({manifest:O})=>!O.extensionDependencies?.some(U=>g.has(U.toLowerCase())));_.length?I=g.size===1?_:_.filter(({task:O})=>!(O===a&&!l)):(this.logService.info("Found extensions with circular dependencies",_.map(({task:O})=>O.identifier.id)),I=[...g.values()]),await this.joinAllSettled(I.map(async({task:O})=>{const U=new Date().getTime(),D=(0,C.isUndefined)(n.operation)?O.operation:n.operation;try{const M=await O.run();if(await this.joinAllSettled(this.participants.map(N=>N.postInstall(M,O.source,n,L.CancellationToken.None))),!P.URI.isUri(O.source)&&(S(this.telemetryService,D===3?"extensionGallery:update":"extensionGallery:install",(0,p.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-U,void 0),b.isWeb&&D!==3))try{await this.galleryService.reportStatistic(M.manifest.publisher,M.manifest.name,M.manifest.version,"install")}catch{}s.push({local:M,identifier:O.identifier,operation:D,source:O.source})}catch(M){throw P.URI.isUri(O.source)||S(this.telemetryService,D===3?"extensionGallery:update":"extensionGallery:install",(0,p.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-U,M),this.logService.error("Error while installing the extension:",O.identifier.id),M}finally{g.delete(O.identifier.id.toLowerCase())}}))}return s.forEach(({identifier:I})=>this.logService.info("Extension installed successfully:",I.id)),this._onDidInstallExtensions.fire(s),s.filter(({identifier:I})=>(0,p.areSameExtensions)(I,a.identifier))[0].local}catch(g){if(o.forEach(({task:I})=>I.cancel()),s.length)try{const I=await Promise.allSettled(s.map(({local:_})=>this.createUninstallExtensionTask(_,{versionOnly:!0}).run()));for(let _=0;_<I.length;_++){const O=I[_],{identifier:U}=s[_];O.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",U.id):this.logService.warn("Rollback: Error while uninstalling extension",U.id,(0,T.getErrorMessage)(O.reason))}}catch(I){this.logService.warn("Error while rolling back extensions",(0,T.getErrorMessage)(I),s.map(({identifier:_})=>_.id))}throw this._onDidInstallExtensions.fire(o.map(({task:I})=>({identifier:I.identifier,operation:2,source:I.source}))),g}finally{for(const{task:g,manifest:I}of o)if(!P.URI.isUri(g.source)){const _=new p.ExtensionIdentifierWithVersion(g.identifier,I.version).key();this.installingExtensions.delete(_)||this.logService.warn("Installation task is not found in the cache",_)}}}async joinAllSettled(c){const r=[],n=[],o=await Promise.allSettled(c);for(const s of o)s.status==="fulfilled"?r.push(s.value):n.push(s.reason);if(n.length)throw w(n);return r}async getAllDepsAndPackExtensionsToInstall(c,r,n,o){if(!this.galleryService.isEnabled())return[];let s=await this.getInstalled();const a=[c,...s.map(I=>I.identifier)],l=[],g=async(I,_)=>{const O=_.extensionDependencies||[],U=[...O];if(_.extensionPack){const D=n?s.find(M=>(0,p.areSameExtensions)(M.identifier,I)):void 0;for(const M of _.extensionPack)D&&D.manifest.extensionPack&&D.manifest.extensionPack.some(N=>(0,p.areSameExtensions)({id:N},{id:M}))||U.every(N=>!(0,p.areSameExtensions)({id:N},{id:M}))&&U.push(M)}if(U.length){const D=[...a,...l.map(N=>N.gallery.identifier)],M=U.filter(N=>D.every(x=>!(0,p.areSameExtensions)(x,{id:N})));if(M.length){const N=await this.galleryService.getExtensions(M.map(x=>({id:x,preRelease:o})),L.CancellationToken.None);for(const x of N){if(D.find(ie=>(0,p.areSameExtensions)(ie,x.identifier)))continue;const Q=O.some(ie=>(0,p.areSameExtensions)({id:ie},x.identifier));let W;try{W=await this.checkAndGetCompatibleVersion(x,!0,o)}catch(ie){if(ie instanceof f.ExtensionManagementError&&ie.code===f.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!Q){this.logService.info("Skipping the packed extension as it cannot be installed",x.identifier.id);continue}else throw ie}l.push({gallery:W.extension,manifest:W.manifest}),await g(W.extension.identifier,W.manifest)}}}};return await g(c,r),s=await this.getInstalled(),l.filter(I=>!s.some(_=>(0,p.areSameExtensions)(_.identifier,I.gallery.identifier)))}async checkAndGetCompatibleVersion(c,r,n){const o=await this.getExtensionsControlManifest();if((0,p.getMaliciousExtensionsSet)(o).has(c.identifier.id))throw new f.ExtensionManagementError(E.localize(3,null,c.identifier.id),f.ExtensionManagementErrorCode.Malicious);if(!!o.unsupportedPreReleaseExtensions&&!!o.unsupportedPreReleaseExtensions[c.identifier.id])throw new f.ExtensionManagementError(E.localize(4,null,c.identifier.id,o.unsupportedPreReleaseExtensions[c.identifier.id].displayName),f.ExtensionManagementErrorCode.UnsupportedPreRelease);if(!await this.canInstall(c)){const l=await this.getTargetPlatform();throw new f.ExtensionManagementError(E.localize(5,null,c.identifier.id,this.productService.nameLong,(0,f.TargetPlatformToString)(l)),f.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const s=await this.getCompatibleVersion(c,r,n);if(s){if(n&&r&&c.hasPreReleaseVersion&&!s.properties.isPreReleaseVersion)throw new f.ExtensionManagementError(E.localize(6,null,c.identifier.id,this.productService.nameLong,this.productService.version),f.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!n&&c.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([c.identifier],L.CancellationToken.None))[0]?new f.ExtensionManagementError(E.localize(7,null,c.identifier.id),f.ExtensionManagementErrorCode.ReleaseVersionNotFound):new f.ExtensionManagementError(E.localize(8,null,c.identifier.id,this.productService.nameLong,this.productService.version),f.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",s.identifier.id);const a=await this.galleryService.getManifest(s,L.CancellationToken.None);if(a===null)throw new f.ExtensionManagementError(`Missing manifest for extension ${c.identifier.id}`,f.ExtensionManagementErrorCode.Invalid);if(a.version!==s.version)throw new f.ExtensionManagementError(`Cannot install '${c.identifier.id}' extension because of version mismatch in Marketplace`,f.ExtensionManagementErrorCode.Invalid);return{extension:s,manifest:a}}async getCompatibleVersion(c,r,n){const o=await this.getTargetPlatform();let s=null;return r&&c.hasPreReleaseVersion&&c.properties.isPreReleaseVersion!==n&&(s=(await this.galleryService.getExtensions([{...c.identifier,preRelease:n}],{targetPlatform:o,compatible:!0},L.CancellationToken.None))[0]||null),!s&&await this.galleryService.isExtensionCompatible(c,n,o)&&(s=c),!s&&r&&(s=await this.galleryService.getCompatibleExtension(c,n,o)),s}async unininstallExtension(c,r){const n=this.uninstallingExtensions.get(c.identifier.id.toLowerCase());if(n)return this.logService.info("Extensions is already requested to uninstall",c.identifier.id),n.waitUntilTaskIsFinished();const o=(g,I)=>{const _=this.createUninstallExtensionTask(g,I);return this.uninstallingExtensions.set(_.extension.identifier.id.toLowerCase(),_),this.logService.info("Uninstalling extension:",g.identifier.id),this._onUninstallExtension.fire(g.identifier),_},s=(g,I)=>{I?this.logService.error("Failed to uninstall extension:",g.identifier.id,I.message):this.logService.info("Successfully uninstalled extension:",g.identifier.id),S(this.telemetryService,"extensionGallery:uninstall",(0,p.getLocalExtensionTelemetryData)(g),void 0,I),this._onDidUninstallExtension.fire({identifier:g.identifier,error:I?.code})},a=[],l=[];try{a.push(o(c,{}));const g=await this.getInstalled(1);if(r.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",c.identifier.id);else{const I=this.getAllPackExtensionsToUninstall(c,g);for(const _ of I)this.uninstallingExtensions.has(_.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",_.identifier.id):a.push(o(_,{}))}r.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",c.identifier.id):this.checkForDependents(a.map(I=>I.extension),g,c),await this.joinAllSettled(a.map(async I=>{try{if(await I.run(),await this.joinAllSettled(this.participants.map(_=>_.postUninstall(I.extension,r,L.CancellationToken.None))),I.extension.identifier.uuid)try{await this.galleryService.reportStatistic(I.extension.manifest.publisher,I.extension.manifest.name,I.extension.manifest.version,"uninstall")}catch{}s(I.extension)}catch(_){const O=_ instanceof f.ExtensionManagementError?_:new f.ExtensionManagementError((0,T.getErrorMessage)(_),f.ExtensionManagementErrorCode.Internal);throw s(I.extension,O),O}finally{l.push(I)}}))}catch(g){const I=g instanceof f.ExtensionManagementError?g:new f.ExtensionManagementError((0,T.getErrorMessage)(g),f.ExtensionManagementErrorCode.Internal);for(const _ of a){try{_.cancel()}catch{}l.includes(_)||s(_.extension,I)}throw I}finally{for(const g of a)this.uninstallingExtensions.delete(g.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",g.extension.identifier.id)}}checkForDependents(c,r,n){for(const o of c){const s=this.getDependents(o,r);if(s.length){const a=s.filter(l=>!c.some(g=>(0,p.areSameExtensions)(g.identifier,l.identifier)));if(a.length)throw new Error(this.getDependentsErrorMessage(o,a,n))}}}getDependentsErrorMessage(c,r,n){return n===c?r.length===1?E.localize(9,null,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?E.localize(10,null,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):E.localize(11,null,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?E.localize(12,null,n.manifest.displayName||n.manifest.name,c.manifest.displayName||c.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?E.localize(13,null,n.manifest.displayName||n.manifest.name,c.manifest.displayName||c.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):E.localize(14,null,n.manifest.displayName||n.manifest.name,c.manifest.displayName||c.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}getAllPackExtensionsToUninstall(c,r,n=[]){if(n.indexOf(c)!==-1)return[];n.push(c);const o=c.manifest.extensionPack?c.manifest.extensionPack:[];if(o.length){const s=r.filter(l=>!l.isBuiltin&&o.some(g=>(0,p.areSameExtensions)({id:g},l.identifier))),a=[];for(const l of s)a.push(...this.getAllPackExtensionsToUninstall(l,r,n));return[...s,...a]}return[]}getDependents(c,r){return r.filter(n=>n.manifest.extensionDependencies&&n.manifest.extensionDependencies.some(o=>(0,p.areSameExtensions)({id:o},c.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const c=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",c),c}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[]}}}};m=he([G(0,f.IExtensionGalleryService),G(1,v.ITelemetryService),G(2,h.ILogService),G(3,u.IProductService)],m),e.AbstractExtensionManagementService=m;function w(i){const c=Array.isArray(i)?i:[i];return c.length===1?c[0]instanceof Error?c[0]:new Error(c[0]):c.reduce((r,n)=>new Error(`${r.message}${r.message?",":""}${n instanceof Error?n.message:n}`),new Error(""))}e.joinErrors=w;function y(i){if(i instanceof f.ExtensionManagementError)return i;const c=new f.ExtensionManagementError(i.message,f.ExtensionManagementErrorCode.Internal);return c.stack=i.stack,c}function S(i,c,r,n,o){const s=o?o instanceof f.ExtensionManagementError?o.code:f.ExtensionManagementErrorCode.Internal:void 0;i.publicLogError(c,{...r,success:!o,duration:n,errorcode:s})}e.reportTelemetry=S;class d{constructor(){this.barrier=new t.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,t.createCancelablePromise)(c=>this.doRun(c))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,t.createCancelablePromise)(c=>new Promise((r,n)=>{const o=c.onCancellationRequested(()=>{o.dispose(),n((0,T.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=d}),define(te[206],ne([0,1,16,5,68,3,10,4,33,7,131,14,30,31,194,83,15,8,60,27,43,23,21]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p,h,u,v,m,w,y,S,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const c="extensionTips/promptedExecutableTips",r="extensionTips/lastPromptedMediumImpExeTime";let n=class extends h.ExtensionTipsService{constructor(s,a,l,g,I,_,O,U,D,M){super(O,U,D,M);this.environmentService=s,this.telemetryService=a,this.extensionManagementService=l,this.storageService=g,this.nativeHostService=I,this.extensionRecommendationNotificationService=_,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,U.exeBasedExtensionTips&&(0,L.forEach)(U.exeBasedExtensionTips,({key:N,value:x})=>{const Q=[],W=[],ie=[];(0,L.forEach)(x.recommendations,({key:B,value:j})=>{j.important?x.important?Q.push({extensionId:B,extensionName:j.name,isExtensionPack:!!j.isExtensionPack}):W.push({extensionId:B,extensionName:j.name,isExtensionPack:!!j.isExtensionPack}):ie.push({extensionId:B,extensionName:j.name,isExtensionPack:!!j.isExtensionPack})}),Q.length&&this.highImportanceExecutableTips.set(N,{exeFriendlyName:x.friendlyName,windowsPath:x.windowsPath,recommendations:Q}),W.length&&this.mediumImportanceExecutableTips.set(N,{exeFriendlyName:x.friendlyName,windowsPath:x.windowsPath,recommendations:W}),ie.length&&this.allOtherExecutableTips.set(N,{exeFriendlyName:x.friendlyName,windowsPath:x.windowsPath,recommendations:ie})}),(0,t.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),a=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...s,...a]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),a=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),l=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(s,l),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(a,l)}groupImportantTipsByExe(s,a){const l=new Map;s.forEach(U=>l.set(U.extensionId.toLowerCase(),U));const{installed:g,uninstalled:I}=this.groupByInstalled([...l.keys()],a);for(const U of g){const D=l.get(U);D&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:U,exeName:D.exeName})}for(const U of I){const D=l.get(U);D&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:U,exeName:D.exeName})}const _=this.getPromptedExecutableTips(),O=new Map;for(const U of I){const D=l.get(U);if(D&&(!_[D.exeName]||!_[D.exeName].includes(D.extensionId))){let M=O.get(D.exeName);M||(M=[],O.set(D.exeName,M)),M.push(D)}}return O}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[s,a]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(a).then(l=>{switch(l){case"reacted":this.addToRecommendedExecutables(a[0].exeName,a);break;case"ignored":this.highImportanceTipsByExe.delete(s);break;case"incompatibleWindow":{const g=T.Event.once(T.Event.latch(T.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(g(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const g=this._register((0,t.disposableTimeout)(()=>{g.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const s=this.getLastPromptedMediumExeTime(),a=Date.now()-s,l=7*24*60*60*1e3;if(a<l){const _=this._register((0,t.disposableTimeout)(()=>{_.dispose(),this.promptMediumImportanceExeBasedTip()},l-a));return}const[g,I]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(I).then(_=>{switch(_){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(g),this.addToRecommendedExecutables(I[0].exeName,I);const O=this._register((0,t.disposableTimeout)(()=>{O.dispose(),this.promptMediumImportanceExeBasedTip()},l));break}case"ignored":this.mediumImportanceTipsByExe.delete(g),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const O=T.Event.once(T.Event.latch(T.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(O(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const O=this._register((0,t.disposableTimeout)(()=>{O.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}}})}async promptExeRecommendations(s){const a=await this.extensionManagementService.getInstalled(1),l=s.filter(I=>!I.whenNotInstalled||I.whenNotInstalled.every(_=>a.every(O=>!(0,p.areSameExtensions)(O.identifier,{id:_})))).map(({extensionId:I})=>I.toLowerCase()),g=(0,P.localize)(0,null,s[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(l,g,`@exe:"${s[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let s=this.storageService.getNumber(r,0);return s||(s=Date.now(),this.updateLastPromptedMediumExeTime(s)),s}updateLastPromptedMediumExeTime(s){this.storageService.store(r,s,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(c,0,"{}"))}addToRecommendedExecutables(s,a){const l=this.getPromptedExecutableTips();l[s]=a.map(({extensionId:g})=>g.toLowerCase()),this.storageService.store(c,JSON.stringify(l),0,0)}groupByInstalled(s,a){const l=[],g=[],I=a.reduce((_,O)=>(_.add(O.identifier.id.toLowerCase()),_),new Set);return s.forEach(_=>{I.has(_.toLowerCase())?l.push(_):g.push(_)}),{installed:l,uninstalled:g}}async getValidExecutableBasedExtensionTips(s){const a=[],l=new Map;for(const g of s.keys()){const I=s.get(g);if(!I||!(0,k.isNonEmptyArray)(I.recommendations))continue;const _=[];R.isWindows?I.windowsPath&&_.push(I.windowsPath.replace("%USERPROFILE%",b.env.USERPROFILE).replace("%ProgramFiles(x86)%",b.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",b.env.ProgramFiles).replace("%APPDATA%",b.env.APPDATA).replace("%WINDIR%",b.env.WINDIR)):(_.push((0,A.join)("/usr/local/bin",g)),_.push((0,A.join)("/usr/bin",g)),_.push((0,A.join)(this.environmentService.userHome.fsPath,g)));for(const O of _){let U=l.get(O);if(U===void 0&&(U=await this.fileService.exists(C.URI.file(O)),l.set(O,U)),U)for(const{extensionId:D,extensionName:M,isExtensionPack:N,whenNotInstalled:x}of I.recommendations)a.push({extensionId:D,extensionName:M,isExtensionPack:N,exeName:g,exeFriendlyName:I.exeFriendlyName,windowsPath:I.windowsPath,whenNotInstalled:x})}}return a}};n=he([G(0,E.INativeEnvironmentService),G(1,i.ITelemetryService),G(2,f.IExtensionManagementService),G(3,d.IStorageService),G(4,w.INativeHostService),G(5,u.IExtensionRecommendationNotificationService),G(6,v.IFileService),G(7,y.IProductService),G(8,S.IRequestService),G(9,m.ILogService)],n),e.ExtensionTipsService=n}),define(te[93],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class k{constructor(T){this.appenders=T}listen(T,A){throw new Error(`Event not found: ${A}`)}call(T,A,{eventName:R,data:b}){return this.appenders.forEach(C=>C.log(R,b)),Promise.resolve(null)}}e.TelemetryAppenderChannel=k;class t{constructor(T){this.channel=T}log(T,A){return this.channel.call("log",{eventName:T,data:A}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=t}),define(te[44],ne([0,1,28,11,19,21]),function(K,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class A{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(w,y){return Promise.resolve(void 0)}publicLog2(w,y){return this.publicLog(w,y)}publicLogError(w,y){return Promise.resolve(void 0)}publicLogError2(w,y){return this.publicLogError(w,y)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=A,e.NullTelemetryService=new A;class R{async publicLog(w,y,S){}async publicLogError(w,y,S){}}e.NullEndpointTelemetryService=R,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function b(m,w){return w.onDidChangeConfiguration(y=>{y.source!==6&&m.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(y.source),configurationKeys:h(y.sourceConfig)})})}e.configurationTelemetry=b;function C(m,w){return!(w.disableTelemetry||!m.enableTelemetry||w.extensionTestsLocationURI)}e.supportsTelemetry=C;function P(m){const w=m.getValue(T.TELEMETRY_SETTING_ID),y=m.getValue("telemetry.enableCrashReporter");if(m.getValue(T.TELEMETRY_OLD_SETTING_ID)===!1||y===!1)return 0;switch(w??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=P;function E(m){const w=Object.create(null),y=Object.create(null),S=Object.create(null);p(m,S);for(let d in S){d=d.length>150?d.substr(d.length-149):d;const i=S[d];typeof i=="number"?y[d]=i:typeof i=="boolean"?y[d]=i?1:0:typeof i=="string"?(i.length>8192&&console.warn(`Telemetry property: ${d} has been trimmed to 8192, the original length is ${i.length}`),w[d]=i.substring(0,8191)):typeof i!="undefined"&&i!==null&&(w[d]=i)}return{properties:w,measurements:y}}e.validateTelemetryData=E;function f(m){if(!m)return"none";let w="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(S=>{m.indexOf(`${S}+`)===0&&(w=S)}),w}e.cleanRemoteAuthority=f;function p(m,w,y=0,S){if(!!m)for(let d of Object.getOwnPropertyNames(m)){const i=m[d],c=S?S+d:d;Array.isArray(i)?w[c]=(0,k.safeStringify)(i):i instanceof Date?w[c]=i.toISOString():(0,t.isObject)(i)?y<2?p(i,w,y+1,c+"."):w[c]=(0,k.safeStringify)(i):w[c]=i}}function h(m){if(!m)return[];const w=[];return u(w,"",m),w}function u(m,w,y){y&&typeof y=="object"&&!Array.isArray(y)?Object.keys(y).forEach(S=>u(m,w?`${w}.${S}`:S,y[S])):m.push(w)}function v(m){return[m.appRoot,m.extensionsPath,m.userHome.fsPath,m.tmpDir.fsPath,m.userDataPath]}e.getPiiPathsFromEnvironment=v}),define(te[207],ne([0,1,44,150]),function(K,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentService=e.BaseAssignmentService=void 0;class L{constructor(){}setSharedProperty(b,C){}postEvent(b,C){}}class T{constructor(b,C,P,E,f){this.getMachineId=b,this.configurationService=C,this.productService=P,this.telemetry=E,this.keyValueStorage=f,this.networkInitialized=!1,P.tasConfig&&this.experimentsEnabled&&(0,k.getTelemetryLevel)(this.configurationService)===3&&(this.tasClient=this.setupTASClient());const p=this.configurationService.getValue("experiments.overrideDelay"),h=typeof p=="number"?p:0;this.overrideInitDelay=new Promise(u=>setTimeout(u,h))}get experimentsEnabled(){return!0}async getTreatment(b){await this.overrideInitDelay;const C=this.configurationService.getValue("experiments.override."+b);if(C!==void 0)return C;if(!this.tasClient||!this.experimentsEnabled)return;let P;const E=await this.tasClient;return this.networkInitialized?P=E.getTreatmentVariable("vscode",b):P=await E.getTreatmentVariableAsync("vscode",b,!0),P=E.getTreatmentVariable("vscode",b),P}async setupTASClient(){const b=this.productService.quality==="stable"?t.TargetPopulation.Public:t.TargetPopulation.Insiders,C=await this.getMachineId(),P=new t.AssignmentFilterProvider(this.productService.version,this.productService.nameLong,C,b),E=this.productService.tasConfig,f=new(await new Promise((p,h)=>{K(["tas-client-umd"],p,h)})).ExperimentationService({filterProviders:[P],telemetry:this.telemetry,storageKey:t.ASSIGNMENT_STORAGE_KEY,keyValueStorage:this.keyValueStorage,featuresTelemetryPropertyName:E.featuresTelemetryPropertyName,assignmentContextTelemetryPropertyName:E.assignmentContextTelemetryPropertyName,telemetryEventName:E.telemetryEventName,endpoint:E.endpoint,refetchInterval:t.ASSIGNMENT_REFETCH_INTERVAL});return await f.initializePromise,f.initialFetch.then(()=>this.networkInitialized=!0),f}}e.BaseAssignmentService=T;class A extends T{constructor(b,C,P){super(()=>Promise.resolve(b),C,P,new L)}}e.AssignmentService=A}),define(te[208],ne([0,1,47,44]),function(K,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function L(T,A,R,b,C,P){const E={"X-Market-Client-Id":`VSCode ${T}`,"User-Agent":`VSCode ${T} (${A.nameShort})`},f=await(0,k.getServiceMachineId)(R,C,P);return(0,t.supportsTelemetry)(A,R)&&(0,t.getTelemetryLevel)(b)===3&&(E["X-Market-User-Id"]=f),E}e.resolveMarketplaceHeaders=L}),define(te[209],ne([0,1,16,25,9,28,4,33,11,7,19,14,30,31,79,15,8,27,43,208,23,21]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p,h,u,v,m,w,y,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const i=A.isWeb?"web":(0,f.getTargetPlatform)(A.platform,R.arch);var c;(function($){$[$.None=0]="None",$[$.IncludeVersions=1]="IncludeVersions",$[$.IncludeFiles=2]="IncludeFiles",$[$.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",$[$.IncludeSharedAccounts=8]="IncludeSharedAccounts",$[$.IncludeVersionProperties=16]="IncludeVersionProperties",$[$.ExcludeNonValidated=32]="ExcludeNonValidated",$[$.IncludeInstallationTargets=64]="IncludeInstallationTargets",$[$.IncludeAssetUri=128]="IncludeAssetUri",$[$.IncludeStatistics=256]="IncludeStatistics",$[$.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",$[$.Unpublished=4096]="Unpublished",$[$.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(c||(c={}));function r(...$){return String($.reduce((z,H)=>z|H,0))}var n;(function($){$[$.Tag=1]="Tag",$[$.ExtensionId=4]="ExtensionId",$[$.Category=5]="Category",$[$.ExtensionName=7]="ExtensionName",$[$.Target=8]="Target",$[$.Featured=9]="Featured",$[$.SearchText=10]="SearchText",$[$.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},s={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},l={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:c.None,criteria:[],assetTypes:[]};class g{constructor(z=l){this.state=z}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(z,H=this.state.pageSize){return new g({...this.state,pageNumber:z,pageSize:H})}withFilter(z,...H){const ee=[...this.state.criteria,...H.length?H.map(se=>({filterType:z,value:se})):[{filterType:z}]];return new g({...this.state,criteria:ee})}withSortBy(z){return new g({...this.state,sortBy:z})}withSortOrder(z){return new g({...this.state,sortOrder:z})}withFlags(...z){return new g({...this.state,flags:z.reduce((H,ee)=>H|ee,0)})}withAssetTypes(...z){return new g({...this.state,assetTypes:z})}get raw(){const{criteria:z,pageNumber:H,pageSize:ee,sortBy:se,sortOrder:ae,flags:de,assetTypes:ge}=this.state;return{filters:[{criteria:z,pageNumber:H,pageSize:ee,sortBy:se,sortOrder:ae}],assetTypes:ge,flags:de}}get searchText(){const z=this.state.criteria.filter(H=>H.filterType===n.SearchText)[0];return z&&z.value?z.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(z=>String(z.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function I($,z){const H=($||[]).filter(ee=>ee.statisticName===z)[0];return H?H.value:0}function _($){const z="Microsoft.VisualStudio.Code.Translation.";return $.files.filter(ee=>ee.assetType.indexOf(z)===0).reduce((ee,se)=>{const ae=M($,se.assetType);return ae&&ee.push([se.assetType.substring(z.length),ae]),ee},[])}function O($){if($.properties){const z=$.properties.filter(se=>se.key===o.Repository),H=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ee=z.filter(se=>H.test(se.value))[0];return ee?{uri:ee.value,fallbackUri:ee.value}:null}return M($,o.Repository)}function U($){return{uri:`${$.fallbackAssetUri}/${o.VSIX}?redirect=true${$.targetPlatform?`&targetPlatform=${$.targetPlatform}`:""}`,fallbackUri:`${$.fallbackAssetUri}/${o.VSIX}${$.targetPlatform?`?targetPlatform=${$.targetPlatform}`:""}`}}function D($){const z=M($,o.Icon);if(z)return z;const H=f.DefaultIconPath;return{uri:H,fallbackUri:H}}function M($,z){return $.files.filter(ee=>ee.assetType===z)[0]?{uri:`${$.assetUri}/${z}${$.targetPlatform?`?targetPlatform=${$.targetPlatform}`:""}`,fallbackUri:`${$.fallbackAssetUri}/${z}${$.targetPlatform?`?targetPlatform=${$.targetPlatform}`:""}`}:null}function N($,z){const H=$.properties?$.properties.filter(se=>se.key===z):[],ee=H.length>0&&H[0].value;return ee?ee.split(",").map(se=>(0,p.adoptToGalleryExtensionId)(se)):[]}function x($){const z=$.properties?$.properties.filter(H=>H.key===s.Engine):[];return z.length>0&&z[0].value||""}function Q($){const z=$.properties?$.properties.filter(H=>H.key===s.PreRelease):[];return z.length>0&&z[0].value==="true"}function W($){const z=$.properties?$.properties.filter(ee=>ee.key===s.LocalizedLanguages):[],H=z.length>0&&z[0].value||"";return H?H.split(","):[]}function ie($){return $.indexOf("preview")!==-1}function B($){return $.targetPlatform?(0,f.toTargetPlatform)($.targetPlatform):"undefined"}function j($){const z=(0,k.distinct)($.versions.map(B)),H=!!$.tags?.includes(f.WEB_EXTENSION_TAG),ee=z.indexOf("web");return H?ee===-1&&z.push("web"):ee!==-1&&z.splice(ee,1),z}function Y($,z){const H=(0,f.getFallbackTargetPlarforms)(z);for(let ee=0;ee<$.length;ee++){const se=$[ee];if(se.version===$[ee-1]?.version){let ae=ee;const de=B(se);if(de===z)for(;ae>0&&$[ae-1].version===se.version;)ae--;else if(H.includes(de))for(;ae>0&&$[ae-1].version===se.version&&B($[ae-1])!==z;)ae--;ae!==ee&&($.splice(ee,1),$.splice(ae,0,se))}}return $}e.sortExtensionVersions=Y;function V($,z,H){$.telemetryData={index:z,querySource:H}}function J($,z,H){const ee=$.versions[0],se={manifest:M(z,o.Manifest),readme:M(z,o.Details),changelog:M(z,o.Changelog),license:M(z,o.License),repository:O(z),download:U(z),icon:D(z),coreTranslations:_(z)};return{identifier:{id:(0,p.getGalleryExtensionId)($.publisher.publisherName,$.extensionName),uuid:$.extensionId},name:$.extensionName,version:z.version,displayName:$.displayName,publisherId:$.publisher.publisherId,publisher:$.publisher.publisherName,publisherDisplayName:$.publisher.displayName,publisherDomain:$.publisher.domain?{link:$.publisher.domain,verified:!!$.publisher.isDomainVerified}:void 0,description:$.shortDescription||"",installCount:I($.statistics,"install"),rating:I($.statistics,"averagerating"),ratingCount:I($.statistics,"ratingcount"),categories:$.categories||[],tags:$.tags||[],releaseDate:Date.parse($.releaseDate),lastUpdated:Date.parse($.lastUpdated),allTargetPlatforms:H,assets:se,properties:{dependencies:N(z,s.Dependency),extensionPack:N(z,s.ExtensionPack),engine:x(z),localizedLanguages:W(z),targetPlatform:B(z),isPreReleaseVersion:Q(z)},hasPreReleaseVersion:Q(ee),hasReleaseVersion:!0,preview:ie($.flags)}}let Z=class{constructor(z,H,ee,se,ae,de,ge,Ee){this.requestService=H,this.logService=ee,this.environmentService=se,this.telemetryService=ae,this.fileService=de,this.productService=ge,this.configurationService=Ee;const Se=ge.extensionsGallery;this.extensionsGalleryUrl=Se&&Se.serviceUrl,this.extensionsControlUrl=Se&&Se.controlUrl,this.commonHeadersPromise=(0,y.resolveMarketplaceHeaders)(ge.version,ge,this.environmentService,this.configurationService,this.fileService,z)}api(z=""){return`${this.extensionsGalleryUrl}${z}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(z,H,ee){const se=t.CancellationToken.isCancellationToken(H)?{}:H,ae=t.CancellationToken.isCancellationToken(H)?H:ee,de=[],ge=[],Ee=[],Se=[];let pe=!0;for(const De of z){De.uuid?ge.push(De.uuid):de.push(De.id);const Me=!!(De.version||De.preRelease);Ee.push({id:De.id,uuid:De.uuid,includePreRelease:Me}),De.version&&Se.push({id:De.id,uuid:De.uuid,version:De.version}),pe=pe&&!!De.hasPreRelease&&!Me}if(!ge.length&&!de.length)return[];let Ce=new g().withPage(1,z.length);ge.length&&(Ce=Ce.withFilter(n.ExtensionId,...ge)),de.length&&(Ce=Ce.withFilter(n.ExtensionName,...de)),(se.queryAllVersions||pe)&&(Ce=Ce.withFlags(Ce.flags,c.IncludeVersions));const{extensions:Ie}=await this.queryGalleryExtensions(Ce,{targetPlatform:se.targetPlatform??i,includePreRelease:Ee,versions:Se,compatible:!!se.compatible},ae);return se.source&&Ie.forEach((De,Me)=>V(De,Me,se.source)),Ie}async getCompatibleExtension(z,H,ee){if((0,f.isNotWebExtensionInWebTargetPlatform)(z.allTargetPlatforms,ee))return null;if(await this.isExtensionCompatible(z,H,ee))return z;const se=new g().withFlags(c.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,z.identifier.uuid),{extensions:ae}=await this.queryGalleryExtensions(se,{targetPlatform:ee,compatible:!0,includePreRelease:H},t.CancellationToken.None);return ae[0]||null}async isExtensionCompatible(z,H,ee){if(!(0,f.isTargetPlatformCompatible)(z.properties.targetPlatform,z.allTargetPlatforms,ee)||!H&&z.properties.isPreReleaseVersion)return!1;let se=z.properties.engine;if(!se){const ae=await this.getManifest(z,t.CancellationToken.None);if(!ae)throw new Error("Manifest was not found");se=ae.engines.vscode}return(0,h.isEngineValid)(se,this.productService.version,this.productService.date)}async isValidVersion(z,H,ee,se,ae){if(!(0,f.isTargetPlatformCompatible)(B(z),se,ae)||H!=="any"&&Q(z)!==(H==="prerelease"))return!1;if(ee){const de=await this.getEngine(z);if(!(0,h.isEngineValid)(de,this.productService.version,this.productService.date))return!1}return!0}async query(z,H){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let ee=z.text||"";const se=(0,T.getOrDefault)(z,pe=>pe.pageSize,50);let ae=new g().withPage(1,se);ee?(ee=ee.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(pe,Ce,Ie)=>(ae=ae.withFilter(n.Category,Ie||Ce),"")),ee=ee.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(pe,Ce,Ie)=>(ae=ae.withFilter(n.Tag,Ie||Ce),"")),ee=ee.replace(/\bfeatured(\s+|\b|$)/g,()=>(ae=ae.withFilter(n.Featured),"")),ee=ee.trim(),ee&&(ee=ee.length<200?ee:ee.substring(0,200),ae=ae.withFilter(n.SearchText,ee)),ae=ae.withSortBy(0)):z.ids?ae=ae.withFilter(n.ExtensionId,...z.ids):z.names?ae=ae.withFilter(n.ExtensionName,...z.names):ae=ae.withSortBy(4),typeof z.sortBy=="number"&&(ae=ae.withSortBy(z.sortBy)),typeof z.sortOrder=="number"&&(ae=ae.withSortOrder(z.sortOrder));const de=async(pe,Ce)=>{const{extensions:Ie,total:De}=await this.queryGalleryExtensions(pe,{targetPlatform:i,compatible:!1,includePreRelease:!!z.includePreRelease},Ce);return Ie.forEach((Me,je)=>V(Me,(pe.pageNumber-1)*pe.pageSize+je,z.source)),{extensions:Ie,total:De}},{extensions:ge,total:Ee}=await de(ae,H),Se=async(pe,Ce)=>{if(Ce.isCancellationRequested)throw new L.CancellationError;const{extensions:Ie}=await de(ae.withPage(pe+1),Ce);return Ie};return{firstPage:ge,total:Ee,pageSize:ae.pageSize,getPage:Se}}async queryGalleryExtensions(z,H,ee){const se=z.flags;!!(z.flags&c.IncludeLatestVersionOnly)&&!!(z.flags&c.IncludeVersions)&&(z=z.withFlags(z.flags&~c.IncludeVersions,c.IncludeLatestVersionOnly)),!(z.flags&c.IncludeLatestVersionOnly)&&!(z.flags&c.IncludeVersions)&&(z=z.withFlags(z.flags,c.IncludeLatestVersionOnly)),H.versions?.length&&(z=z.withFlags(z.flags&~c.IncludeLatestVersionOnly,c.IncludeVersions)),z=z.withFlags(z.flags,c.IncludeAssetUri,c.IncludeCategoryAndTags,c.IncludeFiles,c.IncludeStatistics,c.IncludeVersionProperties);const{galleryExtensions:ae,total:de}=await this.queryRawGalleryExtensions(z,ee);if(!(z.flags&c.IncludeLatestVersionOnly)){const pe=[];for(const Ce of ae){const Ie=await this.toGalleryExtensionWithCriteria(Ce,H,!0);Ie&&pe.push(Ie)}return{extensions:pe,total:de}}const Ee=[],Se=new Map;for(let pe=0;pe<ae.length;pe++){const Ce=ae[pe],Ie={id:(0,p.getGalleryExtensionId)(Ce.publisher.publisherName,Ce.extensionName),uuid:Ce.extensionId},De=(0,b.isBoolean)(H.includePreRelease)?H.includePreRelease:!!H.includePreRelease.find(je=>(0,p.areSameExtensions)(je,Ie))?.includePreRelease;let Me=await this.toGalleryExtensionWithCriteria(Ce,H,!1);!Me||Me.properties.isPreReleaseVersion&&(!De||!Me.hasReleaseVersion)||!Me.properties.isPreReleaseVersion&&Me.properties.targetPlatform!==H.targetPlatform&&Me.hasPreReleaseVersion?Se.set(Ce.extensionId,pe):Ee.push([pe,Me])}if(Se.size){const pe=new Date().getTime(),Ce=new g().withFlags(se&~c.IncludeLatestVersionOnly,c.IncludeVersions).withPage(1,Se.size).withFilter(n.ExtensionId,...Se.keys()),{extensions:Ie}=await this.queryGalleryExtensions(Ce,H,ee);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-pe,count:Se.size});for(const De of Ie){const Me=Se.get(De.identifier.uuid);Ee.push([Me,De])}}return{extensions:Ee.sort((pe,Ce)=>pe[0]-Ce[0]).map(([,pe])=>pe),total:de}}async toGalleryExtensionWithCriteria(z,H,ee){const se={id:(0,p.getGalleryExtensionId)(z.publisher.publisherName,z.extensionName),uuid:z.extensionId},ae=H.versions?.find(Se=>(0,p.areSameExtensions)(Se,se))?.version,de=(0,b.isBoolean)(H.includePreRelease)?H.includePreRelease:!!H.includePreRelease.find(Se=>(0,p.areSameExtensions)(Se,se))?.includePreRelease,ge=j(z),Ee=Y(z.versions,H.targetPlatform);if(H.compatible&&ee&&(0,f.isNotWebExtensionInWebTargetPlatform)(ge,H.targetPlatform))return null;for(let Se=0;Se<Ee.length;Se++){const pe=Ee[Se];if(!(ae&&pe.version!==ae)){if(await this.isValidVersion(pe,de?"any":"release",H.compatible,ge,H.targetPlatform))return J(z,pe,ge);if(ae&&pe.version===ae)return null}}return ae||H.compatible?null:J(z,z.versions[0],ge)}async queryRawGalleryExtensions(z,H){if(!this.isEnabled())throw new Error("No extension gallery service configured.");z=z.withFlags(z.flags,c.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,r(c.Unpublished));const ee=await this.commonHeadersPromise,se=JSON.stringify(z.raw),ae={...ee,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(se.length)},de=new Date().getTime();let ge,Ee,Se=0;try{if(ge=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:se,headers:ae},H),ge.res.statusCode&&ge.res.statusCode>=400&&ge.res.statusCode<500)return{galleryExtensions:[],total:Se};const pe=await(0,w.asJson)(ge);if(pe){const Ce=pe.results[0],Ie=Ce.extensions,De=Ce.resultMetadata&&Ce.resultMetadata.filter(Me=>Me.metadataType==="ResultCount")[0];return Se=De&&De.metadataItems.filter(Me=>Me.name==="TotalCount")[0].count||0,{galleryExtensions:Ie,total:Se}}return{galleryExtensions:[],total:Se}}catch(pe){throw Ee=pe,pe}finally{this.telemetryService.publicLog2("galleryService:query",{...z.telemetryData,requestBodySize:String(se.length),duration:new Date().getTime()-de,success:!!ge&&(0,w.isSuccess)(ge),responseBodySize:ge?.res.headers["Content-Length"],statusCode:ge?String(ge.res.statusCode):void 0,errorCode:Ee?(0,L.isCancellationError)(Ee)?"canceled":(0,L.getErrorMessage)(Ee).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Se)})}}async reportStatistic(z,H,ee,se){if(!this.isEnabled())return;const ae=A.isWeb?this.api(`/itemName/${z}.${H}/version/${ee}/statType/${se==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${z}/extensions/${H}/${ee}/stats?statType=${se}`),de=A.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",Ee={...await this.commonHeadersPromise,Accept:de};try{await this.requestService.request({type:"POST",url:ae,headers:Ee},t.CancellationToken.None)}catch{}}async download(z,H,ee){this.logService.trace("ExtensionGalleryService#download",z.identifier.id);const se=(0,p.getGalleryExtensionTelemetryData)(z),ae=new Date().getTime(),de=pe=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...se,duration:pe}),ge=ee===2?"install":ee===3?"update":"",Ee=ge?{uri:`${z.assets.download.uri}${C.URI.parse(z.assets.download.uri).query?"&":"?"}${ge}=true`,fallbackUri:`${z.assets.download.fallbackUri}${C.URI.parse(z.assets.download.fallbackUri).query?"&":"?"}${ge}=true`}:z.assets.download,Se=await this.getAsset(Ee);await this.fileService.writeFile(H,Se.stream),de(new Date().getTime()-ae)}async getReadme(z,H){if(z.assets.readme){const ee=await this.getAsset(z.assets.readme,{},H);return await(0,w.asText)(ee)||""}return""}async getManifest(z,H){if(z.assets.manifest){const ee=await this.getAsset(z.assets.manifest,{},H),se=await(0,w.asText)(ee);return se?JSON.parse(se):null}return null}async getManifestFromRawExtensionVersion(z,H){const ee=M(z,o.Manifest);if(!ee)throw new Error("Manifest was not found");const se={"Accept-Encoding":"gzip"},ae=await this.getAsset(ee,{headers:se});return await(0,w.asJson)(ae)}async getCoreTranslation(z,H){const ee=z.assets.coreTranslations.filter(se=>se[0]===H.toUpperCase())[0];if(ee){const se=await this.getAsset(ee[1]),ae=await(0,w.asText)(se);return ae?JSON.parse(ae):null}return null}async getChangelog(z,H){if(z.assets.changelog){const ee=await this.getAsset(z.assets.changelog,{},H);return await(0,w.asText)(ee)||""}return""}async getAllCompatibleVersions(z,H,ee){let se=new g().withFlags(c.IncludeVersions,c.IncludeCategoryAndTags,c.IncludeFiles,c.IncludeVersionProperties).withPage(1,1);z.identifier.uuid?se=se.withFilter(n.ExtensionId,z.identifier.uuid):se=se.withFilter(n.ExtensionName,z.identifier.id);const{galleryExtensions:ae}=await this.queryRawGalleryExtensions(se,t.CancellationToken.None);if(!ae.length)return[];const de=j(ae[0]);if((0,f.isNotWebExtensionInWebTargetPlatform)(de,ee))return[];const ge=[],Ee=new Set;return await Promise.all(ae[0].versions.map(async Se=>{try{if(Ee.has(Se.version))return;await this.isValidVersion(Se,H?"any":"release",!0,de,ee)&&(ge.push({version:Se.version,date:Se.lastUpdated,isPreReleaseVersion:Q(Se)}),Ee.add(Se.version))}catch{}})),ge}async getAsset(z,H={},ee=t.CancellationToken.None){const se=await this.commonHeadersPromise,ae={type:"GET"},de={...se,...H.headers||{}};H={...H,...ae,headers:de};const ge=z.uri,Ee=z.fallbackUri,Se={...H,url:ge};try{const pe=await this.requestService.request(Se,ee);if(pe.res.statusCode===200)return pe;const Ce=await(0,w.asText)(pe);throw new Error(`Expected 200, got back ${pe.res.statusCode} instead.

${Ce}`)}catch(pe){if((0,L.isCancellationError)(pe))throw pe;const Ce=(0,L.getErrorMessage)(pe);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ge,message:Ce});const Ie={...H,url:Ee};return this.requestService.request(Ie,ee)}}async getEngine(z){let H=x(z);if(!H){const ee=await this.getManifestFromRawExtensionVersion(z,t.CancellationToken.None);if(!ee)throw new Error("Manifest was not found");H=ee.engines.vscode}return H}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const z=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},t.CancellationToken.None);if(z.res.statusCode!==200)throw new Error("Could not get extensions report.");const H=await(0,w.asJson)(z),ee=[],se={};if(H){for(const ae of H.malicious)ee.push({id:ae});if(H.unsupported)for(const ae of Object.keys(H.unsupported)){const de=H.unsupported[ae];(0,b.isBoolean)(de)||(se[ae.toLowerCase()]=de.preReleaseExtension)}if(H.migrateToPreRelease)for(const[ae,de]of Object.entries(H.migrateToPreRelease))(!de.engine||(0,h.isEngineValid)(de.engine,this.productService.version,this.productService.date))&&(se[ae.toLowerCase()]=de)}return{malicious:ee,unsupportedPreReleaseExtensions:se}}};Z=he([G(1,w.IRequestService),G(2,v.ILogService),G(3,E.IEnvironmentService),G(4,d.ITelemetryService),G(5,u.IFileService),G(6,m.IProductService),G(7,P.IConfigurationService)],Z);let q=class extends Z{constructor(z,H,ee,se,ae,de,ge,Ee){super(z,H,ee,se,ae,de,ge,Ee)}};q=he([G(0,S.IStorageService),G(1,w.IRequestService),G(2,v.ILogService),G(3,E.IEnvironmentService),G(4,d.ITelemetryService),G(5,u.IFileService),G(6,m.IProductService),G(7,P.IConfigurationService)],q),e.ExtensionGalleryService=q;let F=class extends Z{constructor(z,H,ee,se,ae,de,ge){super(void 0,z,H,ee,se,ae,de,ge)}};F=he([G(0,w.IRequestService),G(1,v.ILogService),G(2,E.IEnvironmentService),G(3,d.ITelemetryService),G(4,u.IFileService),G(5,m.IProductService),G(6,P.IConfigurationService)],F),e.ExtensionGalleryServiceWithNoStorageService=F}),define(te[94],ne([0,1,2,14,8,44]),function(K,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let A=class extends k.Disposable{constructor(b,C,P=""){super();this.prefix=P;const E=b.getLogger(C.telemetryLogResource);E?this.logger=this._register(E):(this.logger=this._register(b.createLogger(C.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(b,C){this.logger.trace(`${this.prefix}telemetry/${b}`,(0,T.validateTelemetryData)(C))}};A=he([G(0,L.ILoggerService),G(1,t.IEnvironmentService)],A),e.TelemetryLogAppender=A}),define(te[95],ne([0,1,2,28,4,26,141,19,42,88,38,21,44]),function(K,e,k,t,L,T,A,R,b,C,P,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let p=class{constructor(v,m){this._configurationService=m,this._experimentProperties={},this._disposables=new k.DisposableStore,this._cleanupPatterns=[],this._appenders=v.appenders,this._commonProperties=v.commonProperties||Promise.resolve({}),this._piiPaths=v.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!v.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let w of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,T.escapeRegExpCharacters)(w),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(v,m){this._experimentProperties[v]=m}_updateTelemetryLevel(){this._telemetryLevel=(0,f.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const v=await this._commonProperties;let m=v.sessionID,w=v["common.machineId"],y=v["common.firstSessionDate"],S=v["common.msftInternal"];return{sessionId:m,machineId:w,firstSessionDate:y,msftInternal:S}}dispose(){this._disposables.dispose()}_log(v,m,w,y){return this.telemetryLevel<m?Promise.resolve(void 0):this._commonProperties.then(S=>{w=(0,t.mixin)(w,S),w=(0,t.mixin)(w,this._experimentProperties),w=(0,t.cloneAndChange)(w,d=>{if(typeof d=="string")return this._cleanupInfo(d,y)}),this._appenders.forEach(d=>d.log(v,w))},S=>{console.error(S)})}publicLog(v,m,w){return this._log(v,3,m,w)}publicLog2(v,m,w){return this.publicLog(v,m,w)}publicLogError(v,m){return this.sendErrorTelemetry?this._log(v,2,m,!0):Promise.resolve(void 0)}publicLogError2(v,m){return this.publicLogError(v,m)}_anonymizeFilePaths(v){let m=v;const w=[];for(let i of this._cleanupPatterns)for(;;){const c=i.exec(v);if(!c)break;w.push([c.index,i.lastIndex])}const y=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,S=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let d=0;for(m="";;){const i=S.exec(v);if(!i)break;!y.test(i[0])&&w.every(([c,r])=>i.index<c||i.index>=r)&&(m+=v.substring(d,i.index)+"<REDACTED: user-file-path>",d=S.lastIndex)}return d<v.length&&(m+=v.substr(d)),m}_removePropertiesWithPossibleUserInfo(v){if(!v)return v;const m=v.toLowerCase(),w=/@[a-zA-Z0-9-.]+/,y=/(key|token|sig|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/,S=/xox[pbaors]\-[a-zA-Z0-9]+\-[a-zA-Z0-9\-]+?/;return y.test(m)?"<REDACTED: secret>":w.test(m)?"<REDACTED: email>":S.test(m)?"<REDACTED: token>":v}_cleanupInfo(v,m){let w=v;m&&(w=this._anonymizeFilePaths(w));for(let y of this._cleanupPatterns)w=w.replace(y,"");return w=this._removePropertiesWithPossibleUserInfo(w),w}};p.IDLE_START_EVENT_NAME="UserIdleStart",p.IDLE_STOP_EVENT_NAME="UserIdleStop",p=he([G(1,R.IConfigurationService)],p),e.TelemetryService=p;function h(){const u=(0,A.localize)(0,null,C.default.nameLong),v=C.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",C.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=L.isWeb?"":(0,A.localize)(3,null),w=(0,A.localize)(4,null),y=(0,A.localize)(5,null),S=(0,A.localize)(6,null),d=(0,A.localize)(7,null),i=`
|       | ${w} | ${y} | ${S} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,c=(0,A.localize)(8,null);return`
${u} ${v} ${m}

&nbsp;

${d}
${i}

&nbsp;

${c}
`}P.Registry.as(b.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,A.localize)(9,null),properties:{[E.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:h(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),P.Registry.as(b.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[E.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:C.default.privacyStatementUrl?(0,A.localize)(16,null,C.default.nameLong,C.default.privacyStatementUrl):(0,A.localize)(15,null,C.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${E.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[210],ne([0,1,9,28,44]),function(K,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function T(R,b){const C=await new Promise((E,f)=>{K(["applicationinsights"],E,f)});let P;return C.defaultClient?(P=new C.TelemetryClient(R),P.channel.setUseDiskRetryCaching(!0)):(C.setup(R).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),P=C.defaultClient),R.indexOf("AIF-")===0&&(P.config.endpointUrl=b?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),P}class A{constructor(b,C,P,E,f){this._eventPrefix=b,this._defaultData=C,this.testCollector=E,this.mirrored=f,this._defaultData||(this._defaultData=Object.create(null)),typeof P=="function"?this._aiClient=P():this._aiClient=P,this._asyncAIClient=null}_withAIClient(b){if(!!this._aiClient){if(typeof this._aiClient!="string"){b(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=T(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(C=>{b(C)},C=>{(0,k.onUnexpectedError)(C),console.error(C)})}}log(b,C){if(!!this._aiClient){C=(0,t.mixin)(C,this._defaultData),C=(0,L.validateTelemetryData)(C),this.testCollector&&(C.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++");try{this._withAIClient(P=>P.trackEvent({name:this._eventPrefix+"/"+b,properties:C.properties,measurements:C.measurements}))}catch{}}}flush(){return this._aiClient?new Promise(b=>{this._withAIClient(C=>{try{C.flush({callback:()=>{this._aiClient=void 0,b(void 0)}})}catch{}})}):Promise.resolve(void 0)}}e.AppInsightsAppender=A}),define(te[211],ne([0,1,18,58,19,14,8,21,93,94,95]),function(K,e,k,t,L,T,A,R,b,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let E=class{constructor(p,h,u,v){this.configurationService=p,this.telemetryService=h,this.loggerService=u,this.environmentService=v,this.customTelemetryServices=new Map}async getCustomTelemetryService(p){if(!this.customTelemetryServices.has(p.id)){const{machineId:h,sessionId:u}=await this.telemetryService.getTelemetryInfo(),v=Object.create(null);v["common.vscodemachineid"]=h,v["common.vscodesessionid"]=u;const m=[p.id,JSON.stringify(v),p.aiKey],y=new t.Client(k.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:m,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),S=[new b.TelemetryAppenderClient(y),new C.TelemetryLogAppender(this.loggerService,this.environmentService,`[${p.id}] `)];this.customTelemetryServices.set(p.id,new P.TelemetryService({appenders:S,sendErrorTelemetry:p.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(p.id)}async publicLog(p,h,u){await(await this.getCustomTelemetryService(p)).publicLog(h,u)}async publicLogError(p,h,u){await(await this.getCustomTelemetryService(p)).publicLogError(h,u)}};E=he([G(0,L.IConfigurationService),G(1,R.ITelemetryService),G(2,A.ILoggerService),G(3,T.IEnvironmentService)],E),e.CustomEndpointTelemetryService=E}),define(te[212],ne([0,1,5,25,3,2,8]),function(K,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let R=class extends T.Disposable{constructor(C,P){super();this._logService=P,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new L.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=C===void 0?15e3:C}createRequest(C){return new Promise((P,E)=>{const f=++this._lastRequestId;this._pendingRequests.set(f,P),this._onCreateRequest.fire({requestId:f,...C});const p=new t.CancellationTokenSource;(0,k.timeout)(this._timeout,p.token).then(()=>E(`Request ${f} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(f,[(0,T.toDisposable)(()=>p.cancel())])})}acceptReply(C,P){const E=this._pendingRequests.get(C);E?(this._pendingRequests.delete(C),(0,T.dispose)(this._pendingRequestDisposables.get(C)||[]),this._pendingRequestDisposables.delete(C),E(P)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${C}`)}};R=he([G(1,A.ILogService)],R),e.RequestStore=R}),define(te[96],ne([0,1,6]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var t;(function(u){u.Shell="terminal.integrated.shell.",u.ShellArgs="terminal.integrated.shellArgs.",u.DefaultProfile="terminal.integrated.defaultProfile.",u.Profiles="terminal.integrated.profiles."})(t=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var L;(function(u){u.ShellLinux="terminal.integrated.shell.linux",u.ShellMacOs="terminal.integrated.shell.osx",u.ShellWindows="terminal.integrated.shell.windows",u.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",u.AutomationShellLinux="terminal.integrated.automationShell.linux",u.AutomationShellMacOs="terminal.integrated.automationShell.osx",u.AutomationShellWindows="terminal.integrated.automationShell.windows",u.AutomationProfileLinux="terminal.integrated.automationProfile.linux",u.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",u.AutomationProfileWindows="terminal.integrated.automationProfile.windows",u.ShellArgsLinux="terminal.integrated.shellArgs.linux",u.ShellArgsMacOs="terminal.integrated.shellArgs.osx",u.ShellArgsWindows="terminal.integrated.shellArgs.windows",u.ProfilesWindows="terminal.integrated.profiles.windows",u.ProfilesMacOs="terminal.integrated.profiles.osx",u.ProfilesLinux="terminal.integrated.profiles.linux",u.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",u.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",u.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",u.UseWslProfiles="terminal.integrated.useWslProfiles",u.TabsEnabled="terminal.integrated.tabs.enabled",u.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",u.TabsHideCondition="terminal.integrated.tabs.hideCondition",u.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",u.TabsShowActions="terminal.integrated.tabs.showActions",u.TabsLocation="terminal.integrated.tabs.location",u.TabsFocusMode="terminal.integrated.tabs.focusMode",u.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",u.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",u.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",u.CopyOnSelection="terminal.integrated.copyOnSelection",u.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",u.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",u.FontFamily="terminal.integrated.fontFamily",u.FontSize="terminal.integrated.fontSize",u.LetterSpacing="terminal.integrated.letterSpacing",u.LineHeight="terminal.integrated.lineHeight",u.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",u.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",u.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",u.BellDuration="terminal.integrated.bellDuration",u.FontWeight="terminal.integrated.fontWeight",u.FontWeightBold="terminal.integrated.fontWeightBold",u.CursorBlinking="terminal.integrated.cursorBlinking",u.CursorStyle="terminal.integrated.cursorStyle",u.CursorWidth="terminal.integrated.cursorWidth",u.Scrollback="terminal.integrated.scrollback",u.DetectLocale="terminal.integrated.detectLocale",u.DefaultLocation="terminal.integrated.defaultLocation",u.GpuAcceleration="terminal.integrated.gpuAcceleration",u.TerminalTitleSeparator="terminal.integrated.tabs.separator",u.TerminalTitle="terminal.integrated.tabs.title",u.TerminalDescription="terminal.integrated.tabs.description",u.RightClickBehavior="terminal.integrated.rightClickBehavior",u.Cwd="terminal.integrated.cwd",u.ConfirmOnExit="terminal.integrated.confirmOnExit",u.ConfirmOnKill="terminal.integrated.confirmOnKill",u.EnableBell="terminal.integrated.enableBell",u.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",u.AllowChords="terminal.integrated.allowChords",u.AllowMnemonics="terminal.integrated.allowMnemonics",u.EnvMacOs="terminal.integrated.env.osx",u.EnvLinux="terminal.integrated.env.linux",u.EnvWindows="terminal.integrated.env.windows",u.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",u.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",u.ShowExitAlert="terminal.integrated.showExitAlert",u.SplitCwd="terminal.integrated.splitCwd",u.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",u.WordSeparators="terminal.integrated.wordSeparators",u.EnableFileLinks="terminal.integrated.enableFileLinks",u.UnicodeVersion="terminal.integrated.unicodeVersion",u.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",u.LocalEchoEnabled="terminal.integrated.localEchoEnabled",u.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",u.LocalEchoStyle="terminal.integrated.localEchoStyle",u.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",u.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",u.CustomGlyphs="terminal.integrated.customGlyphs",u.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",u.InheritEnv="terminal.integrated.inheritEnv",u.ShowLinkHover="terminal.integrated.showLinkHover",u.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",u.AutoReplies="terminal.integrated.autoReplies",u.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",u.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",u.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",u.ShellIntegrationDecorationIcon="terminal.integrated.shellIntegration.decorationIcon",u.ShellIntegrationDecorationIconError="terminal.integrated.shellIntegration.decorationIconError",u.ShellIntegrationDecorationIconSuccess="terminal.integrated.shellIntegration.decorationIconSuccess",u.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history"})(L=e.TerminalSettingId||(e.TerminalSettingId={}));var T;(function(u){u.CommandPrompt="cmd",u.PowerShell="pwsh",u.Wsl="wsl",u.GitBash="gitbash"})(T=e.WindowsShellType||(e.WindowsShellType={}));var A;(function(u){u[u.Api=0]="Api",u[u.Process=1]="Process",u[u.Sequence=2]="Sequence",u[u.Config=3]="Config"})(A=e.TitleEventSource||(e.TitleEventSource={}));var R;(function(u){u.LocalPty="localPty",u.PtyHost="ptyHost",u.Log="log",u.Heartbeat="heartbeat"})(R=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,k.createDecorator)("ptyService");var b;(function(u){u.Cwd="cwd",u.InitialCwd="initialCwd",u.FixedDimensions="fixedDimensions",u.Title="title",u.ShellType="shellType",u.HasChildProcesses="hasChildProcesses",u.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",u.OverrideDimensions="overrideDimensions"})(b=e.ProcessPropertyType||(e.ProcessPropertyType={}));var C;(function(u){u[u.BeatInterval=5e3]="BeatInterval",u[u.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",u[u.SecondWaitMultiplier=1]="SecondWaitMultiplier",u[u.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(C=e.HeartbeatConstants||(e.HeartbeatConstants={}));var P;(function(u){u[u.Panel=1]="Panel",u[u.Editor=2]="Editor"})(P=e.TerminalLocation||(e.TerminalLocation={}));var E;(function(u){u.TerminalView="view",u.Editor="editor"})(E=e.TerminalLocationString||(e.TerminalLocationString={}));var f;(function(u){u[u.GraceTime=6e4]="GraceTime",u[u.ShortGraceTime=6e3]="ShortGraceTime"})(f=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var p;(function(u){u[u.HighWatermarkChars=1e5]="HighWatermarkChars",u[u.LowWatermarkChars=5e3]="LowWatermarkChars",u[u.CharCountAckSize=5e3]="CharCountAckSize"})(p=e.FlowControlConstants||(e.FlowControlConstants={}));var h;(function(u){u.GitBash="Git Bash",u.Pwsh="PowerShell"})(h=e.ProfileSource||(e.ProfileSource={}))}),define(te[213],ne([0,1,6]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,k.createDecorator)("localPtyService")}),define(te[214],ne([0,1,46,10,143,25,37,9,4,29,124,152,5]),function(K,e,k,t,L,T,A,R,b,C,P,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const p=1e4;let h;async function u(m,w,y){return w["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):b.isWindows?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.isLaunchedFromCli)(y)&&!w["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.isLaunchedFromCli)(y)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=f.Promises.withAsyncBody(async(S,d)=>{const i=new T.CancellationTokenSource,c=setTimeout(()=>{i.dispose(!0),d(new Error((0,L.localize)(0,null)))},p);try{S(await v(m,i.token))}catch(r){!(0,R.isCancellationError)(r)&&!i.token.isCancellationRequested?d(new Error((0,L.localize)(1,null,(0,A.toErrorMessage)(r)))):S({})}finally{clearTimeout(c),i.dispose()}})),h)}e.getResolvedShellEnv=u;async function v(m,w){const y=process.env.ELECTRON_RUN_AS_NODE;m.trace("getUnixShellEnvironment#runAsNode",y);const S=process.env.ELECTRON_NO_ATTACH_CONSOLE;m.trace("getUnixShellEnvironment#noAttach",S);const d=(0,C.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(d+"(.*)"+d),c={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};m.trace("getUnixShellEnvironment#env",c);const r=await(0,P.getSystemShell)(b.OS,c);return m.trace("getUnixShellEnvironment#shell",r),new Promise((n,o)=>{if(w.isCancellationRequested)return o((0,R.canceled)());const s=(0,t.basename)(r);let a,l;const g=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(s)?(a=`& '${process.execPath}' ${g} -p '''${d}'' + JSON.stringify(process.env) + ''${d}'''`,l=["-Login","-Command"]):(a=`'${process.execPath}' ${g} -p '"${d}" + JSON.stringify(process.env) + "${d}"'`,s==="tcsh"?l=["-ic"]:l=["-ilc"]),m.trace("getUnixShellEnvironment#spawn",JSON.stringify(l),a);const I=(0,k.spawn)(r,[...l,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:c});w.onCancellationRequested(()=>(I.kill(),o((0,R.canceled)()))),I.on("error",U=>{m.error("getUnixShellEnvironment#errorChildProcess",(0,A.toErrorMessage)(U)),o(U)});const _=[];I.stdout.on("data",U=>_.push(U));const O=[];I.stderr.on("data",U=>O.push(U)),I.on("close",(U,D)=>{const M=Buffer.concat(_).toString("utf8");m.trace("getUnixShellEnvironment#raw",M);const N=Buffer.concat(O).toString("utf8");if(N.trim()&&m.trace("getUnixShellEnvironment#stderr",N),U||D)return o(new Error((0,L.localize)(2,null,U,D)));const x=i.exec(M),Q=x?x[1]:"{}";try{const W=JSON.parse(Q);y?W.ELECTRON_RUN_AS_NODE=y:delete W.ELECTRON_RUN_AS_NODE,S?W.ELECTRON_NO_ATTACH_CONSOLE=S:delete W.ELECTRON_NO_ATTACH_CONSOLE,delete W.XDG_RUNTIME_DIR,m.trace("getUnixShellEnvironment#result",W),n(W)}catch(W){m.error("getUnixShellEnvironment#errorCaught",(0,A.toErrorMessage)(W)),o(W)}})})}}),define(te[215],ne([0,1,34,28,10,4,33,11,22]),function(K,e,k,t,L,T,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function C(){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(k.release());let f=0;return E&&E.length===4&&(f=parseInt(E[3])),f}e.getWindowsBuildNumber=C;async function P(E,f,p,h=A.env,u=b.Promises.exists){if(L.isAbsolute(E))return await u(E)?E:void 0;if(f===void 0&&(f=A.cwd()),L.dirname(E)!=="."){const y=L.join(f,E);return await u(y)?y:void 0}const m=(0,t.getCaseInsensitive)(h,"PATH");if(p===void 0&&(0,R.isString)(m)&&(p=m.split(L.delimiter)),p===void 0||p.length===0){const y=L.join(f,E);return await u(y)?y:void 0}for(let y of p){let S;if(L.isAbsolute(y)?S=L.join(y,E):S=L.join(f,y,E),await u(S))return S;if(T.isWindows){let d=S+".com";if(await u(d)||(d=S+".exe",await u(d)))return d}}const w=L.join(f,E);return await u(w)?w:void 0}e.findExecutable=P}),define(te[216],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var k;(function(t){t.DARK="dark",t.LIGHT="light",t.HIGH_CONTRAST="hc"})(k=e.ColorScheme||(e.ColorScheme={}))}),define(te[97],ne([0,1,48,3,2,6,38,216]),function(K,e,k,t,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,T.createDecorator)("themeService");var b;(function(v){function m(w){return w&&typeof w=="object"&&typeof w.id=="string"}v.isThemeColor=m})(b=e.ThemeColor||(e.ThemeColor={}));function C(v){return{id:v}}e.themeColorFromId=C;var P;(function(v){function m(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color=="undefined"||b.isThemeColor(n.color))}v.isThemeIcon=m;const w=new RegExp(`^\\$\\((${k.CSSIcon.iconNameExpression}(?:${k.CSSIcon.iconModifierExpression})?)\\)$`);function y(n){const o=w.exec(n);if(!o)return;let[,s]=o;return{id:s}}v.fromString=y;function S(n){return{id:n}}v.fromId=S;function d(n,o){let s=n.id;const a=s.lastIndexOf("~");return a!==-1&&(s=s.substring(0,a)),o&&(s=`${s}~${o}`),{id:s}}v.modify=d;function i(n){const o=n.id.lastIndexOf("~");if(o!==-1)return n.id.substring(o+1)}v.getModifier=i;function c(n,o){return n.id===o.id&&n.color?.id===o.color?.id}v.isEqual=c;function r(n,o){return{id:n.id,color:o?C(o):void 0}}v.asThemeIcon=r,v.asClassNameArray=k.CSSIcon.asClassNameArray,v.asClassName=k.CSSIcon.asClassName,v.asCSSSelector=k.CSSIcon.asCSSSelector})(P=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=k.Codicon.file,e.FolderThemeIcon=k.Codicon.folder;function E(v){switch(v){case R.ColorScheme.DARK:return"vs-dark";case R.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=E,e.Extensions={ThemingContribution:"base.contributions.theming"};class f{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(m){return this.themingParticipants.push(m),this.onThemingParticipantAddedEmitter.fire(m),(0,L.toDisposable)(()=>{const w=this.themingParticipants.indexOf(m);this.themingParticipants.splice(w,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new f;A.Registry.add(e.Extensions.ThemingContribution,p);function h(v){return p.onColorThemeChange(v)}e.registerThemingParticipant=h;class u extends L.Disposable{constructor(m){super();this.themeService=m,this.theme=m.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(w=>this.onThemeChange(w)))}onThemeChange(m){this.theme=m,this.updateStyles()}updateStyles(){}getColor(m,w){let y=this.theme.getColor(m);return y&&w&&(y=w(y,this.theme)),y?y.toString():null}}e.Themable=u}),define(te[217],ne([0,1,48,7,97]),function(K,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function T(E,f){const p=E.map(h=>({name:h.profileName,description:A(h)}));return f&&p.push(...f.map(h=>({name:h.title,description:R(h)}))),{values:p.map(h=>h.name),markdownDescriptions:p.map(h=>h.description)}}e.createProfileSchemaEnums=T;function A(E){let f=`$(${L.ThemeIcon.isThemeIcon(E.icon)?E.icon.id:E.icon?E.icon:k.Codicon.terminal.id}) ${E.profileName}
- path: ${E.path}`;return E.args&&(typeof E.args=="string"?f+=`
- args: "${E.args}"`:f+=`
- args: [${E.args.length===0?"":`'${E.args.join("','")}'`}]`),E.overrideName!==void 0&&(f+=`
- overrideName: ${E.overrideName}`),E.color&&(f+=`
- color: ${E.color}`),E.env&&(f+=`
- env: ${JSON.stringify(E.env)}`),f}function R(E){return`$(${L.ThemeIcon.isThemeIcon(E.icon)?E.icon.id:E.icon?E.icon:k.Codicon.terminal.id}) ${E.title}
- extensionIdenfifier: ${E.extensionIdentifier}`}function b(E,f){if(!E&&!f)return!0;if(typeof E=="string"&&typeof f=="string")return E===f;if(Array.isArray(E)&&Array.isArray(f)){if(E.length!==f.length)return!1;for(let p=0;p<E.length;p++)if(E[p]!==f[p])return!1;return!0}return!1}e.terminalProfileArgsMatch=b;function C(E,f){if(!E&&!f)return!0;if(!E||!f)return!1;if(L.ThemeIcon.isThemeIcon(E)&&L.ThemeIcon.isThemeIcon(f))return E.id===f.id&&E.color===f.color;if(typeof E=="object"&&E&&"light"in E&&"dark"in E&&typeof f=="object"&&f&&"light"in f&&"dark"in f){const p=E,h=f;if((t.URI.isUri(p.light)||P(p.light))&&(t.URI.isUri(p.dark)||P(p.dark))&&(t.URI.isUri(h.light)||P(h.light))&&(t.URI.isUri(h.dark)||P(h.dark)))return p.light.path===h.light.path&&p.dark.path===h.dark.path}if(t.URI.isUri(E)&&t.URI.isUri(f)||P(E)||P(f)){const p=E,h=f;return p.path===h.path&&p.scheme===h.scheme}return!1}e.terminalIconsEqual=C;function P(E){return E?typeof E.path=="string"&&typeof E.scheme=="string":!1}e.isUriComponents=P}),define(te[218],ne([0,1,48,142,42,38,217]),function(K,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const R={args:{description:(0,t.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,t.localize)(1,null),type:"boolean"},icon:{description:(0,t.localize)(2,null),type:"string",enum:Array.from(k.Codicon.getAll(),S=>S.id),markdownEnumDescriptions:Array.from(k.Codicon.getAll(),S=>`$(${S.id})`)},color:{description:(0,t.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,t.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},b={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(5,null),type:["string","array"],items:{type:"string"}},...R}},C={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(6,null),type:["string"],items:{type:"string"}},...R}},P=(0,t.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),E=(0,t.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),f=(0,t.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),p=(0,t.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),h=(0,t.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),u=(0,t.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),v={id:"terminal",order:100,title:(0,t.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:h},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:u},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(17,null,"#terminal.integrated.automationShell.linux#"),type:["object","null"],default:null,anyOf:[{type:"null"},C],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,description:(0,t.localize)(18,null,"#terminal.integrated.automationShell.osx#"),type:["object","null"],default:null,anyOf:[{type:"null"},C],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,description:(0,t.localize)(19,null,"#terminal.integrated.automationShell.windows#"),type:["object","null"],default:null,anyOf:[{type:"null"},C],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:P},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:E},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:f},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:P},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:E},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,t.localize)(26,null)}},{type:"string",markdownDescription:(0,t.localize)(27,null)}],default:[],markdownDeprecationMessage:f},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,t.localize)(29,null),enum:["PowerShell","Git Bash"]},...R}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(30,null),type:"string"},id:{description:(0,t.localize)(31,null),type:"string"},title:{description:(0,t.localize)(32,null),type:"string"},...R}},{type:"null"},b]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(34,null),type:"string"},id:{description:(0,t.localize)(35,null),type:"string"},title:{description:(0,t.localize)(36,null),type:"string"},...R}},{type:"null"},b]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(38,null),type:"string"},id:{description:(0,t.localize)(39,null),type:"string"},title:{description:(0,t.localize)(40,null),type:"string"},...R}},{type:"null"},b]}},["terminal.integrated.useWslProfiles"]:{description:(0,t.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,t.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,t.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,t.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,t.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function m(){T.Registry.as(L.Extensions.Configuration).registerConfiguration(v),y()}e.registerTerminalPlatformConfiguration=m;let w;function y(S,d){const i=T.Registry.as(L.Extensions.Configuration);let c;S&&(c=(0,A.createProfileSchemaEnums)(S?.profiles,d));const r=w;w={id:"terminal",order:100,title:(0,t.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:S?.os===3?c?.values:void 0,markdownEnumDescriptions:S?.os===3?c?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:S?.os===2?c?.values:void 0,markdownEnumDescriptions:S?.os===2?c?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:S?.os===1?c?.values:void 0,markdownEnumDescriptions:S?.os===1?c?.markdownDescriptions:void 0}}},i.updateConfigurations({add:[w],remove:r?[r]:[]})}e.registerTerminalDefaultProfileConfiguration=y}),define(te[219],ne([0,1,46,48,10,4,22,73,215,97]),function(K,e,k,t,L,T,A,R,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let P,E=!0;function f(c,r,n,o,s=process.env,a,l,g,I){return a=a||{existsFile:A.SymlinkSupport.existsFile,readFile:A.Promises.readFile},T.isWindows?p(n,a,s,l,o.getValue("terminal.integrated.useWslProfiles")!==!1,c&&typeof c=="object"?{...c}:o.getValue("terminal.integrated.profiles.windows"),typeof r=="string"?r:o.getValue("terminal.integrated.defaultProfile.windows"),I,g):S(a,l,n,c&&typeof c=="object"?{...c}:o.getValue(T.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof r=="string"?r:o.getValue(T.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),I,g,s)}e.detectAvailableProfiles=f;async function p(c,r,n,o,s,a,l,g,I){const _=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),O=`${process.env.windir}\\${_?"Sysnative":"System32"}`;let U=!1;(0,b.getWindowsBuildNumber)()>=16299&&(U=!0),await v(g);const D=new Map;c&&(D.set("PowerShell",{source:"PowerShell",icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),D.set("Windows PowerShell",{path:`${O}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),D.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),D.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),D.set("Command Prompt",{path:`${O}\\cmd.exe`,icon:t.Codicon.terminalCmd,isAutoDetected:!0})),d(a,D);const M=await h(D.entries(),l,r,n,o,I);if(c||!c&&s)try{const N=await w(`${O}\\${U?"wsl":"bash"}.exe`,l);for(const x of N)(!a||!(x.profileName in a))&&M.push(x)}catch{E&&(o?.info("WSL is not installed, so could not detect WSL profiles"),E=!1)}return M}async function h(c,r,n,o=process.env,s,a){const l=[];for(const[g,I]of c){if(I===null)continue;let _,O,U;if("source"in I){const N=P?.get(I.source);if(!N)continue;_=N.paths,O=I.args||N.args,I.icon?U=u(I.icon):N.icon&&(U=N.icon)}else _=Array.isArray(I.path)?I.path:[I.path],O=T.isWindows||Array.isArray(I.args)?I.args:void 0,U=u(I.icon);const D=await a?.(_)||_.slice(),M=await i(g,r,D,n,o,O,I.env,I.overrideName,I.isAutoDetected,s);M?(M.isAutoDetected=I.isAutoDetected,M.icon=U,M.color=I.color,l.push(M)):s?.trace("profile not validated",g,_)}return l}function u(c){return typeof c=="string"?{id:c}:c}async function v(c){P&&!c||(P=new Map,P.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),P.set("PowerShell",{profileName:"PowerShell",paths:c||await m(),icon:C.ThemeIcon.asThemeIcon(t.Codicon.terminalPowershell)}))}async function m(){const c=[];for await(const r of(0,R.enumeratePowerShellInstallations)())c.push(r.exePath);return c}async function w(c,r){const n=[],o=await new Promise((l,g)=>{k.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(I,_)=>{if(I)return g("Problem occurred when getting wsl distros");l(_)})});if(!o)return[];const s=new RegExp(/[\r?\n]/),a=o.split(s).filter(l=>l.trim().length>0&&l!=="");for(const l of a){if(l===""||l.startsWith("docker-desktop"))continue;const g=`${l} (WSL)`,I={profileName:g,path:c,args:["-d",`${l}`],isDefault:g===r,icon:y(l),isAutoDetected:!1};n.push(I)}return n}function y(c){return c.includes("Ubuntu")?C.ThemeIcon.asThemeIcon(t.Codicon.terminalUbuntu):c.includes("Debian")?C.ThemeIcon.asThemeIcon(t.Codicon.terminalDebian):C.ThemeIcon.asThemeIcon(t.Codicon.terminalLinux)}async function S(c,r,n,o,s,a,l,g){const I=new Map;if(n){const _=(await c.readFile("/etc/shells")).toString(),O=a||_.split(`
`).filter(D=>D.trim().indexOf("#")!==0&&D.trim().length>0),U=new Map;for(const D of O){let M=(0,L.basename)(D),N=U.get(M)||0;N++,N>1&&(M=`${M} (${N})`),U.set(M,N),I.set(M,{path:D,isAutoDetected:!0})}}return d(o,I),await h(I.entries(),s,c,g,r,l)}function d(c,r){if(!!c)for(const[n,o]of Object.entries(c))o===null||!("path"in o)&&!("source"in o)?r.delete(n):(o.icon=o.icon||r.get(n)?.icon,r.set(n,o))}async function i(c,r,n,o,s,a,l,g,I,_){if(n.length===0)return Promise.resolve(void 0);const O=n.shift();if(O==="")return i(c,r,n,o,s,a,l,g,I);const U={profileName:c,path:O,args:a,env:l,overrideName:g,isAutoDetected:I,isDefault:c===r};if((0,L.basename)(O)===O){const M=s.PATH?s.PATH.split(L.delimiter):void 0,N=await(0,b.findExecutable)(O,void 0,M,void 0,o.existsFile);return N?(U.path=N,U.isFromPath=!0,U):i(c,r,n,o,s,a)}return await o.existsFile((0,L.normalize)(O))?U:i(c,r,n,o,s,a,l,g,I)}}),define(te[220],ne([0,1,3,2,18,4,36,58,19,14,78,214,8,87,212,96,218,219]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p,h,u,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var w;(function(d){d[d.MaxRestarts=5]="MaxRestarts"})(w||(w={}));let y=0,S=class extends t.Disposable{constructor(i,c,r,n){super();this._reconnectConstants=i,this._configurationService=c,this._environmentService=r,this._logService=n,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new k.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new k.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new k.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new k.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new k.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new k.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new k.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new k.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new k.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new k.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new k.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new k.Emitter),this.onProcessExit=this._onProcessExit.event,(0,v.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,t.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new h.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}async initialize(){await this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(T.isWindows)return process.env;try{return await(0,E.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(i){return this._logService.error("ptyHost was unable to resolve shell environment",i),{}}}_startPtyHost(){const i={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:y,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},c=(0,P.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);c&&(c.break&&c.port?i.debugBrk=c.port:!c.break&&c.port&&(i.debug=c.port));const r=new R.Client(L.FileAccess.asFileUri("bootstrap-fork",K).fsPath,i);this._onPtyHostStart.fire(),A.ProxyChannel.toService(r.getChannel(u.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(r.onDidProcessExit(a=>{this._onPtyHostExit.fire(a.code),this._isDisposed||(this._restartCount<=w.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${a.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${a.code}, giving up`))}));const o=r.getChannel(u.TerminalIpcChannels.Log);p.LogLevelChannelClient.setLevel(o,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{p.LogLevelChannelClient.setLevel(o,this._logService.getLevel())}));const s=A.ProxyChannel.toService(r.getChannel(u.TerminalIpcChannels.PtyHost));return this._register(s.onProcessData(a=>this._onProcessData.fire(a))),this._register(s.onProcessReady(a=>this._onProcessReady.fire(a))),this._register(s.onProcessExit(a=>this._onProcessExit.fire(a))),this._register(s.onDidChangeProperty(a=>this._onDidChangeProperty.fire(a))),this._register(s.onProcessReplay(a=>this._onProcessReplay.fire(a))),this._register(s.onProcessOrphanQuestion(a=>this._onProcessOrphanQuestion.fire(a))),this._register(s.onDidRequestDetach(a=>this._onDidRequestDetach.fire(a))),[r,s]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(i,c,r,n,o,s,a,l,g,I,_){const O=setTimeout(()=>this._handleUnresponsiveCreateProcess(),u.HeartbeatConstants.CreateProcessTimeout),U=await this._proxy.createProcess(i,c,r,n,o,s,a,l,g,I,_);return clearTimeout(O),y=Math.max(y,U),U}updateTitle(i,c,r){return this._proxy.updateTitle(i,c,r)}updateIcon(i,c,r){return this._proxy.updateIcon(i,c,r)}attachToProcess(i){return this._proxy.attachToProcess(i)}detachFromProcess(i){return this._proxy.detachFromProcess(i)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(i){return this._proxy.start(i)}shutdown(i,c){return this._proxy.shutdown(i,c)}input(i,c){return this._proxy.input(i,c)}processBinary(i,c){return this._proxy.processBinary(i,c)}resize(i,c,r){return this._proxy.resize(i,c,r)}acknowledgeDataEvent(i,c){return this._proxy.acknowledgeDataEvent(i,c)}setUnicodeVersion(i,c){return this._proxy.setUnicodeVersion(i,c)}getInitialCwd(i){return this._proxy.getInitialCwd(i)}getCwd(i){return this._proxy.getCwd(i)}getLatency(i){return this._proxy.getLatency(i)}orphanQuestionReply(i){return this._proxy.orphanQuestionReply(i)}installAutoReply(i,c){return this._proxy.installAutoReply(i,c)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(i){return this._proxy.uninstallAutoReply(i)}getDefaultSystemShell(i){return this._proxy.getDefaultSystemShell(i)}async getProfiles(i,c,r,n=!1){const o=await this._shellEnv;return(0,m.detectAvailableProfiles)(c,r,n,this._configurationService,o,void 0,this._logService,this._resolveVariables.bind(this,i))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(i){return this._proxy.getWslPath(i)}setTerminalLayoutInfo(i){return this._proxy.setTerminalLayoutInfo(i)}async getTerminalLayoutInfo(i){return await this._proxy.getTerminalLayoutInfo(i)}async requestDetachInstance(i,c){return this._proxy.requestDetachInstance(i,c)}async acceptDetachInstanceReply(i,c){return this._proxy.acceptDetachInstanceReply(i,c)}async serializeTerminalState(i){return this._proxy.serializeTerminalState(i)}async reviveTerminalProcesses(i,c){return this._proxy.reviveTerminalProcesses(i,c)}async refreshProperty(i,c){return this._proxy.refreshProperty(i,c)}async updateProperty(i,c,r){return this._proxy.updateProperty(i,c,r)}async restartPtyHost(){this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.FirstWaitMultiplier+u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${u.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(i,c){return this._resolveVariablesRequestStore.createRequest({workspaceId:i,originalText:c})}async acceptPtyHostResolvedVariables(i,c){this._resolveVariablesRequestStore.acceptReply(i,c)}};S=he([G(1,b.IConfigurationService),G(2,C.IEnvironmentService),G(3,f.ILogService)],S),e.PtyHostService=S}),define(te[64],ne([0,1,3,4,6,8]),function(K,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,L.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,L.createDecorator)("sharedTunnelsService");var A;(function(h){h.Http="http",h.Https="https"})(A=e.TunnelProtocol||(e.TunnelProtocol={}));var R;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(R=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var b;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(b=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function C(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const u=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!u)return{address:u[1],port:+u[2]}}e.extractLocalHostUriMetaDataForPortMapping=C,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function P(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=P,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=E;function f(h,u){return u?u!==1&&h<1024:!t.isWindows&&h<1024}e.isPortPrivileged=f;let p=class{constructor(u){this.logService=u,this._onTunnelOpened=new k.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new k.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new k.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(u){return this._tunnelProvider=u,u?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(u){this._canElevate=u.elevation,this._privacyOptions=u.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const u=[],v=Array.from(this._tunnels.values());for(let m of v){const w=Array.from(m.values());for(let y of w){const S=await y.value;S&&u.push(S)}}return u}async dispose(){for(const u of this._tunnels.values()){for(const{value:v}of u.values())await v.then(m=>m?.dispose());u.clear()}this._tunnels.clear()}openTunnel(u,v,m,w,y=!1,S=R.Private,d){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${v}:${m} on local port ${w}.`),!u)return;v||(v="localhost");const i=this.retainOrCreateTunnel(u,v,m,w,y,S,d);return i?i.then(c=>{if(!c){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(v,m);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(c);return(c.tunnelRemoteHost!==v||c.tunnelRemotePort!==m)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}makeTunnel(u){return{tunnelRemotePort:u.tunnelRemotePort,tunnelRemoteHost:u.tunnelRemoteHost,tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress,privacy:u.privacy,protocol:u.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${u.tunnelRemoteHost}:${u.tunnelRemotePort} `);const v=this._tunnels.get(u.tunnelRemoteHost);if(v){const m=v.get(u.tunnelRemotePort);m&&(m.refcount--,await this.tryDisposeTunnel(u.tunnelRemoteHost,u.tunnelRemotePort,m))}}}}async tryDisposeTunnel(u,v,m){if(m.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${u}:${v}.`);const w=m.value.then(async y=>{y&&(await y.dispose(!0),this._onTunnelClosed.fire({host:y.tunnelRemoteHost,port:y.tunnelRemotePort}))});return this._tunnels.has(u)&&this._tunnels.get(u).delete(v),w}}async closeTunnel(u,v){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${u}:${v} `);const m=this._tunnels.get(u);if(m&&m.has(v)){const w=m.get(v);w.refcount=0,await this.tryDisposeTunnel(u,v,w)}}addTunnelToMap(u,v,m){this._tunnels.has(u)||this._tunnels.set(u,new Map),this._tunnels.get(u).set(v,{refcount:1,value:m})}async removeEmptyTunnelFromMap(u,v){const m=this._tunnels.get(u);m&&(await m.get(v)||m.delete(v),m.size===0&&this._tunnels.delete(u))}getTunnelFromMap(u,v){let m=[u];P(u)?(m.push(...e.LOCALHOST_ADDRESSES),m.push(...e.ALL_INTERFACES_ADDRESSES)):E(u)&&m.push(...e.ALL_INTERFACES_ADDRESSES);const w=m.map(y=>this._tunnels.get(y));for(const y of w){const S=y?.get(v);if(S)return S}}canTunnel(u){return!!C(u)}createWithProvider(u,v,m,w,y,S,d){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${v}:${m} on local port ${w}.`);const c={elevationRequired:y?f(w===void 0?m:w):!1},r={remoteAddress:{host:v,port:m},localAddressPort:w,privacy:S,public:S!==R.Private,protocol:d},n=u.forwardPort(r,c);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),n&&this.addTunnelToMap(v,m,n),n}};p=he([G(0,T.ILogService)],p),e.AbstractTunnelService=p}),define(te[221],ne([0,1,8,64,2,9,5]),function(K,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class R extends L.Disposable{constructor(){super();this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new A.DeferredPromise),this._addressPromise.p)}setAddress(P){this._address=P,this._addressPromise&&(this._addressPromise.complete(P),this._addressPromise=null)}setTunnel(P){this._register(P)}}let b=class Ct extends L.Disposable{constructor(P,E){super();this._tunnelService=P,this._logService=E,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(P=>P.dispose())}async createTunnel(){return{id:String(++Ct._lastId)}}async startTunnel(P,E,f,p,h,u){const v=new R,m=await Promise.resolve(this._tunnelService.openTunnel(P,v,f,p,h,u));if(!m)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${f}:${p} (remote).`),v.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(E))throw this._disposedTunnels.delete(E),v.dispose(),await m.dispose(),(0,T.canceled)();return v.setTunnel(m),this._tunnels.set(E,v),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${E}: ${m.localAddress} (local) to ${f}:${p} (remote).`),{tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress}}async setAddress(P,E){const f=this._tunnels.get(P);!f||f.setAddress(E)}async destroyTunnel(P){const E=this._tunnels.get(P);if(E){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${P}.`),this._tunnels.delete(P),await E.dispose();return}this._disposedTunnels.add(P)}};b._lastId=0,b=he([G(0,t.ISharedTunnelsService),G(1,k.ILogService)],b),e.SharedProcessTunnelService=b}),define(te[32],ne([0,1,6]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,k.createDecorator)("IUriIdentityService")}),define(te[222],ne([0,1,3,2,7,14,31,15,8,32]),function(K,e,k,t,L,T,A,R,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let P=class extends t.Disposable{constructor(f,p,h,u,v){super();this.extensionsManagementService=f,this.logService=u,this.uriIdentityService=v,this._onDidChangeExtensionsByAnotherSource=this._register(new k.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(w=>{this.installedExtensions=w.map(y=>y.identifier),this.startTimestamp=Date.now()}),this._register(f.onInstallExtension(w=>this.onInstallExtension(w))),this._register(f.onDidInstallExtensions(w=>this.onDidInstallExtensions(w))),this._register(f.onDidUninstallExtension(w=>this.onDidUninstallExtension(w)));const m=L.URI.file(h.extensionsPath);this._register(p.watch(m)),this._register(k.Event.filter(p.onDidFilesChange,w=>w.rawChanges.some(y=>this.doesChangeAffects(y,m)))(()=>this.onDidChange()))}doesChangeAffects(f,p){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(f.resource),p)?this.uriIdentityService.extUri.isEqual(f.resource,this.uriIdentityService.extUri.joinPath(p,".obsolete"))?!0:!(f.type!==1&&f.type!==2||this.uriIdentityService.extUri.basename(f.resource).startsWith(".")):!1}onInstallExtension(f){this.addInstallingExtension(f.identifier)}onDidInstallExtensions(f){for(const p of f)this.removeInstallingExtension(p.identifier),p.local&&this.addInstalledExtension(p.identifier)}onDidUninstallExtension(f){f.error||this.removeInstalledExtension(f.identifier)}addInstallingExtension(f){this.removeInstallingExtension(f),this.installingExtensions.push(f)}removeInstallingExtension(f){this.installingExtensions=this.installingExtensions.filter(p=>!(0,A.areSameExtensions)(p,f))}addInstalledExtension(f){this.installedExtensions&&(this.removeInstalledExtension(f),this.installedExtensions.push(f))}removeInstalledExtension(f){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(p=>!(0,A.areSameExtensions)(p,f)))}async onDidChange(){if(this.installedExtensions){const f=await this.extensionsManagementService.getInstalled(1),p=f.filter(u=>[...this.installingExtensions,...this.installedExtensions].some(v=>(0,A.areSameExtensions)(v,u.identifier))?!1:u.installedTimestamp&&u.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",u.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",u.identifier.id),!1)),h=this.installedExtensions.filter(u=>this.installingExtensions.some(v=>(0,A.areSameExtensions)(v,u))?!1:f.every(v=>!(0,A.areSameExtensions)(v.identifier,u))?(this.logService.info("Detected extension removed from another source",u.id),!0):!1);this.installedExtensions=f.map(u=>u.identifier),(p.length||h.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:p,removed:h})}}};P=he([G(1,R.IFileService),G(2,T.INativeEnvironmentService),G(3,b.ILogService),G(4,C.IUriIdentityService)],P),e.ExtensionsWatcher=P}),define(te[223],ne([0,1,32,80,15,20,104,3,2]),function(K,e,k,t,L,T,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class C{constructor(f){this.uri=f,this.time=C._clock++}touch(){return this.time=C._clock++,this}}C._clock=0;let P=class{constructor(f){this._fileService=f,this._dispooables=new b.DisposableStore,this._limit=2**16;const p=new Map,h=u=>{let v=p.get(u.scheme);return v===void 0&&(v=f.hasProvider(u)&&!this._fileService.hasCapability(u,1024),p.set(u.scheme,v)),v};this._dispooables.add(R.Event.any(f.onDidChangeFileSystemProviderRegistrations,f.onDidChangeFileSystemProviderCapabilities)(u=>{p.delete(u.scheme)})),this.extUri=new T.ExtUri(h),this._canonicalUris=new A.SkipList((u,v)=>this.extUri.compare(u,v,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(f){this._fileService.hasProvider(f)&&(f=(0,T.normalizePath)(f));let p=this._canonicalUris.get(f);return p?p.touch().uri.with({fragment:f.fragment}):(this._canonicalUris.set(f,new C(f)),this._checkTrim(),f)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const f=[...this._canonicalUris.entries()].sort((h,u)=>h[1].touch<u[1].touch?1:h[1].touch>u[1].touch?-1:0);C._clock=0,this._canonicalUris.clear();const p=this._limit*.5;for(let h=0;h<p;h++)this._canonicalUris.set(f[h][0],f[h][1].touch())}};P=he([G(0,L.IFileService)],P),e.UriIdentityService=P,(0,t.registerSingleton)(k.IUriIdentityService,P,!0)}),define(te[224],ne([0,1,3,2,40,39,17]),function(K,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class R extends t.Disposable{constructor(C,P,E,f){super();this.fileSystemScheme=C,this.fileSystemProvider=P,this.userDataScheme=E,this.logService=f,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=T.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(this.fileSystemProvider.onDidChangeFile(p=>this.handleFileChanges(p)))}get capabilities(){return this.fileSystemProvider.capabilities&~4}watch(C,P){this.watchResources.set(C,C);const E=this.fileSystemProvider.watch(this.toFileSystemResource(C),P);return(0,t.toDisposable)(()=>{this.watchResources.delete(C),E.dispose()})}stat(C){return this.fileSystemProvider.stat(this.toFileSystemResource(C))}mkdir(C){return this.fileSystemProvider.mkdir(this.toFileSystemResource(C))}rename(C,P,E){return this.fileSystemProvider.rename(this.toFileSystemResource(C),this.toFileSystemResource(P),E)}readFile(C){return this.fileSystemProvider.readFile(this.toFileSystemResource(C),{atomic:!0})}readFileStream(C,P,E){const f=(0,L.newWriteableStream)(p=>A.VSBuffer.concat(p.map(h=>A.VSBuffer.wrap(h))).buffer);return(async()=>{try{const p=await this.readFile(C);f.end(p)}catch(p){f.error(p),f.end()}})(),f}readdir(C){return this.fileSystemProvider.readdir(this.toFileSystemResource(C))}writeFile(C,P,E){return this.fileSystemProvider.writeFile(this.toFileSystemResource(C),P,E)}delete(C,P){return this.fileSystemProvider.delete(this.toFileSystemResource(C),P)}handleFileChanges(C){const P=[];for(const E of C){if(E.resource.scheme!==this.fileSystemScheme)continue;const f=this.toUserDataResource(E.resource);this.watchResources.findSubstr(f)&&P.push({resource:f,type:E.type})}P.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(P))}toFileSystemResource(C){return C.with({scheme:this.fileSystemScheme})}toUserDataResource(C){return C.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=R}),define(te[53],ne([0,1,70]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function t(A,R,b,C){const P=(0,k.setProperty)(A,R,b,C)[0];return P&&(A=A.substring(0,P.offset)+P.content+A.substring(P.offset+P.length)),A}e.edit=t;function L(A,R,b){let C=b;for(;C>=0;){if(A.charAt(C)===R.charAt(R.length-1)&&R.length===1)return C+1;if(C--,R.length===2&&C>=0&&A.charAt(C)===R.charAt(0))return C+2}return 0}e.getLineStartOffset=L;function T(A,R,b){let C=b;for(;C>=0;)if(A.charAt(C)===R.charAt(R.length-1)&&R.length===1||(C++,R.length===2&&C>=0&&A.charAt(C)===R.charAt(1)))return C;return A.length-1}e.getLineEndOffset=T}),define(te[225],ne([0,1,28,62,11]),function(K,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function T(f,p,h,u,v){const m=[],w=[],y=[];if(!p){const O=f.filter(({identifier:U})=>v.every(D=>D.toLowerCase()!==U.id.toLowerCase()));return{local:{added:m,removed:w,updated:y},remote:O.length>0?{added:O,updated:[],removed:[],all:O}:null}}f=f.map(P),p=p.map(P),h=h?h.map(P):null;const S=new Map,d=O=>{O.uuid&&S.set(O.id.toLowerCase(),O.uuid)};f.forEach(({identifier:O})=>d(O)),p.forEach(({identifier:O})=>d(O)),h&&h.forEach(({identifier:O})=>d(O));const i=O=>{const U=O.identifier.uuid||S.get(O.identifier.id.toLowerCase());return U?`uuid:${U}`:`id:${O.identifier.id.toLowerCase()}`},c=(O,U)=>(O.set(i(U),U),O),r=f.reduce(c,new Map),n=p.reduce(c,new Map),o=p.reduce((O,U)=>{const D=i(U);U=(0,k.deepClone)(U);const M=r.get(D);return M&&(M.installed&&(U.installed=!0),U.version||(U.version=M.version)),c(O,U)},new Map),s=h?h.reduce(c,new Map):null,a=u.reduce(c,new Map),l=v.reduce((O,U)=>{const D=S.get(U.toLowerCase());return O.add(D?`uuid:${D}`:`id:${U.toLowerCase()}`)},new Set),g=A(r,n,l);if(g.added.size>0||g.removed.size>0||g.updated.size>0){const O=A(s,r,l),U=A(s,n,l),D=(M,N)=>{const x=r.get(M);if(x){const Q=n.get(M),W=N?Q:x;return{...W,version:Q.version&&(!x.installed||t.gt(Q.version,x.version))?Q.version:x.version,state:R(x,Q,s?.get(M)),preRelease:(0,L.isUndefined)(W.preRelease)?x.preRelease:x.installed?W.preRelease:Q.preRelease}}};for(const M of U.removed.values()){const N=r.get(M);N&&w.push(N.identifier)}for(const M of U.added.values())if(O.added.has(M)){if(g.updated.has(M)){const N=D(M,!0);N&&(y.push(E(N,M)),o.set(M,N))}}else{const N=n.get(M);N.installed&&m.push(E(N,M))}for(const M of U.updated.values()){const N=D(M,!0);N&&(y.push(E(N,M)),o.set(M,N))}for(const M of O.added.values())U.added.has(M)||o.set(M,r.get(M));for(const M of O.updated.values())if(!U.removed.has(M)&&!U.updated.has(M)){const N=D(M,!1);N&&(o.get(M)?.installed&&(N.installed=!0),o.set(M,N))}for(const M of O.removed.values())!a.has(M)&&!U.updated.has(M)&&s?.get(M)?.installed&&o.delete(M)}const I=[],_=A(n,o,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(_.added.size>0||_.updated.size>0||_.removed.size>0)&&o.forEach((O,U)=>I.push(E(O,U))),{local:{added:m,removed:w,updated:y},remote:I.length?{added:[..._.added].map(O=>o.get(O)),updated:[..._.updated].map(O=>o.get(O)),removed:[..._.removed].map(O=>n.get(O)),all:I}:null}}e.merge=T;function A(f,p,h,{checkInstalledProperty:u,checkVersionProperty:v}={checkInstalledProperty:!1,checkVersionProperty:!1}){const m=f?[...f.keys()].filter(i=>!h.has(i)):[],w=[...p.keys()].filter(i=>!h.has(i)),y=w.filter(i=>m.indexOf(i)===-1).reduce((i,c)=>(i.add(c),i),new Set),S=m.filter(i=>w.indexOf(i)===-1).reduce((i,c)=>(i.add(c),i),new Set),d=new Set;for(const i of m){if(S.has(i))continue;const c=f.get(i),r=p.get(i);(!r||c.disabled!==r.disabled||c.installed&&r.installed&&c.preRelease!==r.preRelease||!C(c.state,r.state)||v&&c.version!==r.version||u&&c.installed!==r.installed)&&d.add(i)}return{added:y,removed:S,updated:d}}function R(f,p,h){const u=f.state,v=p.state,m=h?.state;if(!p.version||u&&t.gt(f.version,p.version))return u;if(v&&t.gt(p.version,f.version)||!u)return v;if(!v)return u;const w=(0,k.deepClone)(u),y=m?b(m,v):{added:Object.keys(v).reduce((d,i)=>(d.add(i),d),new Set),removed:new Set,updated:new Set},S=m?b(m,u):{added:Object.keys(u).reduce((d,i)=>(d.add(i),d),new Set),removed:new Set,updated:new Set};for(const d of[...y.added.values(),...y.updated.values()])w[d]=v[d];for(const d of y.removed.values())S.updated.has(d)||delete w[d];return w}function b(f,p){const h=Object.keys(f),u=Object.keys(p),v=u.filter(y=>h.indexOf(y)===-1).reduce((y,S)=>(y.add(S),y),new Set),m=h.filter(y=>u.indexOf(y)===-1).reduce((y,S)=>(y.add(S),y),new Set),w=new Set;for(const y of h){if(m.has(y))continue;const S=f[y],d=p[y];(0,k.equals)(S,d)||w.add(y)}return{added:v,removed:m,updated:w}}function C(f={},p={}){const{added:h,removed:u,updated:v}=b(f,p);return h.size===0&&u.size===0&&v.size===0}function P(f){return{...f,disabled:!!f.disabled,installed:!!f.installed}}function E(f,p){const h={identifier:{id:f.identifier.id,uuid:p.startsWith("uuid:")?p.substring("uuid:".length):void 0},preRelease:!!f.preRelease};return f.version&&(h.version=f.version),f.disabled&&(h.disabled=!0),f.installed&&(h.installed=!0),f.state&&(h.state=f.state),h}}),define(te[98],ne([0,1,16,19,6]),function(K,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,L.createDecorator)("IIgnoredExtensionsManagementService");let T=class{constructor(R){this.configurationService=R}hasToNeverSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,b){let C=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return C=C.filter(P=>P!==R&&P!==`-${R}`),b&&C.push(R.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",C.length?C:void 0,1)}updateSynchronizedExtensions(R,b){let C=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return C=C.filter(P=>P!==R&&P!==`-${R}`),b&&C.push(`-${R.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",C.length?C:void 0,1)}getIgnoredExtensions(R){const b=R.filter(f=>f.isMachineScoped).map(f=>f.identifier.id.toLowerCase()),C=this.getConfiguredIgnoredExtensions().map(f=>f.toLowerCase()),P=[],E=[];if(Array.isArray(C))for(const f of C)f.startsWith("-")?E.push(f.substring(1)):P.push(f);return(0,k.distinct)([...b,...P].filter(f=>E.indexOf(f)===-1))}getConfiguredIgnoredExtensions(){let R=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.configurationService.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(b=>b.toLowerCase())}};T=he([G(0,t.IConfigurationService)],T),e.IgnoredExtensionsManagementService=T}),define(te[226],ne([0,1,16,35,28,160,53]),function(K,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function R(S){return(0,t.parse)(S)||[]}e.parseKeybindings=R;async function b(S,d,i,c,r){const n=R(S),o=R(d),s=i?R(i):null,a=[...n,...o,...s||[]].map(Q=>Q.key),l=await r.resolveUserBindings(a);let g=P(n,o,s,l);if(!g.hasLocalForwarded&&!g.hasRemoteForwarded)return{mergeContent:S,hasChanges:!1,hasConflicts:!1};if(!g.hasLocalForwarded&&g.hasRemoteForwarded)return{mergeContent:d,hasChanges:!0,hasConflicts:!1};if(g.hasLocalForwarded&&!g.hasRemoteForwarded)return{mergeContent:S,hasChanges:!0,hasConflicts:!1};const I=f(n),_=f(o),O=s?f(s):null,U=h(I,_,l),D=O?h(O,I,l):{added:[...I.keys()].reduce((Q,W)=>(Q.add(W),Q),new Set),removed:new Set,updated:new Set},M=O?h(O,_,l):{added:[..._.keys()].reduce((Q,W)=>(Q.add(W),Q),new Set),removed:new Set,updated:new Set},N=C(U,D,M);let x=S;for(const Q of N.removed.values())N.conflicts.has(Q)||(x=w(x,Q,c));for(const Q of N.added.values()){if(N.conflicts.has(Q))continue;const W=_.get(Q);if(W.some(ie=>ie.command!==`-${Q}`&&g.conflicts.has(l[ie.key]))){N.conflicts.add(Q);continue}x=m(x,W,c)}for(const Q of N.updated.values()){if(N.conflicts.has(Q))continue;const W=_.get(Q);if(W.some(ie=>ie.command!==`-${Q}`&&g.conflicts.has(l[ie.key]))){N.conflicts.add(Q);continue}x=y(x,Q,W,c)}return{mergeContent:x,hasChanges:!0,hasConflicts:N.conflicts.size>0}}e.merge=b;function C(S,d,i){const c=new Set,r=new Set,n=new Set,o=new Set;for(const s of d.removed.values())i.updated.has(s)&&o.add(s);for(const s of i.removed.values())o.has(s)||(d.updated.has(s)?o.add(s):r.add(s));for(const s of d.added.values())o.has(s)||i.added.has(s)&&S.updated.has(s)&&o.add(s);for(const s of i.added.values())o.has(s)||(d.added.has(s)?S.updated.has(s)&&o.add(s):c.add(s));for(const s of d.updated.values())o.has(s)||i.updated.has(s)&&S.updated.has(s)&&o.add(s);for(const s of i.updated.values())o.has(s)||(d.updated.has(s)?S.updated.has(s)&&o.add(s):n.add(s));return{added:c,removed:r,updated:n,conflicts:o}}function P(S,d,i,c){const r=new Set,n=E(S,c),o=E(d,c),s=i?E(i,c):null,a=p(n,o);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:r,removed:r,updated:r,conflicts:r};const l=s?p(s,n):{added:[...n.keys()].reduce((D,M)=>(D.add(M),D),new Set),removed:new Set,updated:new Set};if(l.added.size===0&&l.removed.size===0&&l.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:r,removed:r,updated:r,conflicts:r};const g=s?p(s,o):{added:[...o.keys()].reduce((D,M)=>(D.add(M),D),new Set),removed:new Set,updated:new Set};if(g.added.size===0&&g.removed.size===0&&g.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:r,removed:r,updated:r,conflicts:r};const{added:I,removed:_,updated:O,conflicts:U}=C(a,l,g);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:I,removed:_,updated:O,conflicts:U}}function E(S,d){const i=new Map;for(const c of S){const r=d[c.key];let n=i.get(r);n||(n=[],i.set(r,n)),n.push(c)}return i}function f(S){const d=new Map;for(const i of S){const c=i.command[0]==="-"?i.command.substring(1):i.command;let r=d.get(c);r||(r=[],d.set(c,r)),r.push(i)}return d}function p(S,d){const i=[...S.keys()],c=[...d.keys()],r=c.filter(s=>i.indexOf(s)===-1).reduce((s,a)=>(s.add(a),s),new Set),n=i.filter(s=>c.indexOf(s)===-1).reduce((s,a)=>(s.add(a),s),new Set),o=new Set;for(const s of i){if(n.has(s))continue;const a=S.get(s).map(g=>({...g,key:s})),l=d.get(s).map(g=>({...g,key:s}));(0,k.equals)(a,l,(g,I)=>v(g,I))||o.add(s)}return{added:r,removed:n,updated:o}}function h(S,d,i){const c=[...S.keys()],r=[...d.keys()],n=r.filter(a=>c.indexOf(a)===-1).reduce((a,l)=>(a.add(l),a),new Set),o=c.filter(a=>r.indexOf(a)===-1).reduce((a,l)=>(a.add(l),a),new Set),s=new Set;for(const a of c){if(o.has(a))continue;const l=S.get(a).map(I=>({...I,key:i[I.key]})),g=d.get(a).map(I=>({...I,key:i[I.key]}));u(l,g)||s.add(a)}return{added:n,removed:o,updated:s}}function u(S,d){return!(!(0,k.equals)(S.filter(({command:i})=>i[0]!=="-"),d.filter(({command:i})=>i[0]!=="-"),(i,c)=>v(i,c))||!(0,k.equals)(S.filter(({command:i})=>i[0]==="-"),d.filter(({command:i})=>i[0]==="-"),(i,c)=>v(i,c)))}function v(S,d){if(S.command!==d.command||S.key!==d.key)return!1;const i=T.ContextKeyExpr.deserialize(S.when),c=T.ContextKeyExpr.deserialize(d.when);return!(i&&!c||!i&&c||i&&c&&!i.equals(c)||!L.equals(S.args,d.args))}function m(S,d,i){for(const c of d)S=A.edit(S,[-1],c,i);return S}function w(S,d,i){const c=R(S);for(let r=c.length-1;r>=0;r--)(c[r].command===d||c[r].command===`-${d}`)&&(S=A.edit(S,[r],void 0,i));return S}function y(S,d,i,c){const r=R(S),n=r.findIndex(o=>o.command===d||o.command===`-${d}`);for(let o=r.length-1;o>=0;o--)(r[o].command===d||r[o].command===`-${d}`)&&(S=A.edit(S,[o],void 0,c));for(let o=i.length-1;o>=0;o--)S=A.edit(S,[n],i[o],c);return S}}),define(te[227],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function k(T,A,R){const b={},C={},P=new Set;if(!A)return{local:{added:b,updated:C,removed:[...P.values()]},remote:{added:T,updated:{},removed:[]},conflicts:[]};const E=t(T,A);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{local:{added:b,updated:C,removed:[...P.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const f=t(R,T),p=t(R,A),h={},u={},v=new Set,m=new Set;for(const w of f.removed.values())p.updated.has(w)?b[w]=A[w]:v.add(w);for(const w of p.removed.values())m.has(w)||(f.updated.has(w)?m.add(w):P.add(w));for(const w of f.updated.values())m.has(w)||(p.updated.has(w)?E.updated.has(w)&&m.add(w):u[w]=T[w]);for(const w of p.updated.values())m.has(w)||(f.updated.has(w)?E.updated.has(w)&&m.add(w):T[w]!==void 0&&(C[w]=A[w]));for(const w of f.added.values())m.has(w)||(p.added.has(w)?E.updated.has(w)&&m.add(w):h[w]=T[w]);for(const w of p.added.values())m.has(w)||(f.added.has(w)?E.updated.has(w)&&m.add(w):b[w]=A[w]);return{local:{added:b,removed:[...P.values()],updated:C},remote:{added:h,removed:[...v.values()],updated:u},conflicts:[...m.values()]}}e.merge=k;function t(T,A){const R=T?Object.keys(T):[],b=A?Object.keys(A):[],C=b.filter(f=>R.indexOf(f)===-1).reduce((f,p)=>(f.add(p),f),new Set),P=R.filter(f=>b.indexOf(f)===-1).reduce((f,p)=>(f.add(p),f),new Set),E=new Set;for(const f of R){if(P.has(f))continue;const p=T[f],h=A[f];p!==h&&E.add(f)}return{added:C,removed:P,updated:E}}function L(T,A){const{added:R,removed:b,updated:C}=t(T,A);return R.size===0&&b.size===0&&C.size===0}e.areSame=L}),define(te[24],ne([0,1,16,20,11,148,42,30,6,89,38]),function(K,e,k,t,L,T,A,R,b,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function E(){const s=P.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(s).filter(a=>!!s[a].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=E;function f(){const s=P.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),a=Object.keys(s).filter(I=>!!s[I].ignoreSync),l=Object.keys(s).filter(I=>s[I].scope===2||s[I].scope===6),g=E();return(0,k.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...a,...l,...g])}e.getDefaultIgnoredSettings=f,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function p(){const s="vscode://schemas/ignoredSettings",a=P.Registry.as(A.Extensions.Configuration);a.registerConfiguration({id:"settingsSync",order:30,title:(0,T.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,T.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,T.localize)(2,null),items:[{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,T.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,T.localize)(4,null),default:[],scope:1,$ref:s,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const l=P.Registry.as(C.Extensions.JSONContribution),g=()=>{const I=E(),_=f().filter(M=>M!==e.CONFIGURATION_SYNC_STORE_KEY),O=Object.keys(A.allSettings.properties).filter(M=>_.indexOf(M)===-1),U=_.filter(M=>I.indexOf(M)===-1),D={items:{type:"string",enum:[...O,...U.map(M=>`-${M}`)]}};l.registerSchema(s,D)};return a.onDidUpdateConfiguration(()=>g())}e.registerConfiguration=p;function h(s){return s&&(0,L.isObject)(s)&&(0,L.isString)(s.id)&&(0,L.isArray)(s.scopes)}e.isAuthenticationProvider=h;var u;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(u=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState"];function v(s,a,l){return l.joinPath(a.userDataSyncHome,s,`lastSync${s}.json`)}e.getLastSyncResourceUri=v,e.IUserDataSyncStoreManagementService=(0,b.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,b.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,b.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function m(s){const a={};return a[e.HEADER_EXECUTION_ID]=s,a}e.createSyncHeaders=m;var w;(function(s){s.Unauthorized="Unauthorized",s.Conflict="Conflict",s.Gone="Gone",s.PreconditionFailed="PreconditionFailed",s.TooLarge="TooLarge",s.UpgradeRequired="UpgradeRequired",s.PreconditionRequired="PreconditionRequired",s.TooManyRequests="RemoteTooManyRequests",s.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",s.RequestFailed="RequestFailed",s.RequestCanceled="RequestCanceled",s.RequestTimeout="RequestTimeout",s.RequestProtocolNotSupported="RequestProtocolNotSupported",s.RequestPathNotEscaped="RequestPathNotEscaped",s.RequestHeadersNotObject="RequestHeadersNotObject",s.NoRef="NoRef",s.EmptyResponse="EmptyResponse",s.TurnedOff="TurnedOff",s.SessionExpired="SessionExpired",s.ServiceChanged="ServiceChanged",s.DefaultServiceChanged="DefaultServiceChanged",s.LocalTooManyRequests="LocalTooManyRequests",s.LocalPreconditionFailed="LocalPreconditionFailed",s.LocalInvalidContent="LocalInvalidContent",s.LocalError="LocalError",s.IncompatibleLocalContent="IncompatibleLocalContent",s.IncompatibleRemoteContent="IncompatibleRemoteContent",s.UnresolvedConflicts="UnresolvedConflicts",s.Unknown="Unknown"})(w=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class y extends Error{constructor(a,l,g,I){super(a);this.code=l,this.resource=g,this.operationId=I,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=y;class S extends y{constructor(a,l,g,I,_){super(a,g,void 0,_);this.url=l,this.serverCode=I}}e.UserDataSyncStoreError=S;class d extends y{constructor(a,l){super(a,l)}}e.UserDataAutoSyncError=d,function(s){function a(l){if(l instanceof s)return l;const g=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(l.name);if(g&&g[1]){const I=g[2]==="unknown"?void 0:g[2],_=g[3]==="unknown"?void 0:g[3];return new s(l.message,g[1],I,_)}return new s(l.message,"Unknown")}s.toUserDataSyncError=a}(y=e.UserDataSyncError||(e.UserDataSyncError={}));var i;(function(s){s.Uninitialized="uninitialized",s.Idle="idle",s.Syncing="syncing",s.HasConflicts="hasConflicts"})(i=e.SyncStatus||(e.SyncStatus={}));var c;(function(s){s[s.None=0]="None",s[s.Added=1]="Added",s[s.Modified=2]="Modified",s[s.Deleted=3]="Deleted"})(c=e.Change||(e.Change={}));var r;(function(s){s.Preview="preview",s.Conflict="conflict",s.Accepted="accepted"})(r=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function n(s){return`sync.enable.${s}`}e.getEnablementKey=n,e.IUserDataSyncEnablementService=(0,b.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,b.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncService=(0,b.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,b.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,b.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function o(s,a){if(s.scheme!==e.USER_DATA_SYNC_SCHEME)return s=s.with({scheme:a.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(l=>(0,t.isEqualOrParent)(s,(0,t.joinPath)(a.userDataSyncHome,l,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=o}),define(te[45],ne([0,1,16,5,17,25,3,35,2,26,11,7,144,19,14,15,8,47,23,21,32,24]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p,h,u,v,m,w,y,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function i(s){return!!(s&&s.version!==void 0&&typeof s.version=="number"&&s.content!==void 0&&typeof s.content=="string"&&(Object.keys(s).length===2||Object.keys(s).length===3&&s.machineId!==void 0&&typeof s.machineId=="string"))}e.isSyncData=i;let c=class extends b.Disposable{constructor(a,l,g,I,_,O,U,D,M,N,x){super();this.resource=a,this.fileService=l,this.environmentService=g,this.userDataSyncStoreService=_,this.userDataSyncBackupStoreService=O,this.userDataSyncEnablementService=U,this.telemetryService=D,this.logService=M,this.configurationService=N,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new A.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new A.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new t.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new A.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,C.uppercaseFirstLetter)(this.resource),this.extUri=x.extUri,this.syncFolder=this.extUri.joinPath(g.userDataSyncHome,a),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,d.PREVIEW_DIR_NAME),this.lastSyncResource=(0,d.getLastSyncResourceUri)(a,g,this.extUri),this.currentMachineIdPromise=(0,m.getServiceMachineId)(g,l,I)}get status(){return this._status}get conflicts(){return this._conflicts}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const a=await this.syncPreviewPromise;this.syncPreviewPromise=null;const l=await this.performSync(a.remoteUserData,a.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(l)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const a=await this.getLastSyncUserData();(a?await this.hasRemoteChanged(a):!0)&&this._onDidChangeLocal.fire()}}setStatus(a){if(this._status!==a){const l=this._status;a==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),l==="hasConflicts"&&a==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=a,this._onDidChangStatus.fire(a)}}async sync(a,l={}){await this._sync(a,!0,this.getUserDataSyncConfiguration(),l)}async preview(a,l,g={}){return this._sync(a,!1,l,g)}async apply(a,l={}){try{this.syncHeaders={...l};const g=await this.doApply(a);return this.setStatus(g),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(a,l,g,I){try{if(this.syncHeaders={...I},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let _="idle";try{const O=await this.getLastSyncUserData(),U=await this.getLatestRemoteUserData(a,O);return _=await this.performSync(U,O,l,g),_==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):_==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(_)}}finally{this.syncHeaders={}}}async replace(a){const l=await this.resolveContent(a);if(!l)return!1;const g=this.parseSyncData(l);if(!g)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const I=await this.getLastSyncUserData(),_=await this.getLatestRemoteUserData(null,I),O=await this.isRemoteDataFromCurrentMachine(_),U=await this.generateSyncPreview({ref:_.ref,syncData:g},I,O,this.getUserDataSyncConfiguration(),T.CancellationToken.None),D=[];for(const M of U){const N=await this.getAcceptResult(M,M.remoteResource,void 0,T.CancellationToken.None),{remoteChange:x}=await this.getAcceptResult(M,M.previewResource,M.remoteContent,T.CancellationToken.None);D.push([M,{...N,remoteChange:x!==0?x:2}])}await this.applyResult(_,I,D,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(a){const l=await this.currentMachineIdPromise;return!!a.syncData?.machineId&&a.syncData.machineId===l}async getLatestRemoteUserData(a,l){if(l){const g=a&&a.latest?a.latest[this.resource]:void 0;if(l.ref===g||g===void 0&&l.syncData===null)return l}return this.getRemoteUserData(l)}async performSync(a,l,g,I){if(a.syncData&&a.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new d.UserDataSyncError((0,f.localize)(0,null,this.resource,this.version,a.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(a,l,g,I)}catch(_){if(_ instanceof d.UserDataSyncError)switch(_.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(a,l,g,I);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),a=await this.getRemoteUserData(null),l=await this.getLastSyncUserData(),this.performSync(a,l,g,I)}throw _}}async doSync(a,l,g,I){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,t.createCancelablePromise)(O=>this.doGenerateSyncResourcePreview(a,l,g,I,O)));const _=await this.syncPreviewPromise;return this.updateConflicts(_.resourcePreviews),_.resourcePreviews.some(({mergeState:O})=>O==="conflict")?"hasConflicts":g?await this.doApply(!1):"syncing"}catch(_){throw this.syncPreviewPromise=null,_}}async merge(a){return await this.updateSyncResourcePreview(a,async l=>{const g=await this.getMergeResult(l,T.CancellationToken.None);await this.fileService.writeFile(l.previewResource,L.VSBuffer.fromString(g?.content||""));const I=g&&!g.hasConflicts?await this.getAcceptResult(l,l.previewResource,void 0,T.CancellationToken.None):void 0;return l.acceptResult=I,l.mergeState=g.hasConflicts?"conflict":I?"accepted":"preview",l.localChange=I?I.localChange:g.localChange,l.remoteChange=I?I.remoteChange:g.remoteChange,l}),this.syncPreviewPromise}async accept(a,l){return await this.updateSyncResourcePreview(a,async g=>{const I=await this.getAcceptResult(g,a,l,T.CancellationToken.None);return g.acceptResult=I,g.mergeState="accepted",g.localChange=I.localChange,g.remoteChange=I.remoteChange,g}),this.syncPreviewPromise}async discard(a){return await this.updateSyncResourcePreview(a,async l=>{const g=await this.getMergeResult(l,T.CancellationToken.None);return await this.fileService.writeFile(l.previewResource,L.VSBuffer.fromString(g.content||"")),l.acceptResult=void 0,l.mergeState="preview",l.localChange=g.localChange,l.remoteChange=g.remoteChange,l}),this.syncPreviewPromise}async updateSyncResourcePreview(a,l){if(!this.syncPreviewPromise)return;let g=await this.syncPreviewPromise;const I=g.resourcePreviews.findIndex(({localResource:_,remoteResource:O,previewResource:U})=>this.extUri.isEqual(_,a)||this.extUri.isEqual(O,a)||this.extUri.isEqual(U,a));I!==-1&&(this.syncPreviewPromise=(0,t.createCancelablePromise)(async _=>{const O=[...g.resourcePreviews];return O[I]=await l(O[I]),{...g,resourcePreviews:O}}),g=await this.syncPreviewPromise,this.updateConflicts(g.resourcePreviews),g.resourcePreviews.some(({mergeState:_})=>_==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(a){if(!this.syncPreviewPromise)return"idle";const l=await this.syncPreviewPromise;return l.resourcePreviews.some(({mergeState:g})=>g==="conflict")?"hasConflicts":l.resourcePreviews.some(({mergeState:g})=>g!=="accepted")?"syncing":(await this.applyResult(l.remoteUserData,l.lastSyncUserData,l.resourcePreviews.map(g=>[g,g.acceptResult]),a),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(a){const l=a.filter(({mergeState:g})=>g==="conflict");(0,k.equals)(this._conflicts,l,(g,I)=>this.extUri.isEqual(g.previewResource,I.previewResource))||(this._conflicts=l,this._onDidChangeConflicts.fire(l))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:l,ref:g})=>({created:l,uri:this.toRemoteBackupResource(g)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:l,ref:g})=>({created:l,uri:this.toLocalBackupResource(g)}))}toRemoteBackupResource(a){return E.URI.from({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${a}`})}toLocalBackupResource(a){return E.URI.from({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${a}`})}async getMachineId({uri:a}){const l=this.extUri.basename(a);if(this.extUri.isEqual(a,this.toRemoteBackupResource(l))){const{content:g}=await this.getUserData(l);if(g)return this.parseSyncData(g)?.machineId}}async resolveContent(a){const l=this.extUri.basename(a);if(this.extUri.isEqual(a,this.toRemoteBackupResource(l))){const{content:g}=await this.getUserData(l);return g}return this.extUri.isEqual(a,this.toLocalBackupResource(l))?this.userDataSyncBackupStoreService.resolveContent(this.resource,l):null}async resolvePreviewContent(a){const l=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(l)for(const g of l.resourcePreviews){if(this.extUri.isEqual(g.acceptedResource,a))return g.acceptResult?g.acceptResult.content:null;if(this.extUri.isEqual(g.remoteResource,a))return g.remoteContent;if(this.extUri.isEqual(g.localResource,a))return g.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch{}}async doGenerateSyncResourcePreview(a,l,g,I,_){const O=await this.isRemoteDataFromCurrentMachine(a),U=await this.generateSyncPreview(a,l,O,I,_),D=[];for(const M of U){const N=M.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(M.localChange===0&&M.remoteChange===0)D.push({...M,acceptedResource:N,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const x=g?await this.getMergeResult(M,_):void 0;if(_.isCancellationRequested)break;await this.fileService.writeFile(M.previewResource,L.VSBuffer.fromString(x?.content||""));const Q=x&&!x.hasConflicts?await this.getAcceptResult(M,M.previewResource,void 0,_):void 0;D.push({...M,acceptResult:Q,mergeState:x?.hasConflicts?"conflict":Q?"accepted":"preview",localChange:Q?Q.localChange:x?x.localChange:M.localChange,remoteChange:Q?Q.remoteChange:x?x.remoteChange:M.remoteChange})}}return{remoteUserData:a,lastSyncUserData:l,resourcePreviews:D,isLastSyncFromCurrentMachine:O}}async getLastSyncUserData(){try{const a=await this.fileService.readFile(this.lastSyncResource),l=JSON.parse(a.value.toString()),g=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=l.version&&g&&l.version!==g,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${l.version} is not compatible with current sync state version ${g}.`),await this.resetLocal(),null;const I=l;if(I.content===null)return{ref:l.ref,syncData:null};const _=JSON.parse(I.content);if(i(_))return{...l,syncData:_,content:void 0}}catch(a){a instanceof u.FileOperationError&&a.fileOperationResult===1||this.logService.error(a)}return null}async updateLastSyncUserData(a,l={}){if(l.ref||l.content||l.version)throw new Error("Cannot have core properties as additional");const g=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),I={ref:a.ref,content:a.syncData?JSON.stringify(a.syncData):null,version:g,...l};await this.fileService.writeFile(this.lastSyncResource,L.VSBuffer.fromString(JSON.stringify(I)))}async getRemoteUserData(a){const{ref:l,content:g}=await this.getUserData(a);let I=null;return g!==null&&(I=this.parseSyncData(g)),{ref:l,syncData:I}}parseSyncData(a){try{const l=JSON.parse(a);if(i(l))return l}catch(l){this.logService.error(l)}throw new d.UserDataSyncError((0,f.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(a){if((0,P.isString)(a)){const l=await this.userDataSyncStoreService.resolveContent(this.resource,a);return{ref:a,content:l}}else{const l=a?{ref:a.ref,content:a.syncData?JSON.stringify(a.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,l,this.syncHeaders)}}async updateRemoteUserData(a,l){const g=await this.currentMachineIdPromise,I={version:this.version,machineId:g,content:a};return l=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(I),l,this.syncHeaders),{ref:l,syncData:I}}async backupLocal(a){const l={version:this.version,content:a};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(l))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(d.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};c=he([G(1,u.IFileService),G(2,h.IEnvironmentService),G(3,w.IStorageService),G(4,d.IUserDataSyncStoreService),G(5,d.IUserDataSyncBackupStoreService),G(6,d.IUserDataSyncEnablementService),G(7,y.ITelemetryService),G(8,d.IUserDataSyncLogService),G(9,p.IConfigurationService),G(10,S.IUriIdentityService)],c),e.AbstractSynchroniser=c;let r=class extends c{constructor(a,l,g,I,_,O,U,D,M,N,x,Q){super(l,g,I,_,O,U,D,M,N,x,Q);this.file=a,this._register(this.fileService.watch(this.extUri.dirname(a))),this._register(this.fileService.onDidFilesChange(W=>this.onFileChanges(W)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(a,l,g){try{l?await this.fileService.writeFile(this.file,L.VSBuffer.fromString(a),g?void 0:l):await this.fileService.createFile(this.file,L.VSBuffer.fromString(a),{overwrite:g})}catch(I){throw I instanceof u.FileOperationError&&I.fileOperationResult===1||I instanceof u.FileOperationError&&I.fileOperationResult===3?new d.UserDataSyncError(I.message,"LocalPreconditionFailed"):I}}onFileChanges(a){!a.contains(this.file)||this.triggerLocalChange()}};r=he([G(2,u.IFileService),G(3,h.IEnvironmentService),G(4,w.IStorageService),G(5,d.IUserDataSyncStoreService),G(6,d.IUserDataSyncBackupStoreService),G(7,d.IUserDataSyncEnablementService),G(8,y.ITelemetryService),G(9,d.IUserDataSyncLogService),G(10,p.IConfigurationService),G(11,S.IUriIdentityService)],r),e.AbstractFileSynchroniser=r;let n=class extends r{constructor(a,l,g,I,_,O,U,D,M,N,x,Q,W){super(a,l,g,I,_,O,U,D,M,N,Q,W);this.userDataSyncUtilService=x,this._formattingOptions=void 0}hasErrors(a){const l=[];return(0,R.parse)(a,l,{allowEmptyContent:!0,allowTrailingComma:!0}),l.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};n=he([G(2,u.IFileService),G(3,h.IEnvironmentService),G(4,w.IStorageService),G(5,d.IUserDataSyncStoreService),G(6,d.IUserDataSyncBackupStoreService),G(7,d.IUserDataSyncEnablementService),G(8,y.ITelemetryService),G(9,d.IUserDataSyncLogService),G(10,d.IUserDataSyncUtilService),G(11,p.IConfigurationService),G(12,S.IUriIdentityService)],n),e.AbstractJsonFileSynchroniser=n;let o=class{constructor(a,l,g,I,_){this.resource=a,this.environmentService=l,this.logService=g,this.fileService=I,this.extUri=_.extUri,this.lastSyncResource=(0,d.getLastSyncResourceUri)(this.resource,l,this.extUri)}async initialize({ref:a,content:l}){if(!l){this.logService.info("Remote content does not exist.",this.resource);return}const g=this.parseSyncData(l);if(!!g)try{await this.doInitialize({ref:a,syncData:g})}catch(I){this.logService.error(I)}}parseSyncData(a){try{const l=JSON.parse(a);if(i(l))return l}catch(l){this.logService.error(l)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(a,l={}){const g={ref:a.ref,content:a.syncData?JSON.stringify(a.syncData):null,...l};await this.fileService.writeFile(this.lastSyncResource,L.VSBuffer.fromString(JSON.stringify(g)))}};o=he([G(1,h.IEnvironmentService),G(2,v.ILogService),G(3,u.IFileService),G(4,S.IUriIdentityService)],o),e.AbstractInitializer=o}),define(te[228],ne([0,1,5,25,9,3,49,26,7,19,14,30,31,63,15,8,23,21,32,45,225,98,24]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p,h,u,v,m,w,y,S,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=void 0;async function c(o,s){const a=JSON.parse(o.content);if(o.version===1||o.version===2){const l=(await s.getInstalled(0)).filter(g=>g.isBuiltin);for(const g of a)o.version===1&&(g.enabled===!1&&(g.disabled=!0),delete g.enabled),o.version===2&&l.every(I=>!(0,f.areSameExtensions)(I.identifier,g.identifier))&&(g.installed=!0)}return a}let r=class mt extends y.AbstractSynchroniser{constructor(s,a,l,g,I,_,O,U,D,M,N,x,Q,W,ie){super("extensions",a,s,l,g,I,x,Q,D,N,ie);this.extensionManagementService=_,this.extensionEnablementService=O,this.ignoredExtensionsManagementService=U,this.extensionGalleryService=M,this.extensionStorageService=W,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(T.Event.any(T.Event.filter(this.extensionManagementService.onDidInstallExtensions,B=>B.some(({local:j})=>!!j)),T.Event.filter(this.extensionManagementService.onDidUninstallExtension,B=>!B.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionStorageService.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview(s,a){const l=s.syncData?await c(s.syncData,this.extensionManagementService):null,g=a?.skippedExtensions||[],I=a?.syncData?await c(a.syncData,this.extensionManagementService):null,_=await this.extensionManagementService.getInstalled(void 0,!0),O=this.getLocalExtensions(_),U=this.ignoredExtensionsManagementService.getIgnoredExtensions(_);l?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:D,remote:M}=(0,S.merge)(O,l,I,g,U),N={local:D,remote:M,content:this.getPreviewContent(O,D.added,D.updated,D.removed),localChange:D.added.length>0||D.removed.length>0||D.updated.length>0?2:0,remoteChange:M!==null?2:0};return[{skippedExtensions:g,localResource:this.localResource,localContent:this.stringify(O,!1),localExtensions:O,remoteResource:this.remoteResource,remoteContent:l?this.stringify(l,!1):null,previewResource:this.previewResource,previewResult:N,localChange:N.localChange,remoteChange:N.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(s){const a=s.syncData?await c(s.syncData,this.extensionManagementService):null,l=await this.extensionManagementService.getInstalled(void 0,!0),g=this.getLocalExtensions(l),I=this.ignoredExtensionsManagementService.getIgnoredExtensions(l),{remote:_}=(0,S.merge)(g,a,a,s.skippedExtensions||[],I);return _!==null}getPreviewContent(s,a,l,g){const I=[...a,...l],_=new Set,O=U=>{_.add(U.id.toLowerCase()),U.uuid&&_.add(U.uuid)};I.forEach(({identifier:U})=>O(U)),g.forEach(O);for(const U of s)_.has(U.identifier.id.toLowerCase())||U.identifier.uuid&&_.has(U.identifier.uuid)||I.push(U);return this.stringify(I,!1)}async getMergeResult(s,a){return{...s.previewResult,hasConflicts:!1}}async getAcceptResult(s,a,l,g){if(this.extUri.isEqual(a,this.localResource))return this.acceptLocal(s);if(this.extUri.isEqual(a,this.remoteResource))return this.acceptRemote(s);if(this.extUri.isEqual(a,this.previewResource))return s.previewResult;throw new Error(`Invalid Resource: ${a.toString()}`)}async acceptLocal(s){const a=await this.extensionManagementService.getInstalled(),l=this.ignoredExtensionsManagementService.getIgnoredExtensions(a),g=(0,S.merge)(s.localExtensions,null,null,s.skippedExtensions,l),{local:I,remote:_}=g;return{content:s.localContent,local:I,remote:_,localChange:I.added.length>0||I.removed.length>0||I.updated.length>0?2:0,remoteChange:_!==null?2:0}}async acceptRemote(s){const a=await this.extensionManagementService.getInstalled(),l=this.ignoredExtensionsManagementService.getIgnoredExtensions(a),g=s.remoteContent?JSON.parse(s.remoteContent):null;if(g!==null){const I=(0,S.merge)(s.localExtensions,g,s.localExtensions,[],l),{local:_,remote:O}=I;return{content:s.remoteContent,local:_,remote:O,localChange:_.added.length>0||_.removed.length>0||_.updated.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:s.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(s,a,l,g){let{skippedExtensions:I,localExtensions:_}=l[0][0],{local:O,remote:U,localChange:D,remoteChange:M}=l[0][1];if(D===0&&M===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),D!==0&&(await this.backupLocal(JSON.stringify(_)),I=await this.updateLocalExtensions(O.added,O.removed,O.updated,I)),U){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const N=JSON.stringify(U.all);s=await this.updateRemoteUserData(N,g?null:s.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${U.added.length?` Added: ${JSON.stringify(U.added.map(x=>x.identifier.id))}.`:""}${U.updated.length?` Updated: ${JSON.stringify(U.updated.map(x=>x.identifier.id))}.`:""}${U.removed.length?` Removed: ${JSON.stringify(U.removed.map(x=>x.identifier.id))}.`:""}`)}a?.ref!==s.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(s,{skippedExtensions:I}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${I.length?` Skipped: ${JSON.stringify(I.map(N=>N.identifier.id))}.`:""}`))}async getAssociatedResources({uri:s}){return[{resource:this.extUri.joinPath(s,"extensions.json"),comparableResource:mt.EXTENSIONS_DATA_URI}]}async resolveContent(s){if(this.extUri.isEqual(s,mt.EXTENSIONS_DATA_URI)){const l=await this.extensionManagementService.getInstalled(),g=this.ignoredExtensionsManagementService.getIgnoredExtensions(l),I=this.getLocalExtensions(l).filter(_=>!g.some(O=>(0,f.areSameExtensions)({id:O},_.identifier)));return this.stringify(I,!0)}if(this.extUri.isEqual(this.remoteResource,s)||this.extUri.isEqual(this.localResource,s)||this.extUri.isEqual(this.acceptedResource,s)){const l=await this.resolvePreviewContent(s);return l&&this.stringify(JSON.parse(l),!0)}let a=await super.resolveContent(s);if(a)return a;if(a=await super.resolveContent(this.extUri.dirname(s)),a){const l=this.parseSyncData(a);if(l)switch(this.extUri.basename(s)){case"extensions.json":return this.stringify(this.parseExtensions(l),!0)}}return null}stringify(s,a){return s.sort((l,g)=>!l.identifier.uuid&&g.identifier.uuid?-1:l.identifier.uuid&&!g.identifier.uuid?1:(0,R.compare)(l.identifier.id,g.identifier.id)),a?(0,A.toFormattedString)(s,{}):JSON.stringify(s)}async hasLocalData(){try{const s=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(s).some(l=>l.installed||l.disabled))return!0}catch{}return!1}async updateLocalExtensions(s,a,l,g){const I=[],_=[],O=await this.extensionManagementService.getInstalled();if(a.length){const D=O.filter(({identifier:M,isBuiltin:N})=>!N&&a.some(x=>(0,f.areSameExtensions)(M,x)));await k.Promises.settled(D.map(async M=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,M.identifier.id),await this.extensionManagementService.uninstall(M,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,M.identifier.id),I.push(M.identifier)}))}(s.length||l.length)&&await k.Promises.settled([...s,...l].map(async D=>{const M=O.find(x=>(0,f.areSameExtensions)(x.identifier,D.identifier));if(M&&M.isBuiltin){D.state&&M.manifest.version===D.version&&this.updateExtensionState(D.state,M,M.manifest.version),this.extensionEnablementService.getDisabledExtensions().some(Q=>(0,f.areSameExtensions)(Q,D.identifier))!==!!D.disabled&&(D.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,D.identifier.id),await this.extensionEnablementService.disableExtension(D.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,D.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,D.identifier.id),await this.extensionEnablementService.enableExtension(D.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,D.identifier.id))),I.push(D.identifier);return}const N=(await this.extensionGalleryService.getExtensions([{...D.identifier,preRelease:D.preRelease}],t.CancellationToken.None))[0];if(D.state&&(M?M.manifest.version===D.version:!!N)&&this.updateExtensionState(D.state,M||N,M?.manifest.version),N)try{this.extensionEnablementService.getDisabledExtensions().some(Q=>(0,f.areSameExtensions)(Q,D.identifier))!==!!D.disabled&&(D.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,D.identifier.id,N.version),await this.extensionEnablementService.disableExtension(N.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,D.identifier.id,N.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,D.identifier.id,N.version),await this.extensionEnablementService.enableExtension(N.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,D.identifier.id,N.version))),(!M||M.preRelease!==D.preRelease)&&(await this.extensionManagementService.canInstall(N)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,D.identifier.id,N.version),await this.extensionManagementService.installFromGallery(N,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:D.preRelease}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,D.identifier.id,N.version),I.push(N.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,N.displayName||N.identifier.id),_.push(D)))}catch(x){_.push(D),x instanceof E.ExtensionManagementError&&[E.ExtensionManagementErrorCode.Incompatible,E.ExtensionManagementErrorCode.IncompatiblePreRelease,E.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(x.code)?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,N.displayName||N.identifier.id):(this.logService.error(x),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,N.displayName||N.identifier.id))}else _.push(D),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,D.identifier.id)}));const U=[];for(const D of g)I.some(M=>(0,f.areSameExtensions)(M,D.identifier))||U.push(D);for(const D of _)U.some(M=>(0,f.areSameExtensions)(M.identifier,D.identifier))||U.push(D);return U}updateExtensionState(s,a,l){const g=this.extensionStorageService.getExtensionState(a,!0)||{},I=l?this.extensionStorageService.getKeysForSync({id:a.identifier.id,version:l}):void 0;I?I.forEach(_=>{g[_]=s[_]}):Object.keys(s).forEach(_=>g[_]=s[_]),this.extensionStorageService.setExtensionState(a,g,!0)}parseExtensions(s){return JSON.parse(s.content)}getLocalExtensions(s){const a=this.extensionEnablementService.getDisabledExtensions();return s.map(l=>{const{identifier:g,isBuiltin:I,manifest:_,preRelease:O}=l,U={identifier:g,preRelease:O,version:_.version};a.some(D=>(0,f.areSameExtensions)(D,g))&&(U.disabled=!0),I||(U.installed=!0);try{const D=this.extensionStorageService.getKeysForSync({id:g.id,version:_.version});if(D){const M=this.extensionStorageService.getExtensionState(l,!0)||{};U.state=Object.keys(M).reduce((N,x)=>(D.includes(x)&&(N[x]=M[x]),N),{})}}catch(D){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,L.getErrorMessage)(D))}return U})}};r.EXTENSIONS_DATA_URI=b.URI.from({scheme:i.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),r=he([G(0,P.IEnvironmentService),G(1,h.IFileService),G(2,v.IStorageService),G(3,i.IUserDataSyncStoreService),G(4,i.IUserDataSyncBackupStoreService),G(5,E.IExtensionManagementService),G(6,E.IGlobalExtensionEnablementService),G(7,d.IIgnoredExtensionsManagementService),G(8,i.IUserDataSyncLogService),G(9,E.IExtensionGalleryService),G(10,C.IConfigurationService),G(11,i.IUserDataSyncEnablementService),G(12,m.ITelemetryService),G(13,p.IExtensionStorageService),G(14,w.IUriIdentityService)],r),e.ExtensionsSynchroniser=r;let n=class extends y.AbstractInitializer{constructor(s,a,l,g,I,_){super("extensions",g,I,l,_);this.extensionManagementService=s,this.ignoredExtensionsManagementService=a}async parseExtensions(s){return s.syncData?await c(s.syncData,this.extensionManagementService):null}generatePreview(s,a){const l=[],g=[],I=[];for(const _ of s){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(_.identifier.id))continue;const O=a.find(U=>(0,f.areSameExtensions)(U.identifier,_.identifier));O?(l.push(O),_.disabled&&I.push(_.identifier)):_.installed&&(g.push({..._.identifier,preRelease:!!_.preRelease}),_.disabled&&I.push(_.identifier))}return{installedExtensions:l,newExtensions:g,disabledExtensions:I,remoteExtensions:s}}};n=he([G(0,E.IExtensionManagementService),G(1,d.IIgnoredExtensionsManagementService),G(2,h.IFileService),G(3,P.IEnvironmentService),G(4,u.ILogService),G(5,w.IUriIdentityService)],n),e.AbstractExtensionsInitializer=n}),define(te[229],ne([0,1,28,24]),function(K,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(R,b,C,P,E){if(!b)return{remote:Object.keys(R).length>0?R:null,local:{added:{},removed:[],updated:{}}};const f=T(R,b);if(f.added.size===0&&f.removed.size===0&&f.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const p=C?T(C,b):{added:Object.keys(b).reduce((w,y)=>(w.add(y),w),new Set),removed:new Set,updated:new Set},h=C?T(C,R):{added:Object.keys(R).reduce((w,y)=>(w.add(y),w),new Set),removed:new Set,updated:new Set},u={added:{},removed:[],updated:{}},v=k.deepClone(b),m=!C;for(const w of h.added.values())w!==t.SYNC_SERVICE_URL_TYPE&&m&&p.added.has(w)||(v[w]=R[w]);for(const w of h.updated.values())v[w]=R[w];for(const w of h.removed.values())P.unregistered.includes(w)||delete v[w];for(const w of p.added.values()){const y=b[w];if(P.machine.includes(w)){E.info(`GlobalState: Skipped adding ${w} in local storage because it is declared as machine scoped.`);continue}if(C&&h.added.has(w))continue;const S=R[w];S&&S.value===y.value||w===t.SYNC_SERVICE_URL_TYPE&&m&&h.added.has(w)||(S?u.updated[w]=y:u.added[w]=y)}for(const w of p.updated.values()){const y=b[w];if(P.machine.includes(w)){E.info(`GlobalState: Skipped updating ${w} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(w)||h.removed.has(w))continue;const S=R[w];S&&S.value===y.value||(u.updated[w]=y)}for(const w of p.removed.values()){if(P.machine.includes(w)){E.trace(`GlobalState: Skipped removing ${w} in local storage because it is declared as machine scoped.`);continue}h.updated.has(w)||h.removed.has(w)||u.removed.push(w)}return{local:u,remote:A(v,b)?null:v}}e.merge=L;function T(R,b){const C=Object.keys(R),P=Object.keys(b),E=P.filter(h=>C.indexOf(h)===-1).reduce((h,u)=>(h.add(u),h),new Set),f=C.filter(h=>P.indexOf(h)===-1).reduce((h,u)=>(h.add(u),h),new Set),p=new Set;for(const h of C){if(f.has(h))continue;const u=R[h],v=b[h];k.equals(u,v)||p.add(h)}return{added:E,removed:f,updated:p}}function A(R,b){const{added:C,removed:P,updated:E}=T(R,b);return C.size===0&&P.size===0&&E.size===0}}),define(te[230],ne([0,1,17,9,3,35,49,4,7,29,19,14,15,8,47,23,21,32,45,53,229,24]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p,h,u,v,m,w,y,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const i="globalState.argv.",c=["locale"];function r(l,g){const I=l.storage?Object.keys(l.storage).sort():[],_={};return I.forEach(O=>_[O]=l.storage[O]),l.storage=_,g?(0,A.toFormattedString)(l,{}):JSON.stringify(l)}const n=1;let o=class vt extends w.AbstractSynchroniser{constructor(g,I,_,O,U,D,M,N,x,Q){super("globalState",g,U,x,I,_,D,M,O,N,Q);this.storageService=x,this.version=n,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(g.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(L.Event.any(L.Event.filter(g.onDidFilesChange,W=>W.contains(this.environmentService.argvResource)),L.Event.filter(x.onDidChangeValue,W=>W.scope===0&&W.target!==void 0?W.target===0:x.keys(0,0).includes(W.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(g,I,_){const O=g.syncData?JSON.parse(g.syncData.content):null;I=I===null&&_?g:I;const U=I&&I.syncData?JSON.parse(I.syncData.content):null,D=await this.getLocalGlobalState();O?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const M=this.getStorageKeys(U),{local:N,remote:x}=(0,S.merge)(D.storage,O?O.storage:null,U?U.storage:null,M,this.logService),Q={content:null,local:N,remote:x,localChange:Object.keys(N.added).length>0||Object.keys(N.updated).length>0||N.removed.length>0?2:0,remoteChange:x!==null?2:0};return[{localResource:this.localResource,localContent:r(D,!1),localUserData:D,remoteResource:this.remoteResource,remoteContent:O?r(O,!1):null,previewResource:this.previewResource,previewResult:Q,localChange:Q.localChange,remoteChange:Q.remoteChange,acceptedResource:this.acceptedResource,storageKeys:M}]}async hasRemoteChanged(g){const I=g.syncData?JSON.parse(g.syncData.content):null;if(I===null)return!0;const _=await this.getLocalGlobalState(),O=this.getStorageKeys(I),{remote:U}=(0,S.merge)(_.storage,I.storage,I.storage,O,this.logService);return U!==null}async getMergeResult(g,I){return{...g.previewResult,hasConflicts:!1}}async getAcceptResult(g,I,_,O){if(this.extUri.isEqual(I,this.localResource))return this.acceptLocal(g);if(this.extUri.isEqual(I,this.remoteResource))return this.acceptRemote(g);if(this.extUri.isEqual(I,this.previewResource))return g.previewResult;throw new Error(`Invalid Resource: ${I.toString()}`)}async acceptLocal(g){return{content:g.localContent,local:{added:{},removed:[],updated:{}},remote:g.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(g){if(g.remoteContent!==null){const I=JSON.parse(g.remoteContent),{local:_,remote:O}=(0,S.merge)(g.localUserData.storage,I.storage,null,g.storageKeys,this.logService);return{content:g.remoteContent,local:_,remote:O,localChange:Object.keys(_.added).length>0||Object.keys(_.updated).length>0||_.removed.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:g.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(g,I,_,O){let{localUserData:U}=_[0][0],{local:D,remote:M,localChange:N,remoteChange:x}=_[0][1];if(N===0&&x===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),N!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(U)),await this.writeLocalGlobalState(D),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),x!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const Q=JSON.stringify({storage:M});g=await this.updateRemoteUserData(Q,O?null:g.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}I?.ref!==g.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(g),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:g}){return[{resource:this.extUri.joinPath(g,"globalState.json"),comparableResource:vt.GLOBAL_STATE_DATA_URI}]}async resolveContent(g){if(this.extUri.isEqual(g,vt.GLOBAL_STATE_DATA_URI)){const _=await this.getLocalGlobalState();return r(_,!0)}if(this.extUri.isEqual(this.remoteResource,g)||this.extUri.isEqual(this.localResource,g)||this.extUri.isEqual(this.acceptedResource,g)){const _=await this.resolvePreviewContent(g);return _&&r(JSON.parse(_),!0)}let I=await super.resolveContent(g);if(I)return I;if(I=await super.resolveContent(this.extUri.dirname(g)),I){const _=this.parseSyncData(I);if(_)switch(this.extUri.basename(g)){case"globalState.json":return r(JSON.parse(_.content),!0)}}return null}async hasLocalData(){try{const{storage:g}=await this.getLocalGlobalState();if(Object.keys(g).length>1||g[`${i}.locale`]?.value!=="en")return!0}catch{}return!1}async getLocalGlobalState(){const g={},I=await this.getLocalArgvContent(),_=(0,T.parse)(I);for(const O of c)_[O]!==void 0&&(g[`${i}${O}`]={version:1,value:_[O]});for(const O of this.storageService.keys(0,0)){const U=this.storageService.get(O,0);U&&(g[O]={version:1,value:U})}return{storage:g}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const g=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),g.value.toString()}catch(g){this.logService.debug((0,t.getErrorMessage)(g))}return"{}"}async writeLocalGlobalState({added:g,removed:I,updated:_}){const O={},U={},D=(N,x)=>{for(const Q of N){if(Q.startsWith(i)){O[Q.substring(i.length)]=x?x[Q].value:void 0;continue}if(x){const W=x[Q];W.value!==String(this.storageService.get(Q,0))&&(U[Q]=W.value)}else this.storageService.get(Q,0)!==void 0&&(U[Q]=void 0)}};if(D(Object.keys(g),g),D(Object.keys(_),_),D(I),Object.keys(O).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(O),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(U).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const N of Object.keys(U))this.storageService.store(N,U[N],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(U))}}async updateArgv(g){const I=await this.getLocalArgvContent();let _=I;for(const O of Object.keys(g))_=(0,y.edit)(_,[O],g[O],{});I!==_&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,k.VSBuffer.fromString(_)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(g){const I=this.storageService.keys(0,0),_=this.storageService.keys(0,1),O=[...I,..._],U=g?.storage?Object.keys(g.storage).filter(D=>!D.startsWith(i)&&!O.includes(D)&&this.storageService.get(D,0)!==void 0):[];if(!R.isWeb){const D=[...d.ALL_SYNC_RESOURCES.map(M=>(0,d.getEnablementKey)(M)),d.SYNC_SERVICE_URL_TYPE];U.push(...D),_.push(...D)}return{user:I,machine:_,unregistered:U}}};o.GLOBAL_STATE_DATA_URI=b.URI.from({scheme:d.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),o=he([G(0,f.IFileService),G(1,d.IUserDataSyncStoreService),G(2,d.IUserDataSyncBackupStoreService),G(3,d.IUserDataSyncLogService),G(4,E.IEnvironmentService),G(5,d.IUserDataSyncEnablementService),G(6,v.ITelemetryService),G(7,P.IConfigurationService),G(8,u.IStorageService),G(9,m.IUriIdentityService)],o),e.GlobalStateSynchroniser=o;let s=class extends w.AbstractInitializer{constructor(g,I,_,O,U){super("globalState",_,O,I,U);this.storageService=g}async doInitialize(g){const I=g.syncData?JSON.parse(g.syncData.content):null;if(!I){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const _={},O={};for(const U of Object.keys(I.storage))U.startsWith(i)?_[U.substring(i.length)]=I.storage[U].value:this.storageService.get(U,0)===void 0&&(O[U]=I.storage[U].value);if(Object.keys(_).length){let U="{}";try{U=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const D of Object.keys(_))U=(0,y.edit)(U,[D],_[D],{});await this.fileService.writeFile(this.environmentService.argvResource,k.VSBuffer.fromString(U))}if(Object.keys(O).length)for(const U of Object.keys(O))this.storageService.store(U,O[U],0,0)}};s=he([G(0,u.IStorageService),G(1,f.IFileService),G(2,E.IEnvironmentService),G(3,d.IUserDataSyncLogService),G(4,m.IUriIdentityService)],s),e.GlobalStateInitializer=s;let a=class{constructor(g,I,_,O,U){this.userDataSyncStoreClient=g,this.storageService=I,this.environmentService=_,this.fileService=O,this.logService=U}getSyncStoreType(g){return this.parseGlobalState(g)?.storage[d.SYNC_SERVICE_URL_TYPE]?.value}async sync(g){const I=(0,d.createSyncHeaders)((0,C.generateUuid)());try{return await this.doSync(g,I)}catch(_){if(_ instanceof d.UserDataSyncError)switch(_.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(g,I)}throw _}}async doSync(g,I){const _=await this.userDataSyncStoreClient.read("globalState",null,I),O=this.parseGlobalState(_)||{storage:{}};O.storage[d.SYNC_SERVICE_URL_TYPE]={value:g,version:n};const U=await(0,h.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),D={version:n,machineId:U,content:r(O,!1)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(D),_.ref,I)}parseGlobalState({content:g}){if(!g)return null;const I=JSON.parse(g);if((0,w.isSyncData)(I))return I?JSON.parse(I.content):null;throw new Error("Invalid remote data")}};a=he([G(1,u.IStorageService),G(2,E.IEnvironmentService),G(3,f.IFileService),G(4,p.ILogService)],a),e.UserDataSyncStoreTypeSynchronizer=a}),define(te[231],ne([0,1,16,17,3,35,4,11,145,19,14,15,23,21,32,45,226,24]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p,h,u,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function w(d,i,c){try{const r=JSON.parse(d);if(!i)return(0,R.isUndefined)(r.all)?null:r.all;switch(A.OS){case 2:return(0,R.isUndefined)(r.mac)?null:r.mac;case 3:return(0,R.isUndefined)(r.linux)?null:r.linux;case 1:return(0,R.isUndefined)(r.windows)?null:r.windows}}catch(r){return c.error(r),null}}e.getKeybindingsContentFromSyncContent=w;let y=class extends u.AbstractJsonFileSynchroniser{constructor(i,c,r,n,o,s,a,l,g,I,_){super(a.keybindingsResource,"keybindings",s,a,l,i,c,o,I,r,g,n,_);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(L.Event.filter(n.onDidChangeConfiguration,O=>O.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(i,c,r,n){const o=i.syncData?w(i.syncData.content,n.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;c=c===null&&r?i:c;const s=c?this.getKeybindingsContentFromLastSyncUserData(c):null,a=await this.getLocalFileContent(),l=await this.getFormattingOptions();let g=null,I=!1,_=!1,O=!1;if(o){let D=a?a.value.toString():"[]";if(D=D||"[]",this.hasErrors(D))throw new m.UserDataSyncError((0,b.localize)(0,null),"LocalInvalidContent",this.resource);if(!s||s!==D||s!==o){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const M=await(0,v.merge)(D,o,s,l,this.userDataSyncUtilService);M.hasChanges&&(g=M.mergeContent,O=M.hasConflicts,I=O||M.mergeContent!==D,_=O||M.mergeContent!==o)}}else a&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),g=a.value.toString(),_=!0);const U={content:g,localChange:I?a?2:1:0,remoteChange:_?2:0,hasConflicts:O};return[{fileContent:a,localResource:this.localResource,localContent:a?a.value.toString():null,localChange:U.localChange,remoteResource:this.remoteResource,remoteContent:o,remoteChange:U.remoteChange,previewResource:this.previewResource,previewResult:U,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(i){const c=this.getKeybindingsContentFromLastSyncUserData(i);if(c===null)return!0;const r=await this.getLocalFileContent(),n=r?r.value.toString():"",o=await this.getFormattingOptions(),s=await(0,v.merge)(n||"[]",c,c,o,this.userDataSyncUtilService);return s.hasConflicts||s.mergeContent!==c}async getMergeResult(i,c){return i.previewResult}async getAcceptResult(i,c,r,n){if(this.extUri.isEqual(c,this.localResource))return{content:i.fileContent?i.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(c,this.remoteResource))return{content:i.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(c,this.previewResource))return r===void 0?{content:i.previewResult.content,localChange:i.previewResult.localChange,remoteChange:i.previewResult.remoteChange}:{content:r,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${c.toString()}`)}async applyResult(i,c,r,n){const{fileContent:o}=r[0][0];let{content:s,localChange:a,remoteChange:l}=r[0][1];if(a===0&&l===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),s!==null&&(s=s.trim(),s=s||"[]",this.hasErrors(s)))throw new m.UserDataSyncError((0,b.localize)(1,null),"LocalInvalidContent",this.resource);if(a!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),o&&await this.backupLocal(this.toSyncContent(o.value.toString())),await this.updateLocalFileContent(s||"[]",o,n),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),l!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const g=this.toSyncContent(s||"[]",i.syncData?.content);i=await this.updateRemoteUserData(g,n?null:i.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}c?.ref!==i.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(i,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const i=await this.getLocalFileContent();if(i){const c=(0,T.parse)(i.value.toString());if((0,k.isNonEmptyArray)(c))return!0}}catch(i){if(i.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:i}){const c=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(i,"keybindings.json"),comparableResource:c}]}async resolveContent(i){if(this.extUri.isEqual(this.remoteResource,i)||this.extUri.isEqual(this.localResource,i)||this.extUri.isEqual(this.acceptedResource,i))return this.resolvePreviewContent(i);let c=await super.resolveContent(i);if(c)return c;if(c=await super.resolveContent(this.extUri.dirname(i)),c){const r=this.parseSyncData(c);if(r)switch(this.extUri.basename(i)){case"keybindings.json":return w(r.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(i){return!i.syncData||i.platformSpecific!==void 0&&i.platformSpecific!==this.syncKeybindingsPerPlatform()?null:w(i.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(i,c){let r={};try{r=JSON.parse(c||"{}")}catch(n){this.logService.error(n)}switch(this.syncKeybindingsPerPlatform()?delete r.all:r.all=i,A.OS){case 2:r.mac=i;break;case 3:r.linux=i;break;case 1:r.windows=i;break}return JSON.stringify(r)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};y=he([G(0,m.IUserDataSyncStoreService),G(1,m.IUserDataSyncBackupStoreService),G(2,m.IUserDataSyncLogService),G(3,C.IConfigurationService),G(4,m.IUserDataSyncEnablementService),G(5,E.IFileService),G(6,P.IEnvironmentService),G(7,f.IStorageService),G(8,m.IUserDataSyncUtilService),G(9,p.ITelemetryService),G(10,h.IUriIdentityService)],y),e.KeybindingsSynchroniser=y;let S=class extends u.AbstractInitializer{constructor(i,c,r,n){super("keybindings",c,r,i,n)}async doInitialize(i){const c=i.syncData?this.getKeybindingsContentFromSyncContent(i.syncData.content):null;if(!c){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,t.VSBuffer.fromString(c)),await this.updateLastSyncUserData(i)}async isEmpty(){try{const i=await this.fileService.readFile(this.environmentService.settingsResource),c=(0,T.parse)(i.value.toString());return!(0,k.isNonEmptyArray)(c)}catch(i){return i.fileOperationResult===1}}getKeybindingsContentFromSyncContent(i){try{return w(i,!0,this.logService)}catch(c){return this.logService.error(c),null}}};S=he([G(0,E.IFileService),G(1,P.IEnvironmentService),G(2,m.IUserDataSyncLogService),G(3,h.IUriIdentityService)],S),e.KeybindingsInitializer=S}),define(te[232],ne([0,1,16,35,70,49,28,53,24]),function(K,e,k,t,L,T,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function C(s,a,l){let g=[];l?g=E(l):g=P(a);const I=[],_=[...(0,b.getDisallowedIgnoredSettings)()];if(Array.isArray(g))for(const O of g)O.startsWith("-")?_.push(O.substring(1)):I.push(O);return(0,k.distinct)([...s,...I].filter(O=>_.indexOf(O)===-1))}e.getIgnoredSettings=C;function P(s){let a=s.inspect("settingsSync.ignoredSettings").userValue;return a!==void 0||(a=s.inspect("sync.ignoredSettings").userValue,a!==void 0)?a:s.getValue("settingsSync.ignoredSettings")||[]}function E(s){const a=(0,t.parse)(s);return a?a["settingsSync.ignoredSettings"]||a["sync.ignoredSettings"]||[]:[]}function f(s,a,l,g){if(l.length){const I=o(a),_=(0,t.parse)(a),O=(0,t.parse)(s),U=[];for(const D of l){const M=_[D],N=O[D];M===void 0?s=R.edit(s,[D],void 0,g):N!==void 0?s=R.edit(s,[D],M,g):U.push(d(D,I))}U.sort((D,M)=>D.startOffset-M.startOffset),U.forEach(D=>s=m(D.setting.key,a,s,g))}return s}e.updateIgnoredSettings=f;function p(s,a,l,g,I,_){const O=f(s,a,g,_),U=l!==O,D=l!==a;if(!U&&!D)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(U&&!D)return{conflictsSettings:[],localContent:null,remoteContent:O,hasConflicts:!1};if(D&&!U)return{conflictsSettings:[],localContent:f(a,s,g,_),remoteContent:null,hasConflicts:!1};if(l===null&&u(s)){const z=h(s,a,g)?null:f(a,s,g,_);return{conflictsSettings:[],localContent:z,remoteContent:null,hasConflicts:!1}}let M=s,N=a;const x=(0,t.parse)(s),Q=(0,t.parse)(a),W=l?(0,t.parse)(l):null,ie=g.reduce((z,H)=>(z.add(H),z),new Set),B=v(x,Q,ie),j=v(W,x,ie),Y=v(W,Q,ie),V=new Map,J=new Set,Z=z=>{J.add(z);const H=I.filter(({key:ee})=>ee===z)[0];H?(M=R.edit(M,[z],H.value,_),N=R.edit(N,[z],H.value,_)):V.set(z,{key:z,localValue:x[z],remoteValue:Q[z]})};for(const z of j.removed.values())Y.updated.has(z)?Z(z):N=R.edit(N,[z],void 0,_);for(const z of Y.removed.values())J.has(z)||(j.updated.has(z)?Z(z):M=R.edit(M,[z],void 0,_));for(const z of j.updated.values())J.has(z)||(Y.updated.has(z)?B.updated.has(z)&&Z(z):N=R.edit(N,[z],x[z],_));for(const z of Y.updated.values())J.has(z)||(j.updated.has(z)?B.updated.has(z)&&Z(z):M=R.edit(M,[z],Q[z],_));for(const z of j.added.values())J.has(z)||(Y.added.has(z)?B.updated.has(z)&&Z(z):N=m(z,M,N,_));for(const z of Y.added.values())J.has(z)||(j.added.has(z)?B.updated.has(z)&&Z(z):M=m(z,N,M,_));const q=V.size>0||!h(M,N,g),F=q||!h(M,s,[]),$=q||!h(N,a,[]);return{localContent:F?M:null,remoteContent:$?N:null,conflictsSettings:[...V.values()],hasConflicts:q}}e.merge=p;function h(s,a,l){if(s===a)return!0;const g=(0,t.parse)(s),I=(0,t.parse)(a),_=l.reduce((D,M)=>(D.add(M),D),new Set),O=o(s).filter(D=>!(D.setting&&_.has(D.setting.key))),U=o(a).filter(D=>!(D.setting&&_.has(D.setting.key)));if(O.length!==U.length)return!1;for(let D=0;D<O.length;D++){const M=O[D],N=U[D];if(M.setting&&N.setting){if(M.setting.key!==N.setting.key||!A.equals(g[M.setting.key],I[M.setting.key]))return!1}else if(!M.setting&&!N.setting){if(M.value!==N.value)return!1}else return!1}return!0}e.areSame=h;function u(s){return s?o(s).length===0:!0}e.isEmpty=u;function v(s,a,l){const g=s?Object.keys(s).filter(D=>!l.has(D)):[],I=Object.keys(a).filter(D=>!l.has(D)),_=I.filter(D=>g.indexOf(D)===-1).reduce((D,M)=>(D.add(M),D),new Set),O=g.filter(D=>I.indexOf(D)===-1).reduce((D,M)=>(D.add(M),D),new Set),U=new Set;if(s)for(const D of g){if(O.has(D))continue;const M=s[D],N=a[D];A.equals(M,N)||U.add(D)}return{added:_,removed:O,updated:U}}function m(s,a,l,g){const I=(0,t.parse)(a),_=o(a),O=o(l),U=w(s,_,O);return y(l,s,I[s],U,O,g)}e.addSetting=m;function w(s,a,l){const g=a.findIndex(_=>_.setting?.key===s),I=a[g-1];if(I){if(I.setting){const O=d(I.setting.key,l);if(O)return{index:l.indexOf(O),insertAfter:!0}}else{const O=i(g,a);if(O){const U=d(O.setting.key,l);if(U){const D=c(l.indexOf(U),l),M=r(a,O,a[g]);if(D){const N=r(l,U,D),x=n(M,N);return x?{index:l.indexOf(x),insertAfter:!0}:{index:l.indexOf(D),insertAfter:!1}}else{const N=r(l,U,l[l.length-1]),x=n(M,N);return x?{index:l.indexOf(x),insertAfter:!0}:{index:l.length-1,insertAfter:!0}}}}}const _=a[g+1];if(_)if(_.setting){const O=d(_.setting.key,l);if(O)return{index:l.indexOf(O),insertAfter:!1}}else{const O=c(g,a);if(O){const U=d(O.setting.key,l);if(U){const D=i(l.indexOf(U),l),M=r(a,a[g],O);if(D){const N=r(l,D,U),x=n(M.reverse(),N.reverse());return x?{index:l.indexOf(x),insertAfter:!1}:{index:l.indexOf(D),insertAfter:!0}}else{const N=r(l,l[0],U),x=n(M.reverse(),N.reverse());return x?{index:l.indexOf(x),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:l.length-1,insertAfter:!0}}function y(s,a,l,g,I,_){let O;return g.index===-1?O=(0,L.setProperty)(s,[a],l,_):O=S(s,a,l,g,I,_).map(U=>(0,L.withFormatting)(s,U,_)[0]),(0,L.applyEdits)(s,O)}function S(s,a,l,g,I,_){const O=`${JSON.stringify(a)}: ${JSON.stringify(l)}`,U=(0,T.getEOL)(_,s),D=I[g.index];if(g.insertAfter){const M=[];if(D.setting)M.push({offset:D.endOffset,length:0,content:","+O});else{const N=c(g.index,I),x=i(g.index,I),Q=x?.setting?.commaOffset;x&&Q===void 0&&M.push({offset:x.endOffset,length:0,content:","});const W=Q!==void 0&&Q>D.endOffset;M.push({offset:W?Q+1:D.endOffset,length:0,content:N?U+O+",":U+O})}return M}else{if(D.setting)return[{offset:D.startOffset,length:0,content:O+","}];const M=(I[g.index-1]&&!I[g.index-1].setting?U:"")+O+(c(g.index,I)?",":"")+U;return[{offset:D.startOffset,length:0,content:M}]}}function d(s,a){return a.filter(l=>l.setting?.key===s)[0]}function i(s,a){for(let l=s-1;l>=0;l--)if(a[l].setting)return a[l]}function c(s,a){for(let l=s+1;l<a.length;l++)if(a[l].setting)return a[l]}function r(s,a,l){const g=s.indexOf(a),I=s.indexOf(l);return s.filter((_,O)=>g<O&&O<I)}function n(s,a){if(s.length&&a.length){let l=0;for(;l<a.length&&l<s.length;l++)if(s[l].value!==a[l].value)return a[l-1];return a[l-1]}}function o(s){const a=[];let l=-1,g,I;const _={onObjectBegin:O=>{l++},onObjectProperty:(O,U,D)=>{l===0&&(g=U,I=O)},onObjectEnd:(O,U)=>{l--,l===0&&a.push({startOffset:g,endOffset:O+U,value:s.substring(g,O+U),setting:{key:I,commaOffset:void 0}})},onArrayBegin:(O,U)=>{l++},onArrayEnd:(O,U)=>{l--,l===0&&a.push({startOffset:g,endOffset:O+U,value:s.substring(g,O+U),setting:{key:I,commaOffset:void 0}})},onLiteralValue:(O,U,D)=>{l===0&&a.push({startOffset:g,endOffset:U+D,value:s.substring(g,U+D),setting:{key:I,commaOffset:void 0}})},onSeparator:(O,U,D)=>{if(l===0&&O===","){let M=a.length-1;for(;M>=0&&!a[M].setting;M--);const N=a[M];N&&a.splice(M,1,{startOffset:N.startOffset,endOffset:N.endOffset,value:N.value,setting:{key:N.setting.key,commaOffset:U}})}},onComment:(O,U)=>{l===0&&a.push({startOffset:O,endOffset:O+U,value:s.substring(O,O+U)})}};return(0,t.visit)(s,_),a}}),define(te[233],ne([0,1,17,3,146,19,90,14,30,15,23,21,32,45,53,232,24]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p,h,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function m(d){return d&&d.settings&&typeof d.settings=="string"&&Object.keys(d).length===1}function w(d){const i=JSON.parse(d);return m(i)?i:{settings:d}}e.parseSettingsSyncContent=w;let y=class extends p.AbstractJsonFileSynchroniser{constructor(i,c,r,n,o,s,a,l,g,I,_,O){super(c.settingsResource,"settings",i,c,r,n,o,g,I,s,a,l,O);this.extensionManagementService=_,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(i){const c=await this.getLastSyncUserData(),r=await this.getLatestRemoteUserData(i,c),n=this.getSettingsSyncContent(r),o=new A.ConfigurationModelParser(v.USER_DATA_SYNC_CONFIGURATION_SCOPE);return n?.settings&&o.parse(n.settings),o.configurationModel.getValue(v.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(i,c,r){const n=await this.getLocalFileContent(),o=await this.getFormattingOptions(),s=this.getSettingsSyncContent(i);c=c===null&&r?i:c;const a=c?this.getSettingsSyncContent(c):null,l=await this.getIgnoredSettings();let g=null,I=!1,_=!1,O=!1;if(s){let D=n?n.value.toString().trim():"{}";D=D||"{}",this.validateContent(D),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const M=(0,u.merge)(D,s.settings,a?a.settings:null,l,[],o);g=M.localContent||M.remoteContent,I=M.localContent!==null,_=M.remoteContent!==null,O=M.hasConflicts}else n&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),g=n.value.toString(),_=!0);const U={content:g,localChange:I?2:0,remoteChange:_?2:0,hasConflicts:O};return[{fileContent:n,localResource:this.localResource,localContent:n?n.value.toString():null,localChange:U.localChange,remoteResource:this.remoteResource,remoteContent:s?s.settings:null,remoteChange:U.remoteChange,previewResource:this.previewResource,previewResult:U,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(i){const c=this.getSettingsSyncContent(i);if(c===null)return!0;const r=await this.getLocalFileContent(),n=r?r.value.toString().trim():"",o=await this.getIgnoredSettings(),s=await this.getFormattingOptions();return(0,u.merge)(n||"{}",c.settings,c.settings,o,[],s).remoteContent!==null}async getMergeResult(i,c){const r=await this.getFormattingOptions(),n=await this.getIgnoredSettings();return{...i.previewResult,content:i.previewResult.content?(0,u.updateIgnoredSettings)(i.previewResult.content,"{}",n,r):null}}async getAcceptResult(i,c,r,n){const o=await this.getFormattingOptions(),s=await this.getIgnoredSettings();if(this.extUri.isEqual(c,this.localResource))return{content:i.fileContent?(0,u.updateIgnoredSettings)(i.fileContent.value.toString(),"{}",s,o):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(c,this.remoteResource))return{content:i.remoteContent!==null?(0,u.updateIgnoredSettings)(i.remoteContent,i.fileContent?i.fileContent.value.toString():"{}",s,o):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(c,this.previewResource))return r===void 0?{content:i.previewResult.content,localChange:i.previewResult.localChange,remoteChange:i.previewResult.remoteChange}:{content:r!==null?(0,u.updateIgnoredSettings)(r,i.fileContent?i.fileContent.value.toString():"{}",s,o):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${c.toString()}`)}async applyResult(i,c,r,n){const{fileContent:o}=r[0][0];let{content:s,localChange:a,remoteChange:l}=r[0][1];if(a===0&&l===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),s=s?s.trim():"{}",s=s||"{}",this.validateContent(s),a!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),o&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(o.value.toString()))),await this.updateLocalFileContent(s,o,n),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),l!==0){const g=await this.getFormattingOptions(),I=this.getSettingsSyncContent(i),_=await this.getIgnoredSettings(s);s=(0,u.updateIgnoredSettings)(s,I?I.settings:"{}",_,g),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),i=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(s)),n?null:i.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}c?.ref!==i.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(i),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const i=await this.getLocalFileContent();if(i){const c=await this.getFormattingOptions(),r=(0,h.edit)(i.value.toString(),[v.CONFIGURATION_SYNC_STORE_KEY],void 0,c);return!(0,u.isEmpty)(r)}}catch(i){if(i.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:i}){const c=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(i,"settings.json"),comparableResource:c}]}async resolveContent(i){if(this.extUri.isEqual(this.remoteResource,i)||this.extUri.isEqual(this.localResource,i)||this.extUri.isEqual(this.acceptedResource,i))return this.resolvePreviewContent(i);let c=await super.resolveContent(i);if(c)return c;if(c=await super.resolveContent(this.extUri.dirname(i)),c){const r=this.parseSyncData(c);if(r){const n=this.parseSettingsSyncContent(r.content);if(n)switch(this.extUri.basename(i)){case"settings.json":return n.settings}}}return null}async resolvePreviewContent(i){let c=await super.resolvePreviewContent(i);if(c){const r=await this.getFormattingOptions(),n=await this.getIgnoredSettings();c=(0,u.updateIgnoredSettings)(c,"{}",n,r)}return c}getSettingsSyncContent(i){return i.syncData?this.parseSettingsSyncContent(i.syncData.content):null}parseSettingsSyncContent(i){try{return w(i)}catch(c){this.logService.error(c)}return null}toSettingsSyncContent(i){return{settings:i}}async getIgnoredSettings(i){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const r=t.Event.any(t.Event.filter(this.extensionManagementService.onDidInstallExtensions,n=>n.some(({local:o})=>!!o)),t.Event.filter(this.extensionManagementService.onDidUninstallExtension,n=>!n.error))(()=>{r.dispose(),this._defaultIgnoredSettings=void 0})}const c=await this._defaultIgnoredSettings;return(0,u.getIgnoredSettings)(c,this.configurationService,i)}validateContent(i){if(this.hasErrors(i))throw new v.UserDataSyncError((0,L.localize)(0,null),"LocalInvalidContent",this.resource)}};y=he([G(0,C.IFileService),G(1,R.IEnvironmentService),G(2,P.IStorageService),G(3,v.IUserDataSyncStoreService),G(4,v.IUserDataSyncBackupStoreService),G(5,v.IUserDataSyncLogService),G(6,v.IUserDataSyncUtilService),G(7,T.IConfigurationService),G(8,v.IUserDataSyncEnablementService),G(9,E.ITelemetryService),G(10,b.IExtensionManagementService),G(11,f.IUriIdentityService)],y),e.SettingsSynchroniser=y;let S=class extends p.AbstractInitializer{constructor(i,c,r,n){super("settings",c,r,i,n)}async doInitialize(i){const c=i.syncData?this.parseSettingsSyncContent(i.syncData.content):null;if(!c){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,k.VSBuffer.fromString(c.settings)),await this.updateLastSyncUserData(i)}async isEmpty(){try{const i=await this.fileService.readFile(this.environmentService.settingsResource);return(0,u.isEmpty)(i.value.toString().trim())}catch(i){return i.fileOperationResult===1}}parseSettingsSyncContent(i){try{return w(i)}catch(c){this.logService.error(c)}return null}};S=he([G(0,C.IFileService),G(1,R.IEnvironmentService),G(2,v.IUserDataSyncLogService),G(3,f.IUriIdentityService)],S),e.SettingsInitializer=S}),define(te[234],ne([0,1,17,3,28,19,14,15,23,21,32,45,227,24]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let h=class extends E.AbstractSynchroniser{constructor(m,w,y,S,d,i,c,r,n,o){super("snippets",w,m,y,S,d,r,n,i,c,o);this.version=1,this.snippetsFolder=m.snippetsHome,this._register(this.fileService.watch(m.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(t.Event.filter(this.fileService.onDidFilesChange,s=>s.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(m,w,y){const S=await this.getSnippetsFileContents(),d=this.toSnippetsContents(S),i=m.syncData?this.parseSnippets(m.syncData):null;w=w===null&&y?m:w;const c=w&&w.syncData?this.parseSnippets(w.syncData):null;i?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const r=(0,f.merge)(d,i,c);return this.getResourcePreviews(r,S,i||{})}async hasRemoteChanged(m){const w=m.syncData?this.parseSnippets(m.syncData):null;if(w===null)return!0;const y=await this.getSnippetsFileContents(),S=this.toSnippetsContents(y),d=(0,f.merge)(S,w,w);return Object.keys(d.remote.added).length>0||Object.keys(d.remote.updated).length>0||d.remote.removed.length>0||d.conflicts.length>0}async getMergeResult(m,w){return m.previewResult}async getAcceptResult(m,w,y,S){if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:m.fileContent?m.fileContent.value.toString():null,localChange:0,remoteChange:m.fileContent?m.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:m.remoteContent,localChange:m.remoteContent!==null?m.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder))return y===void 0?{content:m.previewResult.content,localChange:m.previewResult.localChange,remoteChange:m.previewResult.remoteChange}:{content:y,localChange:y===null?m.fileContent!==null?3:0:2,remoteChange:y===null?m.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${w.toString()}`)}async applyResult(m,w,y,S){const d=y.map(([i,c])=>({...i,acceptResult:c}));d.every(({localChange:i,remoteChange:c})=>i===0&&c===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),d.some(({localChange:i})=>i!==0)&&(await this.updateLocalBackup(d),await this.updateLocalSnippets(d,S)),d.some(({remoteChange:i})=>i!==0)&&(m=await this.updateRemoteSnippets(d,m,S)),w?.ref!==m.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(m),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:i}of d)try{await this.fileService.del(i)}catch{}}getResourcePreviews(m,w,y){const S=new Map;for(const d of Object.keys(m.local.added)){const i={content:m.local.added[d],hasConflicts:!1,localChange:1,remoteChange:0};S.set(d,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,d).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,d).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[d],previewResource:this.extUri.joinPath(this.syncPreviewFolder,d),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,d).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const d of Object.keys(m.local.updated)){const i={content:m.local.updated[d],hasConflicts:!1,localChange:2,remoteChange:0};S.set(d,{localResource:this.extUri.joinPath(this.syncPreviewFolder,d).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[d],localContent:w[d].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,d).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[d],previewResource:this.extUri.joinPath(this.syncPreviewFolder,d),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,d).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const d of m.local.removed){const i={content:null,hasConflicts:!1,localChange:3,remoteChange:0};S.set(d,{localResource:this.extUri.joinPath(this.syncPreviewFolder,d).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[d],localContent:w[d].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,d).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,d),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,d).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const d of Object.keys(m.remote.added)){const i={content:m.remote.added[d],hasConflicts:!1,localChange:0,remoteChange:1};S.set(d,{localResource:this.extUri.joinPath(this.syncPreviewFolder,d).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[d],localContent:w[d].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,d).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,d),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,d).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const d of Object.keys(m.remote.updated)){const i={content:m.remote.updated[d],hasConflicts:!1,localChange:0,remoteChange:2};S.set(d,{localResource:this.extUri.joinPath(this.syncPreviewFolder,d).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[d],localContent:w[d].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,d).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[d],previewResource:this.extUri.joinPath(this.syncPreviewFolder,d),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,d).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const d of m.remote.removed){const i={content:null,hasConflicts:!1,localChange:0,remoteChange:3};S.set(d,{localResource:this.extUri.joinPath(this.syncPreviewFolder,d).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,d).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[d],previewResource:this.extUri.joinPath(this.syncPreviewFolder,d),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,d).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const d of m.conflicts){const i={content:w[d]?w[d].value.toString():null,hasConflicts:!0,localChange:w[d]?2:1,remoteChange:y[d]?2:1};S.set(d,{localResource:this.extUri.joinPath(this.syncPreviewFolder,d).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[d]||null,localContent:w[d]?w[d].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,d).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[d]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,d),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,d).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const d of Object.keys(w))if(!S.has(d)){const i={content:w[d]?w[d].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};S.set(d,{localResource:this.extUri.joinPath(this.syncPreviewFolder,d).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[d]||null,localContent:w[d]?w[d].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,d).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[d]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,d),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,d).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...S.values()]}async getAssociatedResources({uri:m}){let w=await super.resolveContent(m);if(w){const y=this.parseSyncData(w);if(y){const S=this.parseSnippets(y),d=[];for(const i of Object.keys(S)){const c=this.extUri.joinPath(m,i),r=this.extUri.joinPath(this.snippetsFolder,i),n=await this.fileService.exists(r);d.push({resource:c,comparableResource:n?r:this.extUri.joinPath(this.syncPreviewFolder,i).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"})})}return d}}return[]}async resolveContent(m){if(this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(m);let w=await super.resolveContent(m);if(w)return w;if(w=await super.resolveContent(this.extUri.dirname(m)),w){const y=this.parseSyncData(w);if(y)return this.parseSnippets(y)[this.extUri.basename(m)]||null}return null}async hasLocalData(){try{const m=await this.getSnippetsFileContents();if(Object.keys(m).length)return!0}catch{}return!1}async updateLocalBackup(m){const w={};for(const y of m)y.fileContent&&(w[this.extUri.basename(y.localResource)]=y.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(w)))}async updateLocalSnippets(m,w){for(const{fileContent:y,acceptResult:S,localResource:d,remoteResource:i,localChange:c}of m)if(c!==0){const r=i?this.extUri.basename(i):this.extUri.basename(d),n=this.extUri.joinPath(this.snippetsFolder,r);c===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(n)),await this.fileService.del(n),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(n))):c===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(n)),await this.fileService.createFile(n,k.VSBuffer.fromString(S.content),{overwrite:w}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(n))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(n)),await this.fileService.writeFile(n,k.VSBuffer.fromString(S.content),w?void 0:y),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(n)))}}async updateRemoteSnippets(m,w,y){const S=w.syncData?this.parseSnippets(w.syncData):{},d=(0,L.deepClone)(S);for(const{acceptResult:i,localResource:c,remoteResource:r,remoteChange:n}of m)if(n!==0){const o=c?this.extUri.basename(c):this.extUri.basename(r);n===3?delete d[o]:d[o]=i.content}return(0,f.areSame)(S,d)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),w=await this.updateRemoteUserData(JSON.stringify(d),y?null:w.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),w}parseSnippets(m){return JSON.parse(m.content)}toSnippetsContents(m){const w={};for(const y of Object.keys(m))w[y]=m[y].value.toString();return w}async getSnippetsFileContents(){const m={};let w;try{w=await this.fileService.resolve(this.snippetsFolder)}catch(y){if(y instanceof R.FileOperationError&&y.fileOperationResult===1)return m;throw y}for(const y of w.children||[]){const S=y.resource,d=this.extUri.extname(S);if(d===".json"||d===".code-snippets"){const i=this.extUri.relativePath(this.snippetsFolder,S),c=await this.fileService.readFile(S);m[i]=c}}return m}};h=he([G(0,A.IEnvironmentService),G(1,R.IFileService),G(2,b.IStorageService),G(3,p.IUserDataSyncStoreService),G(4,p.IUserDataSyncBackupStoreService),G(5,p.IUserDataSyncLogService),G(6,T.IConfigurationService),G(7,p.IUserDataSyncEnablementService),G(8,C.ITelemetryService),G(9,P.IUriIdentityService)],h),e.SnippetsSynchroniser=h;let u=class extends E.AbstractInitializer{constructor(m,w,y,S){super("snippets",w,y,m,S)}async doInitialize(m){const w=m.syncData?JSON.parse(m.syncData.content):null;if(!w){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const S of Object.keys(w)){const d=w[S];if(d){const i=this.extUri.joinPath(this.environmentService.snippetsHome,S);await this.fileService.createFile(i,k.VSBuffer.fromString(d)),this.logService.info("Created snippet",this.extUri.basename(i))}}await this.updateLastSyncUserData(m)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(m){return m.fileOperationResult===1}}};u=he([G(0,R.IFileService),G(1,A.IEnvironmentService),G(2,p.IUserDataSyncLogService),G(3,P.IUriIdentityService)],u),e.SnippetsInitializer=u}),define(te[235],ne([0,1,17,19,14,15,23,21,32,45,24]),function(K,e,k,t,L,T,A,R,b,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function E(u,v){try{return JSON.parse(u).tasks}catch(m){return v.error(m),null}}e.getTasksContentFromSyncContent=E;let f=class extends C.AbstractFileSynchroniser{constructor(v,m,w,y,S,d,i,c,r,n){super(n.extUri.joinPath(n.extUri.dirname(i.settingsResource),"tasks.json"),"tasks",d,i,c,v,m,S,r,w,y,n);this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"tasks.json"),this.localResource=this.previewResource.with({scheme:P.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:P.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:P.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(v,m,w,y){const S=v.syncData?E(v.syncData.content,this.logService):null;m=m===null&&w?v:m;const d=m?.syncData?E(m.syncData.content,this.logService):null,i=await this.getLocalFileContent();let c=null,r=!1,n=!1,o=!1;if(S){const a=i?i.value.toString():null;if(!d||d!==a||d!==S){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote tasks with local tasks...`);const l=h(a,S,d);c=l.content,o=l.hasConflicts,r=l.hasLocalChanged,n=l.hasRemoteChanged}}else i&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote tasks does not exist. Synchronizing tasks for the first time.`),c=i.value.toString(),n=!0);const s={content:c,localChange:r?i?2:1:0,remoteChange:n?2:0,hasConflicts:o};return[{fileContent:i,localResource:this.localResource,localContent:i?i.value.toString():null,localChange:s.localChange,remoteResource:this.remoteResource,remoteContent:S,remoteChange:s.remoteChange,previewResource:this.previewResource,previewResult:s,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(v){const m=v?.syncData?E(v.syncData.content,this.logService):null;if(m===null)return!0;const w=await this.getLocalFileContent(),y=w?w.value.toString():null,S=h(y,m,m);return S.hasLocalChanged||S.hasRemoteChanged}async getMergeResult(v,m){return v.previewResult}async getAcceptResult(v,m,w,y){if(this.extUri.isEqual(m,this.localResource))return{content:v.fileContent?v.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(m,this.remoteResource))return{content:v.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(m,this.previewResource))return w===void 0?{content:v.previewResult.content,localChange:v.previewResult.localChange,remoteChange:v.previewResult.remoteChange}:{content:w,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${m.toString()}`)}async applyResult(v,m,w,y){const{fileContent:S}=w[0][0];let{content:d,localChange:i,remoteChange:c}=w[0][1];if(i===0&&c===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing tasks.`),i!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local tasks...`),S&&await this.backupLocal(JSON.stringify(this.toTasksSyncContent(S.value.toString()))),await this.updateLocalFileContent(d||"{}",S,y),this.logService.info(`${this.syncResourceLogLabel}: Updated local tasks`)),c!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote tasks...`);const r=JSON.stringify(this.toTasksSyncContent(d||"{}"));v=await this.updateRemoteUserData(r,y?null:v.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote tasks`)}try{await this.fileService.del(this.previewResource)}catch{}m?.ref!==v.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized tasks...`),await this.updateLastSyncUserData(v),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized tasks`))}async hasLocalData(){return this.fileService.exists(this.file)}async getAssociatedResources({uri:v}){const m=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(v,"tasks.json"),comparableResource:m}]}async resolveContent(v){if(this.extUri.isEqual(this.remoteResource,v)||this.extUri.isEqual(this.localResource,v)||this.extUri.isEqual(this.acceptedResource,v))return this.resolvePreviewContent(v);let m=await super.resolveContent(v);if(m)return m;if(m=await super.resolveContent(this.extUri.dirname(v)),m){const w=this.parseSyncData(m);if(w)switch(this.extUri.basename(v)){case"tasks.json":return E(w.content,this.logService)}}return null}toTasksSyncContent(v){return{tasks:v}}};f=he([G(0,P.IUserDataSyncStoreService),G(1,P.IUserDataSyncBackupStoreService),G(2,P.IUserDataSyncLogService),G(3,t.IConfigurationService),G(4,P.IUserDataSyncEnablementService),G(5,T.IFileService),G(6,L.IEnvironmentService),G(7,A.IStorageService),G(8,R.ITelemetryService),G(9,b.IUriIdentityService)],f),e.TasksSynchroniser=f;let p=class extends C.AbstractInitializer{constructor(v,m,w,y){super("tasks",m,w,v,y);this.uriIdentityService=y,this.tasksResource=this.uriIdentityService.extUri.joinPath(this.uriIdentityService.extUri.dirname(this.environmentService.settingsResource),"tasks.json")}async doInitialize(v){const m=v.syncData?E(v.syncData.content,this.logService):null;if(!m){this.logService.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing tasks because local tasks exist.");return}await this.fileService.writeFile(this.tasksResource,k.VSBuffer.fromString(m)),await this.updateLastSyncUserData(v)}async isEmpty(){return this.fileService.exists(this.tasksResource)}};p=he([G(0,T.IFileService),G(1,L.IEnvironmentService),G(2,P.IUserDataSyncLogService),G(3,b.IUriIdentityService)],p),e.TasksInitializer=p;function h(u,v,m){if(u===null&&v===null&&m===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(u===v)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const w=m!==u,y=m!==v;return!w&&!y?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:w&&!y?{content:u,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:y&&!w?{content:v,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:u,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(te[65],ne([0,1,3,2,6,24]),function(K,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,L.createDecorator)("IUserDataSyncAccountService");let A=class extends t.Disposable{constructor(b,C){super();this.userDataSyncStoreService=b,this.logService=C,this._onDidChangeAccount=this._register(new k.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new k.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(b.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(b.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(b){(b&&this._account?b.token!==this._account.token||b.authenticationProviderId!==this._account.authenticationProviderId:b!==this._account)&&(this._account=b,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(b))}};A=he([G(0,T.IUserDataSyncStoreService),G(1,T.IUserDataSyncLogService)],A),e.UserDataSyncAccountService=A}),define(te[236],ne([0,1,5,17,57,2,20,19,14,15,24]),function(K,e,k,t,L,T,A,R,b,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let E=class extends T.Disposable{constructor(p,h,u,v){super();this.environmentService=p,this.fileService=h,this.configurationService=u,this.logService=v,P.ALL_SYNC_RESOURCES.forEach(m=>this.cleanUpBackup(m))}async getAllRefs(p){const h=(0,A.joinPath)(this.environmentService.userDataSyncHome,p),u=await this.fileService.resolve(h);return u.children?u.children.filter(m=>m.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(m.name)).sort().reverse().map(m=>({ref:m.name,created:this.getCreationTime(m)})):[]}async resolveContent(p,h){if(!h){const u=await this.getAllRefs(p);u.length&&(h=u[u.length-1].ref)}if(h){const u=(0,A.joinPath)(this.environmentService.userDataSyncHome,p,h);return(await this.fileService.readFile(u)).value.toString()}return null}async backup(p,h){const u=(0,A.joinPath)(this.environmentService.userDataSyncHome,p),v=(0,A.joinPath)(u,`${(0,L.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(v,t.VSBuffer.fromString(h))}catch(m){this.logService.error(m)}try{this.cleanUpBackup(p)}catch{}}async cleanUpBackup(p){const h=(0,A.joinPath)(this.environmentService.userDataSyncHome,p);try{try{if(!await this.fileService.exists(h))return}catch{return}const u=await this.fileService.resolve(h);if(u.children){const v=u.children.filter(S=>S.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(S.name)).sort(),m=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let w=v.filter(S=>Date.now()-this.getCreationTime(S)>m);const y=v.length-w.length;y<10&&(w=w.slice(10-y)),await k.Promises.settled(w.map(async S=>{this.logService.info("Deleting from backup",S.resource.path),await this.fileService.del(S.resource)}))}}catch(u){this.logService.error(u)}}getCreationTime(p){return p.ctime||new Date(parseInt(p.name.substring(0,4)),parseInt(p.name.substring(4,6))-1,parseInt(p.name.substring(6,8)),parseInt(p.name.substring(9,11)),parseInt(p.name.substring(11,13)),parseInt(p.name.substring(13,15))).getTime()}};E=he([G(0,b.IEnvironmentService),G(1,C.IFileService),G(2,R.IConfigurationService),G(3,P.IUserDataSyncLogService)],E),e.UserDataSyncBackupStoreService=E}),define(te[237],ne([0,1,3,2,4,14,23,21,24]),function(K,e,k,t,L,T,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const C="sync.enable";let P=class extends t.Disposable{constructor(f,p,h,u){super();this.storageService=f,this.telemetryService=p,this.environmentService=h,this.userDataSyncStoreManagementService=u,this._onDidChangeEnablement=new k.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new k.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(f.onDidChangeValue(v=>this.onDidStorageChange(v)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(C,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(f){f&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(C,{enabled:f}),this.storageService.store(C,f,0,1))}isResourceEnabled(f){return this.storageService.getBoolean((0,b.getEnablementKey)(f),0,!0)}setResourceEnablement(f,p){if(this.isResourceEnabled(f)!==p){const h=(0,b.getEnablementKey)(f);this.storeResourceEnablement(h,p)}}getResourceSyncStateVersion(f){}storeResourceEnablement(f,p){this.storageService.store(f,p,0,L.isWeb?0:1)}onDidStorageChange(f){if(f.scope!==0)return;if(C===f.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const p=b.ALL_SYNC_RESOURCES.filter(h=>(0,b.getEnablementKey)(h)===f.key)[0];if(p){this._onDidChangeResourceEnablement.fire([p,this.isResourceEnabled(p)]);return}}};P=he([G(0,A.IStorageService),G(1,R.ITelemetryService),G(2,T.IEnvironmentService),G(3,b.IUserDataSyncStoreManagementService)],P),e.UserDataSyncEnablementService=P}),define(te[238],ne([0,1,2,7]),function(K,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class L{constructor(f){this.service=f}listen(f,p){switch(p){case"onError":return this.service.onError}throw new Error(`Event not found: ${p}`)}call(f,p,h){switch(p){case"triggerSync":return this.service.triggerSync(h[0],h[1],h[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(h[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=L;class T{constructor(f){this.service=f}listen(f,p){throw new Error(`Event not found: ${p}`)}call(f,p,h){switch(p){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(h[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(t.URI.revive(h[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=T;class A{constructor(f){this.channel=f}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(f){return this.channel.call("resolveUserKeybindings",[f])}async resolveFormattingOptions(f){return this.channel.call("resolveFormattingOptions",[f])}}e.UserDataSyncUtilServiceClient=A;class R{constructor(f){this.service=f}listen(f,p){switch(p){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${p}`)}async call(f,p,h){switch(p){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(h[0],h[1]);case"setEnablements":return this.service.setEnablements(h)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=R;class b{constructor(f){this.service=f}listen(f,p){switch(p){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${p}`)}call(f,p,h){switch(p){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(h)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=b;class C{constructor(f){this.service=f}listen(f,p){switch(p){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${p}`)}call(f,p,h){switch(p){case"switch":return this.service.switch(h[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=C;class P extends k.Disposable{constructor(f){super();this.channel=f,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(f){return this.channel.call("switch",[f])}async getPreviousUserDataSyncStore(){const f=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(f)}revive(f){return{url:t.URI.revive(f.url),type:f.type,defaultUrl:t.URI.revive(f.defaultUrl),insidersUrl:t.URI.revive(f.insidersUrl),stableUrl:t.URI.revive(f.stableUrl),canSwitch:f.canSwitch,authenticationProviders:f.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=P}),define(te[239],ne([0,1,14,8]),function(K,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let L=class extends t.AbstractLogger{constructor(A,R){super();this.logger=this._register(A.createLogger(R.userDataSyncLogResource,{name:"settingssync"}))}trace(A,...R){this.logger.trace(A,...R)}debug(A,...R){this.logger.debug(A,...R)}info(A,...R){this.logger.info(A,...R)}warn(A,...R){this.logger.warn(A,...R)}error(A,...R){this.logger.error(A,...R)}critical(A,...R){this.logger.critical(A,...R)}flush(){this.logger.flush()}};L=he([G(0,t.ILoggerService),G(1,k.IEnvironmentService)],L),e.UserDataSyncLogService=L}),define(te[66],ne([0,1,3,2,4,26,149,14,15,6,27,47,23,24]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,C.createDecorator)("IUserDataSyncMachinesService");const h="sync.currentMachineName",u="Safari",v="Chrome",m="Edge",w="Firefox",y="Android";function S(c){switch(c){case u:case v:case m:case w:case y:case(0,L.PlatformToString)(0):return!0}return!1}e.isWebPlatform=S;function d(){return L.isSafari?u:L.isChrome?v:L.isEdge?m:L.isFirefox?w:L.isAndroid?y:(0,L.PlatformToString)(L.isWeb?0:L.platform)}let i=class Ze extends t.Disposable{constructor(r,n,o,s,a,l){super();this.storageService=o,this.userDataSyncStoreService=s,this.logService=a,this.productService=l,this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,E.getServiceMachineId)(r,n,o)}async getMachines(r){const n=await this.currentMachineIdPromise;return(await this.readMachinesData(r)).machines.map(s=>({...s,isCurrent:s.id===n}))}async addCurrentMachine(r){const n=await this.currentMachineIdPromise,o=await this.readMachinesData(r);o.machines.some(({id:s})=>s===n)||(o.machines.push({id:n,name:this.computeCurrentMachineName(o.machines),platform:d()}),await this.writeMachinesData(o))}async removeCurrentMachine(r){const n=await this.currentMachineIdPromise,o=await this.readMachinesData(r),s=o.machines.filter(({id:a})=>a!==n);s.length!==o.machines.length&&(o.machines=s,await this.writeMachinesData(o))}async renameMachine(r,n,o){const s=await this.readMachinesData(o),a=s.machines.find(({id:l})=>l===r);if(a){a.name=n,await this.writeMachinesData(s);const l=await this.currentMachineIdPromise;r===l&&this.storageService.store(h,n,0,1)}}async setEnablements(r){const n=await this.readMachinesData();for(const[o,s]of r){const a=n.machines.find(l=>l.id===o);a&&(a.disabled=s?void 0:!0)}await this.writeMachinesData(n)}computeCurrentMachineName(r){const n=this.storageService.get(h,0);if(n)return n;const o=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${d()} (${this.productService.nameShort})`,s=new RegExp(`${(0,T.escapeRegExpCharacters)(o)}\\s#(\\d+)`);let a=0;for(const l of r){const g=s.exec(l.name),I=g?parseInt(g[1]):0;a=I>a?I:a}return`${o} #${a+1}`}async readMachinesData(r){this.userData=await this.readUserData(r);const n=this.parse(this.userData);if(n.version!==Ze.VERSION)throw new Error((0,A.localize)(0,null,this.productService.nameLong));return n}async writeMachinesData(r){const n=JSON.stringify(r),o=await this.userDataSyncStoreService.write(Ze.RESOURCE,n,this.userData?.ref||null);this.userData={ref:o,content:n},this._onDidChange.fire()}async readUserData(r){if(this.userData){const n=r&&r.latest?r.latest[Ze.RESOURCE]:void 0;if(this.userData.ref===n)return this.userData;if(n===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(Ze.RESOURCE,this.userData)}parse(r){if(r.content!==null)try{return JSON.parse(r.content)}catch(n){this.logService.error(n)}return{version:Ze.VERSION,machines:[]}}};i.VERSION=1,i.RESOURCE="machines",i=he([G(0,R.IEnvironmentService),G(1,b.IFileService),G(2,f.IStorageService),G(3,p.IUserDataSyncStoreService),G(4,p.IUserDataSyncLogService),G(5,P.IProductService)],i),e.UserDataSyncMachinesService=i}),define(te[240],ne([0,1,5,57,37,9,3,2,4,20,7,147,27,23,21,24,65,66]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p,h,u,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const w="sync.disableMachineEventually",y="sync.sessionId",S="sync.storeUrl",d="sync.productQuality";let i=class extends R.Disposable{constructor(n,o,s,a,l,g,I,_,O,U){super();this.userDataSyncStoreManagementService=o,this.userDataSyncStoreService=s,this.userDataSyncEnablementService=a,this.userDataSyncService=l,this.logService=g,this.userDataSyncAccountService=I,this.telemetryService=_,this.userDataSyncMachinesService=O,this.storageService=U,this.autoSync=this._register(new R.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new A.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new k.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=o.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=n.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(o.onDidChangeUserDataSyncStore(()=>{(0,C.isEqual)(this.syncUrl,o.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=o.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(I.onDidChangeAccount(()=>this.updateAutoSync())),this._register(s.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(l.onDidChangeLocal(D=>this.triggerSync([D],!1,!1))),this._register(A.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,D])=>D)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const n=this.storageService.get(S,0);return n?P.URI.parse(n):void 0}set syncUrl(n){n?this.storageService.store(S,n.toString(),0,1):this.storageService.remove(S,0)}get productQuality(){return this.storageService.get(d,0)}set productQuality(n){n?this.storageService.store(d,n,0,1):this.storageService.remove(d,0)}updateAutoSync(){const{enabled:n,message:o}=this.isAutoSyncEnabled();n?this.autoSync.value===void 0&&(this.autoSync.value=new c(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(s=>this.onDidFinishSync(s))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(o&&this.logService.info(o),this.autoSync.clear()):o&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(o))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,t.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(n,o,s){try{this.userDataSyncAccountService.account&&!s&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(y,0),n?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(a){if(o)this.logService.error(a),this.updateEnablement(!1);else throw a}}updateEnablement(n){this.userDataSyncEnablementService.isEnabled()!==n&&(this.userDataSyncEnablementService.setEnablement(n),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(n){if(!n){this.successiveFailures=0;return}const o=u.UserDataSyncError.toUserDataSyncError(n);o instanceof u.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:o.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),o.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):o.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):o.code==="LocalTooManyRequests"?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):o.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):o.code==="UpgradeRequired"||o.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):o.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${o.resource} content with newer version than of client. Requires client upgrade.`)):o.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${o.resource} content with older version than of client. Requires server reset.`)):o.code==="ServiceChanged"||o.code==="DefaultServiceChanged"?b.isWeb&&o.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(o),this.successiveFailures++),this._onError.fire(o)}async disableMachineEventually(){this.storageService.store(w,!0,0,1),await(0,k.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(w,0,!1)}stopDisableMachineEventually(){this.storageService.remove(w,0)}async triggerSync(n,o,s){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(o&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...n),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",s)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};i=he([G(0,f.IProductService),G(1,u.IUserDataSyncStoreManagementService),G(2,u.IUserDataSyncStoreService),G(3,u.IUserDataSyncEnablementService),G(4,u.IUserDataSyncService),G(5,u.IUserDataSyncLogService),G(6,v.IUserDataSyncAccountService),G(7,h.ITelemetryService),G(8,m.IUserDataSyncMachinesService),G(9,p.IStorageService)],i),e.UserDataAutoSyncService=i;class c extends R.Disposable{constructor(n,o,s,a,l,g,I,_){super();this.lastSyncUrl=n,this.interval=o,this.userDataSyncStoreManagementService=s,this.userDataSyncStoreService=a,this.userDataSyncService=l,this.userDataSyncMachinesService=g,this.logService=I,this.storageService=_,this.intervalHandler=this._register(new R.MutableDisposable),this._onDidStartSync=this._register(new A.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new A.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,R.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(c.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,k.disposableTimeout)(()=>this.sync(c.INTERVAL_SYNCING,!1),this.interval)}sync(n,o){const s=(0,k.createCancelablePromise)(async a=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(l){if((0,T.isCancellationError)(l))return}return this.doSync(n,o,a)});return this.syncPromise=s,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,C.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const n=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),o=this.userDataSyncStoreManagementService.userDataSyncStore;return!!o&&!!n&&(!(0,C.isEqual)(o.defaultUrl,n.defaultUrl)||!(0,C.isEqual)(o.insidersUrl,n.insidersUrl)||!(0,C.isEqual)(o.stableUrl,n.stableUrl))}async doSync(n,o,s){this.logService.info(`Auto Sync: Triggered by ${n}`),this._onDidStartSync.fire();let a;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,o),s.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new u.UserDataAutoSyncError((0,E.localize)(0,null),"DefaultServiceChanged"):new u.UserDataAutoSyncError((0,E.localize)(1,null),"ServiceChanged"):new u.UserDataAutoSyncError((0,E.localize)(2,null),"TurnedOff");const l=this.storageService.get(y,0);if(l&&this.manifest&&l!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new u.UserDataAutoSyncError((0,E.localize)(3,null),"DefaultServiceChanged"):new u.UserDataAutoSyncError((0,E.localize)(4,null),"ServiceChanged"):new u.UserDataAutoSyncError((0,E.localize)(5,null),"SessionExpired");const g=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(s.isCancellationRequested)return;const I=g.find(_=>_.isCurrent);if(I?.disabled)throw new u.UserDataAutoSyncError((0,E.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(_){throw new u.UserDataAutoSyncError((0,L.toErrorMessage)(_),_ instanceof u.UserDataSyncError?_.code:"Unknown")}if(this.manifest&&this.manifest.session!==l&&this.storageService.store(y,this.manifest.session,0,1),s.isCancellationRequested)return;I||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(l){this.logService.error(l),a=l}this._onDidFinishSync.fire(a)}register(n){return super._register(n)}}c.INTERVAL_SYNCING="Interval"}),define(te[241],ne([0,1,16,5,37,3,2,20,11,29,19,30,6,23,21,228,230,231,233,234,235,24]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p,h,u,v,m,w,y,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const i="sync.lastSyncTime";let c=class extends A.Disposable{constructor(a,l,g,I,_,O,U,D){super();this.userDataSyncStoreService=a,this.userDataSyncStoreManagementService=l,this.instantiationService=g,this.configurationService=I,this.logService=_,this.telemetryService=O,this.storageService=U,this.userDataSyncEnablementService=D,this._status="uninitialized",this._onDidChangeStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new T.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new T.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new T.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new T.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new T.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.synchronizers=this._register(new A.MutableDisposable),this.updateStatus([]),this._lastSyncTime=this.storageService.getNumber(i,0,void 0)}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(a,l){this.checkEnablement();const g=(0,C.generateUuid)();try{const D=(0,d.createSyncHeaders)(g);l&&(D["Cache-Control"]="no-cache"),a=await this.userDataSyncStoreService.manifest(a,D)}catch(D){const M=d.UserDataSyncError.toUserDataSyncError(D);throw this.reportUserDataSyncError(M,g),M}let I=!1;const _=this,O=this.getEnabledSynchronizers();let U;return{manifest:a,async run(){if(I)throw new Error("Can run a task only once");return U=(0,t.createCancelablePromise)(D=>_.sync(O,a,g,D)),U.finally(()=>U=void 0)},async stop(){if(U&&U.cancel(),_.status!=="idle")return _.stop(O)}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new d.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");const a=(0,C.generateUuid)(),l=(0,d.createSyncHeaders)(a);let g;try{g=await this.userDataSyncStoreService.manifest(null,l)}catch(O){const U=d.UserDataSyncError.toUserDataSyncError(O);throw this.reportUserDataSyncError(U,a),U}await this.resetLocal();const I=this.getEnabledSynchronizers(),_=async()=>{await this.stop(I),await this.resetLocal()};return new r(a,g,l,I,_,this.configurationService,this.logService)}async sync(a,l,g,I){if(I.isCancellationRequested||!a.length)return;const _=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const O=(0,d.createSyncHeaders)(g);for(const U of a){if(I.isCancellationRequested||!this.userDataSyncEnablementService.isResourceEnabled(U.resource))return;try{await U.sync(l,O)}catch(D){let M=!1;if(D instanceof d.UserDataSyncError)switch(D.code){case"TooLarge":D=new d.UserDataSyncError(D.message,D.code,U.resource),M=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":M=!0;break}const N=d.UserDataSyncError.toUserDataSyncError(D);if(this.reportUserDataSyncError(N,g),M)throw N;this.logService.error(D),this.logService.error(`${U.resource}: ${(0,L.toErrorMessage)(D)}`),this._syncErrors.push([U.resource,N])}}this.logService.info(`Sync done. Took ${new Date().getTime()-_}ms`),this.updateLastSyncTime()}catch(O){const U=d.UserDataSyncError.toUserDataSyncError(O);throw this.reportUserDataSyncError(U,g),U}finally{this.updateStatus(a),this._onSyncErrors.fire(this._syncErrors)}}async stop(a){if(this.status!=="idle")for(const l of a)try{l.status!=="idle"&&await l.stop()}catch(g){this.logService.error(g)}}async replace(a){this.checkEnablement(),await this.performSynchronizerAction(async l=>{if(await l.replace(a))return!0})}async accept(a,l,g,I){this.checkEnablement(),await this.performSynchronizerAction(async _=>{if(_.resource===a)return await _.accept(l,g),I&&await _.apply(!1,(0,d.createSyncHeaders)((0,C.generateUuid)())),!0})}async resolveContent(a){return this.performSynchronizerAction(async l=>{const g=await l.resolveContent(a);if(g)return g})}async getRemoteSyncResourceHandles(a){return await this.performSynchronizerAction(async g=>{if(g.resource===a)return g.getRemoteSyncResourceHandles()})||[]}async getLocalSyncResourceHandles(a){return await this.performSynchronizerAction(async g=>{if(g.resource===a)return g.getLocalSyncResourceHandles()})||[]}async getAssociatedResources(a,l){return await this.performSynchronizerAction(async I=>{if(I.resource===a)return I.getAssociatedResources(l)})||[]}async getMachineId(a,l){return await this.performSynchronizerAction(async I=>{if(I.resource===a)return await I.getMachineId(l)||null})||void 0}async hasLocalData(){return!!await this.performSynchronizerAction(async l=>{if(l.resource!=="globalState"&&await l.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performSynchronizerAction(async l=>{if(await l.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(a){this.logService.error(a)}this._onDidResetRemote.fire()}async resetLocal(){if(this.checkEnablement(),this.storageService.remove(i,0),this.synchronizers.value){for(const a of this.synchronizers.value.enabled)try{await a.resetLocal()}catch(l){this.logService.error(`${a.resource}: ${(0,L.toErrorMessage)(l)}`),this.logService.error(l)}this.synchronizers.value=void 0}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async performSynchronizerAction(a){const l=new A.DisposableStore;try{const g=this.synchronizers.value||l.add(this.instantiationService.createInstance(n,()=>{},()=>{},()=>{})),I=[...g.enabled,...g.disabled.map(_=>l.add(g.createSynchronizer(_)))];for(const _ of I){const O=await a(_);if(!(0,b.isUndefined)(O))return O}return null}finally{l.dispose()}}setStatus(a){const l=this._status;this._status!==a&&(this._status=a,this._onDidChangeStatus.fire(a),l==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(a){this.updateConflicts(a);const l=this.computeStatus(a);this.setStatus(l)}updateConflicts(a){const l=this.computeConflicts(a);(0,k.equals)(this._conflicts,l,([g,I],[_,O])=>g===g&&(0,k.equals)(I,O,(U,D)=>(0,R.isEqual)(U.previewResource,D.previewResource)))||(this._conflicts=this.computeConflicts(a),this._onDidChangeConflicts.fire(l))}computeConflicts(a){return a.filter(l=>l.status==="hasConflicts").map(l=>[l.resource,l.conflicts.map(o)])}computeStatus(a){return this.userDataSyncStoreManagementService.userDataSyncStore?a.some(l=>l.status==="hasConflicts")?"hasConflicts":a.some(l=>l.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(i,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(a,l){this.telemetryService.publicLog2("sync/error",{code:a.code,serverCode:a instanceof d.UserDataSyncStoreError?String(a.serverCode):void 0,url:a instanceof d.UserDataSyncStoreError?a.url:void 0,resource:a.resource,executionId:l,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}getEnabledSynchronizers(){return this.synchronizers.value||(this.synchronizers.value=this.instantiationService.createInstance(n,a=>this.updateStatus(a),a=>this.updateConflicts(a),a=>this._onDidChangeLocal.fire(a))),this.synchronizers.value.enabled}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};c=he([G(0,d.IUserDataSyncStoreService),G(1,d.IUserDataSyncStoreManagementService),G(2,f.IInstantiationService),G(3,P.IConfigurationService),G(4,d.IUserDataSyncLogService),G(5,h.ITelemetryService),G(6,p.IStorageService),G(7,d.IUserDataSyncEnablementService)],c),e.UserDataSyncService=c;class r extends A.Disposable{constructor(a,l,g,I,_,O,U){super();this.id=a,this.manifest=l,this.syncHeaders=g,this.synchronisers=I,this.onStop=_,this.configurationService=O,this.logService=U,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new T.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(a=>a.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(a=>a.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,t.createCancelablePromise)(a=>this.getPreviews(a))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(a){throw this.logService.error(a),a}}async accept(a,l){try{return await this.performAction(a,g=>g.accept(a,l))}catch(g){throw this.logService.error(g),g}}async merge(a){try{return a?await this.performAction(a,l=>l.merge(a)):await this.mergeAll()}catch(l){throw this.logService.error(l),l}}async discard(a){try{return await this.performAction(a,l=>l.discard(a))}catch(l){throw this.logService.error(l),l}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const a=[];for(const[,l]of this.previews)for(const g of l.resourcePreviews)g.mergeState==="conflict"&&a.push(g.previewResource);for(const l of a)await this.discard(l);return this.previews}catch(a){throw this.logService.error(a),a}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const a=[];for(const[l,g]of this.previews){this.synchronizingResources.push([l,g.resourcePreviews.map(O=>O.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const I=this.synchronisers.find(O=>O.resource===l);for(const O of g.resourcePreviews)(O.localChange!==0||O.remoteChange!==0)&&O.mergeState==="preview"&&await I.merge(O.previewResource);const _=await I.apply(!1,this.syncHeaders);_&&a.push(this.toSyncResourcePreview(I.resource,_)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(O=>O[0]===l),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=a,this.previews}catch(a){throw this.logService.error(a),a}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[a,l]of this.previews){this.synchronizingResources.push([a,l.resourcePreviews.map(I=>I.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const g=this.synchronisers.find(I=>I.resource===a);for(const I of l.resourcePreviews)await g.accept(I.remoteResource);await g.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(I=>I[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(a){throw this.logService.error(a),a}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[a,l]of this.previews){this.synchronizingResources.push([a,l.resourcePreviews.map(I=>I.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const g=this.synchronisers.find(I=>I.resource===a);for(const I of l.resourcePreviews)await g.accept(I.localResource);await g.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(I=>I[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(a){throw this.logService.error(a),a}}async stop(){await this.onStop(),this.reset()}async performAction(a,l){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const g=this.previews.findIndex(([,x])=>x.resourcePreviews.some(({localResource:Q,previewResource:W,remoteResource:ie})=>(0,R.isEqual)(a,Q)||(0,R.isEqual)(a,W)||(0,R.isEqual)(a,ie)));if(g===-1)return this.previews;const[I,_]=this.previews[g],O=_.resourcePreviews.find(({localResource:x,remoteResource:Q,previewResource:W})=>(0,R.isEqual)(x,a)||(0,R.isEqual)(Q,a)||(0,R.isEqual)(W,a));if(!O)return this.previews;let U=this.synchronizingResources.find(x=>x[0]===I);U||(U=[I,[]],this.synchronizingResources.push(U)),U[1].some(x=>(0,R.isEqual)(x,O.localResource))||(U[1].push(O.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const D=this.synchronisers.find(x=>x.resource===this.previews[g][0]),M=await l(D);M?this.previews.splice(g,1,this.toSyncResourcePreview(D.resource,M)):this.previews.splice(g,1);const N=this.synchronizingResources.findIndex(x=>x[0]===I);return this.synchronizingResources[N][1].splice(U[1].findIndex(x=>(0,R.isEqual)(x,O.localResource)),1),U[1].length||(this.synchronizingResources.splice(N,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const a=[];for(const[l,g]of this.previews){this.synchronizingResources.push([l,g.resourcePreviews.map(O=>O.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const I=this.synchronisers.find(O=>O.resource===l);let _=g;for(const O of g.resourcePreviews)(O.localChange!==0||O.remoteChange!==0)&&O.mergeState==="preview"&&(_=await I.merge(O.previewResource));_&&a.push(this.toSyncResourcePreview(I.resource,_)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(O=>O[0]===l),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=a,this.previews}async getPreviews(a){const l=[],g=await this.getUserDataSyncConfiguration();for(const I of this.synchronisers){if(a.isCancellationRequested)return[];const _=await I.preview(this.manifest,g,this.syncHeaders);_&&l.push(this.toSyncResourcePreview(I.resource,_))}return l}async getUserDataSyncConfiguration(){const a=this.configurationService.getValue(d.USER_DATA_SYNC_CONFIGURATION_SCOPE),l=this.synchronisers.find(g=>g instanceof w.SettingsSynchroniser);if(l){const g=await l.getRemoteUserDataSyncConfiguration(this.manifest);return{...a,...g}}return a}toSyncResourcePreview(a,l){return[a,{isLastSyncFromCurrentMachine:l.isLastSyncFromCurrentMachine,resourcePreviews:l.resourcePreviews.map(o)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}let n=class extends A.Disposable{constructor(a,l,g,I,_,O,U){super();this.onDidChangeStatus=a,this.onDidChangeConflicts=l,this.onDidChangeLocal=g,this.userDataSyncEnablementService=I,this.instantiationService=_,this.extensionGalleryService=O,this.logService=U,this._enabled=[],this._register(I.onDidChangeResourceEnablement(([D,M])=>this.onDidChangeResourceEnablement(D,M))),this._register((0,A.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,D])=>D.dispose())));for(const D of d.ALL_SYNC_RESOURCES)I.isResourceEnabled(D)&&this.registerSynchronizer(D)}get enabled(){return this._enabled.sort((a,l)=>a[1]-l[1]).map(([a])=>a)}get disabled(){return d.ALL_SYNC_RESOURCES.filter(a=>!this.userDataSyncEnablementService.isResourceEnabled(a))}onDidChangeResourceEnablement(a,l){l?this.registerSynchronizer(a):this.deRegisterSynchronizer(a)}registerSynchronizer(a){if(this._enabled.some(([_])=>_.resource===a))return;if(a==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}const l=new A.DisposableStore,g=l.add(this.createSynchronizer(a));l.add(g.onDidChangeStatus(()=>this.onDidChangeStatus(this.enabled))),l.add(g.onDidChangeConflicts(()=>this.onDidChangeConflicts(this.enabled))),l.add(g.onDidChangeLocal(()=>this.onDidChangeLocal(a)));const I=this.getOrder(a);this._enabled.push([g,I,l])}deRegisterSynchronizer(a){const l=this._enabled.findIndex(([g])=>g.resource===a);if(l!==-1){const g=this._enabled.splice(l,1);for(const[I,,_]of g){if(I.status!=="idle"){const O=I.conflicts.length>0;I.stop(),O&&this.onDidChangeConflicts(this.enabled),this.onDidChangeStatus(this.enabled)}_.dispose()}}}createSynchronizer(a){switch(a){case"settings":return this.instantiationService.createInstance(w.SettingsSynchroniser);case"keybindings":return this.instantiationService.createInstance(m.KeybindingsSynchroniser);case"snippets":return this.instantiationService.createInstance(y.SnippetsSynchroniser);case"tasks":return this.instantiationService.createInstance(S.TasksSynchroniser);case"globalState":return this.instantiationService.createInstance(v.GlobalStateSynchroniser);case"extensions":return this.instantiationService.createInstance(u.ExtensionsSynchroniser)}}getOrder(a){switch(a){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5}}};n=he([G(3,d.IUserDataSyncEnablementService),G(4,f.IInstantiationService),G(5,E.IExtensionGalleryService),G(6,d.IUserDataSyncLogService)],n);function o(s){return{localResource:s.localResource,previewResource:s.previewResource,remoteResource:s.remoteResource,acceptedResource:s.acceptedResource,localChange:s.localChange,remoteChange:s.remoteChange,mergeState:s.mergeState}}}),define(te[242],ne([0,1,3,2,11,7,24]),function(K,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class R{constructor(E,f){this.service=E,this.logService=f,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new k.Emitter}listen(E,f){switch(f){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${f}`)}async call(E,f,p){try{return await this._call(E,f,p)}catch(h){throw this.logService.error(h),h}}async _call(E,f,p){switch(f){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(T.URI.revive(p[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(p[0],T.URI.revive(p[1]),p[2],p[3]);case"resolveContent":return this.service.resolveContent(T.URI.revive(p[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(p[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(p[0]);case"getAssociatedResources":return this.service.getAssociatedResources(p[0],{created:p[1].created,uri:T.URI.revive(p[1].uri)});case"getMachineId":return this.service.getMachineId(p[0],{created:p[1].created,uri:T.URI.revive(p[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(f.startsWith("manualSync/")){const h=f.substring("manualSync/".length),u=p[0],v=this.getManualSyncTask(u);switch(p=p.slice(1),h){case"preview":return v.preview();case"accept":return v.accept(T.URI.revive(p[0]),p[1]);case"merge":return v.merge(T.URI.revive(p[0]));case"discard":return v.discard(T.URI.revive(p[0]));case"discardConflicts":return v.discardConflicts();case"apply":return v.apply();case"pull":return v.pull();case"push":return v.push();case"stop":return v.stop();case"_getStatus":return v.status;case"dispose":return this.disposeManualSyncTask(v)}}throw new Error("Invalid call")}getManualSyncTask(E){const f=this.manualSyncTasks.get(this.createKey(E));if(!f)throw new Error(`Manual sync taks not found: ${E}`);return f.manualSyncTask}async createManualSyncTask(){const E=new t.DisposableStore,f=E.add(await this.service.createManualSyncTask());return E.add(f.onSynchronizeResources(p=>this.onManualSynchronizeResources.fire({manualSyncTaskId:f.id,data:p}))),this.manualSyncTasks.set(this.createKey(f.id),{manualSyncTask:f,disposables:E}),{id:f.id,manifest:f.manifest,status:f.status}}disposeManualSyncTask(E){E.dispose();const f=this.createKey(E.id);this.manualSyncTasks.get(f)?.disposables.dispose(),this.manualSyncTasks.delete(f)}createKey(E){return`manualSyncTask-${E}`}}e.UserDataSyncChannel=R;class b extends t.Disposable{constructor(E){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new k.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new k.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(f,p,h){return E.call(f,p,h).then(null,u=>{throw A.UserDataSyncError.toUserDataSyncError(u)})},listen(f,p){return E.listen(f,p)}},this.channel.call("_getInitialData").then(([f,p,h])=>{this.updateStatus(f),this.updateConflicts(p),h&&this.updateLastSyncTime(h),this._register(this.channel.listen("onDidChangeStatus")(u=>this.updateStatus(u))),this._register(this.channel.listen("onDidChangeLastSyncTime")(u=>this.updateLastSyncTime(u)))}),this._register(this.channel.listen("onDidChangeConflicts")(f=>this.updateConflicts(f))),this._register(this.channel.listen("onSyncErrors")(f=>this._onSyncErrors.fire(f.map(([p,h])=>[p,A.UserDataSyncError.toUserDataSyncError(h)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:E,manifest:f,status:p}=await this.channel.call("createManualSyncTask"),h=this,u=new C(E,f,p,{async call(v,m,w){return h.channel.call(`manualSync/${v}`,[E,...(0,L.isArray)(m)?m:[m]],w)},listen(v,m){return k.Event.map(k.Event.filter(h.channel.listen(`manualSync/${v}`,m),w=>!u.isDiposed()&&w.manualSyncTaskId===E),w=>w.data)}});return u}replace(E){return this.channel.call("replace",[E])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(E,f,p,h){return this.channel.call("accept",[E,f,p,h])}resolveContent(E){return this.channel.call("resolveContent",[E])}async getLocalSyncResourceHandles(E){return(await this.channel.call("getLocalSyncResourceHandles",[E])).map(({created:p,uri:h})=>({created:p,uri:T.URI.revive(h)}))}async getRemoteSyncResourceHandles(E){return(await this.channel.call("getRemoteSyncResourceHandles",[E])).map(({created:p,uri:h})=>({created:p,uri:T.URI.revive(h)}))}async getAssociatedResources(E,f){return(await this.channel.call("getAssociatedResources",[E,f])).map(({resource:h,comparableResource:u})=>({resource:T.URI.revive(h),comparableResource:T.URI.revive(u)}))}async getMachineId(E,f){return this.channel.call("getMachineId",[E,f])}async updateStatus(E){this._status=E,this._onDidChangeStatus.fire(E)}async updateConflicts(E){this._conflicts=E.map(([f,p])=>[f,p.map(h=>({...h,localResource:T.URI.revive(h.localResource),remoteResource:T.URI.revive(h.remoteResource),previewResource:T.URI.revive(h.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(E){this._lastSyncTime!==E&&(this._lastSyncTime=E,this._onDidChangeLastSyncTime.fire(E))}}e.UserDataSyncChannelClient=b;class C extends t.Disposable{constructor(E,f,p,h){super();this.id=E,this.manifest=f,this._disposed=!1,this._status=p;const u=this;this.channel={async call(v,m,w){try{const y=await h.call(v,m,w);return u.isDiposed()||(u._status=await h.call("_getStatus")),y}catch(y){throw A.UserDataSyncError.toUserDataSyncError(y)}},listen(v,m){return h.listen(v,m)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const E=await this.channel.call("preview");return this.deserializePreviews(E)}async accept(E,f){const p=await this.channel.call("accept",[E,f]);return this.deserializePreviews(p)}async merge(E){const f=await this.channel.call("merge",[E]);return this.deserializePreviews(f)}async discard(E){const f=await this.channel.call("discard",[E]);return this.deserializePreviews(f)}async discardConflicts(){const E=await this.channel.call("discardConflicts");return this.deserializePreviews(E)}async apply(){const E=await this.channel.call("apply");return this.deserializePreviews(E)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(E){return E.map(([f,p])=>[f,{isLastSyncFromCurrentMachine:p.isLastSyncFromCurrentMachine,resourcePreviews:p.resourcePreviews.map(h=>({...h,localResource:T.URI.revive(h.localResource),remoteResource:T.URI.revive(h.remoteResource),previewResource:T.URI.revive(h.previewResource),acceptedResource:T.URI.revive(h.acceptedResource)}))}])}}}),define(te[243],ne([0,1,5,25,9,3,2,102,4,20,11,7,29,19,14,15,27,43,47,23,24]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p,h,u,v,m,w,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const d="sync.previous.store",i="sync.donot-make-requests-until",c="sync.user-session-id",r="sync.machine-session-id",n=100,o=1e3*60*5;let s=class extends A.Disposable{constructor(O,U,D){super();this.productService=O,this.configurationService=U,this.storageService=D,this._onDidChangeUserDataSyncStore=this._register(new T.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(T.Event.filter(D.onDidChangeValue,M=>M.key===S.SYNC_SERVICE_URL_TYPE&&M.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(S.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(O){this.storageService.store(S.SYNC_SERVICE_URL_TYPE,O,0,b.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[S.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(S.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(O,U){O=b.isWeb&&O?.web?{...O,...O.web}:O;const D={...O||{},...U||{}};if(D&&(0,P.isString)(D.url)&&(0,P.isObject)(D.authenticationProviders)&&Object.keys(D.authenticationProviders).every(M=>(0,P.isArray)(D.authenticationProviders[M].scopes))){const M=D,N=!!M.canSwitch&&!U?.url,x=M.url===M.insidersUrl?"insiders":"stable",Q=(N?this.userDataSyncStoreType:void 0)||x,W=U?.url||(Q==="insiders"?M.insidersUrl:Q==="stable"?M.stableUrl:M.url);return{url:E.URI.parse(W),type:Q,defaultType:x,defaultUrl:E.URI.parse(M.url),stableUrl:E.URI.parse(M.stableUrl),insidersUrl:E.URI.parse(M.insidersUrl),canSwitch:N,authenticationProviders:Object.keys(M.authenticationProviders).reduce((ie,B)=>(ie.push({id:B,scopes:M.authenticationProviders[B].scopes}),ie),[])}}}};s=he([G(0,v.IProductService),G(1,p.IConfigurationService),G(2,y.IStorageService)],s),e.AbstractUserDataSyncStoreManagementService=s;let a=class extends s{constructor(O,U,D){super(O,U,D);const M=this.storageService.get(d,0);M&&(this.previousConfigurationSyncStore=JSON.parse(M));const N=this.productService[S.CONFIGURATION_SYNC_STORE_KEY];N?this.storageService.store(d,JSON.stringify(N),0,1):this.storageService.remove(d,0)}async switch(O){O!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=O,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};a=he([G(0,v.IProductService),G(1,p.IConfigurationService),G(2,y.IStorageService)],a),e.UserDataSyncStoreManagementService=a;let l=class extends A.Disposable{constructor(O,U,D,M,N,x,Q){super();this.requestService=D,this.logService=M,this.storageService=Q,this._onTokenFailed=this._register(new T.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new T.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new T.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(O),this.commonHeadersPromise=(0,w.getServiceMachineId)(N,x,Q).then(W=>{const ie={"X-Client-Name":`${U.applicationName}${b.isWeb?"-web":""}`,"X-Client-Version":U.version};return U.commit&&(ie["X-Client-Commit"]=U.commit),ie}),this.session=new I(n,o,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,A.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(O,U){this.authToken={token:O,type:U}}updateUserDataSyncStoreUrl(O){this.userDataSyncStoreUrl=O?(0,C.joinPath)(O,"v1"):void 0}initDonotMakeRequestsUntil(){const O=this.storageService.getNumber(i,0);O&&Date.now()<O&&this.setDonotMakeRequestsUntil(new Date(O))}setDonotMakeRequestsUntil(O){this._donotMakeRequestsUntil?.getTime()!==O?.getTime()&&(this._donotMakeRequestsUntil=O,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(i,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,k.createCancelablePromise)(U=>(0,k.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),U).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,U=>null)):this.storageService.remove(i,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",O),D={},M=await this.request(U.toString(),{type:"GET",headers:D},[],t.CancellationToken.None);return(await(0,m.asJson)(M)||[]).map(({url:x,created:Q})=>({ref:(0,C.relativePath)(U,U.with({path:x})),created:Q*1e3}))}async resolveContent(O,U){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const D=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",O,U).toString(),M={};M["Cache-Control"]="no-cache";const N=await this.request(D,{type:"GET",headers:M},[],t.CancellationToken.None);return await(0,m.asText)(N)}async delete(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString(),D={};await this.request(U,{type:"DELETE",headers:D},[],t.CancellationToken.None)}async read(O,U,D={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",O,"latest").toString();D={...D},D["Cache-Control"]="no-cache",U&&(D["If-None-Match"]=U.ref);const N=await this.request(M,{type:"GET",headers:D},[304],t.CancellationToken.None);let x=null;if(N.res.statusCode===304&&(x=U),x===null){const Q=N.res.headers.etag;if(!Q)throw new S.UserDataSyncStoreError("Server did not return the ref",M,"NoRef",N.res.statusCode,N.res.headers[S.HEADER_OPERATION_ID]);const W=await(0,m.asText)(N);if(!W&&N.res.statusCode===304)throw new S.UserDataSyncStoreError("Empty response",M,"EmptyResponse",N.res.statusCode,N.res.headers[S.HEADER_OPERATION_ID]);x={ref:Q,content:W}}return x}async write(O,U,D,M={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString();M={...M},M["Content-Type"]=R.Mimes.text,D&&(M["If-Match"]=D);const x=await this.request(N,{type:"POST",data:U,headers:M},[],t.CancellationToken.None),Q=x.res.headers.etag;if(!Q)throw new S.UserDataSyncStoreError("Server did not return the ref",N,"NoRef",x.res.statusCode,x.res.headers[S.HEADER_OPERATION_ID]);return Q}async manifest(O,U={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const D=(0,C.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();U={...U},U["Content-Type"]="application/json",O&&(U["If-None-Match"]=O.ref);const M=await this.request(D,{type:"GET",headers:U},[304],t.CancellationToken.None);let N=null;if(M.res.statusCode===304&&(N=O),!N){const Q=M.res.headers.etag;if(!Q)throw new S.UserDataSyncStoreError("Server did not return the ref",D,"NoRef",M.res.statusCode,M.res.headers[S.HEADER_OPERATION_ID]);const W=await(0,m.asText)(M);if(!W&&M.res.statusCode===304)throw new S.UserDataSyncStoreError("Empty response",D,"EmptyResponse",M.res.statusCode,M.res.headers[S.HEADER_OPERATION_ID]);W&&(N={...JSON.parse(W),ref:Q})}const x=this.storageService.get(c,0);return x&&N&&x!==N.session&&this.clearSession(),N===null&&x&&this.clearSession(),N&&this.storageService.store(c,N.session,0,1),N}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),U={"Content-Type":R.Mimes.text};await this.request(O,{type:"DELETE",headers:U},[],t.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(c,0),this.storageService.remove(r,0)}async request(O,U,D,M){if(!this.authToken)throw new S.UserDataSyncStoreError("No Auth Token Available",O,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new S.UserDataSyncStoreError(`${U.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const N=await this.commonHeadersPromise;U.headers={...U.headers||{},...N,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(U.headers),this.logService.trace("Sending request to server",{url:O,type:U.type,headers:{...U.headers,authorization:void 0}});let x;try{x=await this.session.request(O,U,M)}catch(B){if(!(B instanceof S.UserDataSyncStoreError)){let j="RequestFailed";const Y=(0,L.getErrorMessage)(B).toLowerCase();Y.includes("xhr timeout")?j="RequestTimeout":Y.includes("protocol")&&Y.includes("not supported")?j="RequestProtocolNotSupported":Y.includes("request path contains unescaped characters")?j="RequestPathNotEscaped":Y.includes("headers must be an object")?j="RequestHeadersNotObject":(0,L.isCancellationError)(B)&&(j="RequestCanceled"),B=new S.UserDataSyncStoreError(`Connection refused for the request '${O}'.`,O,j,void 0,void 0)}throw this.logService.info("Request failed",O),B}const Q=x.res.headers[S.HEADER_OPERATION_ID],W={url:O,status:x.res.statusCode,"execution-id":U.headers[S.HEADER_EXECUTION_ID],"operation-id":Q},ie=(0,m.isSuccess)(x)||x.res.statusCode&&D.indexOf(x.res.statusCode)!==-1;if(ie?this.logService.trace("Request succeeded",W):this.logService.info("Request failed",W),x.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new S.UserDataSyncStoreError(`Request '${O}' failed because of Unauthorized (401).`,O,"Unauthorized",x.res.statusCode,Q);if(this._onTokenSucceed.fire(),x.res.statusCode===409)throw new S.UserDataSyncStoreError(`${U.type} request '${O}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,O,"Conflict",x.res.statusCode,Q);if(x.res.statusCode===410)throw new S.UserDataSyncStoreError(`${U.type} request '${O}' failed because the requested resource is not longer available (410).`,O,"Gone",x.res.statusCode,Q);if(x.res.statusCode===412)throw new S.UserDataSyncStoreError(`${U.type} request '${O}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,O,"PreconditionFailed",x.res.statusCode,Q);if(x.res.statusCode===413)throw new S.UserDataSyncStoreError(`${U.type} request '${O}' failed because of too large payload (413).`,O,"TooLarge",x.res.statusCode,Q);if(x.res.statusCode===426)throw new S.UserDataSyncStoreError(`${U.type} request '${O}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,O,"UpgradeRequired",x.res.statusCode,Q);if(x.res.statusCode===429){const B=x.res.headers["retry-after"];throw B?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(B)*1e3)),new S.UserDataSyncStoreError(`${U.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",x.res.statusCode,Q)):new S.UserDataSyncStoreError(`${U.type} request '${O}' failed because of too many requests (429).`,O,"RemoteTooManyRequests",x.res.statusCode,Q)}if(!ie)throw new S.UserDataSyncStoreError("Server returned "+x.res.statusCode,O,"Unknown",x.res.statusCode,Q);return x}addSessionHeaders(O){let U=this.storageService.get(r,0);U===void 0&&(U=(0,f.generateUuid)(),this.storageService.store(r,U,0,1)),O["X-Machine-Session-Id"]=U;const D=this.storageService.get(c,0);D!==void 0&&(O["X-User-Session-Id"]=D)}};l=he([G(1,v.IProductService),G(2,m.IRequestService),G(3,S.IUserDataSyncLogService),G(4,h.IEnvironmentService),G(5,u.IFileService),G(6,y.IStorageService)],l),e.UserDataSyncStoreClient=l;let g=class extends l{constructor(O,U,D,M,N,x,Q){super(O.userDataSyncStore?.url,U,D,M,N,x,Q);this._register(O.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(O.userDataSyncStore?.url)))}};g=he([G(0,S.IUserDataSyncStoreManagementService),G(1,v.IProductService),G(2,m.IRequestService),G(3,S.IUserDataSyncLogService),G(4,h.IEnvironmentService),G(5,u.IFileService),G(6,y.IStorageService)],g),e.UserDataSyncStoreService=g;class I{constructor(O,U,D,M){this.limit=O,this.interval=U,this.requestService=D,this.logService=M,this.requests=[],this.startTime=void 0}request(O,U,D){if(this.isExpired()&&this.reset(),U.url=O,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new S.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,O,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(O),this.requestService.request(U,D)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=I}),define(te[244],ne([0,1,3,60,27,23,21,240,24,65,66]),function(K,e,k,t,L,T,A,R,b,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let E=class extends R.UserDataAutoSyncService{constructor(p,h,u,v,m,w,y,S,d,i,c){super(p,h,u,v,m,y,S,d,i,c);this._register(k.Event.debounce(k.Event.any(k.Event.map(w.onDidFocusWindow,()=>"windowFocus"),k.Event.map(w.onDidOpenWindow,()=>"windowOpen")),(r,n)=>r?[...r,n]:[n],1e3)(r=>this.triggerSync(r,!0,!1)))}};E=he([G(0,L.IProductService),G(1,b.IUserDataSyncStoreManagementService),G(2,b.IUserDataSyncStoreService),G(3,b.IUserDataSyncEnablementService),G(4,b.IUserDataSyncService),G(5,t.INativeHostService),G(6,b.IUserDataSyncLogService),G(7,C.IUserDataSyncAccountService),G(8,A.ITelemetryService),G(9,P.IUserDataSyncMachinesService),G(10,T.IStorageService)],E),e.UserDataAutoSyncService=E}),define(te[245],ne([0,1,5,3,2]),function(K,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class T extends L.Disposable{constructor({onDidOpenWindow:R,onDidFocusWindow:b,getActiveWindowId:C}){super();this.disposables=this._register(new L.DisposableStore),t.Event.latch(t.Event.any(R,b))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,k.createCancelablePromise)(()=>C()),(async()=>{try{const E=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:E}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(R){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=R}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=T}),define(te[67],ne([0,1,50,5,10,11,22,125,258,259]),function(K,e,k,t,L,T,A,R,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class P extends Error{constructor(i,c){let r=c.message;switch(i){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r);this.type=i,this.cause=c}}e.ExtractError=P;function E(d){const i=d.externalFileAttributes>>16||33188;return[448,56,7].map(c=>i&c).reduce((c,r)=>c+r,i&61440)}function f(d){if(d instanceof P)return d;let i;return/end of central directory record signature not found/.test(d.message)&&(i="CorruptZip"),new P(i,d)}function p(d,i,c,r,n,o){const s=L.dirname(i),a=L.join(r,s);if(!a.startsWith(r))return Promise.reject(new Error(R.localize(0,null,i)));const l=L.join(r,i);let g;return o.onCancellationRequested(()=>{g&&g.destroy()}),Promise.resolve(A.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((I,_)=>{if(!o.isCancellationRequested)try{g=(0,k.createWriteStream)(l,{mode:c}),g.once("close",()=>I()),g.once("error",_),d.once("error",_),d.pipe(g)}catch(O){_(O)}}))}function h(d,i,c,r){let n=(0,t.createCancelablePromise)(()=>Promise.resolve()),o=0;return r.onCancellationRequested(()=>{n.cancel(),d.close()}),new Promise((s,a)=>{const l=new t.Sequencer,g=I=>{I.isCancellationRequested||(o++,d.readEntry())};d.once("error",a),d.once("close",()=>n.then(()=>{r.isCancellationRequested||d.entryCount===o?s():a(new P("Incomplete",new Error(R.localize(1,null,o,d.entryCount))))},a)),d.readEntry(),d.on("entry",I=>{if(r.isCancellationRequested)return;if(!c.sourcePathRegex.test(I.fileName)){g(r);return}const _=I.fileName.replace(c.sourcePathRegex,"");if(/\/$/.test(_)){const D=L.join(i,_);n=(0,t.createCancelablePromise)(M=>A.Promises.mkdir(D,{recursive:!0}).then(()=>g(M)).then(void 0,a));return}const O=v(d,I),U=E(I);n=(0,t.createCancelablePromise)(D=>l.queue(()=>O.then(M=>p(M,_,U,i,c,D).then(()=>g(D)))).then(null,a))})})}function u(d,i=!1){return new Promise((c,r)=>{(0,b.open)(d,i?{lazyEntries:!0}:void 0,(n,o)=>{n?r(f(n)):c((0,T.assertIsDefined)(o))})})}function v(d,i){return new Promise((c,r)=>{d.openReadStream(i,(n,o)=>{n?r(f(n)):c((0,T.assertIsDefined)(o))})})}function m(d,i){return new Promise((c,r)=>{const n=new C.ZipFile;i.forEach(s=>{s.contents?n.addBuffer(typeof s.contents=="string"?Buffer.from(s.contents,"utf8"):s.contents,s.path):s.localPath&&n.addFile(s.localPath,s.path)}),n.end();const o=(0,k.createWriteStream)(d);n.outputStream.pipe(o),n.outputStream.once("error",r),o.once("error",r),o.once("finish",()=>c(d))})}e.zip=m;function w(d,i,c={},r){const n=new RegExp(c.sourcePath?`^${c.sourcePath}`:"");let o=u(d,!0);return c.overwrite&&(o=o.then(s=>A.Promises.rm(i).then(()=>s))),o.then(s=>h(s,i,{sourcePathRegex:n},r))}e.extract=w;function y(d,i){return u(d).then(c=>new Promise((r,n)=>{c.on("entry",o=>{o.fileName===i&&v(c,o).then(s=>r(s),s=>n(s))}),c.once("close",()=>n(new Error(R.localize(2,null,i))))}))}function S(d,i){return y(d,i).then(c=>new Promise((r,n)=>{const o=[];c.once("error",n),c.on("data",s=>o.push(s)),c.on("end",()=>r(Buffer.concat(o)))}))}e.buffer=S}),define(te[246],ne([0,1,67,133]),function(K,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function L(T){return(0,k.buffer)(T,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch{throw new Error((0,t.localize)(0,null))}})}e.getManifest=L}),define(te[247],ne([0,1,16,5,9,2,18,10,4,20,62,7,29,22,67,134,14,30,31,156,61,15,8,27]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p,h,u,v,m,w,y,S,d,i,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;let r=class extends T.Disposable{constructor(o,s,a,l,g){super();this.beforeRemovingExtension=o,this.fileService=s,this.logService=a,this.environmentService=l,this.productService=g,this._devSystemExtensionsPath=null,this.systemExtensionsPath=l.builtinExtensionsPath,this.extensionsPath=l.extensionsPath,this.uninstalledPath=R.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new t.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(o){const s=[];(o===null||o===0)&&s.push(this.scanSystemExtensions().then(null,a=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(a).message,m.ExtensionManagementErrorCode.Internal)))),(o===null||o===1)&&s.push(this.scanUserExtensions(!0).then(null,a=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(a).message,m.ExtensionManagementErrorCode.Internal))));try{const a=await Promise.all(s);return(0,k.flatten)(a)}catch(a){throw this.joinErrors(a)}}async scanUserExtensions(o){this.logService.trace("Started scanning user extensions");let[s,a]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return a=a.filter(l=>!s[new w.ExtensionIdentifierWithVersion(l.identifier,l.manifest.version).key()]),o&&(a=(0,w.groupByExtension)(a,g=>g.identifier).map(g=>g.sort((I,_)=>P.rcompare(I.manifest.version,_.manifest.version))[0])),this.logService.trace("Scanned user extensions:",a.length),a}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(o,s,a,l){const g=o.key(),I=R.join(this.extensionsPath,`.${(0,f.generateUuid)()}`),_=R.join(this.extensionsPath,g);try{await p.Promises.rm(_)}catch{try{await p.Promises.rm(_)}catch{}throw new m.ExtensionManagementError((0,u.localize)(0,null,_,o.id),m.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(o,s,I,l);let O=await this.scanExtension(E.URI.file(I),1);if(!O)throw new Error((0,u.localize)(1,null,I));await this.storeMetadata(O,{...a,installedTimestamp:Date.now()});try{await this.rename(o,I,_,Date.now()+2*60*1e3),this.logService.info("Renamed to",_)}catch(U){try{await p.Promises.rm(I)}catch{}if(U.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",o.id);else throw this.logService.info(`Rename failed because of ${(0,L.getErrorMessage)(U)}. Deleted from extracted location`,I),U}try{O=await this.scanExtension(E.URI.file(_),1)}catch{}if(O)return O;throw new Error((0,u.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(o,s){return this.setMetadata(o,s),await this.storeMetadata(o,{...s,installedTimestamp:o.installedTimestamp}),o}async storeMetadata(o,s){s.isMachineScoped=s.isMachineScoped||void 0,s.isBuiltin=s.isBuiltin||void 0,s.installedTimestamp=s.installedTimestamp||void 0;const a=R.join(o.location.fsPath,"package.json"),l=await p.Promises.readFile(a,"utf8"),{manifest:g}=await this.parseManifest(l);return g.__metadata=s,await p.Promises.writeFile(a,JSON.stringify(g,null,"	")),o}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...o){const s=o.map(a=>new w.ExtensionIdentifierWithVersion(a.identifier,a.manifest.version));await this.withUninstalledExtensions(a=>{s.forEach(l=>a[l.key()]=!0)})}async setInstalled(o){await this.withUninstalledExtensions(l=>delete l[o.key()]);const a=(await this.scanExtensions(1)).find(l=>new w.ExtensionIdentifierWithVersion(l.identifier,l.manifest.version).equals(o))||null;return a?(await this.storeMetadata(a,{installedTimestamp:Date.now()}),this.scanExtension(a.location,1)):null}async withUninstalledExtensions(o){return this.uninstalledFileLimiter.queue(async()=>{let s;try{s=await p.Promises.readFile(this.uninstalledPath,"utf8")}catch(l){if(l.code!=="ENOENT")throw l}let a={};if(s)try{a=JSON.parse(s)}catch{}return o&&(o(a),Object.keys(a).length?await p.Promises.writeFile(this.uninstalledPath,JSON.stringify(a)):await p.Promises.rm(this.uninstalledPath)),a})}async removeExtension(o,s){this.logService.trace(`Deleting ${s} extension from disk`,o.identifier.id,o.location.fsPath),await p.Promises.rm(o.location.fsPath),this.logService.info("Deleted from disk",o.identifier.id,o.location.fsPath)}async removeUninstalledExtension(o){await this.removeExtension(o,"uninstalled"),await this.withUninstalledExtensions(s=>delete s[new w.ExtensionIdentifierWithVersion(o.identifier,o.manifest.version).key()])}async extractAtLocation(o,s,a,l){this.logService.trace(`Started extracting the extension from ${s} to ${a}`);try{await p.Promises.rm(a)}catch(g){throw new m.ExtensionManagementError(this.joinErrors(g).message,m.ExtensionManagementErrorCode.Delete)}try{await(0,h.extract)(s,a,{sourcePath:"extension",overwrite:!0},l),this.logService.info(`Extracted extension to ${a}:`,o.id)}catch(g){try{await p.Promises.rm(a)}catch{}let I=m.ExtensionManagementErrorCode.Extract;throw g instanceof h.ExtractError&&(g.type==="CorruptZip"?I=m.ExtensionManagementErrorCode.CorruptZip:g.type==="Incomplete"&&(I=m.ExtensionManagementErrorCode.IncompleteZip)),new m.ExtensionManagementError(g.message,I)}}async rename(o,s,a,l){try{await p.Promises.rename(s,a)}catch(g){if(b.isWindows&&g&&g.code==="EPERM"&&Date.now()<l)return this.logService.info(`Failed renaming ${s} to ${a} with 'EPERM' error. Trying again...`,o.id),this.rename(o,s,a,l);throw new m.ExtensionManagementError(g.message||(0,u.localize)(3,null,s,a),g.code||m.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const o=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return o;const s=this.scanDevSystemExtensions(),[a,l]=await Promise.all([o,s]);return[...a,...l]}async scanExtensionsInDir(o,s){const a=new t.Limiter(10),l=await this.fileService.resolve(E.URI.file(o));return l.children?(await Promise.all(l.children.filter(I=>I.isDirectory).map(I=>a.queue(async()=>s===1&&(0,C.basename)(I.resource).indexOf(".")===0?null:this.scanExtension(I.resource,s))))).filter(I=>I&&I.identifier):[]}async scanExtension(o,s){try{const a=await this.fileService.resolve(o);if(a.children){const{manifest:l,metadata:g}=await this.readManifest(o.fsPath),I=a.children.find(({name:D})=>/^readme(\.txt|\.md|)$/i.test(D))?.resource,_=a.children.find(({name:D})=>/^changelog(\.txt|\.md|)$/i.test(D))?.resource,O={id:(0,w.getGalleryExtensionId)(l.publisher,l.name)},U={type:s,identifier:O,manifest:l,location:o,readmeUrl:I,changelogUrl:_,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:s===0};return this.setMetadata(U,g),U}}catch(a){s!==0&&this.logService.trace(a)}return null}async scanDefaultSystemExtensions(){const o=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",o.length),o}async scanDevSystemExtensions(){const o=this.getDevSystemExtensionsList();if(o.length){const s=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",s.length),s.filter(a=>o.some(l=>(0,w.areSameExtensions)(a.identifier,{id:l})))}else return[]}setMetadata(o,s){o.publisherDisplayName=s?.publisherDisplayName||null,o.publisherId=s?.publisherId||null,o.identifier.uuid=s?.id,o.isMachineScoped=!!s?.isMachineScoped,o.isPreReleaseVersion=!!s?.isPreReleaseVersion,o.preRelease=!!s?.preRelease,o.isBuiltin=o.type===0||!!s?.isBuiltin,o.installedTimestamp=s?.installedTimestamp}async removeUninstalledExtensions(){const o=await this.getUninstalledExtensions(),s=await this.scanAllUserExtensions(),a=new Set;for(const I of s)o[new w.ExtensionIdentifierWithVersion(I.identifier,I.manifest.version).key()]||a.add(I.identifier.id.toLowerCase());const l=(0,w.groupByExtension)(s,I=>I.identifier);await t.Promises.settled(l.map(async I=>{const _=I.sort((O,U)=>P.rcompare(O.manifest.version,U.manifest.version))[0];a.has(_.identifier.id.toLowerCase())||await this.beforeRemovingExtension(_)}));const g=s.filter(I=>o[new w.ExtensionIdentifierWithVersion(I.identifier,I.manifest.version).key()]);await t.Promises.settled(g.map(I=>this.removeUninstalledExtension(I)))}async removeOutdatedExtensions(){const o=await this.scanAllUserExtensions(),s=[],a=(0,w.groupByExtension)(o,l=>l.identifier);s.push(...(0,k.flatten)(a.map(l=>l.sort((g,I)=>P.rcompare(g.manifest.version,I.manifest.version)).slice(1)))),await t.Promises.settled(s.map(l=>this.removeExtension(l,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(o=>o.name)}joinErrors(o){const s=Array.isArray(o)?o:[o];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((a,l)=>new Error(`${a.message}${a.message?",":""}${l instanceof Error?l.message:l}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=R.normalize(R.join(A.FileAccess.asFileUri("",K).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(o){const s=[p.Promises.readFile(R.join(o,"package.json"),"utf8").then(I=>this.parseManifest(I)),p.Promises.readFile(R.join(o,"package.nls.json"),"utf8").then(void 0,I=>I.code!=="ENOENT"?Promise.reject(I):"{}").then(I=>JSON.parse(I))],[{manifest:a,metadata:l},g]=await Promise.all(s);return{manifest:(0,y.localizeManifest)(a,g),metadata:l}}parseManifest(o){return new Promise((s,a)=>{try{const l=JSON.parse(o);l.publisher||(l.publisher=S.UNDEFINED_PUBLISHER);const g=l.__metadata||null;s({manifest:l,metadata:g})}catch{a(new Error((0,u.localize)(4,null)))}})}};r=he([G(1,d.IFileService),G(2,i.ILogService),G(3,v.INativeEnvironmentService),G(4,c.IProductService)],r),e.ExtensionsScanner=r}),define(te[248],ne([0,1,37,9,18,10,4,33,20,62,11,7,29,22,67,132,82,14,205,30,31,188,173,246,189,247,222,79,15,6,8,27,21,32]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p,h,u,v,m,w,y,S,d,i,c,r,n,o,s,a,l,g,I,_,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;let U=class extends w.AbstractExtensionManagementService{constructor(W,ie,B,j,Y,V,J,Z,q){super(W,ie,B,Z);this.environmentService=j,this.downloadService=Y,this.fileService=J;const F=this._register(V.createInstance(i.ExtensionsLifecycle));this.extensionsScanner=this._register(V.createInstance(n.ExtensionsScanner,z=>F.postUninstall(z))),this.manifestCache=this._register(new r.ExtensionsManifestCache(j,this)),this.extensionsDownloader=this._register(V.createInstance(d.ExtensionsDownloader));const $=this._register(new o.ExtensionsWatcher(this,J,j,B,q));this._register($.onDidChangeExtensionsByAnotherSource(({added:z,removed:H})=>{z.length&&this._onDidInstallExtensions.fire(z.map(ee=>({identifier:ee.identifier,operation:1,local:ee}))),H.forEach(ee=>this._onDidUninstallExtension.fire({identifier:ee}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const W=await this.isAlpineLinux(),ie=(0,y.getTargetPlatform)(W?"alpine":A.platform,R.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",ie),ie})()),this._targetPlatformPromise}async isAlpineLinux(){if(!A.isLinux)return!1;let W;try{W=(await this.fileService.readFile(E.URI.file("/etc/os-release"))).value.toString()}catch{try{W=(await this.fileService.readFile(E.URI.file("/usr/lib/os-release"))).value.toString()}catch(B){this.logService.debug("Error while getting the os-release file.",(0,t.getErrorMessage)(B))}}return!!W&&(W.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(W){this.logService.trace("ExtensionManagementService#zip",W.identifier.id);const ie=await this.collectFiles(W),B=await(0,h.zip)((0,b.joinPath)(this.environmentService.tmpDir,(0,f.generateUuid)()).fsPath,ie);return E.URI.file(B)}async unzip(W){return this.logService.trace("ExtensionManagementService#unzip",W.toString()),(await this.install(W)).identifier}async getManifest(W){const ie=await this.downloadVsix(W),B=T.resolve(ie.fsPath);return(0,c.getManifest)(B)}getInstalled(W=null){return this.extensionsScanner.scanExtensions(W)}async install(W,ie={}){this.logService.trace("ExtensionManagementService#install",W.toString());const B=await this.downloadVsix(W),j=await(0,c.getManifest)(T.resolve(B.fsPath));if(j.engines&&j.engines.vscode&&!(0,s.isEngineValid)(j.engines.vscode,this.productService.version,this.productService.date))throw new Error(u.localize(0,null,(0,S.getGalleryExtensionId)(j.publisher,j.name),this.productService.version));return this.installExtension(j,B,ie)}async updateMetadata(W,ie){this.logService.trace("ExtensionManagementService#updateMetadata",W.identifier.id);const B={...W.manifest.__metadata||{},...ie};return ie.isPreReleaseVersion&&(B.preRelease=!0),W=await this.extensionsScanner.saveMetadataForLocalExtension(W,B),this.manifestCache.invalidate(),W}async updateExtensionScope(W,ie){return this.logService.trace("ExtensionManagementService#updateExtensionScope",W.identifier.id),W=await this.extensionsScanner.saveMetadataForLocalExtension(W,{...W.manifest.__metadata||{},isMachineScoped:ie}),this.manifestCache.invalidate(),W}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(W){if(W.scheme===L.Schemas.file)return W;const ie=(0,b.joinPath)(this.environmentService.tmpDir,(0,f.generateUuid)());return await this.downloadService.download(W,ie),ie}createInstallExtensionTask(W,ie,B){return E.URI.isUri(ie)?new N(W,ie,B,this.galleryService,this.extensionsScanner,this.logService):new M(ie,B,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(W,ie){return new x(W,ie,this.extensionsScanner)}async collectFiles(W){const ie=async j=>{let Y=await p.Promises.readdir(j);Y=Y.map(Z=>T.join(j,Z));const V=await Promise.all(Y.map(Z=>p.Promises.stat(Z)));let J=Promise.resolve([]);return V.forEach((Z,q)=>{const F=Y[q];Z.isFile()&&(J=J.then($=>[...$,F])),Z.isDirectory()&&(J=J.then($=>ie(F).then(z=>[...$,...z])))}),J};return(await ie(W.location.fsPath)).map(j=>({path:`extension/${T.relative(W.location.fsPath,j)}`,localPath:j}))}};U=he([G(0,y.IExtensionGalleryService),G(1,_.ITelemetryService),G(2,g.ILogService),G(3,m.INativeEnvironmentService),G(4,v.IDownloadService),G(5,l.IInstantiationService),G(6,a.IFileService),G(7,I.IProductService),G(8,O.IUriIdentityService)],U),e.ExtensionManagementService=U;class D extends w.AbstractExtensionTask{constructor(W,ie,B,j){super();this.identifier=W,this.source=ie,this.extensionsScanner=B,this.logService=j,this._operation=2}get operation(){return this._operation}async installExtension(W,ie){try{const B=await this.unsetUninstalledAndGetLocal(W.identifierWithVersion);if(B)return W.metadata?this.extensionsScanner.saveMetadataForLocalExtension(B,{...B.manifest.__metadata||{},...W.metadata}):B}catch{throw A.isMacintosh?new y.ExtensionManagementError(u.localize(1,null),y.ExtensionManagementErrorCode.Internal):new y.ExtensionManagementError(u.localize(2,null),y.ExtensionManagementErrorCode.Internal)}return this.extract(W,ie)}async unsetUninstalledAndGetLocal(W){if(!await this.isUninstalled(W))return null;this.logService.trace("Removing the extension from uninstalled list:",W.id);const B=await this.extensionsScanner.setInstalled(W);return this.logService.info("Removed the extension from uninstalled list:",W.id),B}async isUninstalled(W){return!!(await this.extensionsScanner.getUninstalledExtensions())[W.key()]}async extract({zipPath:W,identifierWithVersion:ie,metadata:B},j){let Y=await this.extensionsScanner.extractUserExtension(ie,W,B,j);return this.logService.info("Extracting completed.",ie.id),Y}}class M extends D{constructor(W,ie,B,j,Y){super(W.identifier,W,j,Y);this.gallery=W,this.options=ie,this.extensionsDownloader=B}async doRun(W){const B=(await this.extensionsScanner.scanExtensions(null)).find(Y=>(0,S.areSameExtensions)(Y.identifier,this.gallery.identifier));B&&(this._operation=3);const j=await this.downloadInstallableExtension(this.gallery,this._operation);j.metadata.isMachineScoped=this.options.isMachineScoped||B?.isMachineScoped,j.metadata.isBuiltin=this.options.isBuiltin||B?.isBuiltin,j.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,j.metadata.preRelease=this.gallery.properties.isPreReleaseVersion||((0,P.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:B?.preRelease);try{const Y=await this.installExtension(j,W);return B&&C.neq(B.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(B),Y}catch(Y){throw await this.deleteDownloadedVSIX(j.zipPath),Y}}async deleteDownloadedVSIX(W){try{await this.extensionsDownloader.delete(E.URI.file(W))}catch(ie){this.logService.warn("Error while deleting the downloaded vsix",W.toString(),(0,t.getErrorMessage)(ie))}}async downloadInstallableExtension(W,ie){const B={id:W.identifier.uuid,publisherId:W.publisherId,publisherDisplayName:W.publisherDisplayName};let j;try{this.logService.trace("Started downloading extension:",W.identifier.id),j=(await this.extensionsDownloader.downloadExtension(W,ie)).fsPath,this.logService.info("Downloaded extension:",W.identifier.id,j)}catch(Y){throw new y.ExtensionManagementError((0,w.joinErrors)(Y).message,y.ExtensionManagementErrorCode.Download)}try{const Y=await(0,c.getManifest)(j);return{zipPath:j,identifierWithVersion:new S.ExtensionIdentifierWithVersion(W.identifier,Y.version),metadata:B}}catch(Y){throw await this.deleteDownloadedVSIX(j),new y.ExtensionManagementError((0,w.joinErrors)(Y).message,y.ExtensionManagementErrorCode.Invalid)}}}class N extends D{constructor(W,ie,B,j,Y,V){super({id:(0,S.getGalleryExtensionId)(W.publisher,W.name)},ie,Y,V);this.manifest=W,this.location=ie,this.options=B,this.galleryService=j}async doRun(W){const ie=new S.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),j=(await this.extensionsScanner.scanExtensions(1)).find(V=>(0,S.areSameExtensions)(this.identifier,V.identifier)),Y=await this.getMetadata(this.identifier.id,this.manifest.version,W);if(Y.isMachineScoped=this.options.isMachineScoped||j?.isMachineScoped,Y.isBuiltin=this.options.isBuiltin||j?.isBuiltin,j)if(this._operation=3,ie.equals(new S.ExtensionIdentifierWithVersion(j.identifier,j.manifest.version)))try{await this.extensionsScanner.removeExtension(j,"existing")}catch{throw new Error(u.localize(3,null,this.manifest.displayName||this.manifest.name))}else C.gt(j.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(j);else{const V=await this.unsetUninstalledAndGetLocal(ie);if(V)try{await this.extensionsScanner.removeExtension(V,"existing")}catch{throw new Error(u.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:T.resolve(this.location.fsPath),identifierWithVersion:ie,metadata:Y},W)}async getMetadata(W,ie,B){try{let[j]=await this.galleryService.getExtensions([{id:W,version:ie}],B);if(j||([j]=await this.galleryService.getExtensions([{id:W}],B)),j)return{id:j.identifier.uuid,publisherDisplayName:j.publisherDisplayName,publisherId:j.publisherId,isPreReleaseVersion:j.properties.isPreReleaseVersion,preRelease:j.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class x extends w.AbstractExtensionTask{constructor(W,ie,B){super();this.extension=W,this.options=ie,this.extensionsScanner=B}async doRun(W){const ie=[],B=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const j=new S.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);ie.push(...B.filter(Y=>j.equals(new S.ExtensionIdentifierWithVersion(Y.identifier,Y.manifest.version))))}else ie.push(...B.filter(j=>(0,S.areSameExtensions)(j.identifier,this.extension.identifier)));if(!ie.length)throw new Error(u.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...ie),this.options.remove)for(const j of ie)try{W.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(j)}catch(Y){throw new Error(u.localize(6,null,(0,k.toErrorMessage)(Y)))}}}}),define(te[249],ne([0,1,84,56,34,17,9,3,2,10,4,29,36,74,260]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class u{constructor(I,_=""){this.debugLabel=_,this.socket=I,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=O=>{if(this.traceSocketEvent("error",{code:O?.code,message:O?.message}),O){if(O.code==="EPIPE")return;(0,A.onUnexpectedError)(O)}},this.socket.on("error",this._errorListener)}traceSocketEvent(I,_){p.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,I,_)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(I){const _=O=>{this.traceSocketEvent("read",O),I(T.VSBuffer.wrap(O))};return this.socket.on("data",_),{dispose:()=>this.socket.off("data",_)}}onClose(I){const _=O=>{this.traceSocketEvent("close",{hadError:O}),I({type:0,hadError:O,error:void 0})};return this.socket.on("close",_),{dispose:()=>this.socket.off("close",_)}}onEnd(I){const _=()=>{this.traceSocketEvent("nodeEndReceived"),I()};return this.socket.on("end",_),{dispose:()=>this.socket.off("end",_)}}write(I){if(!this.socket.destroyed)try{this.traceSocketEvent("write",I),this.socket.write(I.buffer,_=>{if(_){if(_.code==="EPIPE")return;(0,A.onUnexpectedError)(_)}})}catch(_){if(_.code==="EPIPE")return;(0,A.onUnexpectedError)(_)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((I,_)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),I();return}const O=()=>{this.socket.off("close",O),this.socket.off("end",O),this.socket.off("error",O),this.socket.off("timeout",O),this.socket.off("drain",O),this.traceSocketEvent("nodeDrainEnd"),I()};this.socket.on("close",O),this.socket.on("end",O),this.socket.on("error",O),this.socket.on("timeout",O),this.socket.on("drain",O)})}}e.NodeSocket=u;var v;(function(g){g[g.MinHeaderByteSize=2]="MinHeaderByteSize"})(v||(v={}));var m;(function(g){g[g.PeekHeader=1]="PeekHeader",g[g.ReadHeader=2]="ReadHeader",g[g.ReadBody=3]="ReadBody",g[g.Fin=4]="Fin"})(m||(m={}));class w extends b.Disposable{constructor(I,_,O,U){super();this._onData=this._register(new R.Emitter),this._onClose=this._register(new R.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=I,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:_,inflateBytesLength:O?.byteLength||0,recordInflateBytes:U}),this._flowManager=this._register(new y(this,_,O,U,this._onData,(D,M)=>this._write(D,M))),this._register(this._flowManager.onError(D=>{console.error(D),(0,A.onUnexpectedError)(D),this._onClose.fire({type:0,hadError:!0,error:D})})),this._incomingData=new p.ChunkStream,this._register(this.socket.onData(D=>this._acceptChunk(D))),this._register(this.socket.onClose(D=>this._onClose.fire(D)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(I,_){this.socket.traceSocketEvent(I,_)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(I){return this._onData.event(I)}onClose(I){return this._onClose.event(I)}onEnd(I){return this.socket.onEnd(I)}write(I){this._flowManager.writeMessage(I)}_write(I,_){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",I);let O=2;I.byteLength<126?O+=0:I.byteLength<2**16?O+=2:O+=8;const U=T.VSBuffer.alloc(O);if(_?U.writeUInt8(194,0):U.writeUInt8(130,0),I.byteLength<126)U.writeUInt8(I.byteLength,1);else if(I.byteLength<2**16){U.writeUInt8(126,1);let D=1;U.writeUInt8(I.byteLength>>>8&255,++D),U.writeUInt8(I.byteLength>>>0&255,++D)}else{U.writeUInt8(127,1);let D=1;U.writeUInt8(0,++D),U.writeUInt8(0,++D),U.writeUInt8(0,++D),U.writeUInt8(0,++D),U.writeUInt8(I.byteLength>>>24&255,++D),U.writeUInt8(I.byteLength>>>16&255,++D),U.writeUInt8(I.byteLength>>>8&255,++D),U.writeUInt8(I.byteLength>>>0&255,++D)}this.socket.write(T.VSBuffer.concat([U,I]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(I){if(I.byteLength!==0){for(this._incomingData.acceptChunk(I);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const _=this._incomingData.peek(this._state.readLen),O=_.readUInt8(0),U=(O&128)>>>7,D=(O&64)>>>6,M=_.readUInt8(1),N=(M&128)>>>7,x=M&127;this._state.state=2,this._state.readLen=2+(N?4:0)+(x===126?2:0)+(x===127?8:0),this._state.fin=U,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(D)),this._state.firstFrameOfMessage=Boolean(U),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const _=this._incomingData.read(this._state.readLen),O=_.readUInt8(1),U=(O&128)>>>7;let D=O&127,M=1;D===126?D=_.readUInt8(++M)*2**8+_.readUInt8(++M):D===127&&(D=_.readUInt8(++M)*0+_.readUInt8(++M)*0+_.readUInt8(++M)*0+_.readUInt8(++M)*0+_.readUInt8(++M)*2**24+_.readUInt8(++M)*2**16+_.readUInt8(++M)*2**8+_.readUInt8(++M));let N=0;U&&(N=_.readUInt8(++M)*2**24+_.readUInt8(++M)*2**16+_.readUInt8(++M)*2**8+_.readUInt8(++M)),this._state.state=3,this._state.readLen=D,this._state.mask=N,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const _=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",_),i(_,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",_),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(_,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await R.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=w;class y extends b.Disposable{constructor(I,_,O,U,D,M){super();this._tracer=I,this._onData=D,this._writeFn=M,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new R.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,_?(this._zlibInflateStream=this._register(new S(this._tracer,U,O,{windowBits:15})),this._zlibDeflateStream=this._register(new d(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(N=>this._onError.fire(N))),this._register(this._zlibDeflateStream.onError(N=>this._onError.fire(N)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:T.VSBuffer.alloc(0)}writeMessage(I){this._writeQueue.push(I),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const I=this._writeQueue.shift();if(this._zlibDeflateStream){const _=await this._deflateMessage(this._zlibDeflateStream,I);this._writeFn(_,!0)}else this._writeFn(I,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(I,_){return new Promise((O,U)=>{I.write(_),I.flush(D=>O(D))})}acceptFrame(I,_,O){this._readQueue.push({data:I,isCompressed:_,isLastFrameOfMessage:O}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const I=this._readQueue.shift();if(this._zlibInflateStream&&I.isCompressed){const _=await this._inflateFrame(this._zlibInflateStream,I.data,I.isLastFrameOfMessage);this._onData.fire(_)}else this._onData.fire(I.data)}this._isProcessingReadQueue=!1}}_inflateFrame(I,_,O){return new Promise((U,D)=>{I.write(_),O&&I.write(T.VSBuffer.fromByteArray([0,0,255,255])),I.flush(M=>U(M))})}}class S extends b.Disposable{constructor(I,_,O,U){super();this._tracer=I,this._recordInflateBytes=_,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=h.createInflateRaw(U),this._zlibInflate.on("error",D=>{this._tracer.traceSocketEvent("zlibInflateError",{message:D?.message,code:D?.code}),this._onError.fire(D)}),this._zlibInflate.on("data",D=>{this._tracer.traceSocketEvent("zlibInflateData",D),this._pendingInflateData.push(T.VSBuffer.wrap(D))}),O&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",O.buffer),this._zlibInflate.write(O.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?T.VSBuffer.concat(this._recordedInflateBytes):T.VSBuffer.alloc(0)}write(I){this._recordInflateBytes&&this._recordedInflateBytes.push(I.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",I),this._zlibInflate.write(I.buffer)}flush(I){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const _=T.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,I(_)})}}class d extends b.Disposable{constructor(I,_){super();this._tracer=I,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=h.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",O=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:O?.message,code:O?.code}),this._onError.fire(O)}),this._zlibDeflate.on("data",O=>{this._tracer.traceSocketEvent("zlibDeflateData",O),this._pendingDeflateData.push(T.VSBuffer.wrap(O))})}write(I){this._tracer.traceSocketEvent("zlibDeflateWrite",I.buffer),this._zlibDeflate.write(I.buffer)}flush(I){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let _=T.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,_=_.slice(0,_.byteLength-4),I(_)})}}function i(g,I){if(I===0)return;let _=g.byteLength>>>2;for(let x=0;x<_;x++){const Q=g.readUInt32BE(x*4);g.writeUInt32BE(Q^I,x*4)}let O=_*4,U=g.byteLength-O;const D=I>>>24&255,M=I>>>16&255,N=I>>>8&255;U>=1&&g.writeUInt8(g.readUInt8(O)^D,O),U>=2&&g.writeUInt8(g.readUInt8(O+1)^M,O+1),U>=3&&g.writeUInt8(g.readUInt8(O+2)^N,O+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const c={[2]:107,[1]:103};function r(){const g=(0,E.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${g}-sock`;let I;return e.XDG_RUNTIME_DIR?I=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${g}.sock`):I=(0,C.join)((0,L.tmpdir)(),`vscode-ipc-${g}.sock`),o(I),I}e.createRandomIPCHandle=r;function n(g,I,_){const O=(0,k.createHash)("md5").update(g).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${O}-${_}-${I}-sock`;let U;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?U=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-${O.substr(0,8)}-${_}-${I}.sock`):U=(0,C.join)(g,`${_}-${I}.sock`),o(U),U}e.createStaticIPCHandle=n;function o(g){const I=c[P.platform];typeof I=="number"&&g.length>=I&&console.warn(`WARNING: IPC handle "${g}" is longer than ${I} chars, try a shorter --user-data-dir`)}class s extends f.IPCServer{constructor(I){super(s.toClientConnectionEvent(I));this.server=I}static toClientConnectionEvent(I){const _=R.Event.fromNodeEventEmitter(I,"connection");return R.Event.map(_,O=>({protocol:new p.Protocol(new u(O,"ipc-server-connection")),onDidClientDisconnect:R.Event.once(R.Event.fromNodeEventEmitter(O,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function a(g){return new Promise((I,_)=>{const O=(0,t.createServer)();O.on("error",_),O.listen(g,()=>{O.removeListener("error",_),I(new s(O))})})}e.serve=a;function l(g,I){return new Promise((_,O)=>{const U=(0,t.createConnection)(g,()=>{U.removeListener("error",O),_(p.Client.fromSocket(new u(U,`ipc-client${I}`),I))});U.once("error",O)})}e.connect=l}),define(te[250],ne([0,1,56,249]),function(K,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(L,T,A,R,b){const C=E=>b(E,void 0),P=k.createConnection({host:L,port:T},()=>{P.removeListener("error",C);const E=Buffer.alloc(16);for(let u=0;u<16;u++)E[u]=Math.round(Math.random()*256);const f=E.toString("base64"),p=[`GET ws://${/:/.test(L)?`[${L}]`:L}:${T}/?${A}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${f}`];P.write(p.join(`\r
`)+`\r
\r
`);const h=u=>{u.toString().indexOf(`\r
\r
`)>=0&&(P.off("data",h),b(void 0,new t.NodeSocket(P,R)))};P.on("data",h)});P.setNoDelay(!0),P.once("error",C)}}}),define(te[251],ne([0,1,56,115,250,5,2,19,8,27,184,64,92]),function(K,e,k,t,L,T,A,R,b,C,P,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function p(w,y,S,d,i){let c;for(let r=3;r&&(c&&c.dispose(),c=await new h(w,y,S,d,i).waitForReady(),!(i&&t.BROWSER_RESTRICTED_PORTS[i]||!t.BROWSER_RESTRICTED_PORTS[c.tunnelLocalPort]));r--);return c}class h extends A.Disposable{constructor(y,S,d,i,c){super();this.defaultTunnelHost=S,this.suggestedLocalPort=c,this.privacy=E.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=y,this._server=k.createServer(),this._barrier=new T.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=r=>this._onConnection(r),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=i,this.tunnelRemoteHost=d}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(S=>{S()})}async waitForReady(){let y=await(0,t.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),S=null;return this._server.listen(y,this.defaultTunnelHost),await this._barrier.wait(),S=this._server.address(),S||(y=0,this._server.listen(y,this.defaultTunnelHost),await this._barrier.wait(),S=this._server.address()),this.tunnelLocalPort=S.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${S.port}`,this}async _onConnection(y){y.pause();const S=(0,E.isLocalhost)(this.tunnelRemoteHost)||(0,E.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,d=await(0,P.connectRemoteAgentTunnel)(this._options,S,this.tunnelRemotePort),i=d.getSocket().socket,c=d.readEntireBuffer();d.dispose(),c.byteLength>0&&y.write(c.buffer),y.on("end",()=>{y.localAddress&&this._socketsDispose.delete(y.localAddress),i.end()}),y.on("close",()=>i.end()),y.on("error",()=>{y.localAddress&&this._socketsDispose.delete(y.localAddress),i.destroy()}),i.on("end",()=>y.end()),i.on("close",()=>y.end()),i.on("error",()=>{y.destroy()}),y.pipe(i),i.pipe(y),y.localAddress&&this._socketsDispose.set(y.localAddress,()=>{y.end(),i.end()})}}let u=class extends E.AbstractTunnelService{constructor(y,S,d,i,c){super(S);this.socketFactory=y,this.signService=d,this.productService=i,this.configurationService=c}get defaultTunnelHost(){const y=this.configurationService.getValue("remote.localPortHost");return!y||y==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(y,S,d,i,c,r,n){const o=this.getTunnelFromMap(S,d);if(o)return++o.refcount,o.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,S,d,i,c,r,n);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${S}:${d} on local port ${i}.`);const s={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:y,signService:this.signService,logService:this.logService,ipcLogger:null},a=p(s,this.defaultTunnelHost,S,d,i);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(S,d,a),a}}};u=he([G(1,b.ILogService),G(2,f.ISignService),G(3,C.IProductService),G(4,R.IConfigurationService)],u),e.BaseTunnelService=u;let v=class extends u{constructor(y,S,d,i){super(L.nodeSocketFactory,y,S,d,i)}};v=he([G(0,b.ILogService),G(1,f.ISignService),G(2,C.IProductService),G(3,R.IConfigurationService)],v),e.TunnelService=v;let m=class extends A.Disposable{constructor(y,S,d,i){super();this.logService=y,this.productService=S,this.signService=d,this.configurationService=i,this._tunnelServices=new Map}async openTunnel(y,S,d,i,c,r,n,o){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${d}:${i} on local port ${c}.`),!this._tunnelServices.has(y)){const s=new v(this.logService,this.signService,this.productService,this.configurationService);this._register(s),this._tunnelServices.set(y,s),s.onTunnelClosed(async()=>{(await s.tunnels).length===0&&(s.dispose(),this._tunnelServices.delete(y))})}return this._tunnelServices.get(y).openTunnel(S,d,i,c,r,n,o)}};m=he([G(0,b.ILogService),G(1,C.IProductService),G(2,f.ISignService),G(3,R.IConfigurationService)],m),e.SharedTunnelsService=m}),define(te[261],ne([0,1,75,34,37,9,2,18,20,7,36,118,178,200,179,170,171,172,159,161,19,182,81,204,82,193,14,197,199,209,30,186,206,248,83,157,15,175,177,51,6,167,86,168,169,59,190,8,87,60,88,27,192,43,23,202,203,21,93,94,95,44,210,211,96,213,220,63,98,24,65,236,238,239,66,237,241,242,243,244,245,92,198,64,251,191,221,91,196,207,32,223,4,224,162,181,180]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p,h,u,v,m,w,y,S,d,i,c,r,n,o,s,a,l,g,I,_,O,U,D,M,N,x,Q,W,ie,B,j,Y,V,J,Z,q,F,$,z,H,ee,se,ae,de,ge,Ee,Se,pe,Ce,Ie,De,Me,je,Ge,Be,re,ce,ue,we,be,Fe,Te,Oe,_e,X,oe,le,fe,me,Le,ye,Re,ke,Pe,Ae,Ne,We,qe,Pt,Rt,Dt,pt,kt,St){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Lt extends A.Disposable{constructor(ve){super();this.configuration=ve,this.server=this._register(new E.Server),this.sharedProcessWorkerService=void 0,this.registerListeners()}registerListeners(){const ve=()=>this.dispose();process.once("exit",ve),k.ipcRenderer.once("vscode:electron-main->shared-process=exit",ve);const Ue="vscode:electron-main->shared-process=disposeWorker",ze=(Ke,$e)=>this.onDisposeWorker($e);k.ipcRenderer.on(Ue,ze),this._register((0,A.toDisposable)(()=>k.ipcRenderer.removeListener(Ue,ze)))}onDisposeWorker(ve){this.sharedProcessWorkerService?.disposeWorker(ve)}async open(){const ve=await this.initServices();(0,ce.registerConfiguration)(),ve.invokeFunction(Ue=>{const ze=Ue.get(Z.ILogService);ze.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Ue),this.registerErrorHandler(ze)}),this._register((0,A.combinedDisposable)(ve.createInstance(f.CodeCacheCleaner,this.configuration.codeCachePath),ve.createInstance(h.LanguagePackCachedDataCleaner),ve.createInstance(m.StorageDataCleaner,this.configuration.backupWorkspacesPath),ve.createInstance(v.LogsDataCleaner),ve.createInstance(u.LocalizationsUpdater),ve.createInstance(p.ExtensionsCleaner)))}async initServices(){const ve=new B.ServiceCollection,Ue={_serviceBrand:void 0,...$.default};ve.set(z.IProductService,Ue);const ze=new P.StaticRouter(Ve=>Ve==="main"),Ke=new j.MessagePortMainProcessService(this.server,ze);ve.set(Y.IMainProcessService,Ke);const $e=new s.SharedProcessEnvironmentService(this.configuration.args,Ue);ve.set(o.INativeEnvironmentService,$e);const nt=new q.LogLevelChannelClient(this.server.getChannel("logLevel",ze)),Xe=new q.LoggerChannelClient(this.configuration.logLevel,nt.onDidChangeLogLevel,Ke.getChannel("logger"));ve.set(Z.ILoggerService,Xe);const ot=this._register(new Z.MultiplexLogService([this._register(new Z.ConsoleLogger(this.configuration.logLevel)),this._register(Xe.createLogger((0,b.joinPath)(C.URI.file($e.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ye=this._register(new q.FollowerLogService(nt,ot));ve.set(Z.ILogService,Ye),this.sharedProcessWorkerService=new Ne.SharedProcessWorkerService(Ye),ve.set(Ae.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Je=this._register(new N.FileService(Ye));ve.set(M.IFileService,Je);const at=this._register(new x.DiskFileSystemProvider(Ye));Je.registerProvider(R.Schemas.file,at);const ct=this._register(new Dt.FileUserDataProvider(R.Schemas.file,this._register(new pt.DiskFileSystemProviderClient(Ke.getChannel(pt.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:Rt.isLinux})),R.Schemas.userData,Ye));Je.registerProvider(R.Schemas.userData,ct);const xe=this._register(new d.ConfigurationService($e.settingsResource,Je));ve.set(S.IConfigurationService,xe);const et=new ae.NativeStorageService(void 0,Ke,$e);ve.set(se.IStorageService,et),this._register((0,A.toDisposable)(()=>et.flush())),await Promise.all([xe.initialize(),et.initialize()]),ve.set(qe.IUriIdentityService,new Pt.UriIdentityService(Je)),ve.set(ee.IRequestService,new Q.SyncDescriptor(H.RequestService)),ve.set(w.IChecksumService,new Q.SyncDescriptor(y.ChecksumService)),ve.set(St.IV8InspectProfilingService,new Q.SyncDescriptor(kt.InspectProfilingService));const it=P.ProxyChannel.toService(Ke.getChannel("nativeHost"),{context:this.configuration.windowId});ve.set(F.INativeHostService,it),ve.set(r.IDownloadService,new Q.SyncDescriptor(n.DownloadService));const lt=this._register(new fe.ActiveWindowManager(it)),ut=new P.StaticRouter(Ve=>lt.getActiveClientId().then(dt=>Ve===dt));ve.set(U.IExtensionRecommendationNotificationService,new D.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ut)));const ht=new We.AssignmentService(this.configuration.machineId,xe,Ue);let rt;const Qe=[];if((0,Ce.supportsTelemetry)(Ue,$e)){const Ve=new Se.TelemetryLogAppender(Xe,$e);Qe.push(Ve);const{installSourcePath:dt}=$e;if(Ue.aiConfig&&Ue.aiConfig.asimovKey){const st=await ht.getTreatment("telemetryMigration")??!1,ft=Ue.quality!=="stable";if(ft&&st){const bt=new Ie.AppInsightsAppender("monacoworkbench",null,Ue.aiConfig.asimovKey,st,!0);this._register((0,A.toDisposable)(()=>bt.flush())),Qe.push(bt)}const Et=new Ie.AppInsightsAppender("monacoworkbench",null,Ue.aiConfig.asimovKey,ft?!1:st,st&&ft);this._register((0,A.toDisposable)(()=>Et.flush())),Qe.push(Et)}rt=new pe.TelemetryService({appenders:Qe,commonProperties:(0,de.resolveCommonProperties)(Je,(0,t.release)(),(0,t.hostname)(),process.arch,Ue.commit,Ue.version,this.configuration.machineId,Ue.msftInternalDomains,dt),sendErrorTelemetry:!0,piiPaths:(0,Ce.getPiiPathsFromEnvironment)($e)},xe)}else{rt=Ce.NullTelemetryService;const Ve=Ce.NullAppender;Qe.push(Ve)}this.server.registerChannel("telemetryAppender",new Ee.TelemetryAppenderChannel(Qe)),ve.set(ge.ITelemetryService,rt);const At=new De.CustomEndpointTelemetryService(xe,rt,Xe,$e);ve.set(ge.ICustomEndpointTelemetryService,At),ve.set(g.IExtensionManagementService,new Q.SyncDescriptor(O.ExtensionManagementService)),ve.set(g.IExtensionGalleryService,new Q.SyncDescriptor(l.ExtensionGalleryService)),ve.set(g.IExtensionTipsService,new Q.SyncDescriptor(_.ExtensionTipsService)),ve.set(V.ILocalizationsService,new Q.SyncDescriptor(J.LocalizationsService)),ve.set(i.IDiagnosticsService,new Q.SyncDescriptor(c.DiagnosticsService)),ve.set(ue.IUserDataSyncAccountService,new Q.SyncDescriptor(ue.UserDataSyncAccountService)),ve.set(ce.IUserDataSyncLogService,new Q.SyncDescriptor(Fe.UserDataSyncLogService)),ve.set(ce.IUserDataSyncUtilService,new be.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Ve=>Ve.ctx!=="main"))),ve.set(g.IGlobalExtensionEnablementService,new Q.SyncDescriptor(a.GlobalExtensionEnablementService)),ve.set(re.IIgnoredExtensionsManagementService,new Q.SyncDescriptor(re.IgnoredExtensionsManagementService)),ve.set(Be.IExtensionStorageService,new Q.SyncDescriptor(Be.ExtensionStorageService)),ve.set(ce.IUserDataSyncStoreManagementService,new Q.SyncDescriptor(oe.UserDataSyncStoreManagementService)),ve.set(ce.IUserDataSyncStoreService,new Q.SyncDescriptor(oe.UserDataSyncStoreService)),ve.set(Te.IUserDataSyncMachinesService,new Q.SyncDescriptor(Te.UserDataSyncMachinesService)),ve.set(ce.IUserDataSyncBackupStoreService,new Q.SyncDescriptor(we.UserDataSyncBackupStoreService)),ve.set(ce.IUserDataSyncEnablementService,new Q.SyncDescriptor(Oe.UserDataSyncEnablementService)),ve.set(ce.IUserDataSyncService,new Q.SyncDescriptor(_e.UserDataSyncService));const wt=new Ge.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:xe.getValue("terminal.integrated.persistentSessionScrollback")??100},xe,$e,Ye);return await wt.initialize(),ve.set(je.ILocalPtyService,this._register(wt)),ve.set(me.ISignService,new Q.SyncDescriptor(Le.SignService)),ve.set(ye.ISharedTunnelsService,new Q.SyncDescriptor(Re.SharedTunnelsService)),ve.set(ke.ISharedProcessTunnelService,new Q.SyncDescriptor(Pe.SharedProcessTunnelService)),new ie.InstantiationService(ve)}initChannels(ve){const Ue=new I.ExtensionManagementChannel(ve.get(g.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Ue);const ze=P.ProxyChannel.fromService(ve.get(V.ILocalizationsService));this.server.registerChannel("localizations",ze);const Ke=P.ProxyChannel.fromService(ve.get(i.IDiagnosticsService));this.server.registerChannel("diagnostics",Ke);const $e=new I.ExtensionTipsChannel(ve.get(g.IExtensionTipsService));this.server.registerChannel("extensionTipsService",$e);const nt=P.ProxyChannel.fromService(ve.get(w.IChecksumService));this.server.registerChannel("checksum",nt);const Xe=P.ProxyChannel.fromService(ve.get(St.IV8InspectProfilingService));this.server.registerChannel("v8InspectProfiling",Xe);const ot=new be.UserDataSyncMachinesServiceChannel(ve.get(Te.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",ot);const Ye=P.ProxyChannel.fromService(ve.get(ge.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",Ye);const Je=new be.UserDataSyncAccountServiceChannel(ve.get(ue.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Je);const at=new be.UserDataSyncStoreManagementServiceChannel(ve.get(ce.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",at);const ct=new X.UserDataSyncChannel(ve.get(ce.IUserDataSyncService),ve.get(Z.ILogService));this.server.registerChannel("userDataSync",ct);const xe=this._register(ve.get(W.IInstantiationService).createInstance(le.UserDataAutoSyncService)),et=new be.UserDataAutoSyncChannel(xe);this.server.registerChannel("userDataAutoSync",et);const it=ve.get(je.ILocalPtyService),lt=P.ProxyChannel.fromService(it);this.server.registerChannel(Me.TerminalIpcChannels.LocalPty,lt);const ut=P.ProxyChannel.fromService(ve.get(ke.ISharedProcessTunnelService));this.server.registerChannel(ke.ipcSharedProcessTunnelChannelName,ut);const ht=P.ProxyChannel.fromService(ve.get(Ae.ISharedProcessWorkerService));this.server.registerChannel(Ae.ipcSharedProcessWorkerChannelName,ht)}registerErrorHandler(ve){window.addEventListener("unhandledrejection",Ue=>{(0,T.onUnexpectedError)(Ue.reason),Ue.preventDefault()}),(0,T.setUnexpectedErrorHandler)(Ue=>{const ze=(0,L.toErrorMessage)(Ue,!0);!ze||ve.error(`[uncaught exception in sharedProcess]: ${ze}`)})}}async function Tt(yt){const ve=new Lt(yt);k.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ve.open(),k.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Tt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8908a9ca0f221f36507231afb39d2d8d1e182702/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
