/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var J=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/path","vs/base/common/uri","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","electron","vs/nls","vs/base/common/types","vs/base/common/errors","vs/base/common/buffer","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/platform/configuration/common/configuration","vs/platform/files/common/files","vs/platform/product/common/productService","vs/platform/environment/electron-main/environmentMainService","vs/base/common/cancellation","vs/base/node/pfs","vs/platform/workspace/common/workspace","os","vs/base/common/strings","vs/base/common/extpath","fs","vs/base/common/arrays","vs/base/common/uuid","vs/platform/telemetry/common/telemetry","vs/base/common/labels","vs/platform/windows/electron-main/windows","vs/base/common/map","vs/base/common/process","vs/base/parts/ipc/common/ipc","vs/platform/state/electron-main/state","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/functional","vs/base/common/json","child_process","vs/base/common/decorators","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/stream","vs/base/common/objects","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/environment/common/environment","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/parts/ipc/node/ipc.net","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/keybindings","crypto","net","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/telemetry/common/telemetryUtils","vs/platform/theme/electron-main/themeMainService","vs/platform/window/common/window","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/hash","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/remote/common/remoteHosts","vs/platform/sign/common/sign","vs/platform/workspaces/common/workspaces","vs/platform/storage/electron-main/storageMainService","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/keyCodes","vs/base/common/processes","vs/base/common/stopwatch","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/common/encryptionService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/storage/common/storage","vs/platform/terminal/node/shellEnv","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/codicons","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/keybindingParser","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/cache","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/common/worker/simpleWorker","vs/base/node/crypto","vs/base/node/decoder","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/node/shellEnv","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/encryption/node/encryptionMainService","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/resolvedKeybindingItem","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/credentials/node/credentialsMainService","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/extensions/electron-main/workerMainProcessExtensionHostStarter","zlib","vs/platform/driver/node/driver","vs/platform/backup/electron-main/backupMainService","vs/platform/driver/electron-main/driver","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","assert","path","graceful-fs","worker_threads","vs/code/electron-main/main"],Z=function(V){for(var e=[],m=0,n=V.length;m<n;m++)e[m]=J[V[m]];return e};define(J[106],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function m(n,L){if(!n)throw new Error(L?`Assertion failed (${L})`:"Assertion Failed")}e.ok=m}),define(J[107],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function m(M){return M?M.replace(/\$\((.*?)\)/g,(S,g)=>` ${g} `).trim():""}e.getCodiconAriaLabel=m;class n{constructor(S,g,b){this.id=S,this.definition=g,this.description=b,n._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return n._allCodicons}}e.Codicon=n,n._allCodicons=[],n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolCustomColor=new n("symbol-customcolor",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"}),n.layout=new n("layout",{fontCharacter:"\\ebeb"}),n.layoutActivitybarLeft=new n("layout-activitybar-left",{fontCharacter:"\\ebec"}),n.layoutActivitybarRight=new n("layout-activitybar-right",{fontCharacter:"\\ebed"}),n.layoutPanelLeft=new n("layout-panel-left",{fontCharacter:"\\ebee"}),n.layoutPanelCenter=new n("layout-panel-center",{fontCharacter:"\\ebef"}),n.layoutPanelJustify=new n("layout-panel-justify",{fontCharacter:"\\ebf0"}),n.layoutPanelRight=new n("layout-panel-right",{fontCharacter:"\\ebf1"}),n.layoutPanel=new n("layout-panel",{fontCharacter:"\\ebf2"}),n.layoutSidebarLeft=new n("layout-sidebar-left",{fontCharacter:"\\ebf3"}),n.layoutSidebarRight=new n("layout-sidebar-right",{fontCharacter:"\\ebf4"}),n.layoutStatusbar=new n("layout-statusbar",{fontCharacter:"\\ebf5"}),n.layoutMenubar=new n("layout-menubar",{fontCharacter:"\\ebf6"}),n.layoutCentered=new n("layout-centered",{fontCharacter:"\\ebf7"}),n.target=new n("target",{fontCharacter:"\\ebf8"}),n.indent=new n("indent",{fontCharacter:"\\ebf9"}),n.recordSmall=new n("record-small",{fontCharacter:"\\ebfa"}),n.errorSmall=new n("error-small",{fontCharacter:"\\ebfb"}),n.arrowCircleDown=new n("arrow-circle-down",{fontCharacter:"\\ebfc"}),n.arrowCircleLeft=new n("arrow-circle-left",{fontCharacter:"\\ebfd"}),n.arrowCircleRight=new n("arrow-circle-right",{fontCharacter:"\\ebfe"}),n.arrowCircleUp=new n("arrow-circle-up",{fontCharacter:"\\ebff"}),n.dialogError=new n("dialog-error",n.error.definition),n.dialogWarning=new n("dialog-warning",n.warning.definition),n.dialogInfo=new n("dialog-info",n.info.definition),n.dialogClose=new n("dialog-close",n.close.definition),n.treeItemExpanded=new n("tree-item-expanded",n.chevronDown.definition),n.treeFilterOnTypeOn=new n("tree-filter-on-type-on",n.listFilter.definition),n.treeFilterOnTypeOff=new n("tree-filter-on-type-off",n.listSelection.definition),n.treeFilterClear=new n("tree-filter-clear",n.close.definition),n.treeItemLoading=new n("tree-item-loading",n.loading.definition),n.menuSelection=new n("menu-selection",n.check.definition),n.menuSubmenu=new n("menu-submenu",n.chevronRight.definition),n.menuBarMore=new n("menubar-more",n.more.definition),n.scrollbarButtonLeft=new n("scrollbar-button-left",n.triangleLeft.definition),n.scrollbarButtonRight=new n("scrollbar-button-right",n.triangleRight.definition),n.scrollbarButtonUp=new n("scrollbar-button-up",n.triangleUp.definition),n.scrollbarButtonDown=new n("scrollbar-button-down",n.triangleDown.definition),n.toolBarMore=new n("toolbar-more",n.more.definition),n.quickInputBack=new n("quick-input-back",n.arrowLeft.definition);function L(M,S){const g=["codicon","codicon-"+M];return S&&g.push("codicon-modifier-"+S),g}e.getClassNamesArray=L;var D;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const S=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function g(I){if(I instanceof n)return["codicon","codicon-"+I.id];const E=S.exec(I.id);if(!E)return g(n.error);let[,w,t]=E;const d=["codicon","codicon-"+w];return t&&d.push("codicon-modifier-"+t.substr(1)),d}M.asClassNameArray=g;function b(I){return g(I).join(" ")}M.asClassName=b;function C(I){return"."+g(I).join(".")}M.asCSSSelector=C})(D=e.CSSIcon||(e.CSSIcon={}))}),define(J[46],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function m(M){return(S,g,b)=>{let C=null,I=null;if(typeof b.value=="function"?(C="value",I=b.value):typeof b.get=="function"&&(C="get",I=b.get),!I)throw new Error("not supported");b[C]=M(I,g)}}e.createDecorator=m;function n(M,S,g){let b=null,C=null;if(typeof g.value=="function"?(b="value",C=g.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(b="get",C=g.get),!C)throw new Error("not supported");const I=`$memoize$${S}`;g[b]=function(...E){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,E)}),this[I]}}e.memoize=n;function L(M,S,g){return m((b,C)=>{const I=`$debounce$${C}`,E=`$debounce$result$${C}`;return function(...w){this[E]||(this[E]=g?g():void 0),clearTimeout(this[I]),S&&(this[E]=S(this[E],...w),w=[this[E]]),this[I]=setTimeout(()=>{b.apply(this,w),this[E]=g?g():void 0},M)}})}e.debounce=L;function D(M,S,g){return m((b,C)=>{const I=`$throttle$timer$${C}`,E=`$throttle$result$${C}`,w=`$throttle$lastRun$${C}`,t=`$throttle$pending$${C}`;return function(...d){if(this[E]||(this[E]=g?g():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),S&&(this[E]=S(this[E],...d)),this[t])return;const p=this[w]+M;p<=Date.now()?(this[w]=Date.now(),b.apply(this,[this[E]]),this[E]=g?g():void 0):(this[t]=!0,this[I]=setTimeout(()=>{this[t]=!1,this[w]=Date.now(),b.apply(this,[this[E]]),this[E]=g?g():void 0},p-Date.now()))}})}e.throttle=D}),define(J[15],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class m{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(c){setTimeout(()=>{throw c.stack?new Error(c.message+`

`+c.stack):c},0)}}addListener(c){return this.listeners.push(c),()=>{this._removeListener(c)}}emit(c){this.listeners.forEach(a=>{a(c)})}_removeListener(c){this.listeners.splice(this.listeners.indexOf(c),1)}setUnexpectedErrorHandler(c){this.unexpectedErrorHandler=c}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(c){this.unexpectedErrorHandler(c),this.emit(c)}onUnexpectedExternalError(c){this.unexpectedErrorHandler(c)}}e.ErrorHandler=m,e.errorHandler=new m;function n(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=n;function L(l){g(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=L;function D(l){g(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=D;function M(l){if(l instanceof Error){let{name:c,message:a}=l;const f=l.stacktrace||l.stack;return{$isError:!0,name:c,message:a,stack:f}}return l}e.transformErrorForSerialization=M;const S="Canceled";function g(l){return l instanceof b?!0:l instanceof Error&&l.name===S&&l.message===S}e.isCancellationError=g;class b extends Error{constructor(){super(S);this.name=this.message}}e.CancellationError=b;function C(){const l=new Error(S);return l.name=l.message,l}e.canceled=C;function I(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=I;function E(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=E;function w(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=w;function t(l){const c=new Error(`${l} has been disposed`);return c.name="DISPOSED",c}e.disposed=t;function d(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=d;class p extends Error{constructor(c){super("NotImplemented");c&&(this.message=c)}}e.NotImplementedError=p;class v extends Error{constructor(c){super("NotSupported");c&&(this.message=c)}}e.NotSupportedError=v;class P extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=P;class h extends Error{constructor(){super(...arguments);this.logTelemetry=!1}}e.ErrorNoTelemetry=h}),define(J[30],Z([0,1,15]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function n(T,A=0){return T[T.length-(1+A)]}e.tail=n;function L(T){if(T.length===0)throw new Error("Invalid tail call");return[T.slice(0,T.length-1),T[T.length-1]]}e.tail2=L;function D(T,A,O=(_,j)=>_===j){if(T===A)return!0;if(!T||!A||T.length!==A.length)return!1;for(let _=0,j=T.length;_<j;_++)if(!O(T[_],A[_]))return!1;return!0}e.equals=D;function M(T,A,O){let _=0,j=T.length-1;for(;_<=j;){const ne=(_+j)/2|0,ae=O(T[ne],A);if(ae<0)_=ne+1;else if(ae>0)j=ne-1;else return ne}return-(_+1)}e.binarySearch=M;function S(T,A){let O=0,_=T.length;if(_===0)return 0;for(;O<_;){const j=Math.floor((O+_)/2);A(T[j])?_=j:O=j+1}return O}e.findFirstInSorted=S;function g(T,A,O){if(T=T|0,T>=A.length)throw new TypeError("invalid index");let _=A[Math.floor(A.length*Math.random())],j=[],ne=[],ae=[];for(let ce of A){const re=O(ce,_);re<0?j.push(ce):re>0?ne.push(ce):ae.push(ce)}return T<j.length?g(T,j,O):T<j.length+ae.length?ae[0]:g(T-(j.length+ae.length),ne,O)}e.quickSelect=g;function b(T,A){const O=[];let _;for(const j of T.slice(0).sort(A))!_||A(_[0],j)!==0?(_=[j],O.push(_)):_.push(j);return O}e.groupBy=b;function C(T,A,O){const _=[];function j(ce,re,le){if(re===0&&le.length===0)return;const he=_[_.length-1];he&&he.start+he.deleteCount===ce?(he.deleteCount+=re,he.toInsert.push(...le)):_.push({start:ce,deleteCount:re,toInsert:le})}let ne=0,ae=0;for(;;){if(ne===T.length){j(ne,0,A.slice(ae));break}if(ae===A.length){j(ne,T.length-ne,[]);break}const ce=T[ne],re=A[ae],le=O(ce,re);le===0?(ne+=1,ae+=1):le<0?(j(ne,1,[]),ne+=1):le>0&&(j(ne,0,[re]),ae+=1)}return _}e.sortedDiff=C;function I(T,A,O){const _=C(T,A,O),j=[],ne=[];for(const ae of _)j.push(...T.slice(ae.start,ae.start+ae.deleteCount)),ne.push(...ae.toInsert);return{removed:j,added:ne}}e.delta=I;function E(T,A,O){if(O===0)return[];const _=T.slice(0,O).sort(A);return t(T,A,_,O,T.length),_}e.top=E;function w(T,A,O,_,j){return O===0?Promise.resolve([]):new Promise((ne,ae)=>{(async()=>{const ce=T.length,re=T.slice(0,O).sort(A);for(let le=O,he=Math.min(O+_,ce);le<ce;le=he,he=Math.min(he+_,ce)){if(le>O&&await new Promise(we=>setTimeout(we)),j&&j.isCancellationRequested)throw(0,m.canceled)();t(T,A,re,le,he)}return re})().then(ne,ae)})}e.topAsync=w;function t(T,A,O,_,j){for(const ne=O.length;_<j;_++){const ae=T[_];if(A(ae,O[ne-1])<0){O.pop();const ce=S(O,re=>A(ae,re)<0);O.splice(ce,0,ae)}}}function d(T){return T.filter(A=>!!A)}e.coalesce=d;function p(T){let A=0;for(let O=0;O<T.length;O++)T[O]&&(T[A]=T[O],A+=1);T.length=A}e.coalesceInPlace=p;function v(T,A,O){T.splice(O,0,T.splice(A,1)[0])}e.move=v;function P(T){return!Array.isArray(T)||T.length===0}e.isFalsyOrEmpty=P;function h(T){return Array.isArray(T)&&T.length>0}e.isNonEmptyArray=h;function l(T,A=O=>O){const O=new Set;return T.filter(_=>{const j=A(_);return O.has(j)?!1:(O.add(j),!0)})}e.distinct=l;function c(T){const A=new Set;return O=>{const _=T(O);return A.has(_)?!1:(A.add(_),!0)}}e.uniqueFilter=c;function a(T,A){const O=f(T,A);if(O!==-1)return T[O]}e.findLast=a;function f(T,A){for(let O=T.length-1;O>=0;O--){const _=T[O];if(A(_))return O}return-1}e.lastIndex=f;function r(T,A){return T.length>0?T[0]:A}e.firstOrDefault=r;function i(T,A,O=(_,j)=>_===j){let _=0;for(let j=0,ne=Math.min(T.length,A.length);j<ne&&O(T[j],A[j]);j++)_++;return _}e.commonPrefixLength=i;function s(T){return[].concat(...T)}e.flatten=s;function o(T,A){let O=typeof A=="number"?T:0;typeof A=="number"?O=T:(O=0,A=T);const _=[];if(O<=A)for(let j=O;j<A;j++)_.push(j);else for(let j=O;j>A;j--)_.push(j);return _}e.range=o;function u(T,A,O){return T.reduce((_,j)=>(_[A(j)]=O?O(j):j,_),Object.create(null))}e.index=u;function y(T,A){return T.push(A),()=>k(T,A)}e.insert=y;function k(T,A){const O=T.indexOf(A);if(O>-1)return T.splice(O,1),A}e.remove=k;function R(T,A,O){const _=T.slice(0,A),j=T.slice(A);return _.concat(O,j)}e.arrayInsert=R;function W(T,A){let O;if(typeof A=="number"){let _=A;O=()=>{const j=Math.sin(_++)*179426549;return j-Math.floor(j)}}else O=Math.random;for(let _=T.length-1;_>0;_-=1){const j=Math.floor(O()*(_+1)),ne=T[_];T[_]=T[j],T[j]=ne}}e.shuffle=W;function U(T,A){const O=T.indexOf(A);O>-1&&(T.splice(O,1),T.unshift(A))}e.pushToStart=U;function K(T,A){const O=T.indexOf(A);O>-1&&(T.splice(O,1),T.push(A))}e.pushToEnd=K;function x(T,A){return Array.isArray(T)?T.map(A):A(T)}e.mapArrayOrNot=x;function ee(T){return Array.isArray(T)?T:[T]}e.asArray=ee;function Q(T){return T[Math.floor(Math.random()*T.length)]}e.getRandomElement=Q;function H(T,A){for(const O of T){const _=A(O);if(_!==void 0)return _}}e.mapFind=H;function X(T,A,O){const _=ie(T,A),j=T.length,ne=O.length;T.length=j+ne;for(let ae=j-1;ae>=_;ae--)T[ae+ne]=T[ae];for(let ae=0;ae<ne;ae++)T[ae+_]=O[ae]}e.insertInto=X;function z(T,A,O,_){const j=ie(T,A),ne=T.splice(j,O);return X(T,j,_),ne}e.splice=z;function ie(T,A){return A<0?Math.max(A+T.length,0):Math.min(A,T.length)}function $(T,A){return(O,_)=>A(T(O),T(_))}e.compareBy=$;const q=(T,A)=>T-A;e.numberComparator=q;function Y(T,A){if(T.length===0)return;let O=T[0];for(let _=1;_<T.length;_++){const j=T[_];A(j,O)>0&&(O=j)}return O}e.findMaxBy=Y;function B(T,A){if(T.length===0)return;let O=T[0];for(let _=1;_<T.length;_++){const j=T[_];A(j,O)>=0&&(O=j)}return O}e.findLastMaxBy=B;function F(T,A){return Y(T,(O,_)=>-A(O,_))}e.findMinBy=F;class N{constructor(A){this.items=A,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(A){let O=this.firstIdx;for(;O<this.items.length&&A(this.items[O]);)O++;const _=O===this.firstIdx?null:this.items.slice(this.firstIdx,O);return this.firstIdx=O,_}takeFromEndWhile(A){let O=this.lastIdx;for(;O>=0&&A(this.items[O]);)O--;const _=O===this.lastIdx?null:this.items.slice(O+1,this.lastIdx+1);return this.lastIdx=O,_}peek(){return this.items[this.firstIdx]}dequeue(){const A=this.items[this.firstIdx];return this.firstIdx++,A}takeCount(A){const O=this.items.slice(this.firstIdx,this.firstIdx+A);return this.firstIdx+=A,O}}e.ArrayQueue=N}),define(J[43],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function m(n){const L=this;let D=!1,M;return function(){return D||(D=!0,M=n.apply(L,arguments)),M}}e.once=m}),define(J[68],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var m;(function(n){function L(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}n.is=L;const D=Object.freeze([]);function M(){return D}n.empty=M;function*S(c){yield c}n.single=S;function g(c){return c||D}n.from=g;function b(c){return!c||c[Symbol.iterator]().next().done===!0}n.isEmpty=b;function C(c){return c[Symbol.iterator]().next().value}n.first=C;function I(c,a){for(const f of c)if(a(f))return!0;return!1}n.some=I;function E(c,a){for(const f of c)if(a(f))return f}n.find=E;function*w(c,a){for(const f of c)a(f)&&(yield f)}n.filter=w;function*t(c,a){let f=0;for(const r of c)yield a(r,f++)}n.map=t;function*d(...c){for(const a of c)for(const f of a)yield f}n.concat=d;function*p(c){for(const a of c)for(const f of a)yield f}n.concatNested=p;function v(c,a,f){let r=f;for(const i of c)r=a(r,i);return r}n.reduce=v;function*P(c,a,f=c.length){for(a<0&&(a+=c.length),f<0?f+=c.length:f>c.length&&(f=c.length);a<f;a++)yield c[a]}n.slice=P;function h(c,a=Number.POSITIVE_INFINITY){const f=[];if(a===0)return[f,c];const r=c[Symbol.iterator]();for(let i=0;i<a;i++){const s=r.next();if(s.done)return[f,n.empty()];f.push(s.value)}return[f,{[Symbol.iterator](){return r}}]}n.consume=h;function l(c,a,f=(r,i)=>r===i){const r=c[Symbol.iterator](),i=a[Symbol.iterator]();for(;;){const s=r.next(),o=i.next();if(s.done!==o.done)return!1;if(s.done)return!0;if(!f(s.value,o.value))return!1}}n.equals=l})(m=e.Iterable||(e.Iterable={}))}),define(J[44],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var m;(function(a){a[a.None=0]="None",a[a.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=2]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",a[a.InvalidUnicode=4]="InvalidUnicode",a[a.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",a[a.InvalidCharacter=6]="InvalidCharacter"})(m=e.ScanError||(e.ScanError={}));var n;(function(a){a[a.OpenBraceToken=1]="OpenBraceToken",a[a.CloseBraceToken=2]="CloseBraceToken",a[a.OpenBracketToken=3]="OpenBracketToken",a[a.CloseBracketToken=4]="CloseBracketToken",a[a.CommaToken=5]="CommaToken",a[a.ColonToken=6]="ColonToken",a[a.NullKeyword=7]="NullKeyword",a[a.TrueKeyword=8]="TrueKeyword",a[a.FalseKeyword=9]="FalseKeyword",a[a.StringLiteral=10]="StringLiteral",a[a.NumericLiteral=11]="NumericLiteral",a[a.LineCommentTrivia=12]="LineCommentTrivia",a[a.BlockCommentTrivia=13]="BlockCommentTrivia",a[a.LineBreakTrivia=14]="LineBreakTrivia",a[a.Trivia=15]="Trivia",a[a.Unknown=16]="Unknown",a[a.EOF=17]="EOF"})(n=e.SyntaxKind||(e.SyntaxKind={}));var L;(function(a){a[a.InvalidSymbol=1]="InvalidSymbol",a[a.InvalidNumberFormat=2]="InvalidNumberFormat",a[a.PropertyNameExpected=3]="PropertyNameExpected",a[a.ValueExpected=4]="ValueExpected",a[a.ColonExpected=5]="ColonExpected",a[a.CommaExpected=6]="CommaExpected",a[a.CloseBraceExpected=7]="CloseBraceExpected",a[a.CloseBracketExpected=8]="CloseBracketExpected",a[a.EndOfFileExpected=9]="EndOfFileExpected",a[a.InvalidCommentToken=10]="InvalidCommentToken",a[a.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=12]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",a[a.InvalidUnicode=14]="InvalidUnicode",a[a.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",a[a.InvalidCharacter=16]="InvalidCharacter"})(L=e.ParseErrorCode||(e.ParseErrorCode={}));var D;(function(a){a.DEFAULT={allowTrailingComma:!0}})(D=e.ParseOptions||(e.ParseOptions={}));function M(a,f=!1){let r=0,i=a.length,s="",o=0,u=16,y=0;function k(Q){let H=0,X=0;for(;H<Q;){const z=a.charCodeAt(r);if(z>=48&&z<=57)X=X*16+z-48;else if(z>=65&&z<=70)X=X*16+z-65+10;else if(z>=97&&z<=102)X=X*16+z-97+10;else break;r++,H++}return H<Q&&(X=-1),X}function R(Q){r=Q,s="",o=0,u=16,y=0}function W(){const Q=r;if(a.charCodeAt(r)===48)r++;else for(r++;r<a.length&&b(a.charCodeAt(r));)r++;if(r<a.length&&a.charCodeAt(r)===46)if(r++,r<a.length&&b(a.charCodeAt(r)))for(r++;r<a.length&&b(a.charCodeAt(r));)r++;else return y=3,a.substring(Q,r);let H=r;if(r<a.length&&(a.charCodeAt(r)===69||a.charCodeAt(r)===101))if(r++,(r<a.length&&a.charCodeAt(r)===43||a.charCodeAt(r)===45)&&r++,r<a.length&&b(a.charCodeAt(r))){for(r++;r<a.length&&b(a.charCodeAt(r));)r++;H=r}else y=3;return a.substring(Q,H)}function U(){let Q="",H=r;for(;;){if(r>=i){Q+=a.substring(H,r),y=2;break}const X=a.charCodeAt(r);if(X===34){Q+=a.substring(H,r),r++;break}if(X===92){if(Q+=a.substring(H,r),r++,r>=i){y=2;break}switch(a.charCodeAt(r++)){case 34:Q+='"';break;case 92:Q+="\\";break;case 47:Q+="/";break;case 98:Q+="\b";break;case 102:Q+="\f";break;case 110:Q+=`
`;break;case 114:Q+="\r";break;case 116:Q+="	";break;case 117:{const ie=k(4);ie>=0?Q+=String.fromCharCode(ie):y=4;break}default:y=5}H=r;continue}if(X>=0&&X<=31)if(g(X)){Q+=a.substring(H,r),y=2;break}else y=6;r++}return Q}function K(){if(s="",y=0,o=r,r>=i)return o=i,u=17;let Q=a.charCodeAt(r);if(S(Q)){do r++,s+=String.fromCharCode(Q),Q=a.charCodeAt(r);while(S(Q));return u=15}if(g(Q))return r++,s+=String.fromCharCode(Q),Q===13&&a.charCodeAt(r)===10&&(r++,s+=`
`),u=14;switch(Q){case 123:return r++,u=1;case 125:return r++,u=2;case 91:return r++,u=3;case 93:return r++,u=4;case 58:return r++,u=6;case 44:return r++,u=5;case 34:return r++,s=U(),u=10;case 47:{const H=r-1;if(a.charCodeAt(r+1)===47){for(r+=2;r<i&&!g(a.charCodeAt(r));)r++;return s=a.substring(H,r),u=12}if(a.charCodeAt(r+1)===42){r+=2;const X=i-1;let z=!1;for(;r<X;){if(a.charCodeAt(r)===42&&a.charCodeAt(r+1)===47){r+=2,z=!0;break}r++}return z||(r++,y=1),s=a.substring(H,r),u=13}return s+=String.fromCharCode(Q),r++,u=16}case 45:if(s+=String.fromCharCode(Q),r++,r===i||!b(a.charCodeAt(r)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=W(),u=11;default:for(;r<i&&x(Q);)r++,Q=a.charCodeAt(r);if(o!==r){switch(s=a.substring(o,r),s){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return s+=String.fromCharCode(Q),r++,u=16}}function x(Q){if(S(Q)||g(Q))return!1;switch(Q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ee(){let Q;do Q=K();while(Q>=12&&Q<=15);return Q}return{setPosition:R,getPosition:()=>r,scan:f?ee:K,getToken:()=>u,getTokenValue:()=>s,getTokenOffset:()=>o,getTokenLength:()=>r-o,getTokenError:()=>y}}e.createScanner=M;function S(a){return a===32||a===9||a===11||a===12||a===160||a===5760||a>=8192&&a<=8203||a===8239||a===8287||a===12288||a===65279}function g(a){return a===10||a===13||a===8232||a===8233}function b(a){return a>=48&&a<=57}var C;(function(a){a[a.nullCharacter=0]="nullCharacter",a[a.maxAsciiCharacter=127]="maxAsciiCharacter",a[a.lineFeed=10]="lineFeed",a[a.carriageReturn=13]="carriageReturn",a[a.lineSeparator=8232]="lineSeparator",a[a.paragraphSeparator=8233]="paragraphSeparator",a[a.nextLine=133]="nextLine",a[a.space=32]="space",a[a.nonBreakingSpace=160]="nonBreakingSpace",a[a.enQuad=8192]="enQuad",a[a.emQuad=8193]="emQuad",a[a.enSpace=8194]="enSpace",a[a.emSpace=8195]="emSpace",a[a.threePerEmSpace=8196]="threePerEmSpace",a[a.fourPerEmSpace=8197]="fourPerEmSpace",a[a.sixPerEmSpace=8198]="sixPerEmSpace",a[a.figureSpace=8199]="figureSpace",a[a.punctuationSpace=8200]="punctuationSpace",a[a.thinSpace=8201]="thinSpace",a[a.hairSpace=8202]="hairSpace",a[a.zeroWidthSpace=8203]="zeroWidthSpace",a[a.narrowNoBreakSpace=8239]="narrowNoBreakSpace",a[a.ideographicSpace=12288]="ideographicSpace",a[a.mathematicalSpace=8287]="mathematicalSpace",a[a.ogham=5760]="ogham",a[a._=95]="_",a[a.$=36]="$",a[a._0=48]="_0",a[a._1=49]="_1",a[a._2=50]="_2",a[a._3=51]="_3",a[a._4=52]="_4",a[a._5=53]="_5",a[a._6=54]="_6",a[a._7=55]="_7",a[a._8=56]="_8",a[a._9=57]="_9",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.ampersand=38]="ampersand",a[a.asterisk=42]="asterisk",a[a.at=64]="at",a[a.backslash=92]="backslash",a[a.bar=124]="bar",a[a.caret=94]="caret",a[a.closeBrace=125]="closeBrace",a[a.closeBracket=93]="closeBracket",a[a.closeParen=41]="closeParen",a[a.colon=58]="colon",a[a.comma=44]="comma",a[a.dot=46]="dot",a[a.doubleQuote=34]="doubleQuote",a[a.equals=61]="equals",a[a.exclamation=33]="exclamation",a[a.greaterThan=62]="greaterThan",a[a.lessThan=60]="lessThan",a[a.minus=45]="minus",a[a.openBrace=123]="openBrace",a[a.openBracket=91]="openBracket",a[a.openParen=40]="openParen",a[a.percent=37]="percent",a[a.plus=43]="plus",a[a.question=63]="question",a[a.semicolon=59]="semicolon",a[a.singleQuote=39]="singleQuote",a[a.slash=47]="slash",a[a.tilde=126]="tilde",a[a.backspace=8]="backspace",a[a.formFeed=12]="formFeed",a[a.byteOrderMark=65279]="byteOrderMark",a[a.tab=9]="tab",a[a.verticalTab=11]="verticalTab"})(C||(C={}));function I(a,f){const r=[],i=new Object;let s;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function y(k,R,W,U){o.value=k,o.offset=R,o.length=W,o.type=U,o.colonOffset=void 0,s=o}try{h(a,{onObjectBegin:(k,R)=>{if(f<=k)throw i;s=void 0,u=f>k,r.push("")},onObjectProperty:(k,R,W)=>{if(f<R||(y(k,R,W,"property"),r[r.length-1]=k,f<=R+W))throw i},onObjectEnd:(k,R)=>{if(f<=k)throw i;s=void 0,r.pop()},onArrayBegin:(k,R)=>{if(f<=k)throw i;s=void 0,r.push(0)},onArrayEnd:(k,R)=>{if(f<=k)throw i;s=void 0,r.pop()},onLiteralValue:(k,R,W)=>{if(f<R||(y(k,R,W,c(k)),f<=R+W))throw i},onSeparator:(k,R,W)=>{if(f<=R)throw i;if(k===":"&&s&&s.type==="property")s.colonOffset=R,u=!1,s=void 0;else if(k===","){const U=r[r.length-1];typeof U=="number"?r[r.length-1]=U+1:(u=!0,r[r.length-1]=""),s=void 0}}})}catch(k){if(k!==i)throw k}return{path:r,previousNode:s,isAtPropertyKey:u,matches:k=>{let R=0;for(let W=0;R<k.length&&W<r.length;W++)if(k[R]===r[W]||k[R]==="*")R++;else if(k[R]!=="**")return!1;return R===k.length}}}e.getLocation=I;function E(a,f=[],r=D.DEFAULT){let i=null,s=[];const o=[];function u(k){Array.isArray(s)?s.push(k):i!==null&&(s[i]=k)}return h(a,{onObjectBegin:()=>{const k={};u(k),o.push(s),s=k,i=null},onObjectProperty:k=>{i=k},onObjectEnd:()=>{s=o.pop()},onArrayBegin:()=>{const k=[];u(k),o.push(s),s=k,i=null},onArrayEnd:()=>{s=o.pop()},onLiteralValue:u,onError:(k,R,W)=>{f.push({error:k,offset:R,length:W})}},r),s[0]}e.parse=E;function w(a,f=[],r=D.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(k){i.type==="property"&&(i.length=k-i.offset,i=i.parent)}function o(k){return i.children.push(k),k}h(a,{onObjectBegin:k=>{i=o({type:"object",offset:k,length:-1,parent:i,children:[]})},onObjectProperty:(k,R,W)=>{i=o({type:"property",offset:R,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:k,offset:R,length:W,parent:i})},onObjectEnd:(k,R)=>{i.length=k+R-i.offset,i=i.parent,s(k+R)},onArrayBegin:(k,R)=>{i=o({type:"array",offset:k,length:-1,parent:i,children:[]})},onArrayEnd:(k,R)=>{i.length=k+R-i.offset,i=i.parent,s(k+R)},onLiteralValue:(k,R,W)=>{o({type:c(k),offset:R,length:W,parent:i,value:k}),s(R+W)},onSeparator:(k,R,W)=>{i.type==="property"&&(k===":"?i.colonOffset=R:k===","&&s(R))},onError:(k,R,W)=>{f.push({error:k,offset:R,length:W})}},r);const y=i.children[0];return y&&delete y.parent,y}e.parseTree=w;function t(a,f){if(!a)return;let r=a;for(let i of f)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let s=!1;for(const o of r.children)if(Array.isArray(o.children)&&o.children[0].value===i){r=o.children[1],s=!0;break}if(!s)return}else{const s=i;if(r.type!=="array"||s<0||!Array.isArray(r.children)||s>=r.children.length)return;r=r.children[s]}return r}e.findNodeAtLocation=t;function d(a){if(!a.parent||!a.parent.children)return[];const f=d(a.parent);if(a.parent.type==="property"){const r=a.parent.children[0].value;f.push(r)}else if(a.parent.type==="array"){const r=a.parent.children.indexOf(a);r!==-1&&f.push(r)}return f}e.getNodePath=d;function p(a){switch(a.type){case"array":return a.children.map(p);case"object":{const f=Object.create(null);for(let r of a.children){const i=r.children[1];i&&(f[r.children[0].value]=p(i))}return f}case"null":case"string":case"number":case"boolean":return a.value;default:return}}e.getNodeValue=p;function v(a,f,r=!1){return f>=a.offset&&f<a.offset+a.length||r&&f===a.offset+a.length}e.contains=v;function P(a,f,r=!1){if(v(a,f,r)){const i=a.children;if(Array.isArray(i))for(let s=0;s<i.length&&i[s].offset<=f;s++){const o=P(i[s],f,r);if(o)return o}return a}}e.findNodeAtOffset=P;function h(a,f,r=D.DEFAULT){const i=M(a,!1);function s(N){return N?()=>N(i.getTokenOffset(),i.getTokenLength()):()=>!0}function o(N){return N?T=>N(T,i.getTokenOffset(),i.getTokenLength()):()=>!0}const u=s(f.onObjectBegin),y=o(f.onObjectProperty),k=s(f.onObjectEnd),R=s(f.onArrayBegin),W=s(f.onArrayEnd),U=o(f.onLiteralValue),K=o(f.onSeparator),x=s(f.onComment),ee=o(f.onError),Q=r&&r.disallowComments,H=r&&r.allowTrailingComma;function X(){for(;;){const N=i.scan();switch(i.getTokenError()){case 4:z(14);break;case 5:z(15);break;case 3:z(13);break;case 1:Q||z(11);break;case 2:z(12);break;case 6:z(16);break}switch(N){case 12:case 13:Q?z(10):x();break;case 16:z(1);break;case 15:case 14:break;default:return N}}}function z(N,T=[],A=[]){if(ee(N),T.length+A.length>0){let O=i.getToken();for(;O!==17;){if(T.indexOf(O)!==-1){X();break}else if(A.indexOf(O)!==-1)break;O=X()}}}function ie(N){const T=i.getTokenValue();return N?U(T):y(T),X(),!0}function $(){switch(i.getToken()){case 11:{let N=0;try{N=JSON.parse(i.getTokenValue()),typeof N!="number"&&(z(2),N=0)}catch{z(2)}U(N);break}case 7:U(null);break;case 8:U(!0);break;case 9:U(!1);break;default:return!1}return X(),!0}function q(){return i.getToken()!==10?(z(3,[],[2,5]),!1):(ie(!1),i.getToken()===6?(K(":"),X(),F()||z(4,[],[2,5])):z(5,[],[2,5]),!0)}function Y(){u(),X();let N=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(N||z(4,[],[]),K(","),X(),i.getToken()===2&&H)break}else N&&z(6,[],[]);q()||z(4,[],[2,5]),N=!0}return k(),i.getToken()!==2?z(7,[2],[]):X(),!0}function B(){R(),X();let N=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(N||z(4,[],[]),K(","),X(),i.getToken()===4&&H)break}else N&&z(6,[],[]);F()||z(4,[],[4,5]),N=!0}return W(),i.getToken()!==4?z(8,[4],[]):X(),!0}function F(){switch(i.getToken()){case 3:return B();case 1:return Y();case 10:return ie(!0);default:return $()}}return X(),i.getToken()===17?r.allowEmptyContent?!0:(z(4,[],[]),!1):F()?(i.getToken()!==17&&z(9,[],[]),!0):(z(4,[],[]),!1)}e.visit=h;function l(a,f){let r=M(a),i=[],s,o=0,u;do switch(u=r.getPosition(),s=r.scan(),s){case 12:case 13:case 17:o!==u&&i.push(a.substring(o,u)),f!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,f)),o=r.getPosition();break}while(s!==17);return i.join("")}e.stripComments=l;function c(a){switch(typeof a){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(a){if(Array.isArray(a))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(J[108],Z([0,1,44]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function n(b,C,I){let E,w,t,d,p;if(C){for(d=C.offset,p=d+C.length,t=d;t>0&&!g(b,t-1);)t--;let u=p;for(;u<b.length&&!g(b,u);)u++;w=b.substring(t,u),E=M(w,I)}else w=b,E=0,t=0,d=0,p=b.length;const v=S(I,b);let P=!1,h=0,l;I.insertSpaces?l=D(" ",I.tabSize||4):l="	";const c=(0,m.createScanner)(w,!1);let a=!1;function f(){return v+D(l,E+h)}function r(){let u=c.scan();for(P=!1;u===15||u===14;)P=P||u===14,u=c.scan();return a=u===16||c.getTokenError()!==0,u}const i=[];function s(u,y,k){!a&&y<p&&k>d&&b.substring(y,k)!==u&&i.push({offset:y,length:k-y,content:u})}let o=r();if(o!==17){const u=c.getTokenOffset()+t,y=D(l,E);s(y,t,u)}for(;o!==17;){let u=c.getTokenOffset()+c.getTokenLength()+t,y=r(),k="";for(;!P&&(y===12||y===13);){const W=c.getTokenOffset()+t;s(" ",u,W),u=c.getTokenOffset()+c.getTokenLength()+t,k=y===12?f():"",y=r()}if(y===2)o!==1&&(h--,k=f());else if(y===4)o!==3&&(h--,k=f());else{switch(o){case 3:case 1:h++,k=f();break;case 5:case 12:k=f();break;case 13:P?k=f():k=" ";break;case 6:k=" ";break;case 10:if(y===6){k="";break}case 7:case 8:case 9:case 11:case 2:case 4:y===12||y===13?k=" ":y!==5&&y!==17&&(a=!0);break;case 16:a=!0;break}P&&(y===12||y===13)&&(k=f())}const R=c.getTokenOffset()+t;s(k,u,R),o=y}return i}e.format=n;function L(b,C){const I=JSON.stringify(b,void 0,C.insertSpaces?C.tabSize||4:"	");return C.eol!==void 0?I.replace(/\r\n|\r|\n/g,C.eol):I}e.toFormattedString=L;function D(b,C){let I="";for(let E=0;E<C;E++)I+=b;return I}function M(b,C){let I=0,E=0;const w=C.tabSize||4;for(;I<b.length;){const t=b.charAt(I);if(t===" ")E++;else if(t==="	")E+=w;else break;I++}return Math.floor(E/w)}function S(b,C){for(let I=0;I<C.length;I++){const E=C.charAt(I);if(E==="\r")return I+1<C.length&&C.charAt(I+1)===`
`?`\r
`:"\r";if(E===`
`)return`
`}return b&&b.eol||`
`}e.getEOL=S;function g(b,C){return`\r
`.indexOf(b.charAt(C))!==-1}e.isEOL=g}),define(J[109],Z([0,1,44,108]),function(V,e,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function L(b,C,I){return D(b,C,void 0,I)}e.removeProperty=L;function D(b,C,I,E,w){const t=C.slice(),d=[],p=(0,m.parseTree)(b,d);let v,P;for(;t.length>0&&(P=t.pop(),v=(0,m.findNodeAtLocation)(p,t),v===void 0&&I!==void 0);)typeof P=="string"?I={[P]:I}:I=[I];if(v)if(v.type==="object"&&typeof P=="string"&&Array.isArray(v.children)){const h=(0,m.findNodeAtLocation)(v,[P]);if(h!==void 0)if(I===void 0){if(!h.parent)throw new Error("Malformed AST");const l=v.children.indexOf(h.parent);let c,a=h.parent.offset+h.parent.length;if(l>0){const f=v.children[l-1];c=f.offset+f.length}else c=v.offset+1,v.children.length>1&&(a=v.children[1].offset);return M(b,{offset:c,length:a-c,content:""},E)}else return M(b,{offset:h.offset,length:h.length,content:JSON.stringify(I)},E);else{if(I===void 0)return[];const l=`${JSON.stringify(P)}: ${JSON.stringify(I)}`,c=w?w(v.children.map(f=>f.children[0].value)):v.children.length;let a;if(c>0){const f=v.children[c-1];a={offset:f.offset+f.length,length:0,content:","+l}}else v.children.length===0?a={offset:v.offset+1,length:0,content:l}:a={offset:v.offset+1,length:0,content:l+","};return M(b,a,E)}}else if(v.type==="array"&&typeof P=="number"&&Array.isArray(v.children))if(I!==void 0){const h=`${JSON.stringify(I)}`;let l;if(v.children.length===0||P===0)l={offset:v.offset+1,length:0,content:v.children.length===0?h:h+","};else{const c=P===-1||P>v.children.length?v.children.length:P,a=v.children[c-1];l={offset:a.offset+a.length,length:0,content:","+h}}return M(b,l,E)}else{const h=P,l=v.children[h];let c;if(v.children.length===1)c={offset:v.offset+1,length:v.length-2,content:""};else if(v.children.length-1===h){const a=v.children[h-1],f=a.offset+a.length,r=v.offset+v.length;c={offset:f,length:r-2-f,content:""}}else c={offset:l.offset,length:v.children[h+1].offset-l.offset,content:""};return M(b,c,E)}else throw new Error(`Can not add ${typeof P!="number"?"index":"property"} to parent of type ${v.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return M(b,{offset:p?p.offset:0,length:p?p.length:0,content:JSON.stringify(I)},E)}}e.setProperty=D;function M(b,C,I){let E=S(b,C),w=C.offset,t=C.offset+C.content.length;if(C.length===0||C.content.length===0){for(;w>0&&!(0,n.isEOL)(E,w-1);)w--;for(;t<E.length&&!(0,n.isEOL)(E,t);)t++}const d=(0,n.format)(E,{offset:w,length:t-w},I);for(let v=d.length-1;v>=0;v--){const P=d[v];E=S(E,P),w=Math.min(w,P.offset),t=Math.max(t,P.offset+P.length),t+=P.content.length-P.length}const p=b.length-(E.length-t)-w;return[{offset:w,length:p,content:E.substring(w,t)}]}e.withFormatting=M;function S(b,C){return b.substring(0,C.offset)+C.content+b.substring(C.offset+C.length)}e.applyEdit=S;function g(b,C){let I=C.slice(0).sort((w,t)=>{const d=w.offset-t.offset;return d===0?w.length-t.length:d}),E=b.length;for(let w=I.length-1;w>=0;w--){let t=I[w];if(t.offset+t.length<=E)b=S(b,t);else throw new Error("Overlapping edit");E=t.offset}return b}e.applyEdits=g}),define(J[83],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=e.EVENT_KEY_CODE_MAP=e.ScanCode=e.KeyCode=void 0;var m;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.NumLock=78]="NumLock",t[t.ScrollLock=79]="ScrollLock",t[t.Semicolon=80]="Semicolon",t[t.Equal=81]="Equal",t[t.Comma=82]="Comma",t[t.Minus=83]="Minus",t[t.Period=84]="Period",t[t.Slash=85]="Slash",t[t.Backquote=86]="Backquote",t[t.BracketLeft=87]="BracketLeft",t[t.Backslash=88]="Backslash",t[t.BracketRight=89]="BracketRight",t[t.Quote=90]="Quote",t[t.OEM_8=91]="OEM_8",t[t.IntlBackslash=92]="IntlBackslash",t[t.Numpad0=93]="Numpad0",t[t.Numpad1=94]="Numpad1",t[t.Numpad2=95]="Numpad2",t[t.Numpad3=96]="Numpad3",t[t.Numpad4=97]="Numpad4",t[t.Numpad5=98]="Numpad5",t[t.Numpad6=99]="Numpad6",t[t.Numpad7=100]="Numpad7",t[t.Numpad8=101]="Numpad8",t[t.Numpad9=102]="Numpad9",t[t.NumpadMultiply=103]="NumpadMultiply",t[t.NumpadAdd=104]="NumpadAdd",t[t.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=106]="NumpadSubtract",t[t.NumpadDecimal=107]="NumpadDecimal",t[t.NumpadDivide=108]="NumpadDivide",t[t.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",t[t.ABNT_C1=110]="ABNT_C1",t[t.ABNT_C2=111]="ABNT_C2",t[t.AudioVolumeMute=112]="AudioVolumeMute",t[t.AudioVolumeUp=113]="AudioVolumeUp",t[t.AudioVolumeDown=114]="AudioVolumeDown",t[t.BrowserSearch=115]="BrowserSearch",t[t.BrowserHome=116]="BrowserHome",t[t.BrowserBack=117]="BrowserBack",t[t.BrowserForward=118]="BrowserForward",t[t.MediaTrackNext=119]="MediaTrackNext",t[t.MediaTrackPrevious=120]="MediaTrackPrevious",t[t.MediaStop=121]="MediaStop",t[t.MediaPlayPause=122]="MediaPlayPause",t[t.LaunchMediaPlayer=123]="LaunchMediaPlayer",t[t.LaunchMail=124]="LaunchMail",t[t.LaunchApp2=125]="LaunchApp2",t[t.Clear=126]="Clear",t[t.MAX_VALUE=127]="MAX_VALUE"})(m=e.KeyCode||(e.KeyCode={}));var n;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.None=0]="None",t[t.Hyper=1]="Hyper",t[t.Super=2]="Super",t[t.Fn=3]="Fn",t[t.FnLock=4]="FnLock",t[t.Suspend=5]="Suspend",t[t.Resume=6]="Resume",t[t.Turbo=7]="Turbo",t[t.Sleep=8]="Sleep",t[t.WakeUp=9]="WakeUp",t[t.KeyA=10]="KeyA",t[t.KeyB=11]="KeyB",t[t.KeyC=12]="KeyC",t[t.KeyD=13]="KeyD",t[t.KeyE=14]="KeyE",t[t.KeyF=15]="KeyF",t[t.KeyG=16]="KeyG",t[t.KeyH=17]="KeyH",t[t.KeyI=18]="KeyI",t[t.KeyJ=19]="KeyJ",t[t.KeyK=20]="KeyK",t[t.KeyL=21]="KeyL",t[t.KeyM=22]="KeyM",t[t.KeyN=23]="KeyN",t[t.KeyO=24]="KeyO",t[t.KeyP=25]="KeyP",t[t.KeyQ=26]="KeyQ",t[t.KeyR=27]="KeyR",t[t.KeyS=28]="KeyS",t[t.KeyT=29]="KeyT",t[t.KeyU=30]="KeyU",t[t.KeyV=31]="KeyV",t[t.KeyW=32]="KeyW",t[t.KeyX=33]="KeyX",t[t.KeyY=34]="KeyY",t[t.KeyZ=35]="KeyZ",t[t.Digit1=36]="Digit1",t[t.Digit2=37]="Digit2",t[t.Digit3=38]="Digit3",t[t.Digit4=39]="Digit4",t[t.Digit5=40]="Digit5",t[t.Digit6=41]="Digit6",t[t.Digit7=42]="Digit7",t[t.Digit8=43]="Digit8",t[t.Digit9=44]="Digit9",t[t.Digit0=45]="Digit0",t[t.Enter=46]="Enter",t[t.Escape=47]="Escape",t[t.Backspace=48]="Backspace",t[t.Tab=49]="Tab",t[t.Space=50]="Space",t[t.Minus=51]="Minus",t[t.Equal=52]="Equal",t[t.BracketLeft=53]="BracketLeft",t[t.BracketRight=54]="BracketRight",t[t.Backslash=55]="Backslash",t[t.IntlHash=56]="IntlHash",t[t.Semicolon=57]="Semicolon",t[t.Quote=58]="Quote",t[t.Backquote=59]="Backquote",t[t.Comma=60]="Comma",t[t.Period=61]="Period",t[t.Slash=62]="Slash",t[t.CapsLock=63]="CapsLock",t[t.F1=64]="F1",t[t.F2=65]="F2",t[t.F3=66]="F3",t[t.F4=67]="F4",t[t.F5=68]="F5",t[t.F6=69]="F6",t[t.F7=70]="F7",t[t.F8=71]="F8",t[t.F9=72]="F9",t[t.F10=73]="F10",t[t.F11=74]="F11",t[t.F12=75]="F12",t[t.PrintScreen=76]="PrintScreen",t[t.ScrollLock=77]="ScrollLock",t[t.Pause=78]="Pause",t[t.Insert=79]="Insert",t[t.Home=80]="Home",t[t.PageUp=81]="PageUp",t[t.Delete=82]="Delete",t[t.End=83]="End",t[t.PageDown=84]="PageDown",t[t.ArrowRight=85]="ArrowRight",t[t.ArrowLeft=86]="ArrowLeft",t[t.ArrowDown=87]="ArrowDown",t[t.ArrowUp=88]="ArrowUp",t[t.NumLock=89]="NumLock",t[t.NumpadDivide=90]="NumpadDivide",t[t.NumpadMultiply=91]="NumpadMultiply",t[t.NumpadSubtract=92]="NumpadSubtract",t[t.NumpadAdd=93]="NumpadAdd",t[t.NumpadEnter=94]="NumpadEnter",t[t.Numpad1=95]="Numpad1",t[t.Numpad2=96]="Numpad2",t[t.Numpad3=97]="Numpad3",t[t.Numpad4=98]="Numpad4",t[t.Numpad5=99]="Numpad5",t[t.Numpad6=100]="Numpad6",t[t.Numpad7=101]="Numpad7",t[t.Numpad8=102]="Numpad8",t[t.Numpad9=103]="Numpad9",t[t.Numpad0=104]="Numpad0",t[t.NumpadDecimal=105]="NumpadDecimal",t[t.IntlBackslash=106]="IntlBackslash",t[t.ContextMenu=107]="ContextMenu",t[t.Power=108]="Power",t[t.NumpadEqual=109]="NumpadEqual",t[t.F13=110]="F13",t[t.F14=111]="F14",t[t.F15=112]="F15",t[t.F16=113]="F16",t[t.F17=114]="F17",t[t.F18=115]="F18",t[t.F19=116]="F19",t[t.F20=117]="F20",t[t.F21=118]="F21",t[t.F22=119]="F22",t[t.F23=120]="F23",t[t.F24=121]="F24",t[t.Open=122]="Open",t[t.Help=123]="Help",t[t.Select=124]="Select",t[t.Again=125]="Again",t[t.Undo=126]="Undo",t[t.Cut=127]="Cut",t[t.Copy=128]="Copy",t[t.Paste=129]="Paste",t[t.Find=130]="Find",t[t.AudioVolumeMute=131]="AudioVolumeMute",t[t.AudioVolumeUp=132]="AudioVolumeUp",t[t.AudioVolumeDown=133]="AudioVolumeDown",t[t.NumpadComma=134]="NumpadComma",t[t.IntlRo=135]="IntlRo",t[t.KanaMode=136]="KanaMode",t[t.IntlYen=137]="IntlYen",t[t.Convert=138]="Convert",t[t.NonConvert=139]="NonConvert",t[t.Lang1=140]="Lang1",t[t.Lang2=141]="Lang2",t[t.Lang3=142]="Lang3",t[t.Lang4=143]="Lang4",t[t.Lang5=144]="Lang5",t[t.Abort=145]="Abort",t[t.Props=146]="Props",t[t.NumpadParenLeft=147]="NumpadParenLeft",t[t.NumpadParenRight=148]="NumpadParenRight",t[t.NumpadBackspace=149]="NumpadBackspace",t[t.NumpadMemoryStore=150]="NumpadMemoryStore",t[t.NumpadMemoryRecall=151]="NumpadMemoryRecall",t[t.NumpadMemoryClear=152]="NumpadMemoryClear",t[t.NumpadMemoryAdd=153]="NumpadMemoryAdd",t[t.NumpadMemorySubtract=154]="NumpadMemorySubtract",t[t.NumpadClear=155]="NumpadClear",t[t.NumpadClearEntry=156]="NumpadClearEntry",t[t.ControlLeft=157]="ControlLeft",t[t.ShiftLeft=158]="ShiftLeft",t[t.AltLeft=159]="AltLeft",t[t.MetaLeft=160]="MetaLeft",t[t.ControlRight=161]="ControlRight",t[t.ShiftRight=162]="ShiftRight",t[t.AltRight=163]="AltRight",t[t.MetaRight=164]="MetaRight",t[t.BrightnessUp=165]="BrightnessUp",t[t.BrightnessDown=166]="BrightnessDown",t[t.MediaPlay=167]="MediaPlay",t[t.MediaRecord=168]="MediaRecord",t[t.MediaFastForward=169]="MediaFastForward",t[t.MediaRewind=170]="MediaRewind",t[t.MediaTrackNext=171]="MediaTrackNext",t[t.MediaTrackPrevious=172]="MediaTrackPrevious",t[t.MediaStop=173]="MediaStop",t[t.Eject=174]="Eject",t[t.MediaPlayPause=175]="MediaPlayPause",t[t.MediaSelect=176]="MediaSelect",t[t.LaunchMail=177]="LaunchMail",t[t.LaunchApp2=178]="LaunchApp2",t[t.LaunchApp1=179]="LaunchApp1",t[t.SelectTask=180]="SelectTask",t[t.LaunchScreenSaver=181]="LaunchScreenSaver",t[t.BrowserSearch=182]="BrowserSearch",t[t.BrowserHome=183]="BrowserHome",t[t.BrowserBack=184]="BrowserBack",t[t.BrowserForward=185]="BrowserForward",t[t.BrowserStop=186]="BrowserStop",t[t.BrowserRefresh=187]="BrowserRefresh",t[t.BrowserFavorites=188]="BrowserFavorites",t[t.ZoomToggle=189]="ZoomToggle",t[t.MailReply=190]="MailReply",t[t.MailForward=191]="MailForward",t[t.MailSend=192]="MailSend",t[t.MAX_VALUE=193]="MAX_VALUE"})(n=e.ScanCode||(e.ScanCode={}));class L{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(d,p){this._keyCodeToStr[d]=p,this._strToKeyCode[p.toLowerCase()]=d}keyCodeToStr(d){return this._keyCodeToStr[d]}strToKeyCode(d){return this._strToKeyCode[d.toLowerCase()]||0}}const D=new L,M=new L,S=new L;e.EVENT_KEY_CODE_MAP=new Array(230),e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const g=[],b=Object.create(null),C=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:t=>C[t]||0,toEnum:t=>b[t]||0,toString:t=>g[t]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let t=0;t<=193;t++)e.IMMUTABLE_CODE_TO_KEY_CODE[t]=-1;for(let t=0;t<=127;t++)e.IMMUTABLE_KEY_CODE_TO_CODE[t]=-1;(function(){const t="",d=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",t,t],[0,1,1,"Hyper",0,t,0,t,t,t],[0,1,2,"Super",0,t,0,t,t,t],[0,1,3,"Fn",0,t,0,t,t,t],[0,1,4,"FnLock",0,t,0,t,t,t],[0,1,5,"Suspend",0,t,0,t,t,t],[0,1,6,"Resume",0,t,0,t,t,t],[0,1,7,"Turbo",0,t,0,t,t,t],[0,1,8,"Sleep",0,t,0,"VK_SLEEP",t,t],[0,1,9,"WakeUp",0,t,0,t,t,t],[31,0,10,"KeyA",31,"A",65,"VK_A",t,t],[32,0,11,"KeyB",32,"B",66,"VK_B",t,t],[33,0,12,"KeyC",33,"C",67,"VK_C",t,t],[34,0,13,"KeyD",34,"D",68,"VK_D",t,t],[35,0,14,"KeyE",35,"E",69,"VK_E",t,t],[36,0,15,"KeyF",36,"F",70,"VK_F",t,t],[37,0,16,"KeyG",37,"G",71,"VK_G",t,t],[38,0,17,"KeyH",38,"H",72,"VK_H",t,t],[39,0,18,"KeyI",39,"I",73,"VK_I",t,t],[40,0,19,"KeyJ",40,"J",74,"VK_J",t,t],[41,0,20,"KeyK",41,"K",75,"VK_K",t,t],[42,0,21,"KeyL",42,"L",76,"VK_L",t,t],[43,0,22,"KeyM",43,"M",77,"VK_M",t,t],[44,0,23,"KeyN",44,"N",78,"VK_N",t,t],[45,0,24,"KeyO",45,"O",79,"VK_O",t,t],[46,0,25,"KeyP",46,"P",80,"VK_P",t,t],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",t,t],[48,0,27,"KeyR",48,"R",82,"VK_R",t,t],[49,0,28,"KeyS",49,"S",83,"VK_S",t,t],[50,0,29,"KeyT",50,"T",84,"VK_T",t,t],[51,0,30,"KeyU",51,"U",85,"VK_U",t,t],[52,0,31,"KeyV",52,"V",86,"VK_V",t,t],[53,0,32,"KeyW",53,"W",87,"VK_W",t,t],[54,0,33,"KeyX",54,"X",88,"VK_X",t,t],[55,0,34,"KeyY",55,"Y",89,"VK_Y",t,t],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",t,t],[22,0,36,"Digit1",22,"1",49,"VK_1",t,t],[23,0,37,"Digit2",23,"2",50,"VK_2",t,t],[24,0,38,"Digit3",24,"3",51,"VK_3",t,t],[25,0,39,"Digit4",25,"4",52,"VK_4",t,t],[26,0,40,"Digit5",26,"5",53,"VK_5",t,t],[27,0,41,"Digit6",27,"6",54,"VK_6",t,t],[28,0,42,"Digit7",28,"7",55,"VK_7",t,t],[29,0,43,"Digit8",29,"8",56,"VK_8",t,t],[30,0,44,"Digit9",30,"9",57,"VK_9",t,t],[21,0,45,"Digit0",21,"0",48,"VK_0",t,t],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",t,t],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",t,t],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",t,t],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",t,t],[10,1,50,"Space",10,"Space",32,"VK_SPACE",t,t],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,t,0,t,t,t],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",t,t],[59,1,64,"F1",59,"F1",112,"VK_F1",t,t],[60,1,65,"F2",60,"F2",113,"VK_F2",t,t],[61,1,66,"F3",61,"F3",114,"VK_F3",t,t],[62,1,67,"F4",62,"F4",115,"VK_F4",t,t],[63,1,68,"F5",63,"F5",116,"VK_F5",t,t],[64,1,69,"F6",64,"F6",117,"VK_F6",t,t],[65,1,70,"F7",65,"F7",118,"VK_F7",t,t],[66,1,71,"F8",66,"F8",119,"VK_F8",t,t],[67,1,72,"F9",67,"F9",120,"VK_F9",t,t],[68,1,73,"F10",68,"F10",121,"VK_F10",t,t],[69,1,74,"F11",69,"F11",122,"VK_F11",t,t],[70,1,75,"F12",70,"F12",123,"VK_F12",t,t],[0,1,76,"PrintScreen",0,t,0,t,t,t],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",t,t],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",t,t],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",t,t],[14,1,80,"Home",14,"Home",36,"VK_HOME",t,t],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",t,t],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",t,t],[13,1,83,"End",13,"End",35,"VK_END",t,t],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",t,t],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",t],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",t],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",t],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",t],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",t,t],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",t,t],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",t,t],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",t,t],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",t,t],[3,1,94,"NumpadEnter",3,t,0,t,t,t],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",t,t],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",t,t],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",t,t],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",t,t],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",t,t],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",t,t],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",t,t],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",t,t],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",t,t],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",t,t],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",t,t],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",t,t],[58,1,107,"ContextMenu",58,"ContextMenu",93,t,t,t],[0,1,108,"Power",0,t,0,t,t,t],[0,1,109,"NumpadEqual",0,t,0,t,t,t],[71,1,110,"F13",71,"F13",124,"VK_F13",t,t],[72,1,111,"F14",72,"F14",125,"VK_F14",t,t],[73,1,112,"F15",73,"F15",126,"VK_F15",t,t],[74,1,113,"F16",74,"F16",127,"VK_F16",t,t],[75,1,114,"F17",75,"F17",128,"VK_F17",t,t],[76,1,115,"F18",76,"F18",129,"VK_F18",t,t],[77,1,116,"F19",77,"F19",130,"VK_F19",t,t],[0,1,117,"F20",0,t,0,"VK_F20",t,t],[0,1,118,"F21",0,t,0,"VK_F21",t,t],[0,1,119,"F22",0,t,0,"VK_F22",t,t],[0,1,120,"F23",0,t,0,"VK_F23",t,t],[0,1,121,"F24",0,t,0,"VK_F24",t,t],[0,1,122,"Open",0,t,0,t,t,t],[0,1,123,"Help",0,t,0,t,t,t],[0,1,124,"Select",0,t,0,t,t,t],[0,1,125,"Again",0,t,0,t,t,t],[0,1,126,"Undo",0,t,0,t,t,t],[0,1,127,"Cut",0,t,0,t,t,t],[0,1,128,"Copy",0,t,0,t,t,t],[0,1,129,"Paste",0,t,0,t,t,t],[0,1,130,"Find",0,t,0,t,t,t],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",t,t],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",t,t],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",t,t],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",t,t],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",t,t],[0,1,136,"KanaMode",0,t,0,t,t,t],[0,0,137,"IntlYen",0,t,0,t,t,t],[0,1,138,"Convert",0,t,0,t,t,t],[0,1,139,"NonConvert",0,t,0,t,t,t],[0,1,140,"Lang1",0,t,0,t,t,t],[0,1,141,"Lang2",0,t,0,t,t,t],[0,1,142,"Lang3",0,t,0,t,t,t],[0,1,143,"Lang4",0,t,0,t,t,t],[0,1,144,"Lang5",0,t,0,t,t,t],[0,1,145,"Abort",0,t,0,t,t,t],[0,1,146,"Props",0,t,0,t,t,t],[0,1,147,"NumpadParenLeft",0,t,0,t,t,t],[0,1,148,"NumpadParenRight",0,t,0,t,t,t],[0,1,149,"NumpadBackspace",0,t,0,t,t,t],[0,1,150,"NumpadMemoryStore",0,t,0,t,t,t],[0,1,151,"NumpadMemoryRecall",0,t,0,t,t,t],[0,1,152,"NumpadMemoryClear",0,t,0,t,t,t],[0,1,153,"NumpadMemoryAdd",0,t,0,t,t,t],[0,1,154,"NumpadMemorySubtract",0,t,0,t,t,t],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",t,t],[0,1,156,"NumpadClearEntry",0,t,0,t,t,t],[5,1,0,t,5,"Ctrl",17,"VK_CONTROL",t,t],[4,1,0,t,4,"Shift",16,"VK_SHIFT",t,t],[6,1,0,t,6,"Alt",18,"VK_MENU",t,t],[57,1,0,t,57,"Meta",0,"VK_COMMAND",t,t],[5,1,157,"ControlLeft",5,t,0,"VK_LCONTROL",t,t],[4,1,158,"ShiftLeft",4,t,0,"VK_LSHIFT",t,t],[6,1,159,"AltLeft",6,t,0,"VK_LMENU",t,t],[57,1,160,"MetaLeft",57,t,0,"VK_LWIN",t,t],[5,1,161,"ControlRight",5,t,0,"VK_RCONTROL",t,t],[4,1,162,"ShiftRight",4,t,0,"VK_RSHIFT",t,t],[6,1,163,"AltRight",6,t,0,"VK_RMENU",t,t],[57,1,164,"MetaRight",57,t,0,"VK_RWIN",t,t],[0,1,165,"BrightnessUp",0,t,0,t,t,t],[0,1,166,"BrightnessDown",0,t,0,t,t,t],[0,1,167,"MediaPlay",0,t,0,t,t,t],[0,1,168,"MediaRecord",0,t,0,t,t,t],[0,1,169,"MediaFastForward",0,t,0,t,t,t],[0,1,170,"MediaRewind",0,t,0,t,t,t],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",t,t],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",t,t],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",t,t],[0,1,174,"Eject",0,t,0,t,t,t],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",t,t],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",t,t],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",t,t],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",t,t],[0,1,179,"LaunchApp1",0,t,0,"VK_MEDIA_LAUNCH_APP1",t,t],[0,1,180,"SelectTask",0,t,0,t,t,t],[0,1,181,"LaunchScreenSaver",0,t,0,t,t,t],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",t,t],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",t,t],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",t,t],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",t,t],[0,1,186,"BrowserStop",0,t,0,"VK_BROWSER_STOP",t,t],[0,1,187,"BrowserRefresh",0,t,0,"VK_BROWSER_REFRESH",t,t],[0,1,188,"BrowserFavorites",0,t,0,"VK_BROWSER_FAVORITES",t,t],[0,1,189,"ZoomToggle",0,t,0,t,t,t],[0,1,190,"MailReply",0,t,0,t,t,t],[0,1,191,"MailForward",0,t,0,t,t,t],[0,1,192,"MailSend",0,t,0,t,t,t],[109,1,0,t,109,"KeyInComposition",229,t,t,t],[111,1,0,t,111,"ABNT_C2",194,"VK_ABNT_C2",t,t],[91,1,0,t,91,"OEM_8",223,"VK_OEM_8",t,t],[0,1,0,t,0,t,0,"VK_KANA",t,t],[0,1,0,t,0,t,0,"VK_HANGUL",t,t],[0,1,0,t,0,t,0,"VK_JUNJA",t,t],[0,1,0,t,0,t,0,"VK_FINAL",t,t],[0,1,0,t,0,t,0,"VK_HANJA",t,t],[0,1,0,t,0,t,0,"VK_KANJI",t,t],[0,1,0,t,0,t,0,"VK_CONVERT",t,t],[0,1,0,t,0,t,0,"VK_NONCONVERT",t,t],[0,1,0,t,0,t,0,"VK_ACCEPT",t,t],[0,1,0,t,0,t,0,"VK_MODECHANGE",t,t],[0,1,0,t,0,t,0,"VK_SELECT",t,t],[0,1,0,t,0,t,0,"VK_PRINT",t,t],[0,1,0,t,0,t,0,"VK_EXECUTE",t,t],[0,1,0,t,0,t,0,"VK_SNAPSHOT",t,t],[0,1,0,t,0,t,0,"VK_HELP",t,t],[0,1,0,t,0,t,0,"VK_APPS",t,t],[0,1,0,t,0,t,0,"VK_PROCESSKEY",t,t],[0,1,0,t,0,t,0,"VK_PACKET",t,t],[0,1,0,t,0,t,0,"VK_DBE_SBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_DBE_DBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_ATTN",t,t],[0,1,0,t,0,t,0,"VK_CRSEL",t,t],[0,1,0,t,0,t,0,"VK_EXSEL",t,t],[0,1,0,t,0,t,0,"VK_EREOF",t,t],[0,1,0,t,0,t,0,"VK_PLAY",t,t],[0,1,0,t,0,t,0,"VK_ZOOM",t,t],[0,1,0,t,0,t,0,"VK_NONAME",t,t],[0,1,0,t,0,t,0,"VK_PA1",t,t],[0,1,0,t,0,t,0,"VK_OEM_CLEAR",t,t]];let p=[],v=[];for(const P of d){const[h,l,c,a,f,r,i,s,o,u]=P;if(v[c]||(v[c]=!0,g[c]=a,b[a]=c,C[a.toLowerCase()]=c,l&&(e.IMMUTABLE_CODE_TO_KEY_CODE[c]=f,f!==0&&f!==3&&f!==5&&f!==4&&f!==6&&f!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[f]=c))),!p[f]){if(p[f]=!0,!r)throw new Error(`String representation missing for key code ${f} around scan code ${a}`);D.define(f,r),M.define(f,o||r),S.define(f,u||o||r)}i&&(e.EVENT_KEY_CODE_MAP[i]=f),s&&(e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[s]=f)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var I;(function(t){function d(c){return D.keyCodeToStr(c)}t.toString=d;function p(c){return D.strToKeyCode(c)}t.fromString=p;function v(c){return M.keyCodeToStr(c)}t.toUserSettingsUS=v;function P(c){return S.keyCodeToStr(c)}t.toUserSettingsGeneral=P;function h(c){return M.strToKeyCode(c)||S.strToKeyCode(c)}t.fromUserSettings=h;function l(c){if(c>=93&&c<=108)return null;switch(c){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return D.keyCodeToStr(c)}t.toElectronAccelerator=l})(I=e.KeyCodeUtils||(e.KeyCodeUtils={}));var E;(function(t){t[t.CtrlCmd=2048]="CtrlCmd",t[t.Shift=1024]="Shift",t[t.Alt=512]="Alt",t[t.WinCtrl=256]="WinCtrl"})(E=e.KeyMod||(e.KeyMod={}));function w(t,d){const p=(d&65535)<<16>>>0;return(t|p)>>>0}e.KeyChord=w}),define(J[59],Z([0,1,15]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ScanCodeBinding=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=void 0;var n;(function(I){I[I.CtrlCmd=2048]="CtrlCmd",I[I.Shift=1024]="Shift",I[I.Alt=512]="Alt",I[I.WinCtrl=256]="WinCtrl",I[I.KeyCode=255]="KeyCode"})(n||(n={}));function L(I,E){if(I===0)return null;const w=(I&65535)>>>0,t=(I&4294901760)>>>16;return t!==0?new S([D(w,E),D(t,E)]):new S([D(w,E)])}e.createKeybinding=L;function D(I,E){const w=!!(I&2048),t=!!(I&256),d=E===2?t:w,p=!!(I&1024),v=!!(I&512),P=E===2?w:t,h=I&255;return new M(d,p,v,P,h)}e.createSimpleKeybinding=D;class M{constructor(E,w,t,d,p){this.ctrlKey=E,this.shiftKey=w,this.altKey=t,this.metaKey=d,this.keyCode=p}equals(E){return this.ctrlKey===E.ctrlKey&&this.shiftKey===E.shiftKey&&this.altKey===E.altKey&&this.metaKey===E.metaKey&&this.keyCode===E.keyCode}getHashCode(){const E=this.ctrlKey?"1":"0",w=this.shiftKey?"1":"0",t=this.altKey?"1":"0",d=this.metaKey?"1":"0";return`${E}${w}${t}${d}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new S([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=M;class S{constructor(E){if(E.length===0)throw(0,m.illegalArgument)("parts");this.parts=E}getHashCode(){let E="";for(let w=0,t=this.parts.length;w<t;w++)w!==0&&(E+=";"),E+=this.parts[w].getHashCode();return E}equals(E){if(E===null||this.parts.length!==E.parts.length)return!1;for(let w=0;w<this.parts.length;w++)if(!this.parts[w].equals(E.parts[w]))return!1;return!0}}e.ChordKeybinding=S;class g{constructor(E,w,t,d,p){this.ctrlKey=E,this.shiftKey=w,this.altKey=t,this.metaKey=d,this.scanCode=p}equals(E){return this.ctrlKey===E.ctrlKey&&this.shiftKey===E.shiftKey&&this.altKey===E.altKey&&this.metaKey===E.metaKey&&this.scanCode===E.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=g;class b{constructor(E,w,t,d,p,v){this.ctrlKey=E,this.shiftKey=w,this.altKey=t,this.metaKey=d,this.keyLabel=p,this.keyAriaLabel=v}}e.ResolvedKeybindingPart=b;class C{}e.ResolvedKeybinding=C}),define(J[110],Z([0,1,83,59]),function(V,e,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class L{static _readModifiers(M){M=M.toLowerCase().trim();let S=!1,g=!1,b=!1,C=!1,I;do I=!1,/^ctrl(\+|\-)/.test(M)&&(S=!0,M=M.substr("ctrl-".length),I=!0),/^shift(\+|\-)/.test(M)&&(g=!0,M=M.substr("shift-".length),I=!0),/^alt(\+|\-)/.test(M)&&(b=!0,M=M.substr("alt-".length),I=!0),/^meta(\+|\-)/.test(M)&&(C=!0,M=M.substr("meta-".length),I=!0),/^win(\+|\-)/.test(M)&&(C=!0,M=M.substr("win-".length),I=!0),/^cmd(\+|\-)/.test(M)&&(C=!0,M=M.substr("cmd-".length),I=!0);while(I);let E;const w=M.indexOf(" ");return w>0?(E=M.substring(0,w),M=M.substring(w)):(E=M,M=""),{remains:M,ctrl:S,shift:g,alt:b,meta:C,key:E}}static parseSimpleKeybinding(M){const S=this._readModifiers(M),g=m.KeyCodeUtils.fromUserSettings(S.key);return[new n.SimpleKeybinding(S.ctrl,S.shift,S.alt,S.meta,g),S.remains]}static parseKeybinding(M,S){if(!M)return null;const g=[];let b;do[b,M]=this.parseSimpleKeybinding(M),g.push(b);while(M.length>0);return new n.ChordKeybinding(g)}static parseSimpleUserBinding(M){const S=this._readModifiers(M),g=S.key.match(/^\[([^\]]+)\]$/);if(g){const C=g[1],I=m.ScanCodeUtils.lowerCaseToEnum(C);return[new n.ScanCodeBinding(S.ctrl,S.shift,S.alt,S.meta,I),S.remains]}const b=m.KeyCodeUtils.fromUserSettings(S.key);return[new n.SimpleKeybinding(S.ctrl,S.shift,S.alt,S.meta,b),S.remains]}static parseUserBinding(M){if(!M)return[];const S=[];let g;for(;M.length>0;)[g,M]=this.parseSimpleUserBinding(M),S.push(g);return S}}e.KeybindingParser=L}),define(J[111],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class m{constructor(L){this.executor=L,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(L){this._error=L}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(L){return new m(()=>L(this.getValue()))}}e.Lazy=m}),define(J[2],Z([0,1,43,68]),function(V,e,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const L=!1;let D=null;function M(s){D=s}if(e.setDisposableTracker=M,L){const s="__is_disposable_tracked__";M(new class{trackDisposable(o){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[s]||console.log(u)},3e3)}setParent(o,u){if(o&&o!==P.None)try{o[s]=!0}catch{}}markAsDisposed(o){if(o&&o!==P.None)try{o[s]=!0}catch{}}markAsSingleton(o){}})}function S(s){return D?.trackDisposable(s),s}function g(s){D?.markAsDisposed(s)}function b(s,o){D?.setParent(s,o)}function C(s,o){if(!!D)for(const u of s)D.setParent(u,o)}function I(s){return D?.markAsSingleton(s),s}e.markAsSingleton=I;class E extends Error{constructor(o){super(`Encountered errors while disposing of store. Errors: [${o.join(", ")}]`);this.errors=o}}e.MultiDisposeError=E;function w(s){return typeof s.dispose=="function"&&s.dispose.length===0}e.isDisposable=w;function t(s){if(n.Iterable.is(s)){let o=[];for(const u of s)if(u)try{u.dispose()}catch(y){o.push(y)}if(o.length===1)throw o[0];if(o.length>1)throw new E(o);return Array.isArray(s)?[]:s}else if(s)return s.dispose(),s}e.dispose=t;function d(...s){const o=p(()=>t(s));return C(s,o),o}e.combinedDisposable=d;function p(s){const o=S({dispose:(0,m.once)(()=>{g(o),s()})});return o}e.toDisposable=p;class v{constructor(){this._toDispose=new Set,this._isDisposed=!1,S(this)}dispose(){this._isDisposed||(g(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{t(this._toDispose.values())}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return b(o,this),this._isDisposed?v.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=v,v.DISABLE_DISPOSED_WARNING=!1;class P{constructor(){this._store=new v,S(this),b(this._store,this)}dispose(){g(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=P,P.None=Object.freeze({dispose(){}});class h{constructor(){this._isDisposed=!1,S(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){this._isDisposed||o===this._value||(this._value?.dispose(),o&&b(o,this),this._value=o)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,g(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const o=this._value;return this._value=void 0,o&&b(o,null),o}}e.MutableDisposable=h;class l{constructor(o){this._disposable=o,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=l;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,S(this)}set(o){let u=o;return this.unset=()=>u=void 0,this.isset=()=>u!==void 0,this.dispose=()=>{u&&(u(),u=void 0,g(this))},this}}e.SafeDisposable=c;class a{constructor(){this.references=new Map}acquire(o,...u){let y=this.references.get(o);y||(y={counter:0,object:this.createReferencedObject(o,...u)},this.references.set(o,y));const{object:k}=y,R=(0,m.once)(()=>{--y.counter==0&&(this.destroyReferencedObject(o,y.object),this.references.delete(o))});return y.counter++,{object:k,dispose:R}}}e.ReferenceCollection=a;class f{constructor(o){this.referenceCollection=o}async acquire(o,...u){const y=this.referenceCollection.acquire(o,...u);try{return{object:await y.object,dispose:()=>y.dispose()}}catch(k){throw y.dispose(),k}}}e.AsyncReferenceCollection=f;class r{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=r;function i(s){const o=new v;try{s(o)}finally{o.dispose()}}e.disposeOnReturn=i}),define(J[112],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class m{constructor(D){this.element=D,this.next=m.Undefined,this.prev=m.Undefined}}m.Undefined=new m(void 0);class n{constructor(){this._first=m.Undefined,this._last=m.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===m.Undefined}clear(){let D=this._first;for(;D!==m.Undefined;){const M=D.next;D.prev=m.Undefined,D.next=m.Undefined,D=M}this._first=m.Undefined,this._last=m.Undefined,this._size=0}unshift(D){return this._insert(D,!1)}push(D){return this._insert(D,!0)}_insert(D,M){const S=new m(D);if(this._first===m.Undefined)this._first=S,this._last=S;else if(M){const b=this._last;this._last=S,S.prev=b,b.next=S}else{const b=this._first;this._first=S,S.next=b,b.prev=S}this._size+=1;let g=!1;return()=>{g||(g=!0,this._remove(S))}}shift(){if(this._first!==m.Undefined){const D=this._first.element;return this._remove(this._first),D}}pop(){if(this._last!==m.Undefined){const D=this._last.element;return this._remove(this._last),D}}_remove(D){if(D.prev!==m.Undefined&&D.next!==m.Undefined){const M=D.prev;M.next=D.next,D.next.prev=M}else D.prev===m.Undefined&&D.next===m.Undefined?(this._first=m.Undefined,this._last=m.Undefined):D.next===m.Undefined?(this._last=this._last.prev,this._last.next=m.Undefined):D.prev===m.Undefined&&(this._first=this._first.next,this._first.prev=m.Undefined);this._size-=1}*[Symbol.iterator](){let D=this._first;for(;D!==m.Undefined;)yield D.element,D=D.next}}e.LinkedList=n}),function(){function V(L){const D=[];typeof L=="number"&&D.push("code/timeOrigin",L);function M(g){D.push(g,Date.now())}function S(){const g=[];for(let b=0;b<D.length;b+=2)g.push({name:D[b],startTime:D[b+1]});return g}return{mark:M,getMarks:S}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?V():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const M of performance.getEntriesByType("mark"))D.push({name:M.name,startTime:Math.round(L+M.startTime)});return D}};if(typeof process=="object"){const L=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return V(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),V()}function m(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var n;typeof global=="object"?n=global:typeof self=="object"?n=self:n={},typeof define=="function"?define("vs/base/common/performance",[],function(){return m(n)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=m(n):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),n.perf=m(n))}(),define(J[3],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const m="en";let n=!1,L=!1,D=!1,M=!1,S=!1,g=!1,b=!1,C=!1,I=!1,E,w=m,t,d;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let p;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?p=e.globals.vscode.process:typeof process!="undefined"&&(p=process);const v=typeof p?.versions?.electron=="string",P=v&&p?.type==="renderer";if(e.isElectronSandboxed=P&&p?.sandboxed,typeof navigator=="object"&&!P)d=navigator.userAgent,n=d.indexOf("Windows")>=0,L=d.indexOf("Macintosh")>=0,C=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=d.indexOf("Linux")>=0,g=!0,E=navigator.language,w=E;else if(typeof p=="object"){n=p.platform==="win32",L=p.platform==="darwin",D=p.platform==="linux",M=D&&!!p.env.SNAP&&!!p.env.SNAP_REVISION,b=v,I=!!p.env.CI||!!p.env.BUILD_ARTIFACTSTAGINGDIRECTORY,E=m,w=m;const o=p.env.VSCODE_NLS_CONFIG;if(o)try{const u=JSON.parse(o),y=u.availableLanguages["*"];E=u.locale,w=y||m,t=u._translationsConfigFile}catch{}S=!0}else console.error("Unable to resolve platform.");var h;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(h=e.Platform||(e.Platform={}));function l(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=l;let c=0;L?c=1:n?c=3:D&&(c=2),e.isWindows=n,e.isMacintosh=L,e.isLinux=D,e.isLinuxSnap=M,e.isNative=S,e.isElectron=b,e.isWeb=g,e.isWebWorker=g&&typeof e.globals.importScripts=="function",e.isIOS=C,e.isCI=I,e.platform=c,e.userAgent=d,e.language=w;var a;(function(o){function u(){return e.language}o.value=u;function y(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=y;function k(){return e.language==="en"}o.isDefault=k})(a=e.Language||(e.Language={})),e.locale=E,e.translationsConfigFile=t,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let o=[];e.globals.addEventListener("message",y=>{if(y.data&&y.data.vscodeScheduleAsyncWork)for(let k=0,R=o.length;k<R;k++){const W=o[k];if(W.id===y.data.vscodeScheduleAsyncWork){o.splice(k,1),W.callback();return}}});let u=0;return y=>{const k=++u;o.push({id:k,callback:y}),e.globals.postMessage({vscodeScheduleAsyncWork:k},"*")}}return o=>setTimeout(o)})();var f;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(f=e.OperatingSystem||(e.OperatingSystem={})),e.OS=L||C?2:n?1:3;let r=!0,i=!1;function s(){if(!i){i=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,r=new Uint16Array(o.buffer)[0]===(2<<8)+1}return r}e.isLittleEndian=s,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(J[36],Z([0,1,3]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let n;if(typeof m.globals.vscode!="undefined"&&typeof m.globals.vscode.process!="undefined"){const L=m.globals.vscode.process;n={get platform(){return L.platform},get arch(){return L.arch},get env(){return L.env},cwd(){return L.cwd()}}}else typeof process!="undefined"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return m.isWindows?"win32":m.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=n.cwd,e.env=n.env,e.platform=n.platform,e.arch=n.arch}),define(J[7],Z([0,1,36]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const n=65,L=97,D=90,M=122,S=46,g=47,b=92,C=58,I=63;class E extends Error{constructor(l,c,a){let f;typeof c=="string"&&c.indexOf("not ")===0?(f="must not be",c=c.replace(/^not /,"")):f="must be";const r=l.indexOf(".")!==-1?"property":"argument";let i=`The "${l}" ${r} ${f} of type ${c}`;i+=`. Received type ${typeof a}`;super(i);this.code="ERR_INVALID_ARG_TYPE"}}function w(h,l){if(typeof h!="string")throw new E(l,"string",h)}function t(h){return h===g||h===b}function d(h){return h===g}function p(h){return h>=n&&h<=D||h>=L&&h<=M}function v(h,l,c,a){let f="",r=0,i=-1,s=0,o=0;for(let u=0;u<=h.length;++u){if(u<h.length)o=h.charCodeAt(u);else{if(a(o))break;o=g}if(a(o)){if(!(i===u-1||s===1))if(s===2){if(f.length<2||r!==2||f.charCodeAt(f.length-1)!==S||f.charCodeAt(f.length-2)!==S){if(f.length>2){const y=f.lastIndexOf(c);y===-1?(f="",r=0):(f=f.slice(0,y),r=f.length-1-f.lastIndexOf(c)),i=u,s=0;continue}else if(f.length!==0){f="",r=0,i=u,s=0;continue}}l&&(f+=f.length>0?`${c}..`:"..",r=2)}else f.length>0?f+=`${c}${h.slice(i+1,u)}`:f=h.slice(i+1,u),r=u-i-1;i=u,s=0}else o===S&&s!==-1?++s:s=-1}return f}function P(h,l){if(l===null||typeof l!="object")throw new E("pathObject","Object",l);const c=l.dir||l.root,a=l.base||`${l.name||""}${l.ext||""}`;return c?c===l.root?`${c}${a}`:`${c}${h}${a}`:a}e.win32={resolve(...h){let l="",c="",a=!1;for(let f=h.length-1;f>=-1;f--){let r;if(f>=0){if(r=h[f],w(r,"path"),r.length===0)continue}else l.length===0?r=m.cwd():(r=m.env[`=${l}`]||m.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==l.toLowerCase()&&r.charCodeAt(2)===b)&&(r=`${l}\\`));const i=r.length;let s=0,o="",u=!1;const y=r.charCodeAt(0);if(i===1)t(y)&&(s=1,u=!0);else if(t(y))if(u=!0,t(r.charCodeAt(1))){let k=2,R=k;for(;k<i&&!t(r.charCodeAt(k));)k++;if(k<i&&k!==R){const W=r.slice(R,k);for(R=k;k<i&&t(r.charCodeAt(k));)k++;if(k<i&&k!==R){for(R=k;k<i&&!t(r.charCodeAt(k));)k++;(k===i||k!==R)&&(o=`\\\\${W}\\${r.slice(R,k)}`,s=k)}}}else s=1;else p(y)&&r.charCodeAt(1)===C&&(o=r.slice(0,2),s=2,i>2&&t(r.charCodeAt(2))&&(u=!0,s=3));if(o.length>0)if(l.length>0){if(o.toLowerCase()!==l.toLowerCase())continue}else l=o;if(a){if(l.length>0)break}else if(c=`${r.slice(s)}\\${c}`,a=u,u&&l.length>0)break}return c=v(c,!a,"\\",t),a?`${l}\\${c}`:`${l}${c}`||"."},normalize(h){w(h,"path");const l=h.length;if(l===0)return".";let c=0,a,f=!1;const r=h.charCodeAt(0);if(l===1)return d(r)?"\\":h;if(t(r))if(f=!0,t(h.charCodeAt(1))){let s=2,o=s;for(;s<l&&!t(h.charCodeAt(s));)s++;if(s<l&&s!==o){const u=h.slice(o,s);for(o=s;s<l&&t(h.charCodeAt(s));)s++;if(s<l&&s!==o){for(o=s;s<l&&!t(h.charCodeAt(s));)s++;if(s===l)return`\\\\${u}\\${h.slice(o)}\\`;s!==o&&(a=`\\\\${u}\\${h.slice(o,s)}`,c=s)}}}else c=1;else p(r)&&h.charCodeAt(1)===C&&(a=h.slice(0,2),c=2,l>2&&t(h.charCodeAt(2))&&(f=!0,c=3));let i=c<l?v(h.slice(c),!f,"\\",t):"";return i.length===0&&!f&&(i="."),i.length>0&&t(h.charCodeAt(l-1))&&(i+="\\"),a===void 0?f?`\\${i}`:i:f?`${a}\\${i}`:`${a}${i}`},isAbsolute(h){w(h,"path");const l=h.length;if(l===0)return!1;const c=h.charCodeAt(0);return t(c)||l>2&&p(c)&&h.charCodeAt(1)===C&&t(h.charCodeAt(2))},join(...h){if(h.length===0)return".";let l,c;for(let r=0;r<h.length;++r){const i=h[r];w(i,"path"),i.length>0&&(l===void 0?l=c=i:l+=`\\${i}`)}if(l===void 0)return".";let a=!0,f=0;if(typeof c=="string"&&t(c.charCodeAt(0))){++f;const r=c.length;r>1&&t(c.charCodeAt(1))&&(++f,r>2&&(t(c.charCodeAt(2))?++f:a=!1))}if(a){for(;f<l.length&&t(l.charCodeAt(f));)f++;f>=2&&(l=`\\${l.slice(f)}`)}return e.win32.normalize(l)},relative(h,l){if(w(h,"from"),w(l,"to"),h===l)return"";const c=e.win32.resolve(h),a=e.win32.resolve(l);if(c===a||(h=c.toLowerCase(),l=a.toLowerCase(),h===l))return"";let f=0;for(;f<h.length&&h.charCodeAt(f)===b;)f++;let r=h.length;for(;r-1>f&&h.charCodeAt(r-1)===b;)r--;const i=r-f;let s=0;for(;s<l.length&&l.charCodeAt(s)===b;)s++;let o=l.length;for(;o-1>s&&l.charCodeAt(o-1)===b;)o--;const u=o-s,y=i<u?i:u;let k=-1,R=0;for(;R<y;R++){const U=h.charCodeAt(f+R);if(U!==l.charCodeAt(s+R))break;U===b&&(k=R)}if(R!==y){if(k===-1)return a}else{if(u>y){if(l.charCodeAt(s+R)===b)return a.slice(s+R+1);if(R===2)return a.slice(s+R)}i>y&&(h.charCodeAt(f+R)===b?k=R:R===2&&(k=3)),k===-1&&(k=0)}let W="";for(R=f+k+1;R<=r;++R)(R===r||h.charCodeAt(R)===b)&&(W+=W.length===0?"..":"\\..");return s+=k,W.length>0?`${W}${a.slice(s,o)}`:(a.charCodeAt(s)===b&&++s,a.slice(s,o))},toNamespacedPath(h){if(typeof h!="string")return h;if(h.length===0)return"";const l=e.win32.resolve(h);if(l.length<=2)return h;if(l.charCodeAt(0)===b){if(l.charCodeAt(1)===b){const c=l.charCodeAt(2);if(c!==I&&c!==S)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(p(l.charCodeAt(0))&&l.charCodeAt(1)===C&&l.charCodeAt(2)===b)return`\\\\?\\${l}`;return h},dirname(h){w(h,"path");const l=h.length;if(l===0)return".";let c=-1,a=0;const f=h.charCodeAt(0);if(l===1)return t(f)?h:".";if(t(f)){if(c=a=1,t(h.charCodeAt(1))){let s=2,o=s;for(;s<l&&!t(h.charCodeAt(s));)s++;if(s<l&&s!==o){for(o=s;s<l&&t(h.charCodeAt(s));)s++;if(s<l&&s!==o){for(o=s;s<l&&!t(h.charCodeAt(s));)s++;if(s===l)return h;s!==o&&(c=a=s+1)}}}}else p(f)&&h.charCodeAt(1)===C&&(c=l>2&&t(h.charCodeAt(2))?3:2,a=c);let r=-1,i=!0;for(let s=l-1;s>=a;--s)if(t(h.charCodeAt(s))){if(!i){r=s;break}}else i=!1;if(r===-1){if(c===-1)return".";r=c}return h.slice(0,r)},basename(h,l){l!==void 0&&w(l,"ext"),w(h,"path");let c=0,a=-1,f=!0,r;if(h.length>=2&&p(h.charCodeAt(0))&&h.charCodeAt(1)===C&&(c=2),l!==void 0&&l.length>0&&l.length<=h.length){if(l===h)return"";let i=l.length-1,s=-1;for(r=h.length-1;r>=c;--r){const o=h.charCodeAt(r);if(t(o)){if(!f){c=r+1;break}}else s===-1&&(f=!1,s=r+1),i>=0&&(o===l.charCodeAt(i)?--i==-1&&(a=r):(i=-1,a=s))}return c===a?a=s:a===-1&&(a=h.length),h.slice(c,a)}for(r=h.length-1;r>=c;--r)if(t(h.charCodeAt(r))){if(!f){c=r+1;break}}else a===-1&&(f=!1,a=r+1);return a===-1?"":h.slice(c,a)},extname(h){w(h,"path");let l=0,c=-1,a=0,f=-1,r=!0,i=0;h.length>=2&&h.charCodeAt(1)===C&&p(h.charCodeAt(0))&&(l=a=2);for(let s=h.length-1;s>=l;--s){const o=h.charCodeAt(s);if(t(o)){if(!r){a=s+1;break}continue}f===-1&&(r=!1,f=s+1),o===S?c===-1?c=s:i!==1&&(i=1):c!==-1&&(i=-1)}return c===-1||f===-1||i===0||i===1&&c===f-1&&c===a+1?"":h.slice(c,f)},format:P.bind(null,"\\"),parse(h){w(h,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return l;const c=h.length;let a=0,f=h.charCodeAt(0);if(c===1)return t(f)?(l.root=l.dir=h,l):(l.base=l.name=h,l);if(t(f)){if(a=1,t(h.charCodeAt(1))){let k=2,R=k;for(;k<c&&!t(h.charCodeAt(k));)k++;if(k<c&&k!==R){for(R=k;k<c&&t(h.charCodeAt(k));)k++;if(k<c&&k!==R){for(R=k;k<c&&!t(h.charCodeAt(k));)k++;k===c?a=k:k!==R&&(a=k+1)}}}}else if(p(f)&&h.charCodeAt(1)===C){if(c<=2)return l.root=l.dir=h,l;if(a=2,t(h.charCodeAt(2))){if(c===3)return l.root=l.dir=h,l;a=3}}a>0&&(l.root=h.slice(0,a));let r=-1,i=a,s=-1,o=!0,u=h.length-1,y=0;for(;u>=a;--u){if(f=h.charCodeAt(u),t(f)){if(!o){i=u+1;break}continue}s===-1&&(o=!1,s=u+1),f===S?r===-1?r=u:y!==1&&(y=1):r!==-1&&(y=-1)}return s!==-1&&(r===-1||y===0||y===1&&r===s-1&&r===i+1?l.base=l.name=h.slice(i,s):(l.name=h.slice(i,r),l.base=h.slice(i,s),l.ext=h.slice(r,s))),i>0&&i!==a?l.dir=h.slice(0,i-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...h){let l="",c=!1;for(let a=h.length-1;a>=-1&&!c;a--){const f=a>=0?h[a]:m.cwd();w(f,"path"),f.length!==0&&(l=`${f}/${l}`,c=f.charCodeAt(0)===g)}return l=v(l,!c,"/",d),c?`/${l}`:l.length>0?l:"."},normalize(h){if(w(h,"path"),h.length===0)return".";const l=h.charCodeAt(0)===g,c=h.charCodeAt(h.length-1)===g;return h=v(h,!l,"/",d),h.length===0?l?"/":c?"./":".":(c&&(h+="/"),l?`/${h}`:h)},isAbsolute(h){return w(h,"path"),h.length>0&&h.charCodeAt(0)===g},join(...h){if(h.length===0)return".";let l;for(let c=0;c<h.length;++c){const a=h[c];w(a,"path"),a.length>0&&(l===void 0?l=a:l+=`/${a}`)}return l===void 0?".":e.posix.normalize(l)},relative(h,l){if(w(h,"from"),w(l,"to"),h===l||(h=e.posix.resolve(h),l=e.posix.resolve(l),h===l))return"";const c=1,a=h.length,f=a-c,r=1,i=l.length-r,s=f<i?f:i;let o=-1,u=0;for(;u<s;u++){const k=h.charCodeAt(c+u);if(k!==l.charCodeAt(r+u))break;k===g&&(o=u)}if(u===s)if(i>s){if(l.charCodeAt(r+u)===g)return l.slice(r+u+1);if(u===0)return l.slice(r+u)}else f>s&&(h.charCodeAt(c+u)===g?o=u:u===0&&(o=0));let y="";for(u=c+o+1;u<=a;++u)(u===a||h.charCodeAt(u)===g)&&(y+=y.length===0?"..":"/..");return`${y}${l.slice(r+o)}`},toNamespacedPath(h){return h},dirname(h){if(w(h,"path"),h.length===0)return".";const l=h.charCodeAt(0)===g;let c=-1,a=!0;for(let f=h.length-1;f>=1;--f)if(h.charCodeAt(f)===g){if(!a){c=f;break}}else a=!1;return c===-1?l?"/":".":l&&c===1?"//":h.slice(0,c)},basename(h,l){l!==void 0&&w(l,"ext"),w(h,"path");let c=0,a=-1,f=!0,r;if(l!==void 0&&l.length>0&&l.length<=h.length){if(l===h)return"";let i=l.length-1,s=-1;for(r=h.length-1;r>=0;--r){const o=h.charCodeAt(r);if(o===g){if(!f){c=r+1;break}}else s===-1&&(f=!1,s=r+1),i>=0&&(o===l.charCodeAt(i)?--i==-1&&(a=r):(i=-1,a=s))}return c===a?a=s:a===-1&&(a=h.length),h.slice(c,a)}for(r=h.length-1;r>=0;--r)if(h.charCodeAt(r)===g){if(!f){c=r+1;break}}else a===-1&&(f=!1,a=r+1);return a===-1?"":h.slice(c,a)},extname(h){w(h,"path");let l=-1,c=0,a=-1,f=!0,r=0;for(let i=h.length-1;i>=0;--i){const s=h.charCodeAt(i);if(s===g){if(!f){c=i+1;break}continue}a===-1&&(f=!1,a=i+1),s===S?l===-1?l=i:r!==1&&(r=1):l!==-1&&(r=-1)}return l===-1||a===-1||r===0||r===1&&l===a-1&&l===c+1?"":h.slice(l,a)},format:P.bind(null,"/"),parse(h){w(h,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return l;const c=h.charCodeAt(0)===g;let a;c?(l.root="/",a=1):a=0;let f=-1,r=0,i=-1,s=!0,o=h.length-1,u=0;for(;o>=a;--o){const y=h.charCodeAt(o);if(y===g){if(!s){r=o+1;break}continue}i===-1&&(s=!1,i=o+1),y===S?f===-1?f=o:u!==1&&(u=1):f!==-1&&(u=-1)}if(i!==-1){const y=r===0&&c?1:r;f===-1||u===0||u===1&&f===i-1&&f===r+1?l.base=l.name=h.slice(y,i):(l.name=h.slice(y,f),l.base=h.slice(y,i),l.ext=h.slice(f,i))}return r>0?l.dir=h.slice(0,r-1):c&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=m.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=m.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=m.platform==="win32"?e.win32.join:e.posix.join,e.resolve=m.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=m.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=m.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=m.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=m.platform==="win32"?e.win32.extname:e.posix.extname,e.format=m.platform==="win32"?e.win32.format:e.posix.format,e.parse=m.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=m.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=m.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=m.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(J[84],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var m;(function(D){D[D.stdout=0]="stdout",D[D.stderr=1]="stderr"})(m=e.Source||(e.Source={}));var n;(function(D){D[D.Success=0]="Success",D[D.Unknown=1]="Unknown",D[D.AccessDenied=2]="AccessDenied",D[D.ProcessNotFound=3]="ProcessNotFound"})(n=e.TerminateResponseCode||(e.TerminateResponseCode={}));function L(D,...M){const S=M.reduce((C,I)=>(C[I]=!0,C),{}),g=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(D).filter(C=>!S[C]).forEach(C=>{for(let I=0;I<g.length;I++)if(C.search(g[I])!==-1){delete D[C];break}})}e.sanitizeProcessEnvironment=L}),define(J[85],Z([0,1,3]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const n=m.globals.performance&&typeof m.globals.performance.now=="function";class L{constructor(M){this._highResolution=n&&M,this._startTime=this._now(),this._stopTime=-1}static create(M=!0){return new L(M)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?m.globals.performance.now():Date.now()}}e.StopWatch=L}),define(J[4],Z([0,1,15,43,2,112,85]),function(V,e,m,n,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;let S=!1,g=!1;var b;(function(r){r.None=()=>L.Disposable.None;function i(B){if(g){const{onListenerDidAdd:F}=B,N=t.create();let T=0;B.onListenerDidAdd=()=>{++T==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),N.print()),F?.()}}}function s(B){return(F,N=null,T)=>{let A=!1,O;return O=B(_=>{if(!A)return O?O.dispose():A=!0,F.call(N,_)},null,T),A&&O.dispose(),O}}r.once=s;function o(B,F,N){return U((T,A=null,O)=>B(_=>T.call(A,F(_)),null,O),N)}r.map=o;function u(B,F,N){return U((T,A=null,O)=>B(_=>{F(_),T.call(A,_)},null,O),N)}r.forEach=u;function y(B,F,N){return U((T,A=null,O)=>B(_=>F(_)&&T.call(A,_),null,O),N)}r.filter=y;function k(B){return B}r.signal=k;function R(...B){return(F,N=null,T)=>(0,L.combinedDisposable)(...B.map(A=>A(O=>F.call(N,O),null,T)))}r.any=R;function W(B,F,N,T){let A=N;return o(B,O=>(A=F(A,O),A),T)}r.reduce=W;function U(B,F){let N;const T={onFirstListenerAdd(){N=B(A.fire,A)},onLastListenerRemove(){N.dispose()}};F||i(T);const A=new p(T);return F&&F.add(A),A.event}function K(B,F,N=100,T=!1,A,O){let _,j,ne,ae=0;const ce={leakWarningThreshold:A,onFirstListenerAdd(){_=B(le=>{ae++,j=F(j,le),T&&!ne&&(re.fire(j),j=void 0),clearTimeout(ne),ne=setTimeout(()=>{const he=j;j=void 0,ne=void 0,(!T||ae>1)&&re.fire(he),ae=0},N)})},onLastListenerRemove(){_.dispose()}};O||i(ce);const re=new p(ce);return O&&O.add(re),re.event}r.debounce=K;function x(B,F=(T,A)=>T===A,N){let T=!0,A;return y(B,O=>{const _=T||!F(O,A);return T=!1,A=O,_},N)}r.latch=x;function ee(B,F,N){return[r.filter(B,F,N),r.filter(B,T=>!F(T),N)]}r.split=ee;function Q(B,F=!1,N=[]){let T=N.slice(),A=B(j=>{T?T.push(j):_.fire(j)});const O=()=>{T&&T.forEach(j=>_.fire(j)),T=null},_=new p({onFirstListenerAdd(){A||(A=B(j=>_.fire(j)))},onFirstListenerDidAdd(){T&&(F?setTimeout(O):O())},onLastListenerRemove(){A&&A.dispose(),A=null}});return _.event}r.buffer=Q;class H{constructor(F){this.event=F}map(F){return new H(o(this.event,F))}forEach(F){return new H(u(this.event,F))}filter(F){return new H(y(this.event,F))}reduce(F,N){return new H(W(this.event,F,N))}latch(){return new H(x(this.event))}debounce(F,N=100,T=!1,A){return new H(K(this.event,F,N,T,A))}on(F,N,T){return this.event(F,N,T)}once(F,N,T){return s(this.event)(F,N,T)}}function X(B){return new H(B)}r.chain=X;function z(B,F,N=T=>T){const T=(...j)=>_.fire(N(...j)),A=()=>B.on(F,T),O=()=>B.removeListener(F,T),_=new p({onFirstListenerAdd:A,onLastListenerRemove:O});return _.event}r.fromNodeEventEmitter=z;function ie(B,F,N=T=>T){const T=(...j)=>_.fire(N(...j)),A=()=>B.addEventListener(F,T),O=()=>B.removeEventListener(F,T),_=new p({onFirstListenerAdd:A,onLastListenerRemove:O});return _.event}r.fromDOMEventEmitter=ie;function $(B){return new Promise(F=>s(B)(F))}r.toPromise=$;function q(B,F){return F(void 0),B(N=>F(N))}r.runAndSubscribe=q;function Y(B,F){let N=null;function T(O){N?.dispose(),N=new L.DisposableStore,F(O,N)}T(void 0);const A=B(O=>T(O));return(0,L.toDisposable)(()=>{A.dispose(),N?.dispose()})}r.runAndSubscribeWithStore=Y})(b=e.Event||(e.Event={}));class C{constructor(i){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${i}_${C._idPool++}`}start(i){this._stopWatch=new M.StopWatch(!0),this._listenerCount=i}stop(){if(this._stopWatch){const i=this._stopWatch.elapsed();this._elapsedOverall+=i,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${i.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}C._idPool=0;let I=-1;function E(r){const i=I;return I=r,{dispose(){I=i}}}e.setGlobalLeakWarningThreshold=E;class w{constructor(i,s=Math.random().toString(18).slice(2,5)){this.customThreshold=i,this.name=s,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(i,s){let o=I;if(typeof this.customThreshold=="number"&&(o=this.customThreshold),o<=0||s<o)return;this._stacks||(this._stacks=new Map);const u=this._stacks.get(i.value)||0;if(this._stacks.set(i.value,u+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=o*.5;let y,k=0;for(const[R,W]of this._stacks)(!y||k<W)&&(y=R,k=W);console.warn(`[${this.name}] potential listener LEAK detected, having ${s} listeners already. MOST frequent listener (${k}):`),console.warn(y)}return()=>{const y=this._stacks.get(i.value)||0;this._stacks.set(i.value,y-1)}}}class t{constructor(i){this.value=i}static create(){return new t(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class d{constructor(i,s,o){this.callback=i,this.callbackThis=s,this.stack=o,this.subscription=new L.SafeDisposable}invoke(i){this.callback.call(this.callbackThis,i)}}class p{constructor(i){this._disposed=!1,this._options=i,this._leakageMon=I>0?new w(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new C(this._options._profName):void 0}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(S){const i=Array.from(this._listeners);queueMicrotask(()=>{for(const s of i)s.subscription.isset()&&(s.subscription.unset(),s.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(i,s,o)=>{this._listeners||(this._listeners=new D.LinkedList);const u=this._listeners.isEmpty();u&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let y,k;this._leakageMon&&this._listeners.size>=30&&(k=t.create(),y=this._leakageMon.check(k,this._listeners.size+1)),S&&(k=k??t.create());const R=new d(i,s,k),W=this._listeners.push(R);u&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,i,s);const U=R.subscription.set(()=>{y&&y(),this._disposed||(W(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return o instanceof L.DisposableStore?o.add(U):Array.isArray(o)&&o.push(U),U}),this._event}fire(i){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new D.LinkedList);for(let s of this._listeners)this._deliveryQueue.push([s,i]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[s,o]=this._deliveryQueue.shift();try{s.invoke(o)}catch(u){(0,m.onUnexpectedError)(u)}}this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=p;class v extends p{async fireAsync(i,s,o){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new D.LinkedList);for(const u of this._listeners)this._asyncDeliveryQueue.push([u,i]);for(;this._asyncDeliveryQueue.size>0&&!s.isCancellationRequested;){const[u,y]=this._asyncDeliveryQueue.shift(),k=[],R={...y,token:s,waitUntil:W=>{if(Object.isFrozen(k))throw new Error("waitUntil can NOT be called asynchronous");o&&(W=o(W,u.callback)),k.push(W)}};try{u.invoke(R)}catch(W){(0,m.onUnexpectedError)(W);continue}Object.freeze(k),await Promise.allSettled(k).then(W=>{for(const U of W)U.status==="rejected"&&(0,m.onUnexpectedError)(U.reason)})}}}}e.AsyncEmitter=v;class P extends p{constructor(i){super(i);this._isPaused=0,this._eventQueue=new D.LinkedList,this._mergeFn=i?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const i=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(i))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(i){this._listeners&&(this._isPaused!==0?this._eventQueue.push(i):super.fire(i))}}e.PauseableEmitter=P;class h extends P{constructor(i){super(i);this._delay=i.delay??100}fire(i){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(i)}}e.DebounceEmitter=h;class l extends p{constructor(i){super(i);this._queuedEvents=[],this._mergeFn=i?.merge}fire(i){this._queuedEvents.push(i),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(s=>super.fire(s)),this._queuedEvents=[]})}}e.MicrotaskEmitter=l;class c{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new p({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(i){const s={event:i,listener:null};this.events.push(s),this.hasListeners&&this.hook(s);const o=()=>{this.hasListeners&&this.unhook(s);const u=this.events.indexOf(s);this.events.splice(u,1)};return(0,L.toDisposable)((0,n.once)(o))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(i=>this.hook(i))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(i=>this.unhook(i))}hook(i){i.listener=i.event(s=>this.emitter.fire(s))}unhook(i){i.listener&&i.listener.dispose(),i.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=c;class a{constructor(){this.buffers=[]}wrapEvent(i){return(s,o,u)=>i(y=>{const k=this.buffers[this.buffers.length-1];k?k.push(()=>s.call(o,y)):s.call(o,y)},void 0,u)}bufferEvents(i){const s=[];this.buffers.push(s);const o=i();return this.buffers.pop(),s.forEach(u=>u()),o}}e.EventBufferer=a;class f{constructor(){this.listening=!1,this.inputEvent=b.None,this.inputEventListener=L.Disposable.None,this.emitter=new p({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(i){this.inputEvent=i,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=i(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=f}),define(J[23],Z([0,1,4]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const n=Object.freeze(function(S,g){const b=setTimeout(S.bind(g),0);return{dispose(){clearTimeout(b)}}});var L;(function(S){function g(b){return b===S.None||b===S.Cancelled||b instanceof D?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}S.isCancellationToken=g,S.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:m.Event.None}),S.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(L=e.CancellationToken||(e.CancellationToken={}));class D{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?n:(this._emitter||(this._emitter=new m.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class M{constructor(g){this._token=void 0,this._parentListener=void 0,this._parentListener=g&&g.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new D),this._token}cancel(){this._token?this._token instanceof D&&this._token.cancel():this._token=L.Cancelled}dispose(g=!1){g&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof D&&this._token.dispose():this._token=L.None}}e.CancellationTokenSource=M}),define(J[113],Z([0,1,23]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class n{constructor(M){this.task=M,this.result=null}get(){if(this.result)return this.result;const M=new m.CancellationTokenSource,S=this.task(M.token);return this.result={promise:S,dispose:()=>{this.result=null,M.cancel(),M.dispose()}},this.result}}e.Cache=n;class L{constructor(M){this.computeFn=M,this.lastCache=void 0,this.lastArgKey=void 0}get(M){const S=JSON.stringify(M);return this.lastArgKey!==S&&(this.lastArgKey=S,this.lastCache=this.computeFn(M)),this.lastCache}}e.LRUCachedComputed=L}),define(J[48],Z([0,1,15,2]),function(V,e,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function L(h){const l=h;return l?[l.on,l.pause,l.resume,l.destroy].every(c=>typeof c=="function"):!1}e.isReadableStream=L;function D(h){const l=h;return l?L(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=D;function M(h,l){return new S(h,l)}e.newWriteableStream=M;class S{constructor(l,c){this.reducer=l,this.options=c,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(l){if(!this.state.destroyed){if(this.state.flowing)this.emitData(l);else if(this.buffer.data.push(l),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(c=>this.pendingWritePromises.push(c))}}error(l){this.state.destroyed||(this.state.flowing?this.emitError(l):this.buffer.error.push(l))}end(l){this.state.destroyed||(typeof l!="undefined"&&this.write(l),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(l){this.listeners.data.slice(0).forEach(c=>c(l))}emitError(l){this.listeners.error.length===0?(0,m.onUnexpectedError)(l):this.listeners.error.slice(0).forEach(c=>c(l))}emitEnd(){this.listeners.end.slice(0).forEach(l=>l())}on(l,c){if(!this.state.destroyed)switch(l){case"data":this.listeners.data.push(c),this.resume();break;case"end":this.listeners.end.push(c),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(c),this.state.flowing&&this.flowErrors();break}}removeListener(l,c){if(this.state.destroyed)return;let a;switch(l){case"data":a=this.listeners.data;break;case"end":a=this.listeners.end;break;case"error":a=this.listeners.error;break}if(a){const f=a.indexOf(c);f>=0&&a.splice(f,1)}}flowData(){if(this.buffer.data.length>0){const l=this.reducer(this.buffer.data);this.emitData(l),this.buffer.data.length=0;const c=[...this.pendingWritePromises];this.pendingWritePromises.length=0,c.forEach(a=>a())}}flowErrors(){if(this.listeners.error.length>0){for(const l of this.buffer.error)this.emitError(l);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function g(h,l){const c=[];let a;for(;(a=h.read())!==null;)c.push(a);return l(c)}e.consumeReadable=g;function b(h,l,c){const a=[];let f;for(;(f=h.read())!==null&&a.length<c;)a.push(f);return f===null&&a.length>0?l(a):{read:()=>{if(a.length>0)return a.shift();if(typeof f!="undefined"){const r=f;return f=void 0,r}return h.read()}}}e.peekReadable=b;function C(h,l){return new Promise((c,a)=>{const f=[];I(h,{onData:r=>{l&&f.push(r)},onError:r=>{l?a(r):c(void 0)},onEnd:()=>{c(l?l(f):void 0)}})})}e.consumeStream=C;function I(h,l){let c=!1;return h.on("error",a=>{c||l.onError(a)}),h.on("end",()=>{c||l.onEnd()}),h.on("data",a=>{c||l.onData(a)}),(0,n.toDisposable)(()=>c=!0)}e.listenStream=I;function E(h,l){return new Promise((c,a)=>{const f=new n.DisposableStore,r=[],i=u=>{if(r.push(u),r.length>l)return f.dispose(),h.pause(),c({stream:h,buffer:r,ended:!1})},s=u=>a(u),o=()=>c({stream:h,buffer:r,ended:!0});f.add((0,n.toDisposable)(()=>h.removeListener("error",s))),h.on("error",s),f.add((0,n.toDisposable)(()=>h.removeListener("end",o))),h.on("end",o),f.add((0,n.toDisposable)(()=>h.removeListener("data",i))),h.on("data",i)})}e.peekStream=E;function w(h,l){const c=M(l);return c.end(h),c}e.toStream=w;function t(){const h=M(()=>{throw new Error("not supported")});return h.end(),h}e.emptyStream=t;function d(h){let l=!1;return{read:()=>l?null:(l=!0,h)}}e.toReadable=d;function p(h,l,c){const a=M(c);return I(h,{onData:f=>a.write(l.data(f)),onError:f=>a.error(l.error?l.error(f):f),onEnd:()=>a.end()}),a}e.transform=p;function v(h,l,c){let a=!1;return{read:()=>{const f=l.read();return a?f:(a=!0,f!==null?c([h,f]):h)}}}e.prefixedReadable=v;function P(h,l,c){let a=!1;const f=M(c);return I(l,{onData:r=>a?f.write(r):(a=!0,f.write(c([h,r]))),onError:r=>f.error(r),onEnd:()=>{a||(a=!0,f.write(h)),f.end()}}),f}e.prefixedStream=P}),define(J[16],Z([0,1,48]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const n=typeof Buffer!="undefined";let L,D;class M{constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}static alloc(y){return n?new M(Buffer.allocUnsafe(y)):new M(new Uint8Array(y))}static wrap(y){return n&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new M(y)}static fromString(y,k){return!(k?.dontUseNodeBuffer||!1)&&n?new M(Buffer.from(y)):(L||(L=new TextEncoder),new M(L.encode(y)))}static fromByteArray(y){const k=M.alloc(y.length);for(let R=0,W=y.length;R<W;R++)k.buffer[R]=y[R];return k}static concat(y,k){if(typeof k=="undefined"){k=0;for(let U=0,K=y.length;U<K;U++)k+=y[U].byteLength}const R=M.alloc(k);let W=0;for(let U=0,K=y.length;U<K;U++){const x=y[U];R.set(x,W),W+=x.byteLength}return R}clone(){const y=M.alloc(this.byteLength);return y.set(this),y}toString(){return n?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(y,k){return new M(this.buffer.subarray(y,k))}set(y,k){if(y instanceof M)this.buffer.set(y.buffer,k);else if(y instanceof Uint8Array)this.buffer.set(y,k);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),k);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),k);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return b(this.buffer,y)}writeUInt32BE(y,k){C(this.buffer,y,k)}readUInt32LE(y){return I(this.buffer,y)}writeUInt32LE(y,k){E(this.buffer,y,k)}readUInt8(y){return w(this.buffer,y)}writeUInt8(y,k){t(this.buffer,y,k)}}e.VSBuffer=M;function S(u,y){return u[y+0]<<0>>>0|u[y+1]<<8>>>0}e.readUInt16LE=S;function g(u,y,k){u[k+0]=y&255,y=y>>>8,u[k+1]=y&255}e.writeUInt16LE=g;function b(u,y){return u[y]*2**24+u[y+1]*2**16+u[y+2]*2**8+u[y+3]}e.readUInt32BE=b;function C(u,y,k){u[k+3]=y,y=y>>>8,u[k+2]=y,y=y>>>8,u[k+1]=y,y=y>>>8,u[k]=y}e.writeUInt32BE=C;function I(u,y){return u[y+0]<<0>>>0|u[y+1]<<8>>>0|u[y+2]<<16>>>0|u[y+3]<<24>>>0}e.readUInt32LE=I;function E(u,y,k){u[k+0]=y&255,y=y>>>8,u[k+1]=y&255,y=y>>>8,u[k+2]=y&255,y=y>>>8,u[k+3]=y&255}e.writeUInt32LE=E;function w(u,y){return u[y]}e.readUInt8=w;function t(u,y,k){u[k]=y}e.writeUInt8=t;function d(u){return m.consumeReadable(u,y=>M.concat(y))}e.readableToBuffer=d;function p(u){return m.toReadable(u)}e.bufferToReadable=p;function v(u){return m.consumeStream(u,y=>M.concat(y))}e.streamToBuffer=v;async function P(u){return u.ended?M.concat(u.buffer):M.concat([...u.buffer,await v(u.stream)])}e.bufferedStreamToBuffer=P;function h(u){return m.toStream(u,y=>M.concat(y))}e.bufferToStream=h;function l(u){return m.transform(u,{data:y=>typeof y=="string"?M.fromString(y):M.wrap(y)},y=>M.concat(y))}e.streamToBufferReadableStream=l;function c(u){return m.newWriteableStream(y=>M.concat(y),u)}e.newWriteableBufferStream=c;function a(u,y){return m.prefixedReadable(u,y,k=>M.concat(k))}e.prefixedBufferReadable=a;function f(u,y){return m.prefixedStream(u,y,k=>M.concat(k))}e.prefixedBufferStream=f;function r(u){let y=0,k=0,R=0;const W=new Uint8Array(Math.floor(u.length/4*3)),U=x=>{switch(k){case 3:W[R++]=y|x,k=0;break;case 2:W[R++]=y|x>>>2,y=x<<6,k=3;break;case 1:W[R++]=y|x>>>4,y=x<<4,k=2;break;default:y=x<<2,k=1}};for(let x=0;x<u.length;x++){const ee=u.charCodeAt(x);if(ee>=65&&ee<=90)U(ee-65);else if(ee>=97&&ee<=122)U(ee-97+26);else if(ee>=48&&ee<=57)U(ee-48+52);else if(ee===43||ee===45)U(62);else if(ee===47||ee===95)U(63);else{if(ee===61)break;throw new SyntaxError(`Unexpected base64 character ${u[x]}`)}}const K=R;for(;k>0;)U(0);return M.wrap(W).slice(0,K)}e.decodeBase64=r;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function o({buffer:u},y=!0,k=!1){const R=k?s:i;let W="";const U=u.byteLength%3;let K=0;for(;K<u.byteLength-U;K+=3){const x=u[K+0],ee=u[K+1],Q=u[K+2];W+=R[x>>>2],W+=R[(x<<4|ee>>>4)&63],W+=R[(ee<<2|Q>>>6)&63],W+=R[Q&63]}if(U===1){const x=u[K+0];W+=R[x>>>2],W+=R[x<<4&63],y&&(W+="==")}else if(U===2){const x=u[K+0],ee=u[K+1];W+=R[x>>>2],W+=R[(x<<4|ee>>>4)&63],W+=R[ee<<2&63],y&&(W+="=")}return W}e.encodeBase64=o}),define(J[27],Z([0,1,113,111]),function(V,e,m,n){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function D(G){return!G||typeof G!="string"?!0:G.trim().length===0}e.isFalsyOrWhitespace=D;const M=/{(\d+)}/g;function S(G,...se){return se.length===0?G:G.replace(M,function(oe,fe){const ye=parseInt(fe,10);return isNaN(ye)||ye<0||ye>=se.length?oe:se[ye]})}e.format=S;const g=/{([^}]+)}/g;function b(G,se){return G.replace(g,(oe,fe)=>se[fe]??oe)}e.format2=b;function C(G){return G.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}e.escape=C;function I(G){return G.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=I;function E(G,se){let oe=0;const fe=se.charCodeAt(0);for(let ye=G.length-1;ye>=0;ye--)G.charCodeAt(ye)===fe&&oe++;return oe}e.count=E;function w(G,se,oe="\u2026"){return G.length<=se?G:`${G.substr(0,se)}${oe}`}e.truncate=w;function t(G,se=" "){const oe=d(G,se);return p(oe,se)}e.trim=t;function d(G,se){if(!G||!se)return G;const oe=se.length;if(oe===0||G.length===0)return G;let fe=0;for(;G.indexOf(se,fe)===fe;)fe=fe+oe;return G.substring(fe)}e.ltrim=d;function p(G,se){if(!G||!se)return G;const oe=se.length,fe=G.length;if(oe===0||fe===0)return G;let ye=fe,Ae=-1;for(;Ae=G.lastIndexOf(se,ye-1),!(Ae===-1||Ae+oe!==ye);){if(Ae===0)return"";ye=Ae}return G.substring(0,ye)}e.rtrim=p;function v(G){return G.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=v;function P(G){return G.replace(/\*/g,"")}e.stripWildcards=P;function h(G,se,oe={}){if(!G)throw new Error("Cannot create regex from empty string");se||(G=I(G)),oe.wholeWord&&(/\B/.test(G.charAt(0))||(G="\\b"+G),/\B/.test(G.charAt(G.length-1))||(G=G+"\\b"));let fe="";return oe.global&&(fe+="g"),oe.matchCase||(fe+="i"),oe.multiline&&(fe+="m"),oe.unicode&&(fe+="u"),new RegExp(G,fe)}e.createRegExp=h;function l(G){return G.source==="^"||G.source==="^$"||G.source==="$"||G.source==="^\\s*$"?!1:!!(G.exec("")&&G.lastIndex===0)}e.regExpLeadsToEndlessLoop=l;function c(G){return!!G.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=c;function a(G){return(G.global?"g":"")+(G.ignoreCase?"i":"")+(G.multiline?"m":"")+(G.unicode?"u":"")}e.regExpFlags=a;function f(G){return G.split(/\r\n|\r|\n/)}e.splitLines=f;function r(G){for(let se=0,oe=G.length;se<oe;se++){const fe=G.charCodeAt(se);if(fe!==32&&fe!==9)return se}return-1}e.firstNonWhitespaceIndex=r;function i(G,se=0,oe=G.length){for(let fe=se;fe<oe;fe++){const ye=G.charCodeAt(fe);if(ye!==32&&ye!==9)return G.substring(se,fe)}return G.substring(se,oe)}e.getLeadingWhitespace=i;function s(G,se=G.length-1){for(let oe=se;oe>=0;oe--){const fe=G.charCodeAt(oe);if(fe!==32&&fe!==9)return oe}return-1}e.lastNonWhitespaceIndex=s;function o(G,se){return G<se?-1:G>se?1:0}e.compare=o;function u(G,se,oe=0,fe=G.length,ye=0,Ae=se.length){for(;oe<fe&&ye<Ae;oe++,ye++){let je=G.charCodeAt(oe),Te=se.charCodeAt(ye);if(je<Te)return-1;if(je>Te)return 1}const _e=fe-oe,Ge=Ae-ye;return _e<Ge?-1:_e>Ge?1:0}e.compareSubstring=u;function y(G,se){return k(G,se,0,G.length,0,se.length)}e.compareIgnoreCase=y;function k(G,se,oe=0,fe=G.length,ye=0,Ae=se.length){for(;oe<fe&&ye<Ae;oe++,ye++){let je=G.charCodeAt(oe),Te=se.charCodeAt(ye);if(je===Te)continue;if(je>=128||Te>=128)return u(G.toLowerCase(),se.toLowerCase(),oe,fe,ye,Ae);R(je)&&(je-=32),R(Te)&&(Te-=32);const He=je-Te;if(He!==0)return He}const _e=fe-oe,Ge=Ae-ye;return _e<Ge?-1:_e>Ge?1:0}e.compareSubstringIgnoreCase=k;function R(G){return G>=97&&G<=122}e.isLowerAsciiLetter=R;function W(G){return G>=65&&G<=90}e.isUpperAsciiLetter=W;function U(G,se){return G.length===se.length&&k(G,se)===0}e.equalsIgnoreCase=U;function K(G,se){const oe=se.length;return se.length>G.length?!1:k(G,se,0,oe)===0}e.startsWithIgnoreCase=K;function x(G,se){let oe,fe=Math.min(G.length,se.length);for(oe=0;oe<fe;oe++)if(G.charCodeAt(oe)!==se.charCodeAt(oe))return oe;return fe}e.commonPrefixLength=x;function ee(G,se){let oe,fe=Math.min(G.length,se.length);const ye=G.length-1,Ae=se.length-1;for(oe=0;oe<fe;oe++)if(G.charCodeAt(ye-oe)!==se.charCodeAt(Ae-oe))return oe;return fe}e.commonSuffixLength=ee;function Q(G){return 55296<=G&&G<=56319}e.isHighSurrogate=Q;function H(G){return 56320<=G&&G<=57343}e.isLowSurrogate=H;function X(G,se){return(G-55296<<10)+(se-56320)+65536}e.computeCodePoint=X;function z(G,se,oe){const fe=G.charCodeAt(oe);if(Q(fe)&&oe+1<se){const ye=G.charCodeAt(oe+1);if(H(ye))return X(fe,ye)}return fe}e.getNextCodePoint=z;function ie(G,se){const oe=G.charCodeAt(se-1);if(H(oe)&&se>1){const fe=G.charCodeAt(se-2);if(Q(fe))return X(fe,oe)}return oe}class ${constructor(se,oe=0){this._str=se,this._len=se.length,this._offset=oe}get offset(){return this._offset}setOffset(se){this._offset=se}prevCodePoint(){const se=ie(this._str,this._offset);return this._offset-=se>=65536?2:1,se}nextCodePoint(){const se=z(this._str,this._len,this._offset);return this._offset+=se>=65536?2:1,se}eol(){return this._offset>=this._len}}e.CodePointIterator=$;class q{constructor(se,oe=0){this._iterator=new $(se,oe)}get offset(){return this._iterator.offset}nextGraphemeLength(){const se=$e.getInstance(),oe=this._iterator,fe=oe.offset;let ye=se.getGraphemeBreakType(oe.nextCodePoint());for(;!oe.eol();){const Ae=oe.offset,_e=se.getGraphemeBreakType(oe.nextCodePoint());if(xe(ye,_e)){oe.setOffset(Ae);break}ye=_e}return oe.offset-fe}prevGraphemeLength(){const se=$e.getInstance(),oe=this._iterator,fe=oe.offset;let ye=se.getGraphemeBreakType(oe.prevCodePoint());for(;oe.offset>0;){const Ae=oe.offset,_e=se.getGraphemeBreakType(oe.prevCodePoint());if(xe(_e,ye)){oe.setOffset(Ae);break}ye=_e}return fe-oe.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=q;function Y(G,se){return new q(G,se).nextGraphemeLength()}e.nextCharLength=Y;function B(G,se){return new q(G,se).prevGraphemeLength()}e.prevCharLength=B;function F(G,se){se>0&&H(G.charCodeAt(se))&&se--;const oe=se+Y(G,se);return[oe-B(G,oe),oe]}e.getCharContainingOffset=F;const N=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function T(G){return N.test(G)}e.containsRTL=T;const A=/^[\t\n\r\x20-\x7E]*$/;function O(G){return A.test(G)}e.isBasicASCII=O,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function _(G){return e.UNUSUAL_LINE_TERMINATORS.test(G)}e.containsUnusualLineTerminators=_;function j(G){return G>=11904&&G<=55215||G>=63744&&G<=64255||G>=65281&&G<=65374}e.isFullWidthCharacter=j;function ne(G){return G>=127462&&G<=127487||G===8986||G===8987||G===9200||G===9203||G>=9728&&G<=10175||G===11088||G===11093||G>=127744&&G<=128591||G>=128640&&G<=128764||G>=128992&&G<=129008||G>=129280&&G<=129535||G>=129648&&G<=129782}e.isEmojiImprecise=ne;function ae(G,se){if(G.length<se)return G;const oe=/\b/g;let fe=0;for(;oe.test(G)&&!(G.length-oe.lastIndex<se);)fe=oe.lastIndex,oe.lastIndex+=1;return G.substring(fe).replace(/^\s/,"")}e.lcut=ae;const ce=/\x1B\x5B[12]?K/g,re=/\x1b\[\d+m/g,le=/\x1b\[0?m/g;function he(G){return G&&(G=G.replace(ce,""),G=G.replace(re,""),G=G.replace(le,"")),G}e.removeAnsiEscapeCodes=he,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function we(G){return!!(G&&G.length>0&&G.charCodeAt(0)===65279)}e.startsWithUTF8BOM=we;function Ee(G){return we(G)?G.substr(1):G}e.stripUTF8BOM=Ee;function Ce(G,se){if(!G||!se||G.length<se.length)return!1;const oe=se.length,fe=G.toLowerCase();let ye=0,Ae=-1;for(;ye<oe;){const _e=fe.indexOf(se[ye],Ae+1);if(_e<0)return!1;Ae=_e,ye++}return!0}e.fuzzyContains=Ce;function Se(G,se=!1){return G?(se&&(G=G.replace(/\\./g,"")),G.toLowerCase()!==G):!1}e.containsUppercaseCharacter=Se;function pe(G){return G.charAt(0).toUpperCase()+G.slice(1)}e.uppercaseFirstLetter=pe;function Ie(G,se=1){if(se===0)return"";let oe=-1;do oe=G.indexOf(`
`,oe+1),se--;while(se>0&&oe>=0);return oe===-1?G:(G[oe-1]==="\r"&&oe--,G.substr(0,oe))}e.getNLines=Ie;function Re(G){const se=90-65+1;return G=G%(2*se),G<se?String.fromCharCode(97+G):String.fromCharCode(65+G-se)}e.singleLetterHash=Re;function Be(G){return $e.getInstance().getGraphemeBreakType(G)}e.getGraphemeBreakType=Be;function xe(G,se){return G===0?se!==5&&se!==7:G===2&&se===3?!1:G===4||G===2||G===3||se===4||se===2||se===3?!0:!(G===8&&(se===8||se===9||se===11||se===12)||(G===11||G===9)&&(se===9||se===10)||(G===12||G===10)&&se===10||se===5||se===13||se===7||G===1||G===13&&se===14||G===6&&se===6)}var Oe;(function(G){G[G.Other=0]="Other",G[G.Prepend=1]="Prepend",G[G.CR=2]="CR",G[G.LF=3]="LF",G[G.Control=4]="Control",G[G.Extend=5]="Extend",G[G.Regional_Indicator=6]="Regional_Indicator",G[G.SpacingMark=7]="SpacingMark",G[G.L=8]="L",G[G.V=9]="V",G[G.T=10]="T",G[G.LV=11]="LV",G[G.LVT=12]="LVT",G[G.ZWJ=13]="ZWJ",G[G.Extended_Pictographic=14]="Extended_Pictographic"})(Oe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class $e{constructor(){this._data=Ye()}static getInstance(){return $e._INSTANCE||($e._INSTANCE=new $e),$e._INSTANCE}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const oe=this._data,fe=oe.length/3;let ye=1;for(;ye<=fe;)if(se<oe[3*ye])ye=2*ye;else if(se>oe[3*ye+1])ye=2*ye+1;else return oe[3*ye+2];return 0}}$e._INSTANCE=null;function Ye(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function at(G,se){if(G===0)return 0;const oe=wt(G,se);if(oe!==void 0)return oe;const fe=new $(se,G);return fe.prevCodePoint(),fe.offset}e.getLeftDeleteOffset=at;function wt(G,se){const oe=new $(se,G);let fe=oe.prevCodePoint();for(;tt(fe)||fe===65039||fe===8419;){if(oe.offset===0)return;fe=oe.prevCodePoint()}if(!ne(fe))return;let ye=oe.offset;return ye>0&&oe.prevCodePoint()===8205&&(ye=oe.offset),ye}function tt(G){return 127995<=G&&G<=127999}var Qe;(function(G){G[G.zwj=8205]="zwj",G[G.emojiVariantSelector=65039]="emojiVariantSelector",G[G.enclosingKeyCap=8419]="enclosingKeyCap"})(Qe||(Qe={})),e.noBreakWhitespace="\xA0";class Ve{constructor(se){this.confusableDictionary=se}static getInstance(se){return Ve.cache.get(Array.from(se))}static getLocales(){return Ve._locales.getValue()}isAmbiguous(se){return this.confusableDictionary.has(se)}getPrimaryConfusable(se){return this.confusableDictionary.get(se)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Ve,L=Ve,Ve.ambiguousCharacterData=new n.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ve.cache=new m.LRUCachedComputed(G=>{function se(Te){const He=new Map;for(let Ke=0;Ke<Te.length;Ke+=2)He.set(Te[Ke],Te[Ke+1]);return He}function oe(Te,He){const Ke=new Map(Te);for(const[et,it]of He)Ke.set(et,it);return Ke}function fe(Te,He){if(!Te)return He;const Ke=new Map;for(const[et,it]of Te)He.has(et)&&Ke.set(et,it);return Ke}const ye=L.ambiguousCharacterData.getValue();let Ae=G.filter(Te=>!Te.startsWith("_")&&Te in ye);Ae.length===0&&(Ae=["_default"]);let _e;for(const Te of Ae){const He=se(ye[Te]);_e=fe(_e,He)}const Ge=se(ye._common),je=oe(Ge,_e);return new Ve(je)}),Ve._locales=new n.Lazy(()=>Object.keys(Ve.ambiguousCharacterData.getValue()).filter(G=>!G.startsWith("_")));class Xe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Xe.getRawData())),this._data}static isInvisibleCharacter(se){return Xe.getData().has(se)}static get codePoints(){return Xe.getData()}}e.InvisibleCharacters=Xe,Xe._data=void 0}),define(J[69],Z([0,1,27]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function n(v){return L(v,0)}e.hash=n;function L(v,P){switch(typeof v){case"object":return v===null?D(349,P):Array.isArray(v)?g(v,P):b(v,P);case"string":return S(v,P);case"boolean":return M(v,P);case"number":return D(v,P);case"undefined":return D(937,P);default:return D(617,P)}}e.doHash=L;function D(v,P){return(P<<5)-P+v|0}e.numberHash=D;function M(v,P){return D(v?433:863,P)}function S(v,P){P=D(149417,P);for(let h=0,l=v.length;h<l;h++)P=D(v.charCodeAt(h),P);return P}e.stringHash=S;function g(v,P){return P=D(104579,P),v.reduce((h,l)=>L(l,h),P)}function b(v,P){return P=D(181387,P),Object.keys(v).sort().reduce((h,l)=>(h=S(l,h),L(v[l],h)),P)}class C{constructor(){this._value=0}get value(){return this._value}hash(P){return this._value=L(P,this._value),this._value}}e.Hasher=C;var I;(function(v){v[v.BLOCK_SIZE=64]="BLOCK_SIZE",v[v.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function E(v,P,h=32){const l=h-P,c=~((1<<l)-1);return(v<<P|(c&v)>>>l)>>>0}function w(v,P=0,h=v.byteLength,l=0){for(let c=0;c<h;c++)v[P+c]=l}function t(v,P,h="0"){for(;v.length<P;)v=h+v;return v}function d(v,P=32){return v instanceof ArrayBuffer?Array.from(new Uint8Array(v)).map(h=>h.toString(16).padStart(2,"0")).join(""):t((v>>>0).toString(16),P/4)}e.toHexString=d;class p{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(P){const h=P.length;if(h===0)return;const l=this._buff;let c=this._buffLen,a=this._leftoverHighSurrogate,f,r;for(a!==0?(f=a,r=-1,a=0):(f=P.charCodeAt(0),r=0);;){let i=f;if(m.isHighSurrogate(f))if(r+1<h){const s=P.charCodeAt(r+1);m.isLowSurrogate(s)?(r++,i=m.computeCodePoint(f,s)):i=65533}else{a=f;break}else m.isLowSurrogate(f)&&(i=65533);if(c=this._push(l,c,i),r++,r<h)f=P.charCodeAt(r);else break}this._buffLen=c,this._leftoverHighSurrogate=a}_push(P,h,l){return l<128?P[h++]=l:l<2048?(P[h++]=192|(l&1984)>>>6,P[h++]=128|(l&63)>>>0):l<65536?(P[h++]=224|(l&61440)>>>12,P[h++]=128|(l&4032)>>>6,P[h++]=128|(l&63)>>>0):(P[h++]=240|(l&1835008)>>>18,P[h++]=128|(l&258048)>>>12,P[h++]=128|(l&4032)>>>6,P[h++]=128|(l&63)>>>0),h>=64&&(this._step(),h-=64,this._totalLen+=64,P[0]=P[64+0],P[1]=P[64+1],P[2]=P[64+2]),h}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),d(this._h0)+d(this._h1)+d(this._h2)+d(this._h3)+d(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,w(this._buff,this._buffLen),this._buffLen>56&&(this._step(),w(this._buff));const P=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(P/4294967296),!1),this._buffDV.setUint32(60,P%4294967296,!1),this._step()}_step(){const P=p._bigBlock32,h=this._buffDV;for(let u=0;u<64;u+=4)P.setUint32(u,h.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)P.setUint32(u,E(P.getUint32(u-12,!1)^P.getUint32(u-32,!1)^P.getUint32(u-56,!1)^P.getUint32(u-64,!1),1),!1);let l=this._h0,c=this._h1,a=this._h2,f=this._h3,r=this._h4,i,s,o;for(let u=0;u<80;u++)u<20?(i=c&a|~c&f,s=1518500249):u<40?(i=c^a^f,s=1859775393):u<60?(i=c&a|c&f|a&f,s=2400959708):(i=c^a^f,s=3395469782),o=E(l,5)+i+r+s+P.getUint32(u*4,!1)&4294967295,r=f,f=a,a=E(c,30),c=l,l=o;this._h0=this._h0+l&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+a&4294967295,this._h3=this._h3+f&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=p,p._bigBlock32=new DataView(new ArrayBuffer(320))});var Dt=this&&this.__classPrivateFieldSet||function(V,e,m,n,L){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!L)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?V!==e||!L:!e.has(V))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?L.call(V,m):L?L.value=m:e.set(V,m),m},Ze=this&&this.__classPrivateFieldGet||function(V,e,m,n){if(m==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?V!==e||!n:!e.has(V))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?n:m==="a"?n.call(V):n?n.value:e.get(V)};define(J[35],Z([0,1,30,27]),function(V,e,m,n){"use strict";var L,D,M;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function S(r,i,s){let o=r.get(i);return o===void 0&&(o=s,r.set(i,o)),o}e.getOrSet=S;function g(r){const i=[];return r.forEach((s,o)=>{i.push(`${o} => ${s}`)}),`Map(${r.size}) {${i.join(", ")}}`}e.mapToString=g;function b(r){const i=[];return r.forEach(s=>{i.push(s)}),`Set(${r.size}) {${i.join(", ")}}`}e.setToString=b;class C{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const s=i.charCodeAt(0),o=this._value.charCodeAt(this._pos);return s-o}value(){return this._value[this._pos]}}e.StringIterator=C;class I{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,n.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class E{constructor(i=!0,s=!0){this._splitOnBackslash=i,this._caseSensitive=s}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let s=i.length-1;s>=0;s--,this._valueLen--){const o=this._value.charCodeAt(s);if(!(o===47||this._splitOnBackslash&&o===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,n.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=E;var w;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(w||(w={}));class t{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new E(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,n.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,n.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,n.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,n.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=t;class d{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var p;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(p||(p={}));class v{constructor(i){this._iter=i}static forUris(i=()=>!1){return new v(new t(i))}static forPaths(i=!1){return new v(new E(void 0,!i))}static forStrings(){return new v(new C)}static forConfigKeys(){return new v(new I)}clear(){this._root=void 0}fill(i,s){if(s){const o=s.slice(0);(0,m.shuffle)(o);for(let u of o)this.set(u,i)}else{const o=i.slice(0);(0,m.shuffle)(o);for(let u of o)this.set(u[0],u[1])}}set(i,s){const o=this._iter.reset(i);let u;this._root||(this._root=new d,this._root.segment=o.value());const y=[];for(u=this._root;;){const R=o.cmp(u.segment);if(R>0)u.left||(u.left=new d,u.left.segment=o.value()),y.push([-1,u]),u=u.left;else if(R<0)u.right||(u.right=new d,u.right.segment=o.value()),y.push([1,u]),u=u.right;else if(o.hasNext())o.next(),u.mid||(u.mid=new d,u.mid.segment=o.value()),y.push([0,u]),u=u.mid;else break}const k=u.value;u.value=s,u.key=i;for(let R=y.length-1;R>=0;R--){const W=y[R][1];W.updateHeight();const U=W.balanceFactor();if(U<-1||U>1){const K=y[R][0],x=y[R+1][0];if(K===1&&x===1)y[R][1]=W.rotateLeft();else if(K===-1&&x===-1)y[R][1]=W.rotateRight();else if(K===1&&x===-1)W.right=y[R+1][1]=y[R+1][1].rotateRight(),y[R][1]=W.rotateLeft();else if(K===-1&&x===1)W.left=y[R+1][1]=y[R+1][1].rotateLeft(),y[R][1]=W.rotateRight();else throw new Error;if(R>0)switch(y[R-1][0]){case-1:y[R-1][1].left=y[R][1];break;case 1:y[R-1][1].right=y[R][1];break;case 0:y[R-1][1].mid=y[R][1];break}else this._root=y[0][1]}}return k}get(i){return this._getNode(i)?.value}_getNode(i){const s=this._iter.reset(i);let o=this._root;for(;o;){const u=s.cmp(o.segment);if(u>0)o=o.left;else if(u<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else break}return o}has(i){const s=this._getNode(i);return!(s?.value===void 0&&s?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,s){const o=this._iter.reset(i),u=[];let y=this._root;for(;y;){const k=o.cmp(y.segment);if(k>0)u.push([-1,y]),y=y.left;else if(k<0)u.push([1,y]),y=y.right;else if(o.hasNext())o.next(),u.push([0,y]),y=y.mid;else break}if(!!y){if(s?(y.left=void 0,y.mid=void 0,y.right=void 0,y.height=1):(y.key=void 0,y.value=void 0),!y.mid&&!y.value)if(y.left&&y.right){const k=this._min(y.right),{key:R,value:W,segment:U}=k;this._delete(k.key,!1),y.key=R,y.value=W,y.segment=U}else{const k=y.left??y.right;if(u.length>0){const[R,W]=u[u.length-1];switch(R){case-1:W.left=k;break;case 0:W.mid=k;break;case 1:W.right=k;break}}else this._root=k}for(let k=u.length-1;k>=0;k--){const R=u[k][1];R.updateHeight();const W=R.balanceFactor();if(W>1?(R.right.balanceFactor()>=0||(R.right=R.right.rotateRight()),u[k][1]=R.rotateLeft()):W<-1&&(R.left.balanceFactor()<=0||(R.left=R.left.rotateLeft()),u[k][1]=R.rotateRight()),k>0)switch(u[k-1][0]){case-1:u[k-1][1].left=u[k][1];break;case 1:u[k-1][1].right=u[k][1];break;case 0:u[k-1][1].mid=u[k][1];break}else this._root=u[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const s=this._iter.reset(i);let o=this._root,u;for(;o;){const y=s.cmp(o.segment);if(y>0)o=o.left;else if(y<0)o=o.right;else if(s.hasNext())s.next(),u=o.value||u,o=o.mid;else break}return o&&o.value||u}findSuperstr(i){const s=this._iter.reset(i);let o=this._root;for(;o;){const u=s.cmp(o.segment);if(u>0)o=o.left;else if(u<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(i){for(const[s,o]of this)i(o,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=s=>{if(!s)return!0;const o=s.balanceFactor();return o<-1||o>1?!1:i(s.left)&&i(s.right)};return i(this._root)}}e.TernarySearchTree=v;class P{constructor(i,s){this.uri=i,this.value=s}}class h{constructor(i,s){this[L]="ResourceMap",i instanceof h?(this.map=new Map(i.map),this.toKey=s??h.defaultToKey):(this.map=new Map,this.toKey=i??h.defaultToKey)}set(i,s){return this.map.set(this.toKey(i),new P(i,s)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,s){typeof s!="undefined"&&(i=i.bind(s));for(let[o,u]of this.map)i(u.value,u.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(L=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=h,h.defaultToKey=r=>r.toString();var l;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(l=e.Touch||(e.Touch={}));class c{constructor(){this[D]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,s=0){const o=this._map.get(i);if(!!o)return s!==0&&this.touch(o,s),o.value}set(i,s,o=0){let u=this._map.get(i);if(u)u.value=s,o!==0&&this.touch(u,o);else{switch(u={key:i,value:s,next:void 0,previous:void 0},o){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(i,u),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const s=this._map.get(i);if(!!s)return this._map.delete(i),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,s){const o=this._state;let u=this._head;for(;u;){if(s?i.bind(s)(u.value,u.key,this):i(u.value,u.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const i=this,s=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const y={value:o.key,done:!1};return o=o.next,y}else return{value:void 0,done:!0}}};return u}values(){const i=this,s=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const y={value:o.value,done:!1};return o=o.next,y}else return{value:void 0,done:!0}}};return u}entries(){const i=this,s=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const y={value:[o.key,o.value],done:!1};return o=o.next,y}else return{value:void 0,done:!0}}};return u}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let s=this._head,o=this.size;for(;s&&o>i;)this._map.delete(s.key),s=s.next,o--;this._head=s,this._size=o,s&&(s.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const s=i.next,o=i.previous;if(!s||!o)throw new Error("Invalid list");s.previous=o,o.next=s}i.next=void 0,i.previous=void 0,this._state++}touch(i,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(i===this._head)return;const o=i.next,u=i.previous;i===this._tail?(u.next=void 0,this._tail=u):(o.previous=u,u.next=o),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(s===2){if(i===this._tail)return;const o=i.next,u=i.previous;i===this._head?(o.previous=void 0,this._head=o):(o.previous=u,u.next=o),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((s,o)=>{i.push([o,s])}),i}fromJSON(i){this.clear();for(const[s,o]of i)this.set(s,o)}}e.LinkedMap=c;class a extends c{constructor(i,s=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,s=2){return super.get(i,s)}peek(i){return super.get(i,0)}set(i,s){return super.set(i,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=a;class f{constructor(i){M.set(this,void 0),Dt(this,M,i,"f")}get size(){return Ze(this,M,"f").size}forEach(i,s){Ze(this,M,"f").forEach(i,s)}get(i){return Ze(this,M,"f").get(i)}has(i){return Ze(this,M,"f").has(i)}entries(){return Ze(this,M,"f").entries()}keys(){return Ze(this,M,"f").keys()}values(){return Ze(this,M,"f").values()}[(M=new WeakMap,Symbol.iterator)](){return Ze(this,M,"f").entries()}}e.ReadonlyMapView=f}),define(J[70],Z([0,1,35]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const n=new m.LRUCache(1e4);function L(b){return g(b,"NFC",n)}e.normalizeNFC=L;const D=new m.LRUCache(1e4);function M(b){return g(b,"NFD",D)}e.normalizeNFD=M;const S=/[^\u0000-\u0080]/;function g(b,C,I){if(!b)return b;const E=I.get(b);if(E)return E;let w;return S.test(b)?w=b.normalize(C):w=b,I.set(b,w),w}e.removeAccents=function(){const b=/[\u0300-\u036f]/g;return function(C){return M(C).replace(b,"")}}()}),define(J[14],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function m(o){return Array.isArray(o)}e.isArray=m;function n(o){return typeof o=="string"}e.isString=n;function L(o){return Array.isArray(o)&&o.every(u=>n(u))}e.isStringArray=L;function D(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=D;function M(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=M;function S(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=S;function g(o){return o===!0||o===!1}e.isBoolean=g;function b(o){return typeof o=="undefined"}e.isUndefined=b;function C(o){return!I(o)}e.isDefined=C;function I(o){return b(o)||o===null}e.isUndefinedOrNull=I;function E(o,u){if(!o)throw new Error(u?`Unexpected type, expected '${u}'`:"Unexpected type")}e.assertType=E;function w(o){if(I(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=w;function t(...o){const u=[];for(let y=0;y<o.length;y++){const k=o[y];if(I(k))throw new Error(`Assertion Failed: argument at index ${y} is undefined or null`);u.push(k)}return u}e.assertAllDefined=t;const d=Object.prototype.hasOwnProperty;function p(o){if(!D(o))return!1;for(let u in o)if(d.call(o,u))return!1;return!0}e.isEmptyObject=p;function v(o){return typeof o=="function"}e.isFunction=v;function P(...o){return o.length>0&&o.every(v)}e.areFunctions=P;function h(o,u){const y=Math.min(o.length,u.length);for(let k=0;k<y;k++)l(o[k],u[k])}e.validateConstraints=h;function l(o,u){if(n(u)){if(typeof o!==u)throw new Error(`argument does not match constraint: typeof ${u}`)}else if(v(u)){try{if(o instanceof u)return}catch{}if(!I(o)&&o.constructor===u||u.length===1&&u.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=l;function c(o){let u=[],y=Object.getPrototypeOf(o);for(;Object.prototype!==y;)u=u.concat(Object.getOwnPropertyNames(y)),y=Object.getPrototypeOf(y);return u}e.getAllPropertyNames=c;function a(o){const u=[];for(const y of c(o))typeof o[y]=="function"&&u.push(y);return u}e.getAllMethodNames=a;function f(o,u){const y=R=>function(){const W=Array.prototype.slice.call(arguments,0);return u(R,W)};let k={};for(const R of o)k[R]=y(R);return k}e.createProxyObject=f;function r(o){return o===null?void 0:o}e.withNullAsUndefined=r;function i(o){return typeof o=="undefined"?null:o}e.withUndefinedAsNull=i;function s(o,u="Unreachable"){throw new Error(u)}e.assertNever=s}),define(J[28],Z([0,1,7,3,27,14]),function(V,e,m,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function M(s){return s===47||s===92}e.isPathSeparator=M;function S(s){return s.replace(/[\\/]/g,m.posix.sep)}e.toSlashes=S;function g(s){return s.indexOf("/")===-1&&(s=S(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=g;function b(s,o=m.posix.sep){if(!s)return"";const u=s.length,y=s.charCodeAt(0);if(M(y)){if(M(s.charCodeAt(1))&&!M(s.charCodeAt(2))){let R=3;const W=R;for(;R<u&&!M(s.charCodeAt(R));R++);if(W!==R&&!M(s.charCodeAt(R+1))){for(R+=1;R<u;R++)if(M(s.charCodeAt(R)))return s.slice(0,R+1).replace(/[\\/]/g,o)}}return o}else if(v(y)&&s.charCodeAt(1)===58)return M(s.charCodeAt(2))?s.slice(0,2)+o:s.slice(0,2);let k=s.indexOf("://");if(k!==-1){for(k+=3;k<u;k++)if(M(s.charCodeAt(k)))return s.slice(0,k+1)}return""}e.getRoot=b;function C(s){if(!n.isWindows||!s||s.length<5)return!1;let o=s.charCodeAt(0);if(o!==92||(o=s.charCodeAt(1),o!==92))return!1;let u=2;const y=u;for(;u<s.length&&(o=s.charCodeAt(u),o!==92);u++);return!(y===u||(o=s.charCodeAt(u+1),isNaN(o)||o===92))}e.isUNC=C;const I=/[\\/:\*\?"<>\|]/g,E=/[\\/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function t(s,o=n.isWindows){const u=o?I:E;return!(!s||s.length===0||/^\s+$/.test(s)||(u.lastIndex=0,u.test(s))||o&&w.test(s)||s==="."||s===".."||o&&s[s.length-1]==="."||o&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=t;function d(s,o,u){const y=s===o;return!u||y?y:!s||!o?!1:(0,L.equalsIgnoreCase)(s,o)}e.isEqual=d;function p(s,o,u,y=m.sep){if(s===o)return!0;if(!s||!o||o.length>s.length)return!1;if(u){if(!(0,L.startsWithIgnoreCase)(s,o))return!1;if(o.length===s.length)return!0;let R=o.length;return o.charAt(o.length-1)===y&&R--,s.charAt(R)===y}return o.charAt(o.length-1)!==y&&(o+=y),s.indexOf(o)===0}e.isEqualOrParent=p;function v(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=v;function P(s,o){return n.isWindows&&s.endsWith(":")&&(s+=m.sep),(0,m.isAbsolute)(s)||(s=(0,m.join)(o,s)),s=(0,m.normalize)(s),n.isWindows?(s=(0,L.rtrim)(s,m.sep),s.endsWith(":")&&(s+=m.sep)):(s=(0,L.rtrim)(s,m.sep),s||(s=m.sep)),s}e.sanitizeFilePath=P;function h(s){const o=(0,m.normalize)(s);return n.isWindows?s.length>3?!1:l(o)&&(s.length===2||o.charCodeAt(2)===92):o===m.posix.sep}e.isRootOrDriveLetter=h;function l(s,o){return(o!==void 0?o:n.isWindows)?v(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=l;function c(s){return l(s)?s[0]:void 0}e.getDriveLetter=c;function a(s,o,u){return o.length>s.length?-1:s===o?0:(u&&(s=s.toLowerCase(),o=o.toLowerCase()),s.indexOf(o))}e.indexOfPath=a;function f(s){const o=s.split(":");let u,y,k;for(const R of o){const W=Number(R);(0,D.isNumber)(W)?y===void 0?y=W:k===void 0&&(k=W):u=u?[u,R].join(":"):R}if(!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:y!==void 0?y:void 0,column:k!==void 0?k:y!==void 0?1:void 0}}e.parseLineAndColumnAware=f;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(s,o,u=8){let y="";for(let R=0;R<u;R++)y+=r.charAt(Math.floor(Math.random()*r.length));let k;return o?k=`${o}-${y}`:k=y,s?(0,m.join)(s,k):k}e.randomPath=i}),define(J[49],Z([0,1,14]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function n(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const p=Array.isArray(d)?[]:{};return Object.keys(d).forEach(v=>{d[v]&&typeof d[v]=="object"?p[v]=n(d[v]):p[v]=d[v]}),p}e.deepClone=n;function L(d){if(!d||typeof d!="object")return d;const p=[d];for(;p.length>0;){const v=p.shift();Object.freeze(v);for(const P in v)if(D.call(v,P)){const h=v[P];typeof h=="object"&&!Object.isFrozen(h)&&p.push(h)}}return d}e.deepFreeze=L;const D=Object.prototype.hasOwnProperty;function M(d,p){return S(d,p,new Set)}e.cloneAndChange=M;function S(d,p,v){if((0,m.isUndefinedOrNull)(d))return d;const P=p(d);if(typeof P!="undefined")return P;if((0,m.isArray)(d)){const h=[];for(const l of d)h.push(S(l,p,v));return h}if((0,m.isObject)(d)){if(v.has(d))throw new Error("Cannot clone recursive data-structure");v.add(d);const h={};for(let l in d)D.call(d,l)&&(h[l]=S(d[l],p,v));return v.delete(d),h}return d}function g(d,p,v=!0){return(0,m.isObject)(d)?((0,m.isObject)(p)&&Object.keys(p).forEach(P=>{P in d?v&&((0,m.isObject)(d[P])&&(0,m.isObject)(p[P])?g(d[P],p[P],v):d[P]=p[P]):d[P]=p[P]}),d):p}e.mixin=g;function b(d,p){if(d===p)return!0;if(d==null||p===null||p===void 0||typeof d!=typeof p||typeof d!="object"||Array.isArray(d)!==Array.isArray(p))return!1;let v,P;if(Array.isArray(d)){if(d.length!==p.length)return!1;for(v=0;v<d.length;v++)if(!b(d[v],p[v]))return!1}else{const h=[];for(P in d)h.push(P);h.sort();const l=[];for(P in p)l.push(P);if(l.sort(),!b(h,l))return!1;for(v=0;v<h.length;v++)if(!b(d[h[v]],p[h[v]]))return!1}return!0}e.equals=b;function C(d){const p=new Set;return JSON.stringify(d,(v,P)=>{if((0,m.isObject)(P)||Array.isArray(P)){if(p.has(P))return"[Circular]";p.add(P)}return P})}e.safeStringify=C;function I(d,p,v){const P=p(d);return typeof P=="undefined"?v:P}e.getOrDefault=I;function E(d,p){const v=Object.create(null);return!d||!p||Object.keys(p).forEach(h=>{const l=d[h],c=p[h];b(l,c)||(v[h]=c)}),v}e.distinct=E;function w(d,p){const v=p.toLowerCase(),P=Object.keys(d).find(h=>h.toLowerCase()===v);return P?d[P]:d[p]}e.getCaseInsensitive=w;function t(d,p){const v=Object.create(null);for(const[P,h]of Object.entries(d))p(P,h)&&(v[P]=h);return v}e.filter=t}),define(J[8],Z([0,1,7,3]),function(V,e,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const L=/^\w[\w\d+.-]*$/,D=/^\//,M=/^\/\//;function S(r,i){if(!r.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!L.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!D.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(M.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function g(r,i){return!r&&!i?"file":r}function b(r,i){switch(r){case"https":case"http":case"file":i?i[0]!==I&&(i=I+i):i=I;break}return i}const C="",I="/",E=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class w{constructor(i,s,o,u,y,k=!1){typeof i=="object"?(this.scheme=i.scheme||C,this.authority=i.authority||C,this.path=i.path||C,this.query=i.query||C,this.fragment=i.fragment||C):(this.scheme=g(i,k),this.authority=s||C,this.path=b(this.scheme,o||C),this.query=u||C,this.fragment=y||C,S(this,k))}static isUri(i){return i instanceof w?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return h(this,!1)}with(i){if(!i)return this;let{scheme:s,authority:o,path:u,query:y,fragment:k}=i;return s===void 0?s=this.scheme:s===null&&(s=C),o===void 0?o=this.authority:o===null&&(o=C),u===void 0?u=this.path:u===null&&(u=C),y===void 0?y=this.query:y===null&&(y=C),k===void 0?k=this.fragment:k===null&&(k=C),s===this.scheme&&o===this.authority&&u===this.path&&y===this.query&&k===this.fragment?this:new d(s,o,u,y,k)}static parse(i,s=!1){const o=E.exec(i);return o?new d(o[2]||C,f(o[4]||C),f(o[5]||C),f(o[7]||C),f(o[9]||C),s):new d(C,C,C,C,C)}static file(i){let s=C;if(n.isWindows&&(i=i.replace(/\\/g,I)),i[0]===I&&i[1]===I){const o=i.indexOf(I,2);o===-1?(s=i.substring(2),i=I):(s=i.substring(2,o),i=i.substring(o)||I)}return new d("file",s,i,C,C)}static from(i){const s=new d(i.scheme,i.authority,i.path,i.query,i.fragment);return S(s,!0),s}static joinPath(i,...s){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return n.isWindows&&i.scheme==="file"?o=w.file(m.win32.join(h(i,!0),...s)).path:o=m.posix.join(i.path,...s),i.with({path:o})}toString(i=!1){return l(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof w)return i;{const s=new d(i);return s._formatted=i.external,s._fsPath=i._sep===t?i.fsPath:null,s}}else return i}}e.URI=w;const t=n.isWindows?1:void 0;class d extends w{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=h(this,!1)),this._fsPath}toString(i=!1){return i?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=t),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const p={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function v(r,i){let s,o=-1;for(let u=0;u<r.length;u++){const y=r.charCodeAt(u);if(y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57||y===45||y===46||y===95||y===126||i&&y===47)o!==-1&&(s+=encodeURIComponent(r.substring(o,u)),o=-1),s!==void 0&&(s+=r.charAt(u));else{s===void 0&&(s=r.substr(0,u));const k=p[y];k!==void 0?(o!==-1&&(s+=encodeURIComponent(r.substring(o,u)),o=-1),s+=k):o===-1&&(o=u)}}return o!==-1&&(s+=encodeURIComponent(r.substring(o))),s!==void 0?s:r}function P(r){let i;for(let s=0;s<r.length;s++){const o=r.charCodeAt(s);o===35||o===63?(i===void 0&&(i=r.substr(0,s)),i+=p[o]):i!==void 0&&(i+=r[s])}return i!==void 0?i:r}function h(r,i){let s;return r.authority&&r.path.length>1&&r.scheme==="file"?s=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?i?s=r.path.substr(1):s=r.path[1].toLowerCase()+r.path.substr(2):s=r.path,n.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=h;function l(r,i){const s=i?P:v;let o="",{scheme:u,authority:y,path:k,query:R,fragment:W}=r;if(u&&(o+=u,o+=":"),(y||u==="file")&&(o+=I,o+=I),y){let U=y.indexOf("@");if(U!==-1){const K=y.substr(0,U);y=y.substr(U+1),U=K.indexOf(":"),U===-1?o+=s(K,!1):(o+=s(K.substr(0,U),!1),o+=":",o+=s(K.substr(U+1),!1)),o+="@"}y=y.toLowerCase(),U=y.indexOf(":"),U===-1?o+=s(y,!1):(o+=s(y.substr(0,U),!1),o+=y.substr(U))}if(k){if(k.length>=3&&k.charCodeAt(0)===47&&k.charCodeAt(2)===58){const U=k.charCodeAt(1);U>=65&&U<=90&&(k=`/${String.fromCharCode(U+32)}:${k.substr(3)}`)}else if(k.length>=2&&k.charCodeAt(1)===58){const U=k.charCodeAt(0);U>=65&&U<=90&&(k=`${String.fromCharCode(U+32)}:${k.substr(2)}`)}o+=s(k,!0)}return R&&(o+="?",o+=s(R,!1)),W&&(o+="#",o+=i?W:v(W,!1)),o}function c(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+c(r.substr(3)):r}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function f(r){return r.match(a)?r.replace(a,i=>c(i)):r}}),define(J[114],Z([0,1,8]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function n(b){const C=b;return C&&typeof C.type=="string"&&typeof C.severity=="string"}e.isRemoteConsoleLog=n;function L(b){const C=[];let I;try{const E=JSON.parse(b.arguments),w=E[E.length-1];w&&w.__$stack&&(E.pop(),I=w.__$stack),C.push(...E)}catch{C.push("Unable to log remote console arguments",b.arguments)}return{args:C,stack:I}}e.parse=L;function D(b){if(typeof b!="string")return D(L(b).stack);const C=b;if(C){const I=M(C),E=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(E&&E.length===4)return{uri:m.URI.file(E[1]),line:Number(E[2]),column:Number(E[3])}}}e.getFirstFrame=D;function M(b){if(!b)return b;const C=b.indexOf(`
`);return C===-1?b:b.substring(0,C)}function S(b,C){const{args:I,stack:E}=L(b),w=typeof I[0]=="string"&&I.length===1;let t=M(E);t&&(t=`(${t.trim()})`);let d=[];if(typeof I[0]=="string"?t&&w?d=[`%c[${C}] %c${I[0]} %c${t}`,g("blue"),g(""),g("grey")]:d=[`%c[${C}] %c${I[0]}`,g("blue"),g(""),...I.slice(1)]:d=[`%c[${C}]%`,g("blue"),...I],t&&!w&&d.push(t),typeof console[b.severity]!="function")throw new Error("Unknown console method");console[b.severity].apply(console,d)}e.log=S;function g(b){return`color: ${b}`}}),define(J[115],Z([0,1,16,27,8]),function(V,e,m,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function D(b){return JSON.stringify(b,S)}e.stringify=D;function M(b){let C=JSON.parse(b);return C=g(C),C}e.parse=M;function S(b,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,n.regExpFlags)(C)}:C}function g(b,C=0){if(!b||C>200)return b;if(typeof b=="object"){switch(b.$mid){case 1:return L.URI.revive(b);case 2:return new RegExp(b.source,b.flags);case 14:return new Date(b.source)}if(b instanceof m.VSBuffer||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let I=0;I<b.length;++I)b[I]=g(b[I],C+1);else for(const I in b)Object.hasOwnProperty.call(b,I)&&(b[I]=g(b[I],C+1))}return b}e.revive=g}),define(J[10],Z([0,1,3,8]),function(V,e,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var L;(function(S){S.inMemory="inmemory",S.vscode="vscode",S.internal="private",S.walkThrough="walkThrough",S.walkThroughSnippet="walkThroughSnippet",S.http="http",S.https="https",S.file="file",S.mailto="mailto",S.untitled="untitled",S.data="data",S.command="command",S.vscodeRemote="vscode-remote",S.vscodeRemoteResource="vscode-remote-resource",S.userData="vscode-userdata",S.vscodeCustomEditor="vscode-custom-editor",S.vscodeNotebook="vscode-notebook",S.vscodeNotebookCell="vscode-notebook-cell",S.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",S.vscodeNotebookCellOutput="vscode-notebook-cell-output",S.vscodeInteractive="vscode-interactive",S.vscodeInteractiveInput="vscode-interactive-input",S.vscodeSettings="vscode-settings",S.vscodeWorkspaceTrust="vscode-workspace-trust",S.vscodeTerminal="vscode-terminal",S.webviewPanel="webview-panel",S.vscodeWebview="vscode-webview",S.extension="extension",S.vscodeFileResource="vscode-file",S.tmp="tmp",S.vsls="vsls"})(L=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class D{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(g){this._preferredWebSchema=g}setDelegate(g){this._delegate=g}set(g,b,C){this._hosts[g]=b,this._ports[g]=C}setConnectionToken(g,b){this._connectionTokens[g]=b}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(g){if(this._delegate)return this._delegate(g);const b=g.authority;let C=this._hosts[b];C&&C.indexOf(":")!==-1&&(C=`[${C}]`);const I=this._ports[b],E=this._connectionTokens[b];let w=`path=${encodeURIComponent(g.path)}`;return typeof E=="string"&&(w+=`&${e.connectionTokenQueryName}=${encodeURIComponent(E)}`),n.URI.from({scheme:m.isWeb?this._preferredWebSchema:L.vscodeRemoteResource,authority:`${C}:${I}`,path:"/vscode-remote-resource",query:w})}}e.RemoteAuthorities=new D;class M{asBrowserUri(g,b){const C=this.toUri(g,b);return C.scheme===L.vscodeRemote?e.RemoteAuthorities.rewrite(C):C.scheme===L.file&&(m.isNative||m.isWebWorker&&m.globals.origin===`${L.vscodeFileResource}://${M.FALLBACK_AUTHORITY}`)?C.with({scheme:L.vscodeFileResource,authority:C.authority||M.FALLBACK_AUTHORITY,query:null,fragment:null}):C}asFileUri(g,b){const C=this.toUri(g,b);return C.scheme===L.vscodeFileResource?C.with({scheme:L.file,authority:C.authority!==M.FALLBACK_AUTHORITY?C.authority:null,query:null,fragment:null}):C}toUri(g,b){return n.URI.isUri(g)?g:n.URI.parse(b.toUrl(g))}}M.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new M}),define(J[17],Z([0,1,28,10,7,3,27,8]),function(V,e,m,n,L,D,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function g(w){return(0,S.uriToFsPath)(w,!0)}e.originalFSPath=g;class b{constructor(t){this._ignorePathCasing=t}compare(t,d,p=!1){return t===d?0:(0,M.compare)(this.getComparisonKey(t,p),this.getComparisonKey(d,p))}isEqual(t,d,p=!1){return t===d?!0:!t||!d?!1:this.getComparisonKey(t,p)===this.getComparisonKey(d,p)}getComparisonKey(t,d=!1){return t.with({path:this._ignorePathCasing(t)?t.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(t){return this._ignorePathCasing(t)}isEqualOrParent(t,d,p=!1){if(t.scheme===d.scheme){if(t.scheme===n.Schemas.file)return m.isEqualOrParent(g(t),g(d),this._ignorePathCasing(t))&&t.query===d.query&&(p||t.fragment===d.fragment);if((0,e.isEqualAuthority)(t.authority,d.authority))return m.isEqualOrParent(t.path,d.path,this._ignorePathCasing(t),"/")&&t.query===d.query&&(p||t.fragment===d.fragment)}return!1}joinPath(t,...d){return S.URI.joinPath(t,...d)}basenameOrAuthority(t){return(0,e.basename)(t)||t.authority}basename(t){return L.posix.basename(t.path)}extname(t){return L.posix.extname(t.path)}dirname(t){if(t.path.length===0)return t;let d;return t.scheme===n.Schemas.file?d=S.URI.file(L.dirname(g(t))).path:(d=L.posix.dirname(t.path),t.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${t.toString})) resulted in a relative path`),d="/")),t.with({path:d})}normalizePath(t){if(!t.path.length)return t;let d;return t.scheme===n.Schemas.file?d=S.URI.file(L.normalize(g(t))).path:d=L.posix.normalize(t.path),t.with({path:d})}relativePath(t,d){if(t.scheme!==d.scheme||!(0,e.isEqualAuthority)(t.authority,d.authority))return;if(t.scheme===n.Schemas.file){const P=L.relative(g(t),g(d));return D.isWindows?m.toSlashes(P):P}let p=t.path||"/",v=d.path||"/";if(this._ignorePathCasing(t)){let P=0;for(const h=Math.min(p.length,v.length);P<h&&!(p.charCodeAt(P)!==v.charCodeAt(P)&&p.charAt(P).toLowerCase()!==v.charAt(P).toLowerCase());P++);p=v.substr(0,P)+p.substr(P)}return L.posix.relative(p,v)}resolvePath(t,d){if(t.scheme===n.Schemas.file){const p=S.URI.file(L.resolve(g(t),d));return t.with({authority:p.authority,path:p.path})}return d=m.toPosixPath(d),t.with({path:L.posix.resolve(t.path,d)})}isAbsolutePath(t){return!!t.path&&t.path[0]==="/"}isEqualAuthority(t,d){return t===d||t!==void 0&&d!==void 0&&(0,M.equalsIgnoreCase)(t,d)}hasTrailingPathSeparator(t,d=L.sep){if(t.scheme===n.Schemas.file){const p=g(t);return p.length>m.getRoot(p).length&&p[p.length-1]===d}else{const p=t.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(t.fsPath)}}removeTrailingPathSeparator(t,d=L.sep){return(0,e.hasTrailingPathSeparator)(t,d)?t.with({path:t.path.substr(0,t.path.length-1)}):t}addTrailingPathSeparator(t,d=L.sep){let p=!1;if(t.scheme===n.Schemas.file){const v=g(t);p=v!==void 0&&v.length===m.getRoot(v).length&&v[v.length-1]===d}else{d="/";const v=t.path;p=v.length===1&&v.charCodeAt(v.length-1)===47}return!p&&!(0,e.hasTrailingPathSeparator)(t,d)?t.with({path:t.path+"/"}):t}}e.ExtUri=b,e.extUri=new b(()=>!1),e.extUriBiasedIgnorePathCase=new b(w=>w.scheme===n.Schemas.file?!D.isLinux:!0),e.extUriIgnorePathCase=new b(w=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function C(w,t){const d=[];for(let p=0;p<w.length;p++){const v=t(w[p]);w.some((P,h)=>h===p?!1:(0,e.isEqualOrParent)(v,t(P)))||d.push(w[p])}return d}e.distinctParents=C;var I;(function(w){w.META_DATA_LABEL="label",w.META_DATA_DESCRIPTION="description",w.META_DATA_SIZE="size",w.META_DATA_MIME="mime";function t(d){const p=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(h=>{const[l,c]=h.split(":");l&&c&&p.set(l,c)});const P=d.path.substring(0,d.path.indexOf(";"));return P&&p.set(w.META_DATA_MIME,P),p}w.parseMetaData=t})(I=e.DataUri||(e.DataUri={}));function E(w,t,d){if(t){let p=w.path;return p&&p[0]!==L.posix.sep&&(p=L.posix.sep+p),w.with({scheme:d,authority:t,path:p})}return w.with({scheme:d})}e.toLocalResource=E}),define(J[9],Z([0,1,23,15,4,2,17,3]),function(V,e,m,n,L,D,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function g(T){return!!T&&typeof T.then=="function"}e.isThenable=g;function b(T){const A=new m.CancellationTokenSource,O=T(A.token),_=new Promise((j,ne)=>{const ae=A.token.onCancellationRequested(()=>{ae.dispose(),A.dispose(),ne(new n.CancellationError)});Promise.resolve(O).then(ce=>{ae.dispose(),A.dispose(),j(ce)},ce=>{ae.dispose(),A.dispose(),ne(ce)})});return new class{cancel(){A.cancel()}then(j,ne){return _.then(j,ne)}catch(j){return this.then(void 0,j)}finally(j){return _.finally(j)}}}e.createCancelablePromise=b;function C(T,A,O){return new Promise((_,j)=>{const ne=A.onCancellationRequested(()=>{ne.dispose(),_(O)});T.then(_,j).finally(()=>ne.dispose())})}e.raceCancellation=C;function I(T,A){return new Promise((O,_)=>{const j=A.onCancellationRequested(()=>{j.dispose(),_(new n.CancellationError)});T.then(O,_).finally(()=>j.dispose())})}e.raceCancellationError=I;async function E(T){let A=-1;const O=T.map((j,ne)=>j.then(ae=>(A=ne,ae))),_=await Promise.race(O);return T.forEach((j,ne)=>{ne!==A&&j.cancel()}),_}e.raceCancellablePromises=E;function w(T,A,O){let _;const j=setTimeout(()=>{_?.(void 0),O?.()},A);return Promise.race([T.finally(()=>clearTimeout(j)),new Promise(ne=>_=ne)])}e.raceTimeout=w;function t(T){return new Promise((A,O)=>{const _=T();g(_)?_.then(A,O):A(_)})}e.asPromise=t;class d{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(A){if(this.activePromise){if(this.queuedPromiseFactory=A,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const _=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,_};this.queuedPromise=new Promise(_=>{this.activePromise.then(O,O).then(_)})}return new Promise((O,_)=>{this.queuedPromise.then(O,_)})}return this.activePromise=A(),new Promise((O,_)=>{this.activePromise.then(j=>{this.activePromise=null,O(j)},j=>{this.activePromise=null,_(j)})})}}e.Throttler=d;class p{constructor(){this.current=Promise.resolve(null)}queue(A){return this.current=this.current.then(()=>A(),()=>A())}}e.Sequencer=p;class v{constructor(){this.promiseMap=new Map}queue(A,O){const j=(this.promiseMap.get(A)??Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get(A)===j&&this.promiseMap.delete(A)});return this.promiseMap.set(A,j),j}}e.SequencerByKey=v;const P=(T,A)=>{let O=!0;const _=setTimeout(()=>{O=!1,A()},T);return{isTriggered:()=>O,dispose:()=>{clearTimeout(_),O=!1}}},h=T=>{let A=!0;return queueMicrotask(()=>{A&&(A=!1,T())}),{isTriggered:()=>A,dispose:()=>{A=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class l{constructor(A){this.defaultDelay=A,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(A,O=this.defaultDelay){this.task=A,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((j,ne)=>{this.doResolve=j,this.doReject=ne}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const j=this.task;return this.task=null,j()}}));const _=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=O===e.MicrotaskDelay?h(_):P(O,_),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new n.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=l;class c{constructor(A){this.delayer=new l(A),this.throttler=new d}trigger(A,O){return this.delayer.trigger(()=>this.throttler.queue(A),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=c;class a{constructor(){this._isOpen=!1,this._promise=new Promise((A,O)=>{this._completePromise=A})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=a;class f extends a{constructor(A){super();this._timeout=setTimeout(()=>this.open(),A)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=f;function r(T,A){return A?new Promise((O,_)=>{const j=setTimeout(()=>{ne.dispose(),O()},T),ne=A.onCancellationRequested(()=>{clearTimeout(j),ne.dispose(),_(new n.CancellationError)})}):b(O=>r(T,O))}e.timeout=r;function i(T,A=0){const O=setTimeout(T,A);return(0,D.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=i;function s(T){const A=[];let O=0;const _=T.length;function j(){return O<_?T[O++]():null}function ne(ae){ae!=null&&A.push(ae);const ce=j();return ce?ce.then(ne):Promise.resolve(A)}return Promise.resolve(null).then(ne)}e.sequence=s;function o(T,A=_=>!!_,O=null){let _=0;const j=T.length,ne=()=>{if(_>=j)return Promise.resolve(O);const ae=T[_++];return Promise.resolve(ae()).then(re=>A(re)?Promise.resolve(re):ne())};return ne()}e.first=o;function u(T,A=_=>!!_,O=null){if(T.length===0)return Promise.resolve(O);let _=T.length;const j=()=>{_=-1;for(const ne of T)ne.cancel?.()};return new Promise((ne,ae)=>{for(const ce of T)ce.then(re=>{--_>=0&&A(re)?(j(),ne(re)):_===0&&ne(O)}).catch(re=>{--_>=0&&(j(),ae(re))})})}e.firstParallel=u;class y{constructor(A){this._size=0,this.maxDegreeOfParalellism=A,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new L.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(A){return this._size++,new Promise((O,_)=>{this.outstandingPromises.push({factory:A,c:O,e:_}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const A=this.outstandingPromises.shift();this.runningPromises++;const O=A.factory();O.then(A.c,A.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=y;class k extends y{constructor(){super(1)}}e.Queue=k;class R{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const A=new $;return this.drainers.add(A),A.p}isDrained(){for(const[,A]of this.queues)if(A.size>0)return!1;return!0}queueFor(A,O=M.extUri){const _=O.getComparisonKey(A);let j=this.queues.get(_);return j||(j=new k,L.Event.once(j.onFinished)(()=>{j?.dispose(),this.queues.delete(_),this.onDidQueueFinish()}),this.queues.set(_,j)),j}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const A of this.drainers)A.complete();this.drainers.clear()}dispose(){for(const[,A]of this.queues)A.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=R;class W{constructor(A,O){this._token=-1,typeof A=="function"&&typeof O=="number"&&this.setIfNotSet(A,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(A,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,A()},O)}setIfNotSet(A,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,A()},O))}}e.TimeoutTimer=W;class U{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(A,O){this.cancel(),this._token=setInterval(()=>{A()},O)}}e.IntervalTimer=U;class K{constructor(A,O){this.timeoutToken=-1,this.runner=A,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(A=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,A)}get delay(){return this.timeout}set delay(A){this.timeout=A}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=K;class x{constructor(A,O){O%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.runner=A,this.timeout=O,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(A=this.timeout){A%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${A}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(A/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=x;class ee extends K{constructor(A,O){super(A,O);this.units=[]}work(A){this.units.push(A),this.isScheduled()||this.schedule()}doRun(){const A=this.units;this.units=[],this.runner&&this.runner(A)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=ee;class Q extends D.Disposable{constructor(A,O){super();this.options=A,this.handler=O,this.pendingWork=[],this.throttler=this._register(new D.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(A){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+A.length>this.options.maxBufferedWork)return!1}else if(this.pending+A.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...A),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new K(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=Q,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=T=>{(0,S.setTimeout0)(()=>{if(A)return;const O=Date.now()+15;T(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let A=!1;return{dispose(){A||(A=!0)}}}:e.runWhenIdle=(T,A)=>{const O=requestIdleCallback(T,typeof A=="number"?{timeout:A}:void 0);let _=!1;return{dispose(){_||(_=!0,cancelIdleCallback(O))}}}}();class H{constructor(A){this._didRun=!1,this._executor=()=>{try{this._value=A()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=H;async function X(T,A,O){let _;for(let j=0;j<O;j++)try{return await T()}catch(ne){_=ne,await r(A)}throw _}e.retry=X;class z{hasPending(A){return this._pending?typeof A=="number"?this._pending.taskId===A:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(A,O,_){return this._pending={taskId:A,cancel:()=>_?.(),promise:O},O.then(()=>this.donePending(A),()=>this.donePending(A)),O}donePending(A){this._pending&&A===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const A=this._next;this._next=void 0,A.run().then(A.promiseResolve,A.promiseReject)}}setNext(A){if(this._next)this._next.run=A;else{let O,_;const j=new Promise((ne,ae)=>{O=ne,_=ae});this._next={run:A,promise:j,promiseResolve:O,promiseReject:_}}return this._next.promise}}e.TaskSequentializer=z;class ie{constructor(A,O=()=>Date.now()){this.interval=A,this.nowFn=O,this.lastIncrementTime=0,this.value=0}increment(){const A=this.nowFn();return A-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=A,this.value=0),this.value++,this.value}}e.IntervalCounter=ie;class ${constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((A,O)=>{this.completeCallback=A,this.errorCallback=O})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(A){return new Promise(O=>{this.completeCallback(A),this.resolved=!0,O()})}error(A){return new Promise(O=>{this.errorCallback(A),this.rejected=!0,O()})}cancel(){new Promise(A=>{this.errorCallback(new n.CancellationError),this.rejected=!0,A()})}}e.DeferredPromise=$;var q;(function(T){async function A(_){let j;const ne=await Promise.all(_.map(ae=>ae.then(ce=>ce,ce=>{j||(j=ce)})));if(typeof j!="undefined")throw j;return ne}T.settled=A;function O(_){return new Promise(async(j,ne)=>{try{await _(j,ne)}catch(ae){ne(ae)}})}T.withAsyncBody=O})(q=e.Promises||(e.Promises={}));var Y;(function(T){T[T.Initial=0]="Initial",T[T.DoneOK=1]="DoneOK",T[T.DoneError=2]="DoneError"})(Y||(Y={}));class B{constructor(A){this._state=0,this._results=[],this._error=null,this._onStateChanged=new L.Emitter,queueMicrotask(async()=>{const O={emitOne:_=>this.emitOne(_),emitMany:_=>this.emitMany(_),reject:_=>this.reject(_)};try{await Promise.resolve(A(O)),this.resolve()}catch(_){this.reject(_)}finally{O.emitOne=void 0,O.emitMany=void 0,O.reject=void 0}})}static fromArray(A){return new B(O=>{O.emitMany(A)})}static fromPromise(A){return new B(async O=>{O.emitMany(await A)})}static fromPromises(A){return new B(async O=>{await Promise.all(A.map(async _=>O.emitOne(await _)))})}static merge(A){return new B(async O=>{await Promise.all(A.map(async _=>{for await(const j of _)O.emitOne(j)}))})}[Symbol.asyncIterator](){let A=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(A<this._results.length)return{done:!1,value:this._results[A++]};if(this._state===1)return{done:!0,value:void 0};await L.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(A,O){return new B(async _=>{for await(const j of A)_.emitOne(O(j))})}map(A){return B.map(this,A)}static filter(A,O){return new B(async _=>{for await(const j of A)O(j)&&_.emitOne(j)})}filter(A){return B.filter(this,A)}static coalesce(A){return B.filter(A,O=>!!O)}coalesce(){return B.coalesce(this)}static async toPromise(A){const O=[];for await(const _ of A)O.push(_);return O}toPromise(){return B.toPromise(this)}emitOne(A){this._state===0&&(this._results.push(A),this._onStateChanged.fire())}emitMany(A){this._state===0&&(this._results=this._results.concat(A),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(A){this._state===0&&(this._state=2,this._error=A,this._onStateChanged.fire())}}e.AsyncIterableObject=B,B.EMPTY=B.fromArray([]);class F extends B{constructor(A,O){super(O);this._source=A}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=F;function N(T){const A=new m.CancellationTokenSource,O=T(A.token);return new F(A,async _=>{const j=A.token.onCancellationRequested(()=>{j.dispose(),A.dispose(),_.reject(new n.CancellationError)});try{for await(const ne of O){if(A.token.isCancellationRequested)return;_.emitOne(ne)}j.dispose(),A.dispose()}catch(ne){j.dispose(),A.dispose(),_.reject(ne)}})}e.createCancelableAsyncIterable=N}),define(J[116],Z([0,1,9,28,35,7,3,27]),function(V,e,m,n,L,D,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function g(){return Object.create(null)}e.getEmptyExpression=g,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const b="[/\\\\]",C="[^/\\\\]",I=/\//g;function E($){switch($){case 0:return"";case 1:return`${C}*?`;default:return`(?:${b}|${C}+${b}|${b}${C}+)*?`}}function w($,q){if(!$)return[];const Y=[];let B=!1,F=!1,N="";for(const T of $){switch(T){case q:if(!B&&!F){Y.push(N),N="";continue}break;case"{":B=!0;break;case"}":B=!1;break;case"[":F=!0;break;case"]":F=!1;break}N+=T}return N&&Y.push(N),Y}e.splitGlobAware=w;function t($){if(!$)return"";let q="";const Y=w($,e.GLOB_SPLIT);if(Y.every(B=>B===e.GLOBSTAR))q=".*";else{let B=!1;Y.forEach((F,N)=>{if(F===e.GLOBSTAR){B||(q+=E(2),B=!0);return}let T=!1,A="",O=!1,_="";for(const j of F){if(j!=="}"&&T){A+=j;continue}if(O&&(j!=="]"||!_)){let ne;j==="-"?ne=j:(j==="^"||j==="!")&&!_?ne="^":j===e.GLOB_SPLIT?ne="":ne=(0,S.escapeRegExpCharacters)(j),_+=ne;continue}switch(j){case"{":T=!0;continue;case"[":O=!0;continue;case"}":{q+=`(?:${w(A,",").map(ce=>t(ce)).join("|")})`,T=!1,A="";break}case"]":q+="["+_+"]",O=!1,_="";break;case"?":q+=C;continue;case"*":q+=E(1);continue;default:q+=(0,S.escapeRegExpCharacters)(j)}}N<Y.length-1&&(Y[N+1]!==e.GLOBSTAR||N+2<Y.length)&&(q+=b),B=!1})}return q}const d=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,P=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,h=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,c=new L.LRUCache(1e4),a=function(){return!1},f=function(){return null};function r($,q){if(!$)return f;let Y;typeof $!="string"?Y=$.pattern:Y=$,Y=Y.trim();const B=`${Y}_${!!q.trimForExclusions}`;let F=c.get(B);if(F)return i(F,$);let N;if(d.test(Y)){const T=Y.substr(4);F=function(A,O){return typeof A=="string"&&A.endsWith(T)?Y:null}}else(N=p.exec(s(Y,q)))?F=o(N[1],Y):(q.trimForExclusions?P:v).test(Y)?F=u(Y,q):(N=h.exec(s(Y,q)))?F=y(N[1].substr(1),Y,!0):(N=l.exec(s(Y,q)))?F=y(N[1],Y,!1):F=k(Y);return c.set(B,F),i(F,$)}function i($,q){return typeof q=="string"?$:function(Y,B){return(0,n.isEqualOrParent)(Y,q.base,!M.isLinux)?$(Y.substr(q.base.length+1),B):null}}function s($,q){return q.trimForExclusions&&$.endsWith("/**")?$.substr(0,$.length-2):$}function o($,q){const Y=`/${$}`,B=`\\${$}`,F=function(T,A){return typeof T!="string"?null:A?A===$?q:null:T===$||T.endsWith(Y)||T.endsWith(B)?q:null},N=[$];return F.basenames=N,F.patterns=[q],F.allBasenames=N,F}function u($,q){const Y=ie($.slice(1,-1).split(",").map(A=>r(A,q)).filter(A=>A!==f),$),B=Y.length;if(!B)return f;if(B===1)return Y[0];const F=function(A,O){for(let _=0,j=Y.length;_<j;_++)if(Y[_](A,O))return $;return null},N=Y.find(A=>!!A.allBasenames);N&&(F.allBasenames=N.allBasenames);const T=Y.reduce((A,O)=>O.allPaths?A.concat(O.allPaths):A,[]);return T.length&&(F.allPaths=T),F}function y($,q,Y){const B=D.sep===D.posix.sep,F=B?$:$.replace(I,D.sep),N=D.sep+F,T=D.posix.sep+$,A=Y?function(O,_){return typeof O=="string"&&(O===F||O.endsWith(N)||!B&&(O===$||O.endsWith(T)))?q:null}:function(O,_){return typeof O=="string"&&(O===F||!B&&O===$)?q:null};return A.allPaths=[(Y?"*/":"./")+$],A}function k($){try{const q=new RegExp(`^${t($)}$`);return function(Y){return q.lastIndex=0,typeof Y=="string"&&q.test(Y)?$:null}}catch{return f}}function R($,q,Y){return!$||typeof q!="string"?!1:W($)(q,void 0,Y)}e.match=R;function W($,q={}){if(!$)return a;if(typeof $=="string"||ee($)){const Y=r($,q);if(Y===f)return a;const B=function(F,N){return!!Y(F,N)};return Y.allBasenames&&(B.allBasenames=Y.allBasenames),Y.allPaths&&(B.allPaths=Y.allPaths),B}return X($,q)}e.parse=W;function U($){if(!$)return;let q;return Y=>(q||(q=($()||Promise.resolve([])).then(B=>B?x(B):{})),q.then(B=>!!B[Y]))}e.hasSiblingPromiseFn=U;function K($){if(!$)return;let q;return Y=>{if(!q){const B=$();q=B?x(B):{}}return!!q[Y]}}e.hasSiblingFn=K;function x($){const q={};for(const Y of $)q[Y]=!0;return q}function ee($){const q=$;return q?typeof q.base=="string"&&typeof q.pattern=="string":!1}e.isRelativePattern=ee;function Q($){return $.allBasenames||[]}e.getBasenameTerms=Q;function H($){return $.allPaths||[]}e.getPathTerms=H;function X($,q){const Y=ie(Object.getOwnPropertyNames($).map(A=>z(A,$[A],q)).filter(A=>A!==f)),B=Y.length;if(!B)return f;if(!Y.some(A=>!!A.requiresSiblings)){if(B===1)return Y[0];const A=function(j,ne){for(let ae=0,ce=Y.length;ae<ce;ae++){const re=Y[ae](j,ne);if(re)return re}return null},O=Y.find(j=>!!j.allBasenames);O&&(A.allBasenames=O.allBasenames);const _=Y.reduce((j,ne)=>ne.allPaths?j.concat(ne.allPaths):j,[]);return _.length&&(A.allPaths=_),A}const F=function(A,O,_){let j;for(let ne=0,ae=Y.length;ne<ae;ne++){const ce=Y[ne];ce.requiresSiblings&&_&&(O||(O=(0,D.basename)(A)),j||(j=O.substr(0,O.length-(0,D.extname)(A).length)));const re=ce(A,O,j,_);if(re)return re}return null},N=Y.find(A=>!!A.allBasenames);N&&(F.allBasenames=N.allBasenames);const T=Y.reduce((A,O)=>O.allPaths?A.concat(O.allPaths):A,[]);return T.length&&(F.allPaths=T),F}function z($,q,Y){if(q===!1)return f;const B=r($,Y);if(B===f)return f;if(typeof q=="boolean")return B;if(q){const F=q.when;if(typeof F=="string"){const N=(T,A,O,_)=>{if(!_||!B(T,A))return null;const j=F.replace("$(basename)",O),ne=_(j);return(0,m.isThenable)(ne)?ne.then(ae=>ae?$:null):ne?$:null};return N.requiresSiblings=!0,N}}return B}function ie($,q){const Y=$.filter(A=>!!A.basenames);if(Y.length<2)return $;const B=Y.reduce((A,O)=>{const _=O.basenames;return _?A.concat(_):A},[]);let F;if(q){F=[];for(let A=0,O=B.length;A<O;A++)F.push(q)}else F=Y.reduce((A,O)=>{const _=O.patterns;return _?A.concat(_):A},[]);const N=function(A,O){if(typeof A!="string")return null;if(!O){let j;for(j=A.length;j>0;j--){const ne=A.charCodeAt(j-1);if(ne===47||ne===92)break}O=A.substr(j)}const _=B.indexOf(O);return _!==-1?F[_]:null};N.basenames=B,N.patterns=F,N.allBasenames=B;const T=$.filter(A=>!A.basenames);return T.push(N),T}}),define(J[33],Z([0,1,28,10,7,3,17,27,8]),function(V,e,m,n,L,D,M,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function b(i,s,o){if(typeof i=="string"&&(i=g.URI.file(i)),o){const y=o.getWorkspaceFolder(i);if(y){const k=o.getWorkspace().folders.length>1;let R;if((0,M.isEqual)(y.uri,i)?R="":R=(0,M.relativePath)(y.uri,i),k){const W=y.name?y.name:(0,M.basename)(y.uri);R=R?W+" \u2022 "+R:W}return R}}if(i.scheme!==n.Schemas.file&&i.scheme!==n.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,m.hasDriveLetter)(i.fsPath))return(0,L.normalize)(I(i.fsPath));let u=(0,L.normalize)(i.fsPath);return!D.isWindows&&s?.userHome&&(u=w(u,s.userHome.fsPath)),u}e.getPathLabel=b;function C(i){if(!i)return;typeof i=="string"&&(i=g.URI.file(i));const s=(0,M.basename)(i)||(i.scheme===n.Schemas.file?i.fsPath:i.path);return D.isWindows&&(0,m.isRootOrDriveLetter)(s)?I(s):s}e.getBaseLabel=C;function I(i,s){return(0,m.hasDriveLetter)(i,s)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=I;let E=Object.create(null);function w(i,s){if(D.isWindows||!i||!s)return i;let o=E.original===s?E.normalized:void 0;return o||(o=`${(0,S.rtrim)(s,L.posix.sep)}${L.posix.sep}`,E={original:s,normalized:o}),(D.isLinux?i.startsWith(o):(0,S.startsWithIgnoreCase)(i,o))&&(i=`~/${i.substr(o.length)}`),i}e.tildify=w;function t(i,s){return i.replace(/^~($|\/|\\)/,`${s}$1`)}e.untildify=t;const d="\u2026",p="\\\\",v="~";function P(i,s=L.sep){const o=new Array(i.length);let u=!1;for(let y=0;y<i.length;y++){let k=i[y];if(k===""){o[y]=`.${s}`;continue}if(!k){o[y]=k;continue}u=!0;let R="";k.indexOf(p)===0?(R=k.substr(0,k.indexOf(p)+p.length),k=k.substr(k.indexOf(p)+p.length)):k.indexOf(s)===0?(R=k.substr(0,k.indexOf(s)+s.length),k=k.substr(k.indexOf(s)+s.length)):k.indexOf(v)===0&&(R=k.substr(0,k.indexOf(v)+v.length),k=k.substr(k.indexOf(v)+v.length));const W=k.split(s);for(let U=1;u&&U<=W.length;U++)for(let K=W.length-U;u&&K>=0;K--){u=!1;let x=W.slice(K,K+U).join(s);for(let ee=0;!u&&ee<i.length;ee++)if(ee!==y&&i[ee]&&i[ee].indexOf(x)>-1){const Q=K+U===W.length,H=K>0&&i[ee].indexOf(s)>-1?s+x:x,X=i[ee].endsWith(H);u=!Q||X}if(!u){let ee="";(W[0].endsWith(":")||R!=="")&&(K===1&&(K=0,U++,x=W[0]+s+x),K>0&&(ee=W[0]+s),ee=R+ee),K>0&&(ee=ee+d+s),ee=ee+x,K+U<W.length&&(ee=ee+s+d),o[y]=ee}}u&&(o[y]=k)}return o}e.shorten=P;var h;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function l(i,s=Object.create(null)){const o=[];let u=!1,y="";for(const k of i)if(k==="$"||u&&k==="{")y&&o.push({value:y,type:h.TEXT}),y="",u=!0;else if(k==="}"&&u){const R=s[y];if(typeof R=="string")R.length&&o.push({value:R,type:h.VARIABLE});else if(R){const W=o[o.length-1];(!W||W.type!==h.SEPARATOR)&&o.push({value:R.label,type:h.SEPARATOR})}y="",u=!1}else y+=k;return y&&!u&&o.push({value:y,type:h.TEXT}),o.filter((k,R)=>{if(k.type===h.SEPARATOR){const W=o[R-1],U=o[R+1];return[W,U].every(K=>K&&(K.type===h.VARIABLE||K.type===h.TEXT)&&K.value.length>0)}return!0}).map(k=>k.value).join("")}e.template=l;function c(i,s){return D.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,D.isMacintosh?"&":"&&"):i.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=c;function a(i,s){return D.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,""):D.isWindows?i.replace(/&&|&/g,o=>o==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=a;function f(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=f;function r(i){const s=i.indexOf("/")!==-1?L.posix:L.win32,o=s.basename(i),u=s.dirname(i);return o.length?{name:o,parentPath:u}:{name:u,parentPath:""}}e.splitName=r}),define(J[117],Z([0,1,8]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(C){return C.toJSON()}class L{constructor(I){this._uriTransformer=I}transformIncoming(I){const E=this._uriTransformer.transformIncoming(I);return E===I?I:n(m.URI.from(E))}transformOutgoing(I){const E=this._uriTransformer.transformOutgoing(I);return E===I?I:n(m.URI.from(E))}transformOutgoingURI(I){const E=this._uriTransformer.transformOutgoing(I);return E===I?I:m.URI.from(E)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=L,e.DefaultURITransformer=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function D(C,I,E){if(!C||E>200)return null;if(typeof C=="object"){if(C instanceof m.URI)return I.transformOutgoing(C);for(let w in C)if(Object.hasOwnProperty.call(C,w)){const t=D(C[w],I,E+1);t!==null&&(C[w]=t)}}return null}function M(C,I){const E=D(C,I,0);return E===null?C:E}e.transformOutgoingURIs=M;function S(C,I,E,w){if(!C||w>200)return null;if(typeof C=="object"){if(C.$mid===1)return E?m.URI.revive(I.transformIncoming(C)):I.transformIncoming(C);for(let t in C)if(Object.hasOwnProperty.call(C,t)){const d=S(C[t],I,E,w+1);d!==null&&(C[t]=d)}}return null}function g(C,I){const E=S(C,I,!1,0);return E===null?C:E}e.transformIncomingURIs=g;function b(C,I){const E=S(C,I,!0,0);return E===null?C:E}e.transformAndReviveIncomingURIs=b}),define(J[31],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const m=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function n(g){return m.test(g)}e.isUUID=n;const L=new Uint8Array(16),D=[];for(let g=0;g<256;g++)D.push(g.toString(16).padStart(2,"0"));let M;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?M=crypto.getRandomValues.bind(crypto):M=function(g){for(let b=0;b<g.length;b++)g[b]=Math.floor(Math.random()*256);return g};function S(){M(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let g=0,b="";return b+=D[L[g++]],b+=D[L[g++]],b+=D[L[g++]],b+=D[L[g++]],b+="-",b+=D[L[g++]],b+=D[L[g++]],b+="-",b+=D[L[g++]],b+=D[L[g++]],b+="-",b+=D[L[g++]],b+=D[L[g++]],b+="-",b+=D[L[g++]],b+=D[L[g++]],b+=D[L[g++]],b+=D[L[g++]],b+=D[L[g++]],b+=D[L[g++]],b}e.generateUuid=S}),define(J[118],Z([0,1,15,4,2,3,14,27]),function(V,e,m,n,L,D,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=e.SimpleWorkerServer=e.SimpleWorkerClient=e.logOnceWebWorkerWarning=void 0;const g="$initialize";let b=!1;function C(r){!D.isWeb||(b||(b=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(r.message))}e.logOnceWebWorkerWarning=C;var I;(function(r){r[r.Request=0]="Request",r[r.Reply=1]="Reply",r[r.SubscribeEvent=2]="SubscribeEvent",r[r.Event=3]="Event",r[r.UnsubscribeEvent=4]="UnsubscribeEvent"})(I||(I={}));class E{constructor(i,s,o,u){this.vsWorker=i,this.req=s,this.method=o,this.args=u,this.type=0}}class w{constructor(i,s,o,u){this.vsWorker=i,this.seq=s,this.res=o,this.err=u,this.type=1}}class t{constructor(i,s,o,u){this.vsWorker=i,this.req=s,this.eventName=o,this.arg=u,this.type=2}}class d{constructor(i,s,o){this.vsWorker=i,this.req=s,this.event=o,this.type=3}}class p{constructor(i,s){this.vsWorker=i,this.req=s,this.type=4}}class v{constructor(i){this._workerId=-1,this._handler=i,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(i){this._workerId=i}sendMessage(i,s){const o=String(++this._lastSentReq);return new Promise((u,y)=>{this._pendingReplies[o]={resolve:u,reject:y},this._send(new E(this._workerId,o,i,s))})}listen(i,s){let o=null;const u=new n.Emitter({onFirstListenerAdd:()=>{o=String(++this._lastSentReq),this._pendingEmitters.set(o,u),this._send(new t(this._workerId,o,i,s))},onLastListenerRemove:()=>{this._pendingEmitters.delete(o),this._send(new p(this._workerId,o)),o=null}});return u.event}handleMessage(i){!i||!i.vsWorker||this._workerId!==-1&&i.vsWorker!==this._workerId||this._handleMessage(i)}_handleMessage(i){switch(i.type){case 1:return this._handleReplyMessage(i);case 0:return this._handleRequestMessage(i);case 2:return this._handleSubscribeEventMessage(i);case 3:return this._handleEventMessage(i);case 4:return this._handleUnsubscribeEventMessage(i)}}_handleReplyMessage(i){if(!this._pendingReplies[i.seq]){console.warn("Got reply to unknown seq");return}let s=this._pendingReplies[i.seq];if(delete this._pendingReplies[i.seq],i.err){let o=i.err;i.err.$isError&&(o=new Error,o.name=i.err.name,o.message=i.err.message,o.stack=i.err.stack),s.reject(o);return}s.resolve(i.res)}_handleRequestMessage(i){let s=i.req;this._handler.handleMessage(i.method,i.args).then(u=>{this._send(new w(this._workerId,s,u,void 0))},u=>{u.detail instanceof Error&&(u.detail=(0,m.transformErrorForSerialization)(u.detail)),this._send(new w(this._workerId,s,void 0,(0,m.transformErrorForSerialization)(u)))})}_handleSubscribeEventMessage(i){const s=i.req,o=this._handler.handleEvent(i.eventName,i.arg)(u=>{this._send(new d(this._workerId,s,u))});this._pendingEvents.set(s,o)}_handleEventMessage(i){if(!this._pendingEmitters.has(i.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(i.req).fire(i.event)}_handleUnsubscribeEventMessage(i){if(!this._pendingEvents.has(i.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(i.req).dispose(),this._pendingEvents.delete(i.req)}_send(i){let s=[];if(i.type===0)for(let o=0;o<i.args.length;o++)i.args[o]instanceof ArrayBuffer&&s.push(i.args[o]);else i.type===1&&i.res instanceof ArrayBuffer&&s.push(i.res);this._handler.sendMessage(i,s)}}class P extends L.Disposable{constructor(i,s,o){super();let u=null;this._worker=this._register(i.create("vs/base/common/worker/simpleWorker",U=>{this._protocol.handleMessage(U)},U=>{u&&u(U)})),this._protocol=new v({sendMessage:(U,K)=>{this._worker.postMessage(U,K)},handleMessage:(U,K)=>{if(typeof o[U]!="function")return Promise.reject(new Error("Missing method "+U+" on main thread host."));try{return Promise.resolve(o[U].apply(o,K))}catch(x){return Promise.reject(x)}},handleEvent:(U,K)=>{if(l(U)){const x=o[U].call(o,K);if(typeof x!="function")throw new Error(`Missing dynamic event ${U} on main thread host.`);return x}if(h(U)){const x=o[U];if(typeof x!="function")throw new Error(`Missing event ${U} on main thread host.`);return x}throw new Error(`Malformed event name ${U}`)}}),this._protocol.setWorkerId(this._worker.getId());let y=null;typeof D.globals.require!="undefined"&&typeof D.globals.require.getConfig=="function"?y=D.globals.require.getConfig():typeof D.globals.requirejs!="undefined"&&(y=D.globals.requirejs.s.contexts._.config);const k=M.getAllMethodNames(o);this._onModuleLoaded=this._protocol.sendMessage(g,[this._worker.getId(),JSON.parse(JSON.stringify(y)),s,k]);const R=(U,K)=>this._request(U,K),W=(U,K)=>this._protocol.listen(U,K);this._lazyProxy=new Promise((U,K)=>{u=K,this._onModuleLoaded.then(x=>{U(c(x,R,W))},x=>{K(x),this._onError("Worker failed to load "+s,x)})})}getProxyObject(){return this._lazyProxy}_request(i,s){return new Promise((o,u)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(i,s).then(o,u)},u)})}_onError(i,s){console.error(i),console.info(s)}}e.SimpleWorkerClient=P;function h(r){return r[0]==="o"&&r[1]==="n"&&S.isUpperAsciiLetter(r.charCodeAt(2))}function l(r){return/^onDynamic/.test(r)&&S.isUpperAsciiLetter(r.charCodeAt(9))}function c(r,i,s){const o=k=>function(){const R=Array.prototype.slice.call(arguments,0);return i(k,R)},u=k=>function(R){return s(k,R)};let y={};for(const k of r){if(l(k)){y[k]=u(k);continue}if(h(k)){y[k]=s(k,void 0);continue}y[k]=o(k)}return y}class a{constructor(i,s){this._requestHandlerFactory=s,this._requestHandler=null,this._protocol=new v({sendMessage:(o,u)=>{i(o,u)},handleMessage:(o,u)=>this._handleMessage(o,u),handleEvent:(o,u)=>this._handleEvent(o,u)})}onmessage(i){this._protocol.handleMessage(i)}_handleMessage(i,s){if(i===g)return this.initialize(s[0],s[1],s[2],s[3]);if(!this._requestHandler||typeof this._requestHandler[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this._requestHandler[i].apply(this._requestHandler,s))}catch(o){return Promise.reject(o)}}_handleEvent(i,s){if(!this._requestHandler)throw new Error("Missing requestHandler");if(l(i)){const o=this._requestHandler[i].call(this._requestHandler,s);if(typeof o!="function")throw new Error(`Missing dynamic event ${i} on request handler.`);return o}if(h(i)){const o=this._requestHandler[i];if(typeof o!="function")throw new Error(`Missing event ${i} on request handler.`);return o}throw new Error(`Malformed event name ${i}`)}initialize(i,s,o,u){this._protocol.setWorkerId(i);const R=c(u,(W,U)=>this._protocol.sendMessage(W,U),(W,U)=>this._protocol.listen(W,U));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(R),Promise.resolve(M.getAllMethodNames(this._requestHandler))):(s&&(typeof s.baseUrl!="undefined"&&delete s.baseUrl,typeof s.paths!="undefined"&&typeof s.paths.vs!="undefined"&&delete s.paths.vs,typeof s.trustedTypesPolicy!==void 0&&delete s.trustedTypesPolicy,s.catchError=!0,D.globals.require.config(s)),new Promise((W,U)=>{(D.globals.require||V)([o],x=>{if(this._requestHandler=x.create(R),!this._requestHandler){U(new Error("No RequestHandler!"));return}W(M.getAllMethodNames(this._requestHandler))},U)}))}}e.SimpleWorkerServer=a;function f(r){return new a(r,null)}e.create=f}),define(J[119],Z([0,1,60,29,43]),function(V,e,m,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function D(M,S){if(await new Promise((C,I)=>{const E=n.createReadStream(M),w=m.createHash("sha1");E.pipe(w);const t=(0,L.once)((d,p)=>{E.removeAllListeners(),w.removeAllListeners(),d?I(d):C(p)});E.once("error",t),E.once("end",t),w.once("error",t),w.once("data",d=>t(void 0,d.toString("hex")))})!==S)throw new Error("Hash mismatch")}e.checksum=D}),define(J[120],Z([0,1,249]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class n{constructor(D="utf8"){this.stringDecoder=new m.StringDecoder(D),this.remaining=null}write(D){const M=[],S=this.remaining?this.remaining+this.stringDecoder.write(D):this.stringDecoder.write(D);if(S.length<1)return M;let g=0,b,C=g;for(;C<S.length;)if(b=S.charCodeAt(C),b===13||b===10){if(M.push(S.substring(g,C)),C++,C<S.length){const I=b;b=S.charCodeAt(C),(I===13&&b===10||I===10&&b===13)&&C++}g=C}else C++;return this.remaining=g<S.length?S.substr(g):null,M}end(){return this.remaining}}e.LineDecoder=n}),define(J[121],Z([0,1,26]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const n=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function L(M){const S=M.replace(/\-/g,":").toLowerCase();return!n.has(S)}function D(){const M=(0,m.networkInterfaces)();for(let S in M){const g=M[S];if(g){for(const{mac:b}of g)if(L(b))return b}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=D}),define(J[71],Z([0,1,26,15,35,31,121]),function(V,e,m,n,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(C){return this._virtualMachineOUIs||(this._virtualMachineOUIs=L.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(C)}value(){if(this._value===void 0){let C=0,I=0;const E=(0,m.networkInterfaces)();for(let w in E){const t=E[w];if(t)for(const{mac:d,internal:p}of t)p||(I+=1,this._isVirtualMachineMacAddress(d.toUpperCase())&&(C+=1))}this._value=I>0?C/I:0}return this._value}};let S;async function g(){return S||(S=(async()=>await b()||D.generateUuid())()),S}e.getMachineId=g;async function b(){try{const C=await new Promise((E,w)=>{V(["crypto"],E,w)}),I=(0,M.getMac)();return C.createHash("sha256").update(I,"utf8").digest("hex")}catch(C){n.onUnexpectedError(C);return}}}),define(J[24],Z([0,1,29,26,122,9,28,70,7,3,17,8]),function(V,e,m,n,L,D,M,S,g,b,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var E;(function(Q){Q[Q.UNLINK=0]="UNLINK",Q[Q.MOVE=1]="MOVE"})(E=e.RimRafMode||(e.RimRafMode={}));async function w(Q,H=E.UNLINK){if((0,M.isRootOrDriveLetter)(Q))throw new Error("rimraf - will refuse to recursively delete root");return H===E.UNLINK?d(Q):t(Q)}async function t(Q){try{const H=(0,M.randomPath)((0,n.tmpdir)());try{await m.promises.rename(Q,H)}catch{return d(Q)}d(H).catch(X=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function d(Q){return e.Promises.rmdir(Q,{recursive:!0,maxRetries:3})}function p(Q){if((0,M.isRootOrDriveLetter)(Q))throw new Error("rimraf - will refuse to recursively delete root");m.rmdirSync(Q,{recursive:!0})}e.rimrafSync=p;async function v(Q,H){return l(await(H?P(Q):(0,L.promisify)(m.readdir)(Q)))}async function P(Q){try{return await(0,L.promisify)(m.readdir)(Q,{withFileTypes:!0})}catch(z){console.warn("[node.js fs] readdir with filetypes failed with error: ",z)}const H=[],X=await v(Q);for(const z of X){let ie=!1,$=!1,q=!1;try{const Y=await e.Promises.lstat((0,g.join)(Q,z));ie=Y.isFile(),$=Y.isDirectory(),q=Y.isSymbolicLink()}catch(Y){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Y)}H.push({name:z,isFile:()=>ie,isDirectory:()=>$,isSymbolicLink:()=>q})}return H}function h(Q){return l(m.readdirSync(Q))}e.readdirSync=h;function l(Q){return Q.map(H=>typeof H=="string"?b.isMacintosh?(0,S.normalizeNFC)(H):H:(H.name=b.isMacintosh?(0,S.normalizeNFC)(H.name):H.name,H))}async function c(Q){const H=await v(Q),X=[];for(const z of H)await f.existsDirectory((0,g.join)(Q,z))&&X.push(z);return X}function a(Q,H=1e3){return new Promise(X=>{let z=!1;const ie=setInterval(()=>{z||(z=!0,m.access(Q,$=>{z=!1,$&&(clearInterval(ie),X(void 0))}))},H)})}e.whenDeleted=a;var f;(function(Q){async function H(ie){let $;try{if($=await e.Promises.lstat(ie),!$.isSymbolicLink())return{stat:$}}catch{}try{return{stat:await e.Promises.stat(ie),symbolicLink:$?.isSymbolicLink()?{dangling:!1}:void 0}}catch(q){if(q.code==="ENOENT"&&$)return{stat:$,symbolicLink:{dangling:!0}};if(b.isWindows&&q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(ie)),symbolicLink:{dangling:!1}}}catch(Y){if(Y.code==="ENOENT"&&$)return{stat:$,symbolicLink:{dangling:!0}};throw Y}throw q}}Q.stat=H;async function X(ie){try{const{stat:$,symbolicLink:q}=await Q.stat(ie);return $.isFile()&&q?.dangling!==!0}catch{}return!1}Q.existsFile=X;async function z(ie){try{const{stat:$,symbolicLink:q}=await Q.stat(ie);return $.isDirectory()&&q?.dangling!==!0}catch{}return!1}Q.existsDirectory=z})(f=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new D.ResourceQueue;function i(Q,H,X){return r.queueFor(I.URI.file(Q),C.extUriBiasedIgnorePathCase).queue(()=>{const z=y(X);return new Promise((ie,$)=>o(Q,H,z,q=>q?$(q):ie()))})}let s=!0;function o(Q,H,X,z){if(!s)return m.writeFile(Q,H,{mode:X.mode,flag:X.flag},z);m.open(Q,X.flag,X.mode,(ie,$)=>{if(ie)return z(ie);m.writeFile($,H,q=>{if(q)return m.close($,()=>z(q));m.fdatasync($,Y=>(Y&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Y),s=!1),m.close($,B=>z(B))))})})}function u(Q,H,X){const z=y(X);if(!s)return m.writeFileSync(Q,H,{mode:z.mode,flag:z.flag});const ie=m.openSync(Q,z.flag,z.mode);try{m.writeFileSync(ie,H);try{m.fdatasyncSync(ie)}catch($){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",$),s=!1}}finally{m.closeSync(ie)}}e.writeFileSync=u;function y(Q){return Q?{mode:typeof Q.mode=="number"?Q.mode:438,flag:typeof Q.flag=="string"?Q.flag:"w"}:{mode:438,flag:"w"}}async function k(Q,H){if(Q!==H)try{await e.Promises.rename(Q,H)}catch(X){if(Q.toLowerCase()!==H.toLowerCase()&&X.code==="EXDEV"||Q.endsWith("."))await R(Q,H,{preserveSymlinks:!1}),await w(Q,E.MOVE);else throw X}}async function R(Q,H,X){return U(Q,H,{root:{source:Q,target:H},options:X,handledSourcePaths:new Set})}const W=511;async function U(Q,H,X){if(X.handledSourcePaths.has(Q))return;X.handledSourcePaths.add(Q);const{stat:z,symbolicLink:ie}=await f.stat(Q);if(ie){if(X.options.preserveSymlinks)try{return await ee(Q,H,X)}catch($){console.warn("[node.js fs] copy of symlink failed: ",$)}if(ie.dangling)return}return z.isDirectory()?K(Q,H,z.mode&W,X):x(Q,H,z.mode&W)}async function K(Q,H,X,z){await e.Promises.mkdir(H,{recursive:!0,mode:X});const ie=await v(Q);for(const $ of ie)await U((0,g.join)(Q,$),(0,g.join)(H,$),z)}async function x(Q,H,X){await e.Promises.copyFile(Q,H),await e.Promises.chmod(H,X)}async function ee(Q,H,X){let z=await e.Promises.readlink(Q);(0,M.isEqualOrParent)(z,X.root.source,!b.isLinux)&&(z=(0,g.join)(X.root.target,z.substr(X.root.source.length+1))),await e.Promises.symlink(z,H)}e.Promises=new class{get access(){return(0,L.promisify)(m.access)}get stat(){return(0,L.promisify)(m.stat)}get lstat(){return(0,L.promisify)(m.lstat)}get utimes(){return(0,L.promisify)(m.utimes)}get read(){return(Q,H,X,z,ie)=>new Promise(($,q)=>{m.read(Q,H,X,z,ie,(Y,B,F)=>Y?q(Y):$({bytesRead:B,buffer:F}))})}get readFile(){return(0,L.promisify)(m.readFile)}get write(){return(Q,H,X,z,ie)=>new Promise(($,q)=>{m.write(Q,H,X,z,ie,(Y,B,F)=>Y?q(Y):$({bytesWritten:B,buffer:F}))})}get appendFile(){return(0,L.promisify)(m.appendFile)}get fdatasync(){return(0,L.promisify)(m.fdatasync)}get truncate(){return(0,L.promisify)(m.truncate)}get rename(){return(0,L.promisify)(m.rename)}get copyFile(){return(0,L.promisify)(m.copyFile)}get open(){return(0,L.promisify)(m.open)}get close(){return(0,L.promisify)(m.close)}get symlink(){return(0,L.promisify)(m.symlink)}get readlink(){return(0,L.promisify)(m.readlink)}get chmod(){return(0,L.promisify)(m.chmod)}get mkdir(){return(0,L.promisify)(m.mkdir)}get unlink(){return(0,L.promisify)(m.unlink)}get rmdir(){return(0,L.promisify)(m.rmdir)}get realpath(){return(0,L.promisify)(m.realpath)}async exists(Q){try{return await e.Promises.access(Q),!0}catch{return!1}}get readdir(){return v}get readDirsInDir(){return c}get writeFile(){return i}get rm(){return w}get move(){return k}get copy(){return R}}}),define(J[86],Z([0,1,29,7,3,27,24]),function(V,e,m,n,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function S(E){if(L.isLinux)return E;const w=(0,n.dirname)(E);if(E===w)return E;const t=((0,n.basename)(E)||E).toLowerCase();try{const p=(0,M.readdirSync)(w).filter(v=>v.toLowerCase()===t);if(p.length===1){const v=S(w);if(v)return(0,n.join)(v,p[0])}else if(p.length>1){const v=p.indexOf(t);if(v>=0){const P=S(w);if(P)return(0,n.join)(P,p[v])}}}catch{}return null}e.realcaseSync=S;async function g(E){if(L.isLinux)return E;const w=(0,n.dirname)(E);if(E===w)return E;const t=((0,n.basename)(E)||E).toLowerCase();try{const p=(await M.Promises.readdir(w)).filter(v=>v.toLowerCase()===t);if(p.length===1){const v=await g(w);if(v)return(0,n.join)(v,p[0])}else if(p.length>1){const v=p.indexOf(t);if(v>=0){const P=await g(w);if(P)return(0,n.join)(P,p[v])}}}catch{}return null}e.realcase=g;async function b(E){try{return await M.Promises.realpath(E)}catch{const t=I(E);return await M.Promises.access(t,m.constants.R_OK),t}}e.realpath=b;function C(E){try{return m.realpathSync(E)}catch{const t=I(E);return m.accessSync(t,m.constants.R_OK),t}}e.realpathSync=C;function I(E){return(0,D.rtrim)((0,n.normalize)(E),n.sep)}}),define(J[123],Z([0,1,61]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function n(S,g,b,C=1){let I=!1;return new Promise(E=>{const w=setTimeout(()=>{if(!I)return I=!0,E(0)},b);L(S,g,C,t=>{if(!I)return I=!0,clearTimeout(w),E(t)})})}e.findFreePort=n;function L(S,g,b,C){if(g===0)return C(0);const I=new m.Socket;I.once("connect",()=>(M(I),L(S+b,g-1,b,C))),I.once("data",()=>{}),I.once("error",E=>(M(I),E.code!=="ECONNREFUSED"?L(S+b,g-1,b,C):C(S))),I.connect(S,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function D(S,g,b){let C=!1,I,E=1;const w=m.createServer({pauseOnConnect:!0});function t(d,p){C||(C=!0,w.removeAllListeners(),w.close(),I&&clearTimeout(I),p(d))}return new Promise(d=>{I=setTimeout(()=>{t(0,d)},b),w.on("listening",()=>{t(S,d)}),w.on("error",p=>{p&&(p.code==="EADDRINUSE"||p.code==="EACCES")&&E<g?(S++,E++,w.listen(S,"127.0.0.1")):t(0,d)}),w.on("close",()=>{t(0,d)}),w.listen(S,"127.0.0.1")})}e.findFreePortFaster=D;function M(S){try{S.removeAllListeners("connect"),S.removeAllListeners("error"),S.end(),S.destroy(),S.unref()}catch(g){console.error(g)}}}),define(J[124],Z([0,1,26,7,24]),function(V,e,m,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const D=/^\d+$/,M=/^Microsoft.PowerShell_.*/,S=/^Microsoft.PowerShellPreview_.*/;var g;(function(l){l[l.x64=0]="x64",l[l.x86=1]="x86",l[l.ARM=2]="ARM"})(g||(g={}));let b;switch(process.arch){case"ia32":case"x32":b=1;break;case"arm":case"arm64":b=2;break;default:b=0;break}let C;process.env.PROCESSOR_ARCHITEW6432?C=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?C=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?C=1:C=0;class I{constructor(c,a,f){this.exePath=c,this.displayName=a,this.knownToExist=f}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await L.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function E({useAlternateBitness:l=!1}={}){return l?b===0?process.env["ProgramFiles(x86)"]||null:C===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function w({useAlternateBitness:l=!1,findPreview:c=!1}={}){const a=E({useAlternateBitness:l});if(!a)return null;const f=n.join(a,"PowerShell");if(!await L.SymlinkSupport.existsDirectory(f))return null;let r=-1,i=null;for(const u of await L.Promises.readdir(f)){let y=-1;if(c){const R=u.indexOf("-");if(R<0)continue;const W=u.substring(0,R);if(!D.test(W)||u.substring(R+1)!=="preview")continue;y=parseInt(W,10)}else{if(!D.test(u))continue;y=parseInt(u,10)}if(y<=r)continue;const k=n.join(f,u,"pwsh.exe");!await L.SymlinkSupport.existsFile(k)||(i=k,r=y)}if(!i)return null;const s=a.includes("x86")?" (x86)":"",o=c?" Preview":"";return new I(i,`PowerShell${o}${s}`,!0)}async function t({findPreview:l}={}){if(!process.env.LOCALAPPDATA)return null;const c=n.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await L.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:a,pwshMsixName:f}=l?{pwshMsixDirRegex:S,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:M,pwshMsixName:"PowerShell (Store)"};for(const r of await L.Promises.readdir(c))if(a.test(r)){const i=n.join(c,r,"pwsh.exe");return new I(i,f)}return null}function d(){const l=n.join(m.homedir(),".dotnet","tools","pwsh.exe");return new I(l,".NET Core PowerShell Global Tool")}function p(){const l=n.join(process.env.windir,b===1&&C!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(l,"Windows PowerShell",!0)}async function*v(){let l=await w();l&&(yield l),l=await w({useAlternateBitness:!0}),l&&(yield l),l=await t(),l&&(yield l),l=d(),l&&(yield l),l=await w({findPreview:!0}),l&&(yield l),l=await t({findPreview:!0}),l&&(yield l),l=await w({useAlternateBitness:!0,findPreview:!0}),l&&(yield l),l=p(),l&&(yield l)}async function*P(){for await(const l of v())await l.exists()&&(yield l)}e.enumeratePowerShellInstallations=P;async function h(){for await(const l of P())return l;return null}e.getFirstAvailablePowerShellInstallation=h}),define(J[87],Z([0,1,45,10]),function(V,e,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function L(M){return new Promise((S,g)=>{let b;const C=new Map;function I(w,t,d,p,v){const P=C.get(t);if(w===M||P){const h={name:E(d),cmd:d,pid:w,ppid:t,load:p,mem:v};C.set(w,h),w===M&&(b=h),P&&(P.children||(P.children=[]),P.children.push(h),P.children.length>1&&(P.children=P.children.sort((l,c)=>l.pid-c.pid)))}}function E(w){const t=/--vscode-window-kind=shared-process/,d=/--vscode-window-kind=issue-reporter/,p=/--vscode-window-kind=process-explorer/,v=/--utility-sub-type=network/,P=/--crashes-directory/,h=/\\pipe\\winpty-control/,l=/conhost\.exe/,c=/--type=([a-zA-Z-]+)/;if(P.exec(w))return"electron-crash-reporter";if(h.exec(w))return"winpty-process";if(l.exec(w))return"console-window-host (Windows internal process)";let a=c.exec(w);if(a&&a.length===2)return a[1]==="renderer"?t.exec(w)?"shared-process":d.exec(w)?"issue-reporter":p.exec(w)?"process-explorer":"window":a[1]==="utility"&&v.exec(w)?"utility-network-service":a[1];const f=/[a-zA-Z-]+\.js/g;let r="";do a=f.exec(w),a&&(r+=a+" ");while(a);return r&&w.indexOf("node ")<0&&w.indexOf("node.exe")<0?`electron_node ${r}`:w}if(process.platform==="win32"){const w=t=>t.indexOf("\\\\?\\")===0||t.indexOf("\\??\\")===0?t.substr(4):t.indexOf('"\\\\?\\')===0||t.indexOf('"\\??\\')===0?'"'+t.substr(5):t;new Promise((t,d)=>{V(["windows-process-tree"],t,d)}).then(t=>{t.getProcessList(M,d=>{t.getProcessCpuUsage(d,p=>{const v=new Map;p.forEach(P=>{const h=w(P.commandLine||"");v.set(P.pid,{name:E(h),cmd:h,pid:P.pid,ppid:P.ppid,load:P.cpu||0,mem:P.memory||0})}),b=v.get(M),b?(v.forEach(P=>{const h=v.get(P.ppid);h&&(h.children||(h.children=[]),h.children.push(P))}),v.forEach(P=>{P.children&&(P.children=P.children.sort((h,l)=>h.pid-l.pid))}),S(b)):g(new Error(`Root process ${M} not found`))})},t.ProcessDataFlag.CommandLine|t.ProcessDataFlag.Memory)})}else{let w=function(){let t=[b];const d=[];for(;t.length;){const v=t.shift();v&&(d.push(v.pid),v.children&&(t=t.concat(v.children)))}let p=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",V).fsPath);p+=" "+d.join(" "),(0,m.exec)(p,{},(v,P,h)=>{if(v||h)g(v||new Error(h.toString()));else{const l=P.toString().split(`
`);for(let c=0;c<d.length;c++){const a=C.get(d[c]);a.load=parseFloat(l[c])}if(!b){g(new Error(`Root process ${M} not found`));return}S(b)}})};(0,m.exec)("which ps",{},(t,d,p)=>{if(t||p)if(process.platform!=="linux")g(t||new Error(p.toString()));else{const v=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/ps.sh",V).fsPath);(0,m.exec)(v,{},(P,h,l)=>{P||l?g(P||new Error(l.toString())):(D(h,I),w())})}else{const v=d.toString().trim(),P="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,m.exec)(`${v} ${P}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(h,l,c)=>{h||c&&!c.includes("screen size is bogus")?g(h||new Error(c.toString())):(D(l,I),process.platform==="linux"?w():b?S(b):g(new Error(`Root process ${M} not found`)))})}})}})}e.listProcesses=L;function D(M,S){const g=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,b=M.toString().split(`
`);for(const C of b){const I=g.exec(C.trim());I&&I.length===6&&S(parseInt(I[1]),parseInt(I[2]),I[5],parseFloat(I[3]),parseFloat(I[4]))}}}),define(J[125],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(J[126],Z([0,1,12,14,125]),function(V,e,m,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function D(){m.ipcMain.on(L.CONTEXT_MENU_CHANNEL,(S,g,b,C,I)=>{const E=M(S,C,b);E.popup({window:(0,n.withNullAsUndefined)(m.BrowserWindow.fromWebContents(S.sender)),x:I?I.x:void 0,y:I?I.y:void 0,positioningItem:I?I.positioningItem:void 0,callback:()=>{E&&S.sender.send(L.CONTEXT_MENU_CLOSE_CHANNEL,g)}})})}e.registerContextMenuListener=D;function M(S,g,b){const C=new m.Menu;return b.forEach(I=>{let E;I.type==="separator"?E=new m.MenuItem({type:I.type}):Array.isArray(I.submenu)?E=new m.MenuItem({submenu:M(S,g,I.submenu),label:I.label}):E=new m.MenuItem({label:I.label,type:I.type,accelerator:I.accelerator,checked:I.checked,enabled:I.enabled,visible:I.visible,click:(w,t,d)=>S.sender.send(g,I.id,d)}),C.append(E)}),C}});var ue=this&&this.__decorate||function(V,e,m,n){var L=arguments.length,D=L<3?e:n===null?n=Object.getOwnPropertyDescriptor(e,m):n,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(V,e,m,n);else for(var S=V.length-1;S>=0;S--)(M=V[S])&&(D=(L<3?M(D):L>3?M(e,m,D):M(e,m))||D);return L>3&&D&&Object.defineProperty(e,m,D),D};define(J[37],Z([0,1,30,9,16,23,46,15,4,2,115,27,14]),function(V,e,m,n,L,D,M,S,g,b,C,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var w;(function($){$[$.Promise=100]="Promise",$[$.PromiseCancel=101]="PromiseCancel",$[$.EventListen=102]="EventListen",$[$.EventDispose=103]="EventDispose"})(w=e.RequestType||(e.RequestType={}));function t($){switch($){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var d;(function($){$[$.Initialize=200]="Initialize",$[$.PromiseSuccess=201]="PromiseSuccess",$[$.PromiseError=202]="PromiseError",$[$.PromiseErrorObj=203]="PromiseErrorObj",$[$.EventFire=204]="EventFire"})(d=e.ResponseType||(e.ResponseType={}));function p($){switch($){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var v;(function($){$[$.Uninitialized=0]="Uninitialized",$[$.Idle=1]="Idle"})(v||(v={}));class P{constructor(q){this.buffer=q,this.pos=0}read(q){const Y=this.buffer.slice(this.pos,this.pos+q);return this.pos+=Y.byteLength,Y}}class h{constructor(){this.buffers=[]}get buffer(){return L.VSBuffer.concat(this.buffers)}write(q){this.buffers.push(q)}}var l;(function($){$[$.Undefined=0]="Undefined",$[$.String=1]="String",$[$.Buffer=2]="Buffer",$[$.VSBuffer=3]="VSBuffer",$[$.Array=4]="Array",$[$.Object=5]="Object"})(l||(l={}));function c($){const q=L.VSBuffer.alloc(4);return q.writeUInt32BE($,0),q}function a($){return $.read(4).readUInt32BE(0)}function f($){const q=L.VSBuffer.alloc(1);return q.writeUInt8($,0),q}const r={Undefined:f(l.Undefined),String:f(l.String),Buffer:f(l.Buffer),VSBuffer:f(l.VSBuffer),Array:f(l.Array),Object:f(l.Object)},i=typeof Buffer!="undefined";function s($,q){if(typeof q=="undefined")$.write(r.Undefined);else if(typeof q=="string"){const Y=L.VSBuffer.fromString(q);$.write(r.String),$.write(c(Y.byteLength)),$.write(Y)}else if(i&&Buffer.isBuffer(q)){const Y=L.VSBuffer.wrap(q);$.write(r.Buffer),$.write(c(Y.byteLength)),$.write(Y)}else if(q instanceof L.VSBuffer)$.write(r.VSBuffer),$.write(c(q.byteLength)),$.write(q);else if(Array.isArray(q)){$.write(r.Array),$.write(c(q.length));for(const Y of q)s($,Y)}else{const Y=L.VSBuffer.fromString(JSON.stringify(q));$.write(r.Object),$.write(c(Y.byteLength)),$.write(Y)}}function o($){switch($.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return $.read(a($)).toString();case l.Buffer:return $.read(a($)).buffer;case l.VSBuffer:return $.read(a($));case l.Array:{const Y=a($),B=[];for(let F=0;F<Y;F++)B.push(o($));return B}case l.Object:return JSON.parse($.read(a($)).toString())}}class u{constructor(q,Y,B=null,F=1e3){this.protocol=q,this.ctx=Y,this.logger=B,this.timeoutDelay=F,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(N=>this.onRawMessage(N)),this.sendResponse({type:200})}registerChannel(q,Y){this.channels.set(q,Y),setTimeout(()=>this.flushPendingRequests(q),0)}sendResponse(q){switch(q.type){case 200:{const Y=this.send([q.type]);this.logger?.logOutgoing(Y,0,1,p(q.type));return}case 201:case 202:case 204:case 203:{const Y=this.send([q.type,q.id],q.data);this.logger?.logOutgoing(Y,q.id,1,p(q.type),q.data);return}}}send(q,Y=void 0){const B=new h;return s(B,q),s(B,Y),this.sendBuffer(B.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onRawMessage(q){const Y=new P(q),B=o(Y),F=o(Y),N=B[0];switch(N){case 100:return this.logger?.logIncoming(q.byteLength,B[1],1,`${t(N)}: ${B[2]}.${B[3]}`,F),this.onPromise({type:N,id:B[1],channelName:B[2],name:B[3],arg:F});case 102:return this.logger?.logIncoming(q.byteLength,B[1],1,`${t(N)}: ${B[2]}.${B[3]}`,F),this.onEventListen({type:N,id:B[1],channelName:B[2],name:B[3],arg:F});case 101:return this.logger?.logIncoming(q.byteLength,B[1],1,`${t(N)}`),this.disposeActiveRequest({type:N,id:B[1]});case 103:return this.logger?.logIncoming(q.byteLength,B[1],1,`${t(N)}`),this.disposeActiveRequest({type:N,id:B[1]})}}onPromise(q){const Y=this.channels.get(q.channelName);if(!Y){this.collectPendingRequest(q);return}const B=new D.CancellationTokenSource;let F;try{F=Y.call(this.ctx,q.name,q.arg,B.token)}catch(A){F=Promise.reject(A)}const N=q.id;F.then(A=>{this.sendResponse({id:N,data:A,type:201}),this.activeRequests.delete(q.id)},A=>{A instanceof Error?this.sendResponse({id:N,data:{message:A.message,name:A.name,stack:A.stack?A.stack.split?A.stack.split(`
`):A.stack:void 0},type:202}):this.sendResponse({id:N,data:A,type:203}),this.activeRequests.delete(q.id)});const T=(0,b.toDisposable)(()=>B.cancel());this.activeRequests.set(q.id,T)}onEventListen(q){const Y=this.channels.get(q.channelName);if(!Y){this.collectPendingRequest(q);return}const B=q.id,N=Y.listen(this.ctx,q.name,q.arg)(T=>this.sendResponse({id:B,data:T,type:204}));this.activeRequests.set(q.id,N)}disposeActiveRequest(q){const Y=this.activeRequests.get(q.id);Y&&(Y.dispose(),this.activeRequests.delete(q.id))}collectPendingRequest(q){let Y=this.pendingRequests.get(q.channelName);Y||(Y=[],this.pendingRequests.set(q.channelName,Y));const B=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===100&&this.sendResponse({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Y.push({request:q,timeoutTimer:B})}flushPendingRequests(q){const Y=this.pendingRequests.get(q);if(Y){for(const B of Y)switch(clearTimeout(B.timeoutTimer),B.request.type){case 100:this.onPromise(B.request);break;case 102:this.onEventListen(B.request);break}this.pendingRequests.delete(q)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,b.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=u;var y;(function($){$[$.LocalSide=0]="LocalSide",$[$.OtherSide=1]="OtherSide"})(y=e.RequestInitiator||(e.RequestInitiator={}));class k{constructor(q,Y=null){this.protocol=q,this.isDisposed=!1,this.state=v.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new g.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(B=>this.onBuffer(B)),this.logger=Y}getChannel(q){const Y=this;return{call(B,F,N){return Y.isDisposed?Promise.reject(S.canceled()):Y.requestPromise(q,B,F,N)},listen(B,F){return Y.isDisposed?g.Event.None:Y.requestEvent(q,B,F)}}}requestPromise(q,Y,B,F=D.CancellationToken.None){const N=this.lastRequestId++,A={id:N,type:100,channelName:q,name:Y,arg:B};if(F.isCancellationRequested)return Promise.reject(S.canceled());let O;return new Promise((j,ne)=>{if(F.isCancellationRequested)return ne(S.canceled());const ae=()=>{const he=we=>{switch(we.type){case 201:this.handlers.delete(N),j(we.data);break;case 202:{this.handlers.delete(N);const Ee=new Error(we.data.message);Ee.stack=we.data.stack,Ee.name=we.data.name,ne(Ee);break}case 203:this.handlers.delete(N),ne(we.data);break}};this.handlers.set(N,he),this.sendRequest(A)};let ce=null;this.state===v.Idle?ae():(ce=(0,n.createCancelablePromise)(he=>this.whenInitialized()),ce.then(()=>{ce=null,ae()}));const re=()=>{ce?(ce.cancel(),ce=null):this.sendRequest({id:N,type:101}),ne(S.canceled())},le=F.onCancellationRequested(re);O=(0,b.combinedDisposable)((0,b.toDisposable)(re),le),this.activeRequests.add(O)}).finally(()=>{this.activeRequests.delete(O)})}requestEvent(q,Y,B){const F=this.lastRequestId++,T={id:F,type:102,channelName:q,name:Y,arg:B};let A=null;const O=new g.Emitter({onFirstListenerAdd:()=>{A=(0,n.createCancelablePromise)(j=>this.whenInitialized()),A.then(()=>{A=null,this.activeRequests.add(O),this.sendRequest(T)})},onLastListenerRemove:()=>{A?(A.cancel(),A=null):(this.activeRequests.delete(O),this.sendRequest({id:F,type:103}))}}),_=j=>O.fire(j.data);return this.handlers.set(F,_),O.event}sendRequest(q){switch(q.type){case 100:case 102:{const Y=this.send([q.type,q.id,q.channelName,q.name],q.arg);this.logger&&this.logger.logOutgoing(Y,q.id,0,`${t(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case 101:case 103:{const Y=this.send([q.type,q.id]);this.logger&&this.logger.logOutgoing(Y,q.id,0,t(q.type));return}}}send(q,Y=void 0){const B=new h;return s(B,q),s(B,Y),this.sendBuffer(B.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onBuffer(q){const Y=new P(q),B=o(Y),F=o(Y),N=B[0];switch(N){case 200:return this.logger&&this.logger.logIncoming(q.byteLength,0,0,p(N)),this.onResponse({type:B[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(q.byteLength,B[1],0,p(N),F),this.onResponse({type:B[0],id:B[1],data:F})}}onResponse(q){if(q.type===200){this.state=v.Idle,this._onDidInitialize.fire();return}const Y=this.handlers.get(q.id);Y&&Y(q)}get onDidInitializePromise(){return g.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===v.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,b.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}ue([M.memoize],k.prototype,"onDidInitializePromise",null),e.ChannelClient=k;class R{constructor(q){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new g.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new g.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,q(({protocol:Y,onDidClientDisconnect:B})=>{g.Event.once(Y.onMessage)(N=>{const T=new P(N),A=o(T),O=new u(Y,A),_=new k(Y);this.channels.forEach((ne,ae)=>O.registerChannel(ae,ne));const j={channelServer:O,channelClient:_,ctx:A};this._connections.add(j),this._onDidAddConnection.fire(j),B(()=>{O.dispose(),_.dispose(),this._connections.delete(j),this._onDidRemoveConnection.fire(j)})})})}get connections(){const q=[];return this._connections.forEach(Y=>q.push(Y)),q}getChannel(q,Y){const B=this;return{call(F,N,T){let A;if((0,E.isFunction)(Y)){let _=(0,m.getRandomElement)(B.connections.filter(Y));A=_?Promise.resolve(_):g.Event.toPromise(g.Event.filter(B.onDidAddConnection,Y))}else A=Y.routeCall(B,F,N);const O=A.then(_=>_.channelClient.getChannel(q));return U(O).call(F,N,T)},listen(F,N){if((0,E.isFunction)(Y))return B.getMulticastEvent(q,Y,F,N);const T=Y.routeEvent(B,F,N).then(A=>A.channelClient.getChannel(q));return U(T).listen(F,N)}}}getMulticastEvent(q,Y,B,F){const N=this;let T=new b.DisposableStore;const A=new g.Emitter({onFirstListenerAdd:()=>{T=new b.DisposableStore;const O=new g.EventMultiplexer,_=new Map,j=ae=>{const re=ae.channelClient.getChannel(q).listen(B,F),le=O.add(re);_.set(ae,le)},ne=ae=>{const ce=_.get(ae);!ce||(ce.dispose(),_.delete(ae))};N.connections.filter(Y).forEach(j),g.Event.filter(N.onDidAddConnection,Y)(j,void 0,T),N.onDidRemoveConnection(ne,void 0,T),O.event(A.fire,A,T),T.add(O)},onLastListenerRemove:()=>{T.dispose()}});return A.event}registerChannel(q,Y){this.channels.set(q,Y),this._connections.forEach(B=>{B.channelServer.registerChannel(q,Y)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=R;class W{constructor(q,Y,B=null){const F=new h;s(F,Y),q.send(F.buffer),this.channelClient=new k(q,B),this.channelServer=new u(q,Y,B)}getChannel(q){return this.channelClient.getChannel(q)}registerChannel(q,Y){this.channelServer.registerChannel(q,Y)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=W;function U($){return{call(q,Y,B){return $.then(F=>F.call(q,Y,B))},listen(q,Y){const B=new g.Relay;return $.then(F=>B.input=F.listen(q,Y)),B.event}}}e.getDelayedChannel=U;function K($){let q=!1;return{call(Y,B,F){return q?$.call(Y,B,F):(0,n.timeout)(0).then(()=>q=!0).then(()=>$.call(Y,B,F))},listen(Y,B){if(q)return $.listen(Y,B);const F=new g.Relay;return(0,n.timeout)(0).then(()=>q=!0).then(()=>F.input=$.listen(Y,B)),F.event}}}e.getNextTickChannel=K;class x{constructor(q){this.fn=q}routeCall(q){return this.route(q)}routeEvent(q){return this.route(q)}async route(q){for(const Y of q.connections)if(await Promise.resolve(this.fn(Y.ctx)))return Promise.resolve(Y);return await g.Event.toPromise(q.onDidAddConnection),await this.route(q)}}e.StaticRouter=x;var ee;(function($){function q(N,T){const A=N,O=T&&T.disableMarshalling,_=new Map;for(const j in A)B(j)&&_.set(j,g.Event.buffer(A[j],!0));return new class{listen(j,ne,ae){const ce=_.get(ne);if(ce)return ce;if(F(ne)){const re=A[ne];if(typeof re=="function")return re.call(A,ae)}throw new Error(`Event not found: ${ne}`)}call(j,ne,ae){const ce=A[ne];if(typeof ce=="function"){if(!O&&Array.isArray(ae))for(let re=0;re<ae.length;re++)ae[re]=(0,C.revive)(ae[re]);return ce.apply(A,ae)}throw new Error(`Method not found: ${ne}`)}}}$.fromService=q;function Y(N,T){const A=T&&T.disableMarshalling;return new Proxy({},{get(O,_){if(typeof _=="string")return T?.properties?.has(_)?T.properties.get(_):F(_)?function(j){return N.listen(_,j)}:B(_)?N.listen(_):async function(...j){let ne;T&&!(0,E.isUndefinedOrNull)(T.context)?ne=[T.context,...j]:ne=j;const ae=await N.call(_,ne);return A?ae:(0,C.revive)(ae)};throw new Error(`Property not found: ${String(_)}`)}})}$.toService=Y;function B(N){return N[0]==="o"&&N[1]==="n"&&I.isUpperAsciiLetter(N.charCodeAt(2))}function F(N){return/^onDynamic/.test(N)&&I.isUpperAsciiLetter(N.charCodeAt(9))}})(ee=e.ProxyChannel||(e.ProxyChannel={}));const Q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function H($){if(Array.isArray($))return $;if($&&typeof $=="object"&&typeof $.toString=="function"){let q=$.toString();if(q!=="[object Object]")return q}return $}function X($){return Array.isArray($)?$.map(H):H($)}function z($,q,Y,B,F,N,T){T=X(T);const A=Q[F],O=A[B%A.length];let _=[`%c[${$}]%c[${String(q).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(B).padStart(5," ")} - ${N}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(N)?(_=_.concat(T),_.push(")")):_.push(T),console.log.apply(console,_)}e.logWithColors=z;class ie{constructor(q,Y){this._outgoingPrefix=q,this._incomingPrefix=Y,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(q,Y,B,F,N){this._totalOutgoing+=q,z(this._outgoingPrefix,this._totalOutgoing,q,Y,B,F,N)}logIncoming(q,Y,B,F,N){this._totalIncoming+=q,z(this._incomingPrefix,this._totalIncoming,q,Y,B,F,N)}}e.IPCLogger=ie}),define(J[127],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class m{constructor(L,D){this.sender=L,this.onMessage=D}send(L){try{this.sender.send("vscode:message",L.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=m}),define(J[128],Z([0,1,16,4,37]),function(V,e,m,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class D{constructor(g){this.port=g,this.onMessage=n.Event.fromDOMEventEmitter(this.port,"message",b=>m.VSBuffer.wrap(b.data)),g.start()}send(g){this.port.postMessage(g.buffer)}disconnect(){this.port.close()}}e.Protocol=D;class M extends L.IPCClient{constructor(g,b){const C=new D(g);super(C,b);this.protocol=C}dispose(){this.protocol.disconnect()}}e.Client=M}),define(J[88],Z([0,1,16,4,2,37]),function(V,e,m,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var M;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(M=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var S;(function(i){i.enableDiagnostics=!1,i.records=[];const s=new WeakMap;let o=0;function u(k,R){if(!s.has(k)){const W=String(++o);s.set(k,W)}return s.get(k)}function y(k,R,W,U){if(!i.enableDiagnostics)return;const K=u(k,R);if(U instanceof m.VSBuffer||U instanceof Uint8Array||U instanceof ArrayBuffer||ArrayBuffer.isView(U)){const x=m.VSBuffer.alloc(U.byteLength);x.set(U),i.records.push({timestamp:Date.now(),id:K,label:R,type:W,buff:x})}else i.records.push({timestamp:Date.now(),id:K,label:R,type:W,data:U})}i.traceSocketEvent=y})(S=e.SocketDiagnostics||(e.SocketDiagnostics={}));var g;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(g=e.SocketCloseEventType||(e.SocketCloseEventType={}));let b=null;function C(){return b||(b=m.VSBuffer.alloc(0)),b}class I{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,o){if(s===0)return C();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const R=this._chunks[0];return o&&(this._chunks.shift(),this._totalLength-=s),R}if(this._chunks[0].byteLength>s){const R=this._chunks[0].slice(0,s);return o&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),R}let u=m.VSBuffer.alloc(s),y=0,k=0;for(;s>0;){const R=this._chunks[k];if(R.byteLength>s){const W=R.slice(0,s);u.set(W,y),y+=s,o&&(this._chunks[k]=R.slice(s),this._totalLength-=s),s-=s}else u.set(R,y),y+=R.byteLength,o?(this._chunks.shift(),this._totalLength-=R.byteLength):k++,s-=R.byteLength}return u}}e.ChunkStream=I;var E;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume"})(E||(E={}));function w(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var t;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(t=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(s,o,u,y){this.type=s,this.id=o,this.ack=u,this.data=y,this.writtenTime=0}get size(){return this.data.byteLength}}class p extends L.Disposable{constructor(s){super();this._onMessage=this._register(new n.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const o=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=o.readUInt32BE(9),this._state.messageType=o.readUInt8(0),this._state.id=o.readUInt32BE(1),this._state.ack=o.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:w(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const u=this._state.messageType,y=this._state.id,k=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",o),this._onMessage.fire(new d(u,y,k,o)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class v{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=m.VSBuffer.alloc(13);o.writeUInt8(s.type,0),o.writeUInt32BE(s.id,1),o.writeUInt32BE(s.ack,5),o.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:w(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(o,s.data)}_bufferAdd(s,o){const u=this._totalLength===0;return this._data.push(s,o),this._totalLength+=s.byteLength+o.byteLength,u}_bufferTake(){const s=m.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,o){this._bufferAdd(s,o)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class P extends L.Disposable{constructor(s){super();this._onMessage=new n.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new n.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new v(this._socket)),this._socketReader=this._register(new p(this._socket)),this._register(this._socketReader.onMessage(o=>{o.type===1&&this._onMessage.fire(o.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new d(1,0,0,s))}}e.Protocol=P;class h extends D.IPCClient{constructor(s,o,u=null){super(s,o,u);this.protocol=s}static fromSocket(s,o){return new h(new P(s),o)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=h;class l{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new n.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=l;class c{constructor(s){this.data=s,this.next=null}}class a{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],o=0,u=this._first;for(;u;)s[o++]=u.data,u=u.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const o=new c(s);if(!this._first){this._first=o,this._last=o;return}this._last.next=o,this._last=o}}class f{constructor(){this.lastRuns=[];const s=Date.now();for(let o=0;o<f._HISTORY_LENGTH;o++)this.lastRuns[o]=s-1e3*o;setInterval(()=>{for(let o=f._HISTORY_LENGTH;o>=1;o--)this.lastRuns[o]=this.lastRuns[o-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return f._INSTANCE||(f._INSTANCE=new f),f._INSTANCE}load(){const s=Date.now(),o=(1+f._HISTORY_LENGTH)*1e3;let u=0;for(let y=0;y<f._HISTORY_LENGTH;y++)s-this.lastRuns[y]<=o&&u++;return 1-u/f._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}f._HISTORY_LENGTH=10,f._INSTANCE=null;class r{constructor(s,o=null,u=f.getInstance()){this._onControlMessage=new l,this.onControlMessage=this._onControlMessage.event,this._onMessage=new l,this.onMessage=this._onMessage.event,this._onDidDispose=new l,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new l,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new l,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=u,this._isReconnecting=!1,this._outgoingUnackMsg=new a,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=s,this._socketWriter=new v(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(y=>this._receiveMessage(y))),this._socketDisposables.push(this._socket.onClose(y=>this._onSocketClose.fire(y))),o&&this._socketReader.acceptChunk(o)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,L.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new d(5,0,0,C());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new d(7,0,0,C());this._socketWriter.write(s)}sendResume(){const s=new d(8,0,0,C());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,o){this._isReconnecting=!0,this._socketDisposables=(0,L.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=new v(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(u=>this._onSocketClose.fire(u))),this._socketReader.acceptChunk(o)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new d(3,0,this._incomingAckId,C());this._socketWriter.write(s);const o=this._outgoingUnackMsg.toArray();for(let u=0,y=o.length;u<y;u++)this._socketWriter.write(o[u]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const o=this._outgoingUnackMsg.peek();if(o&&o.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const o=Date.now();o-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=o,this._socketWriter.write(new d(6,0,0,C())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const o=this._outgoingUnackMsg.toArray();for(let u=0,y=o.length;u<y;u++)this._socketWriter.write(o[u]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const o=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const u=new d(1,o,this._incomingAckId,s);this._outgoingUnackMsg.push(u),this._isReconnecting||(this._socketWriter.write(u),this._recvAckCheck())}sendControl(s){const o=new d(2,0,0,s);this._socketWriter.write(o)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),o=Date.now()-s.writtenTime,u=Date.now()-this._socketReader.lastReadTime,y=Date.now()-this._lastSocketTimeoutTime;if(o>=2e4&&u>=2e4&&y>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const k=Math.max(2e4-o,2e4-u,2e4-y,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},k)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new d(3,0,this._incomingAckId,C());this._socketWriter.write(s)}}e.PersistentProtocol=r}),define(J[129],Z([0,1,12,16,4,2,37,127]),function(V,e,m,n,L,D,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function g(C,I){const E=L.Event.fromNodeEventEmitter(m.ipcMain,I,(t,d)=>({event:t,message:d})),w=L.Event.filter(E,({event:t})=>t.sender.id===C);return L.Event.map(w,({message:t})=>t&&n.VSBuffer.wrap(t))}class b extends M.IPCServer{constructor(){super(b.getOnDidClientConnect())}static getOnDidClientConnect(){const I=L.Event.fromNodeEventEmitter(m.ipcMain,"vscode:hello",({sender:E})=>E);return L.Event.map(I,E=>{const w=E.id,t=b.Clients.get(w);t&&t.dispose();const d=new L.Emitter;b.Clients.set(w,(0,D.toDisposable)(()=>d.fire()));const p=g(w,"vscode:message"),v=L.Event.any(L.Event.signal(g(w,"vscode:disconnect")),d.event);return{protocol:new S.Protocol(E,p),onDidClientDisconnect:v}})}}e.Server=b,b.Clients=new Map}),define(J[89],Z([0,1,12,4,31,128]),function(V,e,m,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class M extends D.Client{constructor(b,C){super({addEventListener:(I,E)=>b.addListener(I,E),removeEventListener:(I,E)=>b.removeListener(I,E),postMessage:I=>b.postMessage(I),start:()=>b.start(),close:()=>b.close()},C)}}e.Client=M;async function S(g){if(g.isDestroyed()||g.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const b=(0,L.generateUuid)();g.webContents.send("vscode:createMessageChannel",b);const C=n.Event.fromNodeEventEmitter(m.ipcMain,"vscode:createMessageChannelResult",(E,w)=>({nonce:w,port:E.ports[0]})),{port:I}=await n.Event.toPromise(n.Event.once(n.Event.filter(C,E=>E.nonce===b)));return I}e.connect=S}),define(J[90],Z([0,1,9,4,2,14]),function(V,e,m,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var M;(function(I){I[I.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(M=e.StorageHint||(e.StorageHint={}));function S(I){const E=I;return E?.changed instanceof Map||E?.deleted instanceof Set}e.isStorageItemsChangeEvent=S;var g;(function(I){I[I.None=0]="None",I[I.Initialized=1]="Initialized",I[I.Closed=2]="Closed"})(g||(g={}));class b extends L.Disposable{constructor(E,w=Object.create(null)){super();this.database=E,this.options=w,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=g.None,this.cache=new Map,this.flushDelayer=new m.ThrottledDelayer(b.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(E=>this.onDidChangeItemsExternal(E)))}onDidChangeItemsExternal(E){E.changed?.forEach((w,t)=>this.accept(t,w)),E.deleted?.forEach(w=>this.accept(w,void 0))}accept(E,w){if(this.state===g.Closed)return;let t=!1;(0,D.isUndefinedOrNull)(w)?t=this.cache.delete(E):this.cache.get(E)!==w&&(this.cache.set(E,w),t=!0),t&&this._onDidChangeStorage.fire(E)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===g.None&&(this.state=g.Initialized,this.options.hint!==M.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(E,w){const t=this.cache.get(E);return(0,D.isUndefinedOrNull)(t)?w:t}getBoolean(E,w){const t=this.get(E);return(0,D.isUndefinedOrNull)(t)?w:t==="true"}getNumber(E,w){const t=this.get(E);return(0,D.isUndefinedOrNull)(t)?w:parseInt(t,10)}async set(E,w){if(this.state===g.Closed)return;if((0,D.isUndefinedOrNull)(w))return this.delete(E);const t=String(w);if(this.cache.get(E)!==t)return this.cache.set(E,t),this.pendingInserts.set(E,t),this.pendingDeletes.delete(E),this._onDidChangeStorage.fire(E),this.doFlush()}async delete(E){if(!(this.state===g.Closed||!this.cache.delete(E)))return this.pendingDeletes.has(E)||this.pendingDeletes.add(E),this.pendingInserts.delete(E),this._onDidChangeStorage.fire(E),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=g.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const E={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(E).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(E){if(!!this.hasPending)return this.doFlush(E)}async doFlush(E){return this.flushDelayer.trigger(()=>this.flushPending(),E)}async whenFlushed(){if(!!this.hasPending)return new Promise(E=>this.whenFlushedCallbacks.push(E))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=b,b.DEFAULT_FLUSH_DELAY=100;class C{constructor(){this.onDidChangeItemsExternal=n.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(E){E.insert&&E.insert.forEach((w,t)=>this.items.set(t,w)),E.delete&&E.delete.forEach(w=>this.items.delete(w))}async close(){}}e.InMemoryStorageDatabase=C}),define(J[130],Z([0,1,9,4,35,7,24]),function(V,e,m,n,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class S{constructor(C,I=Object.create(null)){this.path=C,this.options=I,this.name=(0,D.basename)(this.path),this.logger=new g(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return n.Event.None}async getItems(){const C=await this.whenConnected,I=new Map;return(await this.all(C,"SELECT * FROM ItemTable")).forEach(w=>I.set(w.key,w.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${I.size} rows`),I}async updateItems(C){const I=await this.whenConnected;return this.doUpdateItems(I,C)}doUpdateItems(C,I){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${I.insert?(0,L.mapToString)(I.insert):"0"}), delete(${I.delete?(0,L.setToString)(I.delete):"0"})`),this.transaction(C,()=>{const E=I.insert,w=I.delete;if(E&&E.size>0){const t=[];t.push([]);let d=0;E.forEach((p,v)=>{let P=t[d];P.length>S.MAX_HOST_PARAMETERS&&(d++,P=[],t.push(P)),P.push(v,p)}),t.forEach(p=>{this.prepare(C,`INSERT INTO ItemTable VALUES ${new Array(p.length/2).fill("(?,?)").join(",")}`,v=>v.run(p),()=>{const v=[];let P=0;return E.forEach((h,l)=>{v.push(l),P+=h.length}),`Keys: ${v.join(", ")} Length: ${P}`})})}if(w&&w.size){const t=[];t.push([]);let d=0;w.forEach(p=>{let v=t[d];v.length>S.MAX_HOST_PARAMETERS&&(d++,v=[],t.push(v)),v.push(p)}),t.forEach(p=>{this.prepare(C,`DELETE FROM ItemTable WHERE key IN (${new Array(p.length).fill("?").join(",")})`,v=>v.run(p),()=>{const v=[];return w.forEach(P=>{v.push(P)}),`Keys: ${v.join(", ")}`})})}})}async close(C){this.logger.trace(`[storage ${this.name}] close()`);const I=await this.whenConnected;return this.doClose(I,C)}doClose(C,I){return new Promise((E,w)=>{C.db.close(t=>(t&&this.handleSQLiteError(C,`[storage ${this.name}] close(): ${t}`),this.path===S.IN_MEMORY_PATH?E():!C.isErroneous&&!C.isInMemory?this.backup().then(E,d=>(this.logger.error(`[storage ${this.name}] backup(): ${d}`),E())):typeof I=="function"?M.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(d=>{const p=()=>this.doClose(d,void 0);return this.doUpdateItems(d,{insert:I()}).then(()=>p(),v=>(p(),Promise.reject(v)))})).then(E,w):w(t||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const C=this.toBackupPath(this.path);return M.Promises.copy(this.path,C,{preserveSymlinks:!1})}toBackupPath(C){return`${C}.backup`}async checkIntegrity(C){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${C})`);const I=await this.whenConnected,E=await this.get(I,C?"PRAGMA integrity_check":"PRAGMA quick_check"),w=C?E.integrity_check:E.quick_check;return I.isErroneous?`${w} (last error: ${I.lastError})`:I.isInMemory?`${w} (in-memory!)`:w}async connect(C,I=!0){this.logger.trace(`[storage ${this.name}] open(${C}, retryOnBusy: ${I})`);try{return await this.doConnect(C)}catch(E){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${E}`),E.code==="SQLITE_BUSY"&&I)return await(0,m.timeout)(S.BUSY_OPEN_TIMEOUT),this.connect(C,!1);try{await M.Promises.unlink(C);try{await M.Promises.rename(this.toBackupPath(C),C)}catch{}return await this.doConnect(C)}catch(w){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${w}`),this.doConnect(S.IN_MEMORY_PATH)}}}handleSQLiteError(C,I){C.isErroneous=!0,C.lastError=I,this.logger.error(I)}doConnect(C){return new Promise((I,E)=>{new Promise((w,t)=>{V(["@vscode/sqlite3"],w,t)}).then(w=>{const t={db:new(this.logger.isTracing?w.verbose().Database:w.Database)(C,d=>d?t.db?t.db.close(()=>E(d)):E(d):this.exec(t,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>I(t),p=>t.db.close(()=>E(p)))),isInMemory:C===S.IN_MEMORY_PATH};t.db.on("error",d=>this.handleSQLiteError(t,`[storage ${this.name}] Error (event): ${d}`)),this.logger.isTracing&&t.db.on("trace",d=>this.logger.trace(`[storage ${this.name}] Trace (event): ${d}`))},E)})}exec(C,I){return new Promise((E,w)=>{C.db.exec(I,t=>t?(this.handleSQLiteError(C,`[storage ${this.name}] exec(): ${t}`),w(t)):E())})}get(C,I){return new Promise((E,w)=>{C.db.get(I,(t,d)=>t?(this.handleSQLiteError(C,`[storage ${this.name}] get(): ${t}`),w(t)):E(d))})}all(C,I){return new Promise((E,w)=>{C.db.all(I,(t,d)=>t?(this.handleSQLiteError(C,`[storage ${this.name}] all(): ${t}`),w(t)):E(d))})}transaction(C,I){return new Promise((E,w)=>{C.db.serialize(()=>{C.db.run("BEGIN TRANSACTION"),I(),C.db.run("END TRANSACTION",t=>t?(this.handleSQLiteError(C,`[storage ${this.name}] transaction(): ${t}`),w(t)):E())})})}prepare(C,I,E,w){const t=C.db.prepare(I),d=p=>{this.handleSQLiteError(C,`[storage ${this.name}] prepare(): ${p} (${I}). Details: ${w()}`)};t.on("error",d),E(t),t.finalize(p=>{p&&d(p),t.removeListener("error",d)})}}e.SQLiteStorageDatabase=S,S.IN_MEMORY_PATH=":memory:",S.BUSY_OPEN_TIMEOUT=2e3,S.MAX_HOST_PARAMETERS=256;class g{constructor(C){C&&typeof C.logTrace=="function"&&process.env[g.VSCODE_TRACE_STORAGE]&&(this.logTrace=C.logTrace),C&&typeof C.logError=="function"&&(this.logError=C.logError)}get isTracing(){return!!this.logTrace}trace(C){this.logTrace&&this.logTrace(C)}error(C){this.logError&&this.logError(C)}}g.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(J[131],Z([13,11]),function(V,e){return V.create("vs/base/common/date",e)}),define(J[132],Z([0,1,131]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const n=60,L=n*60,D=L*24,M=D*7,S=D*30,g=D*365;function b(I,E,w){typeof I!="number"&&(I=I.getTime());const t=Math.round((new Date().getTime()-I)/1e3);if(t<-30)return(0,m.localize)(0,null,b(new Date().getTime()+t*1e3,!1));if(t<30)return(0,m.localize)(1,null);let d;return t<n?(d=t,E?d===1?w?(0,m.localize)(2,null,d):(0,m.localize)(3,null,d):w?(0,m.localize)(4,null,d):(0,m.localize)(5,null,d):d===1?w?(0,m.localize)(6,null,d):(0,m.localize)(7,null,d):w?(0,m.localize)(8,null,d):(0,m.localize)(9,null,d)):t<L?(d=Math.floor(t/n),E?d===1?w?(0,m.localize)(10,null,d):(0,m.localize)(11,null,d):w?(0,m.localize)(12,null,d):(0,m.localize)(13,null,d):d===1?w?(0,m.localize)(14,null,d):(0,m.localize)(15,null,d):w?(0,m.localize)(16,null,d):(0,m.localize)(17,null,d)):t<D?(d=Math.floor(t/L),E?d===1?w?(0,m.localize)(18,null,d):(0,m.localize)(19,null,d):w?(0,m.localize)(20,null,d):(0,m.localize)(21,null,d):d===1?w?(0,m.localize)(22,null,d):(0,m.localize)(23,null,d):w?(0,m.localize)(24,null,d):(0,m.localize)(25,null,d)):t<M?(d=Math.floor(t/D),E?d===1?(0,m.localize)(26,null,d):(0,m.localize)(27,null,d):d===1?(0,m.localize)(28,null,d):(0,m.localize)(29,null,d)):t<S?(d=Math.floor(t/M),E?d===1?w?(0,m.localize)(30,null,d):(0,m.localize)(31,null,d):w?(0,m.localize)(32,null,d):(0,m.localize)(33,null,d):d===1?w?(0,m.localize)(34,null,d):(0,m.localize)(35,null,d):w?(0,m.localize)(36,null,d):(0,m.localize)(37,null,d)):t<g?(d=Math.floor(t/S),E?d===1?w?(0,m.localize)(38,null,d):(0,m.localize)(39,null,d):w?(0,m.localize)(40,null,d):(0,m.localize)(41,null,d):d===1?w?(0,m.localize)(42,null,d):(0,m.localize)(43,null,d):w?(0,m.localize)(44,null,d):(0,m.localize)(45,null,d)):(d=Math.floor(t/g),E?d===1?w?(0,m.localize)(46,null,d):(0,m.localize)(47,null,d):w?(0,m.localize)(48,null,d):(0,m.localize)(49,null,d):d===1?w?(0,m.localize)(50,null,d):(0,m.localize)(51,null,d):w?(0,m.localize)(52,null,d):(0,m.localize)(53,null,d))}e.fromNow=b;function C(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=C}),define(J[133],Z([13,11]),function(V,e){return V.create("vs/base/common/errorMessage",e)}),define(J[39],Z([0,1,30,14,133]),function(V,e,m,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function D(I,E){return E&&(I.stack||I.stacktrace)?L.localize(0,null,S(I),M(I.stack)||M(I.stacktrace)):S(I)}function M(I){return Array.isArray(I)?I.join(`
`):I}function S(I){return typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?L.localize(1,null,I.message):I.message||L.localize(2,null)}function g(I=null,E=!1){if(!I)return L.localize(3,null);if(Array.isArray(I)){const w=m.coalesce(I),t=g(w[0],E);return w.length>1?L.localize(4,null,t,w.length):t}if(n.isString(I))return I;if(I.detail){const w=I.detail;if(w.error)return D(w.error,E);if(w.exception)return D(w.exception,E)}return I.stack?D(I,E):I.message?I.message:L.localize(5,null)}e.toErrorMessage=g;function b(I){const E=I;return E instanceof Error&&Array.isArray(E.actions)}e.isErrorWithActions=b;function C(I,E=Object.create(null)){const w=new Error(I);return E.actions&&(w.actions=E.actions),w}e.createErrorWithActions=C}),define(J[134],Z([13,11]),function(V,e){return V.create("vs/base/common/keybindingLabels",e)}),define(J[135],Z([0,1,134]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class n{constructor(M,S,g=S){this.modifierLabels=[null],this.modifierLabels[2]=M,this.modifierLabels[1]=S,this.modifierLabels[3]=g}toLabel(M,S,g){if(S.length===0)return null;const b=[];for(let C=0,I=S.length;C<I;C++){const E=S[C],w=g(E);if(w===null)return null;b[C]=L(E,w,this.modifierLabels[M])}return b.join(" ")}}e.ModifierLabelProvider=n,e.UILabelProvider=new n({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:m.localize(0,null),shiftKey:m.localize(1,null),altKey:m.localize(2,null),metaKey:m.localize(3,null),separator:"+"},{ctrlKey:m.localize(4,null),shiftKey:m.localize(5,null),altKey:m.localize(6,null),metaKey:m.localize(7,null),separator:"+"}),e.AriaLabelProvider=new n({ctrlKey:m.localize(8,null),shiftKey:m.localize(9,null),altKey:m.localize(10,null),metaKey:m.localize(11,null),separator:"+"},{ctrlKey:m.localize(12,null),shiftKey:m.localize(13,null),altKey:m.localize(14,null),metaKey:m.localize(15,null),separator:"+"},{ctrlKey:m.localize(16,null),shiftKey:m.localize(17,null),altKey:m.localize(18,null),metaKey:m.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new n({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new n({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function L(D,M,S){if(M===null)return"";const g=[];return D.ctrlKey&&g.push(S.ctrlKey),D.shiftKey&&g.push(S.shiftKey),D.altKey&&g.push(S.altKey),D.metaKey&&g.push(S.metaKey),M!==""&&g.push(M),g.join(S.separator)}}),define(J[136],Z([13,11]),function(V,e){return V.create("vs/base/node/processes",e)}),define(J[72],Z([0,1,45,28,10,49,7,3,36,84,14,120,24,136]),function(V,e,m,n,L,D,M,S,g,b,C,I,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return b.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return b.TerminateResponseCode}});function t(a){switch(a){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function d(a,f){if(S.isWindows)try{const r={stdio:["pipe","pipe","ignore"]};f&&(r.cwd=f);const i=m.execFile("taskkill",["/T","/F","/PID",a.pid.toString()],r);return new Promise(s=>{i.once("error",o=>{s({success:!1,error:o})}),i.once("exit",(o,u)=>{s(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(r){return Promise.resolve({success:!1,error:r,code:r.status?t(r.status):1})}else if(S.isLinux||S.isMacintosh)try{const r=L.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",V).fsPath;return new Promise(i=>{m.execFile(r,[a.pid.toString()],{encoding:"utf8",shell:!0},(s,o,u)=>{i(s?{success:!1,error:s}:{success:!0})})})}catch(r){return Promise.resolve({success:!1,error:r})}else a.kill("SIGKILL");return Promise.resolve({success:!0})}function p(a){!a||(delete a.DEBUG,S.isMacintosh&&delete a.DYLD_LIBRARY_PATH,S.isLinux&&delete a.LD_PRELOAD)}e.removeDangerousEnvVariables=p;function v(a=g.env){return a.comspec||"cmd.exe"}e.getWindowsShell=v;class P{constructor(f,r,i,s){if(r!==void 0&&i!==void 0&&s!==void 0)this.cmd=f,this.args=r,this.shell=i,this.options=s;else{const o=f;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(g.env).forEach(u=>{o[u]=g.env[u]}),Object.keys(this.options.env).forEach(u=>{o[u]=this.options.env[u]}),this.options.env=o}}getSanitizedCommand(){let f=this.cmd.toLowerCase();const r=f.lastIndexOf(M.sep);return r!==-1&&(f=f.substring(r+1)),P.WellKnowCommands[f]?f:"other"}start(f){return S.isWindows&&(this.options&&this.options.cwd&&n.isUNC(this.options.cwd)||!this.options&&n.isUNC(g.cwd()))?Promise.reject(new Error(w.localize(0,null))):this.useExec().then(r=>{let i,s;const o=new Promise((u,y)=>{i=u,s=y});if(r){let u=this.cmd;this.args&&(u=u+" "+this.args.join(" ")),this.childProcess=m.exec(u,this.options,(y,k,R)=>{this.childProcess=null;const W=y;W&&W.killed?s({killed:this.terminateRequested,stdout:k.toString(),stderr:R.toString()}):this.handleExec(i,f,y,k,R)})}else{let u=null;const y=k=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(k,i,f,s);const R={terminated:this.terminateRequested};C.isNumber(k)&&(R.cmdCode=k),i(R)};if(this.shell&&S.isWindows){const k=D.deepClone(this.options);k.windowsVerbatimArguments=!0,k.detached=!1;let R=!1,W=!1;const U=[];let K=this.ensureQuotes(this.cmd);U.push(K.value),R=K.quoted,this.args&&this.args.forEach(ee=>{K=this.ensureQuotes(ee),U.push(K.value),W=W&&K.quoted});const x=["/s","/c"];R?W?x.push('"'+U.join(" ")+'"'):U.length>1?x.push('"'+U[0]+'" '+U.slice(1).join(" ")):x.push('"'+U[0]+'"'):x.push(U.join(" ")),u=m.spawn(v(),x,k)}else this.cmd&&(u=m.spawn(this.cmd,this.args,this.options));u&&(this.childProcess=u,this.childProcessPromise=Promise.resolve(u),this.pidResolve&&(this.pidResolve(C.isNumber(u.pid)?u.pid:-1),this.pidResolve=void 0),u.on("error",k=>{this.childProcess=null,s({terminated:this.terminateRequested,error:k})}),u.pid&&(this.childProcess.on("close",y),this.handleSpawn(u,i,f,s,!0)))}return o})}handleClose(f,r,i,s){}ensureQuotes(f){return P.regexp.test(f)?{value:'"'+f+'"',quoted:!0}:{value:f,quoted:f.length>0&&f[0]==='"'&&f[f.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(f=>f.pid,f=>-1):new Promise(f=>{this.pidResolve=f})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(f=>(this.terminateRequested=!0,d(f,this.options.cwd).then(r=>(r.success&&(this.childProcess=null),r))),f=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(f=>{if(!this.shell||!S.isWindows)return f(!1);const r=m.spawn(v(),["/s","/c"]);r.on("error",i=>f(!0)),r.on("exit",i=>f(!1))})}}e.AbstractProcess=P,P.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},P.regexp=/^[^"].* .*[^"]/;class h extends P{constructor(f,r,i,s){super(f,r,i,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(f,r,i,s,o){[s,o].forEach((u,y)=>{const k=new I.LineDecoder;k.write(u).forEach(U=>{r({line:U,source:y===0?0:1})});const W=k.end();W&&r({line:W,source:y===0?0:1})}),f({terminated:this.terminateRequested,error:i})}handleSpawn(f,r,i,s,o){const u=new I.LineDecoder,y=new I.LineDecoder;f.stdout.on("data",k=>{u.write(k).forEach(W=>i({line:W,source:0}))}),f.stderr.on("data",k=>{y.write(k).forEach(W=>i({line:W,source:1}))}),this.stdoutLineDecoder=u,this.stderrLineDecoder=y}handleClose(f,r,i,s){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&i({line:o,source:0});const u=this.stderrLineDecoder?this.stderrLineDecoder.end():null;u&&i({line:u,source:1})}}e.LineProcess=h;function l(a){let f=[],r=!1;const i=function(s){if(r){f.push(s);return}(!a.send(s,u=>{if(u&&console.error(u),r=!1,f.length>0){const y=f.slice(0);f=[],y.forEach(k=>i(k))}})||S.isWindows)&&(r=!0)};return{send:i}}e.createQueuedSender=l;var c;(function(a){async function f(r,i,s){if(M.isAbsolute(r))return r;if(i===void 0&&(i=g.cwd()),M.dirname(r)!=="."||(s===void 0&&C.isString(g.env.PATH)&&(s=g.env.PATH.split(M.delimiter)),s===void 0||s.length===0))return M.join(i,r);async function u(y){if(await E.Promises.exists(y)){let k;try{k=await E.Promises.stat(y)}catch(R){R.message.startsWith("EACCES")&&(k=await E.Promises.lstat(y))}return k?!k.isDirectory():!1}return!1}for(let y of s){let k;if(M.isAbsolute(y)?k=M.join(y,r):k=M.join(i,y,r),await u(k))return k;let R=k+".com";if(await u(R)||(R=k+".exe",await u(R)))return R}return M.join(i,r)}a.findExecutable=f})(c=e.win32||(e.win32={}))}),define(J[137],Z([0,1,26,3,124,72]),function(V,e,m,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function M(w,t){return w===1?n.isWindows?I():D.getWindowsShell(t):b(w,t)}e.getSystemShell=M;function S(w,t){return w===1?n.isWindows?E(t):D.getWindowsShell(t):b(w,t)}e.getSystemShellSync=S;let g=null;function b(w,t){if(n.isLinux&&w===2||n.isMacintosh&&w===3)return"/bin/bash";if(!g){let d;if(n.isWindows)d="/bin/bash";else{if(d=t.SHELL,!d)try{d=(0,m.userInfo)().shell}catch{}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}g=d}return g}let C=null;async function I(){return C||(C=(await(0,L.getFirstAvailablePowerShellInstallation)()).exePath),C}function E(w){if(C)return C;const t=n.isWindows&&parseFloat((0,m.release)())>=10,d=w.hasOwnProperty("PROCESSOR_ARCHITEW6432"),p=`${w.windir}\\${d?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return t?p:D.getWindowsShell(w)}}),define(J[138],Z([0,1,45,9,16,23,114,15,4,2,49,72,37]),function(V,e,m,n,L,D,M,S,g,b,C,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class w extends E.ChannelServer{constructor(p){super({send:v=>{try{process.send&&process.send(v.buffer.toString("base64"))}catch{}},onMessage:g.Event.fromNodeEventEmitter(process,"message",v=>L.VSBuffer.wrap(Buffer.from(v,"base64")))},p);process.once("disconnect",()=>this.dispose())}}e.Server=w;class t{constructor(p,v){this.modulePath=p,this.options=v,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new g.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const P=v&&v.timeout?v.timeout:6e4;this.disposeDelayer=new n.Delayer(P),this.child=null,this._client=null}getChannel(p){const v=this;return{call(P,h,l){return v.requestPromise(p,P,h,l)},listen(P,h){return v.requestEvent(p,P,h)}}}requestPromise(p,v,P,h=D.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(h.isCancellationRequested)return Promise.reject(S.canceled());this.disposeDelayer.cancel();const l=this.getCachedChannel(p),c=(0,n.createCancelablePromise)(r=>l.call(v,P,r)),a=h.onCancellationRequested(()=>c.cancel()),f=(0,b.toDisposable)(()=>c.cancel());return this.activeRequests.add(f),c.finally(()=>{a.dispose(),this.activeRequests.delete(f),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),c}requestEvent(p,v,P){if(!this.disposeDelayer)return g.Event.None;this.disposeDelayer.cancel();let h;const l=new g.Emitter({onFirstListenerAdd:()=>{h=this.getCachedChannel(p).listen(v,P)(l.fire,l),this.activeRequests.add(h)},onLastListenerRemove:()=>{this.activeRequests.delete(h),h.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return l.event}get client(){if(!this._client){const p=this.options&&this.options.args?this.options.args:[],v=Object.create(null);v.env={...(0,C.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(v.env={...v.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(v.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(v.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(v.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),v.execArgv===void 0&&(v.execArgv=process.execArgv.filter(i=>!/^--inspect(-brk)?=/.test(i))),(0,I.removeDangerousEnvVariables)(v.env),this.child=(0,m.fork)(this.modulePath,p,v);const P=new g.Emitter;g.Event.fromNodeEventEmitter(this.child,"message",i=>i)(i=>{if((0,M.isRemoteConsoleLog)(i)){(0,M.log)(i,`IPC Library: ${this.options.serverName}`);return}P.fire(L.VSBuffer.wrap(Buffer.from(i,"base64")))});const l=this.options.useQueue?(0,I.createQueuedSender)(this.child):this.child,c=i=>this.child&&this.child.connected&&l.send(i.buffer.toString("base64")),a=P.event,f={send:c,onMessage:a};this._client=new E.ChannelClient(f);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",i=>console.warn('IPC "'+this.options.serverName+'" errored with '+i)),this.child.on("exit",(i,s)=>{process.removeListener("exit",r),this.activeRequests.forEach(o=>(0,b.dispose)(o)),this.activeRequests.clear(),i!==0&&s!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+i+" and signal "+s),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:i,signal:s})})}return this._client}getCachedChannel(p){let v=this.channels.get(p);return v||(v=this.client.getChannel(p),this.channels.set(p,v)),v}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=t}),define(J[139],Z([13,11]),function(V,e){return V.create("vs/code/electron-main/app",e)}),define(J[140],Z([13,11]),function(V,e){return V.create("vs/platform/configuration/common/configurationRegistry",e)}),define(J[141],Z([13,11]),function(V,e){return V.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(J[142],Z([13,11]),function(V,e){return V.create("vs/platform/environment/node/argv",e)}),define(J[143],Z([13,11]),function(V,e){return V.create("vs/platform/environment/node/argvHelper",e)}),define(J[144],Z([13,11]),function(V,e){return V.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(J[145],Z([13,11]),function(V,e){return V.create("vs/platform/files/common/fileService",e)}),define(J[146],Z([13,11]),function(V,e){return V.create("vs/platform/files/common/files",e)}),define(J[147],Z([13,11]),function(V,e){return V.create("vs/platform/files/common/io",e)}),define(J[148],Z([13,11]),function(V,e){return V.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(J[149],Z([13,11]),function(V,e){return V.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(J[150],Z([13,11]),function(V,e){return V.create("vs/platform/issue/electron-main/issueMainService",e)}),define(J[151],Z([13,11]),function(V,e){return V.create("vs/platform/menubar/electron-main/menubar",e)}),define(J[152],Z([13,11]),function(V,e){return V.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(J[153],Z([13,11]),function(V,e){return V.create("vs/platform/request/common/request",e)}),define(J[154],Z([13,11]),function(V,e){return V.create("vs/platform/telemetry/common/telemetryService",e)}),define(J[155],Z([13,11]),function(V,e){return V.create("vs/platform/terminal/node/shellEnv",e)}),define(J[156],Z([13,11]),function(V,e){return V.create("vs/platform/update/common/update.config.contribution",e)}),define(J[157],Z([13,11]),function(V,e){return V.create("vs/platform/windows/electron-main/window",e)}),define(J[158],Z([13,11]),function(V,e){return V.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(J[159],Z([13,11]),function(V,e){return V.create("vs/platform/workspace/common/workspace",e)}),define(J[160],Z([13,11]),function(V,e){return V.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(J[161],Z([13,11]),function(V,e){return V.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(J[162],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function m(L){return L&&L.hasOwnProperty("folderUri")}e.isFolderBackupInfo=m;function n(L){return L&&L.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=n}),define(J[163],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEmptyWindowBackupInfo=void 0;function m(n){return typeof n?.backupFolder=="string"}e.isEmptyWindowBackupInfo=m}),define(J[164],Z([0,1,4,2]),function(V,e,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class L{constructor(){this._onCloseEmitter=new m.Emitter,this._onReloadEmitter=new m.Emitter,this._onTerminateEmitter=new m.Emitter,this._onAttachEmitter=new m.Emitter}call(S,g,b){switch(g){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:b[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:b[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:b[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:b[0],port:b[1],subId:b[2]}))}throw new Error("Method not implemented.")}listen(S,g,b){switch(g){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=L,L.ChannelName="extensionhostdebugservice";class D extends n.Disposable{constructor(S){super();this.channel=S}reload(S){this.channel.call("reload",[S])}get onReload(){return this.channel.listen("reload")}close(S){this.channel.call("close",[S])}get onClose(){return this.channel.listen("close")}attachSession(S,g,b){this.channel.call("attach",[S,g,b])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(S,g){this.channel.call("terminate",[S,g])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(S,g){return this.channel.call("openExtensionDevelopmentHostWindow",[S,g])}}e.ExtensionHostDebugChannelClient=D}),define(J[165],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class m{constructor(M){this.driver=M}listen(M,S){throw new Error(`No event found: ${S}`)}call(M,S,g){switch(S){case"click":return this.driver.click(g[0],g[1],g[2]);case"doubleClick":return this.driver.doubleClick(g);case"setValue":return this.driver.setValue(g[0],g[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(g);case"getElements":return this.driver.getElements(g[0],g[1]);case"getElementXY":return this.driver.getElementXY(g[0],g[1],g[2]);case"typeInEditor":return this.driver.typeInEditor(g[0],g[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(g);case"writeInTerminal":return this.driver.writeInTerminal(g[0],g[1]);case"getLocaleInfo":return this.driver.getLocaleInfo();case"getLocalizedStrings":return this.driver.getLocalizedStrings()}throw new Error(`Call not found: ${S}`)}}e.WindowDriverChannel=m;class n{constructor(M){this.channel=M}click(M,S,g){return this.channel.call("click",[M,S,g])}doubleClick(M){return this.channel.call("doubleClick",M)}setValue(M,S){return this.channel.call("setValue",[M,S])}getTitle(){return this.channel.call("getTitle")}isActiveElement(M){return this.channel.call("isActiveElement",M)}getElements(M,S){return this.channel.call("getElements",[M,S])}getElementXY(M,S,g){return this.channel.call("getElementXY",[M,S,g])}typeInEditor(M,S){return this.channel.call("typeInEditor",[M,S])}getTerminalBuffer(M){return this.channel.call("getTerminalBuffer",M)}writeInTerminal(M,S){return this.channel.call("writeInTerminal",[M,S])}getLocaleInfo(){return this.channel.call("getLocaleInfo")}getLocalizedStrings(){return this.channel.call("getLocalizedStrings")}}e.WindowDriverChannelClient=n;class L{constructor(M){this.channel=M}registerWindowDriver(M){return this.channel.call("registerWindowDriver",M)}reloadWindowDriver(M){return this.channel.call("reloadWindowDriver",M)}}e.WindowDriverRegistryChannelClient=L}),define(J[166],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;class m{constructor(L){this.machineId=L}encryption(){return new Promise((L,D)=>V(["vscode-encrypt"],L,D))}async encrypt(L){try{return(await this.encryption()).encrypt(this.machineId,L)}catch{return L}}async decrypt(L){try{return(await this.encryption()).decrypt(this.machineId,L)}catch{return L}}}e.EncryptionMainService=m}),define(J[167],Z([0,1,132,46,10,7,36,17,8]),function(V,e,m,n,L,D,M,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class b{constructor(d,p,v){this._args=d,this.paths=p,this.productService=v}get appRoot(){return(0,D.dirname)(L.FileAccess.asFileUri("",V).fsPath)}get userHome(){return g.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return g.URI.file((0,D.join)(this.userDataPath,"User"))}get tmpDir(){return g.URI.file(this.paths.tmpDir)}get cacheHome(){return g.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,S.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,S.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const d=(0,m.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,D.join)(this.userDataPath,"logs",d)}return this.args.logsPath}get userDataSyncLogResource(){return g.URI.file((0,D.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,S.joinPath)(g.URI.file((0,D.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return g.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return g.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,S.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,S.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=M.env.VSCODE_PORTABLE;return d?g.URI.file((0,D.join)(d,"argv.json")):(0,S.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,S.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return g.URI.file((0,D.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,D.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,D.resolve)(d):(0,D.normalize)((0,D.join)(L.FileAccess.asFileUri("",V).fsPath,"..","extensions"))}get extensionsDownloadPath(){const d=this.args["extensions-download-dir"];return d?(0,D.resolve)(d):(0,D.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,D.resolve)(d);const p=M.env.VSCODE_EXTENSIONS;if(p)return p;const v=M.env.VSCODE_PORTABLE;return v?(0,D.join)(v,"extensions"):(0,S.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(p=>/^[^:/?#]+?:\/\//.test(p)?g.URI.parse(p):g.URI.file((0,D.normalize)(p)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?g.URI.parse(d):g.URI.file((0,D.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!M.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,S.joinPath)(g.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return g.URI.file((0,D.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}ue([n.memoize],b.prototype,"appRoot",null),ue([n.memoize],b.prototype,"userHome",null),ue([n.memoize],b.prototype,"userDataPath",null),ue([n.memoize],b.prototype,"appSettingsHome",null),ue([n.memoize],b.prototype,"tmpDir",null),ue([n.memoize],b.prototype,"cacheHome",null),ue([n.memoize],b.prototype,"userRoamingDataHome",null),ue([n.memoize],b.prototype,"settingsResource",null),ue([n.memoize],b.prototype,"userDataSyncHome",null),ue([n.memoize],b.prototype,"userDataSyncLogResource",null),ue([n.memoize],b.prototype,"sync",null),ue([n.memoize],b.prototype,"machineSettingsResource",null),ue([n.memoize],b.prototype,"globalStorageHome",null),ue([n.memoize],b.prototype,"workspaceStorageHome",null),ue([n.memoize],b.prototype,"keybindingsResource",null),ue([n.memoize],b.prototype,"keyboardLayoutResource",null),ue([n.memoize],b.prototype,"argvResource",null),ue([n.memoize],b.prototype,"snippetsHome",null),ue([n.memoize],b.prototype,"isExtensionDevelopment",null),ue([n.memoize],b.prototype,"untitledWorkspacesHome",null),ue([n.memoize],b.prototype,"installSourcePath",null),ue([n.memoize],b.prototype,"builtinExtensionsPath",null),ue([n.memoize],b.prototype,"extensionsPath",null),ue([n.memoize],b.prototype,"extensionDevelopmentLocationURI",null),ue([n.memoize],b.prototype,"extensionDevelopmentKind",null),ue([n.memoize],b.prototype,"extensionTestsLocationURI",null),ue([n.memoize],b.prototype,"debugExtensionHost",null),ue([n.memoize],b.prototype,"serviceMachineIdResource",null),ue([n.memoize],b.prototype,"telemetryLogResource",null),ue([n.memoize],b.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=b;function C(t,d){return w(t["inspect-extensions"],t["inspect-brk-extensions"],5870,d,t.debugId,t.extensionEnvironment)}e.parseExtensionHostPort=C;function I(t,d){return w(t["inspect-search"],t["inspect-brk-search"],5876,d,t.extensionEnvironment)}e.parseSearchPort=I;function E(t,d){return w(t["inspect-ptyhost"],t["inspect-brk-ptyhost"],5877,d,t.extensionEnvironment)}e.parsePtyHostPort=E;function w(t,d,p,v,P,h){const c=Number(d||t)||(v?null:p),a=c?Boolean(!!d):!1;let f;if(h)try{f=JSON.parse(h)}catch{}return{port:c,break:a,debugId:P,env:f}}}),define(J[91],Z([0,1,250,3,142]),function(V,e,m,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const D={o:(0,L.localize)(0,null),e:(0,L.localize)(1,null),t:(0,L.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,L.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,L.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,L.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,L.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,L.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,L.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,L.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,L.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,L.localize)(11,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,L.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,L.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,L.localize)(14,null)},category:{type:"string",cat:"e",description:(0,L.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,L.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,L.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,L.localize)(18,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"ext-id",description:(0,L.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,L.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,L.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,L.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,L.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,L.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,L.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,L.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,L.localize)(27,null),args:["on | off"]},"inspect-extensions":{type:"string",deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,L.localize)(28,null)},"inspect-brk-extensions":{type:"string",deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,L.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,L.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,L.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,L.localize)(32,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:["debugSearch"]},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"]},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},_:{type:"string[]"}};const M={onUnknownOption:()=>{},onMultipleValues:()=>{},onDeprecatedOption:()=>{}};function S(t,d,p=M){const v={},P=[],h=[];for(let f in d){const r=d[f];r.alias&&(v[f]=r.alias),r.type==="string"||r.type==="string[]"?(P.push(f),r.deprecates&&P.push(...r.deprecates)):r.type==="boolean"&&(h.push(f),r.deprecates&&h.push(...r.deprecates))}const l=m(t,{string:P,boolean:h,alias:v}),c={},a=l;c._=l._.map(f=>String(f)).filter(f=>f.length>0),delete a._;for(let f in d){const r=d[f];r.alias&&delete a[r.alias];let i=a[f];if(r.deprecates)for(const s of r.deprecates)a.hasOwnProperty(s)&&(i||(i=a[s],i&&p.onDeprecatedOption(s,r.deprecationMessage||(0,L.localize)(33,null))),delete a[s]);typeof i!="undefined"&&(r.type==="string[]"?i&&!Array.isArray(i)&&(i=[i]):r.type==="string"&&Array.isArray(i)&&(i=i.pop(),p.onMultipleValues(f,i)),c[f]=i,r.deprecationMessage&&p.onDeprecatedOption(f,r.deprecationMessage)),delete a[f]}for(let f in a)p.onUnknownOption(f);return c}e.parseArgs=S;function g(t,d){let p="";return d.args&&(Array.isArray(d.args)?p=` <${d.args.join("> <")}>`:p=` <${d.args}>`),d.alias?`-${d.alias} --${t}${p}`:`--${t}${p}`}function b(t,d){let p=0,v=[];for(const c in t){const a=t[c],f=g(c,a);p=Math.max(p,f.length),v.push([f,a.description])}let P=p+2+1;if(d-P<25)return v.reduce((c,a)=>c.concat([`  ${a[0]}`,`      ${a[1]}`]),[]);let h=d-P-1,l=[];for(const c of v){let a=c[0],f=I(c[1],h),r=C(P-a.length-2);l.push("  "+a+r+f[0]);for(let i=1;i<f.length;i++)l.push(C(P)+f[i])}return l}e.formatOptions=b;function C(t){return" ".repeat(t)}function I(t,d){let p=[];for(;t.length;){let v=t.length<d?t.length:t.lastIndexOf(" ",d),P=t.slice(0,v).trim();t=t.slice(v),p.push(P)}return p}function E(t,d,p,v,P){const h=process.stdout.isTTY&&process.stdout.columns||80,l=P?.noInputFiles!==!0?`[${(0,L.localize)(34,null)}...]`:"",c=[`${t} ${p}`];c.push(""),c.push(`${(0,L.localize)(35,null)}: ${d} [${(0,L.localize)(36,null)}]${l}`),c.push(""),P?.noPipe!==!0&&(n.isWindows?c.push((0,L.localize)(37,null,d)):c.push((0,L.localize)(38,null,d)),c.push(""));const a={};for(const f in v){const r=v[f];if(r.description&&r.cat){let i=a[r.cat];i||(a[r.cat]=i={}),i[f]=r}}for(let f in a){const r=f;let i=a[r];i&&(c.push(D[r]),c.push(...b(i,h)),c.push(""))}return c.join(`
`)}e.buildHelpMessage=E;function w(t,d){return`${t||(0,L.localize)(39,null)}
${d||(0,L.localize)(40,null)}
${process.arch}`}e.buildVersionMessage=w}),define(J[168],Z([0,1,61,164,91]),function(V,e,m,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class D extends n.ExtensionHostDebugBroadcastChannel{constructor(S){super();this.windowsMainService=S}call(S,g,b){return g==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(b[0],b[1]):super.call(S,g,b)}async openExtensionDevelopmentHostWindow(S,g){const b=(0,L.parseArgs)(S,L.OPTIONS);b.debugRenderer=g;const C=b.extensionDevelopmentPath;if(!C)return{success:!1};const[I]=this.windowsMainService.openExtensionDevelopmentHostWindow(C,{context:5,cli:b});if(!g)return{success:!0};const E=I.win;if(!E)return{success:!0};const w=E.webContents.debugger;let t=w.isAttached()?1/0:0;const d=(0,m.createServer)(p=>{t++==0&&w.attach();let v=!1;const P=c=>{v||p.write(JSON.stringify(c)+"\0")},h=(c,a,f,r)=>P({method:a,params:f,sessionId:r});E.on("close",()=>{w.removeListener("message",h),p.end(),v=!0}),w.addListener("message",h);let l=Buffer.alloc(0);p.on("data",c=>{l=Buffer.concat([l,c]);for(let a=l.indexOf(0);a!==-1;a=l.indexOf(0)){let f;try{const r=l.slice(0,a).toString("utf8");l=l.slice(a+1),f=JSON.parse(r)}catch(r){console.error("error reading cdp line",r)}w.sendCommand(f.method,f.params,f.sessionId).then(r=>P({id:f.id,sessionId:f.sessionId,result:r})).catch(r=>P({id:f.id,sessionId:f.sessionId,error:{code:0,message:r.message}}))}}),p.on("error",c=>{console.error("error on cdp pipe:",c)}),p.on("close",()=>{v=!0,--t==0&&w.detach()})});return await new Promise(p=>d.listen(0,p)),E.on("close",()=>d.close()),{rendererDebugPort:d.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=D}),define(J[50],Z([0,1,251,143,91]),function(V,e,m,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const D=2048;function M(E,w){const t={onUnknownOption:p=>{console.warn((0,n.localize)(0,null,p))},onMultipleValues:(p,v)=>{console.warn((0,n.localize)(1,null,p,v))},onDeprecatedOption:(p,v)=>{console.warn((0,n.localize)(2,null,p,v))}},d=(0,L.parseArgs)(E,L.OPTIONS,w?t:void 0);return d.goto&&d._.forEach(p=>m(/^(\w:)?[^:]+(:\d*){0,2}$/.test(p),(0,n.localize)(3,null))),d["max-memory"]&&m(parseInt(d["max-memory"])>=D,`The max-memory argument cannot be specified lower than ${D} MB.`),d}function S(E){const w=E.findIndex(t=>!/^-/.test(t));if(w>-1)return[...E.slice(0,w),...E.slice(w+1)]}function g(E){let[,...w]=E;process.env.VSCODE_DEV&&(w=S(w)||[]);const t=!I(process.env);return M(w,t)}e.parseMainProcessArgv=g;function b(E){const[,,...w]=E;return M(w,!0)}e.parseCLIProcessArgv=b;function C(E,...w){const t=E.indexOf("--");return t===-1?E.push(...w):E.splice(t,0,...w),E}e.addArg=C;function I(E){return E.VSCODE_CLI==="1"}e.isLaunchedFromCli=I}),function(){"use strict";function V(e,m,n,L){function D(S){const g=M(S),b=[g];return e.isAbsolute(g)||b.unshift(L),e.resolve(...b)}function M(S){const g=process.env.VSCODE_PORTABLE;if(g)return e.join(g,"user-data");let b=process.env.VSCODE_APPDATA;if(b)return e.join(b,n);const C=S["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if(b=process.env.APPDATA,!b){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");b=e.join(I,"AppData","Roaming")}break;case"darwin":b=e.join(m.homedir(),"Library","Application Support");break;case"linux":b=process.env.XDG_CONFIG_HOME||e.join(m.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(b,n)}return{getUserDataPath:D}}if(typeof define=="function")define(J[169],Z([0,252,26,10,17,36]),function(e,m,n,L,D,M){const S=D.dirname(L.FileAccess.asFileUri("",e)),g=e.__$__nodeRequire(D.joinPath(S,"package.json").fsPath);return V(m,n,g.name,M.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),m=require("path"),n=require("os");module.exports=V(m,n,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(J[170],Z([0,1,26,167,169]),function(V,e,m,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class D extends n.AbstractNativeEnvironmentService{constructor(S,g){super(S,{homeDir:(0,m.homedir)(),tmpDir:(0,m.tmpdir)(),userDataDir:(0,L.getUserDataPath)(S)},g)}}e.NativeEnvironmentService=D}),define(J[171],Z([0,1,29,26,28]),function(V,e,m,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function D(M){const S=(0,L.randomPath)((0,n.tmpdir)());try{return(0,m.writeFileSync)(S,""),M&&console.log(`Marker file for --wait created: ${S}`),S}catch(g){M&&console.error(`Failed to create marker file for --wait: ${g}`);return}}e.createWaitMarkerFile=D}),define(J[172],Z([0,1,16,31]),function(V,e,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function L(D,M,S){let g=S&&S.get("storage.serviceMachineId",0)||null;if(g)return g;try{const C=(await M.readFile(D.serviceMachineIdResource)).value.toString();g=(0,n.isUUID)(C)?C:null}catch{g=null}if(!g){g=(0,n.generateUuid)();try{await M.writeFile(D.serviceMachineIdResource,m.VSBuffer.fromString(g))}catch{}}return S&&S.store("storage.serviceMachineId",g,0,1),g}e.getServiceMachineId=L}),define(J[73],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class m{constructor(L,D=[],M=!1){this.ctor=L,this.staticArguments=D,this.supportsDelayedInstantiation=M}}e.SyncDescriptor=m}),define(J[173],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class m{constructor(D){this.incoming=new Map,this.outgoing=new Map,this.data=D}}e.Node=m;class n{constructor(D){this._hashFn=D,this._nodes=new Map}roots(){const D=[];for(let M of this._nodes.values())M.outgoing.size===0&&D.push(M);return D}insertEdge(D,M){const S=this.lookupOrInsertNode(D),g=this.lookupOrInsertNode(M);S.outgoing.set(this._hashFn(M),g),g.incoming.set(this._hashFn(D),S)}removeNode(D){const M=this._hashFn(D);this._nodes.delete(M);for(let S of this._nodes.values())S.outgoing.delete(M),S.incoming.delete(M)}lookupOrInsertNode(D){const M=this._hashFn(D);let S=this._nodes.get(M);return S||(S=new m(D),this._nodes.set(M,S)),S}lookup(D){return this._nodes.get(this._hashFn(D))}isEmpty(){return this._nodes.size===0}toString(){let D=[];for(let[M,S]of this._nodes)D.push(`${M}, (incoming)[${[...S.incoming.keys()].join(", ")}], (outgoing)[${[...S.outgoing.keys()].join(",")}]`);return D.join(`
`)}findCycleSlow(){for(let[D,M]of this._nodes){const S=new Set([D]),g=this._findCycle(M,S);if(g)return g}}_findCycle(D,M){for(let[S,g]of D.outgoing){if(M.has(S))return[...M,S].join(" -> ");M.add(S);const b=this._findCycle(g,M);if(b)return b;M.delete(S)}}}e.Graph=n}),define(J[5],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var m;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function S(g){return g[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=S})(m=e._util||(e._util={})),e.IInstantiationService=L("instantiationService");function n(M,S,g){S[m.DI_TARGET]===S?S[m.DI_DEPENDENCIES].push({id:M,index:g}):(S[m.DI_DEPENDENCIES]=[{id:M,index:g}],S[m.DI_TARGET]=S)}function L(M){if(m.serviceIds.has(M))return m.serviceIds.get(M);const S=function(g,b,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(S,g,C)};return S.toString=()=>M,m.serviceIds.set(M,S),S}e.createDecorator=L;function D(M){return M}e.refineServiceDecorator=D}),define(J[51],Z([0,1,5]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,m.createDecorator)("backupMainService")}),define(J[19],Z([0,1,14,8,5]),function(V,e,m,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,L.createDecorator)("configurationService");function D(p){return p&&typeof p=="object"&&(!p.overrideIdentifier||typeof p.overrideIdentifier=="string")&&(!p.resource||p.resource instanceof n.URI)}e.isConfigurationOverrides=D;function M(p){return p&&typeof p=="object"&&(!p.overrideIdentifiers||m.isArray(p.overrideIdentifiers))&&!p.overrideIdentifier&&(!p.resource||p.resource instanceof n.URI)}e.isConfigurationUpdateOverrides=M;var S;(function(p){p[p.USER=1]="USER",p[p.USER_LOCAL=2]="USER_LOCAL",p[p.USER_REMOTE=3]="USER_REMOTE",p[p.WORKSPACE=4]="WORKSPACE",p[p.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",p[p.DEFAULT=6]="DEFAULT",p[p.MEMORY=7]="MEMORY"})(S=e.ConfigurationTarget||(e.ConfigurationTarget={}));function g(p){switch(p){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=g;function b(p,v){const P=Object.create(null);for(let h in p)C(P,h,p[h],v);return P}e.toValuesTree=b;function C(p,v,P,h){const l=v.split("."),c=l.pop();let a=p;for(let f=0;f<l.length;f++){let r=l[f],i=a[r];switch(typeof i){case"undefined":i=a[r]=Object.create(null);break;case"object":break;default:h(`Ignoring ${v} as ${l.slice(0,f+1).join(".")} is ${JSON.stringify(i)}`);return}a=i}if(typeof a=="object"&&a!==null)try{a[c]=P}catch{h(`Ignoring ${v} as ${l.join(".")} is ${JSON.stringify(a)}`)}else h(`Ignoring ${v} as ${l.join(".")} is ${JSON.stringify(a)}`)}e.addToValueTree=C;function I(p,v){const P=v.split(".");E(p,P)}e.removeFromValueTree=I;function E(p,v){const P=v.shift();if(v.length===0){delete p[P];return}if(Object.keys(p).indexOf(P)!==-1){const h=p[P];typeof h=="object"&&!Array.isArray(h)&&(E(h,v),Object.keys(h).length===0&&delete p[P])}}function w(p,v,P){function h(a,f){let r=a;for(const i of f){if(typeof r!="object"||r===null)return;r=r[i]}return r}const l=v.split("."),c=h(p,l);return typeof c=="undefined"?P:c}e.getConfigurationValue=w;function t(p,v,P){Object.keys(v).forEach(h=>{h!=="__proto__"&&(h in p?m.isObject(p[h])&&m.isObject(v[h])?t(p[h],v[h],P):P&&(p[h]=v[h]):p[h]=v[h])})}e.merge=t;function d(p,v,P){const h=p.inspect(v),l=p.inspect(P);return typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:h.defaultValue}e.getMigratedSettingValue=d}),define(J[74],Z([0,1,5]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,m.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,m.createDecorator)("credentialsMainService");class n{constructor(){this.secretVault={}}async getPassword(D,M){return this.secretVault[D]?.[M]??null}async setPassword(D,M,S){this.secretVault[D]=this.secretVault[D]??{},this.secretVault[D][M]=S}async deletePassword(D,M){return this.secretVault[D]?.[M]?(delete this.secretVault[D][M],Object.keys(this.secretVault[D]).length===0&&delete this.secretVault[D],!0):!1}async findPassword(D){return JSON.stringify(this.secretVault[D])??null}async findCredentials(D){const M=[];for(const S of Object.keys(this.secretVault[D]||{}))M.push({account:S,password:this.secretVault[D][S]});return M}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=n}),define(J[75],Z([0,1,5]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,m.createDecorator)(e.ID);function n(D){return!!D.hostName&&!!D.errorMessage}e.isRemoteDiagnosticError=n;class L{async getPerformanceInfo(M,S){return{}}async getSystemInfo(M,S){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(M,S){return""}async getWorkspaceFileExtensions(M){return{extensions:[]}}async reportWorkspaceStats(M){}}e.NullDiagnosticsService=L}),define(J[92],Z([0,1,5]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,m.createDecorator)("encryptionMainService")}),define(J[52],Z([0,1,5]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,m.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,m.refineServiceDecorator)(e.IEnvironmentService)}),define(J[174],Z([0,1,5]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,m.createDecorator)("extensionUrlTrustService")}),define(J[175],Z([0,1,5]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,m.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(J[93],Z([0,1,5]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,m.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,m.createDecorator)("externalTerminal")}),define(J[176],Z([0,1,45,10,7,3,84,24,72,144,93]),function(V,e,m,n,L,D,M,S,g,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const I=b.localize(0,null);class E{async getDefaultTerminalForPlatforms(){return{windows:w.getDefaultTerminalWindows(),linux:await d.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class w extends E{openTerminal(l,c){return this.spawnTerminal(m,l,g.getWindowsShell(),c)}spawnTerminal(l,c,a,f){const r=c.windowsExec||w.getDefaultTerminalWindows();f&&f[1]===":"&&(f=f[0].toUpperCase()+f.substr(1));const i=L.basename(r).toLowerCase();if(i==="cmder"||i==="cmder.exe")return l.spawn(r,f?[f]:void 0),Promise.resolve(void 0);const s=["/c","start","/wait"];return r.indexOf(" ")>=0&&s.push('""'),s.push(r),(i==="wt"||i==="wt.exe")&&s.push("-d ."),new Promise((o,u)=>{const y=p(process),k=l.spawn(a,s,{cwd:f,env:y});k.on("error",u),k.on("exit",()=>o())})}runInTerminal(l,c,a,f,r){const i="windowsExec"in r&&r.windowsExec?r.windowsExec:w.getDefaultTerminalWindows();return new Promise((s,o)=>{const u=`"${c} - ${I}"`,y=`""${a.join('" "')}" & pause"`,k=["/c","start",u,"/wait",i,"/c",y],R=Object.assign({},p(process),f);Object.keys(R).filter(K=>R[K]===null).forEach(K=>delete R[K]);const W={cwd:c,env:R,windowsVerbatimArguments:!0};m.spawn(w.CMD,k,W).on("error",K=>{o(v(K))}),s(void 0)})}static getDefaultTerminalWindows(){if(!w._DEFAULT_TERMINAL_WINDOWS){const l=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");w._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${l?"Sysnative":"System32"}\\cmd.exe`}return w._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=w,w.CMD="cmd.exe";class t extends E{openTerminal(l,c){return this.spawnTerminal(m,l,c)}runInTerminal(l,c,a,f,r){const i=r.osxExec||C.DEFAULT_TERMINAL_OSX;return new Promise((s,o)=>{if(i===C.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const u=i===C.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",k=[n.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${u}.scpt`,V).fsPath,"-t",l||I,"-w",c];for(let U of a)k.push("-a"),k.push(U);if(f){const U=Object.assign({},p(process),f);for(let K in U){const x=U[K];x===null?(k.push("-u"),k.push(K)):(k.push("-e"),k.push(`${K}=${x}`))}}let R="";const W=m.spawn(t.OSASCRIPT,k);W.on("error",U=>{o(v(U))}),W.stderr.on("data",U=>{R+=U.toString()}),W.on("exit",U=>{if(U===0)s(void 0);else if(R){const K=R.split(`
`,1);o(new Error(K[0]))}else o(new Error(b.localize(1,null,u,U)))})}else o(new Error(b.localize(2,null,i)))})}spawnTerminal(l,c,a){const f=c.osxExec||C.DEFAULT_TERMINAL_OSX;return new Promise((r,i)=>{const s=["-a",f];a&&s.push(a);const o=p(process),u=l.spawn("/usr/bin/open",s,{cwd:a,env:o});u.on("error",i),u.on("exit",()=>r())})}}e.MacExternalTerminalService=t,t.OSASCRIPT="/usr/bin/osascript";class d extends E{openTerminal(l,c){return this.spawnTerminal(m,l,c)}runInTerminal(l,c,a,f,r){const i=r.linuxExec?Promise.resolve(r.linuxExec):d.getDefaultTerminalLinuxReady();return new Promise((s,o)=>{let u=[];i.then(y=>{y.indexOf("gnome-terminal")>=0?u.push("-x"):u.push("-e"),u.push("bash"),u.push("-c");const k=`${P(a)}; echo; read -p "${d.WAIT_MESSAGE}" -n1;`;u.push(`''${k}''`);const R=Object.assign({},p(process),f);Object.keys(R).filter(x=>R[x]===null).forEach(x=>delete R[x]);const W={cwd:c,env:R};let U="";const K=m.spawn(y,u,W);K.on("error",x=>{o(v(x))}),K.stderr.on("data",x=>{U+=x.toString()}),K.on("exit",x=>{if(x===0)s(void 0);else if(U){const ee=U.split(`
`,1);o(new Error(ee[0]))}else o(new Error(b.localize(4,null,y,x)))})})})}static async getDefaultTerminalLinuxReady(){if(!d._DEFAULT_TERMINAL_LINUX_READY)if(!D.isLinux)d._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const l=await S.Promises.exists("/etc/debian_version");d._DEFAULT_TERMINAL_LINUX_READY=new Promise(c=>{l?c("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?c("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?c("konsole"):process.env.COLORTERM?c(process.env.COLORTERM):process.env.TERM?c(process.env.TERM):c("xterm")})}return d._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(l,c,a){const f=c.linuxExec?Promise.resolve(c.linuxExec):d.getDefaultTerminalLinuxReady();return new Promise((r,i)=>{f.then(s=>{const o=p(process),u=l.spawn(s,[],{cwd:a,env:o});u.on("error",i),u.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=d,d.WAIT_MESSAGE=b.localize(3,null);function p(h){const l={...h.env};return(0,M.sanitizeProcessEnvironment)(l),l}function v(h){return"errno"in h&&h.errno==="ENOENT"&&"path"in h&&typeof h.path=="string"?new Error(b.localize(5,null,h.path)):h}function P(h){let l="";for(let c of h)c.indexOf(" ")>=0?l+='"'+c+'"':l+=c,l+=" ";return l}}),define(J[20],Z([0,1,15,35,7,27,14,8,146,5]),function(V,e,m,n,L,D,M,S,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,b.createDecorator)("fileService");function C(z){return z.create===!0}e.isFileOpenForWriteOptions=C;var I;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(I=e.FileType||(e.FileType={}));var E;(function(z){z[z.Readonly=1]="Readonly"})(E=e.FilePermission||(e.FilePermission={}));var w;(function(z){z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock",z[z.FileAtomicRead=16384]="FileAtomicRead"})(w=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function t(z){return!!(z.capabilities&2)}e.hasReadWriteCapability=t;function d(z){return!!(z.capabilities&8)}e.hasFileFolderCopyCapability=d;function p(z){return!!(z.capabilities&4)}e.hasOpenReadWriteCloseCapability=p;function v(z){return!!(z.capabilities&16)}e.hasFileReadStreamCapability=v;function P(z){return t(z)?!!(z.capabilities&16384):!1}e.hasFileAtomicReadCapability=P;var h;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(h=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class l extends Error{constructor(ie,$){super(ie);this.code=$}}e.FileSystemProviderError=l;function c(z,ie){const $=new l(z.toString(),ie);return f($,ie),$}e.createFileSystemProviderError=c;function a(z){return z||c((0,g.localize)(0,null),h.Unknown)}e.ensureFileSystemProviderError=a;function f(z,ie){return z.name=ie?`${ie} (FileSystemError)`:"FileSystemError",z}e.markAsFileSystemProviderError=f;function r(z){if(!z)return h.Unknown;if(z instanceof l)return z.code;const ie=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!ie)return h.Unknown;switch(ie[1]){case h.FileExists:return h.FileExists;case h.FileIsADirectory:return h.FileIsADirectory;case h.FileNotADirectory:return h.FileNotADirectory;case h.FileNotFound:return h.FileNotFound;case h.FileExceedsMemoryLimit:return h.FileExceedsMemoryLimit;case h.FileTooLarge:return h.FileTooLarge;case h.FileWriteLocked:return h.FileWriteLocked;case h.NoPermissions:return h.NoPermissions;case h.Unavailable:return h.Unavailable}return h.Unknown}e.toFileSystemProviderErrorCode=r;function i(z){if(z instanceof R)return z.fileOperationResult;switch(r(z)){case h.FileNotFound:return 1;case h.FileIsADirectory:return 0;case h.FileNotADirectory:return 10;case h.FileWriteLocked:return 5;case h.NoPermissions:return 6;case h.FileExists:return 4;case h.FileExceedsMemoryLimit:return 9;case h.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var s;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY",z[z.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class o{constructor(ie,$,q){this.resource=ie,this.operation=$,this.target=q}isOperation(ie){return this.operation===ie}}e.FileOperationEvent=o;var u;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class y{constructor(ie,$){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=ie;const q=new Map;for(const Y of ie){const B=q.get(Y.type);switch(B?B.push([Y.resource,Y]):q.set(Y.type,[[Y.resource,Y]]),Y.type){case 1:this.rawAdded.push(Y.resource);break;case 0:this.rawUpdated.push(Y.resource);break;case 2:this.rawDeleted.push(Y.resource);break}}for(const[Y,B]of q)switch(Y){case 1:this.added=n.TernarySearchTree.forUris(()=>$),this.added.fill(B);break;case 0:this.updated=n.TernarySearchTree.forUris(()=>$),this.updated.fill(B);break;case 2:this.deleted=n.TernarySearchTree.forUris(()=>$),this.deleted.fill(B);break}}contains(ie,...$){return this.doContains(ie,{includeChildren:!1},...$)}affects(ie,...$){return this.doContains(ie,{includeChildren:!0},...$)}doContains(ie,$,...q){if(!ie)return!1;const Y=q.length>0;return!!((!Y||q.includes(1))&&(this.added?.get(ie)||$.includeChildren&&this.added?.findSuperstr(ie))||(!Y||q.includes(0))&&(this.updated?.get(ie)||$.includeChildren&&this.updated?.findSuperstr(ie))||(!Y||q.includes(2))&&(this.deleted?.findSubstr(ie)||$.includeChildren&&this.deleted?.findSuperstr(ie)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=y;function k(z,ie,$){return!z||!ie||z===ie||ie.length>z.length?!1:(ie.charAt(ie.length-1)!==L.sep&&(ie+=L.sep),$?(0,D.startsWithIgnoreCase)(z,ie):z.indexOf(ie)===0)}e.isParent=k;class R extends m.ErrorNoTelemetry{constructor(ie,$,q){super(ie);this.fileOperationResult=$,this.options=q}}e.FileOperationError=R;class W extends R{constructor(ie,$,q){super(ie,2,q);this.stat=$}}e.NotModifiedSinceFileOperationError=W;var U;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",z[z.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(U=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var K;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(K=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function x(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}e.etag=x;async function ee(z,ie){if(!ie.hasProvider(S.URI.from({scheme:z.scheme})))return new Promise($=>{const q=ie.onDidChangeFileSystemProviderRegistrations(Y=>{Y.scheme===z.scheme&&Y.added&&(q.dispose(),$())})})}e.whenProviderRegistered=ee,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class Q{static formatSize(ie){return(0,M.isNumber)(ie)||(ie=0),ie<Q.KB?(0,g.localize)(1,null,ie.toFixed(0)):ie<Q.MB?(0,g.localize)(2,null,(ie/Q.KB).toFixed(2)):ie<Q.GB?(0,g.localize)(3,null,(ie/Q.MB).toFixed(2)):ie<Q.TB?(0,g.localize)(4,null,(ie/Q.GB).toFixed(2)):(0,g.localize)(5,null,(ie/Q.TB).toFixed(2))}}e.ByteSize=Q,Q.KB=1024,Q.MB=Q.KB*Q.KB,Q.GB=Q.MB*Q.KB,Q.TB=Q.GB*Q.KB;var H;(function(z){z[z.IA32=0]="IA32",z[z.OTHER=1]="OTHER"})(H=e.Arch||(e.Arch={}));function X(z){return{maxFileSize:z===0?300*Q.MB:16*Q.GB,maxHeapSize:z===0?700*Q.MB:2*700*Q.MB}}e.getPlatformLimits=X}),define(J[177],Z([0,1,16,39,15,4,2,48,8,31,20]),function(V,e,m,n,L,D,M,S,g,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class I extends M.Disposable{constructor(w,t){super();this.channel=w,this.extraCapabilities=t,this.onDidChangeCapabilities=D.Event.None,this._onDidChange=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new D.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,b.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(w){return this.channel.call("stat",[w])}readdir(w){return this.channel.call("readdir",[w])}async readFile(w,t){const{buffer:d}=await this.channel.call("readFile",[w,t]);return d}readFileStream(w,t,d){const p=(0,S.newWriteableStream)(P=>m.VSBuffer.concat(P.map(h=>m.VSBuffer.wrap(h))).buffer),v=this.channel.listen("readFileStream",[w,t])(P=>{if(P instanceof m.VSBuffer)p.write(P.buffer);else{if(P==="end")p.end();else{let h=P;h instanceof Error||(h=(0,C.createFileSystemProviderError)((0,n.toErrorMessage)(h),C.FileSystemProviderErrorCode.Unknown)),p.error(h),p.end()}v.dispose()}});return d.onCancellationRequested(()=>{p.error((0,L.canceled)()),p.end(),v.dispose()}),p}writeFile(w,t,d){return this.channel.call("writeFile",[w,m.VSBuffer.wrap(t),d])}open(w,t){return this.channel.call("open",[w,t])}close(w){return this.channel.call("close",[w])}async read(w,t,d,p,v){const[P,h]=await this.channel.call("read",[w,t,v]);return d.set(P.buffer.slice(0,h),p),h}write(w,t,d,p,v){return this.channel.call("write",[w,t,m.VSBuffer.wrap(d),p,v])}mkdir(w){return this.channel.call("mkdir",[w])}delete(w,t){return this.channel.call("delete",[w,t])}rename(w,t,d){return this.channel.call("rename",[w,t,d])}copy(w,t,d){return this.channel.call("copy",[w,t,d])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(w=>{if(Array.isArray(w)){const t=w;this._onDidChange.fire(t.map(d=>({resource:g.URI.revive(d.resource),type:d.type})))}else{const t=w;this._onDidWatchError.fire(t)}}))}watch(w,t){const d=(0,b.generateUuid)();return this.channel.call("watch",[this.sessionId,d,w,t]),(0,M.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,d]))}}e.DiskFileSystemProviderClient=I}),define(J[94],Z([0,1,16,15,147,20]),function(V,e,m,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function M(C,I,E,w,t,d){let p;try{await S(C,I,E,w,t,d)}catch(v){p=v}finally{p&&t.errorTransformer&&(p=t.errorTransformer(p)),typeof p!="undefined"&&E.error(p),E.end()}}e.readFileIntoStream=M;async function S(C,I,E,w,t,d){g(d);const p=await C.open(I,{create:!1});try{g(d);let v=0,P=0,h=t&&typeof t.length=="number"?t.length:void 0,l=m.VSBuffer.alloc(Math.min(t.bufferSize,typeof h=="number"?h:t.bufferSize)),c=t&&typeof t.position=="number"?t.position:0,a=0;do P=await C.read(p,c,l.buffer,a,l.byteLength-a),c+=P,a+=P,v+=P,typeof h=="number"&&(h-=P),a===l.byteLength&&(await E.write(w(l)),l=m.VSBuffer.alloc(Math.min(t.bufferSize,typeof h=="number"?h:t.bufferSize)),a=0);while(P>0&&(typeof h!="number"||h>0)&&g(d)&&b(v,t));if(a>0){let f=a;typeof h=="number"&&(f=Math.min(a,h)),E.write(w(l.slice(0,f)))}}catch(v){throw(0,D.ensureFileSystemProviderError)(v)}finally{await C.close(p)}}function g(C){if(C.isCancellationRequested)throw(0,n.canceled)();return!0}function b(C,I){if(I?.limits){if(typeof I.limits.memory=="number"&&C>I.limits.memory)throw(0,D.createFileSystemProviderError)((0,L.localize)(0,null),D.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof I.limits.size=="number"&&C>I.limits.size)throw(0,D.createFileSystemProviderError)((0,L.localize)(1,null),D.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(J[62],Z([0,1,2,3,8,20]),function(V,e,m,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function M(w){return w.recursive===!0}e.isRecursiveWatchRequest=M;class S extends m.Disposable{constructor(t,d,p,v){super();this.onFileChanges=t,this.onLogMessage=d,this.verboseLogging=p,this.options=v,this.watcherDisposables=this._register(new m.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const t=new m.DisposableStore;this.watcherDisposables.value=t,this.watcher=this.createWatcher(t),this.watcher.setVerboseLogging(this.verboseLogging),t.add(this.watcher.onDidChangeFile(d=>this.onFileChanges(d))),t.add(this.watcher.onDidLogMessage(d=>this.onLogMessage(d))),t.add(this.watcher.onDidError(d=>this.onError(d)))}onError(t){this.options.restartOnError?this.restartCounter<S.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${t}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${t}`):this.error(t)}restart(t){this.restartCounter++,this.init(),this.watch(t)}async watch(t){this.requests=t,await this.watcher?.watch(t)}async setVerboseLogging(t){this.verboseLogging=t,await this.watcher?.setVerboseLogging(t)}error(t){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${t}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=S,S.MAX_RESTARTS=5;class g extends S{constructor(t,d,p){super(t,d,p,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=g;class b extends S{constructor(t,d,p){super(t,d,p,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=b;function C(w){return w.map(t=>({type:t.type,resource:L.URI.file(t.path)}))}e.toFileChanges=C;function I(w){const t=new E;for(const d of w)t.processEvent(d);return t.coalesce()}e.coalesceEvents=I;class E{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(t){return n.isLinux?t.path:t.path.toLowerCase()}processEvent(t){const d=this.mapPathToChange.get(this.toKey(t));let p=!1;if(d){const v=d.type,P=t.type;d.path!==t.path&&(t.type===2||t.type===1)?p=!0:v===1&&P===2?(this.mapPathToChange.delete(this.toKey(t)),this.coalesced.delete(d)):v===2&&P===1?d.type=0:v===1&&P===0||(d.type=P)}else p=!0;p&&(this.coalesced.add(t),this.mapPathToChange.set(this.toKey(t),t))}coalesce(){const t=[],d=[];return Array.from(this.coalesced).filter(p=>p.type!==2?(t.push(p),!1):!0).sort((p,v)=>p.path.length-v.path.length).filter(p=>d.some(v=>(0,D.isParent)(p.path,v,!n.isLinux))?!1:(d.push(p.path),!0)).concat(t)}}}),define(J[178],Z([0,1,29,9,23,28,116,2,70,7,3,86,24,62]),function(V,e,m,n,L,D,M,S,g,b,C,I,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class t extends S.Disposable{constructor(v,P,h,l){super();this.request=v,this.onDidFilesChange=P,this.onLogMessage=h,this.verboseLogging=l,this.throttledFileChangesWorker=new n.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},c=>this.onDidFilesChange(c)),this.fileChangesDelayer=this._register(new n.ThrottledDelayer(t.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=this.request.excludes.map(c=>(0,M.parse)(c)),this.cts=new L.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const v=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const P=await E.Promises.stat(v);this._register(await this.doWatch(v,P.isDirectory()))}catch(v){v.code!=="ENOENT"?this.error(v):this.trace(v)}}async normalizePath(v){let P=v.path;try{P=await E.Promises.realpath(v.path),v.path===P&&(P=await(0,I.realcase)(v.path)??v.path),v.path!==P&&this.warn(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${v.path}, real: ${P})`)}catch{}return P}async doWatch(v,P){if(C.isMacintosh&&(0,D.isEqualOrParent)(v,"/Volumes/",!0))return this.error(`Refusing to watch ${v} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),S.Disposable.None;const h=new L.CancellationTokenSource(this.cts.token);let l=new S.DisposableStore;try{const c=(0,b.basename)(v),a=(0,m.watch)(v);l.add((0,S.toDisposable)(()=>{a.removeAllListeners(),a.close()})),this.trace(`Started watching: '${v}'`);const f=new Set;if(P)try{for(const i of await E.Promises.readdir(v))f.add(i)}catch(i){this.error(i)}const r=new Map;l.add((0,S.toDisposable)(()=>{for(const[,i]of r)i.dispose();r.clear()})),a.on("error",(i,s)=>{this.error(`Failed to watch ${v} for changes using fs.watch() (${i}, ${s})`),this.dispose()}),a.on("change",(i,s)=>{if(h.token.isCancellationRequested)return;this.trace(`[raw] ["${i}"] ${s}`);let o="";if(s&&(o=s.toString(),C.isMacintosh&&(o=(0,g.normalizeNFC)(o))),!(!o||i!=="change"&&i!=="rename"))if(P)if(i==="rename"){r.get(o)?.dispose();const u=setTimeout(async()=>{if(r.delete(o),o===c&&!await E.Promises.exists(v)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const y=await this.existsChildStrictCase((0,b.join)(v,o));if(h.token.isCancellationRequested)return;let k;y?f.has(o)?k=0:(k=1,f.add(o)):(f.delete(o),k=2),this.onFileChange({path:(0,b.join)(this.request.path,o),type:k})},t.FILE_DELETE_HANDLER_DELAY);r.set(o,(0,S.toDisposable)(()=>clearTimeout(u)))}else{let u;f.has(o)?u=0:(u=1,f.add(o)),this.onFileChange({path:(0,b.join)(this.request.path,o),type:u})}else if(i==="rename"||o!==c){const u=setTimeout(async()=>{const y=await E.Promises.exists(v);h.token.isCancellationRequested||(y?(this.onFileChange({path:this.request.path,type:0},!0),l.add(await this.doWatch(v,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},t.FILE_DELETE_HANDLER_DELAY);l.clear(),l.add((0,S.toDisposable)(()=>clearTimeout(u)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(c){await E.Promises.exists(v)&&!h.token.isCancellationRequested&&this.error(`Failed to watch ${v} for changes using fs.watch() (${c.toString()})`)}return(0,S.toDisposable)(()=>{h.dispose(!0),l.dispose()})}async onFileChange(v,P=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${v.type===1?"[ADDED]":v.type===2?"[DELETED]":"[CHANGED]"} ${v.path}`),!P&&this.excludes.some(h=>h(v.path))?this.verboseLogging&&this.trace(` >> ignored ${v.path}`):this.fileChangesBuffer.push(v);try{await this.fileChangesDelayer.trigger(async()=>{const h=this.fileChangesBuffer;this.fileChangesBuffer=[];const l=(0,w.coalesceEvents)(h);if(l.length>0){if(this.verboseLogging)for(const a of l)this.trace(`>> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.path}`);this.throttledFileChangesWorker.work(l)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${l[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(v){if(C.isLinux)return E.Promises.exists(v);try{const P=(0,b.basename)(v);return(await E.Promises.readdir((0,b.dirname)(v))).some(l=>l===P)}catch(P){return this.trace(P),!1}}setVerboseLogging(v){this.verboseLogging=v}error(v){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${v}`})}warn(v){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${v}`})}trace(v){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${v}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=t,t.FILE_DELETE_HANDLER_DELAY=100,t.FILE_CHANGES_HANDLER_DELAY=50;async function d(p,v,P,h,l=512){const c=await E.Promises.open(p,"r"),a=Buffer.allocUnsafe(l),f=new L.CancellationTokenSource(h);let r,i=!1;const s={path:p,excludes:[],recursive:!1},o=new t(s,u=>{(async()=>{for(const{type:y}of u)if(y===0){if(i)return;i=!0;try{for(;!f.token.isCancellationRequested;){const{bytesRead:k}=await E.Promises.read(c,a,0,l,null);if(!k||f.token.isCancellationRequested)break;v(a.slice(0,k))}}catch(k){r=new Error(k),f.dispose(!0)}finally{i=!1}}})()});return await o.ready,P(),new Promise((u,y)=>{f.token.onCancellationRequested(async()=>{o.dispose();try{await E.Promises.close(c)}catch(k){r=new Error(k)}r?y(r):u()})})}e.watchFileContents=d}),define(J[179],Z([0,1,30,4,2,3,178]),function(V,e,m,n,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class S extends L.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new n.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new n.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=n.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(b){const C=this.normalizeRequests(b),I=C.filter(w=>{const t=this.watchers.get(w.path);return t?!(0,m.equals)(t.request.excludes,w.excludes):!0}),E=Array.from(this.watchers.values()).filter(({request:w})=>!C.find(t=>t.path===w.path&&(0,m.equals)(t.excludes,w.excludes))).map(({request:w})=>w.path);I.length&&this.trace(`Request to start watching: ${I.map(w=>`${w.path} (excludes: ${w.excludes.length>0?w.excludes:"<none>"})`).join(",")}`),E.length&&this.trace(`Request to stop watching: ${E.join(",")}`);for(const w of E)this.stopWatching(w);for(const w of I)this.startWatching(w)}startWatching(b){const C=new M.NodeJSFileWatcherLibrary(b,E=>this._onDidChangeFile.fire(E),E=>this._onDidLogMessage.fire(E),this.verboseLogging),I={request:b,instance:C};this.watchers.set(b.path,I)}async stop(){for(const[b]of this.watchers)this.stopWatching(b);this.watchers.clear()}stopWatching(b){const C=this.watchers.get(b);C&&(this.watchers.delete(b),C.instance.dispose())}normalizeRequests(b){const C=new Map;for(const I of b){const E=D.isLinux?I.path:I.path.toLowerCase();C.set(E,I)}return Array.from(C.values())}async setVerboseLogging(b){this.verboseLogging=b;for(const[,C]of this.watchers)C.instance.setVerboseLogging(b)}trace(b){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(b)})}toMessage(b,C){return C?`[File Watcher (node.js)] ${b} (path: ${C.request.path})`:`[File Watcher (node.js)] ${b}`}}e.NodeJSWatcher=S}),define(J[180],Z([0,1,62,179]),function(V,e,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class L extends m.AbstractNonRecursiveWatcherClient{constructor(M,S,g){super(M,S,g);this.init()}createWatcher(){return new n.NodeJSWatcher}}e.NodeJSWatcherClient=L}),define(J[181],Z([0,1,10,37,138,62]),function(V,e,m,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class M extends D.AbstractUniversalWatcherClient{constructor(g,b,C){super(g,b,C);this.init()}createWatcher(g){const b=g.add(new L.Client(m.FileAccess.asFileUri("bootstrap-fork",V).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return g.add(b.onDidProcessExit(({code:C,signal:I})=>this.onError(`terminated by itself with code ${C}, signal: ${I}`))),n.ProxyChannel.toService((0,n.getNextTickChannel)(b.getChannel("watcher")))}}e.UniversalWatcherClient=M}),define(J[76],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class m{constructor(...L){this._entries=new Map;for(let[D,M]of L)this.set(D,M)}set(L,D){const M=this._entries.get(L);return this._entries.set(L,D),M}has(L){return this._entries.has(L)}get(L){return this._entries.get(L)}}e.ServiceCollection=m}),define(J[182],Z([0,1,9,15,73,173,5,76]),function(V,e,m,n,L,D,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const g=!1;class b extends Error{constructor(t){super("cyclic dependency between services");this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class C{constructor(t=new S.ServiceCollection,d=!1,p){this._activeInstantiations=new Set,this._services=t,this._strict=d,this._parent=p,this._services.set(M.IInstantiationService,this)}createChild(t){return new C(t,this._strict,this)}invokeFunction(t,...d){let p=E.traceInvocation(t),v=!1;try{return t({get:h=>{if(v)throw(0,n.illegalState)("service accessor is only valid during the invocation of its target method");const l=this._getOrCreateServiceInstance(h,p);if(!l)throw new Error(`[invokeFunction] unknown service '${h}'`);return l}},...d)}finally{v=!0,p.stop()}}createInstance(t,...d){let p,v;return t instanceof L.SyncDescriptor?(p=E.traceCreation(t.ctor),v=this._createInstance(t.ctor,t.staticArguments.concat(d),p)):(p=E.traceCreation(t),v=this._createInstance(t,d,p)),p.stop(),v}_createInstance(t,d=[],p){let v=M._util.getServiceDependencies(t).sort((l,c)=>l.index-c.index),P=[];for(const l of v){let c=this._getOrCreateServiceInstance(l.id,p);c||this._throwIfStrict(`[createInstance] ${t.name} depends on UNKNOWN service ${l.id}.`,!1),P.push(c)}let h=v.length>0?v[0].index:d.length;if(d.length!==h){console.warn(`[createInstance] First service dependency of ${t.name} at position ${h+1} conflicts with ${d.length} static arguments`);let l=h-d.length;l>0?d=d.concat(new Array(l)):d=d.slice(0,h)}return new t(...[...d,...P])}_setServiceInstance(t,d){if(this._services.get(t)instanceof L.SyncDescriptor)this._services.set(t,d);else if(this._parent)this._parent._setServiceInstance(t,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(t){let d=this._services.get(t);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(t):d}_getOrCreateServiceInstance(t,d){let p=this._getServiceInstanceOrDescriptor(t);return p instanceof L.SyncDescriptor?this._safeCreateAndCacheServiceInstance(t,p,d.branch(t,!0)):(d.branch(t,!1),p)}_safeCreateAndCacheServiceInstance(t,d,p){if(this._activeInstantiations.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this._activeInstantiations.add(t);try{return this._createAndCacheServiceInstance(t,d,p)}finally{this._activeInstantiations.delete(t)}}_createAndCacheServiceInstance(t,d,p){const v=new D.Graph(l=>l.id.toString());let P=0;const h=[{id:t,desc:d,_trace:p}];for(;h.length;){const l=h.pop();if(v.lookupOrInsertNode(l),P++>1e3)throw new b(v);for(let c of M._util.getServiceDependencies(l.desc.ctor)){let a=this._getServiceInstanceOrDescriptor(c.id);if(a||this._throwIfStrict(`[createInstance] ${t} depends on ${c.id} which is NOT registered.`,!0),a instanceof L.SyncDescriptor){const f={id:c.id,desc:a,_trace:l._trace.branch(c.id,!0)};v.insertEdge(l,f),h.push(f)}}}for(;;){const l=v.roots();if(l.length===0){if(!v.isEmpty())throw new b(v);break}for(const{data:c}of l){if(this._getServiceInstanceOrDescriptor(c.id)instanceof L.SyncDescriptor){const f=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,f)}v.removeNode(c)}}return this._getServiceInstanceOrDescriptor(t)}_createServiceInstanceWithOwner(t,d,p=[],v,P){if(this._services.get(t)instanceof L.SyncDescriptor)return this._createServiceInstance(d,p,v,P);if(this._parent)return this._parent._createServiceInstanceWithOwner(t,d,p,v,P);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(t,d=[],p,v){if(p){const P=new m.IdleValue(()=>this._createInstance(t,d,v));return new Proxy(Object.create(null),{get(h,l){if(l in h)return h[l];let c=P.value,a=c[l];return typeof a!="function"||(a=a.bind(c),h[l]=a),a},set(h,l,c){return P.value[l]=c,!0}})}else return this._createInstance(t,d,v)}_throwIfStrict(t,d){if(d&&console.warn(d),this._strict)throw new Error(t)}}e.InstantiationService=C;var I;(function(w){w[w.Creation=0]="Creation",w[w.Invocation=1]="Invocation",w[w.Branch=2]="Branch"})(I||(I={}));class E{constructor(t,d){this.type=t,this.name=d,this._start=Date.now(),this._dep=[]}static traceInvocation(t){return g?new E(1,t.name||t.toString().substring(0,42).replace(/\n/g,"")):E._None}static traceCreation(t){return g?new E(0,t.name):E._None}branch(t,d){let p=new E(2,t.toString());return this._dep.push([t,d,p]),p}stop(){let t=Date.now()-this._start;E._totals+=t;let d=!1;function p(P,h){let l=[],c=new Array(P+1).join("	");for(const[a,f,r]of h._dep)if(f&&r){d=!0,l.push(`${c}CREATES -> ${a}`);let i=p(P+1,r);i&&l.push(i)}else l.push(`${c}uses -> ${a}`);return l.join(`
`)}let v=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${E._totals.toFixed(2)}ms)`];(t>2||d)&&console.log(v.join(`
`))}}e.Trace=E,E._None=new class extends E{constructor(){super(-1,null)}stop(){}branch(){return this}},E._totals=0}),define(J[183],Z([0,1,15,135,59]),function(V,e,m,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class D extends L.ResolvedKeybinding{constructor(S,g){super();if(g.length===0)throw(0,m.illegalArgument)("parts");this._os=S,this._parts=g}getLabel(){return n.UILabelProvider.toLabel(this._os,this._parts,S=>this._getLabel(S))}getAriaLabel(){return n.AriaLabelProvider.toLabel(this._os,this._parts,S=>this._getAriaLabel(S))}getElectronAccelerator(){return this._parts.length>1||this._parts[0].isDuplicateModifierCase()?null:n.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,S=>this._getElectronAccelerator(S))}getUserSettingsLabel(){return n.UserSettingsLabelProvider.toLabel(this._os,this._parts,S=>this._getUserSettingsLabel(S))}isWYSIWYG(){return this._parts.every(S=>this._isWYSIWYG(S))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(S=>this._getPart(S))}_getPart(S){return new L.ResolvedKeybindingPart(S.ctrlKey,S.shiftKey,S.altKey,S.metaKey,this._getLabel(S),this._getAriaLabel(S))}getDispatchParts(){return this._parts.map(S=>this._getDispatchPart(S))}getSingleModifierDispatchParts(){return this._parts.map(S=>this._getSingleModifierDispatchPart(S))}}e.BaseResolvedKeybinding=D}),define(J[184],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeElementsAfterNulls=e.ResolvedKeybindingItem=void 0;class m{constructor(D,M,S,g,b,C,I){this._resolvedKeybindingItemBrand=void 0,this.resolvedKeybinding=D,this.keypressParts=D?n(D.getDispatchParts()):[],D&&this.keypressParts.length===0&&(this.keypressParts=n(D.getSingleModifierDispatchParts())),this.bubble=M?M.charCodeAt(0)===94:!1,this.command=this.bubble?M.substr(1):M,this.commandArgs=S,this.when=g,this.isDefault=b,this.extensionId=C,this.isBuiltinExtension=I}}e.ResolvedKeybindingItem=m;function n(L){let D=[];for(let M=0,S=L.length;M<S;M++){const g=L[M];if(!g)return D;D.push(g)}return D}e.removeElementsAfterNulls=n}),define(J[185],Z([0,1,83,59,183,184]),function(V,e,m,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class M extends L.BaseResolvedKeybinding{constructor(g,b){super(b,g.parts)}_keyCodeToUILabel(g){if(this._os===2)switch(g){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return m.KeyCodeUtils.toString(g)}_getLabel(g){return g.isDuplicateModifierCase()?"":this._keyCodeToUILabel(g.keyCode)}_getAriaLabel(g){return g.isDuplicateModifierCase()?"":m.KeyCodeUtils.toString(g.keyCode)}_getElectronAccelerator(g){return m.KeyCodeUtils.toElectronAccelerator(g.keyCode)}_getUserSettingsLabel(g){if(g.isDuplicateModifierCase())return"";const b=m.KeyCodeUtils.toUserSettingsUS(g.keyCode);return b&&b.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(g){return M.getDispatchStr(g)}static getDispatchStr(g){if(g.isModifierKey())return null;let b="";return g.ctrlKey&&(b+="ctrl+"),g.shiftKey&&(b+="shift+"),g.altKey&&(b+="alt+"),g.metaKey&&(b+="meta+"),b+=m.KeyCodeUtils.toString(g.keyCode),b}_getSingleModifierDispatchPart(g){return g.keyCode===5&&!g.shiftKey&&!g.altKey&&!g.metaKey?"ctrl":g.keyCode===4&&!g.ctrlKey&&!g.altKey&&!g.metaKey?"shift":g.keyCode===6&&!g.ctrlKey&&!g.shiftKey&&!g.metaKey?"alt":g.keyCode===57&&!g.ctrlKey&&!g.shiftKey&&!g.altKey?"meta":null}static _scanCodeToKeyCode(g){const b=m.IMMUTABLE_CODE_TO_KEY_CODE[g];if(b!==-1)return b;switch(g){case 10:return 31;case 11:return 32;case 12:return 33;case 13:return 34;case 14:return 35;case 15:return 36;case 16:return 37;case 17:return 38;case 18:return 39;case 19:return 40;case 20:return 41;case 21:return 42;case 22:return 43;case 23:return 44;case 24:return 45;case 25:return 46;case 26:return 47;case 27:return 48;case 28:return 49;case 29:return 50;case 30:return 51;case 31:return 52;case 32:return 53;case 33:return 54;case 34:return 55;case 35:return 56;case 36:return 22;case 37:return 23;case 38:return 24;case 39:return 25;case 40:return 26;case 41:return 27;case 42:return 28;case 43:return 29;case 44:return 30;case 45:return 21;case 51:return 83;case 52:return 81;case 53:return 87;case 54:return 89;case 55:return 88;case 56:return 0;case 57:return 80;case 58:return 90;case 59:return 86;case 60:return 82;case 61:return 84;case 62:return 85;case 106:return 92}return 0}static _resolveSimpleUserBinding(g){if(!g)return null;if(g instanceof n.SimpleKeybinding)return g;const b=this._scanCodeToKeyCode(g.scanCode);return b===0?null:new n.SimpleKeybinding(g.ctrlKey,g.shiftKey,g.altKey,g.metaKey,b)}static resolveUserBinding(g,b){const C=(0,D.removeElementsAfterNulls)(g.map(I=>this._resolveSimpleUserBinding(I)));return C.length>0?[new M(new n.ChordKeybinding(C),b)]:[]}}e.USLayoutResolvedKeybinding=M}),define(J[186],Z([0,1,9]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function n(L,D){if(L.length===0)return Promise.resolve(!1);const M=[];let S=!1;for(let g of L){if(g===!0)return Promise.resolve(!0);(0,m.isThenable)(g)&&M.push(g.then(b=>{b&&(S=!0)},b=>{D(b),S=!0}))}return m.Promises.settled(M).then(()=>S)}e.handleVetos=n}),define(J[6],Z([0,1,39,4,2,3,5]),function(V,e,m,n,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,M.createDecorator)("logService"),e.ILoggerService=(0,M.createDecorator)("loggerService");function S(){return new Date().toISOString()}var g;(function(f){f[f.Trace=0]="Trace",f[f.Debug=1]="Debug",f[f.Info=2]="Info",f[f.Warning=3]="Warning",f[f.Error=4]="Error",f[f.Critical=5]="Critical",f[f.Off=6]="Off"})(g=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=g.Info;function b(f,r,i){switch(r){case g.Trace:f.trace(i);break;case g.Debug:f.debug(i);break;case g.Info:f.info(i);break;case g.Warning:f.warn(i);break;case g.Error:f.error(i);break;case g.Critical:f.critical(i);break;default:throw new Error("Invalid log level")}}e.log=b;function C(f){let r="";for(let i=0;i<f.length;i++){let s=f[i];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}r+=(i>0?" ":"")+s}return r}e.format=C;class I extends L.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new n.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(r){this.level!==r&&(this.level=r,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=I;class E extends I{constructor(r){super();this.logAlways=r}checkLogLevel(r){return this.logAlways||this.getLevel()<=r}trace(r,...i){this.checkLogLevel(g.Trace)&&this.log(g.Trace,C([r,...i]))}debug(r,...i){this.checkLogLevel(g.Debug)&&this.log(g.Debug,C([r,...i]))}info(r,...i){this.checkLogLevel(g.Info)&&this.log(g.Info,C([r,...i]))}warn(r,...i){this.checkLogLevel(g.Warning)&&this.log(g.Warning,C([r,...i]))}error(r,...i){if(this.checkLogLevel(g.Error))if(r instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=r.stack,this.log(g.Error,C(s))}else this.log(g.Error,C([r,...i]))}critical(r,...i){this.checkLogLevel(g.Critical)&&this.log(g.Critical,C([r,...i]))}flush(){}}e.AbstractMessageLogger=E;class w extends I{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r),this.useColors=!D.isWindows}trace(r,...i){this.getLevel()<=g.Trace&&(this.useColors?console.log(`[90m[main ${S()}][0m`,r,...i):console.log(`[main ${S()}]`,r,...i))}debug(r,...i){this.getLevel()<=g.Debug&&(this.useColors?console.log(`[90m[main ${S()}][0m`,r,...i):console.log(`[main ${S()}]`,r,...i))}info(r,...i){this.getLevel()<=g.Info&&(this.useColors?console.log(`[90m[main ${S()}][0m`,r,...i):console.log(`[main ${S()}]`,r,...i))}warn(r,...i){this.getLevel()<=g.Warning&&(this.useColors?console.warn(`[93m[main ${S()}][0m`,r,...i):console.warn(`[main ${S()}]`,r,...i))}error(r,...i){this.getLevel()<=g.Error&&(this.useColors?console.error(`[91m[main ${S()}][0m`,r,...i):console.error(`[main ${S()}]`,r,...i))}critical(r,...i){this.getLevel()<=g.Critical&&(this.useColors?console.error(`[90m[main ${S()}][0m`,r,...i):console.error(`[main ${S()}]`,r,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=w;class t extends I{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r)}trace(r,...i){this.getLevel()<=g.Trace&&console.log("%cTRACE","color: #888",r,...i)}debug(r,...i){this.getLevel()<=g.Debug&&console.log("%cDEBUG","background: #eee; color: #888",r,...i)}info(r,...i){this.getLevel()<=g.Info&&console.log("%c INFO","color: #33f",r,...i)}warn(r,...i){this.getLevel()<=g.Warning&&console.log("%c WARN","color: #993",r,...i)}error(r,...i){this.getLevel()<=g.Error&&console.log("%c  ERR","color: #f33",r,...i)}critical(r,...i){this.getLevel()<=g.Critical&&console.log("%cCRITI","background: #f33; color: white",r,...i)}dispose(){}flush(){}}e.ConsoleLogger=t;class d extends I{constructor(r,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=r,this.setLevel(i)}trace(r,...i){this.getLevel()<=g.Trace&&this.adapter.log(g.Trace,[this.extractMessage(r),...i])}debug(r,...i){this.getLevel()<=g.Debug&&this.adapter.log(g.Debug,[this.extractMessage(r),...i])}info(r,...i){this.getLevel()<=g.Info&&this.adapter.log(g.Info,[this.extractMessage(r),...i])}warn(r,...i){this.getLevel()<=g.Warning&&this.adapter.log(g.Warning,[this.extractMessage(r),...i])}error(r,...i){this.getLevel()<=g.Error&&this.adapter.log(g.Error,[this.extractMessage(r),...i])}critical(r,...i){this.getLevel()<=g.Critical&&this.adapter.log(g.Critical,[this.extractMessage(r),...i])}extractMessage(r){return typeof r=="string"?r:(0,m.toErrorMessage)(r,this.getLevel()<=g.Trace)}dispose(){}flush(){}}e.AdapterLogger=d;class p extends I{constructor(r){super();this.logServices=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const i of this.logServices)i.setLevel(r);super.setLevel(r)}trace(r,...i){for(const s of this.logServices)s.trace(r,...i)}debug(r,...i){for(const s of this.logServices)s.debug(r,...i)}info(r,...i){for(const s of this.logServices)s.info(r,...i)}warn(r,...i){for(const s of this.logServices)s.warn(r,...i)}error(r,...i){for(const s of this.logServices)s.error(r,...i)}critical(r,...i){for(const s of this.logServices)s.critical(r,...i)}flush(){for(const r of this.logServices)r.flush()}dispose(){for(const r of this.logServices)r.dispose()}}e.MultiplexLogService=p;class v extends L.Disposable{constructor(r){super();this.logger=r,this._register(r)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(r){this.logger.setLevel(r)}getLevel(){return this.logger.getLevel()}trace(r,...i){this.logger.trace(r,...i)}debug(r,...i){this.logger.debug(r,...i)}info(r,...i){this.logger.info(r,...i)}warn(r,...i){this.logger.warn(r,...i)}error(r,...i){this.logger.error(r,...i)}critical(r,...i){this.logger.critical(r,...i)}flush(){this.logger.flush()}}e.LogService=v;class P extends L.Disposable{constructor(r,i){super();this.logLevel=r,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(s))}))}getLogger(r){return this.loggers.get(r.toString())}createLogger(r,i){let s=this.loggers.get(r.toString());return s||(s=this.doCreateLogger(r,i?.always?g.Trace:this.logLevel,i),this.loggers.set(r.toString(),s),i?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(r=>r.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=P;class h{constructor(){this.onDidChangeLogLevel=new n.Emitter().event}setLevel(r){}getLevel(){return g.Info}trace(r,...i){}debug(r,...i){}info(r,...i){}warn(r,...i){}error(r,...i){}critical(r,...i){}dispose(){}flush(){}}e.NullLogService=h;function l(f){if(f.verbose)return g.Trace;if(typeof f.logLevel=="string"){const r=c(f.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=l;function c(f){switch(f){case"trace":return g.Trace;case"debug":return g.Debug;case"info":return g.Info;case"warn":return g.Warning;case"error":return g.Error;case"critical":return g.Critical;case"off":return g.Off}}e.parseLogLevel=c;function a(f){switch(f){case g.Trace:return"trace";case g.Debug:return"debug";case g.Info:return"info";case g.Warning:return"warn";case g.Error:return"error";case g.Critical:return"critical";case g.Off:return"off"}}e.LogLevelToString=a}),define(J[187],Z([0,1,30,9,15,4,2,7,62,6]),function(V,e,m,n,L,D,M,S,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class C extends M.Disposable{constructor(E,w){super();this.logService=E,this.options=w,this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new D.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new n.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new n.ThrottledDelayer(0))}watch(E,w){return w.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(E,w):this.watchNonRecursive(E,w)}watchUniversal(E,w){const t={path:this.toFilePath(E),excludes:w.excludes,recursive:w.recursive},d=(0,m.insert)(this.universalPathsToWatch,t);return this.refreshUniversalWatchers(),(0,M.toDisposable)(()=>{d(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(E=>(0,L.onUnexpectedError)(E))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(w=>this._onDidChangeFile.fire((0,g.toFileChanges)(w)),w=>this.onWatcherLogMessage(w),this.logService.getLevel()===b.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)})));const E=this.options?.watcher?.recursive?.usePolling;if(E===!0)for(const w of this.universalPathsToWatch)(0,g.isRecursiveWatchRequest)(w)&&(w.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(E))for(const w of this.universalPathsToWatch)(0,g.isRecursiveWatchRequest)(w)&&E.includes(w.path)&&(w.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(E,w){const t={path:this.toFilePath(E),excludes:w.excludes,recursive:!1},d=(0,m.insert)(this.nonRecursivePathsToWatch,t);return this.refreshNonRecursiveWatchers(),(0,M.toDisposable)(()=>{d(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(E=>(0,L.onUnexpectedError)(E))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(E=>this._onDidChangeFile.fire((0,g.toFileChanges)(E)),E=>this.onWatcherLogMessage(E),this.logService.getLevel()===b.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(E){E.type==="error"&&this._onDidWatchError.fire(E.message),this.logService[E.type](E.message)}toFilePath(E){return(0,S.normalize)(E.fsPath)}}e.AbstractDiskFileSystemProvider=C});var te=this&&this.__param||function(V,e){return function(m,n){e(m,n,V)}};define(J[188],Z([0,1,30,9,16,23,4,69,68,2,35,10,63,17,48,145,20,94,6]),function(V,e,m,n,L,D,M,S,g,b,C,I,E,w,t,d,p,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let h=class extends b.Disposable{constructor(c){super();this.logService=c,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new M.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new M.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new M.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new M.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new M.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new M.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new n.ResourceQueue)}registerProvider(c,a){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,E.mark)(`code/registerFilesystem/${c}`);const f=new b.DisposableStore;return this.provider.set(c,a),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:a}),f.add(a.onDidChangeFile(r=>this._onDidFilesChange.fire(new p.FileChangesEvent(r,!this.isPathCaseSensitive(a))))),typeof a.onDidWatchError=="function"&&f.add(a.onDidWatchError(r=>this._onDidWatchError.fire(new Error(r)))),f.add(a.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:a,scheme:c}))),(0,b.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:a}),this.provider.delete(c),(0,b.dispose)(f)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const a=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(f){a.push(f)}}),!this.provider.has(c)&&await n.Promises.settled(a)}async canHandleResource(c){return await this.activateProvider(c.scheme),this.hasProvider(c)}hasProvider(c){return this.provider.has(c.scheme)}hasCapability(c,a){const f=this.provider.get(c.scheme);return!!(f&&f.capabilities&a)}listCapabilities(){return g.Iterable.map(this.provider,([c,a])=>({scheme:c,capabilities:a.capabilities}))}async withProvider(c){if(!(0,w.isAbsolutePath)(c))throw new p.FileOperationError((0,d.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const a=this.provider.get(c.scheme);if(!a){const f=new Error;throw f.name="ENOPRO",f.message=(0,d.localize)(1,null,c.toString()),f}return a}async withReadProvider(c){const a=await this.withProvider(c);if((0,p.hasOpenReadWriteCloseCapability)(a)||(0,p.hasReadWriteCapability)(a)||(0,p.hasFileReadStreamCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(c){const a=await this.withProvider(c);if((0,p.hasOpenReadWriteCloseCapability)(a)||(0,p.hasReadWriteCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,a){try{return await this.doResolveFile(c,a)}catch(f){throw(0,p.toFileSystemProviderErrorCode)(f)===p.FileSystemProviderErrorCode.FileNotFound?new p.FileOperationError((0,d.localize)(2,null,this.resourceForError(c)),1):(0,p.ensureFileSystemProviderError)(f)}}async doResolveFile(c,a){const f=await this.withProvider(c),r=this.isPathCaseSensitive(f),i=a?.resolveTo,s=a?.resolveSingleChildDescendants,o=a?.resolveMetadata,u=await f.stat(c);let y;return this.toFileStat(f,c,u,void 0,!!o,(k,R)=>(y||(y=C.TernarySearchTree.forUris(()=>!r),y.set(c,!0),i&&y.fill(!0,i)),y.get(k.resource)||y.findSuperstr(k.resource.with({query:null,fragment:null}))?!0:k.isDirectory&&s?R===1:!1))}async toFileStat(c,a,f,r,i,s){const{providerExtUri:o}=this.getExtUri(c),u={resource:a,name:o.basename(a),isFile:(f.type&p.FileType.File)!=0,isDirectory:(f.type&p.FileType.Directory)!=0,isSymbolicLink:(f.type&p.FileType.SymbolicLink)!=0,mtime:f.mtime,ctime:f.ctime,size:f.size,readonly:Boolean((f.permissions??0)&p.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,p.etag)({mtime:f.mtime,size:f.size}),children:void 0};if(u.isDirectory&&s(u,r)){try{const y=await c.readdir(a),k=await n.Promises.settled(y.map(async([R,W])=>{try{const U=o.joinPath(a,R),K=i?await c.stat(U):{type:W};return await this.toFileStat(c,U,K,y.length,i,s)}catch(U){return this.logService.trace(U),null}}));u.children=(0,m.coalesce)(k)}catch(y){this.logService.trace(y),u.children=[]}return u}return u}async resolveAll(c){return n.Promises.settled(c.map(async a=>{try{return{stat:await this.doResolveFile(a.resource,a.options),success:!0}}catch(f){return this.logService.trace(f),{stat:void 0,success:!1}}}))}async stat(c){const a=await this.withProvider(c),f=await a.stat(c);return this.toFileStat(a,c,f,void 0,!0,()=>!1)}async exists(c){const a=await this.withProvider(c);try{return!!await a.stat(c)}catch{return!1}}async canCreateFile(c,a){try{await this.doValidateCreateFile(c,a)}catch(f){return f}return!0}async doValidateCreateFile(c,a){if(!a?.overwrite&&await this.exists(c))throw new p.FileOperationError((0,d.localize)(3,null,this.resourceForError(c)),3,a)}async createFile(c,a=L.VSBuffer.fromString(""),f){await this.doValidateCreateFile(c,f);const r=await this.writeFile(c,a);return this._onDidRunOperation.fire(new p.FileOperationEvent(c,0,r)),r}async writeFile(c,a,f){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:i}=this.getExtUri(r);try{await this.validateWriteFile(r,c,f)||await this.mkdirp(r,i.dirname(c));let o;if((0,p.hasReadWriteCapability)(r)&&!(a instanceof L.VSBuffer))if((0,t.isReadableStream)(a)){const u=await(0,t.peekStream)(a,3);u.ended?o=L.VSBuffer.concat(u.buffer):o=u}else o=(0,t.peekReadable)(a,u=>L.VSBuffer.concat(u),3);else o=a;!(0,p.hasOpenReadWriteCloseCapability)(r)||(0,p.hasReadWriteCapability)(r)&&o instanceof L.VSBuffer?await this.doWriteUnbuffered(r,c,f,o):await this.doWriteBuffered(r,c,f,o instanceof L.VSBuffer?(0,L.bufferToReadable)(o):o),this._onDidRunOperation.fire(new p.FileOperationEvent(c,4))}catch(s){throw new p.FileOperationError((0,d.localize)(4,null,this.resourceForError(c),(0,p.ensureFileSystemProviderError)(s).toString()),(0,p.toFileOperationResult)(s),f)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,a,f){if(!!f?.unlock&&!(c.capabilities&8192))throw new Error((0,d.localize)(5,null,this.resourceForError(a)));let i;try{i=await c.stat(a)}catch{return}if((i.type&p.FileType.Directory)!=0)throw new p.FileOperationError((0,d.localize)(6,null,this.resourceForError(a)),0,f);if(this.throwIfFileIsReadonly(a,i),typeof f?.mtime=="number"&&typeof f.etag=="string"&&f.etag!==p.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&f.mtime<i.mtime&&f.etag!==(0,p.etag)({mtime:f.mtime,size:i.size}))throw new p.FileOperationError((0,d.localize)(7,null),3,f);return i}async readFile(c,a,f){const r=await this.withReadProvider(c);return a?.atomic?this.doReadFileAtomic(r,c,a,f):this.doReadFile(r,c,a,f)}async doReadFileAtomic(c,a,f,r){return new Promise((i,s)=>{this.writeQueue.queueFor(a,this.getExtUri(c).providerExtUri).queue(async()=>{try{const o=await this.doReadFile(c,a,f,r);i(o)}catch(o){s(o)}})})}async doReadFile(c,a,f,r){const i=await this.doReadFileStream(c,a,{...f,preferUnbuffered:!0},r);return{...i,value:await(0,L.streamToBuffer)(i.value)}}async readFileStream(c,a,f){const r=await this.withReadProvider(c);return this.doReadFileStream(r,c,a,f)}async doReadFileStream(c,a,f,r){const i=new D.CancellationTokenSource(r),s=this.validateReadFile(a,f).then(u=>u,u=>{throw i.cancel(),u});let o;try{return typeof f?.etag=="string"&&f.etag!==p.ETAG_DISABLED&&await s,f?.atomic&&(0,p.hasFileAtomicReadCapability)(c)||!((0,p.hasOpenReadWriteCloseCapability)(c)||(0,p.hasFileReadStreamCapability)(c))||(0,p.hasReadWriteCapability)(c)&&f?.preferUnbuffered?o=this.readFileUnbuffered(c,a,f):(0,p.hasFileReadStreamCapability)(c)?o=this.readFileStreamed(c,a,i.token,f):o=this.readFileBuffered(c,a,i.token,f),{...await s,value:o}}catch(u){o&&await(0,t.consumeStream)(o);const y=(0,d.localize)(8,null,this.resourceForError(a),(0,p.ensureFileSystemProviderError)(u).toString());throw u instanceof p.NotModifiedSinceFileOperationError?new p.NotModifiedSinceFileOperationError(y,u.stat,f):new p.FileOperationError(y,(0,p.toFileOperationResult)(u),f)}}readFileStreamed(c,a,f,r=Object.create(null)){const i=c.readFileStream(a,r,f);return(0,t.transform)(i,{data:s=>s instanceof L.VSBuffer?s:L.VSBuffer.wrap(s),error:s=>new p.FileOperationError((0,d.localize)(9,null,this.resourceForError(a),(0,p.ensureFileSystemProviderError)(s).toString()),(0,p.toFileOperationResult)(s),r)},s=>L.VSBuffer.concat(s))}readFileBuffered(c,a,f,r=Object.create(null)){const i=(0,L.newWriteableBufferStream)();return(0,v.readFileIntoStream)(c,a,i,s=>s,{...r,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new p.FileOperationError((0,d.localize)(10,null,this.resourceForError(a),(0,p.ensureFileSystemProviderError)(s).toString()),(0,p.toFileOperationResult)(s),r)},f),i}readFileUnbuffered(c,a,f){const r=(0,t.newWriteableStream)(i=>L.VSBuffer.concat(i));return(async()=>{try{let i;f?.atomic&&(0,p.hasFileAtomicReadCapability)(c)?i=await c.readFile(a,{atomic:!0}):i=await c.readFile(a),typeof f?.position=="number"&&(i=i.slice(f.position)),typeof f?.length=="number"&&(i=i.slice(0,f.length)),this.validateReadFileLimits(a,i.byteLength,f),r.end(L.VSBuffer.wrap(i))}catch(i){r.error(i),r.end()}})(),r}async validateReadFile(c,a){const f=await this.resolve(c,{resolveMetadata:!0});if(f.isDirectory)throw new p.FileOperationError((0,d.localize)(11,null,this.resourceForError(c)),0,a);if(typeof a?.etag=="string"&&a.etag!==p.ETAG_DISABLED&&a.etag===f.etag)throw new p.NotModifiedSinceFileOperationError((0,d.localize)(12,null),f,a);return this.validateReadFileLimits(c,f.size,a),f}validateReadFileLimits(c,a,f){if(f?.limits){let r;if(typeof f.limits.memory=="number"&&a>f.limits.memory&&(r=9),typeof f.limits.size=="number"&&a>f.limits.size&&(r=7),typeof r=="number")throw new p.FileOperationError((0,d.localize)(13,null,this.resourceForError(c)),r)}}async canMove(c,a,f){return this.doCanMoveCopy(c,a,"move",f)}async canCopy(c,a,f){return this.doCanMoveCopy(c,a,"copy",f)}async doCanMoveCopy(c,a,f,r){if(c.toString()!==a.toString())try{const i=f==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a);await this.doValidateMoveCopy(i,c,s,a,f,r)}catch(i){return i}return!0}async move(c,a,f){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),s=await this.doMoveCopy(r,c,i,a,"move",!!f),o=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new p.FileOperationEvent(c,s==="move"?2:3,o)),o}async copy(c,a,f){const r=await this.withReadProvider(c),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),s=await this.doMoveCopy(r,c,i,a,"copy",!!f),o=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new p.FileOperationEvent(c,s==="copy"?3:2,o)),o}async doMoveCopy(c,a,f,r,i,s){if(a.toString()===r.toString())return i;const{exists:o,isSameResourceWithDifferentPathCase:u}=await this.doValidateMoveCopy(c,a,f,r,i,s);if(o&&!u&&s&&await this.del(r,{recursive:!0}),await this.mkdirp(f,this.getExtUri(f).providerExtUri.dirname(r)),i==="copy"){if(c===f&&(0,p.hasFileFolderCopyCapability)(c))await c.copy(a,r,{overwrite:s});else{const y=await this.resolve(a);y.isDirectory?await this.doCopyFolder(c,y,f,r):await this.doCopyFile(c,a,f,r)}return i}else return c===f?(await c.rename(a,r,{overwrite:s}),i):(await this.doMoveCopy(c,a,f,r,"copy",s),await this.del(a,{recursive:!0}),"copy")}async doCopyFile(c,a,f,r){if((0,p.hasOpenReadWriteCloseCapability)(c)&&(0,p.hasOpenReadWriteCloseCapability)(f))return this.doPipeBuffered(c,a,f,r);if((0,p.hasOpenReadWriteCloseCapability)(c)&&(0,p.hasReadWriteCapability)(f))return this.doPipeBufferedToUnbuffered(c,a,f,r);if((0,p.hasReadWriteCapability)(c)&&(0,p.hasOpenReadWriteCloseCapability)(f))return this.doPipeUnbufferedToBuffered(c,a,f,r);if((0,p.hasReadWriteCapability)(c)&&(0,p.hasReadWriteCapability)(f))return this.doPipeUnbuffered(c,a,f,r)}async doCopyFolder(c,a,f,r){await f.mkdir(r),Array.isArray(a.children)&&await n.Promises.settled(a.children.map(async i=>{const s=this.getExtUri(f).providerExtUri.joinPath(r,i.name);return i.isDirectory?this.doCopyFolder(c,await this.resolve(i.resource),f,s):this.doCopyFile(c,i.resource,f,s)}))}async doValidateMoveCopy(c,a,f,r,i,s){let o=!1;if(c===f){const{providerExtUri:y,isPathCaseSensitive:k}=this.getExtUri(c);if(k||(o=y.isEqual(a,r)),o&&i==="copy")throw new Error((0,d.localize)(14,null,this.resourceForError(a),this.resourceForError(r)));if(!o&&y.isEqualOrParent(r,a))throw new Error((0,d.localize)(15,null,this.resourceForError(a),this.resourceForError(r)))}const u=await this.exists(r);if(u&&!o){if(!s)throw new p.FileOperationError((0,d.localize)(16,null,this.resourceForError(a),this.resourceForError(r)),4);if(c===f){const{providerExtUri:y}=this.getExtUri(c);if(y.isEqualOrParent(a,r))throw new Error((0,d.localize)(17,null,this.resourceForError(a),this.resourceForError(r)))}}return{exists:u,isSameResourceWithDifferentPathCase:o}}getExtUri(c){const a=this.isPathCaseSensitive(c);return{providerExtUri:a?w.extUri:w.extUriIgnorePathCase,isPathCaseSensitive:a}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(a,c);const f=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new p.FileOperationEvent(c,0,f)),f}async mkdirp(c,a){const f=[],{providerExtUri:r}=this.getExtUri(c);for(;!r.isEqual(a,r.dirname(a));)try{if(((await c.stat(a)).type&p.FileType.Directory)==0)throw new Error((0,d.localize)(18,null,this.resourceForError(a)));break}catch(i){if((0,p.toFileSystemProviderErrorCode)(i)!==p.FileSystemProviderErrorCode.FileNotFound)throw i;f.push(r.basename(a)),a=r.dirname(a)}for(let i=f.length-1;i>=0;i--){a=r.joinPath(a,f[i]);try{await c.mkdir(a)}catch(s){if((0,p.toFileSystemProviderErrorCode)(s)!==p.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(c,a){try{await this.doValidateDelete(c,a)}catch(f){return f}return!0}async doValidateDelete(c,a){const f=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!a?.useTrash&&!(f.capabilities&4096))throw new Error((0,d.localize)(19,null,this.resourceForError(c)));let i;try{i=await f.stat(c)}catch{}if(i)this.throwIfFileIsReadonly(c,i);else throw new p.FileOperationError((0,d.localize)(20,null,this.resourceForError(c)),1);if(!!!a?.recursive){const o=await this.resolve(c);if(o.isDirectory&&Array.isArray(o.children)&&o.children.length>0)throw new Error((0,d.localize)(21,null,this.resourceForError(c)))}return f}async del(c,a){const f=await this.doValidateDelete(c,a),r=!!a?.useTrash,i=!!a?.recursive;await f.delete(c,{recursive:i,useTrash:r}),this._onDidRunOperation.fire(new p.FileOperationEvent(c,1))}watch(c,a={recursive:!1,excludes:[]}){const f=new b.DisposableStore;let r=!1,i=()=>{r=!0};return f.add((0,b.toDisposable)(()=>i())),(async()=>{try{const s=await this.doWatch(c,a);r?(0,b.dispose)(s):i=()=>(0,b.dispose)(s)}catch(s){this.logService.error(s)}})(),f}async doWatch(c,a){const f=await this.withProvider(c),r=(0,S.hash)([this.getExtUri(f).providerExtUri.getComparisonKey(c),a]);let i=this.activeWatchers.get(r);return i||(i={count:0,disposable:f.watch(c,a)},this.activeWatchers.set(r,i)),i.count+=1,(0,b.toDisposable)(()=>{i&&(i.count--,i.count===0&&((0,b.dispose)(i.disposable),this.activeWatchers.delete(r)))})}dispose(){super.dispose();for(const[,c]of this.activeWatchers)(0,b.dispose)(c.disposable);this.activeWatchers.clear()}async doWriteBuffered(c,a,f,r){return this.writeQueue.queueFor(a,this.getExtUri(c).providerExtUri).queue(async()=>{const i=await c.open(a,{create:!0,unlock:f?.unlock??!1});try{(0,t.isReadableStream)(r)||(0,t.isReadableBufferedStream)(r)?await this.doWriteStreamBufferedQueued(c,i,r):await this.doWriteReadableBufferedQueued(c,i,r)}catch(s){throw(0,p.ensureFileSystemProviderError)(s)}finally{await c.close(i)}})}async doWriteStreamBufferedQueued(c,a,f){let r=0,i;if((0,t.isReadableBufferedStream)(f)){if(f.buffer.length>0){const s=L.VSBuffer.concat(f.buffer);await this.doWriteBuffer(c,a,s,s.byteLength,r,0),r+=s.byteLength}if(f.ended)return;i=f.stream}else i=f;return new Promise((s,o)=>{(0,t.listenStream)(i,{onData:async u=>{i.pause();try{await this.doWriteBuffer(c,a,u,u.byteLength,r,0)}catch(y){return o(y)}r+=u.byteLength,setTimeout(()=>i.resume())},onError:u=>o(u),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(c,a,f){let r=0,i;for(;(i=f.read())!==null;)await this.doWriteBuffer(c,a,i,i.byteLength,r,0),r+=i.byteLength}async doWriteBuffer(c,a,f,r,i,s){let o=0;for(;o<r;)o+=await c.write(a,i+o,f.buffer,s+o,r-o)}async doWriteUnbuffered(c,a,f,r){return this.writeQueue.queueFor(a,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,a,f,r))}async doWriteUnbufferedQueued(c,a,f,r){let i;r instanceof L.VSBuffer?i=r:(0,t.isReadableStream)(r)?i=await(0,L.streamToBuffer)(r):(0,t.isReadableBufferedStream)(r)?i=await(0,L.bufferedStreamToBuffer)(r):i=(0,L.readableToBuffer)(r),await c.writeFile(a,i.buffer,{create:!0,overwrite:!0,unlock:f?.unlock??!1})}async doPipeBuffered(c,a,f,r){return this.writeQueue.queueFor(r,this.getExtUri(f).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,a,f,r))}async doPipeBufferedQueued(c,a,f,r){let i,s;try{i=await c.open(a,{create:!1}),s=await f.open(r,{create:!0,unlock:!1});const o=L.VSBuffer.alloc(this.BUFFER_SIZE);let u=0,y=0,k=0;do k=await c.read(i,u,o.buffer,y,o.byteLength-y),await this.doWriteBuffer(f,s,o,k,u,y),u+=k,y+=k,y===o.byteLength&&(y=0);while(k>0)}catch(o){throw(0,p.ensureFileSystemProviderError)(o)}finally{await n.Promises.settled([typeof i=="number"?c.close(i):Promise.resolve(),typeof s=="number"?f.close(s):Promise.resolve()])}}async doPipeUnbuffered(c,a,f,r){return this.writeQueue.queueFor(r,this.getExtUri(f).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,a,f,r))}async doPipeUnbufferedQueued(c,a,f,r){return f.writeFile(r,await c.readFile(a),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,a,f,r){return this.writeQueue.queueFor(r,this.getExtUri(f).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,a,f,r))}async doPipeUnbufferedToBufferedQueued(c,a,f,r){const i=await f.open(r,{create:!0,unlock:!1});try{const s=await c.readFile(a);await this.doWriteBuffer(f,i,L.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,p.ensureFileSystemProviderError)(s)}finally{await f.close(i)}}async doPipeBufferedToUnbuffered(c,a,f,r){const i=await(0,L.streamToBuffer)(this.readFileBuffered(c,a,D.CancellationToken.None));await this.doWriteUnbuffered(f,r,void 0,i)}throwIfFileSystemIsReadonly(c,a){if(c.capabilities&2048)throw new p.FileOperationError((0,d.localize)(22,null,this.resourceForError(a)),6);return c}throwIfFileIsReadonly(c,a){if((a.permissions??0)&p.FilePermission.Readonly)throw new p.FileOperationError((0,d.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===I.Schemas.file?c.fsPath:c.toString(!0)}};h=ue([te(0,P.ILogService)],h),e.FileService=h}),define(J[77],Z([0,1,29,253,9,35,16,4,28,2,7,3,17,48,24,149,20,94,187,39,181,180]),function(V,e,m,n,L,D,M,S,g,b,C,I,E,w,t,d,p,v,P,h,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,n.gracefulify)(m)}catch(f){console.error(`Error enabling graceful-fs: ${(0,h.toErrorMessage)(f)}`)}})();class a extends P.AbstractDiskFileSystemProvider{constructor(r,i){super(r,i);this.onDidChangeCapabilities=S.Event.None,this.resourceLocks=new D.ResourceMap(s=>E.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,I.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:i,symbolicLink:s}=await t.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(i,s),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.toFileSystemProviderError(i)}}async readdir(r){try{const i=await t.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),s=[];return await Promise.all(i.map(async o=>{try{let u;o.isSymbolicLink()?u=(await this.stat((0,E.joinPath)(r,o.name))).type:u=this.toType(o),s.push([o.name,u])}catch(u){this.logService.trace(u)}})),s}catch(i){throw this.toFileSystemProviderError(i)}}toType(r,i){let s;return i?.dangling?s=p.FileType.Unknown:r.isFile()?s=p.FileType.File:r.isDirectory()?s=p.FileType.Directory:s=p.FileType.Unknown,i&&(s|=p.FileType.SymbolicLink),s}async createResourceLock(r){const i=this.toFilePath(r);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let s;for(;s=this.resourceLocks.get(r);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await s.wait();const o=new L.Barrier;return this.resourceLocks.set(r,o),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,b.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.resourceLocks.get(r)===o&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.resourceLocks.delete(r)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),o.open()})}async readFile(r,i){let s;try{i?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(r)})`),s=await this.createResourceLock(r));const o=this.toFilePath(r);return await t.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}finally{s?.dispose()}}readFileStream(r,i,s){const o=(0,w.newWriteableStream)(u=>M.VSBuffer.concat(u.map(y=>M.VSBuffer.wrap(y))).buffer);return(0,v.readFileIntoStream)(this,r,o,u=>u.buffer,{...i,bufferSize:256*1024},s),o}async writeFile(r,i,s){let o;try{const u=this.toFilePath(r);if(!s.create||!s.overwrite){if(await t.Promises.exists(u)){if(!s.overwrite)throw(0,p.createFileSystemProviderError)((0,d.localize)(0,null),p.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,p.createFileSystemProviderError)((0,d.localize)(1,null),p.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(r,{create:!0,unlock:s.unlock}),await this.write(o,0,i,0,i.byteLength)}catch(u){throw await this.toFileSystemProviderWriteError(r,u)}finally{typeof o=="number"&&await this.close(o)}}async open(r,i){const s=this.toFilePath(r);let o;(0,p.isFileOpenForWriteOptions)(i)&&(o=await this.createResourceLock(r));let u;try{if((0,p.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:k}=await t.SymlinkSupport.stat(s);k.mode&128||await t.Promises.chmod(s,k.mode|128)}catch(k){this.logService.trace(k)}let y;if((0,p.isFileOpenForWriteOptions)(i)){if(I.isWindows)try{await t.Promises.truncate(s,0),y="r+"}catch(k){k.code!=="ENOENT"&&this.logService.trace(k)}y||(y="w")}else y="r";u=await t.Promises.open(s,y)}catch(y){throw o?.dispose(),(0,p.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(r,y):this.toFileSystemProviderError(y)}if(this.mapHandleToPos.set(u,0),(0,p.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(u,r),o){const y=this.mapHandleToLock.get(u);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${u} (${s})`),this.mapHandleToLock.set(u,o),y&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${u} (${s})`),y.dispose())}return u}async close(r){const i=this.mapHandleToLock.get(r);try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&this.canFlush)try{await t.Promises.fdatasync(r)}catch(s){this.canFlush=!1,this.logService.error(s)}return await t.Promises.close(r)}catch(s){throw this.toFileSystemProviderError(s)}finally{i&&(this.mapHandleToLock.get(r)===i&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.mapHandleToLock.delete(r)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),i.dispose())}}async read(r,i,s,o,u){const y=this.normalizePos(r,i);let k=null;try{k=(await t.Promises.read(r,s,o,u,y)).bytesRead}catch(R){throw this.toFileSystemProviderError(R)}finally{this.updatePos(r,y,k)}return k}normalizePos(r,i){return i===this.mapHandleToPos.get(r)?null:i}updatePos(r,i,s){const o=this.mapHandleToPos.get(r);typeof o=="number"&&(typeof i=="number"||(typeof s=="number"?this.mapHandleToPos.set(r,o+s):this.mapHandleToPos.delete(r)))}async write(r,i,s,o,u){return(0,L.retry)(()=>this.doWrite(r,i,s,o,u),100,3)}async doWrite(r,i,s,o,u){const y=this.normalizePos(r,i);let k=null;try{k=(await t.Promises.write(r,s,o,u,y)).bytesWritten}catch(R){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),R)}finally{this.updatePos(r,y,k)}return k}async mkdir(r){try{await t.Promises.mkdir(this.toFilePath(r))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(r,i){try{const s=this.toFilePath(r);i.recursive?await t.Promises.rm(s,t.RimRafMode.MOVE):await t.Promises.unlink(s)}catch(s){throw this.toFileSystemProviderError(s)}}async rename(r,i,s){const o=this.toFilePath(r),u=this.toFilePath(i);if(o!==u)try{await this.validateTargetDeleted(r,i,"move",s.overwrite),await t.Promises.move(o,u)}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,d.localize)(2,null,(0,C.basename)(o),(0,C.basename)((0,C.dirname)(u)),y.toString()))),this.toFileSystemProviderError(y)}}async copy(r,i,s){const o=this.toFilePath(r),u=this.toFilePath(i);if(o!==u)try{await this.validateTargetDeleted(r,i,"copy",s.overwrite),await t.Promises.copy(o,u,{preserveSymlinks:!0})}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,d.localize)(3,null,(0,C.basename)(o),(0,C.basename)((0,C.dirname)(u)),y.toString()))),this.toFileSystemProviderError(y)}}async validateTargetDeleted(r,i,s,o){const u=this.toFilePath(r),y=this.toFilePath(i);let k=!1;if(!!(this.capabilities&1024)||(k=(0,g.isEqual)(u,y,!0)),k&&s==="copy")throw(0,p.createFileSystemProviderError)((0,d.localize)(4,null),p.FileSystemProviderErrorCode.FileExists);if(!k&&await t.Promises.exists(y)){if(!o)throw(0,p.createFileSystemProviderError)((0,d.localize)(5,null),p.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}createUniversalWatcher(r,i,s){return new l.UniversalWatcherClient(o=>r(o),o=>i(o),s)}createNonRecursiveWatcher(r,i,s){return new c.NodeJSWatcherClient(o=>r(o),o=>i(o),s)}toFileSystemProviderError(r){if(r instanceof p.FileSystemProviderError)return r;let i;switch(r.code){case"ENOENT":i=p.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=p.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=p.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=p.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=p.FileSystemProviderErrorCode.NoPermissions;break;default:i=p.FileSystemProviderErrorCode.Unknown}return(0,p.createFileSystemProviderError)(r,i)}async toFileSystemProviderWriteError(r,i){let s=this.toFileSystemProviderError(i);if(r&&s.code===p.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await t.SymlinkSupport.stat(this.toFilePath(r));o.mode&128||(s=(0,p.createFileSystemProviderError)(i,p.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.logService.trace(o)}return s}}e.DiskFileSystemProvider=a}),define(J[189],Z([0,1,4,77,2,16,48,23]),function(V,e,m,n,L,D,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class g extends L.Disposable{constructor(I,E){super();this.provider=I,this.logService=E,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(I,E,w){const t=this.getUriTransformer(I);switch(E){case"stat":return this.stat(t,w[0]);case"readdir":return this.readdir(t,w[0]);case"open":return this.open(t,w[0],w[1]);case"close":return this.close(w[0]);case"read":return this.read(w[0],w[1],w[2]);case"readFile":return this.readFile(t,w[0],w[1]);case"write":return this.write(w[0],w[1],w[2],w[3],w[4]);case"writeFile":return this.writeFile(t,w[0],w[1],w[2]);case"rename":return this.rename(t,w[0],w[1],w[2]);case"copy":return this.copy(t,w[0],w[1],w[2]);case"mkdir":return this.mkdir(t,w[0]);case"delete":return this.delete(t,w[0],w[1]);case"watch":return this.watch(t,w[0],w[1],w[2],w[3]);case"unwatch":return this.unwatch(w[0],w[1])}throw new Error(`IPC Command ${E} not found`)}listen(I,E,w){const t=this.getUriTransformer(I);switch(E){case"fileChange":return this.onFileChange(t,w[0]);case"readFileStream":return this.onReadFileStream(t,w[0],w[1])}throw new Error(`Unknown event ${E}`)}stat(I,E){const w=this.transformIncoming(I,E,!0);return this.provider.stat(w)}readdir(I,E){const w=this.transformIncoming(I,E);return this.provider.readdir(w)}async readFile(I,E,w){const t=this.transformIncoming(I,E,!0),d=await this.provider.readFile(t,w);return D.VSBuffer.wrap(d)}onReadFileStream(I,E,w){const t=this.transformIncoming(I,E,!0),d=new S.CancellationTokenSource,p=new m.Emitter({onLastListenerRemove:()=>{d.cancel()}}),v=this.provider.readFileStream(t,w,d.token);return(0,M.listenStream)(v,{onData:P=>p.fire(D.VSBuffer.wrap(P)),onError:P=>p.fire(P),onEnd:()=>{p.fire("end"),p.dispose(),d.dispose()}}),p.event}writeFile(I,E,w,t){const d=this.transformIncoming(I,E);return this.provider.writeFile(d,w.buffer,t)}open(I,E,w){const t=this.transformIncoming(I,E,!0);return this.provider.open(t,w)}close(I){return this.provider.close(I)}async read(I,E,w){const t=D.VSBuffer.alloc(w),d=0,p=await this.provider.read(I,E,t.buffer,d,w);return[t,p]}write(I,E,w,t,d){return this.provider.write(I,E,w.buffer,t,d)}mkdir(I,E){const w=this.transformIncoming(I,E);return this.provider.mkdir(w)}delete(I,E,w){const t=this.transformIncoming(I,E);return this.provider.delete(t,w)}rename(I,E,w,t){const d=this.transformIncoming(I,E),p=this.transformIncoming(I,w);return this.provider.rename(d,p,t)}copy(I,E,w,t){const d=this.transformIncoming(I,E),p=this.transformIncoming(I,w);return this.provider.copy(d,p,t)}onFileChange(I,E){const w=new m.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(E,this.createSessionFileWatcher(I,w))},onLastListenerRemove:()=>{(0,L.dispose)(this.sessionToWatcher.get(E)),this.sessionToWatcher.delete(E)}});return w.event}async watch(I,E,w,t,d){const p=this.sessionToWatcher.get(E);if(p){const v=this.transformIncoming(I,t),P=p.watch(w,v,d);this.watchRequests.set(E+w,P)}}async unwatch(I,E){const w=I+E,t=this.watchRequests.get(w);t&&((0,L.dispose)(t),this.watchRequests.delete(w))}dispose(){super.dispose();for(const[,I]of this.watchRequests)I.dispose();this.watchRequests.clear();for(const[,I]of this.sessionToWatcher)I.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=g;class b extends L.Disposable{constructor(I,E,w,t){super();this.uriTransformer=I,this.logService=w,this.environmentService=t,this.watcherRequests=new Map,this.fileWatcher=this._register(new n.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(E)}registerListeners(I){const E=this._register(new m.Emitter);this._register(E.event(w=>{I.fire(w.map(t=>({resource:this.uriTransformer.transformOutgoingURI(t.resource),type:t.type})))})),this._register(this.fileWatcher.onDidChangeFile(w=>E.fire(w))),this._register(this.fileWatcher.onDidWatchError(w=>I.fire(w)))}getRecursiveWatcherOptions(I){}getExtraExcludes(I){}watch(I,E,w){const t=this.getExtraExcludes(this.environmentService);return Array.isArray(t)&&(w.excludes=[...w.excludes,...t]),this.watcherRequests.set(I,this.fileWatcher.watch(E,w)),(0,L.toDisposable)(()=>{(0,L.dispose)(this.watcherRequests.get(I)),this.watcherRequests.delete(I)})}dispose(){super.dispose();for(const[,I]of this.watcherRequests)I.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=b}),define(J[190],Z([0,1,12,148,3,8,20,7,189,117]),function(V,e,m,n,L,D,M,S,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class C extends g.AbstractDiskFileSystemProviderChannel{constructor(w,t,d){super(w,t);this.environmentService=d}getUriTransformer(w){return b.DefaultURITransformer}transformIncoming(w,t){return D.URI.revive(t)}async delete(w,t,d){if(!d.useTrash)return super.delete(w,t,d);const p=this.transformIncoming(w,t),v=(0,S.normalize)(p.fsPath);try{await m.shell.trashItem(v)}catch{throw(0,M.createFileSystemProviderError)(L.isWindows?(0,n.localize)(0,null,(0,S.basename)(v)):(0,n.localize)(1,null,(0,S.basename)(v)),M.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(w,t){return new I(w,t,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=C;class I extends g.AbstractSessionFileWatcher{watch(w,t,d){if(d.recursive)throw(0,M.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",M.FileSystemProviderErrorCode.Unavailable);return super.watch(w,t,d)}}}),define(J[95],Z([0,1,6]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function n(D,M){switch(M){case m.LogLevel.Trace:return D.trace;case m.LogLevel.Debug:return D.debug;case m.LogLevel.Info:return D.info;case m.LogLevel.Warning:return D.warn;case m.LogLevel.Error:return D.error;case m.LogLevel.Critical:return D.critical;default:throw new Error("Invalid log level")}}class L extends m.AbstractLogger{constructor(M=m.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(M),this._register(this.onDidChangeLogLevel(S=>{this._logger&&this._logger.setLevel(S)}))}set logger(M){this._logger=M;for(const{level:S,args:g}of this.buffer)n(M,S).apply(M,g);this.buffer=[]}_log(M,...S){this._logger?n(this._logger,M).apply(this._logger,S):this.getLevel()<=M&&this.buffer.push({level:M,args:S})}trace(M,...S){this._log(m.LogLevel.Trace,M,...S)}debug(M,...S){this._log(m.LogLevel.Debug,M,...S)}info(M,...S){this._log(m.LogLevel.Info,M,...S)}warn(M,...S){this._log(m.LogLevel.Warning,M,...S)}error(M,...S){this._log(m.LogLevel.Error,M,...S)}critical(M,...S){this._log(m.LogLevel.Critical,M,...S)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=L}),define(J[191],Z([0,1,9,16,17,20,5,95,6]),function(V,e,m,n,L,D,M,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const b=5*D.ByteSize.MB;let C=class extends g.AbstractLogger{constructor(w,t,d,p,v){super();this.name=w,this.resource=t,this.donotUseFormatters=p,this.fileService=v,this.backupIndex=1,this.setLevel(d),this.queue=this._register(new m.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=g.LogLevel.Trace&&this._log(g.LogLevel.Trace,(0,g.format)(arguments))}debug(){this.getLevel()<=g.LogLevel.Debug&&this._log(g.LogLevel.Debug,(0,g.format)(arguments))}info(){this.getLevel()<=g.LogLevel.Info&&this._log(g.LogLevel.Info,(0,g.format)(arguments))}warn(){this.getLevel()<=g.LogLevel.Warning&&this._log(g.LogLevel.Warning,(0,g.format)(arguments))}error(){if(this.getLevel()<=g.LogLevel.Error){const w=arguments[0];if(w instanceof Error){const t=Array.prototype.slice.call(arguments);t[0]=w.stack,this._log(g.LogLevel.Error,(0,g.format)(t))}else this._log(g.LogLevel.Error,(0,g.format)(arguments))}}critical(){this.getLevel()<=g.LogLevel.Critical&&this._log(g.LogLevel.Critical,(0,g.format)(arguments))}flush(){}async initialize(){try{await this.fileService.createFile(this.resource)}catch(w){if(w.fileOperationResult!==3)throw w}}_log(w,t){this.queue.queue(async()=>{await this.initializePromise;let d=await this.loadContent();d.length>b&&(await this.fileService.writeFile(this.getBackupResource(),n.VSBuffer.fromString(d)),d=""),this.donotUseFormatters?d+=t:d+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(w)}] ${t}
`,await this.fileService.writeFile(this.resource,n.VSBuffer.fromString(d))})}getCurrentTimestamp(){const w=p=>p<10?`0${p}`:p,t=p=>p<10?`00${p}`:p<100?`0${p}`:p,d=new Date;return`${d.getFullYear()}-${w(d.getMonth()+1)}-${w(d.getDate())} ${w(d.getHours())}:${w(d.getMinutes())}:${w(d.getSeconds())}.${t(d.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,L.joinPath)((0,L.dirname)(this.resource),`${(0,L.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch{return""}}stringifyLogLevel(w){switch(w){case g.LogLevel.Critical:return"critical";case g.LogLevel.Debug:return"debug";case g.LogLevel.Error:return"error";case g.LogLevel.Info:return"info";case g.LogLevel.Trace:return"trace";case g.LogLevel.Warning:return"warning"}return""}};C=ue([te(4,D.IFileService)],C),e.FileLogger=C;let I=class extends g.AbstractLoggerService{constructor(w,t,d){super(w.getLevel(),w.onDidChangeLogLevel);this.instantiationService=t,this.fileService=d}doCreateLogger(w,t,d){const p=new S.BufferLogService(t);return(0,D.whenProviderRegistered)(w,this.fileService).then(()=>p.logger=this.instantiationService.createInstance(C,d?.name||(0,L.basename)(w),w,p.getLevel(),!!d?.donotUseFormatters)),p}};I=ue([te(0,g.ILogService),te(1,M.IInstantiationService),te(2,D.IFileService)],I),e.FileLoggerService=I}),define(J[192],Z([0,1,4,8,6]),function(V,e,m,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class D{constructor(E){this.service=E,this.onDidChangeLogLevel=m.Event.buffer(E.onDidChangeLogLevel,!0)}listen(E,w){switch(w){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${w}`)}async call(E,w,t){switch(w){case"setLevel":return this.service.setLevel(t)}throw new Error(`Call not found: ${w}`)}}e.LogLevelChannel=D;class M{constructor(E){this.channel=E}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(E){M.setLevel(this.channel,E)}static setLevel(E,w){return E.call("setLevel",w)}}e.LogLevelChannelClient=M;class S{constructor(E){this.loggerService=E,this.loggers=new Map}listen(E,w){throw new Error(`Event not found: ${w}`)}async call(E,w,t){switch(w){case"createLogger":this.createLogger(n.URI.revive(t[0]),t[1]);return;case"log":return this.log(n.URI.revive(t[0]),t[1]);case"consoleLog":return this.consoleLog(t[0],t[1])}throw new Error(`Call not found: ${w}`)}createLogger(E,w){this.loggers.set(E.toString(),this.loggerService.createLogger(E,w))}consoleLog(E,w){let t=console.log;switch(E){case L.LogLevel.Error:t=console.error;break;case L.LogLevel.Warning:t=console.warn;break;case L.LogLevel.Info:t=console.info;break}t.call(console,...w)}log(E,w){const t=this.loggers.get(E.toString());if(!t)throw new Error("Create the logger before logging");for(const[d,p]of w)(0,L.log)(t,d,p)}}e.LoggerChannel=S;class g extends L.AbstractLoggerService{constructor(E,w,t){super(E,w);this.channel=t}createConsoleMainLogger(){return new L.AdapterLogger({log:(E,w)=>{this.channel.call("consoleLog",[E,w])}})}doCreateLogger(E,w,t){return new b(this.channel,E,w,t)}}e.LoggerChannelClient=g;class b extends L.AbstractMessageLogger{constructor(E,w,t,d){super(d?.always);this.channel=E,this.file=w,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(t),this.channel.call("createLogger",[w,d]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(E,w){const t=[[E,w]];this.isLoggerCreated?this.doLog(t):this.buffer.push(...t)}doLog(E){this.channel.call("log",[this.file,E])}}class C extends L.LogService{constructor(E,w){super(w);this.parent=E,this._register(E.onDidChangeLogLevel(t=>w.setLevel(t)))}setLevel(E){super.setLevel(E),this.parent.setLevel(E)}}e.FollowerLogService=C}),define(J[96],Z([0,1,20,6]),function(V,e,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function L(S,g,b,C,I){try{const E=await new Promise((t,d)=>{V(["spdlog"],t,d)});E.setFlushOn(n.LogLevel.Trace);const w=await E.createAsyncRotatingLogger(S,g,b,C);return I&&w.clearFormatters(),w}catch(E){console.error(E)}return null}function D(S,g,b){switch(g){case n.LogLevel.Trace:S.trace(b);break;case n.LogLevel.Debug:S.debug(b);break;case n.LogLevel.Info:S.info(b);break;case n.LogLevel.Warning:S.warn(b);break;case n.LogLevel.Error:S.error(b);break;case n.LogLevel.Critical:S.critical(b);break;default:throw new Error("Invalid log level")}}class M extends n.AbstractMessageLogger{constructor(g,b,C,I,E){super();this.buffer=[],this.setLevel(E),this._loggerCreationPromise=this._createSpdLogLogger(g,b,C,I),this._register(this.onDidChangeLogLevel(w=>{this._logger&&this._logger.setLevel(w)}))}async _createSpdLogLogger(g,b,C,I){const E=C?6:1,w=30/E*m.ByteSize.MB,t=await L(g,b,w,E,I);if(t){this._logger=t,this._logger.setLevel(this.getLevel());for(const{level:d,message:p}of this.buffer)D(this._logger,d,p);this.buffer=[]}}log(g,b){this._logger?D(this._logger,g,b):this.getLevel()<=g&&this.buffer.push({level:g,message:b})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=M}),define(J[193],Z([0,1,10,17,31,20,191,6,96]),function(V,e,m,n,L,D,M,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let b=class extends S.AbstractLoggerService{constructor(I,E){super(I.getLevel(),I.onDidChangeLogLevel);this.fileService=E}doCreateLogger(I,E,w){return I.scheme===m.Schemas.file?new g.SpdLogLogger(w?.name||(0,L.generateUuid)(),I.fsPath,!w?.donotRotate,!!w?.donotUseFormatters,E):new M.FileLogger(w?.name??(0,n.basename)(I),I,E,!!w?.donotUseFormatters,this.fileService)}};b=ue([te(0,S.ILogService),te(1,D.IFileService)],b),e.LoggerService=b}),define(J[194],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function m(M){return M.submenu!==void 0}e.isMenubarMenuItemSubmenu=m;function n(M){return M.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=n;function L(M){return M.uri!==void 0}e.isMenubarMenuItemRecentAction=L;function D(M){return!m(M)&&!n(M)&&!L(M)}e.isMenubarMenuItemAction=D}),define(J[53],Z([0,1,10,3,36,17]),function(V,e,m,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let M;if(typeof n.globals.vscode!="undefined"&&typeof n.globals.vscode.context!="undefined"){const S=n.globals.vscode.context.configuration();if(S)M=S.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof V?.__$__nodeRequire=="function"){const S=(0,D.dirname)(m.FileAccess.asFileUri("",V));M=V.__$__nodeRequire((0,D.joinPath)(S,"product.json").fsPath);const g=V.__$__nodeRequire((0,D.joinPath)(S,"package.json").fsPath);L.env.VSCODE_DEV&&Object.assign(M,{nameShort:`${M.nameShort} Dev`,nameLong:`${M.nameLong} Dev`,dataFolderName:`${M.dataFolderName}-dev`,serverDataFolderName:M.serverDataFolderName?`${M.serverDataFolderName}-dev`:void 0}),Object.assign(M,{version:g.version})}else M={},Object.keys(M).length===0&&Object.assign(M,{version:"1.65.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=M}),define(J[21],Z([0,1,5]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,m.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(J[195],Z([0,1,74,4,2,6,3,52,21]),function(V,e,m,n,L,D,M,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsMainService=void 0;let b=class gt extends L.Disposable{constructor(I,E,w,t){super();this.isRunningOnServer=I,this.logService=E,this.environmentMainService=w,this.productService=t,this._onDidChangePassword=this._register(new n.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getSecretStoragePrefix(){return`${this.productService.urlProtocol}${this.isRunningOnServer?"-server":""}`}async getPassword(I,E){const w=await this.withKeytar(),t=await w.getPassword(I,E);if(t)try{let{content:d,hasNextChunk:p}=JSON.parse(t);if(!d||!p)return t;let v=1;for(;p;){const P=await w.getPassword(I,`${E}-${v}`),h=JSON.parse(P);d+=h.content,p=h.hasNextChunk,v++}return d}catch{return t}return t}async setPassword(I,E,w){const t=await this.withKeytar(),d=3,p=async(v,P,h)=>{let l=0,c;for(;l<d;)try{await t.setPassword(v,P,h);return}catch(a){c=a,this.logService.warn("Error attempting to set a password: ",a),l++,await new Promise(f=>setTimeout(f,200))}throw c};if(M.isWindows&&w.length>gt.MAX_PASSWORD_LENGTH){let v=0,P=0,h=!0;for(;h;){const l=w.substring(v,v+gt.PASSWORD_CHUNK_SIZE);v+=gt.PASSWORD_CHUNK_SIZE,h=w.length-v>0;const c={content:l,hasNextChunk:h};await p(I,P?`${E}-${P}`:E,JSON.stringify(c)),P++}}else await p(I,E,w);this._onDidChangePassword.fire({service:I,account:E})}async deletePassword(I,E){const t=await(await this.withKeytar()).deletePassword(I,E);return t&&this._onDidChangePassword.fire({service:I,account:E}),t}async findPassword(I){return(await this.withKeytar()).findPassword(I)}async findCredentials(I){return(await this.withKeytar()).findCredentials(I)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new m.InMemoryCredentialsProvider,this._keytarCache;try{this._keytarCache=await new Promise((I,E)=>{V(["keytar"],I,E)}),await this._keytarCache.findCredentials("test-keytar-loads")}catch(I){if(!this.isRunningOnServer)throw I;this.logService.warn(`Switching to using in-memory credential store instead because Keytar failed to load: ${I.message}`),this._keytarCache=new m.InMemoryCredentialsProvider}return this._keytarCache}clear(){return this._keytarCache instanceof m.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};b.MAX_PASSWORD_LENGTH=2500,b.PASSWORD_CHUNK_SIZE=b.MAX_PASSWORD_LENGTH-100,b=ue([te(1,D.ILogService),te(2,S.INativeEnvironmentService),te(3,g.IProductService)],b),e.CredentialsMainService=b}),define(J[196],Z([0,1,60,6,21]),function(V,e,m,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let D=class{constructor(S,g){this.productService=S,this.logService=g,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(S,g){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const b=/^(.*)#([^#]+)$/.exec(g);if(!b)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",g),!1;const[,C,I]=b;let E=this.trustedExtensionUrlPublicKeys.get(S);if(!E){if(E=this.productService.trustedExtensionUrlPublicKeys[S],!E||E.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",S),!1;this.trustedExtensionUrlPublicKeys.set(S,[...E])}const w=Buffer.from(decodeURIComponent(I),"base64");if(w.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",g),!1;const t=w.slice(0,6),d=w.readUIntBE(0,6),p=Date.now()-d;if(p<0||p>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",g),!1;const v=w.slice(6),P=m.createVerify("SHA256");P.write(t),P.write(Buffer.from(C)),P.end();for(let h=0;h<E.length;h++){let l=E[h];if(l!==null){if(typeof l=="string")try{l=m.createPublicKey({key:Buffer.from(l,"base64"),format:"der",type:"spki"}),E[h]=l}catch(c){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${h+1} for ${S}:`,c),E[h]=null;continue}if(P.verify(l,v))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",g),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",g),!1}};D=ue([te(0,L.IProductService),te(1,n.ILogService)],D),e.ExtensionUrlTrustService=D}),define(J[54],Z([0,1,5]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,m.createDecorator)("protocolMainService")}),define(J[197],Z([0,1,12,2,35,10,7,3,8,31,52,6]),function(V,e,m,n,L,D,M,S,g,b,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let E=class extends n.Disposable{constructor(t,d){super();this.logService=d,this.validRoots=L.TernarySearchTree.forPaths(!S.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(t.appRoot),this.addValidFileRoot(t.extensionsPath),this.addValidFileRoot(t.globalStorageHome.fsPath),this.addValidFileRoot(t.workspaceStorageHome.fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:t}=m.session;t.protocol.registerFileProtocol(D.Schemas.vscodeFileResource,(d,p)=>this.handleResourceRequest(d,p)),t.protocol.interceptFileProtocol(D.Schemas.file,(d,p)=>this.handleFileRequest(d,p)),this._register((0,n.toDisposable)(()=>{t.protocol.unregisterProtocol(D.Schemas.vscodeFileResource),t.protocol.uninterceptProtocol(D.Schemas.file)}))}addValidFileRoot(t){const d=(0,M.normalize)(t);return this.validRoots.get(d)?n.Disposable.None:(this.validRoots.set(d,!0),(0,n.toDisposable)(()=>this.validRoots.delete(d)))}handleFileRequest(t,d){const p=g.URI.parse(t.url);return this.logService.error(`Refused to load resource ${p.fsPath} from ${D.Schemas.file}: protocol (original URL: ${t.url})`),d({error:-3})}handleResourceRequest(t,d){const p=this.requestToNormalizedFilePath(t);return this.validRoots.findSubstr(p)?d({path:p}):this.validExtensions.has((0,M.extname)(p))?d({path:p}):(this.logService.error(`${D.Schemas.vscodeFileResource}: Refused to load resource ${p} from ${D.Schemas.vscodeFileResource}: protocol (original URL: ${t.url})`),d({error:-3}))}requestToNormalizedFilePath(t){const d=g.URI.parse(t.url),p=D.FileAccess.asFileUri(d);return(0,M.normalize)(p.fsPath)}createIPCObjectUrl(){let t;const d=g.URI.from({scheme:"vscode",path:(0,b.generateUuid)()}),p=d.toString(),v=async()=>t;return m.ipcMain.handle(p,v),this.logService.trace(`IPC Object URL: Registered new channel ${p}.`),{resource:d,update:P=>t=P,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${p}.`),m.ipcMain.removeHandler(p)}}}};E=ue([te(0,C.INativeEnvironmentService),te(1,I.ILogService)],E),e.ProtocolMainService=E}),define(J[40],Z([0,1,106,14]),function(V,e,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class L{constructor(){this.data=new Map}add(M,S){m.ok(n.isString(M)),m.ok(n.isObject(S)),m.ok(!this.data.has(M),"There is already an extension with this id"),this.data.set(M,S)}knows(M){return this.data.has(M)}as(M){return this.data.get(M)||null}}e.Registry=new L}),define(J[198],Z([0,1,4,40]),function(V,e,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function L(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class D{constructor(){this._onDidChangeSchema=new m.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(g,b){this.schemasById[L(g)]=b,this._onDidChangeSchema.fire(g)}notifySchemaChanged(g){this._onDidChangeSchema.fire(g)}getSchemaContributions(){return{schemas:this.schemasById}}}const M=new D;n.Registry.add(e.Extensions.JSONContribution,M)}),define(J[55],Z([0,1,30,4,14,140,198,40]),function(V,e,m,n,L,D,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var g;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(g=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var b;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const C=S.Registry.as(M.Extensions.JSONContribution);class I{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new n.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new n.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:D.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(c,a=!0){this.registerConfigurations([c],a)}registerConfigurations(c,a=!0){const f=this.doRegisterConfigurations(c,a);C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:f})}deregisterConfigurations(c){const a=this.doDeregisterConfigurations(c);C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}updateConfigurations({add:c,remove:a}){const f=[];f.push(...this.doDeregisterConfigurations(a)),f.push(...this.doRegisterConfigurations(c,!1)),C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,m.distinct)(f)})}registerDefaultConfigurations(c){const a=[],f=[];for(const{overrides:r,source:i}of c)for(const s in r)if(a.push(s),e.OVERRIDE_PROPERTY_REGEX.test(s)){const o={...this.configurationDefaultsOverrides.get(s)?.value||{},...r[s]};this.configurationDefaultsOverrides.set(s,{source:i,value:o});const u={type:"object",default:o,description:D.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:o,source:L.isString(i)?void 0:i};f.push(...t(s)),this.configurationProperties[s]=u,this.defaultLanguageConfigurationOverridesNode.properties[s]=u}else{this.configurationDefaultsOverrides.set(s,{value:r[s],source:i});const o=this.configurationProperties[s];o&&(this.updatePropertyDefaultValue(s,o),this.updateSchema(s,o))}this.registerOverrideIdentifiers(f),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}deregisterDefaultConfigurations(c){const a=[];for(const{overrides:f,source:r}of c)for(const i in f){const s=this.configurationDefaultsOverrides.get(i),o=L.isString(r)?r:r?.id,u=L.isString(s?.source)?s?.source:s?.source?.id;if(o===u)if(a.push(i),this.configurationDefaultsOverrides.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const y=this.configurationProperties[i];y&&(this.updatePropertyDefaultValue(i,y),this.updateSchema(i,y))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...c){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(c){for(const a of c)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(c,a){const f=[];return c.forEach(r=>{f.push(...this.validateAndRegisterProperties(r,a,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),f}doDeregisterConfigurations(c){const a=[],f=r=>{if(r.properties)for(const i in r.properties)a.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,r.properties[i]);r.allOf&&r.allOf.forEach(i=>f(i))};for(const r of c){f(r);const i=this.configurationContributors.indexOf(r);i!==-1&&this.configurationContributors.splice(i,1)}return a}validateAndRegisterProperties(c,a=!0,f,r,i=3){i=L.isUndefinedOrNull(c.scope)?i:c.scope;let s=[],o=c.properties;if(o)for(let y in o){if(a&&P(y)){delete o[y];continue}const k=o[y];if(k.source=f,k.defaultDefaultValue=o[y].default,this.updatePropertyDefaultValue(y,k),e.OVERRIDE_PROPERTY_REGEX.test(y)?k.scope=void 0:(k.scope=L.isUndefinedOrNull(k.scope)?i:k.scope,k.restricted=L.isUndefinedOrNull(k.restricted)?!!r?.includes(y):k.restricted),o[y].hasOwnProperty("included")&&!o[y].included){this.excludedConfigurationProperties[y]=o[y],delete o[y];continue}else this.configurationProperties[y]=o[y];!o[y].deprecationMessage&&o[y].markdownDeprecationMessage&&(o[y].deprecationMessage=o[y].markdownDeprecationMessage),s.push(y)}let u=c.allOf;if(u)for(let y of u)s.push(...this.validateAndRegisterProperties(y,a,f,r,i));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(c){const a=f=>{let r=f.properties;if(r)for(const s in r)this.updateSchema(s,r[s]);let i=f.allOf;i&&i.forEach(a)};a(c)}updateSchema(c,a){switch(e.allSettings.properties[c]=a,a.scope){case 1:e.applicationSettings.properties[c]=a;break;case 2:e.machineSettings.properties[c]=a;break;case 6:e.machineOverridableSettings.properties[c]=a;break;case 3:e.windowSettings.properties[c]=a;break;case 4:e.resourceSettings.properties[c]=a;break;case 5:e.resourceSettings.properties[c]=a,this.resourceLanguageSettingsSchema.properties[c]=a;break}}removeFromSchema(c,a){switch(delete e.allSettings.properties[c],a.scope){case 1:delete e.applicationSettings.properties[c];break;case 2:delete e.machineSettings.properties[c];break;case 6:delete e.machineOverridableSettings.properties[c];break;case 3:delete e.windowSettings.properties[c];break;case 4:case 5:delete e.resourceSettings.properties[c],delete this.resourceLanguageSettingsSchema.properties[c];break}}updateOverridePropertyPatternKey(){for(const c of this.overrideIdentifiers.values()){const a=`[${c}]`,f={type:"object",description:D.localize(2,null),errorMessage:D.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,f),e.allSettings.properties[a]=f,e.applicationSettings.properties[a]=f,e.machineSettings.properties[a]=f,e.machineOverridableSettings.properties[a]=f,e.windowSettings.properties[a]=f,e.resourceSettings.properties[a]=f}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const c={type:"object",description:D.localize(4,null),errorMessage:D.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(c,a){const f=this.configurationDefaultsOverrides.get(c);let r=f?.value,i=f?.source;L.isUndefined(r)&&(r=a.defaultDefaultValue,i=void 0),L.isUndefined(r)&&(r=p(a.type)),a.default=r,a.defaultValueSource=i}}const E="\\[([^\\]]+)\\]",w=new RegExp(E,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${E})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function t(l){const c=[];if(e.OVERRIDE_PROPERTY_REGEX.test(l)){let a=w.exec(l);for(;a?.length;){const f=a[1].trim();f&&c.push(f),a=w.exec(l)}}return(0,m.distinct)(c)}e.overrideIdentifiersFromKey=t;function d(l){return l.reduce((c,a)=>`${c}[${a}]`,"")}e.keyFromOverrideIdentifiers=d;function p(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=p;const v=new I;S.Registry.add(e.Extensions.Configuration,v);function P(l){return l.trim()?e.OVERRIDE_PROPERTY_REGEX.test(l)?D.localize(7,null,l):v.getConfigurationProperties()[l]!==void 0?D.localize(8,null,l):null:D.localize(6,null)}e.validateProperty=P;function h(){const l=[],c=v.getConfigurationProperties();for(const a of Object.keys(c))l.push([a,c[a].scope]);return l.push(["launch",4]),l.push(["task",4]),l}e.getScopes=h}),define(J[199],Z([0,1,30,4,44,2,35,49,14,8,19,55,40]),function(V,e,m,n,L,D,M,S,g,b,C,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class w{constructor(r={},i=[],s=[]){this._contents=r,this._keys=i,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,C.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,i){const s=this.getContentsForOverrideIdentifer(i);return s?r?(0,C.getConfigurationValue)(s,r):s:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const s of this.overrides)s.identifiers.includes(r)&&i.push(...s.keys);return m.distinct(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return m.distinct(r)}override(r){let i=this.overrideConfigurations.get(r);return i||(i=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,i)),i}merge(...r){const i=S.deepClone(this.contents),s=S.deepClone(this.overrides),o=[...this.keys];for(const u of r){this.mergeContents(i,u.contents);for(const y of u.overrides){const[k]=s.filter(R=>m.equals(R.identifiers,y.identifiers));k?(this.mergeContents(k.contents,y.contents),k.keys.push(...y.keys),k.keys=m.distinct(k.keys)):s.push(S.deepClone(y))}for(const y of u.keys)o.indexOf(y)===-1&&o.push(y)}return new w(i,o,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(r){const i=this.getContentsForOverrideIdentifer(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let s={};for(const o of m.distinct([...Object.keys(this.contents),...Object.keys(i)])){let u=this.contents[o],y=i[o];y&&(typeof u=="object"&&typeof y=="object"?(u=S.deepClone(u),this.mergeContents(u,y)):u=y),s[o]=u}return new w(s,this.keys,this.overrides)}mergeContents(r,i){for(const s of Object.keys(i)){if(s in r&&g.isObject(r[s])&&g.isObject(i[s])){this.mergeContents(r[s],i[s]);continue}r[s]=S.deepClone(i[s])}}checkAndFreeze(r){return this.isFrozen&&!Object.isFrozen(r)?S.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let i=null,s=null;const o=u=>{u&&(s?this.mergeContents(s,u):s=S.deepClone(u))};for(const u of this.overrides)m.equals(u.identifiers,[r])?i=u.contents:u.identifiers.includes(r)&&o(u.contents);return o(i),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,i){this.addKey(r),(0,C.addToValueTree)(this.contents,r,i,s=>{throw new Error(s)})}removeValue(r){this.removeKey(r)&&(0,C.removeFromValueTree)(this.contents,r)}addKey(r){let i=this.keys.length;for(let s=0;s<i;s++)r.indexOf(this.keys[s])===0&&(i=s);this.keys.splice(i,1,r)}removeKey(r){let i=this.keys.indexOf(r);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=w;class t extends w{constructor(r={}){const i=E.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),s=Object.keys(i),o=Object.create(null),u=[];for(const y in i){const k=r[y],R=k!==void 0?k:i[y].default;(0,C.addToValueTree)(o,y,R,W=>console.error(`Conflict in default settings: ${W}`))}for(const y of Object.keys(o))I.OVERRIDE_PROPERTY_REGEX.test(y)&&u.push({identifiers:(0,I.overrideIdentifiersFromKey)(y),keys:Object.keys(o[y]),contents:(0,C.toValuesTree)(o[y],k=>console.error(`Conflict in default settings file: ${k}`))});super(o,s,u)}}e.DefaultConfigurationModel=t;class d{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new w}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,i){if(!g.isUndefinedOrNull(r)){const s=this.doParseContent(r);this.parseRaw(s,i)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,i){this._raw=r;const{contents:s,keys:o,overrides:u,restricted:y}=this.doParseRaw(r,i);this._configurationModel=new w(s,o,u),this._restrictedConfigurations=y||[]}doParseContent(r){let i={},s=null,o=[],u=[],y=[];function k(W){Array.isArray(o)?o.push(W):s!==null&&(o[s]=W)}let R={onObjectBegin:()=>{let W={};k(W),u.push(o),o=W,s=null},onObjectProperty:W=>{s=W},onObjectEnd:()=>{o=u.pop()},onArrayBegin:()=>{let W=[];k(W),u.push(o),o=W,s=null},onArrayEnd:()=>{o=u.pop()},onLiteralValue:k,onError:(W,U,K)=>{y.push({error:W,offset:U,length:K})}};if(r)try{L.visit(r,R),i=o[0]||{}}catch(W){console.error(`Error while parsing settings file ${this._name}: ${W}`),this._parseErrors=[W]}return i}doParseRaw(r,i){const s=E.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),o=this.filter(r,s,!0,i);r=o.raw;const u=(0,C.toValuesTree)(r,R=>console.error(`Conflict in settings file ${this._name}: ${R}`)),y=Object.keys(r),k=this.toOverrides(r,R=>console.error(`Conflict in settings file ${this._name}: ${R}`));return{contents:u,keys:y,overrides:k,restricted:o.restricted}}filter(r,i,s,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:r,restricted:[]};const u={},y=[];for(let k in r)if(I.OVERRIDE_PROPERTY_REGEX.test(k)&&s){const R=this.filter(r[k],i,!1,o);u[k]=R.raw,y.push(...R.restricted)}else{const R=i[k],W=R?typeof R.scope!="undefined"?R.scope:3:void 0;R?.restricted&&y.push(k),(W===void 0||o.scopes===void 0||o.scopes.includes(W))&&(o.skipRestricted&&R?.restricted||(u[k]=r[k]))}return{raw:u,restricted:y}}toOverrides(r,i){const s=[];for(const o of Object.keys(r))if(I.OVERRIDE_PROPERTY_REGEX.test(o)){const u={};for(const y in r[o])u[y]=r[o][y];s.push({identifiers:(0,I.overrideIdentifiersFromKey)(o),keys:Object.keys(u),contents:(0,C.toValuesTree)(u,i)})}return s}}e.ConfigurationModelParser=d;class p extends D.Disposable{constructor(r,i,s,o){super();this.userSettingsResource=r,this.scopes=i,this.fileService=o,this._onDidChange=this._register(new n.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(n.Event.any(n.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource)),n.Event.filter(this.fileService.onDidRunOperation,u=>(u.isOperation(0)||u.isOperation(1)||u.isOperation(4))&&s.isEqual(u.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new w}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=p;class v{constructor(r,i,s=new w,o=new w,u=new M.ResourceMap,y=new w,k=new M.ResourceMap,R=!0){this._defaultConfiguration=r,this._localUserConfiguration=i,this._remoteUserConfiguration=s,this._workspaceConfiguration=o,this._folderConfigurations=u,this._memoryConfiguration=y,this._memoryConfigurationByResource=k,this._freeze=R,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new M.ResourceMap,this._userConfiguration=null}getValue(r,i,s){return this.getConsolidateConfigurationModel(i,s).getValue(r)}updateValue(r,i,s={}){let o;s.resource?(o=this._memoryConfigurationByResource.get(s.resource),o||(o=new w,this._memoryConfigurationByResource.set(s.resource,o))):o=this._memoryConfiguration,i===void 0?o.removeValue(r):o.setValue(r,i),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,i,s){const o=this.getConsolidateConfigurationModel(i,s),u=this.getFolderConfigurationModelForResource(i.resource,s),y=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,k=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),R=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),W=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),U=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),K=s?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,x=u?i.overrideIdentifier?u.freeze().override(i.overrideIdentifier).getValue(r):u.freeze().getValue(r):void 0,ee=i.overrideIdentifier?y.override(i.overrideIdentifier).getValue(r):y.getValue(r),Q=o.getValue(r),H=m.distinct(m.flatten(o.overrides.map(X=>X.identifiers))).filter(X=>o.getOverrideValue(r,X)!==void 0);return{defaultValue:k,userValue:R,userLocalValue:W,userRemoteValue:U,workspaceValue:K,workspaceFolderValue:x,memoryValue:ee,value:Q,default:k!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,user:R!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userLocal:W!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userRemote:U!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspace:K!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspaceFolder:x!==void 0?{value:u?.freeze().getValue(r),override:i.overrideIdentifier?u?.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,memory:ee!==void 0?{value:y.getValue(r),override:i.overrideIdentifier?y.getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:H.length?H:void 0}}keys(r){const i=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,i){this._folderConfigurations.set(r,i),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const s=[];if(!i){const{added:o,updated:u,removed:y}=c(this._defaultConfiguration,r);i=[...o,...u,...y]}for(const o of i)for(const u of(0,I.overrideIdentifiersFromKey)(o)){const y=this._defaultConfiguration.getKeysForOverrideIdentifier(u),k=r.getKeysForOverrideIdentifier(u),R=[...k.filter(W=>y.indexOf(W)===-1),...y.filter(W=>k.indexOf(W)===-1),...y.filter(W=>!S.equals(this._defaultConfiguration.override(u).getValue(W),r.override(u).getValue(W)))];s.push([u,R])}return this.updateDefaultConfiguration(r),{keys:i,overrides:s}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:s,removed:o,overrides:u}=c(this.localUserConfiguration,r),y=[...i,...s,...o];return y.length&&this.updateLocalUserConfiguration(r),{keys:y,overrides:u}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:s,removed:o,overrides:u}=c(this.remoteUserConfiguration,r);let y=[...i,...s,...o];return y.length&&this.updateRemoteUserConfiguration(r),{keys:y,overrides:u}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:s,removed:o,overrides:u}=c(this.workspaceConfiguration,r);let y=[...i,...s,...o];return y.length&&this.updateWorkspaceConfiguration(r),{keys:y,overrides:u}}compareAndUpdateFolderConfiguration(r,i){const s=this.folderConfigurations.get(r),{added:o,updated:u,removed:y,overrides:k}=c(s,i);let R=[...o,...u,...y];return(R.length||!s)&&this.updateFolderConfiguration(r,i),{keys:R,overrides:k}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:s,updated:o,removed:u,overrides:y}=c(i,void 0);return{keys:[...s,...o,...u],overrides:y}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(r,i){let s=this.getConsolidatedConfigurationModelForResource(r,i);return r.overrideIdentifier?s.override(r.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:r},i){let s=this.getWorkspaceConsolidatedConfiguration();if(i&&r){const o=i.getFolder(r);o&&(s=this.getFolderConsolidatedConfiguration(o.uri)||s);const u=this._memoryConfigurationByResource.get(r);u&&(s=s.merge(u))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let i=this._foldersConsolidatedConfigurations.get(r);if(!i){const s=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(r);o?(i=s.merge(o),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(r,i)):i=s}return i}getFolderConfigurationModelForResource(r,i){if(i&&r){const s=i.getFolder(r);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,i)=>{const{contents:s,overrides:o,keys:u}=this._folderConfigurations.get(i);return r.push([i,{contents:s,overrides:o,keys:u}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>r.add(i)),this.userConfiguration.freeze().keys.forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(s=>r.add(s))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(s=>r.add(s))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(r).forEach(o=>i.add(o))),[...i.values()]}static parse(r){const i=this.parseConfigurationModel(r.defaults),s=this.parseConfigurationModel(r.user),o=this.parseConfigurationModel(r.workspace),u=r.folders.reduce((y,k)=>(y.set(b.URI.revive(k[0]),this.parseConfigurationModel(k[1])),y),new M.ResourceMap);return new v(i,s,new w,o,u,new w,new M.ResourceMap,!1)}static parseConfigurationModel(r){return new w(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=v;function P(...f){if(f.length===0)return{keys:[],overrides:[]};if(f.length===1)return f[0];const r=new Set,i=new Map;for(const o of f)o.keys.forEach(u=>r.add(u)),o.overrides.forEach(([u,y])=>{const k=(0,M.getOrSet)(i,u,new Set);y.forEach(R=>k.add(R))});const s=[];return i.forEach((o,u)=>s.push([u,[...o.values()]])),{keys:[...r.values()],overrides:s}}e.mergeChanges=P;class h{constructor(r,i,s,o){this.change=r,this.previous=i,this.currentConfiguraiton=s,this.currentWorkspace=o,this._previousConfiguration=void 0;const u=new Set;r.keys.forEach(k=>u.add(k)),r.overrides.forEach(([,k])=>k.forEach(R=>u.add(R))),this.affectedKeys=[...u.values()];const y=new w;this.affectedKeys.forEach(k=>y.setValue(k,{})),this.affectedKeysTree=y.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(i){const s=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(r,i,this.currentWorkspace);return!S.equals(s,o)}return!0}return!1}doesAffectedKeysTreeContains(r,i){let s=(0,C.toValuesTree)({[i]:!0},()=>{}),o;for(;typeof s=="object"&&(o=Object.keys(s)[0]);){if(r=r[o],!r)return!1;s=s[o]}return!0}}e.ConfigurationChangeEvent=h;class l extends h{constructor(r,i,s,o){super({keys:r.allKeys(),overrides:[]},void 0,r,i);this.source=s,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=l;function c(f,r){const{added:i,removed:s,updated:o}=a(r,f),u=[],y=f?.getAllOverrideIdentifiers()||[],k=r?.getAllOverrideIdentifiers()||[];if(r){const R=k.filter(W=>!y.includes(W));for(const W of R)u.push([W,r.getKeysForOverrideIdentifier(W)])}if(f){const R=y.filter(W=>!k.includes(W));for(const W of R)u.push([W,f.getKeysForOverrideIdentifier(W)])}if(r&&f){for(const R of y)if(k.includes(R)){const W=a({contents:f.getOverrideValue(void 0,R)||{},keys:f.getKeysForOverrideIdentifier(R)},{contents:r.getOverrideValue(void 0,R)||{},keys:r.getKeysForOverrideIdentifier(R)});u.push([R,[...W.added,...W.removed,...W.updated]])}}return{added:i,removed:s,updated:o,overrides:u}}function a(f,r){const i=f?r?f.keys.filter(u=>r.keys.indexOf(u)===-1):[...f.keys]:[],s=r?f?r.keys.filter(u=>f.keys.indexOf(u)===-1):[...r.keys]:[],o=[];if(f&&r){for(const u of r.keys)if(f.keys.indexOf(u)!==-1){const y=(0,C.getConfigurationValue)(r.contents,u),k=(0,C.getConfigurationValue)(f.contents,u);S.equals(y,k)||o.push(u)}}return{added:i,removed:s,updated:o}}}),define(J[200],Z([0,1,9,4,2,17,19,199,55,40]),function(V,e,m,n,L,D,M,S,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class C extends L.Disposable{constructor(E,w){super();this.settingsResource=E,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new S.UserSettings(this.settingsResource,void 0,D.extUriBiasedIgnorePathCase,w)),this.configuration=new S.Configuration(new S.DefaultConfigurationModel,new S.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new m.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(b.Registry.as(g.Extensions.Configuration).onDidUpdateConfiguration(({properties:t})=>this.onDidDefaultConfigurationChange(t))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const E=await this.userConfiguration.loadConfiguration();this.configuration=new S.Configuration(new S.DefaultConfigurationModel,E)}getConfigurationData(){return this.configuration.toData()}getValue(E,w){const t=typeof E=="string"?E:void 0,d=(0,M.isConfigurationOverrides)(E)?E:(0,M.isConfigurationOverrides)(w)?w:{};return this.configuration.getValue(t,d,void 0)}updateValue(E,w,t,d){return Promise.reject(new Error("not supported"))}inspect(E){return this.configuration.inspect(E,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const E=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(E)}onDidChangeUserConfiguration(E){const w=this.configuration.toData(),t=this.configuration.compareAndUpdateLocalUserConfiguration(E);this.trigger(t,w,1)}onDidDefaultConfigurationChange(E){const w=this.configuration.toData(),t=this.configuration.compareAndUpdateDefaultConfiguration(new S.DefaultConfigurationModel,E);this.trigger(t,w,6)}trigger(E,w,t){const d=new S.ConfigurationChangeEvent(E,{data:w},this.configuration);d.source=t,d.sourceConfig=this.getTargetConfiguration(t),this._onDidChangeConfiguration.fire(d)}getTargetConfiguration(E){switch(E){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=C}),define(J[201],Z([0,1,5]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,m.createDecorator)("remoteAuthorityResolverService");var n;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound"})(n=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class L extends Error{constructor(M,S=n.Unknown,g){super(M);this._message=M,this._code=S,this._detail=g,this.isHandled=S===n.NotAvailable&&g===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,L.prototype)}static isTemporarilyNotAvailable(M){return M instanceof L&&M._code===n.TemporarilyNotAvailable}static isNoResolverFound(M){return M instanceof L&&M._code===n.NoResolverFound}static isHandled(M){return M instanceof L&&M.isHandled}}e.RemoteAuthorityResolverError=L}),define(J[202],Z([0,1,9,16,23,15,4,2,31,88,201]),function(V,e,m,n,L,D,M,S,g,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const I=30*1e3;var E;(function(B){B[B.Management=1]="Management",B[B.ExtensionHost=2]="ExtensionHost",B[B.Tunnel=3]="Tunnel"})(E=e.ConnectionType||(e.ConnectionType={}));function w(B){switch(B){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function t(B){const F=new L.CancellationTokenSource;return setTimeout(()=>F.cancel(),B),F.token}function d(B,F){if(B.isCancellationRequested||F.isCancellationRequested)return L.CancellationToken.Cancelled;const N=new L.CancellationTokenSource;return B.onCancellationRequested(()=>N.cancel()),F.onCancellationRequested(()=>N.cancel()),N.token}class p{constructor(F){this._state="pending",this._disposables=new S.DisposableStore,this.promise=new Promise((N,T)=>{this._resolvePromise=N,this._rejectPromise=T}),F.isCancellationRequested?this._timeout():this._disposables.add(F.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(F){this._state==="pending"?this._disposables.add(F):F.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const F=new Error("Time limit reached");return F.code="ETIMEDOUT",F.syscall="connect",F}resolve(F){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(F))}reject(F){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(F))}}function v(B,F){const N=new p(F);return N.registerDisposable(B.onControlMessage(T=>{const A=JSON.parse(T.toString()),O=z(A);O?N.reject(O):N.resolve(A)})),N.promise}function P(B,F,N,T,A,O,_){const j=new p(_);return F.connect(N,T,A,O,(ne,ae)=>{j.didTimeout?(ne&&B.error(ne),ae?.dispose()):ne||!ae?j.reject(ne):j.resolve(ae)}),j.promise}function h(B,F){const N=new p(F);return B.then(T=>{N.didTimeout||N.resolve(T)},T=>{N.didTimeout||N.reject(T)}),N.promise}async function l(B,F,N,T){const A=q(B,F);B.logService.trace(`${A} 1/6. invoking socketFactory.connect().`);let O;try{O=await P(B.logService,B.socketFactory,B.host,B.port,`reconnectionToken=${B.reconnectionToken}&reconnection=${B.reconnectionProtocol?"true":"false"}`,`renderer-${w(F)}-${B.reconnectionToken}`,T)}catch(ce){throw B.logService.error(`${A} socketFactory.connect() failed or timed out. Error:`),B.logService.error(ce),ce}B.logService.trace(`${A} 2/6. socketFactory.connect() was successful.`);let _,j;B.reconnectionProtocol?(B.reconnectionProtocol.beginAcceptReconnection(O,null),_=B.reconnectionProtocol,j=!1):(_=new b.PersistentProtocol(O,null),j=!0),B.logService.trace(`${A} 3/6. sending AuthRequest control message.`);const ne=await h(B.signService.createNewMessage((0,g.generateUuid)()),T),ae={type:"auth",auth:B.connectionToken||"00000000000000000000",data:ne.data};_.sendControl(n.VSBuffer.fromString(JSON.stringify(ae)));try{const ce=await v(_,d(T,t(1e4)));if(ce.type!=="sign"||typeof ce.data!="string"){const we=new Error("Unexpected handshake message");throw we.code="VSCODE_CONNECTION_ERROR",we}if(B.logService.trace(`${A} 4/6. received SignRequest control message.`),!await h(B.signService.validate(ne,ce.signedData),T)){const we=new Error("Refused to connect to unsupported server");throw we.code="VSCODE_CONNECTION_ERROR",we}const le=await h(B.signService.sign(ce.data),T),he={type:"connectionType",commit:B.commit,signedData:le,desiredConnectionType:F};return N&&(he.args=N),B.logService.trace(`${A} 5/6. sending ConnectionTypeRequest control message.`),_.sendControl(n.VSBuffer.fromString(JSON.stringify(he))),{protocol:_,ownsProtocol:j}}catch(ce){throw ce&&ce.code==="ETIMEDOUT"&&(B.logService.error(`${A} the handshake timed out. Error:`),B.logService.error(ce)),ce&&ce.code==="VSCODE_CONNECTION_ERROR"&&(B.logService.error(`${A} received error control message when negotiating connection. Error:`),B.logService.error(ce)),j&&X(_),ce}}async function c(B,F,N,T){const A=Date.now(),O=q(B,F),{protocol:_,ownsProtocol:j}=await l(B,F,N,T),ne=new p(T);return ne.registerDisposable(_.onControlMessage(ae=>{const ce=JSON.parse(ae.toString()),re=z(ce);re?(B.logService.error(`${O} received error control message when negotiating connection. Error:`),B.logService.error(re),j&&X(_),ne.reject(re)):(B.reconnectionProtocol&&B.reconnectionProtocol.endAcceptReconnection(),B.logService.trace(`${O} 6/6. handshake finished, connection is up and running after ${Y(A)}!`),ne.resolve({protocol:_,firstMessage:ce}))})),ne.promise}async function a(B,F){const{protocol:N}=await c(B,1,void 0,F);return{protocol:N}}async function f(B,F,N){const{protocol:T,firstMessage:A}=await c(B,2,F,N),O=A&&A.debugPort;return{protocol:T,debugPort:O}}async function r(B,F,N){const T=Date.now(),A=q(B,3),{protocol:O}=await l(B,3,F,N);return B.logService.trace(`${A} 6/6. handshake finished, connection is up and running after ${Y(T)}!`),O}async function i(B,F,N){const{host:T,port:A,connectionToken:O}=await B.addressProvider.getAddress();return{commit:B.commit,host:T,port:A,connectionToken:O,reconnectionToken:F,reconnectionProtocol:N,socketFactory:B.socketFactory,signService:B.signService,logService:B.logService}}async function s(B,F,N){try{const T=(0,g.generateUuid)(),A=await i(B,T,null),{protocol:O}=await a(A,L.CancellationToken.None);return new Q(B,F,N,T,O)}catch(T){throw B.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),B.logService.error(T),ee.triggerPermanentFailure(0,0,C.RemoteAuthorityResolverError.isHandled(T)),T}}e.connectRemoteAgentManagement=s;async function o(B,F){try{const N=(0,g.generateUuid)(),T=await i(B,N,null),{protocol:A,debugPort:O}=await f(T,F,L.CancellationToken.None);return new H(B,F,N,A,O)}catch(N){throw B.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),B.logService.error(N),ee.triggerPermanentFailure(0,0,C.RemoteAuthorityResolverError.isHandled(N)),N}}e.connectRemoteAgentExtensionHost=o;async function u(B,F,N){const T=await i(B,(0,g.generateUuid)(),null);return await r(T,{host:F,port:N},L.CancellationToken.None)}e.connectRemoteAgentTunnel=u;function y(B){return(0,m.createCancelablePromise)(F=>new Promise((N,T)=>{const A=setTimeout(N,B*1e3);F.onCancellationRequested(()=>{clearTimeout(A),N()})}))}var k;(function(B){B[B.ConnectionLost=0]="ConnectionLost",B[B.ReconnectionWait=1]="ReconnectionWait",B[B.ReconnectionRunning=2]="ReconnectionRunning",B[B.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",B[B.ConnectionGain=4]="ConnectionGain"})(k=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class R{constructor(F,N){this.reconnectionToken=F,this.millisSinceLastIncomingData=N,this.type=0}}e.ConnectionLostEvent=R;class W{constructor(F,N,T,A){this.reconnectionToken=F,this.millisSinceLastIncomingData=N,this.durationSeconds=T,this.cancellableTimer=A,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=W;class U{constructor(F,N,T){this.reconnectionToken=F,this.millisSinceLastIncomingData=N,this.attempt=T,this.type=2}}e.ReconnectionRunningEvent=U;class K{constructor(F,N,T){this.reconnectionToken=F,this.millisSinceLastIncomingData=N,this.attempt=T,this.type=4}}e.ConnectionGainEvent=K;class x{constructor(F,N,T,A){this.reconnectionToken=F,this.millisSinceLastIncomingData=N,this.attempt=T,this.handled=A,this.type=3}}e.ReconnectionPermanentFailureEvent=x;class ee extends S.Disposable{constructor(F,N,T,A){super();this._connectionType=F,this._onDidStateChange=this._register(new M.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=N,this.reconnectionToken=T,this.protocol=A,this._isReconnecting=!1,this._onDidStateChange.fire(new K(this.reconnectionToken,0,0)),this._register(A.onSocketClose(O=>{const _=$(this._connectionType,this.reconnectionToken,!0);O?O.type===0?(this._options.logService.info(`${_} received socket close event (hadError: ${O.hadError}).`),O.error&&this._options.logService.error(O.error)):(this._options.logService.info(`${_} received socket close event (wasClean: ${O.wasClean}, code: ${O.code}, reason: ${O.reason}).`),O.event&&this._options.logService.error(O.event)):this._options.logService.info(`${_} received socket close event.`),this._beginReconnecting()})),this._register(A.onSocketTimeout(()=>{const O=$(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${O} received socket timeout event.`),this._beginReconnecting()})),ee._instances.push(this),ee._permanentFailure&&this._gotoPermanentFailure(ee._permanentFailureMillisSinceLastIncomingData,ee._permanentFailureAttempt,ee._permanentFailureHandled)}static triggerPermanentFailure(F,N,T){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=F,this._permanentFailureAttempt=N,this._permanentFailureHandled=T,this._instances.forEach(A=>A._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(F=>F._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(F=>F._pauseSocketWriting())}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(ee._permanentFailure)return;const F=$(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${F} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new R(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const N=[0,5,5,10,10,10,10,10,30];let T=-1;do{T++;const A=T<N.length?N[T]:N[N.length-1];try{if(A>0){const _=y(A);this._onDidStateChange.fire(new W(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),A,_)),this._options.logService.info(`${F} waiting for ${A} seconds before reconnecting...`);try{await _}catch{}}if(ee._permanentFailure){this._options.logService.error(`${F} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),T+1)),this._options.logService.info(`${F} resolving connection...`);const O=await i(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${F} connecting to ${O.host}:${O.port}...`),await this._reconnect(O,t(I)),this._options.logService.info(`${F} reconnected!`),this._onDidStateChange.fire(new K(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),T+1));break}catch(O){if(O.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${F} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(O),ee.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),T+1,!1);break}if(T>360){this._options.logService.error(`${F} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(O),ee.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),T+1,!1);break}if(C.RemoteAuthorityResolverError.isTemporarilyNotAvailable(O)){this._options.logService.info(`${F} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(O);continue}if((O.code==="ETIMEDOUT"||O.code==="ENETUNREACH"||O.code==="ECONNREFUSED"||O.code==="ECONNRESET")&&O.syscall==="connect"){this._options.logService.info(`${F} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(O);continue}if((0,D.isCancellationError)(O)){this._options.logService.info(`${F} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(O);continue}if(O instanceof C.RemoteAuthorityResolverError){this._options.logService.error(`${F} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(O),ee.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),T+1,C.RemoteAuthorityResolverError.isHandled(O));break}this._options.logService.error(`${F} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(O),ee.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),T+1,!1);break}}while(!ee._permanentFailure)}_gotoPermanentFailure(F,N,T){this._onDidStateChange.fire(new x(this.reconnectionToken,F,N,T)),X(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=ee,ee._permanentFailure=!1,ee._permanentFailureMillisSinceLastIncomingData=0,ee._permanentFailureAttempt=0,ee._permanentFailureHandled=!1,ee._instances=[];class Q extends ee{constructor(F,N,T,A,O){super(1,F,A,O);this.client=this._register(new b.Client(O,{remoteAuthority:N,clientId:T},F.ipcLogger))}async _reconnect(F,N){await a(F,N)}}e.ManagementPersistentConnection=Q;class H extends ee{constructor(F,N,T,A,O){super(2,F,T,A);this._startArguments=N,this.debugPort=O}async _reconnect(F,N){await f(F,this._startArguments,N)}}e.ExtensionHostPersistentConnection=H;function X(B){try{B.acceptDisconnect();const F=B.getSocket();B.dispose(),F.dispose()}catch(F){(0,D.onUnexpectedError)(F)}}function z(B){if(B&&B.type==="error"){const F=new Error(`Connection error: ${B.reason}`);return F.code="VSCODE_CONNECTION_ERROR",F}return null}function ie(B,F){for(;B.length<F;)B+=" ";return B}function $(B,F,N){return`[remote-connection][${ie(w(B),13)}][${F.substr(0,5)}\u2026][${N?"reconnect":"initial"}]`}function q(B,F){return`${$(F,B.reconnectionToken,!!B.reconnectionProtocol)}[${B.host}:${B.port}]`}function Y(B){return`${Date.now()-B} ms`}}),define(J[78],Z([0,1,10]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function n(D){return D.scheme===m.Schemas.vscodeRemote?D.authority:void 0}e.getRemoteAuthority=n;function L(D){if(!D)return;const M=D.indexOf("+");return M<0?D:D.substr(0,M)}e.getRemoteName=L}),define(J[56],Z([0,1,16,153,55,5,40]),function(V,e,m,n,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,D.createDecorator)("requestService");function S(t){return t.res.statusCode&&t.res.statusCode>=200&&t.res.statusCode<300||t.res.statusCode===1223}e.isSuccess=S;function g(t){return t.res.statusCode===204}async function b(t){if(!S(t))throw new Error("Server returned "+t.res.statusCode);return g(t)?null:(await(0,m.streamToBuffer)(t.stream)).toString()}e.asText=b;async function C(t){if(!S(t))throw new Error("Server returned "+t.res.statusCode);if(g(t))return null;const p=(await(0,m.streamToBuffer)(t.stream)).toString();try{return JSON.parse(p)}catch(v){throw v.message+=`:
`+p,v}}e.asJson=C;function I(t){w(t)}e.updateProxyConfigurationsScope=I;let E;function w(t){const d=M.Registry.as(L.Extensions.Configuration),p=E;E={id:"http",order:15,title:(0,n.localize)(0,null),type:"object",scope:t,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,n.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,n.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,n.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,n.localize)(4,null),(0,n.localize)(5,null),(0,n.localize)(6,null),(0,n.localize)(7,null)],default:"override",description:(0,n.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,n.localize)(9,null),restricted:!0}}},d.updateConfigurations({add:[E],remove:p?[p]:[]})}w(2)}),define(J[203],Z([0,1,204,14]),function(V,e,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function L(M,S){return M.protocol==="http:"?S.HTTP_PROXY||S.http_proxy||null:M.protocol==="https:"&&(S.HTTPS_PROXY||S.https_proxy||S.HTTP_PROXY||S.http_proxy)||null}async function D(M,S,g={}){const b=(0,m.parse)(M),C=g.proxyUrl||L(b,S);if(!C)return null;const I=(0,m.parse)(C);if(!/^https?:$/.test(I.protocol||""))return null;const E={host:I.hostname||"",port:I.port||(I.protocol==="https"?"443":"80"),auth:I.auth,rejectUnauthorized:(0,n.isBoolean)(g.strictSSL)?g.strictSSL:!0};return b.protocol==="http:"?new(await new Promise((w,t)=>{V(["http-proxy-agent"],w,t)}))(E):new(await new Promise((w,t)=>{V(["https-proxy-agent"],w,t)}))(E)}e.getProxyAgent=D}),define(J[79],Z([0,1,5]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,m.createDecorator)(e.SIGN_SERVICE_ID)}),define(J[205],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class m{constructor(){this.validators=new Map}vsda(){return new Promise((L,D)=>V(["vsda"],L,D))}async createNewMessage(L){try{const D=await this.vsda(),M=new D.validator;if(M){const S=String(m._nextId++);return this.validators.set(S,M),{id:S,data:M.createNewMessage(L)}}}catch{}return{id:"",data:L}}async validate(L,D){if(!L.id)return!0;const M=this.validators.get(L.id);if(!M)return!1;this.validators.delete(L.id);try{return M.validate(D)==="ok"}catch{return!1}}async sign(L){try{const D=await this.vsda(),M=new D.signer;if(M)return M.sign(L)}catch{}return L}}e.SignService=m,m._nextId=1}),define(J[38],Z([0,1,5]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,m.createDecorator)("stateMainService")}),define(J[18],Z([0,1,12,9,4,2,3,36,14,5,186,6,38]),function(V,e,m,n,L,D,M,S,g,b,C,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,b.createDecorator)("lifecycleMainService");var w;(function(p){p[p.QUIT=1]="QUIT",p[p.KILL=2]="KILL"})(w=e.ShutdownReason||(e.ShutdownReason={}));var t;(function(p){p[p.Starting=1]="Starting",p[p.Ready=2]="Ready",p[p.AfterWindowOpen=3]="AfterWindowOpen"})(t=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let d=class mt extends D.Disposable{constructor(v,P){super();this.logService=v,this.stateMainService=P,this._onBeforeShutdown=this._register(new L.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new L.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new L.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new L.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new L.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(mt.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(mt.QUIT_AND_RESTART_KEY)}registerListeners(){const v=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),M.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(1))};m.app.addListener("before-quit",v);const P=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!M.isMacintosh)&&m.app.quit()};m.app.addListener("window-all-closed",P),m.app.once("will-quit",h=>{this.logService.trace("Lifecycle#app.on(will-quit)"),h.preventDefault(),this.fireOnWillShutdown(1).finally(()=>{this.resolvePendingQuitPromise(!1),m.app.removeListener("before-quit",v),m.app.removeListener("window-all-closed",P),m.app.quit()})})}fireOnWillShutdown(v){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const P=[];return this._onWillShutdown.fire({reason:v,join(h){P.push(h)}}),this.pendingWillShutdownPromise=(async()=>{try{await n.Promises.settled(P)}catch(h){this.logService.error(h)}try{await this.stateMainService.close()}catch(h){this.logService.error(h)}})(),this.pendingWillShutdownPromise}set phase(v){if(v<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===v)return;this.logService.trace(`lifecycle (main): phase changed (value: ${v})`),this._phase=v;const P=this.phaseWhen.get(this._phase);P&&(P.open(),this.phaseWhen.delete(this._phase))}async when(v){if(v<=this._phase)return;let P=this.phaseWhen.get(v);P||(P=new n.Barrier,this.phaseWhen.set(v,P)),await P.wait()}registerWindow(v){const P=new D.DisposableStore;this.windowCounter++,P.add(v.onWillLoad(l=>this._onWillLoadWindow.fire({window:v,workspace:l.workspace,reason:l.reason})));const h=(0,g.assertIsDefined)(v.win);h.on("close",l=>{const c=v.id;if(this.windowToCloseRequest.has(c)){this.windowToCloseRequest.delete(c);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${v.id}`),l.preventDefault(),this.unload(v,1).then(a=>{if(a){this.windowToCloseRequest.delete(c);return}this.windowToCloseRequest.add(c),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${c}`),this._onBeforeCloseWindow.fire(v),v.close()})}),h.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${v.id}`),this.windowCounter--,P.dispose(),this.windowCounter===0&&(!M.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(1)})}async reload(v,P){await this.unload(v,3)||v.reload(P)}async unload(v,P){if(!v.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${v.id}`);const h=this._quitRequested?2:P;let l=await this.onBeforeUnloadWindowInRenderer(v,h);return l?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${v.id})`),this.handleWindowUnloadVeto(l)):(l=await this.onBeforeUnloadWindowInMain(v,h),l?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${v.id})`),this.handleWindowUnloadVeto(l)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${v.id})`),await this.onWillUnloadWindowInRenderer(v,h),!1))}handleWindowUnloadVeto(v){return v?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(v){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(v),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(v,P){return new Promise(h=>{const l=this.oneTimeListenerTokenGenerator++,c=`vscode:ok${l}`,a=`vscode:cancel${l}`;m.ipcMain.once(c,()=>{h(!1)}),m.ipcMain.once(a,()=>{h(!0)}),v.send("vscode:onBeforeUnload",{okChannel:c,cancelChannel:a,reason:P})})}onBeforeUnloadWindowInMain(v,P){const h=[];return this._onBeforeUnloadWindow.fire({reason:P,window:v,veto(l){h.push(l)}}),(0,C.handleVetos)(h,l=>this.logService.error(l))}onWillUnloadWindowInRenderer(v,P){return new Promise(h=>{const c=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;m.ipcMain.once(c,()=>h()),v.send("vscode:onWillUnload",{replyChannel:c,reason:P})})}quit(v){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${v}`),v&&this.stateMainService.setItem(mt.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(P=>{this.pendingQuitPromiseResolve=P,this.logService.trace("Lifecycle#quit() - calling app.quit()"),m.app.quit()}),this.pendingQuitPromise)}async relaunch(v){this.logService.trace("Lifecycle#relaunch()");const P=process.argv.slice(1);if(v?.addArgs&&P.push(...v.addArgs),v?.removeArgs)for(const c of v.removeArgs){const a=P.indexOf(c);a>=0&&P.splice(a,1)}const h=()=>{try{if(M.isWindows){const c=(0,S.cwd)();c!==process.cwd()&&process.chdir(c)}}catch(c){this.logService.error(c)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),m.app.relaunch({args:P})};m.app.once("quit",h),await this.quit(!0)&&m.app.removeListener("quit",h)}async kill(v){this.logService.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(2),await Promise.race([(0,n.timeout)(1e3),(async()=>{for(const P of m.BrowserWindow.getAllWindows())if(P&&!P.isDestroyed()){let h;P.webContents&&!P.webContents.isDestroyed()?h=new Promise(l=>P.once("closed",l)):h=Promise.resolve(),P.destroy(),await h}})()]),m.app.exit(v)}};d.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",d=ue([te(0,I.ILogService),te(1,E.IStateMainService)],d),e.LifecycleMainService=d}),define(J[206],Z([0,1,4,2,5,18]),function(V,e,m,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,L.createDecorator)("keyboardLayoutMainService");let M=class extends n.Disposable{constructor(b){super();this._onDidChangeKeyboardLayout=this._register(new m.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,b.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const b=await new Promise((C,I)=>{V(["native-keymap"],C,I)});this._keyboardLayoutData=S(b),b.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=S(b),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};M=ue([te(0,D.ILifecycleMainService)],M),e.KeyboardLayoutMainService=M;function S(g){const b=g.getKeyMap(),C=g.getCurrentKeyboardLayout();return{keyboardMapping:b,keyboardLayoutInfo:C}}}),define(J[97],Z([0,1,9,4,2,63,14,90,5]),function(V,e,m,n,L,D,M,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const b="__$__targetStorageMarker";e.IStorageService=(0,g.createDecorator)("storageService");var C;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(C=e.WillSaveStateReason||(e.WillSaveStateReason={}));var I;(function(p){p[p.GLOBAL=0]="GLOBAL",p[p.WORKSPACE=1]="WORKSPACE"})(I=e.StorageScope||(e.StorageScope={}));var E;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})(E=e.StorageTarget||(e.StorageTarget={}));class w extends L.Disposable{constructor(v={flushInterval:w.DEFAULT_FLUSH_INTERVAL}){super();this.options=v,this._onDidChangeValue=this._register(new n.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new n.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new n.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new m.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new L.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,m.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,L.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,D.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,D.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(v,P){P===b?(v===0?this._globalKeyTargets=void 0:v===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:v})):this._onDidChangeValue.fire({scope:v,key:P,target:this.getKeyTargets(v)[P]})}emitWillSaveState(v){this._onWillSaveState.fire({reason:v})}get(v,P,h){return this.getStorage(P)?.get(v,h)}getBoolean(v,P,h){return this.getStorage(P)?.getBoolean(v,h)}getNumber(v,P,h){return this.getStorage(P)?.getNumber(v,h)}store(v,P,h,l){if((0,M.isUndefinedOrNull)(P)){this.remove(v,h);return}this.withPausedEmitters(()=>{this.updateKeyTarget(v,h,l),this.getStorage(h)?.set(v,P)})}remove(v,P){this.withPausedEmitters(()=>{this.updateKeyTarget(v,P,void 0),this.getStorage(P)?.delete(v)})}withPausedEmitters(v){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{v()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(v,P){const h=[],l=this.getKeyTargets(v);for(const c of Object.keys(l))l[c]===P&&h.push(c);return h}updateKeyTarget(v,P,h){const l=this.getKeyTargets(P);typeof h=="number"?l[v]!==h&&(l[v]=h,this.getStorage(P)?.set(b,JSON.stringify(l))):typeof l[v]=="number"&&(delete l[v],this.getStorage(P)?.set(b,JSON.stringify(l)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(v){return v===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(v){const P=this.get(b,v);if(P)try{return JSON.parse(P)}catch{}return Object.create(null)}isNew(v){return this.getBoolean(e.IS_NEW_KEY,v)===!0}async flush(v=C.NONE){this._onWillSaveState.fire({reason:v});const P=this.getStorage(0),h=this.getStorage(1);switch(v){case C.NONE:await m.Promises.settled([P?.whenFlushed()??Promise.resolve(),h?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await m.Promises.settled([P?.flush(0)??Promise.resolve(),h?.flush(0)??Promise.resolve()]);break}}async logStorage(){const v=this.getStorage(0)?.items??new Map,P=this.getStorage(1)?.items??new Map;return d(v,P,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=w,w.DEFAULT_FLUSH_INTERVAL=60*1e3;class t extends w{constructor(){super();this.globalStorage=this._register(new S.Storage(new S.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new S.Storage(new S.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(v=>this.emitDidChangeValue(1,v))),this._register(this.globalStorage.onDidChangeStorage(v=>this.emitDidChangeValue(0,v)))}getStorage(v){return v===0?this.globalStorage:this.workspaceStorage}getLogDetails(v){return v===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(v){}}e.InMemoryStorageService=t;async function d(p,v,P,h){const l=o=>{try{return JSON.parse(o)}catch{return o}},c=new Map,a=new Map;p.forEach((o,u)=>{c.set(u,o),a.set(u,l(o))});const f=new Map,r=new Map;v.forEach((o,u)=>{f.set(u,o),r.set(u,l(o))}),console.group(`Storage: Global (path: ${P})`);let i=[];c.forEach((o,u)=>{i.push({key:u,value:o})}),console.table(i),console.groupEnd(),console.log(a),console.group(`Storage: Workspace (path: ${h})`);let s=[];f.forEach((o,u)=>{s.push({key:u,value:o})}),console.table(s),console.groupEnd(),console.log(r)}e.logStorage=d}),define(J[207],Z([0,1,3,36,8,31]),function(V,e,m,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function M(b){if(m.platform===2&&/^penguin(\.|$)/i.test(b))return"chromebook"}async function S(b,C,I,E,w,t,d,p,v,P){const h=Object.create(null);h["common.machineId"]=d,h.sessionID=(0,D.generateUuid)()+Date.now(),h.commitHash=w,h.version=t,h["common.platformVersion"]=(C||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,m.PlatformToString)(m.platform),h["common.nodePlatform"]=n.platform,h["common.nodeArch"]=E,h["common.product"]=P||"desktop";const l=g(p||[]);l&&(h["common.msftInternal"]=l);let c=0;const a=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-a,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),m.isLinuxSnap&&(h["common.snap"]="true");const f=M(I);f&&(h["common.platformDetail"]=f);try{const r=await b.readFile(L.URI.file(v));h["common.source"]=r.value.toString().slice(0,30)}catch{}return h}e.resolveCommonProperties=S;function g(b){const C=n.env.USERDNSDOMAIN;if(!C)return!1;const I=C.toLowerCase();return b.some(E=>I===E)}e.verifyMicrosoftInternalDomain=g}),define(J[32],Z([0,1,5]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,m.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,m.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var n;(function(D){D[D.NONE=0]="NONE",D[D.CRASH=1]="CRASH",D[D.ERROR=2]="ERROR",D[D.USAGE=3]="USAGE"})(n=e.TelemetryLevel||(e.TelemetryLevel={}));var L;(function(D){D.OFF="off",D.CRASH="crash",D.ERROR="error",D.ON="all"})(L=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(J[208],Z([0,1,26,68,9,44,10,7,3,8,71,24,87,75,20,21,32]),function(V,e,m,n,L,D,M,S,g,b,C,I,E,w,t,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const v=new Map;async function P(f,r){const i=`${f}::${r.join(":")}`,s=v.get(i);if(s)return s;const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],u=new Map,y=new Map,k=2e4;function R(U,K,x,ee){const Q=K.substring(U.length+1);return L.Promises.withAsyncBody(async H=>{let X;try{X=await I.Promises.readdir(K,{withFileTypes:!0})}catch{H();return}if(ee.count>=k){ee.count+=X.length,ee.maxReached=!0,H();return}let z=X.length;if(z===0){H();return}let ie=X;ee.count+X.length>k&&(ee.maxReached=!0,z=k-ee.count,ie=X.slice(0,z)),ee.count+=X.length;for(const $ of ie)if($.isDirectory()){if(x.includes($.name)||await R(U,(0,S.join)(K,$.name),x,ee),--z==0){H();return}}else{const q=$.name.lastIndexOf(".");if(q>=0){const Y=$.name.substring(q+1);Y&&u.set(Y,(u.get(Y)??0)+1)}for(const Y of o)Y.relativePathPattern?.test(Q)!==!1&&Y.filePattern.test($.name)&&y.set(Y.tag,(y.get(Y.tag)??0)+1);if(--z==0){H();return}}})}const W=L.Promises.withAsyncBody(async U=>{const K={count:0,maxReached:!1};await R(f,f,r,K);const x=await c(f);U({configFiles:h(y),fileTypes:h(u),fileCount:K.count,maxFilesReached:K.maxReached,launchConfigFiles:x})});return v.set(i,W),W}e.collectWorkspaceStats=P;function h(f){return[...n.Iterable.map(f.entries(),([r,i])=>({name:r,count:i}))].sort((r,i)=>i.count-r.count)}function l(){const f={os:`${m.type()} ${m.arch()} ${m.release()}`,memory:`${(m.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(m.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(C.virtualMachineHint.value()*100)}%`},r=m.cpus();return r&&r.length>0&&(f.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),f}e.getMachineInfo=l;async function c(f){try{const r=new Map,i=(0,S.join)(f,".vscode","launch.json"),s=await I.Promises.readFile(i),o=[],u=(0,D.parse)(s.toString(),o);if(o.length)return console.log(`Unable to parse ${i}`),[];if((0,D.getNodeType)(u)==="object"&&u.configurations)for(const y of u.configurations){const k=y.type;k&&(r.has(k)?r.set(k,r.get(k)+1):r.set(k,1))}return h(r)}catch{return[]}}e.collectLaunchConfigs=c;let a=class{constructor(r,i){this.telemetryService=r,this.productService=i}formatMachineInfo(r){const i=[];return i.push(`OS Version:       ${r.os}`),i.push(`CPUs:             ${r.cpus}`),i.push(`Memory (System):  ${r.memory}`),i.push(`VM:               ${r.vmHint}`),i.join(`
`)}formatEnvironment(r){const i=[];i.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),i.push(`OS Version:       ${m.type()} ${m.arch()} ${m.release()}`);const s=m.cpus();return s&&s.length>0&&i.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),i.push(`Memory (System):  ${(m.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(m.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`),g.isWindows||i.push(`Load (avg):       ${m.loadavg().map(o=>Math.round(o)).join(", ")}`),i.push(`VM:               ${Math.round(C.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${r.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.expandGPUFeatures(r.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(r,i){return Promise.all([(0,E.listProcesses)(r.mainPID),this.formatWorkspaceMetadata(r)]).then(async s=>{let[o,u]=s,y=this.formatProcessList(r,o);return i.forEach(k=>{if((0,w.isRemoteDiagnosticError)(k))y+=`
${k.errorMessage}`,u+=`
${k.errorMessage}`;else if(y+=`

Remote: ${k.hostName}`,k.processes&&(y+=`
${this.formatProcessList(r,k.processes)}`),k.workspaceMetadata){u+=`
|  Remote: ${k.hostName}`;for(const R of Object.keys(k.workspaceMetadata)){const W=k.workspaceMetadata[R];let U=`${W.fileCount} files`;W.maxFilesReached&&(U=`more than ${U}`),u+=`|    Folder (${R}): ${U}`,u+=this.formatWorkspaceStats(W)}}}),{processInfo:y,workspaceInfo:u}})}async getSystemInfo(r,i){const{memory:s,vmHint:o,os:u,cpus:y}=l(),k={os:u,memory:s,cpus:y,vmHint:o,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:i};return g.isWindows||(k.load=`${m.loadavg().map(R=>Math.round(R)).join(", ")}`),g.isLinux&&(k.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(k)}async getDiagnostics(r,i){const s=[];return(0,E.listProcesses)(r.mainPID).then(async o=>(s.push(""),s.push(this.formatEnvironment(r)),s.push(""),s.push(this.formatProcessList(r,o)),r.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.formatWorkspaceMetadata(r))),i.forEach(u=>{if((0,w.isRemoteDiagnosticError)(u))s.push(`
${u.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${u.hostName}`),s.push(this.formatMachineInfo(u.machineInfo)),u.processes&&s.push(this.formatProcessList(r,u.processes)),u.workspaceMetadata)for(const y of Object.keys(u.workspaceMetadata)){const k=u.workspaceMetadata[y];let R=`${k.fileCount} files`;k.maxFilesReached&&(R=`more than ${R}`),s.push(`Folder (${y}): ${R}`),s.push(this.formatWorkspaceStats(k))}}),s.push(""),s.push(""),s.join(`
`)))}formatWorkspaceStats(r){const i=[],s=60;let o=0;const u=(W,U)=>{const K=` ${W}(${U})`;o+K.length>s?(i.push(y),y="|                 ",o=y.length):o+=K.length,y+=K};let y="|      File types:";const k=10;let R=r.fileTypes.length>k?k:r.fileTypes.length;for(let W=0;W<R;W++){const U=r.fileTypes[W];u(U.name,U.count)}if(i.push(y),r.configFiles.length>=0&&(y="|      Conf files:",o=0,r.configFiles.forEach(W=>{u(W.name,W.count)}),i.push(y)),r.launchConfigFiles.length>0){let W="|      Launch Configs:";r.launchConfigFiles.forEach(U=>{W+=U.count>1?` ${U.name}(${U.count})`:` ${U.name}`}),i.push(W)}return i.join(`
`)}expandGPUFeatures(r){const i=Math.max(...Object.keys(r).map(s=>s.length));return Object.keys(r).map(s=>`${s}:  ${" ".repeat(i-s.length)}  ${r[s]}`).join(`
                  `)}formatWorkspaceMetadata(r){const i=[],s=[];return r.windows.forEach(o=>{o.folderURIs.length===0||!!o.remoteAuthority||(i.push(`|  Window (${o.title})`),o.folderURIs.forEach(u=>{const y=b.URI.revive(u);if(y.scheme===M.Schemas.file){const k=y.fsPath;s.push(P(k,["node_modules",".git"]).then(R=>{let W=`${R.fileCount} files`;R.maxFilesReached&&(W=`more than ${W}`),i.push(`|    Folder (${(0,S.basename)(k)}): ${W}`),i.push(this.formatWorkspaceStats(R))}).catch(R=>{i.push(`|      Error: Unable to collect workspace stats for folder ${k} (${R.toString()})`)}))}else i.push(`|    Folder (${y.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(o=>i.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}formatProcessList(r,i){const s=new Map;r.windows.forEach(u=>s.set(u.pid,u.title));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),i&&this.formatProcessItem(r.mainPID,s,o,i,0),o.join(`
`)}formatProcessItem(r,i,s,o,u){const y=u===0;let k;y?k=o.pid===r?`${this.productService.applicationName} main`:"remote agent":(k=`${"  ".repeat(u)} ${o.name}`,o.name==="window"&&(k=`${k} (${i.get(o.pid)})`));const R=process.platform==="win32"?o.mem:m.totalmem()*(o.mem/100);s.push(`${o.load.toFixed(0).padStart(5," ")}	${(R/t.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${k}`),Array.isArray(o.children)&&o.children.forEach(W=>this.formatProcessItem(r,i,s,W,u+1))}async getWorkspaceFileExtensions(r){const i=new Set;for(const{uri:s}of r.folders){const o=b.URI.revive(s);if(o.scheme!==M.Schemas.file)continue;const u=o.fsPath;try{(await P(u,["node_modules",".git"])).fileTypes.forEach(k=>i.add(k.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(r){for(const{uri:i}of r.folders){const s=b.URI.revive(i);if(s.scheme!==M.Schemas.file)continue;const o=s.fsPath;try{const u=await P(o,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),u.fileTypes.forEach(y=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:y.name,count:y.count})}),u.launchConfigFiles.forEach(y=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:y.name,count:y.count})}),u.configFiles.forEach(y=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:y.name,count:y.count})})}catch{}}}};a=ue([te(0,p.ITelemetryService),te(1,d.IProductService)],a),e.DiagnosticsService=a}),define(J[209],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class m{constructor(D){this.appenders=D}listen(D,M){throw new Error(`Event not found: ${M}`)}call(D,M,{eventName:S,data:g}){return this.appenders.forEach(b=>b.log(S,g)),Promise.resolve(null)}}e.TelemetryAppenderChannel=m;class n{constructor(D){this.channel=D}log(D,M){return this.channel.call("log",{eventName:D,data:M}).then(void 0,S=>`Failed to log telemetry: ${console.warn(S)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=n}),define(J[64],Z([0,1,49,14,19,32]),function(V,e,m,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class M{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(P,h){return Promise.resolve(void 0)}publicLog2(P,h){return this.publicLog(P,h)}publicLogError(P,h){return Promise.resolve(void 0)}publicLogError2(P,h){return this.publicLogError(P,h)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=M,e.NullTelemetryService=new M;class S{async publicLog(P,h,l){}async publicLogError(P,h,l){}}e.NullEndpointTelemetryService=S,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function g(v,P){return P.onDidChangeConfiguration(h=>{h.source!==6&&v.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(h.source),configurationKeys:t(h.sourceConfig)})})}e.configurationTelemetry=g;function b(v,P){return!(P.disableTelemetry||!v.enableTelemetry||P.extensionTestsLocationURI)}e.supportsTelemetry=b;function C(v){const P=v.getValue(D.TELEMETRY_SETTING_ID),h=v.getValue("telemetry.enableCrashReporter");if(v.getValue(D.TELEMETRY_OLD_SETTING_ID)===!1||h===!1)return 0;switch(P??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=C;function I(v){const P=Object.create(null),h=Object.create(null),l=Object.create(null);w(v,l);for(let c in l){c=c.length>150?c.substr(c.length-149):c;const a=l[c];typeof a=="number"?h[c]=a:typeof a=="boolean"?h[c]=a?1:0:typeof a=="string"?(a.length>8192&&console.warn(`Telemetry property: ${c} has been trimmed to 8192, the original length is ${a.length}`),P[c]=a.substring(0,8191)):typeof a!="undefined"&&a!==null&&(P[c]=a)}return{properties:P,measurements:h}}e.validateTelemetryData=I;function E(v){if(!v)return"none";let P="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(l=>{v.indexOf(`${l}+`)===0&&(P=l)}),P}e.cleanRemoteAuthority=E;function w(v,P,h=0,l){if(!!v)for(let c of Object.getOwnPropertyNames(v)){const a=v[c],f=l?l+c:c;Array.isArray(a)?P[f]=(0,m.safeStringify)(a):a instanceof Date?P[f]=a.toISOString():(0,n.isObject)(a)?h<2?w(a,P,h+1,f+"."):P[f]=(0,m.safeStringify)(a):P[f]=a}}function t(v){if(!v)return[];const P=[];return d(P,"",v),P}function d(v,P,h){h&&typeof h=="object"&&!Array.isArray(h)?Object.keys(h).forEach(l=>d(v,P?`${P}.${l}`:l,h[l])):v.push(P)}function p(v){return[v.appRoot,v.extensionsPath,v.userHome.fsPath,v.tmpDir.fsPath,v.userDataPath]}e.getPiiPathsFromEnvironment=p}),define(J[210],Z([0,1,172,64]),function(V,e,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function L(D,M,S,g,b,C){const I={"X-Market-Client-Id":`VSCode ${D}`,"User-Agent":`VSCode ${D} (${M.nameShort})`},E=await(0,m.getServiceMachineId)(S,b,C);return(0,n.supportsTelemetry)(M,S)&&(0,n.getTelemetryLevel)(g)===3&&(I["X-Market-User-Id"]=E),I}e.resolveMarketplaceHeaders=L}),define(J[211],Z([0,1,2,49,3,27,154,19,55,53,40,32,64]),function(V,e,m,n,L,D,M,S,g,b,C,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let w=class{constructor(p,v){this._configurationService=v,this._experimentProperties={},this._disposables=new m.DisposableStore,this._cleanupPatterns=[],this._appenders=p.appenders,this._commonProperties=p.commonProperties||Promise.resolve({}),this._piiPaths=p.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!p.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let P of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,D.escapeRegExpCharacters)(P),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(p,v){this._experimentProperties[p]=v}_updateTelemetryLevel(){this._telemetryLevel=(0,E.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const p=await this._commonProperties;let v=p.sessionID,P=p["common.machineId"],h=p["common.firstSessionDate"],l=p["common.msftInternal"];return{sessionId:v,machineId:P,firstSessionDate:h,msftInternal:l}}dispose(){this._disposables.dispose()}_log(p,v,P,h){return this.telemetryLevel<v?Promise.resolve(void 0):this._commonProperties.then(l=>{P=(0,n.mixin)(P,l),P=(0,n.mixin)(P,this._experimentProperties),P=(0,n.cloneAndChange)(P,c=>{if(typeof c=="string")return this._cleanupInfo(c,h)}),this._appenders.forEach(c=>c.log(p,P))},l=>{console.error(l)})}publicLog(p,v,P){return this._log(p,3,v,P)}publicLog2(p,v,P){return this.publicLog(p,v,P)}publicLogError(p,v){return this.sendErrorTelemetry?this._log(p,2,v,!0):Promise.resolve(void 0)}publicLogError2(p,v){return this.publicLogError(p,v)}_anonymizeFilePaths(p){let v=p;const P=[];for(let a of this._cleanupPatterns)for(;;){const f=a.exec(p);if(!f)break;P.push([f.index,a.lastIndex])}const h=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,l=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let c=0;for(v="";;){const a=l.exec(p);if(!a)break;!h.test(a[0])&&P.every(([f,r])=>a.index<f||a.index>=r)&&(v+=p.substring(c,a.index)+"<REDACTED: user-file-path>",c=l.lastIndex)}return c<p.length&&(v+=p.substr(c)),v}_removePropertiesWithPossibleUserInfo(p){if(!p)return p;const v=p.toLowerCase(),P=/@[a-zA-Z0-9-.]+/,h=/(key|token|sig|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/,l=/xox[pbaors]\-[a-zA-Z0-9]+\-[a-zA-Z0-9\-]+?/;return h.test(v)?"<REDACTED: secret>":P.test(v)?"<REDACTED: email>":l.test(v)?"<REDACTED: token>":p}_cleanupInfo(p,v){let P=p;v&&(P=this._anonymizeFilePaths(P));for(let h of this._cleanupPatterns)P=P.replace(h,"");return P=this._removePropertiesWithPossibleUserInfo(P),P}};w.IDLE_START_EVENT_NAME="UserIdleStart",w.IDLE_STOP_EVENT_NAME="UserIdleStop",w=ue([te(1,S.IConfigurationService)],w),e.TelemetryService=w;function t(){const d=(0,M.localize)(0,null,b.default.nameLong),p=b.default.privacyStatementUrl?(0,M.localize)(2,null,"https://aka.ms/vscode-telemetry",b.default.privacyStatementUrl):(0,M.localize)(1,null,"https://aka.ms/vscode-telemetry"),v=L.isWeb?"":(0,M.localize)(3,null),P=(0,M.localize)(4,null),h=(0,M.localize)(5,null),l=(0,M.localize)(6,null),c=(0,M.localize)(7,null),a=`
|       | ${P} | ${h} | ${l} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,f=(0,M.localize)(8,null);return`
${d} ${p} ${v}

&nbsp;

${c}
${a}

&nbsp;

${f}
`}C.Registry.as(g.Extensions.Configuration).registerConfiguration({id:I.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,M.localize)(9,null),properties:{[I.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,M.localize)(10,null),(0,M.localize)(11,null),(0,M.localize)(12,null),(0,M.localize)(13,null)],markdownDescription:t(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),C.Registry.as(g.Extensions.Configuration).registerConfiguration({id:I.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,M.localize)(14,null),properties:{[I.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:b.default.privacyStatementUrl?(0,M.localize)(16,null,b.default.nameLong,b.default.privacyStatementUrl):(0,M.localize)(15,null,b.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,M.localize)(17,null,`\`#${I.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(J[98],Z([0,1,45,7,155,23,39,15,3,31,137,50,9]),function(V,e,m,n,L,D,M,S,g,b,C,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const w=1e4;let t;async function d(v,P,h){return P["force-disable-user-env"]?(v.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):g.isWindows?(v.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,I.isLaunchedFromCli)(h)&&!P["force-user-env"]?(v.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,I.isLaunchedFromCli)(h)?v.trace("resolveShellEnv(): running (--force-user-env)"):v.trace("resolveShellEnv(): running (macOS/Linux)"),t||(t=E.Promises.withAsyncBody(async(l,c)=>{const a=new D.CancellationTokenSource,f=setTimeout(()=>{a.dispose(!0),c(new Error((0,L.localize)(0,null)))},w);try{l(await p(v,a.token))}catch(r){!(0,S.isCancellationError)(r)&&!a.token.isCancellationRequested?c(new Error((0,L.localize)(1,null,(0,M.toErrorMessage)(r)))):l({})}finally{clearTimeout(f),a.dispose()}})),t)}e.getResolvedShellEnv=d;async function p(v,P){const h=process.env.ELECTRON_RUN_AS_NODE;v.trace("getUnixShellEnvironment#runAsNode",h);const l=process.env.ELECTRON_NO_ATTACH_CONSOLE;v.trace("getUnixShellEnvironment#noAttach",l);const c=(0,b.generateUuid)().replace(/-/g,"").substr(0,12),a=new RegExp(c+"(.*)"+c),f={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};v.trace("getUnixShellEnvironment#env",f);const r=await(0,C.getSystemShell)(g.OS,f);return v.trace("getUnixShellEnvironment#shell",r),new Promise((i,s)=>{if(P.isCancellationRequested)return s((0,S.canceled)());const o=(0,n.basename)(r);let u,y;const k=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(u=`& '${process.execPath}' ${k} -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,y=["-Login","-Command"]):(u=`'${process.execPath}' ${k} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,o==="tcsh"?y=["-ic"]:y=["-ilc"]),v.trace("getUnixShellEnvironment#spawn",JSON.stringify(y),u);const R=(0,m.spawn)(r,[...y,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:f});P.onCancellationRequested(()=>(R.kill(),s((0,S.canceled)()))),R.on("error",K=>{v.error("getUnixShellEnvironment#errorChildProcess",(0,M.toErrorMessage)(K)),s(K)});const W=[];R.stdout.on("data",K=>W.push(K));const U=[];R.stderr.on("data",K=>U.push(K)),R.on("close",(K,x)=>{const ee=Buffer.concat(W).toString("utf8");v.trace("getUnixShellEnvironment#raw",ee);const Q=Buffer.concat(U).toString("utf8");if(Q.trim()&&v.trace("getUnixShellEnvironment#stderr",Q),K||x)return s(new Error((0,L.localize)(2,null,K,x)));const H=a.exec(ee),X=H?H[1]:"{}";try{const z=JSON.parse(X);h?z.ELECTRON_RUN_AS_NODE=h:delete z.ELECTRON_RUN_AS_NODE,l?z.ELECTRON_NO_ATTACH_CONSOLE=l:delete z.ELECTRON_NO_ATTACH_CONSOLE,delete z.XDG_RUNTIME_DIR,v.trace("getUnixShellEnvironment#result",z),i(z)}catch(z){v.error("getUnixShellEnvironment#errorCaught",(0,M.toErrorMessage)(z)),s(z)}})})}}),define(J[212],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var m;(function(n){n.DARK="dark",n.LIGHT="light",n.HIGH_CONTRAST="hc"})(m=e.ColorScheme||(e.ColorScheme={}))}),define(J[213],Z([0,1,107,4,2,5,40,212]),function(V,e,m,n,L,D,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,D.createDecorator)("themeService");var g;(function(p){function v(P){return P&&typeof P=="object"&&typeof P.id=="string"}p.isThemeColor=v})(g=e.ThemeColor||(e.ThemeColor={}));function b(p){return{id:p}}e.themeColorFromId=b;var C;(function(p){function v(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||g.isThemeColor(i.color))}p.isThemeIcon=v;const P=new RegExp(`^\\$\\((${m.CSSIcon.iconNameExpression}(?:${m.CSSIcon.iconModifierExpression})?)\\)$`);function h(i){const s=P.exec(i);if(!s)return;let[,o]=s;return{id:o}}p.fromString=h;function l(i){return{id:i}}p.fromId=l;function c(i,s){let o=i.id;const u=o.lastIndexOf("~");return u!==-1&&(o=o.substring(0,u)),s&&(o=`${o}~${s}`),{id:o}}p.modify=c;function a(i){const s=i.id.lastIndexOf("~");if(s!==-1)return i.id.substring(s+1)}p.getModifier=a;function f(i,s){return i.id===s.id&&i.color?.id===s.color?.id}p.isEqual=f;function r(i,s){return{id:i.id,color:s?b(s):void 0}}p.asThemeIcon=r,p.asClassNameArray=m.CSSIcon.asClassNameArray,p.asClassName=m.CSSIcon.asClassName,p.asCSSSelector=m.CSSIcon.asCSSSelector})(C=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=m.Codicon.file,e.FolderThemeIcon=m.Codicon.folder;function I(p){switch(p){case S.ColorScheme.DARK:return"vs-dark";case S.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class E{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new n.Emitter}onColorThemeChange(v){return this.themingParticipants.push(v),this.onThemingParticipantAddedEmitter.fire(v),(0,L.toDisposable)(()=>{const P=this.themingParticipants.indexOf(v);this.themingParticipants.splice(P,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let w=new E;M.Registry.add(e.Extensions.ThemingContribution,w);function t(p){return w.onColorThemeChange(p)}e.registerThemingParticipant=t;class d extends L.Disposable{constructor(v){super();this.themeService=v,this.theme=v.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(P=>this.onThemeChange(P)))}onThemeChange(v){this.theme=v,this.updateStyles()}updateStyles(){}getColor(v,P){let h=this.theme.getColor(v);return h&&P&&(h=P(h,this.theme)),h?h.toString():null}}e.Themable=d}),define(J[65],Z([0,1,12,3,5,38]),function(V,e,m,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const M="#FFFFFF",S="#1E1E1E",g="#000000",b="theme",C="themeBackground",I="windowSplash";e.IThemeMainService=(0,L.createDecorator)("themeMainService");let E=class{constructor(t){this.stateMainService=t}getBackgroundColor(){if((n.isWindows||n.isMacintosh)&&m.nativeTheme.shouldUseInvertedColorScheme)return g;let t=this.stateMainService.getItem(C,null);if(!t){let d;(n.isWindows||n.isMacintosh)&&m.nativeTheme.shouldUseInvertedColorScheme?d="hc-black":d=this.stateMainService.getItem(b,"vs-dark").split(" ")[0],t=d==="hc-black"?g:d==="vs"?M:S}return n.isMacintosh&&t.toUpperCase()===S&&(t="#171717"),t}saveWindowSplash(t,d){this.stateMainService.setItems([{key:b,data:d.baseTheme},{key:C,data:d.colorInfo.background},{key:I,data:d}]),typeof t=="number"&&this.updateBackgroundColor(t,d)}updateBackgroundColor(t,d){for(const p of m.BrowserWindow.getAllWindows())if(p.id===t){p.setBackgroundColor(d.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(I)}};E=ue([te(0,D.IStateMainService)],E),e.ThemeMainService=E}),define(J[99],Z([0,1,4,3,5,6]),function(V,e,m,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,L.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,L.createDecorator)("sharedTunnelsService");var M;(function(t){t.Http="http",t.Https="https"})(M=e.TunnelProtocol||(e.TunnelProtocol={}));var S;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(S=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var g;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(g=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function b(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const d=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(!!d)return{address:d[1],port:+d[2]}}e.extractLocalHostUriMetaDataForPortMapping=b,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function C(t){return e.LOCALHOST_ADDRESSES.indexOf(t)>=0}e.isLocalhost=C,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function I(t){return e.ALL_INTERFACES_ADDRESSES.indexOf(t)>=0}e.isAllInterfaces=I;function E(t,d){return d?d!==1&&t<1024:!n.isWindows&&t<1024}e.isPortPrivileged=E;let w=class{constructor(d){this.logService=d,this._onTunnelOpened=new m.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new m.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new m.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(d){return this._tunnelProvider=d,d?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(d){this._canElevate=d.elevation,this._privacyOptions=d.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const d=[],p=Array.from(this._tunnels.values());for(let v of p){const P=Array.from(v.values());for(let h of P){const l=await h.value;l&&d.push(l)}}return d}async dispose(){for(const d of this._tunnels.values()){for(const{value:p}of d.values())await p.then(v=>v?.dispose());d.clear()}this._tunnels.clear()}openTunnel(d,p,v,P,h=!1,l=S.Private,c){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${p}:${v} on local port ${P}.`),!d)return;p||(p="localhost");const a=this.retainOrCreateTunnel(d,p,v,P,h,l,c);return a?a.then(f=>{if(!f){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(p,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(f);return(f.tunnelRemoteHost!==p||f.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}makeTunnel(d){return{tunnelRemotePort:d.tunnelRemotePort,tunnelRemoteHost:d.tunnelRemoteHost,tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress,privacy:d.privacy,protocol:d.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${d.tunnelRemoteHost}:${d.tunnelRemotePort} `);const p=this._tunnels.get(d.tunnelRemoteHost);if(p){const v=p.get(d.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(d.tunnelRemoteHost,d.tunnelRemotePort,v))}}}}async tryDisposeTunnel(d,p,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${d}:${p}.`);const P=v.value.then(async h=>{h&&(await h.dispose(!0),this._onTunnelClosed.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this._tunnels.has(d)&&this._tunnels.get(d).delete(p),P}}async closeTunnel(d,p){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${d}:${p} `);const v=this._tunnels.get(d);if(v&&v.has(p)){const P=v.get(p);P.refcount=0,await this.tryDisposeTunnel(d,p,P)}}addTunnelToMap(d,p,v){this._tunnels.has(d)||this._tunnels.set(d,new Map),this._tunnels.get(d).set(p,{refcount:1,value:v})}async removeEmptyTunnelFromMap(d,p){const v=this._tunnels.get(d);v&&(await v.get(p)||v.delete(p),v.size===0&&this._tunnels.delete(d))}getTunnelFromMap(d,p){let v=[d];C(d)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):I(d)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const P=v.map(h=>this._tunnels.get(h));for(const h of P){const l=h?.get(p);if(l)return l}}canTunnel(d){return!!b(d)}createWithProvider(d,p,v,P,h,l,c){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${p}:${v} on local port ${P}.`);const f={elevationRequired:h?E(P===void 0?v:P):!1},r={remoteAddress:{host:p,port:v},localAddressPort:P,privacy:l,public:l!==S.Private,protocol:c},i=d.forwardPort(r,f);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(p,v,i),i}};w=ue([te(0,D.ILogService)],w),e.AbstractTunnelService=w}),define(J[41],Z([0,1,5]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var n;(function(D){D.Uninitialized="uninitialized",D.Idle="idle",D.CheckingForUpdates="checking for updates",D.AvailableForDownload="available for download",D.Downloading="downloading",D.Downloaded="downloaded",D.Updating="updating",D.Ready="ready"})(n=e.StateType||(e.StateType={}));var L;(function(D){D[D.Setup=0]="Setup",D[D.Archive=1]="Archive",D[D.Snap=2]="Snap"})(L=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(D,M)=>({type:"idle",updateType:D,error:M}),CheckingForUpdates:D=>({type:"checking for updates",explicit:D}),AvailableForDownload:D=>({type:"available for download",update:D}),Downloading:D=>({type:"downloading",update:D}),Downloaded:D=>({type:"downloaded",update:D}),Updating:D=>({type:"updating",update:D}),Ready:D=>({type:"ready",update:D})},e.IUpdateService=(0,m.createDecorator)("updateService")}),define(J[214],Z([0,1,3,156,55,40]),function(V,e,m,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),D.Registry.as(L.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,n.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,n.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,n.localize)(2,null),(0,n.localize)(3,null),(0,n.localize)(4,null),(0,n.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,n.localize)(6,null),deprecationMessage:(0,n.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,n.localize)(8,null),description:(0,n.localize)(9,null),included:m.isWindows&&!m.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,n.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(J[215],Z([0,1,4,41]),function(V,e,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class L{constructor(S){this.service=S}listen(S,g){switch(g){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${g}`)}call(S,g,b){switch(g){case"checkForUpdates":return this.service.checkForUpdates(b);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${g}`)}}e.UpdateChannel=L;class D{constructor(S){this.channel=S,this._onStateChange=new m.Emitter,this.onStateChange=this._onStateChange.event,this._state=n.State.Uninitialized,this.channel.listen("onStateChange")(g=>this.state=g),this.channel.call("_getInitialState").then(g=>this.state=g)}get state(){return this._state}set state(S){this._state=S,this._onStateChange.fire(S)}checkForUpdates(S){return this.channel.call("checkForUpdates",S)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=D}),define(J[100],Z([0,1,5]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,m.createDecorator)("urlService")}),define(J[216],Z([0,1,8]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class n{constructor(S){this.handler=S}listen(S,g){throw new Error(`Event not found: ${g}`)}call(S,g,b){switch(g){case"handleURL":return this.handler.handleURL(m.URI.revive(b[0]),b[1])}throw new Error(`Call not found: ${g}`)}}e.URLHandlerChannel=n;class L{constructor(S){this.channel=S}handleURL(S,g){return this.channel.call("handleURL",[S.toJSON(),g])}}e.URLHandlerChannelClient=L;class D{constructor(S){this.next=S}async routeCall(S,g,b,C){if(g!=="handleURL")throw new Error(`Call not found: ${g}`);if(b){const I=m.URI.revive(b);if(I&&I.query){const E=/\bwindowId=(\d+)/.exec(I.query);if(E){const w=E[1],t=new RegExp(`window:${w}`),d=S.connections.find(p=>t.test(p.ctx));if(d)return d}}}return this.next.routeCall(S,g,b,C)}routeEvent(S,g){throw new Error(`Event not found: ${g}`)}}e.URLHandlerRouter=D}),define(J[217],Z([0,1,9,2,8,21]),function(V,e,m,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class M extends n.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(b,C){const I=[...this.handlers.values()];return(0,m.first)(I.map(E=>()=>E.handleURL(b,C)),void 0,!1).then(E=>E||!1)}registerHandler(b){return this.handlers.add(b),(0,n.toDisposable)(()=>this.handlers.delete(b))}}e.AbstractURLService=M;let S=class extends M{constructor(b){super();this.productService=b}create(b){let{authority:C,path:I,query:E,fragment:w}=b||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return C&&I&&I.indexOf("/")!==0&&(I=`/${I}`),L.URI.from({scheme:this.productService.urlProtocol,authority:C,path:I,query:E,fragment:w})}};S=ue([te(0,D.IProductService)],S),e.NativeURLService=S}),define(J[218],Z([0,1,12,9,4,2,3,8]),function(V,e,m,n,L,D,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function g(C){try{return S.URI.parse(C)}catch{return null}}class b{constructor(I,E,w,t,d){if(this.urlService=E,this.uris=[],this.retryCount=0,this.flushDisposable=D.Disposable.None,this.disposables=new D.DisposableStore,this.uris=I,M.isWindows){const P=t.isBuilt?[]:[`"${t.appRoot}"`];P.push("--open-url","--"),m.app.setAsDefaultProtocolClient(d.urlProtocol,process.execPath,P)}const p=L.Event.map(L.Event.fromNodeEventEmitter(m.app,"open-url",(P,h)=>({event:P,url:h})),({event:P,url:h})=>(P.preventDefault(),h));this.disposables.add(p(P=>{const h=g(P);!h||this.urlService.open(h,{originalUrl:P})})),w.getWindows().filter(P=>P.isReady).length>0?this.flush():L.Event.once(w.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const I=[];for(const E of this.uris)await this.urlService.open(E.uri,{originalUrl:E.url})||I.push(E);I.length!==0&&(this.uris=I,this.flushDisposable=(0,n.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=b}),define(J[219],Z([0,1,5]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,m.createDecorator)("webviewManagerService")}),define(J[220],Z([0,1,12,2,10,8]),function(V,e,m,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class M extends n.Disposable{constructor(){super();const g=this.handleWebviewRequest.bind(this);m.protocol.registerFileProtocol(L.Schemas.vscodeWebview,g)}handleWebviewRequest(g,b){try{const C=D.URI.parse(g.url),I=M.validWebviewFilePaths.get(C.path);if(typeof I=="string"){const E=`vs/workbench/contrib/webview/browser/pre/${I}`,w=L.FileAccess.asFileUri(E,V);return b(decodeURIComponent(w.fsPath))}else return b({error:-10})}catch{}return b({error:-2})}}e.WebviewProtocolProvider=M,M.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/main.js","main.js"],["/service-worker.js","service-worker.js"]])}),define(J[66],Z([0,1,3]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function n(b){return!!b.workspaceUri}e.isWorkspaceToOpen=n;function L(b){return!!b.folderUri}e.isFolderToOpen=L;function D(b){return!!b.fileUri}e.isFileToOpen=D;function M(b){const C=S(b),I=b.getValue("window.menuBarVisibility");return I==="default"||C==="native"&&I==="compact"||m.isMacintosh&&m.isNative?"classic":I}e.getMenuBarVisibility=M;function S(b){if(m.isWeb)return"custom";const C=b.getValue("window");if(C){if(m.isMacintosh&&C.nativeTabs===!0||m.isMacintosh&&C.nativeFullScreen===!1)return"native";const w=b.getValue("workbench.colorCustomizations");if(w?.["window.activeBorder"]||w?.["window.inactiveBorder"])return"custom";const t=C.titleBarStyle;if(t==="native"||t==="custom")return t}return m.isLinux?"native":"custom"}e.getTitleBarStyle=S;function g(b=0){return Math.pow(1.2,b)}e.zoomLevelToZoomFactor=g}),define(J[101],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var m;(function(S){S[S.INITIAL=1]="INITIAL",S[S.LOAD=2]="LOAD",S[S.RELOAD=3]="RELOAD"})(m=e.LoadReason||(e.LoadReason={}));var n;(function(S){S[S.CLOSE=1]="CLOSE",S[S.QUIT=2]="QUIT",S[S.RELOAD=3]="RELOAD",S[S.LOAD=4]="LOAD"})(n=e.UnloadReason||(e.UnloadReason={}));const L=function(S=1){return{width:1024,height:768,mode:S}};e.defaultWindowState=L;var D;(function(S){S[S.Maximized=0]="Maximized",S[S.Normal=1]="Normal",S[S.Minimized=2]="Minimized",S[S.Fullscreen=3]="Fullscreen"})(D=e.WindowMode||(e.WindowMode={}));var M;(function(S){S[S.UNRESPONSIVE=1]="UNRESPONSIVE",S[S.CRASHED=2]="CRASHED",S[S.LOAD=3]="LOAD"})(M=e.WindowError||(e.WindowError={}))}),define(J[34],Z([0,1,5]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,m.createDecorator)("windowsMainService");var n;(function(L){L[L.CLI=0]="CLI",L[L.DOCK=1]="DOCK",L[L.MENU=2]="MENU",L[L.DIALOG=3]="DIALOG",L[L.DESKTOP=4]="DESKTOP",L[L.API=5]="API"})(n=e.OpenContext||(e.OpenContext={}))}),define(J[221],Z([0,1,12,23,4,69,2,31,74,92,6,21,34]),function(V,e,m,n,L,D,M,S,g,b,C,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var w;(function(d){d[d.Initial=1]="Initial",d[d.StoredCredentialsUsed=2]="StoredCredentialsUsed",d[d.LoginDialogShown=3]="LoginDialogShown"})(w||(w={}));let t=class extends M.Disposable{constructor(p,v,P,h,l){super();this.logService=p,this.windowsMainService=v,this.credentialsService=P,this.encryptionMainService=h,this.productService=l,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=w.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const p=L.Event.fromNodeEventEmitter(m.app,"login",(v,P,h,l,c)=>({event:v,webContents:P,req:h,authInfo:l,callback:c}));this._register(p(this.onLogin,this))}async onLogin({event:p,authInfo:v,req:P,callback:h}){if(!v.isProxy)return;if(!this.pendingProxyResolve&&this.state===w.LoginDialogShown&&P.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}p.preventDefault();let l;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),l=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(v);try{l=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}h(l?.username,l?.password)}async resolveProxyCredentials(p){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const v=await this.doResolveProxyCredentials(p);if(v)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),v;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(p){this.logService.trace("auth#doResolveProxyCredentials - enter",p);const v=String((0,D.hash)({scheme:p.scheme,host:p.host,port:p.port}));let P,h;try{const f=await this.credentialsService.getPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,v);if(f){const r=JSON.parse(await this.encryptionMainService.decrypt(f));P=r.username,h=r.password}}catch(f){this.logService.error(f)}if(this.state!==w.StoredCredentialsUsed&&typeof P=="string"&&typeof h=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=w.StoredCredentialsUsed,{username:P,password:h};const l=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!l){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${l.id} to handle proxy login`);const c={authInfo:p,username:this.sessionCredentials?.username??P,password:this.sessionCredentials?.password??h,replyChannel:`vscode:proxyAuthResponse:${(0,S.generateUuid)()}`};l.sendWhenReady("vscode:openProxyAuthenticationDialog",n.CancellationToken.None,c),this.state=w.LoginDialogShown;const a=await new Promise(f=>{const r=async(i,s,o)=>{if(s===c.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${l.id}`),l.win?.webContents.off("ipc-message",r),o){const u={username:o.username,password:o.password};try{if(o.remember){const y=await this.encryptionMainService.encrypt(JSON.stringify(u));await this.credentialsService.setPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,v,y)}else await this.credentialsService.deletePassword(this.PROXY_CREDENTIALS_SERVICE_KEY,v)}catch(y){this.logService.error(y)}f({username:u.username,password:u.password})}else f(void 0)};l.win?.webContents.on("ipc-message",r)});return this.sessionCredentials=a,a}};t=ue([te(0,C.ILogService),te(1,E.IWindowsMainService),te(2,g.ICredentialsMainService),te(3,b.IEncryptionMainService),te(4,I.IProductService)],t),e.ProxyAuthHandler=t}),define(J[222],Z([0,1,12,4,2,220,34]),function(V,e,m,n,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let S=class extends L.Disposable{constructor(b){super();this.windowsMainService=b,this._onFoundInFrame=this._register(new n.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new D.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(b,C){let I;if(typeof b.windowId=="number"){const{windowId:E}=b,w=this.windowsMainService.getWindowById(E);if(!w?.win)throw new Error(`Invalid windowId: ${E}`);I=w.win.webContents}else{const{webContentsId:E}=b;if(I=m.webContents.fromId(E),!I)throw new Error(`Invalid webContentsId: ${E}`)}I.isDestroyed()||I.setIgnoreMenuShortcuts(C)}async findInFrame(b,C,I,E){const w=this.getFrameByName(b,C),t=w;if(typeof t.findInFrame=="function"){t.findInFrame(I,{findNext:E.findNext,forward:E.forward});const d=(p,v)=>{v.finalUpdate&&(this._onFoundInFrame.fire(v),w.removeListener("found-in-frame",d))};w.on("found-in-frame",d)}}async stopFindInFrame(b,C,I){const w=this.getFrameByName(b,C);typeof w.stopFindInFrame=="function"&&w.stopFindInFrame(I.keepSelection?"keepSelection":"clearSelection")}getFrameByName(b,C){const I=this.windowsMainService.getWindowById(b.windowId);if(!I?.win)throw new Error(`Invalid windowId: ${b}`);const E=I.win.webContents.mainFrame.framesInSubtree.find(w=>w.name===C);if(!E)throw new Error(`Unknown frame: ${C}`);return E}};S=ue([te(0,M.IWindowsMainService)],S),e.WebviewMainService=S}),define(J[223],Z([0,1,9,4,2]),function(V,e,m,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class D extends L.Disposable{constructor({onDidOpenWindow:S,onDidFocusWindow:g,getActiveWindowId:b}){super();this.disposables=this._register(new L.DisposableStore),n.Event.latch(n.Event.any(S,g))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,m.createCancelablePromise)(()=>b()),(async()=>{try{const I=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:I}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(S){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=S}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=D}),define(J[25],Z([0,1,159,7,35,17,8,5,10]),function(V,e,m,n,L,D,M,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,S.createDecorator)("contextService");function b(f){const r=f;return typeof r?.id=="string"&&M.URI.isUri(r.uri)}e.isSingleFolderWorkspaceIdentifier=b;function C(f){if(f.configuration)return{id:f.id,configPath:f.configuration};if(f.folders.length===1)return{id:f.id,uri:f.folders[0].uri}}e.toWorkspaceIdentifier=C;function I(f){const r=f;return typeof r?.id=="string"&&M.URI.isUri(r.configPath)}e.isWorkspaceIdentifier=I;function E(f){const r=f;if(r?.uri)return{id:r.id,uri:M.URI.revive(r.uri)};const i=f;if(i?.configPath)return{id:i.id,configPath:M.URI.revive(i.configPath)};if(f?.id)return{id:f.id}}e.reviveIdentifier=E;var w;(function(f){f[f.EMPTY=1]="EMPTY",f[f.FOLDER=2]="FOLDER",f[f.WORKSPACE=3]="WORKSPACE"})(w=e.WorkbenchState||(e.WorkbenchState={}));function t(f){const r=f;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&Array.isArray(r.folders))}e.isWorkspace=t;function d(f){const r=f;return!!(r&&typeof r=="object"&&M.URI.isUri(r.uri)&&typeof r.name=="string"&&typeof r.toResource=="function")}e.isWorkspaceFolder=d;class p{constructor(r,i,s,o,u){this._id=r,this._transient=s,this._configuration=o,this._ignorePathCasing=u,this._foldersMap=L.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=i}update(r){this._id=r.id,this._configuration=r.configuration,this._transient=r.transient,this._ignorePathCasing=r._ignorePathCasing,this.folders=r.folders}get folders(){return this._folders}set folders(r){this._folders=r,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(r){this._configuration=r}getFolder(r){return r&&this._foldersMap.findSubstr(r.with({scheme:r.scheme,authority:r.authority,path:r.path}))||null}updateFoldersMap(){this._foldersMap=L.TernarySearchTree.forUris(this._ignorePathCasing);for(const r of this.folders)this._foldersMap.set(r.uri,r)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=p;class v{constructor(r,i){this.raw=i,this.uri=r.uri,this.index=r.index,this.name=r.name}toResource(r){return(0,D.joinPath)(this.uri,r)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=v;function P(f){return new v({uri:f,index:0,name:(0,D.basenameOrAuthority)(f)},{uri:f.toString()})}e.toWorkspaceFolder=P,e.WORKSPACE_EXTENSION="code-workspace";const h=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,m.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function l(f,r){return D.extUriBiasedIgnorePathCase.isEqualOrParent(f,r.untitledWorkspacesHome)}e.isUntitledWorkspace=l;function c(f){let r;return M.URI.isUri(f)?r=f:r=f.configuration,r?.scheme===g.Schemas.tmp}e.isTemporaryWorkspace=c;function a(f){return(typeof f=="string"?(0,n.extname)(f):(0,D.extname)(f))===h}e.hasWorkspaceFileExtension=a}),define(J[47],Z([0,1,12,9,69,33,2,70,7,3,14,24,141,5,6,38,25]),function(V,e,m,n,L,D,M,S,g,b,C,I,E,w,t,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,w.createDecorator)("dialogMainService");let v=class bt{constructor(h,l){this.stateMainService=h,this.logService=l,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new n.Queue}pickFileFolder(h,l){return this.doPick({...h,pickFolders:!0,pickFiles:!0,title:(0,E.localize)(0,null)},l)}pickFolder(h,l){return this.doPick({...h,pickFolders:!0,title:(0,E.localize)(1,null)},l)}pickFile(h,l){return this.doPick({...h,pickFiles:!0,title:(0,E.localize)(2,null)},l)}pickWorkspace(h,l){const c=(0,E.localize)(3,null),a=(0,D.mnemonicButtonLabel)((0,E.localize)(4,null)),f=p.WORKSPACE_FILTER;return this.doPick({...h,pickFiles:!0,title:c,filters:f,buttonLabel:a},l)}async doPick(h,l){const c={title:h.title,buttonLabel:h.buttonLabel,filters:h.filters};c.defaultPath=h.defaultPath||this.stateMainService.getItem(bt.workingDirPickerStorageKey),(typeof h.pickFiles=="boolean"||typeof h.pickFolders=="boolean")&&(c.properties=void 0,h.pickFiles&&h.pickFolders&&(c.properties=["multiSelections","openDirectory","openFile","createDirectory"])),c.properties||(c.properties=["multiSelections",h.pickFolders?"openDirectory":"openFile","createDirectory"]),b.isMacintosh&&c.properties.push("treatPackageAsDirectory");const a=l||m.BrowserWindow.getFocusedWindow(),f=await this.showOpenDialog(c,(0,C.withNullAsUndefined)(a));if(f&&f.filePaths&&f.filePaths.length>0)return this.stateMainService.setItem(bt.workingDirPickerStorageKey,(0,g.dirname)(f.filePaths[0])),f.filePaths}getWindowDialogQueue(h){if(h){let l=this.windowDialogQueues.get(h.id);return l||(l=new n.Queue,this.windowDialogQueues.set(h.id,l)),l}else return this.noWindowDialogueQueue}showMessageBox(h,l){return this.getWindowDialogQueue(l).queue(async()=>l?m.dialog.showMessageBox(l,h):m.dialog.showMessageBox(h))}async showSaveDialog(h,l){const c=this.acquireFileDialogLock(h,l);if(!c)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(l).queue(async()=>{let a;return l?a=await m.dialog.showSaveDialog(l,h):a=await m.dialog.showSaveDialog(h),a.filePath=this.normalizePath(a.filePath),a})}finally{(0,M.dispose)(c)}}normalizePath(h){return h&&b.isMacintosh&&(h=(0,S.normalizeNFC)(h)),h}normalizePaths(h){return h.map(l=>this.normalizePath(l))}async showOpenDialog(h,l){h.defaultPath&&(await I.Promises.exists(h.defaultPath)||(h.defaultPath=void 0));const c=this.acquireFileDialogLock(h,l);if(!c)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(l).queue(async()=>{let a;return l?a=await m.dialog.showOpenDialog(l,h):a=await m.dialog.showOpenDialog(h),a.filePaths=this.normalizePaths(a.filePaths),a})}finally{(0,M.dispose)(c)}}acquireFileDialogLock(h,l){if(!l)return M.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",h);let c=this.windowFileDialogLocks.get(l.id);c||(c=new Set,this.windowFileDialogLocks.set(l.id,c));const a=(0,L.hash)(h);if(!c.has(a))return this.logService.trace("[DialogMainService]: new file dialog lock created",h),c.add(a),(0,M.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",h),c?.delete(a),c?.size===0&&this.windowFileDialogLocks.delete(l.id)})}};v.workingDirPickerStorageKey="pickerWorkingDir",v=ue([te(0,d.IStateMainService),te(1,t.ILogService)],v),e.DialogMainService=v}),define(J[224],Z([0,1,4,2,25]),function(V,e,m,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class D extends n.Disposable{constructor(S,g){super();this.logService=S,this.storageMainService=g,this._onDidChangeGlobalStorage=this._register(new m.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(m.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(S,g)=>(S?S.push(g):S=[g],S),D.STORAGE_CHANGE_DEBOUNCE_TIME)(S=>{S.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(S))}))}serializeGlobalStorageEvents(S){const g=new Map,b=new Set;return S.forEach(C=>{const I=this.storageMainService.globalStorage.get(C.key);typeof I=="string"?g.set(C.key,I):b.add(C.key)}),{changed:Array.from(g.entries()),deleted:Array.from(b.values())}}listen(S,g){switch(g){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${g}`)}async call(S,g,b){const C=(0,L.reviveIdentifier)(b.workspace),I=await this.withStorageInitialized(C);switch(g){case"getItems":return Array.from(I.items.entries());case"updateItems":{const E=b;if(E.insert)for(const[w,t]of E.insert)I.set(w,t);E.delete&&E.delete.forEach(w=>I.delete(w));break}case"close":{if(C)return I.close();break}default:throw new Error(`Call not found: ${g}`)}}async withStorageInitialized(S){const g=S?this.storageMainService.workspaceStorage(S):this.storageMainService.globalStorage;try{await g.init()}catch(b){this.logService.error(`StorageIPC#init: Unable to init ${S?"workspace":"global"} storage due to ${b}`)}return g}}e.StorageDatabaseChannel=D,D.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(J[225],Z([0,1,9,4,2,7,24,90,130,6,97,32,25]),function(V,e,m,n,L,D,M,S,g,b,C,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class w extends L.Disposable{constructor(P){super();this.logService=P,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new n.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=new S.Storage(new S.InMemoryStorageDatabase),this.initializePromise=void 0,this.whenInitPromise=new m.DeferredPromise,this.whenInit=this.whenInitPromise.p}get storage(){return this._storage}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const P=await this.doCreate();this._storage.dispose(),this._storage=P,this._register(P.onDidChangeStorage(l=>this._onDidChangeStorage.fire({key:l}))),await this.doInit(P);const h=P.getBoolean(C.IS_NEW_KEY);h===void 0?P.set(C.IS_NEW_KEY,!0):h&&P.set(C.IS_NEW_KEY,!1)}catch(P){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${P}`)}finally{this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===b.LogLevel.Trace?P=>this.logService.trace(P):void 0,logError:P=>this.logService.error(P)}}doInit(P){return P.init()}get items(){return this._storage.items}get(P,h){return this._storage.get(P,h)}set(P,h){return this._storage.set(P,h)}delete(P){return this._storage.delete(P)}async close(){this.initializePromise&&await this.initializePromise,await this._storage.close(),this._onDidCloseStorage.fire()}}class t extends w{constructor(P,h,l){super(h);this.options=P,this.environmentService=l}async doCreate(){let P;return this.options.useInMemoryStorage?P=g.SQLiteStorageDatabase.IN_MEMORY_PATH:P=(0,D.join)(this.environmentService.globalStorageHome.fsPath,t.STORAGE_NAME),new S.Storage(new g.SQLiteStorageDatabase(P,{logging:this.createLoggingOptions()}))}async doInit(P){await super.doInit(P),this.updateTelemetryState(P)}updateTelemetryState(P){P.get(I.firstSessionDateStorageKey,void 0)===void 0&&P.set(I.firstSessionDateStorageKey,new Date().toUTCString());const l=P.get(I.currentSessionDateStorageKey,void 0),c=new Date().toUTCString();P.set(I.lastSessionDateStorageKey,typeof l=="undefined"?null:l),P.set(I.currentSessionDateStorageKey,c)}}e.GlobalStorageMain=t,t.STORAGE_NAME="state.vscdb";class d extends w{constructor(P,h,l,c){super(l);this.workspace=P,this.options=h,this.environmentService=c}async doCreate(){const{storageFilePath:P,wasCreated:h}=await this.prepareWorkspaceStorageFolder();return new S.Storage(new g.SQLiteStorageDatabase(P,{logging:this.createLoggingOptions()}),{hint:h?S.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:g.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const P=(0,D.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),h=(0,D.join)(P,d.WORKSPACE_STORAGE_NAME);return await M.Promises.exists(P)?{storageFilePath:h,wasCreated:!1}:(await M.Promises.mkdir(P,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(P),{storageFilePath:h,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(P){let h;if((0,E.isSingleFolderWorkspaceIdentifier)(this.workspace)?h={folder:this.workspace.uri.toString()}:(0,E.isWorkspaceIdentifier)(this.workspace)&&(h={workspace:this.workspace.configPath.toString()}),h)try{const l=(0,D.join)(P,d.WORKSPACE_META_NAME);await M.Promises.exists(l)||await M.Promises.writeFile(l,JSON.stringify(h,void 0,2))}catch(l){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${l}`)}}}e.WorkspaceStorageMain=d,d.WORKSPACE_STORAGE_NAME="state.vscdb",d.WORKSPACE_META_NAME="workspace.json";class p extends w{async doCreate(){return new S.Storage(new S.InMemoryStorageDatabase)}}e.InMemoryStorageMain=p}),define(J[102],Z([0,1,17,8,25]),function(V,e,m,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function D(g,b,C){for(const E of g){const w=E.openedWorkspace;if((0,L.isWorkspaceIdentifier)(w)){const t=C(w);if(t){if(t.folders.some(d=>m.extUriBiasedIgnorePathCase.isEqualOrParent(b,d.uri)))return E}else if(m.extUriBiasedIgnorePathCase.isEqualOrParent(b,w.configPath))return E}}const I=g.filter(E=>(0,L.isSingleFolderWorkspaceIdentifier)(E.openedWorkspace)&&m.extUriBiasedIgnorePathCase.isEqualOrParent(b,E.openedWorkspace.uri));if(I.length)return I.sort((E,w)=>-(E.openedWorkspace.uri.path.length-w.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=D;function M(g,b){for(const C of g)if((0,L.isWorkspaceIdentifier)(C.openedWorkspace)&&m.extUriBiasedIgnorePathCase.isEqual(C.openedWorkspace.configPath,b)||(0,L.isSingleFolderWorkspaceIdentifier)(C.openedWorkspace)&&m.extUriBiasedIgnorePathCase.isEqual(C.openedWorkspace.uri,b))return C}e.findWindowOnWorkspaceOrFolder=M;function S(g,b){const C=I=>b.some(E=>m.extUriBiasedIgnorePathCase.isEqual(n.URI.file(E),n.URI.file(I)));for(const I of g)if(I.config?.extensionDevelopmentPath?.some(E=>C(E)))return I}e.findWindowOnExtensionDevelopmentPath=S}),define(J[226],Z([0,1,12,2,3,17,8,19,18,6,38,34,101,25]),function(V,e,m,n,L,D,M,S,g,b,C,I,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let t=class Et extends n.Disposable{constructor(l,c,a,f,r){super();this.windowsMainService=l,this.stateMainService=c,this.lifecycleMainService=a,this.logService=f,this.configurationService=r,this._state=d(this.stateMainService.getItem(Et.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){m.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(l=>this.onBeforeCloseWindow(l)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(l=>{l.newCount-l.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(l=>this.onBeforeCloseWindow(l))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const l={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!l.lastActiveWindow){let f=this.windowsMainService.getLastActiveWindow();(!f||f.isExtensionDevelopmentHost)&&(f=this.windowsMainService.getWindows().find(r=>!r.isExtensionDevelopmentHost)),f&&(l.lastActiveWindow=this.toWindowState(f))}const c=this.windowsMainService.getWindows().find(f=>f.isExtensionDevelopmentHost&&!f.isExtensionTestHost);c&&(l.lastPluginDevelopmentHostWindow=this.toWindowState(c)),this.windowsMainService.getWindowCount()>1&&(l.openedWindows=this.windowsMainService.getWindows().filter(f=>!f.isExtensionDevelopmentHost).map(f=>this.toWindowState(f)));const a=v(l);this.stateMainService.setItem(Et.windowsStateStorageKey,a),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",a)}onBeforeCloseWindow(l){if(this.lifecycleMainService.quitRequested)return;const c=this.toWindowState(l);l.isExtensionDevelopmentHost&&!l.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=c:!l.isExtensionDevelopmentHost&&l.openedWorkspace&&this._state.openedWindows.forEach(a=>{const f=(0,w.isWorkspaceIdentifier)(l.openedWorkspace)&&a.workspace?.id===l.openedWorkspace.id,r=(0,w.isSingleFolderWorkspaceIdentifier)(l.openedWorkspace)&&a.folderUri&&D.extUriBiasedIgnorePathCase.isEqual(a.folderUri,l.openedWorkspace.uri);(f||r)&&(a.uiState=c.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=c)}toWindowState(l){return{workspace:(0,w.isWorkspaceIdentifier)(l.openedWorkspace)?l.openedWorkspace:void 0,folderUri:(0,w.isSingleFolderWorkspaceIdentifier)(l.openedWorkspace)?l.openedWorkspace.uri:void 0,backupPath:l.backupPath,remoteAuthority:l.remoteAuthority,uiState:l.serializeWindowState()}}getNewWindowState(l){const c=this.doGetNewWindowState(l),a=this.configurationService.getValue("window");let f;return c.hasDefaultState?f=!!(a?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(a.newWindowDimensions)>=0):(f=!!(this.lifecycleMainService.wasRestarted||a?.restoreFullscreen),f&&L.isMacintosh&&this.windowsMainService.getWindows().some(r=>r.isFullScreen)&&(f=!1)),c.mode===3&&!f&&(c.mode=1),c}doGetNewWindowState(l){const c=this.windowsMainService.getLastActiveWindow();if(!l.extensionTestsPath){if(!!l.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const o=l.workspace;if((0,w.isWorkspaceIdentifier)(o)){const y=this.state.openedWindows.filter(k=>k.workspace&&k.workspace.id===o.id).map(k=>k.uiState);if(y.length)return y[0]}if((0,w.isSingleFolderWorkspaceIdentifier)(o)){const y=this.state.openedWindows.filter(k=>k.folderUri&&D.extUriBiasedIgnorePathCase.isEqual(k.folderUri,o.uri)).map(k=>k.uiState);if(y.length)return y[0]}else if(l.backupPath){const y=this.state.openedWindows.filter(k=>k.backupPath===l.backupPath).map(k=>k.uiState);if(y.length)return y[0]}const u=this.lastClosedState||this.state.lastActiveWindow;if(!c&&u)return u.uiState}let a;const f=m.screen.getAllDisplays();if(f.length===1)a=f[0];else{if(L.isMacintosh){const o=m.screen.getCursorScreenPoint();a=m.screen.getDisplayNearestPoint(o)}!a&&c&&(a=m.screen.getDisplayMatching(c.getBounds())),a||(a=m.screen.getPrimaryDisplay()||f[0])}let r=(0,E.defaultWindowState)();r.x=Math.round(a.bounds.x+a.bounds.width/2-r.width/2),r.y=Math.round(a.bounds.y+a.bounds.height/2-r.height/2);const i=this.configurationService.getValue("window");let s=!0;if(i?.newWindowDimensions){if(i.newWindowDimensions==="maximized")r.mode=0,s=!1;else if(i.newWindowDimensions==="fullscreen")r.mode=3,s=!1;else if((i.newWindowDimensions==="inherit"||i.newWindowDimensions==="offset")&&c){const o=c.serializeWindowState();o.mode===3?r.mode=3:r=o,s=r.mode!==3&&i.newWindowDimensions==="offset"}}return s&&(r=this.ensureNoOverlap(r)),r.hasDefaultState=!0,r}ensureNoOverlap(l){if(this.windowsMainService.getWindows().length===0)return l;l.x=typeof l.x=="number"?l.x:0,l.y=typeof l.y=="number"?l.y:0;const c=this.windowsMainService.getWindows().map(a=>a.getBounds());for(;c.some(a=>a.x===l.x||a.y===l.y);)l.x+=30,l.y+=30;return l}};t.windowsStateStorageKey="windowsState",t=ue([te(0,I.IWindowsMainService),te(1,C.IStateMainService),te(2,g.ILifecycleMainService),te(3,b.ILogService),te(4,S.IConfigurationService)],t),e.WindowsStateHandler=t;function d(h){const l={openedWindows:[]},c=h||{openedWindows:[]};return c.lastActiveWindow&&(l.lastActiveWindow=p(c.lastActiveWindow)),c.lastPluginDevelopmentHostWindow&&(l.lastPluginDevelopmentHostWindow=p(c.lastPluginDevelopmentHostWindow)),Array.isArray(c.openedWindows)&&(l.openedWindows=c.openedWindows.map(a=>p(a))),l}e.restoreWindowsState=d;function p(h){const l={uiState:h.uiState};return h.backupPath&&(l.backupPath=h.backupPath),h.remoteAuthority&&(l.remoteAuthority=h.remoteAuthority),h.folder&&(l.folderUri=M.URI.parse(h.folder)),h.workspaceIdentifier&&(l.workspace={id:h.workspaceIdentifier.id,configPath:M.URI.parse(h.workspaceIdentifier.configURIPath)}),l}function v(h){return{lastActiveWindow:h.lastActiveWindow&&P(h.lastActiveWindow),lastPluginDevelopmentHostWindow:h.lastPluginDevelopmentHostWindow&&P(h.lastPluginDevelopmentHostWindow),openedWindows:h.openedWindows.map(l=>P(l))}}e.getWindowsStateStoreData=v;function P(h){return{workspaceIdentifier:h.workspace&&{id:h.workspace.id,configURIPath:h.workspace.configPath.toString()},folder:h.folderUri&&h.folderUri.toString(),backupPath:h.backupPath,remoteAuthority:h.remoteAuthority,uiState:h.uiState}}}),define(J[80],Z([0,1,28,44,109,33,10,7,3,17,8,5,78,25]),function(V,e,m,n,L,D,M,S,g,b,C,I,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,I.createDecorator)("workspacesService");function t(k){return k.hasOwnProperty("workspace")}e.isRecentWorkspace=t;function d(k){return k.hasOwnProperty("folderUri")}e.isRecentFolder=d;function p(k){return k.hasOwnProperty("fileUri")}e.isRecentFile=p;function v(k){return P(k)||h(k)}e.isStoredWorkspaceFolder=v;function P(k){const R=k;return typeof R?.path=="string"&&(!R.name||typeof R.name=="string")}function h(k){const R=k;return typeof R?.uri=="string"&&(!R.name||typeof R.name=="string")}function l(k,R,W,U,K=!g.isWindows,x){if(k.scheme!==U.scheme)return{name:W,uri:k.toString(!0)};let ee=R?void 0:x.relativePath(U,k);if(ee!==void 0)ee.length===0?ee=".":g.isWindows&&k.scheme===M.Schemas.file&&!K&&(ee=ee.replace(/\//g,"\\"));else if(k.scheme===M.Schemas.file)ee=k.fsPath,g.isWindows&&(ee=(0,D.normalizeDriveLetter)(ee),K&&(ee=(0,m.toSlashes)(ee)));else{if(!x.isEqualAuthority(k.authority,U.authority))return{name:W,uri:k.toString(!0)};ee=k.path}return{name:W,path:ee}}e.getStoredWorkspaceFolder=l;function c(k,R,W){let U=[],K=new Set;const x=W.dirname(R);for(let ee of k){let Q;if(P(ee))ee.path&&(Q=W.resolvePath(x,ee.path));else if(h(ee))try{Q=C.URI.parse(ee.uri),Q.path[0]!=="/"&&(Q=Q.with({path:"/"+Q.path}))}catch(H){console.warn(H)}if(Q){let H=W.getComparisonKey(Q);if(!K.has(H)){K.add(H);const X=ee.name||W.basenameOrAuthority(Q);U.push(new w.WorkspaceFolder({uri:Q,name:X,index:U.length},ee))}}}return U}e.toWorkspaceFolders=c;function a(k,R,W,U,K){let x=f(R,k);const ee=K.dirname(R),Q=K.dirname(U),H=[],X=r(x.folders);for(const q of x.folders){const Y=P(q)?K.resolvePath(ee,q.path):C.URI.parse(q.uri);let B;W?B=!1:B=!P(q)||(0,S.isAbsolute)(q.path),H.push(l(Y,B,q.name,Q,X,K))}const z={insertSpaces:!1,tabSize:4,eol:g.isLinux||g.isMacintosh?`
`:`\r
`},ie=L.setProperty(k,["folders"],H,z);let $=L.applyEdits(k,ie);return(0,b.isEqualAuthority)(x.remoteAuthority,(0,E.getRemoteAuthority)(U))&&($=L.applyEdits($,L.removeProperty($,["remoteAuthority"],z))),$}e.rewriteWorkspaceFileForNewLocation=a;function f(k,R){let W=n.parse(R);if(W&&Array.isArray(W.folders))W.folders=W.folders.filter(U=>v(U));else throw new Error(`${k} looks like an invalid workspace file.`);return W}function r(k){return g.isWindows?k.some(R=>P(R)&&R.path.indexOf("/")>=0):!0}e.useSlashForPath=r;function i(k){return k.workspace&&typeof k.workspace=="object"&&typeof k.workspace.id=="string"&&typeof k.workspace.configPath=="string"}function s(k){return typeof k.folderUri=="string"}function o(k){return typeof k.fileUri=="string"}function u(k,R){const W={workspaces:[],files:[]};if(k){const U=function(x,ee){for(let Q=0;Q<x.length;Q++)try{ee(x[Q],Q)}catch(H){R.warn(`Error restoring recent entry ${JSON.stringify(x[Q])}: ${H.toString()}. Skip entry.`)}},K=k;if(Array.isArray(K.entries))U(K.entries,x=>{const ee=x.label,Q=x.remoteAuthority;i(x)?W.workspaces.push({label:ee,remoteAuthority:Q,workspace:{id:x.workspace.id,configPath:C.URI.parse(x.workspace.configPath)}}):s(x)?W.workspaces.push({label:ee,remoteAuthority:Q,folderUri:C.URI.parse(x.folderUri)}):o(x)&&W.files.push({label:ee,remoteAuthority:Q,fileUri:C.URI.parse(x.fileUri)})});else{const x=k;Array.isArray(x.workspaces3)&&U(x.workspaces3,(ee,Q)=>{const H=Array.isArray(x.workspaceLabels)&&x.workspaceLabels[Q]||void 0;typeof ee=="object"&&typeof ee.id=="string"&&typeof ee.configURIPath=="string"?W.workspaces.push({label:H,workspace:{id:ee.id,configPath:C.URI.parse(ee.configURIPath)}}):typeof ee=="string"&&W.workspaces.push({label:H,folderUri:C.URI.parse(ee)})}),Array.isArray(x.files2)&&U(x.files2,(ee,Q)=>{const H=Array.isArray(x.fileLabels)&&x.fileLabels[Q]||void 0;typeof ee=="string"&&W.files.push({label:H,fileUri:C.URI.parse(ee)})})}}return W}e.restoreRecentlyOpened=u;function y(k){const R={entries:[]};for(const W of k.workspaces)d(W)?R.entries.push({folderUri:W.folderUri.toString(),label:W.label,remoteAuthority:W.remoteAuthority}):R.entries.push({workspace:{id:W.workspace.id,configPath:W.workspace.configPath.toString()},label:W.label,remoteAuthority:W.remoteAuthority});for(const W of k.files)R.entries.push({fileUri:W.fileUri.toString(),label:W.label,remoteAuthority:W.remoteAuthority});return R}e.toStoreData=y}),define(J[103],Z([0,1,60,29,10,3,17]),function(V,e,m,n,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function S(b){function C(){let I=b.scheme===L.Schemas.file?(0,M.originalFSPath)(b):b.toString();return D.isLinux||(I=I.toLowerCase()),(0,m.createHash)("md5").update(I).digest("hex")}return{id:C(),configPath:b}}e.getWorkspaceIdentifier=S;function g(b,C){function I(){if(b.scheme!==L.Schemas.file)return(0,m.createHash)("md5").update(b.toString()).digest("hex");if(!C)try{C=(0,n.statSync)(b.fsPath)}catch{return}let w;return D.isLinux?w=C.ino:D.isMacintosh?w=C.birthtime.getTime():D.isWindows&&(typeof C.birthtimeMs=="number"?w=Math.floor(C.birthtimeMs):w=C.birthtime.getTime()),(0,m.createHash)("md5").update(b.fsPath).update(w?String(w):"").digest("hex")}const E=I();if(typeof E=="string")return{id:E,uri:b}}e.getSingleFolderWorkspaceIdentifier=g}),define(J[227],Z([0,1,15,4,10,6,254,118,18,85]),function(V,e,m,n,L,D,M,S,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerMainProcessExtensionHostStarter=void 0;class C{constructor(t,d){this._worker=new M.Worker(L.FileAccess.asFileUri("vs/platform/extensions/node/extensionHostStarterWorkerMain.js",V).fsPath),this._worker.on("message",t),this._worker.on("error",d),this.onError=n.Event.fromNodeEventEmitter(this._worker,"error"),this.onExit=n.Event.fromNodeEventEmitter(this._worker,"exit"),this.onMessageError=n.Event.fromNodeEventEmitter(this._worker,"messageerror")}getId(){return 1}postMessage(t,d){this._worker.postMessage(t,d)}dispose(){this._worker.terminate()}}let I=class{constructor(t){this._logService=t}async logInfo(t){this._logService.info(t)}};I=ue([te(0,D.ILogService)],I);let E=class{constructor(t,d){this._logService=t,this._shutdown=!1,this._proxy=null;const p={create:(v,P,h)=>{const l=new C(P,h);return l.onError(c=>{this._logService.error("ExtensionHostStarterWorker has encountered an error:"),this._logService.error(c)}),l.onMessageError(c=>{this._logService.error("ExtensionHostStarterWorker has encountered a message error:"),this._logService.error(c)}),l.onExit(c=>this._logService.info(`ExtensionHostStarterWorker exited with code ${c}.`)),l.postMessage(v,[]),l}};this._worker=new S.SimpleWorkerClient(p,"vs/platform/extensions/node/extensionHostStarterWorker",new I(this._logService)),this._initialize(),d.onWillShutdown(v=>{this._shutdown=!0,this._proxy&&v.join(this._proxy.waitForAllExit(6e3))})}dispose(){}async _initialize(){this._proxy=await this._worker.getProxyObject(),this._logService.info("ExtensionHostStarterWorker created")}onDynamicStdout(t){return this._proxy.onDynamicStdout(t)}onDynamicStderr(t){return this._proxy.onDynamicStderr(t)}onDynamicMessage(t){return this._proxy.onDynamicMessage(t)}onDynamicError(t){return this._proxy.onDynamicError(t)}onDynamicExit(t){return this._proxy.onDynamicExit(t)}async createExtensionHost(){const t=await this._worker.getProxyObject();if(this._shutdown)throw(0,m.canceled)();return t.createExtensionHost()}async start(t,d){const p=b.StopWatch.create(!1),v=await this._worker.getProxyObject();if(this._shutdown)throw(0,m.canceled)();const P=setTimeout(()=>{this._logService.info("ExtensionHostStarterWorker.start() did not return within 30s. This might be a problem.")},3e4),h=await v.start(t,d),l=p.elapsed();return this._logService.info(`ExtensionHostStarterWorker.start() took ${l} ms.`),clearTimeout(P),h}async enableInspectPort(t){const d=await this._worker.getProxyObject();if(this._shutdown)throw(0,m.canceled)();return d.enableInspectPort(t)}async kill(t){const d=await this._worker.getProxyObject();if(this._shutdown)throw(0,m.canceled)();return d.kill(t)}};E=ue([te(0,D.ILogService),te(1,g.ILifecycleMainService)],E),e.WorkerMainProcessExtensionHostStarter=E}),define(J[57],Z([0,1,60,61,26,16,15,4,2,7,3,31,37,88,228]),function(V,e,m,n,L,D,M,S,g,b,C,I,E,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class d{constructor(R,W=""){this.debugLabel=W,this.socket=R,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=U=>{if(this.traceSocketEvent("error",{code:U?.code,message:U?.message}),U){if(U.code==="EPIPE")return;(0,M.onUnexpectedError)(U)}},this.socket.on("error",this._errorListener)}traceSocketEvent(R,W){w.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,R,W)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(R){const W=U=>{this.traceSocketEvent("read",U),R(D.VSBuffer.wrap(U))};return this.socket.on("data",W),{dispose:()=>this.socket.off("data",W)}}onClose(R){const W=U=>{this.traceSocketEvent("close",{hadError:U}),R({type:0,hadError:U,error:void 0})};return this.socket.on("close",W),{dispose:()=>this.socket.off("close",W)}}onEnd(R){const W=()=>{this.traceSocketEvent("nodeEndReceived"),R()};return this.socket.on("end",W),{dispose:()=>this.socket.off("end",W)}}write(R){if(!this.socket.destroyed)try{this.traceSocketEvent("write",R),this.socket.write(R.buffer,W=>{if(W){if(W.code==="EPIPE")return;(0,M.onUnexpectedError)(W)}})}catch(W){if(W.code==="EPIPE")return;(0,M.onUnexpectedError)(W)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((R,W)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),R();return}const U=()=>{this.socket.off("close",U),this.socket.off("end",U),this.socket.off("error",U),this.socket.off("timeout",U),this.socket.off("drain",U),this.traceSocketEvent("nodeDrainEnd"),R()};this.socket.on("close",U),this.socket.on("end",U),this.socket.on("error",U),this.socket.on("timeout",U),this.socket.on("drain",U)})}}e.NodeSocket=d;var p;(function(k){k[k.MinHeaderByteSize=2]="MinHeaderByteSize"})(p||(p={}));var v;(function(k){k[k.PeekHeader=1]="PeekHeader",k[k.ReadHeader=2]="ReadHeader",k[k.ReadBody=3]="ReadBody",k[k.Fin=4]="Fin"})(v||(v={}));class P extends g.Disposable{constructor(R,W,U,K){super();this._onData=this._register(new S.Emitter),this._onClose=this._register(new S.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=R,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:W,inflateBytesLength:U?.byteLength||0,recordInflateBytes:K}),this._flowManager=this._register(new h(this,W,U,K,this._onData,(x,ee)=>this._write(x,ee))),this._register(this._flowManager.onError(x=>{console.error(x),(0,M.onUnexpectedError)(x),this._onClose.fire({type:0,hadError:!0,error:x})})),this._incomingData=new w.ChunkStream,this._register(this.socket.onData(x=>this._acceptChunk(x))),this._register(this.socket.onClose(x=>this._onClose.fire(x)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(R,W){this.socket.traceSocketEvent(R,W)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(R){return this._onData.event(R)}onClose(R){return this._onClose.event(R)}onEnd(R){return this.socket.onEnd(R)}write(R){this._flowManager.writeMessage(R)}_write(R,W){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",R);let U=2;R.byteLength<126?U+=0:R.byteLength<2**16?U+=2:U+=8;const K=D.VSBuffer.alloc(U);if(W?K.writeUInt8(194,0):K.writeUInt8(130,0),R.byteLength<126)K.writeUInt8(R.byteLength,1);else if(R.byteLength<2**16){K.writeUInt8(126,1);let x=1;K.writeUInt8(R.byteLength>>>8&255,++x),K.writeUInt8(R.byteLength>>>0&255,++x)}else{K.writeUInt8(127,1);let x=1;K.writeUInt8(0,++x),K.writeUInt8(0,++x),K.writeUInt8(0,++x),K.writeUInt8(0,++x),K.writeUInt8(R.byteLength>>>24&255,++x),K.writeUInt8(R.byteLength>>>16&255,++x),K.writeUInt8(R.byteLength>>>8&255,++x),K.writeUInt8(R.byteLength>>>0&255,++x)}this.socket.write(D.VSBuffer.concat([K,R]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(R){if(R.byteLength!==0){for(this._incomingData.acceptChunk(R);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const W=this._incomingData.peek(this._state.readLen),U=W.readUInt8(0),K=(U&128)>>>7,x=(U&64)>>>6,ee=W.readUInt8(1),Q=(ee&128)>>>7,H=ee&127;this._state.state=2,this._state.readLen=2+(Q?4:0)+(H===126?2:0)+(H===127?8:0),this._state.fin=K,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(x)),this._state.firstFrameOfMessage=Boolean(K),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const W=this._incomingData.read(this._state.readLen),U=W.readUInt8(1),K=(U&128)>>>7;let x=U&127,ee=1;x===126?x=W.readUInt8(++ee)*2**8+W.readUInt8(++ee):x===127&&(x=W.readUInt8(++ee)*0+W.readUInt8(++ee)*0+W.readUInt8(++ee)*0+W.readUInt8(++ee)*0+W.readUInt8(++ee)*2**24+W.readUInt8(++ee)*2**16+W.readUInt8(++ee)*2**8+W.readUInt8(++ee));let Q=0;K&&(Q=W.readUInt8(++ee)*2**24+W.readUInt8(++ee)*2**16+W.readUInt8(++ee)*2**8+W.readUInt8(++ee)),this._state.state=3,this._state.readLen=x,this._state.mask=Q,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const W=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",W),a(W,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",W),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(W,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await S.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=P;class h extends g.Disposable{constructor(R,W,U,K,x,ee){super();this._tracer=R,this._onData=x,this._writeFn=ee,this._onError=this._register(new S.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new S.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,W?(this._zlibInflateStream=this._register(new l(this._tracer,K,U,{windowBits:15})),this._zlibDeflateStream=this._register(new c(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(Q=>this._onError.fire(Q))),this._register(this._zlibDeflateStream.onError(Q=>this._onError.fire(Q)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:D.VSBuffer.alloc(0)}writeMessage(R){this._writeQueue.push(R),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const R=this._writeQueue.shift();if(this._zlibDeflateStream){const W=await this._deflateMessage(this._zlibDeflateStream,R);this._writeFn(W,!0)}else this._writeFn(R,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(R,W){return new Promise((U,K)=>{R.write(W),R.flush(x=>U(x))})}acceptFrame(R,W,U){this._readQueue.push({data:R,isCompressed:W,isLastFrameOfMessage:U}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const R=this._readQueue.shift();if(this._zlibInflateStream&&R.isCompressed){const W=await this._inflateFrame(this._zlibInflateStream,R.data,R.isLastFrameOfMessage);this._onData.fire(W)}else this._onData.fire(R.data)}this._isProcessingReadQueue=!1}}_inflateFrame(R,W,U){return new Promise((K,x)=>{R.write(W),U&&R.write(D.VSBuffer.fromByteArray([0,0,255,255])),R.flush(ee=>K(ee))})}}class l extends g.Disposable{constructor(R,W,U,K){super();this._tracer=R,this._recordInflateBytes=W,this._onError=this._register(new S.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=t.createInflateRaw(K),this._zlibInflate.on("error",x=>{this._tracer.traceSocketEvent("zlibInflateError",{message:x?.message,code:x?.code}),this._onError.fire(x)}),this._zlibInflate.on("data",x=>{this._tracer.traceSocketEvent("zlibInflateData",x),this._pendingInflateData.push(D.VSBuffer.wrap(x))}),U&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",U.buffer),this._zlibInflate.write(U.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?D.VSBuffer.concat(this._recordedInflateBytes):D.VSBuffer.alloc(0)}write(R){this._recordInflateBytes&&this._recordedInflateBytes.push(R.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",R),this._zlibInflate.write(R.buffer)}flush(R){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const W=D.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,R(W)})}}class c extends g.Disposable{constructor(R,W){super();this._tracer=R,this._onError=this._register(new S.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=t.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",U=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:U?.message,code:U?.code}),this._onError.fire(U)}),this._zlibDeflate.on("data",U=>{this._tracer.traceSocketEvent("zlibDeflateData",U),this._pendingDeflateData.push(D.VSBuffer.wrap(U))})}write(R){this._tracer.traceSocketEvent("zlibDeflateWrite",R.buffer),this._zlibDeflate.write(R.buffer)}flush(R){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let W=D.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,W=W.slice(0,W.byteLength-4),R(W)})}}function a(k,R){if(R===0)return;let W=k.byteLength>>>2;for(let H=0;H<W;H++){const X=k.readUInt32BE(H*4);k.writeUInt32BE(X^R,H*4)}let U=W*4,K=k.byteLength-U;const x=R>>>24&255,ee=R>>>16&255,Q=R>>>8&255;K>=1&&k.writeUInt8(k.readUInt8(U)^x,U),K>=2&&k.writeUInt8(k.readUInt8(U+1)^ee,U+1),K>=3&&k.writeUInt8(k.readUInt8(U+2)^Q,U+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const f={[2]:107,[1]:103};function r(){const k=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${k}-sock`;let R;return e.XDG_RUNTIME_DIR?R=(0,b.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${k}.sock`):R=(0,b.join)((0,L.tmpdir)(),`vscode-ipc-${k}.sock`),s(R),R}e.createRandomIPCHandle=r;function i(k,R,W){const U=(0,m.createHash)("md5").update(k).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${U}-${W}-${R}-sock`;let K;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?K=(0,b.join)(e.XDG_RUNTIME_DIR,`vscode-${U.substr(0,8)}-${W}-${R}.sock`):K=(0,b.join)(k,`${W}-${R}.sock`),s(K),K}e.createStaticIPCHandle=i;function s(k){const R=f[C.platform];typeof R=="number"&&k.length>=R&&console.warn(`WARNING: IPC handle "${k}" is longer than ${R} chars, try a shorter --user-data-dir`)}class o extends E.IPCServer{constructor(R){super(o.toClientConnectionEvent(R));this.server=R}static toClientConnectionEvent(R){const W=S.Event.fromNodeEventEmitter(R,"connection");return S.Event.map(W,U=>({protocol:new w.Protocol(new d(U,"ipc-server-connection")),onDidClientDisconnect:S.Event.once(S.Event.fromNodeEventEmitter(U,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function u(k){return new Promise((R,W)=>{const U=(0,n.createServer)();U.on("error",W),U.listen(k,()=>{U.removeListener("error",W),R(new o(U))})})}e.serve=u;function y(k,R){return new Promise((W,U)=>{const K=(0,n.createConnection)(k,()=>{K.removeListener("error",U),W(w.Client.fromSocket(new d(K,`ipc-client${R}`),R))});K.once("error",U)})}e.connect=y}),define(J[229],Z([0,1,57]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class n{constructor(g){this.driver=g}listen(g,b){throw new Error("No event found")}call(g,b,C){switch(b){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(C);case"startTracing":return this.driver.startTracing(C[0],C[1]);case"stopTracing":return this.driver.stopTracing(C[0],C[1],C[2]);case"reloadWindow":return this.driver.reloadWindow(C);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(C[0],C[1]);case"click":return this.driver.click(C[0],C[1],C[2],C[3]);case"doubleClick":return this.driver.doubleClick(C[0],C[1]);case"setValue":return this.driver.setValue(C[0],C[1],C[2]);case"getTitle":return this.driver.getTitle(C[0]);case"isActiveElement":return this.driver.isActiveElement(C[0],C[1]);case"getElements":return this.driver.getElements(C[0],C[1],C[2]);case"getElementXY":return this.driver.getElementXY(C[0],C[1],C[2]);case"typeInEditor":return this.driver.typeInEditor(C[0],C[1],C[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(C[0],C[1]);case"writeInTerminal":return this.driver.writeInTerminal(C[0],C[1],C[2]);case"getLocaleInfo":return this.driver.getLocaleInfo(C);case"getLocalizedStrings":return this.driver.getLocalizedStrings(C)}throw new Error(`Call not found: ${b}`)}}e.DriverChannel=n;class L{constructor(g){this.channel=g}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(g){return this.channel.call("capturePage",g)}startTracing(g,b){return this.channel.call("startTracing",[g,b])}stopTracing(g,b,C){return this.channel.call("stopTracing",[g,b,C])}reloadWindow(g){return this.channel.call("reloadWindow",g)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(g,b){return this.channel.call("dispatchKeybinding",[g,b])}click(g,b,C,I){return this.channel.call("click",[g,b,C,I])}doubleClick(g,b){return this.channel.call("doubleClick",[g,b])}setValue(g,b,C){return this.channel.call("setValue",[g,b,C])}getTitle(g){return this.channel.call("getTitle",[g])}isActiveElement(g,b){return this.channel.call("isActiveElement",[g,b])}getElements(g,b,C){return this.channel.call("getElements",[g,b,C])}getElementXY(g,b,C,I){return this.channel.call("getElementXY",[g,b,C,I])}typeInEditor(g,b,C){return this.channel.call("typeInEditor",[g,b,C])}getTerminalBuffer(g,b){return this.channel.call("getTerminalBuffer",[g,b])}writeInTerminal(g,b,C){return this.channel.call("writeInTerminal",[g,b,C])}getLocaleInfo(g){return this.channel.call("getLocaleInfo",g)}getLocalizedStrings(g){return this.channel.call("getLocalizedStrings",g)}}e.DriverChannelClient=L;class D{constructor(g){this.registry=g}listen(g,b){throw new Error(`Event not found: ${b}`)}call(g,b,C){switch(b){case"registerWindowDriver":return this.registry.registerWindowDriver(C);case"reloadWindowDriver":return this.registry.reloadWindowDriver(C)}throw new Error(`Call not found: ${b}`)}}e.WindowDriverRegistryChannel=D;async function M(S){const g=await(0,m.connect)(S,"driverClient"),b=g.getChannel("driver"),C=new L(b);return{client:g,driver:C}}e.connect=M}),define(J[22],Z([0,1,46,7,57,52,170,5]),function(V,e,m,n,L,D,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,S.refineServiceDecorator)(D.IEnvironmentService);class g extends M.NativeEnvironmentService{get cachedLanguagesPath(){return(0,n.join)(this.userDataPath,"clp")}get backupHome(){return(0,n.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,n.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,L.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,n.join)(this.userDataPath,"code.lock")}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}ue([m.memoize],g.prototype,"cachedLanguagesPath",null),ue([m.memoize],g.prototype,"backupHome",null),ue([m.memoize],g.prototype,"backupWorkspacesPath",null),ue([m.memoize],g.prototype,"mainIPCHandle",null),ue([m.memoize],g.prototype,"mainLockfile",null),ue([m.memoize],g.prototype,"sandbox",null),ue([m.memoize],g.prototype,"driverVerbose",null),ue([m.memoize],g.prototype,"disableUpdates",null),ue([m.memoize],g.prototype,"disableKeytar",null),ue([m.memoize],g.prototype,"codeCachePath",null),ue([m.memoize],g.prototype,"useCodeCache",null),e.EnvironmentMainService=g}),define(J[230],Z([0,1,60,29,28,10,7,3,17,8,24,163,19,22,20,6,162,25]),function(V,e,m,n,L,D,M,S,g,b,C,I,E,w,t,d,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let P=class{constructor(l,c,a){this.configurationService=c,this.logService=a,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=g.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(f,r)=>(0,L.isEqual)(f,r,!S.isLinux)},this.backupHome=l.backupHome,this.workspacesJsonPath=l.backupWorkspacesPath}async initialize(){let l;try{l=JSON.parse(await C.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch{l=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(l.emptyWorkspaceInfos);let c=[];try{Array.isArray(l.rootURIWorkspaces)&&(c=l.rootURIWorkspaces.map(f=>({workspace:{id:f.id,configPath:b.URI.parse(f.configURIPath)},remoteAuthority:f.remoteAuthority})))}catch{}this.workspaces=await this.validateWorkspaces(c);let a=[];try{Array.isArray(l.folderWorkspaceInfos)?a=l.folderWorkspaceInfos.map(f=>({folderUri:b.URI.parse(f.folderUri),remoteAuthority:f.remoteAuthority})):Array.isArray(l.folderURIWorkspaces)&&(a=l.folderURIWorkspaces.map(f=>({folderUri:b.URI.parse(f),remoteAuthority:void 0})))}catch{}this.folders=await this.validateFolders(a),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==t.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===t.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||t.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(l,c){this.workspaces.some(f=>l.workspace.id===f.workspace.id)||(this.workspaces.push(l),this.saveSync());const a=this.getBackupPath(l.workspace.id);return c&&this.moveBackupFolderSync(a,c),a}moveBackupFolderSync(l,c){if(n.existsSync(l)&&this.convertToEmptyWindowBackupSync(l),n.existsSync(c))try{n.renameSync(c,l)}catch(a){this.logService.error(`Backup: Could not move backup folder to new location: ${a.toString()}`)}}unregisterWorkspaceBackupSync(l){const c=l.id,a=this.workspaces.findIndex(f=>f.workspace.id===c);a!==-1&&(this.workspaces.splice(a,1),this.saveSync())}registerFolderBackupSync(l){return this.folders.some(c=>this.backupUriComparer.isEqual(l.folderUri,c.folderUri))||(this.folders.push(l),this.saveSync()),this.getBackupPath(this.getFolderHash(l))}unregisterFolderBackupSync(l){const c=this.folders.findIndex(a=>this.backupUriComparer.isEqual(l,a.folderUri));c!==-1&&(this.folders.splice(c,1),this.saveSync())}registerEmptyWindowBackupSync(l,c){const a=l||this.getRandomEmptyWindowId();return this.emptyWindows.some(f=>!!f.backupFolder&&this.backupPathComparer.isEqual(f.backupFolder,a))||(this.emptyWindows.push({backupFolder:a,remoteAuthority:c}),this.saveSync()),this.getBackupPath(a)}unregisterEmptyWindowBackupSync(l){const c=this.emptyWindows.findIndex(a=>!!a.backupFolder&&this.backupPathComparer.isEqual(a.backupFolder,l));c!==-1&&(this.emptyWindows.splice(c,1),this.saveSync())}getBackupPath(l){return(0,M.join)(this.backupHome,l)}async validateWorkspaces(l){if(!Array.isArray(l))return[];const c=new Set,a=[];for(let f of l){const r=f.workspace;if(!(0,v.isWorkspaceIdentifier)(r))return[];if(!c.has(r.id)){c.add(r.id);const i=this.getBackupPath(r.id);await this.doHasBackups(i)?r.configPath.scheme!==D.Schemas.file||await C.Promises.exists(r.configPath.fsPath)?a.push(f):await this.convertToEmptyWindowBackup(i):await this.deleteStaleBackup(i)}}return a}async validateFolders(l){if(!Array.isArray(l))return[];const c=[],a=new Set;for(let f of l){const r=f.folderUri,i=this.backupUriComparer.getComparisonKey(r);if(!a.has(i)){a.add(i);const s=this.getBackupPath(this.getFolderHash(f));await this.doHasBackups(s)?r.scheme!==D.Schemas.file||await C.Promises.exists(r.fsPath)?c.push(f):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return c}async validateEmptyWorkspaces(l){if(!Array.isArray(l))return[];const c=[],a=new Set;for(let f of l){const r=f.backupFolder;if(typeof r!="string")return[];if(!a.has(r)){a.add(r);const i=this.getBackupPath(r);await this.doHasBackups(i)?c.push(f):await this.deleteStaleBackup(i)}}return c}async deleteStaleBackup(l){try{await C.Promises.exists(l)&&await C.Promises.rm(l,C.RimRafMode.MOVE)}catch(c){this.logService.error(`Backup: Could not delete stale backup: ${c.toString()}`)}}async convertToEmptyWindowBackup(l){let c=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(f=>!!f.backupFolder&&this.backupPathComparer.isEqual(f.backupFolder,c));)c=this.getRandomEmptyWindowId();const a=this.getBackupPath(c);try{await C.Promises.rename(l,a)}catch(f){return this.logService.error(`Backup: Could not rename backup folder: ${f.toString()}`),!1}return this.emptyWindows.push({backupFolder:c}),!0}convertToEmptyWindowBackupSync(l){let c=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(f=>!!f.backupFolder&&this.backupPathComparer.isEqual(f.backupFolder,c));)c=this.getRandomEmptyWindowId();const a=this.getBackupPath(c);try{n.renameSync(l,a)}catch(f){return this.logService.error(`Backup: Could not rename backup folder: ${f.toString()}`),!1}return this.emptyWindows.push({backupFolder:c}),!0}async getDirtyWorkspaces(){const l=[];for(const c of this.workspaces)await this.hasBackups(c)&&l.push(c);for(const c of this.folders)await this.hasBackups(c)&&l.push(c);return l}hasBackups(l){let c;return(0,I.isEmptyWindowBackupInfo)(l)?c=l.backupFolder:(0,p.isFolderBackupInfo)(l)?c=this.getBackupPath(this.getFolderHash(l)):c=this.getBackupPath(l.workspace.id),this.doHasBackups(c)}async doHasBackups(l){try{const c=await C.Promises.readdir(l);for(const a of c)try{if((await C.Promises.readdir((0,M.join)(l,a))).length>0)return!0}catch{}}catch{}return!1}saveSync(){try{(0,C.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(l){this.logService.error(`Backup: Could not save workspaces.json: ${l.toString()}`)}}async save(){try{await C.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(l){this.logService.error(`Backup: Could not save workspaces.json: ${l.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(l=>({id:l.workspace.id,configURIPath:l.workspace.configPath.toString(),remoteAuthority:l.remoteAuthority})),folderWorkspaceInfos:this.folders.map(l=>({folderUri:l.folderUri.toString(),remoteAuthority:l.remoteAuthority})),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(l){const c=l.folderUri;let a;return c.scheme===D.Schemas.file?a=S.isLinux?c.fsPath:c.fsPath.toLowerCase():a=c.toString().toLowerCase(),(0,m.createHash)("md5").update(a).digest("hex")}};P=ue([te(0,w.IEnvironmentMainService),te(1,E.IConfigurationService),te(2,d.ILogService)],P),e.BackupMainService=P}),define(J[231],Z([0,1,9,4,110,59,2,3,37,57,165,229,22,185,18,34,20,8,7,16,6]),function(V,e,m,n,L,D,M,S,g,b,C,I,E,w,t,d,p,v,P,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function c(r){return r<21}let a=class{constructor(i,s,o,u,y,k,R){this.windowServer=i,this.options=s,this.windowsMainService=o,this.lifecycleMainService=u,this.fileService=y,this.environmentMainService=k,this.logService=R,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new n.Emitter}async registerWindowDriver(i){return this.logService.info(`[driver] registerWindowDriver(${i})`),this.registeredWindowIds.add(i),this.reloadingWindowIds.delete(i),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(i){this.logService.info(`[driver] reloadWindowDriver(${i})`),this.reloadingWindowIds.add(i)}async getWindowIds(){return this.windowsMainService.getWindows().map(s=>s.id).filter(s=>this.registeredWindowIds.has(s)&&!this.reloadingWindowIds.has(s))}async capturePage(i){const s=this.windowsMainService.getWindowById(i)??this.windowsMainService.getLastActiveWindow();if(!s?.win)throw new Error("Invalid window");return(await s.win.webContents.capturePage()).toPNG().toString("base64")}async startTracing(i,s){}async stopTracing(i,s,o){if(!o)return;const u=await this.capturePage(i),y=Buffer.from(u,"base64");await this.fileService.writeFile(v.URI.file((0,P.join)(this.environmentMainService.logsPath,`${s}.png`)),h.VSBuffer.wrap(y))}async reloadWindow(i){this.logService.info(`[driver] reloadWindow(${i})`),await this.whenUnfrozen(i);const s=this.windowsMainService.getWindowById(i);if(!s)throw new Error("Invalid window");this.reloadingWindowIds.add(i),this.lifecycleMainService.reload(s)}exitApplication(){return this.logService.info("[driver] exitApplication()"),this.lifecycleMainService.quit()}async dispatchKeybinding(i,s){await this.whenUnfrozen(i);const o=L.KeybindingParser.parseUserBinding(s);for(let u of o)await this._dispatchKeybinding(i,u)}async _dispatchKeybinding(i,s){if(s instanceof D.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const o=this.windowsMainService.getWindowById(i);if(!o?.win)throw new Error("Invalid window");const u=o.win.webContents,y=new D.SimpleKeybinding(!1,!1,!1,!1,s.keyCode),R=new w.USLayoutResolvedKeybinding(y.toChord(),S.OS).getElectronAccelerator(),W=[];s.ctrlKey&&W.push("ctrl"),s.metaKey&&W.push("meta"),s.shiftKey&&W.push("shift"),s.altKey&&W.push("alt"),u.sendInputEvent({type:"keyDown",keyCode:R,modifiers:W}),c(s.keyCode)||u.sendInputEvent({type:"char",keyCode:R,modifiers:W}),u.sendInputEvent({type:"keyUp",keyCode:R,modifiers:W}),await(0,m.timeout)(100)}async click(i,s,o,u){await(await this.getWindowDriver(i)).click(s,o,u)}async doubleClick(i,s){await(await this.getWindowDriver(i)).doubleClick(s)}async setValue(i,s,o){await(await this.getWindowDriver(i)).setValue(s,o)}async getTitle(i){return await(await this.getWindowDriver(i)).getTitle()}async isActiveElement(i,s){return await(await this.getWindowDriver(i)).isActiveElement(s)}async getElements(i,s,o){return await(await this.getWindowDriver(i)).getElements(s,o)}async getElementXY(i,s,o,u){return await(await this.getWindowDriver(i)).getElementXY(s,o,u)}async typeInEditor(i,s,o){await(await this.getWindowDriver(i)).typeInEditor(s,o)}async getTerminalBuffer(i,s){return await(await this.getWindowDriver(i)).getTerminalBuffer(s)}async writeInTerminal(i,s,o){await(await this.getWindowDriver(i)).writeInTerminal(s,o)}async getLocaleInfo(i){return await(await this.getWindowDriver(i)).getLocaleInfo()}async getLocalizedStrings(i){return await(await this.getWindowDriver(i)).getLocalizedStrings()}async getWindowDriver(i){await this.whenUnfrozen(i);const s=`window:${i}`,o=new g.StaticRouter(y=>y===s),u=this.windowServer.getChannel("windowDriver",o);return new C.WindowDriverChannelClient(u)}async whenUnfrozen(i){for(;this.reloadingWindowIds.has(i);)await n.Event.toPromise(this.onDidReloadingChange.event)}};a=ue([te(2,d.IWindowsMainService),te(3,t.ILifecycleMainService),te(4,p.IFileService),te(5,E.IEnvironmentMainService),te(6,l.ILogService)],a),e.Driver=a;async function f(r,i,s,o){const u=s.driverVerbose,y=o.createInstance(a,r,{verbose:u}),k=new I.WindowDriverRegistryChannel(y);r.registerChannel("windowDriverRegistry",k);const R=await(0,b.serve)(i),W=new I.DriverChannel(y);return R.registerChannel("driver",W),(0,M.combinedDisposable)(R,r)}e.serve=f}),define(J[232],Z([0,1,61,57]),function(V,e,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(L,D,M,S,g){const b=I=>g(I,void 0),C=m.createConnection({host:L,port:D},()=>{C.removeListener("error",b);const I=Buffer.alloc(16);for(let d=0;d<16;d++)I[d]=Math.round(Math.random()*256);const E=I.toString("base64"),w=[`GET ws://${/:/.test(L)?`[${L}]`:L}:${D}/?${M}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${E}`];C.write(w.join(`\r
`)+`\r
\r
`);const t=d=>{d.toString().indexOf(`\r
\r
`)>=0&&(C.off("data",t),g(void 0,new n.NodeSocket(C,S)))};C.on("data",t)});C.setNoDelay(!0),C.once("error",b)}}}),define(J[233],Z([0,1,204,9,16,15,2,14,19,52,98,6,203,228]),function(V,e,m,n,L,D,M,S,g,b,C,I,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let t=class extends M.Disposable{constructor(p,v,P){super();this.environmentService=v,this.logService=P,this.configure(p.getValue()),this._register(p.onDidChangeConfiguration(()=>this.configure(p.getValue()),this))}configure(p){this.proxyUrl=p.http&&p.http.proxy,this.strictSSL=!!(p.http&&p.http.proxyStrictSSL),this.authorization=p.http&&p.http.proxyAuthorization}async request(p,v){this.logService.trace("RequestService#request",p.url);const{proxyUrl:P,strictSSL:h}=this;let l;try{l=await(0,C.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(f){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request resolving shell environment failed",f))}const c={...process.env,...l},a=p.agent?p.agent:await(0,E.getProxyAgent)(p.url||"",c,{proxyUrl:P,strictSSL:h});return p.agent=a,p.strictSSL=h,this.authorization&&(p.headers={...p.headers||{},"Proxy-Authorization":this.authorization}),this._request(p,v)}async getNodeRequest(p){return((0,m.parse)(p.url).protocol==="https:"?await new Promise((h,l)=>{V(["https"],h,l)}):await new Promise((h,l)=>{V(["http"],h,l)})).request}_request(p,v){return n.Promises.withAsyncBody(async(P,h)=>{let l;const c=(0,m.parse)(p.url),a=p.getRawRequest?p.getRawRequest(p):await this.getNodeRequest(p),f={hostname:c.hostname,port:c.port?parseInt(c.port):c.protocol==="https:"?443:80,protocol:c.protocol,path:c.path,method:p.type||"GET",headers:p.headers,agent:p.agent,rejectUnauthorized:(0,S.isBoolean)(p.strictSSL)?p.strictSSL:!0};p.user&&p.password&&(f.auth=p.user+":"+p.password),l=a(f,r=>{const i=(0,S.isNumber)(p.followRedirects)?p.followRedirects:3;if(r.statusCode&&r.statusCode>=300&&r.statusCode<400&&i>0&&r.headers.location)this._request({...p,url:r.headers.location,followRedirects:i-1},v).then(P,h);else{let s=r;r.headers["content-encoding"]==="gzip"&&(s=r.pipe((0,w.createGunzip)())),P({res:r,stream:(0,L.streamToBufferReadableStream)(s)})}}),l.on("error",h),p.timeout&&l.setTimeout(p.timeout),p.data&&typeof p.data=="string"&&l.write(p.data),l.end(),v.onCancellationRequested(()=>{l.abort(),h((0,D.canceled)())})})}async resolveProxy(p){}};t=ue([te(0,g.IConfigurationService),te(1,b.INativeEnvironmentService),te(2,I.ILogService)],t),e.RequestService=t}),define(J[234],Z([0,1,12,233]),function(V,e,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function L(M){return m.net.request}class D extends n.RequestService{request(S,g){return super.request({...S||{},getRawRequest:L},g)}}e.RequestMainService=D}),define(J[235],Z([0,1,12,9,4,2,10,14,89,22,18,6,53,54,65,39]),function(V,e,m,n,L,D,M,S,g,b,C,I,E,w,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let p=class extends D.Disposable{constructor(P,h,l,c,a,f,r){super();this.machineId=P,this.userEnv=h,this.environmentMainService=l,this.lifecycleMainService=c,this.logService=a,this.themeMainService=f,this.protocolMainService=r,this.firstWindowConnectionBarrier=new n.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new L.Emitter),this.onDidError=L.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){m.ipcMain.on("vscode:createSharedProcessMessageChannel",(P,h)=>this.onWindowConnection(P,h)),m.ipcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(P,h)=>this.onWorkerConnection(P,h)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(P,h){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const l=await this.connect();if(P.sender.isDestroyed())return l.close();P.sender.postMessage("vscode:createSharedProcessMessageChannelResult",h,[l])}onWorkerConnection(P,h){this.logService.trace("SharedProcess: onWorkerConnection",h);const l=new D.DisposableStore,c=f=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${f}')`,h),l.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",h))},a=m.BrowserWindow.fromId(h.reply.windowId);if(!a||a.isDestroyed()||a.webContents.isDestroyed()||!h.reply.channel){c("unavailable");return}l.add(L.Event.filter(this.lifecycleMainService.onWillLoadWindow,f=>f.window.win===a)(()=>c("load"))),l.add(L.Event.fromNodeEventEmitter(a,"closed")(()=>c("closed"))),a.webContents.postMessage(h.reply.channel,h.reply.nonce,P.ports)}onWillShutdown(){const P=this.window;!P||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(P.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{P.close()}catch{}this.window=void 0},0))}send(P,...h){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${P}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(P,...h)}catch(l){this.logService.warn(`Error sending IPC message to channel '${P}' of shared process: ${(0,d.toErrorMessage)(l)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(P=>m.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),P()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(P=>m.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),P()}))})()),this._whenIpcReady}createWindow(){const P=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new m.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:M.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",V).fsPath,additionalArguments:[`--vscode-window-config=${P.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1}}),P.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:E.default}),this.window.loadURL(M.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",V).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=P=>{this.logService.trace("SharedProcess#close prevented"),P.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(P,h)=>this._onDidError.fire({type:2,details:h})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(P,h,l)=>this._onDidError.fire({type:3,details:{reason:l,exitCode:h}})))}async connect(){await this.whenIpcReady;const P=(0,S.assertIsDefined)(this.window);return(0,g.connect)(P)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const P=this.window;return P?!P.isDestroyed()&&!P.webContents.isDestroyed():!1}};p=ue([te(2,b.IEnvironmentMainService),te(3,C.ILifecycleMainService),te(4,I.ILogService),te(5,t.IThemeMainService),te(6,w.IProtocolMainService)],p),e.SharedProcess=p}),define(J[236],Z([0,1,9,16,7,14,8,22,20,6]),function(V,e,m,n,L,D,M,S,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class C{constructor(w,t,d){this.storagePath=w,this.logService=t,this.fileService=d,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new m.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(w){w.fileOperationResult!==1&&this.logService.error(w)}}getItem(w,t){const d=this.storage[w];return(0,D.isUndefinedOrNull)(d)?t:d}setItem(w,t){this.setItems([{key:w,data:t}])}setItems(w){let t=!1;for(const{key:d,data:p}of w)this.storage[d]!==p&&((0,D.isUndefinedOrNull)(p)?(0,D.isUndefined)(this.storage[d])||(this.storage[d]=void 0,t=!0):(this.storage[d]=p,t=!0));t&&this.save()}removeItem(w){(0,D.isUndefined)(this.storage[w])||(this.storage[w]=void 0,this.save())}async save(w){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),w)}async doSave(){if(!this.initializing)return;await this.initializing;const w=JSON.stringify(this.storage,null,4);if(w!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,n.VSBuffer.fromString(w)),this.lastSavedStorageContents=w}catch(t){this.logService.error(t)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=C;let I=class Mt{constructor(w,t,d){this.fileStorage=new C(M.URI.file((0,L.join)(w.userDataPath,Mt.STATE_FILE)),t,d)}async init(){return this.fileStorage.init()}getItem(w,t){return this.fileStorage.getItem(w,t)}setItem(w,t){this.fileStorage.setItem(w,t)}setItems(w){this.fileStorage.setItems(w)}removeItem(w){this.fileStorage.removeItem(w)}close(){return this.fileStorage.close()}};I.STATE_FILE="storage.json",I=ue([te(0,S.IEnvironmentMainService),te(1,b.ILogService),te(2,g.IFileService)],I),e.StateMainService=I}),define(J[81],Z([0,1,43,2,52,22,5,18,6,97,225]),function(V,e,m,n,L,D,M,S,g,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GlobalStorageMainService=e.IGlobalStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,M.createDecorator)("storageMainService");let I=class extends n.Disposable{constructor(t,d,p){super();this.logService=t,this.environmentService=d,this.lifecycleMainService=p,this.shutdownReason=void 0,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async t=>{t.workspace&&this.workspaceStorage(t.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(t=>{this.logService.trace("storageMainService#onWillShutdown()"),this.shutdownReason=t.reason,t.join(this.globalStorage.close());for(const[,d]of this.mapWorkspaceToStorage)t.join(d.close())}))}createGlobalStorage(){this.logService.trace("StorageMainService: creating global storage");const t=new C.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,m.once)(t.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),t}workspaceStorage(t){let d=this.mapWorkspaceToStorage.get(t.id);return d||(this.logService.trace(`StorageMainService: creating workspace storage (${t.id})`),d=this.createWorkspaceStorage(t),this.mapWorkspaceToStorage.set(t.id,d),(0,m.once)(d.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${t.id})`),this.mapWorkspaceToStorage.delete(t.id)})),d}createWorkspaceStorage(t){return this.shutdownReason===2?new C.InMemoryStorageMain(this.logService):new C.WorkspaceStorageMain(t,this.getStorageOptions(),this.logService,this.environmentService)}};I=ue([te(0,g.ILogService),te(1,L.IEnvironmentService),te(2,S.ILifecycleMainService)],I),e.StorageMainService=I,e.IGlobalStorageMainService=(0,M.createDecorator)("globalStorageMainService");let E=class extends b.AbstractStorageService{constructor(t,d){super();this.environmentMainService=t,this.storageMainService=d,this.whenReady=this.storageMainService.globalStorage.whenInit}doInitialize(){return this.storageMainService.globalStorage.whenInit}getStorage(t){switch(t){case 0:return this.storageMainService.globalStorage.storage;case 1:return}}getLogDetails(t){return t===0?this.environmentMainService.globalStorageHome.fsPath:void 0}shouldFlushWhenIdle(){return!1}migrate(){throw new Error("Migrating storage is unsupported from main process")}};E=ue([te(0,D.IEnvironmentMainService),te(1,e.IStorageMainService)],E),e.GlobalStorageMainService=E}),define(J[237],Z([0,1,61,123,232,9,2,19,6,21,202,99,79]),function(V,e,m,n,L,D,M,S,g,b,C,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function w(P,h,l,c,a){let f;for(let r=3;r&&(f&&f.dispose(),f=await new t(P,h,l,c,a).waitForReady(),!(a&&n.BROWSER_RESTRICTED_PORTS[a]||!n.BROWSER_RESTRICTED_PORTS[f.tunnelLocalPort]));r--);return f}class t extends M.Disposable{constructor(h,l,c,a,f){super();this.defaultTunnelHost=l,this.suggestedLocalPort=f,this.privacy=I.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=h,this._server=m.createServer(),this._barrier=new D.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=r=>this._onConnection(r),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=a,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(l=>{l()})}async waitForReady(){let h=await(0,n.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),l=null;return this._server.listen(h,this.defaultTunnelHost),await this._barrier.wait(),l=this._server.address(),l||(h=0,this._server.listen(h,this.defaultTunnelHost),await this._barrier.wait(),l=this._server.address()),this.tunnelLocalPort=l.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${l.port}`,this}async _onConnection(h){h.pause();const l=(0,I.isLocalhost)(this.tunnelRemoteHost)||(0,I.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,C.connectRemoteAgentTunnel)(this._options,l,this.tunnelRemotePort),a=c.getSocket().socket,f=c.readEntireBuffer();c.dispose(),f.byteLength>0&&h.write(f.buffer),h.on("end",()=>{h.localAddress&&this._socketsDispose.delete(h.localAddress),a.end()}),h.on("close",()=>a.end()),h.on("error",()=>{h.localAddress&&this._socketsDispose.delete(h.localAddress),a.destroy()}),a.on("end",()=>h.end()),a.on("close",()=>h.end()),a.on("error",()=>{h.destroy()}),h.pipe(a),a.pipe(h),h.localAddress&&this._socketsDispose.set(h.localAddress,()=>{h.end(),a.end()})}}let d=class extends I.AbstractTunnelService{constructor(h,l,c,a,f){super(l);this.socketFactory=h,this.signService=c,this.productService=a,this.configurationService=f}get defaultTunnelHost(){const h=this.configurationService.getValue("remote.localPortHost");return!h||h==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(h,l,c,a,f,r,i){const s=this.getTunnelFromMap(l,c);if(s)return++s.refcount,s.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,l,c,a,f,r,i);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${l}:${c} on local port ${a}.`);const o={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:h,signService:this.signService,logService:this.logService,ipcLogger:null},u=w(o,this.defaultTunnelHost,l,c,a);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(l,c,u),u}}};d=ue([te(1,g.ILogService),te(2,E.ISignService),te(3,b.IProductService),te(4,S.IConfigurationService)],d),e.BaseTunnelService=d;let p=class extends d{constructor(h,l,c,a){super(L.nodeSocketFactory,h,l,c,a)}};p=ue([te(0,g.ILogService),te(1,E.ISignService),te(2,b.IProductService),te(3,S.IConfigurationService)],p),e.TunnelService=p;let v=class extends M.Disposable{constructor(h,l,c,a){super();this.logService=h,this.productService=l,this.signService=c,this.configurationService=a,this._tunnelServices=new Map}async openTunnel(h,l,c,a,f,r,i,s){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${a} on local port ${f}.`),!this._tunnelServices.has(h)){const o=new p(this.logService,this.signService,this.productService,this.configurationService);this._register(o),this._tunnelServices.set(h,o),o.onTunnelClosed(async()=>{(await o.tunnels).length===0&&(o.dispose(),this._tunnelServices.delete(h))})}return this._tunnelServices.get(h).openTunnel(l,c,a,f,r,i,s)}};v=ue([te(0,g.ILogService),te(1,b.IProductService),te(2,E.ISignService),te(3,S.IConfigurationService)],v),e.SharedTunnelsService=v}),define(J[82],Z([0,1,9,23,4,19,22,18,6,21,56,41]),function(V,e,m,n,L,D,M,S,g,b,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function E(t,d,p){return`${p.updateUrl}/api/update/${t}/${d}/${p.commit}`}e.createUpdateURL=E;let w=class{constructor(d,p,v,P,h,l){this.lifecycleMainService=d,this.configurationService=p,this.environmentMainService=v,this.requestService=P,this.logService=h,this.productService=l,this._state=I.State.Uninitialized,this._onStateChange=new L.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(d){this.logService.info("update#setState",d.type),this._state=d,this._onStateChange.fire(d)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const d=this.getUpdateMode(),p=this.getProductQuality(d);if(!p){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(p),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(I.State.Idle(this.getUpdateType())),d==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}d==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,v=>this.logService.error(v))}getUpdateMode(){return(0,D.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(d){return d==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(d=60*60*1e3){return(0,m.timeout)(d).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(d){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(d)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(d){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(d=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${d}`),!d&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(this.url){if(this.getUpdateMode()==="none")return!1}else return;return(await this.requestService.request({url:this.url},n.CancellationToken.None)).res.statusCode===204}getUpdateType(){return 1}doQuitAndInstall(){}};w=ue([te(0,S.ILifecycleMainService),te(1,D.IConfigurationService),te(2,M.IEnvironmentMainService),te(3,C.IRequestService),te(4,g.ILogService),te(5,b.IProductService)],w),e.AbstractUpdateService=w}),define(J[238],Z([0,1,12,46,4,2,19,22,18,6,21,56,32,41,82]),function(V,e,m,n,L,D,M,S,g,b,C,I,E,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let d=class extends t.AbstractUpdateService{constructor(v,P,h,l,c,a,f){super(v,P,l,c,a,f);this.telemetryService=h,this.disposables=new D.DisposableStore}get onRawError(){return L.Event.fromNodeEventEmitter(m.autoUpdater,"error",(v,P)=>P)}get onRawUpdateNotAvailable(){return L.Event.fromNodeEventEmitter(m.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return L.Event.fromNodeEventEmitter(m.autoUpdater,"update-available",(v,P,h)=>({url:P,version:h,productVersion:h}))}get onRawUpdateDownloaded(){return L.Event.fromNodeEventEmitter(m.autoUpdater,"update-downloaded",(v,P,h,l)=>({releaseNotes:P,version:h,productVersion:h,date:l}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(v){this.logService.error("UpdateService error:",v);const h=(this.state.type==="checking for updates"?this.state.explicit:!0)?v:void 0;this.setState(w.State.Idle(1,h))}buildUpdateFeedUrl(v){let P;this.productService.darwinUniversalAssetId?P=this.productService.darwinUniversalAssetId:P=process.arch==="x64"?"darwin":"darwin-arm64";const h=(0,t.createUpdateURL)(P,v,this.productService);try{m.autoUpdater.setFeedURL({url:h})}catch(l){this.logService.error("Failed to set update feed URL",l);return}return h}doCheckForUpdates(v){this.setState(w.State.CheckingForUpdates(v)),m.autoUpdater.checkForUpdates()}onUpdateAvailable(v){this.state.type==="checking for updates"&&this.setState(w.State.Downloading(v))}onUpdateDownloaded(v){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:v.version}),this.setState(w.State.Ready(v)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(w.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),m.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};ue([n.memoize],d.prototype,"onRawError",null),ue([n.memoize],d.prototype,"onRawUpdateNotAvailable",null),ue([n.memoize],d.prototype,"onRawUpdateAvailable",null),ue([n.memoize],d.prototype,"onRawUpdateDownloaded",null),d=ue([te(0,g.ILifecycleMainService),te(1,M.IConfigurationService),te(2,E.ITelemetryService),te(3,S.IEnvironmentMainService),te(4,I.IRequestService),te(5,b.ILogService),te(6,C.IProductService)],d),e.DarwinUpdateService=d}),define(J[239],Z([0,1,45,29,9,4,7,22,18,6,32,41]),function(V,e,m,n,L,D,M,S,g,b,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let E=class{constructor(d,p,v){if(this.lifecycleMainService=d,this.logService=v,this._state=I.State.Uninitialized,this._onStateChange=new D.Emitter,this.onStateChange=this._onStateChange.event,p.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(I.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,P=>this.logService.error(P))}get state(){return this._state}setState(d){this.logService.info("update#setState",d.type),this._state=d,this._onStateChange.fire(d)}scheduleCheckForUpdates(d=60*60*1e3){return(0,L.timeout)(d).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(d){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(d)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(d){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(d=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${d}`),!d&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};E=ue([te(0,g.ILifecycleMainService),te(1,S.IEnvironmentMainService),te(2,b.ILogService)],E);let w=class extends E{constructor(d,p,v,P,h,l){super(v,P,h);this.snap=d,this.snapRevision=p,this.telemetryService=l;const c=(0,n.watch)(M.dirname(this.snap)),a=D.Event.fromNodeEventEmitter(c,"change",(s,o)=>o),f=D.Event.filter(a,s=>s==="current"),i=D.Event.debounce(f,(s,o)=>o,2e3)(()=>this.checkForUpdates(!1));v.onWillShutdown(()=>{i.dispose(),c.close()})}doCheckForUpdates(){this.setState(I.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(d=>{d?this.setState(I.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(I.State.Idle(2)))},d=>{this.logService.error(d),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(I.State.Idle(2,d.message||d))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,m.spawn)("sleep 3 && "+M.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const d=await new Promise((v,P)=>(0,n.realpath)(`${M.dirname(this.snap)}/current`,(h,l)=>h?P(h):v(l))),p=M.basename(d);return this.snapRevision!==p}isLatestVersion(){return this.isUpdateAvailable().then(void 0,d=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};w=ue([te(2,g.ILifecycleMainService),te(3,S.IEnvironmentMainService),te(4,b.ILogService),te(5,C.ITelemetryService)],w),e.SnapUpdateService=w}),define(J[42],Z([0,1,12,29,4,44,33,2,10,7,3,17,14,24,161,51,47,22,5,6,21,102,25,80,103]),function(V,e,m,n,L,D,M,S,g,b,C,I,E,w,t,d,p,v,P,h,l,c,a,f,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,P.createDecorator)("workspacesManagementMainService");let i=class extends S.Disposable{constructor(o,u,y,k,R){super();this.environmentMainService=o,this.logService=u,this.backupMainService=y,this.dialogMainService=k,this.productService=R,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new L.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new L.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(o){return this.doResolveLocalWorkspace(o,u=>(0,n.readFileSync)(u,"utf8"))}resolveLocalWorkspace(o){return this.doResolveLocalWorkspace(o,u=>w.Promises.readFile(u,"utf8"))}doResolveLocalWorkspace(o,u){if(!!this.isWorkspacePath(o)&&o.scheme===g.Schemas.file)try{const y=u(o.fsPath);return y instanceof Promise?y.then(k=>this.doResolveWorkspace(o,k),k=>{}):this.doResolveWorkspace(o,y)}catch{return}}isWorkspacePath(o){return(0,a.isUntitledWorkspace)(o,this.environmentMainService)||(0,a.hasWorkspaceFileExtension)(o)}doResolveWorkspace(o,u){try{const y=this.doParseStoredWorkspace(o,u),k=(0,r.getWorkspaceIdentifier)(o);return{id:k.id,configPath:k.configPath,folders:(0,f.toWorkspaceFolders)(y.folders,k.configPath,I.extUriBiasedIgnorePathCase),remoteAuthority:y.remoteAuthority,transient:y.transient}}catch(y){this.logService.warn(y.toString())}}doParseStoredWorkspace(o,u){const y=(0,D.parse)(u);if(y&&Array.isArray(y.folders))y.folders=y.folders.filter(k=>(0,f.isStoredWorkspaceFolder)(k));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return y}async createUntitledWorkspace(o,u){const{workspace:y,storedWorkspace:k}=this.newUntitledWorkspace(o,u),R=y.configPath.fsPath;return await w.Promises.mkdir((0,b.dirname)(R),{recursive:!0}),await w.Promises.writeFile(R,JSON.stringify(k,null,"	")),y}createUntitledWorkspaceSync(o,u){const{workspace:y,storedWorkspace:k}=this.newUntitledWorkspace(o,u),R=y.configPath.fsPath;return(0,n.mkdirSync)((0,b.dirname)(R),{recursive:!0}),(0,w.writeFileSync)(R,JSON.stringify(k,null,"	")),y}newUntitledWorkspace(o=[],u){const y=(Date.now()+Math.round(Math.random()*1e3)).toString(),k=(0,I.joinPath)(this.untitledWorkspacesHome,y),R=(0,I.joinPath)(k,a.UNTITLED_WORKSPACE_NAME),W=[];for(const U of o)W.push((0,f.getStoredWorkspaceFolder)(U.uri,!0,U.name,k,!C.isWindows,I.extUriBiasedIgnorePathCase));return{workspace:(0,r.getWorkspaceIdentifier)(R),storedWorkspace:{folders:W,remoteAuthority:u}}}async getWorkspaceIdentifier(o){return(0,r.getWorkspaceIdentifier)(o)}isUntitledWorkspace(o){return(0,a.isUntitledWorkspace)(o.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(o){!this.isUntitledWorkspace(o)||(this.doDeleteUntitledWorkspaceSync(o),this._onDidDeleteUntitledWorkspace.fire(o))}async deleteUntitledWorkspace(o){this.deleteUntitledWorkspaceSync(o)}doDeleteUntitledWorkspaceSync(o){const u=(0,I.originalFSPath)(o.configPath);try{(0,w.rimrafSync)((0,b.dirname)(u));const y=(0,b.join)(this.environmentMainService.workspaceStorageHome.fsPath,o.id);(0,n.existsSync)(y)&&(0,w.writeFileSync)((0,b.join)(y,"obsolete"),"")}catch(y){this.logService.warn(`Unable to delete untitled workspace ${u} (${y}).`)}}getUntitledWorkspacesSync(){const o=[];try{const u=(0,w.readdirSync)(this.untitledWorkspacesHome.fsPath).map(y=>(0,I.joinPath)(this.untitledWorkspacesHome,y,a.UNTITLED_WORKSPACE_NAME));for(const y of u){const k=(0,r.getWorkspaceIdentifier)(y),R=this.resolveLocalWorkspaceSync(y);R?o.push({workspace:k,remoteAuthority:R.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(k)}}catch(u){u.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${u}).`)}return o}async enterWorkspace(o,u,y){if(!o||!o.win||!o.isReady||!await this.isValidTargetWorkspacePath(o,u,y))return;const R=this.doEnterWorkspace(o,(0,r.getWorkspaceIdentifier)(y));if(!!R)return this._onDidEnterWorkspace.fire({window:o,workspace:R.workspace}),R}async isValidTargetWorkspacePath(o,u,y){if(!y)return!0;if((0,a.isWorkspaceIdentifier)(o.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqual(o.openedWorkspace.configPath,y))return!1;if((0,c.findWindowOnWorkspaceOrFolder)(u,y)){const k={title:this.productService.nameLong,type:"info",buttons:[(0,M.mnemonicButtonLabel)((0,t.localize)(0,null))],message:(0,t.localize)(1,null,(0,I.basename)(y)),detail:(0,t.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(k,(0,E.withNullAsUndefined)(m.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(o,u){if(!o.config)return;o.focus();let y;return o.config.extensionDevelopmentPath||(y=this.backupMainService.registerWorkspaceBackupSync({workspace:u,remoteAuthority:o.remoteAuthority},o.config.backupPath)),(0,a.isWorkspaceIdentifier)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&this.deleteUntitledWorkspaceSync(o.openedWorkspace),o.config.workspace=u,o.config.backupPath=y,{workspace:u,backupPath:y}}};i=ue([te(0,v.IEnvironmentMainService),te(1,h.ILogService),te(2,d.IBackupMainService),te(3,p.IDialogMainService),te(4,l.IProductService)],i),e.WorkspacesManagementMainService=i}),define(J[104],Z([0,1,12,23,5,34,25,42]),function(V,e,m,n,L,D,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,L.createDecorator)(e.ID);let g=class{constructor(C,I){this.windowsMainService=C,this.workspacesManagementMainService=I}async getRemoteDiagnostics(C){const I=this.windowsMainService.getWindows();return(await Promise.all(I.map(w=>new Promise(t=>{const d=w.remoteAuthority;if(d){const p=`vscode:getDiagnosticInfoResponse${w.id}`,v={includeProcesses:C.includeProcesses,folders:C.includeWorkspaceMetadata?this.getFolderURIs(w):void 0};w.sendWhenReady("vscode:getDiagnosticInfo",n.CancellationToken.None,{replyChannel:p,args:v}),m.ipcMain.once(p,(P,h)=>{h||t({hostName:d,errorMessage:`Unable to resolve connection to '${d}'.`}),t(h)}),setTimeout(()=>{t({hostName:d,errorMessage:`Connection to '${d}' could not be established`})},5e3)}else t(void 0)})))).filter(w=>!!w)}getFolderURIs(C){const I=[],E=C.openedWorkspace;if((0,M.isSingleFolderWorkspaceIdentifier)(E))I.push(E.uri);else if((0,M.isWorkspaceIdentifier)(E)){const w=this.workspacesManagementMainService.resolveLocalWorkspaceSync(E.configPath);w&&w.folders.forEach(d=>{I.push(d.uri)})}return I}};g=ue([te(0,D.IWindowsMainService),te(1,S.IWorkspacesManagementMainService)],g),e.DiagnosticsMainService=g}),define(J[105],Z([0,1,12,30,3,14,8,24,19,50,5,6,100,34,25,42]),function(V,e,m,n,L,D,M,S,g,b,C,I,E,w,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,C.createDecorator)(e.ID);let p=class{constructor(P,h,l,c,a){this.logService=P,this.windowsMainService=h,this.urlService=l,this.workspacesManagementMainService=c,this.configurationService=a}async start(P,h){this.logService.trace("Received data from other instance: ",P,h),L.isMacintosh&&m.app.focus({steal:!0});const l=this.parseOpenUrl(P);if(l.length){let c=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(c=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),c.then(()=>{for(const{uri:a,url:f}of l)this.urlService.open(a,{originalUrl:f})})}else return this.startOpenWindow(P,h)}parseOpenUrl(P){return P["open-url"]&&P._urls&&P._urls.length>0?(0,n.coalesce)(P._urls.map(h=>{try{return{uri:M.URI.parse(h),url:h}}catch{return null}})):[]}async startOpenWindow(P,h){const l=(0,b.isLaunchedFromCli)(h)?0:4;let c=[];const a=P.wait&&P.waitMarkerFilePath?M.URI.file(P.waitMarkerFilePath):void 0,f=P.remote||void 0,r={context:l,cli:P,userEnv:h,waitMarkerFileURI:a,remoteAuthority:f};if(P.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(P.extensionDevelopmentPath,r);else if(!P._.length&&!P["folder-uri"]&&!P["file-uri"]){let i=!1;if(P["new-window"]||P["unity-launch"])i=!0;else if(P["reuse-window"])i=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":i=!0;break;case"off":i=!1;break;default:i=!L.isMacintosh}if(i)c=this.windowsMainService.open({...r,forceNewWindow:!0,forceEmpty:!0});else{const s=this.windowsMainService.getLastActiveWindow();s?(this.windowsMainService.openExistingWindow(s,r),c=[s]):c=this.windowsMainService.open({...r,forceEmpty:!0})}}else c=this.windowsMainService.open({...r,forceNewWindow:P["new-window"],preferNewWindow:!P["reuse-window"]&&!P.wait,forceReuseWindow:P["reuse-window"],diffMode:P.diff,addMode:P.add,noRecentEntry:!!P["skip-add-to-recently-opened"],gotoLineMode:P.goto});if(a&&c.length===1&&c[0])return Promise.race([c[0].whenClosedOrLoaded,(0,S.whenDeleted)(a.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const P=[];return m.BrowserWindow.getAllWindows().forEach(h=>{const l=this.windowsMainService.getWindowById(h.id);l?P.push(this.codeWindowToInfo(l)):P.push(this.browserWindowToInfo(h))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:P,screenReader:!!m.app.accessibilitySupportEnabled,gpuFeatureStatus:m.app.getGPUFeatureStatus()}}getFolderURIs(P){const h=[],l=P.openedWorkspace;if((0,t.isSingleFolderWorkspaceIdentifier)(l))h.push(l.uri);else if((0,t.isWorkspaceIdentifier)(l)){const c=this.workspacesManagementMainService.resolveLocalWorkspaceSync(l.configPath);c&&c.folders.forEach(f=>{h.push(f.uri)})}return h}codeWindowToInfo(P){const h=this.getFolderURIs(P),l=(0,D.assertIsDefined)(P.win);return this.browserWindowToInfo(l,h,P.remoteAuthority)}browserWindowToInfo(P,h=[],l){return{pid:P.webContents.getOSProcessId(),title:P.getTitle(),folderURIs:h,remoteAuthority:l}}};p=ue([te(0,I.ILogService),te(1,w.IWindowsMainService),te(2,E.IURLService),te(3,d.IWorkspacesManagementMainService),te(4,g.IConfigurationService)],p),e.LaunchMainService=p}),define(J[58],Z([0,1,45,12,26,122,46,4,33,2,10,7,3,8,86,71,24,152,47,22,5,18,6,21,32,65,34,25,42]),function(V,e,m,n,L,D,M,S,g,b,C,I,E,w,t,d,p,v,P,h,l,c,a,f,r,i,s,o,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,l.createDecorator)("nativeHostMainService");let y=class extends b.Disposable{constructor(R,W,U,K,x,ee,Q,H,X,z){super();this.sharedProcess=R,this.windowsMainService=W,this.dialogMainService=U,this.lifecycleMainService=K,this.environmentMainService=x,this.telemetryService=ee,this.logService=Q,this.productService=H,this.themeMainService=X,this.workspacesManagementMainService=z,this.onDidOpenWindow=S.Event.map(this.windowsMainService.onDidOpenWindow,ie=>ie.id),this.onDidMaximizeWindow=S.Event.filter(S.Event.fromNodeEventEmitter(n.app,"browser-window-maximize",(ie,$)=>$.id),ie=>!!this.windowsMainService.getWindowById(ie)),this.onDidUnmaximizeWindow=S.Event.filter(S.Event.fromNodeEventEmitter(n.app,"browser-window-unmaximize",(ie,$)=>$.id),ie=>!!this.windowsMainService.getWindowById(ie)),this.onDidBlurWindow=S.Event.filter(S.Event.fromNodeEventEmitter(n.app,"browser-window-blur",(ie,$)=>$.id),ie=>!!this.windowsMainService.getWindowById(ie)),this.onDidFocusWindow=S.Event.any(S.Event.map(S.Event.filter(S.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),ie=>!!ie),ie=>ie.id),S.Event.filter(S.Event.fromNodeEventEmitter(n.app,"browser-window-focus",(ie,$)=>$.id),ie=>!!this.windowsMainService.getWindowById(ie))),this.onDidResumeOS=S.Event.fromNodeEventEmitter(n.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new S.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new S.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=S.Event.debounce(S.Event.any(S.Event.filter(S.Event.fromNodeEventEmitter(n.screen,"display-metrics-changed",(ie,$,q)=>q),ie=>!(Array.isArray(ie)&&ie.length===1&&ie[0]==="workArea")),S.Event.fromNodeEventEmitter(n.screen,"display-added"),S.Event.fromNodeEventEmitter(n.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){n.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.osColorScheme)})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(W=>({id:W.id,workspace:W.openedWorkspace,title:W.win?.getTitle()??"",filename:W.getRepresentedFilename(),dirty:W.isDocumentEdited()}))}async getWindowCount(R){return this.windowsMainService.getWindowCount()}async getActiveWindowId(R){const W=n.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(W)return W.id}openWindow(R,W,U){return Array.isArray(W)?this.doOpenWindow(R,W,U):this.doOpenEmptyWindow(R,W)}async doOpenWindow(R,W,U=Object.create(null)){W.length>0&&this.windowsMainService.open({context:5,contextWindowId:R,urisToOpen:W,cli:this.environmentMainService.args,forceNewWindow:U.forceNewWindow,forceReuseWindow:U.forceReuseWindow,preferNewWindow:U.preferNewWindow,diffMode:U.diffMode,addMode:U.addMode,gotoLineMode:U.gotoLineMode,noRecentEntry:U.noRecentEntry,waitMarkerFileURI:U.waitMarkerFileURI,remoteAuthority:U.remoteAuthority||void 0})}async doOpenEmptyWindow(R,W){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:R},W)}async toggleFullScreen(R){const W=this.windowById(R);W&&W.toggleFullScreen()}async handleTitleDoubleClick(R){const W=this.windowById(R);W&&W.handleTitleDoubleClick()}async isMaximized(R){const W=this.windowById(R);return W?.win?W.win.isMaximized():!1}async maximizeWindow(R){const W=this.windowById(R);W?.win&&W.win.maximize()}async unmaximizeWindow(R){const W=this.windowById(R);W?.win&&W.win.unmaximize()}async minimizeWindow(R){const W=this.windowById(R);W?.win&&W.win.minimize()}async focusWindow(R,W){W&&typeof W.windowId=="number"&&(R=W.windowId);const U=this.windowById(R);U&&U.focus({force:W?.force??!1})}async setMinimumSize(R,W,U){const K=this.windowById(R);if(K?.win){const[x,ee]=K.win.getSize(),[Q,H]=K.win.getMinimumSize(),[X,z]=[W??Q,U??H],[ie,$]=[Math.max(x,X),Math.max(ee,z)];(Q!==X||H!==z)&&K.win.setMinimumSize(X,z),(x!==ie||ee!==$)&&K.win.setSize(ie,$)}}async saveWindowSplash(R,W){this.themeMainService.saveWindowSplash(R,W)}async installShellCommand(R){const{source:W,target:U}=await this.getShellCommandLink();try{const{symbolicLink:K}=await p.SymlinkSupport.stat(W);if(K&&!K.dangling){const x=await(0,t.realpath)(W);if(U===x)return}await p.Promises.unlink(W)}catch(K){if(K.code!=="ENOENT")throw K}try{await p.Promises.symlink(U,W)}catch(K){if(K.code!=="EACCES"&&K.code!=="ENOENT")throw K;const{response:x}=await this.showMessageBox(R,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(0,null,this.productService.nameShort),buttons:[(0,g.mnemonicButtonLabel)((0,v.localize)(1,null)),(0,g.mnemonicButtonLabel)((0,v.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(x===0)try{const ee=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${U}' '${W}'\\" with administrator privileges"`;await(0,D.promisify)(m.exec)(ee)}catch{throw new Error((0,v.localize)(3,null,W))}}}async uninstallShellCommand(R){const{source:W}=await this.getShellCommandLink();try{await p.Promises.unlink(W)}catch(U){switch(U.code){case"EACCES":{const{response:K}=await this.showMessageBox(R,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(4,null,this.productService.nameShort),buttons:[(0,g.mnemonicButtonLabel)((0,v.localize)(5,null)),(0,g.mnemonicButtonLabel)((0,v.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(K===0)try{const x=`osascript -e "do shell script \\"rm '${W}'\\" with administrator privileges"`;await(0,D.promisify)(m.exec)(x)}catch{throw new Error((0,v.localize)(7,null,W))}break}case"ENOENT":break;default:throw U}}}async getShellCommandLink(){const R=(0,I.resolve)(this.environmentMainService.appRoot,"bin","code"),W=`/usr/local/bin/${this.productService.applicationName}`;if(!await p.Promises.exists(R))throw new Error((0,v.localize)(8,null,R));return{source:W,target:R}}async showMessageBox(R,W){return this.dialogMainService.showMessageBox(W,this.toBrowserWindow(R))}async showSaveDialog(R,W){return this.dialogMainService.showSaveDialog(W,this.toBrowserWindow(R))}async showOpenDialog(R,W){return this.dialogMainService.showOpenDialog(W,this.toBrowserWindow(R))}toBrowserWindow(R){const W=this.windowById(R);if(W?.win)return W.win}async pickFileFolderAndOpen(R,W){const U=await this.dialogMainService.pickFileFolder(W);U&&(this.sendPickerTelemetry(U,W.telemetryEventName||"openFileFolder",W.telemetryExtraData),this.doOpenPicked(await Promise.all(U.map(async K=>await p.SymlinkSupport.existsDirectory(K)?{folderUri:w.URI.file(K)}:{fileUri:w.URI.file(K)})),W,R))}async pickFolderAndOpen(R,W){const U=await this.dialogMainService.pickFolder(W);U&&(this.sendPickerTelemetry(U,W.telemetryEventName||"openFolder",W.telemetryExtraData),this.doOpenPicked(U.map(K=>({folderUri:w.URI.file(K)})),W,R))}async pickFileAndOpen(R,W){const U=await this.dialogMainService.pickFile(W);U&&(this.sendPickerTelemetry(U,W.telemetryEventName||"openFile",W.telemetryExtraData),this.doOpenPicked(U.map(K=>({fileUri:w.URI.file(K)})),W,R))}async pickWorkspaceAndOpen(R,W){const U=await this.dialogMainService.pickWorkspace(W);U&&(this.sendPickerTelemetry(U,W.telemetryEventName||"openWorkspace",W.telemetryExtraData),this.doOpenPicked(U.map(K=>({workspaceUri:w.URI.file(K)})),W,R))}doOpenPicked(R,W,U){this.windowsMainService.open({context:3,contextWindowId:U,cli:this.environmentMainService.args,urisToOpen:R,forceNewWindow:W.forceNewWindow})}sendPickerTelemetry(R,W,U){const K=R?R.length:0;this.telemetryService.publicLog(W,{...U,outcome:K?"success":"canceled",numberOfPaths:K})}async showItemInFolder(R,W){n.shell.showItemInFolder(W)}async setRepresentedFilename(R,W){const U=this.windowById(R);U&&U.setRepresentedFilename(W)}async setDocumentEdited(R,W){const U=this.windowById(R);U&&U.setDocumentEdited(W)}async openExternal(R,W){return E.isLinuxSnap?this.safeSnapOpenExternal(W):n.shell.openExternal(W),!0}safeSnapOpenExternal(R){const W=process.env.GDK_PIXBUF_MODULE_FILE,U=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,n.shell.openExternal(R),process.env.GDK_PIXBUF_MODULE_FILE=W,process.env.GDK_PIXBUF_MODULEDIR=U}moveItemToTrash(R,W){return n.shell.trashItem(W)}async isAdmin(){let R;return E.isWindows?R=(await new Promise((W,U)=>{V(["native-is-elevated"],W,U)}))():R=process.getuid()===0,R}async writeElevated(R,W,U,K){const x=await new Promise((ee,Q)=>{V(["@vscode/sudo-prompt"],ee,Q)});return new Promise((ee,Q)=>{const H=[`"${this.cliPath}"`];K?.unlock&&H.push("--file-chmod"),H.push("--file-write",`"${W.fsPath}"`,`"${U.fsPath}"`);const X={name:this.productService.nameLong.replace("-",""),icns:E.isMacintosh&&this.environmentMainService.isBuilt?(0,I.join)((0,I.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};x.exec(H.join(" "),X,(z,ie,$)=>{ie&&this.logService.trace(`[sudo-prompt] received stdout: ${ie}`),$&&this.logService.trace(`[sudo-prompt] received stderr: ${$}`),z?Q(z):ee(void 0)})})}get cliPath(){return E.isWindows?this.environmentMainService.isBuilt?(0,I.join)((0,I.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,I.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):E.isLinux?this.environmentMainService.isBuilt?(0,I.join)((0,I.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,I.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,I.join)(this.environmentMainService.appRoot,"bin","code"):(0,I.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,L.totalmem)(),freemem:(0,L.freemem)(),loadavg:(0,L.loadavg)()}}async getOSProperties(){return{arch:(0,L.arch)(),platform:(0,L.platform)(),release:(0,L.release)(),type:(0,L.type)(),cpus:(0,L.cpus)()}}async getOSVirtualMachineHint(){return d.virtualMachineHint.value()}get osColorScheme(){return{highContrast:n.nativeTheme.shouldUseInvertedColorScheme||n.nativeTheme.shouldUseHighContrastColors,dark:n.nativeTheme.shouldUseDarkColors}}async getOSColorScheme(){return this.osColorScheme}async killProcess(R,W,U){process.kill(W,U)}async readClipboardText(R,W){return n.clipboard.readText(W)}async writeClipboardText(R,W,U){return n.clipboard.writeText(W,U)}async readClipboardFindText(R){return n.clipboard.readFindText()}async writeClipboardFindText(R,W){return n.clipboard.writeFindText(W)}async writeClipboardBuffer(R,W,U,K){return n.clipboard.writeBuffer(W,Buffer.from(U),K)}async readClipboardBuffer(R,W){return n.clipboard.readBuffer(W)}async hasClipboard(R,W,U){return n.clipboard.has(W,U)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){n.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){n.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){n.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){n.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){n.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(R,W){const U=this.windowById(R);U&&U.updateTouchBar(W)}async notifyReady(R){const W=this.windowById(R);W&&W.setReady()}async relaunch(R,W){return this.lifecycleMainService.relaunch(W)}async reload(R,W){const U=this.windowById(R);if(U){if((0,o.isWorkspaceIdentifier)(U.openedWorkspace)){const K=U.openedWorkspace.configPath;if(K.scheme===C.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(K))?.transient)return this.openWindow(U.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(U,W?.disableExtensions!==void 0?{_:[],"disable-extensions":W.disableExtensions}:void 0)}}async closeWindow(R){this.closeWindowById(R,R)}async closeWindowById(R,W){const U=this.windowById(W);if(U?.win)return U.win.close()}async quit(R){const W=this.windowsMainService.getLastActiveWindow();W?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&W.win?W.win.close():this.lifecycleMainService.quit()}async exit(R,W){await this.lifecycleMainService.kill(W)}async resolveProxy(R,W){const K=this.windowById(R)?.win?.webContents?.session;if(K)return K.resolveProxy(W)}async openDevTools(R,W){const U=this.windowById(R);U?.win&&U.win.webContents.openDevTools(W)}async toggleDevTools(R){const W=this.windowById(R);W?.win&&W.win.webContents.toggleDevTools()}async sendInputEvent(R,W){const U=this.windowById(R);U?.win&&(W.type==="mouseDown"||W.type==="mouseUp")&&U.win.webContents.sendInputEvent(W)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(R,W,U,K){if(!E.isWindows)return;const x=await new Promise((ee,Q)=>{V(["@vscode/windows-registry"],ee,Q)});try{return x.GetStringRegKey(W,U,K)}catch{return}}windowById(R){if(typeof R=="number")return this.windowsMainService.getWindowById(R)}};ue([M.memoize],y.prototype,"cliPath",null),y=ue([te(1,s.IWindowsMainService),te(2,P.IDialogMainService),te(3,c.ILifecycleMainService),te(4,h.IEnvironmentMainService),te(5,r.ITelemetryService),te(6,a.ILogService),te(7,f.IProductService),te(8,i.IThemeMainService),te(9,u.IWorkspacesManagementMainService)],y),e.NativeHostMainService=y}),define(J[240],Z([0,1,12,26,33,2,10,3,87,150,75,104,47,22,5,105,6,58,53,21,54,66]),function(V,e,m,n,L,D,M,S,g,b,C,I,E,w,t,d,p,v,P,h,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,t.createDecorator)("issueMainService");let a=class Ct{constructor(r,i,s,o,u,y,k,R,W,U){this.userEnv=r,this.environmentMainService=i,this.launchMainService=s,this.logService=o,this.diagnosticsService=u,this.diagnosticsMainService=y,this.dialogMainService=k,this.nativeHostMainService=R,this.protocolMainService=W,this.productService=U,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){m.ipcMain.on("vscode:issueSystemInfoRequest",async r=>{const[i,s]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),o=await this.diagnosticsService.getSystemInfo(i,s);this.safeSend(r,"vscode:issueSystemInfoResponse",o)}),m.ipcMain.on("vscode:listProcesses",async r=>{const i=[];try{const s=await this.launchMainService.getMainProcessId();i.push({name:(0,b.localize)(0,null),rootProcess:await(0,g.listProcesses)(s)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(u=>{(0,C.isRemoteDiagnosticError)(u)?i.push({name:u.hostName,rootProcess:u}):u.processes&&i.push({name:u.hostName,rootProcess:u.processes})})}catch(s){this.logService.error(`Listing processes failed: ${s}`)}this.safeSend(r,"vscode:listProcessesResponse",i)}),m.ipcMain.on("vscode:issueReporterClipboard",async r=>{const i={title:this.productService.nameLong,message:(0,b.localize)(1,null),type:"warning",buttons:[(0,L.mnemonicButtonLabel)((0,b.localize)(2,null)),(0,L.mnemonicButtonLabel)((0,b.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const s=await this.dialogMainService.showMessageBox(i,this.issueReporterWindow);this.safeSend(r,"vscode:issueReporterClipboardResponse",s.response===0)}}),m.ipcMain.on("vscode:issuePerformanceInfoRequest",async r=>{const i=await this.getPerformanceInfo();this.safeSend(r,"vscode:issuePerformanceInfoResponse",i)}),m.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const r={title:this.productService.nameLong,message:(0,b.localize)(4,null),type:"warning",buttons:[(0,L.mnemonicButtonLabel)((0,b.localize)(5,null)),(0,L.mnemonicButtonLabel)((0,b.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(r,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),m.ipcMain.on("vscode:workbenchCommand",(r,i)=>{const{id:s,from:o,args:u}=i;let y;switch(o){case"issueReporter":y=this.issueReporterParentWindow;break;case"processExplorer":y=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${o}`)}y&&y.webContents.send("vscode:runAction",{id:s,from:o,args:u})}),m.ipcMain.on("vscode:openExternal",(r,i)=>{this.nativeHostMainService.openExternal(void 0,i)}),m.ipcMain.on("vscode:closeIssueReporter",r=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),m.ipcMain.on("vscode:closeProcessExplorer",r=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),m.ipcMain.on("vscode:windowsInfoRequest",async r=>{const i=await this.launchMainService.getMainProcessInfo();this.safeSend(r,"vscode:windowsInfoResponse",i.windows)})}safeSend(r,i,...s){r.sender.isDestroyed()||r.sender.send(i,...s)}async openReporter(r){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=m.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const i=new D.DisposableStore,s=i.add(this.protocolMainService.createIPCObjectUrl()),o=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(o,s,{backgroundColor:r.styles.backgroundColor,title:(0,b.localize)(7,null),zoomLevel:r.zoomLevel,alwaysOnTop:!1},"issue-reporter"),s.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:r,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,n.type)(),arch:(0,n.arch)(),release:(0,n.release)()},product:P.default}),this.issueReporterWindow.loadURL(M.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",V).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,i.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,i.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(r){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=m.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const i=new D.DisposableStore,s=i.add(this.protocolMainService.createIPCObjectUrl()),o=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(o,s,{backgroundColor:r.styles.backgroundColor,title:(0,b.localize)(8,null),zoomLevel:r.zoomLevel,alwaysOnTop:!0},"process-explorer"),s.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:r,product:P.default}),this.processExplorerWindow.loadURL(M.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",V).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,i.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,i.dispose())})}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(r){r.isMinimized()&&r.restore(),r.focus()}createBrowserWindow(r,i,s,o){const u=new m.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:r.width,height:r.height,minWidth:300,minHeight:200,x:r.x,y:r.y,title:s.title,backgroundColor:s.backgroundColor||Ct.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:M.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",V).fsPath,additionalArguments:[`--vscode-window-config=${i.resource.toString()}`,`--vscode-window-kind=${o}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,c.zoomLevelToZoomFactor)(s.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:s.alwaysOnTop});return u.setMenuBarVisibility(!1),u}async getSystemStatus(){const[r,i]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(r,i)}getWindowPosition(r,i,s){let o;const u=m.screen.getAllDisplays();if(u.length===1)o=u[0];else{if(S.isMacintosh){const R=m.screen.getCursorScreenPoint();o=m.screen.getDisplayNearestPoint(R)}!o&&r&&(o=m.screen.getDisplayMatching(r.getBounds())),o||(o=m.screen.getPrimaryDisplay()||u[0])}const y={width:i,height:s},k=o.bounds;return y.x=k.x+k.width/2-y.width/2,y.y=k.y+k.height/2-y.height/2,k.width>0&&k.height>0&&(y.x<k.x&&(y.x=k.x),y.y<k.y&&(y.y=k.y),y.x>k.x+k.width&&(y.x=k.x),y.y>k.y+k.height&&(y.y=k.y),y.width>k.width&&(y.width=k.width),y.height>k.height&&(y.height=k.height)),y}async getPerformanceInfo(){try{const[r,i]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(r,i)}catch(r){throw this.logService.warn("issueService#getPerformanceInfo ",r.message),r}}};a.DEFAULT_BACKGROUND_COLOR="#1E1E1E",a=ue([te(1,w.IEnvironmentMainService),te(2,d.ILaunchMainService),te(3,p.ILogService),te(4,C.IDiagnosticsService),te(5,I.IDiagnosticsMainService),te(6,E.IDialogMainService),te(7,v.INativeHostMainService),te(8,l.IProtocolMainService),te(9,h.IProductService)],a),e.IssueMainService=a}),define(J[241],Z([0,1,23,19,22,18,6,58,21,56,32,41,82]),function(V,e,m,n,L,D,M,S,g,b,C,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let w=class extends E.AbstractUpdateService{constructor(d,p,v,P,h,l,c,a){super(d,p,P,h,l,a);this.telemetryService=v,this.nativeHostMainService=c}buildUpdateFeedUrl(d){return(0,E.createUpdateURL)(`linux-${process.arch}`,d,this.productService)}doCheckForUpdates(d){!this.url||(this.setState(I.State.CheckingForUpdates(d)),this.requestService.request({url:this.url},m.CancellationToken.None).then(b.asJson).then(p=>{!p||!p.url||!p.version||!p.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!d}),this.setState(I.State.Idle(1))):this.setState(I.State.AvailableForDownload(p))}).then(void 0,p=>{this.logService.error(p),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!d});const v=d?p.message||p:void 0;this.setState(I.State.Idle(1,v))}))}async doDownloadUpdate(d){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):d.update.url&&this.nativeHostMainService.openExternal(void 0,d.update.url),this.setState(I.State.Idle(1))}};w=ue([te(0,D.ILifecycleMainService),te(1,n.IConfigurationService),te(2,C.ITelemetryService),te(3,L.IEnvironmentMainService),te(4,b.IRequestService),te(5,M.ILogService),te(6,S.INativeHostMainService),te(7,g.IProductService)],w),e.LinuxUpdateService=w}),define(J[242],Z([0,1,45,29,26,9,23,46,7,8,119,24,19,22,20,18,6,58,21,56,32,41,82]),function(V,e,m,n,L,D,M,S,g,b,C,I,E,w,t,d,p,v,P,h,l,c,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function f(o,u=1e3){for(;!o();)await(0,D.timeout)(u)}let r;function i(){return typeof r=="undefined"&&(r=n.existsSync(g.join(g.dirname(process.execPath),"unins000.exe"))?0:1),r}let s=class extends a.AbstractUpdateService{constructor(u,y,k,R,W,U,K,x,ee){super(u,y,R,W,U,ee);this.telemetryService=k,this.fileService=K,this.nativeHostMainService=x}get cachePath(){const u=g.join((0,L.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return I.Promises.mkdir(u,{recursive:!0}).then(()=>u)}initialize(){super.initialize()}buildUpdateFeedUrl(u){let y="win32";return process.arch!=="ia32"&&(y+=`-${process.arch}`),i()===1?y+="-archive":this.productService.target==="user"&&(y+="-user"),(0,a.createUpdateURL)(y,u,this.productService)}doCheckForUpdates(u){!this.url||(this.setState(c.State.CheckingForUpdates(u)),this.requestService.request({url:this.url},M.CancellationToken.None).then(h.asJson).then(y=>{const k=i();return!y||!y.url||!y.version||!y.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!u}),this.setState(c.State.Idle(k)),Promise.resolve(null)):k===1?(this.setState(c.State.AvailableForDownload(y)),Promise.resolve(null)):(this.setState(c.State.Downloading(y)),this.cleanup(y.version).then(()=>this.getUpdatePackagePath(y.version).then(R=>I.Promises.exists(R).then(W=>{if(W)return Promise.resolve(R);const U=y.url,K=y.hash,x=`${R}.tmp`;return this.requestService.request({url:U},M.CancellationToken.None).then(ee=>this.fileService.writeFile(b.URI.file(x),ee.stream)).then(K?()=>(0,C.checksum)(x,y.hash):()=>{}).then(()=>I.Promises.rename(x,R)).then(()=>R)})).then(R=>{const W=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:R},W&&y.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(c.State.Downloaded(y)):this.setState(c.State.Ready(y))})))}).then(void 0,y=>{this.logService.error(y),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!u});const k=u?y.message||y:void 0;this.setState(c.State.Idle(i(),k))}))}async doDownloadUpdate(u){u.update.url&&this.nativeHostMainService.openExternal(void 0,u.update.url),this.setState(c.State.Idle(i()))}async getUpdatePackagePath(u){const y=await this.cachePath;return g.join(y,`CodeSetup-${this.productService.quality}-${u}.exe`)}async cleanup(u=null){const y=u?U=>!new RegExp(`${this.productService.quality}-${u}\\.exe$`).test(U):()=>!0,k=await this.cachePath,W=(await I.Promises.readdir(k)).filter(y).map(async U=>{try{await I.Promises.unlink(g.join(k,U))}catch{}});await Promise.all(W)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const u=this.state.update;this.setState(c.State.Updating(u));const y=await this.cachePath;this.availableUpdate.updateFilePath=g.join(y,`CodeSetup-${this.productService.quality}-${u.version}.flag`),await I.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,m.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(c.State.Idle(i()))});const R=`${this.productService.win32MutexName}-ready`,W=await new Promise((U,K)=>{V(["windows-mutex"],U,K)});f(()=>W.isActive(R)).then(()=>this.setState(c.State.Ready(u)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?n.unlinkSync(this.availableUpdate.updateFilePath):(0,m.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return i()}};ue([S.memoize],s.prototype,"cachePath",null),s=ue([te(0,d.ILifecycleMainService),te(1,E.IConfigurationService),te(2,l.ITelemetryService),te(3,w.IEnvironmentMainService),te(4,h.IRequestService),te(5,p.ILogService),te(6,t.IFileService),te(7,v.INativeHostMainService),te(8,P.IProductService)],s),e.Win32UpdateService=s}),define(J[243],Z([0,1,12,9,23,39,4,33,2,10,7,63,3,8,157,51,19,47,22,50,20,18,6,21,54,210,81,32,213,65,66,34,25,42,101]),function(V,e,m,n,L,D,M,S,g,b,C,I,E,w,t,d,p,v,P,h,l,c,a,f,r,i,s,o,u,y,k,R,W,U,K){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var x;(function(Q){Q[Q.NONE=0]="NONE",Q[Q.NAVIGATING=1]="NAVIGATING",Q[Q.READY=2]="READY"})(x||(x={}));let ee=class extends g.Disposable{constructor(H,X,z,ie,$,q,Y,B,F,N,T,A,O,_,j){super();this.logService=X,this.environmentMainService=z,this.fileService=ie,this.globalStorageMainService=$,this.configurationService=q,this.themeMainService=Y,this.workspacesManagementMainService=B,this.backupMainService=F,this.telemetryService=N,this.dialogMainService=T,this.lifecycleMainService=A,this.productService=O,this.protocolMainService=_,this.windowsMainService=j,this._onWillLoad=this._register(new M.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new M.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new M.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new M.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[ne,ae]=this.restoreWindowState(H.state);this.windowState=ne,this.logService.trace("window#ctor: using window state",ne);const ce=this.windowState.mode===0||this.windowState.mode===3,re=this.configurationService.getValue("window"),le={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:k.WindowMinimumSize.WIDTH,minHeight:k.WindowMinimumSize.HEIGHT,show:!ce,title:this.productService.nameLong,webPreferences:{preload:b.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",V).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,k.zoomLevelToZoomFactor)(re?.zoomLevel),...this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}}};E.isLinux?le.icon=(0,C.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):E.isWindows&&!this.environmentMainService.isBuilt&&(le.icon=(0,C.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),E.isMacintosh&&!this.useNativeFullScreen()&&(le.fullscreenable=!1),E.isMacintosh&&(le.acceptFirstMouse=!0,re?.clickThroughInactive===!1&&(le.acceptFirstMouse=!1));const he=E.isMacintosh&&re?.nativeTabs===!0;he&&(le.tabbingIdentifier=this.productService.nameShort);const we=(0,k.getTitleBarStyle)(this.configurationService)==="custom";if(we&&(le.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,E.isMacintosh||(le.frame=!1)),(0,I.mark)("code/willCreateCodeBrowserWindow"),this._win=new m.BrowserWindow(le),(0,I.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),E.isMacintosh&&we&&this._win.setSheetOffset(22),E.isMacintosh&&ae&&(!he||m.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(Ee=>typeof Ee=="number")){const Ee=this.windowState;this._win.setBounds({width:Ee.width,height:Ee.height,x:Ee.x,y:Ee.y})}ce&&((0,I.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,I.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this.currentConfig?.backupPath}get openedWorkspace(){return this.currentConfig?.workspace}get remoteAuthority(){return this.currentConfig?.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){return!!this.currentConfig?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.currentConfig?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.currentConfig?.debugId}setRepresentedFilename(H){E.isMacintosh?this._win.setRepresentedFilename(H):this.representedFilename=H}getRepresentedFilename(){return E.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(H){E.isMacintosh&&this._win.setDocumentEdited(H),this.documentEdited=H}isDocumentEdited(){return E.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(H){E.isMacintosh&&H?.force&&m.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.logService.info(`window#load: window reported ready (id: ${this._id})`),this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(H=>{if(this.isReady)return H(this);this.whenReadyCallbacks.push(H)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(H=>{function X(){z.dispose(),ie.dispose(),H()}const z=this.onDidClose(()=>X()),ie=this.onWillLoad(()=>X())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(X,z)=>this.onWindowError(2,z)),this._win.webContents.on("did-fail-load",(X,z,ie)=>this.onWindowError(3,{reason:ie,exitCode:z})),this._win.webContents.on("will-prevent-unload",X=>{X.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",X=>{this.currentConfig&&(this.currentConfig.maximized=!0),m.app.emit("browser-window-maximize",X,this._win)}),this._win.on("unmaximize",X=>{this.currentConfig&&(this.currentConfig.maximized=!1),m.app.emit("browser-window-unmaximize",X,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",L.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",L.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(X=>this.onDidDeleteUntitledWorkspace(X)));const H=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:H},async(X,z)=>{const ie=await this.getMarketplaceHeaders();z({cancel:!1,requestHeaders:Object.assign(X.requestHeaders,ie)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,i.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.globalStorageMainService)),this.marketplaceHeadersPromise}async onWindowError(H,X){switch(H){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${X?.reason||"<unknown>"}, code: ${X?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${X?.reason||"<unknown>"}, code: ${X?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:H,reason:X?.reason,code:X?.exitCode}),H){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.driverHandle){this.destroyWindow(!1);return}if(H===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const z=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,S.mnemonicButtonLabel)((0,t.localize)(0,null)),(0,S.mnemonicButtonLabel)((0,t.localize)(1,null)),(0,S.mnemonicButtonLabel)((0,t.localize)(2,null))],message:(0,t.localize)(3,null),detail:(0,t.localize)(4,null),noLink:!0,defaultId:0,cancelId:1},this._win);if(z.response!==1){const ie=z.response===0;this.destroyWindow(ie)}}else if(H===2){let z;X?z=(0,t.localize)(6,null,X.reason,X.exitCode??"<unknown>"):z=(0,t.localize)(5,null);const $=(await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,S.mnemonicButtonLabel)((0,t.localize)(7,null)),(0,S.mnemonicButtonLabel)((0,t.localize)(8,null))],message:z,detail:(0,t.localize)(9,null),noLink:!0,defaultId:0},this._win)).response===0;this.destroyWindow($)}break}}destroyWindow(H){if(this._onDidDestroy.fire(),this._win?.destroy(),H&&this.config){let X,z;(0,W.isSingleFolderWorkspaceIdentifier)(this.openedWorkspace)?X={folderUri:this.openedWorkspace.uri}:(0,W.isWorkspaceIdentifier)(this.openedWorkspace)?X={workspaceUri:this.openedWorkspace.configPath}:z=!0;const[ie]=this.windowsMainService.open({context:5,userEnv:this.config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:X?[X]:void 0,forceEmpty:z,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});ie.focus()}}onDidDeleteUntitledWorkspace(H){this.openedWorkspace?.id===H.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const H=this.getMenuBarVisibility();H!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=H,this.setMenuBarVisibility(H));let X=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;X?.endsWith("/")&&(X=X.substr(0,X.length-1));const z=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((X||"").indexOf("@")===-1&&(X!==this.currentHttpProxy||z!==this.currentNoProxy)){this.currentHttpProxy=X,this.currentNoProxy=z;const ie=X||"",$=z?`${z},<local>`:"<local>";this.logService.trace(`Setting proxy to '${ie}', bypassing '${$}'`),this._win.webContents.session.setProxy({proxyRules:ie,proxyBypassRules:$,pacScript:""})}}addTabbedWindow(H){E.isMacintosh&&H.win&&this._win.addTabbedWindow(H.win)}load(H,X=Object.create(null)){this.logService.info(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!X.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),X.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(H,X),this.readyState===0?this.currentConfig=H:this.pendingLoadConfig=H,this.readyState=1,this._win.loadURL(b.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",V).toString(!0));const z=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new n.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:H.workspace,reason:X.isReload?3:z?2:1})}updateConfiguration(H,X){const z=(this.currentConfig??this.pendingLoadConfig)?.userEnv;if(z){const ie=(0,h.isLaunchedFromCli)(z)&&!(0,h.isLaunchedFromCli)(H.userEnv),$=this.isExtensionDevelopmentHost;(ie||$)&&(H.userEnv={...z,...H.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(H.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),X.disableExtensions!==void 0&&(H["disable-extensions"]=X.disableExtensions),H.fullscreen=this.isFullScreen,H.maximized=this._win.isMaximized(),H.partsSplash=this.themeMainService.getWindowSplash(),(0,I.mark)("code/willOpenNewWindow"),H.perfMarks=(0,I.getMarks)(),this.configObjectUrl.update(H)}async reload(H){const X=Object.assign({},this.currentConfig);X.workspace=await this.validateWorkspaceBeforeReload(X),delete X.filesToOpenOrCreate,delete X.filesToDiff,delete X.filesToWait,this.isExtensionDevelopmentHost&&H&&(X.verbose=H.verbose,X.debugId=H.debugId,X.extensionEnvironment=H.extensionEnvironment,X["inspect-extensions"]=H["inspect-extensions"],X["inspect-brk-extensions"]=H["inspect-brk-extensions"],X["extensions-dir"]=H["extensions-dir"]),X.isInitialStartup=!1,this.load(X,{isReload:!0,disableExtensions:H?.["disable-extensions"]})}async validateWorkspaceBeforeReload(H){if((0,W.isWorkspaceIdentifier)(H.workspace)){const X=H.workspace.configPath;if(X.scheme===b.Schemas.file&&!await this.fileService.exists(X))return}else if((0,W.isSingleFolderWorkspaceIdentifier)(H.workspace)){const X=H.workspace.uri;if(X.scheme===b.Schemas.file&&!await this.fileService.exists(X))return}return H.workspace}serializeWindowState(){if(!this._win)return(0,K.defaultWindowState)();if(this.isFullScreen){let z;try{z=m.screen.getDisplayMatching(this.getBounds())}catch{}const ie=(0,K.defaultWindowState)();return{mode:3,display:z?z.id:void 0,width:this.windowState.width||ie.width,height:this.windowState.height||ie.height,x:this.windowState.x||0,y:this.windowState.y||0}}const H=Object.create(null);let X;if(!E.isMacintosh&&this._win.isMaximized()?X=0:X=1,X===0?H.mode=0:H.mode=1,X===1||X===0){let z;X===1?z=this.getBounds():z=this._win.getNormalBounds(),H.x=z.x,H.y=z.y,H.width=z.width,H.height=z.height}return H}restoreWindowState(H){(0,I.mark)("code/willRestoreCodeWindowState");let X=!1;if(H)try{const z=m.screen.getAllDisplays();X=z.length>1,H=this.validateWindowState(H,z)}catch(z){this.logService.warn(`Unexpected error validating window state: ${z}
${z.stack}`)}return(0,I.mark)("code/didRestoreCodeWindowState"),[H||(0,K.defaultWindowState)(),X]}validateWindowState(H,X){if(this.logService.trace(`window#validateWindowState: validating window state on ${X.length} display(s)`,H),typeof H.x!="number"||typeof H.y!="number"||typeof H.width!="number"||typeof H.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(H.width<=0||H.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(X.length===1){const $=this.getWorkingArea(X[0]);if($){let q=function(){!H||typeof H.x!="number"||typeof H.y!="number"||!$||(H.x<$.x&&(H.x=$.x),H.y<$.y&&(H.y=$.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",$),q(),H.width>$.width&&(H.width=$.width),H.height>$.height&&(H.height=$.height),H.x>$.x+$.width-128&&(H.x=$.x+$.width-H.width),H.y>$.y+$.height-128&&(H.y=$.y+$.height-H.height),q()}return H}if(H.display&&H.mode===3){const $=X.find(q=>q.id===H.display);if($&&typeof $.bounds?.x=="number"&&typeof $.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const q=(0,K.defaultWindowState)(3);return q.x=$.bounds.x,q.y=$.bounds.y,q}}let z,ie;try{z=m.screen.getDisplayMatching({x:H.x,y:H.y,width:H.width,height:H.height}),ie=this.getWorkingArea(z)}catch{}if(z&&ie&&H.x+H.width>ie.x&&H.y+H.height>ie.y&&H.x<ie.x+ie.width&&H.y<ie.y+ie.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",ie),H}getWorkingArea(H){if(H.workArea.width>0&&H.workArea.height>0)return H.workArea;if(H.bounds.width>0&&H.bounds.height>0)return H.bounds}getBounds(){const[H,X]=this._win.getPosition(),[z,ie]=this._win.getSize();return{x:H,y:X,width:z,height:ie}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(H){this.useNativeFullScreen()?this.setNativeFullScreen(H):this.setSimpleFullScreen(H),this.sendWhenReady(H?"vscode:enterFullScreen":"vscode:leaveFullScreen",L.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(H){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(H)}setSimpleFullScreen(H){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(H),this._win.webContents.focus()}useNativeFullScreen(){const H=this.configurationService.getValue("window");return!H||typeof H.nativeFullScreen!="boolean"||H.nativeTabs?!0:H.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let H=(0,k.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(H)<0&&(H="classic"),H}setMenuBarVisibility(H,X=!0){E.isMacintosh||(H==="toggle"&&X&&this.send("vscode:showInfoMessage",(0,t.localize)(10,null)),H==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(H)}):this.doSetMenuBarVisibility(H))}doSetMenuBarVisibility(H){const X=this.isFullScreen;switch(H){case"classic":this._win.setMenuBarVisibility(!X),this._win.autoHideMenuBar=X;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(E.isMacintosh)switch(m.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(H,X,...z){this.isReady?this.send(H,...z):this.ready().then(()=>{X.isCancellationRequested||this.send(H,...z)})}send(H,...X){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${H}' for window that is destroyed`);return}try{this._win.webContents.send(H,...X)}catch(z){this.logService.warn(`Error sending IPC message to channel '${H}' of window ${this._id}: ${(0,D.toErrorMessage)(z)}`)}}}updateTouchBar(H){!E.isMacintosh||this.touchBarGroups.forEach((X,z)=>{const ie=H[z];X.segments=this.createTouchBarGroupSegments(ie)})}createTouchBar(){if(!!E.isMacintosh){for(let H=0;H<10;H++){const X=this.createTouchBarGroup();this.touchBarGroups.push(X)}this._win.setTouchBar(new m.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(H=[]){const X=this.createTouchBarGroupSegments(H),z=new m.TouchBar.TouchBarSegmentedControl({segments:X,mode:"buttons",segmentStyle:"automatic",change:ie=>{this.sendWhenReady("vscode:runAction",L.CancellationToken.None,{id:z.segments[ie].id,from:"touchbar"})}});return z}createTouchBarGroupSegments(H=[]){return H.map(z=>{let ie;z.icon&&!u.ThemeIcon.isThemeIcon(z.icon)&&z.icon?.dark?.scheme===b.Schemas.file&&(ie=m.nativeImage.createFromPath(w.URI.revive(z.icon.dark).fsPath),ie.isEmpty()&&(ie=void 0));let $;return typeof z.title=="string"?$=z.title:$=z.title.value,{id:z.id,label:ie?void 0:$,icon:ie}})}dispose(){super.dispose(),this._win=null}};ee=ue([te(1,a.ILogService),te(2,P.IEnvironmentMainService),te(3,l.IFileService),te(4,s.IGlobalStorageMainService),te(5,p.IConfigurationService),te(6,y.IThemeMainService),te(7,U.IWorkspacesManagementMainService),te(8,d.IBackupMainService),te(9,o.ITelemetryService),te(10,v.IDialogMainService),te(11,c.ILifecycleMainService),te(12,f.IProductService),te(13,r.IProtocolMainService),te(14,R.IWindowsMainService)],ee),e.CodeWindow=ee}),define(J[67],Z([0,1,12,30,9,4,33,2,10,3,17,8,24,160,5,18,6,38,81,80,25,42]),function(V,e,m,n,L,D,M,S,g,b,C,I,E,w,t,d,p,v,P,h,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,t.createDecorator)("workspacesHistoryMainService");let a=class qe extends S.Disposable{constructor(r,i,s,o,u){super();this.stateMainService=r,this.logService=i,this.workspacesManagementMainService=s,this.lifecycleMainService=o,this.globalStorageMainService=u,this._onDidChangeRecentlyOpened=this._register(new D.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new L.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(r=>this.addRecentlyOpened([{workspace:r.workspace,remoteAuthority:r.window.remoteAuthority}])))}async addRecentlyOpened(r){const i=[],s=[];for(let o of r)if((0,h.isRecentWorkspace)(o))!this.workspacesManagementMainService.isUntitledWorkspace(o.workspace)&&this.indexOfWorkspace(i,o.workspace)===-1&&i.push(o);else if((0,h.isRecentFolder)(o))this.indexOfFolder(i,o.folderUri)===-1&&i.push(o);else{const u=this.indexOfFile(s,o.fileUri)>=0,y=o.fileUri.scheme===g.Schemas.file&&qe.COMMON_FILES_FILTER.indexOf((0,C.basename)(o.fileUri))>=0;!u&&!y&&(s.push(o),b.isWindows&&o.fileUri.scheme===g.Schemas.file&&m.app.addRecentDocument(o.fileUri.fsPath))}await this.addEntriesFromStorage(i,s),i.length>qe.MAX_TOTAL_RECENT_ENTRIES&&(i.length=qe.MAX_TOTAL_RECENT_ENTRIES),s.length>qe.MAX_TOTAL_RECENT_ENTRIES&&(s.length=qe.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:i,files:s}),this._onDidChangeRecentlyOpened.fire(),b.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(r){const i=y=>{const k=this.location(y);for(const R of r)if(C.extUriBiasedIgnorePathCase.isEqual(R,k))return!1;return!0},s=await this.getRecentlyOpened(),o=s.workspaces.filter(i),u=s.files.filter(i);(o.length!==s.workspaces.length||u.length!==s.files.length)&&(await this.saveRecentlyOpened({files:u,workspaces:o}),this._onDidChangeRecentlyOpened.fire(),b.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),m.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(r){const i=[],s=[];if(r){const u=r.config?.workspace;(0,l.isWorkspaceIdentifier)(u)&&!this.workspacesManagementMainService.isUntitledWorkspace(u)?i.push({workspace:u,remoteAuthority:r.remoteAuthority}):(0,l.isSingleFolderWorkspaceIdentifier)(u)&&i.push({folderUri:u.uri,remoteAuthority:r.remoteAuthority})}const o=r?.config?.filesToOpenOrCreate;if(o)for(let u of o){const y=u.fileUri;y&&this.indexOfFile(s,y)===-1&&s.push({fileUri:y})}return await this.addEntriesFromStorage(i,s),{workspaces:i,files:s}}async addEntriesFromStorage(r,i){let s=await this.getRecentlyOpenedFromStorage();for(let o of s.workspaces){let u=(0,h.isRecentFolder)(o)?this.indexOfFolder(r,o.folderUri):this.indexOfWorkspace(r,o.workspace);u>=0?r[u].label=r[u].label||o.label:r.push(o)}for(let o of s.files){let u=this.indexOfFile(i,o.fileUri);u>=0?i[u].label=i[u].label||o.label:i.push(o)}}async getRecentlyOpenedFromStorage(){await this.globalStorageMainService.whenReady;let r;const i=this.globalStorageMainService.get(qe.RECENTLY_OPENED_STORAGE_KEY,0);if(typeof i=="string")try{r=JSON.parse(i)}catch(s){this.logService.error("Unexpected error parsing opened paths list",s)}else r=this.stateMainService.getItem(qe.legacyRecentlyOpenedStorageKey),r&&(this.stateMainService.removeItem(qe.legacyRecentlyOpenedStorageKey),this.globalStorageMainService.store(qe.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify(r),0,1));return(0,h.restoreRecentlyOpened)(r,this.logService)}async saveRecentlyOpened(r){await this.globalStorageMainService.whenReady,this.globalStorageMainService.store(qe.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,h.toStoreData)(r)),0,1)}location(r){return(0,h.isRecentFolder)(r)?r.folderUri:(0,h.isRecentFile)(r)?r.fileUri:r.workspace.configPath}indexOfWorkspace(r,i){return r.findIndex(s=>(0,h.isRecentWorkspace)(s)&&s.workspace.id===i.id)}indexOfFolder(r,i){return r.findIndex(s=>(0,h.isRecentFolder)(s)&&C.extUriBiasedIgnorePathCase.isEqual(s.folderUri,i))}indexOfFile(r,i){return r.findIndex(s=>C.extUriBiasedIgnorePathCase.isEqual(s.fileUri,i))}async handleWindowsJumpList(){!b.isWindows||(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!b.isWindows)return;const r=[];if(r.push({type:"tasks",items:[{type:"task",title:(0,w.localize)(0,null),description:(0,w.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){let i=[];for(let u of m.app.getJumpListSettings().removedItems){const y=u.args;if(y){const k=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(y);k&&i.push(I.URI.parse(k[2]))}}await this.removeRecentlyOpened(i);let s=!1;const o=(0,n.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,qe.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(u=>{const y=(0,h.isRecentWorkspace)(u)?u.workspace:u.folderUri,{title:k,description:R}=this.getWindowsJumpListLabel(y,u.label);let W;return I.URI.isUri(y)?W=`--folder-uri "${y.toString()}"`:(s=!0,W=`--file-uri "${y.configPath.toString()}"`),{type:"task",title:k.substr(0,255),description:R.substr(0,255),program:process.execPath,args:W,iconPath:"explorer.exe",iconIndex:0}}));o.length>0&&r.push({type:"custom",name:s?(0,w.localize)(2,null):(0,w.localize)(3,null),items:o})}r.push({type:"recent"});try{m.app.setJumpList(r)}catch(i){this.logService.warn("updateWindowsJumpList#setJumpList",i)}}getWindowsJumpListLabel(r,i){if(i)return{title:(0,M.splitName)(i).name,description:i};if(I.URI.isUri(r))return{title:(0,C.basename)(r),description:this.renderJumpListPathDescription(r)};if(this.workspacesManagementMainService.isUntitledWorkspace(r))return{title:(0,w.localize)(4,null),description:""};let s=(0,C.basename)(r.configPath);return s.endsWith(l.WORKSPACE_EXTENSION)&&(s=s.substr(0,s.length-l.WORKSPACE_EXTENSION.length-1)),{title:(0,w.localize)(5,null,s),description:this.renderJumpListPathDescription(r.configPath)}}renderJumpListPathDescription(r){return r.scheme==="file"?(0,M.normalizeDriveLetter)(r.fsPath):r.toString()}async updateMacOSRecentDocuments(){if(!b.isMacintosh)return;m.app.clearRecentDocuments();const r=await this.getRecentlyOpened(),i=[];let s=0;for(let u=0;u<r.workspaces.length&&s<qe.MAX_MACOS_DOCK_RECENT_WORKSPACES;u++){const y=this.location(r.workspaces[u]);if(y.scheme===g.Schemas.file){const k=(0,C.originalFSPath)(y);await E.Promises.exists(k)&&(i.push(k),s++)}}const o=[];for(let u=0;u<r.files.length&&s<qe.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;u++){const y=this.location(r.files[u]);if(y.scheme===g.Schemas.file){const k=(0,C.originalFSPath)(y);if(qe.COMMON_FILES_FILTER.includes((0,C.basename)(y))||i.includes(k))continue;await E.Promises.exists(k)&&(o.push(k),s++)}}o.reverse().forEach(u=>m.app.addRecentDocument(u)),i.reverse().forEach(u=>m.app.addRecentDocument(u))}};a.MAX_TOTAL_RECENT_ENTRIES=500,a.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList",a.legacyRecentlyOpenedStorageKey="openedPathsList",a.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,a.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,a.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,a.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],a=ue([te(0,v.IStateMainService),te(1,p.ILogService),te(2,c.IWorkspacesManagementMainService),te(3,d.ILifecycleMainService),te(4,P.IGlobalStorageMainService)],a),e.WorkspacesHistoryMainService=a}),define(J[244],Z([0,1,12,9,23,33,3,8,151,19,22,18,6,194,58,21,38,32,41,66,34,67]),function(V,e,m,n,L,D,M,S,g,b,C,I,E,w,t,d,p,v,P,h,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const a="menu";let f=class It{constructor(s,o,u,y,k,R,W,U,K,x,ee){this.updateService=s,this.configurationService=o,this.windowsMainService=u,this.environmentMainService=y,this.telemetryService=k,this.workspacesHistoryMainService=R,this.stateMainService=W,this.lifecycleMainService=U,this.logService=K,this.nativeHostMainService=x,this.productService=ee,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new n.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new n.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(M.isMacintosh||(0,h.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const s=this.stateMainService.getItem(It.lastKnownMenubarStorageKey);s&&(s.menus&&(this.menubarMenus=s.menus),s.keybindings&&(this.keybindings=s.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(R,W,U)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:W?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(R,W,U)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:W?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(R,W,U)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:a}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(R,W,U)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:a}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const s=this.productService.twitterUrl;s&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(s,"openTwitterUrl"));const o=this.productService.requestFeatureUrl;o&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(o,"openUserVoiceUrl"));const u=this.productService.reportIssueUrl;u&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(u,"openReportIssues"));const y=this.productService.licenseUrl;y&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(M.language){const R=y.indexOf("?")>0?"&":"?";this.openUrl(`${y}${R}lang=${M.language}`,"openLicenseUrl")}else this.openUrl(y,"openLicenseUrl")});const k=this.productService.privacyStatementUrl;k&&y&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(k,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(s=>this.onDidChangeWindowsCount(s)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let s=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof s!="boolean"?!0:s}get currentEnableNativeTabs(){if(!M.isMacintosh)return!1;let s=this.configurationService.getValue("window.nativeTabs");return typeof s!="boolean"?!1:s}updateMenu(s,o){this.menubarMenus=s.menus,this.keybindings=s.keybindings,this.stateMainService.setItem(It.lastKnownMenubarStorageKey,s),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(s){!M.isMacintosh||(s.oldCount===0&&s.newCount>0||s.oldCount>0&&s.newCount===0)&&(this.closedLastWindow=s.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!M.isMacintosh||(this.noActiveWindow=!m.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const s=m.Menu.getApplicationMenu();if(s&&this.oldMenus.push(s),Object.keys(this.menubarMenus).length===0){m.Menu.setApplicationMenu(M.isMacintosh?new m.Menu:null);return}const o=new m.Menu;let u;if(M.isMacintosh){const k=new m.Menu;u=new m.MenuItem({label:this.productService.nameShort,submenu:k}),this.setMacApplicationMenu(k),o.append(u)}if(M.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const k=new m.Menu;k.append(new m.MenuItem({label:this.mnemonicLabel(g.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),m.app.dock.setMenu(k)}if(this.shouldDrawMenu("File")){const k=new m.Menu,R=new m.MenuItem({label:this.mnemonicLabel(g.localize(1,null)),submenu:k});this.setMenuById(k,"File"),o.append(R)}if(this.shouldDrawMenu("Edit")){const k=new m.Menu,R=new m.MenuItem({label:this.mnemonicLabel(g.localize(2,null)),submenu:k});this.setMenuById(k,"Edit"),o.append(R)}if(this.shouldDrawMenu("Selection")){const k=new m.Menu,R=new m.MenuItem({label:this.mnemonicLabel(g.localize(3,null)),submenu:k});this.setMenuById(k,"Selection"),o.append(R)}if(this.shouldDrawMenu("View")){const k=new m.Menu,R=new m.MenuItem({label:this.mnemonicLabel(g.localize(4,null)),submenu:k});this.setMenuById(k,"View"),o.append(R)}if(this.shouldDrawMenu("Go")){const k=new m.Menu,R=new m.MenuItem({label:this.mnemonicLabel(g.localize(5,null)),submenu:k});this.setMenuById(k,"Go"),o.append(R)}if(this.shouldDrawMenu("Run")){const k=new m.Menu,R=new m.MenuItem({label:this.mnemonicLabel(g.localize(6,null)),submenu:k});this.setMenuById(k,"Run"),o.append(R)}if(this.shouldDrawMenu("Terminal")){const k=new m.Menu,R=new m.MenuItem({label:this.mnemonicLabel(g.localize(7,null)),submenu:k});this.setMenuById(k,"Terminal"),o.append(R)}let y;if(this.shouldDrawMenu("Window")){const k=new m.Menu;y=new m.MenuItem({label:this.mnemonicLabel(g.localize(8,null)),submenu:k,role:"window"}),this.setMacWindowMenu(k)}if(y&&o.append(y),this.shouldDrawMenu("Help")){const k=new m.Menu,R=new m.MenuItem({label:this.mnemonicLabel(g.localize(9,null)),submenu:k,role:"help"});this.setMenuById(k,"Help"),o.append(R)}o.items&&o.items.length>0?m.Menu.setApplicationMenu(o):m.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(s){const o=this.createMenuItem(g.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),u=this.getUpdateMenuItems();let y;if(this.shouldDrawMenu("Preferences")){const Q=new m.Menu;this.setMenuById(Q,"Preferences"),y=new m.MenuItem({label:this.mnemonicLabel(g.localize(11,null)),submenu:Q})}const k=new m.Menu,R=new m.MenuItem({label:g.localize(12,null),role:"services",submenu:k}),W=new m.MenuItem({label:g.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),U=new m.MenuItem({label:g.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),K=new m.MenuItem({label:g.localize(15,null),role:"unhide"}),x=new m.MenuItem(this.likeAction("workbench.action.quit",{label:g.localize(16,null,this.productService.nameLong),click:()=>{const Q=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!m.BrowserWindow.getFocusedWindow()||Q?.isMinimized())&&this.nativeHostMainService.quit(void 0)}})),ee=[o];ee.push(...u),y&&ee.push(r(),y),ee.push(r(),R,r(),W,U,K,r(),x),ee.forEach(Q=>s.append(Q))}shouldDrawMenu(s){if(!M.isMacintosh&&(0,h.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(s){case"File":case"Help":if(M.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[s];case"Window":if(M.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[s]}}setMenu(s,o){o.forEach(u=>{if((0,w.isMenubarMenuItemSeparator)(u))s.append(r());else if((0,w.isMenubarMenuItemSubmenu)(u)){const y=new m.Menu,k=new m.MenuItem({label:this.mnemonicLabel(u.label),submenu:y});this.setMenu(y,u.submenu.items),s.append(k)}else(0,w.isMenubarMenuItemRecentAction)(u)?s.append(this.createOpenRecentMenuItem(u)):(0,w.isMenubarMenuItemAction)(u)&&(u.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(s),M.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[u.id]?s.append(new m.MenuItem(this.likeAction(u.id,{label:this.mnemonicLabel(u.label),click:this.fallbackMenuHandlers[u.id]}))):s.append(this.createMenuItem(u.label,u.id,!1,u.checked)):s.append(this.createMenuItem(u.label,u.id,u.enabled!==!1,!!u.checked)):s.append(this.createMenuItem(u.label,u.id,u.enabled!==!1,!!u.checked)))})}setMenuById(s,o){this.menubarMenus&&this.menubarMenus[o]&&this.setMenu(s,this.menubarMenus[o].items)}insertCheckForUpdatesItems(s){const o=this.getUpdateMenuItems();o.length&&(o.forEach(u=>s.append(u)),s.append(r()))}createOpenRecentMenuItem(s){const o=S.URI.revive(s.uri),u=s.id,y=u==="openRecentFile"?{fileUri:o}:u==="openRecentWorkspace"?{workspaceUri:o}:{folderUri:o};return new m.MenuItem(this.likeAction(u,{label:s.label,click:(k,R,W)=>{const U=this.isOptionClick(W);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[y],forceNewWindow:U,gotoLineMode:!1,remoteAuthority:s.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([o])}},!1))}isOptionClick(s){return!!(s&&(!M.isMacintosh&&(s.ctrlKey||s.shiftKey)||M.isMacintosh&&(s.metaKey||s.altKey)))}createRoleMenuItem(s,o,u){const y={label:this.mnemonicLabel(s),role:u,enabled:!0};return new m.MenuItem(this.withKeybinding(o,y))}setMacWindowMenu(s){const o=new m.MenuItem({label:g.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),u=new m.MenuItem({label:g.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),y=new m.MenuItem({label:g.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),k=this.createMenuItem(g.localize(20,null),"workbench.action.switchWindow"),R=[];this.currentEnableNativeTabs&&(R.push(r()),R.push(this.createMenuItem(g.localize(21,null),"workbench.action.newWindowTab")),R.push(this.createRoleMenuItem(g.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),R.push(this.createRoleMenuItem(g.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),R.push(this.createRoleMenuItem(g.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),R.push(this.createRoleMenuItem(g.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[o,u,r(),k,...R,r(),y].forEach(W=>s.append(W))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new m.MenuItem({label:this.mnemonicLabel(g.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new m.MenuItem({label:g.localize(27,null),enabled:!1})];case"available for download":return[new m.MenuItem({label:this.mnemonicLabel(g.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new m.MenuItem({label:g.localize(29,null),enabled:!1})];case"downloaded":return[new m.MenuItem({label:this.mnemonicLabel(g.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new m.MenuItem({label:g.localize(31,null),enabled:!1})];case"ready":return[new m.MenuItem({label:this.mnemonicLabel(g.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(s,o,u,y){const k=this.mnemonicLabel(s),R=typeof o=="function"?o:(ee,Q,H)=>{const X=ee?ee.userSettingsLabel:null;let z=o;Array.isArray(o)&&(z=this.isOptionClick(H)?o[1]:o[0]),X&&H.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:X}):this.runActionInRenderer({type:"commandId",commandId:z})},W=typeof u=="boolean"?u:this.windowsMainService.getWindowCount()>0,U=typeof y=="boolean"?y:!1,K={label:k,click:R,enabled:W};U&&(K.type="checkbox",K.checked=U);let x;return typeof o=="string"?x=o:Array.isArray(o)&&(x=o[0]),M.isMacintosh&&(x==="editor.action.clipboardCutAction"?K.role="cut":x==="editor.action.clipboardCopyAction"?K.role="copy":x==="editor.action.clipboardPasteAction"&&(K.role="paste"),x==="undo"?K.click=this.makeContextAwareClickHandler(R,{inDevTools:ee=>ee.undo(),inNoWindow:()=>m.Menu.sendActionToFirstResponder("undo:")}):x==="redo"?K.click=this.makeContextAwareClickHandler(R,{inDevTools:ee=>ee.redo(),inNoWindow:()=>m.Menu.sendActionToFirstResponder("redo:")}):x==="editor.action.selectAll"&&(K.click=this.makeContextAwareClickHandler(R,{inDevTools:ee=>ee.selectAll(),inNoWindow:()=>m.Menu.sendActionToFirstResponder("selectAll:")}))),new m.MenuItem(this.withKeybinding(x,K))}makeContextAwareClickHandler(s,o){return(u,y,k)=>{const R=m.BrowserWindow.getFocusedWindow();if(!R)return o.inNoWindow();if(R.webContents.isDevToolsFocused()&&R.webContents.devToolsWebContents)return o.inDevTools(R.webContents.devToolsWebContents);s(u,y||R,k)}}runActionInRenderer(s){let o=m.BrowserWindow.getFocusedWindow();if(!o){const y=this.windowsMainService.getLastActiveWindow();y?.isMinimized()&&(o=y.win)}const u=o?this.windowsMainService.getWindowById(o.id):void 0;if(u){if(this.logService.trace("menubar#runActionInRenderer",s),M.isMacintosh&&!this.environmentMainService.isBuilt&&!u.isReady&&(s.type==="commandId"&&s.commandId==="workbench.action.toggleDevTools"||s.type!=="commandId"&&s.userSettingsLabel==="alt+cmd+i"))return;if(s.type==="commandId"){const y={id:s.commandId,from:"menu"};u.sendWhenReady("vscode:runAction",L.CancellationToken.None,y)}else{const y={userSettingsLabel:s.userSettingsLabel};u.sendWhenReady("vscode:runKeybinding",L.CancellationToken.None,y)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",s)}withKeybinding(s,o){const u=typeof s=="string"?this.keybindings[s]:void 0;if(u?.label){if(u.isNative!==!1)o.accelerator=u.label,o.userSettingsLabel=u.userSettingsLabel;else if(typeof o.label=="string"){const y=o.label.indexOf("[");y>=0?o.label=`${o.label.substr(0,y)} [${u.label}]`:o.label=`${o.label} [${u.label}]`}}else o.accelerator=void 0;return o}likeAction(s,o,u=!o.accelerator){u&&(o=this.withKeybinding(s,o));const y=o.click;return o.click=(k,R,W)=>{this.reportMenuActionTelemetry(s),y&&y(k,R,W)},o}openUrl(s,o){this.nativeHostMainService.openExternal(void 0,s),this.reportMenuActionTelemetry(o)}reportMenuActionTelemetry(s){this.telemetryService.publicLog2("workbenchActionExecuted",{id:s,from:a})}mnemonicLabel(s){return(0,D.mnemonicMenuLabel)(s,!this.currentEnableMenuBarMnemonics)}};f.lastKnownMenubarStorageKey="lastKnownMenubarData",f=ue([te(0,P.IUpdateService),te(1,b.IConfigurationService),te(2,l.IWindowsMainService),te(3,C.IEnvironmentMainService),te(4,v.ITelemetryService),te(5,c.IWorkspacesHistoryMainService),te(6,p.IStateMainService),te(7,I.ILifecycleMainService),te(8,E.ILogService),te(9,t.INativeHostMainService),te(10,d.IProductService)],f),e.Menubar=f;function r(){return new m.MenuItem({type:"separator"})}}),define(J[245],Z([0,1,5,18,6,244]),function(V,e,m,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,m.createDecorator)("menubarMainService");let M=class{constructor(g,b,C){this.instantiationService=g,this.lifecycleMainService=b,this.logService=C,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(D.Menubar)}async updateMenubar(g,b){this.logService.trace("menubarService#updateMenubar",g),(await this.menubar).updateMenu(b,g)}};M=ue([te(0,m.IInstantiationService),te(1,n.ILifecycleMainService),te(2,L.ILogService)],M),e.MenubarMainService=M}),define(J[246],Z([0,1,12,29,26,30,23,4,28,43,33,2,10,7,63,3,36,17,14,8,158,51,19,47,22,20,5,18,6,53,21,54,78,38,66,243,102,226,25,103,67,42]),function(V,e,m,n,L,D,M,S,g,b,C,I,E,w,t,d,p,v,P,h,l,c,a,f,r,i,s,o,u,y,k,R,W,U,K,x,ee,Q,H,X,z,ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function $(B){return(0,H.isWorkspaceIdentifier)(B?.workspace)}function q(B){return(0,H.isSingleFolderWorkspaceIdentifier)(B?.workspace)}let Y=class ot extends I.Disposable{constructor(F,N,T,A,O,_,j,ne,ae,ce,re,le,he,we,Ee){super();this.machineId=F,this.initialUserEnv=N,this.logService=T,this.stateMainService=A,this.environmentMainService=O,this.lifecycleMainService=_,this.backupMainService=j,this.configurationService=ne,this.workspacesHistoryMainService=ae,this.workspacesManagementMainService=ce,this.instantiationService=re,this.dialogMainService=le,this.fileService=he,this.productService=we,this.protocolMainService=Ee,this._onDidOpenWindow=this._register(new S.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new S.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new S.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new S.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new Q.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(F=>this._onDidSignalReadyWindow.fire(F.window))),this._register(this.onDidSignalReadyWindow(F=>{if(F.config?.extensionDevelopmentPath||F.config?.extensionTestsPath){const N=new I.DisposableStore;if(N.add(S.Event.any(F.onDidClose,F.onDidDestroy)(()=>N.dispose())),F.config.extensionDevelopmentPath)for(const T of F.config.extensionDevelopmentPath)N.add(this.protocolMainService.addValidFileRoot(T));F.config.extensionTestsPath&&N.add(this.protocolMainService.addValidFileRoot(F.config.extensionTestsPath))}}))}openEmptyWindow(F,N){let T=this.environmentMainService.args;const A=N?.remoteAuthority||void 0,O=!0,_=N?.forceReuseWindow,j=!_;return this.open({...F,cli:T,forceEmpty:O,forceNewWindow:j,forceReuseWindow:_,remoteAuthority:A})}openExistingWindow(F,N){F.focus(),this.handleWaitMarkerFile(N,[F])}open(F){this.logService.trace("windowsManager#open"),F.addMode&&(F.initialStartup||!this.getLastActiveWindow())&&(F.addMode=!1);const N=[],T=[],A=[],O=[],_=[];let j,ne=0;const ae=this.getPathsToOpen(F);this.logService.trace("windowsManager#open pathsToOpen",ae);for(const he of ae)q(he)?F.addMode?N.push(he):T.push(he):$(he)?A.push(he):he.fileUri?(j||(j={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:he.remoteAuthority}),j.filesToOpenOrCreate.push(he)):he.backupPath?_.push({backupFolder:(0,w.basename)(he.backupPath),remoteAuthority:he.remoteAuthority}):ne++;F.diffMode&&j&&j.filesToOpenOrCreate.length>=2&&(j.filesToDiff=j.filesToOpenOrCreate.slice(0,2),j.filesToOpenOrCreate=[]),j&&F.waitMarkerFileURI&&(j.filesToWait={paths:[...j.filesToDiff,...j.filesToOpenOrCreate],waitMarkerFileUri:F.waitMarkerFileURI}),F.initialStartup?(O.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),A.push(...O),_.push(...this.backupMainService.getEmptyWindowBackupPaths())):_.length=0;const{windows:ce,filesOpenedInWindow:re}=this.doOpen(F,A,T,_,ne,j,N);if(this.logService.trace(`windowsManager#open used window count ${ce.length} (workspacesToOpen: ${A.length}, foldersToOpen: ${T.length}, emptyToRestore: ${_.length}, emptyToOpen: ${ne})`),ce.length>1)if(re)re.focus();else{const he=this.windowsStateHandler.state.lastActiveWindow&&!F.forceEmpty&&!F.cli._.length&&!F.cli["file-uri"]&&!F.cli["folder-uri"]&&!(F.urisToOpen&&F.urisToOpen.length);let we=!0,Ee=!0;if(he){const Ce=ce.filter(Se=>this.windowsStateHandler.state.lastActiveWindow&&Se.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);Ce.length&&(Ce[0].focus(),we=!1,Ee=!1)}if(we)for(let Ce=ce.length-1;Ce>=0;Ce--){const Se=ce[Ce];if(!(Se.openedWorkspace&&O.some(pe=>Se.openedWorkspace&&pe.workspace.id===Se.openedWorkspace.id)||Se.backupPath&&_.some(pe=>Se.backupPath&&pe.backupFolder===(0,w.basename)(Se.backupPath)))){Se.focus(),Ee=!1;break}}Ee&&ce[ce.length-1].focus()}const le=j&&j.filesToDiff.length>0;if(!ce.some(he=>he.isExtensionDevelopmentHost)&&!le&&!F.noRecentEntry){const he=[];for(const we of ae)$(we)&&!we.transient?he.push({label:we.label,workspace:we.workspace,remoteAuthority:we.remoteAuthority}):q(we)?he.push({label:we.label,folderUri:we.workspace.uri,remoteAuthority:we.remoteAuthority}):we.fileUri&&he.push({label:we.label,fileUri:we.fileUri,remoteAuthority:we.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(he)}return this.handleWaitMarkerFile(F,ce),ce}handleWaitMarkerFile(F,N){const T=F.waitMarkerFileURI;F.context===0&&T&&N.length===1&&N[0]&&(async()=>{await N[0].whenClosedOrLoaded;try{await this.fileService.del(T)}catch{}})()}doOpen(F,N,T,A,O,_,j){const ne=[];let ae;function ce(Se,pe){ne.push(Se),pe&&(ae=Se,_=void 0)}let{openFolderInNewWindow:re,openFilesInNewWindow:le}=this.shouldOpenNewWindow(F);if(!F.initialStartup&&j.length>0){const Se=j[0].remoteAuthority,pe=this.getLastActiveWindowForAuthority(Se);pe&&ce(this.doAddFoldersToExistingWindow(pe,j.map(Ie=>Ie.workspace.uri)))}const he=T.length+N.length+A.length;if(_&&he===0){const Se=_.filesToOpenOrCreate[0]||_.filesToDiff[0],pe=this.getWindows().filter(Re=>_&&(0,v.isEqualAuthority)(Re.remoteAuthority,_.remoteAuthority));let Ie;Se?.fileUri&&!le&&((F.context===4||F.context===0||F.context===1)&&(Ie=(0,ee.findWindowOnFile)(pe,Se.fileUri,Re=>Re.configPath.scheme===E.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(Re.configPath):void 0)),Ie||(Ie=this.doGetLastActiveWindow(pe))),Ie?(0,H.isWorkspaceIdentifier)(Ie.openedWorkspace)?N.push({workspace:Ie.openedWorkspace,remoteAuthority:Ie.remoteAuthority}):(0,H.isSingleFolderWorkspaceIdentifier)(Ie.openedWorkspace)?T.push({workspace:Ie.openedWorkspace,remoteAuthority:Ie.remoteAuthority}):ce(this.doOpenFilesInExistingWindow(F,Ie,_),!0):ce(this.openInBrowserWindow({userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,filesToOpen:_,forceNewWindow:!0,remoteAuthority:_.remoteAuthority,forceNewTabbedWindow:F.forceNewTabbedWindow}),!0)}const we=(0,D.distinct)(N,Se=>Se.workspace.id);if(we.length>0){const Se=(0,D.coalesce)(we.map(pe=>(0,ee.findWindowOnWorkspaceOrFolder)(this.getWindows(),pe.workspace.configPath)));if(Se.length>0){const pe=Se[0],Ie=(0,v.isEqualAuthority)(_?.remoteAuthority,pe.remoteAuthority)?_:void 0;ce(this.doOpenFilesInExistingWindow(F,pe,Ie),!!Ie),re=!0}we.forEach(pe=>{if(Se.some(Be=>Be.openedWorkspace&&Be.openedWorkspace.id===pe.workspace.id))return;const Ie=pe.remoteAuthority,Re=(0,v.isEqualAuthority)(_?.remoteAuthority,Ie)?_:void 0;ce(this.doOpenFolderOrWorkspace(F,pe,re,Re),!!Re),re=!0})}const Ee=(0,D.distinct)(T,Se=>v.extUriBiasedIgnorePathCase.getComparisonKey(Se.workspace.uri));if(Ee.length>0){const Se=(0,D.coalesce)(Ee.map(pe=>(0,ee.findWindowOnWorkspaceOrFolder)(this.getWindows(),pe.workspace.uri)));if(Se.length>0){const pe=Se[0],Ie=(0,v.isEqualAuthority)(_?.remoteAuthority,pe.remoteAuthority)?_:void 0;ce(this.doOpenFilesInExistingWindow(F,pe,Ie),!!Ie),re=!0}Ee.forEach(pe=>{if(Se.some(Be=>(0,H.isSingleFolderWorkspaceIdentifier)(Be.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(Be.openedWorkspace.uri,pe.workspace.uri)))return;const Ie=pe.remoteAuthority,Re=(0,v.isEqualAuthority)(_?.remoteAuthority,Ie)?_:void 0;ce(this.doOpenFolderOrWorkspace(F,pe,re,Re),!!Re),re=!0})}const Ce=(0,D.distinct)(A,Se=>Se.backupFolder);if(Ce.length>0&&Ce.forEach(Se=>{const pe=Se.remoteAuthority,Ie=(0,v.isEqualAuthority)(_?.remoteAuthority,pe)?_:void 0;ce(this.doOpenEmpty(F,!0,pe,Ie,Se),!!Ie),re=!0}),ne.length===0||_){_&&!O&&O++;const Se=_?_.remoteAuthority:F.remoteAuthority;for(let pe=0;pe<O;pe++)ce(this.doOpenEmpty(F,re,Se,_),!!_),re=!0}return{windows:(0,D.distinct)(ne),filesOpenedInWindow:ae}}doOpenFilesInExistingWindow(F,N,T){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:T}),N.focus();const A={filesToOpenOrCreate:T?.filesToOpenOrCreate,filesToDiff:T?.filesToDiff,filesToWait:T?.filesToWait,termProgram:F?.userEnv?.TERM_PROGRAM};return N.sendWhenReady("vscode:openFiles",M.CancellationToken.None,A),N}doAddFoldersToExistingWindow(F,N){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:N}),F.focus();const T={foldersToAdd:N};return F.sendWhenReady("vscode:addFolders",M.CancellationToken.None,T),F}doOpenEmpty(F,N,T,A,O){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!O,remoteAuthority:T,filesToOpen:A,forceNewWindow:N});let _;return!N&&typeof F.contextWindowId=="number"&&(_=this.getWindowById(F.contextWindowId)),this.openInBrowserWindow({userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,remoteAuthority:T,forceNewWindow:N,forceNewTabbedWindow:F.forceNewTabbedWindow,filesToOpen:A,windowToUse:_,emptyWindowBackupInfo:O})}doOpenFolderOrWorkspace(F,N,T,A,O){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:N,filesToOpen:A}),!T&&!O&&typeof F.contextWindowId=="number"&&(O=this.getWindowById(F.contextWindowId)),this.openInBrowserWindow({workspace:N.workspace,userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,remoteAuthority:N.remoteAuthority,forceNewWindow:T,forceNewTabbedWindow:F.forceNewTabbedWindow,filesToOpen:A,windowToUse:O})}getPathsToOpen(F){let N,T=!1,A=!1;if(F.urisToOpen&&F.urisToOpen.length>0?(N=this.doExtractPathsFromAPI(F),T=!0):F.forceEmpty?N=[Object.create(null)]:F.cli._.length||F.cli["folder-uri"]||F.cli["file-uri"]?(N=this.doExtractPathsFromCLI(F.cli),N.length===0&&N.push(Object.create(null)),T=!0):(N=this.doGetPathsFromLastSession(),N.length===0&&N.push(Object.create(null)),A=!0),!F.addMode&&T){const O=N.filter(_=>q(_));if(O.length>1){const _=O[0].remoteAuthority;if(O.every(j=>(0,v.isEqualAuthority)(j.remoteAuthority,_))){const j=this.workspacesManagementMainService.createUntitledWorkspaceSync(O.map(ne=>({uri:ne.workspace.uri})));N.push({workspace:j,remoteAuthority:_}),N=N.filter(ne=>!q(ne))}}}return F.initialStartup&&!A&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&N.unshift(...this.doGetPathsFromLastSession().filter(O=>$(O)||q(O)||O.backupPath)),N}doExtractPathsFromAPI(F){const N=[],T={gotoLineMode:F.gotoLineMode,remoteAuthority:F.remoteAuthority};for(const A of(0,D.coalesce)(F.urisToOpen||[])){const O=this.resolveOpenable(A,T);if(O)O.label=A.label,N.push(O);else{const _=this.resourceFromOpenable(A),j={title:this.productService.nameLong,type:"info",buttons:[(0,C.mnemonicButtonLabel)((0,l.localize)(0,null))],defaultId:0,message:_.scheme===E.Schemas.file?(0,l.localize)(1,null):(0,l.localize)(2,null),detail:_.scheme===E.Schemas.file?(0,l.localize)(3,null,(0,C.getPathLabel)(_.fsPath,this.environmentMainService)):(0,l.localize)(4,null,_.toString()),noLink:!0};this.dialogMainService.showMessageBox(j,(0,P.withNullAsUndefined)(m.BrowserWindow.getFocusedWindow()))}}return N}doExtractPathsFromCLI(F){const N=[],T={ignoreFileNotFound:!0,gotoLineMode:F.goto,remoteAuthority:F.remote||void 0,forceOpenWorkspaceAsFile:!1},A=F["folder-uri"];if(A)for(const j of A){const ne=this.cliArgToUri(j);if(ne){const ae=this.resolveOpenable({folderUri:ne},T);ae&&N.push(ae)}}const O=F["file-uri"];if(O)for(const j of O){const ne=this.cliArgToUri(j);if(ne){const ae=this.resolveOpenable((0,H.hasWorkspaceFileExtension)(j)?{workspaceUri:ne}:{fileUri:ne},T);ae&&N.push(ae)}}const _=F._;for(const j of _){const ne=T.remoteAuthority?this.doResolvePathRemote(j,T):this.doResolveFilePath(j,T);ne&&N.push(ne)}return N}cliArgToUri(F){try{const N=h.URI.parse(F);if(!N.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${F}`);return}return N}catch(N){this.logService.error(`Invalid URI input string: ${F}, ${N.message}`)}}doGetPathsFromLastSession(){const F=this.getRestoreWindowsSetting();switch(F){case"none":return[];case"one":case"all":case"preserve":case"folders":{const N=[];F!=="one"&&N.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&N.push(this.windowsStateHandler.state.lastActiveWindow);const T=[];for(const A of N)if(A.workspace){const O=this.resolveOpenable({workspaceUri:A.workspace.configPath},{remoteAuthority:A.remoteAuthority,rejectTransientWorkspaces:!0});$(O)&&T.push(O)}else if(A.folderUri){const O=this.resolveOpenable({folderUri:A.folderUri},{remoteAuthority:A.remoteAuthority});q(O)&&T.push(O)}else F!=="folders"&&A.backupPath&&T.push({backupPath:A.backupPath,remoteAuthority:A.remoteAuthority});return T}}}getRestoreWindowsSetting(){let F;return this.lifecycleMainService.wasRestarted?F="all":(F=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(F)||(F="all")),F}resolveOpenable(F,N=Object.create(null)){let T=this.resourceFromOpenable(F);return T.scheme===E.Schemas.file?((0,K.isFileToOpen)(F)&&(N={...N,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(T.fsPath,N)):this.doResolveRemoteOpenable(F,N)}doResolveRemoteOpenable(F,N){let T=this.resourceFromOpenable(F);const A=(0,W.getRemoteAuthority)(T)||N.remoteAuthority;if(T=(0,v.removeTrailingPathSeparator)((0,v.normalizePath)(T)),(0,K.isFileToOpen)(F)){if(N.gotoLineMode){const{path:O,line:_,column:j}=(0,g.parseLineAndColumnAware)(T.path);return{fileUri:T.with({path:O}),selection:_?{startLineNumber:_,startColumn:j||1}:void 0,remoteAuthority:A}}return{fileUri:T,remoteAuthority:A}}else if((0,K.isWorkspaceToOpen)(F))return{workspace:(0,X.getWorkspaceIdentifier)(T),remoteAuthority:A};return{workspace:(0,X.getSingleFolderWorkspaceIdentifier)(T),remoteAuthority:A}}resourceFromOpenable(F){return(0,K.isWorkspaceToOpen)(F)?F.workspaceUri:(0,K.isFolderToOpen)(F)?F.folderUri:F.fileUri}doResolveFilePath(F,N){let T,A;N.gotoLineMode&&({path:F,line:T,column:A}=(0,g.parseLineAndColumnAware)(F)),F=(0,g.sanitizeFilePath)((0,w.normalize)(F),(0,p.cwd)());try{const O=(0,n.statSync)(F);if(O.isFile()){if(!N.forceOpenWorkspaceAsFile){const _=this.workspacesManagementMainService.resolveLocalWorkspaceSync(h.URI.file(F));if(_)return _.transient&&N.rejectTransientWorkspaces?void 0:{workspace:{id:_.id,configPath:_.configPath},type:i.FileType.File,exists:!0,remoteAuthority:_.remoteAuthority,transient:_.transient}}return{fileUri:h.URI.file(F),type:i.FileType.File,exists:!0,selection:T?{startLineNumber:T,startColumn:A||1}:void 0}}else{if(O.isDirectory())return{workspace:(0,X.getSingleFolderWorkspaceIdentifier)(h.URI.file(F),O),type:i.FileType.Directory,exists:!0};if(!d.isWindows&&F==="/dev/null")return{fileUri:h.URI.file(F),type:i.FileType.File,exists:!0}}}catch{const _=h.URI.file(F);if(this.workspacesHistoryMainService.removeRecentlyOpened([_]),N.ignoreFileNotFound)return{fileUri:_,type:i.FileType.File,exists:!1}}}doResolvePathRemote(F,N){const T=F.charCodeAt(0),A=N.remoteAuthority;let O,_;N.gotoLineMode&&({path:F,line:O,column:_}=(0,g.parseLineAndColumnAware)(F)),T!==47&&((0,g.isWindowsDriveLetter)(T)&&F.charCodeAt(F.charCodeAt(1))===58&&(F=(0,g.toSlashes)(F)),F=`/${F}`);const j=h.URI.from({scheme:E.Schemas.vscodeRemote,authority:A,path:F});if(F.charCodeAt(F.length-1)!==47){if((0,H.hasWorkspaceFileExtension)(F))return N.forceOpenWorkspaceAsFile?{fileUri:j,selection:O?{startLineNumber:O,startColumn:_||1}:void 0,remoteAuthority:N.remoteAuthority}:{workspace:(0,X.getWorkspaceIdentifier)(j),remoteAuthority:A};if(N.gotoLineMode||w.posix.basename(F).indexOf(".")!==-1)return{fileUri:j,selection:O?{startLineNumber:O,startColumn:_||1}:void 0,remoteAuthority:A}}return{workspace:(0,X.getSingleFolderWorkspaceIdentifier)(j),remoteAuthority:A}}shouldOpenNewWindow(F){const N=this.configurationService.getValue("window"),T=N?.openFoldersInNewWindow||"default",A=N?.openFilesInNewWindow||"off";let O=(F.preferNewWindow||F.forceNewWindow)&&!F.forceReuseWindow;!F.forceNewWindow&&!F.forceReuseWindow&&(T==="on"||T==="off")&&(O=T==="on");let _=!1;return F.forceNewWindow||F.forceReuseWindow?_=!!F.forceNewWindow&&!F.forceReuseWindow:(d.isMacintosh?F.context===1&&(_=!0):F.context!==3&&F.context!==2&&!(F.userEnv&&F.userEnv.TERM_PROGRAM==="vscode")&&(_=!0),!F.cli.extensionDevelopmentPath&&(A==="on"||A==="off")&&(_=A==="on")),{openFolderInNewWindow:!!O,openFilesInNewWindow:_}}openExtensionDevelopmentHostWindow(F,N){const T=(0,ee.findWindowOnExtensionDevelopmentPath)(this.getWindows(),F);if(T)return this.lifecycleMainService.reload(T,N.cli),T.focus(),[T];let A=N.cli["folder-uri"]||[],O=N.cli["file-uri"]||[],_=N.cli._;if(!_.length&&!A.length&&!O.length&&!N.cli.extensionTestsPath){const ce=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,re=ce&&(ce.workspace||ce.folderUri);re&&(h.URI.isUri(re)?re.scheme===E.Schemas.file?_=[re.fsPath]:A=[re.toString()]:re.configPath.scheme===E.Schemas.file?_=[(0,v.originalFSPath)(re.configPath)]:O=[re.configPath.toString()])}let j=N.remoteAuthority;for(const ce of F)if(ce.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const re=h.URI.parse(ce),le=(0,W.getRemoteAuthority)(re);le&&(j?(0,v.isEqualAuthority)(le,j)||this.logService.error("more than one extension development path authority"):j=le)}_=_.filter(ce=>{const re=h.URI.file(ce);return(0,ee.findWindowOnWorkspaceOrFolder)(this.getWindows(),re)?!1:(0,v.isEqualAuthority)((0,W.getRemoteAuthority)(re),j)}),A=A.filter(ce=>{const re=this.cliArgToUri(ce);return re&&!!(0,ee.findWindowOnWorkspaceOrFolder)(this.getWindows(),re)?!1:re?(0,v.isEqualAuthority)((0,W.getRemoteAuthority)(re),j):!1}),O=O.filter(ce=>{const re=this.cliArgToUri(ce);return re&&!!(0,ee.findWindowOnWorkspaceOrFolder)(this.getWindows(),re)?!1:re?(0,v.isEqualAuthority)((0,W.getRemoteAuthority)(re),j):!1}),N.cli._=_,N.cli["folder-uri"]=A,N.cli["file-uri"]=O;const ne=!_.length&&!A.length&&!O.length,ae={context:N.context,cli:N.cli,forceNewWindow:!0,forceEmpty:ne,userEnv:N.userEnv,noRecentEntry:!0,waitMarkerFileURI:N.waitMarkerFileURI,remoteAuthority:j};return this.open(ae)}openInBrowserWindow(F){const N=this.configurationService.getValue("window"),T={...this.environmentMainService.args,...F.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:F.emptyWindowBackupInfo?(0,w.join)(this.environmentMainService.backupHome,F.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:F.remoteAuthority,workspace:F.workspace,userEnv:{...this.initialUserEnv,...F.userEnv},filesToOpenOrCreate:F.filesToOpen?.filesToOpenOrCreate,filesToDiff:F.filesToOpen?.filesToDiff,filesToWait:F.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:y.default,isInitialStartup:F.initialStartup,perfMarks:(0,t.getMarks)(),os:{release:(0,L.release)(),hostname:(0,L.hostname)()},zoomLevel:typeof N?.zoomLevel=="number"?N.zoomLevel:void 0,autoDetectHighContrast:N?.autoDetectHighContrast??!0,accessibilitySupport:m.app.accessibilitySupportEnabled,colorScheme:{dark:m.nativeTheme.shouldUseDarkColors,highContrast:m.nativeTheme.shouldUseInvertedColorScheme||m.nativeTheme.shouldUseHighContrastColors}};let A;if(!F.forceNewWindow&&!F.forceNewTabbedWindow&&(A=F.windowToUse||this.getLastActiveWindow(),A&&A.focus()),A){const O=A.config;!T.extensionDevelopmentPath&&O&&!!O.extensionDevelopmentPath&&(T.extensionDevelopmentPath=O.extensionDevelopmentPath,T.verbose=O.verbose,T["inspect-brk-extensions"]=O["inspect-brk-extensions"],T.debugId=O.debugId,T.extensionEnvironment=O.extensionEnvironment,T["inspect-extensions"]=O["inspect-extensions"],T["extensions-dir"]=O["extensions-dir"])}else{const O=this.windowsStateHandler.getNewWindowState(T);(0,t.mark)("code/willCreateCodeWindow");const _=A=this.instantiationService.createInstance(x.CodeWindow,{state:O,extensionDevelopmentPath:T.extensionDevelopmentPath,isExtensionTestHost:!!T.extensionTestsPath});if((0,t.mark)("code/didCreateCodeWindow"),F.forceNewTabbedWindow){const ne=this.getLastActiveWindow();ne&&ne.addTabbedWindow(_)}ot.WINDOWS.push(_),this._onDidOpenWindow.fire(_),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,b.once)(_.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(_)),(0,b.once)(_.onDidClose)(()=>this.onWindowClosed(_)),(0,b.once)(_.onDidDestroy)(()=>this._onDidDestroyWindow.fire(_));const j=(0,P.assertIsDefined)(_.win?.webContents);j.removeAllListeners("devtools-reload-page"),j.on("devtools-reload-page",()=>this.lifecycleMainService.reload(_)),this.lifecycleMainService.registerWindow(_)}return T.windowId=A.id,A.isReady?this.lifecycleMainService.unload(A,4).then(O=>{O||this.doOpenInBrowserWindow(A,T,F)}):this.doOpenInBrowserWindow(A,T,F),A}doOpenInBrowserWindow(F,N,T){if(!N.extensionDevelopmentPath)if((0,H.isWorkspaceIdentifier)(N.workspace))N.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:N.workspace,remoteAuthority:N.remoteAuthority});else if((0,H.isSingleFolderWorkspaceIdentifier)(N.workspace))N.backupPath=this.backupMainService.registerFolderBackupSync({folderUri:N.workspace.uri,remoteAuthority:N.remoteAuthority});else{const A=T.emptyWindowBackupInfo&&T.emptyWindowBackupInfo.backupFolder;N.backupPath=this.backupMainService.registerEmptyWindowBackupSync(A,N.remoteAuthority)}F.load(N)}onWindowClosed(F){const N=ot.WINDOWS.indexOf(F);ot.WINDOWS.splice(N,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const F=m.BrowserWindow.getFocusedWindow();if(F)return this.getWindowById(F.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(F){return this.doGetLastActiveWindow(this.getWindows().filter(N=>(0,v.isEqualAuthority)(N.remoteAuthority,F)))}doGetLastActiveWindow(F){const N=Math.max.apply(Math,F.map(T=>T.lastFocusTime));return F.find(T=>T.lastFocusTime===N)}sendToFocused(F,...N){const T=this.getFocusedWindow()||this.getLastActiveWindow();T&&T.sendWhenReady(F,M.CancellationToken.None,...N)}sendToAll(F,N,T){for(const A of this.getWindows())T&&T.indexOf(A.id)>=0||A.sendWhenReady(F,M.CancellationToken.None,N)}getWindows(){return ot.WINDOWS}getWindowCount(){return ot.WINDOWS.length}getWindowById(F){const N=this.getWindows().filter(T=>T.id===F);return(0,D.firstOrDefault)(N)}getWindowByWebContents(F){const N=m.BrowserWindow.fromWebContents(F);if(!!N)return this.getWindowById(N.id)}};Y.WINDOWS=[],Y=ue([te(2,u.ILogService),te(3,U.IStateMainService),te(4,r.IEnvironmentMainService),te(5,o.ILifecycleMainService),te(6,c.IBackupMainService),te(7,a.IConfigurationService),te(8,z.IWorkspacesHistoryMainService),te(9,ie.IWorkspacesManagementMainService),te(10,s.IInstantiationService),te(11,f.IDialogMainService),te(12,i.IFileService),te(13,k.IProductService),te(14,R.IProtocolMainService)],Y),e.WindowsMainService=Y}),define(J[247],Z([0,1,51,34,67,42]),function(V,e,m,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let M=class{constructor(g,b,C,I){this.workspacesManagementMainService=g,this.windowsMainService=b,this.workspacesHistoryMainService=C,this.backupMainService=I,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(g,b){const C=this.windowsMainService.getWindowById(g);if(C)return this.workspacesManagementMainService.enterWorkspace(C,this.windowsMainService.getWindows(),b)}createUntitledWorkspace(g,b,C){return this.workspacesManagementMainService.createUntitledWorkspace(b,C)}deleteUntitledWorkspace(g,b){return this.workspacesManagementMainService.deleteUntitledWorkspace(b)}getWorkspaceIdentifier(g,b){return this.workspacesManagementMainService.getWorkspaceIdentifier(b)}getRecentlyOpened(g){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(g))}addRecentlyOpened(g,b){return this.workspacesHistoryMainService.addRecentlyOpened(b)}removeRecentlyOpened(g,b){return this.workspacesHistoryMainService.removeRecentlyOpened(b)}clearRecentlyOpened(g){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};M=ue([te(0,D.IWorkspacesManagementMainService),te(1,n.IWindowsMainService),te(2,L.IWorkspacesHistoryMainService),te(3,m.IBackupMainService)],M),e.WorkspacesMainService=M}),define(J[248],Z([0,1,12,29,26,16,39,15,28,43,44,33,2,10,7,3,14,8,31,71,126,37,129,89,221,139,51,230,19,74,195,168,75,104,47,231,92,166,22,50,98,174,196,175,227,93,176,177,20,190,77,73,5,76,240,206,105,18,6,192,245,58,21,78,235,79,38,224,81,207,32,209,211,64,41,215,238,241,239,242,100,216,217,218,219,222,34,246,223,25,80,67,247,42]),function(V,e,m,n,L,D,M,S,g,b,C,I,E,w,t,d,p,v,P,h,l,c,a,f,r,i,s,o,u,y,k,R,W,U,K,x,ee,Q,H,X,z,ie,$,q,Y,B,F,N,T,A,O,_,j,ne,ae,ce,re,le,he,we,Ee,Ce,Se,pe,Ie,Re,Be,xe,Oe,$e,Ye,at,wt,tt,Qe,Ve,Xe,G,se,oe,fe,ye,Ae,_e,Ge,je,Te,He,Ke,et,it,kt,Lt,Pt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let pt=class extends E.Disposable{constructor(de,me,ve,ge,ke,De,Pe,Me,be,Le){super();this.mainProcessNodeIpcServer=de,this.userEnv=me,this.mainInstantiationService=ve,this.logService=ge,this.environmentMainService=ke,this.lifecycleMainService=De,this.configurationService=Pe,this.stateMainService=Me,this.fileService=be,this.productService=Le,this.configureSession(),this.registerListeners()}configureSession(){const de=be=>be?.startsWith(`${w.Schemas.vscodeWebview}://`),me=new Set(["clipboard-read","clipboard-sanitized-write"]);m.session.defaultSession.setPermissionRequestHandler((be,Le,We,Ue)=>de(Ue.requestingUrl)?We(me.has(Le)):We(!1)),m.session.defaultSession.setPermissionCheckHandler((be,Le,We,Ue)=>de(Ue.requestingUrl)?me.has(Le):!1);const ve=new Set([w.Schemas.file,w.Schemas.vscodeFileResource,w.Schemas.vscodeRemoteResource,"devtools"]),ge=be=>{for(let Le=be;Le;Le=Le.parent)if(Le.url.startsWith(`${w.Schemas.vscodeWebview}://`))return!0;return!1},ke=be=>be.resourceType==="xhr"||ge(be.frame),De=be=>{const Le=be.frame;if(!Le||!this.windowsMainService)return!1;const We=m.BrowserWindow.getAllWindows();for(const Ue of We)if(Le.processId===Ue.webContents.mainFrame.processId)return!0;return!1},Pe=be=>{if(v.URI.parse(be.url).path!=="/index.html")return!0;const We=be.frame;if(!We||!this.windowsMainService)return!1;for(const Ue of this.windowsMainService.getWindows())if(Ue.win&&We.processId===Ue.win.webContents.mainFrame.processId)return!0;return!1};m.session.defaultSession.webRequest.onBeforeRequest((be,Le)=>{const We=v.URI.parse(be.url);return We.scheme===w.Schemas.vscodeWebview&&!Pe(be)?(this.logService.error("Blocked vscode-webview request",be.url),Le({cancel:!0})):We.scheme===w.Schemas.vscodeFileResource&&!De(be)?(this.logService.error("Blocked vscode-file request",be.url),Le({cancel:!0})):We.path.endsWith(".svg")&&!ve.has(We.scheme)?Le({cancel:!ke(be)}):Le({cancel:!1})}),m.session.defaultSession.webRequest.onHeadersReceived((be,Le)=>{const We=be.responseHeaders,Ue=We["content-type"]||We["Content-Type"];if(Ue&&Array.isArray(Ue)){const Je=v.URI.parse(be.url);if(Je.path.endsWith(".svg")&&ve.has(Je.scheme))return We["Content-Type"]=["image/svg+xml"],Le({cancel:!1,responseHeaders:We});if(!Je.path.includes(w.Schemas.vscodeRemoteResource)&&Ue.some(nt=>nt.toLowerCase().includes("image/svg")))return Le({cancel:!ke(be)})}return Le({cancel:!1})});const Me=m.session.defaultSession;typeof Me.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&Me.setCodeCachePath((0,t.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,S.setUnexpectedErrorHandler)(ve=>this.onUnexpectedError(ve)),process.on("uncaughtException",ve=>(0,S.onUnexpectedError)(ve)),process.on("unhandledRejection",ve=>(0,S.onUnexpectedError)(ve)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,l.registerContextMenuListener)(),m.app.on("accessibility-support-changed",(ve,ge)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",ge)}),m.app.on("activate",(ve,ge)=>{this.logService.trace("app#activate"),ge||this.windowsMainService?.openEmptyWindow({context:1})}),m.app.on("web-contents-created",(ve,ge)=>{ge.on("will-navigate",ke=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),ke.preventDefault()}),ge.setWindowOpenHandler(({url:ke})=>(this.nativeHostMainService?.openExternal(void 0,ke),{action:"deny"}))});let de=[],me;m.app.on("open-file",(ve,ge)=>{this.logService.trace("app#open-file: ",ge),ve.preventDefault(),de.push(this.getWindowOpenableFromPathSync(ge)),me!==void 0&&(clearTimeout(me),me=void 0),me=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:de,gotoLineMode:!1,preferNewWindow:!0}),de=[],me=void 0},100)}),m.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),m.ipcMain.handle("vscode:fetchShellEnv",ve=>{const ge=this.windowsMainService?.getWindowByWebContents(ve.sender);let ke,De;return ge?.config?(ke=ge.config,De={...process.env,...ge.config.userEnv}):(ke=this.environmentMainService.args,De=process.env),this.resolveShellEnvironment(ke,De,!1)}),m.ipcMain.handle("vscode:writeNlsFile",(ve,ge,ke)=>{const De=this.validateNlsPath([ge]);if(!De||typeof ke!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(De,D.VSBuffer.fromString(ke))}),m.ipcMain.handle("vscode:readNlsFile",async(ve,...ge)=>{const ke=this.validateNlsPath(ge);if(!ke)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(ke)).value.toString()}),m.ipcMain.on("vscode:toggleDevTools",ve=>ve.sender.toggleDevTools()),m.ipcMain.on("vscode:openDevTools",ve=>ve.sender.openDevTools()),m.ipcMain.on("vscode:reloadWindow",ve=>ve.sender.reload())}validateNlsPath(de){let me;for(const ve of de)typeof ve=="string"&&(typeof me!="string"?me=ve:me=(0,t.join)(me,ve));if(!(typeof me!="string"||!(0,t.isAbsolute)(me)||!(0,g.isEqualOrParent)(me,this.environmentMainService.cachedLanguagesPath,!d.isLinux)))return v.URI.file(me)}onUnexpectedError(de){if(de){const me={message:`[uncaught exception in main]: ${de.message}`,stack:de.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(me))}this.logService.error(`[uncaught exception in main]: ${de}`),de.stack&&this.logService.error(de.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const de=this.productService.win32AppUserModelId;d.isWindows&&de&&m.app.setAppUserModelId(de);try{d.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!m.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&m.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(be){this.logService.error(be)}const me=new a.Server;this.logService.trace("Resolving machine identifier...");const ve=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${ve}`);const{sharedProcess:ge,sharedProcessReady:ke,sharedProcessClient:De}=this.setupSharedProcess(ve),Pe=await this.initServices(ve,ge,ke);if(this.environmentMainService.driverHandle){const be=await(0,x.serve)(me,this.environmentMainService.driverHandle,this.environmentMainService,Pe);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(be)}this._register(Pe.createInstance(r.ProxyAuthHandler)),Pe.invokeFunction(be=>this.initChannels(be,me,De));const Me=Pe.invokeFunction(be=>this.openFirstWindow(be,me));Pe.invokeFunction(be=>this.afterWindowOpen(be,ge)),this.environmentMainService.args.trace&&Pe.invokeFunction(be=>this.stopTracingEventually(be,Me))}async resolveMachineId(){let de=this.stateMainService.getItem(Ye.machineIdKey);return(!de||d.isMacintosh&&de==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(de=await(0,h.getMachineId)(),this.stateMainService.setItem(Ye.machineIdKey,de)),de}setupSharedProcess(de){const me=this._register(this.mainInstantiationService.createInstance(Ie.SharedProcess,de,this.userEnv)),ve=(async()=>{this.logService.trace("Main->SharedProcess#connect");const ke=await me.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new f.Client(ke,"main")})(),ge=(async()=>(await me.whenReady(),ve))();return{sharedProcess:me,sharedProcessReady:ge,sharedProcessClient:ve}}async initServices(de,me,ve){const ge=new ne.ServiceCollection;switch(process.platform){case"win32":ge.set(Qe.IUpdateService,new _.SyncDescriptor(oe.Win32UpdateService));break;case"linux":d.isLinuxSnap?ge.set(Qe.IUpdateService,new _.SyncDescriptor(se.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):ge.set(Qe.IUpdateService,new _.SyncDescriptor(G.LinuxUpdateService));break;case"darwin":ge.set(Qe.IUpdateService,new _.SyncDescriptor(Xe.DarwinUpdateService));break}ge.set(Te.IWindowsMainService,new _.SyncDescriptor(He.WindowsMainService,[de,this.userEnv])),ge.set(K.IDialogMainService,new _.SyncDescriptor(K.DialogMainService)),ge.set(re.ILaunchMainService,new _.SyncDescriptor(re.LaunchMainService)),ge.set(U.IDiagnosticsMainService,new _.SyncDescriptor(U.DiagnosticsMainService)),ge.set(W.IDiagnosticsService,c.ProxyChannel.toService((0,c.getDelayedChannel)(ve.then(De=>De.getChannel("diagnostics"))))),ge.set(ae.IIssueMainService,new _.SyncDescriptor(ae.IssueMainService,[this.userEnv])),ge.set(ee.IEncryptionMainService,new _.SyncDescriptor(Q.EncryptionMainService,[de])),ge.set(ce.IKeyboardLayoutMainService,new _.SyncDescriptor(ce.KeyboardLayoutMainService)),ge.set(Ce.INativeHostMainService,new _.SyncDescriptor(Ce.NativeHostMainService,[me])),ge.set(y.ICredentialsMainService,new _.SyncDescriptor(k.CredentialsMainService,[!1])),ge.set(Ge.IWebviewManagerService,new _.SyncDescriptor(je.WebviewMainService)),ge.set(it.IWorkspacesService,new _.SyncDescriptor(Lt.WorkspacesMainService)),ge.set(Pt.IWorkspacesManagementMainService,new _.SyncDescriptor(Pt.WorkspacesManagementMainService)),ge.set(kt.IWorkspacesHistoryMainService,new _.SyncDescriptor(kt.WorkspacesHistoryMainService)),ge.set(Ee.IMenubarMainService,new _.SyncDescriptor(Ee.MenubarMainService)),ge.set(ie.IExtensionUrlTrustService,new _.SyncDescriptor($.ExtensionUrlTrustService)),ge.set(q.IExtensionHostStarter,new _.SyncDescriptor(Y.WorkerMainProcessExtensionHostStarter)),ge.set(Oe.IStorageMainService,new _.SyncDescriptor(Oe.StorageMainService)),ge.set(Oe.IGlobalStorageMainService,new _.SyncDescriptor(Oe.GlobalStorageMainService)),d.isWindows?ge.set(B.IExternalTerminalMainService,new _.SyncDescriptor(F.WindowsExternalTerminalService)):d.isMacintosh?ge.set(B.IExternalTerminalMainService,new _.SyncDescriptor(F.MacExternalTerminalService)):d.isLinux&&ge.set(B.IExternalTerminalMainService,new _.SyncDescriptor(F.LinuxExternalTerminalService));const ke=new o.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(ge.set(s.IBackupMainService,ke),ge.set(fe.IURLService,new _.SyncDescriptor(Ae.NativeURLService)),(0,tt.supportsTelemetry)(this.productService,this.environmentMainService)){const De=(0,c.getDelayedChannel)(ve.then(We=>We.getChannel("telemetryAppender"))),Pe=new at.TelemetryAppenderClient(De),Me=(0,$e.resolveCommonProperties)(this.fileService,(0,L.release)(),(0,L.hostname)(),process.arch,this.productService.commit,this.productService.version,de,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),be=(0,tt.getPiiPathsFromEnvironment)(this.environmentMainService),Le={appenders:[Pe],commonProperties:Me,piiPaths:be,sendErrorTelemetry:!0};ge.set(Ye.ITelemetryService,new _.SyncDescriptor(wt.TelemetryService,[Le]))}else ge.set(Ye.ITelemetryService,tt.NullTelemetryService);return await ke.initialize(),this.mainInstantiationService.createChild(ge)}initChannels(de,me,ve){const ge=c.ProxyChannel.fromService(de.get(re.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",ge);const ke=c.ProxyChannel.fromService(de.get(U.IDiagnosticsMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",ke);const De=this.fileService.getProvider(w.Schemas.file);(0,p.assertType)(De instanceof O.DiskFileSystemProvider);const Pe=new A.DiskFileSystemProviderChannel(De,this.logService,this.environmentMainService);me.registerChannel(N.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Pe),ve.then(ze=>ze.registerChannel(N.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Pe));const Me=new Ve.UpdateChannel(de.get(Qe.IUpdateService));me.registerChannel("update",Me);const be=c.ProxyChannel.fromService(de.get(ae.IIssueMainService));me.registerChannel("issue",be);const Le=c.ProxyChannel.fromService(de.get(ee.IEncryptionMainService));me.registerChannel("encryption",Le);const We=c.ProxyChannel.fromService(de.get(y.ICredentialsMainService));me.registerChannel("credentials",We);const Ue=c.ProxyChannel.fromService(de.get(Re.ISignService));me.registerChannel("sign",Ue);const Je=c.ProxyChannel.fromService(de.get(ce.IKeyboardLayoutMainService));me.registerChannel("keyboardLayout",Je),this.nativeHostMainService=de.get(Ce.INativeHostMainService);const nt=c.ProxyChannel.fromService(this.nativeHostMainService);me.registerChannel("nativeHost",nt),ve.then(ze=>ze.registerChannel("nativeHost",nt));const vt=c.ProxyChannel.fromService(de.get(it.IWorkspacesService));me.registerChannel("workspaces",vt);const Ne=c.ProxyChannel.fromService(de.get(Ee.IMenubarMainService));me.registerChannel("menubar",Ne);const ht=c.ProxyChannel.fromService(de.get(fe.IURLService));me.registerChannel("url",ht);const ct=c.ProxyChannel.fromService(de.get(ie.IExtensionUrlTrustService));me.registerChannel("extensionUrlTrust",ct);const lt=c.ProxyChannel.fromService(de.get(Ge.IWebviewManagerService));me.registerChannel("webview",lt);const ut=this._register(new xe.StorageDatabaseChannel(this.logService,de.get(Oe.IStorageMainService)));me.registerChannel("storage",ut),ve.then(ze=>ze.registerChannel("storage",ut));const dt=c.ProxyChannel.fromService(de.get(B.IExternalTerminalMainService));me.registerChannel("externalTerminal",dt);const rt=new we.LogLevelChannel(de.get(he.ILogService));me.registerChannel("logLevel",rt),ve.then(ze=>ze.registerChannel("logLevel",rt));const st=new we.LoggerChannel(de.get(he.ILoggerService));me.registerChannel("logger",st),ve.then(ze=>ze.registerChannel("logger",st));const ft=new R.ElectronExtensionHostDebugBroadcastChannel(de.get(Te.IWindowsMainService));me.registerChannel("extensionhostdebugservice",ft);const Fe=c.ProxyChannel.fromService(de.get(q.IExtensionHostStarter));me.registerChannel(q.ipcExtensionHostStarterChannelName,Fe)}openFirstWindow(de,me){const ve=this.windowsMainService=de.get(Te.IWindowsMainService),ge=de.get(fe.IURLService),ke=de.get(Ce.INativeHostMainService);this.lifecycleMainService.phase=2;const De=[],Pe=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Fe=>{try{return{uri:v.URI.parse(Fe),url:Fe}}catch{return}}).filter(Fe=>{if(!Fe||this.shouldBlockURI(Fe.uri))return!1;const ze=this.getWindowOpenableFromProtocolLink(Fe.uri);return ze?(De.push(ze),!1):!0}),Me=this,be=this.environmentMainService,Le=this.productService,We=this.logService;ge.registerHandler({async handleURL(Fe,ze){if(We.trace("app#handleURL: ",Fe.toString(!0),ze),Fe.scheme===Le.urlProtocol&&Fe.path==="workspace"&&(Fe=Fe.with({authority:"file",path:v.URI.parse(Fe.query).path,query:""})),Me.shouldBlockURI(Fe))return!0;const yt=Me.getWindowOpenableFromProtocolLink(Fe);if(We.trace("app#handleURL: windowOpenableFromProtocolLink = ",yt),yt){const[St]=ve.open({context:5,cli:{...be.args},urisToOpen:[yt],gotoLineMode:!0});return St.focus(),!0}if(d.isMacintosh&&ve.getWindowCount()===0){const[St]=ve.open({context:5,cli:{...be.args},forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,pe.getRemoteAuthority)(Fe)});return await St.ready(),ge.open(Fe,ze)}return!1}});const Ue=this._register(new Ke.ActiveWindowManager({onDidOpenWindow:ke.onDidOpenWindow,onDidFocusWindow:ke.onDidFocusWindow,getActiveWindowId:()=>ke.getActiveWindowId(-1)})),Je=new c.StaticRouter(Fe=>Ue.getActiveClientId().then(ze=>Fe===ze)),nt=new ye.URLHandlerRouter(Je),vt=me.getChannel("urlHandler",nt);ge.registerHandler(new ye.URLHandlerChannelClient(vt)),this._register(new _e.ElectronURLListener(Pe,ge,ve,this.environmentMainService,this.productService));const Ne=this.environmentMainService.args,ht=global.macOpenFiles,ct=(0,X.isLaunchedFromCli)(process.env)?0:4,lt=Ne._.length,ut=!!Ne["folder-uri"],dt=!!Ne["file-uri"],rt=Ne["skip-add-to-recently-opened"]===!0,st=Ne.wait&&Ne.waitMarkerFilePath?v.URI.file(Ne.waitMarkerFilePath):void 0,ft=Ne.remote||void 0;return De.length>0?ve.open({context:ct,cli:Ne,urisToOpen:De,gotoLineMode:!0,initialStartup:!0}):Ne["new-window"]&&!lt&&!ut&&!dt?ve.open({context:ct,cli:Ne,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:rt,waitMarkerFileURI:st,initialStartup:!0,remoteAuthority:ft}):ht.length&&!lt&&!ut&&!dt?ve.open({context:1,cli:Ne,urisToOpen:ht.map(Fe=>this.getWindowOpenableFromPathSync(Fe)),noRecentEntry:rt,waitMarkerFileURI:st,initialStartup:!0}):ve.open({context:ct,cli:Ne,forceNewWindow:Ne["new-window"]||!lt&&Ne["unity-launch"],diffMode:Ne.diff,noRecentEntry:rt,waitMarkerFileURI:st,gotoLineMode:Ne.goto,initialStartup:!0,remoteAuthority:ft})}shouldBlockURI(de){return!!(de.authority===w.Schemas.file&&d.isWindows&&m.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,I.mnemonicButtonLabel)((0,i.localize)(0,null)),(0,I.mnemonicButtonLabel)((0,i.localize)(1,null))],defaultId:0,cancelId:1,message:(0,i.localize)(2,null,(0,I.getPathLabel)(de.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,i.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(de){if(!!de.path){if(de.authority===w.Schemas.file){const me=v.URI.file(de.fsPath);return(0,et.hasWorkspaceFileExtension)(me)?{workspaceUri:me}:{fileUri:me}}else if(de.authority===w.Schemas.vscodeRemote){const me=de.path.indexOf(t.posix.sep,1);if(me!==-1){const ve=de.path.substring(1,me),ge=de.path.substring(me),ke=v.URI.from({scheme:w.Schemas.vscodeRemote,authority:ve,path:ge,query:de.query,fragment:de.fragment});return(0,et.hasWorkspaceFileExtension)(ge)?{workspaceUri:ke}:/:[\d]+$/.test(ge)?{fileUri:ke}:{folderUri:ke}}}}}getWindowOpenableFromPathSync(de){try{if((0,n.statSync)(de).isDirectory())return{folderUri:v.URI.file(de)};if((0,et.hasWorkspaceFileExtension)(de))return{workspaceUri:v.URI.file(de)}}catch{}return{fileUri:v.URI.file(de)}}async afterWindowOpen(de,me){this.lifecycleMainService.phase=3;let ve=!1;(0,b.once)(this.lifecycleMainService.onWillShutdown)(()=>ve=!0);const ge=de.get(Ye.ITelemetryService);this._register(me.onDidError(({type:Pe,details:Me})=>{let be;switch(Pe){case 1:be="SharedProcess: detected unresponsive window";break;case 2:be=`SharedProcess: crashed (detail: ${Me?.reason??"<unknown>"}, code: ${Me?.exitCode??"<unknown>"})`;break;case 3:be=`SharedProcess: failed to load (detail: ${Me?.reason??"<unknown>"}, code: ${Me?.exitCode??"<unknown>"})`;break}(0,S.onUnexpectedError)(new Error(be)),ge.publicLog2("sharedprocesserror",{type:Pe,reason:Me?.reason,code:Me?.exitCode,visible:me.isVisible(),shuttingdown:ve})}));const ke=this.productService.win32MutexName;if(d.isWindows&&ke)try{const Pe=V.__$__nodeRequire("windows-mutex").Mutex,Me=new Pe(ke);(0,b.once)(this.lifecycleMainService.onWillShutdown)(()=>Me.release())}catch(Pe){this.logService.error(Pe)}m.protocol.registerHttpProtocol(w.Schemas.vscodeRemoteResource,(Pe,Me)=>{Me({url:Pe.url.replace(/^vscode-remote-resource:/,"http:"),method:Pe.method})});const De=de.get(Qe.IUpdateService);(De instanceof oe.Win32UpdateService||De instanceof G.LinuxUpdateService||De instanceof Xe.DarwinUpdateService)&&De.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0);try{const Me=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,C.stripComments)(Me))["enable-crash-reporter"]===void 0){const We=(0,tt.getTelemetryLevel)(this.configurationService)>=1,Ue=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${We},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,P.generateUuid)()}"`,"}"],Je=Me.substring(0,Me.length-2).concat(`,
`,Ue.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,D.VSBuffer.fromString(Je))}}catch(Pe){this.logService.error(Pe)}}async resolveShellEnvironment(de,me,ve){try{return await(0,z.getResolvedShellEnv)(this.logService,de,me)}catch(ge){const ke=(0,M.toErrorMessage)(ge);ve?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",ke):this.logService.error(ke)}return{}}stopTracingEventually(de,me){this.logService.info("Tracing: waiting for windows to get ready...");const ve=de.get(K.IDialogMainService);let ge=!1;const ke=async Pe=>{if(ge)return;ge=!0;const Me=await m.contentTracing.stopRecording(`${(0,g.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);Pe?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Me}`):ve.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,i.localize)(4,null),detail:(0,i.localize)(5,null,Me),buttons:[(0,I.mnemonicButtonLabel)((0,i.localize)(6,null))],defaultId:0,noLink:!0},(0,p.withNullAsUndefined)(m.BrowserWindow.getFocusedWindow()))},De=setTimeout(()=>ke(!0),3e4);Promise.all(me.map(Pe=>Pe.ready())).then(()=>{clearTimeout(De),ke(!1)})}};pt=ue([te(2,j.IInstantiationService),te(3,he.ILogService),te(4,H.IEnvironmentMainService),te(5,le.ILifecycleMainService),te(6,u.IConfigurationService),te(7,Be.IStateMainService),te(8,T.IFileService),te(9,Se.IProductService)],pt),e.CodeApplication=pt}),define(J[255],Z([0,1,12,29,30,9,39,15,28,43,33,10,7,63,3,36,27,24,37,57,248,11,19,200,208,22,50,171,20,188,77,73,182,76,18,95,6,193,96,53,21,54,197,99,237,56,234,79,205,38,236,64,65,214]),function(V,e,m,n,L,D,M,S,g,b,C,I,E,w,t,d,p,v,P,h,l,c,a,f,r,i,s,o,u,y,k,R,W,U,K,x,ee,Q,H,X,z,ie,$,q,Y,B,F,N,T,A,O,_,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ne{main(){try{this.startup()}catch(re){console.error(re.message),m.app.exit(1)}}async startup(){(0,S.setUnexpectedErrorHandler)(pe=>console.error(pe));const[re,le,he,we,Ee,Ce,Se]=this.createServices();try{try{await this.initServices(he,we,Ee)}catch(pe){throw this.handleStartupDataDirError(he,Se.nameLong,pe),pe}await re.invokeFunction(async pe=>{const Ie=pe.get(ee.ILogService),Re=pe.get(K.ILifecycleMainService),Be=pe.get(u.IFileService),xe=await this.claimInstance(Ie,he,Re,re,Se,!0);return v.Promises.writeFile(he.mainLockfile,String(process.pid)).catch(Oe=>{Ie.warn(`Error writing main lockfile: ${Oe.stack}`)}),Ce.logger=new H.SpdLogLogger("main",(0,E.join)(he.logsPath,"main.log"),!0,!1,Ce.getLevel()),(0,b.once)(Re.onWillShutdown)(Oe=>{Be.dispose(),we.dispose(),Oe.join(v.Promises.unlink(he.mainLockfile).catch(()=>{}))}),re.createInstance(l.CodeApplication,xe,le).startup()})}catch(pe){re.invokeFunction(this.quit,pe)}}createServices(){const re=new U.ServiceCollection,le={_serviceBrand:void 0,...X.default};re.set(z.IProductService,le);const he=new i.EnvironmentMainService(this.resolveArgs(),le),we=this.patchEnvironment(he);re.set(i.IEnvironmentMainService,he);const Ee=new x.BufferLogService,Ce=new ee.MultiplexLogService([new ee.ConsoleMainLogger((0,ee.getLogLevel)(he)),Ee]);process.once("exit",()=>Ce.dispose()),re.set(ee.ILogService,Ce);const Se=new y.FileService(Ce);re.set(u.IFileService,Se);const pe=new k.DiskFileSystemProvider(Ce);Se.registerProvider(I.Schemas.file,pe),re.set(ee.ILoggerService,new Q.LoggerService(Ce,Se));const Ie=new f.ConfigurationService(he.settingsResource,Se);re.set(a.IConfigurationService,Ie),re.set(K.ILifecycleMainService,new R.SyncDescriptor(K.LifecycleMainService));const Re=new O.StateMainService(he,Ce,Se);return re.set(A.IStateMainService,Re),re.set(B.IRequestService,new R.SyncDescriptor(F.RequestMainService)),re.set(j.IThemeMainService,new R.SyncDescriptor(j.ThemeMainService)),re.set(N.ISignService,new R.SyncDescriptor(T.SignService)),re.set(q.ITunnelService,new R.SyncDescriptor(Y.TunnelService)),re.set(ie.IProtocolMainService,new R.SyncDescriptor($.ProtocolMainService)),[new W.InstantiationService(re,!0),we,he,Ie,Re,Ee,le]}patchEnvironment(re){const le={VSCODE_IPC_HOOK:re.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(he=>{const we=process.env[he];typeof we=="string"&&(le[he]=we)}),Object.assign(process.env,le),le}initServices(re,le,he){return D.Promises.settled([Promise.all([re.extensionsPath,re.codeCachePath,re.logsPath,re.globalStorageHome.fsPath,re.workspaceStorageHome.fsPath,re.backupHome].map(we=>we?v.Promises.mkdir(we,{recursive:!0}):void 0)),le.initialize(),he.init()])}async claimInstance(re,le,he,we,Ee,Ce){let Se;try{(0,w.mark)("code/willStartMainServer"),Se=await(0,h.serve)(le.mainIPCHandle),(0,w.mark)("code/didStartMainServer"),(0,b.once)(he.onWillShutdown)(()=>Se.dispose())}catch(pe){if(pe.code!=="EADDRINUSE")throw this.handleStartupDataDirError(le,Ee.nameLong,pe),pe;let Ie;try{Ie=await(0,h.connect)(le.mainIPCHandle,"main")}catch(Oe){if(!Ce||t.isWindows||Oe.code!=="ECONNREFUSED")throw Oe.code==="EPERM"&&this.showStartupWarningDialog((0,c.localize)(0,null,Ee.nameShort),(0,c.localize)(1,null),Ee.nameLong),Oe;try{(0,n.unlinkSync)(le.mainIPCHandle)}catch($e){throw re.warn("Could not delete obsolete instance handle",$e),$e}return this.claimInstance(re,le,he,we,Ee,!1)}if(le.extensionTestsLocationURI&&!le.debugExtensionHost.break){const Oe="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw re.error(Oe),Ie.dispose(),new Error(Oe)}let Re;!le.args.wait&&!le.args.status&&(Re=setTimeout(()=>{this.showStartupWarningDialog((0,c.localize)(2,null,Ee.nameShort),(0,c.localize)(3,null),Ee.nameLong)},1e4));const Be=P.ProxyChannel.toService(Ie.getChannel("launch"),{disableMarshalling:!0}),xe=P.ProxyChannel.toService(Ie.getChannel("diagnostics"),{disableMarshalling:!0});if(le.args.status)return we.invokeFunction(async()=>{const Oe=new r.DiagnosticsService(_.NullTelemetryService,Ee),$e=await Be.getMainProcessInfo(),Ye=await xe.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),at=await Oe.getDiagnostics($e,Ye);throw console.log(at),new S.ExpectedError});throw t.isWindows&&await this.windowsAllowSetForegroundWindow(Be,re),re.trace("Sending env to running instance..."),await Be.start(le.args,process.env),Ie.dispose(),Re&&clearTimeout(Re),new S.ExpectedError("Sent env to running instance. Terminating...")}if(le.args.status)throw re.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new S.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Se}handleStartupDataDirError(re,le,he){if(he.code==="EACCES"||he.code==="EPERM"){const we=(0,L.coalesce)([re.userDataPath,re.extensionsPath,h.XDG_RUNTIME_DIR]).map(Ee=>(0,C.getPathLabel)(Ee,re));this.showStartupWarningDialog((0,c.localize)(4,null),(0,c.localize)(5,null,(0,M.toErrorMessage)(he),we.join(`
`)),le)}}showStartupWarningDialog(re,le,he){m.dialog.showMessageBoxSync({title:he,type:"warning",buttons:[(0,C.mnemonicButtonLabel)((0,c.localize)(6,null))],message:re,detail:le,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(re,le){if(t.isWindows){const he=await re.getMainProcessId();le.trace("Sending some foreground love to the running instance:",he);try{(await new Promise((we,Ee)=>{V(["windows-foreground-love"],we,Ee)})).allowSetForegroundWindow(he)}catch(we){le.error(we)}}}quit(re,le){const he=re.get(ee.ILogService),we=re.get(K.ILifecycleMainService);let Ee=0;le&&(le.isExpected?le.message&&he.trace(le.message):(Ee=1,le.stack?he.error(le.stack):he.error(`Startup error: ${le.toString()}`))),we.kill(Ee)}resolveArgs(){const re=this.validatePaths((0,s.parseMainProcessArgv)(process.argv));if(re.wait&&!re.waitMarkerFilePath){const le=(0,o.createWaitMarkerFile)(re.verbose);le&&((0,s.addArg)(process.argv,"--waitMarkerFilePath",le),re.waitMarkerFilePath=le)}return re}validatePaths(re){if(re["open-url"]&&(re._urls=re._,re._=[]),!re.remote){const le=this.doValidatePaths(re._,re.goto);re._=le}return re}doValidatePaths(re,le){const he=(0,d.cwd)(),we=re.map(Se=>{let pe=String(Se),Ie;le&&(Ie=(0,g.parseLineAndColumnAware)(pe),pe=Ie.path),pe&&(pe=this.preparePath(he,pe));const Re=(0,g.sanitizeFilePath)(pe,he),Be=(0,E.basename)(Re);return Be&&!(0,g.isValidBasename)(Be)?null:le&&Ie?(Ie.path=Re,this.toPath(Ie)):Re}),Ee=t.isWindows||t.isMacintosh,Ce=(0,L.distinct)(we,Se=>Se&&Ee?Se.toLowerCase():Se||"");return(0,L.coalesce)(Ce)}preparePath(re,le){return t.isWindows&&(le=(0,p.rtrim)(le,'"')),le=(0,p.trim)((0,p.trim)(le," "),"	"),t.isWindows&&(le=(0,E.resolve)(re,le),le=(0,p.rtrim)(le,".")),le}toPath(re){const le=[re.path];return typeof re.line=="number"&&le.push(String(re.line)),typeof re.column=="number"&&le.push(String(re.column)),le.join(":")}}new ne().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8908a9ca0f221f36507231afb39d2d8d1e182702/core/vs/code/electron-main/main.js.map
