/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Y=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/types","vs/base/common/event","vs/base/common/errors","vs/base/common/uri","vs/base/common/network","vs/base/common/path","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/arrays","vs/base/common/resources","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/cancellation","vs/platform/configuration/common/configuration","vs/base/common/strings","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetry","vs/platform/product/common/productService","os","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/stream","child_process","vs/platform/instantiation/common/descriptors","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/node/zip","vs/base/common/decorators","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","vs/base/node/processes","vs/platform/extensions/common/extensionValidator","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/base/common/map","vs/base/common/assert","vs/base/common/json","vs/base/common/processes","vs/base/common/skipList","vs/base/common/hash","vs/base/common/console","vs/base/common/marshalling","vs/base/common/labels","vs/base/node/decoder","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/node/shellEnv","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/node/spdlogLog","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/terminal/node/shellEnv","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","path","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/iterator","graceful-fs","crypto","vs/platform/environment/node/argvHelper","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Q=function(j){for(var i=[],D=0,R=j.length;D<R;D++)i[D]=Y[j[D]];return i};define(Y[55],Q([0,1]),function(j,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ok=void 0;function D(R,b){if(!R)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}i.ok=D}),define(Y[44],Q([0,1]),function(j,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.throttle=i.debounce=i.memoize=i.createDecorator=void 0;function D(L){return(P,l,p)=>{let C=null,T=null;if(typeof p.value=="function"?(C="value",T=p.value):typeof p.get=="function"&&(C="get",T=p.get),!T)throw new Error("not supported");p[C]=L(T,l)}}i.createDecorator=D;function R(L,P,l){let p=null,C=null;if(typeof l.value=="function"?(p="value",C=l.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof l.get=="function"&&(p="get",C=l.get),!C)throw new Error("not supported");const T=`$memoize$${P}`;l[p]=function(...d){return this.hasOwnProperty(T)||Object.defineProperty(this,T,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,d)}),this[T]}}i.memoize=R;function b(L,P,l){return D((p,C)=>{const T=`$debounce$${C}`,d=`$debounce$result$${C}`;return function(...y){this[d]||(this[d]=l?l():void 0),clearTimeout(this[T]),P&&(this[d]=P(this[d],...y),y=[this[d]]),this[T]=setTimeout(()=>{p.apply(this,y),this[d]=l?l():void 0},L)}})}i.debounce=b;function I(L,P,l){return D((p,C)=>{const T=`$throttle$timer$${C}`,d=`$throttle$result$${C}`,y=`$throttle$lastRun$${C}`,w=`$throttle$pending$${C}`;return function(...g){if(this[d]||(this[d]=l?l():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),P&&(this[d]=P(this[d],...g)),this[w])return;const u=this[y]+L;u<=Date.now()?(this[y]=Date.now(),p.apply(this,[this[d]]),this[d]=l?l():void 0):(this[w]=!0,this[T]=setTimeout(()=>{this[w]=!1,this[y]=Date.now(),p.apply(this,[this[d]]),this[d]=l?l():void 0},u-Date.now()))}})}i.throttle=I}),define(Y[56],Q([0,1]),function(j,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getNodeType=i.stripComments=i.visit=i.findNodeAtOffset=i.contains=i.getNodeValue=i.getNodePath=i.findNodeAtLocation=i.parseTree=i.parse=i.getLocation=i.createScanner=i.ParseOptions=i.ParseErrorCode=i.SyntaxKind=i.ScanError=void 0;var D;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(D=i.ScanError||(i.ScanError={}));var R;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(R=i.SyntaxKind||(i.SyntaxKind={}));var b;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(b=i.ParseErrorCode||(i.ParseErrorCode={}));var I;(function(e){e.DEFAULT={allowTrailingComma:!0}})(I=i.ParseOptions||(i.ParseOptions={}));function L(e,r=!1){let t=0,n=e.length,s="",a=0,c=16,h=0;function S(ie){let he=0,ue=0;for(;he<ie;){const x=e.charCodeAt(t);if(x>=48&&x<=57)ue=ue*16+x-48;else if(x>=65&&x<=70)ue=ue*16+x-65+10;else if(x>=97&&x<=102)ue=ue*16+x-97+10;else break;t++,he++}return he<ie&&(ue=-1),ue}function O(ie){t=ie,s="",a=0,c=16,h=0}function N(){const ie=t;if(e.charCodeAt(t)===48)t++;else for(t++;t<e.length&&p(e.charCodeAt(t));)t++;if(t<e.length&&e.charCodeAt(t)===46)if(t++,t<e.length&&p(e.charCodeAt(t)))for(t++;t<e.length&&p(e.charCodeAt(t));)t++;else return h=3,e.substring(ie,t);let he=t;if(t<e.length&&(e.charCodeAt(t)===69||e.charCodeAt(t)===101))if(t++,(t<e.length&&e.charCodeAt(t)===43||e.charCodeAt(t)===45)&&t++,t<e.length&&p(e.charCodeAt(t))){for(t++;t<e.length&&p(e.charCodeAt(t));)t++;he=t}else h=3;return e.substring(ie,he)}function _(){let ie="",he=t;for(;;){if(t>=n){ie+=e.substring(he,t),h=2;break}const ue=e.charCodeAt(t);if(ue===34){ie+=e.substring(he,t),t++;break}if(ue===92){if(ie+=e.substring(he,t),t++,t>=n){h=2;break}switch(e.charCodeAt(t++)){case 34:ie+='"';break;case 92:ie+="\\";break;case 47:ie+="/";break;case 98:ie+="\b";break;case 102:ie+="\f";break;case 110:ie+=`
`;break;case 114:ie+="\r";break;case 116:ie+="	";break;case 117:{const te=S(4);te>=0?ie+=String.fromCharCode(te):h=4;break}default:h=5}he=t;continue}if(ue>=0&&ue<=31)if(l(ue)){ie+=e.substring(he,t),h=2;break}else h=6;t++}return ie}function J(){if(s="",h=0,a=t,t>=n)return a=n,c=17;let ie=e.charCodeAt(t);if(P(ie)){do t++,s+=String.fromCharCode(ie),ie=e.charCodeAt(t);while(P(ie));return c=15}if(l(ie))return t++,s+=String.fromCharCode(ie),ie===13&&e.charCodeAt(t)===10&&(t++,s+=`
`),c=14;switch(ie){case 123:return t++,c=1;case 125:return t++,c=2;case 91:return t++,c=3;case 93:return t++,c=4;case 58:return t++,c=6;case 44:return t++,c=5;case 34:return t++,s=_(),c=10;case 47:{const he=t-1;if(e.charCodeAt(t+1)===47){for(t+=2;t<n&&!l(e.charCodeAt(t));)t++;return s=e.substring(he,t),c=12}if(e.charCodeAt(t+1)===42){t+=2;const ue=n-1;let x=!1;for(;t<ue;){if(e.charCodeAt(t)===42&&e.charCodeAt(t+1)===47){t+=2,x=!0;break}t++}return x||(t++,h=1),s=e.substring(he,t),c=13}return s+=String.fromCharCode(ie),t++,c=16}case 45:if(s+=String.fromCharCode(ie),t++,t===n||!p(e.charCodeAt(t)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=N(),c=11;default:for(;t<n&&re(ie);)t++,ie=e.charCodeAt(t);if(a!==t){switch(s=e.substring(a,t),s){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return s+=String.fromCharCode(ie),t++,c=16}}function re(ie){if(P(ie)||l(ie))return!1;switch(ie){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ee(){let ie;do ie=J();while(ie>=12&&ie<=15);return ie}return{setPosition:O,getPosition:()=>t,scan:r?ee:J,getToken:()=>c,getTokenValue:()=>s,getTokenOffset:()=>a,getTokenLength:()=>t-a,getTokenError:()=>h}}i.createScanner=L;function P(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function l(e){return e===10||e===13||e===8232||e===8233}function p(e){return e>=48&&e<=57}var C;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(C||(C={}));function T(e,r){const t=[],n=new Object;let s;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function h(S,O,N,_){a.value=S,a.offset=O,a.length=N,a.type=_,a.colonOffset=void 0,s=a}try{v(e,{onObjectBegin:(S,O)=>{if(r<=S)throw n;s=void 0,c=r>S,t.push("")},onObjectProperty:(S,O,N)=>{if(r<O||(h(S,O,N,"property"),t[t.length-1]=S,r<=O+N))throw n},onObjectEnd:(S,O)=>{if(r<=S)throw n;s=void 0,t.pop()},onArrayBegin:(S,O)=>{if(r<=S)throw n;s=void 0,t.push(0)},onArrayEnd:(S,O)=>{if(r<=S)throw n;s=void 0,t.pop()},onLiteralValue:(S,O,N)=>{if(r<O||(h(S,O,N,o(S)),r<=O+N))throw n},onSeparator:(S,O,N)=>{if(r<=O)throw n;if(S===":"&&s&&s.type==="property")s.colonOffset=O,c=!1,s=void 0;else if(S===","){const _=t[t.length-1];typeof _=="number"?t[t.length-1]=_+1:(c=!0,t[t.length-1]=""),s=void 0}}})}catch(S){if(S!==n)throw S}return{path:t,previousNode:s,isAtPropertyKey:c,matches:S=>{let O=0;for(let N=0;O<S.length&&N<t.length;N++)if(S[O]===t[N]||S[O]==="*")O++;else if(S[O]!=="**")return!1;return O===S.length}}}i.getLocation=T;function d(e,r=[],t=I.DEFAULT){let n=null,s=[];const a=[];function c(S){Array.isArray(s)?s.push(S):n!==null&&(s[n]=S)}return v(e,{onObjectBegin:()=>{const S={};c(S),a.push(s),s=S,n=null},onObjectProperty:S=>{n=S},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{const S=[];c(S),a.push(s),s=S,n=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:c,onError:(S,O,N)=>{r.push({error:S,offset:O,length:N})}},t),s[0]}i.parse=d;function y(e,r=[],t=I.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(S){n.type==="property"&&(n.length=S-n.offset,n=n.parent)}function a(S){return n.children.push(S),S}v(e,{onObjectBegin:S=>{n=a({type:"object",offset:S,length:-1,parent:n,children:[]})},onObjectProperty:(S,O,N)=>{n=a({type:"property",offset:O,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:S,offset:O,length:N,parent:n})},onObjectEnd:(S,O)=>{n.length=S+O-n.offset,n=n.parent,s(S+O)},onArrayBegin:(S,O)=>{n=a({type:"array",offset:S,length:-1,parent:n,children:[]})},onArrayEnd:(S,O)=>{n.length=S+O-n.offset,n=n.parent,s(S+O)},onLiteralValue:(S,O,N)=>{a({type:o(S),offset:O,length:N,parent:n,value:S}),s(O+N)},onSeparator:(S,O,N)=>{n.type==="property"&&(S===":"?n.colonOffset=O:S===","&&s(O))},onError:(S,O,N)=>{r.push({error:S,offset:O,length:N})}},t);const h=n.children[0];return h&&delete h.parent,h}i.parseTree=y;function w(e,r){if(!e)return;let t=e;for(let n of r)if(typeof n=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let s=!1;for(const a of t.children)if(Array.isArray(a.children)&&a.children[0].value===n){t=a.children[1],s=!0;break}if(!s)return}else{const s=n;if(t.type!=="array"||s<0||!Array.isArray(t.children)||s>=t.children.length)return;t=t.children[s]}return t}i.findNodeAtLocation=w;function g(e){if(!e.parent||!e.parent.children)return[];const r=g(e.parent);if(e.parent.type==="property"){const t=e.parent.children[0].value;r.push(t)}else if(e.parent.type==="array"){const t=e.parent.children.indexOf(e);t!==-1&&r.push(t)}return r}i.getNodePath=g;function u(e){switch(e.type){case"array":return e.children.map(u);case"object":{const r=Object.create(null);for(let t of e.children){const n=t.children[1];n&&(r[t.children[0].value]=u(n))}return r}case"null":case"string":case"number":case"boolean":return e.value;default:return}}i.getNodeValue=u;function f(e,r,t=!1){return r>=e.offset&&r<e.offset+e.length||t&&r===e.offset+e.length}i.contains=f;function E(e,r,t=!1){if(f(e,r,t)){const n=e.children;if(Array.isArray(n))for(let s=0;s<n.length&&n[s].offset<=r;s++){const a=E(n[s],r,t);if(a)return a}return e}}i.findNodeAtOffset=E;function v(e,r,t=I.DEFAULT){const n=L(e,!1);function s(K){return K?()=>K(n.getTokenOffset(),n.getTokenLength()):()=>!0}function a(K){return K?Z=>K(Z,n.getTokenOffset(),n.getTokenLength()):()=>!0}const c=s(r.onObjectBegin),h=a(r.onObjectProperty),S=s(r.onObjectEnd),O=s(r.onArrayBegin),N=s(r.onArrayEnd),_=a(r.onLiteralValue),J=a(r.onSeparator),re=s(r.onComment),ee=a(r.onError),ie=t&&t.disallowComments,he=t&&t.allowTrailingComma;function ue(){for(;;){const K=n.scan();switch(n.getTokenError()){case 4:x(14);break;case 5:x(15);break;case 3:x(13);break;case 1:ie||x(11);break;case 2:x(12);break;case 6:x(16);break}switch(K){case 12:case 13:ie?x(10):re();break;case 16:x(1);break;case 15:case 14:break;default:return K}}}function x(K,Z=[],q=[]){if(ee(K),Z.length+q.length>0){let M=n.getToken();for(;M!==17;){if(Z.indexOf(M)!==-1){ue();break}else if(q.indexOf(M)!==-1)break;M=ue()}}}function te(K){const Z=n.getTokenValue();return K?_(Z):h(Z),ue(),!0}function U(){switch(n.getToken()){case 11:{let K=0;try{K=JSON.parse(n.getTokenValue()),typeof K!="number"&&(x(2),K=0)}catch{x(2)}_(K);break}case 7:_(null);break;case 8:_(!0);break;case 9:_(!1);break;default:return!1}return ue(),!0}function k(){return n.getToken()!==10?(x(3,[],[2,5]),!1):(te(!1),n.getToken()===6?(J(":"),ue(),ne()||x(4,[],[2,5])):x(5,[],[2,5]),!0)}function z(){c(),ue();let K=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(K||x(4,[],[]),J(","),ue(),n.getToken()===2&&he)break}else K&&x(6,[],[]);k()||x(4,[],[2,5]),K=!0}return S(),n.getToken()!==2?x(7,[2],[]):ue(),!0}function G(){O(),ue();let K=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(K||x(4,[],[]),J(","),ue(),n.getToken()===4&&he)break}else K&&x(6,[],[]);ne()||x(4,[],[4,5]),K=!0}return N(),n.getToken()!==4?x(8,[4],[]):ue(),!0}function ne(){switch(n.getToken()){case 3:return G();case 1:return z();case 10:return te(!0);default:return U()}}return ue(),n.getToken()===17?t.allowEmptyContent?!0:(x(4,[],[]),!1):ne()?(n.getToken()!==17&&x(9,[],[]),!0):(x(4,[],[]),!1)}i.visit=v;function m(e,r){let t=L(e),n=[],s,a=0,c;do switch(c=t.getPosition(),s=t.scan(),s){case 12:case 13:case 17:a!==c&&n.push(e.substring(a,c)),r!==void 0&&n.push(t.getTokenValue().replace(/[^\r\n]/g,r)),a=t.getPosition();break}while(s!==17);return n.join("")}i.stripComments=m;function o(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}i.getNodeType=o}),function(){function j(b){const I=[];typeof b=="number"&&I.push("code/timeOrigin",b);function L(l){I.push(l,Date.now())}function P(){const l=[];for(let p=0;p<I.length;p+=2)l.push({name:I[p],startTime:I[p+1]});return l}return{mark:L,getMarks:P}}function i(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?j():{mark(b){performance.mark(b)},getMarks(){let b=performance.timeOrigin;typeof b!="number"&&(b=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const I=[{name:"code/timeOrigin",startTime:Math.round(b)}];for(const L of performance.getEntriesByType("mark"))I.push({name:L.name,startTime:Math.round(b+L.startTime)});return I}};if(typeof process=="object"){const b=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return j(b)}else return console.trace("perf-util loaded in UNKNOWN environment"),j()}function D(b){return b.MonacoPerformanceMarks||(b.MonacoPerformanceMarks=i()),b.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=D(R))}(),define(Y[57],Q([0,1]),function(j,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.sanitizeProcessEnvironment=i.TerminateResponseCode=i.Source=void 0;var D;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(D=i.Source||(i.Source={}));var R;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(R=i.TerminateResponseCode||(i.TerminateResponseCode={}));function b(I,...L){const P=L.reduce((C,T)=>(C[T]=!0,C),{}),l=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(C=>!P[C]).forEach(C=>{for(let T=0;T<l.length;T++)if(C.search(l[T])!==-1){delete I[C];break}})}i.sanitizeProcessEnvironment=b}),function(j,i){if(typeof exports=="object"&&typeof module=="object")module.exports=i();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],i);else{var D=i();for(var R in D)(typeof exports=="object"?exports:j)[R]=D[R]}}(typeof self!="undefined"?self:this,function(){return function(j){var i={};function D(R){if(i[R])return i[R].exports;var b=i[R]={i:R,l:!1,exports:{}};return j[R].call(b.exports,b,b.exports,D),b.l=!0,b.exports}return D.m=j,D.c=i,D.d=function(R,b,I){D.o(R,b)||Object.defineProperty(R,b,{enumerable:!0,get:I})},D.r=function(R){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},D.t=function(R,b){if(1&b&&(R=D(R)),8&b||4&b&&typeof R=="object"&&R&&R.__esModule)return R;var I=Object.create(null);if(D.r(I),Object.defineProperty(I,"default",{enumerable:!0,value:R}),2&b&&typeof R!="string")for(var L in R)D.d(I,L,function(P){return R[P]}.bind(null,L));return I},D.n=function(R){var b=R&&R.__esModule?function(){return R.default}:function(){return R};return D.d(b,"a",b),b},D.o=function(R,b){return Object.prototype.hasOwnProperty.call(R,b)},D.p="",D(D.s=0)}([function(j,i,D){(function(R){var b;i=j.exports=q,b=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var F=Array.prototype.slice.call(arguments,0);F.unshift("SEMVER"),console.log.apply(console,F)}:function(){},i.SEMVER_SPEC_VERSION="2.0.0";var I=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,P=i.re=[],l=i.src=[],p=0,C=p++;l[C]="0|[1-9]\\d*";var T=p++;l[T]="[0-9]+";var d=p++;l[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=p++;l[y]="("+l[C]+")\\.("+l[C]+")\\.("+l[C]+")";var w=p++;l[w]="("+l[T]+")\\.("+l[T]+")\\.("+l[T]+")";var g=p++;l[g]="(?:"+l[C]+"|"+l[d]+")";var u=p++;l[u]="(?:"+l[T]+"|"+l[d]+")";var f=p++;l[f]="(?:-("+l[g]+"(?:\\."+l[g]+")*))";var E=p++;l[E]="(?:-?("+l[u]+"(?:\\."+l[u]+")*))";var v=p++;l[v]="[0-9A-Za-z-]+";var m=p++;l[m]="(?:\\+("+l[v]+"(?:\\."+l[v]+")*))";var o=p++,e="v?"+l[y]+l[f]+"?"+l[m]+"?";l[o]="^"+e+"$";var r="[v=\\s]*"+l[w]+l[E]+"?"+l[m]+"?",t=p++;l[t]="^"+r+"$";var n=p++;l[n]="((?:<|>)?=?)";var s=p++;l[s]=l[T]+"|x|X|\\*";var a=p++;l[a]=l[C]+"|x|X|\\*";var c=p++;l[c]="[v=\\s]*("+l[a]+")(?:\\.("+l[a]+")(?:\\.("+l[a]+")(?:"+l[f]+")?"+l[m]+"?)?)?";var h=p++;l[h]="[v=\\s]*("+l[s]+")(?:\\.("+l[s]+")(?:\\.("+l[s]+")(?:"+l[E]+")?"+l[m]+"?)?)?";var S=p++;l[S]="^"+l[n]+"\\s*"+l[c]+"$";var O=p++;l[O]="^"+l[n]+"\\s*"+l[h]+"$";var N=p++;l[N]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var _=p++;l[_]="(?:~>?)";var J=p++;l[J]="(\\s*)"+l[_]+"\\s+",P[J]=new RegExp(l[J],"g");var re=p++;l[re]="^"+l[_]+l[c]+"$";var ee=p++;l[ee]="^"+l[_]+l[h]+"$";var ie=p++;l[ie]="(?:\\^)";var he=p++;l[he]="(\\s*)"+l[ie]+"\\s+",P[he]=new RegExp(l[he],"g");var ue=p++;l[ue]="^"+l[ie]+l[c]+"$";var x=p++;l[x]="^"+l[ie]+l[h]+"$";var te=p++;l[te]="^"+l[n]+"\\s*("+r+")$|^$";var U=p++;l[U]="^"+l[n]+"\\s*("+e+")$|^$";var k=p++;l[k]="(\\s*)"+l[n]+"\\s*("+r+"|"+l[c]+")",P[k]=new RegExp(l[k],"g");var z=p++;l[z]="^\\s*("+l[c]+")\\s+-\\s+("+l[c]+")\\s*$";var G=p++;l[G]="^\\s*("+l[h]+")\\s+-\\s+("+l[h]+")\\s*$";var ne=p++;l[ne]="(<|>)?=?\\s*\\*";for(var K=0;K<35;K++)b(K,l[K]),P[K]||(P[K]=new RegExp(l[K]));function Z(F,W){if(F instanceof q)return F;if(typeof F!="string"||F.length>I||!(W?P[t]:P[o]).test(F))return null;try{return new q(F,W)}catch{return null}}function q(F,W){if(F instanceof q){if(F.loose===W)return F;F=F.version}else if(typeof F!="string")throw new TypeError("Invalid Version: "+F);if(F.length>I)throw new TypeError("version is longer than "+I+" characters");if(!(this instanceof q))return new q(F,W);b("SemVer",F,W),this.loose=W;var $=F.trim().match(W?P[t]:P[o]);if(!$)throw new TypeError("Invalid Version: "+F);if(this.raw=F,this.major=+$[1],this.minor=+$[2],this.patch=+$[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");$[4]?this.prerelease=$[4].split(".").map(function(le){if(/^[0-9]+$/.test(le)){var de=+le;if(de>=0&&de<L)return de}return le}):this.prerelease=[],this.build=$[5]?$[5].split("."):[],this.format()}i.parse=Z,i.valid=function(F,W){var $=Z(F,W);return $?$.version:null},i.clean=function(F,W){var $=Z(F.trim().replace(/^[=v]+/,""),W);return $?$.version:null},i.SemVer=q,q.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},q.prototype.toString=function(){return this.version},q.prototype.compare=function(F){return b("SemVer.compare",this.version,this.loose,F),F instanceof q||(F=new q(F,this.loose)),this.compareMain(F)||this.comparePre(F)},q.prototype.compareMain=function(F){return F instanceof q||(F=new q(F,this.loose)),A(this.major,F.major)||A(this.minor,F.minor)||A(this.patch,F.patch)},q.prototype.comparePre=function(F){if(F instanceof q||(F=new q(F,this.loose)),this.prerelease.length&&!F.prerelease.length)return-1;if(!this.prerelease.length&&F.prerelease.length)return 1;if(!this.prerelease.length&&!F.prerelease.length)return 0;var W=0;do{var $=this.prerelease[W],le=F.prerelease[W];if(b("prerelease compare",W,$,le),$===void 0&&le===void 0)return 0;if(le===void 0)return 1;if($===void 0)return-1;if($!==le)return A($,le)}while(++W)},q.prototype.inc=function(F,W){switch(F){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",W);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",W);break;case"prepatch":this.prerelease.length=0,this.inc("patch",W),this.inc("pre",W);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",W),this.inc("pre",W);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var $=this.prerelease.length;--$>=0;)typeof this.prerelease[$]=="number"&&(this.prerelease[$]++,$=-2);$===-1&&this.prerelease.push(0)}W&&(this.prerelease[0]===W?isNaN(this.prerelease[1])&&(this.prerelease=[W,0]):this.prerelease=[W,0]);break;default:throw new Error("invalid increment argument: "+F)}return this.format(),this.raw=this.version,this},i.inc=function(F,W,$,le){typeof $=="string"&&(le=$,$=void 0);try{return new q(F,$).inc(W,le).version}catch{return null}},i.diff=function(F,W){if(X(F,W))return null;var $=Z(F),le=Z(W);if($.prerelease.length||le.prerelease.length){for(var de in $)if((de==="major"||de==="minor"||de==="patch")&&$[de]!==le[de])return"pre"+de;return"prerelease"}for(var de in $)if((de==="major"||de==="minor"||de==="patch")&&$[de]!==le[de])return de},i.compareIdentifiers=A;var M=/^[0-9]+$/;function A(F,W){var $=M.test(F),le=M.test(W);return $&&le&&(F=+F,W=+W),$&&!le?-1:le&&!$?1:F<W?-1:F>W?1:0}function V(F,W,$){return new q(F,$).compare(new q(W,$))}function B(F,W,$){return V(F,W,$)>0}function H(F,W,$){return V(F,W,$)<0}function X(F,W,$){return V(F,W,$)===0}function ae(F,W,$){return V(F,W,$)!==0}function ce(F,W,$){return V(F,W,$)>=0}function Ee(F,W,$){return V(F,W,$)<=0}function fe(F,W,$,le){var de;switch(W){case"===":typeof F=="object"&&(F=F.version),typeof $=="object"&&($=$.version),de=F===$;break;case"!==":typeof F=="object"&&(F=F.version),typeof $=="object"&&($=$.version),de=F!==$;break;case"":case"=":case"==":de=X(F,$,le);break;case"!=":de=ae(F,$,le);break;case">":de=B(F,$,le);break;case">=":de=ce(F,$,le);break;case"<":de=H(F,$,le);break;case"<=":de=Ee(F,$,le);break;default:throw new TypeError("Invalid operator: "+W)}return de}function se(F,W){if(F instanceof se){if(F.loose===W)return F;F=F.value}if(!(this instanceof se))return new se(F,W);b("comparator",F,W),this.loose=W,this.parse(F),this.semver===me?this.value="":this.value=this.operator+this.semver.version,b("comp",this)}i.rcompareIdentifiers=function(F,W){return A(W,F)},i.major=function(F,W){return new q(F,W).major},i.minor=function(F,W){return new q(F,W).minor},i.patch=function(F,W){return new q(F,W).patch},i.compare=V,i.compareLoose=function(F,W){return V(F,W,!0)},i.rcompare=function(F,W,$){return V(W,F,$)},i.sort=function(F,W){return F.sort(function($,le){return i.compare($,le,W)})},i.rsort=function(F,W){return F.sort(function($,le){return i.rcompare($,le,W)})},i.gt=B,i.lt=H,i.eq=X,i.neq=ae,i.gte=ce,i.lte=Ee,i.cmp=fe,i.Comparator=se;var me={};function pe(F,W){if(F instanceof pe)return F.loose===W?F:new pe(F.raw,W);if(F instanceof se)return new pe(F.value,W);if(!(this instanceof pe))return new pe(F,W);if(this.loose=W,this.raw=F,this.set=F.split(/\s*\|\|\s*/).map(function($){return this.parseRange($.trim())},this).filter(function($){return $.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+F);this.format()}function we(F){return!F||F.toLowerCase()==="x"||F==="*"}function Ie(F,W,$,le,de,Ce,Se,ke,Re,Oe,Ne,De,Le){return((W=we($)?"":we(le)?">="+$+".0.0":we(de)?">="+$+"."+le+".0":">="+W)+" "+(ke=we(Re)?"":we(Oe)?"<"+(+Re+1)+".0.0":we(Ne)?"<"+Re+"."+(+Oe+1)+".0":De?"<="+Re+"."+Oe+"."+Ne+"-"+De:"<="+ke)).trim()}function Me(F,W){for(var $=0;$<F.length;$++)if(!F[$].test(W))return!1;if(W.prerelease.length){for($=0;$<F.length;$++)if(b(F[$].semver),F[$].semver!==me&&F[$].semver.prerelease.length>0){var le=F[$].semver;if(le.major===W.major&&le.minor===W.minor&&le.patch===W.patch)return!0}return!1}return!0}function xe(F,W,$){try{W=new pe(W,$)}catch{return!1}return W.test(F)}function Ve(F,W,$,le){var de,Ce,Se,ke,Re;switch(F=new q(F,le),W=new pe(W,le),$){case">":de=B,Ce=Ee,Se=H,ke=">",Re=">=";break;case"<":de=H,Ce=ce,Se=B,ke="<",Re="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(xe(F,W,le))return!1;for(var Oe=0;Oe<W.set.length;++Oe){var Ne=W.set[Oe],De=null,Le=null;if(Ne.forEach(function(Ae){Ae.semver===me&&(Ae=new se(">=0.0.0")),De=De||Ae,Le=Le||Ae,de(Ae.semver,De.semver,le)?De=Ae:Se(Ae.semver,Le.semver,le)&&(Le=Ae)}),De.operator===ke||De.operator===Re||(!Le.operator||Le.operator===ke)&&Ce(F,Le.semver)||Le.operator===Re&&Se(F,Le.semver))return!1}return!0}se.prototype.parse=function(F){var W=this.loose?P[te]:P[U],$=F.match(W);if(!$)throw new TypeError("Invalid comparator: "+F);this.operator=$[1],this.operator==="="&&(this.operator=""),$[2]?this.semver=new q($[2],this.loose):this.semver=me},se.prototype.toString=function(){return this.value},se.prototype.test=function(F){return b("Comparator.test",F,this.loose),this.semver===me||(typeof F=="string"&&(F=new q(F,this.loose)),fe(F,this.operator,this.semver,this.loose))},se.prototype.intersects=function(F,W){if(!(F instanceof se))throw new TypeError("a Comparator is required");var $;if(this.operator==="")return $=new pe(F.value,W),xe(this.value,$,W);if(F.operator==="")return $=new pe(this.value,W),xe(F.semver,$,W);var le=!(this.operator!==">="&&this.operator!==">"||F.operator!==">="&&F.operator!==">"),de=!(this.operator!=="<="&&this.operator!=="<"||F.operator!=="<="&&F.operator!=="<"),Ce=this.semver.version===F.semver.version,Se=!(this.operator!==">="&&this.operator!=="<="||F.operator!==">="&&F.operator!=="<="),ke=fe(this.semver,"<",F.semver,W)&&(this.operator===">="||this.operator===">")&&(F.operator==="<="||F.operator==="<"),Re=fe(this.semver,">",F.semver,W)&&(this.operator==="<="||this.operator==="<")&&(F.operator===">="||F.operator===">");return le||de||Ce&&Se||ke||Re},i.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(F){return F.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(F){var W=this.loose;F=F.trim(),b("range",F,W);var $=W?P[G]:P[z];F=F.replace($,Ie),b("hyphen replace",F),F=F.replace(P[k],"$1$2$3"),b("comparator trim",F,P[k]),F=(F=(F=F.replace(P[J],"$1~")).replace(P[he],"$1^")).split(/\s+/).join(" ");var le=W?P[te]:P[U],de=F.split(" ").map(function(Ce){return function(Se,ke){return b("comp",Se),Se=function(Re,Oe){return Re.trim().split(/\s+/).map(function(Ne){return function(De,Le){b("caret",De,Le);var Ae=Le?P[x]:P[ue];return De.replace(Ae,function(Fe,ve,ye,be,Pe){var Te;return b("caret",De,Fe,ve,ye,be,Pe),we(ve)?Te="":we(ye)?Te=">="+ve+".0.0 <"+(+ve+1)+".0.0":we(be)?Te=ve==="0"?">="+ve+"."+ye+".0 <"+ve+"."+(+ye+1)+".0":">="+ve+"."+ye+".0 <"+(+ve+1)+".0.0":Pe?(b("replaceCaret pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Te=ve==="0"?ye==="0"?">="+ve+"."+ye+"."+be+Pe+" <"+ve+"."+ye+"."+(+be+1):">="+ve+"."+ye+"."+be+Pe+" <"+ve+"."+(+ye+1)+".0":">="+ve+"."+ye+"."+be+Pe+" <"+(+ve+1)+".0.0"):(b("no pr"),Te=ve==="0"?ye==="0"?">="+ve+"."+ye+"."+be+" <"+ve+"."+ye+"."+(+be+1):">="+ve+"."+ye+"."+be+" <"+ve+"."+(+ye+1)+".0":">="+ve+"."+ye+"."+be+" <"+(+ve+1)+".0.0"),b("caret return",Te),Te})}(Ne,Oe)}).join(" ")}(Se,ke),b("caret",Se),Se=function(Re,Oe){return Re.trim().split(/\s+/).map(function(Ne){return function(De,Le){var Ae=Le?P[ee]:P[re];return De.replace(Ae,function(Fe,ve,ye,be,Pe){var Te;return b("tilde",De,Fe,ve,ye,be,Pe),we(ve)?Te="":we(ye)?Te=">="+ve+".0.0 <"+(+ve+1)+".0.0":we(be)?Te=">="+ve+"."+ye+".0 <"+ve+"."+(+ye+1)+".0":Pe?(b("replaceTilde pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Te=">="+ve+"."+ye+"."+be+Pe+" <"+ve+"."+(+ye+1)+".0"):Te=">="+ve+"."+ye+"."+be+" <"+ve+"."+(+ye+1)+".0",b("tilde return",Te),Te})}(Ne,Oe)}).join(" ")}(Se,ke),b("tildes",Se),Se=function(Re,Oe){return b("replaceXRanges",Re,Oe),Re.split(/\s+/).map(function(Ne){return function(De,Le){De=De.trim();var Ae=Le?P[O]:P[S];return De.replace(Ae,function(Fe,ve,ye,be,Pe,Te){b("xRange",De,Fe,ve,ye,be,Pe,Te);var je=we(ye),Ue=je||we(be),ze=Ue||we(Pe);return ve==="="&&ze&&(ve=""),je?Fe=ve===">"||ve==="<"?"<0.0.0":"*":ve&&ze?(Ue&&(be=0),ze&&(Pe=0),ve===">"?(ve=">=",Ue?(ye=+ye+1,be=0,Pe=0):ze&&(be=+be+1,Pe=0)):ve==="<="&&(ve="<",Ue?ye=+ye+1:be=+be+1),Fe=ve+ye+"."+be+"."+Pe):Ue?Fe=">="+ye+".0.0 <"+(+ye+1)+".0.0":ze&&(Fe=">="+ye+"."+be+".0 <"+ye+"."+(+be+1)+".0"),b("xRange return",Fe),Fe})}(Ne,Oe)}).join(" ")}(Se,ke),b("xrange",Se),Se=function(Re,Oe){return b("replaceStars",Re,Oe),Re.trim().replace(P[ne],"")}(Se,ke),b("stars",Se),Se}(Ce,W)}).join(" ").split(/\s+/);return this.loose&&(de=de.filter(function(Ce){return!!Ce.match(le)})),de=de.map(function(Ce){return new se(Ce,W)})},pe.prototype.intersects=function(F,W){if(!(F instanceof pe))throw new TypeError("a Range is required");return this.set.some(function($){return $.every(function(le){return F.set.some(function(de){return de.every(function(Ce){return le.intersects(Ce,W)})})})})},i.toComparators=function(F,W){return new pe(F,W).set.map(function($){return $.map(function(le){return le.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(F){if(!F)return!1;typeof F=="string"&&(F=new q(F,this.loose));for(var W=0;W<this.set.length;W++)if(Me(this.set[W],F))return!0;return!1},i.satisfies=xe,i.maxSatisfying=function(F,W,$){var le=null,de=null;try{var Ce=new pe(W,$)}catch{return null}return F.forEach(function(Se){Ce.test(Se)&&(le&&de.compare(Se)!==-1||(de=new q(le=Se,$)))}),le},i.minSatisfying=function(F,W,$){var le=null,de=null;try{var Ce=new pe(W,$)}catch{return null}return F.forEach(function(Se){Ce.test(Se)&&(le&&de.compare(Se)!==1||(de=new q(le=Se,$)))}),le},i.validRange=function(F,W){try{return new pe(F,W).range||"*"}catch{return null}},i.ltr=function(F,W,$){return Ve(F,W,"<",$)},i.gtr=function(F,W,$){return Ve(F,W,">",$)},i.outside=Ve,i.prerelease=function(F,W){var $=Z(F,W);return $&&$.prerelease.length?$.prerelease:null},i.intersects=function(F,W,$){return F=new pe(F,$),W=new pe(W,$),F.intersects(W)},i.coerce=function(F){if(F instanceof q)return F;if(typeof F!="string")return null;var W=F.match(P[N]);return W==null?null:Z((W[1]||"0")+"."+(W[2]||"0")+"."+(W[3]||"0"))}}).call(this,D(1))},function(j,i){var D,R,b=j.exports={};function I(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function P(u){if(D===setTimeout)return setTimeout(u,0);if((D===I||!D)&&setTimeout)return D=setTimeout,setTimeout(u,0);try{return D(u,0)}catch{try{return D.call(null,u,0)}catch{return D.call(this,u,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:I}catch{D=I}try{R=typeof clearTimeout=="function"?clearTimeout:L}catch{R=L}})();var l,p=[],C=!1,T=-1;function d(){C&&l&&(C=!1,l.length?p=l.concat(p):T=-1,p.length&&y())}function y(){if(!C){var u=P(d);C=!0;for(var f=p.length;f;){for(l=p,p=[];++T<f;)l&&l[T].run();T=-1,f=p.length}l=null,C=!1,function(E){if(R===clearTimeout)return clearTimeout(E);if((R===L||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(E);try{R(E)}catch{try{return R.call(null,E)}catch{return R.call(this,E)}}}(u)}}function w(u,f){this.fun=u,this.array=f}function g(){}b.nextTick=function(u){var f=new Array(arguments.length-1);if(arguments.length>1)for(var E=1;E<arguments.length;E++)f[E-1]=arguments[E];p.push(new w(u,f)),p.length!==1||C||P(y)},w.prototype.run=function(){this.fun.apply(null,this.array)},b.title="browser",b.browser=!0,b.env={},b.argv=[],b.version="",b.versions={},b.on=g,b.addListener=g,b.once=g,b.off=g,b.removeListener=g,b.removeAllListeners=g,b.emit=g,b.prependListener=g,b.prependOnceListener=g,b.listeners=function(u){return[]},b.binding=function(u){throw new Error("process.binding is not supported")},b.cwd=function(){return"/"},b.chdir=function(u){throw new Error("process.chdir is not supported")},b.umask=function(){return 0}}])}),define(Y[58],Q([0,1]),function(j,i){"use strict";var D;Object.defineProperty(i,"__esModule",{value:!0}),i.SkipList=void 0;class R{constructor(P,l,p){this.level=P,this.key=l,this.value=p,this.forward=[]}}const b=void 0;class I{constructor(P,l=2**16){this.comparator=P,this[D]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(l)|0),this._header=new R(this._maxLevel,b,b)}get size(){return this._size}clear(){this._header=new R(this._maxLevel,b,b)}has(P){return Boolean(I._search(this,P,this.comparator))}get(P){return I._search(this,P,this.comparator)?.value}set(P,l){return I._insert(this,P,l,this.comparator)&&(this._size+=1),this}delete(P){const l=I._delete(this,P,this.comparator);return l&&(this._size-=1),l}forEach(P,l){let p=this._header.forward[0];for(;p;)P.call(l,p.value,p.key,this),p=p.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this._header.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this._header.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this._header.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",l=this._header.forward[0];for(;l;)P+=`node(${l.key}, ${l.value}, lvl:${l.level})`,l=l.forward[0];return P}static _search(P,l,p){let C=P._header;for(let T=P._level-1;T>=0;T--)for(;C.forward[T]&&p(C.forward[T].key,l)<0;)C=C.forward[T];if(C=C.forward[0],C&&p(C.key,l)===0)return C}static _insert(P,l,p,C){let T=[],d=P._header;for(let y=P._level-1;y>=0;y--){for(;d.forward[y]&&C(d.forward[y].key,l)<0;)d=d.forward[y];T[y]=d}if(d=d.forward[0],d&&C(d.key,l)===0)return d.value=p,!1;{let y=I._randomLevel(P);if(y>P._level){for(let w=P._level;w<y;w++)T[w]=P._header;P._level=y}d=new R(y,l,p);for(let w=0;w<y;w++)d.forward[w]=T[w].forward[w],T[w].forward[w]=d;return!0}}static _randomLevel(P,l=.5){let p=1;for(;Math.random()<l&&p<P._maxLevel;)p+=1;return p}static _delete(P,l,p){let C=[],T=P._header;for(let d=P._level-1;d>=0;d--){for(;T.forward[d]&&p(T.forward[d].key,l)<0;)T=T.forward[d];C[d]=T}if(T=T.forward[0],!T||p(T.key,l)!==0)return!1;for(let d=0;d<P._level&&C[d].forward[d]===T;d++)C[d].forward[d]=T.forward[d];for(;P._level>0&&P._header.forward[P._level-1]===b;)P._level-=1;return!0}}i.SkipList=I}),define(Y[38],Q([0,1,8,2]),function(j,i,D,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.prefixedStream=i.prefixedReadable=i.transform=i.toReadable=i.emptyStream=i.toStream=i.peekStream=i.listenStream=i.consumeStream=i.peekReadable=i.consumeReadable=i.newWriteableStream=i.isReadableBufferedStream=i.isReadableStream=void 0;function b(v){const m=v;return m?[m.on,m.pause,m.resume,m.destroy].every(o=>typeof o=="function"):!1}i.isReadableStream=b;function I(v){const m=v;return m?b(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean":!1}i.isReadableBufferedStream=I;function L(v,m){return new P(v,m)}i.newWriteableStream=L;class P{constructor(m,o){this.reducer=m,this.options=o,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(m){if(!this.state.destroyed){if(this.state.flowing)this.emitData(m);else if(this.buffer.data.push(m),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(o=>this.pendingWritePromises.push(o))}}error(m){this.state.destroyed||(this.state.flowing?this.emitError(m):this.buffer.error.push(m))}end(m){this.state.destroyed||(typeof m!="undefined"&&this.write(m),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(m){this.listeners.data.slice(0).forEach(o=>o(m))}emitError(m){this.listeners.error.length===0?(0,D.onUnexpectedError)(m):this.listeners.error.slice(0).forEach(o=>o(m))}emitEnd(){this.listeners.end.slice(0).forEach(m=>m())}on(m,o){if(!this.state.destroyed)switch(m){case"data":this.listeners.data.push(o),this.resume();break;case"end":this.listeners.end.push(o),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(o),this.state.flowing&&this.flowErrors();break}}removeListener(m,o){if(this.state.destroyed)return;let e;switch(m){case"data":e=this.listeners.data;break;case"end":e=this.listeners.end;break;case"error":e=this.listeners.error;break}if(e){const r=e.indexOf(o);r>=0&&e.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const m=this.reducer(this.buffer.data);this.emitData(m),this.buffer.data.length=0;const o=[...this.pendingWritePromises];this.pendingWritePromises.length=0,o.forEach(e=>e())}}flowErrors(){if(this.listeners.error.length>0){for(const m of this.buffer.error)this.emitError(m);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function l(v,m){const o=[];let e;for(;(e=v.read())!==null;)o.push(e);return m(o)}i.consumeReadable=l;function p(v,m,o){const e=[];let r;for(;(r=v.read())!==null&&e.length<o;)e.push(r);return r===null&&e.length>0?m(e):{read:()=>{if(e.length>0)return e.shift();if(typeof r!="undefined"){const t=r;return r=void 0,t}return v.read()}}}i.peekReadable=p;function C(v,m){return new Promise((o,e)=>{const r=[];T(v,{onData:t=>{m&&r.push(t)},onError:t=>{m?e(t):o(void 0)},onEnd:()=>{o(m?m(r):void 0)}})})}i.consumeStream=C;function T(v,m){let o=!1;return v.on("error",e=>{o||m.onError(e)}),v.on("end",()=>{o||m.onEnd()}),v.on("data",e=>{o||m.onData(e)}),(0,R.toDisposable)(()=>o=!0)}i.listenStream=T;function d(v,m){return new Promise((o,e)=>{const r=new R.DisposableStore,t=[],n=c=>{if(t.push(c),t.length>m)return r.dispose(),v.pause(),o({stream:v,buffer:t,ended:!1})},s=c=>e(c),a=()=>o({stream:v,buffer:t,ended:!0});r.add((0,R.toDisposable)(()=>v.removeListener("error",s))),v.on("error",s),r.add((0,R.toDisposable)(()=>v.removeListener("end",a))),v.on("end",a),r.add((0,R.toDisposable)(()=>v.removeListener("data",n))),v.on("data",n)})}i.peekStream=d;function y(v,m){const o=L(m);return o.end(v),o}i.toStream=y;function w(){const v=L(()=>{throw new Error("not supported")});return v.end(),v}i.emptyStream=w;function g(v){let m=!1;return{read:()=>m?null:(m=!0,v)}}i.toReadable=g;function u(v,m,o){const e=L(o);return T(v,{onData:r=>e.write(m.data(r)),onError:r=>e.error(m.error?m.error(r):r),onEnd:()=>e.end()}),e}i.transform=u;function f(v,m,o){let e=!1;return{read:()=>{const r=m.read();return e?r:(e=!0,r!==null?o([v,r]):v)}}}i.prefixedReadable=f;function E(v,m,o){let e=!1;const r=L(o);return T(m,{onData:t=>e?r.write(t):(e=!0,r.write(o([v,t]))),onError:t=>r.error(t),onEnd:()=>{e||(e=!0,r.write(v)),r.end()}}),r}i.prefixedStream=E}),define(Y[17],Q([0,1,38]),function(j,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.encodeBase64=i.decodeBase64=i.prefixedBufferStream=i.prefixedBufferReadable=i.newWriteableBufferStream=i.streamToBufferReadableStream=i.bufferToStream=i.bufferedStreamToBuffer=i.streamToBuffer=i.bufferToReadable=i.readableToBuffer=i.writeUInt8=i.readUInt8=i.writeUInt32LE=i.readUInt32LE=i.writeUInt32BE=i.readUInt32BE=i.writeUInt16LE=i.readUInt16LE=i.VSBuffer=void 0;const R=typeof Buffer!="undefined";let b,I;class L{constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}static alloc(h){return R?new L(Buffer.allocUnsafe(h)):new L(new Uint8Array(h))}static wrap(h){return R&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new L(h)}static fromString(h,S){return!(S?.dontUseNodeBuffer||!1)&&R?new L(Buffer.from(h)):(b||(b=new TextEncoder),new L(b.encode(h)))}static fromByteArray(h){const S=L.alloc(h.length);for(let O=0,N=h.length;O<N;O++)S.buffer[O]=h[O];return S}static concat(h,S){if(typeof S=="undefined"){S=0;for(let _=0,J=h.length;_<J;_++)S+=h[_].byteLength}const O=L.alloc(S);let N=0;for(let _=0,J=h.length;_<J;_++){const re=h[_];O.set(re,N),N+=re.byteLength}return O}clone(){const h=L.alloc(this.byteLength);return h.set(this),h}toString(){return R?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(h,S){return new L(this.buffer.subarray(h,S))}set(h,S){if(h instanceof L)this.buffer.set(h.buffer,S);else if(h instanceof Uint8Array)this.buffer.set(h,S);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),S);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),S);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return p(this.buffer,h)}writeUInt32BE(h,S){C(this.buffer,h,S)}readUInt32LE(h){return T(this.buffer,h)}writeUInt32LE(h,S){d(this.buffer,h,S)}readUInt8(h){return y(this.buffer,h)}writeUInt8(h,S){w(this.buffer,h,S)}}i.VSBuffer=L;function P(c,h){return c[h+0]<<0>>>0|c[h+1]<<8>>>0}i.readUInt16LE=P;function l(c,h,S){c[S+0]=h&255,h=h>>>8,c[S+1]=h&255}i.writeUInt16LE=l;function p(c,h){return c[h]*2**24+c[h+1]*2**16+c[h+2]*2**8+c[h+3]}i.readUInt32BE=p;function C(c,h,S){c[S+3]=h,h=h>>>8,c[S+2]=h,h=h>>>8,c[S+1]=h,h=h>>>8,c[S]=h}i.writeUInt32BE=C;function T(c,h){return c[h+0]<<0>>>0|c[h+1]<<8>>>0|c[h+2]<<16>>>0|c[h+3]<<24>>>0}i.readUInt32LE=T;function d(c,h,S){c[S+0]=h&255,h=h>>>8,c[S+1]=h&255,h=h>>>8,c[S+2]=h&255,h=h>>>8,c[S+3]=h&255}i.writeUInt32LE=d;function y(c,h){return c[h]}i.readUInt8=y;function w(c,h,S){c[S]=h}i.writeUInt8=w;function g(c){return D.consumeReadable(c,h=>L.concat(h))}i.readableToBuffer=g;function u(c){return D.toReadable(c)}i.bufferToReadable=u;function f(c){return D.consumeStream(c,h=>L.concat(h))}i.streamToBuffer=f;async function E(c){return c.ended?L.concat(c.buffer):L.concat([...c.buffer,await f(c.stream)])}i.bufferedStreamToBuffer=E;function v(c){return D.toStream(c,h=>L.concat(h))}i.bufferToStream=v;function m(c){return D.transform(c,{data:h=>typeof h=="string"?L.fromString(h):L.wrap(h)},h=>L.concat(h))}i.streamToBufferReadableStream=m;function o(c){return D.newWriteableStream(h=>L.concat(h),c)}i.newWriteableBufferStream=o;function e(c,h){return D.prefixedReadable(c,h,S=>L.concat(S))}i.prefixedBufferReadable=e;function r(c,h){return D.prefixedStream(c,h,S=>L.concat(S))}i.prefixedBufferStream=r;function t(c){let h=0,S=0,O=0;const N=new Uint8Array(Math.floor(c.length/4*3)),_=re=>{switch(S){case 3:N[O++]=h|re,S=0;break;case 2:N[O++]=h|re>>>2,h=re<<6,S=3;break;case 1:N[O++]=h|re>>>4,h=re<<4,S=2;break;default:h=re<<2,S=1}};for(let re=0;re<c.length;re++){const ee=c.charCodeAt(re);if(ee>=65&&ee<=90)_(ee-65);else if(ee>=97&&ee<=122)_(ee-97+26);else if(ee>=48&&ee<=57)_(ee-48+52);else if(ee===43||ee===45)_(62);else if(ee===47||ee===95)_(63);else{if(ee===61)break;throw new SyntaxError(`Unexpected base64 character ${c[re]}`)}}const J=O;for(;S>0;)_(0);return L.wrap(N).slice(0,J)}i.decodeBase64=t;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:c},h=!0,S=!1){const O=S?s:n;let N="";const _=c.byteLength%3;let J=0;for(;J<c.byteLength-_;J+=3){const re=c[J+0],ee=c[J+1],ie=c[J+2];N+=O[re>>>2],N+=O[(re<<4|ee>>>4)&63],N+=O[(ee<<2|ie>>>6)&63],N+=O[ie&63]}if(_===1){const re=c[J+0];N+=O[re>>>2],N+=O[re<<4&63],h&&(N+="==")}else if(_===2){const re=c[J+0],ee=c[J+1];N+=O[re>>>2],N+=O[(re<<4|ee>>>4)&63],N+=O[ee<<2&63],h&&(N+="=")}return N}i.encodeBase64=a}),define(Y[59],Q([0,1,26]),function(j,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.StringSHA1=i.toHexString=i.Hasher=i.stringHash=i.numberHash=i.doHash=i.hash=void 0;function R(f){return b(f,0)}i.hash=R;function b(f,E){switch(typeof f){case"object":return f===null?I(349,E):Array.isArray(f)?l(f,E):p(f,E);case"string":return P(f,E);case"boolean":return L(f,E);case"number":return I(f,E);case"undefined":return I(937,E);default:return I(617,E)}}i.doHash=b;function I(f,E){return(E<<5)-E+f|0}i.numberHash=I;function L(f,E){return I(f?433:863,E)}function P(f,E){E=I(149417,E);for(let v=0,m=f.length;v<m;v++)E=I(f.charCodeAt(v),E);return E}i.stringHash=P;function l(f,E){return E=I(104579,E),f.reduce((v,m)=>b(m,v),E)}function p(f,E){return E=I(181387,E),Object.keys(f).sort().reduce((v,m)=>(v=P(m,v),b(f[m],v)),E)}class C{constructor(){this._value=0}get value(){return this._value}hash(E){return this._value=b(E,this._value),this._value}}i.Hasher=C;var T;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(T||(T={}));function d(f,E,v=32){const m=v-E,o=~((1<<m)-1);return(f<<E|(o&f)>>>m)>>>0}function y(f,E=0,v=f.byteLength,m=0){for(let o=0;o<v;o++)f[E+o]=m}function w(f,E,v="0"){for(;f.length<E;)f=v+f;return f}function g(f,E=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(v=>v.toString(16).padStart(2,"0")).join(""):w((f>>>0).toString(16),E/4)}i.toHexString=g;class u{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(E){const v=E.length;if(v===0)return;const m=this._buff;let o=this._buffLen,e=this._leftoverHighSurrogate,r,t;for(e!==0?(r=e,t=-1,e=0):(r=E.charCodeAt(0),t=0);;){let n=r;if(D.isHighSurrogate(r))if(t+1<v){const s=E.charCodeAt(t+1);D.isLowSurrogate(s)?(t++,n=D.computeCodePoint(r,s)):n=65533}else{e=r;break}else D.isLowSurrogate(r)&&(n=65533);if(o=this._push(m,o,n),t++,t<v)r=E.charCodeAt(t);else break}this._buffLen=o,this._leftoverHighSurrogate=e}_push(E,v,m){return m<128?E[v++]=m:m<2048?(E[v++]=192|(m&1984)>>>6,E[v++]=128|(m&63)>>>0):m<65536?(E[v++]=224|(m&61440)>>>12,E[v++]=128|(m&4032)>>>6,E[v++]=128|(m&63)>>>0):(E[v++]=240|(m&1835008)>>>18,E[v++]=128|(m&258048)>>>12,E[v++]=128|(m&4032)>>>6,E[v++]=128|(m&63)>>>0),v>=64&&(this._step(),v-=64,this._totalLen+=64,E[0]=E[64+0],E[1]=E[64+1],E[2]=E[64+2]),v}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,y(this._buff,this._buffLen),this._buffLen>56&&(this._step(),y(this._buff));const E=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(E/4294967296),!1),this._buffDV.setUint32(60,E%4294967296,!1),this._step()}_step(){const E=u._bigBlock32,v=this._buffDV;for(let c=0;c<64;c+=4)E.setUint32(c,v.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)E.setUint32(c,d(E.getUint32(c-12,!1)^E.getUint32(c-32,!1)^E.getUint32(c-56,!1)^E.getUint32(c-64,!1),1),!1);let m=this._h0,o=this._h1,e=this._h2,r=this._h3,t=this._h4,n,s,a;for(let c=0;c<80;c++)c<20?(n=o&e|~o&r,s=1518500249):c<40?(n=o^e^r,s=1859775393):c<60?(n=o&e|o&r|e&r,s=2400959708):(n=o^e^r,s=3395469782),a=d(m,5)+n+t+s+E.getUint32(c*4,!1)&4294967295,t=r,r=e,e=d(o,30),o=m,m=a;this._h0=this._h0+m&4294967295,this._h1=this._h1+o&4294967295,this._h2=this._h2+e&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+t&4294967295}}i.StringSHA1=u,u._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Y[22],Q([0,1,6]),function(j,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.filter=i.getCaseInsensitive=i.distinct=i.getOrDefault=i.safeStringify=i.equals=i.mixin=i.cloneAndChange=i.deepFreeze=i.deepClone=void 0;function R(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const u=Array.isArray(g)?[]:{};return Object.keys(g).forEach(f=>{g[f]&&typeof g[f]=="object"?u[f]=R(g[f]):u[f]=g[f]}),u}i.deepClone=R;function b(g){if(!g||typeof g!="object")return g;const u=[g];for(;u.length>0;){const f=u.shift();Object.freeze(f);for(const E in f)if(I.call(f,E)){const v=f[E];typeof v=="object"&&!Object.isFrozen(v)&&u.push(v)}}return g}i.deepFreeze=b;const I=Object.prototype.hasOwnProperty;function L(g,u){return P(g,u,new Set)}i.cloneAndChange=L;function P(g,u,f){if((0,D.isUndefinedOrNull)(g))return g;const E=u(g);if(typeof E!="undefined")return E;if((0,D.isArray)(g)){const v=[];for(const m of g)v.push(P(m,u,f));return v}if((0,D.isObject)(g)){if(f.has(g))throw new Error("Cannot clone recursive data-structure");f.add(g);const v={};for(let m in g)I.call(g,m)&&(v[m]=P(g[m],u,f));return f.delete(g),v}return g}function l(g,u,f=!0){return(0,D.isObject)(g)?((0,D.isObject)(u)&&Object.keys(u).forEach(E=>{E in g?f&&((0,D.isObject)(g[E])&&(0,D.isObject)(u[E])?l(g[E],u[E],f):g[E]=u[E]):g[E]=u[E]}),g):u}i.mixin=l;function p(g,u){if(g===u)return!0;if(g==null||u===null||u===void 0||typeof g!=typeof u||typeof g!="object"||Array.isArray(g)!==Array.isArray(u))return!1;let f,E;if(Array.isArray(g)){if(g.length!==u.length)return!1;for(f=0;f<g.length;f++)if(!p(g[f],u[f]))return!1}else{const v=[];for(E in g)v.push(E);v.sort();const m=[];for(E in u)m.push(E);if(m.sort(),!p(v,m))return!1;for(f=0;f<v.length;f++)if(!p(g[v[f]],u[v[f]]))return!1}return!0}i.equals=p;function C(g){const u=new Set;return JSON.stringify(g,(f,E)=>{if((0,D.isObject)(E)||Array.isArray(E)){if(u.has(E))return"[Circular]";u.add(E)}return E})}i.safeStringify=C;function T(g,u,f){const E=u(g);return typeof E=="undefined"?f:E}i.getOrDefault=T;function d(g,u){const f=Object.create(null);return!g||!u||Object.keys(u).forEach(v=>{const m=g[v],o=u[v];p(m,o)||(f[v]=o)}),f}i.distinct=d;function y(g,u){const f=u.toLowerCase(),E=Object.keys(g).find(v=>v.toLowerCase()===f);return E?g[E]:g[u]}i.getCaseInsensitive=y;function w(g,u){const f=Object.create(null);for(const[E,v]of Object.entries(g))u(E,v)&&(f[E]=v);return f}i.filter=w}),define(Y[60],Q([0,1,9]),function(j,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.log=i.getFirstFrame=i.parse=i.isRemoteConsoleLog=void 0;function R(p){const C=p;return C&&typeof C.type=="string"&&typeof C.severity=="string"}i.isRemoteConsoleLog=R;function b(p){const C=[];let T;try{const d=JSON.parse(p.arguments),y=d[d.length-1];y&&y.__$stack&&(d.pop(),T=y.__$stack),C.push(...d)}catch{C.push("Unable to log remote console arguments",p.arguments)}return{args:C,stack:T}}i.parse=b;function I(p){if(typeof p!="string")return I(b(p).stack);const C=p;if(C){const T=L(C),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(T||"");if(d&&d.length===4)return{uri:D.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}i.getFirstFrame=I;function L(p){if(!p)return p;const C=p.indexOf(`
`);return C===-1?p:p.substring(0,C)}function P(p,C){const{args:T,stack:d}=b(p),y=typeof T[0]=="string"&&T.length===1;let w=L(d);w&&(w=`(${w.trim()})`);let g=[];if(typeof T[0]=="string"?w&&y?g=[`%c[${C}] %c${T[0]} %c${w}`,l("blue"),l(""),l("grey")]:g=[`%c[${C}] %c${T[0]}`,l("blue"),l(""),...T.slice(1)]:g=[`%c[${C}]%`,l("blue"),...T],w&&!y&&g.push(w),typeof console[p.severity]!="function")throw new Error("Unknown console method");console[p.severity].apply(console,g)}i.log=P;function l(p){return`color: ${p}`}}),define(Y[61],Q([0,1,17,26,9]),function(j,i,D,R,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.revive=i.parse=i.stringify=void 0;function I(p){return JSON.stringify(p,P)}i.stringify=I;function L(p){let C=JSON.parse(p);return C=l(C),C}i.parse=L;function P(p,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,R.regExpFlags)(C)}:C}function l(p,C=0){if(!p||C>200)return p;if(typeof p=="object"){switch(p.$mid){case 1:return b.URI.revive(p);case 2:return new RegExp(p.source,p.flags);case 14:return new Date(p.source)}if(p instanceof D.VSBuffer||p instanceof Uint8Array)return p;if(Array.isArray(p))for(let T=0;T<p.length;++T)p[T]=l(p[T],C+1);else for(const T in p)Object.hasOwnProperty.call(p,T)&&(p[T]=l(p[T],C+1))}return p}i.revive=l}),define(Y[62],Q([0,1,45,10,11,12,19,26,9]),function(j,i,D,R,b,I,L,P,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.splitName=i.unmnemonicLabel=i.mnemonicButtonLabel=i.mnemonicMenuLabel=i.template=i.shorten=i.untildify=i.tildify=i.normalizeDriveLetter=i.getBaseLabel=i.getPathLabel=void 0;function p(n,s,a){if(typeof n=="string"&&(n=l.URI.file(n)),a){const h=a.getWorkspaceFolder(n);if(h){const S=a.getWorkspace().folders.length>1;let O;if((0,L.isEqual)(h.uri,n)?O="":O=(0,L.relativePath)(h.uri,n),S){const N=h.name?h.name:(0,L.basename)(h.uri);O=O?N+" \u2022 "+O:N}return O}}if(n.scheme!==R.Schemas.file&&n.scheme!==R.Schemas.untitled)return n.with({query:null,fragment:null}).toString(!0);if((0,D.hasDriveLetter)(n.fsPath))return(0,b.normalize)(T(n.fsPath));let c=(0,b.normalize)(n.fsPath);return!I.isWindows&&s?.userHome&&(c=y(c,s.userHome.fsPath)),c}i.getPathLabel=p;function C(n){if(!n)return;typeof n=="string"&&(n=l.URI.file(n));const s=(0,L.basename)(n)||(n.scheme===R.Schemas.file?n.fsPath:n.path);return I.isWindows&&(0,D.isRootOrDriveLetter)(s)?T(s):s}i.getBaseLabel=C;function T(n,s){return(0,D.hasDriveLetter)(n,s)?n.charAt(0).toUpperCase()+n.slice(1):n}i.normalizeDriveLetter=T;let d=Object.create(null);function y(n,s){if(I.isWindows||!n||!s)return n;let a=d.original===s?d.normalized:void 0;return a||(a=`${(0,P.rtrim)(s,b.posix.sep)}${b.posix.sep}`,d={original:s,normalized:a}),(I.isLinux?n.startsWith(a):(0,P.startsWithIgnoreCase)(n,a))&&(n=`~/${n.substr(a.length)}`),n}i.tildify=y;function w(n,s){return n.replace(/^~($|\/|\\)/,`${s}$1`)}i.untildify=w;const g="\u2026",u="\\\\",f="~";function E(n,s=b.sep){const a=new Array(n.length);let c=!1;for(let h=0;h<n.length;h++){let S=n[h];if(S===""){a[h]=`.${s}`;continue}if(!S){a[h]=S;continue}c=!0;let O="";S.indexOf(u)===0?(O=S.substr(0,S.indexOf(u)+u.length),S=S.substr(S.indexOf(u)+u.length)):S.indexOf(s)===0?(O=S.substr(0,S.indexOf(s)+s.length),S=S.substr(S.indexOf(s)+s.length)):S.indexOf(f)===0&&(O=S.substr(0,S.indexOf(f)+f.length),S=S.substr(S.indexOf(f)+f.length));const N=S.split(s);for(let _=1;c&&_<=N.length;_++)for(let J=N.length-_;c&&J>=0;J--){c=!1;let re=N.slice(J,J+_).join(s);for(let ee=0;!c&&ee<n.length;ee++)if(ee!==h&&n[ee]&&n[ee].indexOf(re)>-1){const ie=J+_===N.length,he=J>0&&n[ee].indexOf(s)>-1?s+re:re,ue=n[ee].endsWith(he);c=!ie||ue}if(!c){let ee="";(N[0].endsWith(":")||O!=="")&&(J===1&&(J=0,_++,re=N[0]+s+re),J>0&&(ee=N[0]+s),ee=O+ee),J>0&&(ee=ee+g+s),ee=ee+re,J+_<N.length&&(ee=ee+s+g),a[h]=ee}}c&&(a[h]=S)}return a}i.shorten=E;var v;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(v||(v={}));function m(n,s=Object.create(null)){const a=[];let c=!1,h="";for(const S of n)if(S==="$"||c&&S==="{")h&&a.push({value:h,type:v.TEXT}),h="",c=!0;else if(S==="}"&&c){const O=s[h];if(typeof O=="string")O.length&&a.push({value:O,type:v.VARIABLE});else if(O){const N=a[a.length-1];(!N||N.type!==v.SEPARATOR)&&a.push({value:O.label,type:v.SEPARATOR})}h="",c=!1}else h+=S;return h&&!c&&a.push({value:h,type:v.TEXT}),a.filter((S,O)=>{if(S.type===v.SEPARATOR){const N=a[O-1],_=a[O+1];return[N,_].every(J=>J&&(J.type===v.VARIABLE||J.type===v.TEXT)&&J.value.length>0)}return!0}).map(S=>S.value).join("")}i.template=m;function o(n,s){return I.isMacintosh||s?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,I.isMacintosh?"&":"&&"):n.replace(/&&|&/g,a=>a==="&"?"&&":"&")}i.mnemonicMenuLabel=o;function e(n,s){return I.isMacintosh||s?n.replace(/\(&&\w\)|&&/g,""):I.isWindows?n.replace(/&&|&/g,a=>a==="&"?"&&":"&"):n.replace(/&&/g,"_")}i.mnemonicButtonLabel=e;function r(n){return n.replace(/&/g,"&&")}i.unmnemonicLabel=r;function t(n){const s=n.indexOf("/")!==-1?b.posix:b.win32,a=s.basename(n),c=s.dirname(n);return a.length?{name:a,parentPath:c}:{name:c,parentPath:""}}i.splitName=t}),define(Y[27],Q([0,1]),function(j,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.generateUuid=i.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(l){return D.test(l)}i.isUUID=R;const b=new Uint8Array(16),I=[];for(let l=0;l<256;l++)I.push(l.toString(16).padStart(2,"0"));let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(l){for(let p=0;p<l.length;p++)l[p]=Math.floor(Math.random()*256);return l};function P(){L(b),b[6]=b[6]&15|64,b[8]=b[8]&63|128;let l=0,p="";return p+=I[b[l++]],p+=I[b[l++]],p+=I[b[l++]],p+=I[b[l++]],p+="-",p+=I[b[l++]],p+=I[b[l++]],p+="-",p+=I[b[l++]],p+=I[b[l++]],p+="-",p+=I[b[l++]],p+=I[b[l++]],p+="-",p+=I[b[l++]],p+=I[b[l++]],p+=I[b[l++]],p+=I[b[l++]],p+=I[b[l++]],p+=I[b[l++]],p}i.generateUuid=P}),define(Y[63],Q([0,1,132]),function(j,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LineDecoder=void 0;class R{constructor(I="utf8"){this.stringDecoder=new D.StringDecoder(I),this.remaining=null}write(I){const L=[],P=this.remaining?this.remaining+this.stringDecoder.write(I):this.stringDecoder.write(I);if(P.length<1)return L;let l=0,p,C=l;for(;C<P.length;)if(p=P.charCodeAt(C),p===13||p===10){if(L.push(P.substring(l,C)),C++,C<P.length){const T=p;p=P.charCodeAt(C),(T===13&&p===10||T===10&&p===13)&&C++}l=C}else C++;return this.remaining=l<P.length?P.substr(l):null,L}end(){return this.remaining}}i.LineDecoder=R}),define(Y[64],Q([0,1,33,11,15]),function(j,i,D,R,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getFirstAvailablePowerShellInstallation=i.enumeratePowerShellInstallations=void 0;const I=/^\d+$/,L=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var l;(function(m){m[m.x64=0]="x64",m[m.x86=1]="x86",m[m.ARM=2]="ARM"})(l||(l={}));let p;switch(process.arch){case"ia32":case"x32":p=1;break;case"arm":case"arm64":p=2;break;default:p=0;break}let C;process.env.PROCESSOR_ARCHITEW6432?C=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?C=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?C=1:C=0;class T{constructor(o,e,r){this.exePath=o,this.displayName=e,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await b.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function d({useAlternateBitness:m=!1}={}){return m?p===0?process.env["ProgramFiles(x86)"]||null:C===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function y({useAlternateBitness:m=!1,findPreview:o=!1}={}){const e=d({useAlternateBitness:m});if(!e)return null;const r=R.join(e,"PowerShell");if(!await b.SymlinkSupport.existsDirectory(r))return null;let t=-1,n=null;for(const c of await b.Promises.readdir(r)){let h=-1;if(o){const O=c.indexOf("-");if(O<0)continue;const N=c.substring(0,O);if(!I.test(N)||c.substring(O+1)!=="preview")continue;h=parseInt(N,10)}else{if(!I.test(c))continue;h=parseInt(c,10)}if(h<=t)continue;const S=R.join(r,c,"pwsh.exe");!await b.SymlinkSupport.existsFile(S)||(n=S,t=h)}if(!n)return null;const s=e.includes("x86")?" (x86)":"",a=o?" Preview":"";return new T(n,`PowerShell${a}${s}`,!0)}async function w({findPreview:m}={}){if(!process.env.LOCALAPPDATA)return null;const o=R.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await b.SymlinkSupport.existsDirectory(o))return null;const{pwshMsixDirRegex:e,pwshMsixName:r}=m?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:L,pwshMsixName:"PowerShell (Store)"};for(const t of await b.Promises.readdir(o))if(e.test(t)){const n=R.join(o,t,"pwsh.exe");return new T(n,r)}return null}function g(){const m=R.join(D.homedir(),".dotnet","tools","pwsh.exe");return new T(m,".NET Core PowerShell Global Tool")}function u(){const m=R.join(process.env.windir,p===1&&C!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new T(m,"Windows PowerShell",!0)}async function*f(){let m=await y();m&&(yield m),m=await y({useAlternateBitness:!0}),m&&(yield m),m=await w(),m&&(yield m),m=g(),m&&(yield m),m=await y({findPreview:!0}),m&&(yield m),m=await w({findPreview:!0}),m&&(yield m),m=await y({useAlternateBitness:!0,findPreview:!0}),m&&(yield m),m=u(),m&&(yield m)}async function*E(){for await(const m of f())await m.exists()&&(yield m)}i.enumeratePowerShellInstallations=E;async function v(){for await(const m of E())return m;return null}i.getFirstAvailablePowerShellInstallation=v});var ge=this&&this.__decorate||function(j,i,D,R){var b=arguments.length,I=b<3?i:R===null?R=Object.getOwnPropertyDescriptor(i,D):R,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")I=Reflect.decorate(j,i,D,R);else for(var P=j.length-1;P>=0;P--)(L=j[P])&&(I=(b<3?L(I):b>3?L(i,D,I):L(i,D))||I);return b>3&&I&&Object.defineProperty(i,D,I),I};define(Y[46],Q([0,1,18,3,17,24,44,8,7,2,61,26,6]),function(j,i,D,R,b,I,L,P,l,p,C,T,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IPCLogger=i.logWithColors=i.ProxyChannel=i.StaticRouter=i.getNextTickChannel=i.getDelayedChannel=i.IPCClient=i.IPCServer=i.ChannelClient=i.RequestInitiator=i.ChannelServer=i.ResponseType=i.RequestType=void 0;var y;(function(U){U[U.Promise=100]="Promise",U[U.PromiseCancel=101]="PromiseCancel",U[U.EventListen=102]="EventListen",U[U.EventDispose=103]="EventDispose"})(y=i.RequestType||(i.RequestType={}));function w(U){switch(U){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(U){U[U.Initialize=200]="Initialize",U[U.PromiseSuccess=201]="PromiseSuccess",U[U.PromiseError=202]="PromiseError",U[U.PromiseErrorObj=203]="PromiseErrorObj",U[U.EventFire=204]="EventFire"})(g=i.ResponseType||(i.ResponseType={}));function u(U){switch(U){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(U){U[U.Uninitialized=0]="Uninitialized",U[U.Idle=1]="Idle"})(f||(f={}));class E{constructor(k){this.buffer=k,this.pos=0}read(k){const z=this.buffer.slice(this.pos,this.pos+k);return this.pos+=z.byteLength,z}}class v{constructor(){this.buffers=[]}get buffer(){return b.VSBuffer.concat(this.buffers)}write(k){this.buffers.push(k)}}var m;(function(U){U[U.Undefined=0]="Undefined",U[U.String=1]="String",U[U.Buffer=2]="Buffer",U[U.VSBuffer=3]="VSBuffer",U[U.Array=4]="Array",U[U.Object=5]="Object"})(m||(m={}));function o(U){const k=b.VSBuffer.alloc(4);return k.writeUInt32BE(U,0),k}function e(U){return U.read(4).readUInt32BE(0)}function r(U){const k=b.VSBuffer.alloc(1);return k.writeUInt8(U,0),k}const t={Undefined:r(m.Undefined),String:r(m.String),Buffer:r(m.Buffer),VSBuffer:r(m.VSBuffer),Array:r(m.Array),Object:r(m.Object)},n=typeof Buffer!="undefined";function s(U,k){if(typeof k=="undefined")U.write(t.Undefined);else if(typeof k=="string"){const z=b.VSBuffer.fromString(k);U.write(t.String),U.write(o(z.byteLength)),U.write(z)}else if(n&&Buffer.isBuffer(k)){const z=b.VSBuffer.wrap(k);U.write(t.Buffer),U.write(o(z.byteLength)),U.write(z)}else if(k instanceof b.VSBuffer)U.write(t.VSBuffer),U.write(o(k.byteLength)),U.write(k);else if(Array.isArray(k)){U.write(t.Array),U.write(o(k.length));for(const z of k)s(U,z)}else{const z=b.VSBuffer.fromString(JSON.stringify(k));U.write(t.Object),U.write(o(z.byteLength)),U.write(z)}}function a(U){switch(U.read(1).readUInt8(0)){case m.Undefined:return;case m.String:return U.read(e(U)).toString();case m.Buffer:return U.read(e(U)).buffer;case m.VSBuffer:return U.read(e(U));case m.Array:{const z=e(U),G=[];for(let ne=0;ne<z;ne++)G.push(a(U));return G}case m.Object:return JSON.parse(U.read(e(U)).toString())}}class c{constructor(k,z,G=null,ne=1e3){this.protocol=k,this.ctx=z,this.logger=G,this.timeoutDelay=ne,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(K=>this.onRawMessage(K)),this.sendResponse({type:200})}registerChannel(k,z){this.channels.set(k,z),setTimeout(()=>this.flushPendingRequests(k),0)}sendResponse(k){switch(k.type){case 200:{const z=this.send([k.type]);this.logger?.logOutgoing(z,0,1,u(k.type));return}case 201:case 202:case 204:case 203:{const z=this.send([k.type,k.id],k.data);this.logger?.logOutgoing(z,k.id,1,u(k.type),k.data);return}}}send(k,z=void 0){const G=new v;return s(G,k),s(G,z),this.sendBuffer(G.buffer)}sendBuffer(k){try{return this.protocol.send(k),k.byteLength}catch{return 0}}onRawMessage(k){const z=new E(k),G=a(z),ne=a(z),K=G[0];switch(K){case 100:return this.logger?.logIncoming(k.byteLength,G[1],1,`${w(K)}: ${G[2]}.${G[3]}`,ne),this.onPromise({type:K,id:G[1],channelName:G[2],name:G[3],arg:ne});case 102:return this.logger?.logIncoming(k.byteLength,G[1],1,`${w(K)}: ${G[2]}.${G[3]}`,ne),this.onEventListen({type:K,id:G[1],channelName:G[2],name:G[3],arg:ne});case 101:return this.logger?.logIncoming(k.byteLength,G[1],1,`${w(K)}`),this.disposeActiveRequest({type:K,id:G[1]});case 103:return this.logger?.logIncoming(k.byteLength,G[1],1,`${w(K)}`),this.disposeActiveRequest({type:K,id:G[1]})}}onPromise(k){const z=this.channels.get(k.channelName);if(!z){this.collectPendingRequest(k);return}const G=new I.CancellationTokenSource;let ne;try{ne=z.call(this.ctx,k.name,k.arg,G.token)}catch(q){ne=Promise.reject(q)}const K=k.id;ne.then(q=>{this.sendResponse({id:K,data:q,type:201}),this.activeRequests.delete(k.id)},q=>{q instanceof Error?this.sendResponse({id:K,data:{message:q.message,name:q.name,stack:q.stack?q.stack.split?q.stack.split(`
`):q.stack:void 0},type:202}):this.sendResponse({id:K,data:q,type:203}),this.activeRequests.delete(k.id)});const Z=(0,p.toDisposable)(()=>G.cancel());this.activeRequests.set(k.id,Z)}onEventListen(k){const z=this.channels.get(k.channelName);if(!z){this.collectPendingRequest(k);return}const G=k.id,K=z.listen(this.ctx,k.name,k.arg)(Z=>this.sendResponse({id:G,data:Z,type:204}));this.activeRequests.set(k.id,K)}disposeActiveRequest(k){const z=this.activeRequests.get(k.id);z&&(z.dispose(),this.activeRequests.delete(k.id))}collectPendingRequest(k){let z=this.pendingRequests.get(k.channelName);z||(z=[],this.pendingRequests.set(k.channelName,z));const G=setTimeout(()=>{console.error(`Unknown channel: ${k.channelName}`),k.type===100&&this.sendResponse({id:k.id,data:{name:"Unknown channel",message:`Channel name '${k.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);z.push({request:k,timeoutTimer:G})}flushPendingRequests(k){const z=this.pendingRequests.get(k);if(z){for(const G of z)switch(clearTimeout(G.timeoutTimer),G.request.type){case 100:this.onPromise(G.request);break;case 102:this.onEventListen(G.request);break}this.pendingRequests.delete(k)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,p.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}i.ChannelServer=c;var h;(function(U){U[U.LocalSide=0]="LocalSide",U[U.OtherSide=1]="OtherSide"})(h=i.RequestInitiator||(i.RequestInitiator={}));class S{constructor(k,z=null){this.protocol=k,this.isDisposed=!1,this.state=f.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new l.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(G=>this.onBuffer(G)),this.logger=z}getChannel(k){const z=this;return{call(G,ne,K){return z.isDisposed?Promise.reject(P.canceled()):z.requestPromise(k,G,ne,K)},listen(G,ne){return z.isDisposed?l.Event.None:z.requestEvent(k,G,ne)}}}requestPromise(k,z,G,ne=I.CancellationToken.None){const K=this.lastRequestId++,q={id:K,type:100,channelName:k,name:z,arg:G};if(ne.isCancellationRequested)return Promise.reject(P.canceled());let M;return new Promise((V,B)=>{if(ne.isCancellationRequested)return B(P.canceled());const H=()=>{const Ee=fe=>{switch(fe.type){case 201:this.handlers.delete(K),V(fe.data);break;case 202:{this.handlers.delete(K);const se=new Error(fe.data.message);se.stack=fe.data.stack,se.name=fe.data.name,B(se);break}case 203:this.handlers.delete(K),B(fe.data);break}};this.handlers.set(K,Ee),this.sendRequest(q)};let X=null;this.state===f.Idle?H():(X=(0,R.createCancelablePromise)(Ee=>this.whenInitialized()),X.then(()=>{X=null,H()}));const ae=()=>{X?(X.cancel(),X=null):this.sendRequest({id:K,type:101}),B(P.canceled())},ce=ne.onCancellationRequested(ae);M=(0,p.combinedDisposable)((0,p.toDisposable)(ae),ce),this.activeRequests.add(M)}).finally(()=>{this.activeRequests.delete(M)})}requestEvent(k,z,G){const ne=this.lastRequestId++,Z={id:ne,type:102,channelName:k,name:z,arg:G};let q=null;const M=new l.Emitter({onFirstListenerAdd:()=>{q=(0,R.createCancelablePromise)(V=>this.whenInitialized()),q.then(()=>{q=null,this.activeRequests.add(M),this.sendRequest(Z)})},onLastListenerRemove:()=>{q?(q.cancel(),q=null):(this.activeRequests.delete(M),this.sendRequest({id:ne,type:103}))}}),A=V=>M.fire(V.data);return this.handlers.set(ne,A),M.event}sendRequest(k){switch(k.type){case 100:case 102:{const z=this.send([k.type,k.id,k.channelName,k.name],k.arg);this.logger&&this.logger.logOutgoing(z,k.id,0,`${w(k.type)}: ${k.channelName}.${k.name}`,k.arg);return}case 101:case 103:{const z=this.send([k.type,k.id]);this.logger&&this.logger.logOutgoing(z,k.id,0,w(k.type));return}}}send(k,z=void 0){const G=new v;return s(G,k),s(G,z),this.sendBuffer(G.buffer)}sendBuffer(k){try{return this.protocol.send(k),k.byteLength}catch{return 0}}onBuffer(k){const z=new E(k),G=a(z),ne=a(z),K=G[0];switch(K){case 200:return this.logger&&this.logger.logIncoming(k.byteLength,0,0,u(K)),this.onResponse({type:G[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(k.byteLength,G[1],0,u(K),ne),this.onResponse({type:G[0],id:G[1],data:ne})}}onResponse(k){if(k.type===200){this.state=f.Idle,this._onDidInitialize.fire();return}const z=this.handlers.get(k.id);z&&z(k)}get onDidInitializePromise(){return l.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,p.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}ge([L.memoize],S.prototype,"onDidInitializePromise",null),i.ChannelClient=S;class O{constructor(k){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new l.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new l.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,k(({protocol:z,onDidClientDisconnect:G})=>{l.Event.once(z.onMessage)(K=>{const Z=new E(K),q=a(Z),M=new c(z,q),A=new S(z);this.channels.forEach((B,H)=>M.registerChannel(H,B));const V={channelServer:M,channelClient:A,ctx:q};this._connections.add(V),this._onDidAddConnection.fire(V),G(()=>{M.dispose(),A.dispose(),this._connections.delete(V),this._onDidRemoveConnection.fire(V)})})})}get connections(){const k=[];return this._connections.forEach(z=>k.push(z)),k}getChannel(k,z){const G=this;return{call(ne,K,Z){let q;if((0,d.isFunction)(z)){let A=(0,D.getRandomElement)(G.connections.filter(z));q=A?Promise.resolve(A):l.Event.toPromise(l.Event.filter(G.onDidAddConnection,z))}else q=z.routeCall(G,ne,K);const M=q.then(A=>A.channelClient.getChannel(k));return _(M).call(ne,K,Z)},listen(ne,K){if((0,d.isFunction)(z))return G.getMulticastEvent(k,z,ne,K);const Z=z.routeEvent(G,ne,K).then(q=>q.channelClient.getChannel(k));return _(Z).listen(ne,K)}}}getMulticastEvent(k,z,G,ne){const K=this;let Z=new p.DisposableStore;const q=new l.Emitter({onFirstListenerAdd:()=>{Z=new p.DisposableStore;const M=new l.EventMultiplexer,A=new Map,V=H=>{const ae=H.channelClient.getChannel(k).listen(G,ne),ce=M.add(ae);A.set(H,ce)},B=H=>{const X=A.get(H);!X||(X.dispose(),A.delete(H))};K.connections.filter(z).forEach(V),l.Event.filter(K.onDidAddConnection,z)(V,void 0,Z),K.onDidRemoveConnection(B,void 0,Z),M.event(q.fire,q,Z),Z.add(M)},onLastListenerRemove:()=>{Z.dispose()}});return q.event}registerChannel(k,z){this.channels.set(k,z),this._connections.forEach(G=>{G.channelServer.registerChannel(k,z)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}i.IPCServer=O;class N{constructor(k,z,G=null){const ne=new v;s(ne,z),k.send(ne.buffer),this.channelClient=new S(k,G),this.channelServer=new c(k,z,G)}getChannel(k){return this.channelClient.getChannel(k)}registerChannel(k,z){this.channelServer.registerChannel(k,z)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}i.IPCClient=N;function _(U){return{call(k,z,G){return U.then(ne=>ne.call(k,z,G))},listen(k,z){const G=new l.Relay;return U.then(ne=>G.input=ne.listen(k,z)),G.event}}}i.getDelayedChannel=_;function J(U){let k=!1;return{call(z,G,ne){return k?U.call(z,G,ne):(0,R.timeout)(0).then(()=>k=!0).then(()=>U.call(z,G,ne))},listen(z,G){if(k)return U.listen(z,G);const ne=new l.Relay;return(0,R.timeout)(0).then(()=>k=!0).then(()=>ne.input=U.listen(z,G)),ne.event}}}i.getNextTickChannel=J;class re{constructor(k){this.fn=k}routeCall(k){return this.route(k)}routeEvent(k){return this.route(k)}async route(k){for(const z of k.connections)if(await Promise.resolve(this.fn(z.ctx)))return Promise.resolve(z);return await l.Event.toPromise(k.onDidAddConnection),await this.route(k)}}i.StaticRouter=re;var ee;(function(U){function k(K,Z){const q=K,M=Z&&Z.disableMarshalling,A=new Map;for(const V in q)G(V)&&A.set(V,l.Event.buffer(q[V],!0));return new class{listen(V,B,H){const X=A.get(B);if(X)return X;if(ne(B)){const ae=q[B];if(typeof ae=="function")return ae.call(q,H)}throw new Error(`Event not found: ${B}`)}call(V,B,H){const X=q[B];if(typeof X=="function"){if(!M&&Array.isArray(H))for(let ae=0;ae<H.length;ae++)H[ae]=(0,C.revive)(H[ae]);return X.apply(q,H)}throw new Error(`Method not found: ${B}`)}}}U.fromService=k;function z(K,Z){const q=Z&&Z.disableMarshalling;return new Proxy({},{get(M,A){if(typeof A=="string")return Z?.properties?.has(A)?Z.properties.get(A):ne(A)?function(V){return K.listen(A,V)}:G(A)?K.listen(A):async function(...V){let B;Z&&!(0,d.isUndefinedOrNull)(Z.context)?B=[Z.context,...V]:B=V;const H=await K.call(A,B);return q?H:(0,C.revive)(H)};throw new Error(`Property not found: ${String(A)}`)}})}U.toService=z;function G(K){return K[0]==="o"&&K[1]==="n"&&T.isUpperAsciiLetter(K.charCodeAt(2))}function ne(K){return/^onDynamic/.test(K)&&T.isUpperAsciiLetter(K.charCodeAt(9))}})(ee=i.ProxyChannel||(i.ProxyChannel={}));const ie=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function he(U){if(Array.isArray(U))return U;if(U&&typeof U=="object"&&typeof U.toString=="function"){let k=U.toString();if(k!=="[object Object]")return k}return U}function ue(U){return Array.isArray(U)?U.map(he):he(U)}function x(U,k,z,G,ne,K,Z){Z=ue(Z);const q=ie[ne],M=q[G%q.length];let A=[`%c[${U}]%c[${String(k).padStart(7," ")}]%c[len: ${String(z).padStart(5," ")}]%c${String(G).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${M}`];/\($/.test(K)?(A=A.concat(Z),A.push(")")):A.push(Z),console.log.apply(console,A)}i.logWithColors=x;class te{constructor(k,z){this._outgoingPrefix=k,this._incomingPrefix=z,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(k,z,G,ne,K){this._totalOutgoing+=k,x(this._outgoingPrefix,this._totalOutgoing,k,z,G,ne,K)}logIncoming(k,z,G,ne,K){this._totalIncoming+=k,x(this._incomingPrefix,this._totalIncoming,k,z,G,ne,K)}}i.IPCLogger=te}),define(Y[65],Q([0,1,3,7,2,6]),function(j,i,D,R,b,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.InMemoryStorageDatabase=i.Storage=i.isStorageItemsChangeEvent=i.StorageHint=void 0;var L;(function(T){T[T.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(L=i.StorageHint||(i.StorageHint={}));function P(T){const d=T;return d?.changed instanceof Map||d?.deleted instanceof Set}i.isStorageItemsChangeEvent=P;var l;(function(T){T[T.None=0]="None",T[T.Initialized=1]="Initialized",T[T.Closed=2]="Closed"})(l||(l={}));class p extends b.Disposable{constructor(d,y=Object.create(null)){super();this.database=d,this.options=y,this._onDidChangeStorage=this._register(new R.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=l.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(p.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(d=>this.onDidChangeItemsExternal(d)))}onDidChangeItemsExternal(d){d.changed?.forEach((y,w)=>this.accept(w,y)),d.deleted?.forEach(y=>this.accept(y,void 0))}accept(d,y){if(this.state===l.Closed)return;let w=!1;(0,I.isUndefinedOrNull)(y)?w=this.cache.delete(d):this.cache.get(d)!==y&&(this.cache.set(d,y),w=!0),w&&this._onDidChangeStorage.fire(d)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===l.None&&(this.state=l.Initialized,this.options.hint!==L.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(d,y){const w=this.cache.get(d);return(0,I.isUndefinedOrNull)(w)?y:w}getBoolean(d,y){const w=this.get(d);return(0,I.isUndefinedOrNull)(w)?y:w==="true"}getNumber(d,y){const w=this.get(d);return(0,I.isUndefinedOrNull)(w)?y:parseInt(w,10)}async set(d,y){if(this.state===l.Closed)return;if((0,I.isUndefinedOrNull)(y))return this.delete(d);const w=String(y);if(this.cache.get(d)!==w)return this.cache.set(d,w),this.pendingInserts.set(d,w),this.pendingDeletes.delete(d),this._onDidChangeStorage.fire(d),this.doFlush()}async delete(d){if(!(this.state===l.Closed||!this.cache.delete(d)))return this.pendingDeletes.has(d)||this.pendingDeletes.add(d),this.pendingInserts.delete(d),this._onDidChangeStorage.fire(d),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=l.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const d={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(d).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(d){if(!!this.hasPending)return this.doFlush(d)}async doFlush(d){return this.flushDelayer.trigger(()=>this.flushPending(),d)}async whenFlushed(){if(!!this.hasPending)return new Promise(d=>this.whenFlushedCallbacks.push(d))}dispose(){this.flushDelayer.dispose(),super.dispose()}}i.Storage=p,p.DEFAULT_FLUSH_DELAY=100;class C{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(d){d.insert&&d.insert.forEach((y,w)=>this.items.set(w,y)),d.delete&&d.delete.forEach(y=>this.items.delete(y))}async close(){}}i.InMemoryStorageDatabase=C}),define(Y[66],Q([4,5]),function(j,i){return j.create("vs/base/common/date",i)}),define(Y[67],Q([0,1,66]),function(j,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.toLocalISOString=i.fromNow=void 0;const R=60,b=R*60,I=b*24,L=I*7,P=I*30,l=I*365;function p(T,d,y){typeof T!="number"&&(T=T.getTime());const w=Math.round((new Date().getTime()-T)/1e3);if(w<-30)return(0,D.localize)(0,null,p(new Date().getTime()+w*1e3,!1));if(w<30)return(0,D.localize)(1,null);let g;return w<R?(g=w,d?g===1?y?(0,D.localize)(2,null,g):(0,D.localize)(3,null,g):y?(0,D.localize)(4,null,g):(0,D.localize)(5,null,g):g===1?y?(0,D.localize)(6,null,g):(0,D.localize)(7,null,g):y?(0,D.localize)(8,null,g):(0,D.localize)(9,null,g)):w<b?(g=Math.floor(w/R),d?g===1?y?(0,D.localize)(10,null,g):(0,D.localize)(11,null,g):y?(0,D.localize)(12,null,g):(0,D.localize)(13,null,g):g===1?y?(0,D.localize)(14,null,g):(0,D.localize)(15,null,g):y?(0,D.localize)(16,null,g):(0,D.localize)(17,null,g)):w<I?(g=Math.floor(w/b),d?g===1?y?(0,D.localize)(18,null,g):(0,D.localize)(19,null,g):y?(0,D.localize)(20,null,g):(0,D.localize)(21,null,g):g===1?y?(0,D.localize)(22,null,g):(0,D.localize)(23,null,g):y?(0,D.localize)(24,null,g):(0,D.localize)(25,null,g)):w<L?(g=Math.floor(w/I),d?g===1?(0,D.localize)(26,null,g):(0,D.localize)(27,null,g):g===1?(0,D.localize)(28,null,g):(0,D.localize)(29,null,g)):w<P?(g=Math.floor(w/L),d?g===1?y?(0,D.localize)(30,null,g):(0,D.localize)(31,null,g):y?(0,D.localize)(32,null,g):(0,D.localize)(33,null,g):g===1?y?(0,D.localize)(34,null,g):(0,D.localize)(35,null,g):y?(0,D.localize)(36,null,g):(0,D.localize)(37,null,g)):w<l?(g=Math.floor(w/P),d?g===1?y?(0,D.localize)(38,null,g):(0,D.localize)(39,null,g):y?(0,D.localize)(40,null,g):(0,D.localize)(41,null,g):g===1?y?(0,D.localize)(42,null,g):(0,D.localize)(43,null,g):y?(0,D.localize)(44,null,g):(0,D.localize)(45,null,g)):(g=Math.floor(w/l),d?g===1?y?(0,D.localize)(46,null,g):(0,D.localize)(47,null,g):y?(0,D.localize)(48,null,g):(0,D.localize)(49,null,g):g===1?y?(0,D.localize)(50,null,g):(0,D.localize)(51,null,g):y?(0,D.localize)(52,null,g):(0,D.localize)(53,null,g))}i.fromNow=p;function C(T){return T.getFullYear()+"-"+String(T.getMonth()+1).padStart(2,"0")+"-"+String(T.getDate()).padStart(2,"0")+"T"+String(T.getHours()).padStart(2,"0")+":"+String(T.getMinutes()).padStart(2,"0")+":"+String(T.getSeconds()).padStart(2,"0")+"."+(T.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}i.toLocalISOString=C}),define(Y[68],Q([4,5]),function(j,i){return j.create("vs/base/common/errorMessage",i)}),define(Y[28],Q([0,1,18,6,68]),function(j,i,D,R,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.createErrorWithActions=i.isErrorWithActions=i.toErrorMessage=void 0;function I(T,d){return d&&(T.stack||T.stacktrace)?b.localize(0,null,P(T),L(T.stack)||L(T.stacktrace)):P(T)}function L(T){return Array.isArray(T)?T.join(`
`):T}function P(T){return typeof T.code=="string"&&typeof T.errno=="number"&&typeof T.syscall=="string"?b.localize(1,null,T.message):T.message||b.localize(2,null)}function l(T=null,d=!1){if(!T)return b.localize(3,null);if(Array.isArray(T)){const y=D.coalesce(T),w=l(y[0],d);return y.length>1?b.localize(4,null,w,y.length):w}if(R.isString(T))return T;if(T.detail){const y=T.detail;if(y.error)return I(y.error,d);if(y.exception)return I(y.exception,d)}return T.stack?I(T,d):T.message?T.message:b.localize(5,null)}i.toErrorMessage=l;function p(T){const d=T;return d instanceof Error&&Array.isArray(d.actions)}i.isErrorWithActions=p;function C(T,d=Object.create(null)){const y=new Error(T);return d.actions&&(y.actions=d.actions),y}i.createErrorWithActions=C}),define(Y[69],Q([4,5]),function(j,i){return j.create("vs/base/node/processes",i)}),define(Y[47],Q([0,1,39,45,10,22,11,12,29,57,6,63,15,69]),function(j,i,D,R,b,I,L,P,l,p,C,T,d,y){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.win32=i.createQueuedSender=i.LineProcess=i.AbstractProcess=i.getWindowsShell=i.removeDangerousEnvVariables=i.TerminateResponseCode=i.Source=void 0,Object.defineProperty(i,"Source",{enumerable:!0,get:function(){return p.Source}}),Object.defineProperty(i,"TerminateResponseCode",{enumerable:!0,get:function(){return p.TerminateResponseCode}});function w(e){switch(e){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function g(e,r){if(P.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};r&&(t.cwd=r);const n=D.execFile("taskkill",["/T","/F","/PID",e.pid.toString()],t);return new Promise(s=>{n.once("error",a=>{s({success:!1,error:a})}),n.once("exit",(a,c)=>{s(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?w(t.status):1})}else if(P.isLinux||P.isMacintosh)try{const t=b.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",j).fsPath;return new Promise(n=>{D.execFile(t,[e.pid.toString()],{encoding:"utf8",shell:!0},(s,a,c)=>{n(s?{success:!1,error:s}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else e.kill("SIGKILL");return Promise.resolve({success:!0})}function u(e){!e||(delete e.DEBUG,P.isMacintosh&&delete e.DYLD_LIBRARY_PATH,P.isLinux&&delete e.LD_PRELOAD)}i.removeDangerousEnvVariables=u;function f(e=l.env){return e.comspec||"cmd.exe"}i.getWindowsShell=f;class E{constructor(r,t,n,s){if(t!==void 0&&n!==void 0&&s!==void 0)this.cmd=r,this.args=t,this.shell=n,this.options=s;else{const a=r;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(l.env).forEach(c=>{a[c]=l.env[c]}),Object.keys(this.options.env).forEach(c=>{a[c]=this.options.env[c]}),this.options.env=a}}getSanitizedCommand(){let r=this.cmd.toLowerCase();const t=r.lastIndexOf(L.sep);return t!==-1&&(r=r.substring(t+1)),E.WellKnowCommands[r]?r:"other"}start(r){return P.isWindows&&(this.options&&this.options.cwd&&R.isUNC(this.options.cwd)||!this.options&&R.isUNC(l.cwd()))?Promise.reject(new Error(y.localize(0,null))):this.useExec().then(t=>{let n,s;const a=new Promise((c,h)=>{n=c,s=h});if(t){let c=this.cmd;this.args&&(c=c+" "+this.args.join(" ")),this.childProcess=D.exec(c,this.options,(h,S,O)=>{this.childProcess=null;const N=h;N&&N.killed?s({killed:this.terminateRequested,stdout:S.toString(),stderr:O.toString()}):this.handleExec(n,r,h,S,O)})}else{let c=null;const h=S=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(S,n,r,s);const O={terminated:this.terminateRequested};C.isNumber(S)&&(O.cmdCode=S),n(O)};if(this.shell&&P.isWindows){const S=I.deepClone(this.options);S.windowsVerbatimArguments=!0,S.detached=!1;let O=!1,N=!1;const _=[];let J=this.ensureQuotes(this.cmd);_.push(J.value),O=J.quoted,this.args&&this.args.forEach(ee=>{J=this.ensureQuotes(ee),_.push(J.value),N=N&&J.quoted});const re=["/s","/c"];O?N?re.push('"'+_.join(" ")+'"'):_.length>1?re.push('"'+_[0]+'" '+_.slice(1).join(" ")):re.push('"'+_[0]+'"'):re.push(_.join(" ")),c=D.spawn(f(),re,S)}else this.cmd&&(c=D.spawn(this.cmd,this.args,this.options));c&&(this.childProcess=c,this.childProcessPromise=Promise.resolve(c),this.pidResolve&&(this.pidResolve(C.isNumber(c.pid)?c.pid:-1),this.pidResolve=void 0),c.on("error",S=>{this.childProcess=null,s({terminated:this.terminateRequested,error:S})}),c.pid&&(this.childProcess.on("close",h),this.handleSpawn(c,n,r,s,!0)))}return a})}handleClose(r,t,n,s){}ensureQuotes(r){return E.regexp.test(r)?{value:'"'+r+'"',quoted:!0}:{value:r,quoted:r.length>0&&r[0]==='"'&&r[r.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(r=>r.pid,r=>-1):new Promise(r=>{this.pidResolve=r})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(r=>(this.terminateRequested=!0,g(r,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),r=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(r=>{if(!this.shell||!P.isWindows)return r(!1);const t=D.spawn(f(),["/s","/c"]);t.on("error",n=>r(!0)),t.on("exit",n=>r(!1))})}}i.AbstractProcess=E,E.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},E.regexp=/^[^"].* .*[^"]/;class v extends E{constructor(r,t,n,s){super(r,t,n,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(r,t,n,s,a){[s,a].forEach((c,h)=>{const S=new T.LineDecoder;S.write(c).forEach(_=>{t({line:_,source:h===0?0:1})});const N=S.end();N&&t({line:N,source:h===0?0:1})}),r({terminated:this.terminateRequested,error:n})}handleSpawn(r,t,n,s,a){const c=new T.LineDecoder,h=new T.LineDecoder;r.stdout.on("data",S=>{c.write(S).forEach(N=>n({line:N,source:0}))}),r.stderr.on("data",S=>{h.write(S).forEach(N=>n({line:N,source:1}))}),this.stdoutLineDecoder=c,this.stderrLineDecoder=h}handleClose(r,t,n,s){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&n({line:a,source:0});const c=this.stderrLineDecoder?this.stderrLineDecoder.end():null;c&&n({line:c,source:1})}}i.LineProcess=v;function m(e){let r=[],t=!1;const n=function(s){if(t){r.push(s);return}(!e.send(s,c=>{if(c&&console.error(c),t=!1,r.length>0){const h=r.slice(0);r=[],h.forEach(S=>n(S))}})||P.isWindows)&&(t=!0)};return{send:n}}i.createQueuedSender=m;var o;(function(e){async function r(t,n,s){if(L.isAbsolute(t))return t;if(n===void 0&&(n=l.cwd()),L.dirname(t)!=="."||(s===void 0&&C.isString(l.env.PATH)&&(s=l.env.PATH.split(L.delimiter)),s===void 0||s.length===0))return L.join(n,t);async function c(h){if(await d.Promises.exists(h)){let S;try{S=await d.Promises.stat(h)}catch(O){O.message.startsWith("EACCES")&&(S=await d.Promises.lstat(h))}return S?!S.isDirectory():!1}return!1}for(let h of s){let S;if(L.isAbsolute(h)?S=L.join(h,t):S=L.join(n,h,t),await c(S))return S;let O=S+".com";if(await c(O)||(O=S+".exe",await c(O)))return O}return L.join(n,t)}e.findExecutable=r})(o=i.win32||(i.win32={}))}),define(Y[70],Q([0,1,33,12,64,47]),function(j,i,D,R,b,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getSystemShellSync=i.getSystemShell=void 0;async function L(y,w){return y===1?R.isWindows?T():I.getWindowsShell(w):p(y,w)}i.getSystemShell=L;function P(y,w){return y===1?R.isWindows?d(w):I.getWindowsShell(w):p(y,w)}i.getSystemShellSync=P;let l=null;function p(y,w){if(R.isLinux&&y===2||R.isMacintosh&&y===3)return"/bin/bash";if(!l){let g;if(R.isWindows)g="/bin/bash";else{if(g=w.SHELL,!g)try{g=(0,D.userInfo)().shell}catch{}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}l=g}return l}let C=null;async function T(){return C||(C=(await(0,b.getFirstAvailablePowerShellInstallation)()).exePath),C}function d(y){if(C)return C;const w=R.isWindows&&parseFloat((0,D.release)())>=10,g=y.hasOwnProperty("PROCESSOR_ARCHITEW6432"),u=`${y.windir}\\${g?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return w?u:I.getWindowsShell(y)}}),define(Y[71],Q([0,1,39,3,17,24,60,8,7,2,22,47,46]),function(j,i,D,R,b,I,L,P,l,p,C,T,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Client=i.Server=void 0;class y extends d.ChannelServer{constructor(u){super({send:f=>{try{process.send&&process.send(f.buffer.toString("base64"))}catch{}},onMessage:l.Event.fromNodeEventEmitter(process,"message",f=>b.VSBuffer.wrap(Buffer.from(f,"base64")))},u);process.once("disconnect",()=>this.dispose())}}i.Server=y;class w{constructor(u,f){this.modulePath=u,this.options=f,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new l.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const E=f&&f.timeout?f.timeout:6e4;this.disposeDelayer=new R.Delayer(E),this.child=null,this._client=null}getChannel(u){const f=this;return{call(E,v,m){return f.requestPromise(u,E,v,m)},listen(E,v){return f.requestEvent(u,E,v)}}}requestPromise(u,f,E,v=I.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(v.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const m=this.getCachedChannel(u),o=(0,R.createCancelablePromise)(t=>m.call(f,E,t)),e=v.onCancellationRequested(()=>o.cancel()),r=(0,p.toDisposable)(()=>o.cancel());return this.activeRequests.add(r),o.finally(()=>{e.dispose(),this.activeRequests.delete(r),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),o}requestEvent(u,f,E){if(!this.disposeDelayer)return l.Event.None;this.disposeDelayer.cancel();let v;const m=new l.Emitter({onFirstListenerAdd:()=>{v=this.getCachedChannel(u).listen(f,E)(m.fire,m),this.activeRequests.add(v)},onLastListenerRemove:()=>{this.activeRequests.delete(v),v.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return m.event}get client(){if(!this._client){const u=this.options&&this.options.args?this.options.args:[],f=Object.create(null);f.env={...(0,C.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(f.env={...f.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(f.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n))),(0,T.removeDangerousEnvVariables)(f.env),this.child=(0,D.fork)(this.modulePath,u,f);const E=new l.Emitter;l.Event.fromNodeEventEmitter(this.child,"message",n=>n)(n=>{if((0,L.isRemoteConsoleLog)(n)){(0,L.log)(n,`IPC Library: ${this.options.serverName}`);return}E.fire(b.VSBuffer.wrap(Buffer.from(n,"base64")))});const m=this.options.useQueue?(0,T.createQueuedSender)(this.child):this.child,o=n=>this.child&&this.child.connected&&m.send(n.buffer.toString("base64")),e=E.event,r={send:o,onMessage:e};this._client=new d.ChannelClient(r);const t=()=>this.disposeClient();process.once("exit",t),this.child.on("error",n=>console.warn('IPC "'+this.options.serverName+'" errored with '+n)),this.child.on("exit",(n,s)=>{process.removeListener("exit",t),this.activeRequests.forEach(a=>(0,p.dispose)(a)),this.activeRequests.clear(),n!==0&&s!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+n+" and signal "+s),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:n,signal:s})})}return this._client}getCachedChannel(u){let f=this.channels.get(u);return f||(f=this.client.getChannel(u),this.channels.set(u,f)),f}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}i.Client=w}),define(Y[72],Q([4,5]),function(j,i){return j.create("vs/base/node/zip",i)}),define(Y[73],Q([4,5]),function(j,i){return j.create("vs/platform/configuration/common/configurationRegistry",i)}),define(Y[74],Q([4,5]),function(j,i){return j.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",i)}),define(Y[75],Q([4,5]),function(j,i){return j.create("vs/platform/extensionManagement/common/extensionManagement",i)}),define(Y[76],Q([4,5]),function(j,i){return j.create("vs/platform/extensionManagement/common/extensionManagementCLIService",i)}),define(Y[77],Q([4,5]),function(j,i){return j.create("vs/platform/extensionManagement/node/extensionManagementService",i)}),define(Y[78],Q([4,5]),function(j,i){return j.create("vs/platform/extensionManagement/node/extensionManagementUtil",i)}),define(Y[79],Q([4,5]),function(j,i){return j.create("vs/platform/extensionManagement/node/extensionsScanner",i)}),define(Y[80],Q([4,5]),function(j,i){return j.create("vs/platform/extensions/common/extensionValidator",i)}),define(Y[81],Q([4,5]),function(j,i){return j.create("vs/platform/files/common/fileService",i)}),define(Y[82],Q([4,5]),function(j,i){return j.create("vs/platform/files/common/io",i)}),define(Y[83],Q([4,5]),function(j,i){return j.create("vs/platform/files/node/diskFileSystemProvider",i)}),define(Y[84],Q([4,5]),function(j,i){return j.create("vs/platform/request/common/request",i)}),define(Y[85],Q([4,5]),function(j,i){return j.create("vs/platform/telemetry/common/telemetryService",i)}),define(Y[86],Q([4,5]),function(j,i){return j.create("vs/platform/terminal/node/shellEnv",i)}),define(Y[87],Q([0,1,67,44,10,11,29,19,9]),function(j,i,D,R,b,I,L,P,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.parsePtyHostPort=i.parseSearchPort=i.parseExtensionHostPort=i.AbstractNativeEnvironmentService=void 0;class p{constructor(g,u,f){this._args=g,this.paths=u,this.productService=f}get appRoot(){return(0,I.dirname)(b.FileAccess.asFileUri("",j).fsPath)}get userHome(){return l.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return l.URI.file((0,I.join)(this.userDataPath,"User"))}get tmpDir(){return l.URI.file(this.paths.tmpDir)}get cacheHome(){return l.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const g=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,I.join)(this.userDataPath,"logs",g)}return this.args.logsPath}get userDataSyncLogResource(){return l.URI.file((0,I.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(l.URI.file((0,I.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return l.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return l.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=L.env.VSCODE_PORTABLE;return g?l.URI.file((0,I.join)(g,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,P.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return l.URI.file((0,I.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,I.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,I.resolve)(g):(0,I.normalize)((0,I.join)(b.FileAccess.asFileUri("",j).fsPath,"..","extensions"))}get extensionsDownloadPath(){const g=this.args["extensions-download-dir"];return g?(0,I.resolve)(g):(0,I.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,I.resolve)(g);const u=L.env.VSCODE_EXTENSIONS;if(u)return u;const f=L.env.VSCODE_PORTABLE;return f?(0,I.join)(f,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(u=>/^[^:/?#]+?:\/\//.test(u)?l.URI.parse(u):l.URI.file((0,I.normalize)(u)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?l.URI.parse(g):l.URI.file((0,I.normalize)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!L.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,P.joinPath)(l.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return l.URI.file((0,I.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}ge([R.memoize],p.prototype,"appRoot",null),ge([R.memoize],p.prototype,"userHome",null),ge([R.memoize],p.prototype,"userDataPath",null),ge([R.memoize],p.prototype,"appSettingsHome",null),ge([R.memoize],p.prototype,"tmpDir",null),ge([R.memoize],p.prototype,"cacheHome",null),ge([R.memoize],p.prototype,"userRoamingDataHome",null),ge([R.memoize],p.prototype,"settingsResource",null),ge([R.memoize],p.prototype,"userDataSyncHome",null),ge([R.memoize],p.prototype,"userDataSyncLogResource",null),ge([R.memoize],p.prototype,"sync",null),ge([R.memoize],p.prototype,"machineSettingsResource",null),ge([R.memoize],p.prototype,"globalStorageHome",null),ge([R.memoize],p.prototype,"workspaceStorageHome",null),ge([R.memoize],p.prototype,"keybindingsResource",null),ge([R.memoize],p.prototype,"keyboardLayoutResource",null),ge([R.memoize],p.prototype,"argvResource",null),ge([R.memoize],p.prototype,"snippetsHome",null),ge([R.memoize],p.prototype,"isExtensionDevelopment",null),ge([R.memoize],p.prototype,"untitledWorkspacesHome",null),ge([R.memoize],p.prototype,"installSourcePath",null),ge([R.memoize],p.prototype,"builtinExtensionsPath",null),ge([R.memoize],p.prototype,"extensionsPath",null),ge([R.memoize],p.prototype,"extensionDevelopmentLocationURI",null),ge([R.memoize],p.prototype,"extensionDevelopmentKind",null),ge([R.memoize],p.prototype,"extensionTestsLocationURI",null),ge([R.memoize],p.prototype,"debugExtensionHost",null),ge([R.memoize],p.prototype,"serviceMachineIdResource",null),ge([R.memoize],p.prototype,"telemetryLogResource",null),ge([R.memoize],p.prototype,"disableWorkspaceTrust",null),i.AbstractNativeEnvironmentService=p;function C(w,g){return y(w["inspect-extensions"],w["inspect-brk-extensions"],5870,g,w.debugId,w.extensionEnvironment)}i.parseExtensionHostPort=C;function T(w,g){return y(w["inspect-search"],w["inspect-brk-search"],5876,g,w.extensionEnvironment)}i.parseSearchPort=T;function d(w,g){return y(w["inspect-ptyhost"],w["inspect-brk-ptyhost"],5877,g,w.extensionEnvironment)}i.parsePtyHostPort=d;function y(w,g,u,f,E,v){const o=Number(g||w)||(f?null:u),e=o?Boolean(!!g):!1;let r;if(v)try{r=JSON.parse(v)}catch{}return{port:o,break:e,debugId:E,env:r}}}),function(){"use strict";function j(i,D,R,b){function I(P){const l=L(P),p=[l];return i.isAbsolute(l)||p.unshift(b),i.resolve(...p)}function L(P){const l=process.env.VSCODE_PORTABLE;if(l)return i.join(l,"user-data");let p=process.env.VSCODE_APPDATA;if(p)return i.join(p,R);const C=P["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if(p=process.env.APPDATA,!p){const T=process.env.USERPROFILE;if(typeof T!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");p=i.join(T,"AppData","Roaming")}break;case"darwin":p=i.join(D.homedir(),"Library","Application Support");break;case"linux":p=process.env.XDG_CONFIG_HOME||i.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return i.join(p,R)}return{getUserDataPath:I}}if(typeof define=="function")define(Y[88],Q([0,133,33,10,19,29]),function(i,D,R,b,I,L){const P=I.dirname(b.FileAccess.asFileUri("",i)),l=i.__$__nodeRequire(I.joinPath(P,"package.json").fsPath);return j(D,R,l.name,L.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const i=require("../../../../../package.json"),D=require("path"),R=require("os");module.exports=j(D,R,i.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Y[89],Q([0,1,33,87,88]),function(j,i,D,R,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NativeEnvironmentService=void 0;class I extends R.AbstractNativeEnvironmentService{constructor(P,l){super(P,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,b.getUserDataPath)(P)},l)}}i.NativeEnvironmentService=I}),define(Y[90],Q([0,1,22]),function(j,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.localizeManifest=void 0;const R=/^%([\w\d.-]+)%$/i;function b(I,L){const P=l=>{if(typeof l!="string")return;const p=R.exec(l);if(!p)return;const C=L[p[1]]??l;return typeof C=="string"?C:typeof C.message=="string"?C.message:l};return(0,D.cloneAndChange)(I,P)}i.localizeManifest=b}),define(Y[48],Q([0,1,80]),function(j,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isEngineValid=i.isValidExtensionVersion=i.isValidVersion=i.normalizeVersion=i.parseVersion=i.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function I(d){return d=d.trim(),d==="*"||R.test(d)}i.isValidVersionStr=I;function L(d){if(!I(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let y=d.match(R);return y?{hasCaret:y[1]==="^",hasGreaterEquals:y[1]===">=",majorBase:y[2]==="x"?0:parseInt(y[2],10),majorMustEqual:y[2]!=="x",minorBase:y[4]==="x"?0:parseInt(y[4],10),minorMustEqual:y[4]!=="x",patchBase:y[6]==="x"?0:parseInt(y[6],10),patchMustEqual:y[6]!=="x",preRelease:y[8]||null}:null}i.parseVersion=L;function P(d){if(!d)return null;let y=d.majorBase,w=d.majorMustEqual,g=d.minorBase,u=d.minorMustEqual,f=d.patchBase,E=d.patchMustEqual;d.hasCaret&&(y===0||(u=!1),E=!1);let v=0;if(d.preRelease){const m=b.exec(d.preRelease);if(m){const[,o,e,r]=m;v=Date.UTC(Number(o),Number(e)-1,Number(r))}}return{majorBase:y,majorMustEqual:w,minorBase:g,minorMustEqual:u,patchBase:f,patchMustEqual:E,isMinimum:d.hasGreaterEquals,notBefore:v}}i.normalizeVersion=P;function l(d,y,w){let g;typeof d=="string"?g=P(L(d)):g=d;let u;y instanceof Date?u=y.getTime():typeof y=="string"&&(u=new Date(y).getTime());let f;if(typeof w=="string"?f=P(L(w)):f=w,!g||!f)return!1;let E=g.majorBase,v=g.minorBase,m=g.patchBase,o=f.majorBase,e=f.minorBase,r=f.patchBase,t=f.notBefore,n=f.majorMustEqual,s=f.minorMustEqual,a=f.patchMustEqual;return f.isMinimum?E>o?!0:E<o?!1:v>e?!0:v<e||u&&u<t?!1:m>=r:(E===1&&o===0&&(!n||!s||!a)&&(o=1,e=0,r=0,n=!0,s=!1,a=!1),E<o?!1:E>o?!n:v<e?!1:v>e?!s:m<r?!1:m>r?!a:!(u&&u<t))}i.isValidVersion=l;function p(d,y,w,g){return w.isBuiltin||typeof w.main=="undefined"?!0:T(d,y,w.engines.vscode,g)}i.isValidExtensionVersion=p;function C(d,y,w){return d==="*"||T(y,w,d)}i.isEngineValid=C;function T(d,y,w,g=[]){let u=P(L(w));if(!u)return g.push(D.localize(0,null,w)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return g.push(D.localize(1,null,w)),!1}else if(!u.majorMustEqual)return g.push(D.localize(2,null,w)),!1;return l(d,y,u)?!0:(g.push(D.localize(3,null,d,w)),!1)}}),define(Y[91],Q([0,1,17,27]),function(j,i,D,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getServiceMachineId=void 0;async function b(I,L,P){let l=P&&P.get("storage.serviceMachineId",0)||null;if(l)return l;try{const C=(await L.readFile(I.serviceMachineIdResource)).value.toString();l=(0,R.isUUID)(C)?C:null}catch{l=null}if(!l){l=(0,R.generateUuid)();try{await L.writeFile(I.serviceMachineIdResource,D.VSBuffer.fromString(l))}catch{}}return P&&P.store("storage.serviceMachineId",l,0,1),l}i.getServiceMachineId=b}),define(Y[40],Q([0,1]),function(j,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SyncDescriptor=void 0;class D{constructor(b,I=[],L=!1){this.ctor=b,this.staticArguments=I,this.supportsDelayedInstantiation=L}}i.SyncDescriptor=D}),define(Y[92],Q([0,1,40]),function(j,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getSingletonServiceDescriptors=i.registerSingleton=void 0;const R=[];function b(L,P,l){P instanceof D.SyncDescriptor||(P=new D.SyncDescriptor(P,[],l)),R.push([L,P])}i.registerSingleton=b;function I(){return R}i.getSingletonServiceDescriptors=I}),define(Y[93],Q([0,1]),function(j,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Graph=i.Node=void 0;class D{constructor(I){this.incoming=new Map,this.outgoing=new Map,this.data=I}}i.Node=D;class R{constructor(I){this._hashFn=I,this._nodes=new Map}roots(){const I=[];for(let L of this._nodes.values())L.outgoing.size===0&&I.push(L);return I}insertEdge(I,L){const P=this.lookupOrInsertNode(I),l=this.lookupOrInsertNode(L);P.outgoing.set(this._hashFn(L),l),l.incoming.set(this._hashFn(I),P)}removeNode(I){const L=this._hashFn(I);this._nodes.delete(L);for(let P of this._nodes.values())P.outgoing.delete(L),P.incoming.delete(L)}lookupOrInsertNode(I){const L=this._hashFn(I);let P=this._nodes.get(L);return P||(P=new D(I),this._nodes.set(L,P)),P}lookup(I){return this._nodes.get(this._hashFn(I))}isEmpty(){return this._nodes.size===0}toString(){let I=[];for(let[L,P]of this._nodes)I.push(`${L}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return I.join(`
`)}findCycleSlow(){for(let[I,L]of this._nodes){const P=new Set([I]),l=this._findCycle(L,P);if(l)return l}}_findCycle(I,L){for(let[P,l]of I.outgoing){if(L.has(P))return[...L,P].join(" -> ");L.add(P);const p=this._findCycle(l,L);if(p)return p;L.delete(P)}}}i.Graph=R}),define(Y[25],Q([0,1,6,9,13]),function(j,i,D,R,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getMigratedSettingValue=i.merge=i.getConfigurationValue=i.removeFromValueTree=i.addToValueTree=i.toValuesTree=i.ConfigurationTargetToString=i.ConfigurationTarget=i.isConfigurationUpdateOverrides=i.isConfigurationOverrides=i.IConfigurationService=void 0,i.IConfigurationService=(0,b.createDecorator)("configurationService");function I(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof R.URI)}i.isConfigurationOverrides=I;function L(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||D.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof R.URI)}i.isConfigurationUpdateOverrides=L;var P;(function(u){u[u.USER=1]="USER",u[u.USER_LOCAL=2]="USER_LOCAL",u[u.USER_REMOTE=3]="USER_REMOTE",u[u.WORKSPACE=4]="WORKSPACE",u[u.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",u[u.DEFAULT=6]="DEFAULT",u[u.MEMORY=7]="MEMORY"})(P=i.ConfigurationTarget||(i.ConfigurationTarget={}));function l(u){switch(u){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}i.ConfigurationTargetToString=l;function p(u,f){const E=Object.create(null);for(let v in u)C(E,v,u[v],f);return E}i.toValuesTree=p;function C(u,f,E,v){const m=f.split("."),o=m.pop();let e=u;for(let r=0;r<m.length;r++){let t=m[r],n=e[t];switch(typeof n){case"undefined":n=e[t]=Object.create(null);break;case"object":break;default:v(`Ignoring ${f} as ${m.slice(0,r+1).join(".")} is ${JSON.stringify(n)}`);return}e=n}if(typeof e=="object"&&e!==null)try{e[o]=E}catch{v(`Ignoring ${f} as ${m.join(".")} is ${JSON.stringify(e)}`)}else v(`Ignoring ${f} as ${m.join(".")} is ${JSON.stringify(e)}`)}i.addToValueTree=C;function T(u,f){const E=f.split(".");d(u,E)}i.removeFromValueTree=T;function d(u,f){const E=f.shift();if(f.length===0){delete u[E];return}if(Object.keys(u).indexOf(E)!==-1){const v=u[E];typeof v=="object"&&!Array.isArray(v)&&(d(v,f),Object.keys(v).length===0&&delete u[E])}}function y(u,f,E){function v(e,r){let t=e;for(const n of r){if(typeof t!="object"||t===null)return;t=t[n]}return t}const m=f.split("."),o=v(u,m);return typeof o=="undefined"?E:o}i.getConfigurationValue=y;function w(u,f,E){Object.keys(f).forEach(v=>{v!=="__proto__"&&(v in u?D.isObject(u[v])&&D.isObject(f[v])?w(u[v],f[v],E):E&&(u[v]=f[v]):u[v]=f[v])})}i.merge=w;function g(u,f,E){const v=u.inspect(f),m=u.inspect(E);return typeof v.userValue!="undefined"||typeof v.workspaceValue!="undefined"||typeof v.workspaceFolderValue!="undefined"?v.value:typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:v.defaultValue}i.getMigratedSettingValue=g}),define(Y[49],Q([0,1,13]),function(j,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IDownloadService=void 0,i.IDownloadService=(0,D.createDecorator)("downloadService")}),define(Y[20],Q([0,1,13]),function(j,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.INativeEnvironmentService=i.IEnvironmentService=void 0,i.IEnvironmentService=(0,D.createDecorator)("environmentService"),i.INativeEnvironmentService=(0,D.refineServiceDecorator)(i.IEnvironmentService)}),define(Y[50],Q([0,1,17,8,82,16]),function(j,i,D,R,b,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.readFileIntoStream=void 0;async function L(C,T,d,y,w,g){let u;try{await P(C,T,d,y,w,g)}catch(f){u=f}finally{u&&w.errorTransformer&&(u=w.errorTransformer(u)),typeof u!="undefined"&&d.error(u),d.end()}}i.readFileIntoStream=L;async function P(C,T,d,y,w,g){l(g);const u=await C.open(T,{create:!1});try{l(g);let f=0,E=0,v=w&&typeof w.length=="number"?w.length:void 0,m=D.VSBuffer.alloc(Math.min(w.bufferSize,typeof v=="number"?v:w.bufferSize)),o=w&&typeof w.position=="number"?w.position:0,e=0;do E=await C.read(u,o,m.buffer,e,m.byteLength-e),o+=E,e+=E,f+=E,typeof v=="number"&&(v-=E),e===m.byteLength&&(await d.write(y(m)),m=D.VSBuffer.alloc(Math.min(w.bufferSize,typeof v=="number"?v:w.bufferSize)),e=0);while(E>0&&(typeof v!="number"||v>0)&&l(g)&&p(f,w));if(e>0){let r=e;typeof v=="number"&&(r=Math.min(e,v)),d.write(y(m.slice(0,r)))}}catch(f){throw(0,I.ensureFileSystemProviderError)(f)}finally{await C.close(u)}}function l(C){if(C.isCancellationRequested)throw(0,R.canceled)();return!0}function p(C,T){if(T?.limits){if(typeof T.limits.memory=="number"&&C>T.limits.memory)throw(0,I.createFileSystemProviderError)((0,b.localize)(0,null),I.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof T.limits.size=="number"&&C>T.limits.size)throw(0,I.createFileSystemProviderError)((0,b.localize)(1,null),I.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Y[94],Q([0,1,18,7,2,12,134]),function(j,i,D,R,b,I,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NodeJSWatcher=void 0;class P extends b.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new R.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=R.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(p){const C=this.normalizeRequests(p),T=C.filter(y=>{const w=this.watchers.get(y.path);return w?!(0,D.equals)(w.request.excludes,y.excludes):!0}),d=Array.from(this.watchers.values()).filter(({request:y})=>!C.find(w=>w.path===y.path&&(0,D.equals)(w.excludes,y.excludes))).map(({request:y})=>y.path);T.length&&this.trace(`Request to start watching: ${T.map(y=>`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"})`).join(",")}`),d.length&&this.trace(`Request to stop watching: ${d.join(",")}`);for(const y of d)this.stopWatching(y);for(const y of T)this.startWatching(y)}startWatching(p){const C=new L.NodeJSFileWatcherLibrary(p,d=>this._onDidChangeFile.fire(d),d=>this._onDidLogMessage.fire(d),this.verboseLogging),T={request:p,instance:C};this.watchers.set(p.path,T)}async stop(){for(const[p]of this.watchers)this.stopWatching(p);this.watchers.clear()}stopWatching(p){const C=this.watchers.get(p);C&&(this.watchers.delete(p),C.instance.dispose())}normalizeRequests(p){const C=new Map;for(const T of p){const d=I.isLinux?T.path:T.path.toLowerCase();C.set(d,T)}return Array.from(C.values())}async setVerboseLogging(p){this.verboseLogging=p;for(const[,C]of this.watchers)C.instance.setVerboseLogging(p)}trace(p){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(p)})}toMessage(p,C){return C?`[File Watcher (node.js)] ${p} (path: ${C.request.path})`:`[File Watcher (node.js)] ${p}`}}i.NodeJSWatcher=P}),define(Y[95],Q([0,1,51,94]),function(j,i,D,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NodeJSWatcherClient=void 0;class b extends D.AbstractNonRecursiveWatcherClient{constructor(L,P,l){super(L,P,l);this.init()}createWatcher(){return new R.NodeJSWatcher}}i.NodeJSWatcherClient=b}),define(Y[96],Q([0,1,10,46,71,51]),function(j,i,D,R,b,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UniversalWatcherClient=void 0;class L extends I.AbstractUniversalWatcherClient{constructor(l,p,C){super(l,p,C);this.init()}createWatcher(l){const p=l.add(new b.Client(D.FileAccess.asFileUri("bootstrap-fork",j).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return l.add(p.onDidProcessExit(({code:C,signal:T})=>this.onError(`terminated by itself with code ${C}, signal: ${T}`))),R.ProxyChannel.toService((0,R.getNextTickChannel)(p.getChannel("watcher")))}}i.UniversalWatcherClient=L}),define(Y[52],Q([0,1]),function(j,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ServiceCollection=void 0;class D{constructor(...b){this._entries=new Map;for(let[I,L]of b)this.set(I,L)}set(b,I){const L=this._entries.get(b);return this._entries.set(b,I),L}has(b){return this._entries.has(b)}get(b){return this._entries.get(b)}}i.ServiceCollection=D}),define(Y[97],Q([0,1,3,8,40,93,13,52]),function(j,i,D,R,b,I,L,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Trace=i.InstantiationService=void 0;const l=!1;class p extends Error{constructor(w){super("cyclic dependency between services");this.message=w.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${w.toString()}`}}class C{constructor(w=new P.ServiceCollection,g=!1,u){this._activeInstantiations=new Set,this._services=w,this._strict=g,this._parent=u,this._services.set(L.IInstantiationService,this)}createChild(w){return new C(w,this._strict,this)}invokeFunction(w,...g){let u=d.traceInvocation(w),f=!1;try{return w({get:v=>{if(f)throw(0,R.illegalState)("service accessor is only valid during the invocation of its target method");const m=this._getOrCreateServiceInstance(v,u);if(!m)throw new Error(`[invokeFunction] unknown service '${v}'`);return m}},...g)}finally{f=!0,u.stop()}}createInstance(w,...g){let u,f;return w instanceof b.SyncDescriptor?(u=d.traceCreation(w.ctor),f=this._createInstance(w.ctor,w.staticArguments.concat(g),u)):(u=d.traceCreation(w),f=this._createInstance(w,g,u)),u.stop(),f}_createInstance(w,g=[],u){let f=L._util.getServiceDependencies(w).sort((m,o)=>m.index-o.index),E=[];for(const m of f){let o=this._getOrCreateServiceInstance(m.id,u);o||this._throwIfStrict(`[createInstance] ${w.name} depends on UNKNOWN service ${m.id}.`,!1),E.push(o)}let v=f.length>0?f[0].index:g.length;if(g.length!==v){console.warn(`[createInstance] First service dependency of ${w.name} at position ${v+1} conflicts with ${g.length} static arguments`);let m=v-g.length;m>0?g=g.concat(new Array(m)):g=g.slice(0,v)}return new w(...[...g,...E])}_setServiceInstance(w,g){if(this._services.get(w)instanceof b.SyncDescriptor)this._services.set(w,g);else if(this._parent)this._parent._setServiceInstance(w,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(w){let g=this._services.get(w);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(w):g}_getOrCreateServiceInstance(w,g){let u=this._getServiceInstanceOrDescriptor(w);return u instanceof b.SyncDescriptor?this._safeCreateAndCacheServiceInstance(w,u,g.branch(w,!0)):(g.branch(w,!1),u)}_safeCreateAndCacheServiceInstance(w,g,u){if(this._activeInstantiations.has(w))throw new Error(`illegal state - RECURSIVELY instantiating service '${w}'`);this._activeInstantiations.add(w);try{return this._createAndCacheServiceInstance(w,g,u)}finally{this._activeInstantiations.delete(w)}}_createAndCacheServiceInstance(w,g,u){const f=new I.Graph(m=>m.id.toString());let E=0;const v=[{id:w,desc:g,_trace:u}];for(;v.length;){const m=v.pop();if(f.lookupOrInsertNode(m),E++>1e3)throw new p(f);for(let o of L._util.getServiceDependencies(m.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(o.id);if(e||this._throwIfStrict(`[createInstance] ${w} depends on ${o.id} which is NOT registered.`,!0),e instanceof b.SyncDescriptor){const r={id:o.id,desc:e,_trace:m._trace.branch(o.id,!0)};f.insertEdge(m,r),v.push(r)}}}for(;;){const m=f.roots();if(m.length===0){if(!f.isEmpty())throw new p(f);break}for(const{data:o}of m){if(this._getServiceInstanceOrDescriptor(o.id)instanceof b.SyncDescriptor){const r=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,r)}f.removeNode(o)}}return this._getServiceInstanceOrDescriptor(w)}_createServiceInstanceWithOwner(w,g,u=[],f,E){if(this._services.get(w)instanceof b.SyncDescriptor)return this._createServiceInstance(g,u,f,E);if(this._parent)return this._parent._createServiceInstanceWithOwner(w,g,u,f,E);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(w,g=[],u,f){if(u){const E=new D.IdleValue(()=>this._createInstance(w,g,f));return new Proxy(Object.create(null),{get(v,m){if(m in v)return v[m];let o=E.value,e=o[m];return typeof e!="function"||(e=e.bind(o),v[m]=e),e},set(v,m,o){return E.value[m]=o,!0}})}else return this._createInstance(w,g,f)}_throwIfStrict(w,g){if(g&&console.warn(g),this._strict)throw new Error(w)}}i.InstantiationService=C;var T;(function(y){y[y.Creation=0]="Creation",y[y.Invocation=1]="Invocation",y[y.Branch=2]="Branch"})(T||(T={}));class d{constructor(w,g){this.type=w,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(w){return l?new d(1,w.name||w.toString().substring(0,42).replace(/\n/g,"")):d._None}static traceCreation(w){return l?new d(0,w.name):d._None}branch(w,g){let u=new d(2,w.toString());return this._dep.push([w,g,u]),u}stop(){let w=Date.now()-this._start;d._totals+=w;let g=!1;function u(E,v){let m=[],o=new Array(E+1).join("	");for(const[e,r,t]of v._dep)if(r&&t){g=!0,m.push(`${o}CREATES -> ${e}`);let n=u(E+1,t);n&&m.push(n)}else m.push(`${o}uses -> ${e}`);return m.join(`
`)}let f=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${w.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(w>2||g)&&console.log(f.join(`
`))}}i.Trace=d,d._None=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d._totals=0}),define(Y[53],Q([0,1,13]),function(j,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isValidLocalization=i.ILocalizationsService=void 0,i.ILocalizationsService=(0,D.createDecorator)("localizationsService");function R(b){if(typeof b.languageId!="string"||!Array.isArray(b.translations)||b.translations.length===0)return!1;for(const I of b.translations)if(typeof I.id!="string"||typeof I.path!="string")return!1;return!(b.languageName&&typeof b.languageName!="string"||b.localizedLanguageName&&typeof b.localizedLanguageName!="string")}i.isValidLocalization=R}),define(Y[14],Q([0,1,28,7,2,12,13]),function(j,i,D,R,b,I,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LogLevelToString=i.parseLogLevel=i.getLogLevel=i.NullLogService=i.AbstractLoggerService=i.LogService=i.MultiplexLogService=i.AdapterLogger=i.ConsoleLogger=i.ConsoleMainLogger=i.AbstractMessageLogger=i.AbstractLogger=i.format=i.log=i.DEFAULT_LOG_LEVEL=i.LogLevel=i.ILoggerService=i.ILogService=void 0,i.ILogService=(0,L.createDecorator)("logService"),i.ILoggerService=(0,L.createDecorator)("loggerService");function P(){return new Date().toISOString()}var l;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(l=i.LogLevel||(i.LogLevel={})),i.DEFAULT_LOG_LEVEL=l.Info;function p(r,t,n){switch(t){case l.Trace:r.trace(n);break;case l.Debug:r.debug(n);break;case l.Info:r.info(n);break;case l.Warning:r.warn(n);break;case l.Error:r.error(n);break;case l.Critical:r.critical(n);break;default:throw new Error("Invalid log level")}}i.log=p;function C(r){let t="";for(let n=0;n<r.length;n++){let s=r[n];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}t+=(n>0?" ":"")+s}return t}i.format=C;class T extends b.Disposable{constructor(){super(...arguments);this.level=i.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new R.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}i.AbstractLogger=T;class d extends T{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...n){this.checkLogLevel(l.Trace)&&this.log(l.Trace,C([t,...n]))}debug(t,...n){this.checkLogLevel(l.Debug)&&this.log(l.Debug,C([t,...n]))}info(t,...n){this.checkLogLevel(l.Info)&&this.log(l.Info,C([t,...n]))}warn(t,...n){this.checkLogLevel(l.Warning)&&this.log(l.Warning,C([t,...n]))}error(t,...n){if(this.checkLogLevel(l.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(l.Error,C(s))}else this.log(l.Error,C([t,...n]))}critical(t,...n){this.checkLogLevel(l.Critical)&&this.log(l.Critical,C([t,...n]))}flush(){}}i.AbstractMessageLogger=d;class y extends T{constructor(t=i.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!I.isWindows}trace(t,...n){this.getLevel()<=l.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...n):console.log(`[main ${P()}]`,t,...n))}debug(t,...n){this.getLevel()<=l.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...n):console.log(`[main ${P()}]`,t,...n))}info(t,...n){this.getLevel()<=l.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...n):console.log(`[main ${P()}]`,t,...n))}warn(t,...n){this.getLevel()<=l.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,t,...n):console.warn(`[main ${P()}]`,t,...n))}error(t,...n){this.getLevel()<=l.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,t,...n):console.error(`[main ${P()}]`,t,...n))}critical(t,...n){this.getLevel()<=l.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,t,...n):console.error(`[main ${P()}]`,t,...n))}dispose(){}flush(){}}i.ConsoleMainLogger=y;class w extends T{constructor(t=i.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...n){this.getLevel()<=l.Trace&&console.log("%cTRACE","color: #888",t,...n)}debug(t,...n){this.getLevel()<=l.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...n)}info(t,...n){this.getLevel()<=l.Info&&console.log("%c INFO","color: #33f",t,...n)}warn(t,...n){this.getLevel()<=l.Warning&&console.log("%c WARN","color: #993",t,...n)}error(t,...n){this.getLevel()<=l.Error&&console.log("%c  ERR","color: #f33",t,...n)}critical(t,...n){this.getLevel()<=l.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...n)}dispose(){}flush(){}}i.ConsoleLogger=w;class g extends T{constructor(t,n=i.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(n)}trace(t,...n){this.getLevel()<=l.Trace&&this.adapter.log(l.Trace,[this.extractMessage(t),...n])}debug(t,...n){this.getLevel()<=l.Debug&&this.adapter.log(l.Debug,[this.extractMessage(t),...n])}info(t,...n){this.getLevel()<=l.Info&&this.adapter.log(l.Info,[this.extractMessage(t),...n])}warn(t,...n){this.getLevel()<=l.Warning&&this.adapter.log(l.Warning,[this.extractMessage(t),...n])}error(t,...n){this.getLevel()<=l.Error&&this.adapter.log(l.Error,[this.extractMessage(t),...n])}critical(t,...n){this.getLevel()<=l.Critical&&this.adapter.log(l.Critical,[this.extractMessage(t),...n])}extractMessage(t){return typeof t=="string"?t:(0,D.toErrorMessage)(t,this.getLevel()<=l.Trace)}dispose(){}flush(){}}i.AdapterLogger=g;class u extends T{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const n of this.logServices)n.setLevel(t);super.setLevel(t)}trace(t,...n){for(const s of this.logServices)s.trace(t,...n)}debug(t,...n){for(const s of this.logServices)s.debug(t,...n)}info(t,...n){for(const s of this.logServices)s.info(t,...n)}warn(t,...n){for(const s of this.logServices)s.warn(t,...n)}error(t,...n){for(const s of this.logServices)s.error(t,...n)}critical(t,...n){for(const s of this.logServices)s.critical(t,...n)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}i.MultiplexLogService=u;class f extends b.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...n){this.logger.trace(t,...n)}debug(t,...n){this.logger.debug(t,...n)}info(t,...n){this.logger.info(t,...n)}warn(t,...n){this.logger.warn(t,...n)}error(t,...n){this.logger.error(t,...n)}critical(t,...n){this.logger.critical(t,...n)}flush(){this.logger.flush()}}i.LogService=f;class E extends b.Disposable{constructor(t,n){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(s))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,n){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,n?.always?l.Trace:this.logLevel,n),this.loggers.set(t.toString(),s),n?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}i.AbstractLoggerService=E;class v{constructor(){this.onDidChangeLogLevel=new R.Emitter().event}setLevel(t){}getLevel(){return l.Info}trace(t,...n){}debug(t,...n){}info(t,...n){}warn(t,...n){}error(t,...n){}critical(t,...n){}dispose(){}flush(){}}i.NullLogService=v;function m(r){if(r.verbose)return l.Trace;if(typeof r.logLevel=="string"){const t=o(r.logLevel.toLowerCase());if(t!==void 0)return t}return i.DEFAULT_LOG_LEVEL}i.getLogLevel=m;function o(r){switch(r){case"trace":return l.Trace;case"debug":return l.Debug;case"info":return l.Info;case"warn":return l.Warning;case"error":return l.Error;case"critical":return l.Critical;case"off":return l.Off}}i.parseLogLevel=o;function e(r){switch(r){case l.Trace:return"trace";case l.Debug:return"debug";case l.Info:return"info";case l.Warning:return"warn";case l.Error:return"error";case l.Critical:return"critical";case l.Off:return"off"}}i.LogLevelToString=e});var oe=this&&this.__param||function(j,i){return function(D,R){i(D,R,j)}};define(Y[98],Q([0,1,39,3,28,7,2,10,11,15,20,14]),function(j,i,D,R,b,I,L,P,l,p,C,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsLifecycle=void 0;let d=class extends L.Disposable{constructor(w,g){super();this.environmentService=w,this.logService=g,this.processesLimiter=new R.Limiter(5)}async postUninstall(w){const g=this.parseScript(w,"uninstall");return g&&(this.logService.info(w.identifier.id,w.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(g.script,"uninstall",g.args,!0,w).then(()=>this.logService.info(w.identifier.id,w.manifest.version,"Finished running post uninstall script"),u=>this.logService.error(w.identifier.id,w.manifest.version,`Failed to run post uninstall script: ${u}`)))),p.Promises.rm(this.getExtensionStoragePath(w)).then(void 0,u=>this.logService.error("Error while removing extension storage path",u))}parseScript(w,g){const u=`vscode:${g}`;if(w.location.scheme===P.Schemas.file&&w.manifest&&w.manifest.scripts&&typeof w.manifest.scripts[u]=="string"){const f=w.manifest.scripts[u].split(" ");return f.length<2||f[0]!=="node"||!f[1]?(this.logService.warn(w.identifier.id,w.manifest.version,`${u} should be a node script`),null):{script:(0,l.join)(w.location.fsPath,f[1]),args:f.slice(2)||[]}}return null}runLifecycleHook(w,g,u,f,E){return new Promise((v,m)=>{const o=this.start(w,g,u,E);let e;const r=t=>{e&&(clearTimeout(e),e=null),t?m(t):v(void 0)};o.on("error",t=>{r((0,b.toErrorMessage)(t)||"Unknown")}),o.on("exit",(t,n)=>{r(t?`post-${g} process exited with code ${t}`:void 0)}),f&&(e=setTimeout(()=>{e=null,o.kill(),m("timed out")},5e3))})}start(w,g,u,f){const E={silent:!0,execArgv:void 0},v=(0,D.fork)(w,[`--type=extension-post-${g}`,...u],E);v.stdout.setEncoding("utf8"),v.stderr.setEncoding("utf8");const m=I.Event.fromNodeEventEmitter(v.stdout,"data"),o=I.Event.fromNodeEventEmitter(v.stderr,"data");m(t=>this.logService.info(f.identifier.id,f.manifest.version,`post-${g}`,t)),o(t=>this.logService.error(f.identifier.id,f.manifest.version,`post-${g}`,t));const e=I.Event.any(I.Event.map(m,t=>({data:`%c${t}`,format:[""]})),I.Event.map(o,t=>({data:`%c${t}`,format:["color: red"]})));return I.Event.debounce(e,(t,n)=>t?{data:t.data+n.data,format:[...t.format,...n.format]}:{data:n.data,format:n.format},100)(t=>{console.group(f.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),v}getExtensionStoragePath(w){return(0,l.join)(this.environmentService.globalStorageHome.fsPath,w.identifier.id.toLowerCase())}};d=ge([oe(0,C.IEnvironmentService),oe(1,T.ILogService)],d),i.ExtensionsLifecycle=d}),define(Y[99],Q([0,1,18,3,8,7,2,11,51,14]),function(j,i,D,R,b,I,L,P,l,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractDiskFileSystemProvider=void 0;class C extends L.Disposable{constructor(d,y){super();this.logService=d,this.options=y,this._onDidChangeFile=this._register(new I.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new I.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new R.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new R.ThrottledDelayer(0))}watch(d,y){return y.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(d,y):this.watchNonRecursive(d,y)}watchUniversal(d,y){const w={path:this.toFilePath(d),excludes:y.excludes,recursive:y.recursive},g=(0,D.insert)(this.universalPathsToWatch,w);return this.refreshUniversalWatchers(),(0,L.toDisposable)(()=>{g(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(d=>(0,b.onUnexpectedError)(d))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(y=>this._onDidChangeFile.fire((0,l.toFileChanges)(y)),y=>this.onWatcherLogMessage(y),this.logService.getLevel()===p.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===p.LogLevel.Trace)})));const d=this.options?.watcher?.recursive?.usePolling;if(d===!0)for(const y of this.universalPathsToWatch)(0,l.isRecursiveWatchRequest)(y)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(d))for(const y of this.universalPathsToWatch)(0,l.isRecursiveWatchRequest)(y)&&d.includes(y.path)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(d,y){const w={path:this.toFilePath(d),excludes:y.excludes,recursive:!1},g=(0,D.insert)(this.nonRecursivePathsToWatch,w);return this.refreshNonRecursiveWatchers(),(0,L.toDisposable)(()=>{g(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(d=>(0,b.onUnexpectedError)(d))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(d=>this._onDidChangeFile.fire((0,l.toFileChanges)(d)),d=>this.onWatcherLogMessage(d),this.logService.getLevel()===p.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===p.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(d){d.type==="error"&&this._onDidWatchError.fire(d.message),this.logService[d.type](d.message)}toFilePath(d){return(0,P.normalize)(d.fsPath)}}i.AbstractDiskFileSystemProvider=C}),define(Y[100],Q([0,1,18,3,17,24,7,59,135,2,54,10,101,19,38,81,16,50,14]),function(j,i,D,R,b,I,L,P,l,p,C,T,d,y,w,g,u,f,E){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.FileService=void 0;let v=class extends p.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new L.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new L.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new L.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new L.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new L.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new R.ResourceQueue)}registerProvider(o,e){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,d.mark)(`code/registerFilesystem/${o}`);const r=new p.DisposableStore;return this.provider.set(o,e),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:e}),r.add(e.onDidChangeFile(t=>this._onDidFilesChange.fire(new u.FileChangesEvent(t,!this.isPathCaseSensitive(e))))),typeof e.onDidWatchError=="function"&&r.add(e.onDidWatchError(t=>this._onDidWatchError.fire(new Error(t)))),r.add(e.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:e,scheme:o}))),(0,p.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:e}),this.provider.delete(o),(0,p.dispose)(r)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const e=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(r){e.push(r)}}),!this.provider.has(o)&&await R.Promises.settled(e)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.provider.has(o.scheme)}hasCapability(o,e){const r=this.provider.get(o.scheme);return!!(r&&r.capabilities&e)}listCapabilities(){return l.Iterable.map(this.provider,([o,e])=>({scheme:o,capabilities:e.capabilities}))}async withProvider(o){if(!(0,y.isAbsolutePath)(o))throw new u.FileOperationError((0,g.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const e=this.provider.get(o.scheme);if(!e){const r=new Error;throw r.name="ENOPRO",r.message=(0,g.localize)(1,null,o.toString()),r}return e}async withReadProvider(o){const e=await this.withProvider(o);if((0,u.hasOpenReadWriteCloseCapability)(e)||(0,u.hasReadWriteCapability)(e)||(0,u.hasFileReadStreamCapability)(e))return e;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const e=await this.withProvider(o);if((0,u.hasOpenReadWriteCloseCapability)(e)||(0,u.hasReadWriteCapability)(e))return e;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,e){try{return await this.doResolveFile(o,e)}catch(r){throw(0,u.toFileSystemProviderErrorCode)(r)===u.FileSystemProviderErrorCode.FileNotFound?new u.FileOperationError((0,g.localize)(2,null,this.resourceForError(o)),1):(0,u.ensureFileSystemProviderError)(r)}}async doResolveFile(o,e){const r=await this.withProvider(o),t=this.isPathCaseSensitive(r),n=e?.resolveTo,s=e?.resolveSingleChildDescendants,a=e?.resolveMetadata,c=await r.stat(o);let h;return this.toFileStat(r,o,c,void 0,!!a,(S,O)=>(h||(h=C.TernarySearchTree.forUris(()=>!t),h.set(o,!0),n&&h.fill(!0,n)),h.get(S.resource)||h.findSuperstr(S.resource.with({query:null,fragment:null}))?!0:S.isDirectory&&s?O===1:!1))}async toFileStat(o,e,r,t,n,s){const{providerExtUri:a}=this.getExtUri(o),c={resource:e,name:a.basename(e),isFile:(r.type&u.FileType.File)!=0,isDirectory:(r.type&u.FileType.Directory)!=0,isSymbolicLink:(r.type&u.FileType.SymbolicLink)!=0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&u.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,u.etag)({mtime:r.mtime,size:r.size}),children:void 0};if(c.isDirectory&&s(c,t)){try{const h=await o.readdir(e),S=await R.Promises.settled(h.map(async([O,N])=>{try{const _=a.joinPath(e,O),J=n?await o.stat(_):{type:N};return await this.toFileStat(o,_,J,h.length,n,s)}catch(_){return this.logService.trace(_),null}}));c.children=(0,D.coalesce)(S)}catch(h){this.logService.trace(h),c.children=[]}return c}return c}async resolveAll(o){return R.Promises.settled(o.map(async e=>{try{return{stat:await this.doResolveFile(e.resource,e.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async stat(o){const e=await this.withProvider(o),r=await e.stat(o);return this.toFileStat(e,o,r,void 0,!0,()=>!1)}async exists(o){const e=await this.withProvider(o);try{return!!await e.stat(o)}catch{return!1}}async canCreateFile(o,e){try{await this.doValidateCreateFile(o,e)}catch(r){return r}return!0}async doValidateCreateFile(o,e){if(!e?.overwrite&&await this.exists(o))throw new u.FileOperationError((0,g.localize)(3,null,this.resourceForError(o)),3,e)}async createFile(o,e=b.VSBuffer.fromString(""),r){await this.doValidateCreateFile(o,r);const t=await this.writeFile(o,e);return this._onDidRunOperation.fire(new u.FileOperationEvent(o,0,t)),t}async writeFile(o,e,r){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:n}=this.getExtUri(t);try{await this.validateWriteFile(t,o,r)||await this.mkdirp(t,n.dirname(o));let a;if((0,u.hasReadWriteCapability)(t)&&!(e instanceof b.VSBuffer))if((0,w.isReadableStream)(e)){const c=await(0,w.peekStream)(e,3);c.ended?a=b.VSBuffer.concat(c.buffer):a=c}else a=(0,w.peekReadable)(e,c=>b.VSBuffer.concat(c),3);else a=e;!(0,u.hasOpenReadWriteCloseCapability)(t)||(0,u.hasReadWriteCapability)(t)&&a instanceof b.VSBuffer?await this.doWriteUnbuffered(t,o,r,a):await this.doWriteBuffered(t,o,r,a instanceof b.VSBuffer?(0,b.bufferToReadable)(a):a),this._onDidRunOperation.fire(new u.FileOperationEvent(o,4))}catch(s){throw new u.FileOperationError((0,g.localize)(4,null,this.resourceForError(o),(0,u.ensureFileSystemProviderError)(s).toString()),(0,u.toFileOperationResult)(s),r)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,e,r){if(!!r?.unlock&&!(o.capabilities&8192))throw new Error((0,g.localize)(5,null,this.resourceForError(e)));let n;try{n=await o.stat(e)}catch{return}if((n.type&u.FileType.Directory)!=0)throw new u.FileOperationError((0,g.localize)(6,null,this.resourceForError(e)),0,r);if(this.throwIfFileIsReadonly(e,n),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==u.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&r.mtime<n.mtime&&r.etag!==(0,u.etag)({mtime:r.mtime,size:n.size}))throw new u.FileOperationError((0,g.localize)(7,null),3,r);return n}async readFile(o,e,r){const t=await this.withReadProvider(o);return e?.atomic?this.doReadFileAtomic(t,o,e,r):this.doReadFile(t,o,e,r)}async doReadFileAtomic(o,e,r,t){return new Promise((n,s)=>{this.writeQueue.queueFor(e,this.getExtUri(o).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(o,e,r,t);n(a)}catch(a){s(a)}})})}async doReadFile(o,e,r,t){const n=await this.doReadFileStream(o,e,{...r,preferUnbuffered:!0},t);return{...n,value:await(0,b.streamToBuffer)(n.value)}}async readFileStream(o,e,r){const t=await this.withReadProvider(o);return this.doReadFileStream(t,o,e,r)}async doReadFileStream(o,e,r,t){const n=new I.CancellationTokenSource(t),s=this.validateReadFile(e,r).then(c=>c,c=>{throw n.cancel(),c});let a;try{return typeof r?.etag=="string"&&r.etag!==u.ETAG_DISABLED&&await s,r?.atomic&&(0,u.hasFileAtomicReadCapability)(o)||!((0,u.hasOpenReadWriteCloseCapability)(o)||(0,u.hasFileReadStreamCapability)(o))||(0,u.hasReadWriteCapability)(o)&&r?.preferUnbuffered?a=this.readFileUnbuffered(o,e,r):(0,u.hasFileReadStreamCapability)(o)?a=this.readFileStreamed(o,e,n.token,r):a=this.readFileBuffered(o,e,n.token,r),{...await s,value:a}}catch(c){a&&await(0,w.consumeStream)(a);const h=(0,g.localize)(8,null,this.resourceForError(e),(0,u.ensureFileSystemProviderError)(c).toString());throw c instanceof u.NotModifiedSinceFileOperationError?new u.NotModifiedSinceFileOperationError(h,c.stat,r):new u.FileOperationError(h,(0,u.toFileOperationResult)(c),r)}}readFileStreamed(o,e,r,t=Object.create(null)){const n=o.readFileStream(e,t,r);return(0,w.transform)(n,{data:s=>s instanceof b.VSBuffer?s:b.VSBuffer.wrap(s),error:s=>new u.FileOperationError((0,g.localize)(9,null,this.resourceForError(e),(0,u.ensureFileSystemProviderError)(s).toString()),(0,u.toFileOperationResult)(s),t)},s=>b.VSBuffer.concat(s))}readFileBuffered(o,e,r,t=Object.create(null)){const n=(0,b.newWriteableBufferStream)();return(0,f.readFileIntoStream)(o,e,n,s=>s,{...t,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new u.FileOperationError((0,g.localize)(10,null,this.resourceForError(e),(0,u.ensureFileSystemProviderError)(s).toString()),(0,u.toFileOperationResult)(s),t)},r),n}readFileUnbuffered(o,e,r){const t=(0,w.newWriteableStream)(n=>b.VSBuffer.concat(n));return(async()=>{try{let n;r?.atomic&&(0,u.hasFileAtomicReadCapability)(o)?n=await o.readFile(e,{atomic:!0}):n=await o.readFile(e),typeof r?.position=="number"&&(n=n.slice(r.position)),typeof r?.length=="number"&&(n=n.slice(0,r.length)),this.validateReadFileLimits(e,n.byteLength,r),t.end(b.VSBuffer.wrap(n))}catch(n){t.error(n),t.end()}})(),t}async validateReadFile(o,e){const r=await this.resolve(o,{resolveMetadata:!0});if(r.isDirectory)throw new u.FileOperationError((0,g.localize)(11,null,this.resourceForError(o)),0,e);if(typeof e?.etag=="string"&&e.etag!==u.ETAG_DISABLED&&e.etag===r.etag)throw new u.NotModifiedSinceFileOperationError((0,g.localize)(12,null),r,e);return this.validateReadFileLimits(o,r.size,e),r}validateReadFileLimits(o,e,r){if(r?.limits){let t;if(typeof r.limits.memory=="number"&&e>r.limits.memory&&(t=9),typeof r.limits.size=="number"&&e>r.limits.size&&(t=7),typeof t=="number")throw new u.FileOperationError((0,g.localize)(13,null,this.resourceForError(o)),t)}}async canMove(o,e,r){return this.doCanMoveCopy(o,e,"move",r)}async canCopy(o,e,r){return this.doCanMoveCopy(o,e,"copy",r)}async doCanMoveCopy(o,e,r,t){if(o.toString()!==e.toString())try{const n=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e);await this.doValidateMoveCopy(n,o,s,e,r,t)}catch(n){return n}return!0}async move(o,e,r){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e),s=await this.doMoveCopy(t,o,n,e,"move",!!r),a=await this.resolve(e,{resolveMetadata:!0});return this._onDidRunOperation.fire(new u.FileOperationEvent(o,s==="move"?2:3,a)),a}async copy(o,e,r){const t=await this.withReadProvider(o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e),s=await this.doMoveCopy(t,o,n,e,"copy",!!r),a=await this.resolve(e,{resolveMetadata:!0});return this._onDidRunOperation.fire(new u.FileOperationEvent(o,s==="copy"?3:2,a)),a}async doMoveCopy(o,e,r,t,n,s){if(e.toString()===t.toString())return n;const{exists:a,isSameResourceWithDifferentPathCase:c}=await this.doValidateMoveCopy(o,e,r,t,n,s);if(a&&!c&&s&&await this.del(t,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(t)),n==="copy"){if(o===r&&(0,u.hasFileFolderCopyCapability)(o))await o.copy(e,t,{overwrite:s});else{const h=await this.resolve(e);h.isDirectory?await this.doCopyFolder(o,h,r,t):await this.doCopyFile(o,e,r,t)}return n}else return o===r?(await o.rename(e,t,{overwrite:s}),n):(await this.doMoveCopy(o,e,r,t,"copy",s),await this.del(e,{recursive:!0}),"copy")}async doCopyFile(o,e,r,t){if((0,u.hasOpenReadWriteCloseCapability)(o)&&(0,u.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(o,e,r,t);if((0,u.hasOpenReadWriteCloseCapability)(o)&&(0,u.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(o,e,r,t);if((0,u.hasReadWriteCapability)(o)&&(0,u.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(o,e,r,t);if((0,u.hasReadWriteCapability)(o)&&(0,u.hasReadWriteCapability)(r))return this.doPipeUnbuffered(o,e,r,t)}async doCopyFolder(o,e,r,t){await r.mkdir(t),Array.isArray(e.children)&&await R.Promises.settled(e.children.map(async n=>{const s=this.getExtUri(r).providerExtUri.joinPath(t,n.name);return n.isDirectory?this.doCopyFolder(o,await this.resolve(n.resource),r,s):this.doCopyFile(o,n.resource,r,s)}))}async doValidateMoveCopy(o,e,r,t,n,s){let a=!1;if(o===r){const{providerExtUri:h,isPathCaseSensitive:S}=this.getExtUri(o);if(S||(a=h.isEqual(e,t)),a&&n==="copy")throw new Error((0,g.localize)(14,null,this.resourceForError(e),this.resourceForError(t)));if(!a&&h.isEqualOrParent(t,e))throw new Error((0,g.localize)(15,null,this.resourceForError(e),this.resourceForError(t)))}const c=await this.exists(t);if(c&&!a){if(!s)throw new u.FileOperationError((0,g.localize)(16,null,this.resourceForError(e),this.resourceForError(t)),4);if(o===r){const{providerExtUri:h}=this.getExtUri(o);if(h.isEqualOrParent(e,t))throw new Error((0,g.localize)(17,null,this.resourceForError(e),this.resourceForError(t)))}}return{exists:c,isSameResourceWithDifferentPathCase:a}}getExtUri(o){const e=this.isPathCaseSensitive(o);return{providerExtUri:e?y.extUri:y.extUriIgnorePathCase,isPathCaseSensitive:e}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(e,o);const r=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new u.FileOperationEvent(o,0,r)),r}async mkdirp(o,e){const r=[],{providerExtUri:t}=this.getExtUri(o);for(;!t.isEqual(e,t.dirname(e));)try{if(((await o.stat(e)).type&u.FileType.Directory)==0)throw new Error((0,g.localize)(18,null,this.resourceForError(e)));break}catch(n){if((0,u.toFileSystemProviderErrorCode)(n)!==u.FileSystemProviderErrorCode.FileNotFound)throw n;r.push(t.basename(e)),e=t.dirname(e)}for(let n=r.length-1;n>=0;n--){e=t.joinPath(e,r[n]);try{await o.mkdir(e)}catch(s){if((0,u.toFileSystemProviderErrorCode)(s)!==u.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(o,e){try{await this.doValidateDelete(o,e)}catch(r){return r}return!0}async doValidateDelete(o,e){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!e?.useTrash&&!(r.capabilities&4096))throw new Error((0,g.localize)(19,null,this.resourceForError(o)));let n;try{n=await r.stat(o)}catch{}if(n)this.throwIfFileIsReadonly(o,n);else throw new u.FileOperationError((0,g.localize)(20,null,this.resourceForError(o)),1);if(!!!e?.recursive){const a=await this.resolve(o);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,g.localize)(21,null,this.resourceForError(o)))}return r}async del(o,e){const r=await this.doValidateDelete(o,e),t=!!e?.useTrash,n=!!e?.recursive;await r.delete(o,{recursive:n,useTrash:t}),this._onDidRunOperation.fire(new u.FileOperationEvent(o,1))}watch(o,e={recursive:!1,excludes:[]}){const r=new p.DisposableStore;let t=!1,n=()=>{t=!0};return r.add((0,p.toDisposable)(()=>n())),(async()=>{try{const s=await this.doWatch(o,e);t?(0,p.dispose)(s):n=()=>(0,p.dispose)(s)}catch(s){this.logService.error(s)}})(),r}async doWatch(o,e){const r=await this.withProvider(o),t=(0,P.hash)([this.getExtUri(r).providerExtUri.getComparisonKey(o),e]);let n=this.activeWatchers.get(t);return n||(n={count:0,disposable:r.watch(o,e)},this.activeWatchers.set(t,n)),n.count+=1,(0,p.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,p.dispose)(n.disposable),this.activeWatchers.delete(t)))})}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,p.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,e,r,t){return this.writeQueue.queueFor(e,this.getExtUri(o).providerExtUri).queue(async()=>{const n=await o.open(e,{create:!0,unlock:r?.unlock??!1});try{(0,w.isReadableStream)(t)||(0,w.isReadableBufferedStream)(t)?await this.doWriteStreamBufferedQueued(o,n,t):await this.doWriteReadableBufferedQueued(o,n,t)}catch(s){throw(0,u.ensureFileSystemProviderError)(s)}finally{await o.close(n)}})}async doWriteStreamBufferedQueued(o,e,r){let t=0,n;if((0,w.isReadableBufferedStream)(r)){if(r.buffer.length>0){const s=b.VSBuffer.concat(r.buffer);await this.doWriteBuffer(o,e,s,s.byteLength,t,0),t+=s.byteLength}if(r.ended)return;n=r.stream}else n=r;return new Promise((s,a)=>{(0,w.listenStream)(n,{onData:async c=>{n.pause();try{await this.doWriteBuffer(o,e,c,c.byteLength,t,0)}catch(h){return a(h)}t+=c.byteLength,setTimeout(()=>n.resume())},onError:c=>a(c),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(o,e,r){let t=0,n;for(;(n=r.read())!==null;)await this.doWriteBuffer(o,e,n,n.byteLength,t,0),t+=n.byteLength}async doWriteBuffer(o,e,r,t,n,s){let a=0;for(;a<t;)a+=await o.write(e,n+a,r.buffer,s+a,t-a)}async doWriteUnbuffered(o,e,r,t){return this.writeQueue.queueFor(e,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,e,r,t))}async doWriteUnbufferedQueued(o,e,r,t){let n;t instanceof b.VSBuffer?n=t:(0,w.isReadableStream)(t)?n=await(0,b.streamToBuffer)(t):(0,w.isReadableBufferedStream)(t)?n=await(0,b.bufferedStreamToBuffer)(t):n=(0,b.readableToBuffer)(t),await o.writeFile(e,n.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async doPipeBuffered(o,e,r,t){return this.writeQueue.queueFor(t,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,e,r,t))}async doPipeBufferedQueued(o,e,r,t){let n,s;try{n=await o.open(e,{create:!1}),s=await r.open(t,{create:!0,unlock:!1});const a=b.VSBuffer.alloc(this.BUFFER_SIZE);let c=0,h=0,S=0;do S=await o.read(n,c,a.buffer,h,a.byteLength-h),await this.doWriteBuffer(r,s,a,S,c,h),c+=S,h+=S,h===a.byteLength&&(h=0);while(S>0)}catch(a){throw(0,u.ensureFileSystemProviderError)(a)}finally{await R.Promises.settled([typeof n=="number"?o.close(n):Promise.resolve(),typeof s=="number"?r.close(s):Promise.resolve()])}}async doPipeUnbuffered(o,e,r,t){return this.writeQueue.queueFor(t,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,e,r,t))}async doPipeUnbufferedQueued(o,e,r,t){return r.writeFile(t,await o.readFile(e),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,e,r,t){return this.writeQueue.queueFor(t,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,e,r,t))}async doPipeUnbufferedToBufferedQueued(o,e,r,t){const n=await r.open(t,{create:!0,unlock:!1});try{const s=await o.readFile(e);await this.doWriteBuffer(r,n,b.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,u.ensureFileSystemProviderError)(s)}finally{await r.close(n)}}async doPipeBufferedToUnbuffered(o,e,r,t){const n=await(0,b.streamToBuffer)(this.readFileBuffered(o,e,I.CancellationToken.None));await this.doWriteUnbuffered(r,t,void 0,n)}throwIfFileSystemIsReadonly(o,e){if(o.capabilities&2048)throw new u.FileOperationError((0,g.localize)(22,null,this.resourceForError(e)),6);return o}throwIfFileIsReadonly(o,e){if((e.permissions??0)&u.FilePermission.Readonly)throw new u.FileOperationError((0,g.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===T.Schemas.file?o.fsPath:o.toString(!0)}};v=ge([oe(0,E.ILogService)],v),i.FileService=v}),define(Y[102],Q([0,1,103,136,3,54,17,7,45,2,11,12,19,38,15,83,16,50,99,28,96,95]),function(j,i,D,R,b,I,L,P,l,p,C,T,d,y,w,g,u,f,E,v,m,o){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DiskFileSystemProvider=void 0,(()=>{try{(0,R.gracefulify)(D)}catch(r){console.error(`Error enabling graceful-fs: ${(0,v.toErrorMessage)(r)}`)}})();class e extends E.AbstractDiskFileSystemProvider{constructor(t,n){super(t,n);this.onDidChangeCapabilities=P.Event.None,this.resourceLocks=new I.ResourceMap(s=>d.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,T.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(t){try{const{stat:n,symbolicLink:s}=await w.SymlinkSupport.stat(this.toFilePath(t));return{type:this.toType(n,s),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.toFileSystemProviderError(n)}}async readdir(t){try{const n=await w.Promises.readdir(this.toFilePath(t),{withFileTypes:!0}),s=[];return await Promise.all(n.map(async a=>{try{let c;a.isSymbolicLink()?c=(await this.stat((0,d.joinPath)(t,a.name))).type:c=this.toType(a),s.push([a.name,c])}catch(c){this.logService.trace(c)}})),s}catch(n){throw this.toFileSystemProviderError(n)}}toType(t,n){let s;return n?.dangling?s=u.FileType.Unknown:t.isFile()?s=u.FileType.File:t.isDirectory()?s=u.FileType.Directory:s=u.FileType.Unknown,n&&(s|=u.FileType.SymbolicLink),s}async createResourceLock(t){const n=this.toFilePath(t);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let s;for(;s=this.resourceLocks.get(t);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await s.wait();const a=new b.Barrier;return this.resourceLocks.set(t,a),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,p.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.resourceLocks.get(t)===a&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.resourceLocks.delete(t)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),a.open()})}async readFile(t,n){let s;try{n?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(t)})`),s=await this.createResourceLock(t));const a=this.toFilePath(t);return await w.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}finally{s?.dispose()}}readFileStream(t,n,s){const a=(0,y.newWriteableStream)(c=>L.VSBuffer.concat(c.map(h=>L.VSBuffer.wrap(h))).buffer);return(0,f.readFileIntoStream)(this,t,a,c=>c.buffer,{...n,bufferSize:256*1024},s),a}async writeFile(t,n,s){let a;try{const c=this.toFilePath(t);if(!s.create||!s.overwrite){if(await w.Promises.exists(c)){if(!s.overwrite)throw(0,u.createFileSystemProviderError)((0,g.localize)(0,null),u.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,u.createFileSystemProviderError)((0,g.localize)(1,null),u.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(t,{create:!0,unlock:s.unlock}),await this.write(a,0,n,0,n.byteLength)}catch(c){throw await this.toFileSystemProviderWriteError(t,c)}finally{typeof a=="number"&&await this.close(a)}}async open(t,n){const s=this.toFilePath(t);let a;(0,u.isFileOpenForWriteOptions)(n)&&(a=await this.createResourceLock(t));let c;try{if((0,u.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:S}=await w.SymlinkSupport.stat(s);S.mode&128||await w.Promises.chmod(s,S.mode|128)}catch(S){this.logService.trace(S)}let h;if((0,u.isFileOpenForWriteOptions)(n)){if(T.isWindows)try{await w.Promises.truncate(s,0),h="r+"}catch(S){S.code!=="ENOENT"&&this.logService.trace(S)}h||(h="w")}else h="r";c=await w.Promises.open(s,h)}catch(h){throw a?.dispose(),(0,u.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(t,h):this.toFileSystemProviderError(h)}if(this.mapHandleToPos.set(c,0),(0,u.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(c,t),a){const h=this.mapHandleToLock.get(c);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${c} (${s})`),this.mapHandleToLock.set(c,a),h&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${c} (${s})`),h.dispose())}return c}async close(t){const n=this.mapHandleToLock.get(t);try{if(this.mapHandleToPos.delete(t),this.writeHandles.delete(t)&&this.canFlush)try{await w.Promises.fdatasync(t)}catch(s){this.canFlush=!1,this.logService.error(s)}return await w.Promises.close(t)}catch(s){throw this.toFileSystemProviderError(s)}finally{n&&(this.mapHandleToLock.get(t)===n&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.mapHandleToLock.delete(t)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),n.dispose())}}async read(t,n,s,a,c){const h=this.normalizePos(t,n);let S=null;try{S=(await w.Promises.read(t,s,a,c,h)).bytesRead}catch(O){throw this.toFileSystemProviderError(O)}finally{this.updatePos(t,h,S)}return S}normalizePos(t,n){return n===this.mapHandleToPos.get(t)?null:n}updatePos(t,n,s){const a=this.mapHandleToPos.get(t);typeof a=="number"&&(typeof n=="number"||(typeof s=="number"?this.mapHandleToPos.set(t,a+s):this.mapHandleToPos.delete(t)))}async write(t,n,s,a,c){return(0,b.retry)(()=>this.doWrite(t,n,s,a,c),100,3)}async doWrite(t,n,s,a,c){const h=this.normalizePos(t,n);let S=null;try{S=(await w.Promises.write(t,s,a,c,h)).bytesWritten}catch(O){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(t),O)}finally{this.updatePos(t,h,S)}return S}async mkdir(t){try{await w.Promises.mkdir(this.toFilePath(t))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(t,n){try{const s=this.toFilePath(t);n.recursive?await w.Promises.rm(s,w.RimRafMode.MOVE):await w.Promises.unlink(s)}catch(s){throw this.toFileSystemProviderError(s)}}async rename(t,n,s){const a=this.toFilePath(t),c=this.toFilePath(n);if(a!==c)try{await this.validateTargetDeleted(t,n,"move",s.overwrite),await w.Promises.move(a,c)}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,g.localize)(2,null,(0,C.basename)(a),(0,C.basename)((0,C.dirname)(c)),h.toString()))),this.toFileSystemProviderError(h)}}async copy(t,n,s){const a=this.toFilePath(t),c=this.toFilePath(n);if(a!==c)try{await this.validateTargetDeleted(t,n,"copy",s.overwrite),await w.Promises.copy(a,c,{preserveSymlinks:!0})}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,g.localize)(3,null,(0,C.basename)(a),(0,C.basename)((0,C.dirname)(c)),h.toString()))),this.toFileSystemProviderError(h)}}async validateTargetDeleted(t,n,s,a){const c=this.toFilePath(t),h=this.toFilePath(n);let S=!1;if(!!(this.capabilities&1024)||(S=(0,l.isEqual)(c,h,!0)),S&&s==="copy")throw(0,u.createFileSystemProviderError)((0,g.localize)(4,null),u.FileSystemProviderErrorCode.FileExists);if(!S&&await w.Promises.exists(h)){if(!a)throw(0,u.createFileSystemProviderError)((0,g.localize)(5,null),u.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}createUniversalWatcher(t,n,s){return new m.UniversalWatcherClient(a=>t(a),a=>n(a),s)}createNonRecursiveWatcher(t,n,s){return new o.NodeJSWatcherClient(a=>t(a),a=>n(a),s)}toFileSystemProviderError(t){if(t instanceof u.FileSystemProviderError)return t;let n;switch(t.code){case"ENOENT":n=u.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=u.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=u.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=u.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=u.FileSystemProviderErrorCode.NoPermissions;break;default:n=u.FileSystemProviderErrorCode.Unknown}return(0,u.createFileSystemProviderError)(t,n)}async toFileSystemProviderWriteError(t,n){let s=this.toFileSystemProviderError(n);if(t&&s.code===u.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await w.SymlinkSupport.stat(this.toFilePath(t));a.mode&128||(s=(0,u.createFileSystemProviderError)(n,u.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.logService.trace(a)}return s}}i.DiskFileSystemProvider=e}),define(Y[104],Q([0,1,16,14]),function(j,i,D,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SpdLogLogger=void 0;async function b(P,l,p,C,T){try{const d=await new Promise((w,g)=>{j(["spdlog"],w,g)});d.setFlushOn(R.LogLevel.Trace);const y=await d.createAsyncRotatingLogger(P,l,p,C);return T&&y.clearFormatters(),y}catch(d){console.error(d)}return null}function I(P,l,p){switch(l){case R.LogLevel.Trace:P.trace(p);break;case R.LogLevel.Debug:P.debug(p);break;case R.LogLevel.Info:P.info(p);break;case R.LogLevel.Warning:P.warn(p);break;case R.LogLevel.Error:P.error(p);break;case R.LogLevel.Critical:P.critical(p);break;default:throw new Error("Invalid log level")}}class L extends R.AbstractMessageLogger{constructor(l,p,C,T,d){super();this.buffer=[],this.setLevel(d),this._loggerCreationPromise=this._createSpdLogLogger(l,p,C,T),this._register(this.onDidChangeLogLevel(y=>{this._logger&&this._logger.setLevel(y)}))}async _createSpdLogLogger(l,p,C,T){const d=C?6:1,y=30/d*D.ByteSize.MB,w=await b(l,p,y,d,T);if(w){this._logger=w,this._logger.setLevel(this.getLevel());for(const{level:g,message:u}of this.buffer)I(this._logger,g,u);this.buffer=[]}}log(l,p){this._logger?I(this._logger,l,p):this.getLevel()<=l&&this.buffer.push({level:l,message:p})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}i.SpdLogLogger=L}),define(Y[32],Q([0,1,13]),function(j,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.productSchemaId=i.IProductService=void 0,i.IProductService=(0,D.createDecorator)("productService"),i.productSchemaId="vscode://schemas/vscode-product"}),define(Y[30],Q([0,1,55,6]),function(j,i,D,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Registry=void 0;class b{constructor(){this.data=new Map}add(L,P){D.ok(R.isString(L)),D.ok(R.isObject(P)),D.ok(!this.data.has(L),"There is already an extension with this id"),this.data.set(L,P)}knows(L){return this.data.has(L)}as(L){return this.data.get(L)||null}}i.Registry=new b}),define(Y[105],Q([0,1,7,30]),function(j,i,D,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Extensions=void 0,i.Extensions={JSONContribution:"base.contributions.json"};function b(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class I{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(l,p){this.schemasById[b(l)]=p,this._onDidChangeSchema.fire(l)}notifySchemaChanged(l){this._onDidChangeSchema.fire(l)}getSchemaContributions(){return{schemas:this.schemasById}}}const L=new I;R.Registry.add(i.Extensions.JSONContribution,L)}),define(Y[34],Q([0,1,18,7,6,73,105,30]),function(j,i,D,R,b,I,L,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getScopes=i.validateProperty=i.getDefaultValue=i.keyFromOverrideIdentifiers=i.overrideIdentifiersFromKey=i.OVERRIDE_PROPERTY_REGEX=i.OVERRIDE_PROPERTY_PATTERN=i.configurationDefaultsSchemaId=i.resourceLanguageSettingsSchemaId=i.resourceSettings=i.windowSettings=i.machineOverridableSettings=i.machineSettings=i.applicationSettings=i.allSettings=i.ConfigurationScope=i.Extensions=i.EditPresentationTypes=void 0;var l;(function(m){m.Multiline="multilineText",m.Singleline="singlelineText"})(l=i.EditPresentationTypes||(i.EditPresentationTypes={})),i.Extensions={Configuration:"base.contributions.configuration"};var p;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.MACHINE=2]="MACHINE",m[m.WINDOW=3]="WINDOW",m[m.RESOURCE=4]="RESOURCE",m[m.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",m[m.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(p=i.ConfigurationScope||(i.ConfigurationScope={})),i.allSettings={properties:{},patternProperties:{}},i.applicationSettings={properties:{},patternProperties:{}},i.machineSettings={properties:{},patternProperties:{}},i.machineOverridableSettings={properties:{},patternProperties:{}},i.windowSettings={properties:{},patternProperties:{}},i.resourceSettings={properties:{},patternProperties:{}},i.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",i.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const C=P.Registry.as(L.Extensions.JSONContribution);class T{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:I.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},C.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(o,e=!0){this.registerConfigurations([o],e)}registerConfigurations(o,e=!0){const r=this.doRegisterConfigurations(o,e);C.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}deregisterConfigurations(o){const e=this.doDeregisterConfigurations(o);C.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:e})}updateConfigurations({add:o,remove:e}){const r=[];r.push(...this.doDeregisterConfigurations(e)),r.push(...this.doRegisterConfigurations(o,!1)),C.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,D.distinct)(r)})}registerDefaultConfigurations(o){const e=[],r=[];for(const{overrides:t,source:n}of o)for(const s in t)if(e.push(s),i.OVERRIDE_PROPERTY_REGEX.test(s)){const a={...this.configurationDefaultsOverrides.get(s)?.value||{},...t[s]};this.configurationDefaultsOverrides.set(s,{source:n,value:a});const c={type:"object",default:a,description:I.localize(1,null,s),$ref:i.resourceLanguageSettingsSchemaId,defaultDefaultValue:a,source:b.isString(n)?void 0:n};r.push(...w(s)),this.configurationProperties[s]=c,this.defaultLanguageConfigurationOverridesNode.properties[s]=c}else{this.configurationDefaultsOverrides.set(s,{value:t[s],source:n});const a=this.configurationProperties[s];a&&(this.updatePropertyDefaultValue(s,a),this.updateSchema(s,a))}this.registerOverrideIdentifiers(r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:e,defaultsOverrides:!0})}deregisterDefaultConfigurations(o){const e=[];for(const{overrides:r,source:t}of o)for(const n in r){const s=this.configurationDefaultsOverrides.get(n),a=b.isString(t)?t:t?.id,c=b.isString(s?.source)?s?.source:s?.source?.id;if(a===c)if(e.push(n),this.configurationDefaultsOverrides.delete(n),i.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const h=this.configurationProperties[n];h&&(this.updatePropertyDefaultValue(n,h),this.updateSchema(n,h))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:e,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...o){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(o){for(const e of o)this.overrideIdentifiers.add(e);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(o,e){const r=[];return o.forEach(t=>{r.push(...this.validateAndRegisterProperties(t,e,t.extensionInfo,t.restrictedProperties)),this.configurationContributors.push(t),this.registerJSONConfiguration(t)}),r}doDeregisterConfigurations(o){const e=[],r=t=>{if(t.properties)for(const n in t.properties)e.push(n),delete this.configurationProperties[n],this.removeFromSchema(n,t.properties[n]);t.allOf&&t.allOf.forEach(n=>r(n))};for(const t of o){r(t);const n=this.configurationContributors.indexOf(t);n!==-1&&this.configurationContributors.splice(n,1)}return e}validateAndRegisterProperties(o,e=!0,r,t,n=3){n=b.isUndefinedOrNull(o.scope)?n:o.scope;let s=[],a=o.properties;if(a)for(let h in a){if(e&&E(h)){delete a[h];continue}const S=a[h];if(S.source=r,S.defaultDefaultValue=a[h].default,this.updatePropertyDefaultValue(h,S),i.OVERRIDE_PROPERTY_REGEX.test(h)?S.scope=void 0:(S.scope=b.isUndefinedOrNull(S.scope)?n:S.scope,S.restricted=b.isUndefinedOrNull(S.restricted)?!!t?.includes(h):S.restricted),a[h].hasOwnProperty("included")&&!a[h].included){this.excludedConfigurationProperties[h]=a[h],delete a[h];continue}else this.configurationProperties[h]=a[h];!a[h].deprecationMessage&&a[h].markdownDeprecationMessage&&(a[h].deprecationMessage=a[h].markdownDeprecationMessage),s.push(h)}let c=o.allOf;if(c)for(let h of c)s.push(...this.validateAndRegisterProperties(h,e,r,t,n));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(o){const e=r=>{let t=r.properties;if(t)for(const s in t)this.updateSchema(s,t[s]);let n=r.allOf;n&&n.forEach(e)};e(o)}updateSchema(o,e){switch(i.allSettings.properties[o]=e,e.scope){case 1:i.applicationSettings.properties[o]=e;break;case 2:i.machineSettings.properties[o]=e;break;case 6:i.machineOverridableSettings.properties[o]=e;break;case 3:i.windowSettings.properties[o]=e;break;case 4:i.resourceSettings.properties[o]=e;break;case 5:i.resourceSettings.properties[o]=e,this.resourceLanguageSettingsSchema.properties[o]=e;break}}removeFromSchema(o,e){switch(delete i.allSettings.properties[o],e.scope){case 1:delete i.applicationSettings.properties[o];break;case 2:delete i.machineSettings.properties[o];break;case 6:delete i.machineOverridableSettings.properties[o];break;case 3:delete i.windowSettings.properties[o];break;case 4:case 5:delete i.resourceSettings.properties[o],delete this.resourceLanguageSettingsSchema.properties[o];break}}updateOverridePropertyPatternKey(){for(const o of this.overrideIdentifiers.values()){const e=`[${o}]`,r={type:"object",description:I.localize(2,null),errorMessage:I.localize(3,null),$ref:i.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(e,r),i.allSettings.properties[e]=r,i.applicationSettings.properties[e]=r,i.machineSettings.properties[e]=r,i.machineOverridableSettings.properties[e]=r,i.windowSettings.properties[e]=r,i.resourceSettings.properties[e]=r}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const o={type:"object",description:I.localize(4,null),errorMessage:I.localize(5,null),$ref:i.resourceLanguageSettingsSchemaId};i.allSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=o,i.applicationSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=o,i.machineSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=o,i.machineOverridableSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=o,i.windowSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=o,i.resourceSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=o,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(o,e){const r=this.configurationDefaultsOverrides.get(o);let t=r?.value,n=r?.source;b.isUndefined(t)&&(t=e.defaultDefaultValue,n=void 0),b.isUndefined(t)&&(t=u(e.type)),e.default=t,e.defaultValueSource=n}}const d="\\[([^\\]]+)\\]",y=new RegExp(d,"g");i.OVERRIDE_PROPERTY_PATTERN=`^(${d})+$`,i.OVERRIDE_PROPERTY_REGEX=new RegExp(i.OVERRIDE_PROPERTY_PATTERN);function w(m){const o=[];if(i.OVERRIDE_PROPERTY_REGEX.test(m)){let e=y.exec(m);for(;e?.length;){const r=e[1].trim();r&&o.push(r),e=y.exec(m)}}return(0,D.distinct)(o)}i.overrideIdentifiersFromKey=w;function g(m){return m.reduce((o,e)=>`${o}[${e}]`,"")}i.keyFromOverrideIdentifiers=g;function u(m){switch(Array.isArray(m)?m[0]:m){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}i.getDefaultValue=u;const f=new T;P.Registry.add(i.Extensions.Configuration,f);function E(m){return m.trim()?i.OVERRIDE_PROPERTY_REGEX.test(m)?I.localize(7,null,m):f.getConfigurationProperties()[m]!==void 0?I.localize(8,null,m):null:I.localize(6,null)}i.validateProperty=E;function v(){const m=[],o=f.getConfigurationProperties();for(const e of Object.keys(o))m.push([e,o[e].scope]);return m.push(["launch",4]),m.push(["task",4]),m}i.getScopes=v}),define(Y[106],Q([0,1,18,7,56,2,54,22,6,9,25,34,30]),function(j,i,D,R,b,I,L,P,l,p,C,T,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AllKeysConfigurationChangeEvent=i.ConfigurationChangeEvent=i.mergeChanges=i.Configuration=i.UserSettings=i.ConfigurationModelParser=i.DefaultConfigurationModel=i.ConfigurationModel=void 0;class y{constructor(t={},n=[],s=[]){this._contents=t,this._keys=n,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,C.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,n){const s=this.getContentsForOverrideIdentifer(n);return s?t?(0,C.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){const n=[];for(const s of this.overrides)s.identifiers.includes(t)&&n.push(...s.keys);return D.distinct(n)}getAllOverrideIdentifiers(){const t=[];for(const n of this.overrides)t.push(...n.identifiers);return D.distinct(t)}override(t){let n=this.overrideConfigurations.get(t);return n||(n=this.createOverrideConfigurationModel(t),this.overrideConfigurations.set(t,n)),n}merge(...t){const n=P.deepClone(this.contents),s=P.deepClone(this.overrides),a=[...this.keys];for(const c of t){this.mergeContents(n,c.contents);for(const h of c.overrides){const[S]=s.filter(O=>D.equals(O.identifiers,h.identifiers));S?(this.mergeContents(S.contents,h.contents),S.keys.push(...h.keys),S.keys=D.distinct(S.keys)):s.push(P.deepClone(h))}for(const h of c.keys)a.indexOf(h)===-1&&a.push(h)}return new y(n,a,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(t){const n=this.getContentsForOverrideIdentifer(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let s={};for(const a of D.distinct([...Object.keys(this.contents),...Object.keys(n)])){let c=this.contents[a],h=n[a];h&&(typeof c=="object"&&typeof h=="object"?(c=P.deepClone(c),this.mergeContents(c,h)):c=h),s[a]=c}return new y(s,this.keys,this.overrides)}mergeContents(t,n){for(const s of Object.keys(n)){if(s in t&&l.isObject(t[s])&&l.isObject(n[s])){this.mergeContents(t[s],n[s]);continue}t[s]=P.deepClone(n[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?P.deepFreeze(t):t}getContentsForOverrideIdentifer(t){let n=null,s=null;const a=c=>{c&&(s?this.mergeContents(s,c):s=P.deepClone(c))};for(const c of this.overrides)D.equals(c.identifiers,[t])?n=c.contents:c.identifiers.includes(t)&&a(c.contents);return a(n),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,n){this.addKey(t),(0,C.addToValueTree)(this.contents,t,n,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&(0,C.removeFromValueTree)(this.contents,t)}addKey(t){let n=this.keys.length;for(let s=0;s<n;s++)t.indexOf(this.keys[s])===0&&(n=s);this.keys.splice(n,1,t)}removeKey(t){let n=this.keys.indexOf(t);return n!==-1?(this.keys.splice(n,1),!0):!1}}i.ConfigurationModel=y;class w extends y{constructor(t={}){const n=d.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),s=Object.keys(n),a=Object.create(null),c=[];for(const h in n){const S=t[h],O=S!==void 0?S:n[h].default;(0,C.addToValueTree)(a,h,O,N=>console.error(`Conflict in default settings: ${N}`))}for(const h of Object.keys(a))T.OVERRIDE_PROPERTY_REGEX.test(h)&&c.push({identifiers:(0,T.overrideIdentifiersFromKey)(h),keys:Object.keys(a[h]),contents:(0,C.toValuesTree)(a[h],S=>console.error(`Conflict in default settings file: ${S}`))});super(a,s,c)}}i.DefaultConfigurationModel=w;class g{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,n){if(!l.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,n)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,n){this._raw=t;const{contents:s,keys:a,overrides:c,restricted:h}=this.doParseRaw(t,n);this._configurationModel=new y(s,a,c),this._restrictedConfigurations=h||[]}doParseContent(t){let n={},s=null,a=[],c=[],h=[];function S(N){Array.isArray(a)?a.push(N):s!==null&&(a[s]=N)}let O={onObjectBegin:()=>{let N={};S(N),c.push(a),a=N,s=null},onObjectProperty:N=>{s=N},onObjectEnd:()=>{a=c.pop()},onArrayBegin:()=>{let N=[];S(N),c.push(a),a=N,s=null},onArrayEnd:()=>{a=c.pop()},onLiteralValue:S,onError:(N,_,J)=>{h.push({error:N,offset:_,length:J})}};if(t)try{b.visit(t,O),n=a[0]||{}}catch(N){console.error(`Error while parsing settings file ${this._name}: ${N}`),this._parseErrors=[N]}return n}doParseRaw(t,n){const s=d.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),a=this.filter(t,s,!0,n);t=a.raw;const c=(0,C.toValuesTree)(t,O=>console.error(`Conflict in settings file ${this._name}: ${O}`)),h=Object.keys(t),S=this.toOverrides(t,O=>console.error(`Conflict in settings file ${this._name}: ${O}`));return{contents:c,keys:h,overrides:S,restricted:a.restricted}}filter(t,n,s,a){if(!a?.scopes&&!a?.skipRestricted)return{raw:t,restricted:[]};const c={},h=[];for(let S in t)if(T.OVERRIDE_PROPERTY_REGEX.test(S)&&s){const O=this.filter(t[S],n,!1,a);c[S]=O.raw,h.push(...O.restricted)}else{const O=n[S],N=O?typeof O.scope!="undefined"?O.scope:3:void 0;O?.restricted&&h.push(S),(N===void 0||a.scopes===void 0||a.scopes.includes(N))&&(a.skipRestricted&&O?.restricted||(c[S]=t[S]))}return{raw:c,restricted:h}}toOverrides(t,n){const s=[];for(const a of Object.keys(t))if(T.OVERRIDE_PROPERTY_REGEX.test(a)){const c={};for(const h in t[a])c[h]=t[a][h];s.push({identifiers:(0,T.overrideIdentifiersFromKey)(a),keys:Object.keys(c),contents:(0,C.toValuesTree)(c,n)})}return s}}i.ConfigurationModelParser=g;class u extends I.Disposable{constructor(t,n,s,a){super();this.userSettingsResource=t,this.scopes=n,this.fileService=a,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(R.Event.any(R.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource)),R.Event.filter(this.fileService.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(1)||c.isOperation(4))&&s.isEqual(c.resource,t)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new y}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}i.UserSettings=u;class f{constructor(t,n,s=new y,a=new y,c=new L.ResourceMap,h=new y,S=new L.ResourceMap,O=!0){this._defaultConfiguration=t,this._localUserConfiguration=n,this._remoteUserConfiguration=s,this._workspaceConfiguration=a,this._folderConfigurations=c,this._memoryConfiguration=h,this._memoryConfigurationByResource=S,this._freeze=O,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new L.ResourceMap,this._userConfiguration=null}getValue(t,n,s){return this.getConsolidateConfigurationModel(n,s).getValue(t)}updateValue(t,n,s={}){let a;s.resource?(a=this._memoryConfigurationByResource.get(s.resource),a||(a=new y,this._memoryConfigurationByResource.set(s.resource,a))):a=this._memoryConfiguration,n===void 0?a.removeValue(t):a.setValue(t,n),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,n,s){const a=this.getConsolidateConfigurationModel(n,s),c=this.getFolderConfigurationModelForResource(n.resource,s),h=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,S=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),O=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),N=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),_=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),J=s?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,re=c?n.overrideIdentifier?c.freeze().override(n.overrideIdentifier).getValue(t):c.freeze().getValue(t):void 0,ee=n.overrideIdentifier?h.override(n.overrideIdentifier).getValue(t):h.getValue(t),ie=a.getValue(t),he=D.distinct(D.flatten(a.overrides.map(ue=>ue.identifiers))).filter(ue=>a.getOverrideValue(t,ue)!==void 0);return{defaultValue:S,userValue:O,userLocalValue:N,userRemoteValue:_,workspaceValue:J,workspaceFolderValue:re,memoryValue:ee,value:ie,default:S!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,user:O!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userLocal:N!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userRemote:_!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspace:J!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspaceFolder:re!==void 0?{value:c?.freeze().getValue(t),override:n.overrideIdentifier?c?.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,memory:ee!==void 0?{value:h.getValue(t),override:n.overrideIdentifier?h.getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:he.length?he:void 0}}keys(t){const n=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,n){this._folderConfigurations.set(t,n),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const s=[];if(!n){const{added:a,updated:c,removed:h}=o(this._defaultConfiguration,t);n=[...a,...c,...h]}for(const a of n)for(const c of(0,T.overrideIdentifiersFromKey)(a)){const h=this._defaultConfiguration.getKeysForOverrideIdentifier(c),S=t.getKeysForOverrideIdentifier(c),O=[...S.filter(N=>h.indexOf(N)===-1),...h.filter(N=>S.indexOf(N)===-1),...h.filter(N=>!P.equals(this._defaultConfiguration.override(c).getValue(N),t.override(c).getValue(N)))];s.push([c,O])}return this.updateDefaultConfiguration(t),{keys:n,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:s,removed:a,overrides:c}=o(this.localUserConfiguration,t),h=[...n,...s,...a];return h.length&&this.updateLocalUserConfiguration(t),{keys:h,overrides:c}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:s,removed:a,overrides:c}=o(this.remoteUserConfiguration,t);let h=[...n,...s,...a];return h.length&&this.updateRemoteUserConfiguration(t),{keys:h,overrides:c}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:s,removed:a,overrides:c}=o(this.workspaceConfiguration,t);let h=[...n,...s,...a];return h.length&&this.updateWorkspaceConfiguration(t),{keys:h,overrides:c}}compareAndUpdateFolderConfiguration(t,n){const s=this.folderConfigurations.get(t),{added:a,updated:c,removed:h,overrides:S}=o(s,n);let O=[...a,...c,...h];return(O.length||!s)&&this.updateFolderConfiguration(t,n),{keys:O,overrides:S}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:a,removed:c,overrides:h}=o(n,void 0);return{keys:[...s,...a,...c],overrides:h}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,n){let s=this.getConsolidatedConfigurationModelForResource(t,n);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},n){let s=this.getWorkspaceConsolidatedConfiguration();if(n&&t){const a=n.getFolder(t);a&&(s=this.getFolderConsolidatedConfiguration(a.uri)||s);const c=this._memoryConfigurationByResource.get(t);c&&(s=s.merge(c))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let n=this._foldersConsolidatedConfigurations.get(t);if(!n){const s=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(t);a?(n=s.merge(a),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(t,n)):n=s}return n}getFolderConfigurationModelForResource(t,n){if(n&&t){const s=n.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,n)=>{const{contents:s,overrides:a,keys:c}=this._folderConfigurations.get(n);return t.push([n,{contents:s,overrides:a,keys:c}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>t.add(n)),this.userConfiguration.freeze().keys.forEach(n=>t.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}allOverrideIdentifiers(){const t=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>t.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(a=>n.add(a))),[...n.values()]}static parse(t){const n=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),a=this.parseConfigurationModel(t.workspace),c=t.folders.reduce((h,S)=>(h.set(p.URI.revive(S[0]),this.parseConfigurationModel(S[1])),h),new L.ResourceMap);return new f(n,s,new y,a,c,new y,new L.ResourceMap,!1)}static parseConfigurationModel(t){return new y(t.contents,t.keys,t.overrides).freeze()}}i.Configuration=f;function E(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const t=new Set,n=new Map;for(const a of r)a.keys.forEach(c=>t.add(c)),a.overrides.forEach(([c,h])=>{const S=(0,L.getOrSet)(n,c,new Set);h.forEach(O=>S.add(O))});const s=[];return n.forEach((a,c)=>s.push([c,[...a.values()]])),{keys:[...t.values()],overrides:s}}i.mergeChanges=E;class v{constructor(t,n,s,a){this.change=t,this.previous=n,this.currentConfiguraiton=s,this.currentWorkspace=a,this._previousConfiguration=void 0;const c=new Set;t.keys.forEach(S=>c.add(S)),t.overrides.forEach(([,S])=>S.forEach(O=>c.add(O))),this.affectedKeys=[...c.values()];const h=new y;this.affectedKeys.forEach(S=>h.setValue(S,{})),this.affectedKeysTree=h.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=f.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(n){const s=this.previousConfiguration?this.previousConfiguration.getValue(t,n,this.previous?.workspace):void 0,a=this.currentConfiguraiton.getValue(t,n,this.currentWorkspace);return!P.equals(s,a)}return!0}return!1}doesAffectedKeysTreeContains(t,n){let s=(0,C.toValuesTree)({[n]:!0},()=>{}),a;for(;typeof s=="object"&&(a=Object.keys(s)[0]);){if(t=t[a],!t)return!1;s=s[a]}return!0}}i.ConfigurationChangeEvent=v;class m extends v{constructor(t,n,s,a){super({keys:t.allKeys(),overrides:[]},void 0,t,n);this.source=s,this.sourceConfig=a}}i.AllKeysConfigurationChangeEvent=m;function o(r,t){const{added:n,removed:s,updated:a}=e(t,r),c=[],h=r?.getAllOverrideIdentifiers()||[],S=t?.getAllOverrideIdentifiers()||[];if(t){const O=S.filter(N=>!h.includes(N));for(const N of O)c.push([N,t.getKeysForOverrideIdentifier(N)])}if(r){const O=h.filter(N=>!S.includes(N));for(const N of O)c.push([N,r.getKeysForOverrideIdentifier(N)])}if(t&&r){for(const O of h)if(S.includes(O)){const N=e({contents:r.getOverrideValue(void 0,O)||{},keys:r.getKeysForOverrideIdentifier(O)},{contents:t.getOverrideValue(void 0,O)||{},keys:t.getKeysForOverrideIdentifier(O)});c.push([O,[...N.added,...N.removed,...N.updated]])}}return{added:n,removed:s,updated:a,overrides:c}}function e(r,t){const n=r?t?r.keys.filter(c=>t.keys.indexOf(c)===-1):[...r.keys]:[],s=t?r?t.keys.filter(c=>r.keys.indexOf(c)===-1):[...t.keys]:[],a=[];if(r&&t){for(const c of t.keys)if(r.keys.indexOf(c)!==-1){const h=(0,C.getConfigurationValue)(t.contents,c),S=(0,C.getConfigurationValue)(r.contents,c);P.equals(h,S)||a.push(c)}}return{added:n,removed:s,updated:a}}}),define(Y[107],Q([0,1,3,7,2,19,25,106,34,30]),function(j,i,D,R,b,I,L,P,l,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ConfigurationService=void 0;class C extends b.Disposable{constructor(d,y){super();this.settingsResource=d,this._onDidChangeConfiguration=this._register(new R.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,I.extUriBiasedIgnorePathCase,y)),this.configuration=new P.Configuration(new P.DefaultConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(p.Registry.as(l.Extensions.Configuration).onDidUpdateConfiguration(({properties:w})=>this.onDidDefaultConfigurationChange(w))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const d=await this.userConfiguration.loadConfiguration();this.configuration=new P.Configuration(new P.DefaultConfigurationModel,d)}getConfigurationData(){return this.configuration.toData()}getValue(d,y){const w=typeof d=="string"?d:void 0,g=(0,L.isConfigurationOverrides)(d)?d:(0,L.isConfigurationOverrides)(y)?y:{};return this.configuration.getValue(w,g,void 0)}updateValue(d,y,w,g){return Promise.reject(new Error("not supported"))}inspect(d){return this.configuration.inspect(d,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const d=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(d)}onDidChangeUserConfiguration(d){const y=this.configuration.toData(),w=this.configuration.compareAndUpdateLocalUserConfiguration(d);this.trigger(w,y,1)}onDidDefaultConfigurationChange(d){const y=this.configuration.toData(),w=this.configuration.compareAndUpdateDefaultConfiguration(new P.DefaultConfigurationModel,d);this.trigger(w,y,6)}trigger(d,y,w){const g=new P.ConfigurationChangeEvent(d,{data:y},this.configuration);g.source=w,g.sourceConfig=this.getTargetConfiguration(w),this._onDidChangeConfiguration.fire(g)}getTargetConfiguration(d){switch(d){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}i.ConfigurationService=C}),define(Y[108],Q([0,1,10]),function(j,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getRemoteName=i.getRemoteAuthority=void 0;function R(I){return I.scheme===D.Schemas.vscodeRemote?I.authority:void 0}i.getRemoteAuthority=R;function b(I){if(!I)return;const L=I.indexOf("+");return L<0?I:I.substr(0,L)}i.getRemoteName=b}),define(Y[35],Q([0,1,26,13,108]),function(j,i,D,R,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IBuiltinExtensionsScannerService=i.isResolverExtension=i.isAuthenticationProviderExtension=i.isLanguagePackExtension=i.ExtensionIdentifier=i.ExtensionType=i.EXTENSION_CATEGORIES=i.isIExtensionIdentifier=i.getWorkspaceSupportTypeMessage=i.ALL_EXTENSION_KINDS=i.UNDEFINED_PUBLISHER=i.BUILTIN_MANIFEST_CACHE_FILE=i.USER_MANIFEST_CACHE_FILE=i.MANIFEST_CACHE_FOLDER=void 0,i.MANIFEST_CACHE_FOLDER="CachedExtensions",i.USER_MANIFEST_CACHE_FILE="user",i.BUILTIN_MANIFEST_CACHE_FILE="builtin",i.UNDEFINED_PUBLISHER="undefined_publisher",i.ALL_EXTENSION_KINDS=["ui","workspace","web"];function I(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}i.getWorkspaceSupportTypeMessage=I;function L(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}i.isIExtensionIdentifier=L,i.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(P=i.ExtensionType||(i.ExtensionType={}));class l{constructor(y){this.value=y,this._lower=y.toLowerCase()}static equals(y,w){if(typeof y=="undefined"||y===null)return typeof w=="undefined"||w===null;if(typeof w=="undefined"||w===null)return!1;if(typeof y=="string"||typeof w=="string"){let g=typeof y=="string"?y:y.value,u=typeof w=="string"?w:w.value;return D.equalsIgnoreCase(g,u)}return y._lower===w._lower}static toKey(y){return typeof y=="string"?y.toLowerCase():y._lower}}i.ExtensionIdentifier=l;function p(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}i.isLanguagePackExtension=p;function C(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}i.isAuthenticationProviderExtension=C;function T(d,y){if(y){const w=`onResolveRemoteAuthority:${(0,b.getRemoteName)(y)}`;return d.activationEvents?.indexOf(w)!==-1}return!1}i.isResolverExtension=T,i.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(Y[21],Q([0,1,26,35]),function(j,i,D,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getExtensionDependencies=i.getMaliciousExtensionsSet=i.BetterMergeId=i.getGalleryExtensionTelemetryData=i.getLocalExtensionTelemetryData=i.groupByExtension=i.getGalleryExtensionId=i.adoptToGalleryExtensionId=i.getExtensionId=i.ExtensionIdentifierWithVersion=i.areSameExtensions=void 0;function b(w,g){return w.uuid&&g.uuid?w.uuid===g.uuid:w.id===g.id?!0:(0,D.compareIgnoreCase)(w.id,g.id)===0}i.areSameExtensions=b;class I{constructor(g,u){this.version=u,this.id=g.id,this.uuid=g.uuid}key(){return`${this.id}-${this.version}`}equals(g){return g instanceof I?b(this,g)&&this.version===g.version:!1}}i.ExtensionIdentifierWithVersion=I;function L(w,g){return`${w}.${g}`}i.getExtensionId=L;function P(w){return w.toLocaleLowerCase()}i.adoptToGalleryExtensionId=P;function l(w,g){return P(L(w,g))}i.getGalleryExtensionId=l;function p(w,g){const u=[],f=E=>{for(const v of u)if(v.some(m=>b(g(m),g(E))))return v;return null};for(const E of w){const v=f(E);v?v.push(E):u.push([E])}return u}i.groupByExtension=p;function C(w){return{id:w.identifier.id,name:w.manifest.name,galleryId:null,publisherId:w.publisherId,publisherName:w.manifest.publisher,publisherDisplayName:w.publisherDisplayName,dependencies:w.manifest.extensionDependencies&&w.manifest.extensionDependencies.length>0}}i.getLocalExtensionTelemetryData=C;function T(w){return{id:w.identifier.id,name:w.name,galleryId:w.identifier.uuid,publisherId:w.publisherId,publisherName:w.publisher,publisherDisplayName:w.publisherDisplayName,isPreReleaseVersion:w.properties.isPreReleaseVersion,dependencies:!!(w.properties.dependencies&&w.properties.dependencies.length>0),...w.telemetryData}}i.getGalleryExtensionTelemetryData=T,i.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function d(w){const g=new Set;if(w.malicious)for(const u of w.malicious)g.add(u.id);return g}i.getMaliciousExtensionsSet=d;function y(w,g){const u=[],f=g.manifest.extensionDependencies?.slice(0)??[];for(;f.length;){const E=f.shift();if(E&&u.every(v=>!b(v.identifier,{id:E}))){const v=w.filter(m=>b(m.identifier,{id:E}));v.length===1&&(u.push(v[0]),f.push(...v[0].manifest.extensionDependencies?.slice(0)??[]))}}return u}i.getExtensionDependencies=y}),define(Y[23],Q([0,1,10,75,21,13]),function(j,i,D,R,b,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IExtensionManagementCLIService=i.PreferencesLocalizedLabel=i.PreferencesLabel=i.ExtensionsChannelId=i.ExtensionsLocalizedLabel=i.ExtensionsLabel=i.DefaultIconPath=i.IExtensionTipsService=i.IGlobalExtensionEnablementService=i.ENABLED_EXTENSIONS_STORAGE_PATH=i.DISABLED_EXTENSIONS_STORAGE_PATH=i.IExtensionManagementService=i.ExtensionManagementError=i.ExtensionManagementErrorCode=i.IExtensionGalleryService=i.InstallOperation=i.StatisticType=i.SortOrder=i.SortBy=i.isIExtensionIdentifier=i.getFallbackTargetPlarforms=i.isTargetPlatformCompatible=i.isNotWebExtensionInWebTargetPlatform=i.getTargetPlatform=i.toTargetPlatform=i.TargetPlatformToString=i.TargetPlatform=i.getIdAndVersion=i.WEB_EXTENSION_TAG=i.EXTENSION_IDENTIFIER_REGEX=i.EXTENSION_IDENTIFIER_PATTERN=void 0,i.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",i.EXTENSION_IDENTIFIER_REGEX=new RegExp(i.EXTENSION_IDENTIFIER_PATTERN),i.WEB_EXTENSION_TAG="__web_extension";const L=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function P(e){const r=L.exec(e);return r&&r[1]?[(0,b.adoptToGalleryExtensionId)(r[1]),r[2]]:[(0,b.adoptToGalleryExtensionId)(e),void 0]}i.getIdAndVersion=P;var l;(function(e){e.WIN32_X64="win32-x64",e.WIN32_IA32="win32-ia32",e.WIN32_ARM64="win32-arm64",e.LINUX_X64="linux-x64",e.LINUX_ARM64="linux-arm64",e.LINUX_ARMHF="linux-armhf",e.ALPINE_X64="alpine-x64",e.ALPINE_ARM64="alpine-arm64",e.DARWIN_X64="darwin-x64",e.DARWIN_ARM64="darwin-arm64",e.WEB="web",e.UNIVERSAL="universal",e.UNKNOWN="unknown",e.UNDEFINED="undefined"})(l=i.TargetPlatform||(i.TargetPlatform={}));function p(e){switch(e){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}i.TargetPlatformToString=p;function C(e){switch(e){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}i.toTargetPlatform=C;function T(e,r){switch(e){case 3:return r==="x64"?"win32-x64":r==="ia32"?"win32-ia32":r==="arm64"?"win32-arm64":"unknown";case 2:return r==="x64"?"linux-x64":r==="arm64"?"linux-arm64":r==="arm"?"linux-armhf":"unknown";case"alpine":return r==="x64"?"alpine-x64":r==="arm64"?"alpine-arm64":"unknown";case 1:return r==="x64"?"darwin-x64":r==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}i.getTargetPlatform=T;function d(e,r){return r==="web"&&!e.includes("web")}i.isNotWebExtensionInWebTargetPlatform=d;function y(e,r,t){return d(r,t)?!1:e==="undefined"||e==="universal"?!0:e==="unknown"?!1:e===t?!0:w(t).includes(e)}i.isTargetPlatformCompatible=y;function w(e){switch(e){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}i.getFallbackTargetPlarforms=w;function g(e){return e&&typeof e=="object"&&typeof e.id=="string"&&(!e.uuid||typeof e.uuid=="string")}i.isIExtensionIdentifier=g;var u;(function(e){e[e.NoneOrRelevance=0]="NoneOrRelevance",e[e.LastUpdatedDate=1]="LastUpdatedDate",e[e.Title=2]="Title",e[e.PublisherName=3]="PublisherName",e[e.InstallCount=4]="InstallCount",e[e.PublishedDate=10]="PublishedDate",e[e.AverageRating=6]="AverageRating",e[e.WeightedRating=12]="WeightedRating"})(u=i.SortBy||(i.SortBy={}));var f;(function(e){e[e.Default=0]="Default",e[e.Ascending=1]="Ascending",e[e.Descending=2]="Descending"})(f=i.SortOrder||(i.SortOrder={}));var E;(function(e){e.Install="install",e.Uninstall="uninstall"})(E=i.StatisticType||(i.StatisticType={}));var v;(function(e){e[e.None=1]="None",e[e.Install=2]="Install",e[e.Update=3]="Update",e[e.Migrate=4]="Migrate"})(v=i.InstallOperation||(i.InstallOperation={})),i.IExtensionGalleryService=(0,I.createDecorator)("extensionGalleryService");var m;(function(e){e.Unsupported="Unsupported",e.UnsupportedPreRelease="UnsupportedPreRelease",e.Malicious="Malicious",e.Incompatible="Incompatible",e.IncompatiblePreRelease="IncompatiblePreRelease",e.IncompatibleTargetPlatform="IncompatibleTargetPlatform",e.ReleaseVersionNotFound="ReleaseVersionNotFound",e.Invalid="Invalid",e.Download="Download",e.Extract="Extract",e.Delete="Delete",e.Rename="Rename",e.CorruptZip="CorruptZip",e.IncompleteZip="IncompleteZip",e.Internal="Internal"})(m=i.ExtensionManagementErrorCode||(i.ExtensionManagementErrorCode={}));class o extends Error{constructor(r,t){super(r);this.code=t,this.name=t}}i.ExtensionManagementError=o,i.IExtensionManagementService=(0,I.createDecorator)("extensionManagementService"),i.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",i.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",i.IGlobalExtensionEnablementService=(0,I.createDecorator)("IGlobalExtensionEnablementService"),i.IExtensionTipsService=(0,I.createDecorator)("IExtensionTipsService"),i.DefaultIconPath=D.FileAccess.asBrowserUri("./media/defaultIcon.png",j).toString(!0),i.ExtensionsLabel=(0,R.localize)(0,null),i.ExtensionsLocalizedLabel={value:i.ExtensionsLabel,original:"Extensions"},i.ExtensionsChannelId="extensions",i.PreferencesLabel=(0,R.localize)(1,null),i.PreferencesLocalizedLabel={value:i.PreferencesLabel,original:"Preferences"},i.IExtensionManagementCLIService=(0,I.createDecorator)("IExtensionManagementCLIService")}),define(Y[109],Q([0,1,24,8,62,10,41,9,76,23,21,35]),function(j,i,D,R,b,I,L,P,l,p,C,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionManagementCLIService=void 0;const d=u=>(0,l.localize)(0,null,u),y=(0,l.localize)(1,null,"ms-dotnettools.csharp");function w(u,f){return f?`${u.publisher}.${u.name}@${u.version}`:`${u.publisher}.${u.name}`}let g=class{constructor(f,E){this.extensionManagementService=f,this.extensionGalleryService=E}get location(){}async listExtensions(f,E,v=console){let m=await this.extensionManagementService.getInstalled(1);const o=T.EXTENSION_CATEGORIES.map(r=>r.toLowerCase());if(E&&E!==""){if(o.indexOf(E.toLowerCase())<0){v.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}m=m.filter(r=>r.manifest.categories?r.manifest.categories.map(n=>n.toLowerCase()).indexOf(E.toLowerCase())>-1:!1)}else if(E===""){v.log("Possible Categories: "),o.forEach(r=>{v.log(r)});return}this.location&&v.log((0,l.localize)(2,null,this.location)),m=m.sort((r,t)=>r.identifier.id.localeCompare(t.identifier.id));let e;for(let r of m)e!==r.identifier.id&&(e=r.identifier.id,v.log(w(r.manifest,f)))}async installExtensions(f,E,v,m,o=console){const e=[],r=[];f.length&&o.log(this.location?(0,l.localize)(3,null,this.location):(0,l.localize)(4,null));const t=await this.extensionManagementService.getInstalled(1),n=(c,h)=>{const S=t.find(O=>(0,C.areSameExtensions)(O.identifier,{id:c}));if(S){if(!h&&!m)return o.log((0,l.localize)(5,null,c,S.manifest.version,c)),!1;if(h&&S.manifest.version===h)return o.log((0,l.localize)(6,null,`${c}@${h}`)),!1}return!0},s=[],a=[];for(const c of f)if(c instanceof P.URI)s.push(c);else{const[h,S]=(0,p.getIdAndVersion)(c);n(h,S)&&a.push({id:h,version:S,installOptions:{...v,isBuiltin:!1}})}for(const c of E){const[h,S]=(0,p.getIdAndVersion)(c);n(h,S)&&a.push({id:h,version:S,installOptions:{...v,isBuiltin:!0}})}if(s.length&&await Promise.all(s.map(async c=>{try{const h=await this.installVSIX(c,{...v,isBuiltin:!1},m,o);h&&r.push(h)}catch(h){o.error(h.message||h.stack||h),e.push(c.toString())}})),a.length){const c=await this.getGalleryExtensions(a);await Promise.all(a.map(async h=>{const S=c.get(h.id.toLowerCase());if(S)try{const O=await this.installFromGallery(h,S,t,m,o);O&&r.push(O)}catch(O){o.error(O.message||O.stack||O),e.push(h.id)}else o.error(`${d(h.version?`${h.id}@${h.version}`:h.id)}
${y}`),e.push(h.id)}))}if(e.length)throw new Error((0,l.localize)(7,null,e.join(", ")))}async installVSIX(f,E,v,m){const o=await this.extensionManagementService.getManifest(f);if(!o)throw new Error("Invalid vsix");if(await this.validateVSIX(o,v,m))try{return await this.extensionManagementService.install(f,E),m.log((0,l.localize)(8,null,(0,b.getBaseLabel)(f))),o}catch(r){if((0,R.isCancellationError)(r))return m.log((0,l.localize)(9,null,(0,b.getBaseLabel)(f))),null;throw r}return null}async getGalleryExtensions(f){const E=new Map,v=f.some(o=>o.installOptions.installPreReleaseVersion),m=await this.extensionGalleryService.getExtensions(f.map(o=>({...o,preRelease:v})),D.CancellationToken.None);for(const o of m)E.set(o.identifier.id.toLowerCase(),o);return E}async installFromGallery({id:f,version:E,installOptions:v},m,o,e,r){const t=await this.extensionGalleryService.getManifest(m,D.CancellationToken.None);if(t&&!this.validateExtensionKind(t,r))return null;const n=o.find(s=>(0,C.areSameExtensions)(s.identifier,m.identifier));if(n){if(m.version===n.manifest.version)return r.log((0,l.localize)(10,null,E?`${f}@${E}`:f)),null;r.log((0,l.localize)(11,null,f,m.version))}try{return v.isBuiltin?r.log(E?(0,l.localize)(12,null,f,E):(0,l.localize)(13,null,f)):r.log(E?(0,l.localize)(14,null,f,E):(0,l.localize)(15,null,f)),await this.extensionManagementService.installFromGallery(m,{...v,installGivenVersion:!!E}),r.log((0,l.localize)(16,null,f,m.version)),t}catch(s){if((0,R.isCancellationError)(s))return r.log((0,l.localize)(17,null,f)),null;throw s}}validateExtensionKind(f,E){return!0}async validateVSIX(f,E,v){const m={id:(0,C.getGalleryExtensionId)(f.publisher,f.name)},e=(await this.extensionManagementService.getInstalled(1)).find(r=>(0,C.areSameExtensions)(m,r.identifier)&&(0,L.gt)(r.manifest.version,f.version));return e&&!E?(v.log((0,l.localize)(18,null,e.identifier.id,e.manifest.version,f.version)),!1):this.validateExtensionKind(f,v)}async uninstallExtensions(f,E,v=console){const m=async e=>{if(e instanceof P.URI){const r=await this.extensionManagementService.getManifest(e);return w(r)}return e},o=[];for(const e of f){const r=await m(e),n=(await this.extensionManagementService.getInstalled()).filter(s=>(0,C.areSameExtensions)(s.identifier,{id:r}));if(!n.length)throw new Error(`${this.notInstalled(r)}
${y}`);if(n.some(s=>s.type===0)){v.log((0,l.localize)(19,null,r));return}if(!E&&n.some(s=>s.isBuiltin)){v.log((0,l.localize)(20,null,r));return}v.log((0,l.localize)(21,null,r));for(const s of n)await this.extensionManagementService.uninstall(s),o.push(s);this.location?v.log((0,l.localize)(22,null,r,this.location)):v.log((0,l.localize)(23,null,r))}}async locateExtension(f,E=console){const v=await this.extensionManagementService.getInstalled();f.forEach(m=>{v.forEach(o=>{if(o.identifier.id===m&&o.location.scheme===I.Schemas.file){E.log(o.location.fsPath);return}})})}notInstalled(f){return this.location?(0,l.localize)(24,null,f,this.location):(0,l.localize)(25,null,f)}};g=ge([oe(0,p.IExtensionManagementService),oe(1,p.IExtensionGalleryService)],g),i.ExtensionManagementCLIService=g}),define(Y[110],Q([0,1,3,8,2,12,19,41,9,27,15,20,23,21,16,14]),function(j,i,D,R,b,I,L,P,l,p,C,T,d,y,w,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsDownloader=void 0;const u=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let f=class extends b.Disposable{constructor(v,m,o,e){super();this.fileService=m,this.extensionGalleryService=o,this.logService=e,this.extensionsDownloadDir=l.URI.file(v.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(v,m){await this.cleanUpPromise;const o=this.getName(v),e=(0,L.joinPath)(this.extensionsDownloadDir,o);if(!await this.fileService.exists(e)){const r=(0,L.joinPath)(this.extensionsDownloadDir,`.${(0,p.generateUuid)()}`);await this.fileService.exists(r)||await this.extensionGalleryService.download(v,r,m);try{await this.rename(r,e,Date.now()+2*60*1e3)}catch(t){try{await this.fileService.del(r)}catch{}if(t.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",v.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,R.getErrorMessage)(t)}. Deleted the vsix from downloaded location`,r.path),t}}return e}async delete(v){await this.cleanUpPromise,await this.fileService.del(v)}async rename(v,m,o){try{await C.Promises.rename(v.fsPath,m.fsPath)}catch(e){if(I.isWindows&&e&&e.code==="EPERM"&&Date.now()<o)return this.logService.info(`Failed renaming ${v} to ${m} with 'EPERM' error. Trying again...`),this.rename(v,m,o);throw e}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const v=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(v.children){const m=[],o=[];for(const t of v.children){const n=this.parse(t.name);n&&o.push([n,t])}const e=(0,y.groupByExtension)(o,([t])=>t),r=[];for(const t of e)t.sort((n,s)=>P.rcompare(n[0].version,s[0].version)),m.push(...t.slice(1).map(n=>n[1].resource)),r.push(t[0][1]);r.sort((t,n)=>t.mtime-n.mtime),m.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(t=>t.resource)),await D.Promises.settled(m.map(t=>(this.logService.trace("Deleting vsix from cache",t.path),this.fileService.del(t))))}}catch(v){this.logService.error(v)}}getName(v){return this.cache?`${new y.ExtensionIdentifierWithVersion(v.identifier,v.version).key().toLowerCase()}${v.properties.targetPlatform!=="undefined"?`-${v.properties.targetPlatform}`:""}`:(0,p.generateUuid)()}parse(v){const m=u.exec(v);return m&&m[1]&&m[2]?new y.ExtensionIdentifierWithVersion({id:m[1]},m[2]):null}};f=ge([oe(0,T.INativeEnvironmentService),oe(1,w.IFileService),oe(2,d.IExtensionGalleryService),oe(3,g.ILogService)],f),i.ExtensionsDownloader=f}),define(Y[111],Q([0,1,2,11,15,35]),function(j,i,D,R,b,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsManifestCache=void 0;class L extends D.Disposable{constructor(l,p){super();this.environmentService=l,this.extensionsManifestCache=(0,R.join)(this.environmentService.userDataPath,I.MANIFEST_CACHE_FOLDER,I.USER_MANIFEST_CACHE_FILE),this._register(p.onDidInstallExtensions(C=>this.onDidInstallExtensions(C))),this._register(p.onDidUninstallExtension(C=>this.onDidUnInstallExtension(C)))}onDidInstallExtensions(l){l.some(p=>!!p.local)&&this.invalidate()}onDidUnInstallExtension(l){l.error||this.invalidate()}invalidate(){b.Promises.rm(this.extensionsManifestCache,b.RimRafMode.MOVE).then(()=>{},()=>{})}}i.ExtensionsManifestCache=L}),define(Y[112],Q([0,1,137,18,3,2,10,11,15,20,23,21,53,14]),function(j,i,D,R,b,I,L,P,l,p,C,T,d,y){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LocalizationsService=void 0;let w=class extends I.Disposable{constructor(f,E,v){super();this.extensionManagementService=f,this.logService=v,this.cache=this._register(new g(E,v)),this.extensionManagementService.registerParticipant({postInstall:async m=>this.postInstallExtension(m),postUninstall:async m=>this.postUninstallExtension(m)})}async getLanguageIds(){const f=await this.cache.getLanguagePacks(),E=["en",...Object.keys(f)];return(0,R.distinct)(E)}async postInstallExtension(f){f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",f.identifier.id),await this.update())}async postUninstallExtension(f){const E=await this.cache.getLanguagePacks();Object.keys(E).some(v=>E[v]&&E[v].extensions.some(m=>(0,T.areSameExtensions)(m.extensionIdentifier,f.identifier)))&&(this.logService.info("Removing language packs from the extension",f.identifier.id),await this.update())}async update(){const[f,E]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),v=await this.cache.update(E);return!(0,R.equals)(Object.keys(f),Object.keys(v))}};w=ge([oe(0,C.IExtensionManagementService),oe(1,p.INativeEnvironmentService),oe(2,y.ILogService)],w),i.LocalizationsService=w;let g=class extends I.Disposable{constructor(f,E){super();this.logService=E,this.languagePacks={},this.languagePacksFilePath=(0,P.join)(f.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new b.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(f){return this.withLanguagePacks(E=>{Object.keys(E).forEach(v=>delete E[v]),this.createLanguagePacksFromExtensions(E,...f)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(f,...E){for(const v of E)v&&v.manifest&&v.manifest.contributes&&v.manifest.contributes.localizations&&v.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(f,v);Object.keys(f).forEach(v=>this.updateHash(f[v]))}createLanguagePacksFromExtension(f,E){const v=E.identifier,m=E.manifest.contributes&&E.manifest.contributes.localizations?E.manifest.contributes.localizations:[];for(const o of m)if(E.location.scheme===L.Schemas.file&&(0,d.isValidLocalization)(o)){let e=f[o.languageId];e||(e={hash:"",extensions:[],translations:{}},f[o.languageId]=e);let r=e.extensions.filter(t=>(0,T.areSameExtensions)(t.extensionIdentifier,v))[0];r?r.version=E.manifest.version:e.extensions.push({extensionIdentifier:v,version:E.manifest.version});for(const t of o.translations)e.translations[t.id]=(0,P.join)(E.location.fsPath,t.path)}}updateHash(f){if(f){const E=(0,D.createHash)("md5");for(const v of f.extensions)E.update(v.extensionIdentifier.uuid||v.extensionIdentifier.id).update(v.version);f.hash=E.digest("hex")}}withLanguagePacks(f=()=>null){return this.languagePacksFileLimiter.queue(()=>{let E=null;return l.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,v=>v.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(v)).then(v=>{try{return JSON.parse(v)}catch{return{}}}).then(v=>(E=f(v),v)).then(v=>{for(const o of Object.keys(v))v[o]||delete v[o];this.languagePacks=v,this.initializedCache=!0;const m=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",m),l.Promises.writeFile(this.languagePacksFilePath,m)}).then(()=>E,v=>this.logService.error(v))})}};g=ge([oe(0,p.INativeEnvironmentService),oe(1,y.ILogService)],g)}),define(Y[42],Q([0,1,17,84,34,13,30]),function(j,i,D,R,b,I,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.updateProxyConfigurationsScope=i.asJson=i.asText=i.isSuccess=i.IRequestService=void 0,i.IRequestService=(0,I.createDecorator)("requestService");function P(w){return w.res.statusCode&&w.res.statusCode>=200&&w.res.statusCode<300||w.res.statusCode===1223}i.isSuccess=P;function l(w){return w.res.statusCode===204}async function p(w){if(!P(w))throw new Error("Server returned "+w.res.statusCode);return l(w)?null:(await(0,D.streamToBuffer)(w.stream)).toString()}i.asText=p;async function C(w){if(!P(w))throw new Error("Server returned "+w.res.statusCode);if(l(w))return null;const u=(await(0,D.streamToBuffer)(w.stream)).toString();try{return JSON.parse(u)}catch(f){throw f.message+=`:
`+u,f}}i.asJson=C;function T(w){y(w)}i.updateProxyConfigurationsScope=T;let d;function y(w){const g=L.Registry.as(b.Extensions.Configuration),u=d;d={id:"http",order:15,title:(0,R.localize)(0,null),type:"object",scope:w,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(4,null),(0,R.localize)(5,null),(0,R.localize)(6,null),(0,R.localize)(7,null)],default:"override",description:(0,R.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(9,null),restricted:!0}}},g.updateConfigurations({add:[d],remove:u?[u]:[]})}y(2)}),define(Y[113],Q([0,1,24,10,16,42]),function(j,i,D,R,b,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DownloadService=void 0;let L=class{constructor(l,p){this.requestService=l,this.fileService=p}async download(l,p,C=D.CancellationToken.None){if(l.scheme===R.Schemas.file||l.scheme===R.Schemas.vscodeRemote){await this.fileService.copy(l,p);return}const T={type:"GET",url:l.toString()},d=await this.requestService.request(T,C);if(d.res.statusCode===200)await this.fileService.writeFile(p,d.stream);else{const y=await(0,I.asText)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${y}`)}}};L=ge([oe(0,I.IRequestService),oe(1,b.IFileService)],L),i.DownloadService=L}),define(Y[114],Q([0,1,115,6]),function(j,i,D,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getProxyAgent=void 0;function b(L,P){return L.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:L.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function I(L,P,l={}){const p=(0,D.parse)(L),C=l.proxyUrl||b(p,P);if(!C)return null;const T=(0,D.parse)(C);if(!/^https?:$/.test(T.protocol||""))return null;const d={host:T.hostname||"",port:T.port||(T.protocol==="https"?"443":"80"),auth:T.auth,rejectUnauthorized:(0,R.isBoolean)(l.strictSSL)?l.strictSSL:!0};return p.protocol==="http:"?new(await new Promise((y,w)=>{j(["http-proxy-agent"],y,w)}))(d):new(await new Promise((y,w)=>{j(["https-proxy-agent"],y,w)}))(d)}i.getProxyAgent=I}),define(Y[116],Q([0,1,3,7,2,101,6,65,13]),function(j,i,D,R,b,I,L,P,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.logStorage=i.InMemoryStorageService=i.AbstractStorageService=i.StorageTarget=i.StorageScope=i.WillSaveStateReason=i.IStorageService=i.IS_NEW_KEY=void 0,i.IS_NEW_KEY="__$__isNewStorageMarker";const p="__$__targetStorageMarker";i.IStorageService=(0,l.createDecorator)("storageService");var C;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(C=i.WillSaveStateReason||(i.WillSaveStateReason={}));var T;(function(u){u[u.GLOBAL=0]="GLOBAL",u[u.WORKSPACE=1]="WORKSPACE"})(T=i.StorageScope||(i.StorageScope={}));var d;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(d=i.StorageTarget||(i.StorageTarget={}));class y extends b.Disposable{constructor(f={flushInterval:y.DEFAULT_FLUSH_INTERVAL}){super();this.options=f,this._onDidChangeValue=this._register(new R.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new R.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new R.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new b.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,b.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,I.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,I.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(f,E){E===p?(f===0?this._globalKeyTargets=void 0:f===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:f})):this._onDidChangeValue.fire({scope:f,key:E,target:this.getKeyTargets(f)[E]})}emitWillSaveState(f){this._onWillSaveState.fire({reason:f})}get(f,E,v){return this.getStorage(E)?.get(f,v)}getBoolean(f,E,v){return this.getStorage(E)?.getBoolean(f,v)}getNumber(f,E,v){return this.getStorage(E)?.getNumber(f,v)}store(f,E,v,m){if((0,L.isUndefinedOrNull)(E)){this.remove(f,v);return}this.withPausedEmitters(()=>{this.updateKeyTarget(f,v,m),this.getStorage(v)?.set(f,E)})}remove(f,E){this.withPausedEmitters(()=>{this.updateKeyTarget(f,E,void 0),this.getStorage(E)?.delete(f)})}withPausedEmitters(f){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{f()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(f,E){const v=[],m=this.getKeyTargets(f);for(const o of Object.keys(m))m[o]===E&&v.push(o);return v}updateKeyTarget(f,E,v){const m=this.getKeyTargets(E);typeof v=="number"?m[f]!==v&&(m[f]=v,this.getStorage(E)?.set(p,JSON.stringify(m))):typeof m[f]=="number"&&(delete m[f],this.getStorage(E)?.set(p,JSON.stringify(m)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(f){return f===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(f){const E=this.get(p,f);if(E)try{return JSON.parse(E)}catch{}return Object.create(null)}isNew(f){return this.getBoolean(i.IS_NEW_KEY,f)===!0}async flush(f=C.NONE){this._onWillSaveState.fire({reason:f});const E=this.getStorage(0),v=this.getStorage(1);switch(f){case C.NONE:await D.Promises.settled([E?.whenFlushed()??Promise.resolve(),v?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await D.Promises.settled([E?.flush(0)??Promise.resolve(),v?.flush(0)??Promise.resolve()]);break}}async logStorage(){const f=this.getStorage(0)?.items??new Map,E=this.getStorage(1)?.items??new Map;return g(f,E,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}i.AbstractStorageService=y,y.DEFAULT_FLUSH_INTERVAL=60*1e3;class w extends y{constructor(){super();this.globalStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(f=>this.emitDidChangeValue(1,f))),this._register(this.globalStorage.onDidChangeStorage(f=>this.emitDidChangeValue(0,f)))}getStorage(f){return f===0?this.globalStorage:this.workspaceStorage}getLogDetails(f){return f===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(f){}}i.InMemoryStorageService=w;async function g(u,f,E,v){const m=a=>{try{return JSON.parse(a)}catch{return a}},o=new Map,e=new Map;u.forEach((a,c)=>{o.set(c,a),e.set(c,m(a))});const r=new Map,t=new Map;f.forEach((a,c)=>{r.set(c,a),t.set(c,m(a))}),console.group(`Storage: Global (path: ${E})`);let n=[];o.forEach((a,c)=>{n.push({key:c,value:a})}),console.table(n),console.groupEnd(),console.log(e),console.group(`Storage: Workspace (path: ${v})`);let s=[];r.forEach((a,c)=>{s.push({key:c,value:a})}),console.table(s),console.groupEnd(),console.log(t)}i.logStorage=g}),define(Y[117],Q([0,1,12,29,9,27]),function(j,i,D,R,b,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.verifyMicrosoftInternalDomain=i.resolveCommonProperties=void 0;function L(p){if(D.platform===2&&/^penguin(\.|$)/i.test(p))return"chromebook"}async function P(p,C,T,d,y,w,g,u,f,E){const v=Object.create(null);v["common.machineId"]=g,v.sessionID=(0,I.generateUuid)()+Date.now(),v.commitHash=y,v.version=w,v["common.platformVersion"]=(C||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),v["common.platform"]=(0,D.PlatformToString)(D.platform),v["common.nodePlatform"]=R.platform,v["common.nodeArch"]=d,v["common.product"]=E||"desktop";const m=l(u||[]);m&&(v["common.msftInternal"]=m);let o=0;const e=Date.now();Object.defineProperties(v,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-e,enumerable:!0},"common.sequence":{get:()=>o++,enumerable:!0}}),D.isLinuxSnap&&(v["common.snap"]="true");const r=L(T);r&&(v["common.platformDetail"]=r);try{const t=await p.readFile(b.URI.file(f));v["common.source"]=t.value.toString().slice(0,30)}catch{}return v}i.resolveCommonProperties=P;function l(p){const C=R.env.USERDNSDOMAIN;if(!C)return!1;const T=C.toLowerCase();return p.some(d=>T===d)}i.verifyMicrosoftInternalDomain=l}),define(Y[31],Q([0,1,13]),function(j,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TelemetryConfiguration=i.TelemetryLevel=i.TELEMETRY_OLD_SETTING_ID=i.TELEMETRY_SETTING_ID=i.TELEMETRY_SECTION_ID=i.machineIdKey=i.lastSessionDateStorageKey=i.firstSessionDateStorageKey=i.currentSessionDateStorageKey=i.ICustomEndpointTelemetryService=i.ITelemetryService=void 0,i.ITelemetryService=(0,D.createDecorator)("telemetryService"),i.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),i.currentSessionDateStorageKey="telemetry.currentSessionDate",i.firstSessionDateStorageKey="telemetry.firstSessionDate",i.lastSessionDateStorageKey="telemetry.lastSessionDate",i.machineIdKey="telemetry.machineId",i.TELEMETRY_SECTION_ID="telemetry",i.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",i.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var R;(function(I){I[I.NONE=0]="NONE",I[I.CRASH=1]="CRASH",I[I.ERROR=2]="ERROR",I[I.USAGE=3]="USAGE"})(R=i.TelemetryLevel||(i.TelemetryLevel={}));var b;(function(I){I.OFF="off",I.CRASH="crash",I.ERROR="error",I.ON="all"})(b=i.TelemetryConfiguration||(i.TelemetryConfiguration={}))}),define(Y[118],Q([0,1,18,3,24,8,7,2,12,6,9,74,23,21,14,32,31]),function(j,i,D,R,b,I,L,P,l,p,C,T,d,y,w,g,u){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractExtensionTask=i.reportTelemetry=i.joinErrors=i.AbstractExtensionManagementService=void 0;let f=class extends P.Disposable{constructor(r,t,n,s){super();this.galleryService=r,this.telemetryService=t,this.logService=n,this.productService=s,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new L.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new L.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new L.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new L.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,P.toDisposable)(()=>{this.installingExtensions.forEach(a=>a.cancel()),this.uninstallingExtensions.forEach(a=>a.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(r){const t=await this.getTargetPlatform();return r.allTargetPlatforms.some(n=>(0,d.isTargetPlatformCompatible)(n,r.allTargetPlatforms,t))}async installFromGallery(r,t={}){try{if(!this.galleryService.isEnabled())throw new d.ExtensionManagementError(T.localize(0,null),d.ExtensionManagementErrorCode.Internal);const n=await this.checkAndGetCompatibleVersion(r,!t.installGivenVersion,!!t.installPreReleaseVersion);return await this.installExtension(n.manifest,n.extension,t)}catch(n){throw m(this.telemetryService,"extensionGallery:install",(0,y.getGalleryExtensionTelemetryData)(r),void 0,n),this.logService.error("Failed to install extension.",r.identifier.id),this.logService.error(n),v(n)}}async uninstall(r,t={}){return this.logService.trace("ExtensionManagementService#uninstall",r.identifier.id),this.unininstallExtension(r,t)}async reinstallFromGallery(r){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",r.identifier.id),!this.galleryService.isEnabled())throw new Error(T.localize(1,null));const t=await this.getTargetPlatform(),[n]=await this.galleryService.getExtensions([{...r.identifier,preRelease:r.preRelease}],{targetPlatform:t,compatible:!0},b.CancellationToken.None);if(!n)throw new Error(T.localize(2,null));await this.createUninstallExtensionTask(r,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(n)}getExtensionsControlManifest(){const r=new Date().getTime();return(!this.extensionsControlManifest||r-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=r),this.extensionsControlManifest}registerParticipant(r){this.participants.push(r)}async installExtension(r,t,n){if(!C.URI.isUri(t)){let S=this.installingExtensions.get(new y.ExtensionIdentifierWithVersion(t.identifier,t.version).key());if(S)return this.logService.info("Extensions is already requested to install",t.identifier.id),S.waitUntilTaskIsFinished();n={...n,installOnlyNewlyAddedFromExtensionPack:!0}}const s=[],a=[],c=this.createInstallExtensionTask(r,t,n);C.URI.isUri(t)||this.installingExtensions.set(new y.ExtensionIdentifierWithVersion(c.identifier,r.version).key(),c),this._onInstallExtension.fire({identifier:c.identifier,source:t}),this.logService.info("Installing extension:",c.identifier.id),s.push({task:c,manifest:r});let h=!1;try{if(n.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",c.identifier.id);else try{const O=await this.getAllDepsAndPackExtensionsToInstall(c.identifier,r,!!n.installOnlyNewlyAddedFromExtensionPack,!!n.installPreReleaseVersion);for(const{gallery:N,manifest:_}of O)if(h=h||!!_.extensionDependencies?.some(J=>(0,y.areSameExtensions)({id:J},c.identifier)),this.installingExtensions.has(new y.ExtensionIdentifierWithVersion(N.identifier,N.version).key()))this.logService.info("Extension is already requested to install",N.identifier.id);else{const J=this.createInstallExtensionTask(_,N,{...n,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new y.ExtensionIdentifierWithVersion(J.identifier,_.version).key(),J),this._onInstallExtension.fire({identifier:J.identifier,source:N}),this.logService.info("Installing extension:",J.identifier.id),s.push({task:J,manifest:_})}}catch(O){if(C.URI.isUri(c.source))(0,D.isNonEmptyArray)(r.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",c.identifier.id,O.message),(0,D.isNonEmptyArray)(r.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",c.identifier.id,O.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",c.identifier.id),O}const S=s.reduce((O,{task:N,manifest:_})=>(O.set(N.identifier.id.toLowerCase(),{task:N,manifest:_}),O),new Map);for(;S.size;){let O;const N=[...S.values()].filter(({manifest:_})=>!_.extensionDependencies?.some(J=>S.has(J.toLowerCase())));N.length?O=S.size===1?N:N.filter(({task:_})=>!(_===c&&!h)):(this.logService.info("Found extensions with circular dependencies",N.map(({task:_})=>_.identifier.id)),O=[...S.values()]),await this.joinAllSettled(O.map(async({task:_})=>{const J=new Date().getTime(),re=(0,p.isUndefined)(n.operation)?_.operation:n.operation;try{const ee=await _.run();if(await this.joinAllSettled(this.participants.map(ie=>ie.postInstall(ee,_.source,n,b.CancellationToken.None))),!C.URI.isUri(_.source)&&(m(this.telemetryService,re===3?"extensionGallery:update":"extensionGallery:install",(0,y.getGalleryExtensionTelemetryData)(_.source),new Date().getTime()-J,void 0),l.isWeb&&re!==3))try{await this.galleryService.reportStatistic(ee.manifest.publisher,ee.manifest.name,ee.manifest.version,"install")}catch{}a.push({local:ee,identifier:_.identifier,operation:re,source:_.source})}catch(ee){throw C.URI.isUri(_.source)||m(this.telemetryService,re===3?"extensionGallery:update":"extensionGallery:install",(0,y.getGalleryExtensionTelemetryData)(_.source),new Date().getTime()-J,ee),this.logService.error("Error while installing the extension:",_.identifier.id),ee}finally{S.delete(_.identifier.id.toLowerCase())}}))}return a.forEach(({identifier:O})=>this.logService.info("Extension installed successfully:",O.id)),this._onDidInstallExtensions.fire(a),a.filter(({identifier:O})=>(0,y.areSameExtensions)(O,c.identifier))[0].local}catch(S){if(s.forEach(({task:O})=>O.cancel()),a.length)try{const O=await Promise.allSettled(a.map(({local:N})=>this.createUninstallExtensionTask(N,{versionOnly:!0}).run()));for(let N=0;N<O.length;N++){const _=O[N],{identifier:J}=a[N];_.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",J.id):this.logService.warn("Rollback: Error while uninstalling extension",J.id,(0,I.getErrorMessage)(_.reason))}}catch(O){this.logService.warn("Error while rolling back extensions",(0,I.getErrorMessage)(O),a.map(({identifier:N})=>N.id))}throw this._onDidInstallExtensions.fire(s.map(({task:O})=>({identifier:O.identifier,operation:2,source:O.source}))),S}finally{for(const{task:S,manifest:O}of s)if(!C.URI.isUri(S.source)){const N=new y.ExtensionIdentifierWithVersion(S.identifier,O.version).key();this.installingExtensions.delete(N)||this.logService.warn("Installation task is not found in the cache",N)}}}async joinAllSettled(r){const t=[],n=[],s=await Promise.allSettled(r);for(const a of s)a.status==="fulfilled"?t.push(a.value):n.push(a.reason);if(n.length)throw E(n);return t}async getAllDepsAndPackExtensionsToInstall(r,t,n,s){if(!this.galleryService.isEnabled())return[];let a=await this.getInstalled();const c=[r,...a.map(O=>O.identifier)],h=[],S=async(O,N)=>{const _=N.extensionDependencies||[],J=[..._];if(N.extensionPack){const re=n?a.find(ee=>(0,y.areSameExtensions)(ee.identifier,O)):void 0;for(const ee of N.extensionPack)re&&re.manifest.extensionPack&&re.manifest.extensionPack.some(ie=>(0,y.areSameExtensions)({id:ie},{id:ee}))||J.every(ie=>!(0,y.areSameExtensions)({id:ie},{id:ee}))&&J.push(ee)}if(J.length){const re=[...c,...h.map(ie=>ie.gallery.identifier)],ee=J.filter(ie=>re.every(he=>!(0,y.areSameExtensions)(he,{id:ie})));if(ee.length){const ie=await this.galleryService.getExtensions(ee.map(he=>({id:he,preRelease:s})),b.CancellationToken.None);for(const he of ie){if(re.find(te=>(0,y.areSameExtensions)(te,he.identifier)))continue;const ue=_.some(te=>(0,y.areSameExtensions)({id:te},he.identifier));let x;try{x=await this.checkAndGetCompatibleVersion(he,!0,s)}catch(te){if(te instanceof d.ExtensionManagementError&&te.code===d.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!ue){this.logService.info("Skipping the packed extension as it cannot be installed",he.identifier.id);continue}else throw te}h.push({gallery:x.extension,manifest:x.manifest}),await S(x.extension.identifier,x.manifest)}}}};return await S(r,t),a=await this.getInstalled(),h.filter(O=>!a.some(N=>(0,y.areSameExtensions)(N.identifier,O.gallery.identifier)))}async checkAndGetCompatibleVersion(r,t,n){const s=await this.getExtensionsControlManifest();if((0,y.getMaliciousExtensionsSet)(s).has(r.identifier.id))throw new d.ExtensionManagementError(T.localize(3,null,r.identifier.id),d.ExtensionManagementErrorCode.Malicious);if(!!s.unsupportedPreReleaseExtensions&&!!s.unsupportedPreReleaseExtensions[r.identifier.id])throw new d.ExtensionManagementError(T.localize(4,null,r.identifier.id,s.unsupportedPreReleaseExtensions[r.identifier.id].displayName),d.ExtensionManagementErrorCode.UnsupportedPreRelease);if(!await this.canInstall(r)){const h=await this.getTargetPlatform();throw new d.ExtensionManagementError(T.localize(5,null,r.identifier.id,this.productService.nameLong,(0,d.TargetPlatformToString)(h)),d.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const a=await this.getCompatibleVersion(r,t,n);if(a){if(n&&t&&r.hasPreReleaseVersion&&!a.properties.isPreReleaseVersion)throw new d.ExtensionManagementError(T.localize(6,null,r.identifier.id,this.productService.nameLong,this.productService.version),d.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!n&&r.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([r.identifier],b.CancellationToken.None))[0]?new d.ExtensionManagementError(T.localize(7,null,r.identifier.id),d.ExtensionManagementErrorCode.ReleaseVersionNotFound):new d.ExtensionManagementError(T.localize(8,null,r.identifier.id,this.productService.nameLong,this.productService.version),d.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",a.identifier.id);const c=await this.galleryService.getManifest(a,b.CancellationToken.None);if(c===null)throw new d.ExtensionManagementError(`Missing manifest for extension ${r.identifier.id}`,d.ExtensionManagementErrorCode.Invalid);if(c.version!==a.version)throw new d.ExtensionManagementError(`Cannot install '${r.identifier.id}' extension because of version mismatch in Marketplace`,d.ExtensionManagementErrorCode.Invalid);return{extension:a,manifest:c}}async getCompatibleVersion(r,t,n){const s=await this.getTargetPlatform();let a=null;return t&&r.hasPreReleaseVersion&&r.properties.isPreReleaseVersion!==n&&(a=(await this.galleryService.getExtensions([{...r.identifier,preRelease:n}],{targetPlatform:s,compatible:!0},b.CancellationToken.None))[0]||null),!a&&await this.galleryService.isExtensionCompatible(r,n,s)&&(a=r),!a&&t&&(a=await this.galleryService.getCompatibleExtension(r,n,s)),a}async unininstallExtension(r,t){const n=this.uninstallingExtensions.get(r.identifier.id.toLowerCase());if(n)return this.logService.info("Extensions is already requested to uninstall",r.identifier.id),n.waitUntilTaskIsFinished();const s=(S,O)=>{const N=this.createUninstallExtensionTask(S,O);return this.uninstallingExtensions.set(N.extension.identifier.id.toLowerCase(),N),this.logService.info("Uninstalling extension:",S.identifier.id),this._onUninstallExtension.fire(S.identifier),N},a=(S,O)=>{O?this.logService.error("Failed to uninstall extension:",S.identifier.id,O.message):this.logService.info("Successfully uninstalled extension:",S.identifier.id),m(this.telemetryService,"extensionGallery:uninstall",(0,y.getLocalExtensionTelemetryData)(S),void 0,O),this._onDidUninstallExtension.fire({identifier:S.identifier,error:O?.code})},c=[],h=[];try{c.push(s(r,{}));const S=await this.getInstalled(1);if(t.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",r.identifier.id);else{const O=this.getAllPackExtensionsToUninstall(r,S);for(const N of O)this.uninstallingExtensions.has(N.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",N.identifier.id):c.push(s(N,{}))}t.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",r.identifier.id):this.checkForDependents(c.map(O=>O.extension),S,r),await this.joinAllSettled(c.map(async O=>{try{if(await O.run(),await this.joinAllSettled(this.participants.map(N=>N.postUninstall(O.extension,t,b.CancellationToken.None))),O.extension.identifier.uuid)try{await this.galleryService.reportStatistic(O.extension.manifest.publisher,O.extension.manifest.name,O.extension.manifest.version,"uninstall")}catch{}a(O.extension)}catch(N){const _=N instanceof d.ExtensionManagementError?N:new d.ExtensionManagementError((0,I.getErrorMessage)(N),d.ExtensionManagementErrorCode.Internal);throw a(O.extension,_),_}finally{h.push(O)}}))}catch(S){const O=S instanceof d.ExtensionManagementError?S:new d.ExtensionManagementError((0,I.getErrorMessage)(S),d.ExtensionManagementErrorCode.Internal);for(const N of c){try{N.cancel()}catch{}h.includes(N)||a(N.extension,O)}throw O}finally{for(const S of c)this.uninstallingExtensions.delete(S.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",S.extension.identifier.id)}}checkForDependents(r,t,n){for(const s of r){const a=this.getDependents(s,t);if(a.length){const c=a.filter(h=>!r.some(S=>(0,y.areSameExtensions)(S.identifier,h.identifier)));if(c.length)throw new Error(this.getDependentsErrorMessage(s,c,n))}}}getDependentsErrorMessage(r,t,n){return n===r?t.length===1?T.localize(9,null,n.manifest.displayName||n.manifest.name,t[0].manifest.displayName||t[0].manifest.name):t.length===2?T.localize(10,null,n.manifest.displayName||n.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):T.localize(11,null,n.manifest.displayName||n.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):t.length===1?T.localize(12,null,n.manifest.displayName||n.manifest.name,r.manifest.displayName||r.manifest.name,t[0].manifest.displayName||t[0].manifest.name):t.length===2?T.localize(13,null,n.manifest.displayName||n.manifest.name,r.manifest.displayName||r.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):T.localize(14,null,n.manifest.displayName||n.manifest.name,r.manifest.displayName||r.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name)}getAllPackExtensionsToUninstall(r,t,n=[]){if(n.indexOf(r)!==-1)return[];n.push(r);const s=r.manifest.extensionPack?r.manifest.extensionPack:[];if(s.length){const a=t.filter(h=>!h.isBuiltin&&s.some(S=>(0,y.areSameExtensions)({id:S},h.identifier))),c=[];for(const h of a)c.push(...this.getAllPackExtensionsToUninstall(h,t,n));return[...a,...c]}return[]}getDependents(r,t){return t.filter(n=>n.manifest.extensionDependencies&&n.manifest.extensionDependencies.some(s=>(0,y.areSameExtensions)({id:s},r.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const r=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",r),r}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[]}}}};f=ge([oe(0,d.IExtensionGalleryService),oe(1,u.ITelemetryService),oe(2,w.ILogService),oe(3,g.IProductService)],f),i.AbstractExtensionManagementService=f;function E(e){const r=Array.isArray(e)?e:[e];return r.length===1?r[0]instanceof Error?r[0]:new Error(r[0]):r.reduce((t,n)=>new Error(`${t.message}${t.message?",":""}${n instanceof Error?n.message:n}`),new Error(""))}i.joinErrors=E;function v(e){if(e instanceof d.ExtensionManagementError)return e;const r=new d.ExtensionManagementError(e.message,d.ExtensionManagementErrorCode.Internal);return r.stack=e.stack,r}function m(e,r,t,n,s){const a=s?s instanceof d.ExtensionManagementError?s.code:d.ExtensionManagementErrorCode.Internal:void 0;e.publicLogError(r,{...t,success:!s,duration:n,errorcode:a})}i.reportTelemetry=m;class o{constructor(){this.barrier=new R.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,R.createCancelablePromise)(r=>this.doRun(r))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,R.createCancelablePromise)(r=>new Promise((t,n)=>{const s=r.onCancellationRequested(()=>{s.dispose(),n((0,I.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}i.AbstractExtensionTask=o}),define(Y[36],Q([0,1,22,6,25,31]),function(j,i,D,R,b,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getPiiPathsFromEnvironment=i.cleanRemoteAuthority=i.validateTelemetryData=i.getTelemetryLevel=i.supportsTelemetry=i.configurationTelemetry=i.NullAppender=i.NullEndpointTelemetryService=i.NullTelemetryService=i.NullTelemetryServiceShape=void 0;class L{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(E,v){return Promise.resolve(void 0)}publicLog2(E,v){return this.publicLog(E,v)}publicLogError(E,v){return Promise.resolve(void 0)}publicLogError2(E,v){return this.publicLogError(E,v)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}i.NullTelemetryServiceShape=L,i.NullTelemetryService=new L;class P{async publicLog(E,v,m){}async publicLogError(E,v,m){}}i.NullEndpointTelemetryService=P,i.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function l(f,E){return E.onDidChangeConfiguration(v=>{v.source!==6&&f.publicLog2("updateConfiguration",{configurationSource:(0,b.ConfigurationTargetToString)(v.source),configurationKeys:w(v.sourceConfig)})})}i.configurationTelemetry=l;function p(f,E){return!(E.disableTelemetry||!f.enableTelemetry||E.extensionTestsLocationURI)}i.supportsTelemetry=p;function C(f){const E=f.getValue(I.TELEMETRY_SETTING_ID),v=f.getValue("telemetry.enableCrashReporter");if(f.getValue(I.TELEMETRY_OLD_SETTING_ID)===!1||v===!1)return 0;switch(E??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}i.getTelemetryLevel=C;function T(f){const E=Object.create(null),v=Object.create(null),m=Object.create(null);y(f,m);for(let o in m){o=o.length>150?o.substr(o.length-149):o;const e=m[o];typeof e=="number"?v[o]=e:typeof e=="boolean"?v[o]=e?1:0:typeof e=="string"?(e.length>8192&&console.warn(`Telemetry property: ${o} has been trimmed to 8192, the original length is ${e.length}`),E[o]=e.substring(0,8191)):typeof e!="undefined"&&e!==null&&(E[o]=e)}return{properties:E,measurements:v}}i.validateTelemetryData=T;function d(f){if(!f)return"none";let E="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(m=>{f.indexOf(`${m}+`)===0&&(E=m)}),E}i.cleanRemoteAuthority=d;function y(f,E,v=0,m){if(!!f)for(let o of Object.getOwnPropertyNames(f)){const e=f[o],r=m?m+o:o;Array.isArray(e)?E[r]=(0,D.safeStringify)(e):e instanceof Date?E[r]=e.toISOString():(0,R.isObject)(e)?v<2?y(e,E,v+1,r+"."):E[r]=(0,D.safeStringify)(e):E[r]=e}}function w(f){if(!f)return[];const E=[];return g(E,"",f),E}function g(f,E,v){v&&typeof v=="object"&&!Array.isArray(v)?Object.keys(v).forEach(m=>g(f,E?`${E}.${m}`:m,v[m])):f.push(E)}function u(f){return[f.appRoot,f.extensionsPath,f.userHome.fsPath,f.tmpDir.fsPath,f.userDataPath]}i.getPiiPathsFromEnvironment=u}),define(Y[119],Q([0,1,91,36]),function(j,i,D,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.resolveMarketplaceHeaders=void 0;async function b(I,L,P,l,p,C){const T={"X-Market-Client-Id":`VSCode ${I}`,"User-Agent":`VSCode ${I} (${L.nameShort})`},d=await(0,D.getServiceMachineId)(P,p,C);return(0,R.supportsTelemetry)(L,P)&&(0,R.getTelemetryLevel)(l)===3&&(T["X-Market-User-Id"]=d),T}i.resolveMarketplaceHeaders=b}),define(Y[120],Q([0,1,18,24,8,22,12,29,6,9,25,20,23,21,48,16,14,32,42,119,116,31]),function(j,i,D,R,b,I,L,P,l,p,C,T,d,y,w,g,u,f,E,v,m,o){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionGalleryServiceWithNoStorageService=i.ExtensionGalleryService=i.sortExtensionVersions=void 0;const e=L.isWeb?"web":(0,d.getTargetPlatform)(L.platform,P.arch);var r;(function(M){M[M.None=0]="None",M[M.IncludeVersions=1]="IncludeVersions",M[M.IncludeFiles=2]="IncludeFiles",M[M.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",M[M.IncludeSharedAccounts=8]="IncludeSharedAccounts",M[M.IncludeVersionProperties=16]="IncludeVersionProperties",M[M.ExcludeNonValidated=32]="ExcludeNonValidated",M[M.IncludeInstallationTargets=64]="IncludeInstallationTargets",M[M.IncludeAssetUri=128]="IncludeAssetUri",M[M.IncludeStatistics=256]="IncludeStatistics",M[M.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",M[M.Unpublished=4096]="Unpublished",M[M.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(r||(r={}));function t(...M){return String(M.reduce((A,V)=>A|V,0))}var n;(function(M){M[M.Tag=1]="Tag",M[M.ExtensionId=4]="ExtensionId",M[M.Category=5]="Category",M[M.ExtensionName=7]="ExtensionName",M[M.Target=8]="Target",M[M.Featured=9]="Featured",M[M.SearchText=10]="SearchText",M[M.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const s={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},h={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:r.None,criteria:[],assetTypes:[]};class S{constructor(A=h){this.state=A}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(A,V=this.state.pageSize){return new S({...this.state,pageNumber:A,pageSize:V})}withFilter(A,...V){const B=[...this.state.criteria,...V.length?V.map(H=>({filterType:A,value:H})):[{filterType:A}]];return new S({...this.state,criteria:B})}withSortBy(A){return new S({...this.state,sortBy:A})}withSortOrder(A){return new S({...this.state,sortOrder:A})}withFlags(...A){return new S({...this.state,flags:A.reduce((V,B)=>V|B,0)})}withAssetTypes(...A){return new S({...this.state,assetTypes:A})}get raw(){const{criteria:A,pageNumber:V,pageSize:B,sortBy:H,sortOrder:X,flags:ae,assetTypes:ce}=this.state;return{filters:[{criteria:A,pageNumber:V,pageSize:B,sortBy:H,sortOrder:X}],assetTypes:ce,flags:ae}}get searchText(){const A=this.state.criteria.filter(V=>V.filterType===n.SearchText)[0];return A&&A.value?A.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(A=>String(A.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function O(M,A){const V=(M||[]).filter(B=>B.statisticName===A)[0];return V?V.value:0}function N(M){const A="Microsoft.VisualStudio.Code.Translation.";return M.files.filter(B=>B.assetType.indexOf(A)===0).reduce((B,H)=>{const X=ee(M,H.assetType);return X&&B.push([H.assetType.substring(A.length),X]),B},[])}function _(M){if(M.properties){const A=M.properties.filter(H=>H.key===s.Repository),V=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),B=A.filter(H=>V.test(H.value))[0];return B?{uri:B.value,fallbackUri:B.value}:null}return ee(M,s.Repository)}function J(M){return{uri:`${M.fallbackAssetUri}/${s.VSIX}?redirect=true${M.targetPlatform?`&targetPlatform=${M.targetPlatform}`:""}`,fallbackUri:`${M.fallbackAssetUri}/${s.VSIX}${M.targetPlatform?`?targetPlatform=${M.targetPlatform}`:""}`}}function re(M){const A=ee(M,s.Icon);if(A)return A;const V=d.DefaultIconPath;return{uri:V,fallbackUri:V}}function ee(M,A){return M.files.filter(B=>B.assetType===A)[0]?{uri:`${M.assetUri}/${A}${M.targetPlatform?`?targetPlatform=${M.targetPlatform}`:""}`,fallbackUri:`${M.fallbackAssetUri}/${A}${M.targetPlatform?`?targetPlatform=${M.targetPlatform}`:""}`}:null}function ie(M,A){const V=M.properties?M.properties.filter(H=>H.key===A):[],B=V.length>0&&V[0].value;return B?B.split(",").map(H=>(0,y.adoptToGalleryExtensionId)(H)):[]}function he(M){const A=M.properties?M.properties.filter(V=>V.key===a.Engine):[];return A.length>0&&A[0].value||""}function ue(M){const A=M.properties?M.properties.filter(V=>V.key===a.PreRelease):[];return A.length>0&&A[0].value==="true"}function x(M){const A=M.properties?M.properties.filter(B=>B.key===a.LocalizedLanguages):[],V=A.length>0&&A[0].value||"";return V?V.split(","):[]}function te(M){return M.indexOf("preview")!==-1}function U(M){return M.targetPlatform?(0,d.toTargetPlatform)(M.targetPlatform):"undefined"}function k(M){const A=(0,D.distinct)(M.versions.map(U)),V=!!M.tags?.includes(d.WEB_EXTENSION_TAG),B=A.indexOf("web");return V?B===-1&&A.push("web"):B!==-1&&A.splice(B,1),A}function z(M,A){const V=(0,d.getFallbackTargetPlarforms)(A);for(let B=0;B<M.length;B++){const H=M[B];if(H.version===M[B-1]?.version){let X=B;const ae=U(H);if(ae===A)for(;X>0&&M[X-1].version===H.version;)X--;else if(V.includes(ae))for(;X>0&&M[X-1].version===H.version&&U(M[X-1])!==A;)X--;X!==B&&(M.splice(B,1),M.splice(X,0,H))}}return M}i.sortExtensionVersions=z;function G(M,A,V){M.telemetryData={index:A,querySource:V}}function ne(M,A,V){const B=M.versions[0],H={manifest:ee(A,s.Manifest),readme:ee(A,s.Details),changelog:ee(A,s.Changelog),license:ee(A,s.License),repository:_(A),download:J(A),icon:re(A),coreTranslations:N(A)};return{identifier:{id:(0,y.getGalleryExtensionId)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},name:M.extensionName,version:A.version,displayName:M.displayName,publisherId:M.publisher.publisherId,publisher:M.publisher.publisherName,publisherDisplayName:M.publisher.displayName,publisherDomain:M.publisher.domain?{link:M.publisher.domain,verified:!!M.publisher.isDomainVerified}:void 0,description:M.shortDescription||"",installCount:O(M.statistics,"install"),rating:O(M.statistics,"averagerating"),ratingCount:O(M.statistics,"ratingcount"),categories:M.categories||[],tags:M.tags||[],releaseDate:Date.parse(M.releaseDate),lastUpdated:Date.parse(M.lastUpdated),allTargetPlatforms:V,assets:H,properties:{dependencies:ie(A,a.Dependency),extensionPack:ie(A,a.ExtensionPack),engine:he(A),localizedLanguages:x(A),targetPlatform:U(A),isPreReleaseVersion:ue(A)},hasPreReleaseVersion:ue(B),hasReleaseVersion:!0,preview:te(M.flags)}}let K=class{constructor(A,V,B,H,X,ae,ce,Ee){this.requestService=V,this.logService=B,this.environmentService=H,this.telemetryService=X,this.fileService=ae,this.productService=ce,this.configurationService=Ee;const fe=ce.extensionsGallery;this.extensionsGalleryUrl=fe&&fe.serviceUrl,this.extensionsControlUrl=fe&&fe.controlUrl,this.commonHeadersPromise=(0,v.resolveMarketplaceHeaders)(ce.version,ce,this.environmentService,this.configurationService,this.fileService,A)}api(A=""){return`${this.extensionsGalleryUrl}${A}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(A,V,B){const H=R.CancellationToken.isCancellationToken(V)?{}:V,X=R.CancellationToken.isCancellationToken(V)?V:B,ae=[],ce=[],Ee=[],fe=[];let se=!0;for(const we of A){we.uuid?ce.push(we.uuid):ae.push(we.id);const Ie=!!(we.version||we.preRelease);Ee.push({id:we.id,uuid:we.uuid,includePreRelease:Ie}),we.version&&fe.push({id:we.id,uuid:we.uuid,version:we.version}),se=se&&!!we.hasPreRelease&&!Ie}if(!ce.length&&!ae.length)return[];let me=new S().withPage(1,A.length);ce.length&&(me=me.withFilter(n.ExtensionId,...ce)),ae.length&&(me=me.withFilter(n.ExtensionName,...ae)),(H.queryAllVersions||se)&&(me=me.withFlags(me.flags,r.IncludeVersions));const{extensions:pe}=await this.queryGalleryExtensions(me,{targetPlatform:H.targetPlatform??e,includePreRelease:Ee,versions:fe,compatible:!!H.compatible},X);return H.source&&pe.forEach((we,Ie)=>G(we,Ie,H.source)),pe}async getCompatibleExtension(A,V,B){if((0,d.isNotWebExtensionInWebTargetPlatform)(A.allTargetPlatforms,B))return null;if(await this.isExtensionCompatible(A,V,B))return A;const H=new S().withFlags(r.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,A.identifier.uuid),{extensions:X}=await this.queryGalleryExtensions(H,{targetPlatform:B,compatible:!0,includePreRelease:V},R.CancellationToken.None);return X[0]||null}async isExtensionCompatible(A,V,B){if(!(0,d.isTargetPlatformCompatible)(A.properties.targetPlatform,A.allTargetPlatforms,B)||!V&&A.properties.isPreReleaseVersion)return!1;let H=A.properties.engine;if(!H){const X=await this.getManifest(A,R.CancellationToken.None);if(!X)throw new Error("Manifest was not found");H=X.engines.vscode}return(0,w.isEngineValid)(H,this.productService.version,this.productService.date)}async isValidVersion(A,V,B,H,X){if(!(0,d.isTargetPlatformCompatible)(U(A),H,X)||V!=="any"&&ue(A)!==(V==="prerelease"))return!1;if(B){const ae=await this.getEngine(A);if(!(0,w.isEngineValid)(ae,this.productService.version,this.productService.date))return!1}return!0}async query(A,V){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let B=A.text||"";const H=(0,I.getOrDefault)(A,se=>se.pageSize,50);let X=new S().withPage(1,H);B?(B=B.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(se,me,pe)=>(X=X.withFilter(n.Category,pe||me),"")),B=B.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(se,me,pe)=>(X=X.withFilter(n.Tag,pe||me),"")),B=B.replace(/\bfeatured(\s+|\b|$)/g,()=>(X=X.withFilter(n.Featured),"")),B=B.trim(),B&&(B=B.length<200?B:B.substring(0,200),X=X.withFilter(n.SearchText,B)),X=X.withSortBy(0)):A.ids?X=X.withFilter(n.ExtensionId,...A.ids):A.names?X=X.withFilter(n.ExtensionName,...A.names):X=X.withSortBy(4),typeof A.sortBy=="number"&&(X=X.withSortBy(A.sortBy)),typeof A.sortOrder=="number"&&(X=X.withSortOrder(A.sortOrder));const ae=async(se,me)=>{const{extensions:pe,total:we}=await this.queryGalleryExtensions(se,{targetPlatform:e,compatible:!1,includePreRelease:!!A.includePreRelease},me);return pe.forEach((Ie,Me)=>G(Ie,(se.pageNumber-1)*se.pageSize+Me,A.source)),{extensions:pe,total:we}},{extensions:ce,total:Ee}=await ae(X,V),fe=async(se,me)=>{if(me.isCancellationRequested)throw new b.CancellationError;const{extensions:pe}=await ae(X.withPage(se+1),me);return pe};return{firstPage:ce,total:Ee,pageSize:X.pageSize,getPage:fe}}async queryGalleryExtensions(A,V,B){const H=A.flags;!!(A.flags&r.IncludeLatestVersionOnly)&&!!(A.flags&r.IncludeVersions)&&(A=A.withFlags(A.flags&~r.IncludeVersions,r.IncludeLatestVersionOnly)),!(A.flags&r.IncludeLatestVersionOnly)&&!(A.flags&r.IncludeVersions)&&(A=A.withFlags(A.flags,r.IncludeLatestVersionOnly)),V.versions?.length&&(A=A.withFlags(A.flags&~r.IncludeLatestVersionOnly,r.IncludeVersions)),A=A.withFlags(A.flags,r.IncludeAssetUri,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeStatistics,r.IncludeVersionProperties);const{galleryExtensions:X,total:ae}=await this.queryRawGalleryExtensions(A,B);if(!(A.flags&r.IncludeLatestVersionOnly)){const se=[];for(const me of X){const pe=await this.toGalleryExtensionWithCriteria(me,V,!0);pe&&se.push(pe)}return{extensions:se,total:ae}}const Ee=[],fe=new Map;for(let se=0;se<X.length;se++){const me=X[se],pe={id:(0,y.getGalleryExtensionId)(me.publisher.publisherName,me.extensionName),uuid:me.extensionId},we=(0,l.isBoolean)(V.includePreRelease)?V.includePreRelease:!!V.includePreRelease.find(Me=>(0,y.areSameExtensions)(Me,pe))?.includePreRelease;let Ie=await this.toGalleryExtensionWithCriteria(me,V,!1);!Ie||Ie.properties.isPreReleaseVersion&&(!we||!Ie.hasReleaseVersion)||!Ie.properties.isPreReleaseVersion&&Ie.properties.targetPlatform!==V.targetPlatform&&Ie.hasPreReleaseVersion?fe.set(me.extensionId,se):Ee.push([se,Ie])}if(fe.size){const se=new Date().getTime(),me=new S().withFlags(H&~r.IncludeLatestVersionOnly,r.IncludeVersions).withPage(1,fe.size).withFilter(n.ExtensionId,...fe.keys()),{extensions:pe}=await this.queryGalleryExtensions(me,V,B);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-se,count:fe.size});for(const we of pe){const Ie=fe.get(we.identifier.uuid);Ee.push([Ie,we])}}return{extensions:Ee.sort((se,me)=>se[0]-me[0]).map(([,se])=>se),total:ae}}async toGalleryExtensionWithCriteria(A,V,B){const H={id:(0,y.getGalleryExtensionId)(A.publisher.publisherName,A.extensionName),uuid:A.extensionId},X=V.versions?.find(fe=>(0,y.areSameExtensions)(fe,H))?.version,ae=(0,l.isBoolean)(V.includePreRelease)?V.includePreRelease:!!V.includePreRelease.find(fe=>(0,y.areSameExtensions)(fe,H))?.includePreRelease,ce=k(A),Ee=z(A.versions,V.targetPlatform);if(V.compatible&&B&&(0,d.isNotWebExtensionInWebTargetPlatform)(ce,V.targetPlatform))return null;for(let fe=0;fe<Ee.length;fe++){const se=Ee[fe];if(!(X&&se.version!==X)){if(await this.isValidVersion(se,ae?"any":"release",V.compatible,ce,V.targetPlatform))return ne(A,se,ce);if(X&&se.version===X)return null}}return X||V.compatible?null:ne(A,A.versions[0],ce)}async queryRawGalleryExtensions(A,V){if(!this.isEnabled())throw new Error("No extension gallery service configured.");A=A.withFlags(A.flags,r.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,t(r.Unpublished));const B=await this.commonHeadersPromise,H=JSON.stringify(A.raw),X={...B,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(H.length)},ae=new Date().getTime();let ce,Ee,fe=0;try{if(ce=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:H,headers:X},V),ce.res.statusCode&&ce.res.statusCode>=400&&ce.res.statusCode<500)return{galleryExtensions:[],total:fe};const se=await(0,E.asJson)(ce);if(se){const me=se.results[0],pe=me.extensions,we=me.resultMetadata&&me.resultMetadata.filter(Ie=>Ie.metadataType==="ResultCount")[0];return fe=we&&we.metadataItems.filter(Ie=>Ie.name==="TotalCount")[0].count||0,{galleryExtensions:pe,total:fe}}return{galleryExtensions:[],total:fe}}catch(se){throw Ee=se,se}finally{this.telemetryService.publicLog2("galleryService:query",{...A.telemetryData,requestBodySize:String(H.length),duration:new Date().getTime()-ae,success:!!ce&&(0,E.isSuccess)(ce),responseBodySize:ce?.res.headers["Content-Length"],statusCode:ce?String(ce.res.statusCode):void 0,errorCode:Ee?(0,b.isCancellationError)(Ee)?"canceled":(0,b.getErrorMessage)(Ee).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(fe)})}}async reportStatistic(A,V,B,H){if(!this.isEnabled())return;const X=L.isWeb?this.api(`/itemName/${A}.${V}/version/${B}/statType/${H==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${A}/extensions/${V}/${B}/stats?statType=${H}`),ae=L.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",Ee={...await this.commonHeadersPromise,Accept:ae};try{await this.requestService.request({type:"POST",url:X,headers:Ee},R.CancellationToken.None)}catch{}}async download(A,V,B){this.logService.trace("ExtensionGalleryService#download",A.identifier.id);const H=(0,y.getGalleryExtensionTelemetryData)(A),X=new Date().getTime(),ae=se=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...H,duration:se}),ce=B===2?"install":B===3?"update":"",Ee=ce?{uri:`${A.assets.download.uri}${p.URI.parse(A.assets.download.uri).query?"&":"?"}${ce}=true`,fallbackUri:`${A.assets.download.fallbackUri}${p.URI.parse(A.assets.download.fallbackUri).query?"&":"?"}${ce}=true`}:A.assets.download,fe=await this.getAsset(Ee);await this.fileService.writeFile(V,fe.stream),ae(new Date().getTime()-X)}async getReadme(A,V){if(A.assets.readme){const B=await this.getAsset(A.assets.readme,{},V);return await(0,E.asText)(B)||""}return""}async getManifest(A,V){if(A.assets.manifest){const B=await this.getAsset(A.assets.manifest,{},V),H=await(0,E.asText)(B);return H?JSON.parse(H):null}return null}async getManifestFromRawExtensionVersion(A,V){const B=ee(A,s.Manifest);if(!B)throw new Error("Manifest was not found");const H={"Accept-Encoding":"gzip"},X=await this.getAsset(B,{headers:H});return await(0,E.asJson)(X)}async getCoreTranslation(A,V){const B=A.assets.coreTranslations.filter(H=>H[0]===V.toUpperCase())[0];if(B){const H=await this.getAsset(B[1]),X=await(0,E.asText)(H);return X?JSON.parse(X):null}return null}async getChangelog(A,V){if(A.assets.changelog){const B=await this.getAsset(A.assets.changelog,{},V);return await(0,E.asText)(B)||""}return""}async getAllCompatibleVersions(A,V,B){let H=new S().withFlags(r.IncludeVersions,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1);A.identifier.uuid?H=H.withFilter(n.ExtensionId,A.identifier.uuid):H=H.withFilter(n.ExtensionName,A.identifier.id);const{galleryExtensions:X}=await this.queryRawGalleryExtensions(H,R.CancellationToken.None);if(!X.length)return[];const ae=k(X[0]);if((0,d.isNotWebExtensionInWebTargetPlatform)(ae,B))return[];const ce=[],Ee=new Set;return await Promise.all(X[0].versions.map(async fe=>{try{if(Ee.has(fe.version))return;await this.isValidVersion(fe,V?"any":"release",!0,ae,B)&&(ce.push({version:fe.version,date:fe.lastUpdated,isPreReleaseVersion:ue(fe)}),Ee.add(fe.version))}catch{}})),ce}async getAsset(A,V={},B=R.CancellationToken.None){const H=await this.commonHeadersPromise,X={type:"GET"},ae={...H,...V.headers||{}};V={...V,...X,headers:ae};const ce=A.uri,Ee=A.fallbackUri,fe={...V,url:ce};try{const se=await this.requestService.request(fe,B);if(se.res.statusCode===200)return se;const me=await(0,E.asText)(se);throw new Error(`Expected 200, got back ${se.res.statusCode} instead.

${me}`)}catch(se){if((0,b.isCancellationError)(se))throw se;const me=(0,b.getErrorMessage)(se);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ce,message:me});const pe={...V,url:Ee};return this.requestService.request(pe,B)}}async getEngine(A){let V=he(A);if(!V){const B=await this.getManifestFromRawExtensionVersion(A,R.CancellationToken.None);if(!B)throw new Error("Manifest was not found");V=B.engines.vscode}return V}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const A=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},R.CancellationToken.None);if(A.res.statusCode!==200)throw new Error("Could not get extensions report.");const V=await(0,E.asJson)(A),B=[],H={};if(V){for(const X of V.malicious)B.push({id:X});if(V.unsupported)for(const X of Object.keys(V.unsupported)){const ae=V.unsupported[X];(0,l.isBoolean)(ae)||(H[X.toLowerCase()]=ae.preReleaseExtension)}if(V.migrateToPreRelease)for(const[X,ae]of Object.entries(V.migrateToPreRelease))(!ae.engine||(0,w.isEngineValid)(ae.engine,this.productService.version,this.productService.date))&&(H[X.toLowerCase()]=ae)}return{malicious:B,unsupportedPreReleaseExtensions:H}}};K=ge([oe(1,E.IRequestService),oe(2,u.ILogService),oe(3,T.IEnvironmentService),oe(4,o.ITelemetryService),oe(5,g.IFileService),oe(6,f.IProductService),oe(7,C.IConfigurationService)],K);let Z=class extends K{constructor(A,V,B,H,X,ae,ce,Ee){super(A,V,B,H,X,ae,ce,Ee)}};Z=ge([oe(0,m.IStorageService),oe(1,E.IRequestService),oe(2,u.ILogService),oe(3,T.IEnvironmentService),oe(4,o.ITelemetryService),oe(5,g.IFileService),oe(6,f.IProductService),oe(7,C.IConfigurationService)],Z),i.ExtensionGalleryService=Z;let q=class extends K{constructor(A,V,B,H,X,ae,ce){super(void 0,A,V,B,H,X,ae,ce)}};q=ge([oe(0,E.IRequestService),oe(1,u.ILogService),oe(2,T.IEnvironmentService),oe(3,o.ITelemetryService),oe(4,g.IFileService),oe(5,f.IProductService),oe(6,C.IConfigurationService)],q),i.ExtensionGalleryServiceWithNoStorageService=q}),define(Y[121],Q([0,1,2,22,12,26,85,25,34,122,30,31,36]),function(j,i,D,R,b,I,L,P,l,p,C,T,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TelemetryService=void 0;let y=class{constructor(u,f){this._configurationService=f,this._experimentProperties={},this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appenders=u.appenders,this._commonProperties=u.commonProperties||Promise.resolve({}),this._piiPaths=u.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!u.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let E of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,I.escapeRegExpCharacters)(E),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(u,f){this._experimentProperties[u]=f}_updateTelemetryLevel(){this._telemetryLevel=(0,d.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const u=await this._commonProperties;let f=u.sessionID,E=u["common.machineId"],v=u["common.firstSessionDate"],m=u["common.msftInternal"];return{sessionId:f,machineId:E,firstSessionDate:v,msftInternal:m}}dispose(){this._disposables.dispose()}_log(u,f,E,v){return this.telemetryLevel<f?Promise.resolve(void 0):this._commonProperties.then(m=>{E=(0,R.mixin)(E,m),E=(0,R.mixin)(E,this._experimentProperties),E=(0,R.cloneAndChange)(E,o=>{if(typeof o=="string")return this._cleanupInfo(o,v)}),this._appenders.forEach(o=>o.log(u,E))},m=>{console.error(m)})}publicLog(u,f,E){return this._log(u,3,f,E)}publicLog2(u,f,E){return this.publicLog(u,f,E)}publicLogError(u,f){return this.sendErrorTelemetry?this._log(u,2,f,!0):Promise.resolve(void 0)}publicLogError2(u,f){return this.publicLogError(u,f)}_anonymizeFilePaths(u){let f=u;const E=[];for(let e of this._cleanupPatterns)for(;;){const r=e.exec(u);if(!r)break;E.push([r.index,e.lastIndex])}const v=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,m=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(f="";;){const e=m.exec(u);if(!e)break;!v.test(e[0])&&E.every(([r,t])=>e.index<r||e.index>=t)&&(f+=u.substring(o,e.index)+"<REDACTED: user-file-path>",o=m.lastIndex)}return o<u.length&&(f+=u.substr(o)),f}_removePropertiesWithPossibleUserInfo(u){if(!u)return u;const f=u.toLowerCase(),E=/@[a-zA-Z0-9-.]+/,v=/(key|token|sig|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/,m=/xox[pbaors]\-[a-zA-Z0-9]+\-[a-zA-Z0-9\-]+?/;return v.test(f)?"<REDACTED: secret>":E.test(f)?"<REDACTED: email>":m.test(f)?"<REDACTED: token>":u}_cleanupInfo(u,f){let E=u;f&&(E=this._anonymizeFilePaths(E));for(let v of this._cleanupPatterns)E=E.replace(v,"");return E=this._removePropertiesWithPossibleUserInfo(E),E}};y.IDLE_START_EVENT_NAME="UserIdleStart",y.IDLE_STOP_EVENT_NAME="UserIdleStop",y=ge([oe(1,P.IConfigurationService)],y),i.TelemetryService=y;function w(){const g=(0,L.localize)(0,null,p.default.nameLong),u=p.default.privacyStatementUrl?(0,L.localize)(2,null,"https://aka.ms/vscode-telemetry",p.default.privacyStatementUrl):(0,L.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=b.isWeb?"":(0,L.localize)(3,null),E=(0,L.localize)(4,null),v=(0,L.localize)(5,null),m=(0,L.localize)(6,null),o=(0,L.localize)(7,null),e=`
|       | ${E} | ${v} | ${m} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,L.localize)(8,null);return`
${g} ${u} ${f}

&nbsp;

${o}
${e}

&nbsp;

${r}
`}C.Registry.as(l.Extensions.Configuration).registerConfiguration({id:T.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,L.localize)(9,null),properties:{[T.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,L.localize)(10,null),(0,L.localize)(11,null),(0,L.localize)(12,null),(0,L.localize)(13,null)],markdownDescription:w(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),C.Registry.as(l.Extensions.Configuration).registerConfiguration({id:T.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,L.localize)(14,null),properties:{[T.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:p.default.privacyStatementUrl?(0,L.localize)(16,null,p.default.nameLong,p.default.privacyStatementUrl):(0,L.localize)(15,null,p.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,L.localize)(17,null,`\`#${T.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Y[123],Q([0,1,8,22,36]),function(j,i,D,R,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AppInsightsAppender=void 0;async function I(P,l){const p=await new Promise((T,d)=>{j(["applicationinsights"],T,d)});let C;return p.defaultClient?(C=new p.TelemetryClient(P),C.channel.setUseDiskRetryCaching(!0)):(p.setup(P).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),C=p.defaultClient),P.indexOf("AIF-")===0&&(C.config.endpointUrl=l?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),C}class L{constructor(l,p,C,T,d){this._eventPrefix=l,this._defaultData=p,this.testCollector=T,this.mirrored=d,this._defaultData||(this._defaultData=Object.create(null)),typeof C=="function"?this._aiClient=C():this._aiClient=C,this._asyncAIClient=null}_withAIClient(l){if(!!this._aiClient){if(typeof this._aiClient!="string"){l(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=I(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(p=>{l(p)},p=>{(0,D.onUnexpectedError)(p),console.error(p)})}}log(l,p){if(!!this._aiClient){p=(0,R.mixin)(p,this._defaultData),p=(0,b.validateTelemetryData)(p),this.testCollector&&(p.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++");try{this._withAIClient(C=>C.trackEvent({name:this._eventPrefix+"/"+l,properties:p.properties,measurements:p.measurements}))}catch{}}}flush(){return this._aiClient?new Promise(l=>{this._withAIClient(p=>{try{p.flush({callback:()=>{this._aiClient=void 0,l(void 0)}})}catch{}})}):Promise.resolve(void 0)}}i.AppInsightsAppender=L}),define(Y[124],Q([0,1,11,15]),function(j,i,D,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.buildTelemetryMessage=void 0;async function b(I,L){const P=Object.create(null),l=(C,T)=>{const d=JSON.parse(C);P[T]=d};if(L){const C=[],T=await R.Promises.readdir(L);for(const y of T)try{(await R.Promises.stat((0,D.join)(L,y))).isDirectory()&&C.push(y)}catch{}const d=[];for(const y of C)(await R.Promises.readdir((0,D.join)(L,y))).filter(g=>g==="telemetry.json").length===1&&d.push(y);for(const y of d){const w=(await R.Promises.readFile((0,D.join)(L,y,"telemetry.json"))).toString();l(w,y)}}let p=(await R.Promises.readFile((0,D.join)(I,"telemetry-core.json"))).toString();return l(p,"vscode-core"),p=(await R.Promises.readFile((0,D.join)(I,"telemetry-extensions.json"))).toString(),l(p,"vscode-extensions"),JSON.stringify(P,null,4)}i.buildTelemetryMessage=b}),define(Y[125],Q([0,1,39,11,86,24,28,8,12,27,70,138,3]),function(j,i,D,R,b,I,L,P,l,p,C,T,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getResolvedShellEnv=void 0;const y=1e4;let w;async function g(f,E,v){return E["force-disable-user-env"]?(f.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):l.isWindows?(f.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,T.isLaunchedFromCli)(v)&&!E["force-user-env"]?(f.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,T.isLaunchedFromCli)(v)?f.trace("resolveShellEnv(): running (--force-user-env)"):f.trace("resolveShellEnv(): running (macOS/Linux)"),w||(w=d.Promises.withAsyncBody(async(m,o)=>{const e=new I.CancellationTokenSource,r=setTimeout(()=>{e.dispose(!0),o(new Error((0,b.localize)(0,null)))},y);try{m(await u(f,e.token))}catch(t){!(0,P.isCancellationError)(t)&&!e.token.isCancellationRequested?o(new Error((0,b.localize)(1,null,(0,L.toErrorMessage)(t)))):m({})}finally{clearTimeout(r),e.dispose()}})),w)}i.getResolvedShellEnv=g;async function u(f,E){const v=process.env.ELECTRON_RUN_AS_NODE;f.trace("getUnixShellEnvironment#runAsNode",v);const m=process.env.ELECTRON_NO_ATTACH_CONSOLE;f.trace("getUnixShellEnvironment#noAttach",m);const o=(0,p.generateUuid)().replace(/-/g,"").substr(0,12),e=new RegExp(o+"(.*)"+o),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};f.trace("getUnixShellEnvironment#env",r);const t=await(0,C.getSystemShell)(l.OS,r);return f.trace("getUnixShellEnvironment#shell",t),new Promise((n,s)=>{if(E.isCancellationRequested)return s((0,P.canceled)());const a=(0,R.basename)(t);let c,h;const S=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(c=`& '${process.execPath}' ${S} -p '''${o}'' + JSON.stringify(process.env) + ''${o}'''`,h=["-Login","-Command"]):(c=`'${process.execPath}' ${S} -p '"${o}" + JSON.stringify(process.env) + "${o}"'`,a==="tcsh"?h=["-ic"]:h=["-ilc"]),f.trace("getUnixShellEnvironment#spawn",JSON.stringify(h),c);const O=(0,D.spawn)(t,[...h,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});E.onCancellationRequested(()=>(O.kill(),s((0,P.canceled)()))),O.on("error",J=>{f.error("getUnixShellEnvironment#errorChildProcess",(0,L.toErrorMessage)(J)),s(J)});const N=[];O.stdout.on("data",J=>N.push(J));const _=[];O.stderr.on("data",J=>_.push(J)),O.on("close",(J,re)=>{const ee=Buffer.concat(N).toString("utf8");f.trace("getUnixShellEnvironment#raw",ee);const ie=Buffer.concat(_).toString("utf8");if(ie.trim()&&f.trace("getUnixShellEnvironment#stderr",ie),J||re)return s(new Error((0,b.localize)(2,null,J,re)));const he=e.exec(ee),ue=he?he[1]:"{}";try{const x=JSON.parse(ue);v?x.ELECTRON_RUN_AS_NODE=v:delete x.ELECTRON_RUN_AS_NODE,m?x.ELECTRON_NO_ATTACH_CONSOLE=m:delete x.ELECTRON_NO_ATTACH_CONSOLE,delete x.XDG_RUNTIME_DIR,f.trace("getUnixShellEnvironment#result",x),n(x)}catch(x){f.error("getUnixShellEnvironment#errorCaught",(0,L.toErrorMessage)(x)),s(x)}})})}}),define(Y[37],Q([0,1,13]),function(j,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IUriIdentityService=void 0,i.IUriIdentityService=(0,D.createDecorator)("IUriIdentityService")}),define(Y[126],Q([0,1,7,2,9,20,21,16,14,37]),function(j,i,D,R,b,I,L,P,l,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsWatcher=void 0;let C=class extends R.Disposable{constructor(d,y,w,g,u){super();this.extensionsManagementService=d,this.logService=g,this.uriIdentityService=u,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(E=>{this.installedExtensions=E.map(v=>v.identifier),this.startTimestamp=Date.now()}),this._register(d.onInstallExtension(E=>this.onInstallExtension(E))),this._register(d.onDidInstallExtensions(E=>this.onDidInstallExtensions(E))),this._register(d.onDidUninstallExtension(E=>this.onDidUninstallExtension(E)));const f=b.URI.file(w.extensionsPath);this._register(y.watch(f)),this._register(D.Event.filter(y.onDidFilesChange,E=>E.rawChanges.some(v=>this.doesChangeAffects(v,f)))(()=>this.onDidChange()))}doesChangeAffects(d,y){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(d.resource),y)?this.uriIdentityService.extUri.isEqual(d.resource,this.uriIdentityService.extUri.joinPath(y,".obsolete"))?!0:!(d.type!==1&&d.type!==2||this.uriIdentityService.extUri.basename(d.resource).startsWith(".")):!1}onInstallExtension(d){this.addInstallingExtension(d.identifier)}onDidInstallExtensions(d){for(const y of d)this.removeInstallingExtension(y.identifier),y.local&&this.addInstalledExtension(y.identifier)}onDidUninstallExtension(d){d.error||this.removeInstalledExtension(d.identifier)}addInstallingExtension(d){this.removeInstallingExtension(d),this.installingExtensions.push(d)}removeInstallingExtension(d){this.installingExtensions=this.installingExtensions.filter(y=>!(0,L.areSameExtensions)(y,d))}addInstalledExtension(d){this.installedExtensions&&(this.removeInstalledExtension(d),this.installedExtensions.push(d))}removeInstalledExtension(d){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(y=>!(0,L.areSameExtensions)(y,d)))}async onDidChange(){if(this.installedExtensions){const d=await this.extensionsManagementService.getInstalled(1),y=d.filter(g=>[...this.installingExtensions,...this.installedExtensions].some(u=>(0,L.areSameExtensions)(u,g.identifier))?!1:g.installedTimestamp&&g.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",g.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",g.identifier.id),!1)),w=this.installedExtensions.filter(g=>this.installingExtensions.some(u=>(0,L.areSameExtensions)(u,g))?!1:d.every(u=>!(0,L.areSameExtensions)(u.identifier,g))?(this.logService.info("Detected extension removed from another source",g.id),!0):!1);this.installedExtensions=d.map(g=>g.identifier),(y.length||w.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:y,removed:w})}}};C=ge([oe(1,P.IFileService),oe(2,I.INativeEnvironmentService),oe(3,l.ILogService),oe(4,p.IUriIdentityService)],C),i.ExtensionsWatcher=C}),define(Y[127],Q([0,1,37,92,16,19,58,7,2]),function(j,i,D,R,b,I,L,P,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UriIdentityService=void 0;class p{constructor(d){this.uri=d,this.time=p._clock++}touch(){return this.time=p._clock++,this}}p._clock=0;let C=class{constructor(d){this._fileService=d,this._dispooables=new l.DisposableStore,this._limit=2**16;const y=new Map,w=g=>{let u=y.get(g.scheme);return u===void 0&&(u=d.hasProvider(g)&&!this._fileService.hasCapability(g,1024),y.set(g.scheme,u)),u};this._dispooables.add(P.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(g=>{y.delete(g.scheme)})),this.extUri=new I.ExtUri(w),this._canonicalUris=new L.SkipList((g,u)=>this.extUri.compare(g,u,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(d){this._fileService.hasProvider(d)&&(d=(0,I.normalizePath)(d));let y=this._canonicalUris.get(d);return y?y.touch().uri.with({fragment:d.fragment}):(this._canonicalUris.set(d,new p(d)),this._checkTrim(),d)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const d=[...this._canonicalUris.entries()].sort((w,g)=>w[1].touch<g[1].touch?1:w[1].touch>g[1].touch?-1:0);p._clock=0,this._canonicalUris.clear();const y=this._limit*.5;for(let w=0;w<y;w++)this._canonicalUris.set(d[w][0],d[w][1].touch())}};C=ge([oe(0,b.IFileService)],C),i.UriIdentityService=C,(0,R.registerSingleton)(D.IUriIdentityService,C,!0)}),define(Y[43],Q([0,1,103,3,11,6,15,72,139,140]),function(j,i,D,R,b,I,L,P,l,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.buffer=i.extract=i.zip=i.ExtractError=void 0;class C extends Error{constructor(e,r){let t=r.message;switch(e){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t);this.type=e,this.cause=r}}i.ExtractError=C;function T(o){const e=o.externalFileAttributes>>16||33188;return[448,56,7].map(r=>e&r).reduce((r,t)=>r+t,e&61440)}function d(o){if(o instanceof C)return o;let e;return/end of central directory record signature not found/.test(o.message)&&(e="CorruptZip"),new C(e,o)}function y(o,e,r,t,n,s){const a=b.dirname(e),c=b.join(t,a);if(!c.startsWith(t))return Promise.reject(new Error(P.localize(0,null,e)));const h=b.join(t,e);let S;return s.onCancellationRequested(()=>{S&&S.destroy()}),Promise.resolve(L.Promises.mkdir(c,{recursive:!0})).then(()=>new Promise((O,N)=>{if(!s.isCancellationRequested)try{S=(0,D.createWriteStream)(h,{mode:r}),S.once("close",()=>O()),S.once("error",N),o.once("error",N),o.pipe(S)}catch(_){N(_)}}))}function w(o,e,r,t){let n=(0,R.createCancelablePromise)(()=>Promise.resolve()),s=0;return t.onCancellationRequested(()=>{n.cancel(),o.close()}),new Promise((a,c)=>{const h=new R.Sequencer,S=O=>{O.isCancellationRequested||(s++,o.readEntry())};o.once("error",c),o.once("close",()=>n.then(()=>{t.isCancellationRequested||o.entryCount===s?a():c(new C("Incomplete",new Error(P.localize(1,null,s,o.entryCount))))},c)),o.readEntry(),o.on("entry",O=>{if(t.isCancellationRequested)return;if(!r.sourcePathRegex.test(O.fileName)){S(t);return}const N=O.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(N)){const re=b.join(e,N);n=(0,R.createCancelablePromise)(ee=>L.Promises.mkdir(re,{recursive:!0}).then(()=>S(ee)).then(void 0,c));return}const _=u(o,O),J=T(O);n=(0,R.createCancelablePromise)(re=>h.queue(()=>_.then(ee=>y(ee,N,J,e,r,re).then(()=>S(re)))).then(null,c))})})}function g(o,e=!1){return new Promise((r,t)=>{(0,l.open)(o,e?{lazyEntries:!0}:void 0,(n,s)=>{n?t(d(n)):r((0,I.assertIsDefined)(s))})})}function u(o,e){return new Promise((r,t)=>{o.openReadStream(e,(n,s)=>{n?t(d(n)):r((0,I.assertIsDefined)(s))})})}function f(o,e){return new Promise((r,t)=>{const n=new p.ZipFile;e.forEach(a=>{a.contents?n.addBuffer(typeof a.contents=="string"?Buffer.from(a.contents,"utf8"):a.contents,a.path):a.localPath&&n.addFile(a.localPath,a.path)}),n.end();const s=(0,D.createWriteStream)(o);n.outputStream.pipe(s),n.outputStream.once("error",t),s.once("error",t),s.once("finish",()=>r(o))})}i.zip=f;function E(o,e,r={},t){const n=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let s=g(o,!0);return r.overwrite&&(s=s.then(a=>L.Promises.rm(e).then(()=>a))),s.then(a=>w(a,e,{sourcePathRegex:n},t))}i.extract=E;function v(o,e){return g(o).then(r=>new Promise((t,n)=>{r.on("entry",s=>{s.fileName===e&&u(r,s).then(a=>t(a),a=>n(a))}),r.once("close",()=>n(new Error(P.localize(2,null,e))))}))}function m(o,e){return v(o,e).then(r=>new Promise((t,n)=>{const s=[];r.once("error",n),r.on("data",a=>s.push(a)),r.on("end",()=>t(Buffer.concat(s)))}))}i.buffer=m}),define(Y[128],Q([0,1,43,78]),function(j,i,D,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getManifest=void 0;function b(I){return(0,D.buffer)(I,"extension/package.json").then(L=>{try{return JSON.parse(L.toString("utf8"))}catch{throw new Error((0,R.localize)(0,null))}})}i.getManifest=b}),define(Y[129],Q([0,1,18,3,8,2,10,11,12,19,41,9,27,15,43,79,20,23,21,90,35,16,14,32]),function(j,i,D,R,b,I,L,P,l,p,C,T,d,y,w,g,u,f,E,v,m,o,e,r){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsScanner=void 0;let t=class extends I.Disposable{constructor(s,a,c,h,S){super();this.beforeRemovingExtension=s,this.fileService=a,this.logService=c,this.environmentService=h,this.productService=S,this._devSystemExtensionsPath=null,this.systemExtensionsPath=h.builtinExtensionsPath,this.extensionsPath=h.extensionsPath,this.uninstalledPath=P.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new R.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(s){const a=[];(s===null||s===0)&&a.push(this.scanSystemExtensions().then(null,c=>Promise.reject(new f.ExtensionManagementError(this.joinErrors(c).message,f.ExtensionManagementErrorCode.Internal)))),(s===null||s===1)&&a.push(this.scanUserExtensions(!0).then(null,c=>Promise.reject(new f.ExtensionManagementError(this.joinErrors(c).message,f.ExtensionManagementErrorCode.Internal))));try{const c=await Promise.all(a);return(0,D.flatten)(c)}catch(c){throw this.joinErrors(c)}}async scanUserExtensions(s){this.logService.trace("Started scanning user extensions");let[a,c]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return c=c.filter(h=>!a[new E.ExtensionIdentifierWithVersion(h.identifier,h.manifest.version).key()]),s&&(c=(0,E.groupByExtension)(c,S=>S.identifier).map(S=>S.sort((O,N)=>C.rcompare(O.manifest.version,N.manifest.version))[0])),this.logService.trace("Scanned user extensions:",c.length),c}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(s,a,c,h){const S=s.key(),O=P.join(this.extensionsPath,`.${(0,d.generateUuid)()}`),N=P.join(this.extensionsPath,S);try{await y.Promises.rm(N)}catch{try{await y.Promises.rm(N)}catch{}throw new f.ExtensionManagementError((0,g.localize)(0,null,N,s.id),f.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(s,a,O,h);let _=await this.scanExtension(T.URI.file(O),1);if(!_)throw new Error((0,g.localize)(1,null,O));await this.storeMetadata(_,{...c,installedTimestamp:Date.now()});try{await this.rename(s,O,N,Date.now()+2*60*1e3),this.logService.info("Renamed to",N)}catch(J){try{await y.Promises.rm(O)}catch{}if(J.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",s.id);else throw this.logService.info(`Rename failed because of ${(0,b.getErrorMessage)(J)}. Deleted from extracted location`,O),J}try{_=await this.scanExtension(T.URI.file(N),1)}catch{}if(_)return _;throw new Error((0,g.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(s,a){return this.setMetadata(s,a),await this.storeMetadata(s,{...a,installedTimestamp:s.installedTimestamp}),s}async storeMetadata(s,a){a.isMachineScoped=a.isMachineScoped||void 0,a.isBuiltin=a.isBuiltin||void 0,a.installedTimestamp=a.installedTimestamp||void 0;const c=P.join(s.location.fsPath,"package.json"),h=await y.Promises.readFile(c,"utf8"),{manifest:S}=await this.parseManifest(h);return S.__metadata=a,await y.Promises.writeFile(c,JSON.stringify(S,null,"	")),s}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...s){const a=s.map(c=>new E.ExtensionIdentifierWithVersion(c.identifier,c.manifest.version));await this.withUninstalledExtensions(c=>{a.forEach(h=>c[h.key()]=!0)})}async setInstalled(s){await this.withUninstalledExtensions(h=>delete h[s.key()]);const c=(await this.scanExtensions(1)).find(h=>new E.ExtensionIdentifierWithVersion(h.identifier,h.manifest.version).equals(s))||null;return c?(await this.storeMetadata(c,{installedTimestamp:Date.now()}),this.scanExtension(c.location,1)):null}async withUninstalledExtensions(s){return this.uninstalledFileLimiter.queue(async()=>{let a;try{a=await y.Promises.readFile(this.uninstalledPath,"utf8")}catch(h){if(h.code!=="ENOENT")throw h}let c={};if(a)try{c=JSON.parse(a)}catch{}return s&&(s(c),Object.keys(c).length?await y.Promises.writeFile(this.uninstalledPath,JSON.stringify(c)):await y.Promises.rm(this.uninstalledPath)),c})}async removeExtension(s,a){this.logService.trace(`Deleting ${a} extension from disk`,s.identifier.id,s.location.fsPath),await y.Promises.rm(s.location.fsPath),this.logService.info("Deleted from disk",s.identifier.id,s.location.fsPath)}async removeUninstalledExtension(s){await this.removeExtension(s,"uninstalled"),await this.withUninstalledExtensions(a=>delete a[new E.ExtensionIdentifierWithVersion(s.identifier,s.manifest.version).key()])}async extractAtLocation(s,a,c,h){this.logService.trace(`Started extracting the extension from ${a} to ${c}`);try{await y.Promises.rm(c)}catch(S){throw new f.ExtensionManagementError(this.joinErrors(S).message,f.ExtensionManagementErrorCode.Delete)}try{await(0,w.extract)(a,c,{sourcePath:"extension",overwrite:!0},h),this.logService.info(`Extracted extension to ${c}:`,s.id)}catch(S){try{await y.Promises.rm(c)}catch{}let O=f.ExtensionManagementErrorCode.Extract;throw S instanceof w.ExtractError&&(S.type==="CorruptZip"?O=f.ExtensionManagementErrorCode.CorruptZip:S.type==="Incomplete"&&(O=f.ExtensionManagementErrorCode.IncompleteZip)),new f.ExtensionManagementError(S.message,O)}}async rename(s,a,c,h){try{await y.Promises.rename(a,c)}catch(S){if(l.isWindows&&S&&S.code==="EPERM"&&Date.now()<h)return this.logService.info(`Failed renaming ${a} to ${c} with 'EPERM' error. Trying again...`,s.id),this.rename(s,a,c,h);throw new f.ExtensionManagementError(S.message||(0,g.localize)(3,null,a,c),S.code||f.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const s=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return s;const a=this.scanDevSystemExtensions(),[c,h]=await Promise.all([s,a]);return[...c,...h]}async scanExtensionsInDir(s,a){const c=new R.Limiter(10),h=await this.fileService.resolve(T.URI.file(s));return h.children?(await Promise.all(h.children.filter(O=>O.isDirectory).map(O=>c.queue(async()=>a===1&&(0,p.basename)(O.resource).indexOf(".")===0?null:this.scanExtension(O.resource,a))))).filter(O=>O&&O.identifier):[]}async scanExtension(s,a){try{const c=await this.fileService.resolve(s);if(c.children){const{manifest:h,metadata:S}=await this.readManifest(s.fsPath),O=c.children.find(({name:re})=>/^readme(\.txt|\.md|)$/i.test(re))?.resource,N=c.children.find(({name:re})=>/^changelog(\.txt|\.md|)$/i.test(re))?.resource,_={id:(0,E.getGalleryExtensionId)(h.publisher,h.name)},J={type:a,identifier:_,manifest:h,location:s,readmeUrl:O,changelogUrl:N,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:a===0};return this.setMetadata(J,S),J}}catch(c){a!==0&&this.logService.trace(c)}return null}async scanDefaultSystemExtensions(){const s=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",s.length),s}async scanDevSystemExtensions(){const s=this.getDevSystemExtensionsList();if(s.length){const a=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",a.length),a.filter(c=>s.some(h=>(0,E.areSameExtensions)(c.identifier,{id:h})))}else return[]}setMetadata(s,a){s.publisherDisplayName=a?.publisherDisplayName||null,s.publisherId=a?.publisherId||null,s.identifier.uuid=a?.id,s.isMachineScoped=!!a?.isMachineScoped,s.isPreReleaseVersion=!!a?.isPreReleaseVersion,s.preRelease=!!a?.preRelease,s.isBuiltin=s.type===0||!!a?.isBuiltin,s.installedTimestamp=a?.installedTimestamp}async removeUninstalledExtensions(){const s=await this.getUninstalledExtensions(),a=await this.scanAllUserExtensions(),c=new Set;for(const O of a)s[new E.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version).key()]||c.add(O.identifier.id.toLowerCase());const h=(0,E.groupByExtension)(a,O=>O.identifier);await R.Promises.settled(h.map(async O=>{const N=O.sort((_,J)=>C.rcompare(_.manifest.version,J.manifest.version))[0];c.has(N.identifier.id.toLowerCase())||await this.beforeRemovingExtension(N)}));const S=a.filter(O=>s[new E.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version).key()]);await R.Promises.settled(S.map(O=>this.removeUninstalledExtension(O)))}async removeOutdatedExtensions(){const s=await this.scanAllUserExtensions(),a=[],c=(0,E.groupByExtension)(s,h=>h.identifier);a.push(...(0,D.flatten)(c.map(h=>h.sort((S,O)=>C.rcompare(S.manifest.version,O.manifest.version)).slice(1)))),await R.Promises.settled(a.map(h=>this.removeExtension(h,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(s=>s.name)}joinErrors(s){const a=Array.isArray(s)?s:[s];return a.length===1?a[0]instanceof Error?a[0]:new Error(a[0]):a.reduce((c,h)=>new Error(`${c.message}${c.message?",":""}${h instanceof Error?h.message:h}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=P.normalize(P.join(L.FileAccess.asFileUri("",j).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(s){const a=[y.Promises.readFile(P.join(s,"package.json"),"utf8").then(O=>this.parseManifest(O)),y.Promises.readFile(P.join(s,"package.nls.json"),"utf8").then(void 0,O=>O.code!=="ENOENT"?Promise.reject(O):"{}").then(O=>JSON.parse(O))],[{manifest:c,metadata:h},S]=await Promise.all(a);return{manifest:(0,v.localizeManifest)(c,S),metadata:h}}parseManifest(s){return new Promise((a,c)=>{try{const h=JSON.parse(s);h.publisher||(h.publisher=m.UNDEFINED_PUBLISHER);const S=h.__metadata||null;a({manifest:h,metadata:S})}catch{c(new Error((0,g.localize)(4,null)))}})}};t=ge([oe(1,o.IFileService),oe(2,e.ILogService),oe(3,u.INativeEnvironmentService),oe(4,r.IProductService)],t),i.ExtensionsScanner=t}),define(Y[130],Q([0,1,28,8,10,11,12,29,19,41,6,9,27,15,43,77,49,20,118,23,21,110,98,128,111,129,126,48,16,13,14,32,31,37]),function(j,i,D,R,b,I,L,P,l,p,C,T,d,y,w,g,u,f,E,v,m,o,e,r,t,n,s,a,c,h,S,O,N,_){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionManagementService=void 0;let J=class extends E.AbstractExtensionManagementService{constructor(x,te,U,k,z,G,ne,K,Z){super(x,te,U,K);this.environmentService=k,this.downloadService=z,this.fileService=ne;const q=this._register(G.createInstance(e.ExtensionsLifecycle));this.extensionsScanner=this._register(G.createInstance(n.ExtensionsScanner,A=>q.postUninstall(A))),this.manifestCache=this._register(new t.ExtensionsManifestCache(k,this)),this.extensionsDownloader=this._register(G.createInstance(o.ExtensionsDownloader));const M=this._register(new s.ExtensionsWatcher(this,ne,k,U,Z));this._register(M.onDidChangeExtensionsByAnotherSource(({added:A,removed:V})=>{A.length&&this._onDidInstallExtensions.fire(A.map(B=>({identifier:B.identifier,operation:1,local:B}))),V.forEach(B=>this._onDidUninstallExtension.fire({identifier:B}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const x=await this.isAlpineLinux(),te=(0,v.getTargetPlatform)(x?"alpine":L.platform,P.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",te),te})()),this._targetPlatformPromise}async isAlpineLinux(){if(!L.isLinux)return!1;let x;try{x=(await this.fileService.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{x=(await this.fileService.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(U){this.logService.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(U))}}return!!x&&(x.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(x){this.logService.trace("ExtensionManagementService#zip",x.identifier.id);const te=await this.collectFiles(x),U=await(0,w.zip)((0,l.joinPath)(this.environmentService.tmpDir,(0,d.generateUuid)()).fsPath,te);return T.URI.file(U)}async unzip(x){return this.logService.trace("ExtensionManagementService#unzip",x.toString()),(await this.install(x)).identifier}async getManifest(x){const te=await this.downloadVsix(x),U=I.resolve(te.fsPath);return(0,r.getManifest)(U)}getInstalled(x=null){return this.extensionsScanner.scanExtensions(x)}async install(x,te={}){this.logService.trace("ExtensionManagementService#install",x.toString());const U=await this.downloadVsix(x),k=await(0,r.getManifest)(I.resolve(U.fsPath));if(k.engines&&k.engines.vscode&&!(0,a.isEngineValid)(k.engines.vscode,this.productService.version,this.productService.date))throw new Error(g.localize(0,null,(0,m.getGalleryExtensionId)(k.publisher,k.name),this.productService.version));return this.installExtension(k,U,te)}async updateMetadata(x,te){this.logService.trace("ExtensionManagementService#updateMetadata",x.identifier.id);const U={...x.manifest.__metadata||{},...te};return te.isPreReleaseVersion&&(U.preRelease=!0),x=await this.extensionsScanner.saveMetadataForLocalExtension(x,U),this.manifestCache.invalidate(),x}async updateExtensionScope(x,te){return this.logService.trace("ExtensionManagementService#updateExtensionScope",x.identifier.id),x=await this.extensionsScanner.saveMetadataForLocalExtension(x,{...x.manifest.__metadata||{},isMachineScoped:te}),this.manifestCache.invalidate(),x}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(x){if(x.scheme===b.Schemas.file)return x;const te=(0,l.joinPath)(this.environmentService.tmpDir,(0,d.generateUuid)());return await this.downloadService.download(x,te),te}createInstallExtensionTask(x,te,U){return T.URI.isUri(te)?new ie(x,te,U,this.galleryService,this.extensionsScanner,this.logService):new ee(te,U,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(x,te){return new he(x,te,this.extensionsScanner)}async collectFiles(x){const te=async k=>{let z=await y.Promises.readdir(k);z=z.map(K=>I.join(k,K));const G=await Promise.all(z.map(K=>y.Promises.stat(K)));let ne=Promise.resolve([]);return G.forEach((K,Z)=>{const q=z[Z];K.isFile()&&(ne=ne.then(M=>[...M,q])),K.isDirectory()&&(ne=ne.then(M=>te(q).then(A=>[...M,...A])))}),ne};return(await te(x.location.fsPath)).map(k=>({path:`extension/${I.relative(x.location.fsPath,k)}`,localPath:k}))}};J=ge([oe(0,v.IExtensionGalleryService),oe(1,N.ITelemetryService),oe(2,S.ILogService),oe(3,f.INativeEnvironmentService),oe(4,u.IDownloadService),oe(5,h.IInstantiationService),oe(6,c.IFileService),oe(7,O.IProductService),oe(8,_.IUriIdentityService)],J),i.ExtensionManagementService=J;class re extends E.AbstractExtensionTask{constructor(x,te,U,k){super();this.identifier=x,this.source=te,this.extensionsScanner=U,this.logService=k,this._operation=2}get operation(){return this._operation}async installExtension(x,te){try{const U=await this.unsetUninstalledAndGetLocal(x.identifierWithVersion);if(U)return x.metadata?this.extensionsScanner.saveMetadataForLocalExtension(U,{...U.manifest.__metadata||{},...x.metadata}):U}catch{throw L.isMacintosh?new v.ExtensionManagementError(g.localize(1,null),v.ExtensionManagementErrorCode.Internal):new v.ExtensionManagementError(g.localize(2,null),v.ExtensionManagementErrorCode.Internal)}return this.extract(x,te)}async unsetUninstalledAndGetLocal(x){if(!await this.isUninstalled(x))return null;this.logService.trace("Removing the extension from uninstalled list:",x.id);const U=await this.extensionsScanner.setInstalled(x);return this.logService.info("Removed the extension from uninstalled list:",x.id),U}async isUninstalled(x){return!!(await this.extensionsScanner.getUninstalledExtensions())[x.key()]}async extract({zipPath:x,identifierWithVersion:te,metadata:U},k){let z=await this.extensionsScanner.extractUserExtension(te,x,U,k);return this.logService.info("Extracting completed.",te.id),z}}class ee extends re{constructor(x,te,U,k,z){super(x.identifier,x,k,z);this.gallery=x,this.options=te,this.extensionsDownloader=U}async doRun(x){const U=(await this.extensionsScanner.scanExtensions(null)).find(z=>(0,m.areSameExtensions)(z.identifier,this.gallery.identifier));U&&(this._operation=3);const k=await this.downloadInstallableExtension(this.gallery,this._operation);k.metadata.isMachineScoped=this.options.isMachineScoped||U?.isMachineScoped,k.metadata.isBuiltin=this.options.isBuiltin||U?.isBuiltin,k.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,k.metadata.preRelease=this.gallery.properties.isPreReleaseVersion||((0,C.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:U?.preRelease);try{const z=await this.installExtension(k,x);return U&&p.neq(U.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(U),z}catch(z){throw await this.deleteDownloadedVSIX(k.zipPath),z}}async deleteDownloadedVSIX(x){try{await this.extensionsDownloader.delete(T.URI.file(x))}catch(te){this.logService.warn("Error while deleting the downloaded vsix",x.toString(),(0,R.getErrorMessage)(te))}}async downloadInstallableExtension(x,te){const U={id:x.identifier.uuid,publisherId:x.publisherId,publisherDisplayName:x.publisherDisplayName};let k;try{this.logService.trace("Started downloading extension:",x.identifier.id),k=(await this.extensionsDownloader.downloadExtension(x,te)).fsPath,this.logService.info("Downloaded extension:",x.identifier.id,k)}catch(z){throw new v.ExtensionManagementError((0,E.joinErrors)(z).message,v.ExtensionManagementErrorCode.Download)}try{const z=await(0,r.getManifest)(k);return{zipPath:k,identifierWithVersion:new m.ExtensionIdentifierWithVersion(x.identifier,z.version),metadata:U}}catch(z){throw await this.deleteDownloadedVSIX(k),new v.ExtensionManagementError((0,E.joinErrors)(z).message,v.ExtensionManagementErrorCode.Invalid)}}}class ie extends re{constructor(x,te,U,k,z,G){super({id:(0,m.getGalleryExtensionId)(x.publisher,x.name)},te,z,G);this.manifest=x,this.location=te,this.options=U,this.galleryService=k}async doRun(x){const te=new m.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),k=(await this.extensionsScanner.scanExtensions(1)).find(G=>(0,m.areSameExtensions)(this.identifier,G.identifier)),z=await this.getMetadata(this.identifier.id,this.manifest.version,x);if(z.isMachineScoped=this.options.isMachineScoped||k?.isMachineScoped,z.isBuiltin=this.options.isBuiltin||k?.isBuiltin,k)if(this._operation=3,te.equals(new m.ExtensionIdentifierWithVersion(k.identifier,k.manifest.version)))try{await this.extensionsScanner.removeExtension(k,"existing")}catch{throw new Error(g.localize(3,null,this.manifest.displayName||this.manifest.name))}else p.gt(k.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(k);else{const G=await this.unsetUninstalledAndGetLocal(te);if(G)try{await this.extensionsScanner.removeExtension(G,"existing")}catch{throw new Error(g.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:I.resolve(this.location.fsPath),identifierWithVersion:te,metadata:z},x)}async getMetadata(x,te,U){try{let[k]=await this.galleryService.getExtensions([{id:x,version:te}],U);if(k||([k]=await this.galleryService.getExtensions([{id:x}],U)),k)return{id:k.identifier.uuid,publisherDisplayName:k.publisherDisplayName,publisherId:k.publisherId,isPreReleaseVersion:k.properties.isPreReleaseVersion,preRelease:k.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class he extends E.AbstractExtensionTask{constructor(x,te,U){super();this.extension=x,this.options=te,this.extensionsScanner=U}async doRun(x){const te=[],U=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const k=new m.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);te.push(...U.filter(z=>k.equals(new m.ExtensionIdentifierWithVersion(z.identifier,z.manifest.version))))}else te.push(...U.filter(k=>(0,m.areSameExtensions)(k.identifier,this.extension.identifier)));if(!te.length)throw new Error(g.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...te),this.options.remove)for(const k of te)try{x.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(k)}catch(z){throw new Error(g.localize(6,null,(0,D.toErrorMessage)(z)))}}}}),define(Y[131],Q([0,1,115,3,17,8,2,6,25,20,125,14,114,141]),function(j,i,D,R,b,I,L,P,l,p,C,T,d,y){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.RequestService=void 0;let w=class extends L.Disposable{constructor(u,f,E){super();this.environmentService=f,this.logService=E,this.configure(u.getValue()),this._register(u.onDidChangeConfiguration(()=>this.configure(u.getValue()),this))}configure(u){this.proxyUrl=u.http&&u.http.proxy,this.strictSSL=!!(u.http&&u.http.proxyStrictSSL),this.authorization=u.http&&u.http.proxyAuthorization}async request(u,f){this.logService.trace("RequestService#request",u.url);const{proxyUrl:E,strictSSL:v}=this;let m;try{m=await(0,C.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(r){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request resolving shell environment failed",r))}const o={...process.env,...m},e=u.agent?u.agent:await(0,d.getProxyAgent)(u.url||"",o,{proxyUrl:E,strictSSL:v});return u.agent=e,u.strictSSL=v,this.authorization&&(u.headers={...u.headers||{},"Proxy-Authorization":this.authorization}),this._request(u,f)}async getNodeRequest(u){return((0,D.parse)(u.url).protocol==="https:"?await new Promise((v,m)=>{j(["https"],v,m)}):await new Promise((v,m)=>{j(["http"],v,m)})).request}_request(u,f){return R.Promises.withAsyncBody(async(E,v)=>{let m;const o=(0,D.parse)(u.url),e=u.getRawRequest?u.getRawRequest(u):await this.getNodeRequest(u),r={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:u.type||"GET",headers:u.headers,agent:u.agent,rejectUnauthorized:(0,P.isBoolean)(u.strictSSL)?u.strictSSL:!0};u.user&&u.password&&(r.auth=u.user+":"+u.password),m=e(r,t=>{const n=(0,P.isNumber)(u.followRedirects)?u.followRedirects:3;if(t.statusCode&&t.statusCode>=300&&t.statusCode<400&&n>0&&t.headers.location)this._request({...u,url:t.headers.location,followRedirects:n-1},f).then(E,v);else{let s=t;t.headers["content-encoding"]==="gzip"&&(s=t.pipe((0,y.createGunzip)())),E({res:t,stream:(0,b.streamToBufferReadableStream)(s)})}}),m.on("error",v),u.timeout&&m.setTimeout(u.timeout),u.data&&typeof u.data=="string"&&m.write(u.data),m.end(),f.onCancellationRequested(()=>{m.abort(),v((0,I.canceled)())})})}async resolveProxy(u){}};w=ge([oe(0,l.IConfigurationService),oe(1,p.INativeEnvironmentService),oe(2,T.ILogService)],w),i.RequestService=w}),define(Y[142],Q([0,1,33,3,17,28,8,2,10,11,29,9,15,25,107,49,113,20,89,120,23,109,130,16,100,102,40,97,52,53,112,14,104,122,32,42,131,117,31,121,36,123,124,37,127]),function(j,i,D,R,b,I,L,P,l,p,C,T,d,y,w,g,u,f,E,v,m,o,e,r,t,n,s,a,c,h,S,O,N,_,J,re,ee,ie,he,ue,x,te,U,k,z){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.main=void 0;class G extends P.Disposable{constructor(Z){super();this.argv=Z,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[Z,q]=await this.initServices();return Z.invokeFunction(async M=>{const A=M.get(O.ILogService),V=M.get(r.IFileService),B=M.get(f.INativeEnvironmentService),H=M.get(m.IExtensionManagementCLIService);A.info("CLI main",this.argv),this.registerErrorHandler(A),await this.doRun(B,H,V),await Promise.all(q.map(X=>{(0,R.raceTimeout)(X.flush(),1e3)}))})}async initServices(){const Z=new c.ServiceCollection,q={_serviceBrand:void 0,..._.default};Z.set(J.IProductService,q);const M=new E.NativeEnvironmentService(this.argv,q);Z.set(f.INativeEnvironmentService,M),await Promise.all([M.appSettingsHome.fsPath,M.extensionsPath].map(Ee=>Ee?d.Promises.mkdir(Ee,{recursive:!0}):void 0));const A=(0,O.getLogLevel)(M),V=[];V.push(new N.SpdLogLogger("cli",(0,p.join)(M.logsPath,"cli.log"),!0,!1,A)),A===O.LogLevel.Trace&&V.push(new O.ConsoleLogger(A));const B=this._register(new O.MultiplexLogService(V));Z.set(O.ILogService,B);const H=this._register(new t.FileService(B));Z.set(r.IFileService,H);const X=this._register(new n.DiskFileSystemProvider(B));H.registerProvider(l.Schemas.file,X);const ae=this._register(new w.ConfigurationService(M.settingsResource,H));Z.set(y.IConfigurationService,ae),await ae.initialize(),Z.set(k.IUriIdentityService,new z.UriIdentityService(H)),Z.set(re.IRequestService,new s.SyncDescriptor(ee.RequestService)),Z.set(g.IDownloadService,new s.SyncDescriptor(u.DownloadService)),Z.set(m.IExtensionManagementService,new s.SyncDescriptor(e.ExtensionManagementService)),Z.set(m.IExtensionGalleryService,new s.SyncDescriptor(v.ExtensionGalleryServiceWithNoStorageService)),Z.set(m.IExtensionManagementCLIService,new s.SyncDescriptor(o.ExtensionManagementCLIService)),Z.set(h.ILocalizationsService,new s.SyncDescriptor(S.LocalizationsService));const ce=[];if((0,x.supportsTelemetry)(q,M)){q.aiConfig&&q.aiConfig.asimovKey&&ce.push(new te.AppInsightsAppender("monacoworkbench",null,q.aiConfig.asimovKey));const{installSourcePath:Ee}=M,fe={appenders:ce,sendErrorTelemetry:!1,commonProperties:(async()=>{let se;try{const me=await d.Promises.readFile((0,p.join)(M.userDataPath,"storage.json"));se=JSON.parse(me.toString())[he.machineIdKey]}catch(me){me.code!=="ENOENT"&&B.error(me)}return(0,ie.resolveCommonProperties)(H,(0,D.release)(),(0,D.hostname)(),process.arch,q.commit,q.version,se,q.msftInternalDomains,Ee)})(),piiPaths:(0,x.getPiiPathsFromEnvironment)(M)};Z.set(he.ITelemetryService,new s.SyncDescriptor(ue.TelemetryService,[fe]))}else Z.set(he.ITelemetryService,x.NullTelemetryService);return[new a.InstantiationService(Z),ce]}registerErrorHandler(Z){(0,L.setUnexpectedErrorHandler)(q=>{const M=(0,I.toErrorMessage)(q,!0);!M||Z.error(`[uncaught exception in CLI]: ${M}`)}),process.on("uncaughtException",q=>(0,L.onUnexpectedError)(q)),process.on("unhandledRejection",q=>(0,L.onUnexpectedError)(q))}async doRun(Z,q,M){if(this.argv["install-source"])return this.setInstallSource(Z,M,this.argv["install-source"]);if(this.argv["list-extensions"])return q.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const A={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"]};return q.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],A,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return q.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return q.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,U.buildTelemetryMessage)(Z.appRoot,Z.extensionsPath))}}asExtensionIdOrVSIX(Z){return Z.map(q=>/\.vsix$/i.test(q)?T.URI.file((0,p.isAbsolute)(q)?q:(0,p.join)((0,C.cwd)(),q)):q)}async setInstallSource(Z,q,M){await q.writeFile(T.URI.file(Z.installSourcePath),b.VSBuffer.fromString(M.slice(0,30)))}}async function ne(K){const Z=new G(K);try{await Z.run()}finally{Z.dispose()}}i.main=ne})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8908a9ca0f221f36507231afb39d2d8d1e182702/core/vs/code/node/cliProcessMain.js.map
